/*	Renegade Scripts.dll
	Copyright 2011 Tiberian Technologies

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
//----------------------------------------------------------------------------------------------------------------------------------------------
//------RELEASED BEFORE BEING PROPERLY UPDATED TO 4.0, SERVERS SHOULD STILL USE 3.4.4 UNTIL I HAVE THE TIME TO FIX THE ISSUES - JERAD GRAY------
//----------------------------------------------------------------------------------------------------------------------------------------------
#include "General.h"
#include "scripts.h"
#include "engine.h"
#include "jmgRP2.h"
#include "armedgameobj.h"
#include "WeaponBagClass.h"
#include "WeaponClass.h"
#include "WeaponManager.h"
#include "MoveablePhysClass.h"
#include "GameObjManager.h"
#include "SoldierGameObj.h"
#include <float.h>
#include <time.h>
#include "VehicleGameObj.h"
#include "BuildingGameObj.h"
#include "ScriptZoneGameObj.h"
#include "ScriptableGameObj.h"
#include "BeaconGameObj.h"
#define VERSION "2.2.9:1.0 Alpha"
char MAPVERSION[100] = "Not Available";
#define PLUGINVERSIONNUMBER 3
#define PI 3.14159265f
#define PI180 PI/180
// Checkstand Stuff
#define MAXCHECKERPAYPERHOUR 25.0f
#define CHECKERCHECKOUTMAXPAYOUT 10000.0f
int Customers[128][10] = {0};
// Train stuff
#define TRAINSTATIONPAYOUT 2500.0f
// Tactical Nuke Stuff
#define MINRADTIME 450
#define MAXRADTIME 750
#define EMPRANGE 150
#define EMPSTANDARDDURATION 60.0
#define EMPMESSAGE 339335703
//Carryall stuff
#define CARRYALLPICKUPRANGE 6.0
#define CARRYALLMINDROPHEIGHT 5
// Player Health Regeneration
#define PLAYERHEALTHRENGENSTARTTIME 30
#define PLAYERHEALTHRENGENPERCENT 0.001167f
// Fishing stuff
#define SCHOOLRADIUS 50.0f
//#define NUMBEROFSCHOOLS 25// Now defined in the H file
int TOTALFISHCOUNT = 0;
// Parachute Stuff
bool USENEWPARACHUTE = true;
#define PARACHUTEALLOWDEPLOYDELAY 5
#define RECREATEPARADETECTTIME 25
#define PARACHUTEMINFALLSPEED 2.0f
int PARACHUTEENABLEDONSPAWN = 1;
bool PARACHUTESLOWDAMAGE = true;
// Swimming Stuff
int ISNEWSWIMMING[128] = {0};
int ISUNDERWATER[128] = {0};
Vector3 SWIMMINGSCREENCOLORS[128];
float SimpleDistance(Vector3 Pos1,Vector3 Pos2)
{// Gets rid of the square root which can be resource heavy when doing large numbers of distance calculations
	float DiffX = Pos1.X-Pos2.X;
	float DiffY = Pos1.Y-Pos2.Y;
	float DiffZ = Pos1.Z-Pos2.Z;
	return (DiffX*DiffX+DiffY*DiffY+DiffZ*DiffZ);
}

RP2SwimmingZoneTypeIndexControl *Create_And_Return_Swimming_Zone_Node(int ZoneID)
{
	if (!RP2SwimmingZoneTypeIndexNode)
	{
		RP2SwimmingZoneTypeIndexNode = new RP2SwimmingZoneTypeIndexControl;
		RP2SwimmingZoneTypeIndexNode->ZoneID = ZoneID;
		RP2SwimmingZoneTypeIndexNode->ZoneType = 0;
		RP2SwimmingZoneTypeIndexNode->next = NULL;
		return RP2SwimmingZoneTypeIndexNode;
	}
	else
	{
		RP2SwimmingZoneTypeIndexControl *Current = RP2SwimmingZoneTypeIndexNode;
		while (Current != NULL)
		{
			if (Current->ZoneID == ZoneID)
			{
				Current->ZoneID = ZoneID;
				return Current;
			}
			else if (Current->next == NULL)
			{
				Current->next = new RP2SwimmingZoneTypeIndexControl;
				Current = Current->next;
				Current->ZoneID = ZoneID;
				Current->ZoneType = 0;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

RP2SwimmingZoneTypeIndexControl *Return_Swimming_Zone_Node(int ZoneID)
{// Create an index of all water zones and their types
	if (RP2SwimmingZoneTypeIndexNode)
	{
		RP2SwimmingZoneTypeIndexControl *Current = RP2SwimmingZoneTypeIndexNode;
		while (Current != NULL)
		{
			if (ZoneID == Current->ZoneID)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

// Drugs Stuff
int DRUGSCREENEFFECTSON[128] = {0};
// New Spawn System Stuff
int ISSELECTINGSPAWN[128] = {1};
int PEOPLEINLINEFORSPAWNING = 0;
int ATTEMPTINGTOSPAWN[128] = {0};
int SPAWNINGALLOWED[128] = {1};
int COMPLETEDACHIEVEMENTS[128] = {0};
int TOTALACHIEVEMENTCOUNT;
// PhoneStuff
#define RP2PHONEBOOKPRESET "Phone_Number_System_Controller"
int GLOBALPHONELINES[128] = {0};
int GLOBALPHONETIMES[128] = {0};
int PHONEZONES[128] = {0};
// Swarm AI
int GroupUp = 0;
int SwarmSize = 0;
int SwarmHunt = 0;
int GroupedSwarm = 0;
int GlobalHuntProbability = 10;
int SwarmHuntProbability = 2;
Vector3 SwarmLocation;
// Game auto save stuff
#define SAVEGAMETIME 300.0f
JMG_RP2_Phone_Main_Map_Runtime_Save *SaveTheGame;
int Phone_Number_Count_Connections(int PhoneLineID)
{
	for (int x = 1;x < 128;x++)
	{
		if (GLOBALPHONELINES[x])
		{
			GameObject *Player = Get_GameObj(x);
			if (!Player)
			{
				GLOBALPHONELINES[x] = 0;
				GLOBALPHONETIMES[x] = 0;
			}
		}
	}
	int ConnectionCount = 0;
	for (int x = 1;x < 128;x++)
	{
		if (GLOBALPHONELINES[x] == PhoneLineID)
		{
			ConnectionCount++;
		}
	}
	return ConnectionCount;
}
// Bank Stuff
#define MAXINTRESTRATE 0.003f
#define INTRESTDELAY 300.0f
#define RP2MAINMAPATMPRESET "ATM_Controller"
// PT Player Zone Tracking
int CURRENTPLAYERPTZONE[128] = {0};
// New RP2 Mission System Stuff
#define RP2MISSIONCONTROLOBJECTNAME "RP2_GLOBAL_MISSION_CONTROLLER"
#define RP2MISSIONMESSAGERECCIVER "RP2_GLOBAL_MISSION_MESSAGE_RECEIVER"
int OBJECTIVECOUNT = 1;
int PHONEMAXRANDCHOICE = 0;
int TELEPORTMAXRANDCHOICE = 0;
// NEW SCUD STUFF
int USEGOODSCUDTARGETINGMOVEMENT = 0;// Same issue as with parachute
#define SCUDMOVEMENTHEIGHT 149.0f//(Spring Length Should Also Be Adjusted)
SCUD_Missile_Launcher_Control *Find_A_Scud_Launcher_Node(int LauncherID)
{
	if (SCUD_Missile_Launcher_Node)
	{
		SCUD_Missile_Launcher_Control *Current = SCUD_Missile_Launcher_Node;
		while (Current != NULL)
		{
			if (Current->LauncherID == LauncherID)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

// RP2 Player Anti Missile System
#define ANTIMISSILESYSTEM "Renhalo_Laser_Defense_System"
#define PLAYERANTIMISSILESYSTEM "Renhalo_Laser_Defense_System_Phone"
void FIND_ANTI_MISSILE_SYSTEM(GameObject *obj)
{
	if (AntiMissileSystemNode)
	{
		Vector3 Pos = Commands->Get_Position(obj);
		AntiMissileSystemControl *Current = AntiMissileSystemNode;
		while (Current != NULL)
		{
			GameObject *AntiMissileDish = Commands->Find_Object(Current->DishID);
			if (AntiMissileDish)
			{
				Vector3 DishPos = Commands->Get_Position(AntiMissileDish);
				Pos.Z = 0.0;
				DishPos.Z = 0.0;
				if (Commands->Get_Distance(Pos,DishPos) < 200)
				{
					Commands->Send_Custom_Event(obj,AntiMissileDish,9911591,1,0);
				}
			}
			Current = Current->next;
		}
	}
}

// RP2 SPECIAL WEAPON CONTROL STUFF
#define MAXDROPPEDWEAPONS 10//Max number of weapons player can drop on the map at a time
#define RP2MAXINVENTORYWEAPONLIMIT 50// Yeah Don't change this unless you love Disconnects
#define STARTINGINVENTORYSIZE 15.0f
#define INVENTORYMAXSIZELIMIT 40.0f// Always forces you to have room for ATLEAST 10 items
int HASPRINTEDDEATHMESSAGE[128] = {0};
int TEMPDISABLEWEAPONDROP[128] = {false};
enum {BODY = 0,PISTOL = 1,SHOTGUN = 2,RIFLE = 3,LAUNCHER = 4,ROCKETLAUNCHER = 5,CANNON = 6,MACHINEGUN = 7,GATTLINGGUN = 8,PHONE = 9,ITEM = 10,SWORD = 11,KNIFE = 12,LIQUIDSPRAYER = 13,MISC = 14,SUBMACHINEGUN = 15,SNIPERRIFLE = 16,GRENADE = 17};
float RP2StarCurrentInventorySize[128] = {0};
float RP2StarMaxInventorySize[128] = {STARTINGINVENTORYSIZE};
int WeaponTierCounts[4] = {0};/*
0 = Nonstandard Weapon (used for missions and things like that)
1 = Standard Weapon (Normal Player Aquireable weapon)
2 = Powerful Weapon (Weapons like Rocket Launcher)
3 = Crazy Weapon (Weapons like the Radio, and other admin only weapons)*/
RP2WeaponListControl *Get_WLS_Weapon_Settings(const char *WeaponName)
{
	RP2WeaponListControl *ReturnNode = NULL;
	if (!_stricmp(WeaponName,"null"))
	{
		return NULL;
	}
	if (RP2WeaponListNode)
	{
		int end = 0;
		RP2WeaponListControl *Current = RP2WeaponListNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(WeaponName,Current->WeaponName))
			{
				ReturnNode = Current;
				end = 1;
			}
			Current = Current->next;
		}
	}
	if (!ReturnNode)
	{
		char text[2000];
		sprintf(text,"MESSAGE ERROR: Weapon \"%s\" has not been defined in the Weapons List!",WeaponName);
		Console_Input(text);
	}
	return ReturnNode;
}

RP2PlayerSAWTControl *Add_Or_Update_RP2PlayerSAWT_Node(int PlayerID,const char *WeaponName)
{
	if (!RP2PlayerSAWTArray[PlayerID])
	{
		RP2PlayerSAWTArray[PlayerID] = new RP2PlayerSAWTControl;
		sprintf(RP2PlayerSAWTArray[PlayerID]->WeaponName,"%s",WeaponName);
		RP2PlayerSAWTArray[PlayerID]->LastAmmoCount = 0;
		RP2PlayerSAWTArray[PlayerID]->next = NULL;
		return RP2PlayerSAWTArray[PlayerID];
	}
	else
	{
		RP2PlayerSAWTControl *Current = RP2PlayerSAWTArray[PlayerID];
		while (Current != NULL)
		{
			if (!_stricmp(Current->WeaponName,WeaponName))
			{
				return Current;
			}
			else if (Current->next == NULL)
			{
				Current->next = new RP2PlayerSAWTControl;
				Current = Current->next;
				sprintf(Current->WeaponName,"%s",WeaponName);
				Current->LastAmmoCount = 0;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

RP2WeaponListControl *Get_WLS_Random_Weapon_Node()
{
	if (RP2WeaponListNode)
	{
		int Count = Commands->Get_Random_Int(0,100);
		RP2WeaponListControl *Current = RP2WeaponListNode;
		while (Current != NULL)
		{
			if (!Count)
			{
				//AmmoDefinitionClass *PrimaryAmmo = Get_Weapon_Ammo_Definition(Current->WeaponName,1);
				if ((Current->WeaponTier == 1/* || Current->WeaponTier == 2*/) /*&& PrimaryAmmo->BurstDelayTime < 1.0f*/ && Current->WeaponClass != LAUNCHER && Current->WeaponClass != KNIFE && Current->WeaponClass != PHONE && Current->WeaponClass != ITEM  && Current->WeaponClass != MISC  && Current->WeaponClass != BODY)
				{
					return Current;
				}
				else
				{
					Count = Commands->Get_Random_Int(1,5);
				}
			}
			Current = Current->next;
			if (!Current)
			{
				Current = RP2WeaponListNode;
			}
			Count--;
		}
	}
	return NULL;
}

RP2WeaponListControl *Grab_Random_Power_Up_From_List()
{
	if (RP2WeaponListNode)
	{
		int Count = Commands->Get_Random_Int(0,100);
		RP2WeaponListControl *Current = RP2WeaponListNode;
		while (Current != NULL)
		{
			if (!Count)
			{
				int RandomNum = Commands->Get_Random_Int(0,100);
				if (((Current->WeaponTier == 0 && RandomNum > 75) || (Current->WeaponTier == 1) || (Current->WeaponTier == 2 && RandomNum > 50) || (Current->WeaponClass == LAUNCHER && RandomNum > 50) || (Current->WeaponClass == KNIFE && RandomNum > 50)) && (Current->WeaponClass != MISC && Current->WeaponClass != PHONE && Current->WeaponClass != ITEM && Current->WeaponClass != BODY))
				{
					return Current;
				}
				else
				{
					Count = Commands->Get_Random_Int(1,5);
				}
			}
			Current = Current->next;
			if (!Current)
			{
				Current = RP2WeaponListNode;
			}
			Count--;
		}
	}
	return NULL;
}

extern void Create_Random_Powerup_At_Location(Vector3 Location,float Facing)
{
	RP2WeaponListControl *Weapon = Grab_Random_Power_Up_From_List();
	Location.Z += Weapon->DropHeight;
	GameObject *object = Commands->Create_Object("Daves_Arrow_NT",Location);
	Commands->Set_Model(object,"null");
	Commands->Set_Facing(object,Facing);
	char params[128];
	sprintf(params,"%s,-1,0.25,0.25,0.25,1,0,1",Weapon->WeaponName);
	Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);
}

void RP2_Cannot_Grant_Weapon_Reasons(GameObject *obj,RP2WeaponListControl *WeaponNode,int GrantBullets)
{
	char text[2000];
	int PlayerID = Get_Player_ID(obj);
	if (!Commands->Get_Health(obj))
	{
		return;
	}
	else if (ISSELECTINGSPAWN[PlayerID])
	{
		sprintf(text,"You must spawn before you can pickup weapons.");
	}
	else if (Has_Weapon(obj,WeaponNode->WeaponName) && Get_Total_Bullets(obj,WeaponNode->WeaponName) == -1)
	{
		sprintf(text,"I already have this weapon!");
	}
	else if (Has_Weapon(obj,WeaponNode->WeaponName) && !GrantBullets)
	{
		sprintf(text,"I already have this weapon, it also appears to be empty of ammo, it will do me no good to take it with me.");
	}
	else if (!Has_Weapon(obj,WeaponNode->WeaponName) && Get_Weapon_Count(obj) >= RP2MAXINVENTORYWEAPONLIMIT) // HIT RP2's HARD WEAPON LIMIT
	{
		sprintf(text,"I have reached RP2's weapon limit; I can either get rid of some of my other guns, or I can forget about this one and go on my way.");
	}
	else if (!Has_Weapon(obj,WeaponNode->WeaponName) && (RP2StarCurrentInventorySize[PlayerID] + WeaponNode->WeaponSize) > RP2StarMaxInventorySize[PlayerID]) // INVENTORY FULL
	{
		sprintf(text,"This weapon is too large to carry with my other weapons; in order to carry it I must remove some of my other weapons.");
	}
	else if (Has_Weapon(obj,WeaponNode->WeaponName) && Get_Clip_Bullets(obj,WeaponNode->WeaponName) == Get_Max_Clip_Bullets(obj,WeaponNode->WeaponName) && Get_Bullets(obj,WeaponNode->WeaponName) == Get_Max_Bullets(obj,WeaponNode->WeaponName)) // FULL AMMO AND OWN THE WEAPON
	{
		sprintf(text,"I already have this weapon and its maximum ammo.");
	}
	else if (Has_Weapon(obj,WeaponNode->WeaponName) && Get_Bullets(obj,WeaponNode->WeaponName) < Get_Max_Bullets(obj,WeaponNode->WeaponName) && Get_Max_Bullets(obj,WeaponNode->WeaponName) != -1) // FULL BACKPACK BUT CLIP NOT FULL
	{
		sprintf(text,"I must reload this gun before I can carry any more ammo for it.");
	}
	else if ((RP2StarCurrentInventorySize[PlayerID] + WeaponNode->AmmoSize) > RP2StarMaxInventorySize[PlayerID]) // FULL BACKPACK BUT CLIP NOT FULL
	{
		sprintf(text,"My inventory is full; I cannot fit this object in!");
	}
	else // UNKNOWN LOGIC
	{
		sprintf(text,"For some unknown reason I cannot carry this gun.");
		Console_Input("MESSAGE ERROR: unknown reason for not being able to get a weapon!");
	}
	Send_Message_Player(obj,255,127,127,text);
	Commands->Create_3D_Sound_At_Bone("Pickup Nothing Sound",obj,"c head");
}

void WLS_Add_Weapon_Weight(GameObject *obj,RP2WeaponListControl *Weapon,int PlayerID)
{
	if (!obj || !Weapon || !PlayerID)
	{// Make sure function has all needed data
		return;
	}
	if (Has_Weapon(obj,Weapon->AltWeaponName))
	{// Only add this weapon's weight if it doens't have a dependant alt weapon
		return;
	}
	else if (Weapon->WeaponSize > 0)
	{// Add weapon's weigth to your inventroy
		RP2StarCurrentInventorySize[PlayerID] += Weapon->WeaponSize;
	}
	else
	{// Increase your max inventory size by the weapon's weight
		RP2StarMaxInventorySize[PlayerID] -= Weapon->WeaponSize;
	}
}

void WLS_Remove_Weapon_Weight(GameObject *obj,RP2WeaponListControl *Weapon,int PlayerID)
{
	if (!obj || !Weapon || !PlayerID)
	{// Make sure function has all needed data
		return;
	}
	if (Has_Weapon(obj,Weapon->AltWeaponName))
	{// Only remove this weapon's weight if it doens't have a dependant alt weapon
		return;
	}
	else if (Weapon->WeaponSize > 0)
	{// Remove weapon's weight to your inventroy
		RP2StarCurrentInventorySize[PlayerID] -= Weapon->WeaponSize;
	}
	else
	{// Decrease your max inventory size by the weapon's weight
		RP2StarMaxInventorySize[PlayerID] += Weapon->WeaponSize;
	}
}

void Dropped_Weapon_Limiter(GameObject *obj,RP2WeaponListControl *Node,int Bullets)
{
start:
	if (!DroppedWeaponNode)
	{
		DroppedWeaponNode = new DroppedWeaponControl;
		DroppedWeaponNode->PowerupID = Commands->Get_ID(obj);
		DroppedWeaponNode->Bullets = Bullets;
		sprintf(DroppedWeaponNode->WeaponName,"%s",Node->WeaponName);
		DroppedWeaponNode->next = NULL;
	}
	else
	{
		int end = 0,Count = 0;
		DroppedWeaponControl *Current = DroppedWeaponNode,*Prev = NULL;
		while (Current != NULL && !end)
		{
			Count++;
			GameObject *Powerup = Commands->Find_Object(Current->PowerupID);
			if (!Powerup)
			{
				Count--;
				if (Prev == NULL)// Head of List
				{
					DroppedWeaponControl *Temp = DroppedWeaponNode->next;
					delete DroppedWeaponNode;
					DroppedWeaponNode = Temp;
				}
				else if (Prev != NULL && Current->next == NULL)// End Of List
				{
					Prev->next = NULL;
					delete Current;
					Current = Prev;
				}
				else if (Prev != NULL && Current->next != NULL)
				{
					Prev->next = Current->next;
					delete Current;
					Current = Prev;
				}
				goto start;
			}
			if (Count >= MAXDROPPEDWEAPONS && Current->next == NULL)
			{
				end = 1;
				Current->next = new DroppedWeaponControl;
				Current = Current->next;
				Current->PowerupID = Commands->Get_ID(obj);
				sprintf(Current->WeaponName,"%s",Node->WeaponName);
				Current->Bullets = Bullets;
				Current->next = NULL;

				DroppedWeaponControl *Temp = DroppedWeaponNode->next;
				Powerup = Commands->Find_Object(DroppedWeaponNode->PowerupID);
				if (Powerup)
				{
					Commands->Destroy_Object(Powerup);
				}
				delete DroppedWeaponNode;
				DroppedWeaponNode = Temp;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new DroppedWeaponControl;
				Current = Current->next;
				sprintf(Current->WeaponName,"%s",Node->WeaponName);
				Current->PowerupID = Commands->Get_ID(obj);
				Current->Bullets = Bullets;
				Current->next = NULL;
			}
			Prev = Current;
			Current = Current->next;
		}
	}
}

DroppedWeaponControl *Find_Nearby_Dropped_Powerups(GameObject *obj,const char *Weapon)
{
	if (DroppedWeaponNode)
	{
		Vector3 Pos = Commands->Get_Position(obj);
		DroppedWeaponControl *Current = DroppedWeaponNode;
		while (Current != NULL)
		{
			if (!_stricmp(Weapon,Current->WeaponName))
			{
				GameObject *Object = Commands->Find_Object(Current->PowerupID);
				if (Object)
				{
					if (Commands->Get_Distance(Pos,Commands->Get_Position(Object)) < 5.0f)
					{
						return Current;
					}
				}
			}
			Current = Current->next;
		}
	}
	return NULL;
}

RP2PUWCPlayerListControl *FindMyPlayerListNode(const char *PlayerName)
{// Called by other functions to find the player's weapon node list
	if (!RP2PUWCPlayerListNode)
	{
		RP2PUWCPlayerListNode = new RP2PUWCPlayerListControl;
		sprintf(RP2PUWCPlayerListNode->PlayerName,"%s",PlayerName);
		RP2PUWCPlayerListNode->List = NULL;
		RP2PUWCPlayerListNode->next = NULL;
		return RP2PUWCPlayerListNode;
	}
	else
	{
		RP2PUWCPlayerListControl *Current = RP2PUWCPlayerListNode;
		while (Current)
		{
			if (!_stricmp(PlayerName,Current->PlayerName))
			{
				return Current;
			}
			else if (!Current->next)
			{
				Current->next = new RP2PUWCPlayerListControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				Current->List = NULL;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void AddWeaponNodeToMyCarriedList(const char *PlayerName,RP2WeaponListControl *WeaponNode)
{// Adds the node to the player's weapon list
	RP2PUWCPlayerListControl *MyNode = FindMyPlayerListNode(PlayerName);
	if (!MyNode->List)
	{
		MyNode->List = new RP2PickedUpWeaponControl;
		MyNode->List->PickedUpNode = WeaponNode;
		MyNode->List->WeaponTotalAmmo = 0;
		MyNode->List->next = NULL;
	}
	else
	{
		RP2PickedUpWeaponControl *Current = MyNode->List;
		while (Current)
		{
			if (Current->PickedUpNode == WeaponNode)
			{
				return;
			}
			else if (!Current->next)
			{
				Current->next = new RP2PickedUpWeaponControl;
				Current = Current->next;
				Current->PickedUpNode = WeaponNode;
				Current->WeaponTotalAmmo = 0;
				Current->next = NULL;
				return;
			}
			Current = Current->next;
		}
	}
}

void SpecialGivePowerup(GameObject *obj,RP2WeaponListControl *TheWeapon)
{// Adds the weapon to the player's picked up list
	const char *str = Get_Player_Name(obj);
	AddWeaponNodeToMyCarriedList(str,TheWeapon);
	delete[] str;
	Commands->Give_PowerUp(obj,TheWeapon->PowerUpName,true);
}

void GetAmmoForWeaponsInList(GameObject *obj,const char *PlayerName,int Divisor)
{// Gets half the ammo for all weapons in the players list
	RP2PUWCPlayerListControl *MyNode = FindMyPlayerListNode(PlayerName);
	if (MyNode->List)
	{
		RP2PickedUpWeaponControl *Current = MyNode->List;
		while (Current)
		{
			Current->WeaponTotalAmmo = Get_Total_Bullets(obj,Current->PickedUpNode->WeaponName)/Divisor;// The divisor is used to cut your ammo amount by its value
			Current = Current->next;
		}
	}
}

void SFillTheGun(GameObject *obj,int GunBullets,RP2WeaponListControl *TheWeapon)
{// Special Fill Gun Function
	if (!Get_Total_Bullets(obj,TheWeapon->WeaponName))
	{// Gun is empty, fill clip first
		if (GunBullets > Get_Max_Bullets(obj,TheWeapon->WeaponName))
		{// plenty of ammo
			Set_Bullets(obj,TheWeapon->WeaponName,Get_Max_Bullets(obj,TheWeapon->WeaponName));
			GunBullets -= Get_Max_Bullets(obj,TheWeapon->WeaponName);
		}
		else
		{// not enough ammo
			Set_Bullets(obj,TheWeapon->WeaponName,GunBullets);
			GunBullets = 0;
		}
	}
	if (GunBullets > Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName))// plenty of ammo
	{
		GunBullets -= Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName);
		Set_Clip_Bullets(obj,TheWeapon->WeaponName,Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName));
	}
	else
	{
		Set_Clip_Bullets(obj,TheWeapon->WeaponName,GunBullets);
		GunBullets = 0;
	}
	// UPDATE INVENTORY WEIGHTS
	if (TheWeapon->AmmoSize)
	{
		int PlayerID = Get_Player_ID(obj);
		Add_Or_Update_RP2PlayerSAWT_Node(PlayerID,TheWeapon->WeaponName)->LastAmmoCount = Get_Total_Bullets(obj,TheWeapon->WeaponName);
	}
}

void GrantTheWeapon(GameObject *obj,RP2WeaponListControl *TheWeapon,int WeaponBullets)
{// Code that checks if you can carry the weapon, and gives it to you if you can
	if (!TheWeapon || !WeaponBullets)
	{// Don't bother, no ammo = no weapon
		return;
	}
	int PlayerID = Get_Player_ID(obj);
	if (Has_Weapon(obj,TheWeapon->WeaponName))
	{// If you already have the weapon don't attempt to 
		RP2StarCurrentInventorySize[PlayerID] -= TheWeapon->WeaponSize;
	}
	if (!ISSELECTINGSPAWN[PlayerID] && ((!Has_Weapon(obj,TheWeapon->WeaponName) && Get_Weapon_Count(obj) < RP2MAXINVENTORYWEAPONLIMIT && 
		((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) && 
		((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->AmmoSize) <= RP2StarMaxInventorySize[PlayerID])) || /*You donot have the weapon, your weapon count is less then the max and your inventory weight is less than the max*/
		(Has_Weapon(obj,TheWeapon->WeaponName) && 
		(Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) > Get_Clip_Bullets(obj,TheWeapon->WeaponName)) && 
		((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->AmmoSize) <= RP2StarMaxInventorySize[PlayerID]))))// You already have the weapon, and you have room for more ammo
	{
		if (!Has_Weapon(obj,TheWeapon->WeaponName))
		{// Dont have the weapon, take up some space
			Commands->Give_PowerUp(obj,TheWeapon->PowerUpName,1);
			RP2StarCurrentInventorySize[PlayerID] += TheWeapon->WeaponSize;
		}
		if (Has_Weapon(obj,TheWeapon->WeaponName))
		{// Make SURE it has the weapon
			int GrantBullets = WeaponBullets;
			if (GrantBullets == -1){GrantBullets = Get_Max_Total_Bullets(obj,TheWeapon->WeaponName);}// Powerup gives max bullets
			int GunBullets = Get_Clip_Bullets(obj,TheWeapon->WeaponName) + GrantBullets; // Add all your backpack bullets to the powerup's bullets (SO THIS IS ALL THE BULLETS THAT CAN COME INTO PLAY)
			// NEW INVENTORY CALCULATION HERE (BULLETS TAKE SPACE)// used to be Get_Total_Bullets
			if (TheWeapon->AmmoSize)
			{// Ammo takes up inventory, needs special handeling
				int GrantedBullets = 0;
				while ((GrantedBullets < Get_Max_Total_Bullets(obj,TheWeapon->WeaponName)) && ((GunBullets - GrantedBullets) > 0) && ((RP2StarCurrentInventorySize[PlayerID] + (TheWeapon->AmmoSize*GrantedBullets)) <= RP2StarMaxInventorySize[PlayerID]))
				{
					GrantedBullets++;
				}
				RP2StarCurrentInventorySize[PlayerID] += (TheWeapon->AmmoSize*GrantedBullets);
				SFillTheGun(obj,GrantedBullets,TheWeapon);
				return;//End, previous function should handel all special cases for the object class
			}
			// FOR WEAPONS WITH INFINITE AMMO
			if ((Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) == -1 || Get_Max_Bullets(obj,TheWeapon->WeaponName) == -1))
			{// for weapons like the knife/wrench
				Set_Bullets(obj,TheWeapon->WeaponName,Get_Max_Bullets(obj,TheWeapon->WeaponName));
				Set_Clip_Bullets(obj,TheWeapon->WeaponName,Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName));
				return;
			}
			SFillTheGun(obj,GunBullets,TheWeapon);
		}
	}
}

void GrantAllWeaponsInList(GameObject *obj,const char *PlayerName)
{// Grants all weapons (with an ammo > 0) in the player's weapon list
	RP2PUWCPlayerListControl *MyNode = FindMyPlayerListNode(PlayerName);
	if (!MyNode || !obj)
	{// Don't bother, node/player no longer exists
		return;
	}
	if (MyNode->List)
	{
		RP2PickedUpWeaponControl *Current = MyNode->List;
		while (Current)
		{// Crash Likes to occure on the next line
			GrantTheWeapon(obj,Current->PickedUpNode,Current->WeaponTotalAmmo);
			Current = Current->next;
		}
	}
}

void Remove_Weapon_Safe(GameObject *obj,const char *WeaponName)
{
	if (Has_Weapon(obj,WeaponName))
	{
		Commands->Select_Weapon(obj,"Weapon_Empty_Hands");
		Remove_Weapon(obj,WeaponName);
		Commands->Select_Weapon(obj,"Weapon_Empty_Hands");
	}
}

float Weapon_Refill_Modifier(GameObject *obj,const char *WeaponName,float SingleBulletCost)
{
	if (Get_Total_Bullets(obj,WeaponName) == -1){return 0.0;}
	int WeaponType = 0;
	RP2WeaponListControl *MyNode = Get_WLS_Weapon_Settings(WeaponName);
	if (MyNode){WeaponType = MyNode->WeaponClass;}
	switch (WeaponType)
	{
	case BODY:SingleBulletCost *= 0.0;break;
	case PHONE:SingleBulletCost *= 0.0;break;
	case ITEM:SingleBulletCost *= 0.0;break;
	case SWORD:SingleBulletCost *= 0.0;break;
	case KNIFE:SingleBulletCost *= 0.0;break;
	case MISC:SingleBulletCost *= 0.0;break;
	case PISTOL:SingleBulletCost /= 8.0;break;
	case SHOTGUN:SingleBulletCost /= 6.0;break;
	case RIFLE:SingleBulletCost /= 4.0;break;
	case LAUNCHER:SingleBulletCost /= 2.0;break;
	case ROCKETLAUNCHER:SingleBulletCost /= 1.0;break;
	case CANNON:SingleBulletCost /= 1.0;break;
	case MACHINEGUN:SingleBulletCost /= 3.0;break;
	case GATTLINGGUN:SingleBulletCost /= 1.0;break;
	case LIQUIDSPRAYER:SingleBulletCost /= 4.0;break;
	case SUBMACHINEGUN:SingleBulletCost /= 5.0;break;
	case SNIPERRIFLE:SingleBulletCost /= 1.0;break;
	case GRENADE:SingleBulletCost /= 5.0;break;
	default:SingleBulletCost /= 1.0;break;
	}
	return SingleBulletCost;
}

// Clean Up Tests
void Test_Node_For_Null(void *TestNode,const char *Message)
{
	if (TestNode)
	{
		char MESS[200];
		sprintf(MESS,"MESSAGE WARNING: Linked List: %s is not NULL!",Message);
		Console_Input(MESS);
		TestNode = NULL;
	}
}

void Test_All_Nodes_For_NULL()
{
	Test_Node_For_Null(AntiMissileSystemNode,"AntiMissileSystemNode");
	Test_Node_For_Null(PlayerCharacterNode,"PlayerCharacterNode");
	for (int x = 0;x < 128;x++){Test_Node_For_Null(ObjectLimitNode[x],"ObjectLimitNode");}
	Test_Node_For_Null(SCUD_Missile_Launcher_Node,"SCUD_Missile_Launcher_Node");
	Test_Node_For_Null(RP2PlayerBankAccountNode,"RP2PlayerBankAccountNode");
	Test_Node_For_Null(RP2RandomTeleportPositionNode,"RP2RandomTeleportPositionNode");
	Test_Node_For_Null(RP2GiveObjectiveByCreationLocationNode,"RP2GiveObjectiveByCreationLocationNode");
	Test_Node_For_Null(RP2MissionObjectiveTypeNode,"RP2MissionObjectiveTypeNode");
	Test_Node_For_Null(RP2PhoneMissionNode,"RP2PhoneMissionNode");
	Test_Node_For_Null(RP2PhoneTextNode,"RP2PhoneTextNode");
	Test_Node_For_Null(PlayerSpecificPNNode,"PlayerSpecificPNNode");
	Test_Node_For_Null(RP2WeaponListNode,"RP2WeaponListNode");
	for (int x = 0;x < 128;x++){Test_Node_For_Null(RP2PlayerSAWTArray[x],"RP2PlayerSAWTArray");}
	Test_Node_For_Null(DroppedWeaponNode,"DroppedWeaponNode");
	Test_Node_For_Null(RP2PickedUpWeaponNode,"RP2PickedUpWeaponNode");
	Test_Node_For_Null(RP2PUWCPlayerListNode,"RP2PUWCPlayerListNode");
	Test_Node_For_Null(PhoneNumbers,"PhoneNumbers");
	Test_Node_For_Null(CellPhoneNumberNode,"CellPhoneNumberNode");
	Test_Node_For_Null(PlayerRedialNumberNode,"PlayerRedialNumberNode");
	Test_Node_For_Null(PlayerCellPhoneIDNode,"PlayerCellPhoneIDNode");
	Test_Node_For_Null(SwimmingWaterZoneTypeNode,"SwimmingWaterZoneTypeNode");
	Test_Node_For_Null(SwimmingAnimationTypeNode,"SwimmingAnimationTypeNode");
	Test_Node_For_Null(RP2VehicleNode,"RP2VehicleNode");
	Test_Node_For_Null(SwimmingScubaGearNode,"SwimmingScubaGearNode");
	Test_Node_For_Null(RP2SwimmingZoneTypeIndexNode,"RP2SwimmingZoneTypeIndexNode");
	Test_Node_For_Null(RP2NewHouseSystemNode,"RP2NewHouseSystemNode");
	Test_Node_For_Null(WeaponCupboardNode,"WeaponCupboardNode");
	Test_Node_For_Null(PlayerHouseVehicleNode,"PlayerHouseVehicleNode");
	Test_Node_For_Null(FishTypeNode,"FishTypeNode");
	Test_Node_For_Null(FishSchoolNode,"FishSchoolNode");
	Test_Node_For_Null(PlayerFavoriteVehicleNode,"PlayerFavoriteVehicleNode");
	Test_Node_For_Null(PlayerFavoriteWeaponNode,"PlayerFavoriteWeaponNode");
	Test_Node_For_Null(WarthogNode,"WarthogNode");
	Test_Node_For_Null(HomeSecuritySystemNode,"HomeSecuritySystemNode");
	Test_Node_For_Null(HomeSecurityObjectNode,"HomeSecurityObjectNode");
	Test_Node_For_Null(HomeSecurityZoneNode,"HomeSecurityZoneNode");
	Test_Node_For_Null(DefaultRP2WeatherNode,"DefaultRP2WeatherNode");
	Test_Node_For_Null(ArcticRP2WeatherNode,"ArcticRP2WeatherNode");
	Test_Node_For_Null(RenhaloRP2WeatherNode,"RenhaloRP2WeatherNode");
	Test_Node_For_Null(MarsRP2WeatherNode,"MarsRP2WeatherNode");
	Test_Node_For_Null(RCRP2WeatherNode,"RCRP2WeatherNode");
	Test_Node_For_Null(CanadaRP2WeatherNode,"CanadaRP2WeatherNode");
	for (int x = 0;x < 128;x++){Test_Node_For_Null(PlayerWeatherNodes[x],"PlayerWeatherNodes");}
}

// VEHICLE STUFF
#define VISIBLESEATCONNECTIONOBJECTOVERRIDECUSTOM 975421365
RP2VehicleControl *Get_Vehicle_Node(GameObject *obj)
{
	if (RP2VehicleNode)
	{
		RP2VehicleControl *Current = RP2VehicleNode;
		int MyID = Commands->Get_ID(obj);
		while (Current)
		{
			if (Current->VehicleID == MyID)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

WarthogControl *Get_Warthog_Node(GameObject *obj)
{
	if (WarthogNode)
	{
		int MyID = Commands->Get_ID(obj);
		WarthogControl *Current = WarthogNode;
		while (Current)
		{
			if (Current->BodyID == MyID || Current->GunnerID == MyID || Current->TurretID == MyID)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

#define STRIKECRAFTJUMPCHARGE 120.0f
int RUNNINGGAMETIMES;
int RUNNINGGAMETIMEM;
int RUNNINGGAMETIMEH;
// MISSION STUFF
int Get_Player_Mission_Objective_Count(const char *PlayerName,int MissionType)
{
	if (RP2PlayerMissionsNode)
	{
		int end = 0;
		RP2PlayerMissionsControl *Current = RP2PlayerMissionsNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				int end2 = 0;
				MissionTypes *Current2 = Current->Mission;
				while (Current2 != NULL && end2 == 0)
				{
					if (Current2->MissionType == MissionType)
					{
						end2 = 1;
						return Current2->CompletedMissionObjectives + Current2->StartedMission;
					}
					Current2 = Current2->next;
				}
				end = 1;
			}
			Current = Current->next;
		}
	}
	return 0;
}

int Check_Player_Mission_Avability(const char *PlayerName,int MT)
{
	if (RP2PlayerMissionsNode)
	{
		int end = 0;
		RP2PlayerMissionsControl *Current = RP2PlayerMissionsNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				MissionTypes *Current2 = Current->Mission;
				while (Current2 != NULL)
				{
					if (Current2->MissionType == MT)
					{
						if (!Current2->StartedMission && !Current2->MissionCompleted)
						{
							return 1;
						}
						else
						{
							return 0;
						}
					}
					Current2 = Current2->next;
				}
				return 1;
			}
			Current = Current->next;
		}
	}
	return 0;
}

int Check_Player_Mission_InComplete(const char *PlayerName,int MT)
{
	if (RP2PlayerMissionsNode)
	{
		int end = 0;
		RP2PlayerMissionsControl *Current = RP2PlayerMissionsNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				int end2 = 0;
				MissionTypes *Current2 = Current->Mission;
				while (Current2 != NULL && end2 == 0)
				{
					if (Current2->MissionType == MT)
					{
						end2 = 1;
						if (!Current2->MissionCompleted)
						{
							return Current2->CompletedMissionObjectives + Current2->StartedMission;
						}
					}
					Current2 = Current2->next;
				}
				end = 1;
			}
			Current = Current->next;
		}
	}
	return 0;
}

void Get_Player_Debug_Mission_List(const char *PlayerName)
{
	Console_Input("MESSAGE HEAD OF THE NODE TREE");
	if (RP2PlayerMissionsNode)
	{
		int end = 0;
		RP2PlayerMissionsControl *Current = RP2PlayerMissionsNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				MissionTypes *Current2 = Current->Mission;
				while (Current2 != NULL)
				{
					char NODE[2000];
					sprintf(NODE,"MESSAGE NODE:%d",Current2->MissionType);
					Console_Input(NODE);
					Current2 = Current2->next;
				}
			}
			Current = Current->next;
		}
	}
	Console_Input("MESSAGE END NULL");
}

void Debug_A_Linked_List()
{
	Console_Input("MESSAGE HEAD OF THE NODE TREE");
	if (PlayerFavoriteVehicleNode)
	{
		PlayerFavoriteVehicleControl *Current = PlayerFavoriteVehicleNode;
		while (Current != NULL)
		{
			char NODE[2000];
			sprintf(NODE,"MESSAGE =========NODE:%s=========",Current->PlayerName);
			Console_Input(NODE);
			sprintf(NODE,"MESSAGE Buy String:%s",Current->VehicleName);
			Console_Input(NODE);
			sprintf(NODE,"MESSAGE Confirmation String:%s",Current->VehiclePreset);
			Console_Input(NODE);
			sprintf(NODE,"MESSAGE Goodbye String:%d",Current->VehicleCost);
			Console_Input(NODE);
			Current = Current->next;
		}
	}
	Console_Input("MESSAGE END NULL");
}

void Print_Missions()
{
	Console_Input("MESSAGE HEAD OF THE NODE TREE");
	if (RP2MissionObjectiveTypeNode)
	{
		RP2MissionObjectiveTypeControl *Current = RP2MissionObjectiveTypeNode;
		while (Current != NULL)
		{
			char NODE[2000];
			sprintf(NODE,"MESSAGE =========NODE MissionType:%d=========",Current->MissionType);
			Console_Input(NODE);
			Current = Current->next;
		}
	}
	Console_Input("MESSAGE END NULL");
}

int Get_Gun_Position(GameObject *obj,const char *WeaponName)
{
	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
	if (!o2){return 0;}
	ArmedGameObj *o3 = o2->As_ArmedGameObj();
	if (!o3){return 0;}
	WeaponBagClass *w = o3->Get_Weapon_Bag();
	int x = w->Get_Count();
	for (int i = 0;i < x;i++)
	{
		if (w->Peek_Weapon(i))
		{
			if (!_stricmp(w->Peek_Weapon(i)->Get_Definition()->Get_Name(),WeaponName))
			{
				return i;
			}
		}
	}
	return 0;
}

void Get_Killer_Weapon_Syntax(GameObject *Killer,char *Message)
{
	if (RP2WeaponListNode)
	{
		const char *Weapon = Get_Current_Weapon(Killer);
		if (Weapon)
		{
			RP2WeaponListControl *ANode = Get_WLS_Weapon_Settings(Weapon);
			if (ANode)
			{
				if (ANode->WeaponClass == BODY)
				{
					if (Get_Sex(Killer) == 'A')
					{
						const char *str = Get_Translated_Weapon(Killer,Get_Gun_Position(Killer,Weapon));
						sprintf(Message,"with his %s",str);
						delete[] str;
					}
					else
					{
						const char *str = Get_Translated_Weapon(Killer,Get_Gun_Position(Killer,Weapon));
						sprintf(Message,"with her %s",str);
						delete[] str;
					}
				}
				else
				{
					const char *str = Get_Translated_Weapon(Killer,Get_Gun_Position(Killer,Weapon));
					sprintf(Message,"with a %s",str);
					delete[] str;
				}
			}
		}
	}
}

void TextPrintColor(int PlayerID,const char *Message)
{
	if (!HASPRINTEDDEATHMESSAGE[PlayerID])
	{
		HASPRINTEDDEATHMESSAGE[PlayerID] = 1;
		if (!Get_Team(PlayerID))
		{
			for (int x = 1;x < 128;x++)
			{
				GameObject *Player = Get_GameObj(x);
				if (Player)
				{
					Send_Message_Player(Player,255,0,0,Message);
				}
			}
		}
		else
		{
			for (int x = 1;x < 128;x++)
			{
				GameObject *Player = Get_GameObj(x);
				if (Player)
				{
					Send_Message_Player(Player,255,204,0,Message);
				}
			}
		}
	}
}

void RP2_Player_Death_Message_Control(GameObject *obj,const char *DeathMessage,GameObject *Killer)
{
	if (Commands->Is_A_Star(obj))
	{
		int PlayerID = Get_Player_ID(obj);
		char Message[237];
		sprintf(Message,"null");
		if (Killer)
		{
			if (Killer == obj)
			{
				if (Get_Sex(obj) == 'B')
				{
					const char *str = Get_Player_Name(obj);
					sprintf(Message,"%s killed herself.",str);
					delete[] str;
				}
				else
				{
					const char *str = Get_Player_Name(obj);
					sprintf(Message,"%s killed himself.",str);
					delete[] str;
				}
			}
			else if (Commands->Is_A_Star(Killer) || Commands->Is_A_Star(Get_Vehicle_Driver(Killer)))
			{
				const char *KillerWeapon = Get_Current_Weapon(Killer);
				if (Commands->Is_A_Star(Get_Vehicle_Driver(Killer)))
				{
					Killer = Get_Vehicle_Driver(Killer);
				}
				if (Get_Vehicle(Killer))
				{
					const char *str = Get_Translated_Preset_Name(Get_Vehicle(Killer));
					const char *str2 = Get_Player_Name(Killer);
					const char *str3 = Get_Player_Name(obj);
					sprintf(Message,"%s killed %s while driving a %s.",str2,str3,str);
					delete[] str3;
					delete[] str2;
					delete[] str;
				}
				else if (KillerWeapon)
				{
					char Data[128];
					Get_Killer_Weapon_Syntax(Killer,Data);
					const char *str = Get_Player_Name(Killer);
					const char *str2 = Get_Player_Name(obj);
					sprintf(Message,"%s killed %s %s.",str,str2,Data);
					delete[] str;
					delete[] str2;
				}
				TextPrintColor(Get_Player_ID(Killer),Message);
				return;
			}
			else if (!_stricmp(Commands->Get_Preset_Name(Killer),"Flamethrower_Fuel_Tank"))
			{
				const char *str = Get_Player_Name(obj);
				sprintf(Message,"%s was killed by a combusting flamethrower's fuel tank.",str);
				delete[] str;
			}
			else
			{
				const char *str = Get_Translated_Preset_Name(Killer);
				const char *str2 = Get_Player_Name(obj);
				sprintf(Message,"%s was killed by a %s",str2,str);
				delete[] str;
				delete[] str2;
			}
		}
		else if (!_stricmp("null",DeathMessage) && !_stricmp("null",Message))
		{
			const char *str = Get_Player_Name(obj);
			sprintf(Message,"%s has died.",str);
			delete[] str;
		}
		else
		{
			sprintf(Message,"%s",DeathMessage);
		}
		TextPrintColor(PlayerID,Message);
	}
}

// Weapons Cupboard
#define GIVEOUTNEWWEAPONTIME 400
#define GIVEOUTNEWWEAPONTIMEM1 (GIVEOUTNEWWEAPONTIME-1)
// HOUSE STUFF (Condensed 4 linked lists and one array into a single linked lists because there was little to no efficency gain and the code was unbearable to work with 3/20/10).
int IsInsideHouse[128] = {0};
#define OBJECTTOALREAPIRVALUE 500.0f
HomeSecuritySystemControl *CreateSecurityNode(HomeSecuritySystemControl *TargetNode,int Address)
{
	time_t secs=time(0);
	tm *t=localtime(&secs);
	TargetNode = new HomeSecuritySystemControl;
	TargetNode->HouseAddress = Address;
	TargetNode->NumberOfPrePays = 0;
	TargetNode->RentYear = t->tm_year;
	TargetNode->RentDay = t->tm_yday;
	TargetNode->RentPrice = 0;
	TargetNode->DetectIntruders = false;
	TargetNode->DetectVandals = false;
	TargetNode->CeilingGuns = false;
	TargetNode->MissileDefenseSystem = false;
	TargetNode->AutoRepair = false;
	for (int x = 0;x < 128;x++)
	{
		TargetNode->Intruding[x] = 0;
	}
	TargetNode->SoundAlarm = false;
	for (int x = 0;x < 5;x++)
	{
		TargetNode->HouseSecurityAlarmIDs[x] = 0;
	}
	TargetNode->next = NULL;
	return TargetNode;
}

RP2NewHouseSystemControl *Add_Or_Update_Housing_Node(int Address)
{
	if (!RP2NewHouseSystemNode)
	{
		RP2NewHouseSystemNode = new RP2NewHouseSystemControl;
		sprintf(RP2NewHouseSystemNode->PlayerName,"null");
		RP2NewHouseSystemNode->HouseAddress = Address;
		RP2NewHouseSystemNode->NumberOfPrePays = 0;
		RP2NewHouseSystemNode->RentTime = 0;
		RP2NewHouseSystemNode->HouseYear = 0;
		RP2NewHouseSystemNode->HouseDay = 0;
		RP2NewHouseSystemNode->IsOwned = 0;
		RP2NewHouseSystemNode->ControllerID = 0;
		RP2NewHouseSystemNode->SpawnObjectID = 0;
		RP2NewHouseSystemNode->RentPrice = 0;
		RP2NewHouseSystemNode->next = NULL;
		return RP2NewHouseSystemNode;
	}
	else
	{
		RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
		while (Current != NULL)
		{
			if (Current->HouseAddress == Address)
			{
				return Current;
			}
			else if (Current->next == NULL)
			{
				Current->next = new RP2NewHouseSystemControl;
				Current = Current->next;
				Current->HouseAddress = Address;
				sprintf(Current->PlayerName,"null");
				Current->NumberOfPrePays = 0;
				Current->RentTime = 0;
				Current->HouseYear = 0;
				Current->HouseDay = 0;
				Current->IsOwned = 0;
				Current->ControllerID = 0;
				Current->SpawnObjectID = 0;
				Current->RentPrice = 0;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

RP2NewHouseSystemControl *Find_Housing_Node(int Address)
{
	if (RP2NewHouseSystemNode)
	{
		RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
		while (Current != NULL)
		{
			if (Current->HouseAddress == Address)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

HomeSecuritySystemControl *Find_Housing_Security_Node(int Address)
{
	if (HomeSecuritySystemNode)
	{
		HomeSecuritySystemControl *Current = HomeSecuritySystemNode;
		while (Current != NULL)
		{
			if (Current->HouseAddress == Address)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

// Added so fog controller no longer has to be defined on the script
void RP2_Set_Fog_And_Screen_Color_To_Level_Default(GameObject *sender)
{
	RP2WeatherStruct *MyNode = PlayerWeatherNodes[Get_Player_ID(sender)];
	if (MyNode)
	{
		if (!_stricmp(Commands->Get_Preset_Name(sender),"Power_Armor"))
		{
			Set_Fog_Enable_Player(sender,MyNode->FogEnabled);
			Set_Fog_Range_Player(sender,MyNode->FogMinDist,MyNode->FogMaxDist,0);
			Set_Screen_Fade_Color_Player(sender,MyNode->ScreenColor.X+0.0f,MyNode->ScreenColor.Y+0.0f,MyNode->ScreenColor.Z+0.25f,0);
			Set_Screen_Fade_Opacity_Player(sender,MyNode->ScreenOpacity+0.2f,0);
		}
		else
		{
			Set_Fog_Enable_Player(sender,MyNode->FogEnabled);
			Set_Fog_Range_Player(sender,MyNode->FogMinDist,MyNode->FogMaxDist,0);
			Set_Screen_Fade_Color_Player(sender,MyNode->ScreenColor.X,MyNode->ScreenColor.Y,MyNode->ScreenColor.Z,0);
			Set_Screen_Fade_Opacity_Player(sender,MyNode->ScreenOpacity,0);
		}
	}
	else
	{
		Set_Fog_Enable_Player(sender,1);
		Set_Fog_Range_Player(sender,300.0,600.0,0);
		Set_Screen_Fade_Color_Player(sender,0.0,0.0,0.0,0);
		Set_Screen_Fade_Opacity_Player(sender,0.0,0);
	}
}

RP2WeatherStruct *RP2_Area_Weather_Selection_Control(int AreaID,RP2WeatherStruct *Node)
{
	switch (AreaID)
	{
	case 0://MainLand
		if (Node){DefaultRP2WeatherNode = Node;}
		return DefaultRP2WeatherNode;
	case 1://Arctic
		if (Node){ArcticRP2WeatherNode = Node;}
		return ArcticRP2WeatherNode;
	case 2://Renhalo
		if (Node){RenhaloRP2WeatherNode = Node;}
		return RenhaloRP2WeatherNode;
	case 3://Mars
		if (Node){MarsRP2WeatherNode = Node;}
		return MarsRP2WeatherNode;
	case 4://RC
		if (Node){RCRP2WeatherNode = Node;}
		return RCRP2WeatherNode;
	case 5://Canada
		if (Node){CanadaRP2WeatherNode = Node;}
		return CanadaRP2WeatherNode;
	default:
		char error[128];
		sprintf(error,"MESSAGE ERROR: Weather area ID %d is not in the listing, weather area has been set to the Default!",AreaID);
		Console_Input(error);
		if (Node){DefaultRP2WeatherNode = Node;}
		return DefaultRP2WeatherNode;
	}
}

RP2RandomTeleportPositionControl *Get_Matching_Teleport_Node(int NODE)
{
	if (RP2RandomTeleportPositionNode)
	{
		RP2RandomTeleportPositionControl *Current = RP2RandomTeleportPositionNode;
		while (Current != NULL)
		{
			if (Current->SpotNumber == NODE)
			{
				if (Commands->Get_Distance(Commands->Get_Position(Commands->Get_A_Star(Current->Telepos)),Current->Telepos) < 10.0f)
				{
					Current = RP2RandomTeleportPositionNode;
					NODE = Commands->Get_Random_Int(0,TELEPORTMAXRANDCHOICE);
				}
				else
				{
					return Current;
				}
			}
			Current = Current->next;
		}
	}
	return NULL;
}

RP2RandomTeleportPositionControl *Find_Closest_Teleport_Node(GameObject *obj,float MinDistance,float MaxDistance)
{
	float Distance = 99999.9f;
	RP2RandomTeleportPositionControl *ReturnNode = NULL;
	Vector3 Pos = Commands->Get_Position(obj);
	if (RP2RandomTeleportPositionNode)
	{
		RP2RandomTeleportPositionControl *Current = RP2RandomTeleportPositionNode;
		while (Current != NULL)
		{
			float TempDistance = Commands->Get_Distance(Pos,Current->Telepos);
			if (TempDistance < Distance && TempDistance < MaxDistance && TempDistance > MinDistance)
			{
				Distance = TempDistance;
				ReturnNode = Current;
			}
			Current = Current->next;
		}
	}
	return ReturnNode;
}

extern RP2RandomTeleportPositionControl *Swarm_Get_Random_Teleport_Node(GameObject *obj,float Distance)
{
	Vector3 Pos = Commands->Get_Position(obj);
	if (RP2RandomTeleportPositionNode)
	{
		for (int x = 0;x < 5000;x++)
		{
			int RandomNode = Commands->Get_Random_Int(0,TELEPORTMAXRANDCHOICE);
			RP2RandomTeleportPositionControl *Current = RP2RandomTeleportPositionNode;
			while (Current != NULL)
			{
				if (RandomNode == Current->SpotNumber)
				{
					if (Commands->Get_Distance(Pos,Current->Telepos) < Distance)
					{
						return Current;
					}
				}
				Current = Current->next;
			}
		}
	}
	return NULL;
}

// END OF SPECIAL CRAP
void JMG_Slot_Machine_On_Poke::Created(GameObject *obj)
{
	didwin = 0;
	if (1 == Get_Int_Parameter("StartEnabled"))
	{
		enabled = true;
	}
	else
	{
		enabled = false;
	}
}

void JMG_Slot_Machine_On_Poke::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("EnableMessage"))
	{
		enabled = true;
	}
	if (message == Get_Int_Parameter("DisableMessage"))
	{
		enabled = false;
	}
}

void JMG_Slot_Machine_On_Poke::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(poker)])
		{
			if (enabled)
			{
				int cost;
				cost = Get_Int_Parameter("Cost");
				Commands->Create_Sound(Get_Parameter("PullSound"),Commands->Get_Position(obj),obj);
				if (cost <= Commands->Get_Money(poker))
				{
					int winnings = Get_Int_Parameter("Winnings");
					int percent = Get_Int_Parameter("Percent");
					int chance = Commands->Get_Random_Int(0,99);
					if (chance < percent)
					{
						didwin = 1;
						Commands->Give_Money(poker,(float)winnings,0);
						Commands->Set_Animation(obj,Get_Parameter("WinAnimation"),false,0,0,-1,false);
					}
					else
					{
						didwin = 0;
						cost = -cost;
						Commands->Give_Money(poker,(float)cost,0);
						Commands->Set_Animation(obj,Get_Parameter("LoseAnimation"),false,0,0,-1,false);
					}
					enabled = false;
				}
			}
		}
	}
}

void JMG_Slot_Machine_On_Poke::Animation_Complete(GameObject *obj,const char *anim)
{
	enabled = true;
	if (didwin == 1)
	{
		didwin = 2;
		Commands->Set_Animation(obj,Get_Parameter("LoseAnimation"),false,0,0,0,false);//Should Fix the client no animation glitch
		Commands->Create_Sound(Get_Parameter("WinSound"),Commands->Get_Position(obj),obj);
	}
	if (didwin == 0)
	{
		didwin = 2;
		Commands->Set_Animation(obj,Get_Parameter("WinAnimation"),false,0,0,0,false);//Should Fix the client no animation glitch
		Commands->Create_Sound(Get_Parameter("LoseSound"),Commands->Get_Position(obj),obj);
	}
}

void JMG_Visible_Infantry_In_Vehicle::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		GameObject *object = Commands->Find_Object(param);
		Commands->Set_Model(object,Get_Parameter("ModelName"));
		const char *subobject = Get_Parameter("Subobject");
		if (!_stricmp(subobject,"0"))
		{
			subobject = 0;
		}
		float firstframe = Get_Float_Parameter("FirstFrame");
		if (firstframe == -1)
		{
			firstframe = Get_Animation_Frame(obj);
		}
		Commands->Disable_Physical_Collisions(object);
		Commands->Disable_All_Collisions(object);
		Commands->Set_Animation(object,Get_Parameter("Animation"),true,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
	}
}

void JMG_Attach_Turret_And_Send_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	float facing = Commands->Get_Facing(obj);
	Vector3 position = Commands->Get_Position(obj);
	if (message == Get_Int_Parameter("CreateMessage"))
	{
		GameObject *object = Commands->Create_Object(Get_Parameter("Preset"),position);
		Commands->Set_Facing(object,facing);
		Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("BoneName"));
	}
	if (message == Get_Int_Parameter("SendMessageMessage"))
	{
		Send_Custom_All_Objects_Area(Get_Int_Parameter("SendMessage"),Commands->Get_Position(obj),0.1f,obj,2);
	}
}

// Updated Script To Work With Weapons
void JMG_Flash_Light_Toggle::Created(GameObject *obj)
{
	FlashLightID = 0;
	LightOn = 0;
}

void JMG_Flash_Light_Toggle::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7745471 && Has_Weapon(obj,"Weapon_Flashlight"))// Normal Light Toggle Command
	{
		if (!FlashLightID)
		{
			CreateLight(obj);
			LightOn = 1;
			Commands->Create_3D_Sound_At_Bone("Flashlight_On",obj,"gunbone");
		}
		else
		{
			DestroyLight();
			LightOn = 0;
			Commands->Create_3D_Sound_At_Bone("Flashlight_On",obj,"gunbone");
		}
	}
	if (message == 90000028)// Enter Vehicle
	{
		DestroyLight();
	}
	if (message == 90000029)// Exit Vehicle
	{
		if (LightOn)
		{
			CreateLight(obj);
		}
	}
	if (message == 347361)// Swimming
	{
		DestroyLight();
	}
	if (message == 347360)// Stop Swimming
	{
		if (LightOn)
		{
			CreateLight(obj);
		}
	}
	if (message == 7745470)// Turn off
	{
		DestroyLight();
	}
}

void JMG_Flash_Light_Toggle::Killed(GameObject *obj, GameObject *damager)
{
	DestroyLight();
}

void JMG_Flash_Light_Toggle::Destroyed(GameObject *obj)
{
	DestroyLight();
}

void JMG_Flash_Light_Toggle::CreateLight(GameObject *obj)
{
	if (!FlashLightID && Has_Weapon(obj,"Weapon_Flashlight") && !Get_Vehicle(obj) && !ISNEWSWIMMING[Get_Player_ID(obj)] && Commands->Get_Health(obj))
	{
		GameObject *flashlight = Commands->Create_Object("Master_Chief_Flash_Light_Beam",Commands->Get_Position(obj));
		Commands->Attach_To_Object_Bone(flashlight,obj,"gunbone");
		char params[20];
		sprintf(params,"%d",Commands->Get_ID(obj));
		Commands->Attach_Script(flashlight,"JMG_Remove_Object_When_Creator_Destroyed",params);
		FlashLightID = Commands->Get_ID(flashlight);
	}
}

void JMG_Flash_Light_Toggle::DestroyLight()
{
	if (FlashLightID)
	{
		GameObject *object = Commands->Find_Object(FlashLightID);
		Commands->Destroy_Object(object);
		FlashLightID = 0;
	}
}

void JMG_Dual_Weapon_Script::Created(GameObject *obj)
{
	Commands->Set_Is_Visible(obj,0);
}

void JMG_Dual_Weapon_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		const char *weaponpointer = Get_Current_Weapon(sender);
		if (weaponpointer)
		{
			if (!_stricmp(weaponpointer,Get_Parameter("Weapon")))
			{
				Commands->Set_Is_Visible(obj,1);
			}
		}
		else
		{
			Commands->Set_Is_Visible(obj,0);
		}
	}
}

void JMG_Free_For_All_Script::Created(GameObject *obj)
{
	MyMissionNode = NULL;
	FireTruckID = 0;
	// Added in the system for the weapons cupboard
	CupboardID = 0;
	Overweight = 0;
	PTUpdateWeaponsListDelay = 0;
	Commands->Attach_Script(obj,"Spawn_Zombie_When_Killed_By_Zombie","");
	//Commands->Attach_Script(obj,"JMG_Simple_Prone_On_Custom","3423432,s_a_human.h_a_h11c,85,3453453,-1.197,s_a_human.h_a_prone,1");
	Attach_Script_Once(obj,"JMG_RP2_Special_Death_Control","");
	Attach_Script_Once(obj,"JMG_RP2_Cop_Arrest_Script","");
	RP2_Set_Fog_And_Screen_Color_To_Level_Default(obj);
	for (int x = 0;x < 5;x++)
	{
		Ambulances[x] = 0;
	}
	/// 10/27/09 Ren's inventory weapons limit discovered 51	
	if (Commands->Is_A_Star(obj))
	{
		Enable_Radar_Player(obj,true);
		Commands->Enable_Enemy_Seen(obj,false);
		if (Has_Weapon(obj,"Weapon_Empty_Hands"))// Remove beacons (prevent them from transfering from char to char)
		{
			
			if (!Is_Script_Attached(obj,"JMG_RP2_Jerad")){if (Has_Weapon(obj,"Weapon_Vortex_Beacon")){Commands->Select_Weapon(obj,"Weapon_Empty_Hands");Remove_Weapon(obj,"Weapon_Vortex_Beacon");}if (Has_Weapon(obj,"Weapon_Tactical_Nuke")){Commands->Select_Weapon(obj,"Weapon_Empty_Hands");Remove_Weapon(obj,"Weapon_Tactical_Nuke");}}
			if (Has_Weapon(obj,"Weapon_Handcuffs")){Commands->Select_Weapon(obj,"Weapon_Empty_Hands");Remove_Weapon(obj,"Weapon_Handcuffs");}
			if (_stricmp((Commands->Get_Preset_Name(obj)),"Napalmic")){if (Has_Weapon(obj,"Weapon_Pain_Pills")){Commands->Select_Weapon(obj,"Weapon_Empty_Hands");Remove_Weapon(obj,"Weapon_Pain_Pills");}}
			if (Has_Weapon(obj,"Weapon_Drugs")){Commands->Select_Weapon(obj,"Weapon_Empty_Hands");Remove_Weapon(obj,"Weapon_Drugs");}
			if (Has_Weapon(obj,"Weapon_Detox")){Commands->Select_Weapon(obj,"Weapon_Empty_Hands");Remove_Weapon(obj,"Weapon_Detox");}
		}
		PlayerID = Get_Player_ID(obj);
		if (!Is_Script_Attached(obj,"JMG_RP2_Jerad"))
		{
			HASPRINTEDDEATHMESSAGE[PlayerID] = 0;
			RP2StarMaxInventorySize[PlayerID] = STARTINGINVENTORYSIZE;
			RP2StarCurrentInventorySize[PlayerID] = 0;
		}
		if (ISSELECTINGSPAWN[PlayerID])
		{
			Send_Message_Player(obj,150,0,0,"Please spawn first...");
			Commands->Destroy_Object(obj);
		}
		TEMPDISABLEWEAPONDROP[PlayerID] = 0;
		Commands->Start_Timer(obj,this,0.25f,45231897);
		Commands->Start_Timer(obj,this,0.1f,45231896);
		Commands->Start_Timer(obj,this,1.0f,55231899);	
		Commands->Start_Timer(obj,this,1.0f,55231900);
		Commands->Start_Timer(obj,this,0.0f,55231896);
		Add_Mission_Node(obj);
		Security_Check(obj);
		if (!Is_Script_Attached(obj,"JMG_RP2_Random_Civilian_Model"))
		{
			Player_Character_Node(obj);
		}
		const char *str = Get_Player_Name(obj);
		GrantAllWeaponsInList(obj,str);
		delete[] str;
	}
	else
	{
		Commands->Set_Player_Type(obj,-1);
		Attach_Script_Once(obj,"JMG_RP2_Object_Send_Text_Message_On_Death","");
	}
	SeeIfVisible = 0;
	HealthRegen = 0;
	SellZoneID = 0;
	MyHealthRegenTime = PLAYERHEALTHRENGENSTARTTIME;
	MyHealthRegenAmount = PLAYERHEALTHRENGENPERCENT;
	/*char mns[234];
	sprintf(mns,"MESSAGE My ID is:%d",MyIDNS);
	Console_Input(mns);*/
}

void JMG_Free_For_All_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 91193348)
	{
		Commands->Send_Custom_Event(obj,sender,91193349,1,0);
	}
	if (message == 91193350 && Get_Fly_Mode(obj) == 1)
	{
		Toggle_Fly_Mode(obj);
	}
	if (message == 3423430 && Commands->Is_A_Star(obj))
	{// Death Drop
		if (!Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
		{
			Death_Drop_Weapon(obj);
		}
		const char *str = Get_Player_Name(obj);
		GetAmmoForWeaponsInList(obj,str,2);
		delete[] str;
		if (Is_Script_Attached(obj,"JMG_Free_For_All_Script"))
		{// Remove the script so it doesn't trigger when your body gets removed
			Remove_Script(obj,"JMG_Free_For_All_Script");
		}
	}
	if (message == 3423432 && Commands->Is_A_Star(obj) && !Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach") && Commands->Get_Health(obj) && !Get_Vehicle(obj))
	{
		if (TEMPDISABLEWEAPONDROP[PlayerID])
		{
			Send_Message_Player(obj,255,127,127,"Greenpeace would piss all over the place if I threw this burning hot weapon onto the ground, better let it cool off before I discard it.");
			return;
		}
		const char *MyWeapon = Get_Current_Weapon(obj);
		if (MyWeapon && !ISNEWSWIMMING[PlayerID])
		{
			RP2WeaponListControl *Weapon = Get_WLS_Weapon_Settings(MyWeapon);
			if (Weapon && !Get_Vehicle(obj))
			{
				if (Weapon->CanBeDropped)
				{
					if (CupboardID)
					{
						GameObject *Cupboard = Commands->Find_Object(CupboardID);
						if (Cupboard)
						{
							Commands->Send_Custom_Event(obj,Cupboard,4045146,0,0);
						}
						else
						{
							Console_Input("MESSAGE ERROR: Weapons cupboard not found!");
						}
					}
					else if (SellZoneID)
					{
						if (Weapon->BulletCost && !Weapon->DropWhenEmpty && Weapon->AmmoSize)
						{
							Sell_Weapon_Single(obj,Weapon);
							return;
						}
						RP2StarCurrentInventorySize[PlayerID] -= Weapon->AmmoSize*Get_Total_Bullets(obj,Weapon->WeaponName);
						if (Sell_Weapon(obj,Weapon))
						{
							WLS_Remove_Weapon_Weight(obj,Weapon,PlayerID);
						}
						else{RP2StarCurrentInventorySize[PlayerID] += Weapon->AmmoSize*Get_Total_Bullets(obj,Weapon->WeaponName);}
						if (Weapon->DropMessage)
						{
							Commands->Send_Custom_Event(obj,obj,Weapon->DropMessage,1,0);
						}
					}
					else
					{
						if (Weapon->BulletCost && !Weapon->DropWhenEmpty && Weapon->AmmoSize)
						{
							Drop_Weapon_Single(obj,Weapon);
							return;
						}
						RP2StarCurrentInventorySize[PlayerID] -= Weapon->AmmoSize*Get_Total_Bullets(obj,Weapon->WeaponName);
						if (Drop_Weapon(obj,Weapon))
						{
							WLS_Remove_Weapon_Weight(obj,Weapon,PlayerID);
						}
						else{RP2StarCurrentInventorySize[PlayerID] += Weapon->AmmoSize*Get_Total_Bullets(obj,Weapon->WeaponName);}
						if (Weapon->DropMessage)
						{
							Commands->Send_Custom_Event(obj,obj,Weapon->DropMessage,1,0);
						}
					}
				}
				else
				{
					if (Weapon->WeaponClass == BODY)
					{
						Send_Message_Player(obj,255,127,127,"I don't feel like cutting my limbs off at the moment.");
					}
					else
					{
						Send_Message_Player(obj,255,127,127,"I cannot drop this weapon!");
					}
				}
			}
		}
		else
		{
			Send_Message_Player(obj,255,127,127,"I am not holding anything to drop!");
		}
	}
	if (message == 3423433 && Commands->Is_A_Star(obj) && Commands->Get_Health(obj) && !Get_Vehicle(obj))
	{
		if (TEMPDISABLEWEAPONDROP[Get_Player_ID(obj)])
		{
			Send_Message_Player(obj,255,127,127,"They won't touch this flamethrower until it cools down. Once it has cooled down I should try the transaction again.");
			return;
		}
		const char *MyWeapon = Get_Current_Weapon(obj);
		if (MyWeapon && !ISNEWSWIMMING[PlayerID])
		{
			RP2WeaponListControl *Weapon = Get_WLS_Weapon_Settings(MyWeapon);
			if (Weapon)
			{
				if (Weapon->CanBeDropped)
				{
					if (Weapon->BulletCost && !Weapon->DropWhenEmpty && Weapon->AmmoSize)
					{
						Sell_Weapon_Single(obj,Weapon);
						return;
					}
					RP2StarCurrentInventorySize[PlayerID] -= Weapon->AmmoSize*Get_Total_Bullets(obj,Weapon->WeaponName);
					if (Sell_Weapon(obj,Weapon))
					{
						WLS_Remove_Weapon_Weight(obj,Weapon,PlayerID);
					}
					else{RP2StarCurrentInventorySize[PlayerID] += Weapon->AmmoSize*Get_Total_Bullets(obj,Weapon->WeaponName);}
					if (Weapon->DropMessage)
					{
						Commands->Send_Custom_Event(obj,obj,Weapon->DropMessage,1,0);
					}
				}
				else
				{
					if (Weapon->WeaponClass == BODY)
					{
						Send_Message_Player(obj,255,127,127,"I don't feel like cutting my limbs off at the moment.");
					}
					else
					{
						Send_Message_Player(obj,255,127,127,"I cannot sell this weapon!");
					}
				}
			}
		}
		else
		{
			Send_Message_Player(obj,255,127,127,"I am not holding anything to sell!");
		}
	}
	if (message == 4045146)
	{
		CupboardID = param;
	}
	if (message == 4045156)
	{
		SellZoneID = param;
	}
	if (message == 51191170)
	{
		if (Commands->Is_A_Star(obj))
		{
			if (SeeIfVisible == 0)
			{
				Commands->Start_Timer(obj,this,0.1f,45231898);
			}
			SeeIfVisible += 30;
			Commands->Enable_Enemy_Seen(obj,true);
		}
	}
	if (message == 90000028)
	{
		Vehicle_Mission_Conflict_Check(obj,sender);
	}
	if (message == 70451564)
	{
		GameObject *object = Commands->Find_Object(param);
		if (object)
		{
			Vector3 pos = Commands->Get_Position(object);
			Force_Camera_Look_Player(obj,pos);
			Commands->Destroy_Object(object);
		}
	}
	if (message == 5432167)
	{
		PTUpdateWeaponsList(obj);
		if (FireTruckID)
		{
			GameObject *FireTruck = Commands->Find_Object(FireTruckID);
			if (Get_Vehicle_Occupant_Count(FireTruck) < Get_Vehicle_Seat_Count(FireTruck))
			{
				Commands->Set_Position(obj,Commands->Get_Bone_Position(FireTruck,"Seat0"));
				Soldier_Transition_Vehicle(obj);
				Commands->Send_Custom_Event(obj,obj,4745473,0,0.25f);
			}
			else
			{
				Send_Message_Player(obj,127,25,25,"Sorry, the fire truck is full.");
			}
		}
	}
	if (message == 5193734)
	{
		FireTruckID = param;
	}
	if (message == 4745473)
	{// Used for time delayed vehicle entry
		if (!Get_Vehicle(obj))
		{
			Soldier_Transition_Vehicle(obj);
		}
	}
	if (message == 9119110)
	{// Remove an ambulance's id from the list
		int end = 0;
		for (int x = 0;x < 5 && !end;x++)
		{
			if (param == Ambulances[x])
			{
				Ambulances[x] = 0;
				end = 1;
			}
		}
	}
	if (message == 9119111)
	{// Add an ambulance's id from the list
		int end = 0;
		int AmbulanceID = Commands->Get_ID(sender);
		for (int x = 0;x < 5;x++)
		{// Check for matching IDs
			if (Ambulances[x] == AmbulanceID)
			{
				return;
			}
		}
		for (int x = 0;x < 5 && !end;x++)
		{// Attempt to add ID to list
			if (!Ambulances[x])
			{
				Ambulances[x] = AmbulanceID;
				end = 1;
			}
		}
	}
	/*if (message == 7745471)
	{
		GameObject *Object = Commands->Create_Object("PT_MadCat",Commands->Get_Position(obj));
		Commands->Set_Position(Object,Commands->Get_Position(obj));
	}*/
}

void JMG_Free_For_All_Script::Timer_Expired(GameObject *obj, int number)
{
	if (number == 55231896)
	{
		Attach_Script_Once(obj,"JMG_Renhalo_Dart_Gun_Script","");
		Attach_Script_Once(obj,"JMG_RP2_Player_Phone_Control_Script","");
	}
	if (number == 45231896)
	{
		if (Commands->Is_A_Star(obj))
		{
			Attach_Script_Once(obj,"JMG_Dont_Be_A_Douche","30");
			if (Get_Sex(obj) == 'B'){Attach_Script_Once(obj,"JMG_New_Swimming_Script","1,1,5,0,0.95,Invisible_Box,newhaadj,Weapon_Empty_Hands,POW_Empty_Hands,Breath_Sound_Female_01,Breath_Female_01,TankRefillSound,HeartBeatSound,c_ag_civ1_male,null,SwimmingSkin,SwimmingDamage,0,null,null,1");}
			else{Attach_Script_Once(obj,"JMG_New_Swimming_Script","1,1,5,0,0.95,Invisible_Box,newhaadj,Weapon_Empty_Hands,POW_Empty_Hands,Breath_Sound,Gasp_For_Breath_Sound,TankRefillSound,HeartBeatSound,c_ag_civ1_male,null,SwimmingSkin,SwimmingDamage,0,null,null,1");}
			Attach_Script_Once(obj,"JMG_Flash_Light_Toggle","");
			if (USENEWPARACHUTE){Attach_Script_Once(obj,"JMG_New_Parachute_Script","");}
			else {Attach_Script_Once(obj,"JMG_Parachute_Script","Falling_Object");}
			Attach_Script_Once(obj,"JMG_Druggy_Script","10.00,0.1f,911912913,-1,-1.000,-1,0,0.00");
			Attach_Script_Once(obj,"JMG_RP2_Screen_Fade_Red_On_Damage","");
			Attach_Script_Once(obj,"JMG_RP2_Vehicle_Entry_Control","");
			Attach_Script_Once(obj,"JMG_Block_Refill_RP2","");
			Attach_Script_Once(obj,"JMG_RP2_Plasma_Torpedo_Launcher","");
			Commands->Attach_Script(obj,"JMG_RP2_Character_Info","");
			Commands->Attach_Script(obj,"JMG_RP2_WLS_Grant_Weapon","Weapon_Cell_Phone,-2");
			Commands->Attach_Script(obj,"JMG_RP2_Flame_Thrower_Script","");
			Commands->Attach_Script(obj,"JMG_RP2_Soldier_Set_Favorite_Vehicle","");
			Commands->Attach_Script(obj,"JMG_RP2_Soldier_Set_Favorite_Weapon","");
			Commands->Attach_Script(obj,"JMG_RP2_Get_Unstuck_Key","");
			Commands->Attach_Script(obj,"JMG_RP2_Ammo_Crate_Control","");
			Commands->Attach_Script(obj,"JMG_RP2_Pull_Out_Phone_On_Keypress","");
		
			RP2_Set_Fog_And_Screen_Color_To_Level_Default(obj);
			Commands->Start_Timer(obj,this,0.1f,4523188);	
		}
	}
	if (number == 4523188)
	{
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Character_Info,4327728");// Used for info key
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Request_Entry,4327717");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Yes,211511231");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","No,211511230");	
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","FlashLight,7745471");	
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Vehicle_Special,7745460");	
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Phone,331194043");	
		Commands->Start_Timer(obj,this,0.1f,45231899);	

	}
	if (number == 45231899)
	{
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Drop_Object,3423432");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Sell_Vehicle,5656565");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Primary_Fire,21511235");	
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Secondary_Fire,21511236");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Tertiary_Fire,21511237");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Stuck,911911911");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Override,3423434");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","AmmoTransfer,789654");
		Commands->Start_Timer(obj,this,0.1f,45231850);	

	}
	if (number == 45231850)
	{
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","5656565,56565657");	
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Deploy_Chute,35432167");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Action_Key,5432167");	
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","SmallIncrease,10012142");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","SmallDecrease,10002142");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","LargeIncrease,10112142");	
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","LargeDecrease,10102142");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","21511235,98562145");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","21511236,98562146");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","21511237,98562147");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","7745460,7745472");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","3423432,7745473");
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","7745471,77454712");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","5432167,75432167");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","10102142,20102142");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","10112142,20112142");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","10002142,20002142");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","10012142,20012142");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","3423434,3423435");	
		Commands->Attach_Script(obj,"JMG_Vehicle_Key_Custom","35432167,35432168");	
	}
	if (number == 45231897)
	{// Inventory Weight Code
		if (RP2MAXINVENTORYWEAPONLIMIT < Get_Weapon_Count(obj))
		{
			Send_Message_Player(obj,255,255,255,"YOU HAVE BEEN KILLED FOR EXCEEDING 50 WEAPONS, IF YOU HAD ENTERED A ZONE WITH MORE THEN 50 WEAPONS, YOU WOULD HAVE DISCONNECTED ALL PLAYERS IN THE GAME!");
			Commands->Destroy_Object(obj);
		}
		if (RP2StarCurrentInventorySize[PlayerID] > RP2StarMaxInventorySize[PlayerID])
		{
			if (!Overweight)
			{
				Vector3 pos = Commands->Get_Position(obj);
				pos.Z -= 0.1f;
				GameObject *holdpos = Commands->Create_Object("Daves Arrow",pos);
				Commands->Set_Model(holdpos,"null");
				Commands->Attach_To_Object_Bone(obj,holdpos,"origin");
				Overweight = Commands->Get_ID(holdpos);
				Send_Message_Player(obj,255,127,127,"There is too much crap in my inventory, there is no way I can take another step tell I get rid of some of it!");
			}
		}
		else if (Overweight)
		{
			Commands->Destroy_Object(Commands->Find_Object(Overweight));
			Overweight = 0;
			Vector3 pos = Commands->Get_Position(obj);
			pos.Z += 0.1f;
			Commands->Set_Position(obj,pos);
			Send_Message_Player(obj,255,127,127,"Much better, I feel like I can walk again.");
		}
		const char *Weap = Get_Current_Weapon(obj);
		if (Weap)
		{
			int BulletCount = Get_Current_Total_Bullets(obj);
			RP2WeaponListControl *Weapon = Get_WLS_Weapon_Settings(Weap);
			if (Weapon && !Get_Vehicle(obj))
			{
				if (Weapon->AmmoSize)
				{
					RP2PlayerSAWTControl *SAWT_Node = Add_Or_Update_RP2PlayerSAWT_Node(PlayerID,Weapon->WeaponName);
					if (SAWT_Node)
					{
						int Difference = Get_Total_Bullets(obj,Weapon->WeaponName)-SAWT_Node->LastAmmoCount;
						if (Difference)
						{
							RP2StarCurrentInventorySize[PlayerID] += Weapon->AmmoSize*Difference;
							SAWT_Node->LastAmmoCount = Get_Total_Bullets(obj,Weapon->WeaponName);
						}
					}
				}		
				if (!BulletCount)// Remove things like Grenades when you run out of ammo
				{
					if (Weapon->CanBeDropped && !Weapon->DropWhenEmpty)
					{
						Drop_Weapon(obj,Weapon);
					}
				}
			}	
		}
		if (PTUpdateWeaponsListDelay)
		{
			PTUpdateWeaponsListDelay--;
		}
		Commands->Start_Timer(obj,this,0.25f,45231897);
	}
	if (number == 45231898)
	{// Check if you can spawn code
		if (SeeIfVisible)
		{
			SeeIfVisible--;
			Commands->Start_Timer(obj,this,0.1f,45231898);
		}
		else
		{
			Commands->Enable_Enemy_Seen(obj,false);
		}
	}
	if (number == 55231899 && Commands->Get_Health(obj))
	{// SelfHeal Code
		if (HealthRegen >= MyHealthRegenTime)
		{
			float MaxHealth = Commands->Get_Max_Health(obj) * MyRehealCap;
			float CurrentHealth = Commands->Get_Health(obj);
			if (CurrentHealth)
			{
				if (CurrentHealth < MaxHealth)
				{
					float RegainHealth = MyHealthRegenAmount * MaxHealth;
					if (Get_Vehicle(obj))
					{
						RegainHealth /= 2;
					}
					if (Commands->Get_Max_Health(obj) * 0.1f > CurrentHealth)
					{
						RegainHealth *= 3;
					}
					Commands->Set_Health(obj,(CurrentHealth+RegainHealth));
					if (Commands->Get_Health(obj) > MaxHealth)
					{
						Commands->Set_Health(obj,MaxHealth);
					}
				}
			}
		}
		else
		{
			HealthRegen++;
		}
		Commands->Start_Timer(obj,this,0.15f,55231899);	
	}
	if (number == 55231900 && Commands->Get_Health(obj))
	{// Ambulance Code
		int AmbulanceEffect = 0;
		MyRehealCap = 0.75f;
		for (int x = 0;x < 5 && AmbulanceEffect < 15;x++)
		{
			GameObject *Ambulance = Commands->Find_Object(Ambulances[x]);
			if (Ambulance)
			{
				AmbulanceEffect += Get_Vehicle_Occupant_Count(Ambulance) + 1;
			}
		}
		if (AmbulanceEffect)
		{
			MyRehealCap = 1.0f;
			if (AmbulanceEffect > 15)
			{
				AmbulanceEffect = 15;
			}
		}
		MyHealthRegenTime = PLAYERHEALTHRENGENSTARTTIME - (int)((PLAYERHEALTHRENGENSTARTTIME * (AmbulanceEffect/15))*0.95f);
		MyHealthRegenAmount = PLAYERHEALTHRENGENPERCENT + (PLAYERHEALTHRENGENPERCENT * AmbulanceEffect);
		Commands->Start_Timer(obj,this,1.0f,55231900);
	}
}

void JMG_Free_For_All_Script::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	if (Commands->Is_A_Star(obj) && seen && PEOPLEINLINEFORSPAWNING)
	{
		for (int x = 1;x < 128;x++)
		{
			GameObject *Spawn = Get_GameObj(ATTEMPTINGTOSPAWN[x]);
			if (Spawn)
			{
				if (seen == Spawn)
				{
					Commands->Send_Custom_Event(obj,seen,51191171,0,0);
				}
			}
		}
	}
}

void JMG_Free_For_All_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	HealthRegen = 0;
}

void JMG_Free_For_All_Script::Killed(GameObject *obj, GameObject *damager)
{
	if (Commands->Is_A_Star(obj))
	{
		RP2_Player_Death_Message_Control(obj,"null",damager);
		if (RP2PlayerSAWTArray[PlayerID])
		{
			RP2PlayerSAWTControl *temp,*die;
			temp = RP2PlayerSAWTArray[PlayerID];
			while (temp != NULL)
			{
				die = temp;
				temp = temp->next;
				delete die;
			}
			RP2PlayerSAWTArray[PlayerID] = NULL;
		}
		int Failed = 0;
		char FailMissions[237];
	StartDelete://Start of Mission Cleanup
		if (MyMissionNode)
		{
			MissionTypes *Current = MyMissionNode->Mission,*OldCurrent = NULL;
			while (Current != NULL)
			{
				if (Current->ResetOnDeath && !Current->MissionCompleted)
				{
					if (!Failed)
					{
						Failed = 1;
						sprintf(FailMissions,"%d",Current->MissionType);
					}
					else
					{
						sprintf(FailMissions,"%s, %d",FailMissions,Current->MissionType);
					}
					// Delete the data points in the mission node!
					if (Current->MissionDataPoints)
					{
						MissionObjectives *temp,*die;
						temp = Current->MissionDataPoints;
						while (temp != NULL)
						{
							die = temp;
							temp = temp->next;
							delete die;
						}
						Current->MissionDataPoints = NULL;
					}
					// Delete the MISSION NODE!
					if (!OldCurrent && !Current->next)// Delete Only Node in list
					{
						OldCurrent = NULL;
						delete Current;
						MyMissionNode->Mission = NULL;
						goto StartDelete;// Go to the start of the clean up
					}
					else if (OldCurrent && !Current->next)// Delete End Of List
					{
						OldCurrent->next = NULL;
						delete Current;
						goto StartDelete;// Go to the start of the clean up
					}
					else if (!OldCurrent && Current->next)// Delete the head of the node list
					{
						MyMissionNode->Mission = Current->next;
						OldCurrent = NULL;
						delete Current;
						Current = MyMissionNode->Mission;
						goto StartDelete;// Go to the start of the clean up
					}
					else if (OldCurrent && Current->next)// Delete Middle Of List
					{
						OldCurrent->next = Current->next;
						OldCurrent = Current->next;
						delete Current;
						goto StartDelete;// Go to the start of the clean up
					}
				}
				else
				{
					OldCurrent = Current;
					Current = Current->next;
				}
			}
		}
		if (Failed)
		{
			Send_Message_Player(obj,75,150,125,"I have failed the following missions due to being killed:");
			Send_Message_Player(obj,75,150,125,FailMissions);
		}
		Commands->Send_Custom_Event(obj,obj,3423430,1,0.1f);//Drop weapons on death
	}
}

void JMG_Free_For_All_Script::Destroyed(GameObject *obj)
{
	if (Commands->Is_A_Star(obj))
	{
		if (RP2PlayerSAWTArray[PlayerID])
		{
			RP2PlayerSAWTControl *temp,*die;
			temp = RP2PlayerSAWTArray[PlayerID];
			while (temp != NULL)
			{
				die = temp;
				temp = temp->next;
				delete die;
			}
			RP2PlayerSAWTArray[PlayerID] = NULL;
		}
		if (!Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
		{
			Death_Drop_Weapon(obj);
		}
		const char *str = Get_Player_Name(obj);
		GetAmmoForWeaponsInList(obj,str,2);
		delete[] str;
	}
}

int JMG_Free_For_All_Script::Drop_Weapon(GameObject *obj,RP2WeaponListControl *Weapon)
{
	int ReturnVal = 0;// No Weapon to remove
	RP2WeaponListControl *Weapon2 = Get_WLS_Weapon_Settings(Weapon->AltWeaponName);
	if (Can_Drop_Weapon(obj,Weapon,Weapon2))
	{
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z += Weapon->DropHeight;
		GameObject *object = Commands->Create_Object("Daves_Arrow_NT",pos);
		Commands->Set_Model(object,"null");
		Commands->Set_Facing(object,Commands->Get_Facing(obj));
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			char params[2000];
			sprintf(params,"%s,%d,0.25,0.25,0.25,1,0,1",Weapon->WeaponName,Get_Total_Bullets(obj,Weapon->WeaponName));
			Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);
			ReturnVal = 1;
			Remove_Weapon_Safe(obj,Weapon->WeaponName);
		}
		if (Weapon2)
		{
			if (Has_Weapon(obj,Weapon2->WeaponName))
			{
				char params[2000];
				sprintf(params,"%s,%d,0.25,0.25,0.25,1,0,1",Weapon2->WeaponName,Get_Total_Bullets(obj,Weapon2->WeaponName));
				Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);		
				ReturnVal = 1;
				Remove_Weapon_Safe(obj,Weapon2->WeaponName);
			}
		}
	}
	else
	{
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			Remove_Weapon_Safe(obj,Weapon->WeaponName);
			ReturnVal = 1;
		}
		if (Weapon2)
		{
			if (Has_Weapon(obj,Weapon2->WeaponName))
			{
				Remove_Weapon_Safe(obj,Weapon2->WeaponName);
				ReturnVal = 1;
			}
		}
	}
	return ReturnVal;
}

int JMG_Free_For_All_Script::Drop_Weapon_Single(GameObject *obj,RP2WeaponListControl *Weapon)
{
	int ReturnVal = 0;// No Weapon to remove
	RP2WeaponListControl *Weapon2 = Get_WLS_Weapon_Settings(Weapon->AltWeaponName);
	if (Can_Drop_Weapon(obj,Weapon,Weapon2))
	{
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z += Weapon->DropHeight;
		GameObject *object = Commands->Create_Object("Daves_Arrow_NT",pos);
		Commands->Set_Model(object,"null");
		Commands->Set_Facing(object,Commands->Get_Facing(obj));
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			char params[2000];
			if (Get_Clip_Bullets(obj,Weapon->WeaponName))
			{
				Set_Clip_Bullets(obj,Weapon->WeaponName,Get_Clip_Bullets(obj,Weapon->WeaponName)-1);
				RP2StarCurrentInventorySize[PlayerID] -= Weapon->AmmoSize;
				sprintf(params,"%s,1,0.25,0.25,0.25,1,0,1",Weapon->WeaponName);
				Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);
			}
			else if (Get_Bullets(obj,Weapon->WeaponName))
			{
				Set_Bullets(obj,Weapon->WeaponName,Get_Bullets(obj,Weapon->WeaponName)-1);
				RP2StarCurrentInventorySize[PlayerID] -= Weapon->AmmoSize;
				sprintf(params,"%s,1,0.25,0.25,0.25,1,0,1",Weapon->WeaponName);
				Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);
			}
			ReturnVal = 1;
			if (!Get_Total_Bullets(obj,Weapon->WeaponName))
			{
				Remove_Weapon_Safe(obj,Weapon->WeaponName);
				WLS_Remove_Weapon_Weight(obj,Weapon,PlayerID);
			}
		}
		if (Weapon2)
		{
			if (Has_Weapon(obj,Weapon2->WeaponName))
			{
				char params[2000];
				if (Get_Clip_Bullets(obj,Weapon2->WeaponName))
				{
					RP2StarCurrentInventorySize[PlayerID] -= Weapon2->AmmoSize;
					Set_Clip_Bullets(obj,Weapon2->WeaponName,Get_Clip_Bullets(obj,Weapon2->WeaponName)-1);
					sprintf(params,"%s,1,0.25,0.25,0.25,1,0,1",Weapon2->WeaponName);
					Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);
				}
				else if (Get_Bullets(obj,Weapon2->WeaponName))
				{
					RP2StarCurrentInventorySize[PlayerID] -= Weapon2->AmmoSize;
					Set_Bullets(obj,Weapon2->WeaponName,Get_Bullets(obj,Weapon2->WeaponName)-1);
					sprintf(params,"%s,1,0.25,0.25,0.25,1,0,1",Weapon2->WeaponName);
					Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);	
				}
				ReturnVal = 1;
				if (!Get_Total_Bullets(obj,Weapon2->WeaponName))
				{
					Remove_Weapon_Safe(obj,Weapon2->WeaponName);
					WLS_Remove_Weapon_Weight(obj,Weapon2,PlayerID);
				}
			}
		}
		if (!Is_Script_Attached(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special"))
		{
			Commands->Destroy_Object(object);
		}
	}
	else
	{
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			Remove_Weapon_Safe(obj,Weapon->WeaponName);
			ReturnVal = 1;
		}
		if (Weapon2)
		{
			if (Has_Weapon(obj,Weapon2->WeaponName))
			{
				Remove_Weapon_Safe(obj,Weapon2->WeaponName);
				ReturnVal = 1;
			}
		}
	}
	return ReturnVal;
}

int JMG_Free_For_All_Script::Sell_Weapon(GameObject *obj,RP2WeaponListControl *Weapon)
{
	int ReturnVal = 0;// No Weapon to remove
	float Money = 0;
	RP2WeaponListControl *Weapon2 = Get_WLS_Weapon_Settings(Weapon->AltWeaponName);
	if (Can_Drop_Weapon(obj,Weapon,Weapon2))
	{
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			if (Weapon->WeaponCost)
			{
				float Cost = Weapon_Cost_Multiplier(Weapon->WeaponCost);
				Money += Cost;
				Commands->Give_Money(obj,Cost,true);
			}
			int WeaponBullets = Get_Total_Bullets(obj,Weapon->WeaponName);
			if (WeaponBullets != -1 && WeaponBullets > 0 && Weapon->BulletCost)
			{
				float Cost = Weapon_Cost_Multiplier(Weapon->BulletCost*WeaponBullets);
				Money += Cost;
				Commands->Give_Money(obj,Cost,true);
			}
			ReturnVal = 1;
			Remove_Weapon_Safe(obj,Weapon->WeaponName);
		}
		if (Weapon2)
		{
			if (Has_Weapon(obj,Weapon2->WeaponName))
			{
				if (!ReturnVal)
				{
					if (Weapon2->WeaponCost)
					{
						float Cost = Weapon_Cost_Multiplier(Weapon2->WeaponCost);
						Money += Cost;
						Commands->Give_Money(obj,Cost,true);
					}
					int WeaponBullets = Get_Total_Bullets(obj,Weapon2->WeaponName);
					if (WeaponBullets != -1 && WeaponBullets > 0 && Weapon2->BulletCost)
					{
						float Cost = Weapon_Cost_Multiplier(Weapon2->BulletCost*WeaponBullets);
						Money += Cost;
						Commands->Give_Money(obj,Cost,true);
					}
					ReturnVal = 1;
				}
				Remove_Weapon_Safe(obj,Weapon2->WeaponName);
			}
		}
		if (Money)
		{
			char SellText[236];
			sprintf(SellText,"I just received $%.2f for the transaction.",Money);
			Send_Message_Player(obj,255,127,127,SellText);
		}
	}
	else
	{
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			Remove_Weapon_Safe(obj,Weapon->WeaponName);
			ReturnVal = 1;
		}
		if (Weapon2)
		{
			if (Has_Weapon(obj,Weapon2->WeaponName))
			{
				Remove_Weapon_Safe(obj,Weapon2->WeaponName);
				ReturnVal = 1;
			}
		}
	}
	return ReturnVal;
}


int JMG_Free_For_All_Script::Sell_Weapon_Single(GameObject *obj,RP2WeaponListControl *Weapon)
{
	int ReturnVal = 0;// No Weapon to remove
	float Money = 0;
	RP2WeaponListControl *Weapon2 = Get_WLS_Weapon_Settings(Weapon->AltWeaponName);
	if (Can_Drop_Weapon(obj,Weapon,Weapon2))
	{
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			if (Get_Clip_Bullets(obj,Weapon->WeaponName))
			{
				Set_Clip_Bullets(obj,Weapon->WeaponName,Get_Clip_Bullets(obj,Weapon->WeaponName)-1);
				RP2StarCurrentInventorySize[PlayerID] -= Weapon->AmmoSize;
			}
			else if (Get_Bullets(obj,Weapon->WeaponName))
			{
				Set_Bullets(obj,Weapon->WeaponName,Get_Bullets(obj,Weapon->WeaponName)-1);
				RP2StarCurrentInventorySize[PlayerID] -= Weapon->AmmoSize;
			}
			else
			{
				return 0;
			}
			if (Get_Total_Bullets(obj,Weapon->WeaponName) != -1 && Weapon->BulletCost)
			{
				float Cost = Weapon_Cost_Multiplier(Weapon->BulletCost);
				Money += Cost;
				Commands->Give_Money(obj,Cost,true);
			}
			ReturnVal = 1;
			if (!Get_Total_Bullets(obj,Weapon->WeaponName))
			{
				Remove_Weapon_Safe(obj,Weapon->WeaponName);
				WLS_Remove_Weapon_Weight(obj,Weapon,PlayerID);
				if (Weapon->WeaponCost)
				{
					float Cost = Weapon_Cost_Multiplier(Weapon->WeaponCost);
					Money += Cost;
					Commands->Give_Money(obj,Cost,true);
				}
			}
		}
		if (Weapon2)
		{
			if (Get_Clip_Bullets(obj,Weapon2->WeaponName))
			{
				Set_Clip_Bullets(obj,Weapon2->WeaponName,Get_Clip_Bullets(obj,Weapon2->WeaponName)-1);
				RP2StarCurrentInventorySize[PlayerID] -= Weapon2->AmmoSize;
			}
			else if (Get_Bullets(obj,Weapon2->WeaponName))
			{
				Set_Bullets(obj,Weapon2->WeaponName,Get_Bullets(obj,Weapon2->WeaponName)-1);
				RP2StarCurrentInventorySize[PlayerID] -= Weapon2->AmmoSize;
			}
			else
			{
				return 0;
			}
			if (Get_Total_Bullets(obj,Weapon2->WeaponName) != -1 && Weapon2->BulletCost)
			{
				float Cost = Weapon_Cost_Multiplier(Weapon2->BulletCost);
				Money += Cost;
				Commands->Give_Money(obj,Cost,true);
			}
			ReturnVal = 1;
			if (!Get_Total_Bullets(obj,Weapon2->WeaponName))
			{
				Remove_Weapon_Safe(obj,Weapon2->WeaponName);
				WLS_Remove_Weapon_Weight(obj,Weapon2,PlayerID);
				if (Weapon2->WeaponCost)
				{
					float Cost = Weapon_Cost_Multiplier(Weapon2->WeaponCost);
					Money += Cost;
					Commands->Give_Money(obj,Cost,true);
				}
			}
		}
		if (Money)
		{
			char SellText[236];
			sprintf(SellText,"I just received %.2f for the transaction.",Money);
			Send_Message_Player(obj,255,127,127,SellText);
		}
	}
	else
	{
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			Remove_Weapon_Safe(obj,Weapon->WeaponName);
			ReturnVal = 1;
		}
		if (Weapon2)
		{
			if (Has_Weapon(obj,Weapon2->WeaponName))
			{
				Remove_Weapon_Safe(obj,Weapon2->WeaponName);
				ReturnVal = 1;
			}
		}
	}
	return ReturnVal;
}

int JMG_Free_For_All_Script::Can_Drop_Weapon(GameObject *obj,RP2WeaponListControl *Weapon,RP2WeaponListControl *Weapon2)
{
	if (Weapon)
	{
		if (Get_Total_Bullets(obj,Weapon->WeaponName) || Weapon->DropWhenEmpty)
		{
			return 1;
		}
	}
	if (Weapon2)
	{
		if (Get_Total_Bullets(obj,Weapon2->WeaponName) || Weapon2->DropWhenEmpty)
		{
			return 1;
		}
	}
	return 0;
}

void JMG_Free_For_All_Script::Add_Mission_Node(GameObject *obj)
{
	char PlayerName[256];
	const char *str = Get_Player_Name(obj);
	sprintf(PlayerName,"%s",str);
	delete[] str;
	if (!RP2PlayerMissionsNode)
	{
		RP2PlayerMissionsNode = new RP2PlayerMissionsControl;
		sprintf(RP2PlayerMissionsNode->PlayerName,"%s",PlayerName);
		RP2PlayerMissionsNode->Mission = NULL;
		RP2PlayerMissionsNode->FailOnTrackedVehicle = NULL;
		RP2PlayerMissionsNode->FailOnWheeledVehicle = NULL;
		RP2PlayerMissionsNode->FailOnMotorcycle = NULL;
		RP2PlayerMissionsNode->FailOnAircraft = NULL;
		RP2PlayerMissionsNode->FailOnTurret = NULL;
		RP2PlayerMissionsNode->FailOnBoat = NULL;
		RP2PlayerMissionsNode->AllVehicles = NULL;
		RP2PlayerMissionsNode->MissionConflicts = NULL;
		MyMissionNode = RP2PlayerMissionsNode;
		RP2PlayerMissionsNode->next = NULL;
	}
	else
	{
		int end = 0;
		RP2PlayerMissionsControl *Current = RP2PlayerMissionsNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				MyMissionNode = Current;
				end = 1;
			}
			if (Current->next == NULL && end == 0)
			{
				end = 1;
				Current->next = new RP2PlayerMissionsControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				Current->Mission = NULL;
				Current->FailOnTrackedVehicle = NULL;
				Current->FailOnWheeledVehicle = NULL;
				Current->FailOnMotorcycle = NULL;
				Current->FailOnAircraft = NULL;
				Current->FailOnTurret = NULL;
				Current->FailOnBoat = NULL;
				Current->AllVehicles = NULL;
				Current->MissionConflicts = NULL;
				MyMissionNode = RP2PlayerMissionsNode;
				MyMissionNode = Current;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
	if (MyMissionNode)// Regrant Rewards
	{
		int Failed = 0;
		char FailMissions[237];
		MissionTypes *Current = MyMissionNode->Mission;
		while (Current != NULL)
		{
			if (Current->ResetOnSpawn && !Current->MissionCompleted)
			{
				Commands->Send_Custom_Event(obj,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Current->MissionType,-3,0);
				if (!Failed)
				{
					Failed = 1;
					sprintf(FailMissions,"%d",Current->MissionType);
				}
				else
				{
					sprintf(FailMissions,"%s, %d",FailMissions,Current->MissionType);
				}
			}
			if ((Current->RegrantOnSpawn || (Current->RegrantOnFirstSpawn && !Current->HasGranted)) && Current->MissionCompleted)
			{
				Commands->Send_Custom_Event(obj,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Current->MissionType,-999,0);
			}
			Current = Current->next;
		}
		if (Failed)
		{
			Send_Message_Player(obj,75,150,125,"I have failed the following missions due to being killed:");
			Send_Message_Player(obj,75,150,125,FailMissions);
		}
	}
}

void JMG_Free_For_All_Script::Vehicle_Mission_Conflict_Check(GameObject *obj,GameObject *sender)
{
	if (MyMissionNode->AllVehicles)
	{
		if (Get_Vehicle(obj))
		{
			Scan_For_Vehicle_Conflicts(obj,MyMissionNode->AllVehicles);
		}
	}
	else
	{
		if (MyMissionNode->FailOnTrackedVehicle)
		{
			if (sender->As_PhysicalGameObj() && sender->As_PhysicalGameObj()->Peek_Physical_Object() && sender->As_PhysicalGameObj()->Peek_Physical_Object()->As_TrackedVehicleClass())
			{
				Scan_For_Vehicle_Conflicts(obj,MyMissionNode->FailOnTrackedVehicle);
			}
		}
		if (MyMissionNode->FailOnMotorcycle)
		{
			if (sender->As_PhysicalGameObj() && sender->As_PhysicalGameObj()->Peek_Physical_Object() && sender->As_PhysicalGameObj()->Peek_Physical_Object()->As_MotorcycleClass())
			{
				Scan_For_Vehicle_Conflicts(obj,MyMissionNode->FailOnMotorcycle);
			}
		}
		if (MyMissionNode->FailOnTurret)
		{
			if (sender->As_PhysicalGameObj() && sender->As_PhysicalGameObj()->Peek_Physical_Object() && sender->As_PhysicalGameObj()->Peek_Physical_Object()->As_WheeledVehicleClass())
			{
				Scan_For_Vehicle_Conflicts(obj,MyMissionNode->FailOnTurret);
			}
		}
		if (MyMissionNode->FailOnWheeledVehicle)
		{
			if (sender->As_PhysicalGameObj() && sender->As_PhysicalGameObj()->Peek_Physical_Object() && sender->As_PhysicalGameObj()->Peek_Physical_Object()->As_Phys3Class())
			{
				Scan_For_Vehicle_Conflicts(obj,MyMissionNode->FailOnWheeledVehicle);
			}
		}
		if (MyMissionNode->FailOnAircraft)
		{
			if (sender->As_PhysicalGameObj() && sender->As_PhysicalGameObj()->Peek_Physical_Object() && sender->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass() && !Is_Script_Attached(sender,"JMG_Boat_To_High"))
			{
				Scan_For_Vehicle_Conflicts(obj,MyMissionNode->FailOnAircraft);
			}
		}
		if (MyMissionNode->FailOnBoat)
		{
			if (sender->As_PhysicalGameObj() && sender->As_PhysicalGameObj()->Peek_Physical_Object() && sender->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass() && Is_Script_Attached(sender,"JMG_Boat_To_High"))
			{
				Scan_For_Vehicle_Conflicts(obj,MyMissionNode->FailOnBoat);
			}	
		}
	}
}

void JMG_Free_For_All_Script::Scan_For_Vehicle_Conflicts(GameObject *obj,RP2PlayerVehicleFailMissionControl *Node)
{
	RP2PlayerVehicleFailMissionControl *Current = Node;
	while (Current != NULL)
	{
		Commands->Send_Custom_Event(obj,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Current->MissionType,-4,0);
		Current = Current->next;
	}
}

float JMG_Free_For_All_Script::Weapon_Cost_Multiplier(int Cost)
{
	if (Get_Player_Count() > 9)
	{
		return (float)Cost;
	}
	else
	{
		return (float)((float)Cost * ((float)Get_Player_Count()/10.0f));
	}
}

void JMG_Free_For_All_Script::Drop_Credit_Card_Info(GameObject *obj)
{
	Vector3 pos = Commands->Get_Position(obj);
	pos.Z += 0.25;
	GameObject *object = Commands->Create_Object("Daves_Arrow_NT",pos);
	Commands->Set_Model(object,"null");
	Commands->Set_Facing(object,Commands->Get_Facing(obj));
	char params[2000];
	const char *str = Get_Player_Name(obj);
	sprintf(params,"%s",str);
	delete[] str;
	Commands->Attach_Script(object,"JMG_RP2_Dropped_Credit_Card_Info_Powerup_Control",params);
}

void JMG_Free_For_All_Script::Security_Check(GameObject *obj)
{
	const char *Preset = Commands->Get_Preset_Name(obj);
	const char *PlayerName = Get_Player_Name(obj);
	Security_Check_Failed(obj,Preset,PlayerName,"Canadacdn");
	Security_Check_Failed(obj,Preset,PlayerName,"Blazed58");
	Security_Check_Failed(obj,Preset,PlayerName,"Admiral666");
	Security_Check_Failed(obj,Preset,PlayerName,"Napalmic");
	Security_Check_Failed(obj,Preset,PlayerName,"Cabal8616");
	Security_Check_Failed(obj,Preset,PlayerName,"Seadust");
	Security_Check_Failed(obj,Preset,PlayerName,"Oblivion165");
	Security_Check_Failed(obj,Preset,PlayerName,"Jerad2142");
	Security_Check_Failed(obj,Preset,PlayerName,"Jerad");
	delete[] PlayerName;
}

void JMG_Free_For_All_Script::Security_Check_Failed(GameObject *obj,const char *Preset,const char *PlayerName,const char *TestName)
{
	if (!_stricmp(Preset,TestName))
	{
		if (_stricmp(PlayerName,TestName))
		{
			if (Is_Script_Attached(obj,"JMG_RP2_Jerad"))
			{
				Remove_Script(obj,"JMG_RP2_Jerad");
			}
			Change_Character(obj,"CJ");
		}
	}
}

void JMG_Free_For_All_Script::Player_Character_Node(GameObject *obj)
{
	char PlayerName[256];
	const char *str = Get_Player_Name(obj);
	sprintf(PlayerName,"%s",str);
	delete[] str;
	if (!PlayerCharacterNode)
	{
		PlayerCharacterNode = new PlayerCharacterControl;
		sprintf(PlayerCharacterNode->PlayerName,"%s",PlayerName);
		sprintf(PlayerCharacterNode->PresetName,"%s",Commands->Get_Preset_Name(obj));
		PlayerCharacterNode->next = NULL;
	}
	else
	{
		PlayerCharacterControl *Current = PlayerCharacterNode;
		while (Current != NULL)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				sprintf(Current->PresetName,"%s",Commands->Get_Preset_Name(obj));
				return;
			}
			if (Current->next == NULL)
			{
				Current->next = new PlayerCharacterControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				sprintf(Current->PresetName,"%s",Commands->Get_Preset_Name(obj));
				Current->next = NULL;
				return;
			}
			Current = Current->next;
		}
	}
}

void JMG_Free_For_All_Script::Death_Drop_Weapon(GameObject *obj)
{
	const char *MyWeapon = Get_Current_Weapon(obj);
	if (!MyWeapon)
	{
		if (!ISNEWSWIMMING[PlayerID])
		{
			if (Has_Weapon(obj,"Weapon_Empty_Hands")){Commands->Select_Weapon(obj,"Weapon_Empty_Hands");}
			Drop_Credit_Card_Info(obj);
		}
		return;
	}
	RP2WeaponListControl *Weapon = Get_WLS_Weapon_Settings(MyWeapon);
	if (!Weapon && Get_Vehicle(obj))
	{
		if (Has_Weapon(obj,"Weapon_Empty_Hands")){Commands->Select_Weapon(obj,"Weapon_Empty_Hands");}
		Drop_Credit_Card_Info(obj);
		return;
	}
	if (Weapon->WeaponClass == PHONE)
	{
		if (Has_Weapon(obj,"Weapon_Empty_Hands")){Commands->Select_Weapon(obj,"Weapon_Empty_Hands");}
		Drop_Credit_Card_Info(obj);
		return;
	}
	else if (Weapon->CanBeDropped)
	{
		RP2StarCurrentInventorySize[PlayerID] -= Weapon->AmmoSize*Get_Total_Bullets(obj,Weapon->WeaponName);
		if (Drop_Weapon(obj,Weapon))
		{
			WLS_Remove_Weapon_Weight(obj,Weapon,PlayerID);
		}
		else{RP2StarCurrentInventorySize[PlayerID] += Weapon->AmmoSize*Get_Total_Bullets(obj,Weapon->WeaponName);}
		if (Weapon->DropMessage)
		{
			Commands->Send_Custom_Event(obj,obj,Weapon->DropMessage,1,0);
		}
	}
	else
	{
		if (Has_Weapon(obj,"Weapon_Empty_Hands")){Commands->Select_Weapon(obj,"Weapon_Empty_Hands");}
		Drop_Credit_Card_Info(obj);
		return;
	}// Record all your weapons to your list (ammo counts)
}

void JMG_Free_For_All_Script::PTUpdateWeaponsList(GameObject *obj)
{
	if (CURRENTPLAYERPTZONE[Get_Player_ID(obj)] && !PTUpdateWeaponsListDelay && Commands->Get_Health(obj))
	{
		PTUpdateWeaponsListDelay = 16;// 4 second delay
		const char *str = Get_Player_Name(obj);
		GetAmmoForWeaponsInList(obj,str,1);
		delete[] str;
	}
}

void JMG_Buy_Soldier_On_Preset_Entry::Entered(GameObject *obj,GameObject *enter)
{
	const char *preset;
	const char *preset2;
	const char *c;
	int cost;
	c = Get_Parameter("Enter_Preset");
	preset = Commands->Get_Preset_Name(enter);
	if (!_stricmp(preset,c))
	{
		cost = Get_Int_Parameter("Cost");
		preset2 = Get_Parameter("Preset_Name");
		if (cost <= Commands->Get_Money(enter))
		{
			cost = -cost;
			Commands->Give_Money(enter,(float)cost,0);
			Change_Character(enter,preset2);
		}
	}

}

void JMG_Block_Refill_RP2::Created(GameObject *obj)
{
	currenthealth = Commands->Get_Health(obj);
	currentshield = Commands->Get_Shield_Strength(obj);
	Commands->Start_Timer(obj,this,0.5f,126523);
	enabled = 0;
}

void JMG_Block_Refill_RP2::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 595671)
	{
		enabled = 1;
	}
	if (message == 595670)
	{
		enabled = 0;
	}
}

void JMG_Block_Refill_RP2::Timer_Expired(GameObject *obj, int number)
{
	if (number == 126523)
	{
		if (enabled == 1)
		{
			if (Commands->Get_Health(obj) > currenthealth || Commands->Get_Shield_Strength(obj) > currentshield)
			{
				Commands->Set_Health(obj,currenthealth);
				Commands->Set_Shield_Strength(obj,currentshield);
			}
		}
		if (enabled == 0)
		{
			currenthealth = Commands->Get_Health(obj);
			currentshield = Commands->Get_Shield_Strength(obj);
		}
		Commands->Start_Timer(obj,this,0.5f,126523);
	}
}

void JMG_Druggy_Script::Created(GameObject *obj)
{
	CurrentDrugLevel = 0;
	DefaultWithdrawalLevel = 3;
	DefaultDrugOverdoseLevel = 4;
	DefaultDrugDeathLevel = 20;
	DrugOverdoseLevel = DefaultDrugOverdoseLevel;
	DrugDeathLevel = DefaultDrugDeathLevel;
	WithdrawalLevel = DefaultWithdrawalLevel;
	AllowHealthIncrease = 0;
	StillOnDrugs = 0;
	CanDisplayedDFTMessage = 1;
	ScreenEffectsEnabled = 0;
	CanDisplayedWithdrawalMessage = 1;
	CanDisplayedOverdoseMessage = 0;
	PillsPickedUp = 0;
	PillsPickedUpSpeedBonus = 0;
	CanDisplayedDeathWarnMessage = 0;
	CanDisplayedNDLMessage = 0;
	AllowHighHurt = 0;
	WithdrawalDamageEnabled = 0;
	Red = 50.0f;
	Green = 50.0f;
	Blue = 50.0f;
	AddedHealth = 0.0f;
	AddedWeight = 0;
	SubtractedWeight = 0;
	DropDrugs = 0;
	DrugLevelDropTime = 0;
	CantExitVehicle = 0;
	int number3 = Get_Int_Parameter("DrugTypeMessage") + 2;
	int number4 = Get_Int_Parameter("DrugTypeMessage") + 3;
	Commands->Start_Timer(obj,this,0.1f,Get_Int_Parameter("DrugTypeMessage"));
	Commands->Send_Custom_Event(obj,obj,number3,Get_Int_Parameter("DrugTypeMessage"),Get_Float_Parameter("WithdrawalDamageRate"));
	Commands->Send_Custom_Event(obj,obj,number4,Get_Int_Parameter("DrugTypeMessage"),Get_Float_Parameter("Get_Hurt_While_High_Rate"));
}

void JMG_Druggy_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (Commands->Get_Health(obj))
	{
		if (message == Get_Int_Parameter("DrugTypeMessage"))
		{
			Take_Drugs(obj,param);
		}
		if (message == Get_Int_Parameter("DrugTypeMessage") + 545)
		{
			float newparam = param / 1000.0f;
			AddedHealth += newparam;
			Set_Max_Health(obj,Commands->Get_Max_Health(obj) + newparam);
		}
		if (message == Get_Int_Parameter("DrugTypeMessage") + 555)
		{
			float newparam = 1.000f + (param / 1000.0f);
			AddedHealth += newparam;
			Set_Max_Health(obj,Commands->Get_Max_Health(obj) + newparam);
		}
		if (message == 98745522 && StillOnDrugs == 1)
		{
			Detox_Used(obj);
		}
		int number3 = Get_Int_Parameter("DrugTypeMessage") + 2, number4 = Get_Int_Parameter("DrugTypeMessage") + 3;
		if (message == number3 && param == Get_Int_Parameter("DrugTypeMessage"))
		{
			Injure_When_Withdrawal(obj,number3);
		}
		if (message == number4 && param == Get_Int_Parameter("DrugTypeMessage"))
		{
			Hurt_While_High(obj,number4);
		}
	}
}

void JMG_Druggy_Script::Timer_Expired(GameObject *obj, int number)
{
	if (Commands->Get_Health(obj) > 0.0f)
	{
		if (number == Get_Int_Parameter("DrugTypeMessage"))
		{
			if (CurrentDrugLevel == 0 && StillOnDrugs == 1)
			{
				if (CanDisplayedNDLMessage == 1)
				{
					CanDisplayedNDLMessage = 0;
					Send_Message_Player(obj,255,255,0,"The last of the pills' negative side effects have dissipated... except for this headache. Doing those drugs was probably a bad choice on my part.");
				}
				Reset_Drug_Script(obj);
			}
			if (StillOnDrugs == 1)
			{
				if (CurrentDrugLevel > DrugOverdoseLevel && AllowHealthIncrease == 1)
				{
					Overdose(obj);
				}
				if (CurrentDrugLevel < WithdrawalLevel && WithdrawalDamageEnabled == 0)
				{
					Begin_Suffering_From_Withdrawal(obj);
				}
				else if (CurrentDrugLevel > WithdrawalLevel && WithdrawalDamageEnabled == 1)
				{
					End_Suffering_From_Withdrawal(obj);
				}
				if (CurrentDrugLevel > DrugDeathLevel)
				{
					Overdosing_Kills(obj);
				}
				if (CurrentDrugLevel > DrugDeathLevel + (DrugDeathLevel * -0.15f) && CanDisplayedDeathWarnMessage == 0)
				{
					CanDisplayedDeathWarnMessage = 1;
					Send_Message_Player(obj,255,255,0,"I do not feel wellEI think I had better stop taking those pills immanently and head to the hospital as soon as I can.");
				}
				else if (DrugOverdoseLevel < DrugOverdoseLevel && CanDisplayedDeathWarnMessage == 1) 
				{
					CanDisplayedDeathWarnMessage = 0;
				}
			}
			DrugLevelDropTime += 0.1f;
			float DLDT = DrugLevelDropTime - (int)DrugLevelDropTime;
			if (DLDT < 0.05f || DLDT > 0.95f)
			{// Relocated to clean up some minor flaws with timing
				DropDrugs++;
				if (PillsPickedUpSpeedBonus > 0 && DropDrugs >= (Get_Float_Parameter("DrugLevelDropRate")/2.0f))
				{
					PillsPickedUpSpeedBonus--;
				}
				// Drug Level Drop Rates Relocated (in order to make the script more pridictible)
				if (DrugLevelDropTime >= Get_Float_Parameter("DrugLevelDropRate"))
				{
					DrugLevelDropTime = 0.0f;
					Effect_Wear_Off(obj);
				}
			}
			Screen_Effects(obj);
			Commands->Start_Timer(obj,this,0.1f,Get_Int_Parameter("DrugTypeMessage"));
		}
	}
}

void JMG_Druggy_Script::Injure_When_Withdrawal(GameObject *obj,int number3)
{
	if (WithdrawalDamageEnabled == 1 && AllowHighHurt == 1)
	{
		if (Get_Vehicle(obj))
		{
			Soldier_Transition_Vehicle(obj);
			CantExitVehicle++;
			Send_Message_Player(obj,255,255,0,"I don't feel like I can drive safely.");
		}
		else
		{
			CantExitVehicle = 0;
		}
		if (CantExitVehicle > 5)
		{
			CantExitVehicle = 0;
			GameObject *PlayerVehicle = Get_Vehicle(obj);
			if (PlayerVehicle)
			{
				Commands->Apply_Damage(PlayerVehicle,9999.99f,"BlamoKiller",0);
			}
		}
		float Health = Commands->Get_Health(obj);
		float SubtractHealth = (Commands->Get_Max_Health(obj)*0.01f) * (1.0f-CurrentDrugLevel/WithdrawalLevel);
		if ((Health - SubtractHealth) > SubtractHealth)
		{
			Commands->Set_Health(obj,1.0f);
			Commands->Set_Health(obj,Health - SubtractHealth);
		}
		else
		{
			Commands->Apply_Damage(obj,99999.0f,"Blamokiller",0);
			if (!ISUNDERWATER[Get_Player_ID(obj)])
			{
				RP2_Set_Fog_And_Screen_Color_To_Level_Default(obj);
			}
			Send_Message_Player(obj,255,255,0,"You feel the side effects from that last pill washing through your system, you fall to your knees gasping for breath, but there is no help to be found. Guess you should not have taken those pills after all.");
			char DeathMSG[237];
			const char *str = Get_Player_Name(obj);
			sprintf(DeathMSG,"%s died from drug overdose.",str);
			delete[] str;
			RP2_Player_Death_Message_Control(obj,DeathMSG,0);
		}
	}
	Commands->Send_Custom_Event(obj,obj,number3,Get_Int_Parameter("DrugTypeMessage"),Get_Float_Parameter("WithdrawalDamageRate"));
}

void JMG_Druggy_Script::Hurt_While_High(GameObject *obj,int number4)
{
	if (Get_Float_Parameter("Get_Hurt_While_High_Rate"))
	{
		if (AllowHighHurt == 1 && CurrentDrugLevel > WithdrawalLevel && CurrentDrugLevel < DrugDeathLevel)
		{
			if (Get_Vehicle(obj))
			{
				Soldier_Transition_Vehicle(obj);
				CantExitVehicle++;
				Send_Message_Player(obj,255,255,0,"I don't feel like I can drive safely.");
			}
			else
			{
				CantExitVehicle = 0;
			}
			if (CantExitVehicle > 5)
			{
				CantExitVehicle = 0;
				GameObject *PlayerVehicle = Get_Vehicle(obj);
				if (PlayerVehicle)
				{
					Commands->Apply_Damage(PlayerVehicle,9999.99f,"BlamoKiller",0);
				}
			}
			float Health = Commands->Get_Health(obj);
			float SubtractHealth = (Commands->Get_Max_Health(obj)*0.01f) * (CurrentDrugLevel/DrugDeathLevel);
			if ((Health - SubtractHealth) > SubtractHealth)
			{
				Commands->Set_Health(obj,Health - SubtractHealth);
			}
			else
			{
				Commands->Set_Health(obj,1.0f);
				Commands->Apply_Damage(obj,99999.0f,"Blamokiller",0);
				if (!ISUNDERWATER[Get_Player_ID(obj)])
				{
					RP2_Set_Fog_And_Screen_Color_To_Level_Default(obj);
				}
				Send_Message_Player(obj,255,255,0,"You feel the side effects from that last pill washing through your system, you fall to your knees gasping for breath, but there is no help to be found. Guess you should not have taken those pills after all.");
				char DeathMSG[237];
				const char *str = Get_Player_Name(obj);
				sprintf(DeathMSG,"%s died from drug overdose.",str);
				delete[] str;
				RP2_Player_Death_Message_Control(obj,DeathMSG,0);
			}
		}
		Commands->Send_Custom_Event(obj,obj,number4,Get_Int_Parameter("DrugTypeMessage"),Get_Float_Parameter("Get_Hurt_While_High_Rate"));
	}
}

void JMG_Druggy_Script::Effect_Wear_Off(GameObject *obj)
{
	if (CurrentDrugLevel > 0 && (Get_Int_Parameter("Max_Drug_Drop_Level") < CurrentDrugLevel ||  Get_Int_Parameter("Max_Drug_Drop_Level") == -1))
	{
		CurrentDrugLevel--;
	}
	float CurrentDeathPoint = ((((WithdrawalLevel-DefaultWithdrawalLevel)/2.0f)*3.0f)+DefaultDrugDeathLevel);// Reincrease Deathpoint
	if (CurrentDrugLevel > WithdrawalLevel && DrugDeathLevel < CurrentDeathPoint)
	{
		DrugDeathLevel += 1.0;
		if (DrugDeathLevel > CurrentDeathPoint)
		{
			DrugDeathLevel = CurrentDeathPoint;
		}
	}
	int PlayerID = Get_Player_ID(obj);
	if (WithdrawalDamageEnabled == 1 && CurrentDrugLevel < (WithdrawalLevel - 1) && (CurrentDrugLevel - 1) > 0 && (RP2StarMaxInventorySize[PlayerID] - 5) >= 5)
	{
		if (WithdrawalLevel > DefaultWithdrawalLevel)// Lower Minimal Drug Need
		{
			WithdrawalLevel--;
		}
		if (DrugOverdoseLevel - 2 > DefaultDrugOverdoseLevel)// Lower Minimal Drug Need
		{
			DrugOverdoseLevel--;
		}
		if (DrugOverdoseLevel < DrugDeathLevel - 3 && DrugDeathLevel - 3  > DefaultDrugDeathLevel)// Drastically Lower Drug Death point
		{
			DrugDeathLevel -= 3;
		}
		else if (DrugDeathLevel > DefaultDrugDeathLevel)// Lower Death Point
		{
			DrugDeathLevel--;
		}
		SubtractedWeight -= 5;
		RP2StarMaxInventorySize[PlayerID] -= 5;
		Send_Message_Player(obj,255,255,0,"The effects of withdrawal continue to get worse:");
		char Stats1[2000];
		sprintf(Stats1,"Max inventory weight decreased 5 points, new max %d.",(int)RP2StarMaxInventorySize[Get_Player_ID(obj)]);
		Send_Message_Player(obj,255,255,0,Stats1);
	}
}

void JMG_Druggy_Script::Detox_Used(GameObject *obj)
{
	if (AddedHealth)
	{
		float OldMaxHealth = Commands->Get_Max_Health(obj);
		float HealthPercent = Commands->Get_Health(obj)/OldMaxHealth;
		Commands->Set_Health(obj,(Commands->Get_Health(obj)*HealthPercent));
		Set_Max_Health(obj,(OldMaxHealth - AddedHealth));
		if (Commands->Get_Max_Health(obj) < 1.0f)
		{
			Set_Max_Health(obj,1.0f);
		}
		if (Commands->Get_Health(obj) < 1.0f)
		{
			Commands->Set_Health(obj,1.0f);
		}
		Send_Message_Player(obj,255,255,0,"I have used a medical detox to cure myself of the pills' side effects; unfortunately, it seems that all gains from the drugs are gone as well.");
		char Stats[2000];
		sprintf(Stats,"Max Heath:%.2f, Pre-Detox Health:%.2f, Health Points Lost:%.2f",Commands->Get_Max_Health(obj),OldMaxHealth,OldMaxHealth-Commands->Get_Max_Health(obj));
		Send_Message_Player(obj,255,255,0,Stats);
	}
	Reset_Drug_Script(obj);
}

void JMG_Druggy_Script::Overdose(GameObject *obj)
{
	CanDisplayedWithdrawalMessage = 0;
	if (CanDisplayedOverdoseMessage == 0)
	{
		Commands->Send_Custom_Event(obj,obj,347369,0,0);//Drugged up no swim toggle
		CanDisplayedOverdoseMessage = 1;
		char message[2000];
		const char *str = Get_Player_Name(obj);
		switch (PillsPickedUp)
		{
		case 0:
			sprintf(message,"%s: I swear I had something to say...",str);
			break;
		case 1:
			sprintf(message,"%s: Wow, these pills make me feel great, I feel like I can do more than I ever could before!",str);
			break;
		case 2:
			sprintf(message,"%s: As my high gets more intense it feels like I can just do more and more!",str);
			break;
		case 3:
			sprintf(message,"%s: Weeeeeeee pills! They are the easy way to get things done!",str);
			break;
		case 4:
			sprintf(message,"%s: Drugs can do anything! Muahahahahahaha!",str);
			break;
		case 5:
			sprintf(message,"%s: Pills pills pills pills, they are so great, I could just die!",str);
			break;
		default:
			switch (Commands->Get_Random_Int(0,6))
			{
			case 0:
				sprintf(message,"%s: PLECOS!",str);
				break;
			case 1:
				sprintf(message,"%s: Pills pills pills pills!",str);
				break;
			case 2:
				sprintf(message,"%s: Do a barrel roll!",str);
				break;
			case 3:
				sprintf(message,"%s: All your base are belongs to us!",str);
				break;
			case 4:
				sprintf(message,"%s: I love pills!",str);
				break;
			case 5:
				sprintf(message,"%s: Just remember kids, drugs kill.",str);
				break;
			}
			break;
		}
		delete[] str;
		Send_Message_Player(obj,255,255,0,message);
	}
	AllowHealthIncrease = 0;
	AllowHighHurt = 1;
	ScreenEffectsEnabled = 1;
	DRUGSCREENEFFECTSON[Get_Player_ID(obj)] = 1;
	AddedWeight += 5;
	RP2StarMaxInventorySize[Get_Player_ID(obj)] += 5;
	Send_Message_Player(obj,255,255,0,"Your continued druggy habits have provided these positive side effects:");
	char Stats1[2000];
	sprintf(Stats1,"Max inventory weight increased 5 points, new max %d.",(int)RP2StarMaxInventorySize[Get_Player_ID(obj)]);
	Send_Message_Player(obj,255,255,0,Stats1);
	float MaxHealth = Commands->Get_Max_Health(obj);
	float PillPickupBonus = (10.0f * PillsPickedUpSpeedBonus);
	if (MaxHealth + PillPickupBonus < Get_Int_Parameter("Gain_Health_Max") || Get_Int_Parameter("Gain_Health_Max") == -1)
	{
		PillsPickedUp++;
		PillsPickedUpSpeedBonus++;
		AddedHealth += PillPickupBonus;
		float HealthPercent = Commands->Get_Health(obj)/Commands->Get_Max_Health(obj);
		Set_Max_Health(obj,MaxHealth + PillPickupBonus);
		Commands->Set_Health(obj,Commands->Get_Health(obj) * HealthPercent);
		PillsPickedUp++;
		PillsPickedUpSpeedBonus++;

		if (PillPickupBonus)
		{
			char Stats[2000];
			sprintf(Stats,"Health Points Gained:%.2f, Total Health Points Gained:%.2f.",PillPickupBonus,AddedHealth);
			Send_Message_Player(obj,255,255,0,Stats);
		}
	}
}

void JMG_Druggy_Script::Overdosing_Kills(GameObject *obj)
{
	float DamageAmmount = (Commands->Get_Max_Health(obj) * 0.01f) * 2.5f;
	Commands->Apply_Damage(obj,0.0,"None",0);
	float Health = Commands->Get_Health(obj);
	if (Get_Vehicle(obj))
	{
		Soldier_Transition_Vehicle(obj);
		CantExitVehicle++;
		Commands->Apply_Damage(obj,DamageAmmount,"None",0);
		Send_Message_Player(obj,255,255,0,"I don't feel like I can drive safely.");
	}
	else
	{
		CantExitVehicle = 0;
	}
	if (CantExitVehicle > 5)
	{
		CantExitVehicle = 0;
		GameObject *PlayerVehicle = Get_Vehicle(obj);
		if (PlayerVehicle)
		{
			Commands->Apply_Damage(PlayerVehicle,9999.99f,"BlamoKiller",0);
		}
	}
	else if ((Health - DamageAmmount) > DamageAmmount)
	{
		Commands->Set_Health(obj,Health - DamageAmmount);
	}
	else
	{
		Commands->Set_Health(obj,1.0f);
		char DeathMSG[237];
		const char *str = Get_Player_Name(obj);
		sprintf(DeathMSG,"%s died from drug overdose.",str);
		delete[] str;
		RP2_Player_Death_Message_Control(obj,DeathMSG,0);
		Commands->Apply_Damage(obj,99999.0f,"Blamokiller",0);
	}
	if (Commands->Get_Health(obj) == 0.0f)
	{
		if (!ISUNDERWATER[Get_Player_ID(obj)])
		{
			RP2_Set_Fog_And_Screen_Color_To_Level_Default(obj);
		}
		Send_Message_Player(obj,255,255,0,"You feel the side effects from that last pill washing through your system, you fall to your knees gasping for breath, but there is no help to be found. Guess you should not have taken those pills after all.");
		char DeathMSG[237];
		const char *str = Get_Player_Name(obj);
		sprintf(DeathMSG,"%s died from drug overdose.",str);
		delete[] str;
		RP2_Player_Death_Message_Control(obj,DeathMSG,0);
	}
	else
	{
		Set_Screen_Fade_Opacity_Player(obj,0.75f,0);
		Set_Screen_Fade_Color_Player(obj,0.8f,0.0f,0.0f,0);
	}
}

void JMG_Druggy_Script::Begin_Suffering_From_Withdrawal(GameObject *obj)
{
	WithdrawalDamageEnabled = 1;
	if (CanDisplayedWithdrawalMessage == 0 && AllowHighHurt == 1)
	{
		DRUGSCREENEFFECTSON[Get_Player_ID(obj)] = 1;
		Commands->Send_Custom_Event(obj,obj,347369,1,0);// Reenable swimming from withdrawal
		CanDisplayedWithdrawalMessage = 1;
		Send_Message_Player(obj,255,255,0,"My body feels like it is on fire, I need to find more pills and fast!");
	}
}

void JMG_Druggy_Script::End_Suffering_From_Withdrawal(GameObject *obj)
{
	WithdrawalDamageEnabled = 0;
	Send_Message_Player(obj,255,255,0,"Ah, that is much better, I should keep some pills with me to keep the craving under control.");
}	

void JMG_Druggy_Script::Take_Drugs(GameObject *obj,int param)
{
	CurrentDrugLevel += param;
	StillOnDrugs = 1;
	AllowHealthIncrease = 1;
	DrugDeathLevel += 2.5f;
	WithdrawalLevel += 2.0f;
	DrugOverdoseLevel += 3.0f;
	CanDisplayedOverdoseMessage = 0;
	CanDisplayedNDLMessage = 1;
	DropDrugs = 0;
	DrugLevelDropTime = 0;
	if (CanDisplayedDFTMessage == 1)
	{
		Send_Message_Player(obj,255,255,0,"Although these pills do look appealing, I probably should not take any more, after all, it will not be as easy to quit taking them if I get addicted.");
		CanDisplayedDFTMessage = 0;
	}
}

void JMG_Druggy_Script::Screen_Effects(GameObject *obj)
{
	if (ScreenEffectsEnabled == 1 && CurrentDrugLevel <= DrugDeathLevel)
	{
		int PlayerID = Get_Player_ID(obj);
		if (ISUNDERWATER[PlayerID] == 0)
		{
			float percentscreenopacity = (CurrentDrugLevel - (WithdrawalLevel - 1)) / (DrugDeathLevel - (WithdrawalLevel - 1));

			Red += Commands->Get_Random(-0.1f,0.1f);
			if (Red > 1.0f){Red = 1;}
			if (Red < 0.0f){Red = 0;}

			Green += Commands->Get_Random(-0.1f,0.1f);
			if (Green > 1.0f){Green = 1.0f;}
			if (Green < 0.0f){Green = 0;}

			Blue += Commands->Get_Random(-0.1f,0.1f);
			if (Blue > 1.0f){Blue = 1.0f;}
			if (Blue < 0.0f){Blue = 0;}
			RP2WeatherStruct *MyNode = PlayerWeatherNodes[Get_Player_ID(obj)];
			if (MyNode)
			{
				Set_Screen_Fade_Color_Player(obj,MyNode->ScreenColor.X+Red,MyNode->ScreenColor.Y+Green,MyNode->ScreenColor.Z+Blue,0.1f);
				if (!Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
				{
					Set_Screen_Fade_Opacity_Player(obj,MyNode->ScreenOpacity+percentscreenopacity,0.1f);
				}
			}
			else
			{
				if (!Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
				{
					Set_Screen_Fade_Opacity_Player(obj,percentscreenopacity,0.1f);
				}
				Set_Screen_Fade_Color_Player(obj,Red,Green,Blue,0.1f);
			}
		}
		else
		{
			float effect = -0.25f *(CurrentDrugLevel - (WithdrawalLevel - 1)) / (DrugDeathLevel - (WithdrawalLevel - 1));
			
			float Red2 = SWIMMINGSCREENCOLORS[PlayerID].X;
			float Green2 = SWIMMINGSCREENCOLORS[PlayerID].Y;
			float Blue2 = SWIMMINGSCREENCOLORS[PlayerID].Z;

			Red2 += Commands->Get_Random(-effect,effect);
			if (Red2 > 1.0f){Red2 = 1;}
			if (Red2 < 0.0f){Red2 = 0;}

			Green2 += Commands->Get_Random(-effect,effect);
			if (Green2 > 1.0f){Green2 = 1.0f;}
			if (Green2 < 0.0f){Green2 = 0;}

			Blue2 += Commands->Get_Random(-effect,effect);
			if (Blue2 > 1.0f){Blue2 = 1.0f;}
			if (Blue2 < 0.0f){Blue2 = 0;}
			Set_Screen_Fade_Color_Player(obj,Red2,Green2,Blue2,0.1f);
		}
	}
}

void JMG_Druggy_Script::Reset_Drug_Script(GameObject *obj)
{
	CurrentDrugLevel = 0;
	DrugOverdoseLevel = DefaultDrugOverdoseLevel;
	DrugDeathLevel = DefaultDrugDeathLevel;
	WithdrawalLevel = DefaultWithdrawalLevel;
	AllowHealthIncrease = 0;
	StillOnDrugs = 0;
	CanDisplayedDFTMessage = 1;
	ScreenEffectsEnabled = 0;
	DRUGSCREENEFFECTSON[Get_Player_ID(obj)] = 1;
	CanDisplayedWithdrawalMessage = 1;
	CanDisplayedOverdoseMessage = 0;
	PillsPickedUp = 0;
	PillsPickedUpSpeedBonus = 0;
	CanDisplayedDeathWarnMessage = 0;
	AllowHighHurt = 0;
	WithdrawalDamageEnabled = 0;
	Red = 50.0f;
	Green = 50.0f;
	Blue = 50.0f;
	if (!ISUNDERWATER[Get_Player_ID(obj)])
	{
		RP2_Set_Fog_And_Screen_Color_To_Level_Default(obj);
	}
	AddedHealth = 0.0f;
	if (AddedWeight != 0 || SubtractedWeight != 0)
	{
		int PlayerID = Get_Player_ID(obj);
		RP2StarMaxInventorySize[PlayerID] -= SubtractedWeight;
		RP2StarMaxInventorySize[PlayerID] -= AddedWeight;
		char Stats1[2000];
		sprintf(Stats1,"Max inventory weight restored to %d.",(int)RP2StarMaxInventorySize[Get_Player_ID(obj)]);
		Send_Message_Player(obj,255,255,0,Stats1);
		AddedWeight = 0;
		SubtractedWeight = 0;
	}
}

void JMG_Get_Drugs_Power_Up::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		Commands->Send_Custom_Event(obj,sender,Get_Int_Parameter("DrugTypeMessage"),Get_Int_Parameter("DrugAddAmount"),0);
	}
}

void JMG_No_Heal_Zone::Entered(GameObject *obj,GameObject *enter)
{
	Commands->Send_Custom_Event(obj,enter,595671,1,0);
}

void JMG_No_Heal_Zone::Exited(GameObject *obj,GameObject *exiter)
{
	Commands->Send_Custom_Event(obj,exiter,595670,1,0);
}

// Touched it up so hopefully it picks the key up better, also optimised the code
void JMG_Parachute_Script::Created(GameObject *obj)
{
	create = 0;
	for (int x = 0;x < 6;x++)
	{
		CE_ID[x] = 0;
	}
	In_Water = 1;
	fallenough = 0;
	ChuteEnabled = 0;
	haspowerup = 0;
	lastzmove = 0;
	SpaceBarPressed = 0;
	messagedisplayed = 0;
	Commands->Start_Timer(obj,this,0.1f,10242349);
}

void JMG_Parachute_Script::Timer_Expired(GameObject *obj,int number)
{
	if (10242349 == number)
	{
		if (!Get_Vehicle(obj) && In_Water == 1)
		{
			if (create == 0 && SpaceBarPressed == 1 && Commands->Get_Health(obj) > 0)
			{
				create = 1;
				SpaceBarPressed = 0;
				char params[20];
				sprintf(params,"%d",Commands->Get_ID(obj));
				float facing = Commands->Get_Facing(obj);
				Vector3 pos = Commands->Get_Position(obj);
				Vector3 originalpos = pos;

				float PlaceDistance = 2.0f;
				float X[6] = { 0.0f, 0.0f, 0.0f,PlaceDistance,-PlaceDistance,0.0f};
				float Y[6] = { 0.0f, PlaceDistance,-PlaceDistance,0.0f, 0.0f,0.0f};
				float Z[6] = {-5.0f,-0.1f,-0.1f,0.1f,-0.1f,4.0f};
				for (int x = 0;x < 6;x++)
				{
					pos = originalpos;
					pos.X += X[x];
					pos.Y += Y[x];
					pos.Z += Z[x];
					GameObject *object = Commands->Create_Object(Get_Parameter("Falling_Preset"),pos);
					CE_ID[x] = Commands->Get_ID(object);
				}
				GameObject *object = Commands->Find_Object(CE_ID[0]);
				Commands->Set_Model(object,"fallingobject");
				Commands->Set_Facing(object,facing);

				object = Commands->Find_Object(CE_ID[0]);

				pos = originalpos;
				GameObject *parachute = Commands->Create_Object("Signal_Flares",pos);
				Commands->Attach_Script(parachute,"JMG_Remove_Object_When_Creator_Destroyed",params);
				Commands->Disable_Physical_Collisions(parachute);
				Commands->Set_Model(parachute,"X5D_Parachute");
				Para_ID = Commands->Get_ID(parachute);
				Commands->Attach_To_Object_Bone(parachute,object,"Paraspot");

				pos = originalpos;
				Commands->Create_Sound("parachute_open",pos,obj);
				Commands->Attach_To_Object_Bone(obj,object,"AttachSpot");
				Speed = 0;
				SpeedUp = 0;
				SpeedUpCount = 0;
				OldFacing = Commands->Get_Facing(obj);
				Commands->Start_Timer(obj,this,0.0f,10242350);// trigger new parachute movement addon (added 2/27/10 to try to make up for the removal of the good script).
				Is_Attached = 1;
			}
			if (create == 1 && Commands->Get_Health(obj) > 0)
			{
				if (Has_Weapon(obj,"Weapon_Empty_Hands"))
				{
					Commands->Select_Weapon(obj,"Weapon_Empty_Hands");
				}
				GameObject *object = Commands->Find_Object(CE_ID[0]);
				GameObject *object1 = Commands->Find_Object(CE_ID[1]);
				GameObject *object2 = Commands->Find_Object(CE_ID[2]);
				GameObject *object3 = Commands->Find_Object(CE_ID[3]);
				GameObject *object4 = Commands->Find_Object(CE_ID[4]);
				GameObject *object5 = Commands->Find_Object(CE_ID[5]);
				if (Commands->Get_Health(object) == 0.0f && ChuteEnabled == 1)
				{
					ChuteEnabled = 0;
					Destroy_Main_Chute_Object(obj);
				}
				if ((Commands->Get_Health(object1) == 0.0f || Commands->Get_Health(object2) == 0.0f || Commands->Get_Health(object3) == 0.0f || Commands->Get_Health(object4) == 0.0f) && Commands->Get_ID(object) > 0)
				{
					Destroy_Main_Chute_Object(obj);
					Commands->Apply_Damage(object,9999999.00f,"BlamoKiller",0);
					Vector3 posz = Commands->Get_Position(obj);
					posz.Z += 2.0f;
					Commands->Set_Position(obj,posz);
				}
				if (Commands->Get_Health(object5) == 0.0f && ChuteEnabled == 1)
				{
					ChuteEnabled = 0;
					Vector3 posz = Commands->Get_Position(object);
					posz.Z += 100.0f;
					Commands->Set_Position(object,posz);
				}
			}
		}
		// Timers combined
		Vector3 pos = Commands->Get_Position(obj);
		if (lastpos.Z - 2.0f > pos.Z && lastpos.Z - 50.0f < pos.Z && ChuteEnabled == 1 && !Get_Vehicle(obj))
		{
			lastzmove++;
			if (lastzmove > PARACHUTEALLOWDEPLOYDELAY)
			{
				fallenough = 1;	
				if (messagedisplayed == 0 && In_Water == 1)
				{
					messagedisplayed = 1;
					Send_Message_Player(obj,0,255,64,"Press the space bar to deploy your parachute!");
				}
			}
		}
		else 
		{
			lastzmove = 0;
			fallenough = 0;
		}
		lastpos = Commands->Get_Position(obj);
		Commands->Start_Timer(obj,this,0.1f,10242349);
	}
	if (10242339 == number)
	{
		create = 0;
		if (haspowerup > 0)
		{
			int randomdamage = Commands->Get_Random_Int(0,100);
			if (randomdamage - haspowerup > 0 && randomdamage > 50)
			{
				Send_Message_Player(obj,0,255,64,"That last jump did a lot of damage to my parachute.");
			}
			haspowerup -= randomdamage;
		}
		else
		{
			haspowerup = 1;
		}
		if (haspowerup > 0)
		{
			ChuteEnabled = 1;
		}
		else
		{
			ChuteEnabled = 0;
			Send_Message_Player(obj,0,255,64,"Looks like that last jump was too much for my parachute, better find a new one.");
		}
		Commands->Set_Shield_Type(obj,armor);
		Set_Skin(obj,health);
		messagedisplayed = 0;
		SpaceBarPressed = 0;
	}
	if (10242350 == number)
	{
		GameObject *object = Commands->Find_Object(CE_ID[0]);
		if (Speed < 0.5)
		{
			Speed += 0.001f * SpeedUp;
		}
		else
		{
			Speed = 0.5f;
		}
		SpeedUpCount++;
		if (SpeedUp < 10 && SpeedUpCount == 10)
		{
			SpeedUpCount = 0;
			SpeedUp++;
		}
		float facing = Commands->Get_Facing(obj);
		float AddX = cos(facing*PI180)*Speed;
		float AddY = sin(facing*PI180)*Speed;
		for (int x = 0;x < 6;x++)
		{
			GameObject *object2 = Commands->Find_Object(CE_ID[x]);
			if (object2)
			{
				Vector3 pos = Commands->Get_Position(object);
				pos.X += AddX;
				pos.Y += AddY;
				Commands->Set_Position(object2,pos);
			}
		}
		if (create)
		{
			Commands->Start_Timer(obj,this,0.0f,10242350);
		}
		if (Is_Attached)
		{
			Is_Attached = 0;
			Commands->Attach_To_Object_Bone(obj,0,0);
		}
		else
		{
			Is_Attached = 1;
			Commands->Set_Facing(object,Commands->Get_Facing(obj));
			Commands->Attach_To_Object_Bone(obj,object,"AttachSpot");
		}
		//Slow down when turning
		float Facing = Commands->Get_Facing(obj);
		Facing += 180.0f;
		float Diff = abs(Facing - OldFacing);
		if (Diff > 10)
		{
			SpeedUpCount = 0;
			SpeedUp = 0;
		}
		if (Diff > 180)
		{
			Diff -= 180.0f;
		}
		Speed -= ((Speed*(Diff/180))/2);
		OldFacing = Facing;
	}
}

void JMG_Parachute_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 98472765 && Commands->Get_Health(obj) > 0)
	{
		if (haspowerup < param)
		{
			haspowerup = param;
			Send_Message_Player(obj,0,255,64,"I picked up a parachute, it seems to be in good condition!");
		}
		else
		{
			Send_Message_Player(obj,0,255,64,"Yeah... I think I'll keep my current parachute, thanks.");
		}
		ChuteEnabled = 1;
	}
	if (message == 347360){
		In_Water = 1;}
	if (message == 347361){
		In_Water = 0;}
	if (message == 35432167 && !Get_Vehicle(obj) && fallenough == 1){// Space Bar
		SpaceBarPressed = 1;}
}

void JMG_Parachute_Script::Killed(GameObject *obj, GameObject *damager)
{
	if (Para_ID > 0)
	{
		Commands->Destroy_Object(Commands->Find_Object(Para_ID));
	}
}

void JMG_Parachute_Power_Up::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		int Condition = Get_Int_Parameter("Condition");
		if (Condition > 100)
		{
			Condition = 100;
		}
		Commands->Send_Custom_Event(obj,sender,98472765,Condition,0);
	}
}

void JMG_Parachute_Script::Destroy_Main_Chute_Object(GameObject *obj)
{
	if (create == 1)
	{
		CE_ID[0] = 0;
		Commands->Apply_Damage(Commands->Find_Object(Para_ID),9999999.00f,"BlamoKiller",0);
		armor = Get_Shield_Type(obj);
		health = Get_Skin(obj);
		Commands->Set_Shield_Type(obj,"blamo");
		Set_Skin(obj,"blamo");
		Commands->Start_Timer(obj,this,3.25f,10242339);
	}
}

void JMG_Police_Car_Script::Created(GameObject *obj)
{
	siren = 0;
	lightson = 0;
	SirenID = 0;
	char Animation[1000];
	sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
	Commands->Set_Animation(obj,Animation,true,0,1,0,1);
}

void JMG_Police_Car_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7154148)
	{
		Send_Message_Player(sender,200,200,125,"Vehicle Special Keys:");
		Send_Message_Player(sender,200,200,125,"Left Click - Turn lights on");
		Send_Message_Player(sender,200,200,125,"Right Click - Cycle through siren modes");
	}
	if (message == 98562145 && lightson == 0)
	{
		char Animation[1000];
		sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
		lightson = 1;
		Commands->Set_Animation(obj,Animation,true,0,2,3,1);
	}
	else if (message == 98562145 && lightson == 1)
	{
		char Animation[1000];
		sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
		lightson = 0;
		Commands->Set_Animation(obj,Animation,true,0,1,0,1);
	}
	if (message == 98562146)
	{
		if (SirenID > 0)
		{
			GameObject *Siren = Commands->Find_Object(SirenID);
			if (Siren)
			{
				Commands->Destroy_Object(Siren);
			}
			SirenID = 0;
		}
		if (siren == 0)
		{
			siren = 1;
			Vector3 pos;
			char params[20];
			sprintf(params,"%d",Commands->Get_ID(obj));
			GameObject *siren = Commands->Create_Object("Daves Arrow",pos);
			Commands->Attach_To_Object_Bone(siren,obj,"origin");	
			Commands->Set_Model(siren,"PoliceCarSiren1");
			SirenID = Commands->Get_ID(siren);
			Commands->Attach_Script(siren,"JMG_Remove_Object_When_Creator_Destroyed",params);
		}
		else if (siren == 1)
		{
			siren = 2;
			Vector3 pos;
			char params[20];
			sprintf(params,"%d",Commands->Get_ID(obj));
			GameObject *siren = Commands->Create_Object("Daves Arrow",pos);
			Commands->Attach_To_Object_Bone(siren,obj,"origin");	
			Commands->Set_Model(siren,"PoliceCarSiren2");
			SirenID = Commands->Get_ID(siren);
			Commands->Attach_Script(siren,"JMG_Remove_Object_When_Creator_Destroyed",params);
		}
		else if (siren == 2)
		{
			siren = 0;
		}
	}
}

void JMG_RP2_Water_Kill_Zone::Entered(GameObject *obj,GameObject *enter)
{
	const char *blast = "BlamoKiller";
	Set_Screen_Fade_Opacity_Player(enter,0.5f,0.0f);
	Set_Screen_Fade_Color_Player(enter,0.0f,0.0f,1.0f,0.0f);
	Commands->Apply_Damage(enter,9999999.00f,blast,0);
}

void JMG_RP2_Water_Kill_Zone::Exited(GameObject *obj,GameObject *enter)
{
		Set_Screen_Fade_Opacity_Player(enter,0.0f,0.0f);
		Set_Screen_Fade_Color_Player(enter,0.0f,0.0f,0.0f,0.0f);
}

void JMG_Boat_To_High::Created(GameObject *obj)
{
	Commands->Enable_Engine(obj,true);
	Create_Height = Commands->Get_Position(obj).Z;
	Commands->Start_Timer(obj,this,0.1f,41352349);
}

void JMG_Boat_To_High::Timer_Expired(GameObject *obj,int number)
{
	if (41352349 == number)
	{
		Vector3 pos = Commands->Get_Position(obj);
		if (Commands->Get_Position(obj).Z < Create_Height && obj->As_PhysicalGameObj())
		{
			Vector3 OldPos = pos;
			pos.Z = Create_Height;
			Commands->Set_Position(obj,pos);
			PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
			if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
			{
				Commands->Set_Position(obj,OldPos);
				pos = OldPos;
			}
		}
		if (Get_Float_Parameter("WaterLevel") < pos.Z)
		{
			Commands->Apply_Damage(obj,9999999.00f,"BlamoKiller",0);
		}
		if (Get_Float_Parameter("WaterLevel") - 1.0 > pos.Z)
		{
			Commands->Apply_Damage(obj,9999999.00f,"BlamoKiller",0);
		}
		Commands->Start_Timer(obj,this,0.1f,41352349);
	}
}

void Reset_Screen_Color_When_Created::Created(GameObject *obj)
{
	Set_Screen_Fade_Opacity_Player(obj,0.0f,0.0f);
	Set_Screen_Fade_Color_Player(obj,0.0f,0.0f,0.0f,0.0f);
}

void JMG_Plecos_Script::Created(GameObject *obj)
{
	Send_Message_Player(obj,255,0,0,"Warning: Canadacdn is on-line! Be prepared for the spamming of PLECOS related messages.");
	float time = 6.0f * Get_Float_Parameter("Delay_Time_Multiplier");
	Commands->Start_Timer(obj,this,time,98465472);
}

void JMG_Plecos_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 98465472)
	{
		const char *message = "";
		int Random = Commands->Get_Random_Int(0,54);
		if (Random == 0){message = "Canadacdn: also PLECOS";}
		if (Random == 1){message = "Canadacdn: PLECOS algae sucking upping";}
		if (Random == 2){message = "Canadacdn: if so, a script called PLECOS is mandatory";}
		if (Random == 3){message = "Canadacdn: make me a PLECOS script for my birthday";}
		if (Random == 4){message = "Canadacdn: needs more PLECOS...";}
		if (Random == 5){message = "Canadacdn: party with PLECOS";}
		if (Random == 6){message = "Canadacdn: and keep on PLECOin";}
		if (Random == 7){message = "Canadacdn: A Reminder, and PLECOS!";}
		if (Random == 8){message = "Canadacdn: Big PLECOS to you.";}
		if (Random == 9){message = "Canadacdn: PLECOS alert!";}
		if (Random == 10){message = "Canadacdn: A Reminder, and PLECOS!";}
		if (Random == 11){message = "Canadacdn: Hypostomus PLECOSTOMUS";}
		if (Random == 12){message = "Canadacdn: PLECOS.";}
		if (Random == 13){message = "Canadacdn: PLECOS and basketballs.";}
		if (Random == 14){message = "Canadacdn: Looks like your computer's got PLECOS. I recommend algae wafers.";}
		if (Random == 15){message = "Canadacdn: Aw, PLECOS.";}
		if (Random == 16){message = "Canadacdn: Also, PLECOS";}
		if (Random == 17){message = "Canadacdn: Admire the PLECOS, respect the PLECOS, love the PLECOS";}
		if (Random == 18){message = "Canadacdn: Awesome! You get a nice PLECOS as a reward.";}
		if (Random == 19){message = "Canadacdn: Ok, remember. PLECOS.";}
		if (Random == 20){message = "Canadacdn: PLECOS are not allowed to gamble";}
		if (Random == 21){message = "Canadacdn: Yes, or no, or PLECOS!";}
		if (Random == 22){message = "Canadacdn: The wonderful wizard of PLECOS!";}
		if (Random == 23){message = "Canadacdn: The name's PLECOS. PLECOS Stomus.";}
		if (Random == 24){message = "Canadacdn: I've run out of PLECOS-related titles";}
		if (Random == 25){message = "Canadacdn: A gift basket of PLECOS";}
		if (Random == 26){message = "Canadacdn: I only own one PLECOS.";}
		if (Random == 27){message = "Canadacdn: I have a really important task for you. Kidding, it's some PLECOS!";}
		if (Random == 28){message = "Canadacdn: I'm as happy as a PLECOS in a room filled with algae.";}
		if (Random == 29){message = "Canadacdn: Ok. Buy PLECOS.";}
		if (Random == 30){message = "Canadacdn: Also, buy some PLECOS.";}
		if (Random == 31){message = "Canadacdn: PLECOSX10";}
		if (Random == 32){message = "Canadacdn: PLECOS need their space.";}
		if (Random == 33){message = "Canadacdn: Yes, buy some PLECOS.";}
		if (Random == 34){message = "Canadacdn: PLECOSTOMUSES";}
		if (Random == 35){message = "Canadacdn: Safeway has 0 tolerance toward the mutant PLECOS community";}
		if (Random == 36){message = "Canadacdn: Oh, and PLECOS";}
		if (Random == 37){message = "Canadacdn: PLECOS sure are awesome, through";}
		if (Random == 38){message = "Canadacdn: I fed my PLECOS some algae wafer food today, and it went insane and ate it quickly";}
		if (Random == 39){message = "Canadacdn: dropped the food into the water, and watched PLECOS suck it up";}
		if (Random == 40){message = "Canadacdn: May the PLECOS be with you";}
		if (Random == 41){message = "Canadacdn: With luck, and PLECOS, everything will be okay.";}
		if (Random == 42){message = "Canadacdn: No PLECOS for you!";}
		if (Random == 43){message = "Canadacdn: Post as many pictures of PLECOS as you can.";}
		if (Random == 44){message = "Canadacdn: no, space PLECOS will fall on you";}
		if (Random == 45){message = "Canadacdn: you get spammed with PLECOS references";}
		if (Random == 46){message = "Canadacdn: Big PLECOS to you indeed";}
		if (Random == 47){message = "Canadacdn: PLECOS is all-caps";}
		if (Random == 48){message = "Canadacdn: buy a fish tank with PLECOS when you go to collage";}
		if (Random == 49){message = "Canadacdn: but PLECOS are not for eating, EVER";}
		if (Random == 50){message = "Canadacdn: Cabal: Analysis indicates that PLECOS are awesome";}
		if (Random == 51){message = "Canadacdn: post some PLECOS in my birthday thread";}
		if (Random == 52){message = "Canadacdn: PLECOS world?";}
		if (Random == 53){message = "Canadacdn: [PLECOS]PLECOS[/PLECOS]";}
		if (Random == 54){message = "Canadacdn: because PLECOS are awesome";}
		if (Random == 56){message = "Canadacdn: PLECOS splash in the water all day long.";}
		Send_Message_Player(obj,255,255,255,message);
		Commands->Start_Timer(obj,this,Commands->Get_Random((3.0f * Get_Float_Parameter("Delay_Time_Multiplier")),(9.0f * Get_Float_Parameter("Delay_Time_Multiplier"))),98465472);
	}
}

void JMG_Detox_Powerup::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		Commands->Send_Custom_Event(obj,sender,98745522,1,0);
	}
}

void JMG_Drug_Health_Increase_Powerup_Monitor::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		if (Get_Float_Parameter("Add_Health_Amount") > 0)
		{
			Commands->Send_Custom_Event(obj,sender,Get_Int_Parameter("DrugTypeMessage") + 545,Get_Int_Parameter("Add_Health_Amount"),0);
		}
		if (Get_Float_Parameter("Multiply_Health_Ratio") > 0)
		{
			Commands->Send_Custom_Event(obj,sender,Get_Int_Parameter("DrugTypeMessage") + 555,Get_Int_Parameter("Multiply_Health_Ratio"),0);
		}
	}
}

void JMG_Prostitute_Script::Created(GameObject *obj)
{
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Yes,211511231");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","No,211511230");
	Commands->Attach_Script(obj,"JMG_RP2_Change_Models_On_Custom","4,c_ag_gdi_hotw,c_ag_gdi_syd2,c_ag_nod_saku,c_ag_nod_saku2,null,null,null,null,null,null");
	cost = 250;
	cost2 = 250;
	moneygathered = 0;
	Current_ID = 0;
	hasacustomer = 0;
	haschosen = 0;
	hasclient = 0;
	iwta = 0;
	name = newstr("null");
	resetinprogress = 0;
	count = 30;
	resetcount = 5;
	resetpending = 0;
	secondattempt = 0;
	choicetime = 0;
	hasbeenshot = 0;
	shotresetcount = 0;
	shotcount = 0;
	percentage = 0.0f;
	tofaraway = 0;
	cmcn = 0;
	camcn = 0;
	myoriginalmaxshield = Commands->Get_Max_Shield_Strength(obj);
	Send_Message_Player(obj,255,127,127,"Plus increases the charge per minute, Minus decreases the charge.");
	Send_Message_Player(obj,255,127,127,"In order for the script to activate someone must press 'E' on you.");
	Send_Message_Player(obj,255,127,127,"The more you charge the more health benefit there is to your client.");
	Send_Message_Player(obj,255,127,127,"ChangeModel changes your Character and ChangeAppearence changes your outfit.");
	Send_Message_Player(obj,255,127,127,"Your current charge per minute is $250");
	Commands->Start_Timer(obj,this,0.1f,28957463);
	Commands->Enable_HUD_Pokable_Indicator(obj,1);
	Commands->Start_Timer(obj,this,10.0f,28957467);
}

void JMG_Prostitute_Script::Poked(GameObject *obj,GameObject *poker)
{
	//send data
	if (Current_ID == 0 && iwta == 0 && hasacustomer == 0 && secondattempt == 0 && resetinprogress == 0)
	{
		char text[1000];
		const char *str = Get_Player_Name(poker);
		sprintf(text,"%s is checking you out!",str);
		delete[] str;
		Send_Message_Player(obj,255,127,127,text);
		float currentmoney = Commands->Get_Money(poker);
		if (currentmoney > cost)
		{
			Commands->Send_Custom_Event(obj,poker,211511213,cost2,0);
			Current_ID = Commands->Get_ID(poker);
			name = Get_Player_Name(poker);
			hasacustomer = 1;
			Commands->Enable_HUD_Pokable_Indicator(obj,0);
			resetpending = 1;
			DelayOn = 1;
			Commands->Start_Timer(obj,this,0.0f,28957465);
			Commands->Start_Timer(obj,this,1.0f,28957466);
			secondattempt = 1;
			char sex = Get_Sex(obj);
			if (sex == 'A')
			{
				Send_Message_Player(poker,255,127,127,"He is pretty cute!");
				if (cost == 0){Send_Message_Player(poker,255,127,127,"And I have a feeling he is just looking for some fun.");}
				if (cost == 50){Send_Message_Player(poker,255,127,127,"And for someone as cute as him; $50 a minute is a excellent deal.");}
				if (cost == 100){Send_Message_Player(poker,255,127,127,"And all this cutie wants is $100 a minute.");}
				if (cost == 150){Send_Message_Player(poker,255,127,127,"And he is just so cute; $150 a minute is completely worth it.");}
				if (cost == 200){Send_Message_Player(poker,255,127,127,"And all this dude wants is $200 a minute; that is pretty affordable.");}
				if (cost == 250){Send_Message_Player(poker,255,127,127,"Even at $250 a minute; a stud like him is worth it");}
				if (cost == 300){Send_Message_Player(poker,255,127,127,"But he does want $300 a minute for his time; but he is still cute.");}
				if (cost == 350){Send_Message_Player(poker,255,127,127,"But he does charge $350; but he is cute after all.");}
				if (cost == 400){Send_Message_Player(poker,255,127,127,"But he does charge $400; but he is good looking.");}
				if (cost == 450){Send_Message_Player(poker,255,127,127,"But he does charge $450 a minute.");}
				if (cost == 500){Send_Message_Player(poker,255,127,127,"But he charges $500 a minute; that is not worth it.");}
				Send_Message_Player(poker,255,127,127,"If I am interested in more, I should make some indication of this.");
			}
			if (sex == 'B')
			{
				Send_Message_Player(poker,255,127,127,"Wow; she is hot! There are no questions about that.");
				if (cost == 0){Send_Message_Player(poker,255,127,127,"And I have a feeling she is just looking for some fun.");}
				if (cost == 50){Send_Message_Player(poker,255,127,127,"And for someone as sexy as she is; $50 a minute makes her easy.");}
				if (cost == 100){Send_Message_Player(poker,255,127,127,"And all this sexy animal wants is $100 a minute.");}
				if (cost == 150){Send_Message_Player(poker,255,127,127,"And she is just so sexy; $150 a minute is completely worth her time.");}
				if (cost == 200){Send_Message_Player(poker,255,127,127,"And all this beautiful chick wants is $200 a minute; that is pretty affordable.");}
				if (cost == 250){Send_Message_Player(poker,255,127,127,"Even at $250 a minute; a rarity like her is definitely worth it");}
				if (cost == 300){Send_Message_Player(poker,255,127,127,"But she does want $300 a minute for her time; but she is still beautiful.");}
				if (cost == 350){Send_Message_Player(poker,255,127,127,"But she does charges $350 a minute; but she is extremely hot after all.");}
				if (cost == 400){Send_Message_Player(poker,255,127,127,"But she does charges $400 a minute; but she is very good looking.");}
				if (cost == 450){Send_Message_Player(poker,255,127,127,"But she does charges $450 a minute; but she is still pretty.");}
				if (cost == 500){Send_Message_Player(poker,255,127,127,"But she charges $500 a minute; see is cute through.");}
				Send_Message_Player(poker,255,127,127,"If I am interested, I should let this sexy babe know what I am thinking.");
			}
		}
	}
	// bring up choice text
	if (Current_ID > 0 && iwta == 0 && DelayOn == 0 && haschosen == 0 && secondattempt == 1 && resetinprogress == 0 && _stricmp(Commands->Get_Preset_Name(obj),Commands->Get_Preset_Name(poker)))
	{
		resetpending = 0;
		resetcount = 5;
		char messag2[1000];
		sprintf(messag2,"%s is willing to pay your fees, do I accept %s's offer?",name,name);
		Send_Message_Player(obj,255,127,127,messag2);
		iwta = 1;
		haschosen = 0;
		secondattempt = 2;
		choicetime = 1;
		GameObject *object = Commands->Find_Object(Current_ID);
		Send_Message_Player(object,255,127,127,"I should wait and see if they accept my offer.");
		Commands->Start_Timer(obj,this,12.0f,28957469);
	}
	// prostitute + prostitute = no
	if (Current_ID > 0 && iwta == 0 && DelayOn == 0 && haschosen == 0 && secondattempt == 1 && resetinprogress == 0 && !_stricmp(Commands->Get_Preset_Name(obj),Commands->Get_Preset_Name(poker)))
	{
		Send_Message_Player(poker,255,127,127,"An employee cannot hire another employee, it doesn't work that way!");
		Send_Message_Player(Commands->Find_Object(Current_ID),255,127,127,"An employee cannot hire another employee, it doesn't work that way!");
	}
}

void JMG_Prostitute_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (resetinprogress == 0)
	{
		// addjust charge -
		if (message == 10002142 && cost > 0.0f && Current_ID == 0)
		{
			cost -= 50;
			cost2 -= 50;
			char Charge[256];
			sprintf(Charge,"Charge per minute: $%d",cost2);
			Send_Message_Player(obj,255,127,127,Charge);
		}
		// adjust charge +
		if (message == 10012142 && cost < 500.0f && Current_ID == 0)
		{
			cost += 50;
			cost2 += 50;
			char Charge[256];
			sprintf(Charge,"Charge per minute: $%d",cost2);
			Send_Message_Player(obj,255,127,127,Charge);
		}
		// yes
		if (message == 211511231 && hasacustomer == 1 && haschosen == 0 && choicetime == 1)
		{
			Send_Message_Player(obj,255,127,127,"I have accepted the offer.");
			GameObject *object = Commands->Find_Object(Current_ID);
			char messag4[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag4,"%s has accepted my offer.",str);
			delete[] str;
			Send_Message_Player(object,255,127,127,messag4);
			hasacustomer = 1;
			haschosen = 1;
			Commands->Send_Custom_Event(obj,sender,211511241,cost2,0);
			Commands->Enable_HUD_Pokable_Indicator(obj,0);
		}
		// no
		if (message == 211511230 && hasacustomer == 1 && haschosen == 0 && choicetime == 1)
		{
			Send_Message_Player(obj,255,127,127,"I have rejected the offer.");
			GameObject *object = Commands->Find_Object(Current_ID);
			char messag4[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag4,"%s has rejected my offer.",str);
			delete[] str;
			Send_Message_Player(object,255,127,127,messag4);
			hasacustomer = 0;
			haschosen = 1;
			Current_ID = 0;
			Commands->Start_Timer(obj,this,15.0f,28957461);
		}
		// has aggreeded to be your whore
		if (message == 211511241)
		{
			char messag2[1000];
			sprintf(messag2,"You are now working for %s.",name);
			Send_Message_Player(obj,255,127,127,messag2);
			GameObject *object = Commands->Find_Object(Current_ID);
			const char *str = Get_Player_Name(obj);
			sprintf(messag2,"%s is now working for me.",str);
			delete[] str;
			Send_Message_Player(object,255,127,127,messag2);
			hasclient = 1;
			Commands->Send_Custom_Event(obj,sender,211511214,1,0);
			Commands->Start_Timer(obj,this,60.0f,28957462);
			Commands->Start_Timer(obj,this,1.0f,28957468);
			char params[20];
			sprintf(params,"%d",Commands->Get_ID(obj));
			Attach_Script_Once(object,"JMG_Prostitute_Attach_Script",params);
			percentage = (cost + 250) / 1000.00f;
			percentage *= 2.5;
			hisoriginalmaxshield = Commands->Get_Max_Shield_Strength(object);
			float mymaxshield = Commands->Get_Max_Shield_Strength(obj);
			float myshield = Commands->Get_Shield_Strength(obj);
			float givememaxshield = (percentage / 2.5f) * mymaxshield;
			float givemeshield = (percentage / 2.5f) * myshield;
			Set_Max_Shield_Strength(obj,mymaxshield - givememaxshield);
			Commands->Set_Shield_Strength(obj,myshield - givemeshield);
			float theirmaxshield = Commands->Get_Max_Shield_Strength(object);
			float theirshield = Commands->Get_Shield_Strength(object);
			float givetheirmaxshield = percentage * theirmaxshield;
			float givetheirshield = percentage * theirshield;
			Set_Max_Shield_Strength(object,theirmaxshield + givetheirmaxshield);
			Commands->Set_Shield_Strength(object,theirshield + givetheirshield);
		}
		//not enough money
		if (message == 211511215)
		{
			Send_Message_Player(obj,255,127,127,"My \"client\" did not have enough money for the latest payment, so I no longer work for him.");
			GameObject *object = Commands->Find_Object(Current_ID);
			char messag3[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag3,"I do not have enough money to pay %s, so %s has quit.",str,str);
			delete[] str;
			Send_Message_Player(object,255,127,127,messag3);
			resetinprogress = 1;
			hasclient = 0;
			Commands->Start_Timer(obj,this,60.0f,28957461);
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);	
		}
		//to far away
		if (message == 211511216)
		{
			Send_Message_Player(obj,255,127,127,"I have ran away from my \"client\", I must now give 75% of my \"client's\" money back.");
			GameObject *object = Commands->Find_Object(Current_ID);
			char messag3[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag3,"%s has run away. But has left me a check with 75%% of the money they earned from me.",str);
			delete[] str;
			Send_Message_Player(object,255,127,127,messag3);
			resetinprogress = 1;
			hasclient = 0;
			Commands->Start_Timer(obj,this,60.0f,28957461);
			Commands->Give_Money(object,moneygathered * 0.75f,0);
			Commands->Give_Money(obj,-moneygathered * 0.75f,0);
			moneygathered *= 0.25f;
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);
		}
		//way to far away
		if (message == 211511219)
		{
			Send_Message_Player(obj,255,127,127,"My \"client\" has gone through a door, I have 30 seconds to get back to their position.");
			GameObject *object = Commands->Find_Object(Current_ID);
			char messag3[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag3,"I have lost %s, they now have 30 seconds to get back.",str);
			delete[] str;
			Send_Message_Player(object,255,127,127,messag3);
			tofaraway = 1;
		}
		//to far away punish
		if (message == 211511320)
		{
			Send_Message_Player(obj,255,127,127,"I have ran away from my \"client\" I must now give 75% of my \"client's\" money back.");
			GameObject *object = Commands->Find_Object(Current_ID);
			char messag3[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag3,"%s has run away. But has left me a check returning 75%% of my money that I gave them.",str);
			delete[] str;
			Send_Message_Player(obj,255,127,127,messag3);
			resetinprogress = 1;
			hasclient = 0;
			Commands->Start_Timer(obj,this,60.0f,28957461);
			Commands->Give_Money(object,moneygathered * 0.75f,0);
			Commands->Give_Money(obj,-moneygathered * 0.75f,0);
			moneygathered *= 0.25f;
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);
		}
		//shot by client
		if (message == 211511218)
		{
			Send_Message_Player(obj,255,127,127,"I was shot to many times by my \"client,\" I have charged my \"client\" for 50% of all the money my \"client\" had, I no longer work for him.");
			GameObject *object = Commands->Find_Object(Current_ID);
			char messag3[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag3,"I have shot %s to many times, and I have given them 50%% of my money.",str);
			delete[] str;
			Send_Message_Player(obj,255,127,127,messag3);
			resetinprogress = 1;
			hasclient = 0;
			Commands->Start_Timer(obj,this,60.0f,28957461);
			float takemoney = Commands->Get_Money(object) * 0.5f;
			Commands->Give_Money(object,- takemoney,0);
			Commands->Give_Money(obj,+ takemoney,0);
			moneygathered += takemoney;
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);
		}
		//I was killed
		if (message == 211511217)
		{
			Send_Message_Player(obj,255,127,127,"I have been killed, my \"client\" will have to find a new employer.");
			GameObject *object = Commands->Find_Object(Current_ID);
			char messag3[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag3,"%s was killed.",str);
			delete[] str;
			Send_Message_Player(obj,255,127,127,messag3);
			resetinprogress = 1;
			hasclient = 0;
			Commands->Start_Timer(obj,this,60.0f,28957461);
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);
		}
		// watch your fire
		if (message == 211511322)
		{
			hasbeenshot = 1;
			if (shotcount < 3)
			{
				shotcount += 1;
			}
			if (shotcount == 3)
			{
				Commands->Send_Custom_Event(obj,obj,211511218,1,0);
			}
			GameObject *object = Commands->Find_Object(Current_ID);
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);
		}
		// havn't killed them yet
		if (message == 211511322)
		{
			hasbeenshot = 0;
			shotcount = 0;
			shotresetcount = 0;
			GameObject *object = Commands->Find_Object(Current_ID);
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);
		}
		//I killed my client
		if (message == 211511324)
		{
			Send_Message_Player(obj,255,127,127,"I have killed my \"client\" and will now have to pay him 75% of my money.");
			GameObject *object = Commands->Find_Object(Current_ID);
			char messag3[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag3,"%s has killed me, I have collected 75%% of that %s's money. And %s obviously no longer works for me.",str,str,str);
			delete[] str;
			Send_Message_Player(obj,255,127,127,messag3);
			resetinprogress = 1;
			float takemoney = Commands->Get_Money(obj) * 0.75f;
			Commands->Give_Money(obj,- takemoney,0);
			Commands->Give_Money(object,+ takemoney,0);
			moneygathered = 0;
			Commands->Start_Timer(obj,this,0.0f,28957461);
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);
		}
		//I shot my client
		if (message == 211511323)
		{
			Send_Message_Player(obj,255,127,127,"I have shot my \"client\" and he has decided to both fine and fire me. I must now give him 25% of my earnings.");
			GameObject *object = Commands->Find_Object(Current_ID);
			resetinprogress = 1;
			float takemoney = moneygathered * 0.25f;
			Commands->Give_Money(obj,- takemoney,0);
			Commands->Give_Money(object,+ takemoney,0);
			moneygathered *= 0.25f;
			Commands->Start_Timer(obj,this,60.0f,28957461);
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);
		}
		//Client killed
		if (message == 211511325)
		{
			Send_Message_Player(obj,255,127,127,"My \"client\" was killed; I will either have to go jobless or find a new one.");
			resetinprogress = 1;
			Commands->Start_Timer(obj,this,0.0f,28957461);
			GameObject *object = Commands->Find_Object(Current_ID);
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);
		}
		//Quit Because of the boss
		if (message == 211511326)
		{
			char messag1[1000];
			sprintf(messag1,"%s has fired me. If %s wants it can rehire me through, as it might have been a misunderstanding.",name,name);
			Send_Message_Player(obj,255,127,127,messag1);
			resetinprogress = 1;
			Commands->Start_Timer(obj,this,0.0f,28957461);
			GameObject *object = Commands->Find_Object(Current_ID);
			Commands->Send_Custom_Event(obj,object,211511324,Commands->Get_ID(obj),0);
		}
		// Has returned in time
		if (message == 211511327)
		{
			Send_Message_Player(obj,255,127,127,"I made it back to my \"client\" before my time was up, and well not be punished.");
			GameObject *object = Commands->Find_Object(Current_ID);
			char messag3[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag3,"%s has returned to me before their time was up.",str);
			delete[] str;
			Send_Message_Player(object,255,127,127,messag3);
		}
	}
}

void JMG_Prostitute_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 28957462)
	{
		GameObject *object = Commands->Find_Object(Current_ID);
		float currentmoney = Commands->Get_Money(object);
		if (currentmoney - cost >= 0 && resetinprogress == 0)
		{
			GameObject *object2 = Commands->Find_Object(Current_ID);
			Send_Message_Player(object2,255,127,127,"I have paid my \"client.\"");
			char messag3[1000];
			const char *str = Get_Player_Name(obj);
			sprintf(messag3,"%s has paid me.",str);
			delete[] str;
			Send_Message_Player(obj,255,127,127,messag3);
			Commands->Give_Money(object,-cost,0);
			Commands->Give_Money(obj,cost,0);
			moneygathered += cost;
			Commands->Start_Timer(obj,this,60.0f,28957462);
		}
		else if ((currentmoney - cost < 0) && (resetinprogress == 0))
		{
			Commands->Send_Custom_Event(obj,obj,211511215,1,0);
			hasclient = 0;
		}
	}
	if (number == 28957463)
	{
		if (hasclient == 1 && resetinprogress == 0)
		{
			GameObject *object = Commands->Find_Object(Current_ID);
			float distance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(object));
			if (distance > 10.0f && distance < 20 && tofaraway == 0)
			{	
				tofaraway = 1;
				Commands->Send_Custom_Event(obj,obj,211511216,1,0);
				hasclient = 0;
			}
			if (distance >= 20 && tofaraway == 0 && resetinprogress == 0)
			{
				tofaraway = 1;
				Commands->Send_Custom_Event(obj,obj,211511219,1,0);
				Commands->Start_Timer(obj,this,1.0f,28957464);
			}
			if (distance <= 10.0f && tofaraway == 1)
			{
				tofaraway = 0;
				count = 30;
				Commands->Send_Custom_Event(obj,obj,211511327,1,0);
			}
		}
		Commands->Start_Timer(obj,this,0.1f,28957463);
	}
	if (number == 28957461)
	{
		moneygathered = 0;
		hasacustomer = 0;
		haschosen = 0;
		hasclient = 0;
		iwta = 0;
		name = newstr("null");
		resetinprogress = 0;
		count = 30;
		resetcount = 5;
		resetpending = 0;
		secondattempt = 0;
		choicetime = 0;
		hasbeenshot = 0;
		shotresetcount = 0;
		shotcount = 0;
		percentage = 0.0f;
		tofaraway = 0;
		float newpercentage = myoriginalmaxshield / Commands->Get_Max_Shield_Strength(obj);
		Commands->Set_Shield_Strength(obj,Commands->Get_Shield_Strength(obj) * newpercentage);
		Set_Max_Shield_Strength(obj,myoriginalmaxshield);
		Commands->Enable_HUD_Pokable_Indicator(obj,1);
		Current_ID = 0;
	}
	if (number == 28957464 && tofaraway == 1)
	{
		if (count > 0 && tofaraway == 1)
		{
			count -= 1;
			if (count == 1)
			{
				Send_Message_Player(obj,255,127,127,"I have 1 second to get back to my client...");
			}
			else if (count <= 5 || count == 20 || count == 15 || count == 10)
			{
				char warning[1000];
				sprintf(warning,"I have %d seconds to get back to my client...",count);
				Send_Message_Player(obj,255,127,127,warning);
			}
		}
		if ((count == 0) && (tofaraway == 1))
		{
			Commands->Start_Timer(obj,this,0.1f,28957461);
			Commands->Send_Custom_Event(obj,obj,211511320,1,0);
		}
		Commands->Start_Timer(obj,this,1.0f,28957464);
	}
	if (number == 28957465 && resetpending == 1)
	{
		if (resetcount > 0 && resetinprogress == 0)
		{
			resetcount -= 1;
			Commands->Start_Timer(obj,this,1.0f,28957465);
		}
		if (resetcount == 0 && resetinprogress == 0)
		{
			resetcount = 5;
			resetpending = 0;
			Commands->Start_Timer(obj,this,0.0f,28957461);
		}
	}
	if (number == 28957466 && resetinprogress == 0)
	{
		DelayOn = 0;
		Commands->Enable_HUD_Pokable_Indicator(obj,1);
	}
	if (number == 28957467)
	{
		if (hasbeenshot == 1 && shotresetcount < 3 && resetinprogress == 0)
		{
			shotresetcount += 1;
		}
		if (hasbeenshot == 1 && shotresetcount == 3 && resetinprogress == 0)
		{
			Commands->Start_Timer(obj,this,0.0f,211511321);
		}
		Commands->Start_Timer(obj,this,10.0f,28957467);
	}
	if (number == 28957468 && resetinprogress == 0)
	{
		GameObject *object = Commands->Find_Object(Current_ID);
		Commands->Send_Custom_Event(obj,object,Commands->Get_ID(obj),(int)moneygathered,0);
		Commands->Start_Timer(obj,this,1.0f,28957468);
	}
	if (number == 28957469 && haschosen == 0 && hasacustomer == 1)
	{
		char messag[1000];
		sprintf(messag,"%s is waiting for your 'yes' or 'no' answer.",name);
		Send_Message_Player(obj,255,127,127,messag);
		Commands->Start_Timer(obj,this,12.0f,28957469);
	}
}

void JMG_Prostitute_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Current_ID > 0 && resetinprogress == 0)
	{
		int damagerid = Commands->Get_ID(damager);
		if (Current_ID == damagerid)
		{
			Commands->Send_Custom_Event(obj,obj,211511322,1,0);
		}
		float HP = Commands->Get_Health(obj) + Commands->Get_Shield_Strength(obj);
		if (damage >= HP)
		{
			Commands->Send_Custom_Event(obj,obj,211511218,1,0);
		}
	}
}

void JMG_Prostitute_Script::Killed(GameObject *obj, GameObject *damager)
{
	if (Current_ID > 0 && resetinprogress == 0)
	{
		Commands->Send_Custom_Event(obj,obj,211511217,1,0);
		Current_ID = 0;
	}
}

void JMG_Keyboard_Input_Custom::Created(GameObject *obj)
{
	InstallHook(Get_Parameter("Key"),obj);
}

void JMG_Keyboard_Input_Custom::KeyHook()
{
	Commands->Send_Custom_Event(Owner(),Owner(),Get_Int_Parameter("Message"),0,0);
}

void JMG_Prostitute_Attach_Script::Created(GameObject *obj)
{
	hassentcustom = 0;
	prostitute = 0;
	name = "null";
	cost = 0;
	dip = 0;
	ttcyon = 0;
	Prostitute_ID = Get_Int_Parameter("ID");
	percentage = 0.0f;
	scriptopperational = 1;
	Commands->Start_Timer(obj,this,1.0f,911511200);
	originalshield = Commands->Get_Max_Shield_Strength(obj);
}

void JMG_Prostitute_Attach_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (scriptopperational == 1)
	{
		if (message == Get_Int_Parameter("ID"))
		{
			name = Get_Player_Name(sender);
			cost = param;
			prostitute = 0;
		}
		if (message == 911511200)
		{
			char messag4[1000];
			sprintf(messag4,"The Game has detected that your \"employee\" %s has bought a new character, committed suicide, or quit the game.",name);
			Send_Message_Player(obj,255,127,127,messag4);
			Send_Message_Player(obj,255,127,127,"You will now be refunded 25% of the money you gave them, and your shield will now be reset.");
			float ncost = cost * 0.25f;
			Commands->Give_Money(obj,ncost,0);
			float newpercentage = originalshield / Commands->Get_Max_Shield_Strength(obj);
			Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj)* newpercentage);
			Set_Max_Shield_Strength(obj,originalshield);
			Commands->Enable_HUD_Pokable_Indicator(obj,1);
			GameObject *object = Commands->Find_Object(Get_Int_Parameter("ID"));
			Commands->Send_Custom_Event(obj,object,211511326,1,0);
			{
				Remove_Script(obj,"JMG_Prostitute_Attach_Script");
			}
		}
		if (message == 211511323)
		{
			char messag3[1000];
			sprintf(messag3,"My \"employee\" %s has shot me.",name);
			Send_Message_Player(obj,255,127,127,messag3);
			Send_Message_Player(obj,255,127,127," This may have been an accident, but it is now up to me whether to fine and them or let them get away with it this time.");
			ttcyon = 1;
			Commands->Start_Timer(obj,this,12.0f,911511201);
		}
		if (message == 211511324 && param == Get_Int_Parameter("ID"))
		{
			scriptopperational = 0;
			float newpercentage = originalshield / Commands->Get_Max_Shield_Strength(obj);
			Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj)* newpercentage);
			Set_Max_Shield_Strength(obj,originalshield);
		}
		// yes
		if (message == 211511231 && ttcyon == 1)
		{
			GameObject *object = Commands->Find_Object(Prostitute_ID);
			char messag4[1000];
			sprintf(messag4,"I have decided to fine %s, they will now be forced to give me 25%% of their earnings and will no longer work for me.",name);
			Send_Message_Player(obj,255,127,127,messag4);
			ttcyon = 0;
			Commands->Send_Custom_Event(obj,object,211511323,1,0);
		}
		// no
		if (message == 211511230 && ttcyon == 1)
		{
			GameObject *object = Commands->Find_Object(Prostitute_ID);
			char messag4[1000];
			sprintf(messag4,"I have decided not to punish %s, I won't even mention this to them.",name);
			Send_Message_Player(object,255,127,127,messag4);
			ttcyon = 0;
		}
	}
}

void JMG_Prostitute_Attach_Script::Timer_Expired(GameObject *obj,int number)
{
	if (scriptopperational == 1)
	{
		if (number == 911511200)
		{
			prostitute += 1;
			if (prostitute == 5 && hassentcustom == 0)
			{
				hassentcustom = 1;
				Commands->Send_Custom_Event(obj,obj,911511200,1,0);
			}
			Commands->Start_Timer(obj,this,1.0f,911511200);
		}
		if (number == 911511201 && ttcyon == 1)
		{
			char messag1[1000];
			sprintf(messag1,"Should I punish %s for shooting me?",name);
			Send_Message_Player(obj,255,127,127,messag1);
			Commands->Start_Timer(obj,this,12.0f,911511201);
		}
	}
}

void JMG_Prostitute_Attach_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (scriptopperational == 1)
	{
		if (Prostitute_ID > 0)
		{
			float HP = Commands->Get_Health(obj) + Commands->Get_Shield_Strength(obj);
			int damagerid = Commands->Get_ID(damager);
			GameObject *object = Commands->Find_Object(Prostitute_ID);
			if (Prostitute_ID == damagerid)
			{
				if (damage < HP && dip == 0)
				{
					Commands->Send_Custom_Event(obj,obj,211511323,1,0);
					dip = 1;
				}
				if (damage >= HP)
				{
					Commands->Send_Custom_Event(obj,object,211511324,1,0);
				}
			}
		}
	}
}

void JMG_Prostitute_Attach_Script::Killed(GameObject *obj, GameObject *damager)
{
	if (scriptopperational == 1)
	{
		if (Prostitute_ID > 0)
		{
			GameObject *object = Commands->Find_Object(Prostitute_ID);
			Commands->Send_Custom_Event(obj,object,211511325,1,0);
			Prostitute_ID = 0;
		}
	}
}

void JMG_Sword_Script::Created(GameObject *obj)
{
	canblock = 1;
	cnumber = 1;
	playingblockanimation = 0;
	enabled = true;
	health = Commands->Get_Health(obj);
	armor = Commands->Get_Shield_Strength(obj);
	newtotal = Get_Bullets(obj,Get_Parameter("Weapon"));
	sworddamageamount = 0;
	Vector3 pos = Commands->Get_Position(obj);
	GameObject *object = Commands->Create_Object("Daves Arrow",pos);
	Commands->Attach_To_Object_Bone(object,obj,"c head");
	Commands->Set_Is_Rendered(object,false);
	Commands->Set_Is_Visible(object,false);
	ObjectID = Commands->Get_ID(object);
	Commands->Start_Timer(obj,this,0.1f,62514633);
}

void JMG_Sword_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	const char *weaponpointer = Get_Current_Weapon(obj);
	if (weaponpointer)
	{
		if ((message == 1345923) && (canblock == 1) && (Get_Bullets(obj,Get_Parameter("Weapon")) > 0) && _stricmp(weaponpointer,Get_Parameter("Weapon")))
		{
			canblock = 0;
			playingblockanimation = 1;
			health = Commands->Get_Health(obj);
			armor = Commands->Get_Shield_Strength(obj);
			Commands->Start_Timer(obj,this,20.50,45634532);
			Commands->Start_Timer(obj,this,50.00,45634531);
			Commands->Innate_Enable(obj);
			Commands->Set_Animation(obj,Get_Parameter("BlockAnimation"),false,0,0,-1,false);
		}
	}
	/*if (message == CUSTOM_EVENT_JUMP_COMPLETE)
	{
		Commands->Innate_Enable(obj);
		Commands->Set_Animation(obj,"null.null",false,0,0,-1,false);
		Commands->Innate_Disable(obj);
		canblock = 1;
		enabled = true;
		char messag[1000];
		sprintf(messag,"ppage %d %s",Get_Player_ID(obj),"I jumped");
		Console_Input(messag);
	}*/
	if (message == 24531258)
	{
		if ((cnumber == 1) && (enabled))
		{
			Commands->Innate_Enable(obj);
			Commands->Set_Animation(obj,Get_Parameter("Animation"),false,0,0,-1,false);
			Commands->Start_Timer(obj,this,Get_Float_Parameter("ResetSwingComboTime"),453654);
			cnumber = 2;
			enabled = false;
		}
		if ((cnumber == 2) && (enabled))
		{
			Commands->Innate_Enable(obj);
			Commands->Set_Animation(obj,Get_Parameter("Animation2"),false,0,0,-1,false);
			cnumber = 3;
			enabled = false;
		}
		if ((cnumber == 3) && (enabled))
		{
			Commands->Innate_Enable(obj);
			Commands->Set_Animation(obj,Get_Parameter("Animation3"),false,0,0,-1,false);
			cnumber = 1;
			enabled = false;
		}
	}
}

void JMG_Sword_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 45634531)
	{
		canblock = 1;
	}
	if (number == 45634532)
	{
		playingblockanimation = 0;
		Commands->Innate_Disable(obj);
		if (Get_Int_Parameter("Reset_Sword_Health_Once_Done_Blocking") == 1)
		{
			sworddamageamount = 0;
		}
	}
	if (number == 453654)
	{
		cnumber = 1;
	}
	if (62514633 == number)
	{
		if (Get_Bullets(obj,Get_Parameter("Weapon")) > newtotal)
		{
			newtotal = Get_Bullets(obj,Get_Parameter("Weapon"));
		}
		if (Get_Bullets(obj,Get_Parameter("Weapon")) < newtotal)
		{
			newtotal = Get_Bullets(obj,Get_Parameter("Weapon"));
			Commands->Send_Custom_Event(obj,obj,24531258,1,0);
		}
		Commands->Start_Timer(obj,this,0.1f,62514633);
	}
}

void JMG_Sword_Script::Animation_Complete(GameObject *obj,const char *anim)
{
	if (playingblockanimation == 0)
	{
		Commands->Innate_Disable(obj);
		enabled = true;
	}
	if (playingblockanimation == 1)
	{
		Commands->Set_Animation(obj,Get_Parameter("BlockAnimation"),false,0,0,-1,false);
	}
}

void JMG_Sword_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (playingblockanimation == 1)
	{	
		Commands->Set_Health(obj,health);
		Commands->Set_Shield_Strength(obj,armor);
		GameObject *object = Commands->Find_Object(ObjectID);
		Vector3 sound = Commands->Get_Position(object);
		Commands->Create_Sound("Sword_Block_Sound",sound,object);
		if (Has_Weapon(damager,Get_Parameter("NoDamageWeapon1")) == 1 || Has_Weapon(damager,Get_Parameter("NoDamageWeapon2")) == 1)
		{
			if ((_stricmp(Get_Current_Weapon(damager),Get_Parameter("NoDamageWeapon1"))) && (_stricmp(Get_Current_Weapon(damager),Get_Parameter("NoDamageWeapon2"))))
			{		
				sworddamageamount += damage;
			}
		}
		if (sworddamageamount >= Get_Float_Parameter("Sword_Health"))
		{
			Send_Message_Player(obj,127,0,0,"My sword was destroyed by taking too much damage!");
			Set_Clip_Bullets(obj,Get_Parameter("Weapon"),0);
			Set_Bullets(obj,Get_Parameter("Weapon"),0);
			Commands->Create_Sound("Sword_Break_Sound",sound,object);
			playingblockanimation = 0;
			if (0 != Get_Parameter("SwordBrokePowerup"))
			{
				Commands->Give_PowerUp(obj,Get_Parameter("SwordBrokePowerup"),false);
			}
		}

	}
}

void JMG_Sword_Script::Killed(GameObject *obj,GameObject *damager)
{
	GameObject *object = Commands->Find_Object(ObjectID);
	Commands->Apply_Damage(object,9999999.00f,"blamokiller",0);
	ObjectID = 0;
}

void JMG_Dual_P90_Script::Created(GameObject *obj)
{
	count = 0;
	Nnewtotal = Get_Bullets(obj,"Weapon_P90_New");
	Nclipbullets = Get_Clip_Bullets(obj,"Weapon_P90_New");
	isdoingthing = 0;
	Commands->Start_Timer(obj,this,0.01f,24534521);
	Commands->Start_Timer(obj,this,0.1f,456431);
	modelnum = 1;
}

void JMG_Dual_P90_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 4523121)
	{
		if (count < 2)
		{
			count += 1;
		}
		if ((count == 2) && (Get_Bullets(obj,"Weapon_P90_New") > 2))
		{
			count = 0;
			Commands->Start_Timer(obj,this,0.25f,54312);
			Set_Clip_Bullets(obj,"Weapon_P90_New",0);
			Set_Bullets(obj,"Weapon_P90_New",0);
			isdoingthing = 1;
		}
		resetcountcount = 0;
	}
	if (message == 23453453)
	{
		count = 0;
	}
}

void JMG_Dual_P90_Script::Timer_Expired(GameObject *obj,int number)
{
	if (24534521 == number)
	{
		if ((Get_Bullets(obj,"Weapon_P90_New") > Nnewtotal) && (isdoingthing == 0))
		{
			Nnewtotal = Get_Bullets(obj,"Weapon_P90_New");
			Nclipbullets = Get_Clip_Bullets(obj,"Weapon_P90_New");
		}
		if ((Get_Bullets(obj,"Weapon_P90_New") < Nnewtotal) && (isdoingthing == 0))
		{
			Nnewtotal = Get_Bullets(obj,"Weapon_P90_New");
			Nclipbullets = Get_Clip_Bullets(obj,"Weapon_P90_New");
			Commands->Send_Custom_Event(obj,obj,4523121,1,0);
		}
		Commands->Start_Timer(obj,this,0.01f,24534521);
	}
	if (54312 == number)
	{
			Set_Clip_Bullets(obj,"Weapon_P90_New",Nclipbullets);
			Set_Bullets(obj,"Weapon_P90_New",Nnewtotal);
			isdoingthing = 0;
	}
	if (456431 == number)
	{
		if (count > 0)
		{
			if (resetcountcount < 5)
			{
				resetcountcount += 1;
			}
			if (resetcountcount == 5)
			{	
				resetcountcount = 0;
				Commands->Send_Custom_Event(obj,obj,23453453,1,0);
			}
		}
		Commands->Start_Timer(obj,this,0.1f,456431);
	}
}

void JMG_RP2_Dual_Wield_Script::Created(GameObject *obj)
{
	originalmodel = "NodMG";
	Commands->Start_Timer(obj,this,0.1f,5453912); 
}

void JMG_RP2_Dual_Wield_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 5453912)
	{
		char newmodel[512];
		sprintf(newmodel,"%s_p", originalmodel);
		const char *weaponpointer = Get_Current_Weapon(obj);
		if (weaponpointer)
		{
			if ((_stricmp(Get_Model(obj),newmodel)) && (!_stricmp(weaponpointer,"Weapon_P90_New")))
			{
				Commands->Set_Model(obj,newmodel);
			}
			if ((_stricmp(Get_Model(obj),originalmodel)) && (_stricmp(weaponpointer,"Weapon_P90_New")))
			{
				Commands->Set_Model(obj,originalmodel);
			}
		}
	Commands->Start_Timer(obj,this,0.1f,5453912); 
	}
}

void JMG_Swimming_Script::Created(GameObject *obj)// Beings it is finally stable, time for some massive revisions! 9/4/09
{
	isswimming = 0;
	mymodel = Get_Model(obj);
	enabled = 1;
	allowemptyhands = 0;
	if (Has_Weapon(obj,Get_Parameter("Empty_Hands_Weapon")) == 0)
	{
		Commands->Give_PowerUp(obj,Get_Parameter("Swimming_Weapon_Powerup"),1);
	}
	if (Has_Weapon(obj,Get_Parameter("Empty_Hands_Weapon")) == 0)
	{
		char message[2000];
		sprintf(message,"CRITICAL ERROR: Empty hands powerup did not grant the empty hands weapon, swimming script has been removed from %s!",Commands->Get_Preset_Name(obj));
		Send_Message_Player(obj,255,0,0,message);
		Remove_Script(obj,"JMG_Swimming_Script");
	}
	lastpos = Commands->Get_Position(obj);
	speed = 0.0f;
	scubamax = Get_Int_Parameter("Starting_Scuba_Tank_Air_Ammount");
	scubacurrent = 0;
	if (scubamax > 0)
	{
		char text[2000];
		sprintf(text,"I currently have a scuba tank which holds %d seconds of air.",scubamax);
		Send_Message_Player(obj,0,127,255,text);
	}
	ScubaSoundID = 0;
	underwater = 0;
	allowupgrade = 0;
	for (int x = 0;x < 10;x++)
	{
		uniquetankcheck[x] = 0;
	}
	Vector3 pos;
	char params[20];
	sprintf(params,"%d",Commands->Get_ID(obj));
	GameObject *object = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
	Commands->Set_Model(object,Get_Parameter("Swimming_Height_Adjust_Model"));
	Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
	Commands->Attach_To_Object_Bone(object,obj,"nabone");
	sprintf(HeightAdjustAnimation,"%s.%s",Get_Model(object),Get_Model(object));
	HeightAdjustID = Commands->Get_ID(object);
	drowntime = Get_Int_Parameter("Drown_Time");
	Reset_Screen(obj);
	IsHeadSubmerged = 0;
	CDT = 0;
	EnableEEnter = 1;
	canswim = Get_Int_Parameter("Can_Swim");
	EffectControlID = 0;
	submergetime = 0.15f;
	High_Jump_Stopper = 0;
	Commands->Start_Timer(obj,this,0.1f,5432156);
	Commands->Start_Timer(obj,this,1.0f,5432158);
	Commands->Start_Timer(obj,this,0.1f,5432152);
	Commands->Start_Timer(obj,this,3.0f,5432161);
}

void JMG_Swimming_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message >= 5432156 && message <= 5432172)
	{
		if (message == 5432156 || message == 5432157)
		{
			Air_Control(obj,param,message,sender);
		}
		if (message >= 5432158 && message <= 5432162)
		{
			Scuba_Tank_Upgrade_Tracker(obj,param,message);
		}
		if (message == 5432166)// Talk to height adjuster
		{
			Commands->Send_Custom_Event(obj,obj,345347,HeightAdjustID,0);
		}
		if (message == 5432168)
		{
			CDT = param;
		}
		if (message == 5432169)
		{
			scubacurrent = param;
			underwater = 0;
			if (ScubaSoundID > 0)
			{
				Remove_Scuba_Tank_Sound();
			}
			Reset_Screen(obj);
		}	
		if (message == 5432170)
		{
			canswim = param;
		}
		if (message == 5432171)
		{
			EffectControlID = param;
		}
		if (message == 5432172)
		{
			Incorrect_Model_Glitch_Test(obj,sender);
		}
	}
	else
	{
		if (message == 345345 || message == 345346)
		{
			Special_Water_Effects_Control(obj,message);
		}
		if (message == 347361)
		{
			Enter_Water_Human(obj,sender);
		}
		if (message == 347360)
		{
			Exit_Water_Human(obj);
		}
		if (message == 90000028)
		{
			Exit_Water_Into_Vehicle(obj);
		}
		if (message == 90000029)
		{
			Exit_Vehicle_Into_Water(obj);
		}
	}
	
}

void JMG_Swimming_Script::Timer_Expired(GameObject *obj,int number)
{
	// Makes sure that it doesn't waist time checking for timers that arn't part of the script
	if (number >= 5432152 && number <= 5432166) 
	{
		if (Commands->Get_Health(obj) > 0)
		{
			if (number == 5432152)
			{
				In_Water(obj);
				Commands->Start_Timer(obj,this,0.1f,5432152);
			}
			if (number == 5432153)
			{
				High_Jump_Stopper = 0;
			}
			if (number == 5432154 && isswimming == 0)
			{
				Commands->Destroy_Object(Commands->Find_Object(ObjectID));
				ObjectID = 0;
				Commands->Set_Model(obj,mymodel);
			}
			// Moved to avoid duplicate call
			if (number == 5432155)
			{
				Create_Swimmer(obj);
			}
			if (number == 5432156)
			{
				Create_Scuba_Tank_Refil_Sound(obj);
				Commands->Start_Timer(obj,this,0.2f,5432156);
			}
			if (number == 5432157)
			{
				Double_Check_Swimming(obj);
			}
			if (number == 5432158)
			{
				Height_Adjuster_Control(obj);
				Commands->Start_Timer(obj,this,1.0f,5432158);
			}
			if (number == 5432161)
			{
				Retrive_Model_Glitch_Check(obj);
			}	
			if (number == 5432162)
			{		
				Key_Press_Swimming_Restart(obj);
			}
			if (number == 5432163)
			{
				Commands->Destroy_Object(Commands->Find_Object(ObjectID));
				ObjectID = 0;
				Commands->Set_Model(obj,mymodel);
			}
			// Keep Level With water surface
			if (number == 5432164)
			{
				GameObject *object = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),Commands->Get_Position(obj));
				Commands->Attach_To_Object_Bone(obj,object,"origin");
				Commands->Destroy_Object(object);
				allowemptyhands = 0;
				GameObject *Heightadjuster = Commands->Find_Object(HeightAdjustID);
				Commands->Set_Animation(Heightadjuster,HeightAdjustAnimation,true,0,0,0,0);
				if (Has_Weapon(obj,myweapon))
				{
					Commands->Select_Weapon(obj,myweapon);
				}
				else
				{
					Commands->Select_Weapon(obj,Get_Parameter("Empty_Hands_Weapon"));
				}
			}
			if (number == 5432165 && EnableEEnter == 0)
			{
				EnableEEnter = 1;
			}
		}
	}
}

void JMG_Swimming_Script::Killed(GameObject *obj,GameObject *damager)
{
	if (ObjectID > 0)
	{
		Commands->Destroy_Object(Commands->Find_Object(HeadID));
		ObjectID = 0;
	}
	if (ScubaSoundID > 0)
	{
		Remove_Scuba_Tank_Sound();
	}
	if (HeadID > 0)
	{
		Commands->Send_Custom_Event(obj,Commands->Find_Object(HeadID),5347362,1,0);
		HeadID = 0;
	}
	if (HeightAdjustID > 0)
	{
		Commands->Destroy_Object(Commands->Find_Object(HeightAdjustID));
		HeightAdjustID = 0;
	}
	Commands->Set_Model(obj,mymodel);
}

void JMG_Swimming_Script::High_Jump_Stop(GameObject *obj)
{
	if (isswimming == 0 && High_Jump_Stopper <= 1)
	{
		High_Jump_Stopper = 2;
		Vector3 pos = Commands->Get_Position(obj);
		GameObject *object = Commands->Create_Object("Daves Arrow",pos);
		Commands->Set_Model(object,"null");
		Commands->Attach_To_Object_Bone(obj,object,"origin");
		Commands->Destroy_Object(object);
		allowemptyhands = 0;
		GameObject *Heightadjuster = Commands->Find_Object(HeightAdjustID);
		Commands->Set_Animation(Heightadjuster,HeightAdjustAnimation,true,0,0,0,0);
		if (Has_Weapon(obj,myweapon))
		{
			Commands->Select_Weapon(obj,myweapon);
		}
		else
		{
			Commands->Select_Weapon(obj,Get_Parameter("Empty_Hands_Weapon"));
		}
		if (LastWaterZone.Z + 2.0f < Commands->Get_Position(obj).Z)
		{
			LastWaterZone.Z += 1.0f;
			Commands->Set_Position(obj,LastWaterZone);
		}
		Commands->Start_Timer(obj,this,0.2f,5432153);
	}
}

void JMG_Swimming_Script::Remove_Scuba_Tank_Sound()
{
	GameObject *scubatank = Commands->Find_Object(ScubaSoundID);
	Vector3 pos;
	pos.X = 0.00f;
	pos.Y = 0.00f;
	pos.Z = 10000.00f;
	GameObject *moveobject = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
	Commands->Attach_To_Object_Bone(scubatank,moveobject,"origin");
	Commands->Attach_Script(scubatank,"JMG_Remove_Object_When_Timer_Expired","1.0");
	Commands->Attach_Script(moveobject,"JMG_Remove_Object_When_Timer_Expired","1.0");
	ScubaSoundID = 0;
}

void JMG_Swimming_Script::Create_Swimmer(GameObject *obj)
{
	char params[25];
	sprintf(params,"%d",Commands->Get_ID(obj));
	Vector3 pos = Commands->Get_Position(obj);
	if (HeadID == 0 && enabled == 1 && isswimming > 0)
	{
		Retrive_Model_Glitch_Check(obj);
		if (canswim == 1)
		{
			const char *tmyweapon = Get_Current_Weapon(obj);
			if (tmyweapon)
			{
				myweapon = tmyweapon;
			}
			allowemptyhands = 1;
			Commands->Destroy_Object(Commands->Find_Object(ObjectID));
			ObjectID = 0;
			// Fake Object Settings
			GameObject *object = Commands->Create_Object("Daves Arrow",pos);
			Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
			Commands->Attach_To_Object_Bone(object,Commands->Find_Object(HeightAdjustID),"HeightAdjust");
			Commands->Disable_Physical_Collisions(object);
			ObjectID = Commands->Get_ID(object);
			if (_stricmp(Get_Parameter("Swimming_Model_Override"),"null"))
			{
				Commands->Set_Model(object,Get_Parameter("Swimming_Model_Override"));
			}
			else
			{
				Commands->Set_Model(object,mymodel);
			}
			// Head
			GameObject *head = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
			Commands->Attach_To_Object_Bone(head,Commands->Find_Object(HeightAdjustID),"c Pelvis");	
			HeadID = Commands->Get_ID(head);
			Commands->Attach_Script(head,"JMG_Remove_Object_When_Creator_Destroyed",params);
			char paramshead[256];
			sprintf(paramshead,"%d,%d,%d,%d,%d,%d,%d,%s,%s,%s,%s,%s",ObjectID,Commands->Get_ID(obj),drowntime,lastwaterzone,scubacurrent,scubamax,CDT,Get_Parameter("Breath_Sound"),Get_Parameter("Urgent_Breath_Sound"),Get_Parameter("Scuba_Breath_Sound"),Get_Parameter("Heart_Beat_Loop_Sound"),Get_Parameter("Invisible_Box_Object"));
			Commands->Attach_Script(head,"JMG_Swimming_Head_Attach_Script",paramshead);
			Set_Max_Shield_Strength(object,Commands->Get_Max_Shield_Strength(obj));
			Set_Max_Health(object,Commands->Get_Max_Health(obj));
			Commands->Set_Shield_Strength(object,Commands->Get_Shield_Strength(obj));
			Commands->Set_Health(object,Commands->Get_Health(obj));
			Set_Skin(object,Get_Skin(obj));
			Commands->Set_Shield_Type(object,Get_Shield_Type(obj));
			Commands->Set_Player_Type(object,Commands->Get_Player_Type(obj));
			// attach script to swimming model
			char params2[512];		
			sprintf(params2,"%d,%d,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s",Commands->Get_ID(obj),Commands->Get_ID(head),Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Not_Moving"),Get_Parameter("Forward"),Get_Parameter("Backward"),Get_Parameter("Turn_Left"),Get_Parameter("Turn_Right"),Get_Parameter("Up"),Get_Parameter("Down"),Get_Parameter("Tilt_Up"),Get_Parameter("Tilt_Down"),Get_Parameter("Tilt_Up_Backward"),Get_Parameter("Tilt_Down_Backward"),Get_Parameter("Swim_Left"),Get_Parameter("Swim_Left_Tilt_Up"),Get_Parameter("Swim_Left_Tilt_Down"),Get_Parameter("Swim_Right"),Get_Parameter("Swim_Right_Tilt_Up"),Get_Parameter("Swim_Right_Tilt_Down"),Get_Parameter("Not_Moving_Surface"),Get_Parameter("Forward_Surface"),Get_Parameter("Backward_Surface"),Get_Parameter("Turn_Left_Surface"),Get_Parameter("Turn_Right_Surface"),Get_Parameter("Water_Jump"));
			Commands->Attach_Script(object,"JMG_Swimming_Attach_Script",params2);
			Commands->Send_Custom_Event(obj,Commands->Find_Object(lastwaterzone),53133150,ObjectID,0);
			if (EffectControlID == 0)
			{
				Commands->Send_Custom_Event(obj,Commands->Find_Object(lastwaterzone),53133156,Commands->Get_ID(obj),0);
			}
			Commands->Set_Model(obj,"infnc");
		}
		else
		{
			// Head
			GameObject *head = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
			Commands->Attach_To_Object_Bone(head,Commands->Find_Object(HeightAdjustID),"c Pelvis");	
			HeadID = Commands->Get_ID(head);
			Commands->Attach_Script(head,"JMG_Remove_Object_When_Creator_Destroyed",params);
			char paramshead[256];
			sprintf(paramshead,"%d,%d,%d,%d,%d,%d,%d,%s,%s,%s,%s,%s",ObjectID,Commands->Get_ID(obj),drowntime,lastwaterzone,scubacurrent,scubamax,CDT,Get_Parameter("Breath_Sound"),Get_Parameter("Urgent_Breath_Sound"),Get_Parameter("Scuba_Breath_Sound"),Get_Parameter("Heart_Beat_Loop_Sound"),Get_Parameter("Invisible_Box_Object"));
			Commands->Attach_Script(head,"JMG_Swimming_Head_Attach_Script",paramshead);
			if (EffectControlID == 0)
			{
				Commands->Send_Custom_Event(obj,Commands->Find_Object(lastwaterzone),53133156,Commands->Get_ID(obj),0);
			}
		}
	}
}

void JMG_Swimming_Script::Scuba_Tank_Upgrade_Tracker(GameObject *obj,int param,int message)
{
	if (message == 5432158)
	{
		allowupgrade = 0;
		for (int x = 0,end = 0;x < 10 && end == 0;x++)
		{
			if (uniquetankcheck[x] == param)
			{
				end = 1;
			}
			if (uniquetankcheck[x] == 0)
			{
				end = 1;
				uniquetankcheck[x] = param;
				allowupgrade = 1;
			}
		}
		if (allowupgrade == 0)
		{
			Send_Message_Player(obj,0,127,255,"I already have that upgrade for my scuba tank.");
		}
	}
	if (message == 5432159 && allowupgrade == 1)
	{
		char text[2000];
		scubamax += param;
		allowupgrade = 0;
		if (scubamax == 0)
		{
			sprintf(text,"I have found a scuba tank. It looks like it can hold %d seconds of air.",scubamax);
		}
		else
		{
			sprintf(text,"I have found an upgrade from my scuba tank and it can now hold %d seconds worth of air.",scubamax);
		}
		Send_Message_Player(obj,0,127,255,text);
	}
	if (message == 5432160)
	{
		scubamax = param;
		for (int x = 0;x < 10;x++)
		{
			uniquetankcheck[x] = 0;
		}
		char text[2000];
		sprintf(text,"I have acquired a basic scuba tank which holds %d seconds of air.",scubamax);
		Send_Message_Player(obj,0,127,255,text);
	}
	if (message == 5432161)
	{
		char text[2000];
		scubamax += param;
		if (scubamax == 0)
		{
			sprintf(text,"I have found a scuba tank. It looks like it can hold %d seconds of air.",scubamax);
		}
		else
		{
			sprintf(text,"I have bought an upgrade for my scuba tank, it can now hold %d seconds of air.",scubamax);
		}
		Send_Message_Player(obj,0,127,255,text);
	}
	if (message == 5432162)
	{
		scubamax = 0;
		scubacurrent = 0;
		int x;
		for (x = 0;x < 10;x++)
		{
			uniquetankcheck[x] = 0;
		}
	}
}

void JMG_Swimming_Script::Exit_Water_Human(GameObject *obj)
{
	isswimming--;
	if (isswimming <= 0 && enabled == 1)
	{
		CDT = 0;
		underwater = 0;
		isswimming = 0;
		Commands->Destroy_Object(Commands->Find_Object(HeadID));
		HeadID = 0;
		if (Get_Fly_Mode(obj) == 1)
		{
			Toggle_Fly_Mode(obj);
		}
		if (EffectControlID > 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(EffectControlID));
			EffectControlID = 0;
		}
		if (submergetime < 0.15 && submergetime > 0.01f)
		{
			submergetime = 0.25;
		}
		else if (submergetime < 0.15f)
		{
			submergetime = 0.01f;
		}
		High_Jump_Stopper = 1;
		High_Jump_Stop(obj);
		Reset_Screen(obj);
		Commands->Start_Timer(obj,this,0.15f,5432154);
		Commands->Send_Custom_Event(obj,obj,345344,1,0);
	}
}

void JMG_Swimming_Script::Exit_Water_Into_Vehicle(GameObject *obj)
{
	enabled = 0;
	if (isswimming > 0)
	{
		CDT = 0;
		underwater = 0;
		if (Get_Fly_Mode(obj) == 1)
		{
			Toggle_Fly_Mode(obj);
		}
		if (EffectControlID > 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(EffectControlID));
			EffectControlID = 0;
		}
		Commands->Destroy_Object(Commands->Find_Object(HeadID));
		HeadID = 0;
		High_Jump_Stopper = 0;
		High_Jump_Stop(obj);
		Commands->Send_Custom_Event(obj,obj,345344,1,0);
	}
}

void JMG_Swimming_Script::Exit_Vehicle_Into_Water(GameObject *obj)
{
	enabled = 1;
	if (isswimming > 0)
	{
		Commands->Destroy_Object(Commands->Find_Object(HeadID));
		HeadID = 0;
		CDT = 0;
		if (EnableEEnter ==	1)
		{
			EnableEEnter = 0;
			Commands->Start_Timer(obj,this,1.0f,5432165);
		}
		Commands->Start_Timer(obj,this,0.05f,5432155);
		Commands->Start_Timer(obj,this,0.15f,5432157);
	}
}

void JMG_Swimming_Script::Enter_Water_Human(GameObject *obj,GameObject *sender)
{
	isswimming++;
	if (isswimming == 1)
	{
		lastwaterzone = Commands->Get_ID(sender);
		EnterZoneHeight = Commands->Get_Position(obj).Z;
		IsHeadSubmerged = 0;
		CDT = 0;
		if (EnableEEnter ==	1)
		{
			EnableEEnter = 0;
			Commands->Start_Timer(obj,this,1.0f,5432165);
		}
	}
	if (isswimming == 1 && enabled == 1)
	{
		underwater = 0;
		float speed2 = speed;
		if (speed2 < 1.0f)
		{
			Commands->Send_Custom_Event(obj,sender,53133151,1,0);
		}
		else if (speed2 < 6.0f)
		{
			Commands->Send_Custom_Event(obj,sender,53133152,1,0);
		}
		else if (speed2 < 10.0f)
		{
			Commands->Send_Custom_Event(obj,sender,53133153,1,0);
		}
		else
		{
			Commands->Send_Custom_Event(obj,sender,53133154,1,0);
		}
		Commands->Destroy_Object(Commands->Find_Object(HeadID));
		HeadID = 0;
		if (EnableEEnter ==	1)
		{
			EnableEEnter = 0;
			Commands->Start_Timer(obj,this,1.0f,5432165);
		}
		Create_Swimmer(obj);
		Commands->Start_Timer(obj,this,submergetime,5432157);
	}
	else if (isswimming == 1)
	{
		lastwaterzone = Commands->Get_ID(sender);
		EnterZoneHeight = Commands->Get_Position(obj).Z;
		IsHeadSubmerged = 0;
		if (EnableEEnter ==	1)
		{
			EnableEEnter = 0;
			Commands->Start_Timer(obj,this,1.0f,5432165);
		}
	}
}

void JMG_Swimming_Script::Incorrect_Model_Glitch_Test(GameObject *obj,GameObject *sender)
{
	if (!_stricmp(mymodel,"infnc"))
	{
		Send_Message_Player(obj,255,0,0,"ERROR: Due to a glitch with Get_Model, your model data was lost, you have been reset to the default model to prevent a server crash. Sorry for the inconvenience.");
		mymodel = Get_Parameter("Default_Model_Override");
		Commands->Set_Model(sender,mymodel);
	}
	else
	{
		Commands->Set_Model(sender,mymodel);
	}
}

void JMG_Swimming_Script::Air_Control(GameObject *obj,int param,int message,GameObject *sender)
{
	if (message == 5432156)
	{
		drowntime = param;
	}
	if (message == 5432157)
	{
		underwater = 1;
		Commands->Send_Custom_Event(obj,sender,5347361,scubacurrent,0);
	}
}

void JMG_Swimming_Script::Reset_Screen(GameObject *obj)
{
	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Level_Default_Fog_Controller_ID")),987123546,1,0);
}

void JMG_Swimming_Script::In_Water(GameObject *obj)
{
	speed = lastpos.Z - Commands->Get_Position(obj).Z;
	speed = abs(speed);
	lastpos = Commands->Get_Position(obj);
	if (submergetime < 0.15f)
	{
		submergetime += 0.01f;
	}
	if (isswimming >= 1)
	{
		if (enabled == 1 && allowemptyhands == 1)
		{
			Commands->Select_Weapon(obj,"");
			Commands->Select_Weapon(obj,Get_Parameter("Empty_Hands_Weapon"));
		}
		LastWaterZone = lastpos;
	}
}

void JMG_Swimming_Script::Double_Check_Swimming(GameObject *obj)
{
	if (Get_Fly_Mode(obj) == 0 && isswimming > 0 && enabled == 1)
	{
		if (canswim == 1)
		{
			Commands->Set_Animation(obj,"s_a_human.infncanim",true,0,0,-1,false);
			Toggle_Fly_Mode(obj);
		}
		if (ObjectID == 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(HeadID));
			HeadID = 0;
			Commands->Start_Timer(obj,this,0.1f,5432155);
		}
	}
}

void JMG_Swimming_Script::Retrive_Model_Glitch_Check(GameObject *obj)
{
	if (isswimming == 0 && _stricmp(mymodel,Get_Model(obj)))
	{
		mymodel = Get_Model(obj);
		if (!_stricmp(mymodel,"infnc") ||  _stricmp(mymodel,Get_Model(obj)))
		{
			Send_Message_Player(obj,255,0,0,"Due to a glitch with Get_Model, your model data was lost, you have been reset to the default model to prevent a server crash. Sorry for the inconvenience.");
			mymodel = Get_Parameter("Default_Model_Override");
		}
	}
}

void JMG_Swimming_Script::Special_Water_Effects_Control(GameObject *obj,int message)
{
	if (message == 345345)
	{
		IsHeadSubmerged = 0;			
		Reset_Screen(obj);
		Commands->Send_Custom_Event(obj,Commands->Find_Object(EffectControlID),8474460,0,0);
	}
	if (message == 345346)
	{
		IsHeadSubmerged = 1;
		Commands->Send_Custom_Event(obj,Commands->Find_Object(EffectControlID),8474461,0,0);
	}
}

void JMG_Swimming_Script::Key_Press_Swimming_Restart(GameObject* obj)
{
	if (isswimming > 0 && Get_Fly_Mode(obj) == 0 && enabled == 1)
	{
		Reset_Screen(obj);
		if ((CDT + 20) < (drowntime * 10))
		{
			CDT += 20;
		}
		else
		{
			CDT = 1 - (drowntime * 10);
		}
		Commands->Destroy_Object(Commands->Find_Object(HeadID));
		HeadID = 0;
		Commands->Start_Timer(obj,this,0.05f,5432155);
		Commands->Start_Timer(obj,this,0.15f,5432157);
	}
}

void JMG_Swimming_Script::Height_Adjuster_Control(GameObject *obj)
{
	GameObject *Heightadjuster = Commands->Find_Object(HeightAdjustID);
	if (IsHeadSubmerged == 0 && isswimming >= 1)
	{
		float distancefromsurface = Commands->Get_Position(obj).Z - EnterZoneHeight;
		distancefromsurface = 100.0f * abs(distancefromsurface);
		Commands->Set_Animation(Heightadjuster,HeightAdjustAnimation,true,0,Get_Animation_Frame(Heightadjuster),distancefromsurface,0);
	}
	else if (IsHeadSubmerged == 1 && isswimming >= 1)
	{
		Commands->Set_Animation(Heightadjuster,HeightAdjustAnimation,true,0,Get_Animation_Frame(Heightadjuster),0,0);
	}
}

void JMG_Swimming_Script::Create_Scuba_Tank_Refil_Sound(GameObject *obj)
{
	if (scubacurrent < scubamax && underwater == 0)
	{
		scubacurrent++;
		if (scubacurrent < scubamax && ScubaSoundID == 0)
		{
			Vector3 pos;
			char params[20];
			sprintf(params,"%d",Commands->Get_ID(obj));
			GameObject *tankrefill = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
			Commands->Attach_To_Object_Bone(tankrefill,obj,"c head");	
			ScubaSoundID = Commands->Get_ID(tankrefill);
			Commands->Attach_Script(tankrefill,"JMG_Move_And_Then_Remove_When_Creator_Removed",params);
			char params2[256];
			sprintf(params2,"%s,origin",Get_Parameter("Scuba_Refill_Sound"));
			Commands->Attach_Script(tankrefill,"RMV_Engine_Sound",params2);
		}
		if (scubacurrent == scubamax && ScubaSoundID > 0)
		{
			Remove_Scuba_Tank_Sound();
		}
	}
	if ((scubacurrent >= scubamax && ScubaSoundID > 0) || (underwater == 1 && ScubaSoundID > 0))
	{
		Remove_Scuba_Tank_Sound();
		scubacurrent = scubamax;
	}
}

void JMG_Swimable_Water_Zone::Entered(GameObject *obj,GameObject *enter)
{
	Commands->Send_Custom_Event(obj,enter,347361,1,0);
}

void JMG_Swimable_Water_Zone::Exited(GameObject *obj,GameObject *exit)
{
	Commands->Send_Custom_Event(obj,exit,347360,1,0);
}

void JMG_Swimable_Water_Zone::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message >= 53133148 && message <= 53133156)
	{
		if (message == 53133148 && Commands->Get_Health(sender) > 0)
		{
			Commands->Send_Custom_Event(obj,sender,53133140,Get_Int_Parameter("ScreenRed"),0);
			Commands->Send_Custom_Event(obj,sender,53133141,Get_Int_Parameter("ScreenGreen"),0);
			Commands->Send_Custom_Event(obj,sender,53133142,Get_Int_Parameter("ScreenBlue"),0);
			Commands->Send_Custom_Event(obj,sender,53133143,Get_Int_Parameter("AddRedAmount"),0);
			Commands->Send_Custom_Event(obj,sender,53133144,Get_Int_Parameter("AddGreenAmount"),0);
			Commands->Send_Custom_Event(obj,sender,53133145,Get_Int_Parameter("AddBlueAmount"),0);
			Commands->Send_Custom_Event(obj,sender,53133146,Get_Int_Parameter("WaterMurkyness"),0);
			Commands->Send_Custom_Event(obj,sender,53133147,Get_Int_Parameter("WaterColorThickness"),0);
		}
		if (message == 53133150 && Commands->Get_Health(sender) > 0) 
		{
			char params[256];
			sprintf(params,"%d,%s,%s,%s,%s,%s",param,Get_Parameter("Underwater_Effect_Controller"),Get_Parameter("Surface_Water_Effect"),Get_Parameter("Underwater_Effect"),Get_Parameter("Surface_Swim_Sound"),Get_Parameter("Underwater_Swim_Sound"));
			Attach_Script_Once(sender,"JMG_Swimming_Water_Effects_Script",params);
		}
		if (message == 53133151 && Commands->Get_Health(sender) > 0) 
		{
			Commands->Create_Explosion(Get_Parameter("Small_Splash"),Commands->Get_Position(sender),0);
		}
		if (message == 53133152 && Commands->Get_Health(sender) > 0) 
		{
			Commands->Create_Explosion(Get_Parameter("Medium_Splash"),Commands->Get_Position(sender),0);
		}
		if (message == 53133153 && Commands->Get_Health(sender) > 0)
		{
			Commands->Create_Explosion(Get_Parameter("Large_Splash"),Commands->Get_Position(sender),0);
		}
		if (message == 53133154 && Commands->Get_Health(sender) > 0)
		{
			Commands->Create_Explosion(Get_Parameter("Huge_Splash"),Commands->Get_Position(sender),0);
		}
		if (message == 53133155 && Commands->Get_Health(sender) > 0)
		{
			Set_Fog_Range_Player(sender,(Get_Int_Parameter("WaterMurkyness")/1000.0f),(Get_Int_Parameter("WaterMurkyness")/10.0f),0);
			Set_Screen_Fade_Color_Player(sender,(Get_Int_Parameter("ScreenRed")/100.0f),(Get_Int_Parameter("ScreenGreen")/100.0f),Get_Int_Parameter("ScreenBlue")/100.0f,0);
			Set_Screen_Fade_Opacity_Player(sender,(Get_Int_Parameter("WaterColorThickness")/100.0f),0);
		}/*
		if (message == 53133156 && Commands->Get_Health(sender) > 0 && Get_Int_Parameter("Underwater_Plants_Enabled") == 2) 
		{				
			Send_Message_Player(sender,255,255,255,"Created");
			char params[2000];
			sprintf(params,"%d",param);
			GameObject *object = Commands->Create_Object(Get_Parameter("Underwater_Plant_Placer"),Commands->Get_Position(sender));
			Commands->Attach_To_Object_Bone(object,sender,"origin");
			Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
			sprintf(params,"%s,%f",Get_Parameter("Underwater_Plant_Emitter"),Get_Float_Parameter("Plant_Start_Depth"));
			Commands->Attach_Script(object,"JMG_Swimming_Under_Water_Effects_Control",params);
			Commands->Send_Custom_Event(obj,sender,5432171,Commands->Get_ID(object),0);
			Underwater_Plant_Placer=JMG_Plant_Deapth_Generator:string,Plant_Start_Depth=10.00:float,Underwater_Plant_Emitter=uwplantemtr:string,
		}*/
	}
}

void JMG_Swimming_Attach_Script::Created(GameObject *obj)
{
	pos = Commands->Get_Position(obj);
	forward = 0;
	backward = 0;
	StandingStill = 1;
	ASFBTRLUD = 110000000;
	OldCodeDIR = 110000000;
	oldfacing = Commands->Get_Facing(obj);
	truningleft = 0;
	truningright = 0;
	up = 0;
	down = 0;
	underwater = 0;
	enabled = 1;
	Commands->Start_Timer(obj,this,0.5f,1456234);
	Commands->Start_Timer(obj,this,0.1f,1456235);
	char ANIMATION[512];
	sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Not_Moving_Surface"));
	Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,0);
	Set_Damage_Points(obj,0.0f);
	Set_Death_Points(obj,0.0f);
}

void JMG_Swimming_Attach_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 345345)
	{
		underwater--;
		if (underwater == 0)
		{
			OldCodeDIR = 2;
			char ANIMATION[512];
			sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Not_Moving_Surface"));
			Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
		}
	}
	if (message == 345346)
	{
		underwater++;
		OldCodeDIR = 2;
	}
}

void JMG_Swimming_Attach_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 1456234 && enabled == 1)
	{
		Vector3 mechposition = Commands->Get_Position(obj);
		float facing = Commands->Get_Facing(obj);
		Vector3 newpos = Commands->Get_Position(obj);
		float distancexy = abs(pos.X - newpos.X)+abs(pos.Y - newpos.Y);
		float distancez = abs(pos.Z - newpos.Z);
		StandingStill = 0;
		truningright = 0;
		truningleft = 0;
		forward = 0;
		backward = 0;
		up = 0;
		down = 0;
		/*int x,y;
		bestdegree = 0;
		float lastbigx,lastbigy,PI = 3.14159265f;
		Vector3 curpos2 = Commands->Get_Position(obj);
		lastbigx = 1000.0;
		lastbigy = 1000.0;
		for (x = 0,y = -180;x < 40;x++,y += 9)
		{
			Vector3 curpos = curpos2;
			curpos.X -= cos(y*PI180)*distancexy;
			curpos.Y -= sin(y*PI180)*distancexy;
			if ((sqrt((curpos.X - pos.X) * (curpos.X - pos.X)) < lastbigx) && (sqrt((curpos.Y - pos.Y) * (curpos.Y - pos.Y)) < lastbigy))
			{
				bestdegree = y;
				lastbigx = sqrt((curpos.X - pos.X) * (curpos.X - pos.X));
				lastbigy = sqrt((curpos.Y - pos.Y) * (curpos.Y - pos.Y));
			}
		}*/
		if (distancexy <= 0.05 && distancez <= 0.05 && facing == oldfacing)
		{
			up = 0;
			down = 0;
			truningright = 0;
			truningleft = 0;
			backward = 0;
			forward = 0;
			StandingStill = 1;
			OldCodeDIR = 110000000;
		}
		else if (distancexy > 0.05f)	
		{
			float xpos = pos.X;
			float ypos = pos.Y;
			float xdist = mechposition.X - xpos;
			float ydist = mechposition.Y - ypos;
			if (facing >= -45 && facing <= 45)
			{
				if (xdist > ydist)
				{
					forward = 1;
					backward = 0;
					OldCodeDIR = 101000000;
				}
				else if (ydist > xdist)
				{
					backward = 1;
					forward = 0;
					OldCodeDIR = 100100000;
				}
			}
			if (facing < -45 && facing > -135)
			{
				if (xdist > ydist)
				{
					forward = 1;
					backward = 0;
					OldCodeDIR = 101000000;
				}
				else if (ydist > xdist)
				{
					backward = 1;
					forward = 0;
					OldCodeDIR = 100100000;
				}
			}
			if (facing <= -135 || facing >= 135)
			{
				if (xdist < ydist)
				{
					forward = 1;
					backward = 0;
					OldCodeDIR = 101000000;
				}
				else if (ydist < xdist)
				{
					backward = 1;
					forward = 0;
					OldCodeDIR = 100100000;
				}
			}
			if (facing < 135 && facing > 45)
			{
				if (xdist < ydist)
				{
					forward = 1;
					backward = 0;
					OldCodeDIR = 101000000;
				}
				else if (ydist < xdist)
				{
					backward = 1;
					forward = 0;
					OldCodeDIR = 100100000;
				}
			}
			if (distancez - distancexy > 0.05f)
			{
				if (newpos.Z > pos.Z)
				{
					up = 1;
					down = 0;
					if (forward == 1)
					{
						OldCodeDIR = 101000010;
					}
					else
					{
						OldCodeDIR = 100100010;
					}
				}
				else if (newpos.Z < pos.Z)
				{
					up = 0;
					down = 1;
					if (forward == 1)
					{
						OldCodeDIR = 101000001;
					}
					else
					{
						OldCodeDIR = 100100001;
					}
				}
			}
		}
		else if (distancez > 0.05 && distancexy < 0.05f)
		{
			if (newpos.Z > pos.Z)
			{
				up = 1;
				down = 0;
				OldCodeDIR = 100010010;
			}
			else if (newpos.Z < pos.Z)
			{
				up = 0;
				down = 1;
				OldCodeDIR = 100000001;
			}
		}
		else if (facing != oldfacing)
		{
			if (facing > oldfacing)
			{
				truningright = 1;
				truningleft = 0;
				OldCodeDIR = 100011000;
			}
			else if (facing < oldfacing)
			{
				truningright = 0;
				truningleft = 1;
				OldCodeDIR = 100010100;
			}
		}
		pos = Commands->Get_Position(obj);
		oldfacing = facing;
		Commands->Start_Timer(obj,this,0.1f,1456234);
	}
	if (number == 1456235)
	{
		if (ASFBTRLUD != OldCodeDIR)
		{
			char ANIMATION[512];
			if (ASFBTRLUD != 110000000 && StandingStill == 1)
			{
				ASFBTRLUD = 110000000;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Not_Moving"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Not_Moving_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 101000000 && forward == 1 && up == 0 && down == 0)
			{
				ASFBTRLUD = 101000000;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Forward"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Forward_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100100000 && backward == 1 && up == 0 && down == 0)
			{
				ASFBTRLUD = 100100000;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Backward"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Backward_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100010100 && truningleft == 1)
			{
				ASFBTRLUD = 100010100;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Turn_Left"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Turn_Left_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100011000 && truningright == 1)
			{
				ASFBTRLUD = 100011000;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Turn_Right"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Turn_Right_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100010010 && up == 1 && forward == 0 && backward == 0)
			{
				ASFBTRLUD = 100010010;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Up"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Not_Moving_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100000001 && down == 1 && forward == 0 && backward == 0)
			{
				ASFBTRLUD = 100000001;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Down"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Not_Moving_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 101000010 && forward == 1 && up == 1)
			{
				ASFBTRLUD = 101000010;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Tilt_Up"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Forward_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 101000001 && forward == 1 && down == 1)
			{
				ASFBTRLUD = 101000001;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Tilt_Down"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Forward_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100100010 && backward == 1 && up == 1)
			{
				ASFBTRLUD = 100100010;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Tilt_Up_Backward"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,0);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Backward_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100100001 && backward == 1 && down == 1)
			{
				ASFBTRLUD = 100100001;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Tilt_Down_Backward"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",Get_Parameter("Skeleton"),Get_Parameter("Animation_Name"),Get_Parameter("Backward_Surface"));
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			OldCodeDIR = ASFBTRLUD;
		}
		Commands->Start_Timer(obj,this,0.1f,1456235);
	}
}

void JMG_Swimming_Attach_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Commands->Get_ID(damager) > 0 && Commands->Get_Health(Commands->Find_Object(Get_Int_Parameter("ID"))) > 0)
	{
		GameObject *player = Commands->Find_Object(Get_Int_Parameter("ID"));
		if (damager)
		{
			Commands->Apply_Damage(player,damage,"none",damager);
		}
		else
		{
			Commands->Apply_Damage(player,damage,"none",0);
		}
	}
}

/*void JMG_Swimming_Attach_Script::Killed(GameObject *obj,GameObject *damager)
{
	if (damager)
	{
		GameObject *player = Commands->Find_Object(Get_Int_Parameter("ID"));
		Commands->Set_Health(player,1.0);
		Commands->Set_Shield_Strength(player,0.0);
		Commands->Apply_Damage(player,99999.0,"blamokiller",damager);
	}
}*/

void JMG_Swimming_Head_Attach_Script::Created(GameObject *obj)
{
	screenred[0] = 0.0;
	screengreen[0] = 0.0;
	screenblue[0] = 1.0;
	tolong = Get_Int_Parameter("Current_Drown_Time");
	inwater = 0;
	addredamount = 0.01f;
	addgreenamount = -0.01f;
	addblueamount = -0.01f;
	watermurkyness[0] = 50.0;
	watercolorthickness[0] = 90.0;
	scubatankair = Get_Int_Parameter("TankAirAmmount") * 10;
	scubatankairmax = Get_Int_Parameter("MaxTankAirAmmount") * 10;
	UWBSID = 0;
	canrepeat = 1;
	HeartBeatID =0;
	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Current_Water_Zone")),53133148,1,0);
	int x;
	for (x = 0;x < 4;x++)
	{
		Watchcolor[x] = 0;
	}
	Commands->Start_Timer(obj,this,0.1f,1456235);
}

void JMG_Swimming_Head_Attach_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 1456235 && canrepeat == 1)
	{
		GameObject *player = Commands->Find_Object(Get_Int_Parameter("PlayerID"));
		if (inwater >= 1)
		{
			if (scubatankair > 0 && scubatankairmax > 0)
			{
				scubatankair--;
				int CountDow2n = 1+((int)(((float)scubatankair / (float)scubatankairmax)*10.0f));
				int CountDow4n = 1+((int)(((float)scubatankair / (scubatankairmax*0.1f))*10.0));
				if (CountDown > 0 && CountDow4n > 9)
				{
					if (CountDown != CountDow2n && CountDow2n > 0)
					{
						CountDown = CountDow2n;
						CountDow3n = CountDow4n;
						char mes[1000];
						sprintf(mes,"My scuba tank has %d0%c of its air left.",CountDown,'%');
						Send_Message_Player(player,0,127,255,mes);
					}
				}
				else if (CountDow3n != CountDow4n && CountDow4n <= 5 && CountDow4n > 0)
				{
					CountDow3n = CountDow4n;
					char mes[1000];
					sprintf(mes,"My scuba tank has %d%c of its air left.",CountDow3n,'%');
					Send_Message_Player(player,0,127,255,mes);
				}
				if (UWBSID == 0)
				{
					GameObject *swimmer = Commands->Find_Object(Get_Int_Parameter("SwimmingObjectID"));
					Vector3 pos = Commands->Get_Position(obj);
					char params[20];
					sprintf(params,"%d",Commands->Get_ID(obj));
					GameObject *breath = Commands->Create_Object("Daves Arrow",pos);
					Commands->Attach_To_Object_Bone(breath,swimmer,"c head");	
					Commands->Set_Model(breath,"maskbubble");
					UWBSID = Commands->Get_ID(breath);
					Commands->Attach_Script(breath,"JMG_Move_And_Then_Remove_When_Creator_Removed",params);
					char params2[256];
					sprintf(params2,"%s,origin",Get_Parameter("Scuba_Breath_Sound"));
					Commands->Attach_Script(breath,"RMV_Engine_Sound",params2);
				}
				if (scubatankair == 0)
				{
					if (UWBSID > 0)
					{
						Remove_Repeating_Sound_Object(&UWBSID);
					}
				}
			}
			if (scubatankair == 0 && Get_Int_Parameter("Drown_Time") >= 0)
			{
				if (tolong == 0 && scubatankairmax > 0)
				{
					Send_Message_Player(player,0,127,255,"My scuba tank is empty.");
				}
				tolong += 1;
				if (tolong >= (Get_Int_Parameter("Drown_Time")) * 10 && Watchcolor[3] < 3)
				{
					screenred[0] += addredamount;
					screengreen[0] += addgreenamount;
					screenblue[0] += addblueamount;
					Set_Fog_Range_Player(player,watermurkyness[0]/10.0f,watermurkyness[0],0);
					Set_Screen_Fade_Color_Player(player,screenred[0],screengreen[0],screenblue[0],0);
					Set_Screen_Fade_Opacity_Player(player,watercolorthickness[0],0);
					Commands->Send_Custom_Event(obj,player,5432168,tolong,0);
					if (HeartBeatID == 0)
					{
						GameObject *swimmer = Commands->Find_Object(Get_Int_Parameter("SwimmingObjectID"));
						Vector3 pos;
						char params[20];
						sprintf(params,"%d",Commands->Get_ID(obj));
						GameObject *heart = Commands->Create_Object("Daves Arrow",pos);
						Commands->Attach_To_Object_Bone(heart,swimmer,"c head");	
						HeartBeatID = Commands->Get_ID(heart);
						Commands->Set_Model(heart,"null");
						Commands->Attach_Script(heart,"JMG_Move_And_Then_Remove_When_Creator_Removed",params);
						char params2[256];
						sprintf(params2,"%s,origin",Get_Parameter("Heart_Beat_Loop_Sound"));
						Commands->Attach_Script(heart,"RMV_Engine_Sound",params2);
					}
				}
				if (addredamount != 0.0 && (screenred[0] > 1.00 || screenred[0] < 0.0) && Watchcolor[0] == 0)
				{
					Watchcolor[0] = 1;
					Watchcolor[3]++;
				}
				else if (addredamount == 0.0 && Watchcolor[0] == 0)
				{
					Watchcolor[0] = 1;
					Watchcolor[3]++;
				}
				if (addgreenamount != 0.0 && (screengreen[0] > 1.00 || screengreen[0] < 0.0) && Watchcolor[1] == 0)
				{
					Watchcolor[1] = 1;
					Watchcolor[3]++;
				}
				else if (addgreenamount == 0.0 && Watchcolor[1] == 0)
				{
					Watchcolor[1] = 1;
					Watchcolor[3]++;
				}
				if (addblueamount != 0.0 && (screenblue[0] > 1.00 || screenblue[0] < 0.0) && Watchcolor[2] == 0)
				{
					Watchcolor[2] = 1;
					Watchcolor[3]++;
				}
				else if (addblueamount == 0.0 && Watchcolor[2] == 0)
				{
					Watchcolor[2] = 1;
					Watchcolor[3]++;
				}
				if (Watchcolor[3] == 3)
				{
					watermurkyness[0] -= 2.5;
					Set_Fog_Range_Player(player,watermurkyness[0]/10.0f,watermurkyness[0],0);
				}
				if (watermurkyness[0] <= 0.0 && Commands->Get_Health(player) > 0.0)
				{
					canrepeat = 0;
					Commands->Apply_Damage(player,9999.99f,"blamokiller",player);
					Set_Screen_Fade_Opacity_Player(player,0.0f,0);
				}
			}
		}
		Commands->Start_Timer(obj,this,0.1f,1456235);
	}
}

void JMG_Swimming_Head_Attach_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 53133140){screenred[0] = param/100.0f;screenred[1] = screenred[0];}
	if (message == 53133141){screengreen[0] = param/100.0f;screengreen[1] = screengreen[0];}
	if (message == 53133142){screenblue[0] = param/100.0f;screenblue[1] = screenblue[0];}
	if (message == 53133143){addredamount = param/100.0f;}
	if (message == 53133144){addgreenamount = param/100.0f;}
	if (message == 53133145){addblueamount = param/100.0f;}
	if (message == 53133146){watermurkyness[0] = param*1.0f;watermurkyness[1] = watermurkyness[0];}
	if (message == 53133147){watercolorthickness[0] = param*1.0f;watercolorthickness[1] = watercolorthickness[0];}
	GameObject *player = Commands->Find_Object(Get_Int_Parameter("PlayerID"));
	GameObject *swimmer = Commands->Find_Object(Get_Int_Parameter("SwimmingObjectID"));
	// Under Water
	if (message == 347361)
	{
		inwater++;
		if (inwater == 1)
		{
			CountDown = 11;
			Set_Fog_Enable_Player(player,1);
			Set_Fog_Range_Player(player,watermurkyness[0]*0.75f,watermurkyness[0],0);
			Set_Screen_Fade_Color_Player(player,screenred[0],screengreen[0],screenblue[0],0);
			Set_Screen_Fade_Opacity_Player(player,watercolorthickness[0],0);
			Commands->Send_Custom_Event(obj,swimmer,345346,1,0);
			Commands->Send_Custom_Event(obj,player,345346,1,0);
			Commands->Send_Custom_Event(obj,player,5432157,1,0);
		}
	}
	// Out of water
	if (message == 347360)
	{
		inwater--;
		if (inwater == 0)
		{
			screenred[0] = screenred[1];
			screengreen[0] = screengreen[1];
			screenblue[0] = screenblue[1];
			watermurkyness[0] = watermurkyness[1];
			watercolorthickness[0] = watercolorthickness[1];
			if (tolong >= (Get_Int_Parameter("Drown_Time")) * 10 && Get_Int_Parameter("Drown_Time") >= 0)
			{
				Commands->Create_3D_Sound_At_Bone(Get_Parameter("Urgent_Breath_Sound"),obj,"origin");
			}
			else
			{
				Commands->Create_3D_Sound_At_Bone(Get_Parameter("Breath_Sound"),obj,"origin");
			}
			if (UWBSID > 0)
			{
				Remove_Repeating_Sound_Object(&UWBSID);
			}
			if (HeartBeatID > 0)
			{
				Remove_Repeating_Sound_Object(&HeartBeatID);
			}
			int tempparam = scubatankair / 10;
			Commands->Send_Custom_Event(obj,player,5432169,tempparam,0);
			Commands->Send_Custom_Event(obj,swimmer,345345,1,0);
			Commands->Send_Custom_Event(obj,player,345345,1,0);
		}
	}
	if (message == 5347361)
	{
		scubatankair = param * 10;
	}
	if (message == 5347362)
	{
		if (UWBSID > 0)
		{
			Remove_Repeating_Sound_Object(&UWBSID);
			if (HeartBeatID > 0)
			{
				Remove_Repeating_Sound_Object(&HeartBeatID);
			}
		}
		else if (HeartBeatID > 0)
		{
			Remove_Repeating_Sound_Object(&HeartBeatID);
		}
	}
	if (message == 5347363)
	{
		Commands->Send_Custom_Event(obj,player,5432168,tolong,0);
	}
}

void JMG_Swimming_Head_Attach_Script::Remove_Repeating_Sound_Object(int *ID)
{
	GameObject *object = Commands->Find_Object(*ID);
	Vector3 pos;
	pos.X = 0.00f;
	pos.Y = 0.00f;
	pos.Z = 10000.00f;
	GameObject *moveobject = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(moveobject,"null");
	Commands->Attach_To_Object_Bone(object,moveobject,"origin");
	Commands->Attach_Script(moveobject,"JMG_Remove_Object_When_Timer_Expired","1.5");
	Commands->Attach_Script(object,"JMG_Remove_Object_When_Timer_Expired","1.5");
	Commands->Set_Position(moveobject,pos);
	*ID = 0;
}

void JMG_Remove_Self_On_Timer::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),2345);
}

void JMG_Remove_Self_On_Timer::Timer_Expired(GameObject *obj,int number)
{
	if (number == 2345)
	{
		Commands->Destroy_Object(obj);
	}
}

// These are now unused
void JMG_RP2_Freezer_Burn::Created(GameObject *obj)
{
	aco = 0;
	unfreeze = 3;
	FreezeID = 0;
	Commands->Start_Timer(obj,this,1.00f,46345);
}

void JMG_RP2_Freezer_Burn::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Get_Vehicle(damager))
	{
		damager = Get_Vehicle(damager);
	}
	const char *weaponpointer = Get_Current_Weapon(damager);
	if (Commands->Get_ID(damager) != 0 && weaponpointer)
	{
		aco = 0;
		if (!_stricmp(weaponpointer,Get_Parameter("Weapon")))
		{
			aco = 1;
			unfreeze = 0;
			if (FreezeID == 0)
			{
				if (FreezeID == 0)
				{
					GameObject *object = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
					Commands->Set_Model(object,"null");
					Commands->Attach_To_Object_Bone(obj,object,"none");
					FreezeID = Commands->Get_ID(object);
				}
			}
		}
	}
}

void JMG_RP2_Freezer_Burn::Killed(GameObject *obj,GameObject *damager)
{
	if (aco == 1)
	{
		const char *exp;
		exp = Get_Parameter("Explosion");
		Commands->Create_Explosion(exp,Commands->Get_Position(obj),0);
		Commands->Start_Timer(obj,this,0.10f,6584253);
		Commands->Set_Model(obj,"infnc");
	}
	if (FreezeID > 0)
	{
		GameObject *object = Commands->Find_Object(FreezeID);
		if (Commands->Get_Health(object) > 0)
		{
			Commands->Destroy_Object(object);
		}
	}
}

void JMG_RP2_Freezer_Burn::Timer_Expired(GameObject *obj,int number)
{
	if (number == 6584253)
	{
		Commands->Set_Model(obj,"infnc");
	}
	if (46345 == number)
	{
		if (unfreeze < 3)
		{
			unfreeze++;
			if (unfreeze == 3 && FreezeID > 0)
			{
				GameObject *object = Commands->Find_Object(FreezeID);
				if (Commands->Get_Health(object) > 0)
				{
					Commands->Destroy_Object(object);
				}
				FreezeID = 0;
			}
		}
		Commands->Start_Timer(obj,this,1.00f,46345);
	}
}

void JMG_RP2_Random_Splatters::Created(GameObject *obj)
{
	aco2 = 0;
}

void JMG_RP2_Random_Splatters::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Get_Vehicle(damager))
	{
		damager = Get_Vehicle(damager);
	}
	if (Commands->Get_ID(damager) != 0 && Commands->Get_Health(obj) > 0)
	{
		aco2 = 0;
		const char *wptr = Get_Current_Weapon(damager);
		if (Get_Float_Parameter("Damage_Amount") != -1.000 && damage >= Get_Float_Parameter("Damage_Amount"))
		{
			aco2 = 1;
		}
		if (wptr)// 5 to prevent burn splatter
		{
			if (_stricmp(wptr,"Weapon_Liquid_Nitrogen") && damage > 5.0f)
			{
				if (!_stricmp(wptr,"Weapon_Barrett_M82") || 
				!_stricmp(wptr,"Weapon_Barrett_M82_Ai") || 
				!_stricmp(wptr,"Weapon_RPG-7") || 
				!_stricmp(wptr,"Weapon_M72_LAW") || 
				!_stricmp(wptr,"Weapon_FIM-92_Stinger") || 
				!_stricmp(wptr,"Weapon_Fragmentation_Grenade") || 
				!_stricmp(wptr,"Weapon_M203_Grenade_Launcher") || 
				!_stricmp(wptr,"Weapon_M32_Multiple_Grenade_Launcher") || 
				!_stricmp(wptr,"Weapon_Apache_Longbow_Hellfire_Missiles") || 
				!_stricmp(wptr,"Weapon_Apache_Longbow_Hydra_Rockets") || 
				!_stricmp(wptr,"Weapon_Comanche") || 
				!_stricmp(wptr,"Weapon_Harrier") || 
				!_stricmp(wptr,"Weapon_Hydra") || 
				!_stricmp(wptr,"Weapon_Hind") || 
				!_stricmp(wptr,"Weapon_M109_Howitzer") || 
				!_stricmp(wptr,"Weapon_M1A1_Abrams") || 
				!_stricmp(wptr,"Weapon_Comanche") || 
				!_stricmp(wptr,"Weapon_Scud_Launcher") || 
				!_stricmp(wptr,"Weapon_T-80") || 
				!_stricmp(wptr,"Weapon_Hellfire_Turret") || 
				!_stricmp(wptr,"Weapon_Rocket_Launcher_Halo_Style") || 
				!_stricmp(wptr,"Weapon_Shot_Gun_Jerad") || 
				!_stricmp(wptr,"Weapon_Renhalo_Hover_Craft") ||
				!_stricmp(wptr,"Weapon_Shore_Cannon"))
				{
					aco2 = 1;
					/*if (damage >= 50.00f)// Fall Down
					{
						Commands->Start_Timer(obj,this,0.10f,6584254);
					}*/
				}
			}
			if (!_stricmp(wptr,"Weapon_Plasma_Torpedo_Launcher"))
			{
				aco2 = 2;
			}
		}
	}
	if (Commands->Get_ID(damager) == 0)
	{
		aco2 = 1;
	}
}

void JMG_RP2_Random_Splatters::Killed(GameObject *obj,GameObject *damager)
{
	if (aco2 == 1)
	{
		aco2 = 0;
		Commands->Set_Model(obj,"infnc");
		char splatter[512];
		int num = Commands->Get_Random_Int(0,Get_Int_Parameter("Number_Of_Random_Splatters"));
		sprintf(splatter,"%s%d",Get_Parameter("Splatter_Name"),num);
		Commands->Create_Explosion(splatter,Commands->Get_Position(obj),0);
		Commands->Start_Timer(obj,this,0.01f,6584253);
	}
	if (aco2 == 2)
	{
		aco2 = 0;
		Commands->Set_Model(obj,"infnc");
		Vector3 pos = Commands->Get_Bone_Position(obj,"c pelvis");
		Commands->Create_Explosion("Zap_explosion",Commands->Get_Bone_Position(obj,"c head"),0);
		for (int x = 0;x < 5;x++)
		{
			pos = Commands->Get_Bone_Position(obj,"c pelvis");
			pos.X += Commands->Get_Random(-0.25,0.25);
			pos.Y += Commands->Get_Random(-0.25,0.25);
			pos.Z += Commands->Get_Random(-1.25,1.25);
			Commands->Create_Explosion("Zap_explosion",pos,0);
		}
		Commands->Start_Timer(obj,this,0.01f,6584253);
	}
}

void JMG_RP2_Random_Splatters::Timer_Expired(GameObject *obj,int number)
{
	if (6584253 == number)
	{
		Commands->Set_Model(obj,"infnc");
	}
	if (6584254 == number)
	{
		Commands->Set_Animation(obj,"s_a_human.h_a_635a",false,0,0,28,false);
		if (Commands->Get_Health(obj) > 0.0f)
		{
			Commands->Start_Timer(obj,this,0.93f,6584255);
		}
	}
	if (6584255 == number)
	{
		int rand = Commands->Get_Random_Int(0,99);
		if (rand >= 50)
		{
			Commands->Set_Animation(obj,"s_a_human.h_a_h12c",false,0,0,100,false);
		}
		else
		{
			Commands->Set_Animation(obj,"s_a_human.h_a_h13c",false,0,0,90,false);
		}
	}
}

// Renamed and cleaned up 10/27/09 Jerad Gray
void JMG_RP2_Vehicle_Entry_Control::Created(GameObject *obj)
{
	isnotdefault = 0;
	Commands->Set_Player_Type(obj,-1);
	MarkerID = 0;
	enabled = 1;
	RemoveTime = 0;
}

void JMG_RP2_Vehicle_Entry_Control::Timer_Expired(GameObject *obj,int number)
{
	if (number == 4327717)
	{
		RemoveTime = 0;
		isnotdefault = 0;
		Commands->Set_Player_Type(obj,-1);
		if (MarkerID > 0)
		{
			GameObject *object = Commands->Find_Object(MarkerID);
			if (object)
			{
				Commands->Destroy_Object(object);
			}
			MarkerID = 0;
		}
	}
	if (number == 4327716 && MarkerID > 0)
	{
		if (Commands->Get_Player_Type(obj) != 1 && !Get_Vehicle(obj))
		{
			Commands->Set_Player_Type(obj,1);
		}
		RemoveTime++;
		if (RemoveTime == 150)
		{
			Commands->Start_Timer(obj,this,0.0f,4327717);
		}
		Commands->Start_Timer(obj,this,0.1f,4327716);
	}
	else if (number == 4327716 && MarkerID > 0)
	{
		Commands->Set_Player_Type(obj,-1);
	}
}

void JMG_RP2_Vehicle_Entry_Control::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 4327717 && isnotdefault == 0)
	{
		isnotdefault = 1;
		RemoveTime = 0;
		Commands->Start_Timer(obj,this,0.1f,4327716);
		if (!param)
		{
			GameObject *PlayerVehicle = Get_Vehicle(obj);
			if (PlayerVehicle)
			{
				const char *VehiclePresetName = Commands->Get_Preset_Name(PlayerVehicle);
				RP2VehicleControl *GVehicleNode = Get_Vehicle_Node(PlayerVehicle);
				if (GVehicleNode && GVehicleNode->IsWarthog)// Special Warthog Stuff
				{
					WarthogControl *WarthogNode2 = Get_Warthog_Node(PlayerVehicle);
					GameObject *WarthogChasie = Commands->Find_Object(WarthogNode2->BodyID);
					GameObject *WarthogGunner = Commands->Find_Object(WarthogNode2->GunnerID);
					GameObject *WarthogTurret = Commands->Find_Object(WarthogNode2->TurretID);
					if (Warthog_Special2(obj,WarthogChasie,WarthogGunner,WarthogTurret))
					{
						return;
					}
					GameObject *Arrow = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
					Commands->Attach_To_Object_Bone(Arrow,WarthogChasie,"origin");
					char params[20];
					sprintf(params,"%d",Commands->Get_ID(obj));
					Commands->Attach_Script(Arrow,"JMG_Remove_Object_When_Creator_Destroyed",params);
					MarkerID = Commands->Get_ID(Arrow);
					Commands->Set_Model(Arrow,"o_em_get_in");
					if (!Warthog_Special(WarthogChasie,WarthogGunner,WarthogTurret)){Commands->Set_Model(Arrow,"o_em_get_inn");}
					return;
				}
				Commands->Send_Custom_Event(obj,PlayerVehicle,912397343,1,0);
				GameObject *Arrow = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
				if (!_stricmp(VehiclePresetName,"Bus") || !_stricmp(VehiclePresetName,"Chinook") || !_stricmp(VehiclePresetName,"Fishing_Boat") || !_stricmp(VehiclePresetName,"Fishing_Trawler") || !_stricmp(VehiclePresetName,"Submarine"))// Highest Height
				{
					if (Get_Vehicle_Seat_Count(PlayerVehicle) != Get_Vehicle_Occupant_Count(PlayerVehicle))
					{
						Commands->Set_Model(Arrow,"o_em_get_in2");
					}
					else
					{
						Commands->Set_Model(Arrow,"o_em_get_inn2");
					}
				}
				else if (!_stricmp(VehiclePresetName,"Subway_Car") || !_stricmp(VehiclePresetName,"Cargo_Truck") || !_stricmp(VehiclePresetName,"RH_Ghost"))// Medium Height
				{
					if (Get_Vehicle_Seat_Count(PlayerVehicle) != Get_Vehicle_Occupant_Count(PlayerVehicle))
					{
						Commands->Set_Model(Arrow,"o_em_get_in3");
					}
					else
					{
						Commands->Set_Model(Arrow,"o_em_get_inn3");
					}
				}
				else// Lowest Height
				{
					if (Get_Vehicle_Seat_Count(PlayerVehicle) != Get_Vehicle_Occupant_Count(PlayerVehicle))
					{
						Commands->Set_Model(Arrow,"o_em_get_in");
					}
					else
					{
						Commands->Set_Model(Arrow,"o_em_get_inn");
					}
				}
				Commands->Attach_To_Object_Bone(Arrow,PlayerVehicle,"origin");
				char params[20];
				sprintf(params,"%d",Commands->Get_ID(obj));
				Commands->Attach_Script(Arrow,"JMG_Remove_Object_When_Creator_Destroyed",params);
				MarkerID = Commands->Get_ID(Arrow);
			}
			else
			{
				GameObject *Arrow = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
				Commands->Set_Model(Arrow,"o_em_pickup");
				Commands->Attach_To_Object_Bone(Arrow,obj,"origin");
				char params[20];
				sprintf(params,"%d",Commands->Get_ID(obj));
				Commands->Attach_Script(Arrow,"JMG_Remove_Object_When_Creator_Destroyed",params);
				MarkerID = Commands->Get_ID(Arrow);
			}
		}
	}
	if (message == 90000028)
	{
		RemoveTime = 0;
		isnotdefault = 0;
		Commands->Set_Player_Type(obj,-1);
		if (MarkerID > 0)
		{
			GameObject *object = Commands->Find_Object(MarkerID);
			if (object)
			{
				Commands->Destroy_Object(object);
			}
			MarkerID = 0;
		}
	}
	if (message == 90000029)
	{
		isnotdefault = 0;
		Commands->Set_Player_Type(obj,-1);
		if (MarkerID > 0)
		{
			GameObject *object = Commands->Find_Object(MarkerID);
			if (object)
			{
				Commands->Destroy_Object(object);
			}
			MarkerID = 0;
		}
	}
	if (message == 4327718)
	{
		RemoveTime = 0;
		isnotdefault = 0;
		Commands->Set_Player_Type(obj,-1);
		if (MarkerID > 0)
		{
			GameObject *object = Commands->Find_Object(MarkerID);
			if (object)
			{
				Commands->Destroy_Object(object);
			}
			MarkerID = 0;
		}
	}
}

void JMG_RP2_Vehicle_Entry_Control::Killed(GameObject *obj,GameObject *damager)
{
	if (MarkerID > 0)
	{
		GameObject *object = Commands->Find_Object(MarkerID);
		if (object)
		{
			Commands->Destroy_Object(object);
		}
		MarkerID = 0;
	}
}

void JMG_RP2_Vehicle_Entry_Control::Destroyed(GameObject *obj)
{
	if (MarkerID > 0)
	{
		GameObject *object = Commands->Find_Object(MarkerID);
		if (object)
		{
			Commands->Destroy_Object(object);
		}
		MarkerID = 0;
	}
}

int JMG_RP2_Vehicle_Entry_Control::Warthog_Special(GameObject *Side1,GameObject *Side2,GameObject *Side3)
{	
	if ((Get_Vehicle_Occupant_Count(Side1) + Get_Vehicle_Occupant_Count(Side2) + Get_Vehicle_Occupant_Count(Side3)) < 3)
	{
		return 1;
	}
	return 0;
}

int JMG_RP2_Vehicle_Entry_Control::Warthog_Special2(GameObject *obj,GameObject *Side1,GameObject *Side2,GameObject *Side3)
{	
	if (Commands->Get_Player_Type(Side1) == -1 && Commands->Get_Player_Type(Side2) == -1 && Commands->Get_Player_Type(Side3) == -1)
	{
		Commands->Send_Custom_Event(obj,Side1,912397343,1,0);
		Commands->Send_Custom_Event(obj,Side2,912397343,1,0);
		Commands->Send_Custom_Event(obj,Side3,912397343,1,0);
		return 0;
	}
	return 1;
}

void JMG_Real_Plane_Physics::Created(GameObject *obj)
{
	occupied = 0;
	Commands->Start_Timer(obj,this,0.1f,4534343);
	//Commands->Start_Timer(obj,this,1.0,4534344);
	Commands->Start_Timer(obj,this,0.25f,4534345);
	Commands->Start_Timer(obj,this,1.00f,4534346);
	Commands->Start_Timer(obj,this,1.00f,4534347);
	//Attach_Script_Once(obj,"M00_Cinematic_Attack_Command_DLS","99999999");GameObject *FacingWatcher = Commands->Create_Object("Realign",Commands->Get_Position(obj));
	GameObject *FacingWatcher = Commands->Create_Object("Realign",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(FacingWatcher,obj,"nobone");
	FWID = Commands->Get_ID(FacingWatcher);
	speed = 0;
	Commands->Set_Model(obj,"planetest");
	GameObject *RotationBox = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Set_Model(RotationBox,"null");
	Commands->Attach_To_Object_Bone(RotationBox,obj,"Barrel");
	Rotation = Commands->Get_ID(RotationBox);
	oldfacing = Commands->Get_Facing(RotationBox);
	oldpos = Commands->Get_Position(obj);
	alreadydieing = 0;
	GameObject *OnGroundO = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Set_Model(OnGroundO,"null");
	Commands->Attach_To_Object_Bone(OnGroundO,obj,"Wheelp05ef");
	OnGroundID = Commands->Get_ID(OnGroundO);
	changeog = 0;
	change = 0;
	OnGround = 2;
	GameObject *Propeller = Commands->Create_Object("Plane_Propeller",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(Propeller,obj,"Box01");
	PropellerID = Commands->Get_ID(Propeller);
	safetime = 0;
	FAID = 0;
}

void JMG_Real_Plane_Physics::Timer_Expired(GameObject *obj,int number)
{
	if (number == 4534343)
	{
		if (occupied == 0)
		{
			Set_Current_Bullets(obj,0);
			Set_Current_Clip_Bullets(obj,0);
		}
		if (occupied != 0)
		{
			Set_Current_Bullets(obj,1000);
			Set_Current_Clip_Bullets(obj,1000);
		}
		if (speed == 0)
		{
			Commands->Start_Timer(obj,this,0.05f,4534343);
		}
		if (speed == 1)
		{
			Commands->Start_Timer(obj,this,0.0425f,4534343);
		}
		if (speed == 2)
		{
			Commands->Start_Timer(obj,this,0.0375f,4534343);
		}
		if (speed == 3)
		{
			Commands->Start_Timer(obj,this,0.0325f,4534343);
		}
		if (speed == 4)
		{
			Commands->Start_Timer(obj,this,0.02f,4534343);
		}
		if (speed == 5)
		{
			Commands->Start_Timer(obj,this,0.01f,4534343);
		}
	}
	if (number == 4534344)
	{
		GameObject *object = Commands->Find_Object(FWID);
		Commands->Attach_To_Object_Bone(obj,object,"Origin");
		Commands->Attach_To_Object_Bone(object,obj,"Origin");
	}
	if (number == 4534345)
	{
		GameObject *object2 = Commands->Find_Object(Rotation);
		float currentfacing = Commands->Get_Facing(object2);
		float Animationframe = (oldfacing-currentfacing);
		if (Animationframe > 360)
		{
			Animationframe -= 360;
		}
		if (Animationframe < -360)
		{
			Animationframe += 360;
		}
		Animationframe = (Animationframe * 2) + 30;
		if (Get_Animation_Frame(obj) - Animationframe < 60 || Get_Animation_Frame(obj) - Animationframe > 0)
		{
			if (OnGround == 0)
			{
				Commands->Set_Animation(obj,"planetest.planetest",true,0,Get_Animation_Frame(obj),Animationframe,0);
			}
		}
		oldfacing = Commands->Get_Facing(object2);
		Commands->Start_Timer(obj,this,0.05f,4534345);
	}
	if (number == 4534346)
	{
		Vector3 MyPos = Commands->Get_Position(obj);
		float lastspeed = distance;
		distance = Commands->Get_Distance(oldpos,MyPos);
		if (lastspeed > 1.0 && distance < 1.0 && alreadydieing == 0 && safetime > 12)
		{
			//GameObject *driver = Get_Vehicle_Driver(obj);
			alreadydieing = 1;
			//Commands->Apply_Damage(obj,9999.99f,"blamokiller",Get_Vehicle_Driver(obj));
			char message[1000];
			sprintf(message,"MESSAGE BOOM!");
			Console_Input(message);
		}
		if (distance > 7.0 && safetime > 12)
		{
			//GameObject *driver = Get_Vehicle_Driver(obj);
			alreadydieing = 1;
			Commands->Apply_Damage(obj,9999.99f,"blamokiller",Get_Vehicle_Driver(obj));
			char message[1000];
			sprintf(message,"MESSAGE BOOM!");
			Console_Input(message);
		}
		oldpos = Commands->Get_Position(obj);
		GameObject *HeightChecker = Commands->Find_Object(OnGroundID);
		float newdistance = Commands->Get_Distance(MyPos,Commands->Get_Position(HeightChecker));
		if (newdistance < 1.7f)
		{
			changeog++;
			safetime = 0;
			change = 0;
			if (changeog == 2)
			{
				OnGround = 1;
				GameObject *object = Commands->Find_Object(FWID);
				if (Commands->Get_Health(object) > 0)
				{
					Commands->Destroy_Object(object);
				}
				Commands->Set_Facing(obj,Commands->Get_Facing(Commands->Find_Object(Rotation)));
				Commands->Set_Model(obj,"planetestog");
				GameObject *Propeller = Commands->Find_Object(PropellerID);
				Commands->Attach_To_Object_Bone(Propeller,obj,"Box01");
			}
			if (changeog < 10)
			{
				speed = 0;
				Set_Current_Bullets(obj,0);
				Set_Current_Clip_Bullets(obj,0);
			}
		}
		else
		{
			change++;
			safetime++;
			changeog = 0;
			if (change == 2)
			{
				OnGround = 0;
				GameObject *FacingWatcher = Commands->Create_Object("Realign",Commands->Get_Position(obj));
				Commands->Attach_To_Object_Bone(obj,FacingWatcher,"nobone");
				Commands->Attach_To_Object_Bone(FacingWatcher,obj,"nobone");
				FWID = Commands->Get_ID(FacingWatcher);
				Commands->Set_Model(obj,"planetest");
				if (FAID == 0)
				{
					GameObject *ForcedAnimation = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
					Commands->Set_Model(ForcedAnimation,"planeliftoff");
					Commands->Set_Animation(ForcedAnimation,"planeliftoff.planeliftoff",true,0,0,60,0);
					Commands->Attach_To_Object_Bone(obj,ForcedAnimation,"origin");
					FAID = Commands->Get_ID(ForcedAnimation);
				}
				GameObject *Propeller = Commands->Find_Object(PropellerID);
				Commands->Attach_To_Object_Bone(Propeller,obj,"Box01");
				Vector3 pos = Commands->Get_Position(obj);
				pos.Z += 2.0f;
				Commands->Set_Position(obj,pos);
				Commands->Start_Timer(obj,this,2.0f,4534348);
			}
		}
		Commands->Start_Timer(obj,this,0.1f,4534346);
	}
	if (number == 4534347)
	{
		char message[1000];
		sprintf(message,"MESSAGE Speed %f", distance);
		Console_Input(message);
		Commands->Start_Timer(obj,this,0.5f,4534347);
	}
	if (number == 4534348)
	{
		if (FAID > 0)
		{
			GameObject *object = Commands->Find_Object(FAID);
			if (Commands->Get_Health(object) > 0)
			{
				Commands->Destroy_Object(object);
			}
			FAID = 0;
		}
	}
}

void JMG_Real_Plane_Physics::Custom(GameObject *obj,int message,int param,GameObject *sender)
{

	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		occupied++;
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		occupied--;
		if (occupied == 0)
		{
			speed = 0;
		}
	}
	if (message == 11111111 && speed < 5)
	{
		speed++;
	}
	/*if (message == 11111111)
	{
		GameObject *object = Commands->Find_Object(FWID);
		Commands->Attach_To_Object_Bone(obj,object,"Origin");
		Commands->Attach_To_Object_Bone(object,obj,"origin");
	}*/
	if (message == 11111110 && speed > 0)
	{
		speed--;
	}
}

void JMG_Advanced_Poke_Send_Custom::Poked(GameObject *obj,GameObject *poker)
{
	int team;
	team = Get_Int_Parameter("Player_Type");
	if (CheckPlayerType(poker,team))
	{
		return;
	}
	if (Get_Int_Parameter("ID") == 0)
		Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),0);
	if (Get_Int_Parameter("ID") != 0)
		Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ID")),Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),0);
	Commands->Create_Sound(Get_Parameter("Sound_Name"),Commands->Get_Position(obj),obj);
	Commands->Set_Animation(poker,Get_Parameter("Poke_Animation"),true,0,0,Get_Float_Parameter("LastFrame"),0);
}

void JMG_Play_Animation_On_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (CheckPlayerType(enter,Get_Int_Parameter("Player_Type")))
	{
		return;
	}
	if (!Get_Int_Parameter("TriggerOnEnter"))
	{
		Commands->Set_Animation(enter,Get_Parameter("Animation"),true,0,0,Get_Float_Parameter("LastFrame"),0);
		Commands->Create_Sound(Get_Parameter("Sound_Name"),Commands->Get_Position(obj),obj);
		if (Get_Float_Parameter("Damage") > 0)
		{
			Commands->Start_Timer(obj,this,Get_Float_Parameter("LastFrame")/30,Commands->Get_ID(enter));
		}
	}
}

void JMG_Play_Animation_On_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (CheckPlayerType(exit,Get_Int_Parameter("Player_Type")))
	{
		return;
	}
	if (!Get_Int_Parameter("TriggerOnExit"))
	{
		Commands->Set_Animation(exit,Get_Parameter("Animation"),true,0,0,Get_Float_Parameter("LastFrame"),0);
		Commands->Create_Sound(Get_Parameter("Sound_Name"),Commands->Get_Position(obj),obj);
		if (Get_Float_Parameter("Damage") > 0)
		{
			Commands->Start_Timer(obj,this,Get_Float_Parameter("LastFrame")/30,Commands->Get_ID(exit));
		}
	}
}

void JMG_Play_Animation_On_Zone::Timer_Expired(GameObject *obj,int number)
{
	if (Get_Float_Parameter("damage") > 0)
	{
		Commands->Apply_Damage(obj,Get_Float_Parameter("Damage"),Get_Parameter("Damage_Type"),Commands->Find_Object(number));
	}
}

void JMG_Weapon_Give_Powerup::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Get_Weapon_Count(obj) < RP2MAXINVENTORYWEAPONLIMIT)
	{
		if (Commands->Get_ID(damager) != 0)
		{
			const char *weaponpointer = Get_Current_Weapon(damager);
			if (weaponpointer)
			{
				if (!_stricmp(weaponpointer,Get_Parameter("Weapon"))) 
				{
					Commands->Give_PowerUp(obj,Get_Parameter("Powerup"),false);
					Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
				}
			}
		}
	}
	else
	{
		RP2_Cannot_Grant_Weapon_Reasons(obj,Get_WLS_Weapon_Settings(Get_Parameter("Weapon")),1);
	}
}

void JMG_War_Blitz_Create::Created(GameObject *obj)
{
	if (Get_Int_Parameter("OnCreate") > 0)
	{
		if (Get_Float_Parameter("Delay") > 0)
		{
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Delay"),100);
		}
		else
		{
			Commands->Set_War_Blitz(Get_Float_Parameter("War_Blitz_Intensity"),Get_Float_Parameter("Start_Distance"),Get_Float_Parameter("End_Distance"),Get_Float_Parameter("War_Blitz_Heading"),Get_Float_Parameter("War_Blitz_Distribution"),1.0f);
		}
	}
}

void JMG_War_Blitz_Create::Destroyed(GameObject *obj)
{
	if (Get_Int_Parameter("OnDestroy") > 0)
	{
		if (Get_Float_Parameter("Delay") > 0)
		{
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Delay"),100);
		}
		else 
		{
			Commands->Set_War_Blitz(Get_Float_Parameter("War_Blitz_Intensity"),Get_Float_Parameter("Start_Distance"),Get_Float_Parameter("End_Distance"),Get_Float_Parameter("War_Blitz_Heading"),Get_Float_Parameter("War_Blitz_Distribution"),1.0f);
		}
	}
}

void JMG_War_Blitz_Create::Timer_Expired(GameObject *obj,int number)
{
	if (number == 100)
	{
			Commands->Set_War_Blitz(Get_Float_Parameter("War_Blitz_Intensity"),Get_Float_Parameter("Start_Distance"),Get_Float_Parameter("End_Distance"),Get_Float_Parameter("War_Blitz_Heading"),Get_Float_Parameter("War_Blitz_Distribution"),1.0f);
	}
}

void JMG_Keyboard_Input_Custom_ID_Veh::Created(GameObject *obj)
{
	InstallHook(Get_Parameter("Key"),obj);
}

void JMG_Keyboard_Input_Custom_ID_Veh::KeyHook()
{
	Commands->Send_Custom_Event(Owner(),Commands->Find_Object(Get_Int_Parameter("ID")),Get_Int_Parameter("Message"),0,0);
}

void JMG_Keyboard_Vehicle_Input_Custom::Created(GameObject *obj)
{
	int set;
	for (set = 0;set < 10;set++)
	{
		passenger[set] = 0;
	}
}

void JMG_Keyboard_Vehicle_Input_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		int r, end = 0;
		for(r = 0;r < 10 && end == 0;r++)
		{
			if (passenger[r] == Commands->Get_ID(sender))
			{
				end = 1;
				passenger[r] = 0;
			}
		}
		char params[1000];
		sprintf(params,"%s,%d,%d",Get_Parameter("Key"),0,Commands->Get_ID(obj));
		Attach_Script_Once(sender,"JMG_Keyboard_Input_Custom_ID_Veh",params);
		Remove_Script(sender,"JMG_Keyboard_Input_Custom_ID_Veh");
	}
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		int r, end = 0, msg;
		int SenderID = Commands->Get_ID(sender);
		if (Get_Int_Parameter("User") == 0 && Commands->Get_ID(Get_Vehicle_Driver(obj)) == SenderID)
		{
			msg = Get_Int_Parameter("Message");
		}		
		else if (Get_Int_Parameter("User") == 1 && Commands->Get_ID(Get_Vehicle_Gunner(obj)) == SenderID)
		{
			msg = Get_Int_Parameter("Message");
		}		
		else if (Get_Int_Parameter("User") == 2 && Commands->Get_ID(Get_Vehicle_Gunner(obj)) != SenderID && Commands->Get_ID(Get_Vehicle_Driver(obj)) != SenderID)
		{
			msg = Get_Int_Parameter("Message");
		}
		else if (Get_Int_Parameter("User") == 3)
		{
			msg = Get_Int_Parameter("Message");
		}
		else
		{
			msg = 0;
		}
		char params[1000];
		sprintf(params,"%s,%d,%d",Get_Parameter("Key"),msg,Commands->Get_ID(obj));
		Attach_Script_Once(sender,"JMG_Keyboard_Input_Custom_ID_Veh",params);
		for(r = 0;r < 10 && end == 0;r++)
		{
			if (passenger[r] == 0)
			{
				end = 1;
				passenger[r] = Commands->Get_ID(sender);
			}
		}
	}
}

void JMG_Keyboard_Vehicle_Input_Custom::Killed(GameObject *obj,GameObject *damager)
{
	int r;
	for(r = 0;r < 10;r++)
	{
		if (passenger[r] > 0)
		{
			GameObject *remove = Commands->Find_Object(passenger[r]);
			if (Is_Script_Attached(remove,"JMG_Keyboard_Input_Custom_ID_Veh") == 1)
			{
				Remove_Script(remove,"JMG_Keyboard_Input_Custom_ID_Veh");
			}
			passenger[r] = 0;
		}
	}
}

void JMG_Play_Reload_Sound_On_Last_Shot::Created(GameObject *obj)
{
	isplayingsound = 0;
	Commands->Start_Timer(obj,this,0.1f,5653912); 
}

void JMG_Play_Reload_Sound_On_Last_Shot::Timer_Expired(GameObject *obj,int number)
{
	if (number == 5653912)
	{
		const char *weapon = Get_Current_Weapon(obj);
		if (weapon)
		{
			if (!_stricmp(weapon,Get_Parameter("Weapon")))
			{
				if (Get_Bullets(obj,Get_Parameter("Weapon")) == 0 && Get_Clip_Bullets(obj,Get_Parameter("Weapon")) > 0 && isplayingsound == 0)
				{
					isplayingsound = 1;
					Commands->Start_Timer(obj,this,(Get_Float_Parameter("Reload_Time") + 0.1f),5653913);
					Commands->Create_3D_Sound_At_Bone(Get_Parameter("Sound_Name"),obj,"gunbone");
				}
			}
		}
		Commands->Start_Timer(obj,this,0.1f,5653912); 
	}
	if (number == 5653913)
	{
		isplayingsound = 0;
	}
}

void JMG_RP2_Teleport_Zone_Script::Created(GameObject *obj)
{
	if (Get_Int_Parameter("Object_ID") > 0)
	{
		GameObject *TeleObject = Commands->Find_Object(Get_Int_Parameter("Object_ID"));
		if (TeleObject)
		{
			Teleport_Pos = Commands->Get_Position(TeleObject);
			Commands->Destroy_Object(TeleObject);
			return;
		}
	}
	Teleport_Pos = Get_Vector3_Parameter("TeleportLocation");
}

void JMG_RP2_Teleport_Zone_Script::Entered(GameObject *obj,GameObject *enter)//For Doors
{
	char params[128];
	if ((enter->As_PhysicalGameObj() && enter->As_PhysicalGameObj()->Peek_Physical_Object() && enter->As_PhysicalGameObj()->Peek_Physical_Object()->As_HumanPhysClass()) && !Get_Vehicle(enter) && Commands->Is_A_Star(enter))
	{
		sprintf(params,"%f,%f,%f,%f,%f,%s,%s,%s,%s,%s",Teleport_Pos.X,Teleport_Pos.Y,Teleport_Pos.Z,Get_Float_Parameter("Enter_Rotation"),Get_Float_Parameter("Exit_Rotation"),Get_Parameter("Enter_Animation"),Get_Parameter("Exit_Animation"),Get_Parameter("Enter_Path_Animation"),Get_Parameter("Exit_Path_Animation"),Get_Parameter("Bone_Attach_Name"));
		Attach_Script_Once(enter,"JMG_RP2_Teleport_Zone_Script_Attach",params);
	}
}

void JMG_RP2_Teleport_Zone_Script_Attach::Created(GameObject *obj)
{
	Commands->Innate_Enable(obj);
	Vector3 pos = Commands->Get_Bone_Position(obj,"c head");
	pos.X += 20.0f*(cos(Get_Float_Parameter("Enter_Rotation")*3.14159265f/180));
	pos.Y += 20.0f*(sin(Get_Float_Parameter("Enter_Rotation")*3.14159265f/180));
	GameObject *object = Commands->Create_Object("Daves Arrow",pos);
	Set_Facing_ID = Commands->Get_ID(object);
	Commands->Set_Model(object,"null");
	pos = Commands->Get_Position(obj);
	char anim[1000];
	sprintf(anim,"%s.%s",Get_Parameter("Enter_Path_Animation"),Get_Parameter("Enter_Path_Animation"));
	GameObject *object2 = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(object2,Get_Parameter("Enter_Path_Animation"));
	Commands->Set_Facing(object2,Get_Float_Parameter("Enter_Rotation"));
	Commands->Attach_To_Object_Bone(obj,object2,Get_Parameter("Bone_Attach_Name"));
	if (Commands->Get_Health(obj))
	{
		Commands->Set_Animation(object2,anim,true,0,60,90.0f,0);
		Commands->Set_Animation(obj,Get_Parameter("Enter_Animation"),true,0,0,90.0f,0);
		Set_Screen_Fade_Opacity_Player(obj,1.0,0.1f);
		if (!ISSELECTINGSPAWN[Get_Player_ID(obj)])
		{
			Set_Screen_Fade_Color_Player(obj,0.0f,0.0f,0.0f,0.1f);
		}
	}
	Movement_Object = Commands->Get_ID(object2);
	Commands->Start_Timer(obj,this,0.1f,453453542);
	Commands->Start_Timer(obj,this,1.0f,453453543);
	Commands->Start_Timer(obj,this,1.5f,453453544);
	Commands->Start_Timer(obj,this,0.1f,453453545);
}

void JMG_RP2_Teleport_Zone_Script_Attach::Timer_Expired(GameObject *obj,int number)
{
	if (number == 453453543) // 1 sec in
	{
		Vector3 pos;
		pos.X = Get_Float_Parameter("X");
		pos.Y = Get_Float_Parameter("Y");
		pos.Z = Get_Float_Parameter("Z");
		Vector3 ExitPos = pos;
		PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
		objphys->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Find_Teleport_Location(pos,1.0f,&ExitPos);
		Commands->Set_Position(obj,ExitPos);
		Set_Screen_Fade_Opacity_Player(obj,1.0f,0.1f);
		Commands->Destroy_Object(Commands->Find_Object(Set_Facing_ID));
		Commands->Destroy_Object(Commands->Find_Object(Movement_Object));
		pos = Commands->Get_Bone_Position(obj,"c head");			
		pos.X += 20.0f*(cos(Get_Float_Parameter("Exit_Rotation")*PI180));
		pos.Y += 20.0f*(sin(Get_Float_Parameter("Exit_Rotation")*PI180));
		GameObject *object = Commands->Create_Object("Daves Arrow",pos);
		Commands->Set_Model(object,"null");
		Set_Facing_ID = Commands->Get_ID(object);
		char anim[1000];
		sprintf(anim,"%s.%s",Get_Parameter("Exit_Path_Animation"),Get_Parameter("Exit_Path_Animation"));
		GameObject *object2 = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
		Commands->Set_Facing(object2,Get_Float_Parameter("Exit_Rotation"));
		Commands->Set_Model(object2,Get_Parameter("Exit_Path_Animation"));
		Commands->Attach_To_Object_Bone(obj,object2,Get_Parameter("Bone_Attach_Name"));
		Movement_Object = Commands->Get_ID(object2);
		if (Commands->Get_Health(obj))
		{
			Commands->Set_Animation(object2,anim,true,0,15,90,0);
			Commands->Set_Animation(obj,Get_Parameter("Exit_Animation"),true,0,24,30.0f,0);
			if (!ISSELECTINGSPAWN[Get_Player_ID(obj)])
			{
				RP2WeatherStruct *MyNode = PlayerWeatherNodes[Get_Player_ID(obj)];
				if (MyNode)
				{
					Set_Screen_Fade_Color_Player(obj,MyNode->ScreenColor.X,MyNode->ScreenColor.Y,MyNode->ScreenColor.Z,0.5);
					Set_Screen_Fade_Opacity_Player(obj,MyNode->ScreenOpacity,0.5);
				}
				else
				{
					RP2_Set_Fog_And_Screen_Color_To_Level_Default(obj);
				}

			}
			else
			{
				Set_Screen_Fade_Color_Player(obj,0,0.39f,0.78f,0.0);
				Set_Screen_Fade_Opacity_Player(obj,0.5,0.0);
			}
		}
		Commands->Start_Timer(obj,this,0.05f,453453542);// Set Facing
		Commands->Start_Timer(obj,this,0.2f,453453542);// Set Facing
		Commands->Start_Timer(obj,this,0.22f,453453542);// Set Facing
	}
	if (number == 453453544) // 1.5 sec in
	{
		Commands->Destroy_Object(Commands->Find_Object(Set_Facing_ID));
		Commands->Destroy_Object(Commands->Find_Object(Movement_Object));
		Set_Facing_ID = 0;
		Commands->Innate_Disable(obj);
		if (Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
		{
			Remove_Script(obj,"JMG_RP2_Teleport_Zone_Script_Attach");
		}
	}
	if (number == 453453542)
	{
		GameObject *object = Commands->Find_Object(Set_Facing_ID);
		if (Set_Facing_ID > 0 && object)
		{
			if (Commands->Get_Health(object) > 0.00)
			{
				Vector3 pos = Commands->Get_Position(object);
				Force_Camera_Look_Player(obj,pos);
			}
		}
		//Commands->Start_Timer(obj,this,0.1f,453453542);
	}
	if (number == 453453545)
	{
		if (Get_Vehicle(obj))
		{
			Commands->Apply_Damage(Get_Vehicle(obj),99999.99f,"blamokiller",0);
		}
		Commands->Start_Timer(obj,this,0.1f,453453545);
	}
}

void JMG_RP2_Renhalo_Vortex::Created(GameObject *obj)
{
	Commands->Enable_Enemy_Seen(obj,true);
}

void JMG_RP2_Renhalo_Vortex::Enemy_Seen(GameObject *obj,GameObject *seen)
{
	if (seen->As_SoldierGameObj())
	{
		if (Commands->Is_A_Star(seen))
		{
			int PlayerID = Get_Player_ID(seen);
			PHONEZONES[PlayerID] = 1;
			RP2WeatherStruct *MyNode = PlayerWeatherNodes[PlayerID];
			if (MyNode && MyNode->AreaID != 2)
			{
				PlayerWeatherNodes[PlayerID] = RP2_Area_Weather_Selection_Control(2,NULL);
			}
		}
		Vector3 pos;
		pos.X = 4892.0f + Commands->Get_Random(-5.0f,5.0f);
		pos.Y = 5037.0f + Commands->Get_Random(-5.0f,5.0f);
		pos.Z = -4995.0f;
		Commands->Set_Position(seen,pos);
		Commands->Send_Custom_Event(obj,seen,PHONELostSignal,1,0);
	}
}

void JMG_RP2_Renhalo_Vortex::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 534343 && Commands->Get_ID(sender) != Commands->Get_ID(obj))
	{
		//Commands->Apply_Damage(obj,999.00f,"Blamo_Killer",0);
	}
}

void JMG_Find_And_Write_Positions::Created(GameObject *obj)
{
	int x;
	count = 0;
	for (x = 0;x < 999;x++)
	{
		X[x] = 0;
		Y[x] = 0;
		Z[x] = 0;
	}
	time = 0;
	Commands->Start_Timer(obj,this,1.0f,5653912);
	Commands->Start_Timer(obj,this,0.1f,5653913);
}

void JMG_Find_And_Write_Positions::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 34984)
	{
		Vector3 pos = Commands->Get_Position(sender);
		int x;
		int end = 0;
		for (x = 0;x < 1000 && end == 0;x++)
		{
			if (X[x] == pos.X && Z[x] == pos.Z && Z[x] == pos.Z)
			{
				end = 1;
				Commands->Send_Custom_Event(obj,sender,34985,1,0);
			}
			else if (X[x] == 0 && Y[x] == 0 && Z[x] == 0)
			{
				end = 1;
				X[x] = pos.X;
				Y[x] = pos.Y;
				Z[x] = pos.Z;
				Commands->Send_Custom_Event(obj,sender,34985,1,0);
				count = 0;
			}
		}
	}
	if (message == 34986)
	{
		FILE *file1;
		file1 = fopen(Get_Parameter("File_Name"),"w");
		int x;
		int end = 0;
		for (x = 0;x < 1000 && end == 0;x++)
		{
			if (X[x] == 0.00f && Y[x] == 0.00f && Z[x] == 0.00f)
			{
				end = 1;
				fprintf(file1,"%d",x);
				fflush(file1);
				fclose (file1);
				char messag[1000];
				char messag2[1000];
				time -= 5;
				sprintf(messag,"MESSAGE %d has finished writing the positions. It has made %d entries in %.1f seconds.",Commands->Get_ID(obj),x,time);
				sprintf(messag2,"MESSAGE File Saved as \"%s\".",Get_Parameter("File_Name"));
				Console_Input(messag);
				Console_Input(messag2);
			}
			else
			{
				fprintf(file1,"%0.3f %0.3f %0.3f\n",X[x],Y[x],Z[x]);
				fflush(file1);
			}
		}
	}
}

void JMG_Find_And_Write_Positions::Timer_Expired(GameObject *obj,int number)
{
	if (number == 5653912)
	{
		count++;
		if (count >= 5)
		{
				Commands->Send_Custom_Event(obj,obj,34986,1,0);
		}
		else
		{
			Commands->Start_Timer(obj,this,1.0f,5653912);
		}
	}
	if (number == 5653913)
	{
		time += 0.1f;
		Commands->Start_Timer(obj,this,0.1f,5653913);
	}
}

void JMG_Send_Message_Until_Message_Reccived::Created(GameObject *obj)
{
	recived = 0;
	Commands->Start_Timer(obj,this,1.0f,5653912);
}

void JMG_Send_Message_Until_Message_Reccived::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message_to_Reccive"))
	{
		recived = 1;
	}
}

void JMG_Send_Message_Until_Message_Reccived::Timer_Expired(GameObject *obj,int number)
{
	if (number == 5653912 && recived == 0)
	{
		Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ID")),Get_Int_Parameter("Message"),1,0);
		Commands->Start_Timer(obj,this,0.1f,5653912);
	}
}

/*void JMG_Random_Teleport_Zone_File::Created(GameObject *obj)
{
	//int kill = 0;
	FILE *veh;
	veh = fopen(Get_Parameter("File_Name"), "r");
	//float xsum = 0,ysum = 0,zsum = 0, Xsum = 0,Ysum = 0,Zsum = 0, Ssum = 0, Fsum = 0;
	if (veh == NULL)
	{
		char messag[1000];
		sprintf(messag,"MESSAGE Teleport Zone %d IS UNABLE TO LOAD \"%s\"! GAME IS UNSTABLE WITHOUT THIS FILE!!",Commands->Get_ID(obj),Get_Parameter("File_Name"));
		Console_Input(messag);
		Remove_Script(obj,"JMG_Random_Teleport_Zone_File");
	}
	else
	{
		int x;
		int nl = Get_Int_Parameter("NumberofLocations");
		for (x = 0;x < nl;x++)
		{
			fscanf(veh,"%f %f %f",&X[x], &Y[x], &Z[x]);
			/*if (Get_Int_Parameter("UseSecurity") == 1)
			{
				if (x == 0)
				{
					Xsum = X[x];
					Ysum = Y[x];
					Zsum = Z[x];
				}
				else if (x % 2 == 0)
				{
					Xsum *= X[x];
					Ysum *= Y[x];
					Zsum *= Z[x];
				}
				else
				{
					Xsum /= X[x];
					Ysum /= Y[x];
					Zsum /= Z[x];
				}
				xsum += X[x];
				ysum += Y[x];
				zsum += Z[x];
				if (X[x] / Y[x] < X[x] / Z[x])
				{
					Ssum += X[x];
				}
				if (Y[x] / Z[x] < Y[x] / X[x])
				{
					Ssum += Y[x];
				}
				if (Y[x] / X[x] < Y[x] / Z[x])
				{
					Ssum += Z[x];
				}
				if (x == 0)
				{
					Fsum = sqrt(sqrt((X[x]+Y[x]+Z[x])*(X[x]+Y[x]+Z[x])));
				}
				else if (x % 2 == 0)
				{
					Fsum += sqrt(sqrt((X[x]+Y[x]+Z[x])*(X[x]+Y[x]+Z[x])));
				}
			}/
		}
		fclose(veh);
	}
	/*if (Get_Int_Parameter("UseSecurity") == 1)
	{
		if (((Xsum + Ysum + Zsum - 0.01f) < Get_Float_Parameter("SecurityCodeM") * 100 && (Xsum + Ysum + Zsum + 0.01f) > Get_Float_Parameter("SecurityCodeM")) || Get_Float_Parameter("SecurityCodeM") == 0){}
		else
		{
			kill++;
		}
		if (((Xsum + Ysum + Zsum - 0.01f) < Get_Float_Parameter("SecurityCodeS") * 100 && (Xsum + Ysum + Zsum + 0.01f) > Get_Float_Parameter("SecurityCodeS")) || Get_Float_Parameter("SecurityCodeS") == 0){}
		else
		{
			kill++;
		}
		if (((Ssum - 0.01f) < Get_Float_Parameter("SecurityCodeO") && (Ssum + 0.01f) * 100 > Get_Float_Parameter("SecurityCodeO")) || Get_Float_Parameter("SecurityCodeO") == 0){}
		else
		{
			kill++;
		}
		if (((Fsum - 0.01f) < Get_Float_Parameter("SecurityCodeR") && (Fsum + 0.01f) * 100 > Get_Float_Parameter("SecurityCodeR")) || Get_Float_Parameter("SecurityCodeR") == 0){}
		else
		{
			kill++;
		}
		if (kill > 0)
		{
			char messag[1000];
			sprintf(messag,"MESSAGE Match Error! Aborting! \"JMG_Random_Teleport_Zone_File\" will NOT work!");
			Console_Input(messag);
			char messag2[1000];
			sprintf(messag2,"MESSAGE Reinstall \"%s\" File, as it does not correctly match on %d checks!",Get_Parameter("File_Name"),kill);
			Console_Input(messag2);
			Remove_Script(obj,"JMG_Random_Teleport_Zone_File");
		}
	}/
}*/

void JMG_Random_Teleport_Zone_File::Entered(GameObject *obj,GameObject *enter)
{
	RP2RandomTeleportPositionControl *Node = Get_Matching_Teleport_Node(Commands->Get_Random_Int(0,TELEPORTMAXRANDCHOICE));
	if (Node)
	{
		Vector3 Pos = Node->Telepos;
		if (enter->As_VehicleGameObj())
		{
			Pos.Z += 5.0f;
			Commands->Send_Custom_Event(obj,Get_Vehicle_Driver(enter),PHONEAquiredSignal,1,0);
		}
		else
		{
			Commands->Send_Custom_Event(obj,enter,PHONEAquiredSignal,1,0);
		}
		Commands->Set_Position(enter,Pos);
		char params[2000];
		sprintf(params,"5.0,34234,%s",Get_Shield_Type(enter));
		Commands->Set_Shield_Type(enter,"Blamo");
		Commands->Attach_Script(enter,"JMG_Change_Armor_Type_On_Timer",params);
	}
}

void JMG_Security_Printout_For_Teleport_Zone::Created(GameObject *obj)
{
	FILE *veh1;
	veh1 = fopen(Get_Parameter("File_Name"), "r");
	float xsum = 0,ysum = 0,zsum = 0, Xsum = 0,Ysum = 0,Zsum = 0, Ssum = 0, Fsum = 0;
	{
		int x;
		int nl = Get_Int_Parameter("NumberofLocations");
		for (x = 0;x < nl;x++)
		{
			fscanf(veh1,"%f %f %f",&X[x], &Y[x], &Z[x]);
			if (x == 0)
			{
				Xsum = X[x];
				Ysum = Y[x];
				Zsum = Z[x];
			}
			else if (x % 2 == 0)
			{
				Xsum *= X[x];
				Ysum *= Y[x];
				Zsum *= Z[x];
			}
			else
			{
				Xsum /= X[x];
				Ysum /= Y[x];
				Zsum /= Z[x];
			}
			xsum += X[x];
			ysum += Y[x];
			zsum += Z[x];
			if (X[x] / Y[x] < X[x] / Z[x])
			{
				Ssum += X[x];
			}
			if (Y[x] / Z[x] < Y[x] / X[x])
			{
				Ssum += Y[x];
			}
			if (Y[x] / X[x] < Y[x] / Z[x])
			{
				Ssum += Z[x];
			}
			if (x == 0)
			{
				Fsum = sqrt(sqrt((X[x]+Y[x]+Z[x])*(X[x]+Y[x]+Z[x])));
			}
			else if (x % 2 == 0)
			{
				Fsum += sqrt(sqrt((X[x]+Y[x]+Z[x])*(X[x]+Y[x]+Z[x])));
			}
		}
		fclose (veh1);
	}
	char messag[1000];
	sprintf(messag,"MESSAGE SecurityCodeM %f",(Xsum + Ysum + Zsum) / 100);
	Console_Input(messag);
	char messag1[1000];
	sprintf(messag1,"MESSAGE SecurityCodeS %f",(xsum + ysum + zsum) / 100);
	Console_Input(messag1);
	char messag2[1000];
	sprintf(messag2,"MESSAGE SecurityCodeO %f",Ssum / 100);
	Console_Input(messag2);
	char messag3[1000];
	sprintf(messag3,"MESSAGE SecurityCodeR %f",Fsum / 100);
	Console_Input(messag3);
}

void JMG_Set_Rotation_To_Nearest_Soldier::Created(GameObject *obj)
{
	Send_Custom_All_Objects_Area(91193348,Commands->Get_Position(obj),1.0f,obj,2);
}

void JMG_Set_Rotation_To_Nearest_Soldier::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 91193349)
	{
		Commands->Attach_To_Object_Bone(obj,sender,"origin");
		Commands->Start_Timer(obj,this,0.1f,486781323);
	}
}

void JMG_Set_Rotation_To_Nearest_Soldier::Timer_Expired(GameObject *obj,int number)
{
	if (number == 486781323)
	{
		Commands->Attach_To_Object_Bone(obj,obj,"origin");
	}
}

void JMG_RP2_Network_Link_Beacon::Created(GameObject *obj)
{
	GameObject *Planter = Commands->Get_A_Star(Commands->Get_Position(obj));
	if (Has_Weapon(Planter,"Weapon_Vortex_Beacon"))
	{
		Set_Bullets(Planter,"Weapon_Vortex_Beacon",Get_Bullets(Planter,"Weapon_Vortex_Beacon")-1);
	}
	if (Has_Weapon(Planter,"Weapon_Vortex_Beacon_Player"))
	{
		Set_Bullets(Planter,"Weapon_Vortex_Beacon_Player",Get_Bullets(Planter,"Weapon_Vortex_Beacon_Player")-1);
	}
	Commands->Start_Timer(obj,this,21.0f,542424);
	Commands->Start_Timer(obj,this,20.0f,542423);
	Commands->Set_Animation(obj,"laptop.laptop",true,0,0,1200.0f,0);
}

void JMG_RP2_Network_Link_Beacon::Timer_Expired(GameObject *obj,int number)
{
	if (number == 542424)
	{
		GameObject *object2 = Commands->Find_Object(PositionObject);
		GameObject *object = Commands->Create_Object("RH_Hack_Portal",Commands->Get_Bone_Position(object2,"Portal"));
		Portal = Commands->Get_ID(object);
		Commands->Start_Timer(obj,this,1.0f,542425);
	}
	if (number == 542423)
	{
		Vector3 pos;
		GameObject *object = Commands->Create_Object("Beacon_Portal_Placer",pos);
		Commands->Attach_To_Object_Bone(object,obj,"MuzzleA0");
		PositionObject = Commands->Get_ID(object);
	}
	if (number == 542425)
	{
		GameObject *object2 = Commands->Find_Object(PositionObject);
		GameObject *object = Commands->Find_Object(Portal);
		Vector3 pos = Commands->Get_Bone_Position(object2,"Portal");
		Commands->Set_Position(object,pos);
		Commands->Destroy_Object(object2);
	}
}

void JMG_RP2_Network_Link_Beacon::Destroyed(GameObject *obj)
{
	Commands->Destroy_Object(Commands->Find_Object(PositionObject));
	Commands->Destroy_Object(Commands->Find_Object(Portal));
}

void JMG_Set_Ammo_On_Enter_Reset_On_Exit::Created(GameObject *obj)
{
	int x;
	for (x = 0;x < 125;x++)
	{
		IDOfSoldier[x] = 0;
		OriginalBullets[x] = 0;
		OriginalClipBullets[x] = 0;
	}
}

void JMG_Set_Ammo_On_Enter_Reset_On_Exit::Entered(GameObject *obj,GameObject *enter)
{
	int x, end,y = 0;
	if (!enter->As_VehicleGameObj())
	{
		end = 0;
		for (x = 0;x < 125 && end == 0;x++)
		{
			if (IDOfSoldier[x] == 0)
			{
				end = 1;
				IDOfSoldier[x] = Commands->Get_ID(enter);
				OriginalBullets[x] = Get_Bullets(enter,Get_Parameter("Weapon"));
				OriginalClipBullets[x] = Get_Clip_Bullets(enter,Get_Parameter("Weapon"));
				Set_Clip_Bullets(enter,Get_Parameter("Weapon"),Get_Int_Parameter("Bullets"));
				Set_Bullets(enter,Get_Parameter("Weapon"),Get_Int_Parameter("Clip_Bullets"));
			}
			if (IDOfSoldier[x] == Commands->Get_ID(enter))
			{
				end = 1;
			}
		}
	}
	if (enter->As_VehicleGameObj())
	{
		while (y <= Get_Vehicle_Seat_Count(enter))
		{
			end = 0;
			if (Commands->Get_ID(Get_Vehicle_Occupant(enter,y)) > 0)
			{
				for (x = 0;x < 125 && end == 0;x++)
				{
					if (IDOfSoldier[x] == 0)
					{
						end = 1;
						IDOfSoldier[x] = Commands->Get_ID(Get_Vehicle_Occupant(enter,y));
						OriginalBullets[x] = Get_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"));
						OriginalClipBullets[x] = Get_Clip_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"));
						Set_Clip_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"),Get_Int_Parameter("Bullets"));
						Set_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"),Get_Int_Parameter("Clip_Bullets"));
						y++;
					}
					else if (IDOfSoldier[x] == Commands->Get_ID(Get_Vehicle_Occupant(enter,y)))
					{
						x = 0;
						y++;
					}
					else if (x == 125)
					{
						y++;
					}
				}
			}
			else
			{
				y++;
			}
		}
	}
}

void JMG_Set_Ammo_On_Enter_Reset_On_Exit::Exited(GameObject *obj,GameObject *exit)
{
	int x, end,y = 0;
	if (!exit->As_VehicleGameObj())
	{
		end = 0;
		for (x = 0;x < 125 && end == 0;x++)
		{
			if (Commands->Get_ID(exit) == IDOfSoldier[x])
			{
				end = 1;
				Set_Bullets(exit,Get_Parameter("Weapon"),OriginalBullets[x]);
				Set_Clip_Bullets(exit,Get_Parameter("Weapon"),OriginalClipBullets[x]);
				IDOfSoldier[x] = 0;
			}
		}
	}
	if (exit->As_VehicleGameObj())
	{
		y = 0;
		while (y < Get_Vehicle_Seat_Count(exit))
		{
			y++;
			end = 0;
			if (Commands->Get_ID(Get_Vehicle_Occupant(exit,y)) > 0)
			{
				for (x = 0;x < 125 && end == 0;x++)
				{
					if (Commands->Get_ID(Get_Vehicle_Occupant(exit,y)) == IDOfSoldier[x])
					{
						end = 1;
						Set_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"),OriginalBullets[x]);
						Set_Clip_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"),OriginalClipBullets[x]);
					}
				}
			}
		}
	}
}

void JMG_Send_Custom_With_ID_Of_Enter_Or_Exiter::Entered(GameObject *obj,GameObject *enter)
{
	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ID")),Get_Int_Parameter("Enter_Message"),Commands->Get_ID(enter),0);
}

void JMG_Send_Custom_With_ID_Of_Enter_Or_Exiter::Exited(GameObject *obj,GameObject *exit)
{
	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ID")),Get_Int_Parameter("Exit_Message"),Commands->Get_ID(exit),0);
}

void JMG_Change_Or_Reset_Sender_Ammo_On_Custom::Created(GameObject *obj)
{
	int x;
	for (x = 0;x < 125;x++)
	{
		IDOfSoldier[x] = 0;
		OriginalBullets[x] = 0;
		OriginalClipBullets[x] = 0;
	}
}

void JMG_Change_Or_Reset_Sender_Ammo_On_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	int x, end,y = 0;
	if (message == Get_Int_Parameter("Set_Ammo_Message"))
	{
		if (!Commands->Find_Object(param)->As_VehicleGameObj())
		{
			end = 0;
			for (x = 0;x < 125 && end == 0;x++)
			{
				if (IDOfSoldier[x] == 0)
				{
					if (Get_Bullets(Commands->Find_Object(param),Get_Parameter("Weapon")) != Get_Int_Parameter("Bullets") || Get_Clip_Bullets(Commands->Find_Object(param),Get_Parameter("Weapon")) != Get_Int_Parameter("Clip_Bullets"))
					{
						end = 1;
						IDOfSoldier[x] = param;
						OriginalBullets[x] = Get_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"));
						OriginalClipBullets[x] = Get_Clip_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"));
						Set_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"),Get_Int_Parameter("Bullets"));
						Set_Clip_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"),Get_Int_Parameter("Clip_Bullets"));
					}
					else
					{
						end = 1;
					}
					if (IDOfSoldier[x] == param)
					{
						end = 1;
					}
				}
			}
		}
		if (Commands->Find_Object(param)->As_VehicleGameObj())
		{
			while (y <= Get_Vehicle_Seat_Count(Commands->Find_Object(param)))
			{
				end = 0;
				if (Commands->Is_A_Star(Get_Vehicle_Occupant(Commands->Find_Object(param),y)) == 1)
				{
					if (Get_Bullets(Commands->Find_Object(param),Get_Parameter("Weapon")) != Get_Int_Parameter("Bullets") || Get_Clip_Bullets(Commands->Find_Object(param),Get_Parameter("Weapon")) != Get_Int_Parameter("Clip_Bullets"))
					{
						for (x = 0;x < 125 && end == 0;x++)
						{
							if (IDOfSoldier[x] == 0)
							{
								end = 1;
								IDOfSoldier[x] = Commands->Get_ID(Get_Vehicle_Occupant(Commands->Find_Object(param),y));
								OriginalBullets[x] = Get_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"));
								OriginalClipBullets[x] = Get_Clip_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"));
								Set_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"),Get_Int_Parameter("Bullets"));
								Set_Clip_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"),Get_Int_Parameter("Clip_Bullets"));
								y++;
							}
							else if (IDOfSoldier[x] == Commands->Get_ID(Get_Vehicle_Occupant(Commands->Find_Object(param),y)))
							{
								x = 0;
								y++;
							}
							else if (x == 125)
							{
								y++;
							}
						}
					}
					else
					{
						y++;
					}
				}
			}
		}
	}
	if (message == Get_Int_Parameter("Reset_Ammo_Message"))
	{
		if (!Commands->Find_Object(param)->As_VehicleGameObj())
		{
			end = 0;
			for (x = 0;x < 125 && end == 0;x++)
			{
				if (param == IDOfSoldier[x])
				{
					end = 1;
					Set_Clip_Bullets(Commands->Find_Object(param),Get_Parameter("Weapon"),OriginalBullets[x]);
					Set_Bullets(Commands->Find_Object(param),Get_Parameter("Weapon"),OriginalClipBullets[x]);
					IDOfSoldier[x] = 0;
				}
			}
		}
		if (Commands->Find_Object(param)->As_VehicleGameObj())
		{
			y = 0;
			while (y < Get_Vehicle_Seat_Count(Commands->Find_Object(param)))
			{
				end = 0;
				y++;
				if (Commands->Get_ID(Get_Vehicle_Occupant(Commands->Find_Object(param),y)) > 0)
				{
					for (x = 0;x < 125 && end == 0;x++)
					{
						GameObject *object = Get_Vehicle_Occupant(Commands->Find_Object(param),y);
						if (Commands->Get_ID(object) == IDOfSoldier[x])
						{
							end = 1;
							Set_Clip_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"),OriginalBullets[x]);
							Set_Bullets(Commands->Find_Object(IDOfSoldier[x]),Get_Parameter("Weapon"),OriginalClipBullets[x]);
						}
					}
				}
			}
		}
	}
}

void JMG_Play_Animation_On_Create::Created(GameObject *obj)
{
	Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,0,-1,0);
}

void JMG_Set_Random_Rotation::Created(GameObject *obj)
{
	Commands->Set_Facing(obj,Commands->Get_Random(0,360));
}

void JMG_Random_Explosive_Barrel::Created(GameObject *obj)
{
	char barrel[13];
	int barreltype = Commands->Get_Random_Int(1,8);
	sprintf(barrel,"dsp_metdrum0%d",barreltype);
	Commands->Set_Model(obj,barrel);
	char barrelanim[30];
	sprintf(barrelanim,"dsp_metdrum0%d.dsp_metdrum0%d",barreltype,barreltype);
	Commands->Set_Animation(obj,barrelanim,true,0,0,0,0);
	Commands->Set_Facing(obj,Commands->Get_Random(0,360));
	int x;
	for (x = 0;x < 3;x++)
	{
		hasbeenhit[x] = 0;
	}
}

void JMG_Random_Explosive_Barrel::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (hasbeenhit[0] == 0)
	{
		hasbeenhit[0] = 1;
		char barrelanim[30];
		int barrelanimtype = Commands->Get_Random_Int(1,10);
		hasbeenhit[1] = barrelanimtype;
		float numberofframes = 60.0f;
		if (barrelanimtype == 1){numberofframes = 28.0f;
		sprintf(barrelanim,"dsp_metdrum01.dsp_metdrum01");}
		if (barrelanimtype == 2){numberofframes = 15.0f;
		sprintf(barrelanim,"dsp_metdrum02.dsp_metdrum02");}
		if (barrelanimtype == 3){numberofframes = 20.0f;
		sprintf(barrelanim,"dsp_metdrum03.dsp_metdrum03");}
		if (barrelanimtype == 4){numberofframes = 27.0f;
		sprintf(barrelanim,"dsp_metdrum06.dsp_metdrum06");}
		if (barrelanimtype == 5){numberofframes = 7.0f;
		sprintf(barrelanim,"jgbarlexp01.jgbarlexp01");}
		if (barrelanimtype == 6){numberofframes = 12.0f;
		sprintf(barrelanim,"jgbarlexp02.jgbarlexp02");}
		if (barrelanimtype == 7){numberofframes = 27.0f;
		sprintf(barrelanim,"jgbarlexp03.jgbarlexp03");}
		if (barrelanimtype == 8){numberofframes = 7.0f;
		sprintf(barrelanim,"jgbarlexp01.jgbarlexp01");}
		if (barrelanimtype == 9){numberofframes = 12.0f;
		sprintf(barrelanim,"jgbarlexp02.jgbarlexp02");}
		if (barrelanimtype == 10){numberofframes = 27.0f;
		sprintf(barrelanim,"jgbarlexp03.jgbarlexp03");}
		Commands->Set_Animation(obj,barrelanim,true,0,0,numberofframes,0);
		Commands->Start_Timer(obj,this,Commands->Get_Random(0.25f,0.5f),45354);
		Commands->Start_Timer(obj,this,10.0f,45355);
	}
}

void JMG_Random_Explosive_Barrel::Timer_Expired(GameObject *obj,int number)
{
	if (number == 45354)
	{
		Commands->Create_Explosion_At_Bone("Explosion_Barrel_Fuel",obj,"damaged",0);
	}
	if (number == 45355)
	{
		Commands->Apply_Damage(obj,9999.99f,"BlamoKiller",0);
	}
}
void JMG_Random_Explosive_Barrel::Animation_Complete(GameObject *obj,const char *anim)
{
	if (hasbeenhit[2] == 0)
	{
		hasbeenhit[2] = 1;
		char barrelanim[30];
		float numberofframes = 60.0f;
		if (hasbeenhit[1] == 1){numberofframes = 28.0f;
		sprintf(barrelanim,"dsp_metdrum01.dsp_metdrum01");}
		if (hasbeenhit[1] == 2){numberofframes = 15.0f;
		sprintf(barrelanim,"dsp_metdrum02.dsp_metdrum02");}
		if (hasbeenhit[1] == 3){numberofframes = 20.0f;
		sprintf(barrelanim,"dsp_metdrum03.dsp_metdrum03");}
		if (hasbeenhit[1] == 4){numberofframes = 27.0f;
		sprintf(barrelanim,"dsp_metdrum06.dsp_metdrum06");}
		if (hasbeenhit[1] == 5){numberofframes = 7.0f;
		sprintf(barrelanim,"jgbarlexp01.jgbarlexp01");}
		if (hasbeenhit[1] == 6){numberofframes = 12.0f;
		sprintf(barrelanim,"jgbarlexp02.jgbarlexp02");}
		if (hasbeenhit[1] == 7){numberofframes = 27.0f;
		sprintf(barrelanim,"jgbarlexp03.jgbarlexp03");}
		if (hasbeenhit[1] == 8){numberofframes = 7.0f;
		sprintf(barrelanim,"jgbarlexp01.jgbarlexp01");}
		if (hasbeenhit[1] == 9){numberofframes = 12.0f;
		sprintf(barrelanim,"jgbarlexp02.jgbarlexp02");}
		if (hasbeenhit[1] == 10){numberofframes = 27.0f;
		sprintf(barrelanim,"jgbarlexp03.jgbarlexp03");}
		Commands->Set_Animation(obj,barrelanim,true,0,Get_Animation_Frame(obj),numberofframes,0);
		Commands->Create_Explosion_At_Bone("Explosion_Barrel_Fuel",obj,"damaged",0);
	}
	hasbeenhit[2] = 1;
}

/*void JMG_RP2_Crane::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 98752421)
	{
		int x,end = 0;
		for (x = 0;x < 4 && end == 0;x++)
		{
			if (bone[x] == 0)
			{
				char magnetbone[340];
				sprintf(magnetbone,"magnt0%d",x);
				Commands->Attach_To_Object_Bone(sender,obj,magnetbone);
				bone[x] = Commands->Get_ID(sender);
			}
		}
	}
}*/

void JMG_Dont_Be_A_Douche::Created(GameObject *obj)
{
	GameObject *Arrow = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Set_Model(Arrow,"!point");
	Commands->Attach_To_Object_Bone(Arrow,obj,"origin");
	char params[20];
	sprintf(params,"%d",Commands->Get_ID(obj));
	Commands->Attach_Script(Arrow,"JMG_Remove_Object_When_Creator_Destroyed",params);
	MarkerID = Commands->Get_ID(Arrow);
	bulletcount = Get_Current_Bullets(obj);
	clipcount = Get_Current_Clip_Bullets(obj);
	char text[1000];
	sprintf(text,"You have anti spawn-kill protection for %.2f seconds or until you attack.",Get_Float_Parameter("Effect_Time"));
	Send_Message_Player(obj,0,255,64,text);
	AttackerID = 0;
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Effect_Time"),465392);	
	Commands->Start_Timer(obj,this,0.25,465391);
	Commands->Start_Timer(obj,this,1.0,465393);		
	Commands->Start_Timer(obj,this,10.0f,465394);	
}

void JMG_Dont_Be_A_Douche::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 90000028)
	{
		Commands->Start_Timer(obj,this,0.0f,465392);
	}
}

void JMG_Dont_Be_A_Douche::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Is_Script_Attached(damager,"JMG_RP2_Simple_Smart_House_Defense")){return;}
	if (Commands->Get_ID(damager) > 0 && obj != damager && damage)
	{
		GameObject *THEDAMAGER = damager;
		AttackerID = Commands->Get_ID(THEDAMAGER);
		float curpoints = Commands->Get_Points(obj),curmoney = Commands->Get_Money(obj);
		int invehicle = 0;
		if (Commands->Get_ID(Get_Vehicle_Return(damager)) != Commands->Get_ID(damager))
		{
			invehicle = 1;
			Soldier_Transition_Vehicle(damager);
			if (damage >= Commands->Get_Health(damager)+Commands->Get_Shield_Strength(damager))
			{
				char Params[256];
				sprintf(Params,"%d",Commands->Get_ID(damager));
				Commands->Attach_Script(damager,"JMG_RP2_Force_Vehicle_Exit_And_Kill",Params);
			}
		}
		GameObject *Vehicle3 = Get_Vehicle(damager);
		if (Vehicle3)
		{
			Special_Scud_System(Vehicle3);
			if (Is_Script_Attached(Vehicle3,"JMG_Dont_Be_A_Douche"))
			{
				Commands->Apply_Damage(Vehicle3,9999.9f,"BlamoKiller",0);
			}
			else
			{
				Commands->Apply_Damage(Vehicle3,9999.9f,"BlamoKiller",obj);
			}
		}
		if (Is_Script_Attached(THEDAMAGER,"JMG_Dont_Be_A_Douche"))
		{
			Commands->Apply_Damage(THEDAMAGER,(damage * 2.0f),"None",0);
		}
		else
		{
			Commands->Apply_Damage(THEDAMAGER,(damage * 2.0f),"None",obj);
		}
		if (curmoney - Commands->Get_Money(obj) < 0)
		{
			Commands->Give_Money(THEDAMAGER,2*(curmoney - Commands->Get_Money(obj)),1);
		}
		if (curpoints - Commands->Get_Points(obj) < 0)
		{
			Commands->Give_Points(THEDAMAGER,2*(curpoints - Commands->Get_Points(obj)),1);
		}
		if (Commands->Get_Health(obj) > 0 && damage > 0.1f && AttackerID != Commands->Get_ID(THEDAMAGER))
		{
			if (Commands->Is_A_Star(damager))
			{
				Send_Message_Player(THEDAMAGER,255,0,0,"That player just spawned, stop attacking!");
			}
		}
		AttackerID = Commands->Get_ID(THEDAMAGER);
	}
}

void JMG_Dont_Be_A_Douche::Timer_Expired(GameObject *obj,int number)
{
	if (number == 465393)
	{
		Commands->Send_Custom_Event(obj,obj,9110551,1,0);
	}
	if (number == 465392 && MarkerID > 0)
	{
		Commands->Send_Custom_Event(obj,obj,9110550,1,0);
		GameObject *object = Commands->Find_Object(MarkerID);
		if (object)
		{
			Commands->Destroy_Object(object);
		}
		MarkerID = 0;
		Send_Message_Player(obj,0,255,64,"Your anti spawn-kill protection has worn off, be on your guard!");
		Remove_Script(obj,"JMG_Dont_Be_A_Douche");
	}
	if (number == 465391)
	{
		if (bulletcount != Get_Current_Bullets(obj) || clipcount != Get_Current_Clip_Bullets(obj))
		{
			Commands->Start_Timer(obj,this,0.0f,465392);
		}
		Commands->Start_Timer(obj,this,0.25f,465391);	
	}
	if (number == 465394)
	{
		AttackerID = 0;
		Commands->Start_Timer(obj,this,10.0f,465394);	
	}
}

void JMG_Dont_Be_A_Douche::Killed(GameObject *obj,GameObject *damager)
{
	if (MarkerID > 0 && obj != damager)
	{
		GameObject *Marker = Commands->Find_Object(MarkerID);
		if (Marker)
		{
			Commands->Destroy_Object(Marker);
		}
		MarkerID = 0;
		if (Commands->Is_A_Star(damager))
		{
			Send_Message_Player(damager,255,0,0,"Don't Be a Douche!");
		}
	}
}

void JMG_Dont_Be_A_Douche::Destroyed(GameObject *obj)
{
	if (MarkerID > 0)
	{
		GameObject *Marker = Commands->Find_Object(MarkerID);
		if (Marker)
		{
			Commands->Destroy_Object(Marker);
		}
		MarkerID = 0;
	}
}

int JMG_Dont_Be_A_Douche::Special_Scud_System(GameObject *obj)
{
	if (!_stricmp(Commands->Get_Preset_Name(obj),"SCUD_Targeting_Setup"))
	{
		if (SCUD_Missile_Launcher_Node)
		{
			int end = 0;
			SCUD_Missile_Launcher_Control *Current = SCUD_Missile_Launcher_Node;
			while (Current != NULL && end == 0)
			{
				if (Commands->Get_ID(obj) == Current->TargetingSystemID)
				{
					obj = Commands->Find_Object(Current->LauncherID);
					return 1;
				}
				Current = Current->next;
			}
		}
	}
	return 0;
}
void JMG_RP2_Drown_Time_Modifier::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.1f,453131655);
}

void JMG_RP2_Drown_Time_Modifier::Timer_Expired(GameObject *obj,int number)
{
	if (number == 453131655)
	{
		Commands->Send_Custom_Event(obj,obj,5432156,Get_Int_Parameter("Drown_Time"),0);
		Remove_Script(obj,"JMG_RP2_Drown_Time_Modifier");
	}
}

void JMG_Grant_Powerup_To_Vehicle_Owner::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.25,987);
}

void JMG_Grant_Powerup_To_Vehicle_Owner::Timer_Expired(GameObject *obj,int number)
{
	GameObject *owner = Get_Vehicle_Owner(obj);
	if (number == 987 && Commands->Get_ID(owner) > 0)
	{
		int PlayerID = Get_Player_ID(owner);
		int WeaponSize = Get_Int_Parameter("Weapon_Size");
		if (!ISSELECTINGSPAWN[PlayerID] && ((Get_Weapon_Count(owner) < RP2MAXINVENTORYWEAPONLIMIT && (RP2StarCurrentInventorySize[PlayerID] + WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) || (Has_Weapon(owner,Get_Parameter("Weapon_Name")) == 1 && Get_Clip_Bullets(owner,Get_Parameter("Weapon_Name")) < Get_Max_Clip_Bullets(owner,Get_Parameter("Weapon_Name")))))
		{
			if (!Has_Weapon(owner,Get_Parameter("Weapon_Name")))
			{
				RP2StarCurrentInventorySize[PlayerID] += WeaponSize;
			}
			if (Get_Bullets(owner,Get_Parameter("Weapon_Name")) < Get_Max_Bullets(owner,Get_Parameter("Weapon_Name")) && Get_Clip_Bullets(owner,Get_Parameter("Weapon_Name")) > 0)
			{
				const char *weaponpointer = Get_Current_Weapon(owner);
				if (weaponpointer)
				{
					if (!_stricmp(weaponpointer,Get_Parameter("Weapon_Name")))
					{
						Commands->Select_Weapon(owner,"");
						Commands->Select_Weapon(owner,Get_Parameter("Weapon_Name"));
					}
				}
				int transferammount = Get_Max_Bullets(owner,Get_Parameter("Weapon_Name")) - Get_Bullets(owner,Get_Parameter("Weapon_Name"));
				if (Get_Clip_Bullets(owner,Get_Parameter("Weapon_Name")) - transferammount > 0)
				{
					int clipbullettotal = Get_Clip_Bullets(owner,Get_Parameter("Weapon_Name")) - transferammount;
					Set_Clip_Bullets(owner,Get_Parameter("Weapon_Name"),clipbullettotal);
					Set_Bullets(owner,Get_Parameter("Weapon_Name"),Get_Max_Bullets(owner,Get_Parameter("Weapon_Name")));
				}
				else
				{
					Set_Clip_Bullets(owner,Get_Parameter("Weapon_Name"),Get_Bullets(owner,Get_Parameter("Weapon_Name")) + Get_Clip_Bullets(owner,Get_Parameter("Weapon_Name")));
					Set_Bullets(owner,Get_Parameter("Weapon_Name"),0);
				}
			}
			Commands->Give_PowerUp(owner,Get_Parameter("Powerup"),1);
			Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
		}
		else
		{
			Commands->Give_Money(owner,Get_Int_Parameter("Cost")*1.0f,0);
			RP2_Cannot_Grant_Weapon_Reasons(owner,Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name")),1);
		}
		Commands->Destroy_Object(obj);
	}
}

void JMG_Remove_Object_When_Creator_Destroyed::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.25,465391);
	GameObject *Creator = Commands->Find_Object(Get_Int_Parameter("Creator_ID"));
	if (Creator)
	{
		ownerspreset = Commands->Get_Preset_Name(Creator);
	}
	else
	{
		Commands->Destroy_Object(obj);
	}
}

void JMG_Remove_Object_When_Creator_Destroyed::Timer_Expired(GameObject *obj,int number)
{
	GameObject *object = Commands->Find_Object(Get_Int_Parameter("Creator_ID"));
	if (!object || Commands->Get_Health(object) == 0 || _stricmp(Commands->Get_Preset_Name(object),ownerspreset))
	{
		Commands->Set_Model(obj,"null");
		Commands->Destroy_Object(obj);
	}
	else
	{
		Commands->Start_Timer(obj,this,0.25,465391);
	}
}

void JMG_Enable_Flash_Light_On_Pickup::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		Commands->Send_Custom_Event(obj,sender,344373,1,0);
	}
}

// Redid the system, old system caused game wide disconnects 10/27/09
void JMG_RP2_Nod_PT_Zone::Created(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		PlayerID[x] = 0;
	}
	ZoneOccupants = 0;
}

void JMG_RP2_Nod_PT_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		int PlayerIDp = Get_Player_ID(enter);
		CURRENTPLAYERPTZONE[PlayerIDp] = Commands->Get_ID(obj);
		if (ZoneOccupants == 0)
		{
			Commands->Start_Timer(obj,this,0.1f,95959595);
		}
		ZoneOccupants++;
		if (!ISSELECTINGSPAWN[PlayerIDp])
		{
			Commands->Set_Player_Type(enter,0);
		}
		for (int x = 0,end = 0;x < 128 && end == 0;x++)
		{
			if (PlayerIDp == PlayerID[x])
			{
				end = 1;
			}
			else if (PlayerID[x] == 0)
			{
				PlayerID[x] = PlayerIDp;
				end = 1;
			}
		}
	}
}

void JMG_RP2_Nod_PT_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (Commands->Is_A_Star(exit))
	{
		int PlayerIDp = Get_Player_ID(exit);
		if (CURRENTPLAYERPTZONE[PlayerIDp] == Commands->Get_ID(obj))
		{
			CURRENTPLAYERPTZONE[PlayerIDp] = 0;
		}
		if (!ISSELECTINGSPAWN[PlayerIDp])
		{
			ZoneOccupants--;
			for (int x = 0,end = 0;x < 128 && end == 0;x++)
			{
				if (PlayerIDp == PlayerID[x])
				{
					PlayerID[x] = 0;
					Commands->Set_Player_Type(exit,-1);
					end = 1;
				}
			}
		}
		else
		{
			Commands->Send_Custom_Event(obj,exit,51191172,-1,0);
		}
	}
}

void JMG_RP2_Nod_PT_Zone::Timer_Expired(GameObject *obj,int number)
{
	if (number == 95959595)
	{
		for (int x = 0;x < 128;x++)
		{
			if (PlayerID[x] != 0)
			{
				GameObject *Zoner = Get_GameObj(PlayerID[x]);
				if (IsInsideZone(obj,Zoner))
				{
					if (!ISSELECTINGSPAWN[PlayerID[x]])
					{
						if (Get_Player_Type(Zoner) != 0)
						{
							Commands->Set_Player_Type(Zoner,0);
						}
					}
				}
			}
		}
		if (ZoneOccupants > 0)
		{
			Commands->Start_Timer(obj,this,0.01f,95959595);
		}
	}
}

void JMG_RP2_GDI_PT_Zone::Created(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		PlayerID[x] = 0;
	}
	ZoneOccupants = 0;
}

void JMG_RP2_GDI_PT_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		int PlayerIDp = Get_Player_ID(enter);
		CURRENTPLAYERPTZONE[PlayerIDp] = Commands->Get_ID(obj);
		if (ZoneOccupants == 0)
		{
			Commands->Start_Timer(obj,this,0.1f,95959595);
		}
		ZoneOccupants++;
		if (!ISSELECTINGSPAWN[PlayerIDp])
		{
			Commands->Set_Player_Type(enter,1);
		}
		for (int x = 0,end = 0;x < 128 && end == 0;x++)
		{
			if (PlayerIDp == PlayerID[x])
			{
				end = 1;
			}
			else if (PlayerID[x] == 0)
			{
				PlayerID[x] = PlayerIDp;
				end = 1;
			}
		}
	}
}

void JMG_RP2_GDI_PT_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (Commands->Is_A_Star(exit))
	{
		int PlayerIDp = Get_Player_ID(exit);
		if (CURRENTPLAYERPTZONE[PlayerIDp] == Commands->Get_ID(obj))
		{
			CURRENTPLAYERPTZONE[PlayerIDp] = 0;
		}
		if (!ISSELECTINGSPAWN[PlayerIDp])
		{
			ZoneOccupants--;
			for (int x = 0,end = 0;x < 128 && end == 0;x++)
			{
				if (PlayerIDp == PlayerID[x])
				{
					PlayerID[x] = 0;
					Commands->Set_Player_Type(exit,-1);
					end = 1;
				}
			}
		}
		else
		{
			Commands->Send_Custom_Event(obj,exit,51191172,-1,0);
		}
	}
}

void JMG_RP2_GDI_PT_Zone::Timer_Expired(GameObject *obj,int number)
{
	if (number == 95959595)
	{
		for (int x = 0;x < 128;x++)
		{
			if (PlayerID[x] != 0)
			{
				GameObject *Zoner = Get_GameObj(PlayerID[x]);
				if (IsInsideZone(obj,Zoner))
				{
					if (!ISSELECTINGSPAWN[PlayerID[x]])
					{
						if (Commands->Get_Player_Type(Zoner) != 1)
						{
							Commands->Set_Player_Type(Zoner,1);
						}
					}
				}
			}
		}
		if (ZoneOccupants > 0)
		{
			Commands->Start_Timer(obj,this,0.01f,95959595);
		}
	}
}

void JMG_Remove_Object_When_Timer_Expired::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),2453810);
}

void JMG_Remove_Object_When_Timer_Expired::Timer_Expired(GameObject *obj,int number)
{
	if (number == 2453810)
	{
		Commands->Destroy_Object(obj);
	}
}

void JMG_Swimming_Water_Effects_Script::Created(GameObject *obj)
{
	SwimmerID = Get_Int_Parameter("SwimmerID");
	Vector3 pos;
	char params[20];
	sprintf(params,"%d",SwimmerID);
	GameObject *object = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
	Commands->Set_Model(object,Get_Parameter("Surface_Water_Effect"));
	Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
	Commands->Disable_Physical_Collisions(object);
	ObjectID = Commands->Get_ID(object);
	underwater = 0;
	hastriggered = 0;
	Commands->Start_Timer(obj,this,0.1f,453543);
	Commands->Start_Timer(obj,this,0.1f,453544);
}

void JMG_Swimming_Water_Effects_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 345345)
	{
		underwater = 0;
		Commands->Set_Model(Commands->Find_Object(ObjectID),Get_Parameter("Surface_Water_Effect"));
	}
	if (message == 345346)
	{
		underwater = 1;
		Commands->Set_Model(Commands->Find_Object(ObjectID),Get_Parameter("Underwater_Effect"));
	}
	if (message == 345344)
	{
		if (ObjectID > 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(ObjectID));
			ObjectID = 0;
		}
		if (Is_Script_Attached(obj,"JMG_Swimming_Water_Effects_Script"))
		{
			Remove_Script(obj,"JMG_Swimming_Water_Effects_Script");
		}
	}
	if (message == 345347)
	{
		Commands->Attach_To_Object_Bone(Commands->Find_Object(ObjectID),Commands->Find_Object(param),"hadg2");
	}
}

void JMG_Swimming_Water_Effects_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 453543 && Commands->Get_Health(obj) > 0)
	{
		if (Get_Animation_Frame(Commands->Find_Object(SwimmerID)) <= 5)
		{
			if (hastriggered == 0)
			{
				if (underwater == 0)
				{
					Commands->Create_3D_Sound_At_Bone(Get_Parameter("Surface_Swim_Sound"),obj,"origin");
					Commands->Set_Model(Commands->Find_Object(ObjectID),Get_Parameter("Surface_Water_Effect"));
				}
				if (underwater == 1)
				{
					Commands->Create_3D_Sound_At_Bone(Get_Parameter("Underwater_Swim_Sound"),obj,"origin");
				}
			}
			hastriggered = 1;
		}
		else
		{
			if (underwater == 0 && hastriggered == 1)
			{
				Commands->Set_Model(Commands->Find_Object(ObjectID),"null");
			}
			hastriggered = 0;
		}
		Commands->Start_Timer(obj,this,0.1f,453543);
	}
	if (number == 453544 && Commands->Get_Health(obj) > 0)
	{
		Commands->Send_Custom_Event(obj,obj,5432166,1,0);
	}
}

void JMG_Do_Not_Drive_In_Water::Created(GameObject *obj)
{					
	Commands->Start_Timer(obj,this,0.01f,491285);
}

void JMG_Do_Not_Drive_In_Water::Timer_Expired(GameObject *obj,int number)
{
	if (number == 491285)
	{
		Commands->Apply_Damage(obj,Get_Float_Parameter("DamageAmount"),"none",0);
		Commands->Start_Timer(obj,this,0.01f,491285);
	}
}

void JMG_Scuba_Tank_Powerup::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		if (Get_Int_Parameter("Tank_Type") == -1)
		{
			Commands->Send_Custom_Event(obj,sender,5432161,Get_Int_Parameter("Max_Pressure_Add"),0);
		}
		if (Get_Int_Parameter("Tank_Type") == 0) // Force to value
		{
			Commands->Send_Custom_Event(obj,sender,5432160,Get_Int_Parameter("Max_Pressure_Add"),0);
		}
		if (Get_Int_Parameter("Tank_Type") >= 1)
		{
			Commands->Send_Custom_Event(obj,sender,5432158,Get_Int_Parameter("Tank_Type"),0);
			char params[256];
			sprintf(params,"5432159,%d,0.1f,78645,-1",Get_Int_Parameter("Max_Pressure_Add"));
			Commands->Attach_Script(sender,"JMG_Send_Custom_To_Self_On_Timer",params);
		}
	}
}

void JMG_Send_Custom_To_Self_On_Timer::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("Timer_Number"));
}

void JMG_Send_Custom_To_Self_On_Timer::Timer_Expired(GameObject *obj,int number)
{
	if (number == Get_Int_Parameter("Timer_Number"))
	{
		Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),0);
		if (Get_Int_Parameter("Repeat") == 1)
		{
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("Timer_Number"));
		}
		if (Get_Int_Parameter("Repeat") == -1)
		{
			Remove_Script(obj,"JMG_Send_Custom_To_Self_On_Timer");
		}
	}
}

void JMG_RP2_Ferriswheel_Script::Created(GameObject *obj)
{
	/*forward = 1;
	CurrentFrame = 0.0f;
	Commands->Start_Timer(obj,this,0.0,98964);*/
}

void JMG_RP2_Ferriswheel_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 98964)
	{
		if (forward == 1)
		{
			CurrentFrame += 200.0f;
			if (CurrentFrame > 1800)
			{
				forward = 0;
				CurrentFrame -= 400.0f;
				Commands->Static_Anim_Phys_Goto_Frame(Get_Int_Parameter("ID"),CurrentFrame,"ferriswheel.ferriswheel_b");
			}
			else
			{
				Commands->Static_Anim_Phys_Goto_Frame(Get_Int_Parameter("ID"),CurrentFrame,"ferriswheel.ferriswheel_f");
			}
		}
		else if (forward == 0)
		{
			CurrentFrame -= 200.0f;
			if (CurrentFrame < 0)
			{
				forward = 1;
				CurrentFrame += 400.0f;
				Commands->Static_Anim_Phys_Goto_Frame(Get_Int_Parameter("ID"),CurrentFrame,"ferriswheel.ferriswheel_f");
			}
			else
			{
				Commands->Static_Anim_Phys_Goto_Frame(Get_Int_Parameter("ID"),CurrentFrame,"ferriswheel.ferriswheel_b");
			}
		}
		Commands->Start_Timer(obj,this,10.0,98964);
	}
}

void JMG_RP2_Death_Match_PT_Assister::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.1f,465391);
}

void JMG_RP2_Death_Match_PT_Assister::Timer_Expired(GameObject *obj,int number)
{
	GameObject *object = Commands->Find_Object(Get_Int_Parameter("Creator_ID"));
	if (Commands->Get_Health(object) == 0 || Commands->Get_Player_Type(object) != Get_Int_Parameter("Creator_Team"))
	{
		if (Get_Int_Parameter("Creator_Team") == 1)
		{
			Send_Custom_All_Objects_Area(9720441,Commands->Get_Position(obj),0.25,obj,2);
		}
		if (Get_Int_Parameter("Creator_Team") == 0)
		{
			Send_Custom_All_Objects_Area(9720440,Commands->Get_Position(obj),0.25,obj,2);
		}
		Commands->Destroy_Object(obj);
	}
	Commands->Start_Timer(obj,this,0.1f,465391);
}

void JMG_Random_Facing_On_Create::Created(GameObject *obj)
{
	Commands->Set_Facing(obj,Commands->Get_Random(0,360));
}

void JMG_Move_And_Then_Remove_When_Creator_Removed::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.25,465391);
	ownerspreset = Commands->Get_Preset_Name(Commands->Find_Object(Get_Int_Parameter("Creator_ID")));
}

void JMG_Move_And_Then_Remove_When_Creator_Removed::Timer_Expired(GameObject *obj,int number)
{
	GameObject *object = Commands->Find_Object(Get_Int_Parameter("Creator_ID"));
	if (Commands->Get_Health(object) == 0 || _stricmp(Commands->Get_Preset_Name(object),ownerspreset))
	{
		Vector3 pos;
		pos.X = 0.00f;
		pos.Y = 0.00f;
		pos.Z = 10000.00f;
		GameObject *moveobject = Commands->Create_Object("Daves Arrow",pos);
		Commands->Set_Model(moveobject,"null");
		Commands->Attach_To_Object_Bone(obj,moveobject,"origin");
		Commands->Attach_Script(moveobject,"JMG_Remove_Object_When_Timer_Expired","5.0");
		Commands->Attach_Script(obj,"JMG_Remove_Object_When_Timer_Expired","5.0");
	}
	else
	{
		Commands->Start_Timer(obj,this,0.25,465391);
	}
}

void JMG_Create_Object_Attach_Script_Random_Facing::Created(GameObject *obj)
{
	GameObject *object = Commands->Create_Object(Get_Parameter("Preset"),Commands->Get_Position(obj));
	Commands->Set_Facing(obj,Commands->Get_Random(0,360));
	{
		const char *paramx = Get_Parameter("Params");
		char *params = newstr(paramx);
		char delim = Get_Parameter("Delim")[0];
		unsigned int x = strlen(params);
		for (unsigned int i=0;i<x;i++)
		{
			if (params[i] == delim)
			{
				params[i] = ',';
			}
		}
		Commands->Attach_Script(object,Get_Parameter("Script"),params);
		delete params;
	}
	Commands->Destroy_Object(obj);
}

void JMG_RP2_Helicopter_Drop_Off_AI::Created(GameObject *obj)
{
	IHTTP = 0;
	IsHeadingOut = 0;
	ChangeObjectiveCount = 0;
	Vector3 pos = Commands->Get_Position(obj);
	Last_Position = pos;
	Start_Position = pos;
	Commands->Start_Timer(obj,this,1.0f,486781323);
	Commands->Start_Timer(obj,this,600.0f,486781324);
	Commands->Enable_Engine(obj,true);
	Commands->Enable_Hibernation(obj,false);
	Commands->Enable_Vehicle_Transitions(obj,false);
	Commands->Set_Model(obj,"jmgtranswb");
	GameObject *harness = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(harness,obj,"harnesspos");
	Commands->Set_Model(harness,"jmgtranshrns");
	char params[20];
	sprintf(params,"%d",Commands->Get_ID(obj));
	Commands->Attach_Script(harness,"JMG_Remove_Object_When_Creator_Destroyed",params);
	HarnessID = Commands->Get_ID(harness);
	GameObject *vehicle = Commands->Create_Object(Get_Parameter("Vehicle_Preset"),Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(vehicle,obj,"cargospot");
	Commands->Disable_All_Collisions(vehicle);
	Commands->Enable_Engine(vehicle,0);
	VehicleID = Commands->Get_ID(vehicle);
}

void JMG_RP2_Helicopter_Drop_Off_AI::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7854526)
	{
		IHTTP = 1;
		Target_Pos = Commands->Get_Position(sender);
		Target_Pos.Z += 10.0f;
		ActionParamsStruct params;
		params.Set_Basic(this,100,777);
		params.Set_Movement(Target_Pos,1.0f,0,false);
		params.MoveBackup = false;
		Commands->Action_Goto(obj,params);
		IsHeadingOut = 2;
	}
}

void JMG_RP2_Helicopter_Drop_Off_AI::Timer_Expired(GameObject *obj,int number)
{
	if (number == 486781323)
	{
		if (IsHeadingOut == 2)
		{
			ChangeObjectiveCount++;
			if (ChangeObjectiveCount == 10)
			{
				IsHeadingOut = 1;
				ChangeObjectiveCount = 0;
			}
		}
		if (IsHeadingOut == 1)
		{
			// Resume Heading to Target
			if (IHTTP == 0)
			{
				IHTTP = 1;
				ActionParamsStruct params;
				params.Set_Basic(this,100,777);
				params.Set_Movement(Target_Pos,1.0f,0,false);
				params.MoveBackup = false;
				Commands->Action_Goto(obj,params);
			}
			// Check if it gets stuck on the way there
			if (Commands->Get_Distance(Last_Position,Commands->Get_Position(obj)) < 1.0f && IHTTP == 1)
			{
				ChangeObjectiveCount++;
				if (ChangeObjectiveCount >= 2)
				{
					Temp_Target_Pos = Commands->Get_Position(obj);
					IHTTP = 10;
				}
			}
			else if (IHTTP == 1)
			{
				ChangeObjectiveCount = 0;
			}
			// Check if it is  above the target
			if (IHTTP == 1 && abs(Commands->Get_Position(obj).X - Target_Pos.X) < 2.5f && abs(Commands->Get_Position(obj).Y - Target_Pos.Y) < 2.5f)
			{
				IHTTP = 2;
			}
			//Begin Desent and when in range, prepare for drop
			if (IHTTP == 2 && abs(Commands->Get_Position(obj).Z - Target_Pos.Z) < 5.0f)
			{
				IHTTP = 3;
			}
			else if (IHTTP == 2)
			{
				Temp_Target_Pos = Commands->Get_Position(obj);
				Temp_Target_Pos.X = Target_Pos.X;
				Temp_Target_Pos.Y = Target_Pos.Y;
				Temp_Target_Pos.Z -= 10.0f;
				ActionParamsStruct params;
				params.Set_Basic(this,100,777);
				params.Set_Movement(Temp_Target_Pos,1.0f,0,false);
				params.MoveBackup = false;
				Commands->Action_Goto(obj,params);
			}
			//Can't Go down further so prepare for drop
			if (IHTTP == 2 && Commands->Get_Distance(Last_Position,Commands->Get_Position(obj)) < 1.0f)
			{
				ChangeObjectiveCount++;
				if (ChangeObjectiveCount >= 4)
				{
					IHTTP = 3;
					ChangeObjectiveCount = 0;
				}
			}
			// Wait 5 seconds before raising back up into the air
			if (IHTTP == 3)
			{	
				ChangeObjectiveCount++;
				if (ChangeObjectiveCount == 2)
				{
					Commands->Set_Model(obj,"jmgtrans");
					Commands->Set_Animation(Commands->Find_Object(HarnessID),"jmgtranshrns.jmgtranshrns",true,0,0,600,1);
					Commands->Attach_To_Object_Bone(Commands->Find_Object(VehicleID),0,NULL);
					Commands->Enable_Collisions(Commands->Find_Object(VehicleID));
				}
				if (ChangeObjectiveCount >= 5)
				{
					IHTTP = 4;
					ChangeObjectiveCount = 0;
				}
			}
			// Begin Rise then head home
			if (IHTTP == 4 && abs(Commands->Get_Position(obj).Z - Target_Pos.Z) > 200.0f)
			{
				IHTTP = 5;
				ActionParamsStruct params;
				params.Set_Basic(this,100,777);
				params.Set_Movement(Start_Position,1.0f,0,false);
				params.MoveBackup = false;
				Commands->Action_Goto(obj,params);
			}
			else if (IHTTP == 4)
			{
				Temp_Target_Pos = Commands->Get_Position(obj);
				Temp_Target_Pos.X = Target_Pos.X;
				Temp_Target_Pos.Y = Target_Pos.Y;
				Temp_Target_Pos.Z += 10.0f;
				ActionParamsStruct params;
				params.Set_Basic(this,100,777);
				params.Set_Movement(Temp_Target_Pos,1.0f,0,false);
				params.MoveBackup = false;
				Commands->Action_Goto(obj,params);
			}
			// Check if its stuck on the way home
			if (Commands->Get_Distance(Last_Position,Commands->Get_Position(obj)) < 1.0f && IHTTP == 5)
			{
				ChangeObjectiveCount++;
				if (ChangeObjectiveCount >= 3)
				{
					Temp_Target_Pos = Commands->Get_Position(obj);
					IHTTP = 16;
				}
			}
			else if (IHTTP == 5)
			{
				ChangeObjectiveCount = 0;
			}
			// Resume Heading Home
			if (IHTTP == 6)
			{
				IHTTP = 5;
				ActionParamsStruct params;
				params.Set_Basic(this,100,777);
				params.Set_Movement(Start_Position,1.0f,0,false);
				params.MoveBackup = false;
				Commands->Action_Goto(obj,params);
			}
			// Check if it is home
			if (Commands->Get_Distance(Start_Position,Commands->Get_Position(obj)) < 5.0f && IHTTP == 5)
			{
				Commands->Destroy_Object(obj);
			}
			// Stuck Rise Control
			if (IHTTP > 9 && abs((Temp_Target_Pos.Z + 100.0f) - Commands->Get_Position(obj).Z) > 10.0f)
			{
				Vector3 pos = Commands->Get_Position(obj);
				pos.Z += 10.0f;
				ActionParamsStruct params;
				params.Set_Basic(this,100,777);
				params.Set_Movement(pos,1.0f,0,false);
				params.MoveBackup = false;
				Commands->Action_Goto(obj,params);
				if (Commands->Get_Distance(Last_Position,Commands->Get_Position(obj)) < 1.0f)
				{
					ChangeObjectiveCount++;
					if (ChangeObjectiveCount >= 10)
					{
						Vector3 pos = Commands->Get_Position(obj);
						pos.Z += 10;
						Commands->Set_Position(obj,pos);
						ChangeObjectiveCount = 0;
					}
				}
				else
				{
					ChangeObjectiveCount = 0;
				}
			}
			else if (IHTTP > 9)
			{
				IHTTP -= 10;
			}
			// Make sure car still lives
			if (Commands->Get_Health(Commands->Find_Object(VehicleID)) == 0.0f)
			{
				IHTTP = 5;
				ActionParamsStruct params;
				params.Set_Basic(this,100,777);
				params.Set_Movement(Start_Position,1.0f,0,false);
				params.MoveBackup = false;
				Commands->Action_Goto(obj,params);
			}
			Last_Position = Commands->Get_Position(obj);
		}
		Commands->Start_Timer(obj,this,1.0f,486781323);
	}
	if (number == 486781324)
	{
		Commands->Apply_Damage(obj,99999999.99f,"None",0);
	}
}

void JMG_RP2_Helicopter_Drop_Off_AI::Killed(GameObject *obj,GameObject *damager)
{
	if (Commands->Get_Health(Commands->Find_Object(VehicleID)) > 0.0)
	{
		Commands->Enable_Collisions(Commands->Find_Object(VehicleID));
	}
}

void JMG_Helicopter_AI_Beacon::Created(GameObject *obj)
{
	Vector3 pos = Commands->Get_Position(obj);
	pos.Z = 200.0f;
	int x = Commands->Get_Random_Int(0,360),y = Commands->Get_Random_Int(500,600);
	if (Commands->Get_Random(0,9) >= 5)
	{
		y *= -1;
	}
	pos.X += cos(x*PI180)*y;
	if (Commands->Get_Random(0,9) >= 5)
	{
		y *= -1;
	}
	pos.Y += sin(x*PI180)*y;
	object = Commands->Create_Object(Get_Parameter("Preset"),pos);
	Commands->Set_Facing(obj,Commands->Get_Random(0,360));
	{
		const char *paramx = Get_Parameter("Params");
		char *params = newstr(paramx);
		char delim = Get_Parameter("Delim")[0];
		unsigned int len = strlen(params);
		for (unsigned int i=0;i<len;i++)
		{
			if (params[i] == delim)
			{
				params[i] = ',';
			}
		}
		Commands->Attach_Script(object,Get_Parameter("Script"),params);
		delete params;
	}
	Commands->Attach_Script(obj,"JMG_Remove_Object_When_Timer_Expired","10.0");
	Commands->Send_Custom_Event(obj,object,7854526,0,0);
}

void JMG_Buy_Weapon_On_Poke_Advanced::Poked(GameObject *obj,GameObject *poker)
{
	const char *GrantedWeapon = Get_Powerup_Weapon(Get_Parameter("Weapon_Powerup"));
	int PlayerID = Get_Player_ID(poker);
	int WeaponSize = Get_Int_Parameter("Weapon_Size");
	if (!ISSELECTINGSPAWN[PlayerID] && ((Has_Weapon(poker,GrantedWeapon) == 0 && Get_Weapon_Count(poker) < RP2MAXINVENTORYWEAPONLIMIT && (RP2StarCurrentInventorySize[PlayerID] + WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) || (Has_Weapon(poker,GrantedWeapon) == 1 && Get_Max_Clip_Bullets(poker,GrantedWeapon) > Get_Clip_Bullets(poker,GrantedWeapon))))
	{
		if (!Has_Weapon(poker,GrantedWeapon))// Buy Weapon First If You Don't Have it
		{
			if (Get_Int_Parameter("Weapon_Cost") <= Commands->Get_Money(poker))// Check if you have the money
			{
				RP2StarCurrentInventorySize[PlayerID] += WeaponSize;
				Commands->Give_Money(poker,Get_Int_Parameter("Weapon_Cost")*-1.0f,0);
				Commands->Give_PowerUp(poker,Get_Parameter("Weapon_Powerup"),1);
				Commands->Create_Sound(Get_Parameter("Buy_Sound"),Commands->Get_Position(poker),poker);
			}
			else
			{
				char text[2000];
				sprintf(text,"This item costs $%.2f, I need another $%.2f to buy this item.",(float)Get_Int_Parameter("Weapon_Cost"),(float)Get_Int_Parameter("Weapon_Cost") - Commands->Get_Money(poker));
				Send_Message_Player(poker,127,0,0,text);
				Commands->Create_Sound(Get_Parameter("Declined_Sound"),Commands->Get_Position(poker),poker);
			}
		}
		if (Has_Weapon(poker,GrantedWeapon))// You must have the weapon before you can get the bullets
		{
			int GrantBullets = Get_Max_Clip_Bullets(poker,GrantedWeapon) - Get_Clip_Bullets(poker,GrantedWeapon);
			if (!Get_Total_Bullets(poker,GrantedWeapon))
			{
				GrantBullets = Get_Max_Total_Bullets(poker,GrantedWeapon);
			}
			float BulletCost = (float)(GrantBullets * Get_Int_Parameter("Bullet_Cost"));
			if (BulletCost > Commands->Get_Money(poker))// Buy as many shells as you can if you don't have enough to buy full ammo
			{
				GrantBullets = (int)(Commands->Get_Money(poker) / Get_Int_Parameter("Bullet_Cost"));
				BulletCost = (float)(GrantBullets * Get_Int_Parameter("Bullet_Cost"));
			}
			if (GrantBullets)// Buy only if you can get at least one shell
			{
				int GunBullets = Get_Clip_Bullets(poker,GrantedWeapon) + GrantBullets; // Add all your backpack bullets to the powerup's bullets
				int TempCarryOver = 0;
				if (Get_Max_Clip_Bullets(poker,GrantedWeapon) < GunBullets)
				{
					TempCarryOver = GunBullets - Get_Max_Clip_Bullets(poker,GrantedWeapon);
					GunBullets = Get_Max_Clip_Bullets(poker,GrantedWeapon);
				}
				Set_Bullets(poker,GrantedWeapon,Get_Bullets(poker,GrantedWeapon) + TempCarryOver);
				Set_Clip_Bullets(poker,GrantedWeapon,GunBullets);
				Commands->Create_Sound(Get_Parameter("Buy_Sound"),Commands->Get_Position(poker),poker);
			}
			else
			{
				char text[2000];
				sprintf(text,"It costs $%.2f to buy one round for this item, I need another $%.2f to buy a round.",(float)Get_Int_Parameter("Bullet_Cost"),(float)Get_Int_Parameter("Bullet_Cost") - Commands->Get_Money(poker));
				Send_Message_Player(poker,127,0,0,text);
				Commands->Create_Sound(Get_Parameter("Declined_Sound"),Commands->Get_Position(poker),poker);
			}
		}
		Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
	}
	else
	{
		RP2_Cannot_Grant_Weapon_Reasons(poker,Get_WLS_Weapon_Settings(GrantedWeapon),1);
	}
}

void JMG_Buy_Armor_On_Poke_Advanced::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Get_Shield_Strength(poker) < Commands->Get_Max_Shield_Strength(poker))
	{
		float allouteexpenses;
		float shieldtofill = Commands->Get_Max_Shield_Strength(poker) - Commands->Get_Shield_Strength(poker);
		if (shieldtofill < Get_Float_Parameter("Armor_Points_To_Grant"))
		{
			allouteexpenses = shieldtofill * Get_Int_Parameter("Cost_For_1_Armor");
		}
		else
		{
			allouteexpenses = Get_Float_Parameter("Armor_Points_To_Grant") * Get_Int_Parameter("Cost_For_1_Armor");
			shieldtofill = Get_Float_Parameter("Armor_Points_To_Grant");
		}
		if (allouteexpenses <= Commands->Get_Money(poker))
		{
			if (shieldtofill == Get_Float_Parameter("Armor_Points_To_Grant"))
			{
				Commands->Set_Shield_Strength(poker,Commands->Get_Shield_Strength(poker) + Get_Float_Parameter("Armor_Points_To_Grant"));
			}
			else
			{
				Commands->Set_Shield_Strength(poker,Commands->Get_Max_Shield_Strength(poker));
			}
			Commands->Give_Money(poker,allouteexpenses*-1.0f,0);
		}
		else
		{
			char text[2000];
			sprintf(text,"I need $%.2f to get this.",allouteexpenses);
			Send_Message_Player(poker,127,0,0,text);
		}
	}
	else
	{
		Send_Message_Player(poker,127,0,0,"My armor is full.");
	}
}

void JMG_Visible_Infantry_In_Vehicle2::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		GameObject *object = Commands->Find_Object(param);
		const char *mymodel = Get_Model(obj);
		if (!_stricmp(mymodel,"infnc"))// Invisible While Swimming Fix
		{
			Commands->Send_Custom_Event(obj,object,5432172,1,0);
		}
		else
		{
			Commands->Set_Model(object,mymodel);
		}
		Commands->Disable_All_Collisions(object);
		Commands->Set_Animation(object,Get_Parameter("Animation"),true,0,0,-1,0);
		char params[22];
		sprintf(params,"%d",Commands->Get_ID(obj));
		Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
	}
}
//Old Scripts
void JMG_Advanced_Visible_Driver::Created(GameObject *obj)
{
	char message[4000];
	sprintf(message,"MESSAGE WARNING: JMG_Advanced_Visible_Driver attached to %s! Please Replace with JMG_Vehicle_Occupant_Visible_And_Damageable!",Commands->Get_Preset_Name(obj));
	Console_Input(message);
	int r,sc = Get_Vehicle_Seat_Count(obj);
	for(r = 0;r < sc;r++)
	{
		if (idstore[r] > 0)
		{
			idstore[r] = 0;
			idstore2[r] = 0;
		}
	}
	Commands->Start_Timer(obj,this,1.0f,45364530);
}

void JMG_Advanced_Visible_Driver::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		int r, end = 0,sc = Get_Vehicle_Seat_Count(obj);
		for(r = 0;r < sc && end == 0;r++)
		{
			if (idstore[r] == 0)
			{
				if (Get_Int_Parameter("Debug") == 0)
				{
					end = 1;
				}
				GameObject *object = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
				if (Get_Int_Parameter("Driver_Animation") != 0 && r == 0)
				{
					Commands->Send_Custom_Event(obj,sender,Get_Int_Parameter("Driver_Animation"),Commands->Get_ID(object),0);
				}
				else
				{
					Commands->Send_Custom_Event(obj,sender,Get_Int_Parameter("Default_Animation"),Commands->Get_ID(object),0);
				}
				char seatname[100];
				sprintf(seatname,"%s%d",Get_Parameter("BoneName"),r);
				Commands->Attach_To_Object_Bone(object,obj,seatname);
				idstore2[r] = Commands->Get_ID(object);
				idstore[r] = Commands->Get_ID(sender);
			}
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		int r, end = 0,sc = Get_Vehicle_Seat_Count(obj);
		for(r = 0;r < sc && end == 0;r++)
		{
			if (idstore[r] == Commands->Get_ID(sender))
			{
				if (Get_Int_Parameter("Debug") == 0)
				{
					end = 1;
				}
				GameObject *object = Commands->Find_Object(idstore2[r]);
				Commands->Destroy_Object(object);
				idstore[r] = 0;
				idstore2[r] = 0;
			}
		}
	}
}

void JMG_Advanced_Visible_Driver::Timer_Expired(GameObject *obj, int number)
{
	if (number == 45364530)
	{
		if (Is_Stealth(obj))
		{
			int r,sc = Get_Vehicle_Seat_Count(obj);
			for(r = 0;r < sc;r++)
			{
				if (idstore[r] > 0)
				{
					GameObject *object = Commands->Find_Object(idstore2[r]);
					Commands->Destroy_Object(object);
					idstore2[r] = 0;
				}
			}
		}
		else
		{
			int r,sc = Get_Vehicle_Seat_Count(obj);
			for(r = 0;r < sc;r++)
			{
				if (idstore2[r] == 0 && idstore[r] > 0)
				{
					GameObject *object = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
					char seatname[50];
					sprintf(seatname,"%s%d",Get_Parameter("BoneName"),r);
					Commands->Attach_To_Object_Bone(object,obj,seatname);
					if (Get_Int_Parameter("Driver_Animation") != 0 && r == 0)
					{
						Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("Driver_Animation"),Commands->Get_ID(object),0);
					}
					else
					{
						Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("Default_Animation"),Commands->Get_ID(object),0);
					}
					idstore2[r] = Commands->Get_ID(object);
				}
				if (idstore[r] == 0 && idstore2[r] > 0)
				{
					GameObject *object = Commands->Find_Object(idstore2[r]);
					Commands->Destroy_Object(object);
					idstore2[r] = 0;
				}
			}
		}
		Commands->Start_Timer(obj,this,1.0f,45364530);
	}
}

void JMG_Advanced_Visible_Driver::Killed(GameObject *obj, GameObject *shooter)
{
	int r;
	for(r = 0;r < 10;r++)
	{
		if (idstore[r] > 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(idstore2[r]));
			idstore2[r] = 0;
		}
	}
}

void JMG_RP2_Random_Teleport_Zone::Created(GameObject *obj)
{
	Object_ID[0] = Get_Int_Parameter("Object_ID_1");
	Object_ID[1] = Get_Int_Parameter("Object_ID_2");
	Object_ID[2] = Get_Int_Parameter("Object_ID_3");
	Object_ID[3] = Get_Int_Parameter("Object_ID_4");
	Object_ID[4] = Get_Int_Parameter("Object_ID_5");
	int r, end;
	for (r = 0, end = 0;r < 5 && end == 0;r++)
	{
		if (Object_ID[r] == 0)
		{
			Object_ID[5] = r;
			end = 1;
		}
		else if (r == 4)
		{
			Object_ID[5] = 4;
		}
	}
	Object_ID[6] = 10;
}

void JMG_RP2_Random_Teleport_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (!Commands->Is_A_Star(enter))
	{
		return;
	}
	if (Object_ID[5] > 1)
	{
		int x = 0;
		x = Commands->Get_Random_Int(0,Object_ID[5]);
		while (x == Object_ID[6])
		{
			x = Commands->Get_Random_Int(0,Object_ID[5]);
		}
		Send_Custom_All_Objects_Area(91193348,Commands->Get_Position(Commands->Find_Object(Object_ID[x])),1.0f,obj,2);
		RTeleportCall(enter,Commands->Find_Object(Object_ID[x]));
		Object_ID[6] = x;
	}
	else if (Object_ID[5] == 1)
	{
		int x = 0;
		if (Object_ID[6] == 10)
		{
			x = Commands->Get_Random_Int(0,1);
		}
		else if (Object_ID[6] == 1)
		{
			x = 0;
		}
		else if (Object_ID[6] == 0)
		{
			x = 1;
		}
		Send_Custom_All_Objects_Area(91193348,Commands->Get_Position(Commands->Find_Object(Object_ID[x])),1.0f,obj,2);
		RTeleportCall(enter,Commands->Find_Object(Object_ID[x]));
		Object_ID[6] = x;
	}
	else if (Object_ID[5] == 0)
	{
		Send_Custom_All_Objects_Area(91193348,Commands->Get_Position(Commands->Find_Object(Object_ID[0])),1.0f,obj,2);
		RTeleportCall(enter,Commands->Find_Object(Object_ID[0]));
	}
}

void JMG_RP2_Random_Teleport_Zone::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == 91193349)
	{
		Commands->Apply_Damage(sender,9999.99f,"none",0);
	}
}

void JMG_RP2_Random_Teleport_Zone::RTeleportCall(GameObject *obj,GameObject *TargetSpot)
{
	if (!TargetSpot)
	{
		return;
	}
	Vector3 Pos = Commands->Get_Position(TargetSpot);
	Vector3 ExitPos = Pos;
	float Facing = Commands->Get_Facing(TargetSpot);
	PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
	objphys->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Find_Teleport_Location(Pos,1.0f,&ExitPos);
	Commands->Set_Position(obj,ExitPos);
	Vector3 pos = Commands->Get_Bone_Position(obj,"c head");
	pos.X += 20.0f*(cos(Facing*PI180));
	pos.Y += 20.0f*(sin(Facing*PI180));
	GameObject *object = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(object,"null");
	Force_Camera_Look_Player(obj,pos);
	Commands->Send_Custom_Event(obj,obj,70451564,Commands->Get_ID(object),0.1f);
}

//Touched up to work better with new swimming and new spawn system 3/19/2010
void JMG_RP2_Cop_Arrest_Script::Created(GameObject *obj)
{
	Anti_Douche_Active = 0;
}

void JMG_RP2_Cop_Arrest_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 9110550)
	{
		Anti_Douche_Active = 0;
	}
	if (message == 9110551)
	{
		Anti_Douche_Active = 1;
	}
}

void JMG_RP2_Cop_Arrest_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Commands->Get_ID(damager) > 0)
	{
		const char *weaponpointer = Get_Current_Weapon(damager);
		if (weaponpointer)
		{
			if (Commands->Get_Health(obj) > 0 && Commands->Get_ID(damager) != Commands->Get_ID(obj) && !_stricmp(weaponpointer,"Weapon_Handcuffs"))
			{
				if (Commands->Is_A_Star(obj))
				{
					int PlayerID = Get_Player_ID(obj);
					if (ISSELECTINGSPAWN[PlayerID])
					{
						return;
					}
					PHONEZONES[PlayerID] = 1;
					if (ISNEWSWIMMING[PlayerID])
					{
						return;
					}
				}
				Commands->Send_Custom_Event(obj,Commands->Find_Object(102061),91191155,Commands->Get_ID(obj),0);
				if (Anti_Douche_Active == 1)
				{
					Commands->Send_Custom_Event(obj,Commands->Find_Object(102061),91191155,Commands->Get_ID(damager),0);
					Commands->Create_3D_Sound_At_Bone("SFX.door_1s_cell_02",obj,"c head");
					Commands->Create_3D_Sound_At_Bone("SFX.door_1s_cell_02",damager,"c head");
				}
			}
		}
	}
}

void JMG_Jail_Cell_Control::Created(GameObject *obj)
{
	Object_ID[0] = 102056;
	Object_ID[1] = 102057;
	Object_ID[2] = 102058;
	Object_ID[3] = 102059;
	Object_ID[4] = 102060;
	Object_ID[5] = 90;

	GameObject *PhoneTower = Find_Nearest_Preset(Commands->Get_Position(obj),RP2PHONEBOOKPRESET);
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Banking_System","1815,5554000,7,2,1,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Transfer_Funds","1816,5554001,7,2,1,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Sell_House_Phone_Number_Control_System","7896,5553002,7,2.0,1.0,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Player_Call_Tactical_Nuke","");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Player_Special_Phone_Number","");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Buy_Favorite_Vehicle","7860,2.0,1.0,2,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Buy_Favorite_Weapon","7861,2.0,1.0,2,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","1813,555711,6,null,0,0,0,2,0,0,555952,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Teleport_Sender_Player","555952,5047.36 5045.61 -4980.07,90.0");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","18112,9115111,7,null,0,0,0,2,0,0,98482,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Request_Display_Server_Version","98482");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","18113,9115112,7,null,0,0,0,2,0,0,98483,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Request_Object_Count","98483");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","18134,5911,4,null,0,0,0,2,0,0,5559544,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Create_AI_Swarm","5559544,0,1,1");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","181357,5912,4,null,0,0,0,2,0,0,5559546,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Create_AI_Swarm","5559546,0,0,0");//
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","18136,5556666,7,null,0,0,0,2,0,0,5559545,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Create_Preset_At_Sender_Player","5559545,Super_Secret_Vehicle,10.0");//
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","281564,5913,4,null,0,0,0,2,0,0,25453,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Create_AI_Swarm_One","25453,1");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_House_Security_System_Config_Number","95414,5553003,7,2.0,2.0,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Console_Command_On_Custom","452452,win");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","9848465,123453550802,12,null,0,0,0,2,0,0,452452,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Create_Test_Object","45245355");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","9848467,543213550802,12,null,0,0,0,2,0,0,45245355,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Grant_Random_Weapon","4652031");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","984321,5559000,7,Grant a random weapon ($2500),1,0,0,3,-1,2500,4652031,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Server_Remove_PTs_FPS_Improvement_Test","1112345");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","335345,6543213550802,13,null,0,0,0,2,0,0,1112345,0,0,60");
	/*Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","18133,2,1,null,0,0,0,2,0,0,5559523,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","18135,4,1,null,0,0,0,2,0,0,5559524,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Teleport_Sender_Player","5559523,-1172.55 -1024.59 20.29,45.0");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Main_Map_Runtime_Save","");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Mission_System_Mission_Vehicle_Exception","1,RH_Ghost");
	// Phone Test
	//Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Advanced_Phone_Number_Control_System","1812,555711,6,null,0,0,0,1,0,0,555951,0,0,60");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Create_Preset_At_Sender_Player","555951,RH_Ghost,5.0");
	Commands->Attach_Script(PhoneTower,"JMG_RP2_Phone_Create_Preset_At_Sender_Player","5559524,POW_Flash_Light,0.0");*/
}

void JMG_Jail_Cell_Control::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 91191155)
	{
		int x = 0;
		x = Commands->Get_Random_Int(0,4);
		while (x == Object_ID[5])
		{
			x = Commands->Get_Random_Int(0,4);
		}
		Send_Custom_All_Objects_Area(91193348,Commands->Get_Position(Commands->Find_Object(Object_ID[x])),1.0f,obj,2);
		Commands->Set_Position(Commands->Find_Object(param),Commands->Get_Position(Commands->Find_Object(Object_ID[x])));
		Object_ID[5] = x;
	}
}

void JMG_Renhalo_Dart_Gun_Script::Created(GameObject *obj)
{
	DamagerCount = 0;
	Damage = 0;
	DartLauncherID = 0;
	Gun = 0;
}

void JMG_Renhalo_Dart_Gun_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	// Hurt by gun stuff
	if (message == 7546508)
	{
		if (param == 1)
		{
			Damage += 5.0;
		}
		else if (param == 2)
		{
			Damage += -5.0;
		}
	}
	if (message == 7546509 && Commands->Get_Health(obj) > 0)
	{
		TimerTime += 0.1f;
		if (Damage > 0.0)
		{
			Damage -= 0.1f;
		}
		else if (Damage < 0.0)
		{
			Damage += 0.1f;
		}
		{
			GameObject *Player = Get_GameObj(DartLauncherID);
			if (Commands->Get_Health(obj) < Damage && Damage > 0)
			{
				if (Commands->Is_A_Star(obj))
				{
					char DeathMSG[237];
					GameObject *Player = Get_GameObj(DartLauncherID);//Commented out to remove the timer overflow
					if (Player)
					{
						const char *str = Get_Player_Name(obj);
						const char *str2 = Get_Player_Name(Player);
						sprintf(DeathMSG,"%s died from a well-placed shot of neurotoxin from %s.",str,str2);
						delete[] str;
						delete[] str2;
					}
					else
					{
						const char *str = Get_Player_Name(obj);
						sprintf(DeathMSG,"%s died from a neurotoxin.",str);
						delete[] str;
					}
					RP2_Player_Death_Message_Control(obj,DeathMSG,0);
				}
			}
			if (Player)
			{
				Commands->Apply_Damage(obj,Damage,"None",Player);
			}
			else
			{
				Commands->Apply_Damage(obj,Damage,"None",0);
			}
		}
		if (TimerTime < 4.0 && Commands->Get_Max_Shield_Strength(obj) > Commands->Get_Shield_Strength(obj) && !Get_Vehicle(obj))
		{
			Commands->Send_Custom_Event(obj,obj,7546509,DamagerCount,TimerTime);
		}
		else
		{
			Damage = 0;
		}
	}
	//Gun user stuff
	if (!Get_Vehicle(obj))
	{
		if (message == 21511235/* && Gun == 0*/)
		{
			Gun = 1;
			//Commands->Start_Timer(obj,this,2.3,7546509);
		}
		else if (message == 21511236/* && Gun == 0*/)
		{
			Gun = 2;
			//Commands->Start_Timer(obj,this,2.3,7546509);
		}
		if (message == 7546507)
		{
			Commands->Send_Custom_Event(obj,sender,7546508,Gun,0);
			//Gun = 0;
		}
	}
}

void JMG_Renhalo_Dart_Gun_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damager && !damage)
	{// Made it check and make sure that no damage was caused, just to make sure that it was actually caused by the dart gun
		if (Commands->Get_ID(damager) != Commands->Get_ID(obj) && !Get_Vehicle(damager))
		{
			const char *weaponpointer = Get_Current_Weapon(damager);
			if (weaponpointer)
			{
				if(!_stricmp(weaponpointer,"Weapon_Tranquilizer_Gun"))
				{
					DartLauncherID = Get_Player_ID(damager);
					DamagerCount++;
					if (DamagerCount > 200)
					{
						DamagerCount = 0;
					}
					TimerTime = 0.1f;
					Commands->Send_Custom_Event(obj,damager,7546507,0,0);
					Commands->Send_Custom_Event(obj,obj,7546509,DamagerCount,TimerTime);
				}
			}
		}
	}
}

void JMG_Renhalo_Dart_Gun_Script::Timer_Expired(GameObject *obj, int number)
{
	if (number == 7546509)
	{
		Gun = 0;
	}
}

void JMG_Jerad_Energy_Shield::Created(GameObject *obj)
{
	canchargelevel = 0;
	oldhealth = Commands->Get_Health(obj);
	oldshield = Commands->Get_Shield_Strength(obj);
	ChargeObjectID = 0;
	CriticalBeepID = 0;
	WarningBeepID = 0;
	Commands->Start_Timer(obj,this,0.02f,9876522);
	Commands->Start_Timer(obj,this,0.1f,9876521);
}

void JMG_Jerad_Energy_Shield::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 453)
	{
		canchargelevel = 0;
	}
}

void JMG_Jerad_Energy_Shield::Timer_Expired(GameObject *obj, int number)
{
	float currentshield = Commands->Get_Shield_Strength(obj);
	float currenthealth = Commands->Get_Health(obj);
	if (currenthealth)
	{
		float MaxShield = 100.0f;
		if (number == 9876521)
		{
			if (canchargelevel < 40)
			{
				canchargelevel++;
			}
			if (currenthealth < oldhealth || currentshield < oldshield)
			{
				canchargelevel = 0;
				if (ChargeObjectID > 0)
				{
					Commands->Start_Timer(obj,this,0.0f,9876523);
				}
			}
			if (currentshield == MaxShield && ChargeObjectID > 0)
			{
				Commands->Start_Timer(obj,this,0.0f,9876523);
			}
			if (currentshield <= 0 && CriticalBeepID == 0 && ChargeObjectID == 0)
			{
				char params[20];
				sprintf(params,"%d",Commands->Get_ID(obj));
				GameObject *sound = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
				Commands->Set_Model(sound,"null");
				Commands->Attach_To_Object_Bone(sound,obj,"c head");
				Commands->Attach_Script(sound,"JMG_Move_And_Then_Remove_When_Creator_Removed",params);
				Commands->Attach_Script(sound,"RMV_Engine_Sound","Master_Chief_Shield_Beep,origin");
				CriticalBeepID = Commands->Get_ID(sound);
			}
			if (currentshield > 1 && CriticalBeepID > 0)
			{
				Commands->Start_Timer(obj,this,0.0f,9876524);
			}
			if (CriticalBeepID > 0 && ChargeObjectID > 0)
			{
				Commands->Start_Timer(obj,this,0.0f,9876524);
			}
			if (currentshield > 0 && currentshield <= 40 && WarningBeepID == 0 && ChargeObjectID == 0)
			{
				char params[20];
				sprintf(params,"%d",Commands->Get_ID(obj));
				GameObject *sound = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
				Commands->Set_Model(sound,"null");
				Commands->Attach_To_Object_Bone(sound,obj,"c head");
				Commands->Attach_Script(sound,"JMG_Move_And_Then_Remove_When_Creator_Removed",params);
				Commands->Attach_Script(sound,"RMV_Engine_Sound","Master_Chief_Shield_Beep_High,origin");
				WarningBeepID = Commands->Get_ID(sound);
			}
			if ((currentshield > 40 || currentshield < 1) && WarningBeepID > 0)
			{
				Commands->Start_Timer(obj,this,0.0f,9876525);
			}
			if (WarningBeepID > 0 && ChargeObjectID > 0)
			{
				Commands->Start_Timer(obj,this,0.0f,9876525);
			}
			oldhealth = Commands->Get_Health(obj);
			oldshield = Commands->Get_Shield_Strength(obj);
			Commands->Start_Timer(obj,this,0.1f,9876521);
		}
		if (number == 9876522)
		{
			if (canchargelevel == 40 && currentshield < MaxShield)
			{
				Commands->Set_Shield_Strength(obj,Commands->Get_Shield_Strength(obj) + 0.96f);
				if (ChargeObjectID == 0)
				{
					char params[20];
					sprintf(params,"%d",Commands->Get_ID(obj));
					GameObject *sound = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
					Commands->Set_Model(sound,"null");
					Commands->Attach_To_Object_Bone(sound,obj,"c head");
					Commands->Attach_Script(sound,"JMG_Move_And_Then_Remove_When_Creator_Removed",params);
					Commands->Attach_Script(sound,"RMV_Engine_Sound","Master_Chief_Shield_Recharge,origin");
					ChargeObjectID = Commands->Get_ID(sound);
				}
			}
			if (canchargelevel == 40 && currentshield > MaxShield - 0.48)
			{
				Commands->Set_Shield_Strength(obj,MaxShield);
			}
			Commands->Start_Timer(obj,this,0.02f,9876522);
		}
		if (number == 9876523)
		{
			GameObject *sound = Commands->Find_Object(ChargeObjectID);
			if (sound)
			{
				Vector3 pos;
				pos.X = 0.00f;
				pos.Y = 0.00f;
				pos.Z = 10000.00f;
				GameObject *moveobject = Commands->Create_Object("Daves Arrow",pos);
				Commands->Attach_To_Object_Bone(sound,moveobject,"origin");
				Commands->Attach_Script(sound,"JMG_Remove_Object_When_Timer_Expired","1.0");
				Commands->Attach_Script(moveobject,"JMG_Remove_Object_When_Timer_Expired","1.0");
			}
			ChargeObjectID = 0;
		}
		if (number == 9876524)
		{
			GameObject *sound = Commands->Find_Object(CriticalBeepID);
			if (sound)
			{
				Vector3 pos;
				pos.X = 0.00f;
				pos.Y = 0.00f;
				pos.Z = 10000.00f;
				GameObject *moveobject = Commands->Create_Object("Daves Arrow",pos);
				Commands->Attach_To_Object_Bone(sound,moveobject,"origin");
				Commands->Attach_Script(sound,"JMG_Remove_Object_When_Timer_Expired","1.0");
				Commands->Attach_Script(moveobject,"JMG_Remove_Object_When_Timer_Expired","1.0");
			}
			CriticalBeepID = 0;
		}
		if (number == 9876525)
		{
			GameObject *sound = Commands->Find_Object(WarningBeepID);
			if (sound)
			{
				Vector3 pos;
				pos.X = 0.00f;
				pos.Y = 0.00f;
				pos.Z = 10000.00f;
				GameObject *moveobject = Commands->Create_Object("Daves Arrow",pos);
				Commands->Attach_To_Object_Bone(sound,moveobject,"origin");
				Commands->Attach_Script(sound,"JMG_Remove_Object_When_Timer_Expired","1.0");
				Commands->Attach_Script(moveobject,"JMG_Remove_Object_When_Timer_Expired","1.0");
			}
			WarningBeepID = 0;
		}
	}
}

void JMG_Jerad_Energy_Shield::Killed(GameObject *obj,GameObject *damager)
{
	if (ChargeObjectID > 0)
	{
		GameObject *object = Commands->Find_Object(ChargeObjectID);
		if (Commands->Get_Health(object) > 0)
		{
			Commands->Destroy_Object(object);
		}
		ChargeObjectID = 0;
	}
	if (CriticalBeepID > 0)
	{
		GameObject *object = Commands->Find_Object(CriticalBeepID);
		if (Commands->Get_Health(object) > 0)
		{
			Commands->Destroy_Object(object);
		}
		CriticalBeepID = 0;
	}
	if (WarningBeepID > 0)
	{
		GameObject *object = Commands->Find_Object(WarningBeepID);
		if (Commands->Get_Health(object) > 0)
		{
			Commands->Destroy_Object(object);
		}
		WarningBeepID = 0;
	}
}

void JMG_Jerad_Energy_Shield::Destroyed(GameObject *obj)
{
	if (ChargeObjectID > 0)
	{
		GameObject *object = Commands->Find_Object(ChargeObjectID);
		if (Commands->Get_Health(object) > 0)
		{
			Commands->Destroy_Object(object);
		}
		ChargeObjectID = 0;
	}
	if (CriticalBeepID > 0)
	{
		GameObject *object = Commands->Find_Object(CriticalBeepID);
		if (Commands->Get_Health(object) > 0)
		{
			Commands->Destroy_Object(object);
		}
		CriticalBeepID = 0;
	}
	if (WarningBeepID > 0)
	{
		GameObject *object = Commands->Find_Object(WarningBeepID);
		if (Commands->Get_Health(object) > 0)
		{
			Commands->Destroy_Object(object);
		}
		WarningBeepID = 0;
	}
}

void JMG_RP2_Jerad::Created(GameObject *obj)
{
	if (Commands->Is_A_Star(obj))
	{
		Attach_Script_Once(obj,"JMG_RP2_Player_Phone_Control_Script","");
	}
	int PlayerID = Get_Player_ID(obj);
	HASPRINTEDDEATHMESSAGE[PlayerID] = 0;
	RP2StarMaxInventorySize[PlayerID] = (STARTINGINVENTORYSIZE+1);
	RP2StarCurrentInventorySize[PlayerID] = 0;
	Attach_Script_Once(obj,"JMG_Jerad_Energy_Shield","0");
	Commands->Start_Timer(obj,this,0.1f,45252897);
	//Commands->Start_Timer(obj,this,1.0f,45252898);
}

void JMG_RP2_Jerad::Timer_Expired(GameObject *obj, int number)
{	
	if (number == 45252897)
	{
		if (Commands->Is_A_Star(obj))
		{
			Attach_Script_Once(obj,"JMG_New_Swimming_Script","1,1,25,120,0.05,Invisible_Box,newhaadj,Weapon_Empty_Hands,POW_Empty_Hands,Breath_Sound,Gasp_For_Breath_Sound,TankRefillSound,HeartBeatSound,c_ag_civ1_male,null,SwimmingSkin,SwimmingDamage,0,null,null,1");
		}
		Commands->Attach_Script(obj,"JMG_RP2_WLS_Grant_Weapon_Special","Weapon_Radio,-2");
		Commands->Attach_Script(obj,"JMG_RP2_WLS_Grant_Weapon_Special","Weapon_Battering_Ram,-2");
		Commands->Attach_Script(obj,"JMG_RP2_WLS_Grant_Weapon_Special","Weapon_Rocket_Launcher_Halo_Style,-2");
		Commands->Attach_Script(obj,"JMG_RP2_WLS_Grant_Weapon_Special","Weapon_Assult_Rifle,-2");
		Commands->Attach_Script(obj,"JMG_RP2_WLS_Grant_Weapon_Special","Weapon_Tranquilizer_Gun,-2");
		Commands->Attach_Script(obj,"JMG_RP2_WLS_Grant_Weapon_Special","Weapon_Plasma_Torpedo_Launcher,-2");
		Commands->Attach_Script(obj,"JMG_RP2_WLS_Grant_Weapon_Special","Weapon_Particle_Projection_Rifle,-2");
		Commands->Attach_Script(obj,"JMG_RP2_WLS_Grant_Weapon_Special","Weapon_Tactical_Nuke,-2");
		Attach_Script_Once(obj,"JMG_Free_For_All_Script","");
	}
	if (number == 45252898)
	{
		if (Commands->Get_Money(obj) < 99999999)
		{
			Commands->Give_Money(obj,Commands->Get_Random(0.0,10.0f),1);
		}
		Commands->Start_Timer(obj,this,1.0f,45252898);
	}
}

void JMG_Keyboard_Input_Custom_ID_Veh2::Created(GameObject *obj)
{
	InstallHook(Get_Parameter("Key"),obj);
}

void JMG_Keyboard_Input_Custom_ID_Veh2::KeyHook()
{
	Commands->Send_Custom_Event(Owner(),Commands->Find_Object(100334),Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),0);
}

void JMG_Vehicle_Key_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message") && Commands->Get_Health(sender) && Commands->Is_A_Star(sender))
	{
		GameObject *vehicle = Get_Vehicle(obj);
		if (vehicle)
		{
			Commands->Send_Custom_Event(sender,vehicle,Get_Int_Parameter("Send_Message"),param,0);
		}
	}
}

void JMG_Switch_Weapon::Created(GameObject *obj)
{
	if (Get_Float_Parameter("Time") > 0.0f)
	{
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNumber"));
	}
}

void JMG_Switch_Weapon::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		if (Has_Weapon(obj,Get_Parameter("Weapon")) == 1)
		{
			Commands->Select_Weapon(obj,Get_Parameter("Weapon"));
		}
	}
}

void JMG_Switch_Weapon::Timer_Expired(GameObject *obj, int number)
{
	if (number == Get_Int_Parameter("TimerNumber"))
	{
		if (Has_Weapon(obj,Get_Parameter("Weapon")) == 1)
		{
			Commands->Select_Weapon(obj,Get_Parameter("Weapon"));
		}
	}
}

void JMG_Health_Regen_Fixed::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
}

void JMG_Health_Regen_Fixed::Timer_Expired(GameObject *obj,int number)
{
	int timernumber = Get_Int_Parameter("TimerNum");
	float timertime = Get_Float_Parameter("Time"),health;
	if (number == timernumber)
	{
		health = Commands->Get_Health(obj);
		if (health > 0)
		{
			health += Get_Float_Parameter("Points");
			if (health > Commands->Get_Max_Health(obj))
			{
				health = Commands->Get_Max_Health(obj);
			}
			Commands->Set_Health(obj,health);
			Commands->Start_Timer(obj,this,timertime,timernumber);
		}
	}
}

void JMG_Check_Model_Match_Or_Change::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
}

void JMG_Check_Model_Match_Or_Change::Timer_Expired(GameObject *obj,int number)
{
	if (number == Get_Int_Parameter("TimerNum"))
	{
		if (_stricmp(Get_Parameter("Set_Model"),Get_Model(obj)))
		{
			Commands->Set_Model(obj,Get_Parameter("Set_Model"));
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
		}
	}
}

void JMG_RP2_Throw_Script::Created(GameObject *obj)
{
	ObjectID = 0;
}

void JMG_RP2_Throw_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Commands->Get_ID(damager) != 0)
	{
		const char *wptr = Get_Current_Weapon(damager);
		if (wptr)
		{
			char RandThrow[512];
			//if (!_stricmp(wptr,"Weapon_LAW") || !_stricmp(wptr,"Weapon_RPG") || !_stricmp(wptr,"Weapon_Stinger") || !_stricmp(wptr,"Weapon_M1_Abrams") || !_stricmp(wptr,"Weapon_Harrier_Bombs") || !_stricmp(wptr,"Weapon_Hydra") || !_stricmp(wptr,"Weapon_Artillery") || !_stricmp(wptr,"Weapon_T-80_125mm_Cannon"))
			{
				int num = 0;
				if (damage >= Get_Float_Parameter("MinDamageAmount")/* && damage < Get_Float_Parameter("MediumDamageAmount")*/)
				{		
					Vector3 pos = Commands->Get_Position(obj);
					GameObject *object = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
					GameObject *ctb = Commands->Create_Object("GDI_Orca",pos);
					Commands->Disable_Physical_Collisions(object);
					ObjectID = Commands->Get_ID(object);
					
					if (Get_Int_Parameter("Number_Of_Random_Throws") > 1)
					{
						num = Commands->Get_Random_Int(0,(Get_Int_Parameter("Number_Of_Random_Throws") - 1));
					}
					sprintf(RandThrow,"%s%d",Get_Parameter("Models_Throw_Small"),num);
					Commands->Set_Model(object,"smallthrow0");//smallthrow0
					Commands->Set_Model(ctb,"ctb");//smallthrow0
					Commands->Attach_To_Object_Bone(obj,ctb,"origin");
					Commands->Attach_To_Object_Bone(ctb,object,"Box01");
					char ANIMATION[512];
					sprintf(ANIMATION,"%s.%s",RandThrow,RandThrow);
					Commands->Set_Animation(object,"smallthrow0.smallthrow0",true,0,0,-1,1);
				}
				/*else if (damage >= Get_Float_Parameter("MediumDamageAmount") && damage < Get_Float_Parameter("HighDamageAmount"))
				{
					Vector3 pos = Commands->Get_Position(obj);
					GameObject *object = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
					Commands->Attach_To_Object_Bone(obj,object,"AttachThrowBone");
					Commands->Disable_Physical_Collisions(object);
					ObjectID = Commands->Get_ID(object);
					
					if (Get_Int_Parameter("Number_Of_Random_Throws") > 1)
					{
						num = Commands->Get_Random_Int(0,(Get_Int_Parameter("Number_Of_Random_Throws") - 1));
					}
					sprintf(RandThrow,"%s%d",Get_Parameter("Models_Throw_Medium"),num);
					Commands->Set_Model(object,RandThrow);
					char ANIMATION[512];
					sprintf(ANIMATION,"%s.%s",RandThrow,RandThrow);
					Commands->Set_Animation(object,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else if (damage >= Get_Float_Parameter("HighDamageAmount"))
				{
					Vector3 pos = Commands->Get_Position(obj);
					GameObject *object = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
					Commands->Attach_To_Object_Bone(obj,object,"AttachThrowBone");
					Commands->Disable_Physical_Collisions(object);
					ObjectID = Commands->Get_ID(object);
					
					if (Get_Int_Parameter("Number_Of_Random_Throws") > 1)
					{
						num = Commands->Get_Random_Int(0,(Get_Int_Parameter("Number_Of_Random_Throws") - 1));
					}
					sprintf(RandThrow,"%s%d",Get_Parameter("Models_Throw_Large"),num);
					Commands->Set_Model(object,RandThrow);
					char ANIMATION[512];
					sprintf(ANIMATION,"%s.%s",RandThrow,RandThrow);
					Commands->Set_Animation(object,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}*/
			}
		}
	}
}

void JMG_RP2_Teleport_On_Poke::Poked(GameObject *obj,GameObject *poker)
{
	char params[2500];
	Vector3 pos;
	if (Get_Int_Parameter("Object_ID") > 0)
	{
		pos = Commands->Get_Position(Commands->Find_Object(Get_Int_Parameter("Object_ID")));
	}
	else
	{
		pos = Get_Vector3_Parameter("TeleportLocation");
	}
	if (_stricmp("null",Get_Parameter("Poke_Sound")))
	{
		Commands->Create_Sound(Get_Parameter("Poke_Sound"),Commands->Get_Position(obj),obj);
	}
	sprintf(params,"%f,%f,%f,%f,%f,%s,%s,%s,%s,%s",pos.X,pos.Y,pos.Z,Get_Float_Parameter("Enter_Rotation"),Get_Float_Parameter("Exit_Rotation"),Get_Parameter("Enter_Animation"),Get_Parameter("Exit_Animation"),Get_Parameter("Enter_Path_Animation"),Get_Parameter("Exit_Path_Animation"),Get_Parameter("Bone_Attach_Name"));
	Attach_Script_Once(poker,"JMG_RP2_Teleport_Zone_Script_Attach",params);
}

void JMG_RP2_Elevator_Control::Created(GameObject *obj)
{
	isup = 1;
	enabled = 1;
	for(int x = 0;x < 10;x++)
	{
		SwitchArray[x] = 0;
	}
}

void JMG_RP2_Elevator_Control::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Switch_Poked_Message"))
	{
		if (isup == 1 && enabled == 1)
		{
			isup = 0;
			enabled = 0;
			Commands->Static_Anim_Phys_Goto_Last_Frame(Get_Int_Parameter("Elevator_ID"),Get_Parameter("Animation"));
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
			for(int x = 0,end = 0;x < 10 && end == 0;x++)
			{
				if (SwitchArray[x] != 0)
				{
					Commands->Set_Model(Commands->Find_Object(SwitchArray[x]),Get_Parameter("Evtr_Swth_Move_Down_Model"));
				}
			}
		}
		else if (isup == 0 && enabled == 1)
		{
			isup = 1;
			enabled = 0;
			Commands->Static_Anim_Phys_Goto_Frame(Get_Int_Parameter("Elevator_ID"),0.0,Get_Parameter("Animation"));
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
			for(int x = 0,end = 0;x < 10 && end == 0;x++)
			{
				if (SwitchArray[x] != 0)
				{
					Commands->Set_Model(Commands->Find_Object(SwitchArray[x]),Get_Parameter("Evtr_Swth_Move_Up_Model"));
				}
			}
		}
	}
	if (message == Get_Int_Parameter("Add_Switch_Array_Message"))
	{
		for(int x = 0,end = 0;x < 10 && end == 0;x++)
		{
			if (SwitchArray[x] == 0)
			{
				end = 1;
				SwitchArray[x] = param;
			}
		}
	}
}

void JMG_RP2_Elevator_Control::Timer_Expired(GameObject *obj, int number)
{
	if (number == Get_Int_Parameter("TimerNum"))
	{
		enabled = 1;
		if (isup == 1)
		{
			for(int x = 0,end = 0;x < 10 && end == 0;x++)
			{
				if (SwitchArray[x] != 0)
				{
					Commands->Set_Model(Commands->Find_Object(SwitchArray[x]),Get_Parameter("Evtr_Swth_Up_Model"));
				}
			}
		}
		if (isup == 0)
		{
			for(int x = 0,end = 0;x < 10 && end == 0;x++)
			{
				if (SwitchArray[x] != 0)
				{
					Commands->Set_Model(Commands->Find_Object(SwitchArray[x]),Get_Parameter("Evtr_Swth_Down_Model"));
				}
			}
		}
	}
}

void JMG_RP2_Create_Elevator_Switch_Attach_To_Bone::Created(GameObject *obj)
{
	GameObject *object = Commands->Create_Object(Get_Parameter("Create_Object"),Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(object,Commands->Find_Object(Get_Int_Parameter("Attach_To_Object_ID")),Get_Parameter("Attach_Bone"));
	char params[20];
	sprintf(params,"2,%d,%d,1",Commands->Get_ID(obj),Get_Int_Parameter("Poke_Message"));
	Commands->Attach_Script(object,"JFW_Poke_Send_Custom_2",params);
	Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Add_Array_Message"),Commands->Get_ID(object),0);
}

void JMG_Mindless_Zombie_Hunt::Created(GameObject *obj)
{
	CurrentTarget = 0;
	huntorattack = 0;
	waitcount = 0;
	speed = Commands->Get_Random(1.0,1.5);
	homelocation = Commands->Get_Position(obj);
	Commands->Enable_Enemy_Seen(obj,true);
	Commands->Start_Timer(obj,this,0.1f,92562343);
}

void JMG_Mindless_Zombie_Hunt::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	if (CurrentTarget == 0)
	{
		huntorattack = 0;
		CurrentTarget = Commands->Get_ID(seen);
		Commands->Enable_Enemy_Seen(obj,false);
	}
}

void JMG_Mindless_Zombie_Hunt::Timer_Expired(GameObject *obj,int number)
{
	if (92562343 == number)
	{

		if (CurrentTarget > 0)
		{
			if (Commands->Get_Health(Commands->Find_Object(CurrentTarget)) == 0.00f && CurrentTarget > 0)
			{
				waitcount = 0;
				CurrentTarget = 0;
				Commands->Enable_Enemy_Seen(obj,true);
				Commands->Action_Reset(obj,10);
				ActionParamsStruct params;
				params.Set_Basic(this,999,10);
				params.Set_Movement(homelocation,speed,0,false);
				Commands->Action_Goto(obj,params);
			}
			else if (Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(CurrentTarget))) > 200)
			{
				CurrentTarget = 0;
				Commands->Enable_Enemy_Seen(obj,true);
				waitcount = 0;
				if (huntorattack == 1)
				{
					Commands->Action_Reset(obj,10);
				}
			}
			else
			{
				GameObject *target = Commands->Find_Object(CurrentTarget);
				if (Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(target)) > 1.5f)
				{
					waitcount++;
					if (waitcount > 10)
					{
						if (huntorattack != 2)
						{
							huntorattack = 2;
							waitcount = 0;
							Commands->Action_Reset(obj, 10);
						}
						waitcount = 0;
						ActionParamsStruct params;
						params.Set_Basic(this,999,10);
						params.Set_Movement(target,speed,0,0);
						params.MoveFollow = true;
						//params.Set_Movement(Commands->Get_Position(target),speed,0,false);
						Commands->Action_Goto(obj,params);
					}
				}
				else
				{
					if (huntorattack != 1)
					{
						waitcount = 0;
						huntorattack = 1;
						ActionParamsStruct params;
						//Commands->Action_Reset(obj,10);
						params.Set_Basic(this,999,10);
						params.Set_Attack(target,3.0,0,1);
						Commands->Action_Attack(obj,params);
					}
				}
			}
		}
		Commands->Start_Timer(obj,this,0.1f,92562343);
	}
}

void JMG_Mindless_Zombie_Hunt::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (CurrentTarget == 1)
	{
		huntorattack = 0;
		waitcount = 0;
		CurrentTarget = Commands->Get_ID(damager);
	}
}

void JMG_Attach_Script_To_All_Players::Created(GameObject *obj)
{
	const char *paramx = Get_Parameter("Params");
	char *params2 = newstr(paramx);
	char delim = Get_Parameter("Delim")[0];
	unsigned int x = strlen(params2);
	for (unsigned int i=0;i<x;i++)
	{
		if (params2[i] == delim)
		{
			params2[i] = ',';
		}
	}
	params = params2;
	Commands->Start_Timer(obj,this,0.1f,92562443);
}

void JMG_Attach_Script_To_All_Players::Timer_Expired(GameObject *obj, int number)
{
	if (number == 92562443)
	{
		for (SLNode<SoldierGameObj>* node = GameObjManager::StarGameObjList.Head(); (node != NULL); node = node->Next())
		{
			SoldierGameObj *objx = node->Data();
			if (objx)
			{
				if (objx->Get_Player_Data())
				{
					if (((cPlayer *)objx->Get_Player_Data())->IsActive)
					{
						if (Is_Script_Attached(objx,Get_Parameter("Script")) == 0)
						{
							Attach_Script_Once(objx,Get_Parameter("Script"),params);
						}
					}
				}
			}
		}
		Commands->Start_Timer(obj,this,0.1f,92562443);
	}
}

void JMG_Renegade_Mutation_Mode::Created(GameObject *obj)
{
	Players = NULL;
	Count = 0;
	Mutants = 0;
	StartingTeam = 1;
	MinPlayers = 4;
	Start_Override_Time = 3000;
	HasDoneStartCheck = 0;
	IsLastManStanding = 0;
	MutantStartingCharacter = "CnC_Nod_Mutant_0_Mutant";
	MutantStartingCharacterLevel2 = "CnC_Nod_Mutant_1Off_Acolyte";
	MutantStartingCharacterLevel3 = "CnC_Nod_Mutant_2SF_Templar";
	MutantStartingCharacterSpecial1 = "Mutant_3Boss_Petrova";
	MutantStartingCharacterSpecial2 = "Mutant_3Boss_Raveshaw";
	HumanStartingCharacter = "CnC_GDI_MiniGunner_1Off";
	ControllerID = Commands->Get_ID(obj);
	Commands->Start_Timer(obj,this,1.0f,14313952);
	Commands->Start_Timer(obj,this,1.0f,92562143);
	Commands->Start_Timer(obj,this,5.0f,34987324);
	Commands->Start_Timer(obj,this,2.0f,42135245);
	char params[5000];
	sprintf(params,"JMG_Renegade_Mutation_Mode_Infantry_Controller,%d@%d@%d@%d@%d,@",Commands->Get_ID(obj),Get_Int_Parameter("Spawn_Message"),Get_Int_Parameter("Suicide_Message"),Get_Int_Parameter("Killed_Message"),Get_Int_Parameter("Betrayed_Message"));
	Attach_Script_Once(obj,"JMG_Attach_Script_To_All_Players",params);
}

void JMG_Renegade_Mutation_Mode::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (Commands->Get_ID(sender) != Commands->Get_ID(obj))
	{
		if (message == Get_Int_Parameter("Spawn_Message"))
		{
			if (_stricmp(Commands->Get_Preset_Name(sender),MutantStartingCharacter) &&_stricmp(Commands->Get_Preset_Name(sender),MutantStartingCharacterLevel2) &&_stricmp(Commands->Get_Preset_Name(sender),MutantStartingCharacterLevel3) && _stricmp(Commands->Get_Preset_Name(sender),HumanStartingCharacter) && _stricmp(Commands->Get_Preset_Name(sender),MutantStartingCharacterSpecial1) &&_stricmp(Commands->Get_Preset_Name(sender),MutantStartingCharacterSpecial2))
			{
				Creation_Message_Reccived(Commands->Get_ID(sender));
				char message[1000];
				sprintf(message,"MESSAGE Message received");
				Console_Input(message);
			}
		}
		else if (message == Get_Int_Parameter("Suicide_Message"))
		{
			Suicide_Message_Reccived(Commands->Get_ID(sender));
		}
		else if (message == Get_Int_Parameter("Betrayed_Message"))
		{
			Betrayed_Message_Reccived(Commands->Get_ID(sender),param);
		}
		else if (message == Get_Int_Parameter("Killed_Message"))
		{
			Killed_Message_Reccived(Commands->Get_ID(sender),param);
		}
	}
	if (message == 4847372 && HasDoneStartCheck == 0)
	{
		Start_Game();
	}
	/*if (message == Get_Int_Parameter("Spawn_Message"))
	{
		int end = 0;
					char message[1000];
					sprintf(message,"MESSAGE Player %s has committed suicide %d times.",Players->Name,Players->Suicide);
					Console_Input(message);
		while (Players->next != NULL && end == 0)
		{
			if (Players->Name == NULL)
			{
					char message[1000];
					sprintf(message,"MESSAGE Player %s has committed suicide %d times.",Players->Name,Players->Suicide);
					Console_Input(message);
				end = 1;
				struct PlayDataNode *node2 = CreateNode(Get_Player_Name(sender));
				Players = Insert(Players,node2);
				Players->Spawns++;
				Players->next = NULL;
				Players->Count = Count;
				Count++;
			}
			else if (Players->Name != NULL)
			{
				end = 1;
				struct PlayDataNode *node2 = CreateNode(Get_Player_Name(sender));
				Players = Insert(Players,node2);
				Players->Spawns++;
				Players->next = NULL;
				Players->Count = Count;
				Count++;
			}
			else if (!_stricmp(Players->Name,Get_Player_Name(sender)))
			{
				if (Players->Team == 0)
				{
					Change_Character(sender,MutantStartingCharacter);
				}
				Change_Character(sender,HumanStartingCharacter);
				if (Players->Team == 1)
				{
					Players->Spawns++;
					if (Players->Spawns - Players->Betrails > 3 && Players->Team != 0)
					{
						
						if (Get_Team_Player_Count(1) == 2 && Get_Team_Player_Count(0) > 1 )
						{				
							Kill_All_Buildings_By_Team(1);
						}
						else
						{
							Mutants++;
							Players->Team = 0;
							Change_Team_2(sender,0);
							Change_Character(sender,MutantStartingCharacter);
						}
					}
					else if (Players->Betrails > 3 && Players->Team != 0)
					{
						
						if (Get_Team_Player_Count(1) == 2 && Get_Team_Player_Count(0) > 1 )
						{
							Kill_All_Buildings_By_Team(1);
						}
						else
						{
							Mutants++;
							Players->Team = 0;
							Change_Team_2(sender,0);
							Change_Character(sender,MutantStartingCharacter);
						}
					}
					else if (Players->Suicide > 1 && Players->Team != 0)
					{
						
						if (Get_Team_Player_Count(1) == 2 && Get_Team_Player_Count(0) > 1 )
						{
							Kill_All_Buildings_By_Team(1);
						}
						else
						{
							Mutants++;
							Players->Team = 0;
							Change_Team_2(sender,0);
							Change_Character(sender,MutantStartingCharacter);
						}
					}
				}
			}
			else if (Players->next != NULL)
			{
				Players = Players->next;
			}
		}
	}	
	if (message == Get_Int_Parameter("Suicide_Message"))
	{
		int end = 0;
		while (Players->next != NULL && end == 0)
		{
			if (!_stricmp(Players->Name,Get_Player_Name(sender)) == 1)
			{
				end = 1;
				Players->Suicide++;
					char message[1000];
					sprintf(message,"MESSAGE Player %s has committed suicide %d times.",Players->Name,Players->Suicide);
					Console_Input(message);
			}
			Players = Players->next;
		}
	}
	if (message == Get_Int_Parameter("Killed_Message"))
	{
		int end = 0;
		while (Players->next != NULL && end == 0)
		{
			if (!_stricmp(Players->Name,Get_Player_Name(sender)) == 1)
			{
				end = 1;
				Players->Deaths++;
					char message[1000];
					sprintf(message,"MESSAGE Player %s has been killed %d times.",Players->Name,Players->Deaths);
					Console_Input(message);
			}
			Players = Players->next;
		}
	}
	if (message == Get_Int_Parameter("Betrayed_Message"))
	{
		int end = 0;
		while (Players->next == NULL && end == 0)
		{
			if (!_stricmp(Players->Name,Get_Player_Name(sender)) == 1)
			{
				end = 1;
				Players->Betrails++;
					char message[1000];
					sprintf(message,"MESSAGE Player %s has been betrayed %d times.",Players->Name,Players->Betrails);
					Console_Input(message);
			}
			Players = Players->next;
		}
	}*/
}

void JMG_Renegade_Mutation_Mode::Timer_Expired(GameObject *obj, int number)
{
	if (number == 14313952)
	{
		if (IsLastManStanding > 0)
		{
			GameObject *ScorePlayer;
			for (int x = 1;x <= Count;x++)
			{
				ScorePlayer = Get_GameObj((x));
				if (x != IsLastManStanding)
				{
					Commands->Give_Points(ScorePlayer,-1.0,1);
				}
				else
				{
					Commands->Give_Points(ScorePlayer,1.0,1);
				}
			}
		}		
		Commands->Start_Timer(obj,this,1.0f,14313952);
	}
	if (number == 92562143)
	{
		if (HasDoneStartCheck == 0)
		{
			if (Get_Player_Count() >= MinPlayers && Count > 0)
			{
				Start_Game();
				Commands->Start_Timer(obj,this,0.1f,68823496);
				Commands->Start_Timer(obj,this,4.0f,34584377);
				Commands->Start_Timer(obj,this,10.0f,34584377);
			}
			else if (Get_Player_Count() >= 2)
			{
				if (Start_Override_Time == 3000)
				{
					Commands->Start_Timer(obj,this,0.1f,68823496);
					Commands->Start_Timer(obj,this,4.0f,34584377);
					Commands->Start_Timer(obj,this,10.0f,34584377);
				}
				Start_Override_Time--;
				if (Start_Override_Time <= 0)
				{
					Start_Game();
				}
			}
		}
		if (Get_Team_Player_Count(1) == 1 && IsLastManStanding == 0 && HasDoneStartCheck == 1)
		{
			IsLastManStanding = Last_Man_Standing();
		}
		else if (Get_Team_Player_Count(1) > 1 && IsLastManStanding > 0 && HasDoneStartCheck == 1)
		{
			 IsLastManStanding = End_Last_Man_Standing(IsLastManStanding);
		}
		Commands->Start_Timer(obj,this,0.1f,92562143);
	}
	if (number == 34987324)
	{
		PrintNamesandIDs();
		if (HasDoneStartCheck == 0 && Get_Player_Count() >= 2)
		{
			char message[1000];
			sprintf(message,"MESSAGE %d players are in the game, required min players is set to %d, game will start in %.2f reguardless.",Get_Player_Count(),MinPlayers,(Start_Override_Time/600.0f));
			Console_Input(message);
		}
		else if (HasDoneStartCheck == 0 && Get_Player_Count() < 2)
		{
			char message[1000];
			sprintf(message,"MESSAGE At least two players are needed to start a game by timed override!");
			Console_Input(message);
		}
		Commands->Start_Timer(obj,this,10.0f,34987324);
	}
	if (number == 42135245)
	{
		CheckForRelogGlitching();
		Commands->Start_Timer(obj,this,2.0f,42135245);
	}
	if (number == 68823496)
	{
		Disable_Purchase_Terminals(obj);
		Base_Invulnerable();
	}
	if (number == 34584377)
	{
		Remove_Harvesters();
	}
}

void JMG_Renegade_Mutation_Mode::Destroyed(GameObject *obj)
{
	End_Game_Successful();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void JMG_Renegade_Mutation_Mode::Creation_Message_Reccived(int SenderID)
{
	GameObject *sender = Commands->Find_Object(SenderID);
	int end = 0;
	if (!Players)
	{
		end = 1;
		Players = new PlayDataNode;
		Players->next = NULL;
		Players->Name = Get_Player_Name(sender);
		Players->Team = 0;
		Players->Count = Count;
		Players->Spawns = 1;
		Players->Kills = 0;
		Players->Betrails = 0;
		Players->Idle = 0;
		Players->Suicide = 0;
		Players->Score = 0;
		Players->IsSpecial = 0;
		Players->PlayerID = Get_Player_ID(sender);
		Count++;
		Change_Team_2(sender,0);
		Commands->Set_Player_Type(sender,0);
		Change_Character(sender,HumanStartingCharacter);
		char params[1000];
		sprintf(params,"%s,%d,%d","Start_Game_Key",4847372,ControllerID);
		Commands->Attach_Script(sender,"JMG_Renegade_Mutation_Mode_Start_Game_Key",params);
			char message[1000];
			sprintf(message,"MESSAGE NO LIST!");
			Console_Input(message);
	}
	else
	{
		PlayDataNode *Current = Players;
		while (Current != NULL && end == 0)
		{		
			const char *str = Get_Player_Name(sender);
			if (!_stricmp(Current->Name,str))
			{
				char message[1000];
				sprintf(message,"MESSAGE Found: Name: %s Spawns: %d Suicide %d Betrails %d Team: %d",Current->Name,Current->Spawns,Current->Suicide,Current->Betrails,Current->Team);
				Console_Input(message);
				end = 1;
				Default_Spawn_Setup(Current,0);
				if (Current->Count == 0 && HasDoneStartCheck == 0)
				{
					char params[1000];
					sprintf(params,"%s,%d,%d","Start_Game_Key",4847372,ControllerID);
					Commands->Attach_Script(sender,"JMG_Renegade_Mutation_Mode_Start_Game_Key",params);
				}
				if (Current->Team == 1)
				{
					Current->Spawns++;
					if ((Current->Spawns - Current->Betrails - Current->Suicide) > 1)
					{	
						if (Get_Team_Player_Count(1) == 1 && HasDoneStartCheck == 1)
						{				
							End_Game_Successful();
						}
						else
						{
							Current->Team = 0;
							Default_Spawn_Setup(Current,1);
						}
					}
					/*else if (Current->Spawns > 1 && Get_Team_Player_Count(1) == 1)
					{
						End_Game_Successful();
					}*/
					else if (Current->Betrails > 2)
					{
						if (Get_Team_Player_Count(1) == 1 && HasDoneStartCheck == 1)
						{
							End_Game_Successful();
						}
						else
						{
							Current->Team = 0;
							Default_Spawn_Setup(Current,1);
						}
					}
					else if (Current->Suicide > 1)
					{
						if (Get_Team_Player_Count(1) == 1 && HasDoneStartCheck == 1)
						{
							End_Game_Successful();
						}
						else
						{
							Current->Team = 0;
							Default_Spawn_Setup(Current,1);
						}
					}
				}
			}
			delete[] str;
			if (Current->next != NULL)
			{
				Current = Current->next;
			}
			else if (end == 0)
			{
					char message[1000];
					sprintf(message,"MESSAGE Player Not Found! Adding!");
					Console_Input(message);
				end = 1;
				Current->next = new PlayDataNode;
				Current = Current->next; //Switch to new node
				Current->Name = Get_Player_Name(sender);
				Current->Team = StartingTeam;
				Current->Spawns = 1;
				Current->Count = Count;
				Current->Kills = 0;
				Current->Betrails = 0;
				Current->next = NULL;
				Current->Idle = 0;
				Current->Suicide = 0;
				Current->Score = 0;
				Current->IsSpecial = 0;
				Current->PlayerID = Get_Player_ID(sender);
				Count++;
				int startteam = StartingTeam;
				Change_Team_2(sender,startteam);
				Commands->Set_Player_Type(sender,startteam);
				if (startteam == 0)
				{
					Change_Character(sender,MutantStartingCharacter);
					Mutants++;
				}
				else
				{
					Change_Character(sender,HumanStartingCharacter);
				}
			}
		}
	}
}	

void JMG_Renegade_Mutation_Mode::Suicide_Message_Reccived(int SenderID)
{
	GameObject *sender = Commands->Find_Object(SenderID);
	int end = 0;
	PlayDataNode *Current = Players;
	while (Current != NULL && end == 0)
	{
		const char *str = Get_Player_Name(sender);
		if (!_stricmp(Current->Name,str) == 1)
		{
			end = 1;
			Current->Suicide++;
				char message[1000];
				sprintf(message,"MESSAGE Player %s has committed suicide %d times.",Current->Name,Current->Suicide);
				Console_Input(message);
		}
		Current = Current->next;
		delete[] str;
	}
}

void JMG_Renegade_Mutation_Mode::Killed_Message_Reccived(int SenderID,int KillerID)
{
	GameObject *sender = Commands->Find_Object(SenderID);
	GameObject *Killer = Commands->Find_Object(KillerID);
	int end = 0;
	PlayDataNode *Current = Players;
	//Mutant Killed Human
	if (Commands->Get_Player_Type(sender) == 1 && IsLastManStanding == 0)
	{
		while (Current != NULL && end == 0)
		{
			const char *str = Get_Player_Name(sender);
			if (!_stricmp(Current->Name,str) == 1)
			{
				end = 1;
				float points = Commands->Get_Points(sender);
				Commands->Give_Points(sender,-points,1);
				PlayDataNode *Currentk = Players;
				int end2 = 0;
				while (Currentk != NULL && end2 == 0)
				{
					if (!_stricmp(Currentk->Name,Get_Player_Name(Killer)) == 1)
					{
						end2 = 1;
						Currentk->Score += points;
						Currentk->Kills++;
					}
					Currentk = Currentk->next;
				}
			}
			Current = Current->next;
			delete[] str;
		}
	}
	//Mutant Killed The LMS Human
	else if (Commands->Get_Player_Type(sender) == 1 && IsLastManStanding > 0)
	{
		while (Current != NULL && end == 0)
		{
			const char *str = Get_Player_Name(sender);
			if (!_stricmp(Current->Name,str) == 1)
			{
				end = 1;
				float points = Commands->Get_Points(sender);
				Commands->Give_Points(sender,points,1);
				PlayDataNode *Currentk = Players;
				int end2 = 0;
				while (Currentk != NULL && end2 == 0)
				{
					if (!_stricmp(Currentk->Name,Get_Player_Name(Killer)) == 1)
					{
						end2 = 1;
						Currentk->Score += points;
						Currentk->Kills++;
					}
					Currentk = Currentk->next;
				}
			}
			Current = Current->next;
			delete[] str;
		}
	}
	// Mutant Killed By Human
	else if (Commands->Get_Player_Type(sender) == 0)
	{
		while (Current != NULL && end == 0)
		{
			const char *str = Get_Player_Name(sender);
			if (!_stricmp(Current->Name,str) == 1)
			{
				end = 1;
				float points = Current->Score;
				Current->Score = 0;
				Commands->Give_Points(Killer,points,1);
				PlayDataNode *Currentk = Players;
				int end2 = 0;
				while (Currentk != NULL && end2 == 0)
				{
					if (!_stricmp(Currentk->Name,Get_Player_Name(Killer)) == 1)
					{
						end2 = 1;
						Currentk->Kills++;
					}
					Currentk = Currentk->next;
				}
			}
			Current = Current->next;
			delete[] str;
		}
	}
}

void JMG_Renegade_Mutation_Mode::Betrayed_Message_Reccived(int SenderID,int BetrayerID)
{
	GameObject *sender = Commands->Find_Object(SenderID);
	GameObject *betrayer = Commands->Find_Object(BetrayerID);
	int end = 0;
	PlayDataNode *Current = Players;
	while (Current != NULL && end == 0)
	{
		const char *str = Get_Player_Name(sender);
		if (!_stricmp(Current->Name,str) == 1)
		{
			end = 1;
			Current->Betrails++;
				char message[1000];
				sprintf(message,"MESSAGE Player %s has been betrayed %d times.",Current->Name,Current->Betrails);
				Console_Input(message);
		}
		Current = Current->next;
		delete[] str;
	}
	Current = Players;
	while (Current != NULL && end == 0)
	{
		const char *str = Get_Player_Name(betrayer);
		if (!_stricmp(Current->Name,str) == 1)
		{
			end = 1;
			Current->Betrails += 2;
				char message[1000];
				sprintf(message,"MESSAGE Player %s has been betrayed %d times.",Current->Name,Current->Betrails);
				Console_Input(message);
		}
		Current = Current->next;
		delete[] str;
	}
}

void JMG_Renegade_Mutation_Mode::Change_Player_Data_By_Count_ID(int CountID,int NewTeam,int NewSpawns,int NewKills,int NewBetrails,int NewSuicide,int NewIsSpecial)
{
	int end = 0;
	PlayDataNode *Current = Players;
	while (Current != NULL && end == 0)
	{
		if (Current->Count == CountID)
		{
			if (NewTeam != -999){Current->Team = NewTeam;}
			if (NewSpawns != -999){Current->Spawns = NewSpawns;}
			if (NewKills != -999){Current->Kills = NewKills;}
			if (NewBetrails != -999){Current->Betrails = NewBetrails;}
			if (NewSuicide != -999){Current->Suicide = NewSuicide;}
			if (NewIsSpecial != -999){Current->IsSpecial = NewIsSpecial;}
		}
		Current = Current->next;
	}
}

GameObject *JMG_Renegade_Mutation_Mode::FindPlayerByCount(int CountID)
{
	GameObject *Player = Commands->Find_Object(0);
	int end = 0;
	PlayDataNode *Current = Players;
	while (Current != NULL && end == 0)
	{
		if (Current->Count == CountID)
		{
			end = 1;
			Player = Get_GameObj(Current->PlayerID);
		}
		Current = Current->next;
	}
	return Player;
}

void JMG_Renegade_Mutation_Mode::PrintNamesandIDs()
{
	if (Players)
	{
		PlayDataNode *Current = Players;
		while (Current != NULL)
		{
			char message[1000];
			sprintf(message,"MESSAGE %d PlayerName: %s; Player ID: %d",Current->Count,Current->Name,Current->PlayerID);
			Console_Input(message);
			Current = Current->next;
		}
	}
}

void JMG_Renegade_Mutation_Mode::CheckForRelogGlitching()
{
	if (Players)
	{
		PlayDataNode *Current = Players;
		while (Current != NULL)
		{
			if (Commands->Get_Health(Get_GameObj(Current->PlayerID)) == 0.0f)
			{
				if (Current->Team == 0)
				{
					Current->Idle++;
					if (Current->Idle > 5)
					{
						StartingTeam = 0;
					}
				}
			}
			else
			{
				Current->Idle = 0;
			}
			Current = Current->next;
		}
	}
}

void JMG_Renegade_Mutation_Mode::Start_Game()
{
	int x = Commands->Get_Random_Int(0,Count);
	if (x == 0)
	{
		GameObject *Player = FindPlayerByCount(0);
		Change_Player_Data_By_Count_ID(0,0,1,0,0,0,1);
		Commands->Set_Player_Type(Player,0);
	}
	else
	{
		Change_Player_Data_By_Count_ID(x,0,1,0,0,0,1);
		Change_Player_Data_By_Count_ID(0,1,1,0,0,0,0);
		GameObject *Player = FindPlayerByCount(x);
		Commands->Set_Player_Type(Player,0);
		Player = FindPlayerByCount(0);
		Commands->Set_Player_Type(Player,1);
	}
	if (Players)
	{
		PlayDataNode *Current = Players;
		while (Current != NULL)
		{
			GameObject *PrePlayerRunThrough = Get_GameObj(Current->PlayerID);
			Current->Spawns = 0;
			Current->Kills = 0;
			Current->Betrails = 0;
			Current->Idle = 0;
			Current->Suicide = 0;
			Change_Team_2(PrePlayerRunThrough,Current->Team);
			Commands->Set_Player_Type(PrePlayerRunThrough,Current->Team);
			float points = Commands->Get_Points(PrePlayerRunThrough);
			Commands->Give_Points(PrePlayerRunThrough,-points,1);
			Commands->Destroy_Object(PrePlayerRunThrough);
			Current = Current->next;
		}
	}
	HasDoneStartCheck = 1;
	char message[1000];
	sprintf(message,"MESSAGE >>>>>>>>>>>>>>>>>>>>>>>>>THE GAME HAS BEGUN!<<<<<<<<<<<<<<<<<<<<<<<<<");
	Console_Input(message);
}

void JMG_Renegade_Mutation_Mode::Empty_Players_List()
{
	if (Players)
	{
		PlayDataNode *Current = Players;
		while (Players != NULL)
		{
			Current = Players->next;
			delete[] Players->Name;
			delete(Players);
			Players = Current;
		}
		delete[] Players->Name;
		delete(Players);
		if (Players)
		{
			char message[1000];
			sprintf(message,"MESSAGE FAIL!!!! LIST STILL EXISTS!");
			Console_Input(message);
		}
	}
}

void JMG_Renegade_Mutation_Mode::End_Game_Successful()
{
	if (Players)
	{
		PlayDataNode *Current = Players;
		while (Current != NULL)
		{
			GameObject *Player = Get_GameObj(Current->PlayerID);
			Commands->Give_Points(Player,Current->Score,1);
			Current->Score = 0;
			Current = Current->next;
		}
	}
	Kill_All_Buildings_By_Team(0);
	Empty_Players_List();
}

void JMG_Renegade_Mutation_Mode::Default_Spawn_Setup(PlayDataNode *Current,int AddCount)
{
	PlayDataNode *NODE = Current;
	Mutants += AddCount;
	GameObject *obj = Get_GameObj(NODE->PlayerID);
	Commands->Set_Player_Type(obj,NODE->Team);
	int level = 0;
	if (NODE->Kills - NODE->Betrails >= 2 && NODE->Kills - NODE->Betrails < 5)
	{
		level = 1; 
	}
	else if (NODE->Kills - NODE->Betrails >= 5)
	{	
		level = 2; 
	}
	if (NODE->IsSpecial == 1 && NODE->Kills < 5)
	{
		level = 4;
		if (NODE->Kills > 0)
		{
			NODE->IsSpecial = 0;
		}
		else
		{
			level = 3;
		}
	}
	else
	{
		NODE->IsSpecial = 0;
	}
	if (NODE->Team == 0)
	{
		switch (level)
		{
			case 0: 
				Change_Character(obj,MutantStartingCharacter);
				break;
			case 1: 
				Change_Character(obj,MutantStartingCharacterLevel2);
				break;
			case 2: 
				Change_Character(obj,MutantStartingCharacterLevel3);
				break;
			case 3: 
				Change_Character(obj,MutantStartingCharacterSpecial1);
				Set_Max_Health(obj,Commands->Get_Max_Health(obj) * (10.0f * ((Get_Player_Count()*1.0f)/127.0f)));
				Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
				Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj) * (10.0f * ((Get_Player_Count()*1.0f)/127.0f)));
				Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
				break;
			case 4: 
				Change_Character(obj,MutantStartingCharacterSpecial2);
				Set_Max_Health(obj,Commands->Get_Max_Health(obj) * (10.0f * ((Get_Player_Count()*1.0f)/127.0f)));
				Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
				Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj) * (10.0f * ((Get_Player_Count()*1.0f)/127.0f)));
				Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
				break;
			default:
				Change_Character(obj,MutantStartingCharacter);
				break;
		}
	}
	else
	{
		Change_Character(obj,HumanStartingCharacter);
	}
	if (Get_Team(NODE->PlayerID) != NODE->Team)
	{
		Change_Team_2(obj,NODE->Team);
		Commands->Destroy_Object(obj);
	}
}

void JMG_Renegade_Mutation_Mode::Disable_Purchase_Terminals(GameObject *obj)
{
	Vector3 pos;
	pos.X = 0.0;
	pos.X = 0.0;
	pos.X = 1000.0;
	GameObject *GPT = Find_Object_By_Preset(1,"pct_zone_gdi");
	while (GPT)
	{
		Commands->Set_Player_Type(GPT,2);
		Commands->Set_Position(GPT,pos);
		GPT = Find_Object_By_Preset(1,"pct_zone_gdi");
	}
	GameObject *NPT = Find_Object_By_Preset(0,"pct_zone_nod");
	while (NPT)
	{
		Commands->Set_Player_Type(NPT,2);
		Commands->Set_Position(NPT,pos);
		NPT = Find_Object_By_Preset(0,"pct_zone_nod");
	}
}

void JMG_Renegade_Mutation_Mode::Base_Invulnerable()
{
	SLNode<BuildingGameObj> *ABuildingLL = GameObjManager::BuildingGameObjList.Head();
	while (ABuildingLL)
	{
		GameObject *TheBuilding = ABuildingLL->Data();
		if (TheBuilding)
		{
			if (Building_Type(TheBuilding) == 9)
			{
				Commands->Apply_Damage(TheBuilding,9999.999f,"BlamoKiller",0);
			}
			else
			{	
				//(this is to fix the issue with not being able to change the MCT's skin)
				Commands->Attach_Script(TheBuilding,"JMG_Simple_Timed_Heal_Regen","0.1f,34534,1000.0");
				Set_Damage_Points(TheBuilding,0.0f);
				Set_Death_Points(TheBuilding,0.0f);
				Set_Max_Health(TheBuilding,100000000.000);
				Commands->Set_Health(TheBuilding,100000000.000);
				Set_Max_Shield_Strength(TheBuilding,100000000.000);
				Commands->Set_Shield_Strength(TheBuilding,100000000.000);
				//---------------------------------------------------------------------
				Commands->Set_Shield_Type(TheBuilding,"Blamo");
				Set_Skin(TheBuilding,"Blamo");
			}
		}
		ABuildingLL = ABuildingLL->Next();
	}
	GameObject *Nod_Turret = Find_Object_By_Preset(0,"Nod_Turret_MP");
	while (Nod_Turret)
	{
		Commands->Set_Player_Type(Nod_Turret,2);
		Commands->Apply_Damage(Nod_Turret,9999.99f,"BlamoKiller",0);
		Set_Damage_Points(Nod_Turret,0.0f);
		Set_Death_Points(Nod_Turret,0.0f);
		Nod_Turret = Find_Object_By_Preset(0,"Nod_Turret_MP");
	}
}

void JMG_Renegade_Mutation_Mode::Remove_Harvesters()
{
	Vector3 pos;
	pos.X = 0.0;
	pos.X = 0.0;
	pos.X = 1000.0;
	GameObject *Harvester = Find_Object_By_Preset(1,"CnC_GDI_Harvester");
	Commands->Set_Position(Harvester,pos);
	GameObject *Harvester2 = Find_Object_By_Preset(0,"CnC_Nod_Harvester");
	Commands->Disable_All_Collisions(Harvester2);
	Commands->Attach_To_Object_Bone(Harvester2,Harvester,"origin");
}

void JMG_Renegade_Mutation_Mode::Kill_Beacon_Zones(GameObject *obj)
{
	Vector3 pos = Commands->Get_Position(obj);
	GameObject *Zone = Find_Closest_Zone(pos,5);
	while(Zone)
	{
		Commands->Destroy_Object(Zone);
		Zone = Find_Closest_Zone(pos,5);
	}
}

int JMG_Renegade_Mutation_Mode::Last_Man_Standing()
{
	GameObject *LastMan = 0;
	if (Players)
	{
		int end = 0;
		PlayDataNode *Current = Players;
		while (Current != NULL && end == 0)
		{
			if (Commands->Get_Player_Type(Get_GameObj(Current->PlayerID)) == 1)
			{
				end = 1;
				LastMan = Get_GameObj(Current->PlayerID);
			}
		}
		Current = Players;
		while (Current != NULL && end == 0)
		{
			Set_Obj_Radar_Blip_Shape_Player(LastMan,Get_GameObj(Current->PlayerID),5);
		}
	}
	char message[1000];
	const char *str = Get_Player_Name(LastMan);
	sprintf(message,"MESSAGE %s is the last man standing!",str);
	delete[] str;
	Console_Input(message);
	return Get_Player_ID(LastMan);
}

int JMG_Renegade_Mutation_Mode::End_Last_Man_Standing(int XLastManID)
{
	GameObject *LastMan = Get_GameObj(XLastManID);
	if (Players)
	{
		int end = 0;
		PlayDataNode *Current = Players;
		while (Current != NULL && end == 0)
		{
			Set_Obj_Radar_Blip_Shape_Player(LastMan,Get_GameObj(Current->PlayerID),2);
		}
	}
	char message[1000];
	sprintf(message,"MESSAGE Another player has joined your ranks, you are no longer the LMS!");
	Console_Input(message);
	return 0;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

void JMG_Renegade_Mutation_Mode_Infantry_Controller::Created(GameObject *obj)
{
	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Controller_ID")),Get_Int_Parameter("Spawn_Message"),1,0);
}

void JMG_Renegade_Mutation_Mode_Infantry_Controller::Killed(GameObject *obj,GameObject *damager)
{
	if (Commands->Get_Health(damager) > 0.000)
	{
		if (Commands->Get_ID(damager) == 0)
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Controller_ID")),Get_Int_Parameter("Suicide_Message"),1,0);
		}
		else if (Commands->Get_Player_Type(obj) != Commands->Get_Player_Type(damager))
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Controller_ID")),Get_Int_Parameter("Killed_Message"),Commands->Get_ID(damager),0);
		}
		else
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Controller_ID")),Get_Int_Parameter("Betrayed_Message"),Commands->Get_ID(damager),0);
		}
	}
}

void JMG_Renegade_Mutation_Mode_Start_Game_Key::Created(GameObject *obj)
{
	InstallHook(Get_Parameter("Key"),obj);
}

void JMG_Renegade_Mutation_Mode_Start_Game_Key::KeyHook()
{
	Commands->Send_Custom_Event(Owner(),Commands->Find_Object(Get_Int_Parameter("ID")),Get_Int_Parameter("Message"),0,0);
}

void JMG_Simple_Timed_Heal_Regen::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
}

void JMG_Simple_Timed_Heal_Regen::Timer_Expired(GameObject *obj,int number)
{
	int TimerNumber = Get_Int_Parameter("TimerNum");
	if (TimerNumber == number)
	{
		Commands->Apply_Damage(obj,-1*Get_Float_Parameter("Add_Life"),"blamokiller",0);
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),TimerNumber);
	}
}

/*void JMG_RP2_Submarine_Script::Created(GameObject *obj)
{
	Vector3 pos;
	GameObject *object = Commands->Create_Object("Daves Arrow",pos);
	GameObject *object2 = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(object,"hoverplate");
	Commands->Set_Model(object2,"invisiblenc");
	Commands->Attach_To_Object_Bone(object2,obj,"origin");
	Hover_Pos = Commands->Get_ID(object);
	SoundID = Commands->Get_ID(object2);
	cancollide = 1;
	Pinging = 0;
	Commands->Start_Timer(obj,this,0.1f,542423);
	Commands->Start_Timer(obj,this,0.25f,542424);
	Commands->Start_Timer(obj,this,0.5f,542425);
	Commands->Start_Timer(obj,this,0.75f,542426);
	Vector3 pos2 = Commands->Get_Position(obj);
	pos2.Z += 100.0f;
	Commands->Set_Position(obj,pos2);
	int set;
	for (set = 0;set < 10;set++)
	{
		idstore[set] = 0;
	}
	for (set = 0;set < 5;set++)
	{
		colornfog[set] = 0;
	}
}

void JMG_RP2_Submarine_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 542423)
	{
		GameObject *object = Commands->Find_Object(Hover_Pos);
		GameObject *object2 = Commands->Find_Object(SoundID);
		Vector3 raiseheight = Commands->Get_Position(obj);
		if (Is_In_Water != 0 && Pinging == 0)
		{
			Pinging = 1;
			Commands->Set_Model(object2,"Sub_Ping");
		}
		else if (Is_In_Water == 0 && Pinging == 1)
		{
			Pinging = 0;
			Commands->Set_Model(object2,"invisiblenc");
		}
		if (Get_Vehicle_Occupant_Count(obj) == 0 && raiseheight.Z < -22.165)
		{
			raiseheight.Z += 0.1f;
			Commands->Set_Position(obj,raiseheight);
		}
		Vector3 pos = Commands->Get_Position(obj);
		if (pos.Z < -30 && cancollide == 1)
		{
			Commands->Set_Model(object,"invisiblenc");
			cancollide = 0;
		}
		else if (cancollide == 0)
		{
			Commands->Set_Model(object,"subblock");
			cancollide = 1;
		}
		pos.Z = -17.25;//-22.165 is the sub's highest point in the water
		Commands->Set_Position(object,pos);
		Commands->Set_Facing(object,Commands->Get_Facing(obj));
		Commands->Start_Timer(obj,this,0.1f,542423);
	}
	if (number == 542424)
	{
		Is_In_Water = 0;
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z -= 100.0f;
		Commands->Set_Position(obj,pos);
	}
	if (number == 542425)
	{
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z -= 5.0f;
		Commands->Set_Position(obj,pos);
	}
	if (number == 542426)
	{
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z += 5.0f;
		Commands->Set_Position(obj,pos);
	}
}

void JMG_RP2_Submarine_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		int r, end = 0;
		for(r = 0;r < 10 && end == 0;r++)
		{
			if (idstore[r] == 0)
			{
				end = 1;
				idstore[r] = Commands->Get_ID(sender);
			}
		}
		Commands->Send_Custom_Event(obj,sender,90000028,-1,0);
		if (Is_In_Water > 0)
		{
			Set_Screen_Fade_Color_Player(sender,colornfog[0],colornfog[1],colornfog[2],0);
			Set_Screen_Fade_Opacity_Player(sender,95,0);
			Set_Fog_Range_Player(sender,150,200,0);
		}
		else
		{	
			Commands->Send_Custom_Event(sender,Commands->Find_Object(133700),987123546,1,0);
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		int r, end = 0;
		for(r = 0;r < 10 && end == 0;r++)
		{
			if (idstore[r] == Commands->Get_ID(sender))
			{
				end = 1;
				GameObject *exiter = Commands->Find_Object(idstore[r]);
				idstore[r] = 0;
				Commands->Send_Custom_Event(exiter,Commands->Find_Object(133700),987123546,1,0);
				Commands->Send_Custom_Event(obj,exiter,90000029,0,0);
				Commands->Set_Player_Type(exiter,-1);
				idstore[r] = 0;
			}
		}
		//Commands->Enable_Engine(obj,1);
		Commands->Send_Custom_Event(obj,sender,90000029,1,0);
	}
	if (message == 347361)
	{
		Is_In_Water++;
		if (Is_In_Water == 1)
		{
			Commands->Send_Custom_Event(obj,sender,53133154,1,0);
			Commands->Send_Custom_Event(obj,sender,53133148,Commands->Get_ID(obj),0);
		}
	}
	if (message == 347360)
	{
		Is_In_Water--;
		if (Is_In_Water == 0)
		{
			int sc = Get_Vehicle_Seat_Count(obj);
			for (int r = 0;r < sc;r++)
			{
				GameObject *Player = Get_Vehicle_Occupant(obj,r);
				Commands->Send_Custom_Event(Player,Commands->Find_Object(133700),987123546,1,0);
			}
		}
	}
	if (message == 912397343)
	{
		if (Commands->Get_ID(sender) == Commands->Get_ID(Get_Vehicle_Driver(obj)))
		{
			Commands->Start_Timer(obj,this,0.0f,24534534);
		}
		else if (Commands->Get_ID(Get_Vehicle_Driver(obj)) == 0 && Commands->Get_ID(sender) == Commands->Get_ID(Get_Vehicle_Gunner(obj)))
		{
			Commands->Start_Timer(obj,this,0.0f,24534534);
		}
		else if (Commands->Get_ID(Get_Vehicle_Gunner(obj)) == 0 && Commands->Get_ID(Get_Vehicle_Driver(obj)) == 0)
		{
			Commands->Start_Timer(obj,this,0.0f,24534534);
		}
	}
	if (message == 53133140){colornfog[0] = param/100.0f;}
	if (message == 53133141){colornfog[1] = param/100.0f;}
	if (message == 53133142){colornfog[2] = param/100.0f;}
	if (message == 53133146){colornfog[3] = param*1.0f;}
	if (message == 53133147)
	{
		colornfog[4] = param*1.0f;
		int sc = Get_Vehicle_Seat_Count(obj);
		for (int r = 0;r < sc;r++)
		{
			GameObject *Player = Get_Vehicle_Occupant(obj,r);
			Set_Screen_Fade_Color_Player(Player,colornfog[0],colornfog[1],colornfog[2],0);
			Set_Screen_Fade_Opacity_Player(Player,95,0);
			Set_Fog_Range_Player(Player,150,200,0);
		}
	}
}

void JMG_RP2_Submarine_Script::Destroyed(GameObject *obj)
{
	GameObject *object = Commands->Find_Object(Hover_Pos);
	Commands->Destroy_Object(object);
	object = Commands->Find_Object(SoundID);
	Commands->Destroy_Object(object);
	int r;
	for(r = 0;r < 10;r++)
	{
		if (idstore[r] > 0)
		{
			GameObject *apassenger = Commands->Find_Object(idstore[r]);
			idstore[r] = 0;
			Commands->Send_Custom_Event(obj,apassenger,90000029,1,0);
			Commands->Set_Player_Type(apassenger,-1);
		}
	}
}
*/

void JMG_RP2_Submarine_Script::Created(GameObject *obj)
{
	char Message[2000];
	sprintf(Message,"MESSAGE Warning: JMG_RP2_Submarine_Script is no longer in use, yet vehicle preset %s is using it, please correct this.",Commands->Get_Preset_Name(obj));
	Console_Input(Message);
}

void JMG_Player_Path_Creator::Created(GameObject *obj)
{
	lines = 0;
	canwrite = 1;
	file = fopen("temppath.jmg","w");
	fflush(file);
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","FPath,324");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","FOWPath,325");
	Commands->Start_Timer(obj,this,0.1f,12322);
}

void JMG_Player_Path_Creator::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 324 && canwrite == 1)
	{
		canwrite = 0;
		fclose(file);
		FILE *newfile;
		FILE *readfile;
		char filename[256];
		sprintf(filename,"%s Path File ID %d.txt",The_Game()->Get_Map_Name().Peek_Buffer(),Commands->Get_Random_Int(0,999999));
		newfile = fopen(filename,"w");
		readfile = fopen("temppath.jmg","r");
		fprintf(newfile,"%d\n",lines);
		fflush(newfile);
		const char *str = Get_Player_Name(obj);
		fprintf(newfile,"%s\n",str);
		delete[] str;
		fflush(newfile);
		float X,Y,Z;
		for (int x = 0;x < lines;x++)
		{
			fscanf(readfile,"%f %f %f",&X,&Y,&Z);
			fprintf(newfile,"%0.3f %0.3f %0.3f\n",X,Y,Z);
			fflush(newfile);
		}
		fclose(readfile);
		fclose(newfile);
		remove("temppath.jmg");
		char messag[1000];
		sprintf(messag,"MESSAGE Path Complete, file named \"%s\" Please send it to \"rp2pathproject@live.com\" either through e-mail or msn if on-line (msn prefered).",filename);
		Console_Input(messag);
	}
	if (message == 325 && canwrite == 1)
	{
		canwrite = 0;
		fclose(file);
		FILE *newfile;
		FILE *readfile;
		char filename[256];
		sprintf(filename,"%s Path File ID %d.txt",The_Game()->Get_Map_Name().Peek_Buffer(),Commands->Get_Random_Int(0,999999));
		newfile = fopen(filename,"w");
		readfile = fopen("temppath.jmg","r");
		fprintf(newfile,"%d\n",lines);
		fflush(newfile);
		const char *str = Get_Player_Name(obj);
		fprintf(newfile,"%s\n",str);
		delete[] str;
		fflush(newfile);
		float X,Y,Z;
		for (int x = 0;x < lines;x++)
		{
			fscanf(readfile,"%f %f %f",&X,&Y,&Z);
			fprintf(newfile,"%0.3f %0.3f %0.3f\n",X,Y,Z);
			fflush(newfile);
		}
		fprintf(newfile,"-10.5656 -10.5656 -10.5656\n");
		fflush(newfile);
		fclose(readfile);
		fclose(newfile);
		remove("temppath.jmg");
		char messag[1000];
		sprintf(messag,"MESSAGE Path Complete, file named \"%s\" Please send it to \"rp2pathproject@live.com\" either through e-mail or msn if on-line (msn prefered).",filename);
		Console_Input(messag);
	}
}

void JMG_Player_Path_Creator::Timer_Expired(GameObject *obj,int number)
{
	if (number == 12322 && canwrite == 1)
	{
		lines++;
		Vector3 pos = Commands->Get_Position(obj);
		fprintf(file,"%0.3f %0.3f %0.3f\n",pos.X,pos.Y,pos.Z);
		fflush(file);
		Commands->Start_Timer(obj,this,0.1f,12322);
	}
}

void JMG_RP2_AI_Path_Controller::Created(GameObject *obj)
{
	maxdifferent = 8;
	for (int x = 0;x < maxdifferent;x++)
	{
		for (int y = 0;y < 500;y++)
		{
			X[x][y] = 0;
			Y[x][y] = 0;
			Z[x][y] = 0;
		}
	}	
	for (int x = 0;x < 10;x++)
	{
		AIID[x] = 0;
		AIPath[x] = 0;
	}
	FILE *readfile;
	readfile = fopen(Get_Parameter("Path File"),"r");
	int x = 0, y = 0;
	float X2,Y2,Z2;
	char name[1000];
	int numoflines;
	fscanf(readfile,"%s",name);
	fscanf(readfile,"%s",name);
	fscanf(readfile,"%s",name);
	fscanf(readfile,"%s",name);
	fscanf(readfile,"%s",name);
	fscanf(readfile,"%s",name);
	fscanf(readfile,"%d",&numoflines);
	while (x > -1)
	{
		fscanf(readfile,"%f %f %f",&X2,&Y2,&Z2);
		if (X2 == -92959.00592 && Y2 == -92959.00592 && Z2 == -92959.00592)
		{
			X[x][y] = X2;
			Y[x][y] = Y2;
			Z[x][y] = Z2;
			y = 0;
			x++;
			fscanf(readfile,"%s",name);
			fscanf(readfile,"%d",&numoflines);
			if (!_stricmp(name,"&*^endoffile*^&#"))
			{
				x = -1;
			}
		}
		else
		{
			X[x][y] = X2;
			Y[x][y] = Y2;
			Z[x][y] = Z2;
		}
		y++;
	}
	fclose(readfile);
}

void JMG_RP2_AI_Path_Controller::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 9474327 && param == 0)
	{
		Vector3 pos;
		int Rand = Commands->Get_Random_Int(0,maxdifferent);
		pos.X = X[Rand][0];
		pos.Y = Y[Rand][0];
		pos.Z = Z[Rand][0];
		pos.Z += 2.0f;
		Commands->Set_Position(sender,pos);
		pos.X = X[Rand][1];
		pos.Y = Y[Rand][1];
		pos.Z = Z[Rand][1];
		GameObject *createobject = Commands->Create_Object("Daves Arrow",pos);
		Commands->Send_Custom_Event(obj,sender,9474327,Commands->Get_ID(createobject),0);
		for (int x = 0,end = 0;x < 10 && end == 0;x++)
		{
			if (AIID[x] == 0)
			{
				end = 1;
				AIID[x] = Commands->Get_ID(sender);
				AIPath[x] = Rand;
			}
		}
	}
	else if (message == 9474327 && param != 0)
	{
		int Rand = 0;
		GameObject *object;
		for (int x = 0,end = 0;x < 10 && end == 0;x++)
		{
			if (AIID[x] == Commands->Get_ID(sender))
			{
				end = 1;
				object = Commands->Find_Object(AIID[x]);
				Rand = AIPath[x];
			}
		}
		Vector3 pos;
		int spot = param++;
		if (X[Rand][spot] != -92959.00592 && Y[Rand][spot] != -92959.00592 && Z[Rand][spot] != -92959.00592)
		{
			pos.X = X[Rand][spot];
			pos.Y = Y[Rand][spot];
			pos.Z = Z[Rand][spot];
			GameObject *createobject = Commands->Create_Object("Daves Arrow",pos);
			Commands->Send_Custom_Event(obj,sender,9474327,Commands->Get_ID(createobject),0);
		}
	}
	if (message == 9474328)
	{
		for (int x = 0,end = 0;x < 10 && end == 0;x++)
		{
			if (AIID[x] == Commands->Get_ID(sender))
			{
				AIID[x] = 0;
				end = 1;
			}
		}
	}
}

void JMG_RP2_Follow_User_Made_Path_AI::Created(GameObject *obj)
{
	CurrentTarget = 0;
	huntorattack = 0;
	waitcount = 0;
	spot = 0;
	lastdistance = 0;
	lastdistancenochagewait = 0;
	waitingnextpos = 1;
	GoToLocation = Commands->Get_Position(obj);
	Commands->Enable_Enemy_Seen(obj,true);
	Commands->Start_Timer(obj,this,0.1f,92562143);
}

void JMG_RP2_Follow_User_Made_Path_AI::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	if (CurrentTarget == 0 && Is_Script_Attached(seen,"JMG_Dont_Be_A_Douche") == 0 && (Get_Current_Weapon(obj)))
	{
		huntorattack = 0;
		CurrentTarget = Commands->Get_ID(seen);
		Commands->Enable_Enemy_Seen(obj,false);
	}
	else if (CurrentTarget == Commands->Get_ID(seen))
	{
		waitcount = 0;
	}
}

void JMG_RP2_Follow_User_Made_Path_AI::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 9474327 && param != 0)
	{
		waitingnextpos = 0;
		GameObject *Target = Commands->Find_Object(param);
		GoToLocation = Commands->Get_Position(Target);
		Commands->Destroy_Object(Target);
		ActionParamsStruct params;
		params.Set_Basic(this,999,10);
		params.Set_Movement(GoToLocation,1.0,0.0,false);
		Commands->Action_Goto(obj,params);
		huntorattack = 0;
	}
}

void JMG_RP2_Follow_User_Made_Path_AI::Timer_Expired(GameObject *obj,int number)
{
	if (92562143 == number)
	{
		if (CurrentTarget != 0)
		{
			waitcount++;
			if (huntorattack == 0)
			{
				GameObject *Target = Commands->Find_Object(CurrentTarget);
				waitcount = 0;
				Commands->Action_Reset(obj,10);
				huntorattack = 1;
				ActionParamsStruct params;
				params.Set_Basic(this,999,10);
				params.Set_Attack(Target,300.0f,0.0f,1);
				Commands->Action_Attack(obj,params);
			}
			if (waitcount == 10)
			{
				Commands->Enable_Enemy_Seen(obj,true);
			}
			if (waitcount >= 20)
			{
				waitcount = 0;
				Commands->Action_Reset(obj,10);
				CurrentTarget = 0;
				ActionParamsStruct params;
				params.Set_Basic(this,999,10);
				params.Set_Movement(GoToLocation,1.0,0.0,false);
				Commands->Action_Goto(obj,params);
				huntorattack = 0;
			}
		}
		if (Commands->Get_Position(obj).X == GoToLocation.X && Commands->Get_Position(obj).Y == GoToLocation.Y && Commands->Get_Position(obj).Z == GoToLocation.Z && waitingnextpos == 0)
		{
			waitingnextpos = 1;
			spot++;
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Controller_ID")),9474327,spot,0);
		}
		float distance = Commands->Get_Distance(Commands->Get_Position(obj),GoToLocation);
		if (distance == lastdistance && huntorattack == 0 && waitingnextpos == 0)
		{
			lastdistancenochagewait++;
			if (lastdistancenochagewait > 20)
			{
				lastdistancenochagewait = 0;
				waitingnextpos = 1;
				spot++;
				Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Controller_ID")),9474327,spot,0);
			}
		}
		else
		{
			lastdistancenochagewait = 0;
			lastdistance = distance;
		}
		Commands->Start_Timer(obj,this,0.1f,92562143);
	}
}

void JMG_RP2_Follow_User_Made_Path_AI::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (CurrentTarget == 1 && (Get_Current_Weapon(obj)))
	{
		huntorattack = 0;
		waitcount = 0;
		CurrentTarget = Commands->Get_ID(damager);
	}
}

void JMG_RP2_Follow_User_Made_Path_AI::Destroyed(GameObject *obj)
{
	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Controller_ID")),94743278,1,0);
}

void JMG_Single_Player_Only_Script::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.1f,435345);
}

void JMG_Single_Player_Only_Script::Timer_Expired(GameObject *obj,int number)
{
	if (435345 == number)
	{
		int MessageAllowed = 0;
		if (Get_Player_Count() > 1)
		{
			MessageAllowed = 1;
		}
		if (MessageAllowed == 1)
		{
			MessageAllowed = 0;
			for (SLNode<SoldierGameObj>* node = GameObjManager::StarGameObjList.Head(); (node != NULL); node = node->Next())
			{
				SoldierGameObj *objx = node->Data();
				if (objx)
				{
					if (objx->Get_Player_Data())
					{
						if (((cPlayer *)objx->Get_Player_Data())->IsActive)
						{
							GameObject *object = Commands->Create_Object("Invisiblebox",Commands->Get_Position(obj));
							MessageAllowed = 0;
							Set_Screen_Fade_Color_Player(objx,0.0f,0.0f,0.0f,0);
							Set_Screen_Fade_Opacity_Player(objx,1.0f,0);
							Commands->Attach_To_Object_Bone(object,objx,"origin");
							Commands->Clear_Weapons(objx);
							Send_Message_Player(objx,255,0,0,"Sorry, this map only allows 1 person to play on it at a time,\n please quit and rehost the game with a max player count of 1.");
						}
					}
				}
			}
		}
		else
		{
			Commands->Start_Timer(obj,this,0.1f,435345);
		}
	}
}

/*void JMG_AI_Artillery_Targeting::Created(GameObject *obj)
{
	AngleRange[36];
	float speed = 25.0;
	float degree = 0;
	float height = 0;
	float Gravity = 0;
	maxdistance = 0;
	for (int x = 0;x < 36;x++)
	{
		float distance = Gravity/(speed*sin(degree)+sqrt((0.5*(speed*speed))(1-cos(degree))-(2*Gravity*(0-height))));
		AngleRange[x] = distance;
		if (distance > maxdistance)
		{
			maxdistance = distance;
		}
	}
}


void JMG_AI_Artillery_Targeting::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	float Angle;
	enemydistance = Commands->Get_Distance(Commands->Get_Position(seen),Commands->Get_Position(obj));
	if (enemydistance < maxdistance && !(seen->As_PhysicalGameObj() && seen->As_PhysicalGameObj()->Peek_Physical_Object() && seen->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
	{
		Commands->Select_Weapon(obj,Get_Parameter("Dummy_Weapon"));
		ActionParamsStruct params;
		params.Set_Attack(seen,maxdistance,0,1);
		Commands->Action_Attack(obj,params);
		for (int x = 0,end = 0;x < 36 && end == 0;x++)
		{
			if (enemydistance < AngleRange[x])
			{
				end = 1;
				Angle = x - 1;
			}
		}
		Vector3 pos;
		pos.X = Commands->Get_Position(obj).X + sin(Commands->Get_Facing(facingobject))*1.0;
		pos.Y = Commands->Get_Position(obj).Y + cos(Commands->Get_Facing(facingobject))*1.0;
		pos.Z = Commands->Get_Position(obj).Z + tan(Angle)*1.0;
		Commands->Select_Weapon(obj,Get_Parameter("Primary_Weapon"));
		GameObject *targetspot = Commands->Create_Object("Daves Arrow",pos);
		params.Set_Attack(targetspot,maxdistance,0,1);
		Commands->Action_Attack(obj,params);
	}
}
*/
void JMG_Set_Position_On_Create::Created(GameObject *obj)
{
	Commands->Set_Position(obj,Get_Vector3_Parameter("Position"));
}

void JMG_RP2_Chinook_Door_Control::Created(GameObject *obj)
{
	Commands->Set_Animation(obj,"v_chinook.v_chinook",false,0,0,15,false);
	Commands->Start_Timer(obj,this,0.1f,234765);
}

void JMG_RP2_Chinook_Door_Control::Timer_Expired(GameObject *obj,int number)
{
	if (number == 234765)
	{
		if (Get_Vehicle_Occupant_Count(obj) > 0)
		{
			int sc = Get_Vehicle_Seat_Count(obj);
			for(int r = 0,end = 0;r < sc && end == 0;r++)
			{
				GameObject *object = Get_Vehicle_Occupant(obj,r);
				if (Commands->Get_ID(object) > 0)
				{
					if (Commands->Get_Player_Type(object) == 1)
					{
						Commands->Set_Animation(obj,"v_chinook.v_chinook",false,0,Get_Animation_Frame(obj),0,false);
						//Commands->Enable_Vehicle_Transitions(obj,1);
					}
					else
					{
						Commands->Set_Animation(obj,"v_chinook.v_chinook",false,0,Get_Animation_Frame(obj),15,false);
						//Commands->Enable_Vehicle_Transitions(obj,0);
					}
				}
			}
		}
		else
		{
			Commands->Set_Animation(obj,"v_chinook.v_chinook",false,0,Get_Animation_Frame(obj),0,false);
			//Commands->Enable_Vehicle_Transitions(obj,1);
		}
		Commands->Start_Timer(obj,this,0.1f,234765);
	}
}

void JMG_RP2_Vehicle_Animate_While_Firing::Created(GameObject *obj)
{
	const char *model = Get_Model(obj);
	sprintf(Animation,"%s.%s",model,model);
	if (Get_Current_Weapon(obj))
	{
		oldbullets = Get_Bullets(obj,Get_Current_Weapon(obj));
	}
	Commands->Start_Timer(obj,this,0.1f,393837);
}

void JMG_RP2_Vehicle_Animate_While_Firing::Timer_Expired(GameObject *obj,int number)
{
	if (number == 393837)
	{
		if (Get_Current_Weapon(obj))
		{
			int bullets = Get_Bullets(obj,Get_Current_Weapon(obj));
			if (bullets != oldbullets)
			{
				Commands->Set_Animation(obj,Animation,false,0,0,-1,false);
			}
			else
			{
				Commands->Set_Animation(obj,Animation,false,0,0,0,false);
			}
			oldbullets = bullets;
		}
		Commands->Start_Timer(obj,this,0.1f,393837);
	}
}

void JMG_RP2_Air_Craft_Cloud_Script::Created(GameObject *obj)
{
	EngineEnabled = 1;
	NumberOfClouds = 0;
	for (int x = 0;x < 10;x++)
	{
		CloudID[x] = 0;
	}
	Commands->Start_Timer(obj,this,1.0f,34532);
}

void JMG_RP2_Air_Craft_Cloud_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 34532)
	{
		float Zpos = Commands->Get_Position(obj).Z;
		if (Zpos > 1500.0f && EngineEnabled)
		{
			EngineEnabled = 0;
			Commands->Enable_Engine(obj,0);
		}
		else if (Zpos < 1400 && !EngineEnabled && Get_Vehicle_Driver(obj))
		{
			EngineEnabled = 1;
			Commands->Enable_Engine(obj,1);
		}
		if (Zpos > 450.0f)
		{
			int clouddiff = (((int)Zpos - 200)/50) - NumberOfClouds;
			if (clouddiff != NumberOfClouds)
			{
				if (clouddiff > 0)
				{
					for (int x = 0,end = 0;x < 10 && end == 0;x++)
					{
						if (CloudID[x] == 0)
						{
							clouddiff--;
							if (clouddiff <= 0)
							{
								end = 1;
							}
							NumberOfClouds++;
							GameObject *object = Commands->Create_Object("Daves Arrow",Vector3(0,0,0));
							Commands->Set_Model(object,"null");
							Commands->Attach_To_Object_Bone(object,obj,"origin");
							CloudID[x] = Commands->Get_ID(object);
						}
					}
				}
				else if (clouddiff < 0)
				{
					for (int x = NumberOfClouds,end = 0;x >= 0 && end == 0;x--)
					{
						if (CloudID[x] != 0)
						{
							clouddiff++;
							if (clouddiff >= 0)
							{
								end = 1;
							}
							NumberOfClouds--;
							Commands->Destroy_Object(Commands->Find_Object(CloudID[x]));
							CloudID[x] = 0;
						}
					}
				}
			}
		}
		else if (NumberOfClouds)
		{
			for (int x = NumberOfClouds,end = 0;x >= 0 && end == 0;x--)
			{
				if (CloudID[x] != 0)
				{
					GameObject *Cloud = Commands->Find_Object(CloudID[x]);
					if (Cloud)
					{
						Commands->Destroy_Object(Cloud);
					}
					CloudID[x] = 0;
				}
			}
			NumberOfClouds = 0;
		}
		Commands->Start_Timer(obj,this,1.0f,34532);
	}
}

void JMG_RP2_Air_Craft_Cloud_Script::Killed(GameObject *obj,GameObject *damager)
{
	for (int x = 0;x < 10;x++)
	{
		if (CloudID[x] != 0)
		{
			GameObject *Cloud = Commands->Find_Object(CloudID[x]);
			if (Cloud)
			{
				Commands->Destroy_Object(Cloud);
			}
			CloudID[x] = 0;
		}
	}
}

void JMG_RP2_Air_Craft_Cloud_Script::Destroyed(GameObject *obj)
{
	for (int x = 0;x < 10;x++)
	{
		if (CloudID[x] != 0)
		{
			GameObject *Cloud = Commands->Find_Object(CloudID[x]);
			if (Cloud)
			{
				Commands->Destroy_Object(Cloud);
			}
			CloudID[x] = 0;
		}
	}
}

void JMG_Swimming_Under_Water_Effects_Control::Created(GameObject *obj)
{
	PlantID = 0;
	oldpos = Commands->Get_Position(obj);
	Commands->Start_Timer(obj,this,0.1f,23432);
	Commands->Start_Timer(obj,this,2.0f,23433);
	enabled = 1;
	const char *model = Get_Model(obj);
	sprintf(Animation,"%s.%s",model,model);
	sprintf(Animation2,"%s.%s",Get_Parameter("Underwater_Plant_Emitter"),Get_Parameter("Underwater_Plant_Emitter"));
	toggle = 0;
}

void JMG_Swimming_Under_Water_Effects_Control::Timer_Expired(GameObject *obj,int number)
{
	if (number == 23432)
	{
		Vector3 pos = Commands->Get_Position(obj);
		float ZBoneDistance = abs(Commands->Get_Bone_Position(obj,"WheelP00F").Z);
		if ((ZBoneDistance <= 300.0f) && (abs(Commands->Get_Bone_Position(obj,"WheelP01F").Z) > Get_Float_Parameter("Plant_Start_Depth")) && enabled == 1)
		{
			if (PlantID != 0)
			{
				Vector3 plantpos = Commands->Get_Position(obj);
				plantpos.X += Commands->Get_Random(-300,300);
				plantpos.Y += Commands->Get_Random(-300,300);
				plantpos.Z = Commands->Get_Safe_Flight_Height(plantpos.X,plantpos.Y);
				Commands->Set_Position(Commands->Find_Object(PlantID),plantpos);
			}
			else
			{
				char params[20];
				sprintf(params,"%d",Commands->Get_ID(obj));
				GameObject *object = Commands->Create_Object("Invisible_Box_NR",Vector3(0,0,0));
				Commands->Set_Model(object,Get_Parameter("Underwater_Plant_Emitter"));
				Commands->Set_Animation(object,Animation2,0,0,1.0f,1.0f,0);
				Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
				PlantID = Commands->Get_ID(object);
			}
			Commands->Start_Timer(obj,this,0.1f,23432);
		}
		else
		{
			if (PlantID != 0)
			{
				Commands->Destroy_Object(Commands->Find_Object(PlantID));
			}
			Commands->Start_Timer(obj,this,0.1f,23432);
		}
		oldpos = pos;
	}
	
	if (number == 23433)
	{
		char mess[2000];			
		sprintf(mess,"MESSAGE %f %f %f",abs(Commands->Get_Bone_Position(obj,"WheelP00F").Z),abs(Commands->Get_Bone_Position(obj,"WheelP01F").Z),Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Bone_Position(obj,"WheelP02F")));
		Console_Input(mess);
		Commands->Start_Timer(obj,this,2.0f,23433);
	}
}

void JMG_Swimming_Under_Water_Effects_Control::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 8474460)
	{
		enabled = 0;
	}
	if (message == 8474461)
	{
		enabled = 1;
	}
}

void JMG_Change_Armor_Type_On_Timer::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
}

void JMG_Change_Armor_Type_On_Timer::Timer_Expired(GameObject *obj,int number)
{
	if (number == Get_Int_Parameter("TimerNum"))
	{
		Commands->Set_Shield_Type(obj,Get_Parameter("ArmorType"));
	}
}

void JMG_Simple_Prone_On_Custom::Created(GameObject *obj)
{
	IsProne = 0;
	animationcomplete = 0;
	Commands->Start_Timer(obj,this,1.0,(Get_Int_Parameter("TimerNum")+2));
}

void JMG_Simple_Prone_On_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("ProneMessage"))
	{	
		if (!Get_Vehicle(obj))
		{
			if (IsProne == 0 && Get_Fly_Mode(obj) == 0)
			{
				animationcomplete = 0;
				IsProne = 2;
				float lastframe = Get_Float_Parameter("LastFrame");
				float time = (Get_Float_Parameter("LastFrame")/30.0f) + 0.1f;
				Commands->Start_Timer(obj,this,time,Get_Int_Parameter("TimerNum"));
				if (Get_Int_Parameter("ReverseGoProneAnimaton") == 0)
				{
					Commands->Set_Animation(obj,Get_Parameter("GotoProneAnimation"),true,0,0,0,0);
					Commands->Set_Animation(obj,Get_Parameter("GotoProneAnimation"),true,0,0,lastframe,0);
				}
				else
				{
					Commands->Set_Animation(obj,Get_Parameter("GotoProneAnimation"),true,0,lastframe,lastframe,0);
					Commands->Set_Animation(obj,Get_Parameter("GotoProneAnimation"),true,0,lastframe,0,0);
				}
			}
			else if (IsProne == 1)
			{
				IsProne = 2;
				float lastframe = Get_Float_Parameter("LastFrame");
				float time = (Get_Float_Parameter("LastFrame")/30.0f) + 0.1f;
				Commands->Start_Timer(obj,this,time,(Get_Int_Parameter("TimerNum")+1));
				Vector3 pos = Commands->Get_Position(obj);
				pos.Z -= Get_Float_Parameter("ZMoveAmount");
				Commands->Set_Position(obj,pos);
				if (Get_Fly_Mode(obj) == 1)
				{
					Toggle_Fly_Mode(obj);
				}
				if (Get_Int_Parameter("ReverseGoProneAnimaton") == 1)
				{
					Commands->Set_Animation(obj,Get_Parameter("GotoProneAnimation"),true,0,0,0,0);
					Commands->Set_Animation(obj,Get_Parameter("GotoProneAnimation"),true,0,0,lastframe,0);
				}
				else
				{
					Commands->Set_Animation(obj,Get_Parameter("GotoProneAnimation"),true,0,lastframe,lastframe,0);
					Commands->Set_Animation(obj,Get_Parameter("GotoProneAnimation"),true,0,lastframe,0.0f,0);
				}
			}
		}
	}
}

void JMG_Simple_Prone_On_Custom::Animation_Complete(GameObject *obj,const char *anim)
{
	if (!_stricmp(anim,Get_Parameter("GotoProneAnimation")))
	{
		animationcomplete = 1;
		Commands->Set_Loiters_Allowed(obj,false);
	}
	if (IsProne == 1 && Commands->Get_Health(obj) > 0.0f)
	{
		Commands->Set_Animation(obj,Get_Parameter("ProneAnimation"),true,0,0.0f,-1,0);
		Commands->Set_Animation(obj,Get_Parameter("ProneAnimation"),true,0,0.0f,-1,0);
	}
}

void JMG_Simple_Prone_On_Custom::Timer_Expired(GameObject *obj,int number)
{
	if (number == Get_Int_Parameter("TimerNum"))
	{
		if (animationcomplete == 1 && IsProne == 2)
		{
			animationcomplete = 0;
			Vector3 pos = Commands->Get_Position(obj);
			pos.Z += Get_Float_Parameter("ZMoveAmount");
			Commands->Set_Position(obj,pos);
			Commands->Set_Animation(obj,Get_Parameter("ProneAnimation"),true,0,0,-1,0);
			if (Get_Fly_Mode(obj) == 0)
			{
				Toggle_Fly_Mode(obj);
			}
			IsProne = 1;
		}
		else
		{
			IsProne = 0;
		}
	}
	if (number == (Get_Int_Parameter("TimerNum")+1))
	{
		IsProne = 0;
		Commands->Set_Loiters_Allowed(obj,true);
	}
	if (number == (Get_Int_Parameter("TimerNum")+2))
	{
		if (IsProne == 1)
		{
			Commands->Set_Animation(obj,Get_Parameter("ProneAnimation"),true,0,0.0f,-1,0);
			Toggle_Fly_Mode(obj);
			Commands->Set_Animation(obj,Get_Parameter("ProneAnimation"),true,0,0.0f,-1,0);
			if (Get_Fly_Mode(obj) == 0)
			{
				Toggle_Fly_Mode(obj);
			}
		}
		Commands->Start_Timer(obj,this,1.0,(Get_Int_Parameter("TimerNum")+2));
	}
}

void JMG_Enter_Console_Command_On_Create::Created(GameObject *obj)
{
	const char *message = Get_Parameter("ConsoleMessage1");
	if (message[0] != '0')
	{
		Console_Input(message);
	}
	message = Get_Parameter("ConsoleMessage2");
	if (message[0] != '0')
	{
		Console_Input(message);
	}
	message = Get_Parameter("ConsoleMessage3");
	if (message[0] != '0')
	{
		Console_Input(message);
	}
	message = Get_Parameter("ConsoleMessage4");
	if (message[0] != '0')
	{
		Console_Input(message);
	}
	message = Get_Parameter("ConsoleMessage5");
	if (message[0] != '0')
	{
		Console_Input(message);
	}
}

void JMG_Swimming_Underwater_Effect_Script::Created(GameObject *obj)
{
	isvisible = 0;
	Vector3 oldpos = Commands->Get_Position(obj);
	GameObject *object = Commands->Create_Object("Daves Arrow",oldpos);
	if (Get_Float_Parameter("Random_Effect_Placement_Distance") == 0.0)
	{
		Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("Attach_Bone_Name"));
	}
	Commands->Set_Model(object,"null");
	EffectID = Commands->Get_ID(object);
}

void JMG_Swimming_Underwater_Effect_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 453543)// NO NEED TO DECLAIR TIMER
	{
		float Zpos = Commands->Get_Position(obj).Z;
		if (Zpos < Get_Float_Parameter("Effect_Enable_Depth") && (Get_Float_Parameter("Effect_Enable_Depth") <= Get_Float_Parameter("Effect_Disable_Depth") || Zpos > Get_Float_Parameter("Effect_Disable_Depth")))
		{
			if (!isvisible)
			{
				isvisible = 1;
				Commands->Set_Model(Commands->Find_Object(EffectID),Get_Parameter("Effect_W3D_Name"));
			}
			float REPD = Get_Float_Parameter("Random_Effect_Placement_Distance");
			if (REPD != 0.0)
			{
				Vector3 effectpos = Commands->Get_Position(obj);
				effectpos.X += Commands->Get_Random(-REPD,REPD);
				effectpos.Y += Commands->Get_Random(-REPD,REPD);
				if (Get_Int_Parameter("Effect_Locked_At_Surface") == 0)
				{
					effectpos.Z = Get_Float_Parameter("Random_Or_Surface_Height");
				}
				else
				{
					effectpos.Z += Commands->Get_Random(-REPD,REPD);
				}
				Commands->Set_Position(Commands->Find_Object(EffectID),effectpos);
			}
		}
		else
		{
			if (isvisible)
			{
				Commands->Set_Model(Commands->Find_Object(EffectID),"null");
				isvisible = 0;
			}
		}
	}
}

void JMG_Visible_Infantry_In_Vehicle_Attach_Script::Created(GameObject *obj)
{
	LastDamage = 1.0f;
	GameObject *Player = Commands->Find_Object(Get_Int_Parameter("PlayerID"));
	Commands->Disable_Physical_Collisions(obj);
	Last_Damager_ID = 0;
	DamagerDelay = 0;
	if (_stricmp(Get_Model(Player),"infnc"))
	{
		Commands->Set_Model(obj,Get_Model(Player));
		SetupAnimation(obj);
	}
	else
	{
		Commands->Send_Custom_Event(obj,obj,91151910,1,0.1f);
	}
	if (Get_Int_Parameter("IsDamagable") == 1)
	{
		Set_Max_Health(obj,Commands->Get_Max_Health(Player));
		Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(Player));
		Commands->Set_Health(obj,Commands->Get_Health(Player));
		Commands->Set_Shield_Strength(obj,Commands->Get_Shield_Strength(Player));
		Set_Skin(obj,Get_Skin(Player));
		Commands->Set_Shield_Type(obj,Get_Shield_Type(Player));
		Commands->Set_Player_Type(obj,Commands->Get_Player_Type(Player));
		Set_Damage_Points(obj,Get_Damage_Points(Player));
	}
	else
	{
		Set_Max_Health(obj,Commands->Get_Max_Health(Player));
		Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(Player));
		Commands->Set_Shield_Type(obj,Get_Shield_Type(Player));
		Commands->Set_Player_Type(obj,Commands->Get_Player_Type(Player));
		Set_Skin(obj,"Blamo");
		Commands->Set_Shield_Type(obj,"Blamo");
		Commands->Disable_All_Collisions(obj);
	}
	char params[20];
	sprintf(params,"%d",Commands->Get_ID(Player));
	Commands->Attach_Script(obj,"JMG_Remove_Object_When_Creator_Destroyed",params);
}

void JMG_Visible_Infantry_In_Vehicle_Attach_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 91151910)
	{
		GameObject *Player = Commands->Find_Object(Get_Int_Parameter("PlayerID"));
		if (Player)
		{
			if (_stricmp(Get_Model(Player),"infnc"))
			{
				Commands->Set_Model(obj,Get_Model(Player));
				SetupAnimation(obj);
			}
			else
			{
				Commands->Send_Custom_Event(obj,obj,91151914,1,0.2f);
			}
		}
	}
	if (message == 91151914)
	{
		GameObject *Player = Commands->Find_Object(Get_Int_Parameter("PlayerID"));
		if (Player)
		{
			if (_stricmp(Get_Model(Player),"infnc"))
			{
				Commands->Set_Model(obj,Get_Model(Player));
				SetupAnimation(obj);
			}
			else
			{
				Commands->Send_Custom_Event(obj,obj,91151915,1,2.5);
			}
		}
	}
	if (message == 91151915)
	{
		GameObject *Player = Commands->Find_Object(Get_Int_Parameter("PlayerID"));
		if (Player)
		{
			Commands->Set_Model(obj,Get_Model(Player));
			SetupAnimation(obj);
		}
	}
	if (message == 91151911)
	{
		GameObject *Player = Commands->Find_Object(Get_Int_Parameter("PlayerID"));
		Commands->Set_Health(Player,Commands->Get_Health(obj));
		Commands->Set_Shield_Strength(Player,Commands->Get_Shield_Strength(obj));
		Commands->Destroy_Object(obj);
	}
	if (message == 91151912)
	{
		Commands->Set_Model(obj,"null");
	}
}

void JMG_Visible_Infantry_In_Vehicle_Attach_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 91151911)
	{
		if (DamagerDelay)
		{
			if (DamagerDelay == 1)
			{
				Last_Damager_ID = 0;
			}
			DamagerDelay--;
		}
		GameObject *TVehicle = Commands->Find_Object(Get_Int_Parameter(Get_Int_Parameter("VehicleID")));
		GameObject *object = Commands->Find_Object(WheelMonitorID);
		if (Commands->Get_Facing(TVehicle) - Commands->Get_Facing(object) == 0)
		{
			if (AnimationState != 1) // forward
			{
				AnimationState = 1;
				Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,turninganimation[2],turninganimation[3],false);
			}
		}
		else if (Commands->Get_Facing(TVehicle) - Commands->Get_Facing(object) > 0)
		{
			if (AnimationState != 0)// left 
			{
				AnimationState = 0;
				Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,turninganimation[0],turninganimation[1],false);
			}
		}
		else
		{
			if (AnimationState != 2)// right
			{
				AnimationState = 2;
				Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,turninganimation[4],turninganimation[5],false);
			}
		}
		Commands->Start_Timer(obj,this,0.25f,91151911);
	}
}

void JMG_Visible_Infantry_In_Vehicle_Attach_Script::Animation_Complete(GameObject *obj,const char *anim)
{
	if (AnimationState != 1) // forward
	{
		AnimationState = 1;
		Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,turninganimation[2],turninganimation[3],false);
	}
	else if (AnimationState != 0)// left 
	{
		AnimationState = 0;
		Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,turninganimation[0],turninganimation[1],false);
	}
	else if (AnimationState != 2)// right
	{
		AnimationState = 2;
		Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,turninganimation[4],turninganimation[5],false);
	}
	else
	{
		float frame = Get_Float_Parameter("Frame");
		if (frame < 0)
		{
			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,0,-1,false);
		}
		else
		{
			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,frame,frame,false);
		}
	}
}

void JMG_Visible_Infantry_In_Vehicle_Attach_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Commands->Get_Health(obj) && damage)
	{
		LastDamage = damage;
		GameObject *Player = Commands->Find_Object(Get_Int_Parameter("PlayerID"));
		if (damager)
		{
			DamagerDelay = 12;
			Last_Damager_ID = Commands->Get_ID(damager);
		}
		if (damager && Player)
		{
			if (damager == Player)
			{
				Commands->Apply_Damage(obj,-damage,"None",0);
			}
			else
			{
				Commands->Send_Custom_Event(obj,Player,596911,(int)(damage*100),0);
			}
		}
		else
		{
			Commands->Send_Custom_Event(obj,Player,596911,(int)(damage*100),0);
		}
	}
}

void JMG_Visible_Infantry_In_Vehicle_Attach_Script::Killed(GameObject *obj,GameObject *damager)
{
	GameObject *Player = Commands->Find_Object(Get_Int_Parameter("PlayerID"));
	Soldier_Transition_Vehicle(obj);
	Toggle_Fly_Mode(obj);
	if (LastDamage < 1.0){LastDamage = 1.0;}
	Commands->Set_Health(Player,LastDamage);
	Commands->Set_Shield_Strength(Player,0);
	Set_Damage_Points(Player,0.0f);
	GameObject *MDamager = Commands->Find_Object(Last_Damager_ID);
	if (MDamager)
	{
		Commands->Apply_Damage(Player,9999.99f,"BlamoKiller",MDamager);
	}
	else
	{
		Commands->Apply_Damage(Player,9999.99f,"BlamoKiller",0);
	}
	char Params[256];
	sprintf(Params,"%d",Last_Damager_ID);
	Commands->Attach_Script(Player,"JMG_RP2_Force_Vehicle_Exit_And_Kill",Params);
}

void JMG_Visible_Infantry_In_Vehicle_Attach_Script::SetupAnimation(GameObject *obj)
{
	if (Get_Int_Parameter("IsDriver") > 0 && Get_Int_Parameter("IsDriver") % 3 == 0)
	{
		float framecount = (float)Get_Int_Parameter("IsDriver") / 3;
		turninganimation[0] = 0.00f;
		turninganimation[1] = 0.00f + framecount;
		turninganimation[2] = turninganimation[1] + 1.00f;
		turninganimation[3] = turninganimation[2] + framecount;
		turninganimation[4] = turninganimation[3] + 1.00f;
		turninganimation[5] = turninganimation[4] + framecount;
		GameObject *object = Commands->Create_Object("Daves Arrow",Vector3(0,0,0));
		//Commands->Set_Model(object,"null");
		if (Commands->Get_Distance(Commands->Get_Bone_Position(obj,Get_Parameter("WheelBoneName")),Commands->Get_Bone_Position(obj,"origin")) == 0.0f)
		{
			char message[4000];
			sprintf(message,"MESSAGE WARNING: No bone named %s was found on vehicle preset %s! Please check the vehicle's model and change it accordingly.",Get_Parameter("WheelBoneName"),Commands->Get_Preset_Name(obj));
			Console_Input(message);
		}
		else
		{
			Commands->Attach_To_Object_Bone(object,Commands->Find_Object(Get_Int_Parameter("VehicleID")),Get_Parameter("WheelBoneName"));
			WheelMonitorID = Commands->Get_ID(object);
			char params[20];
			sprintf(params,"%d",Commands->Get_ID(obj));
			Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,turninganimation[2],turninganimation[3],false);
			AnimationState = 1;
			Commands->Start_Timer(obj,this,0.25f,91151911);
		}
	}
	else if (Get_Int_Parameter("IsDriver") > 0 && Get_Int_Parameter("IsDriver") % 3 != 0)
	{
		char message[2000];
		sprintf(message,"%d is not dividable by 3, please remember that animation frame counting starts at 0! If you do not want to use steering animations, set the steering parameter to 0.",Get_Int_Parameter("IsDriver"));
		Console_Input(message);
	}
	else
	{
		float frame = Get_Float_Parameter("Frame");
		if (frame < 0)
		{
			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,0,-1,false);
		}
		else
		{
			Console_Input("MESSAGE LOCKED FRAME");
			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,frame,frame,false);
		}
	}
}

void JMG_Vehicle_Occupant_Visible_And_Damageable::Created(GameObject *obj)
{
	VehicleID = 0;
	int sc = Get_Vehicle_Seat_Count(obj);
	if (sc > 100)
	{
		Console_Input("MESSAGE JMG_Vehicle_Occupant_Visible_And_Damageable cannot be attached to a vehicle with more than 100 seats, sorry!");
		Remove_Script(obj,"JMG_Vehicle_Occupant_Visible_And_Damageable");
	}
	else
	{
		for(int r = 0;r < sc;r++)
		{
			idstore[r] = 0;
			idstore2[r] = 0;
		}
	}
}

void JMG_Vehicle_Occupant_Visible_And_Damageable::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		int sc = Get_Vehicle_Seat_Count(obj);
		for (int r = 0,end = 0;r < sc && (end == 0 || Get_Int_Parameter("Debug"));r++)
		{
			if (idstore[r] == 0)
			{
				end = 1;
				GameObject *visibledriver = Commands->Create_Object(Get_Parameter("VisibleDriverPreset"),Commands->Get_Position(obj));
				if (Is_Stealth(obj))
				{
					Commands->Send_Custom_Event(obj,visibledriver,91151912,0,1);
				}
				char params[256];
				if (_stricmp(Get_Parameter("DriverAnimationOverride"),"NULL") && Get_Vehicle_Driver(obj) == sender)
				{
					if (Get_Int_Parameter("SelectRandomAnimation") > 0)
					{
						int random = Commands->Get_Random_Int(0,Get_Int_Parameter("SelectRandomAnimation"));
						char animationname[64];
						sprintf(animationname,"%s%d",Get_Parameter("DriverAnimationOverride"),random);
						sprintf(params,"%d,%d,%s,%.2f,%d,%d,%s",Commands->Get_ID(sender),Commands->Get_ID(Choose_Connection_Object(obj)),animationname,Get_Float_Parameter("LockAtFrame"),Get_Int_Parameter("IsDamagable"),Get_Int_Parameter("TurnSteeringWheel"),Get_Parameter("WheelBoneName"));
					}
					else
					{
						sprintf(params,"%d,%d,%s,%.2f,%d,%d,%s",Commands->Get_ID(sender),Commands->Get_ID(Choose_Connection_Object(obj)),Get_Parameter("DriverAnimationOverride"),Get_Float_Parameter("LockAtFrame"),Get_Int_Parameter("IsDamagable"),Get_Int_Parameter("TurnSteeringWheel"),Get_Parameter("WheelBoneName"));
					}
				}
				else 
				{
					if (Get_Int_Parameter("SelectRandomAnimation") > 0)
					{
						int random = Commands->Get_Random_Int(0,Get_Int_Parameter("SelectRandomAnimation"));
						char animationname[64];
						sprintf(animationname,"%s%d",Get_Parameter("DefaultAnimation"),random);
						sprintf(params,"%d,%d,%s,%.2f,%d,0,%s",Commands->Get_ID(sender),Commands->Get_ID(Choose_Connection_Object(obj)),animationname,Get_Float_Parameter("LockAtFrame"),Get_Int_Parameter("IsDamagable"),Get_Parameter("WheelBoneName"));
					}
					else
					{
						sprintf(params,"%d,%d,%s,%.2f,%d,0,%s",Commands->Get_ID(sender),Commands->Get_ID(Choose_Connection_Object(obj)),Get_Parameter("DefaultAnimation"),Get_Float_Parameter("LockAtFrame"),Get_Int_Parameter("IsDamagable"),Get_Parameter("WheelBoneName"));
					}
				}
				char seatname[100];
				sprintf(seatname,"%s%d",Get_Parameter("BoneName"),r);
				Commands->Attach_To_Object_Bone(visibledriver,Choose_Connection_Object(obj),seatname);
				idstore2[r] = Commands->Get_ID(visibledriver);
				idstore[r] = Commands->Get_ID(sender);
				Commands->Attach_Script(visibledriver,"JMG_Visible_Infantry_In_Vehicle_Attach_Script",params);
			}
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		int sc = Get_Vehicle_Seat_Count(obj);
		for (int r = 0, end = 0;r < sc && (end == 0 || Get_Int_Parameter("Debug"));r++)
		{
			if (idstore[r] == Commands->Get_ID(sender))
			{
				end = 1;
				GameObject *object = Commands->Find_Object(idstore2[r]);
				Commands->Send_Custom_Event(obj,object,91151911,0,0);
				idstore[r] = 0;
				idstore2[r] = 0;
			}
		}
	}
	if (message == VISIBLESEATCONNECTIONOBJECTOVERRIDECUSTOM)
	{
		VehicleID = Commands->Get_ID(sender);
	}
}

void JMG_Vehicle_Occupant_Visible_And_Damageable::Killed(GameObject *obj, GameObject *shooter)
{
	int sc = Get_Vehicle_Seat_Count(obj);
	for (int r = 0;r < sc;r++)
	{
		if (idstore[r] > 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(idstore2[r]));
			idstore2[r] = 0;
		}
	}
}

void JMG_Vehicle_Occupant_Visible_And_Damageable::Destroyed(GameObject *obj)
{
	int sc = Get_Vehicle_Seat_Count(obj);
	for (int r = 0;r < sc;r++)
	{
		if (idstore[r] > 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(idstore2[r]));
			idstore2[r] = 0;
		}
	}
}

GameObject *JMG_Vehicle_Occupant_Visible_And_Damageable::Choose_Connection_Object(GameObject *obj)
{
	if (VehicleID)
	{
		GameObject *AVehicle = Commands->Find_Object(VehicleID);
		if (AVehicle)
		{
			return AVehicle;
		}
	}
	return obj;
}

void JMG_Object_Toggle_On_Vehicle_Enter_Exit::Created(GameObject *obj)
{
	if (Get_Int_Parameter("ObjectControllerID") != 0)
	{
		for(int x = 0;x < 10;x++)
		{
			ObjectID[x] = -1;
		}
		Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ObjectControllerID")),Get_Int_Parameter("ObjectType"),0,0);
	}
	else
	{
		for(int x = 0;x < 10;x++)
		{
			ObjectID[x] = 0;
		}
	}
}

void JMG_Object_Toggle_On_Vehicle_Enter_Exit::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("ObjectType"))
	{
		for (int x = 0,d = param;x < 10;x++)
		{
			ObjectID[x] = d;
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		if (Get_Int_Parameter("ObjectCount") == 0 && ObjectID[0] == 0)
		{
			GameObject *object = Commands->Create_Object(Get_Parameter("Preset"),Commands->Get_Position(obj));
			Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("BoneName"));
			ObjectID[0] = Commands->Get_ID(object);
		}
		else
		{
			for (int x = 0;x < Get_Int_Parameter("ObjectCount");x++)
			{
				if (ObjectID[x] == 0)
				{
					char bonename[32];
					sprintf(bonename,"%s%d",Get_Parameter("BoneName"),x);
					GameObject *object = Commands->Create_Object(Get_Parameter("Preset"),Commands->Get_Position(obj));
					Commands->Attach_To_Object_Bone(object,obj,bonename);
					ObjectID[x] = Commands->Get_ID(object);
				}
			}
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED && Get_Vehicle_Occupant_Count(obj) == 0)
	{
		for (int x = 0;x < 10;x++)
		{
			if (ObjectID[x] != 0 && ObjectID[x] != -1)
			{
				Commands->Destroy_Object(Commands->Find_Object(ObjectID[x]));
				ObjectID[x] = 0;
			}
		}
	}
}

void JMG_Object_Toggle_On_Vehicle_Enter_Exit::Killed(GameObject *obj, GameObject *shooter)
{
	for (int x = 0;x < 10;x++)
	{
		if (ObjectID[x] != 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(ObjectID[x]));
			ObjectID[x] = 0;
		}
	}
}

void JMG_Object_Toggle_On_Vehicle_Enter_Exit_Controller::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("ObjectType"))
	{
		Commands->Send_Custom_Event(obj,sender,Get_Int_Parameter("ObjectType"),Get_Int_Parameter("Enable"),0);
	}
}

void JMG_Repair_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (!Is_Script_Attached(enter,"JMG_Repair_Zone_Attach_Script") && enter->As_VehicleGameObj())
	{
		char params[4000];
		sprintf(params,"%f,%d,%d,%d,%d,%d,%f,%f,%s,%s",Get_Float_Parameter("Repair_Delay"),Get_Int_Parameter("Damage_Halt_Repair_Time"),Get_Int_Parameter("Add_Health"),Get_Int_Parameter("Add_Armor"),Get_Int_Parameter("Heath_Repair_Cost"),Get_Int_Parameter("Armor_Repair_Cost"),Get_Float_Parameter("Health_Repair_Sound_Time"),Get_Float_Parameter("Armor_Repair_Sound_Time"),Get_Parameter("Health_Repair_Sound"),Get_Parameter("Armor_Repair_Sound"));
		Commands->Attach_Script(enter,"JMG_Repair_Zone_Attach_Script",params);
	}
}

void JMG_Repair_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (Is_Script_Attached(exit,"JMG_Repair_Zone_Attach_Script"))
	{
		Remove_Script(exit,"JMG_Repair_Zone_Attach_Script");
	}
}

void JMG_Repair_Zone_Attach_Script::Created(GameObject *obj)
{
	repair = 0;
	delay = 0;
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),2222909);
	if (Get_Float_Parameter("Health_Repair_Sound_Time") == Get_Float_Parameter("Armor_Repair_Sound_Time"))
	{
		Commands->Start_Timer(obj,this,0.15f,2222913);
	}
	else
	{
		if (Get_Float_Parameter("Health_Repair_Sound_Time") > 0.0f)
		{
			Commands->Start_Timer(obj,this,0.15f,2222910);
		}
		if (Get_Float_Parameter("Armor_Repair_Sound_Time") > 0.0f)
		{
			Commands->Start_Timer(obj,this,0.15f,2222911);
		}
	}
	if (Get_Int_Parameter("Damage_Halt_Repair_Time") > 0)
	{
		Commands->Start_Timer(obj,this,1.0f,2222914);
	}
}

void JMG_Repair_Zone_Attach_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 2222909)
	{
		repair = 0;
		GameObject *Driver = Get_Vehicle_Driver(obj);
		if (Driver)
		{
			float PMoney = Commands->Get_Money(Driver);
			float PHealth = Commands->Get_Health(obj);
			float PArmor = Commands->Get_Shield_Strength(obj);
			if (((PMoney - Get_Int_Parameter("Armor_Repair_Cost") >= 0) || (PMoney - Get_Int_Parameter("Heath_Repair_Cost")) >= 0) && delay == 0)
			{
				Commands->Apply_Damage(obj,0.0f,"None",0);
				if (PHealth < Commands->Get_Max_Health(obj) && (PMoney - Get_Int_Parameter("Heath_Repair_Cost")) >= 0)
				{
					repair = 1;
					Commands->Give_Money(Driver,-1 * (float)Get_Int_Parameter("Heath_Repair_Cost"),1);
					Commands->Set_Health(obj,Commands->Get_Health(obj)+Get_Int_Parameter("Add_Health"));
					if (Commands->Get_Max_Health(obj) < Commands->Get_Health(obj))
					{
						Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
					}
				}
				else if (PArmor < Commands->Get_Max_Shield_Strength(obj) && (PMoney - Get_Int_Parameter("Armor_Repair_Cost")) >= 0)
				{
					repair = 2;
					Commands->Give_Money(Driver,-1 * (float)Get_Int_Parameter("Armor_Repair_Cost"),1);
					Commands->Set_Shield_Strength(obj,Commands->Get_Shield_Strength(obj)+Get_Int_Parameter("Add_Armor"));
					if (Commands->Get_Max_Shield_Strength(obj) < Commands->Get_Shield_Strength(obj))
					{
						Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
					}
				}
			}
		}
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),2222909);
	}
	if (number == 2222910)
	{
		if (repair == 1 && delay == 0)
		{
			Commands->Create_3D_Sound_At_Bone(Get_Parameter("Health_Repair_Sound"),obj,"origin");
		}
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Health_Repair_Sound_Time"),2222910);
	}
	if (number == 2222911)
	{
		if (repair == 2 && delay == 0)
		{
			Commands->Create_3D_Sound_At_Bone(Get_Parameter("Armor_Repair_Sound"),obj,"origin");
		}
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Armor_Repair_Sound_Time"),2222911);
	}
	if (number == 2222913)
	{
		if (repair == 1 && delay == 0)
		{
			Commands->Create_3D_Sound_At_Bone(Get_Parameter("Health_Repair_Sound"),obj,"origin");
		}
		if (repair == 2 && delay == 0)
		{
			Commands->Create_3D_Sound_At_Bone(Get_Parameter("Armor_Repair_Sound"),obj,"origin");
		}
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Armor_Repair_Sound_Time"),2222913);
	}
	if (number == 2222914)
	{
		if (delay > 0)
		{
			delay--;
		}
		Commands->Start_Timer(obj,this,1.0f,2222914);
	}
}

void JMG_Repair_Zone_Attach_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damage > 0.0f)
	{
		delay = Get_Int_Parameter("Damage_Halt_Repair_Time");
	}
}

void JMG_Vehicle_Sell_Price::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		Commands->Send_Custom_Event(obj,sender,(Get_Int_Parameter("ReturnMessage") + param),Get_Int_Parameter("Price"),0);
	}
	if (message == 3057911)
	{
		Commands->Send_Custom_Event(obj,sender,3057911,Get_Int_Parameter("Price"),0);
	}
}

void JMG_Attach_Script_To_All_Specified_Presets::Created(GameObject *obj)
{
	const char *paramx = Get_Parameter("Params");
	char *params2 = newstr(paramx);
	char delim = Get_Parameter("Delim")[0];
	unsigned int x = strlen(params2);
	for (unsigned int i=0;i<x;i++)
	{
		if (params2[i] == delim)
		{
			params2[i] = ',';
		}
	}
	params = params2;
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
}

void JMG_Attach_Script_To_All_Specified_Presets::Timer_Expired(GameObject *obj, int number)
{
	int timernum = Get_Int_Parameter("TimerNum");
	if (number == timernum)
	{
		SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
		while (x)
		{
			ScriptableGameObj *preset = x->Data()->As_ScriptableGameObj();
			if (preset)
			{
				const DefinitionClass *def = &preset->Get_Definition();
				if (!_stricmp(def->Get_Name(),Get_Parameter("Preset")))
				{
					if (!Is_Script_Attached(preset,Get_Parameter("Script")))
					{
						Attach_Script_Once(preset,Get_Parameter("Script"),params);
					}
				}
			}
			x = x->Next();
		}
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),timernum);
	}
}

void JMG_RP2_Random_Civilian_Model::Created(GameObject *obj)
{
	const char *Perset = Get_Player_Name(obj);
	if (!_stricmp(Perset,"Canadacdn"))
	{
		Change_Character(obj,"Canadacdn");
	}
	else if (!_stricmp(Perset,"Blazed58"))
	{
		Change_Character(obj,"Blazed58");
	}
	else if (!_stricmp(Perset,"Admiral666"))
	{
		Change_Character(obj,"Admiral666");
	}
	else if (!_stricmp(Perset,"Napalmic"))
	{
		Change_Character(obj,"Napalmic");
	}
	else if (!_stricmp(Perset,"Cabal8616"))
	{
		Change_Character(obj,"Cabal8616");
	}
	else if (!_stricmp(Perset,"Seadust"))
	{
		Change_Character(obj,"Seadust");
	}
	else if (!_stricmp(Perset,"Oblivion165"))
	{
		Change_Character(obj,"Oblivion165");
	}
	else if (!_stricmp(Perset,"Jerad2142"))
	{
		Change_Character(obj,"Jerad2142");
	}
	else if (Select_Player_Character(obj)){}
	else
	{
		int x = Commands->Get_Random_Int(0,15);
		switch (x)
		{
				case 0: Commands->Set_Model(obj,"NewGDIMGO");break;// Redid the model myself to fix visible drivers 2/12/20
				case 1: Commands->Set_Model(obj,"c_ag_gdi_locke");break;
				case 2: Commands->Set_Model(obj,"c_civ_pimpp");break;
				case 3: Commands->Set_Model(obj,"c_rp2_20sciv");break;
				case 4: Commands->Set_Model(obj,"c_rp2_cj");break;
				case 5: Commands->Set_Model(obj,"ClownRemake");break;// Redid the model myself to fix visible drivers 2/12/20
				case 6: Commands->Set_Model(obj,"c_rp2_hobo");break;
				case 7: Commands->Set_Model(obj,"c_ag_labtec3");break;
				case 8: Commands->Set_Model(obj,"c_ag_gdi_mobi");break;
				case 9: Commands->Set_Model(obj,"c_ag_nod_kane");break;
				case 10: Commands->Set_Model(obj,"c_ag_labtec1");break;
				case 11: Commands->Set_Model(obj,"c_ag_gdi_mp");break;
				case 12: Commands->Set_Model(obj,"c_ag_gdi_syd2");break;
				case 13: Commands->Set_Model(obj,"c_ag_civf");break;
				case 14: Commands->Set_Model(obj,"FmaleServ");break;// Redid the model myself to fix visible drivers 2/12/20
				case 15: Commands->Set_Model(obj,"c_ag_labtec2");break;
				default: break;
		}
	}
	delete[] Perset;
}

int JMG_RP2_Random_Civilian_Model::Select_Player_Character(GameObject *obj)
{
	char PlayerName[256];
	const char *str = Get_Player_Name(obj);
	sprintf(PlayerName,"%s",str);
	delete[] str;
	if (PlayerCharacterNode)
	{
		PlayerCharacterControl *Current = PlayerCharacterNode;
		while (Current != NULL)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				Change_Character(obj,Current->PresetName);
				return 1;
			}
			Current = Current->next;
		}
	}
	return 0;
}

void JMG_Sell_Vehicle_On_Custom::Created(GameObject *obj)
{
	Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("CostRequestMessage"),1,0);
}

void JMG_Sell_Vehicle_On_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("SellKeyMessage"))
	{	
		if (Get_Vehicle_Driver(obj) == sender)
		{
			Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("CostRequestMessage"),0,0);
		}
	}
	if (message == Get_Int_Parameter("PriceReturnedMessage") + 1)
	{
		GameObject *Driver = Get_Vehicle_Driver(obj);
		float Cost = Vehicle_Price_Calculation(obj,(float)param,Driver);
		if (Cost >= 0)
		{
			char text[2000];
			sprintf(text,"Your vehicle currently has a sell price of %.0f credits!",Cost);
			Send_Message_Player(Driver,255,255,0,text);
		}
	}
	if (message == Get_Int_Parameter("PriceReturnedMessage"))
	{
		GameObject *Driver = Get_Vehicle_Driver(obj);
		float Cost = Vehicle_Price_Calculation(obj,(float)param,Driver);
		if (Cost >= 0)
		{
			if (Is_Script_Attached(obj,"JMG_Vehicle_Sell_Price"))
			{
				Remove_Script(obj,"JMG_Vehicle_Sell_Price");
			}
			char text[2000];
			sprintf(text,"You sold your vehicle for %.0f credits!",Cost);
			Send_Message_Player(Driver,255,255,0,text);
			Commands->Create_3D_Sound_At_Bone(Get_Parameter("SellSound"),obj,"origin");
			Commands->Give_Money(Driver,Cost,1);
			Commands->Create_Explosion(Get_Parameter("Sell_Explosion"),Commands->Get_Position(obj),0);
			RP2VehicleControl *GVehicleNode = Get_Vehicle_Node(obj);
			if (GVehicleNode && GVehicleNode->IsWarthog)
			{
				WarthogControl *MyNode = Get_Warthog_Node(obj);
				if (Commands->Find_Object(MyNode->BodyID) != obj){Commands->Destroy_Object(Commands->Find_Object(MyNode->BodyID));}
				if (Commands->Find_Object(MyNode->GunnerID) != obj){Commands->Destroy_Object(Commands->Find_Object(MyNode->GunnerID));}
				if (Commands->Find_Object(MyNode->TurretID) != obj){Commands->Destroy_Object(Commands->Find_Object(MyNode->TurretID));}
			}
			JMG_Force_Occupants_Exit(obj);
		}
	}
}

float JMG_Sell_Vehicle_On_Custom::Vehicle_Price_Calculation(GameObject *obj,float Cost,GameObject *VehicleDriver)
{
	RP2VehicleControl *GVehicleNode = Get_Vehicle_Node(obj);
	if (GVehicleNode && GVehicleNode->IsWarthog)
	{
		WarthogControl *MyNode = Get_Warthog_Node(obj);
		if (Warthog_Special(Commands->Find_Object(MyNode->BodyID),Commands->Find_Object(MyNode->GunnerID),Commands->Find_Object(MyNode->TurretID)))
		{
			Send_Message_Player(VehicleDriver,255,255,0,"Everyone else must exit the vehicle before you can sell it!");
			return 0.0f;
		}
	}
	if (!VehicleDriver)
	{
		return 0.0f;
	}
	else if (Cost > 0)
	{
		float MaxHP = (Commands->Get_Max_Health(obj) * Get_Float_Parameter("HealthValueRatio")) + (Commands->Get_Max_Shield_Strength(obj) * Get_Float_Parameter("ArmorValueRatio"));
		float CurrentHP = (Commands->Get_Health(obj) * Get_Float_Parameter("HealthValueRatio")) + (Commands->Get_Shield_Strength(obj) * Get_Float_Parameter("ArmorValueRatio"));
		float Percent = (CurrentHP / MaxHP);
		if (Percent >= Get_Float_Parameter("MinimumSellCondition"))
		{
			float MinCost = Get_Float_Parameter("MinimumSellCondition") * Cost;
			float VariableCost = Cost - MinCost;
			VariableCost *= Percent;
			Cost = VariableCost + MinCost;
			if (Cost == 0)
			{
				Send_Message_Player(VehicleDriver,255,255,0,"Your vehicles condition is too poor to sell!");
				return 0.0f;
			}
			else
			{
				return Cost;
			}
		}
		else
		{
			Send_Message_Player(VehicleDriver,255,255,0,"Your vehicles condition is too poor to sell!");
			return 0.0f;
		}
	}
	else if (Cost == 0)
	{
		Send_Message_Player(VehicleDriver,255,255,0,"Your vehicle has no sale value!");
		return 0.0f;
	}
	else if (Cost == -1)
	{
		Send_Message_Player(VehicleDriver,255,255,0,"You cannot sell this vehicle!");
		return -1.0f;
	}
	else
	{
		return 0.0f;
	}
}

void JMG_Sell_Vehicle_On_Custom::JMG_Force_Occupants_Exit(GameObject *obj)
{
	if (Is_Script_Attached(obj,"JMG_RP2_Chinook_Door_Control"))
	{
		Remove_Script(obj,"JMG_RP2_Chinook_Door_Control");
	}
	Commands->Enable_Vehicle_Transitions(obj,true);
	int j = 0;
	if (!obj || !obj->As_VehicleGameObj())
	{
		return;
	}
	while (Get_Vehicle_Occupant_Count(obj) > 0 && j < 5)
	{
		if (!obj || !obj->As_VehicleGameObj())
		{
			return;
		}
		int x = obj->As_VehicleGameObj()->Get_Occupant_Count();
		for (int i = 0;i < x;i++)
		{
			if (obj->As_VehicleGameObj()->Get_Occupant(i))
			{
				ActionParamsStruct params;
				params.Set_Basic((long)0,100,39);
				Commands->Action_Enter_Exit(obj->As_VehicleGameObj()->Get_Occupant(i),params);
			}
		}
		Commands->Enable_Vehicle_Transitions(obj,true);
		j++;
	}
	if (Get_Vehicle_Occupant_Count(obj) == 0)
	{
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z += 10000.0f;
		Commands->Set_Position(obj,pos);
	}
	if (Is_Script_Attached(obj,"DAN_Drop_Wreckage_On_Death"))
	{
		Remove_Script(obj,"DAN_Drop_Wreckage_On_Death");
	}
	Commands->Apply_Damage(obj,9999999.9f,"BlamoKiller",0);
}

int JMG_Sell_Vehicle_On_Custom::Warthog_Special(GameObject *Side1,GameObject *Side2,GameObject *Side3)
{	
	if ((Get_Vehicle_Occupant_Count(Side1) + Get_Vehicle_Occupant_Count(Side2) + Get_Vehicle_Occupant_Count(Side3)) <= 1)
	{
		return 0;
	}
	return 1;
}

void JMG_Vehicle_Sell_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (!Is_Script_Attached(enter,"JMG_Sell_Vehicle_On_Custom") && enter->As_VehicleGameObj())
	{
		char params[4000];
		sprintf(params,"%d,%d,%d,%s,%f,%f,%f,%s",Get_Int_Parameter("SellKeyMessage"),Get_Int_Parameter("CostRequestMessage"),Get_Int_Parameter("PriceReturnedMessage"),Get_Parameter("SellSound"),Get_Float_Parameter("HealthValueRatio"),Get_Float_Parameter("ArmorValueRatio"),Get_Float_Parameter("MinimumSellCondition"),Get_Parameter("Sell_Explosion"));
		Commands->Attach_Script(enter,"JMG_Sell_Vehicle_On_Custom",params);
	}
}

void JMG_Vehicle_Sell_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (Is_Script_Attached(exit,"JMG_Sell_Vehicle_On_Custom"))
	{
		Remove_Script(exit,"JMG_Sell_Vehicle_On_Custom");
	}
}

void JMG_Buy_Preset_On_Poke::Created(GameObject *obj)
{
	enabled = true;
}

void JMG_Buy_Preset_On_Poke::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(poker)])
		{
			Send_Message_Player(obj,150,0,0,"You must spawn before you can buy this...");
		}
		else
		{
			if (CheckPlayerType(poker,Get_Int_Parameter("Player_Type")))
			{
				return;
			}
			if (enabled)
			{
				float cost = (float)Get_Int_Parameter("Cost");
				if (cost <= Commands->Get_Money(poker))
				{
					enabled = false;
					if (Get_Int_Parameter("DeathZoneID"))
					{
						GameObject *Zone = Commands->Find_Object(Get_Int_Parameter("DeathZoneID"));
						Damage_All_Objects_In_Zone(Zone,999999.9f,"None",0);
					}
					Commands->Give_Money(poker,-1*cost,0);
					GameObject *newpreset = Commands->Create_Object(Get_Parameter("Preset"),Get_Vector3_Parameter("Location"));
					Commands->Set_Facing(newpreset,Get_Float_Parameter("Facing"));
					Commands->Create_Sound(Get_Parameter("BuySound"),Commands->Get_Position(poker),poker);
					Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
				}
				else
				{
					Commands->Create_Sound(Get_Parameter("InadequateFundsSound"),Commands->Get_Position(poker),poker);
				}
			}
		}
	}
}

void JMG_Buy_Preset_On_Poke::Timer_Expired(GameObject *obj,int number)
{
	if (Get_Int_Parameter("TimerNum") == number)
	{
		enabled = true;
	}
}

void JMG_RP2_Vehicle_Door_Script::Created(GameObject *obj)
{
	Commands->Set_Animation(obj,Get_Parameter("Animation"),false,0,0,Get_Float_Parameter("LastFrame"),false);
	Commands->Start_Timer(obj,this,0.1f,234765);
}

void JMG_RP2_Vehicle_Door_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 234765)
	{
		if (Get_Vehicle_Occupant_Count(obj) > 0)
		{
			int sc = Get_Vehicle_Seat_Count(obj);
			for(int r = 0,end = 0;r < sc && end == 0;r++)
			{
				GameObject *object = Get_Vehicle_Occupant(obj,r);
				if (Commands->Get_ID(object) > 0)
				{
					if (Commands->Get_Player_Type(object) == 1)
					{
						Commands->Set_Animation(obj,Get_Parameter("Animation"),false,0,Get_Animation_Frame(obj),0,false);
						Commands->Enable_Vehicle_Transitions(obj,1);
					}
					else
					{
						Commands->Set_Animation(obj,Get_Parameter("Animation"),false,0,Get_Animation_Frame(obj),Get_Float_Parameter("LastFrame"),false);
						Commands->Enable_Vehicle_Transitions(obj,0);
					}
				}
			}
		}
		else
		{
			Commands->Set_Animation(obj,Get_Parameter("Animation"),false,0,Get_Animation_Frame(obj),0,false);
			Commands->Enable_Vehicle_Transitions(obj,1);
		}
		Commands->Start_Timer(obj,this,0.1f,234765);
	}
}

void JMG_Simple_Vehicle_Fire_Animation_Script::Created(GameObject *obj)
{
	hasbullet = 1;
	Commands->Set_Animation(obj,Get_Parameter("Animation"),false,0,0,Get_Float_Parameter("LastFrame"),false);
	Commands->Start_Timer(obj,this,0.1f,Get_Int_Parameter("TimerNum"));
}

void JMG_Simple_Vehicle_Fire_Animation_Script::Timer_Expired(GameObject *obj,int number)
{
	int TimerNUM = Get_Int_Parameter("TimerNum");
	if (number == TimerNUM)
	{
		if (Get_Current_Bullets(obj) == 1 && hasbullet == 0)
		{
			hasbullet = 1;
			Commands->Set_Animation(obj,Get_Parameter("Animation"),false,0,Get_Animation_Frame(obj),0,false);
		}
		if (Get_Current_Bullets(obj) == 0 && hasbullet == 1)
		{
			hasbullet = 0;
			Commands->Set_Animation(obj,Get_Parameter("Animation"),false,0,Get_Animation_Frame(obj),Get_Float_Parameter("LastFrame"),false);
		}
		Commands->Start_Timer(obj,this,0.1f,TimerNUM);
	}
}

void JMG_Kill_All_In_Range_On_Create::Created(GameObject *obj)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = x->Data();
		if (o)
		{
			if (Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(o)) <= Get_Float_Parameter("DamageRange") && o != obj)
			{
				Commands->Apply_Damage(o,99999.0f,"None",0);
			}
		}
		x = x->Next();
	}
}

void JMG_Kill_All_In_Range_On_Create_If_Above::Created(GameObject *obj)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	int kill = 0;
	while (x)
	{
		GameObject *o = x->Data();
		if (o)
		{
			Vector3 objpos = Commands->Get_Position(obj),opos = Commands->Get_Position(o);
			if (Commands->Get_Distance(objpos,opos) <= Get_Float_Parameter("DamageRange") && objpos.Z > opos.Z && o != obj)
			{
				kill = 1;
				Commands->Apply_Damage(o,99999.0f,"None",0);
			}
		}
		x = x->Next();
	}
	if (kill && Get_Int_Parameter("KillSelf"))
	{
		Commands->Destroy_Object(obj);
	}
}

void JMG_Kill_Nearest_Unit_Type_When_Stuck::Created(GameObject *obj)
{
	LastPos = Commands->Get_Position(obj);
	StuckCount = 0;
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
}

void JMG_Kill_Nearest_Unit_Type_When_Stuck::Timer_Expired(GameObject *obj,int number)
{
	int TimerNum = Get_Int_Parameter("TimerNum");
	if (number == TimerNum)
	{
		Vector3 pos = Commands->Get_Position(obj);
		if (Commands->Get_Distance(pos,LastPos) < 0.25f)
		{
			StuckCount++;
			if (StuckCount > 3)
			{
				StuckCount = 0;
				float LastDist = 9999.9f;
				int KillTargetID = 0;
				SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
				while (x)
				{
					GameObject *o = x->Data();
					if (o)
					{
						if (!_stricmp(Commands->Get_Preset_Name(o),Get_Parameter("ObjectName")))
						{
							float tempdist = Commands->Get_Distance(Commands->Get_Position(o),pos);
							if (tempdist < LastDist)
							{
								LastDist = tempdist;
								KillTargetID = Commands->Get_ID(o);
							}
						}
					}
					x = x->Next();
				}
				if (KillTargetID != 0)
				{
					Commands->Apply_Damage(Commands->Find_Object(KillTargetID),999.0f,"blamokiller",0);
				}
			}
		}
		else
		{
			StuckCount = 0;
		}
		LastPos = pos;
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),TimerNum);
	}
}

void JMG_Return_Fire_On_Damager::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damage)
	{
		if (Get_Int_Parameter("Innate_Disabled") == 1)
		{
			Commands->Innate_Disable(obj);
		}
		ActionParamsStruct params;
		params.Set_Movement(damager,1.0,Get_Float_Parameter("Max_Distance"),false);
		params.MoveFollow = true;
		Commands->Action_Goto(obj,params);
		params.Set_Basic(this,999,10);
		params.Set_Attack(damager,Get_Float_Parameter("Max_Weapon_Range"),0,1);
		params.AttackCheckBlocked = false;
		Commands->Action_Attack(obj,params);
	}
}

void JMG_Return_Fire_On_Damager_2::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,1.0f,Get_Int_Parameter("TimerNum"));
}

void JMG_Return_Fire_On_Damager_2::Timer_Expired(GameObject *obj,int number)
{
	int TimerNUM = Get_Int_Parameter("TimerNum");
	if (number == TimerNUM)
	{
		GameObject *damager = JMG_Find_Closest_Non_Building_Object_By_Team(obj,Get_Int_Parameter("Ignore_Team"),Get_Float_Parameter("Proxy_Range"),Commands->Get_Position(obj));
		if (damager)
		{
			ActionParamsStruct params;
			params.Set_Movement(damager,1.0,Get_Float_Parameter("Max_Distance"),false);
			params.MoveFollow = true;
			params.MovePathfind = Get_Int_Parameter("Pathfind");
			Commands->Action_Goto(obj,params);
			params.Set_Basic(this,999,10);
			params.Set_Attack(damager,Get_Float_Parameter("Max_Weapon_Range"),0,1);
			params.AttackCheckBlocked = false;
			Commands->Action_Attack(obj,params);
		}
		Commands->Start_Timer(obj,this,1.0f,TimerNUM);
	}
}

void JMG_Return_Fire_On_Damager_2::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damage)
	{
		if (Get_Int_Parameter("Innate_Disabled") == 1)
		{
			Commands->Innate_Disable(obj);
		}
		ActionParamsStruct params;
		params.Set_Movement(damager,1.0,Get_Float_Parameter("Max_Distance"),false);
		params.MoveFollow = true;
		Commands->Action_Goto(obj,params);
		params.Set_Basic(this,999,10);
		params.Set_Attack(damager,Get_Float_Parameter("Max_Weapon_Range"),0,1);
		params.AttackCheckBlocked = false;
		Commands->Action_Attack(obj,params);
	}
}

GameObject *JMG_Return_Fire_On_Damager_2::JMG_Find_Closest_Non_Building_Object_By_Team(GameObject *obj,int Team,float MaxRange,Vector3 position)
{
	float closestdist = FLT_MAX;
	GameObject *closest = 0;
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = x->Data();
		if (o)
		{
			if ((Get_Object_Type(o) != Team && Commands->Get_ID(obj) != Commands->Get_ID(o)))
			{
				Vector3 pos = Commands->Get_Position(o);
				float dist = Commands->Get_Distance(pos,position);
				if (dist < closestdist && dist <= MaxRange)
				{
					closestdist = dist;
					closest = o;
				}
			}
		}
		x = x->Next();
	}
	return closest;
}

void JMG_Motion_Mine_Script::Created(GameObject *obj)
{
	DetectRange = Get_Float_Parameter("Max_Mine_Detect_Range")*Get_Float_Parameter("Max_Mine_Detect_Range");
	DetectSpeed = Get_Float_Parameter("Max_Safe_Speed")*Get_Float_Parameter("Max_Safe_Speed");
	GameObject *star = Commands->Get_A_Star(Commands->Get_Position(obj));
	OwnerID = Get_Player_ID(star);
	for (int x = 0;x < 10;x++)
	{
		CurrentTargets[x] = 0;
	}
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Safe_Time"),Get_Int_Parameter("Timer_Number"));
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Safe_Time"),(Get_Int_Parameter("Timer_Number")+1));
}

void JMG_Motion_Mine_Script::Timer_Expired(GameObject *obj,int number)
{
	int TimerNumber = Get_Int_Parameter("Timer_Number");
	if ((TimerNumber+1) == number)
	{
		Commands->Set_Model(obj,Get_Parameter("Active_Mine_Model"));
	}
	if (TimerNumber == number)
	{
		Get_Target(obj);
		for (int x = 0,end = 0;x < 10 && end == 0;x++)
		{
			if (CurrentTargets[x] != 0)
			{
				GameObject *Target = Commands->Find_Object(CurrentTargets[x]);
				Vector3 NewPos = Commands->Get_Position(Target);
				if (Lazy_Distance_Comp_Script(NewPos,Commands->Get_Position(obj)) <= DetectRange)
				{
					if (Lazy_Distance_Comp_Script(NewPos,TargetPositions[x]) > DetectSpeed)
					{
						end = 1;
						Commands->Create_Explosion(Get_Parameter("Mine_Explosion"),Commands->Get_Position(obj),Get_GameObj(OwnerID));
					}
				}
				else
				{
					CurrentTargets[x] = 0;
				}
				TargetPositions[x] = NewPos;
			}
		}
		Commands->Start_Timer(obj,this,0.1f,TimerNumber);
	}
}

void JMG_Motion_Mine_Script::Get_Target(GameObject *obj)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x) 
	{
		GameObject *o = x->Data();
		if (obj)
		{
			if (obj != o)
			{
				if (Usable_Target(o))
				{
					Vector3 ObjPosition = Commands->Get_Position(o);
					if ((Commands->Get_Distance(ObjPosition,Commands->Get_Position(obj)) <= Get_Float_Parameter("Max_Mine_Detect_Range")))
					{
						int TargetID = Commands->Get_ID(o); 
						for (int xx = 0;xx < 10;xx++)
						{
							if (CurrentTargets[xx] == TargetID)
							{
								break;
							}
							else if (CurrentTargets[xx] == 0)
							{
								CurrentTargets[xx] = TargetID;
								TargetPositions[xx] = ObjPosition;
							}
							else if (xx == 10 && CurrentTargets[xx] != 0)
							{
								Commands->Create_Explosion(Get_Parameter("Mine_Explosion"),Commands->Get_Position(obj),Get_GameObj(OwnerID));
							}
						}
					}
				}
			}
			x = x->Next();
		}
	}
}

int JMG_Motion_Mine_Script::Usable_Target(GameObject *obj)
{
	if (obj->As_VehicleGameObj())
	{
		if (((obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->Peek_Physical_Object() && obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()) || (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->Peek_Physical_Object() && obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_TrackedVehicleClass()) || (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->Peek_Physical_Object() && obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_WheeledVehicleClass()) || (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->Peek_Physical_Object() && obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MotorcycleClass()) || (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->Peek_Physical_Object() && obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_HumanPhysClass())))
		{
			return 1;
		}
	}
	if (obj->As_SoldierGameObj())
	{
		return 1;
	}
	return 0;
}

float JMG_Motion_Mine_Script::Lazy_Distance_Comp_Script(Vector3 MyPos,Vector3 Pos)
{
	float XDis = (MyPos.X - Pos.X);
	float YDis = (MyPos.Y - Pos.Y);
	float ZDis = (MyPos.Z - Pos.Z);
	return ((XDis * XDis) + (YDis * YDis) + (ZDis * ZDis));
}

void JMG_Attach_Script_Collector_Once::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		const char *script = Get_Parameter("Script");
		const char *paramx = Get_Parameter("Params");
		char *params = newstr(paramx);
		char delim = Get_Parameter("Delim")[0];
		unsigned int x = strlen(params);
		for (unsigned int i=0;i<x;i++)
		{
			if (params[i] == delim)
			{
				params[i] = ',';
			}
		}
		Attach_Script_Once(sender,script,params);
		delete[] params;
	}
}

void JMG_RP2_Player_Phone_Control_Script::Created(GameObject *obj)
{
	//char Text[2000];
	//sprintf(Text,"Created Phone for %s...",Get_Player_Name(obj));
	/**///Phone_Trace(Text,0,1);
	FirstTimeOut = 1;
	TraceDepthPC = 0;
	MyIDPC = Commands->Get_ID(obj);
	PersonalPhoneNumber = NULL;
	PlayerRedialNumbers = NULL;
	ShortTermUsage = NULL;
	SoundIDSetupNode(obj);
	CallerID = 0;
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneZero,940860500");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneOne,940860501");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneTwo,940860502");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneThree,940860503");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneFour,940860504");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneFive,940860505");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneSix,940860506");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneSeven,940860507");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneEight,940860508");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneNine,940860509");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneClear,940860510");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneSend,940860511");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneDelete,940860512");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhoneStar,940860513");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhonePound,940860514");
	Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","PhonePower,940860515");
	Number = 0;
	for (int x = 0;x < 100;x++)
	{
		cnumber[x] = NULL;
	}
	PhoneOut = 0;
	ClearNumbers();
	RingThrough = 0;
	GameObject *PhoneBook = Find_Nearest_Preset(Commands->Get_Position(obj),RP2PHONEBOOKPRESET);
	if (PHONEZONES[Get_Player_ID(obj)] > 0)
	{
		PhoneEnabled = 1;
	}
	else
	{
		PhoneEnabled = 0;
	}
	SpecialKeys = 0;
	CallComplete = 0;
	StarPress = 0;
	WaitingForPound = 0;
	CallInProgress = 0;
	ClearLines = 0;
	LastPos[0] = LastPos[1] = Commands->Get_Position(obj);
	PhoneLineID = 0;
	RedialNodeSetup(obj);
	PoundPress = 0;
	Powered = 1;
	HousingKeyTransfer = 0;
	HoldSpecial = 0;
	InVehicle = 0;
	IsSpamming = 0;
	MissedCalls = 0;
	TurnedOff = 0;
	WaitingForDescription = 1;
	SpecialID = 0;
	NewSpecialNumberPress = 0;
	if (PhoneBook)
	{
		PhoneBookID = Commands->Get_ID(PhoneBook);
		Commands->Start_Timer(obj,this,0.1f,60540801);
	}
	else
	{
		Send_Message_Player(obj,127,255,0,"No phone tower detected in this area!");
	}
	Commands->Start_Timer(obj,this,1.0f,60540805);
	Commands->Start_Timer(obj,this,0.0f,60540807);
}

void JMG_RP2_Player_Phone_Control_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == PHONESendSenderTheDisconnectSignal)
	{
		SpecialCount = 0;
		SpecialID = 0;
		Phone_OffHook(obj);
	}	
	if (message == PHONECallReccived)
	{
		Phone_Called_Select_State(obj,param);
	}
	if (message == PHONEUserDied)// Contact Killed - Remote Shutdown
	{
		ContactKilledRS(obj);
	}
	if (message == PHONELostSignal)
	{
		LostSignal(obj);
	}
	if (message == PHONEAquiredSignal)
	{
		SignalDetected(obj);
	}
	if (message == PHONEOtherGuyHungUp)// Other End Hangs up
	{
		Reset_Phone(obj);
		Reset_Phone(obj);
	}
	if (message == 940860515 && PhoneOut == 1)
	{
		PowerButton(obj);
	}
	if (message == PHONEResetCustom)
	{
		Powered = 1;
		Reset_Phone(obj);
	}
	if (PhoneOut == 1 && !Powered)
	{
		if (PressAnyKey(message))// Phone is off remind player
		{
			Send_Message_Player(obj,127,255,0,"(Your phone is off...)");
		}
	}
	else if (PhoneOut == 1 && Powered)
	{
		if (PressAnyKey(message) == 1 && (CallComplete || PlayerIDNode->OffHookSoundID))// Allow anykey to reset after call
		{
			Reset_Phone(obj);
		}
		if (message == PHONECallRingDelay && PhoneLineID != 0)// Relay
		{
			PhoneCallDelayRelay(obj);
		}
		if (message == PHONEBombCallRingDelay && SpecialID)// Sepcial Bomb Timer
		{
			SpecialCount += 0.01f;
			if (SpecialCount >= SpecialCountMax)
			{
				Commands->Send_Custom_Event(obj,sender,PHONEBombPhoneRing,1,0);// start ring the other end
			}
			if (SpecialCount >= (SpecialCountMax + 0.5))
			{
				Commands->Send_Custom_Event(obj,sender,PHONEBombDetonate,1,0);
			}
			else
			{
				Commands->Send_Custom_Event(sender,obj,PHONEBombCallRingDelay,1,0.01f);// Delay before Call starts ringing through
			}
		}
		if (message == PHONETriggerBomb)// Special Code for the bomb
		{
			SpecialCount = 0;
			SpecialCountMax = Commands->Get_Random(1.0,2.0);
			SpecialID = param;
			GameObject *TargetObject = Commands->Find_Object(param);
			Commands->Send_Custom_Event(obj,TargetObject,40860544,1,0);// Link Bomb
			Commands->Send_Custom_Event(TargetObject,obj,PHONEBombCallRingDelay,1,0.01f);// Delay before Call starts ringing through
		}
		if (message == PHONEFoundOtherPlayerStandBy)// Found Player Start UP Ring Delay System
		{
			PhoneLineID = param;// This is the person you are calling's ID
			GameObject *OtherPlayer = Get_GameObj(PhoneLineID);
			char Message[237];
			const char *str = Get_Player_Name(OtherPlayer);
			sprintf(Message,"Phone number found... Standby while a connection is established with %s.",str);
			delete[] str;
			Send_Message_Player(obj,127,255,0,Message);
			RingUp = Commands->Get_Random_Int(30,45);
			Commands->Send_Custom_Event(obj,obj,PHONECallRingDelay,1,0.1f);// Delay before Call starts ringing through
		}
		if (message == PHONECallReccived)// Call received, start ringing
		{
			if (!CallerID)
			{
				if (Get_Player_ID(obj) != param)
				{
					HumanCallObjectFound(obj,param);
				}
				else// Can't call yourself
				{
					Phone_Disconnect(obj);
				}
			}
			else
			{
				Commands->Send_Custom_Event(obj,Get_GameObj(param),PHONELineBusy,1,0);
			}
		}
		if (CallInProgress == 1)// Require a call to be in progress
		{
			if (message == PHONEStopRingingNumberReached && param == 0)
			{
				PhoneCallPickedUpSimple(obj);
			}
			if (message == PHONENumberRequires1Or2Entry && param != 0)
			{
				PhoneCallPickedUp(obj,param);
			}
			if (message == PHONENumberRequires1Or2EntryNoDiscard && param != 0)
			{
				HoldSpecial = 1;
				PhoneCallPickedUp(obj,param);
			}
			if (message == PHONENumberRequestSingleDigitPress)
			{
				NewSpecialNumberPress = 1;
				HoldSpecial = 1;
				PhoneCallPickedUp(obj,param);
			}
			if (message == PHONEOtherEndHangUp)
			{
				CallCompleteMessage(obj);
			}
			if (message == PHONELineBusy)
			{
				PhoneLineBusy(obj);
			}
			if (message == PHONECallWaiting)
			{
				CallWaitingBeep(obj);
			}
			if (message == PHONENumberRequiresAdditionalNumberAndPound && param != 0)
			{
				WaitingForAdditionalNumber(obj,param);
			}
			if (message == 40860517)
			{
				HousingKeyTransfer = param;
				SpecialKeys = 0;
				WaitingForPound = 0;
			}
		}
		if (message >= 940860500 && message <= 940860509 && StarPress == 0)
		{
			NumberKeyPressed(obj,message);
		}
		if (message >= 940860500 && message <= 940860509 && StarPress == 1 && Number && !WaitingForPound)
		{
			NumberKeyPressedStorage(obj,message);
		}
		else if (message >= 940860500 && message <= 940860509 && StarPress == 1 && !Number && !WaitingForPound)
		{
			NumberKeyPressedRedial(obj,message,0);
		}
		else if (message >= 940860500 && message <= 940860509 && StarPress == 1 && WaitingForPound)// Redial a number when another phone number is asking for a number
		{
			NumberKeyPressedRedial(obj,message,1);
		}
		if (message == 940860510)
		{
			ClearKeyPressed(obj);
		}
		if (message == 940860511 && SpecialKeys == 0 && !HousingKeyTransfer)
		{
			SendKeyPressed(obj);
		}
		else if (message == 940860511 && HousingKeyTransfer)
		{
			SendPhoneNumberToRecciver(obj);
		}
		if (message == 940860512 && (SpecialKeys == 0 || (WaitingForPound == 1 && SpecialKeys != 0)))
		{
			DeleteKeyPressed(obj);
		}
		if (message == 940860513)
		{
			StarKeyPressed(obj);
		}
		if (message == 940860514)
		{
			PoundKeyPressed(obj);
		}
		if (message == PHONECheckForRedialNumberMatchReturn && ShortTermUsage && WaitingForDescription)
		{
			PhoneDefineNumberReturn(obj,param);
		}
		if (Commands->Get_Health(obj) > 0)
		{
			if (message == 21511236 && StarPress == 0)
			{
				ListPhoneNumbers(obj,1);
			}
			if (message == 21511237 && StarPress == 0)
			{
				ListPhoneNumbers(obj,2);
			}
			else if (message == 21511236 && StarPress == 1)
			{
				ListStoredPhoneNumbers(obj);
			}
			if (message == 21511237 && StarPress == 1)
			{
				ListPhoneNumbers(obj,3);
			}
			if (message == 21511235 && StarPress == 0)
			{
				DisplayCurrentlyEnteredNumber(obj);
			}
			else if (message == 21511235 && StarPress == 1)
			{
				DisplayMyPhoneNumber(obj);
			}
		}
	}
	/*if (message == 3423432)
	{
		char mns[234];
		sprintf(mns,"MESSAGE My ID is:%d",MyIDPC);
		Console_Input(mns);
		//Phone_Trace("JMG_Important_Debug_Data",1,0);
		char Text[20000];
		sprintf(Text,"BasicInfo: Number:%d ReachedNumber:%d CallInProgress:%d RedialFast:%d PhoneOut:%d PhoneEnabled:%d InZones:%d RingThrough:%d SpecialKeys:%d CallComplete:%d StarPress:%d WaitingForPound:%d",Number,ReachedNumber,CallInProgress,RedialFast,PhoneOut,PhoneEnabled,InZones,RingThrough,SpecialKeys,CallComplete,StarPress,WaitingForPound);
		//Phone_Trace(Text,0,0);
		sprintf(Text,"ObjectIDs: PlayerIDNode->DialToneID:%d PhoneBookID:%d PlayerIDNode->RingSoundID:%d PlayerIDNode->OffHookSoundID:%d PlayerIDNode->BusySoundID:%d PlayerIDNode->CallWaitingID:%d",PlayerIDNode->DialToneID,PhoneBookID,PlayerIDNode->RingSoundID,PlayerIDNode->OffHookSoundID,PlayerIDNode->BusySoundID,PlayerIDNode->CallWaitingID);
		//Phone_Trace(Text,0,0);
		sprintf(Text,"IDList: cnumber:%s BackupNumber:%s",cnumber,BackupNumber);
		//Phone_Trace(Text,0,0);
		//Phone_Trace("Complete - JMG_Important_Debug_Data",-1,0);
	}*/
}	

void JMG_RP2_Player_Phone_Control_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 60540800)
	{
		Phone_Ring_Timeout(obj);
	}
	if (number == 60540801)
	{
		Phone_Position_Control(obj);
	}
	if (number == 60540802 && CallInProgress == 1)
	{
		Phone_Redial_Sound_Trigger(obj);
	}
	if (number == 60540804)
	{
		Call_Complete(obj);
	}
	if (number == 60540805)
	{
		if (!Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
		{
			Vector3 POS = Commands->Get_Position(obj);
			if (Commands->Get_Distance(LastPos[1],POS) > 1.25f)
			{
				LastPos[0] = LastPos[1];
				LastPos[1] = POS;
			}
		}
		if (IsSpamming > 0)
		{
			IsSpamming--;
		}
		Commands->Start_Timer(obj,this,1.0f,60540805);
	}
	if (number == 60540806)
	{
		Phone_Busy_Startup(obj);
	}
	if (number == 60540807)
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(obj)])
		{
			AddPersonalNumberNode(obj);
			sprintf(MyPhoneNumber,"%s",FormatPhoneNumber(PersonalPhoneNumber->MyPhoneNumber));
		}
	}
}

void JMG_RP2_Player_Phone_Control_Script::Killed(GameObject *obj,GameObject *damager)
{
	/**///Phone_Trace("Killed",1,0);
	if (PhoneLineID)
	{
		Commands->Send_Custom_Event(obj,Get_GameObj(PhoneLineID),PHONEUserDied,0,0);
	}
	ClearLines = 0;
	Reset_Phone(obj);
	PHONEZONES[Get_Player_ID(obj)] = 1;
	/**///Phone_Trace("Complete - Killed",-1,0);
	Remove_Script(obj,"JMG_RP2_Player_Phone_Control_Script");
}

void JMG_RP2_Player_Phone_Control_Script::PlayerNumberControl(GameObject *sender)
{
	/**///Phone_Trace("PlayerNumberControl",1,0);
	int SenderPlayerID = Get_Player_ID(sender);
	if (!PhoneNumbers)
	{
		PhoneNumbers = new PhoneNumberControl;
		PhoneNumbers->PlayerID = SenderPlayerID;
		PhoneNumbers->StarPressed = StarPress;
		PhoneNumbers->PhoneNumberLength = Number;
		sprintf(PhoneNumbers->PhoneNumber,"%s",cnumber);
		PhoneNumbers->next = NULL;
	}
	else
	{
		int end = 0;
		PhoneNumberControl *Current = PhoneNumbers;
		while (Current != NULL && end == 0)
		{
			if (SenderPlayerID == Current->PlayerID)// match
			{
				end = 1;
				Current->PhoneNumberLength = Number;
				Current->PlayerID = SenderPlayerID;
				Current->StarPressed = StarPress;
				sprintf(Current->PhoneNumber,"%s",cnumber);
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new PhoneNumberControl;
				Current = Current->next; //Switch to new node
				Current->PlayerID = SenderPlayerID;
				Current->PhoneNumberLength = Number;
				Current->StarPressed = StarPress;
				sprintf(Current->PhoneNumber,"%s",cnumber);
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
	ClearNumbers();
	/**///Phone_Trace("Complete - PlayerNumberControl",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PlayerPoundNumberControl(GameObject *obj)
{
	/**///Phone_Trace("PlayerPoundNumberControl",1,0);
	int SenderPlayerID = Get_Player_ID(obj);
	if (PhoneNumbers && SpecialKeys != 0)
	{
		int end = 0;
		PhoneNumberControl *Current = PhoneNumbers;
		while (Current != NULL && end == 0)
		{
			if (SenderPlayerID == Current->PlayerID)// match
			{
				end = 1;
				sprintf(Current->PhonePound,"%s",cnumber);
				WaitingForPound = 0;
				Current->PhonePoundLength = Number;
				Current->PlayerID = SenderPlayerID;
				ClearNumbers();
				Commands->Send_Custom_Event(obj,Commands->Find_Object(PhoneBookID),PHONECallStartCustom,SpecialKeys,0);
			}
			Current = Current->next;
		}
	}
	/**///Phone_Trace("Complete - PlayerPoundNumberControl",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::ClearNumbers()
{
	/**///Phone_Trace("ClearNumbers",1,0);
	Number = 0;
	for (int x = 0;x < 100;x++)
	{
		cnumber[x] = NULL;
	}
	/**///Phone_Trace("Complete - ClearNumbers",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::DisplayCurrentNumber(GameObject *obj)
{
	/**///Phone_Trace("DisplayCurrentNumber",1,0);
	char me[2000];
	sprintf(me,"Current Number: %s",cnumber);
	Send_Message_Player(obj,127,255,0,me);
	/**///Phone_Trace("Complete - DisplayCurrentNumber",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PressNumber(GameObject *obj,char Number1)
{
	//char TraceNumber[2000];
	//sprintf(TraceNumber,"PressNumber %d",Number1);
	///**///Phone_Trace(TraceNumber,1,0);
	cnumber[Number] = Number1;
	Number++;
	char sound[32];
	sprintf(sound,"Phone_%c",Number1);
	Commands->Create_Sound(sound,Commands->Get_Bone_Position(obj,"c R Hand"),obj);
	//sprintf(TraceNumber,"Complete - PressNumber %d",Number1);
	///**///Phone_Trace(TraceNumber,-1,0);
}

int JMG_RP2_Player_Phone_Control_Script::Repeating_Sound_Object(GameObject *obj,const char *Model)
{
	/**///Phone_Trace("Repeating_Sound_Object",1,0);
	Vector3 pos;
	char params[20];
	sprintf(params,"%d",MyIDPC);
	GameObject *SoundObject = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(SoundObject,Model);
	Commands->Attach_To_Object_Bone(SoundObject,obj,"c R Hand");	
	Commands->Attach_Script(SoundObject,"JMG_Remove_Object_When_Creator_Destroyed",params);
	int ID = Commands->Get_ID(SoundObject);
	/**///Phone_Trace("Complete - Repeating_Sound_Object",-1,0);
	return ID;
}

void JMG_RP2_Player_Phone_Control_Script::Remove_Repeating_Sound_Object(int *ID)
{
	/**///Phone_Trace("Remove_Repeating_Sound_Object",1,0);
	GameObject *SoundObject = Commands->Find_Object(*ID);
	if (SoundObject)
	{
		Commands->Destroy_Object(SoundObject);
	}
	*ID = 0;
	/**///Phone_Trace("Complete - Remove_Repeating_Sound_Object",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::Reset_Phone(GameObject *obj)
{
	/**///Phone_Trace("Reset_Phone",1,0);
	WaitingForDescription = 0;
	Number = 0;
	RingThrough = 0;
	StarPress = 0;
	WaitingForPound = 0;
	CallComplete = 0;
	PoundPress = 0;
	HoldSpecial = 0;
	int PlayerID = Get_Player_ID(obj);
	GLOBALPHONELINES[PlayerID] = 0;
	GLOBALPHONETIMES[PlayerID] = 0;
	ShortTermUsage = NULL;
	CallInProgress = 0;
	NewSpecialNumberPress = 0;
	if (SpecialID)
	{
		Commands->Send_Custom_Event(obj,Commands->Find_Object(SpecialID),40860543,0,0);
		SpecialID = 0;
	}
	if (PhoneLineID)
	{
		/**///Phone_Trace("Special Action->Clear Phone Line ID",0,0);
		Commands->Send_Custom_Event(obj,Get_GameObj(PhoneLineID),PHONEUserDied,0,0);
		PhoneLineID = 0;
	}
	for (int x = 0;x < 100;x++)
	{
		cnumber[x] = NULL;
	}
	if (PlayerIDNode->DialToneID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->DialToneID);
	}
	if (PlayerIDNode->RingSoundID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->RingSoundID);
	}
	if (PlayerIDNode->BusySoundID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->BusySoundID);
	}	
	if (PlayerIDNode->OffHookSoundID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->OffHookSoundID);
	}
	if (PlayerIDNode->PhoneDisconnectID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->PhoneDisconnectID);
	}
	if (SpecialKeys != 0)
	{
		GameObject *PhoneBook = Commands->Find_Object(PhoneBookID);
		Commands->Send_Custom_Event(obj,PhoneBook,PHONENumberEndCallMessage,SpecialKeys,0);
		SpecialKeys = 0;
	}	
	if (HousingKeyTransfer != 0)
	{
		GameObject *PhoneBook = Commands->Find_Object(PhoneBookID);
		Commands->Send_Custom_Event(PhoneBook,PhoneBook,PHONENumberEndCallMessage,HousingKeyTransfer,0);
		HousingKeyTransfer = 0;
	}	
	if (!TurnedOff)// Added so it could ring while in vehicles
	{
		if (ClearLines)// Special so you don't lose the call if you clear out your last call
		{
			if (!PlayerIDNode->RingSoundID)
			{
				PlayerIDNode->RingSoundID = Repeating_Sound_Object(obj,"Phone_Ring_Y_E");
			}
			if (PlayerIDNode->CallWaitingID)
			{
				Remove_Repeating_Sound_Object(&PlayerIDNode->CallWaitingID);
			}
		}
		else// Kill Open Line - clear all calls
		{
			if (PlayerIDNode->RingSoundID)
			{
				Remove_Repeating_Sound_Object(&PlayerIDNode->RingSoundID);
			}
			if (PlayerIDNode->CallWaitingID)
			{
				Remove_Repeating_Sound_Object(&PlayerIDNode->CallWaitingID);
			}
			if (CallerID)
			{
				Commands->Send_Custom_Event(obj,Get_GameObj(CallerID),PHONEUserDied,0,0);// Tell other Phone that there was a DC!
			}
			CallerID = 0;
			PhoneLineID = 0;
		}
		ClearLines = 0;
	}
	/**///Phone_Trace("Complete - Reset_Phone",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::Redial_Sound(GameObject *obj,char Number1)
{
	/*//*///Phone_Trace("Redial_Sound",1,0);
	char sound[32];
	sprintf(sound,"Phone_%c",Number1);
	Commands->Create_Sound(sound,Commands->Get_Bone_Position(obj,"c R Hand"),obj);
	/*//*///Phone_Trace("Complete - Redial_Sound",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::Phone_Ring_Timeout(GameObject *obj)
{
	///**///Phone_Trace("Phone_Ring_Timeout",1,0);
	if (ReachedNumber == 0 && CallInProgress == 1 && PhoneOut == 1)
	{
		RingThrough++;
		if (RingThrough >= 120)
		{
			if (PhoneLineID)
			{
				Commands->Send_Custom_Event(obj,Get_GameObj(PhoneLineID),PHONEUserDied,0,0);
				PhoneLineID = 0;
			}
			RingThrough = 0;
			Phone_Disconnect(obj);
		}
		else
		{
			Commands->Start_Timer(obj,this,0.1f,60540800);
		}
	}
	else
	{
		RingThrough = 0;
	}
	///**///Phone_Trace("Complete - Phone_Ring_Timeout",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::Phone_Position_Control(GameObject *obj)
{
	///**///Phone_Trace("Phone_Position_Control",1,0);
	if (!Number && !CallInProgress && !PlayerIDNode->DialToneID && PhoneOut && !CallerID)
	{
		if (Powered)
		{
			PlayerIDNode->DialToneID = Repeating_Sound_Object(obj,"Phone_Dial_Tone");
		}
	}
	else if ((Number || CallInProgress || CallerID) && PlayerIDNode->DialToneID)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->DialToneID);
	}
	const char *weap = Get_Current_Weapon(obj);
	if (!Has_Weapon(obj,"Weapon_Cell_Phone"))// Shut down script if you drop the phone
	{
		if (PhoneOut)
		{
			Reset_Phone(obj);
			PhoneOut = 0;
		}
	}
	else if (weap && !Get_Vehicle(obj))
	{
		if (!_stricmp(weap,"Weapon_Cell_Phone") && !PhoneOut)
		{
			PhoneOut = 1;
			if ((CallerID && FirstTimeOut) || FirstTimeOut)
			{
				FirstTimeOut = 0;
				if (!CallerID)
				{
					Reset_Phone(obj);
				}
			}
			if (!PhoneEnabled)
			{
				Send_Message_Player(obj,127,255,0,"No signal...");
			}
		}
		else if (_stricmp(weap,"Weapon_Cell_Phone") && PhoneOut)
		{
			Reset_Phone(obj);
			PhoneOut = 0;
		}
	}
	if (Get_Vehicle(obj) && !InVehicle)
	{
		InVehicle = 1;
		if (PhoneOut)
		{
			Reset_Phone(obj);
		}
		PhoneOut = 0;
		if (Powered)
		{
			TurnedOff = 1;
			PowerButton(obj);
		}
	}
	else if (!Get_Vehicle(obj) && InVehicle)
	{
		if (TurnedOff)
		{
			PowerButton(obj);
			TurnedOff = 0;
			if (CallerID)
			{
				if (!PlayerIDNode->RingSoundID)
				{
					PlayerIDNode->RingSoundID = Repeating_Sound_Object(obj,"Phone_Ring_Y_E");
				}
			}
		}
		InVehicle = 0;
	}
	Commands->Start_Timer(obj,this,0.1f,60540801);
	///**///Phone_Trace("Complete - Phone_Position_Control",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::Phone_Redial_Sound_Trigger(GameObject *obj)
{
	///**///Phone_Trace("Phone_Redial_Sound_Trigger",1,0);
	Redial_Sound(obj,BackupNumber[RedialFast[1]]);
	if (RedialFast[1] < RedialFast[0])
	{
		Commands->Start_Timer(obj,this,0.25f,60540802);
		RedialFast[1]++;
	}
	else
	{	
		Commands->Start_Timer(obj,this,12.0f,60540800);
		if (PlayerIDNode->RingSoundID == 0)
		{
			PlayerIDNode->RingSoundID = Repeating_Sound_Object(obj,"Phone_Ring");
		}
		Commands->Send_Custom_Event(obj,Commands->Find_Object(PhoneBookID),PHONECallStartCustom,0,0);
	}
	///**///Phone_Trace("Complete - Phone_Redial_Sound_Trigger",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::Call_Complete(GameObject *obj)
{
	/*//*///Phone_Trace("Call_Complete",1,0);
	if (CallInProgress == 1)
	{
		CallComplete++;
		if (CallComplete < 25)
		{
			Commands->Start_Timer(obj,this,0.1f,60540804);
		}
		else
		{
			if (PlayerIDNode->OffHookSoundID == 0)
			{
				PlayerIDNode->OffHookSoundID = Repeating_Sound_Object(obj,"Phone_Off_Hook");
			}
			CallComplete = 0;
		}
	}
	else if (CallInProgress == 0)
	{
		CallComplete = 0;
	}
	/*//*///Phone_Trace("Complete - Call_Complete",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::LostSignal(GameObject *obj)
{
	/**///Phone_Trace("LostSignal",1,0);
	PHONEZONES[Get_Player_ID(obj)]--;
	if (PHONEZONES[Get_Player_ID(obj)] <= 0)
	{
		Reset_Phone(obj);
		if (PHONEZONES[Get_Player_ID(obj)] == 0)
		{
			if (PhoneOut && Powered)
			{
				Send_Message_Player(obj,127,255,0,"Signal lost...");
			}
		}
		PhoneEnabled = 0;
	}
	/**///Phone_Trace("Complete - LostSignal",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::SignalDetected(GameObject *obj)
{
	/**///Phone_Trace("SignalDetected",1,0);
	PHONEZONES[Get_Player_ID(obj)]++;
	if (PHONEZONES[Get_Player_ID(obj)] > 0)
	{
		PhoneEnabled = 1;
		if (PHONEZONES[Get_Player_ID(obj)] == 1)
		{
			if (PhoneOut && Powered)
			{
				Send_Message_Player(obj,127,255,0,"Signal in range...");
			}
		}
	}
	/**///Phone_Trace("Complete - SignalDetected",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::NumberKeyPressed(GameObject *obj,int message)
{
	/**///Phone_Trace("NumberKeyPressed",1,0);
	if ((SpecialKeys == 0 || (WaitingForPound == 1 && SpecialKeys != 0)) && !NewSpecialNumberPress)
	{
		if (Number < 100)
		{
			if (message == 940860500)
			{
				if (Number > 0)
				{
					PressNumber(obj,'0');
				}
				else
				{
					/**///Phone_Trace("Press_0_Key_Fake",1,0);
					Commands->Create_Sound("Phone_0",Commands->Get_Bone_Position(obj,"c R Hand"),obj);
					/**///Phone_Trace("Complete - Press_0_Key_Fake",-1,0);
				}
			}
			if (message == 940860501)
			{
				PressNumber(obj,'1');
			}
			if (message == 940860502)
			{
				PressNumber(obj,'2');
			}
			if (message == 940860503)
			{
				PressNumber(obj,'3');
			}
			if (message == 940860504)
			{
				PressNumber(obj,'4');
			}
			if (message == 940860505)
			{
				PressNumber(obj,'5');
			}
			if (message == 940860506)
			{
				PressNumber(obj,'6');
			}
			if (message == 940860507)
			{
				PressNumber(obj,'7');
			}
			if (message == 940860508)
			{
				PressNumber(obj,'8');
			}
			if (message == 940860509)
			{
				PressNumber(obj,'9');
			}
		}
		else
		{
			/**///Phone_Trace("Number_Buffer_Full",1,0);
			Send_Message_Player(obj,127,255,0,"Max Number Length Exceeded!");
			Commands->Create_Sound("Phone_B",Commands->Get_Bone_Position(obj,"c R Hand"),obj);
			/**///Phone_Trace("Complete - Number_Buffer_Full",-1,0);
		}
	}
	else if (NewSpecialNumberPress)
	{
		if (message == 940860500)
		{
			PressNumberSpecial(obj,'0');
		}
		if (message == 940860501)
		{
			PressNumberSpecial(obj,'1');
		}
		if (message == 940860502)
		{
			PressNumberSpecial(obj,'2');
		}
		if (message == 940860503)
		{
			PressNumberSpecial(obj,'3');
		}
		if (message == 940860504)
		{
			PressNumberSpecial(obj,'4');
		}
		if (message == 940860505)
		{
			PressNumberSpecial(obj,'5');
		}
		if (message == 940860506)
		{
			PressNumberSpecial(obj,'6');
		}
		if (message == 940860507)
		{
			PressNumberSpecial(obj,'7');
		}
		if (message == 940860508)
		{
			PressNumberSpecial(obj,'8');
		}
		if (message == 940860509)
		{
			PressNumberSpecial(obj,'9');
		}
	}
	else
	{
		if (message == 940860501)
		{
			/**///Phone_Trace("Special_Keys_Mode_1_Key",1,0);
			Commands->Create_Sound("Phone_1",Commands->Get_Bone_Position(obj,"c R Hand"),obj);
			Commands->Send_Custom_Event(obj,Commands->Find_Object(PhoneBookID),PHONESpecial1Key,SpecialKeys,0);
			if (!HoldSpecial)
			{
				SpecialKeys = 0;
			}
			HoldSpecial = 0;
			/**///Phone_Trace("Complete - Special_Keys_Mode_1_Key",-1,0);
		}
		if (message == 940860502)
		{
			/**///Phone_Trace("Special_Keys_Mode_2_Key",1,0);
			Commands->Create_Sound("Phone_2",Commands->Get_Bone_Position(obj,"c R Hand"),obj);
			Commands->Send_Custom_Event(obj,Commands->Find_Object(PhoneBookID),PHONESpecial2Key,SpecialKeys,0);
			if (!HoldSpecial)
			{
				SpecialKeys = 0;
			}
			HoldSpecial = 0;
			/**///Phone_Trace("Complete - Special_Keys_Mode_2_Key",-1,0);
		}
	}
	/**///Phone_Trace("Complete - NumberKeyPressed",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::ClearKeyPressed(GameObject *obj)
{
	/**///Phone_Trace("ClearKeyPressed",1,0);
	if (SpecialKeys != 0)
	{
		Commands->Send_Custom_Event(obj,Commands->Find_Object(PhoneBookID),PHONENumberEndCallMessage,SpecialKeys,0);
	}
	Reset_Phone(obj);
	if (Number)
	{
		Send_Message_Player(obj,127,255,0,cnumber);
	}
	Commands->Create_Sound("Phone_A",Commands->Get_Bone_Position(obj,"c R Hand"),obj);
	/**///Phone_Trace("Complete - ClearKeyPressed",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::StarKeyPressed(GameObject *obj)
{
	/**///Phone_Trace("StarKeyPressed",1,0);
	Commands->Create_Sound("Phone_Star",Commands->Get_Bone_Position(obj,"c R Hand"),obj);
	if (!PlayerIDNode->OffHookSoundID)
	{
		if (!StarPress)
		{
			StarPress = 1;
			if (Number)
			{
				WaitingForDescription = 1;
				DefinePhoneNumberNode(obj);
				Send_Message_Player(obj,127,255,0,"Scanning phone records to find a matching phone number, stand-by...");
				Commands->Send_Custom_Event(obj,obj,PHONECheckForRedialNumberMatchReturn,0,0.15f);
				Commands->Send_Custom_Event(obj,Commands->Find_Object(PhoneBookID),PHONESearchForMatchingNumbersCustom,PHONESearchForMatchingNumbersCustom,0);
			}
			else if (!Number && !CallComplete && CallInProgress == 0 && SpecialKeys == 0)
			{
				Send_Message_Player(obj,127,255,0,"Choose one of your speed dial numbers:");
			}
			else if (WaitingForPound)
			{
				Send_Message_Player(obj,127,255,0,"Choose one of your speed dial numbers to input into this inquiry:");
			}
		}
		else
		{
			StarPress = 0;
			WaitingForDescription = 0;
			ShortTermUsage = NULL;
			Send_Message_Player(obj,127,255,0,"Star menu left, normal functionality restored.");
		}
	}
	/**///Phone_Trace("Complete - StarKeyPressed",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PoundKeyPressed(GameObject *obj)
{
	/**///Phone_Trace("PoundKeyPressed",1,0);
	if (!PlayerIDNode->OffHookSoundID)
	{
		if (SpecialKeys != 0 && WaitingForPound == 1)
		{
			PlayerPoundNumberControl(obj);
		}
	}
	Commands->Create_Sound("Phone_Pound",Commands->Get_Bone_Position(obj,"c R Hand"),obj);
	/**///Phone_Trace("Complete - PoundKeyPressed",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::ListPhoneNumbers(GameObject *obj,int channel)
{
	/**///Phone_Trace("ListPhoneNumbers",1,0);
	Send_Message_Player(obj,127,255,0,"----------Phone Number List----------");
	char Temp[2000];
	if (PersonalPhoneNumber)
	{
		sprintf(Temp,"My Phone Number: %s",MyPhoneNumber);
		Send_Message_Player(obj,127,255,0,Temp);
	}
	Commands->Send_Custom_Event(obj,Commands->Find_Object(PhoneBookID),PHONERequestKnownPhoneNumberList,channel,0);
	Send_Message_Player(obj,127,255,0,"------------------------------------------");
	/**///Phone_Trace("Complete - ListPhoneNumbers",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::DisplayCurrentlyEnteredNumber(GameObject *obj)
{
	/**///Phone_Trace("DisplayCurrentlyEnteredNumber",1,0);
	if (Number > 0)
	{
		DisplayCurrentNumber(obj);
	}
	/**///Phone_Trace("Complete - DisplayCurrentlyEnteredNumber",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::DeleteKeyPressed(GameObject *obj)
{
	/**///Phone_Trace("DeleteKeyPressed",1,0);
	if (!PlayerIDNode->OffHookSoundID)
	{
		if (Number > 0)
		{
			Number--;
			cnumber[Number] = NULL;
			if (Number > 0)
			{
				DisplayCurrentNumber(obj);
			}
			Commands->Create_Sound("Phone_C",Commands->Get_Bone_Position(obj,"c R Hand"),obj);
		}
	}
	else
	{
		Commands->Create_Sound("Phone_C",Commands->Get_Bone_Position(obj,"c R Hand"),obj);
	}
	/**///Phone_Trace("Complete - DeleteKeyPressed",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::SendKeyPressed(GameObject *obj)
{
	/**///Phone_Trace("SendKeyPressed",1,0);
	Commands->Create_Sound("Phone_D",Commands->Get_Bone_Position(obj,"c R Hand"),obj);
	if (!CallInProgress)
	{
		if (PhoneEnabled)
		{
			if (Number)// Normal Callout
			{
				sprintf(BackupNumber,"%s",cnumber);
				ReachedNumber = 0;
				CallInProgress = 1;
				RedialFast[0] = Number;
				RedialFast[1] = 0;
				char CallNumber[2000];
				sprintf(CallNumber,"Calling %s...",cnumber);
				Send_Message_Player(obj,127,255,0,CallNumber);
				Commands->Start_Timer(obj,this,0.35f,60540802);
				PlayerNumberControl(obj);
			}
			else if (CallerID)// Teleport Caller To me
			{
				ClearLines = 0;
				GameObject *Caller = Get_GameObj(CallerID);
				if (Caller)
				{
					if (Commands->Get_Distance(Commands->Get_Position(obj),LastPos[0]) > 1.25f)
					{
						Commands->Set_Position(Caller,LastPos[0]);
					}
					else if (Commands->Get_Distance(Commands->Get_Position(obj),LastPos[1]) > 1.25f)
					{
						Commands->Set_Position(Caller,LastPos[1]);
					}
				}
				Commands->Send_Custom_Event(obj,Caller,PHONEOtherGuyHungUp,0,0);//Reset Phones
				Commands->Send_Custom_Event(obj,obj,PHONEOtherGuyHungUp,0,0.1f);//Reset Phones
			}
		}
		else
		{
			if (Number > 0)
			{
				Reset_Phone(obj);
				Send_Message_Player(obj,127,255,0,"No signal...");
			}
		}
	}
	/**///Phone_Trace("Complete - SendKeyPressed",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::WaitingForAdditionalNumber(GameObject *obj,int param)
{
	/**///Phone_Trace("WaitingForAdditionalNumber",1,0);
	SpecialKeys = param;
	ReachedNumber = 1;
	WaitingForPound = 1;
	if (PlayerIDNode->RingSoundID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->RingSoundID);
	}
	/**///Phone_Trace("Complete - WaitingForAdditionalNumber",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::CallWaitingBeep(GameObject *obj)
{
	/**///Phone_Trace("CallWaitingBeep",1,0);
	if (PlayerIDNode->CallWaitingID == 0)
	{
		PlayerIDNode->CallWaitingID = Repeating_Sound_Object(obj,"Phone_Call_Wait");
	}
	/**///Phone_Trace("Complete - CallWaitingBeep",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PhoneLineBusy(GameObject *obj)
{
	/**///Phone_Trace("PhoneLineBusy",1,0);
	if (PlayerIDNode->RingSoundID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->RingSoundID);
	}
	if (PlayerIDNode->BusySoundID == 0)
	{
		PlayerIDNode->BusySoundID = Repeating_Sound_Object(obj,"Phone_Line_Busy");
	}
	if (HousingKeyTransfer)
	{
		GameObject *PhoneBook = Commands->Find_Object(PhoneBookID);
		Commands->Send_Custom_Event(PhoneBook,PhoneBook,40860507,HousingKeyTransfer,0);
	}
	/**///Phone_Trace("Complete - PhoneLineBusy",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PhoneCallPickedUp(GameObject *obj,int param)
{
	/**///Phone_Trace("PhoneCallPickedUp",1,0);
	SpecialKeys = param;
	ReachedNumber = 1;
	if (PlayerIDNode->RingSoundID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->RingSoundID);
	}
	/**///Phone_Trace("Complete - PhoneCallPickedUp",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PhoneCallPickedUpSimple(GameObject *obj)
{
	/**///Phone_Trace("PhoneCallPickedUpSimple",1,0);
	SpecialKeys = 0;
	ReachedNumber = 1;
	if (PlayerIDNode->RingSoundID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->RingSoundID);
	}
	/**///Phone_Trace("Complete - PhoneCallPickedUpSimple",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::CallCompleteMessage(GameObject *obj)
{
	/**///Phone_Trace("CallCompleteMessage",1,0);
	if (CallerID)
	{
		if (!PlayerIDNode->RingSoundID)
		{
			PlayerIDNode->RingSoundID = Repeating_Sound_Object(obj,"Phone_Ring_Y_E");
		}
		if (PlayerIDNode->CallWaitingID)
		{
			Remove_Repeating_Sound_Object(&PlayerIDNode->CallWaitingID);
		}
		CallInProgress = 0;
		ClearLines = 0;
	}
	else if (!CallComplete)
	{
		Commands->Start_Timer(obj,this,0.1f,60540804);
	}
	/**///Phone_Trace("Complete - CallCompleteMessage",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::AddPersonalNumberNode(GameObject *obj)
{
	/**///Phone_Trace("AddPersonalNumberNode",1,0);
	char PlayerName[2000],PhoneNumber[100];
	const char *str = Get_Player_Name(obj);
	sprintf(PlayerName,"%s",str);
	delete[] str;
	int NumberOfLetters = 0,Sum = 0,LetterCount = strlen(PlayerName);
	for (int x = 0;x < LetterCount;x++)
	{
		NumberOfLetters++;
		Sum += PlayerName[x];
	}
	sprintf(PhoneNumber,"4%02d%04d%03d",NumberOfLetters,abs(Sum-(5*Sum)),abs(PlayerName[0]-PlayerName[LetterCount]));
	if (!CellPhoneNumberNode)
	{
		CellPhoneNumberNode = new CellPhoneNumberControl;
		CellPhoneNumberNode->PlayerID = Get_Player_ID(obj);
		sprintf(CellPhoneNumberNode->PlayerName,"%s",PlayerName);
		sprintf(CellPhoneNumberNode->MyPhoneNumber,"%s",PhoneNumber);
		CellPhoneNumberNode->NumberLength = (strlen(CellPhoneNumberNode->MyPhoneNumber));
		PersonalPhoneNumber = CellPhoneNumberNode;
		CellPhoneNumberNode->next = NULL;
	}
	else
	{
		int end = 0,Attempts = 1,Runout = 0;
		RestartUniqueNumber:
		CellPhoneNumberControl *Current = CellPhoneNumberNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Current->MyPhoneNumber,PhoneNumber))
			{
				if (_stricmp(Current->PlayerName,PlayerName))
				{
					if (Attempts == 1)
					{
						for (int x = 98;x >= 0;x--)
						{
							PhoneNumber[x+1] = PhoneNumber[x];
						}
					}
					char IChar = '0';
					switch (Attempts){case 1: IChar = '1';break;case 2: IChar = '2';break;case 3: IChar = '3';break;case 4: IChar = '4';break;case 5: IChar = '5';break;case 6: IChar = '6';break;case 7: IChar = '7';break;case 8: IChar = '8';break;case 9: IChar = '9';break;}
					if (Attempts <= 9)
					{
						PhoneNumber[0] = IChar;
					}
					Attempts++;
					if (Attempts >= 10)
					{
						Attempts = 1;
					}
					Runout++;
					if (Runout < 50)
					{
						goto RestartUniqueNumber;
					}
				}
				else
				{
					end = 1;
					Current->PlayerID = Get_Player_ID(obj);
					PersonalPhoneNumber = Current;
				}
			}
			if (Current->next == NULL && end == 0)
			{
				end = 1;
				Current->next = new CellPhoneNumberControl;
				Current = Current->next;
				Current->PlayerID = Get_Player_ID(obj);
				sprintf(Current->PlayerName,"%s",PlayerName);
				sprintf(Current->MyPhoneNumber,"%s",PhoneNumber);
				Current->NumberLength = (strlen(Current->MyPhoneNumber));
				PersonalPhoneNumber = Current;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
	/**///Phone_Trace("Complete - AddPersonalNumberNode",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PhoneIdleAndCalled(GameObject *obj,int param)
{
	/**///Phone_Trace("PhoneIdleAndCalled",1,0);
	ClearLines = 0;
	CallerID = param;
	GameObject *Caller = Get_GameObj(CallerID);
	if (Caller)
	{
		char Calling[2000];
		const char *str = Get_Player_Name(Caller);
		sprintf(Calling,"%s is calling...",str);
		delete[] str;
		Send_Message_Player(obj,127,255,0,Calling);
	}
	else
	{
		CallerID = 0;
		return;
	}
	if (PlayerIDNode->RingSoundID == 0)
	{
		PlayerIDNode->RingSoundID = Repeating_Sound_Object(obj,"Phone_Ring_Y_E");
	}
	/**///Phone_Trace("Complete - PhoneIdleAndCalled",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PhoneInUseAndCalled(GameObject *obj,int param)
{
	/**///Phone_Trace("PhoneInUseAndCalled",1,0);
	ClearLines = 1;
	CallerID = param;
	GameObject *Caller = Get_GameObj(CallerID);
	if (Caller)
	{
		char Calling[2000];
		const char *str = Get_Player_Name(Caller);
		sprintf(Calling,"%s is calling...",str);
		delete[] str;
		Send_Message_Player(obj,127,255,0,Calling);
		CallerID = param;
	}
	else
	{
		CallerID = 0;
		ClearLines = 0;
		return;
	}
	if (PlayerIDNode->CallWaitingID == 0)
	{
		PlayerIDNode->CallWaitingID = Repeating_Sound_Object(obj,"Phone_Call_Wait");
	}
	/**///Phone_Trace("Complete - PhoneInUseAndCalled",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PhoneCallDelayRelay(GameObject *obj)
{
	/**///Phone_Trace("PhoneCallDelayRelay",1,0);
	RingUp--;
	if (RingUp <= 0)
	{
		GameObject *OtherPlayer = Get_GameObj(PhoneLineID);
		Send_Message_Player(obj,127,255,0,"Connected, ringing through!");
		RingThrough = -120;// Give the Phone more time before auto hangup;
		Commands->Send_Custom_Event(obj,OtherPlayer,PHONECallReccived,Get_Player_ID(obj),0);// Send message to other player
	}
	else
	{
		Commands->Send_Custom_Event(obj,obj,PHONECallRingDelay,1,0.1f);// Restart its own timer
	}
	/**///Phone_Trace("Complete - PhoneCallDelayRelay",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::HumanCallObjectFound(GameObject *obj,int param)
{
	/**///Phone_Trace("HumanCallObjectFound",1,0);
	if (!CallerID)
	{
		if (!Number && !CallInProgress)
		{
			PhoneIdleAndCalled(obj,param);
		}
		else
		{
			PhoneInUseAndCalled(obj,param);
		}
	}
	else
	{
		Commands->Send_Custom_Event(obj,Get_GameObj(param),PHONELineBusy,0,0);//Phone line Busy
	}
	/**///Phone_Trace("Complete - HumanCallObjectFound",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::ContactKilledRS(GameObject *obj)
{
	/**///Phone_Trace("ContactKilledRS",1,0);
	if (PlayerIDNode->CallWaitingID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->CallWaitingID);
	}
	else if (PlayerIDNode->RingSoundID != 0)
	{
		CallInProgress = 0;
		Remove_Repeating_Sound_Object(&PlayerIDNode->RingSoundID);
	}
	if (ClearLines == 0)
	{
		for (int x = 0;x < 100;x++)
		{
			cnumber[x] = NULL;
		}
		SpecialKeys = 0;
		Number = 0;
		RingThrough = 0;
		StarPress = 0;
		WaitingForPound = 0;
		CallComplete = 0;
	}
	ClearLines = 0;
	CallerID = 0;
	PhoneLineID = 0;
	PoundPress = 0;
	HousingKeyTransfer = 0;
	/**///Phone_Trace("Complete - ContactKilledRS",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::Phone_Busy_Startup(GameObject *obj)
{
	/**///Phone_Trace("Phone_Busy_Startup",1,0);
	if (CallInProgress == 1)
	{
		CallComplete++;
		if (CallComplete < 25)
		{
			Commands->Start_Timer(obj,this,0.1f,60540806);
		}
		else
		{
			PhoneLineBusy(obj);
			CallComplete = 0;
		}
	}
	else if (CallInProgress == 0)
	{
		CallComplete = 0;
	}
	/**///Phone_Trace("Complete - Phone_Busy_Startup",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::Phone_Disconnect(GameObject *obj)
{
	/**///Phone_Trace("Phone_Disconnect",1,0);
	if (PlayerIDNode->RingSoundID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->RingSoundID);
	}
	if (!PlayerIDNode->PhoneDisconnectID && !PlayerIDNode->OffHookSoundID && !PlayerIDNode->BusySoundID)
	{
		PlayerIDNode->PhoneDisconnectID = Repeating_Sound_Object(obj,"PhoneDisconnect");
	}
	/**///Phone_Trace("Complete - Phone_Disconnect",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::RedialNodeSetup(GameObject *obj)
{
	/**///Phone_Trace("RedialNodeSetup",1,0);
	char PlayerName[256];
	const char *str = Get_Player_Name(obj);
	sprintf(PlayerName,"%s",str);
	delete[] str;
	if (!PlayerRedialNumberNode)
	{
		PlayerRedialNumberNode = new PlayerRedialNumberControl;
		sprintf(PlayerRedialNumberNode->PlayerName,"%s",PlayerName);
		sprintf(PlayerRedialNumberNode->PhoneNumber0,"Empty");
		sprintf(PlayerRedialNumberNode->PhoneNumber1,"Empty");
		sprintf(PlayerRedialNumberNode->PhoneNumber2,"Empty");
		sprintf(PlayerRedialNumberNode->PhoneNumber3,"Empty");
		sprintf(PlayerRedialNumberNode->PhoneNumber4,"Empty");
		sprintf(PlayerRedialNumberNode->PhoneNumber5,"Empty");
		sprintf(PlayerRedialNumberNode->PhoneNumber6,"Empty");
		sprintf(PlayerRedialNumberNode->PhoneNumber7,"Empty");
		sprintf(PlayerRedialNumberNode->PhoneNumber8,"Empty");
		sprintf(PlayerRedialNumberNode->PhoneNumber9,"Empty");
		for (int x = 0;x < 10;x++)
		{
			PlayerRedialNumberNode->NumberLength[x] = 0;
		}
		PlayerRedialNumbers = PlayerRedialNumberNode;
		PlayerRedialNumberNode->next = NULL;
	}
	else
	{
		int end = 0;
		PlayerRedialNumberControl *Current = PlayerRedialNumberNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				end = 1;
				PlayerRedialNumbers = Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new PlayerRedialNumberControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				sprintf(Current->PhoneNumber0,"Empty");
				sprintf(Current->PhoneNumber1,"Empty");
				sprintf(Current->PhoneNumber2,"Empty");
				sprintf(Current->PhoneNumber3,"Empty");
				sprintf(Current->PhoneNumber4,"Empty");
				sprintf(Current->PhoneNumber5,"Empty");
				sprintf(Current->PhoneNumber6,"Empty");
				sprintf(Current->PhoneNumber7,"Empty");
				sprintf(Current->PhoneNumber8,"Empty");
				sprintf(Current->PhoneNumber9,"Empty");
				for (int x = 0;x < 10;x++)
				{
					Current->NumberLength[x] = 0;
				}
				PlayerRedialNumbers = Current;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
	/**///Phone_Trace("Complete - RedialNodeSetup",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::NumberKeyPressedStorage(GameObject *obj,int message)
{
	/**///Phone_Trace("NumberKeyPressedStorage",1,0);
	if (PlayerRedialNumbers && Number)
	{
		if (!WaitingForDescription)
		{
			char Message[2000];
			if (message == 940860500)
			{
				PlayerRedialNumbers->NumberLength[0] = Number;
				sprintf(PlayerRedialNumbers->PhoneNumber0,"%s",ShortTermUsage->PhoneNumber);
				sprintf(Message,"Phone Number:%s has been stored under %d.",cnumber,0);
			}
			if (message == 940860501)
			{
				PlayerRedialNumbers->NumberLength[1] = Number;
				sprintf(PlayerRedialNumbers->PhoneNumber1,"%s",ShortTermUsage->PhoneNumber);
				sprintf(Message,"Phone Number:%s has been stored under %d.",cnumber,1);
			}
			if (message == 940860502)
			{
				PlayerRedialNumbers->NumberLength[2] = Number;
				sprintf(PlayerRedialNumbers->PhoneNumber2,"%s",ShortTermUsage->PhoneNumber);
				sprintf(Message,"Phone Number:%s has been stored under %d.",cnumber,2);
			}
			if (message == 940860503)
			{
				PlayerRedialNumbers->NumberLength[3] = Number;
				sprintf(PlayerRedialNumbers->PhoneNumber3,"%s",ShortTermUsage->PhoneNumber);
				sprintf(Message,"Phone Number:%s has been stored under %d.",cnumber,3);
			}
			if (message == 940860504)
			{
				PlayerRedialNumbers->NumberLength[4] = Number;
				sprintf(PlayerRedialNumbers->PhoneNumber4,"%s",ShortTermUsage->PhoneNumber);
				sprintf(Message,"Phone Number:%s has been stored under %d.",cnumber,4);
			}
			if (message == 940860505)
			{
				PlayerRedialNumbers->NumberLength[5] = Number;
				sprintf(PlayerRedialNumbers->PhoneNumber5,"%s",ShortTermUsage->PhoneNumber);
				sprintf(Message,"Phone Number:%s has been stored under %d.",cnumber,5);
			}
			if (message == 940860506)
			{
				PlayerRedialNumbers->NumberLength[6] = Number;
				sprintf(PlayerRedialNumbers->PhoneNumber6,"%s",ShortTermUsage->PhoneNumber);
				sprintf(Message,"Phone Number:%s has been stored under %d.",cnumber,6);
			}
			if (message == 940860507)
			{
				PlayerRedialNumbers->NumberLength[7] = Number;
				sprintf(PlayerRedialNumbers->PhoneNumber7,"%s",ShortTermUsage->PhoneNumber);
				sprintf(Message,"Phone Number:%s has been stored under %d.",cnumber,7);
			}
			if (message == 940860508)
			{
				PlayerRedialNumbers->NumberLength[8] = Number;
				sprintf(PlayerRedialNumbers->PhoneNumber8,"%s",ShortTermUsage->PhoneNumber);
				sprintf(Message,"Phone Number:%s has been stored under %d.",cnumber,8);
			}
			if (message == 940860509)
			{
				PlayerRedialNumbers->NumberLength[9] = Number;
				sprintf(PlayerRedialNumbers->PhoneNumber9,"%s",ShortTermUsage->PhoneNumber);
				sprintf(Message,"Phone Number:%s has been stored under %d.",cnumber,9);
			}
			Send_Message_Player(obj,127,255,0,Message);
			Reset_Phone(obj);
		}
		else
		{
			Send_Message_Player(obj,127,255,0,"Searching for matches, stand-by...");
		}
	}
	/**///Phone_Trace("Complete - NumberKeyPressedStorage",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::NumberKeyPressedRedial(GameObject *obj,int message,int PoundKeyNeeded)
{
	/**///Phone_Trace("NumberKeyPressedRedial",1,0);
	if (PlayerRedialNumbers)
	{
		if (message == 940860500)
		{
			Number = PlayerRedialNumbers->NumberLength[0];
			ExtractRedialNumber(PlayerRedialNumbers->PhoneNumber0,Number);
		}
		if (message == 940860501)
		{
			Number = PlayerRedialNumbers->NumberLength[1];
			ExtractRedialNumber(PlayerRedialNumbers->PhoneNumber1,Number);
		}
		if (message == 940860502)
		{
			Number = PlayerRedialNumbers->NumberLength[2];
			ExtractRedialNumber(PlayerRedialNumbers->PhoneNumber2,Number);
		}
		if (message == 940860503)
		{
			Number = PlayerRedialNumbers->NumberLength[3];
			ExtractRedialNumber(PlayerRedialNumbers->PhoneNumber3,Number);
		}
		if (message == 940860504)
		{
			Number = PlayerRedialNumbers->NumberLength[4];
			ExtractRedialNumber(PlayerRedialNumbers->PhoneNumber4,Number);
		}
		if (message == 940860505)
		{
			Number = PlayerRedialNumbers->NumberLength[5];
			ExtractRedialNumber(PlayerRedialNumbers->PhoneNumber5,Number);
		}
		if (message == 940860506)
		{
			Number = PlayerRedialNumbers->NumberLength[6];
			ExtractRedialNumber(PlayerRedialNumbers->PhoneNumber6,Number);
		}
		if (message == 940860507)
		{
			Number = PlayerRedialNumbers->NumberLength[7];
			ExtractRedialNumber(PlayerRedialNumbers->PhoneNumber7,Number);
		}
		if (message == 940860508)
		{
			Number = PlayerRedialNumbers->NumberLength[8];
			ExtractRedialNumber(PlayerRedialNumbers->PhoneNumber8,Number);
		}
		if (message == 940860509)
		{
			Number = PlayerRedialNumbers->NumberLength[9];
			ExtractRedialNumber(PlayerRedialNumbers->PhoneNumber9,Number);
		}
		if (Number > 0)
		{
			if (!PoundKeyNeeded)// Press Send
			{
				StarPress = 0;
				Commands->Send_Custom_Event(obj,obj,940860511,1,0);// Send Button Message
			}
			else
			{
				StarPress = 0;
				char MESSAGE[237];
				sprintf(MESSAGE,"The number %s has been entered and pound has been emulated.",cnumber);
				Send_Message_Player(obj,127,255,0,MESSAGE);
				Commands->Send_Custom_Event(obj,obj,940860514,1,0);// Pound Button Message
			}
		}
		else
		{
			Send_Message_Player(obj,127,255,0,"There is no phone number stored under that key!");
			Reset_Phone(obj);
		}
	}
	/**///Phone_Trace("Complete - NumberKeyPressedRedial",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::ListStoredPhoneNumbers(GameObject *obj)
{
	/**///Phone_Trace("ListPhoneNumbers",1,0);
	Send_Message_Player(obj,127,255,0,"-------Stored Phone Number List------");
	char Temp[2000];
	sprintf(Temp,"Phone Number 0: %s",PlayerRedialNumbers->PhoneNumber0);
	Send_Message_Player(obj,127,255,0,Temp);
	sprintf(Temp,"Phone Number 1: %s",PlayerRedialNumbers->PhoneNumber1);
	Send_Message_Player(obj,127,255,0,Temp);
	sprintf(Temp,"Phone Number 2: %s",PlayerRedialNumbers->PhoneNumber2);
	Send_Message_Player(obj,127,255,0,Temp);
	sprintf(Temp,"Phone Number 3: %s",PlayerRedialNumbers->PhoneNumber3);
	Send_Message_Player(obj,127,255,0,Temp);
	sprintf(Temp,"Phone Number 4: %s",PlayerRedialNumbers->PhoneNumber4);
	Send_Message_Player(obj,127,255,0,Temp);
	sprintf(Temp,"Phone Number 5: %s",PlayerRedialNumbers->PhoneNumber5);
	Send_Message_Player(obj,127,255,0,Temp);
	sprintf(Temp,"Phone Number 6: %s",PlayerRedialNumbers->PhoneNumber6);
	Send_Message_Player(obj,127,255,0,Temp);
	sprintf(Temp,"Phone Number 7: %s",PlayerRedialNumbers->PhoneNumber7);
	Send_Message_Player(obj,127,255,0,Temp);
	sprintf(Temp,"Phone Number 8: %s",PlayerRedialNumbers->PhoneNumber8);
	Send_Message_Player(obj,127,255,0,Temp);
	sprintf(Temp,"Phone Number 9: %s",PlayerRedialNumbers->PhoneNumber9);
	Send_Message_Player(obj,127,255,0,Temp);
	Send_Message_Player(obj,127,255,0,"------------------------------------------");
	/**///Phone_Trace("Complete - ListPhoneNumbers",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::DisplayMyPhoneNumber(GameObject *obj)
{
	/**///Phone_Trace("DisplayMyPhoneNumber",1,0);
	char PlayerName[256];
	const char *str = Get_Player_Name(obj);
	sprintf(PlayerName,"%s",str);
	delete[] str;
	char Temp[237],Temp2[237];
	sprintf(Temp,"%s's phone number: %s",PlayerName,MyPhoneNumber);
	sprintf(Temp2,"Your phone number has been displayed to all players in game.");
	IsSpamming += 6;
	if (IsSpamming > 10)
	{
		sprintf(Temp,"Stop spamming!");
		Send_Message_Player(obj,255,255,255,Temp);
		IsSpamming = 30;
	}
	else if (PersonalPhoneNumber)
	{
		for (int x = 1;x < 128;x++)
		{
			GameObject *Player = Get_GameObj(x);
			if (Player)
			{
				if (Player != obj)
				{
					Send_Message_Player(Player,127,255,0,Temp);
				}
				else
				{
					Send_Message_Player(Player,127,255,0,Temp2);
				}
			}
		}
	}
	/**///Phone_Trace("Complete - DisplayMyPhoneNumber",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PowerButton(GameObject *obj)
{
	/**///Phone_Trace("PowerButton",1,0);
	if (Has_Weapon(obj,"Weapon_Cell_Phone") && Commands->Get_Health(obj))
	{
		if (Powered)
		{
			Powered = 0;
			if (!TurnedOff)
			{
				Send_Message_Player(obj,127,255,0,"(Your phone is now off...)");
			}
			Reset_Phone(obj);
		}
		else
		{
			Powered = 1;
			if (!TurnedOff)
			{
				char Message[237];
				sprintf(Message,"%d missed calls...",MissedCalls);
				Send_Message_Player(obj,127,255,0,"(Your phone is now on...)");
				Send_Message_Player(obj,127,255,0,Message);
			}
			MissedCalls = 0;
			Reset_Phone(obj);
		}
	}
	/**///Phone_Trace("Complete - PowerButton",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::SendPhoneNumberToRecciver(GameObject *obj)
{
	/**///Phone_Trace("SendPhoneNumberToRecciver",1,0);
	if (PhoneEnabled == 1)
	{
		sprintf(BackupNumber,"%s",cnumber);
		ReachedNumber = 0;
		CallInProgress = 1;
		PlayerNumberControl(obj);
		Commands->Send_Custom_Event(obj,Commands->Find_Object(PhoneBookID),PHONEHousingKeyTransferCustom,HousingKeyTransfer,0.1f);
	}
	else
	{
		if (Number > 0)
		{
			Reset_Phone(obj);
			Send_Message_Player(obj,127,255,0,"No signal...");
		}
	}
	/**///Phone_Trace("Complete - SendPhoneNumberToRecciver",-1,0);
}

char *JMG_RP2_Player_Phone_Control_Script::FormatPhoneNumber(char PhoneNumber[])
{
	/**///Phone_Trace("FormatPhoneNumber",1,0);
	static char PhoneNumberTemp[200];
	int Difference = strlen(PhoneNumber) - 10;
	int TempX = 0;
	if (Difference < 0)
	{
		sprintf(PhoneNumberTemp,"%s",PhoneNumber);
	}
	else if (Difference > 0)
	{
		for (int x = 0;x < 100;x++)
		{
			if (x < Difference)
			{
				PhoneNumberTemp[x] = PhoneNumber[TempX];
				TempX++;
			}
			else
			{
				if (x - Difference == 0)
				{
					PhoneNumberTemp[x] = '(';
				}
				else if (x - (Difference+4) == 0)
				{
					PhoneNumberTemp[x] = ')';
				}
				else if (x - (Difference+8) == 0)
				{
					PhoneNumberTemp[x] = '-';
				}
				else
				{
					PhoneNumberTemp[x] = PhoneNumber[TempX];
					TempX++;
				}
			}
		}
	}
	else
	{
		sprintf(PhoneNumberTemp,"(%c%c%c)%c%c%c-%c%c%c%c",PhoneNumber[0],PhoneNumber[1],PhoneNumber[2],PhoneNumber[3],PhoneNumber[4],PhoneNumber[5],PhoneNumber[6],PhoneNumber[7],PhoneNumber[8],PhoneNumber[9]);
	}
	/**///Phone_Trace("Complete - FormatPhoneNumber",-1,0);
	return PhoneNumberTemp;
}

void JMG_RP2_Player_Phone_Control_Script::DefinePhoneNumberNode(GameObject *obj)
{
	/**///Phone_Trace("DefinePhoneNumberNode",1,0);
	ShortTermUsage = NULL;
	int SenderPlayerID = Get_Player_ID(obj);
	if (!PhoneNumbers)
	{
		PhoneNumbers = new PhoneNumberControl;
		PhoneNumbers->PlayerID = SenderPlayerID;
		PhoneNumbers->StarPressed = StarPress;
		PhoneNumbers->PhoneNumberLength = Number;
		sprintf(PhoneNumbers->PhoneNumber,"%s",cnumber);
		ShortTermUsage = PhoneNumbers;
		PhoneNumbers->next = NULL;
	}
	else
	{
		int end = 0;
		PhoneNumberControl *Current = PhoneNumbers;
		while (Current != NULL && end == 0)
		{
			if (SenderPlayerID == Current->PlayerID)// match
			{
				end = 1;
				Current->PhoneNumberLength = Number;
				Current->PlayerID = SenderPlayerID;
				Current->StarPressed = StarPress;
				ShortTermUsage = Current;
				sprintf(Current->PhoneNumber,"%s",cnumber);
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new PhoneNumberControl;
				Current = Current->next; //Switch to new node
				Current->PlayerID = SenderPlayerID;
				Current->PhoneNumberLength = Number;
				Current->StarPressed = StarPress;
				sprintf(Current->PhoneNumber,"%s",cnumber);
				ShortTermUsage = Current;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
	/**///Phone_Trace("Complete - DefinePhoneNumberNode",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PhoneDefineNumberReturn(GameObject *obj,int param)
{
	/**///Phone_Trace("PhoneDefineNumberReturn",1,0);
	if (param == 1)
	{
		char Message[2000];
		sprintf(Message,"Match found! Select a number to store the phone number %s under.",cnumber);
		Send_Message_Player(obj,127,255,0,Message);
	}
	else
	{
		char Message[2000];
		sprintf(Message,"Unable to find number in records! But please proceed to select a number to store the phone number %s under.",cnumber);
		Send_Message_Player(obj,127,255,0,Message);
		sprintf(ShortTermUsage->PhoneNumber,"%s - ???",ShortTermUsage->PhoneNumber);
	}
	WaitingForDescription = 0;
	/**///Phone_Trace("Complete - PhoneDefineNumberReturn",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::ExtractRedialNumber(const char *PNumber,int Number)
{
	/**///Phone_Trace("ExtractRedialNumber",1,0);
	char TempPN[256];
	sprintf(TempPN,"%s",PNumber);
	TempPN[Number] = '\0';
	sprintf(cnumber,"%s",TempPN);
	/**///Phone_Trace("Complete - ExtractRedialNumber",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::SoundIDSetupNode(GameObject *obj)
{
	/**///Phone_Trace("SoundIDSetupNode",1,0);
	if (!PlayerCellPhoneIDNode)
	{
		PlayerCellPhoneIDNode = new PlayerCellPhoneIDControl;
		PlayerCellPhoneIDNode->PlayerID = Get_Player_ID(obj);
		PlayerCellPhoneIDNode->BusySoundID = 0;
		PlayerCellPhoneIDNode->CallWaitingID = 0;
		PlayerCellPhoneIDNode->DialToneID = 0;
		PlayerCellPhoneIDNode->OffHookSoundID = 0;
		PlayerCellPhoneIDNode->PhoneDisconnectID = 0;
		PlayerCellPhoneIDNode->RingSoundID = 0;
		PlayerIDNode = PlayerCellPhoneIDNode;
		PlayerCellPhoneIDNode->next = NULL;
	}
	else
	{
		int end = 0;
		PlayerCellPhoneIDControl *Current = PlayerCellPhoneIDNode;
		while (Current != NULL && end == 0)
		{
			if (Get_Player_ID(obj) == Current->PlayerID)
			{
				end = 1;
				if (Current->DialToneID != 0){Remove_Repeating_Sound_Object(&Current->DialToneID);}
				if (Current->RingSoundID != 0){Remove_Repeating_Sound_Object(&Current->RingSoundID);}
				if (Current->BusySoundID != 0){Remove_Repeating_Sound_Object(&Current->BusySoundID);}	
				if (Current->OffHookSoundID != 0){Remove_Repeating_Sound_Object(&Current->OffHookSoundID);}
				if (Current->PhoneDisconnectID != 0){Remove_Repeating_Sound_Object(&Current->PhoneDisconnectID);}
				if (Current->CallWaitingID != 0){Remove_Repeating_Sound_Object(&Current->CallWaitingID);}
				PlayerIDNode = Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new PlayerCellPhoneIDControl;
				Current = Current->next;
				Current->PlayerID = Get_Player_ID(obj);
				Current->BusySoundID = 0;
				Current->CallWaitingID = 0;
				Current->DialToneID = 0;
				Current->OffHookSoundID = 0;
				Current->PhoneDisconnectID = 0;
				Current->RingSoundID = 0;
				PlayerIDNode = Current;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
	/**///Phone_Trace("Complete - SoundIDSetupNode",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::Phone_Called_Select_State(GameObject *obj,int param)
{
	/**///Phone_Trace("Phone_Called_Select_State",1,0);
	if (!PhoneOut && (Powered || TurnedOff))// Phone not out, so all clear to ring
	{
		if (CallerID == 0)
		{
			if (Get_Player_ID(obj) != param)
			{
				PhoneIdleAndCalled(obj,param);
			}
			else
			{
				Phone_Disconnect(obj);
			}
		}
		else
		{
			Commands->Send_Custom_Event(obj,Get_GameObj(param),PHONELineBusy,1,0);
		}
	}
	else if (!Powered)
	{
		MissedCalls++;
	}
	/**///Phone_Trace("Complete - Phone_Called_Select_State",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::Phone_OffHook(GameObject *obj)
{
	/**///Phone_Trace("Phone_OffHook",1,0);
	if (PlayerIDNode->RingSoundID != 0)
	{
		Remove_Repeating_Sound_Object(&PlayerIDNode->RingSoundID);
	}
	if (!PlayerIDNode->PhoneDisconnectID && !PlayerIDNode->OffHookSoundID && !PlayerIDNode->BusySoundID)
	{
		PlayerIDNode->OffHookSoundID = Repeating_Sound_Object(obj,"Phone_Off_Hook");
	}
	/**///Phone_Trace("Complete - Phone_OffHook",-1,0);
}

void JMG_RP2_Player_Phone_Control_Script::PressNumberSpecial(GameObject *obj,char Number1)
{
	//char TraceNumber[2000];
	//sprintf(TraceNumber,"PressNumberSpecial %d",Number1);
	///**///Phone_Trace(TraceNumber,1,0);
	char sound[32];
	sprintf(sound,"Phone_%c",Number1);
	Commands->Create_Sound(sound,Commands->Get_Bone_Position(obj,"c R Hand"),obj);
	sprintf(sound,"%c",Number1);
	NewSpecialNumberPress = 0;
	Commands->Send_Custom_Event(obj,Commands->Find_Object(PhoneBookID),atoi(sound),SpecialKeys,0);
	if (!HoldSpecial)
	{
		SpecialKeys = 0;
	}
	HoldSpecial = 0;
	//sprintf(TraceNumber,"Complete - PressNumberSpecial %d",Number1);
	///**///Phone_Trace(TraceNumber,-1,0);
}

int JMG_RP2_Player_Phone_Control_Script::PressAnyKey(int message)
{
	if ((message >= 940860500 && message <= 940860509) || message == 940860512 || message == 940860513 || message == 940860514 || message == 940860511)
	{
		return 1;
	}
	if (message == 940860510)
	{
		return 2;
	}
	return 0;
}

void JMG_RP2_Player_Phone_Control_Script::Phone_Trace(const char *Description,int num,int ClearFile)
{
	FILE *TracePC;
	char params2[200];
	sprintf(params2,"PhoneTraceDump\\PhoneTrace%d.txt",MyIDPC);
	if (!ClearFile)
	{
		 TracePC = fopen(params2,"a+");
	}
	else
	{
		 TracePC = fopen(params2,"w");
	}
	if (TracePC)
	{
		if (num > 0)
		{
			TraceDepthPC += num;
		}
		char OutLine[2000];
		sprintf(OutLine,"%d:",TraceDepthPC);
		/*for (int x = 0;x < TraceDepthPC;x++)
		{
			sprintf(OutLine,"%s  ",OutLine);
		}*/
		sprintf(params2,"%s%s\n",OutLine,Description);
		fprintf(TracePC,params2);
		fflush(TracePC);
		if (num < 0)
		{
			TraceDepthPC += num;
		}
		fclose(TracePC);
	}
}

void JMG_RP2_Phone_Number_Message::Created(GameObject *obj)
{
}

void JMG_RP2_Phone_Number_Message::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == PHONECallStartCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0,PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("NumberOfDigits") == Current->PhoneNumberLength)
					{
						int end2 = 0;
						for (int x = 0;x < Current->PhoneNumberLength && end2 == 0;x++)
						{
							if (Current->PhoneNumber[x] != Get_Parameter("PhoneNumber")[x])
							{
								end2 = 1;
							}
						}
						if (end2 == 0)
						{
							/*char messag[2000];
							sprintf(messag,"MESSAGE Player ID: %d NumberOfNumbers: %d Number: %s",Current->PlayerID,Current->PhoneNumberLength,Current->PhoneNumber);
							Console_Input(messag);*/
							Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Message"),PlayerID,0);
							Commands->Send_Custom_Event(obj,sender,PHONEStopRingingNumberReached,0,0);
						}
					}
					else
					{
						end = 1;
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && Get_Int_Parameter("ShowDescriptionInHelp") && param == 1)
	{
		Send_Message_Player(obj,127,255,0,Get_Parameter("Description"));
	}
}

void JMG_Attach_Script_To_Poker::Poked(GameObject *obj,GameObject *poker)
{
	const char *script = Get_Parameter("Script");
	const char *paramx = Get_Parameter("Params");
	char *params = newstr(paramx);
	char delim = Get_Parameter("Delim")[0];
	unsigned int x = strlen(params);
	for (unsigned int i=0;i<x;i++)
	{
		if (params[i] == delim)
		{
			params[i] = ',';
		}
	}
	Attach_Script_Once(poker,script,params);
	delete[] params;
}

void JMG_Phone_Create_Cinematic_At_Custom_Sender_Position::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		Vector3 Pos = Commands->Get_Position(Get_GameObj(param));
		Pos.Z += 2.0f;
		GameObject *PCinematic = Commands->Create_Object("Daves Arrow",Pos);
		Commands->Set_Model(PCinematic,"Null");
		Commands->Attach_Script(PCinematic,"Test_Cinematic",Get_Parameter("CinematicFile"));
	}
}

void JMG_RP2_Phone_Enable_Zone::Entered(GameObject *obj,GameObject *enter)
{
	Commands->Send_Custom_Event(obj,enter,PHONEAquiredSignal,1,0);
}

void JMG_RP2_Phone_Disable_Zone::Entered(GameObject *obj,GameObject *enter)
{
	Commands->Send_Custom_Event(obj,enter,PHONELostSignal,1,0);
}

void JMG_RP2_Phone_Disabled_While_In_Zone::Entered(GameObject *obj,GameObject *enter)
{
	Commands->Send_Custom_Event(obj,enter,PHONELostSignal,1,0);
}

void JMG_RP2_Phone_Disabled_While_In_Zone::Exited(GameObject *obj,GameObject *exiter)
{
	Commands->Send_Custom_Event(obj,exiter,PHONEAquiredSignal,1,0);
}

void JMG_RP2_Phone_Advanced_Phone_Number_Control_System::Created(GameObject *obj)
{
	MyTextNode = MyNode(Get_Int_Parameter("Script_ID"));
	sprintf(PhoneNumber,"%s - %s",FormatPhoneNumber(Get_Parameter("Phone_Number")),Get_Parameter("Description"));
}

void JMG_RP2_Phone_Advanced_Phone_Number_Control_System::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							if (_stricmp(Get_Parameter("Description"),"null"))
							{
								sprintf(Current->PhoneNumber,"%s - %s",Current->PhoneNumber,Get_Parameter("Description"));
							}
							else
							{
								sprintf(Current->PhoneNumber,"%s - ???",Current->PhoneNumber);
							}
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONECallStartCustom && param == 0 && PhoneNumbers)
	{
		int end = 0;
		int PlayerID = Get_Player_ID(sender);
		PhoneNumberControl *Current = PhoneNumbers;
		while (Current != NULL && end == 0)
		{
			if (PlayerID == Current->PlayerID)// match
			{
				if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
				{
					if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
					{
						end = 1;
						if (Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")) < Get_Int_Parameter("Max_Callers"))
						{
							GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
							GLOBALPHONETIMES[PlayerID] = 0;
							Commands->Send_Custom_Event(sender,obj,Get_Int_Parameter("Script_ID"),PlayerID,(Get_Float_Parameter("Pickup_Delay")+Commands->Get_Random(0.0f,Get_Float_Parameter("Max_Random_Pickup_Delay"))));
						}
						else
						{
							for (int x = 1;x < 128;x++)
							{
								if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
								{
									GameObject *Player = Get_GameObj(x);
									Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
								}
							}
							Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
						}
					}
				}
			}
			Current = Current->next;
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && param == Get_Int_Parameter("Show_In_Menu"))
	{
		Send_Message_Player(sender,127,255,0,PhoneNumber);
	}
	if (message == Get_Int_Parameter("Script_ID"))// First Step
	{
		if (GLOBALPHONELINES[Get_Player_ID(sender)] != Get_Int_Parameter("Script_ID"))
		{
			return;
		}
		if (_stricmp(MyTextNode->Greeting,"null"))
		{
			Send_Message_Player(sender,127,255,0,MyTextNode->Greeting);
		}
		if ((Get_Int_Parameter("Cost") > 0 && Get_Int_Parameter("Require_Confirmation") != -1) || Get_Int_Parameter("Require_Confirmation") > 0)
		{
			if (_stricmp(MyTextNode->Confirmation,"null"))
			{
				Send_Message_Player(sender,127,255,0,MyTextNode->Confirmation);
			}
			Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
			Commands->Send_Custom_Event(sender,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);// Start Timer
		}
		else
		{
			int cost = Get_Int_Parameter("Cost");
			if (cost < 0)
			{
				if (_stricmp(MyTextNode->Buy,"null"))
				{
					Send_Message_Player(sender,127,255,0,MyTextNode->Buy);
				}
				Commands->Give_Money(sender,(float)cost,1);
			}
			else if (cost >= 0 && Commands->Get_Money(sender) >= cost)
			{
				if (_stricmp(MyTextNode->Buy,"null"))
				{
					Send_Message_Player(sender,127,255,0,MyTextNode->Buy);
				}
				Commands->Give_Money(sender,-(float)cost,1);
			}
			else
			{
				Commands->Send_Custom_Event(obj,sender,PHONEStopRingingNumberReached,0,0);
				Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
				Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
				Send_Message_Player(sender,127,255,0,"Sorry you don't have the money to buy that.");
				return;
			}
			Commands->Send_Custom_Event(obj,sender,PHONEStopRingingNumberReached,0,0);
			Commands->Send_Custom_Event(sender,obj,Get_Int_Parameter("Message"),param,0);// player buys
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
		}
	}
	if (message == PHONENumberEndCallMessage && param == Get_Int_Parameter("Script_ID"))
	{
		int PlayerID = Get_Player_ID(sender);
		if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
		{
			GLOBALPHONELINES[PlayerID] = 0;
			GLOBALPHONETIMES[PlayerID] = 0;
		}
	}
	if (message == PHONESpecial1Key && param == Get_Int_Parameter("Script_ID"))// yes
	{
		int PlayerID = Get_Player_ID(sender);
		int cost = Get_Int_Parameter("Cost");
		if ((Get_Int_Parameter("Cost") > 0 || Get_Int_Parameter("Require_Confirmation")) && Commands->Get_Money(sender) >= cost)
		{
			Commands->Give_Money(sender,-(float)cost,1);
			if (_stricmp(MyTextNode->Buy,"null"))
			{
				Send_Message_Player(sender,127,255,0,MyTextNode->Buy);
			}
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
			Commands->Send_Custom_Event(sender,obj,Get_Int_Parameter("Message"),PlayerID,0);// player buys
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
		}
		else
		{
			if (_stricmp(MyTextNode->Sorry,"null"))
			{
				Send_Message_Player(sender,127,255,0,MyTextNode->Sorry);
			}
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
		}
	}
	if (message == PHONESpecial2Key && param == Get_Int_Parameter("Script_ID"))// no
	{
		if (_stricmp(MyTextNode->Goodbye,"null"))
		{
			Send_Message_Player(sender,127,255,0,MyTextNode->Goodbye);
		}
		Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
		Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
	}
	if (message == PHONENumberCallTimeMonitor && param == Get_Int_Parameter("Script_ID"))
	{
		ChargeForCall(obj);
	}
}

void JMG_RP2_Phone_Advanced_Phone_Number_Control_System::AutoCancelCall(GameObject *obj,GameObject *player)
{
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}

void JMG_RP2_Phone_Advanced_Phone_Number_Control_System::ChargeForCall(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
		{
			GameObject *Player = Get_GameObj(x);
			int CallTime = GLOBALPHONETIMES[x]++;
			if (Commands->Get_Health(Player) > 0)
			{
				int chargepersec = Get_Int_Parameter("Charge_Per_Second");
				if (Get_Int_Parameter("Max_Call_Duration") < CallTime)
				{
					AutoCancelCall(obj,Player);
				}
				else if (CallTime % 60 == 0)
				{
					int totalcharge = (chargepersec + Get_Int_Parameter("Charge_Per_Minute"));
					if (Commands->Get_Money(Player) >= totalcharge)
					{
						Commands->Give_Money(Player,-(float)totalcharge,1);
					}
					else
					{
						Send_Message_Player(Player,127,255,0,"Signal Lost");
						AutoCancelCall(obj,Player);
					}
				}
				else if (Commands->Get_Money(Player) >= chargepersec)
				{
					Commands->Give_Money(Player,-(float)chargepersec,1);
				}
				else
				{
					Send_Message_Player(Player,127,255,0,"Signal Lost");
					AutoCancelCall(obj,Player);
				}
			}
			else
			{
				Commands->Send_Custom_Event(Player,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
			}
			Commands->Send_Custom_Event(Player,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);
		}
	}
}

RP2PhoneTextControl *JMG_RP2_Phone_Advanced_Phone_Number_Control_System::MyNode(int ScriptID)
{
	if (!RP2PhoneTextNode)
	{
		RP2PhoneTextNode = new RP2PhoneTextControl;
		RP2PhoneTextNode->ScriptID = ScriptID;
		sprintf(RP2PhoneTextNode->Buy,"null");
		sprintf(RP2PhoneTextNode->Confirmation,"null");
		sprintf(RP2PhoneTextNode->Goodbye,"null");
		sprintf(RP2PhoneTextNode->Greeting,"null");
		sprintf(RP2PhoneTextNode->Sorry,"null");
		RP2PhoneTextNode->next = NULL;
		return RP2PhoneTextNode;
	}
	else
	{
		int end = 0;
		RP2PhoneTextControl *Current = RP2PhoneTextNode;
		while (Current != NULL && end == 0)
		{
			if (Current->ScriptID == ScriptID)
			{
				end = 1;
				return Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new RP2PhoneTextControl;
				Current = Current->next;
				Current->ScriptID = ScriptID;
				sprintf(Current->Buy,"null");
				sprintf(Current->Confirmation,"null");
				sprintf(Current->Goodbye,"null");
				sprintf(Current->Greeting,"null");
				sprintf(Current->Sorry,"null");
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

char *JMG_RP2_Phone_Advanced_Phone_Number_Control_System::FormatPhoneNumber(const char *PN)
{
	static char PhoneNumberTemp[200];
	int NumberLength = strlen(PN);
	int Difference = NumberLength - 10,Difference2 = NumberLength - 7,Difference3 = NumberLength - 9;
	int TempX = 0;
	if (Difference >= 0 && Difference2)
	{
		for (int x = 0;x < 100;x++)
		{
			if (NumberLength-x < Difference)
			{
				PhoneNumberTemp[x] = PN[TempX];
				TempX++;
			}
			else
			{
				if (x - Difference == 0)
				{
					PhoneNumberTemp[x] = '(';
				}
				else if (x - (Difference+4) == 0)
				{
					PhoneNumberTemp[x] = ')';
				}
				else if (x - (Difference+8) == 0)
				{
					PhoneNumberTemp[x] = '-';
				}
				else
				{
					PhoneNumberTemp[x] = PN[TempX];
					TempX++;
				}
			}
			PhoneNumberTemp[x+1] = '\0';
		}
	}
	else if (!Difference2)
	{
		for (int x = 0;x < 100;x++)
		{
			if (x - (Difference2+3) == 0)
			{
				PhoneNumberTemp[x] = '-';
			}
			else
			{
				PhoneNumberTemp[x] = PN[TempX];
				TempX++;
			}
			PhoneNumberTemp[x+1] = '\0';
		}
	}
	else if (!Difference3)
	{
		for (int x = 0;x < 100;x++)
		{
			if (NumberLength-x < Difference3)
			{
				PhoneNumberTemp[x] = PN[TempX];
				TempX++;
			}
			else
			{
				if (x - Difference3 == 0)
				{
					PhoneNumberTemp[x] = '(';
				}
				else if (x - (Difference3+3) == 0)
				{
					PhoneNumberTemp[x] = ')';
				}
				else if (x - (Difference3+7) == 0)
				{
					PhoneNumberTemp[x] = '-';
				}
				else
				{
					PhoneNumberTemp[x] = PN[TempX];
					TempX++;
				}
			}
			PhoneNumberTemp[x+1] = '\0';
		}
	}
	else
	{
		sprintf(PhoneNumberTemp,"(%c%c%c)%c%c%c-%c%c%c%c\0",PN[0],PN[1],PN[2],PN[3],PN[4],PN[5],PN[6],PN[7],PN[8],PN[9]);
	}
	return PhoneNumberTemp;
}

void JMG_RP2_Phone_Create_Preset_At_Sender_Player::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		Vector3 pos = Commands->Get_Position(Get_GameObj(param));
		pos.Z += Get_Float_Parameter("Add_Z");
		Commands->Create_Object(Get_Parameter("Preset"),pos);
	}
}

void JMG_RP2_Phone_Play_Sound_At_Sender_Player::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		GameObject *Star = Get_GameObj(param);
		Vector3 pos = Commands->Get_Bone_Position(Star,"c R Hand");
		Commands->Create_Sound(Get_Parameter("Sound"),pos,Star);
	}
}

void JMG_RP2_Phone_Hidden_Number_Allow_Display::Created(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		StoredID[x] = 0;
	}
}

void JMG_RP2_Phone_Hidden_Number_Allow_Display::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == PHONERequestKnownPhoneNumberList)
	{
		for (int x = 0,end = 0;x < 128 && end == 0;x++)
		{
			if (StoredID[x] == Get_Player_ID(sender))
			{
				end = 1;
				Send_Message_Player(sender,127,255,0,Get_Parameter("Description"));
			}
		}
	}
	if (message == 40891165 && param == Get_Int_Parameter("AddPlayerMessage"))
	{
		for (int x = 0,end = 0;x < 128 && end == 0;x++)
		{
			if (StoredID[x] == 0)
			{
				end = 1;
				StoredID[x] = Get_Player_ID(sender);
				Send_Message_Player(sender,127,255,0,Get_Parameter("Description"));
			}
			else if (StoredID[x] == Get_Player_ID(sender))
			{
				end = 1;
			}
		}
	}
}	

void JMG_RP2_Phone_Add_Number_To_List_Zone::Created(GameObject *obj)
{
	GameObject *PhoneBook = Find_Nearest_Preset(Commands->Get_Position(obj),RP2PHONEBOOKPRESET);
	PhoneBookID = Commands->Get_ID(PhoneBook);
}

void JMG_RP2_Phone_Add_Number_To_List_Zone::Entered(GameObject *obj,GameObject *enter)
{
	Commands->Send_Custom_Event(obj,Commands->Find_Object(PhoneBookID),40891165,Get_Int_Parameter("Message"),0);
}

void JMG_Custom_Multiplier::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		for (int x = 1;x <= Get_Int_Parameter("Number_Of_Output_Customs");x++)
		{
			int outputmessage = Get_Int_Parameter("Message") + x;
			Commands->Send_Custom_Event(obj,obj,outputmessage,param,0);
		}
	}
}

void JMG_Grant_Weapon_On_Weapon::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	const char *weap = Get_Current_Weapon(damager);
	if (weap)
	{
		if (!_stricmp(Get_Parameter("Damager_Weapon"),weap))
		{
			if (damage == Get_Float_Parameter("Damage_Amount"))
			{
				if (Get_Weapon_Count(obj) < RP2MAXINVENTORYWEAPONLIMIT)
				{
					Commands->Give_PowerUp(obj,Get_Parameter("Powerup_Name"),true);
					Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
				}
				else
				{
					const char *GrantedWeapon = Get_Powerup_Weapon(Get_Parameter("Powerup_Name"));
					RP2_Cannot_Grant_Weapon_Reasons(obj,Get_WLS_Weapon_Settings(GrantedWeapon),1);
				}
			}
		}
	}
}

/* All new swimming stuff created on 9/12/09 Jerad Gray*/
void JMG_New_Swimming_Water_Type::Created(GameObject *obj)
{
	//JeradTrace("JMG_New_Swimming_Water_Type");
	if (!SwimmingWaterZoneTypeNode)
	{
		SwimmingWaterZoneTypeNode = new SwimmingWaterZoneTypeControl;
		SwimmingWaterZoneTypeNode->WaterZoneType = Get_Int_Parameter("Water_Type");
		SwimmingWaterZoneTypeNode->ScreenRed = Get_Float_Parameter("ScreenRed");
		SwimmingWaterZoneTypeNode->ScreenGreen = Get_Float_Parameter("ScreenGreen");
		SwimmingWaterZoneTypeNode->ScreenBlue = Get_Float_Parameter("ScreenBlue");
		SwimmingWaterZoneTypeNode->AddRedAmount = Get_Float_Parameter("AddRedAmount");
		SwimmingWaterZoneTypeNode->AddGreenAmount = Get_Float_Parameter("AddGreenAmount");
		SwimmingWaterZoneTypeNode->AddBlueAmount = Get_Float_Parameter("AddBlueAmount");
		SwimmingWaterZoneTypeNode->WaterMurkyness = Get_Float_Parameter("WaterMaxViewRange");
		SwimmingWaterZoneTypeNode->WaterColorThickness = Get_Float_Parameter("WaterTranslucency");
		SwimmingWaterZoneTypeNode->Depth_Before_Water_Darkens = Get_Float_Parameter("Depth_Before_Water_Darkens");
		SwimmingWaterZoneTypeNode->Small_Splash = Get_Parameter("Small_Splash");
		SwimmingWaterZoneTypeNode->Medium_Splash = Get_Parameter("Medium_Splash");
		SwimmingWaterZoneTypeNode->Large_Splash = Get_Parameter("Large_Splash");
		SwimmingWaterZoneTypeNode->Huge_Splash = Get_Parameter("Huge_Splash");
		SwimmingWaterZoneTypeNode->Underwater_Effect_Controller = Get_Parameter("Underwater_Effect_Controller");
		SwimmingWaterZoneTypeNode->Surface_Water_Effect = Get_Parameter("Surface_Water_Effect");
		SwimmingWaterZoneTypeNode->Underwater_Effect = Get_Parameter("Underwater_Effect");
		SwimmingWaterZoneTypeNode->Water_Surface_Ambient_Sound = Get_Parameter("Water_Surface_Ambient_Sound");
		SwimmingWaterZoneTypeNode->Underwater_Ambient_Sound = Get_Parameter("Underwater_Ambient_Sound");
		SwimmingWaterZoneTypeNode->Scuba_Mask_Emitter = Get_Parameter("Scuba_Mask_Emitter");
		SwimmingWaterZoneTypeNode->VehicleScreenRed = Get_Float_Parameter("VehicleScreenRed");
		SwimmingWaterZoneTypeNode->VehicleScreenGreen = Get_Float_Parameter("VehicleScreenGreen");
		SwimmingWaterZoneTypeNode->VehicleScreenBlue = Get_Float_Parameter("VehicleScreenBlue");
		SwimmingWaterZoneTypeNode->VehicleWaterMurkyness = Get_Float_Parameter("VehicleWaterMaxViewRange");
		SwimmingWaterZoneTypeNode->VehicleWaterColorThickness = Get_Float_Parameter("VehicleWaterTranslucency");
		SwimmingWaterZoneTypeNode->VehicleWaterDamage = Get_Float_Parameter("VehicleWaterDamage");
		SwimmingWaterZoneTypeNode->SwimmingAnimationTypeOverride = Get_Int_Parameter("SwimmingAnimationTypeOverride");
		SwimmingWaterZoneTypeNode->InfantryWaterDamage = Get_Float_Parameter("InfantryWaterDamage");
		SwimmingWaterZoneTypeNode->InfantryWaterDamageDelay = Get_Int_Parameter("InfantryWaterDamageDelay");
		SwimmingWaterZoneTypeNode->next = NULL;
	}
	else
	{
		int end = 0;
		SwimmingWaterZoneTypeControl *Current = SwimmingWaterZoneTypeNode;
		while (Current != NULL && end == 0)
		{
			if (Get_Int_Parameter("Water_Type") == Current->WaterZoneType)// match
			{
				end = 1;
			}
			else if (Current->next == NULL)
			{
				Current->next = new SwimmingWaterZoneTypeControl;
				Current = Current->next;
				Current->WaterZoneType = Get_Int_Parameter("Water_Type");
				Current->ScreenRed = Get_Float_Parameter("ScreenRed");
				Current->ScreenGreen = Get_Float_Parameter("ScreenGreen");
				Current->ScreenBlue = Get_Float_Parameter("ScreenBlue");
				Current->AddRedAmount = Get_Float_Parameter("AddRedAmount");
				Current->AddGreenAmount = Get_Float_Parameter("AddGreenAmount");
				Current->AddBlueAmount = Get_Float_Parameter("AddBlueAmount");
				Current->WaterMurkyness = Get_Float_Parameter("WaterMaxViewRange");
				Current->WaterColorThickness = Get_Float_Parameter("WaterTranslucency");
				Current->Depth_Before_Water_Darkens = Get_Float_Parameter("Depth_Before_Water_Darkens");
				Current->Small_Splash = Get_Parameter("Small_Splash");
				Current->Medium_Splash = Get_Parameter("Medium_Splash");
				Current->Large_Splash = Get_Parameter("Large_Splash");
				Current->Huge_Splash = Get_Parameter("Huge_Splash");
				Current->Underwater_Effect_Controller = Get_Parameter("Underwater_Effect_Controller");
				Current->Surface_Water_Effect = Get_Parameter("Surface_Water_Effect");
				Current->Underwater_Effect = Get_Parameter("Underwater_Effect");
				Current->Water_Surface_Ambient_Sound = Get_Parameter("Water_Surface_Ambient_Sound");
				Current->Underwater_Ambient_Sound = Get_Parameter("Underwater_Ambient_Sound");
				Current->Scuba_Mask_Emitter = Get_Parameter("Scuba_Mask_Emitter");
				Current->VehicleScreenRed = Get_Float_Parameter("VehicleScreenRed");
				Current->VehicleScreenGreen = Get_Float_Parameter("VehicleScreenGreen");
				Current->VehicleScreenBlue = Get_Float_Parameter("VehicleScreenBlue");
				Current->VehicleWaterMurkyness = Get_Float_Parameter("VehicleWaterMaxViewRange");
				Current->VehicleWaterColorThickness = Get_Float_Parameter("VehicleWaterTranslucency");
				Current->VehicleWaterDamage = Get_Float_Parameter("VehicleWaterDamage");
				Current->SwimmingAnimationTypeOverride = Get_Int_Parameter("SwimmingAnimationTypeOverride");
				Current->InfantryWaterDamage = Get_Float_Parameter("InfantryWaterDamage");
				Current->InfantryWaterDamageDelay = Get_Int_Parameter("InfantryWaterDamageDelay");
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
	//JeradTrace("Complete - JMG_New_Swimming_Water_Type");
}

void JMG_New_Swimming_Animation_Type::Created(GameObject *obj)
{
	//JeradTrace("JMG_New_Swimming_Animation_Type");
	if (!SwimmingAnimationTypeNode)
	{
		SwimmingAnimationTypeNode = new SwimmingAnimationTypeControl;
		SwimmingAnimationTypeNode->SwimmingAnimationType = Get_Int_Parameter("Swimming_Animation_Type");
		SwimmingAnimationTypeNode->Skeleton = Get_Parameter("Skeleton");
		SwimmingAnimationTypeNode->Animation_Name = Get_Parameter("Animation_Name");
		SwimmingAnimationTypeNode->Not_Moving = Get_Parameter("Not_Moving");
		SwimmingAnimationTypeNode->Forward = Get_Parameter("Forward");
		SwimmingAnimationTypeNode->Backward = Get_Parameter("Backward");
		SwimmingAnimationTypeNode->Turn_Left = Get_Parameter("Turn_Left");
		SwimmingAnimationTypeNode->Turn_Right = Get_Parameter("Turn_Right");
		SwimmingAnimationTypeNode->Up = Get_Parameter("Up");
		SwimmingAnimationTypeNode->Down = Get_Parameter("Down");
		SwimmingAnimationTypeNode->Tilt_Up = Get_Parameter("Tilt_Up");
		SwimmingAnimationTypeNode->Tilt_Down = Get_Parameter("Tilt_Down");
		SwimmingAnimationTypeNode->Tilt_Up_Backward = Get_Parameter("Tilt_Up_Backward");
		SwimmingAnimationTypeNode->Tilt_Down_Backward = Get_Parameter("Tilt_Down_Backward");
		SwimmingAnimationTypeNode->Swim_Left = Get_Parameter("Swim_Left");
		SwimmingAnimationTypeNode->Swim_Left_Tilt_Up = Get_Parameter("Swim_Left_Tilt_Up");
		SwimmingAnimationTypeNode->Swim_Left_Tilt_Down = Get_Parameter("Swim_Left_Tilt_Down");
		SwimmingAnimationTypeNode->Swim_Right = Get_Parameter("Swim_Right");
		SwimmingAnimationTypeNode->Swim_Right_Tilt_Up = Get_Parameter("Swim_Right_Tilt_Up");
		SwimmingAnimationTypeNode->Swim_Right_Tilt_Down = Get_Parameter("Swim_Right_Tilt_Down");
		SwimmingAnimationTypeNode->Not_Moving_Surface = Get_Parameter("Not_Moving_Surface");
		SwimmingAnimationTypeNode->Forward_Surface = Get_Parameter("Forward_Surface");
		SwimmingAnimationTypeNode->Backward_Surface = Get_Parameter("Backward_Surface");
		SwimmingAnimationTypeNode->Turn_Left_Surface = Get_Parameter("Turn_Left_Surface");
		SwimmingAnimationTypeNode->Turn_Right_Surface = Get_Parameter("Turn_Right_Surface");
		SwimmingAnimationTypeNode->Left_Surface = Get_Parameter("Left_Surface");
		SwimmingAnimationTypeNode->Right_Surface = Get_Parameter("Right_Surface");
		SwimmingAnimationTypeNode->next = NULL;
	}
	else
	{
		int end = 0;
		SwimmingAnimationTypeControl *Current = SwimmingAnimationTypeNode;
		while (Current != NULL && end == 0)
		{
			if (Get_Int_Parameter("Swimming_Animation_Type") == Current->SwimmingAnimationType)// match
			{
				char Warning[2000];
				sprintf(Warning,"MESSAGE Warning: Swimming Animation Type %d already exists, ALL different swimming animations need a unique type!",Get_Int_Parameter("Swimming_Animation_Type"));
				Console_Input(Warning);
				end = 1;
			}
			else if (Current->next == NULL)
			{
				Current->next = new SwimmingAnimationTypeControl;
				Current = Current->next;
				Current->SwimmingAnimationType = Get_Int_Parameter("Swimming_Animation_Type");
				Current->Skeleton = Get_Parameter("Skeleton");
				Current->Animation_Name = Get_Parameter("Animation_Name");
				Current->Not_Moving = Get_Parameter("Not_Moving");
				Current->Forward = Get_Parameter("Forward");
				Current->Backward = Get_Parameter("Backward");
				Current->Turn_Left = Get_Parameter("Turn_Left");
				Current->Turn_Right = Get_Parameter("Turn_Right");
				Current->Up = Get_Parameter("Up");
				Current->Down = Get_Parameter("Down");
				Current->Tilt_Up = Get_Parameter("Tilt_Up");
				Current->Tilt_Down = Get_Parameter("Tilt_Down");
				Current->Tilt_Up_Backward = Get_Parameter("Tilt_Up_Backward");
				Current->Tilt_Down_Backward = Get_Parameter("Tilt_Down_Backward");
				Current->Swim_Left = Get_Parameter("Swim_Left");
				Current->Swim_Left_Tilt_Up = Get_Parameter("Swim_Left_Tilt_Up");
				Current->Swim_Left_Tilt_Down = Get_Parameter("Swim_Left_Tilt_Down");
				Current->Swim_Right = Get_Parameter("Swim_Right");
				Current->Swim_Right_Tilt_Up = Get_Parameter("Swim_Right_Tilt_Up");
				Current->Swim_Right_Tilt_Down = Get_Parameter("Swim_Right_Tilt_Down");
				Current->Not_Moving_Surface = Get_Parameter("Not_Moving_Surface");
				Current->Forward_Surface = Get_Parameter("Forward_Surface");
				Current->Backward_Surface = Get_Parameter("Backward_Surface");
				Current->Turn_Left_Surface = Get_Parameter("Turn_Left_Surface");
				Current->Turn_Right_Surface = Get_Parameter("Turn_Right_Surface");
				Current->Left_Surface = Get_Parameter("Left_Surface");
				Current->Right_Surface = Get_Parameter("Right_Surface");
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
	//JeradTrace("Complete - JMG_New_Swimming_Animation_Type");
}

/*Completed 9/13/09 Some additional Vehicle work started
10/01/09 Fixed a animation glitch and fixed a screen fade + vehicle glitch as well
10/10/09 Added in the visable scuba tank system, as well as the debug data key, and the global swimming array
10/10/09 Fixed a glitch that occured that if you entered two zones that overlapped (IE Your water zone counter jumped to two right away and thus certain parts of the script didn't trigger)
10/10/09 Fixed a glitch with the high jump stopper that made you swim under the surface of the water when you were on the surface
10/10/09 Improved the water submerg system
10/11/09 Added the ability to drown in your vehicle
10/21/09 Added in the option to only damage health when drowning
11/19/09 Completed the new Scuba Tank System
11/22/09 Added in a new system to toggle whether you can swim or not
2/14/10 New code to get the height of the water zone, you will no longer end up swimming above or below zones on laggy servers
2/14/10 Did some work on the high jump stopper, should be more stable now
2/25/10 Improved how swimming handeled dynamic water zones
2/25/10 Improved the anti high jump system to work better with the new dynamic zones which allow you to exit from the side of zones and so forth.
2/25/10 Constructed the Miscount function to make sure that even under high lag it doesn't miss the fact that your in water
2/25/10 Moved the code StartSwimmingUnderwater and StartSwimmingOnSurface from Underwater_Tracking_Control in order not to duplicate it for the miscount function
3/26/10 Swimming zones are now able to apply damage to the character (Was having issues with it insta killing you when using damage zones)
4/19/10 Fixed a crash that occured when you got into an unscripted vehicle (Node wasn't initilized to NULL)
4/19/10 Made MyVehicle reset to null when you exited a vehicle to make sure you can't exploit unscripted vehicles
4/19/10 Updated how the error detection works so you won't get false positives when in unscripted vehicles
4/23/10 Fixed a issue where certain vehicles would kick you back out if you entered them while swimming
5/3/10 Fixed a issue where if you feel into water after dieing it wouldn't turn the screen blue
5/15/10 Fixed the issue that made you return to the location where you entered the vehicle
5/15/10 Added some code that should make sure you aren't stuck in something upon water exit*/
void JMG_New_Swimming_Script::Created(GameObject *obj)// Beings it is finally stable, time for some massive revisions! 9/4/09
{
	MyVehicle = NULL;
	MyIDNS = Commands->Get_ID(obj);
	isswimming = 0;
	InVehicle = 0;// 0 = No Vehicle, 1 = Non water proof vehicle, 2 = Water Proof Vehicle
	allowemptyhands = 0;
	if (Has_Weapon(obj,Get_Parameter("Swimming_Weapon")) == 0)
	{
		Commands->Give_PowerUp(obj,Get_Parameter("Swimming_Weapon_Powerup"),1);
	}
	if (Has_Weapon(obj,Get_Parameter("Swimming_Weapon")) == 0)
	{
		char message[2000];
		sprintf(message,"CRITICAL ERROR: Empty hands powerup did not grant the empty hands weapon, swimming script has been removed from %s!",Commands->Get_Preset_Name(obj));
		Send_Message_Player(obj,255,0,0,message);
		Remove_Script(obj,"JMG_Swimming_Script");
	}
	lastpos = Commands->Get_Position(obj);
	speed = 0.0f;
	scubacurrent = ScubaMax = Get_Int_Parameter("Starting_Scuba_Tank_Air_Ammount");
	if (ScubaMax > 0)
	{
		char text[2000],text2[2000];
		sprintf(text,"I currently have a scuba tank which holds %s of air.",Scuba_Tank_Air_Time(text2));
		Send_Message_Player(obj,0,127,255,text);
	}
	ScubaSoundID = 0;
	ISUNDERWATER[Get_Player_ID(obj)] = underwater = 0;
	allowupgrade = 0;
	for (int x = 0;x < 10;x++)
	{
		uniquetankcheck[x] = 0;
	}
	Vector3 pos;
	char params[20];
	sprintf(params,"%d",MyIDNS);
	GameObject *object = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
	Commands->Set_Model(object,Get_Parameter("Swimming_Height_Adjust_Model"));
	Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
	Commands->Attach_To_Object_Bone(object,obj,"nabone");
	sprintf(HeightAdjustAnimation,"%s.%s",Get_Model(object),Get_Model(object));
	HeightAdjustID = Commands->Get_ID(object);
	drowntime = Get_Int_Parameter("Drown_Time");
	Reset_Screen(obj);
	CDT = 0;
	EnableEEnter = 1;
	CanSwim = Get_Int_Parameter("Can_Swim");
	submergetime = 0.15f;
	UWBSID = 0;
	HeartBeatID = 0;
	TraceDepth = 0;
	HeadID = 0;
	ObjectID = 0;
	WaterType = NULL;
	NoSwimID = 0;
	HJROWP = 0;
	ISNEWSWIMMING[Get_Player_ID(obj)] = 0;
	MyScubaTank = NULL;
	ScubaTankHealth = 0.0f;
	ScubaTankArmor = 0.0f;
	VisibleTankID = 0;
	CanSwimToggleProcess[2] = 0;
	ArrayPosition = 0;
	CantExitVehicle = 0;
	sprintf(myweapon,"null");
	InWaterTime = 0;
	if (CanSwim == 1)
	{
		Create_Head(obj,Commands->Find_Object(HeightAdjustID),"c pelvis",1);
	}
	else
	{
		Create_Head(obj,obj,"c pelvis",0);
	}
	for (int x = 0;x < 100;x++)
	{
		SwimmingToggleOverFlowBuffer[x] = -1;
	}
	Commands->Start_Timer(obj,this,0.2f,5432156);
	Commands->Start_Timer(obj,this,1.0f,5432158);
	Commands->Start_Timer(obj,this,0.1f,5432152);
	/**///Swimming_Trace("Complete - Created",0);
}

void JMG_New_Swimming_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message >= 5432158 && message <= 5432162)
	{
		Scuba_Tank_Upgrade_Tracker(obj,param,message,sender);
	}
	if (message == 345345 || message == 345346)
	{
		Underwater_Tracking_Control(obj,message);
	}
	if (message == 347362)
	{
		ObjectID = 0;
	}
	if (message == 347361)
	{
		Enter_Water_Human(obj,param,sender);
	}
	if (message == 347360)
	{
		Exit_Water_Human(obj,sender);
	}
	if (message == 90000028)
	{
		Enter_Vehicle(obj,param,sender);
	}
	if (message == 90000029)
	{
		Exit_Vehicle(obj);
	}
	if (message == 5432166)
	{
		Scuba_Tank_Killed(obj,Commands->Find_Object(ObjectID));
	}
	if (message == 5432167 && CanSwim == 1)
	{
		Action_Key_Pressed(obj);
	}
	if (message == 5432168)
	{
		Additional_High_Jump_Check(obj,param);
	}
	if (message == 347369 && Get_Int_Parameter("Can_Swim"))// Use a param of 2 to toggle otherwise it is force override
	{
		Swimming_Toggle_Control(obj,param);
	}
	if (message == 347370)
	{
		Enable_Swimming_Toggle();
	}
	if (message == 347371)
	{
		Toggle_Swimming();
	}
	/*if (message == 3423432)
	{
		char mns[234];
		sprintf(mns,"MESSAGE My ID is:%d",MyIDNS);
		Console_Input(mns);
		Swimming_Trace("JMG_Important_Debug_Data",1);
		char Text[20000];
		sprintf(Text,"BasicInfo: CurrentWaterType:%d CanSwim:%d isswimming:%d underwater:%d speed:%.2f EnterZoneHeight:%.2f myweapon:%s allowemptyhands:%d InVehicle:%d EnableEEnter:%d EEnter:%d Skin: %s Shield: %s",CurrentWaterType,CanSwim,isswimming,underwater,speed,EnterZoneHeight,myweapon,allowemptyhands,InVehicle,EnableEEnter,EEnter,Get_Skin(obj),Get_Shield_Type(obj));
		Swimming_Trace(Text,0);
		sprintf(Text,"DrownEffects: submergetime:%.2f ScubaMax:%d scubacurrent:%d  drowntime:%d CDT:%d screenred[0]:%.2f screenred[1]:%.2f screengreen[0]:%.2f screengreen[1]:%.2f screenblue[0]:%.2f screenblue[1]:%.2f addredamount:%.2f addgreenamount:%.2f addblueamount:%.2f watermurkyness[0]:%.2f watermurkyness[1]:%.2f watercolorthickness[0]:%.2f watercolorthickness[1]:%.2f CountDown:%d CountDow3n:%d",submergetime,ScubaMax,scubacurrent,drowntime,CDT,screenred[0],screenred[1],screengreen[0],screengreen[1],screenblue[0],screenblue[1],addredamount,addgreenamount,addblueamount,watermurkyness[0],watermurkyness[1],watercolorthickness[0],watercolorthickness[1],CountDown,CountDow3n);
		Swimming_Trace(Text,0);
		sprintf(Text,"IDList: UWBSID:%d HeartBeatID:%d MyIDNS:%d ObjectID:%d HeadID:%d ScubaSoundID:%d HeightAdjustID:%d NoSwimID:%d",UWBSID,HeartBeatID,MyIDNS,ObjectID,HeadID,ScubaSoundID,HeightAdjustID,NoSwimID);
		Swimming_Trace(Text,0);
		Swimming_Trace("Complete - JMG_Important_Debug_Data",-1);
	}*/
}

void JMG_New_Swimming_Script::Timer_Expired(GameObject *obj,int number)
{
	// Makes sure that it doesn't waist time checking for timers that arn't part of the script
	if (number >= 5432152 && number <= 5432166) 
	{
		if (Commands->Get_Health(obj) > 0)
		{
			if (number == 5432152)
			{
				/**///Swimming_Trace("number == 5432152",1);
				if (!WaterType && isswimming >= 1)
				{// Catch the null water type
					int Temp = isswimming;
					isswimming = 0;
					GameObject *Zone = FindCurrentWaterZone(obj);
					Enter_Water_Human(obj,Return_Swimming_Zone_Node(Commands->Get_ID(Zone))->ZoneType,Zone);
					isswimming = Temp;
					Vector3 Pos;
					Pos.X = 0.0;
					Pos.Y = 0.0;
					Pos.Z = 0.0;
					Commands->Set_Position(obj,Pos);
					Send_Message_Player(obj,255,0,0,"Fatal Error: Swimming code failed to initilize properly, YOU MUST DIE!");
				}
				In_Water(obj);
				Create_Scuba_Tank(obj);
				if (underwater >= 1 && InVehicle < 2)
				{
					Screen_Effects(obj);
				}
				Commands->Start_Timer(obj,this,0.1f,5432152);
				/**///Swimming_Trace("Complete - number == 5432152",-1);
			}
			if (number == 5432154 && isswimming == 0)
			{
				Kill_Fake_Swimmer(obj);
			}
			// Moved to avoid duplicate call
			if (number == 5432155)
			{
				Create_Swimmer(obj);
			}
			if (number == 5432156)
			{
				Create_Scuba_Tank_Refil_Sound(obj);
				Commands->Start_Timer(obj,this,0.2f,5432156);
			}
			if (number == 5432157)
			{
				Double_Check_Swimming(obj);
			}
			if (number == 5432158)
			{
				/**///Swimming_Trace("Scuba & HA Update",1);
				Height_Adjuster_Control(obj);
				if (underwater >= 1)
				{
					Scuba_Tank_In_Water_Control(obj);
				}
				Commands->Start_Timer(obj,this,1.0f,5432158);
				/**///Swimming_Trace("Complete - Scuba & HA Update",-1);
			}
			if (number == 5432162)
			{		
				Key_Press_Swimming_Restart(obj);
			}
			if (number == 5432164)
			{
				Stop_Water_Flyout(obj);
			}
			if (number == 5432165 && EnableEEnter == 0)
			{
				EnableEEnter = 1;
			}
			if (number == 5432166)
			{
				Attempt_Vehicle_Enter(obj);
			}
		}
	}
}

void JMG_New_Swimming_Script::Killed(GameObject *obj,GameObject *damager)
{
	/**///Swimming_Trace("Killed",1);
	if (ObjectID > 0)
	{
		Kill_Fake_Swimmer(obj);
	}
	if (HeadID > 0)
	{
		Commands->Send_Custom_Event(obj,Commands->Find_Object(HeadID),5347362,1,0);
		HeadID = 0;
	}
	if (HeightAdjustID > 0)
	{
		Commands->Destroy_Object(Commands->Find_Object(HeightAdjustID));
		HeightAdjustID = 0;
	}
	if (underwater > 0 && watermurkyness[1] != -125)
	{	
		Commands->Create_Sound(Get_Parameter("Underwater_Death_Sound"),Commands->Get_Bone_Position(obj,"c head"),obj);
	}
	Remove_Repeating_Sound_Object(&UWBSID);
	Remove_Repeating_Sound_Object(&HeartBeatID);
	Remove_Repeating_Sound_Object(&ScubaSoundID);
	/**///Swimming_Trace("Complete - Killed",-1);
}

void JMG_New_Swimming_Script::High_Jump_Stop(GameObject *obj)
{
	/**///Swimming_Trace("High_Jump_Stop",1);
	if (CanSwim == 1)
	{
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z += 0.1f;
		GameObject *object = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
		Commands->Set_Model(object,"null");
		Commands->Attach_To_Object_Bone(obj,object,"origin");
		Commands->Destroy_Object(object);
	}
	Reset_Weapon_On_Water_Exit(obj);
	/**///Swimming_Trace("Complete - High_Jump_Stop",-1);
}

void JMG_New_Swimming_Script::Create_Swimmer(GameObject *obj)
{
	/**///Swimming_Trace("Create_Swimmer",1);
	if (InVehicle == 0 && isswimming > 0)
	{
		char params[25];
		sprintf(params,"%d",MyIDNS);
		Vector3 pos = Commands->Get_Position(obj);
		if (CanSwim == 1)
		{
			allowemptyhands = 1;
			// Fake Object Settings
			if (ObjectID == 0)
			{
				GameObject *object = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
				Commands->Set_Model(object,"null");
				Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
				Commands->Attach_To_Object_Bone(object,Commands->Find_Object(HeightAdjustID),"HeightAdjust");
				Commands->Disable_Physical_Collisions(object);
				ObjectID = Commands->Get_ID(object);
				if (_stricmp(Get_Parameter("Swimming_Model_Override"),"null"))
				{
					Commands->Set_Model(object,Get_Parameter("Swimming_Model_Override"));
				}
				else
				{
					Commands->Set_Model(object,Get_Model(obj));
				}
				Set_Max_Shield_Strength(object,Commands->Get_Max_Shield_Strength(obj));
				Set_Max_Health(object,(Commands->Get_Max_Health(obj)*1000.0f));
				Commands->Set_Shield_Strength(object,Commands->Get_Shield_Strength(obj));
				Commands->Set_Health(object,Commands->Get_Max_Health(obj));
				Set_Skin(object,Get_Skin(obj));
				Commands->Set_Shield_Type(object,Get_Shield_Type(obj));
				Set_Skin(obj,Get_Parameter("Swimming_Skin"));
				Commands->Set_Shield_Type(obj,Get_Parameter("Swimming_Skin"));
				Commands->Set_Player_Type(object,Commands->Get_Player_Type(obj));
				if (WaterType)
				{
					char params2[2000];
					if (WaterType->SwimmingAnimationTypeOverride > 0 && Get_Int_Parameter("AnimationType") > 0)
					{
						sprintf(params2,"%d,%d,%s,%s,%s,%s,%s,%d,%s,%d",Commands->Get_ID(obj),WaterType->SwimmingAnimationTypeOverride,WaterType->Underwater_Effect_Controller,WaterType->Surface_Water_Effect,WaterType->Underwater_Effect,WaterType->Water_Surface_Ambient_Sound,WaterType->Underwater_Ambient_Sound,underwater,Get_Parameter("Swimming_Damage_Warhead"),Get_Int_Parameter("Allow_Splash_Effects"));
					}
					else
					{
						sprintf(params2,"%d,%d,%s,%s,%s,%s,%s,%d,%s,%d",Commands->Get_ID(obj),Get_Int_Parameter("AnimationType"),WaterType->Underwater_Effect_Controller,WaterType->Surface_Water_Effect,WaterType->Underwater_Effect,WaterType->Water_Surface_Ambient_Sound,WaterType->Underwater_Ambient_Sound,underwater,Get_Parameter("Swimming_Damage_Warhead"),Get_Int_Parameter("Allow_Splash_Effects"));	
					}
					Commands->Attach_Script(object,"JMG_New_Swimming_Attach_Script",params2);
				}
				else
				{
					Send_Message_Player(obj,255,0,0,"ERROR: Water type unknown, YOU MUST DIE!");
					Commands->Apply_Damage(obj,100000,"blamokiller",0);
				}
			}
			Create_Scuba_Tank(obj,Commands->Find_Object(ObjectID));
			Create_Head(obj,Commands->Find_Object(HeightAdjustID),"c pelvis",1);
			Commands->Set_Model(obj,"infnc");
		}
		else
		{
			Create_Head(obj,obj,"c pelvis",0);
		}
	}
	/**///Swimming_Trace("Complete - Create_Swimmer",-1);
}

void JMG_New_Swimming_Script::Scuba_Tank_Upgrade_Tracker(GameObject *obj,int param,int message,GameObject *sender)
{
	// Rebuilt 11/16/09
	/**///Swimming_Trace("Scuba_Tank_Upgrade_Tracker",1);
	if (message == 5432158)
	{
		int TextMessage = 0;
		int Refund = 0;
		int acquired = 0;
		int end = 0;
		if (SwimmingScubaGearNode)
		{
			SwimmingScubaGearControl *Current = SwimmingScubaGearNode;
			while (Current != NULL && end == 0)
			{
				if (param == Current->ScubaGearType)
				{
					end = 1;
					int AllowUpgrade = 0;
					for (int x = 0,end2 = 0;x < 10 && end2 == 0;x++)
					{
						if (uniquetankcheck[x] == param){end2 = 1;Refund = Current->PurchaseCost;TextMessage = 3;}//Already added this upgrade
						if (uniquetankcheck[x] == 0){end2 = 1;uniquetankcheck[x] = param;Refund = Current->PurchaseCost;AllowUpgrade = Current->UpgradeMaxAir;}//Allow Upgrade
					}
					if (AllowUpgrade || (!AllowUpgrade && ScubaMax == 0))// Can Get Tank
					{
						acquired = 1;
						MyScubaTank = Current;
						MaskEmitBubbles = Current->EmitsBubbles;
						if (ScubaTankHealth < Current->TankHealth){ScubaTankHealth = Current->TankHealth;}
						if (ScubaTankArmor < Current->TankArmor){ScubaTankArmor = Current->TankArmor;} 
						if (ScubaMax == 0){ScubaMax = Current->HoldAirAmount;TextMessage = 1;} // First Tank
						else{ScubaMax += Current->HoldAirAmount;TextMessage = 2;} // Already have one tank add to its max air
						if (ScubaMax < 0){ScubaMax = 0;} // Can't Have negitive Air
					}
					else if ((ScubaTankHealth < Current->TankHealth || ScubaTankArmor < Current->TankArmor) && MyScubaTank)
					{
						acquired = 1;
						TextMessage = 4;
						if (ScubaTankHealth < MyScubaTank->TankHealth){ScubaTankHealth = MyScubaTank->TankHealth;}
						if (ScubaTankArmor < MyScubaTank->TankArmor){ScubaTankArmor = MyScubaTank->TankArmor;} 
					}
					else if (Refund && !acquired)
					{
						TextMessage = 0;
						Send_Message_Player(obj,0,127,255,"I already have this upgrade for my scuba tank; therefore, I have canceled my purchase.");
						Commands->Give_Money(obj,(float)-Refund,true);
					}
				}
				else if (Current->next == NULL)
				{
					end = 1;
					char ERRORs[2000];
					sprintf(ERRORs,"MESSAGE ERROR: Scuba Tank Type %d not found! (Power Up Sender ID:%d!)",param,Commands->Get_ID(sender));
					Console_Input(ERRORs);
				}
				Current = Current->next;
			}
		}
		else
		{
			Console_Input("MESSAGE ERROR: There are NO scuba tanks defined!");
		}
		if (TextMessage)
		{
			char text[2000],text2[2000];
			switch(TextMessage)
			{
			case 1:
				if (MyScubaTank->PurchaseCost){
					sprintf(text,"I have acquired a scuba tank which can hold up to %s of air.",Scuba_Tank_Air_Time(text2));}
				else{
					sprintf(text,"I have found a scuba tank which can hold up to %s of air.",Scuba_Tank_Air_Time(text2));}
				break;
			case 2:
				if (MyScubaTank->PurchaseCost){
					sprintf(text,"I have bought an upgrade for my scuba tank, it can now hold %s of air.",Scuba_Tank_Air_Time(text2));}
				else{
					sprintf(text,"I have found an upgrade from my scuba tank and it can now hold %s worth of air.",Scuba_Tank_Air_Time(text2));}
				break;
			case 3:
				sprintf(text,"I already have that upgrade for my scuba gear, thus it does me no good to hang on to it.");
				break;
			case 4:
				if (MyScubaTank->PurchaseCost){
					sprintf(text,"Using parts from the scuba tank I bought I have repaired my old tank.");}
				else{
					sprintf(text,"Using parts from the scuba tank I found I have repaired my old tank.");}
				break;
			}
			Send_Message_Player(obj,0,127,255,text);
		}
	}
	/**///Swimming_Trace("Complete - Scuba_Tank_Upgrade_Tracker",-1);
}

void JMG_New_Swimming_Script::Exit_Water_Human(GameObject *obj,GameObject *sender)
{
	/**///Swimming_Trace("Exit_Water_Human",1);
	isswimming--;
	if (isswimming > 0)
	{
		RefindSwimmingZone(obj);
	}
	if (isswimming <= 0)
	{
		WaterZoneHeight(sender);
		if (InVehicle < 2)
		{
			CDT = 0;
			ISUNDERWATER[Get_Player_ID(obj)] = underwater = 0;
			isswimming = 0;
		}
		if (InVehicle == 0)
		{
			Kill_Fake_Swimmer(obj);
			Remove_Scuba_Tank();
			if (submergetime >= 0.0)
			{
				submergetime = 0.15f;
			}
			if (Get_Fly_Mode(obj) == 1)
			{
				Toggle_Fly_Mode(obj);
			}
			High_Jump_Stop(obj);
			Additional_High_Jump_Check(obj,5);
		}
		ISNEWSWIMMING[Get_Player_ID(obj)] = 0;
		Reset_Screen(obj);
	}
	/**///Swimming_Trace("Complete - Exit_Water_Human",-1);
}

void JMG_New_Swimming_Script::Enter_Vehicle(GameObject *obj,int param,GameObject *sender)
{
	/**///Swimming_Trace("Enter_Vehicle",1);
	int end = 0,VehicleID = Commands->Get_ID(sender);
	MyVehicle = NULL;
	if (RP2VehicleNode)
	{
		RP2VehicleControl *Current = RP2VehicleNode;
		while (Current && !end)
		{
			if (VehicleID == Current->VehicleID)// match
			{
				end = 1;
				MyVehicle = Current;
			}
			Current = Current->next;
		}
	}
	if (!MyVehicle)
	{
		char Message[238];
		sprintf(Message,"MESSAGE WARNING: Preset %s does not have a VehicleNode!",Commands->Get_Preset_Name(sender));
		Console_Input(Message);
	}
	if (param == -1)
	{
		InVehicle = 2;
		CDT = 0;
		Reload_Screen_Effects();
		Reset_Screen(obj);
	}
	else
	{
		InVehicle = 1;
		if (Vehicle_Air_Supply(obj))
		{
			CDT = 0;
			Reload_Screen_Effects();
		}
	}
	if (isswimming > 0)
	{
		if (Get_Fly_Mode(obj) == 1)
		{
			Toggle_Fly_Mode(obj);
		}
	}
	else
	{
		const char *tmyweapon = Get_Current_Weapon(obj);
		if (tmyweapon && !Get_Vehicle(obj))
		{
			sprintf(myweapon,"%s",tmyweapon);
		}
	}
	if (NoSwimID != 0 && CanSwim == 0)
	{
		Commands->Destroy_Object(Commands->Find_Object(NoSwimID));
		NoSwimID = 0;
	}
	Remove_Repeating_Sound_Object(&HeartBeatID);
	/**///Swimming_Trace("Complete - Enter_Vehicle",-1);
}

void JMG_New_Swimming_Script::Exit_Vehicle(GameObject *obj)
{
	/**///Swimming_Trace("Exit_Vehicle",1);
	InVehicle = 0;
	MyVehicle = NULL;
	if (isswimming > 0)
	{
		EnableActionKeyEnter(obj);
		Create_Swimmer(obj);
		if (InVehicle == 2)
		{
			Commands->Send_Custom_Event(obj,obj,345345,1,0);
			Commands->Send_Custom_Event(obj,obj,345346,1,0);
		}
		Commands->Start_Timer(obj,this,0.15f,5432157);
	}
	if (CanSwim == 0 && NoSwimID == 0 && underwater > 0)
	{
		GameObject *NoSwimEffects = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
		Commands->Set_Model(NoSwimEffects,WaterType->Underwater_Effect);
		Commands->Attach_To_Object_Bone(NoSwimEffects,obj,"origin");
		NoSwimID = Commands->Get_ID(NoSwimEffects);
	}
	/**///Swimming_Trace("Complete - Exit_Vehicle",-1);
}

void JMG_New_Swimming_Script::Enter_Water_Human(GameObject *obj,int param,GameObject *sender)
{
	/**///Swimming_Trace("Enter_Water_Human",1);
	isswimming++;
	WaterZoneHeight(sender);
	if (isswimming == 1)
	{
		ISUNDERWATER[Get_Player_ID(obj)] = underwater = 0;
		CurrentWaterType = param;
		CDT = 0;
		if (HJROWP)
		{
			HJROWP = 0;
		}
		const char *tmyweapon = Get_Current_Weapon(obj);
		if (tmyweapon && !Get_Vehicle(obj))
		{
			sprintf(myweapon,"%s",tmyweapon);
		}
		EnableActionKeyEnter(obj);
		ISNEWSWIMMING[Get_Player_ID(obj)] = 1;
		// Water Definition Node Stuff
		if (CanSwimToggleProcess[2] == 0)
		{
			SwimmingWaterZoneTypeControl *Current = SwimmingWaterZoneTypeNode;
			int end = 0;
			if (Current)
			{
				while (Current != NULL && end == 0)
				{
					if (param == Current->WaterZoneType)// match
					{
						end = 1;
						WaterType = Current;
						screenred[1] = screenred[0] = Current->ScreenRed;
						screengreen[1] = screengreen[0] = Current->ScreenGreen;
						screenblue[1] = screenblue[0] = Current->ScreenBlue;
						addredamount = Current->AddRedAmount;
						addgreenamount = Current->AddGreenAmount;
						addblueamount = Current->AddBlueAmount;
						watermurkyness[1] = watermurkyness[0] = Current->WaterMurkyness;
						watercolorthickness[1] = watercolorthickness[0] = Current->WaterColorThickness;
					}
					Current = Current->next;
				}
			}
			if (!end)
			{
				screenred[1] = screenred[0] = 0.00f;
				screengreen[1] = screengreen[0] = 0.00f;
				screenblue[1] = screenblue[0] = 0.00f;
				addredamount = 0.00f;
				addgreenamount = 0.00f;
				addblueamount = 0.00f;
				watermurkyness[1] = watermurkyness[0] = 0.00f;
				watercolorthickness[1] = watercolorthickness[0] = 0.00f;
				char errormsg[1000];
				sprintf(errormsg,"ERROR: Water Zone Type %d not found!",param);
				Send_Message_Player(obj,255,0,0,errormsg);
			}
		}
		// Back to original Swimming Script Stuff
		if (!InVehicle)
		{
			float speed2 = speed;
			if (WaterType && Get_Int_Parameter("Allow_Splash_Effects"))
			{
				if (speed2 < 1.0f)
				{
					Commands->Create_Explosion(WaterType->Small_Splash,Commands->Get_Position(obj),0);
				}
				else if (speed2 < 6.0f)
				{
					Commands->Create_Explosion(WaterType->Medium_Splash,Commands->Get_Position(obj),0);
				}
				else if (speed2 < 10.0f)
				{
					Commands->Create_Explosion(WaterType->Large_Splash,Commands->Get_Position(obj),0);
				}
				else
				{
					Commands->Create_Explosion(WaterType->Huge_Splash,Commands->Get_Position(obj),0);
				}
			}
			EnableActionKeyEnter(obj);
			Create_Swimmer(obj);
			Commands->Start_Timer(obj,this,submergetime,5432157);// Double Check Swimming
		}
		else if (InVehicle) // used to be == 1 but I think it should have been for both vehicle types unless I have it handled special someowhere else, in which case woops XD
		{
			EnableActionKeyEnter(obj);
		}
	}
	if (InWaterTime < 0)
	{
		InWaterTime = 0;
	}
	if (!Commands->Get_Health(obj))
	{
		Reload_Screen_Effects();
		Set_Fog_Enable_Player(obj,1);
		Set_Fog_Range_Player(obj,((watermurkyness[1]*0.75f)),(watermurkyness[1]),0.1f);
		Set_Screen_Fade_Color_Player(obj,screenred[0],screengreen[0],screenblue[0],0.1f);
		Set_Screen_Fade_Opacity_Player(obj,watercolorthickness[0],0.1f);
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].X = screenred[0];
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Y = screengreen[0];
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Z = screenblue[0];
	}
	/**///Swimming_Trace("Complete - Enter_Water_Human",-1);
}

void JMG_New_Swimming_Script::Reset_Screen(GameObject *obj)
{
	/**///Swimming_Trace("Reset_Screen",1);
	if (CanSwimToggleProcess[2] == 0)// Disable for cirtain situations
	{
		RP2_Set_Fog_And_Screen_Color_To_Level_Default(obj);
	}
	/**///Swimming_Trace("Complete - Reset_Screen",-1);
}

void JMG_New_Swimming_Script::In_Water(GameObject *obj)
{
	/**///Swimming_Trace("In_Water",1);
	Vector3 pos = Commands->Get_Position(obj);
	speed = abs(pos.Z - lastpos.Z);
	lastpos = pos;
	if (submergetime < 0.15 && underwater <= 0)
	{
		submergetime += 0.01f;
	}
	else if (submergetime > -0.15f)
	{
		submergetime -= 0.01f;
	}
	if (isswimming >= 1)
	{
		Swimming_Switch_Weapons(obj);
		if (!Get_Vehicle(obj))
		{
			if (speed < 1.25f)
			{
				LastWaterZone = pos;
			}
			if (underwater <= 0)
			{
				InWaterTime++;
				TakeWaterDamage(obj);
			}
		}
		else//Fixed the issue that made you return to the location where you entered the vehicle
		{
			LastWaterZone = pos;
		}
	}
	else
	{
		if (InWaterTime > 0)
		{
			InWaterTime--;
		}
	}
	if (Get_Vehicle(obj))
	{
		if (ObjectID != 0)
		{
			Kill_Fake_Swimmer(obj);
		}
		if (VisibleTankID != 0)
		{
			Remove_Scuba_Tank();
		}
	}
	/**///Swimming_Trace("Complete - In_Water",-1);
}

void JMG_New_Swimming_Script::Double_Check_Swimming(GameObject *obj)
{
	/**///Swimming_Trace("Double_Check_Swimming",1);
	if (Get_Fly_Mode(obj) == 0 && isswimming > 0 && InVehicle == 0)
	{
		if (CanSwim == 1)
		{
			Commands->Set_Animation(obj,"s_a_human.infncanim",true,0,0,-1,false);
			Toggle_Fly_Mode(obj);
		}
		Commands->Start_Timer(obj,this,0.1f,5432155);
	}
	/**///Swimming_Trace("Complete - Double_Check_Swimming",-1);
}

void JMG_New_Swimming_Script::Underwater_Tracking_Control(GameObject *obj,int message)
{
	/**///Swimming_Trace("Underwater_Tracking_Control",1);
	if (message == 345345)// Head out of water
	{
		underwater--;
		ISUNDERWATER[Get_Player_ID(obj)] = underwater;
		if (underwater <= 0)
		{
			StartSwimmingOnSurface(obj);
		}
		Commands->Send_Custom_Event(obj,Commands->Find_Object(ObjectID),345346,1,0);// Tell Swimming object its not underwater
	}
	if (message == 345346)// Head In Water
	{
		underwater++;
		ISUNDERWATER[Get_Player_ID(obj)] = underwater;
		if (underwater == 1)
		{
			StartSwimmingUnderwater(obj);
		}
		Commands->Send_Custom_Event(obj,Commands->Find_Object(ObjectID),345345,1,0);// Tell Swimming object its underwater
	}
	/**///Swimming_Trace("Complete - Underwater_Tracking_Control",-1);
}

void JMG_New_Swimming_Script::Key_Press_Swimming_Restart(GameObject* obj)
{
	/**///Swimming_Trace("Key_Press_Swimming_Restart",1);
	if (isswimming > 0 && Get_Fly_Mode(obj) == 0 && InVehicle == 0)
	{
		if (Get_Fly_Mode(obj) == 0)
		{
			Toggle_Fly_Mode(obj);
		}
		EnableEEnter = 1;
	}
	/**///Swimming_Trace("Complete - Key_Press_Swimming_Restart",-1);
}

void JMG_New_Swimming_Script::Height_Adjuster_Control(GameObject *obj)
{
	/**///Swimming_Trace("Height_Adjuster_Control",1);
	GameObject *Heightadjuster = Commands->Find_Object(HeightAdjustID);
	if (isswimming >= 1)
	{
		if (underwater == 0)
		{
			float distancefromsurface = ((EnterZoneHeight - Commands->Get_Position(obj).Z)*100.0f) + 50.0f;
			if (distancefromsurface > 500 || distancefromsurface < 0)
			{
				RefindSwimmingZone(obj);
			}
			Commands->Set_Animation(Heightadjuster,HeightAdjustAnimation,true,0,Get_Animation_Frame(Heightadjuster),distancefromsurface,0);
		}
		else if (Get_Animation_Frame(Heightadjuster) != 100)
		{
			Commands->Set_Animation(Heightadjuster,HeightAdjustAnimation,true,0,Get_Animation_Frame(Heightadjuster),100,0);
		}
		else // added this in to make you not bounce around as randomly happend wit hthat glitch
		{
			Commands->Set_Animation(Heightadjuster,HeightAdjustAnimation,true,0,Get_Animation_Frame(Heightadjuster),99,0);
		}
	}
	/**///Swimming_Trace("Complete - Height_Adjuster_Control",-1);
}

void JMG_New_Swimming_Script::Create_Scuba_Tank_Refil_Sound(GameObject *obj)
{
	/**///Swimming_Trace("Create_Scuba_Tank_Refil_Sound",1);
	if (scubacurrent < ScubaMax && underwater == 0)
	{
		scubacurrent++;
		if (scubacurrent < ScubaMax && ScubaSoundID == 0)
		{
			Vector3 pos;
			char params[20];
			sprintf(params,"%d",MyIDNS);
			GameObject *tankrefill = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
			Commands->Set_Model(tankrefill,"null");
			Commands->Set_Model(tankrefill,Get_Parameter("Scuba_Refill_Sound"));
			Commands->Attach_To_Object_Bone(tankrefill,obj,"c head");	
			ScubaSoundID = Commands->Get_ID(tankrefill);
			Commands->Attach_Script(tankrefill,"JMG_Remove_Object_When_Creator_Destroyed",params);
		}
	}
	if (scubacurrent >= ScubaMax || underwater >= 1)
	{
		Remove_Repeating_Sound_Object(&ScubaSoundID);
	}
	/**///Swimming_Trace("Complete - Create_Scuba_Tank_Refil_Sound",-1);
}

void JMG_New_Swimming_Script::Remove_Repeating_Sound_Object(int *ID)
{
	/**///Swimming_Trace("Remove_Repeating_Sound_Object",1);
	if (ID != 0)
	{
		GameObject *object = Commands->Find_Object(*ID);
		if (object)
		{
			Commands->Destroy_Object(object);
		}
		*ID = 0;
	}
	/**///Swimming_Trace("Complete - Remove_Repeating_Sound_Object",-1);
}

void JMG_New_Swimming_Script::Scuba_Tank_In_Water_Control(GameObject *obj)
{
	/**///Swimming_Trace("Scuba_Tank_In_Water_Control",1);
	if (scubacurrent > 0 && ScubaMax > 0 && !Vehicle_Air_Supply(obj))
	{
		if (InVehicle < 2)// Only Run in nonwater proof vehicles
		{
			scubacurrent--;
			int CountDow2n = 1+((int)(((float)scubacurrent / (float)ScubaMax)*10.0f));
			int CountDow4n = 1+((int)(((float)scubacurrent / (ScubaMax*0.1f))*10.0));
			if (CountDown > 0 && CountDow4n > 9)
			{
				if (CountDown != CountDow2n && CountDow2n > 0)
				{
					CountDown = CountDow2n;
					CountDow3n = CountDow4n;
					char mes[1000];
					sprintf(mes,"My scuba tank has %d0%c of its air left.",CountDown,'%');
					Send_Message_Player(obj,0,127,255,mes);
				}
			}
			else if (CountDow3n != CountDow4n && CountDow4n <= 5 && CountDow4n > 0)
			{
				CountDow3n = CountDow4n;
				char mes[1000];
				sprintf(mes,"My scuba tank has %d%c of its air left.",CountDow3n,'%');
				Send_Message_Player(obj,0,127,255,mes);
			}
		}
	}
	/**///Swimming_Trace("Complete - Scuba_Tank_In_Water_Control",-1);
}

void JMG_New_Swimming_Script::Screen_Effects(GameObject *obj)
{
	/**///Swimming_Trace("Screen_Effects",1);
	if (Vehicle_Air_Supply(obj))
	{
		Set_Fog_Enable_Player(obj,1);
		Set_Fog_Range_Player(obj,((watermurkyness[1]*0.75f)),(watermurkyness[1]),0.1f);
		Set_Screen_Fade_Color_Player(obj,screenred[0],screengreen[0],screenblue[0],0.1f);
		Set_Screen_Fade_Opacity_Player(obj,watercolorthickness[0],0.1f);
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].X = screenred[0];
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Y = screengreen[0];
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Z = screenblue[0];
	}
	else if (Get_Int_Parameter("Drown_Time") == -1)
	{
		InWaterTime++;
		TakeWaterDamage(obj);
		Set_Fog_Enable_Player(obj,1);
		Set_Fog_Range_Player(obj,((watermurkyness[1]*0.75f)),(watermurkyness[1]),0.1f);
		Set_Screen_Fade_Color_Player(obj,screenred[0],screengreen[0],screenblue[0],0.1f);
		Set_Screen_Fade_Opacity_Player(obj,watercolorthickness[0],0.1f);
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].X = screenred[0];
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Y = screengreen[0];
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Z = screenblue[0];
	}
	else if (scubacurrent == 0 && Get_Int_Parameter("Drown_Time") >= 0)
	{
		InWaterTime++;
		TakeWaterDamage(obj);
		if (CDT == 0 && ScubaMax > 0)
		{
			Send_Message_Player(obj,0,127,255,"My scuba tank is empty.");
		}
		CDT += 1;
		if (CDT >= (Get_Int_Parameter("Drown_Time")) * 10)
		{
			screenred[0] += addredamount;
			screengreen[0] += addgreenamount;
			screenblue[0] += addblueamount;
			Set_Screen_Fade_Color_Player(obj,screenred[0],screengreen[0],screenblue[0],0.1f);
			Set_Screen_Fade_Opacity_Player(obj,watercolorthickness[0],0.1f);
			SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].X = screenred[0];
			SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Y = screengreen[0];
			SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Z = screenblue[0];
			if (HeartBeatID == 0)
			{
				GameObject *swimmer = Commands->Find_Object(ObjectID);
				Vector3 pos;
				char params[20];
				sprintf(params,"%d",MyIDNS);
				GameObject *heart = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),pos);
				Commands->Set_Model(heart,"null");
				Commands->Attach_To_Object_Bone(heart,swimmer,"c head");	
				HeartBeatID = Commands->Get_ID(heart);
				Commands->Set_Model(heart,Get_Parameter("Heart_Beat_Loop_Sound"));
				Commands->Attach_Script(heart,"JMG_Remove_Object_When_Creator_Destroyed",params);
			}
		}
		else
		{
			Set_Fog_Enable_Player(obj,1);
			Set_Fog_Range_Player(obj,((watermurkyness[1]*0.75f)),(watermurkyness[1]),0.1f);
			Set_Screen_Fade_Color_Player(obj,screenred[0],screengreen[0],screenblue[0],0.1f);
			Set_Screen_Fade_Opacity_Player(obj,watercolorthickness[0],0.1f);
			SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].X = screenred[0];
			SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Y = screengreen[0];
			SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Z = screenblue[0];
		}
		// Newly created Fog Opacity System
		watermurkyness[0] = 0.0f;
		if (addredamount < 0.0)
		{
			if (screenred[0] > watermurkyness[0])
			{
				watermurkyness[0] = screenred[0];
			}
		}
		else if (addredamount > 0.0)
		{
			if (1.0f - screenred[0] > watermurkyness[0])
			{
				watermurkyness[0] = 1.0f - screenred[0];
			}
		}
		if (addgreenamount < 0.0)
		{
			if (screengreen[0] > watermurkyness[0])
			{
				watermurkyness[0] = screengreen[0];
			}
		}
		else if (addgreenamount > 0.0)
		{
			if (1.0f - screengreen[0] > watermurkyness[0])
			{
				watermurkyness[0] = 1.0f - screengreen[0];
			}
		}
		if (addblueamount < 0.0)
		{
			if (screenblue[0] > watermurkyness[0])
			{
				watermurkyness[0] = screenblue[0];
			}
		}
		else if (addblueamount > 0.0)
		{
			if (1.0f - screenblue[0] > watermurkyness[0])
			{
				watermurkyness[0] = 1.0f - screenblue[0];
			}
		}
		watermurkyness[0] += 0.25f;
		if (watermurkyness[0] >= 0.25 && watermurkyness[0] < 1.0)
		{
			Set_Fog_Range_Player(obj,((watermurkyness[1]*0.75f)*watermurkyness[0]),(watermurkyness[1]*watermurkyness[0]),0.1f);
		}
		if (Get_Int_Parameter("Drown_Damage_Health_And_Shield"))
		{
			DrownDamageSystem(obj);
		}
		else
		{
			DrownDamageSystemHealthOnly(obj);
		}
	}
	else if (scubacurrent > 0)
	{
		InWaterTime++;
		TakeWaterDamage(obj);
		Set_Fog_Enable_Player(obj,1);
		Set_Fog_Range_Player(obj,((watermurkyness[1]*0.75f)),(watermurkyness[1]),0.1f);
		Set_Screen_Fade_Color_Player(obj,screenred[0],screengreen[0],screenblue[0],0.1f);
		Set_Screen_Fade_Opacity_Player(obj,watercolorthickness[0],0.1f);
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].X = screenred[0];
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Y = screengreen[0];
		SWIMMINGSCREENCOLORS[Get_Player_ID(obj)].Z = screenblue[0];
	}
	/**///Swimming_Trace("Complete - Screen_Effects",-1);
}

void JMG_New_Swimming_Script::Action_Key_Pressed(GameObject *obj)
{
	/**///Swimming_Trace("Action_Key_Pressed",1);
	if (isswimming > 0 && Get_Fly_Mode(obj) == 1 && InVehicle == 0 && EnableEEnter == 1 && !Get_Vehicle(obj))
	{
		EEnter = 0;
		EnableEEnter = 1;
		if (Get_Fly_Mode(obj) == 1)
		{
			Toggle_Fly_Mode(obj);
		}
		Commands->Start_Timer(obj,this,0.1f,5432166);
	}
	/**///Swimming_Trace("Complete - Action_Key_Pressed",-1);
}

void JMG_New_Swimming_Script::Attempt_Vehicle_Enter(GameObject *obj)
{
	/**///Swimming_Trace("Attempt_Vehicle_Enter",1);
	if (isswimming > 0 && !Get_Vehicle(obj))
	{
		Soldier_Transition_Vehicle(obj);
		EEnter++;
		if (EEnter < 2)
		{
			Commands->Start_Timer(obj,this,0.1f,5432166);
		}
		else
		{
			Commands->Start_Timer(obj,this,0.1f,5432162);
		}
	}
	/**///Swimming_Trace("Complete - Attempt_Vehicle_Enter",-1);
}

void JMG_New_Swimming_Script::Kill_Fake_Swimmer(GameObject *obj)
{
	/**///Swimming_Trace("Kill_Fake_Swimmer",1);
	if (CanSwim == 1)
	{
		GameObject *object = Commands->Find_Object(ObjectID);
		if (Commands->Get_Health(object) > 0.0)
		{
			Commands->Set_Model(obj,Get_Model(object));
			Set_Skin(obj,Get_Skin(object));
			Commands->Set_Shield_Type(obj,Get_Shield_Type(object));
			Commands->Destroy_Object(object);
			ObjectID = 0;
		}
		else if (Commands->Get_Health(obj) > 0.0)//Error Checking
		{
			GameObject *VehicleP = Get_Vehicle(obj);
			if (VehicleP)
			{
				char Message[238];
				sprintf(Message,"WARNING: Vehicle Preset %s may have been the cause of this problem!",Commands->Get_Preset_Name(VehicleP));
				Send_Message_Player(obj,255,0,0,Message);
				Commands->Apply_Damage(VehicleP,9999.9f,"blamokiller",0);
			}
			else
			{
				Commands->Apply_Damage(obj,9999.9f,"blamokiller",0);
				Send_Message_Player(obj,255,0,0,"Fatal Error: Your fake swimming model was not found, your death was necessary to preserve server stability.");
			}
		}
	}
	/**///Swimming_Trace("Complete - Kill_Fake_Swimmer",-1);
}

void JMG_New_Swimming_Script::Create_Head(GameObject *obj,GameObject *attach,const char *attachbone,int HeadPosition)
{
	/**///Swimming_Trace("Create_Head",1);
	GameObject *Head = Commands->Find_Object(HeadID);
	if (!Head)
	{
		char params[25];
		sprintf(params,"%d",MyIDNS);
		GameObject *head = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),Commands->Get_Position(obj));
		Commands->Set_Model(head,"null");
		Commands->Attach_To_Object_Bone(head,attach,attachbone);	
		HeadID = Commands->Get_ID(head);
		Commands->Attach_Script(head,"JMG_Remove_Object_When_Creator_Destroyed",params);
		char paramshead[256];
		sprintf(paramshead,"%d",MyIDNS);
		Commands->Attach_Script(head,"JMG_New_Swimming_Head_Attach_Script",paramshead);
	}
	else if (HeadPos != HeadPosition)
	{
		HeadPos = HeadPosition;
		Commands->Attach_To_Object_Bone(Commands->Find_Object(HeadID),attach,attachbone);	
	}
	CheckForUnderwaterZoneMiscount(obj,Commands->Find_Object(HeadID));
	/**///Swimming_Trace("Complete - Create_Head",-1);
}

void JMG_New_Swimming_Script::Reload_Screen_Effects()
{
	/**///Swimming_Trace("Reload_Screen_Effects",1);
	if (CanSwimToggleProcess[2] == 0)// Disable for cirtain situations
	{
		screenred[0] = screenred[1];
		screengreen[0] = screengreen[1];
		screenblue[0] = screenblue[1];
		watermurkyness[0] = watermurkyness[1];
		watercolorthickness[0] = watercolorthickness[1];
	}
	/**///Swimming_Trace("Complete - Reload_Screen_Effects",-1);
}

void JMG_New_Swimming_Script::Additional_High_Jump_Check(GameObject *obj,int param)
{
	/**///Swimming_Trace("Additional_High_Jump_Check",1);
	if (!Get_Vehicle(obj) && !isswimming && param > 0 && Commands->Get_Position(obj).Z > lastpos.Z)
	{
		if (speed > 1.05f)
		{
			Vector3 temppos = LastWaterZone;
			if (temppos.Z > EnterZoneHeight)
			{
				temppos.Z = EnterZoneHeight += 0.5f;// Code to work with the new zone system, should make water even harder to jump out of(which it did and it did great, but now I want you to be able to exit out the side of water zones so have to take that back off)
			}
			else
			{
				temppos.Z += 1.0f; // Enhanced version so now both styles of anti high jump countermeasures can be used and you can exit the side of water zones!
			}
			GameObject *stop = Commands->Create_Object("Daves Arrow",temppos);
			Commands->Attach_To_Object_Bone(obj,stop,"origin");
			Commands->Set_Model(stop,"null");
			Commands->Destroy_Object(stop);
			lastpos = temppos;
			HJROWP = 1;
			
		}
		param--;
		Reset_Screen(obj);
		Commands->Send_Custom_Event(obj,obj,5432168,param,0.1f);
	}
	else if (!Get_Vehicle(obj) && !isswimming && !param && Commands->Get_Position(obj).Z > lastpos.Z)
	{
		HJROWP = 0;// Added in so you won't glitch and swim under the water as easily
		Vector3 ExitPos,StartPos;//Small bit of code to try to prevent you getting stuck in the ground
		StartPos = ExitPos = Commands->Get_Position(obj);
		PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
		objphys->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Find_Teleport_Location(StartPos,1.0f,&ExitPos);
		Commands->Set_Position(obj,StartPos);
	}
	/**///Swimming_Trace("Complete - Additional_High_Jump_Check",-1);
}

const char *JMG_New_Swimming_Script::Scuba_Tank_Air_Time(char text[])
{
	/**///Swimming_Trace("Scuba_Tank_Air_Time",1);
	if (ScubaMax/60 > 1)
	{
		if (ScubaMax%60 > 1)
		{
			sprintf(text,"%d minutes and %d seconds",ScubaMax/60,ScubaMax%60);
		}
		else if (ScubaMax%60 > 0)
		{
			sprintf(text,"%d minutes and %d second",ScubaMax/60,ScubaMax%60);
		}
		else
		{
			sprintf(text,"%d minutes",ScubaMax/60);
		}
	}
	else if (ScubaMax/60 > 0)
	{
		if (ScubaMax%60 > 1)
		{
			sprintf(text,"%d minute and %d seconds",ScubaMax/60,ScubaMax%60);
		}
		else if (ScubaMax%60 > 0)
		{
			sprintf(text,"%d minute and %d second",ScubaMax/60,ScubaMax%60);
		}
		else
		{
			sprintf(text,"%d minute",ScubaMax/60);
		}
	}
	else if (ScubaMax > 1)
	{
		sprintf(text,"%d seconds",ScubaMax);
	}
	else if (ScubaMax > 0)
	{
		sprintf(text,"%d second",ScubaMax);
	}
	else
	{
		sprintf(text,"no");
	}
	/**///Swimming_Trace("Complete - Scuba_Tank_Air_Time",-1);
	return text;
}

void JMG_New_Swimming_Script::Reset_Weapon_On_Water_Exit(GameObject *obj)
{
	/**///Swimming_Trace("Reset_Weapon_On_Water_Exit",1);
	if (allowemptyhands == 1 && !Get_Vehicle(obj))
	{
		allowemptyhands = 0;
		RP2WeaponListControl *Weapon = Get_WLS_Weapon_Settings(myweapon);
		if (Weapon)
		{
			if (Has_Weapon(obj,Weapon->WeaponName))
			{
				Commands->Select_Weapon(obj,Weapon->WeaponName);
			}
			else
			{
				Commands->Select_Weapon(obj,Get_Parameter("Swimming_Weapon"));
			}
		}
		else
		{
			Commands->Select_Weapon(obj,Get_Parameter("Swimming_Weapon"));
		}
	}
	/**///Swimming_Trace("Complete - Reset_Weapon_On_Water_Exit",-1);
}

void JMG_New_Swimming_Script::Swimming_Switch_Weapons(GameObject *obj)
{
	/**///Swimming_Trace("Swimming_Switch_Weapons",1);
	if (InVehicle == 0 && allowemptyhands == 1 && CanSwim == 1)
	{
		Commands->Select_Weapon(obj,"");
		Commands->Select_Weapon(obj,Get_Parameter("Swimming_Weapon"));
	}
	else if (InVehicle == 0 && allowemptyhands == 1 && CanSwim == 0)
	{
		const char *weap = Get_Current_Weapon(obj);
		if (weap)
		{
			if (_stricmp(weap,Get_Parameter("Swimming_Weapon")))
			{
				Commands->Select_Weapon(obj,Get_Parameter("Swimming_Weapon"));
			}
		}
	}
	/**///Swimming_Trace("Complete - Swimming_Switch_Weapons",-1);
}

int JMG_New_Swimming_Script::Vehicle_Air_Supply(GameObject *obj)
{
	/**///Swimming_Trace("Vehicle_Air_Supply",1);
	if (MyVehicle)
	{
		if (Get_Vehicle(obj) && MyVehicle->AirSupply > 0)
		{
			/**///Swimming_Trace("Complete 1 - Vehicle_Air_Supply",-1);
			return 1;
		}
	}
	/**///Swimming_Trace("Complete 0 - Vehicle_Air_Supply",-1);
	return 0;
}

void JMG_New_Swimming_Script::Create_Scuba_Tank(GameObject *obj)
{
	/**///Swimming_Trace("Create_Scuba_Tank",1);
	if (scubacurrent > 0 && ScubaMax > 0 && !Vehicle_Air_Supply(obj))
	{
		if (InVehicle < 2)// Only Run in nonwater proof vehicles
		{
			if (UWBSID == 0 && !Get_Vehicle(obj) && underwater > 0)
			{
				GameObject *swimmer = obj;
				if (CanSwim == 1)
				{
					swimmer = Commands->Find_Object(ObjectID);
				}
				char params[20];
				sprintf(params,"%d",MyIDNS);
				GameObject *breath = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),Commands->Get_Position(obj));
				Commands->Set_Model(breath,"null");
				Commands->Attach_To_Object_Bone(breath,swimmer,"c head");
				if (WaterType)
				{
					Commands->Set_Model(breath,WaterType->Scuba_Mask_Emitter);
				}
				UWBSID = Commands->Get_ID(breath);
				Commands->Attach_Script(breath,"JMG_Remove_Object_When_Creator_Destroyed",params);
			}
		}
	}
	if (scubacurrent == 0 || Get_Vehicle(obj) || underwater <= 0)
	{
		Remove_Repeating_Sound_Object(&UWBSID);
	}
	/**///Swimming_Trace("Complete - Create_Scuba_Tank",-1);
}

void JMG_New_Swimming_Script::Stop_Water_Flyout(GameObject *obj)
{
	/**///Swimming_Trace("Stop_Water_Flyout",1);
	GameObject *object = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),Commands->Get_Position(obj));
	Commands->Set_Model(object,"null");
	Commands->Attach_To_Object_Bone(obj,object,"origin");
	Commands->Destroy_Object(object);
	allowemptyhands = 0;
	GameObject *Heightadjuster = Commands->Find_Object(HeightAdjustID);
	Commands->Set_Animation(Heightadjuster,HeightAdjustAnimation,true,0,0,0,0);
	RP2WeaponListControl *Weapon = Get_WLS_Weapon_Settings(myweapon);
	if (Weapon)
	{
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			Commands->Select_Weapon(obj,Weapon->WeaponName);
		}
		else
		{
			Commands->Select_Weapon(obj,Get_Parameter("Swimming_Weapon"));
		}
	}
	else
	{
		Commands->Select_Weapon(obj,Get_Parameter("Swimming_Weapon"));
	}
	/**///Swimming_Trace("Complete - Stop_Water_Flyout",-1);
}

void JMG_New_Swimming_Script::EnableActionKeyEnter(GameObject *obj)
{
	/**///Swimming_Trace("EnableActionKeyEnter",1);
	if (EnableEEnter == 1)
	{
		EnableEEnter = 0;
		Commands->Start_Timer(obj,this,1.0f,5432165);
	}
	/**///Swimming_Trace("Complete - EnableActionKeyEnter",-1);
}

void JMG_New_Swimming_Script::DrownDamageSystem(GameObject *obj)
{
	/**///Swimming_Trace("DrownDamageSystem",1);
	// Redone Death System
	if (watermurkyness[0] <= 0.25)
	{
		if (!Get_Float_Parameter("Drown_Damage_Percent_Ratio"))
		{
			GameObject *InVehicle = Get_Vehicle(obj);
			if (InVehicle)
			{
				CantExitVehicle++;
				Soldier_Transition_Vehicle(obj);
				DrownedText(obj);
				Commands->Apply_Damage(obj,9999.99f,"blamokiller",obj);
			}
			else
			{
				CantExitVehicle = 0;
			}
			if (CantExitVehicle > 5)
			{
				CantExitVehicle = 0;
				GameObject *PlayerVehicle = Get_Vehicle(obj);
				if (PlayerVehicle)
				{
					Commands->Apply_Damage(PlayerVehicle,9999.99f,"BlamoKiller",0);
				}
			}
			else
			{
				DrownedText(obj);
				Commands->Apply_Damage(obj,9999.99f,"blamokiller",obj);
			}
		}
		else
		{
			float TotalHP = Commands->Get_Max_Health(obj) + Commands->Get_Max_Shield_Strength(obj); 
			TotalHP *= (Get_Float_Parameter("Drown_Damage_Percent_Ratio")/100);
			GameObject *InVehicle = Get_Vehicle(obj);
			if (InVehicle)
			{
				CantExitVehicle++;
				Soldier_Transition_Vehicle(obj);
				if (CanSwim == 1)
				{
					DrownedText(obj);
					Commands->Apply_Damage(obj,TotalHP,Get_Parameter("Swimming_Damage_Warhead"),0);
				}
				else
				{
					DrownedText(obj);
					Commands->Apply_Damage(obj,TotalHP,"None",0);
				}
			}
			else
			{
				CantExitVehicle = 0;
				if (CanSwim == 1)
				{
					DrownedText(obj);
					Commands->Apply_Damage(obj,TotalHP,Get_Parameter("Swimming_Damage_Warhead"),0);
				}
				else
				{
					DrownedText(obj);
					Commands->Apply_Damage(obj,TotalHP,"None",0);
				}
			}
			if (CantExitVehicle > 5)
			{
				CantExitVehicle = 0;
				GameObject *PlayerVehicle = Get_Vehicle(obj);
				if (PlayerVehicle)
				{
					Commands->Apply_Damage(PlayerVehicle,9999.99f,"BlamoKiller",0);
				}
			}
		}
	}
	/**///Swimming_Trace("Complete - DrownDamageSystem",-1);
}

void JMG_New_Swimming_Script::DrownDamageSystemHealthOnly(GameObject *obj)
{
	/**///Swimming_Trace("DrownDamageSystemHealthOnly",1);
	// Redone Death System
	if (watermurkyness[0] <= 0.25)
	{
		if (!Get_Float_Parameter("Drown_Damage_Percent_Ratio"))
		{
			GameObject *InVehicle = Get_Vehicle(obj);
			if (InVehicle)
			{
				CantExitVehicle++;
				Soldier_Transition_Vehicle(obj);
				DrownedText(obj);
				Commands->Apply_Damage(obj,9999.99f,"blamokiller",obj);
			}
			else
			{
				CantExitVehicle = 0;
				DrownedText(obj);
				Commands->Apply_Damage(obj,9999.99f,"blamokiller",obj);
			}
			if (CantExitVehicle > 5)
			{
				CantExitVehicle = 0;
				GameObject *PlayerVehicle = Get_Vehicle(obj);
				if (PlayerVehicle)
				{
					Commands->Apply_Damage(PlayerVehicle,9999.99f,"BlamoKiller",0);
				}
			}
		}
		else
		{
			float MyHealth = Commands->Get_Health(obj);
			float TotalHP = Commands->Get_Max_Health(obj);
			TotalHP *= (Get_Float_Parameter("Drown_Damage_Percent_Ratio")/100);
			TotalHP = (MyHealth - TotalHP);
			GameObject *InVehicle = Get_Vehicle(obj);
			if (InVehicle)
			{
				CantExitVehicle++;
				Soldier_Transition_Vehicle(obj);
				if (TotalHP > 0)
				{
					Commands->Set_Health(obj,TotalHP);
					Commands->Apply_Damage(obj,0.0,"None",0);
				}
				else
				{
					if (TotalHP <= 0)
					{
						Commands->Set_Health(obj,1);
					}
					DrownedText(obj);
					Commands->Apply_Damage(obj,9999.99f,"blamokiller",obj);
				}
			}
			else
			{
				CantExitVehicle = 0;
				if (TotalHP > 0)
				{
					Commands->Set_Health(obj,TotalHP);
					Commands->Apply_Damage(obj,0.0,"None",0);
				}
				else
				{
					if (TotalHP <= 0)
					{
						Commands->Set_Health(obj,1);
					}
					DrownedText(obj);
					Commands->Apply_Damage(obj,9999.99f,"blamokiller",obj);
					Commands->Create_Sound(Get_Parameter("Drown_Sound"),Commands->Get_Bone_Position(obj,"c head"),obj);
					watermurkyness[1] = -125;// Disable Death Sound
				}
			}
			if (CantExitVehicle > 5)
			{
				CantExitVehicle = 0;
				GameObject *PlayerVehicle = Get_Vehicle(obj);
				if (PlayerVehicle)
				{
					Commands->Apply_Damage(PlayerVehicle,9999.99f,"BlamoKiller",0);
				}
			}
		}
	}
	/**///Swimming_Trace("Complete - DrownDamageSystemHealthOnly",-1);
}

void JMG_New_Swimming_Script::Create_Scuba_Tank(GameObject *Player,GameObject *obj)
{
	/**///Swimming_Trace("Create_Scuba_Tank",1);
	if (MyScubaTank && !VisibleTankID)
	{
		GameObject *VisibleTank = Commands->Create_Object(Get_Parameter("Invisible_Box_Object"),Commands->Get_Position(obj));
		Commands->Set_Model(VisibleTank,"null");
		Commands->Set_Model(VisibleTank,MyScubaTank->TankModel);
		Commands->Attach_To_Object_Bone(VisibleTank,obj,MyScubaTank->AttachBone);
		Set_Max_Health(VisibleTank,MyScubaTank->TankHealth);
		Commands->Set_Health(VisibleTank,ScubaTankHealth);
		Set_Max_Shield_Strength(VisibleTank,MyScubaTank->TankArmor);
		Commands->Set_Shield_Strength(VisibleTank,ScubaTankArmor);
		Set_Skin(VisibleTank,MyScubaTank->TankSkin);
		Commands->Set_Shield_Type(VisibleTank,MyScubaTank->TankShield);
		VisibleTankID = Commands->Get_ID(VisibleTank);
		char params[256];
		sprintf(params,"%d",Commands->Get_ID(Player));
		Commands->Attach_Script(VisibleTank,"JMG_New_Swimming_Scuba_Tank_Attach_Script",params);
		Commands->Attach_Script(VisibleTank,"JMG_Remove_Object_When_Creator_Destroyed",params);
	}
	/**///Swimming_Trace("Complete - Create_Scuba_Tank",-1);
}

void JMG_New_Swimming_Script::Scuba_Tank_Killed(GameObject *Player,GameObject *obj)
{
	/**///Swimming_Trace("Scuba_Tank_Killed",1);
	if (MyScubaTank)
	{
		GameObject *VisibleTank = Commands->Find_Object(VisibleTankID);
		if (VisibleTank)
		{
			ScubaMax = 0;//No Air
			scubacurrent = 0;//No Air
			if (underwater) // Tank Burst
			{
				Commands->Create_Explosion(MyScubaTank->UnderwaterExplosion,Commands->Get_Bone_Position(obj,MyScubaTank->AttachBone),VisibleTank);
			}
			else
			{
				Commands->Create_Explosion(MyScubaTank->SurfaceExplosion,Commands->Get_Bone_Position(obj,MyScubaTank->AttachBone),VisibleTank);
			}
			for (int x = 0,end2 = 0;x < 10 && end2 == 0;x++)// No longer have Any tank/upgrades
			{
				uniquetankcheck[x] = 0;
			}
			MyScubaTank = NULL;
			VisibleTankID = 0;
			if (Commands->Get_Health(Player))
			{
				Send_Message_Player(Player,0,127,255,"My scuba tank has been destroyed!");
			}
		}
	}
	else
	{
		Console_Input("MESSAGE ERROR: MYSCUBATANK NODE IS NULL, IT WAS CALLED FOR IN \"Scuba_Tank_Killed\"");
	}
	/**///Swimming_Trace("Complete - Scuba_Tank_Killed",-1);
}

void JMG_New_Swimming_Script::Remove_Scuba_Tank()
{
	/**///Swimming_Trace("Remove_Scuba_Tank",1);
	GameObject *VisibleTank = Commands->Find_Object(VisibleTankID);
	if (VisibleTank)
	{
		ScubaTankHealth = Commands->Get_Health(VisibleTank);
		ScubaTankArmor = Commands->Get_Shield_Strength(VisibleTank);
		Commands->Destroy_Object(VisibleTank);
		VisibleTankID = 0;
	}
	/**///Swimming_Trace("Complete - Remove_Scuba_Tank",-1);
}

void JMG_New_Swimming_Script::Swimming_Toggle_Control(GameObject *obj,int param)
{
	if (CanSwimToggleProcess[2] == 0 && EnableEEnter == 1)
	{
		if (param == 3)
		{
			// Overflow backup
			for (int x = ArrayPosition,end = 0,autostop = 0;x < 100 && end == 0 && autostop < 2;x++)
			{
				if (x == 100)
				{
					autostop++;
					x = 0;
					if (autostop >= 2)
					{
						Console_Input("Swimming Error: Toggle param not found in sort buffer, giving up!");
					}
				}
				if (SwimmingToggleOverFlowBuffer[x] != -1)
				{
					param = SwimmingToggleOverFlowBuffer[x];
					SwimmingToggleOverFlowBuffer[x] = -1;
					ArrayPosition = x;
					end = 1;
				}
			}
		}
		if (param != CanSwim || param == 2)
		{
			if (isswimming)
			{
				GameObject *nomove = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
				Commands->Attach_To_Object_Bone(obj,nomove,"null");
				Commands->Set_Model(nomove,"null");
				// Remember Variables
				CanSwimToggleProcess[4] = Commands->Get_ID(nomove);
				CanSwimToggleProcess[3] = CDT; //Hold Air
				CanSwimToggleProcess[2] = 1;
				CanSwimToggleProcess[0] = isswimming;
				CanSwimToggleProcess[1] = underwater;
				//Disable Swimming
				isswimming = 1;
				underwater = 1;
				Commands->Send_Custom_Event(obj,obj,345345,1,0.0f);
				Commands->Send_Custom_Event(obj,obj,347360,1,0.1f);

				Commands->Send_Custom_Event(obj,obj,347371,1,0.25f);

				// Now Reenable
				isswimming = CanSwimToggleProcess[0];
				underwater = CanSwimToggleProcess[1];
				Commands->Send_Custom_Event(obj,obj,347361,1,0.3f);
				Commands->Send_Custom_Event(obj,obj,345346,1,0.4f);

				Commands->Send_Custom_Event(obj,obj,347370,1,0.5f);// Reenable time
			}
			else // Not swimming just toggle
			{
				Toggle_Swimming();
			}
		}
	}
	else// If it fails delay it and try agian
	{
		Commands->Send_Custom_Event(obj,obj,347369,3,1);
		if (param != 3)
		{
			for (int x = ArrayPosition,end = 0,autostop = 0;x < 100 && end == 0 && autostop < 2;x++)
			{
				if (x == 100)
				{
					autostop++;
					x = 0;
					if (autostop >= 2)
					{
						Console_Input("Swimming Error: Too many toggle messages!");
					}
				}
				if (SwimmingToggleOverFlowBuffer[x] == -1)
				{
					SwimmingToggleOverFlowBuffer[x] = param;
					end = 1;
				}
			}
		}
	}
}

void JMG_New_Swimming_Script::Enable_Swimming_Toggle()
{
	GameObject *Stoper = Commands->Find_Object(CanSwimToggleProcess[4]);
	if (Stoper)
	{
		Commands->Destroy_Object(Stoper);
		CanSwimToggleProcess[4];
	}
	CDT = CanSwimToggleProcess[3];
	CanSwimToggleProcess[2] = 0;
}

void JMG_New_Swimming_Script::Toggle_Swimming()
{
	if (CanSwim)
	{
		CanSwim = 0;
	}
	else
	{
		CanSwim = 1;
	}
}

void JMG_New_Swimming_Script::WaterZoneHeight(GameObject *Zone)
{
	/**///Swimming_Trace("WaterZoneHeight",1);
	if (Zone)
	{
		OBBoxClass *TheZone = Get_Zone_Box(Zone);
		EnterZoneHeight = TheZone->Center.Z+(TheZone->Extent.Z);
	}
	/**///Swimming_Trace("Complete - WaterZoneHeight",-1);
}

void JMG_New_Swimming_Script::DrownedText(GameObject *obj)
{
	/**///Swimming_Trace("DrownedText",1);
	char Text[237];
	const char *str = Get_Player_Name(obj);
	sprintf(Text,"%s has drowned.",str);
	delete[] str;
	RP2_Player_Death_Message_Control(obj,Text,0);
	/**///Swimming_Trace("Complete - DrownedText",-1);
}

void JMG_New_Swimming_Script::RefindSwimmingZone(GameObject *obj)
{
	/**///Swimming_Trace("RefindSwimmingZone",1);
	GameObject *Zone = NULL;
	Vector3 Pos = Commands->Get_Position(obj);
	float HighestPoint = 0;
	SLNode<ScriptZoneGameObj> *x = GameObjManager::ScriptZoneGameObjList.Head();
	while (x)
	{
		GameObject *TempZone = x->Data();
		if (TempZone)
		{
			if (Is_Script_Attached(TempZone,"JMG_New_Swimming_Zone"))
			{
				if (IsInsideZone(TempZone,obj))
				{
					if (Zone)
					{
						OBBoxClass *ZZBox = Get_Zone_Box(Zone);
						float TempHighestPoint = ZZBox->Center.Z+(ZZBox->Extent.Z);
						float TempDist = abs(Pos.Z - TempHighestPoint);
						if (TempDist < HighestPoint)
						{
							Zone = TempZone;
							HighestPoint = TempDist;
						}
					}
					else
					{
						Zone = TempZone;
						OBBoxClass *ZZBox = Get_Zone_Box(Zone);
						HighestPoint = abs(Pos.Z - (ZZBox->Center.Z+(ZZBox->Extent.Z)));
					}
				}
			}
		}
		x = x->Next();
	}
	WaterZoneHeight(Zone);
	/**///Swimming_Trace("Complete - RefindSwimmingZone",-1);
}

void JMG_New_Swimming_Script::CheckForUnderwaterZoneMiscount(GameObject *obj,GameObject *Head)
{
	/**///Swimming_Trace("CheckForUnderwaterZoneMiscount",1);
	if (obj && Head)
	{
		int UWZC = 0;
		SLNode<ScriptZoneGameObj> *x = GameObjManager::ScriptZoneGameObjList.Head();
		while (x)
		{
			GameObject *TempZone = x->Data();
			if (TempZone)
			{
				if (Is_Script_Attached(TempZone,"JMG_New_Swimming_Zone"))
				{
					if (IsInsideZone(TempZone,Head))
					{
						UWZC++;
					}
				}
			}
			x = x->Next();
		}
		if (underwater != UWZC)
		{
			if (!underwater && UWZC)
			{
				ISUNDERWATER[Get_Player_ID(obj)] = underwater = UWZC;
				StartSwimmingUnderwater(obj);// Turns screen effects on and tells animation that its under water (this seems to have been skipping under the right lag conditions prior)
				Commands->Send_Custom_Event(obj,Commands->Find_Object(ObjectID),345345,1,0);// Tell Swimming object its underwater
			}
			else if (underwater && UWZC)
			{
				ISUNDERWATER[Get_Player_ID(obj)] = underwater = UWZC;
			}
		}
	}
	/**///Swimming_Trace("Complete - CheckForUnderwaterZoneMiscount",-1);
}

void JMG_New_Swimming_Script::StartSwimmingUnderwater(GameObject *obj)
{
	/**///Swimming_Trace("StartSwimmingUnderwater",1);
	CountDown = 11;
	if (CanSwim == 0)
	{
		if (!Get_Vehicle(obj) && NoSwimID == 0)
		{
			GameObject *NoSwimEffects = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
			Commands->Set_Model(NoSwimEffects,WaterType->Underwater_Effect);
			Commands->Attach_To_Object_Bone(NoSwimEffects,obj,"origin");
			NoSwimID = Commands->Get_ID(NoSwimEffects);
		}
		allowemptyhands = 1;
	}
	ISNEWSWIMMING[Get_Player_ID(obj)] = 2;
	/**///Swimming_Trace("Complete - StartSwimmingUnderwater",-1);
}

void JMG_New_Swimming_Script::StartSwimmingOnSurface(GameObject *obj)
{
	/**///Swimming_Trace("StartSwimmingOnSurface",1);
	ISUNDERWATER[Get_Player_ID(obj)] = underwater = 0;
	if (CanSwim == 0)
	{
		if (NoSwimID != 0)
		{
			Commands->Destroy_Object(Commands->Find_Object(NoSwimID));
			NoSwimID = 0;
		}
		Reset_Weapon_On_Water_Exit(obj);
	}
	if (CanSwimToggleProcess[2] == 0)// Disable for cirtain situations
	{
		Reload_Screen_Effects();
		if (CDT >= (Get_Int_Parameter("Drown_Time")) * 10 && Get_Int_Parameter("Drown_Time") >= 0)// Gasp for breath
		{
			Commands->Create_3D_Sound_At_Bone(Get_Parameter("Urgent_Breath_Sound"),obj,"origin");
		}
		else
		{
			Commands->Create_3D_Sound_At_Bone(Get_Parameter("Breath_Sound"),obj,"origin");
		}
	}
	CDT = 0;
	Remove_Repeating_Sound_Object(&UWBSID);
	Remove_Repeating_Sound_Object(&HeartBeatID);
	Remove_Repeating_Sound_Object(&ScubaSoundID);
	if (ISNEWSWIMMING[Get_Player_ID(obj)] != 0)
	{
		ISNEWSWIMMING[Get_Player_ID(obj)] = 1;
	}
	Reset_Screen(obj);
	/**///Swimming_Trace("Complete - StartSwimmingOnSurface",-1);
}

void JMG_New_Swimming_Script::TakeWaterDamage(GameObject *obj)
{
	if (!WaterType || !WaterType->InfantryWaterDamage)
	{
		return;
	}
	if (InWaterTime >= WaterType->InfantryWaterDamageDelay)
	{
		float TotalHP = Commands->Get_Health(obj);
		TotalHP -= WaterType->InfantryWaterDamage;
		GameObject *InVehicle = Get_Vehicle(obj);
		if (InVehicle)
		{
			CantExitVehicle++;
			Soldier_Transition_Vehicle(obj);
		}
		if (TotalHP > 0)
		{
			Commands->Set_Health(obj,TotalHP);
			Commands->Apply_Damage(obj,0.0,"None",0);
		}
		else
		{
			if (TotalHP <= 0)
			{
				Commands->Set_Health(obj,1);
			}
			char Text[237];
			const char *str = Get_Player_Name(obj);
			sprintf(Text,"%s just couldn't swim anymore...",str);
			delete[] str;
			RP2_Player_Death_Message_Control(obj,Text,0);
			Commands->Apply_Damage(obj,9999.99f,"blamokiller",obj);
		}
		if (CantExitVehicle > 5)
		{
			CantExitVehicle = 0;
			GameObject *PlayerVehicle = Get_Vehicle(obj);
			if (PlayerVehicle)
			{
				Commands->Apply_Damage(PlayerVehicle,9999.99f,"BlamoKiller",0);
			}
		}
	}
}

GameObject *JMG_New_Swimming_Script::FindCurrentWaterZone(GameObject *obj)
{
	/**///Swimming_Trace("FindCurrentWaterZone",1);
	GameObject *Zone = NULL;
	Vector3 Pos = Commands->Get_Position(obj);
	float HighestPoint = 0;
	SLNode<ScriptZoneGameObj> *x = GameObjManager::ScriptZoneGameObjList.Head();
	while (x)
	{
		GameObject *TempZone = x->Data();
		if (TempZone)
		{
			if (Is_Script_Attached(TempZone,"JMG_New_Swimming_Zone"))
			{
				if (IsInsideZone(TempZone,obj))
				{
					if (Zone)
					{
						OBBoxClass *ZZBox = Get_Zone_Box(Zone);
						float TempHighestPoint = ZZBox->Center.Z+(ZZBox->Extent.Z);
						float TempDist = abs(Pos.Z - TempHighestPoint);
						if (TempDist < HighestPoint)
						{
							Zone = TempZone;
							HighestPoint = TempDist;
						}
					}
					else
					{
						Zone = TempZone;
						OBBoxClass *ZZBox = Get_Zone_Box(Zone);
						HighestPoint = abs(Pos.Z - (ZZBox->Center.Z+(ZZBox->Extent.Z)));
					}
				}
			}
		}
		x = x->Next();
	}
	/**///Swimming_Trace("Complete - FindCurrentWaterZone",-1);
	return Zone;
}

void JMG_New_Swimming_Script::Swimming_Trace(const char *Description,int num)
{
	FILE *TraceST;
	char STParam[200];
	sprintf(STParam,"SwimmingTraceDump\\SwimTrace%d.txt",MyIDNS);
	if (!TraceDepth && !num)
	{
		TraceST = fopen(STParam,"w");
	}
	else
	{
		TraceST = fopen(STParam,"a+");
	}
	if (TraceST)
	{
		if (num > 0)
		{
			TraceDepth += num;
		}
		char OutLine[2000];
		sprintf(OutLine,"%d:",TraceDepth);
		/*for (int x = 0;x < TraceDepth;x++)
		{
			sprintf(OutLine,"%s  ",OutLine);
		}*/
		fprintf(TraceST,"%s%s\n",OutLine,Description);
		fflush(TraceST);
		if (num < 0)
		{
			TraceDepth += num;
		}
		fclose(TraceST);
	}
}

// Removed the old inwater system 10/10/09 
void JMG_New_Swimming_Head_Attach_Script::Created(GameObject *obj)
{
	inwater = 0;
}

void JMG_New_Swimming_Head_Attach_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	GameObject *player = Commands->Find_Object(Get_Int_Parameter("PlayerID"));
	// Under Water
	if (message == 347361)
	{
		Commands->Send_Custom_Event(obj,player,345346,1,0);
	}
	// Out of water
	if (message == 347360)
	{
		Commands->Send_Custom_Event(obj,player,345345,1,0);
	}
}

// Removed the last of the reborn mech logic 10/1/09 and implimented strafing animation system
void JMG_New_Swimming_Attach_Script::Created(GameObject *obj)
{
	// Define Animation Node
	if (SwimmingAnimationTypeNode)
	{
		SwimmingAnimationTypeControl *Current = SwimmingAnimationTypeNode;
		int end = 0;
		while (Current != NULL && end == 0)
		{
			if (Get_Int_Parameter("AnimationType") == Current->SwimmingAnimationType)// match
			{
				end = 1;
				AnimationType = Current;
			}
			Current = Current->next;
		}
		if (end == 0)
		{
			char errormsg[1000];
			sprintf(errormsg,"ERROR: Swimming Animation Type %d not found! Animations Shutting Down...",Get_Int_Parameter("AnimationType"));
			Send_Message_Player(Commands->Find_Object(Get_Int_Parameter("ID")),255,0,0,errormsg);
			Remove_Script(obj,Get_Parameter("JMG_New_Swimming_Attach_Script"));
		}
		// Back to original stuff
		pos = Commands->Get_Position(obj);
		forward = 0;
		backward = 0;
		right = 0;
		left = 0;
		StandingStill = 1;
		ASFBTRLUD = 110000000;
		OldCodeDIR = 110000000;
		oldfacing = Commands->Get_Facing(obj);
		truningleft = 0;
		truningright = 0;
		up = 0;
		down = 0;
		underwater = Get_Int_Parameter("UnderWater");
		enabled = 1;
		char ANIMATION[512];
		sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Not_Moving_Surface);
		Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,0);
		Set_Damage_Points(obj,0.0f);
		Set_Death_Points(obj,0.0f);
		// Part of the old effects script
		char params[20];
		sprintf(params,"%d",Commands->Get_ID(obj));
		GameObject *object = Commands->Create_Object(Get_Parameter("Underwater_Effect_Controller"),pos);
		if (underwater)
		{
			if (Get_Int_Parameter("Allow_Splash_Effects"))
			{
				Commands->Set_Model(object,Get_Parameter("Underwater_Effect"));
				SoundID = Repeating_Sound_Object(obj,Get_Parameter("Underwater_Ambient_Sound"));
			}
			else
			{
				Commands->Set_Model(object,"null");
			}
		}
		else
		{
			if (Get_Int_Parameter("Allow_Splash_Effects"))
			{
				Commands->Set_Model(object,Get_Parameter("Surface_Water_Effect"));
				SoundID = Repeating_Sound_Object(obj,Get_Parameter("Water_Surface_Ambient_Sound"));
			}
			else
			{
				Commands->Set_Model(object,"null");
			}
		}
		Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
		Commands->Disable_Physical_Collisions(object);
		Commands->Attach_To_Object_Bone(object,obj,"c neck");
		ObjectID = Commands->Get_ID(object);
		hastriggered = 0;
		// Back to original Stuff
		Commands->Start_Timer(obj,this,0.5f,1456234);
		Commands->Start_Timer(obj,this,0.1f,1456235);
	}
	else
	{
		char errormsg[1000];
		sprintf(errormsg,"ERROR: NO swimming animation controller detected! Shutting down animation control script!");
		Send_Message_Player(Commands->Find_Object(Get_Int_Parameter("ID")),255,0,0,errormsg);
		Remove_Script(obj,"JMG_New_Swimming_Attach_Script");
	}
}

void JMG_New_Swimming_Attach_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 345346)
	{
		underwater--;
		if (underwater <= 0)
		{
			underwater = 0;
			OldCodeDIR = 2;
			char ANIMATION[512];
			sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Not_Moving_Surface);
			Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
			if (Get_Int_Parameter("Allow_Splash_Effects"))
			{
				Commands->Set_Model(Commands->Find_Object(ObjectID),Get_Parameter("Surface_Water_Effect"));
			}
			if (SoundID > 0)
			{
				Remove_Repeating_Sound_Object(&SoundID);
			}
			SoundID = Repeating_Sound_Object(obj,Get_Parameter("Water_Surface_Ambient_Sound"));
		}
	}
	if (message == 345345)
	{
		underwater++;
		if (underwater == 1)
		{		
			OldCodeDIR = 2;
			if (Get_Int_Parameter("Allow_Splash_Effects"))
			{
				Commands->Set_Model(Commands->Find_Object(ObjectID),Get_Parameter("Underwater_Effect"));
			}
			if (SoundID > 0)
			{
				Remove_Repeating_Sound_Object(&SoundID);
			}
			SoundID = Repeating_Sound_Object(obj,Get_Parameter("Underwater_Ambient_Sound"));
		}
	}
}

void JMG_New_Swimming_Attach_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 1456234 && enabled == 1)
	{
		Vector3 newpos = Commands->Get_Position(obj);
		float facing = Commands->Get_Facing(obj);
		float distancexy = abs(pos.X - newpos.X)+abs(pos.Y - newpos.Y);
		float distancez = abs(pos.Z - newpos.Z);
		StandingStill = 0;truningright = 0;truningleft = 0;forward = 0;
		backward = 0;right = 0;left = 0;up = 0;down = 0;
		if (distancexy <= 0.05 && distancez <= 0.05 && facing <= oldfacing + 0.1f && facing >= oldfacing - 0.1f)
		{
			StandingStill = 1;
			OldCodeDIR = 110000000;
		}
		else if (distancexy > 0.05f)	
		{
			Vector3 Movement = newpos;
			Movement.X -= pos.X;
			Movement.Y -= pos.Y;
			float TempRotation = atan2(Movement.Y,Movement.X) * 180 / PI;
			float MovementAngle = TempRotation - facing;
			/*char printout[2000];
			sprintf(printout,"MESSAGE Rotation:%0.2f MyRotation:%0.2f MovementDirection:%.2f",TempRotation,facing,MovementAngle);
			Console_Input(printout);*/
			if ((MovementAngle > -45 && MovementAngle < 45) || (MovementAngle < -315 && MovementAngle > -360) || MovementAngle > 315) 
			{
				if (distancez > 0.05f){
					if (newpos.Z > pos.Z){
						up = 1;
						OldCodeDIR = 101000010;}
					else if (newpos.Z < pos.Z){
						down = 1;
						OldCodeDIR = 101000001;}}
				else{
					OldCodeDIR = 101000000;}
				forward = 1;
			}
			else if ((MovementAngle >= 45 && MovementAngle <= 135) || (MovementAngle <= -225 && MovementAngle >= -315)) 
			{
				if (distancez > 0.05f){
					if (newpos.Z > pos.Z){
						up = 1;
						OldCodeDIR = 100000110;}
					else if (newpos.Z < pos.Z){
						down = 1;
						OldCodeDIR = 100000101;}}
				else{
					OldCodeDIR = 100000100;}
				left = 1;
			}
			else if ((MovementAngle >= 225 && MovementAngle <= 315) || (MovementAngle <= -45 && MovementAngle >= -135)) 
			{
				if (distancez > 0.05f){
					if (newpos.Z > pos.Z){
						up = 1;
						OldCodeDIR = 100001010;}
					else if (newpos.Z < pos.Z){
						down = 1;
						OldCodeDIR = 100001001;}}
				else{
					OldCodeDIR = 100001000;}
				right = 1;
			}
			else if ((MovementAngle > 135 && MovementAngle < 225) || (MovementAngle < -135 && MovementAngle > -225)) 
			{
				if (distancez > 0.05f){
					if (newpos.Z > pos.Z){
						up = 1;
						OldCodeDIR = 100100010;}
					else if (newpos.Z < pos.Z){
						down = 1;
						OldCodeDIR = 100100001;}}
				else{
					OldCodeDIR = 100100000;}
				backward = 1;
			}
			else
			{
				char printout[2000];
				sprintf(printout,"MESSAGE ERROR: Degree Not Defined! Degree:%.2f",MovementAngle);
				Console_Input(printout);
			}
		}
		else if (distancez > 0.05 && distancexy < 0.05f)
		{
			if (newpos.Z > pos.Z){
				up = 1;
				OldCodeDIR = 100010010;}
			else if (newpos.Z < pos.Z){
				down = 1;
				OldCodeDIR = 100000001;}
		}
		else if (facing > oldfacing + 0.1f || facing < oldfacing - 0.1f)
		{
			if (facing > oldfacing){
				truningright = 1;
				OldCodeDIR = 100011000;}
			else if (facing < oldfacing){
				truningleft = 1;
				OldCodeDIR = 100010100;}
		}
		pos = newpos;
		oldfacing = Commands->Get_Facing(obj);
		Commands->Start_Timer(obj,this,0.1f,1456234);
	}
	if (number == 1456235)
	{
		if (ASFBTRLUD != OldCodeDIR)
		{
			char ANIMATION[512];
			if (ASFBTRLUD != 110000000 && StandingStill == 1)
			{
				ASFBTRLUD = 110000000;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Not_Moving);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Not_Moving_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 101000000 && forward == 1 && up == 0 && down == 0)
			{
				ASFBTRLUD = 101000000;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Forward);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Forward_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100100000 && backward == 1 && up == 0 && down == 0)
			{
				ASFBTRLUD = 100100000;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Backward);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Backward_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100010100 && truningleft == 1)
			{
				ASFBTRLUD = 100010100;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Turn_Left);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Turn_Left_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100011000 && truningright == 1)
			{
				ASFBTRLUD = 100011000;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Turn_Right);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Turn_Right_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100010010 && up == 1 && forward == 0 && backward == 0)
			{
				ASFBTRLUD = 100010010;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Up);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Not_Moving_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100000001 && down == 1 && forward == 0 && backward == 0)
			{
				ASFBTRLUD = 100000001;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Down);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Not_Moving_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 101000010 && forward == 1 && up == 1)
			{
				ASFBTRLUD = 101000010;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Tilt_Up);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Forward_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 101000001 && forward == 1 && down == 1)
			{
				ASFBTRLUD = 101000001;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Tilt_Down);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Forward_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100100010 && backward == 1 && up == 1)
			{
				ASFBTRLUD = 100100010;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Tilt_Up_Backward);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,0);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Backward_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100100001 && backward == 1 && down == 1)
			{
				ASFBTRLUD = 100100001;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Tilt_Down_Backward);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Backward_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			// NEW CRAP
			if (ASFBTRLUD != 100001000 && right == 1 && up == 0 && down == 0)
			{
				ASFBTRLUD = 100001000;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Swim_Right);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Right_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100001010 && right == 1 && up == 1)
			{
				ASFBTRLUD = 100001010;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Swim_Right_Tilt_Up);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Right_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100001001 && right == 1 && down == 1)
			{
				ASFBTRLUD = 100001001;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Swim_Right_Tilt_Down);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Right_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100000100 && left == 1 && up == 0 && down == 0)
			{
				ASFBTRLUD = 100000100;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Swim_Left);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Left_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100000110 && left == 1 && up == 1)
			{
				ASFBTRLUD = 100000110;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Swim_Left_Tilt_Up);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,0);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Left_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			if (ASFBTRLUD != 100000101 && left == 1 && down == 1)
			{
				ASFBTRLUD = 100000101;
				if (underwater >= 1)
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Swim_Left_Tilt_Down);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
				else
				{
					sprintf(ANIMATION,"%s.%s%s",AnimationType->Skeleton,AnimationType->Animation_Name,AnimationType->Left_Surface);
					Commands->Set_Animation(obj,ANIMATION,true,0,Get_Animation_Frame(obj),-1,1);
				}
			}
			OldCodeDIR = ASFBTRLUD;
		}
		// Old Effects object code
		{
			if (Get_Int_Parameter("Allow_Splash_Effects"))
			{
				if (Get_Animation_Frame(obj) <= 5 || (Get_Animation_Frame(obj) > 10 && Get_Animation_Frame(obj) <= 15))
				{
					if (hastriggered == 0)
					{
						if (underwater == 0)
						{
							Commands->Set_Model(Commands->Find_Object(ObjectID),Get_Parameter("Surface_Water_Effect"));
						}
					}
					hastriggered = 1;
				}
				else
				{
					if (underwater == 0 && hastriggered == 1)
					{
						Commands->Set_Model(Commands->Find_Object(ObjectID),"null");
					}
					hastriggered = 0;
				}
			}
		}
		// Swimming Script
		Commands->Start_Timer(obj,this,0.1f,1456235);
	}
}

void JMG_New_Swimming_Attach_Script::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Commands->Get_ID(damager) > 0 && Commands->Get_Health(Commands->Find_Object(Get_Int_Parameter("ID"))) > 0)
	{
		GameObject *player = Commands->Find_Object(Get_Int_Parameter("ID"));
		if (damager && player)
		{
			Commands->Apply_Damage(player,damage,Get_Parameter("Swimming_Damage_Warhead"),damager);
		}
		else
		{
			Commands->Apply_Damage(player,damage,Get_Parameter("Swimming_Damage_Warhead"),0);
		}
	}
}

void JMG_New_Swimming_Attach_Script::Killed(GameObject *obj,GameObject *damager)
{
	GameObject *player = Commands->Find_Object(Get_Int_Parameter("ID"));
	Commands->Send_Custom_Event(obj,player,347362,1,0);
	Commands->Set_Model(player,Get_Model(obj));
	Commands->Apply_Damage(player,99999.9f,"BlamoKiller",0);
}

int JMG_New_Swimming_Attach_Script::Repeating_Sound_Object(GameObject *obj,const char *Sound)
{
	Vector3 pos;
	char params[20];
	sprintf(params,"%d",Commands->Get_ID(obj));
	GameObject *SoundObject = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(SoundObject,Sound);
	Commands->Attach_To_Object_Bone(SoundObject,obj,"c head");	
	Commands->Attach_Script(SoundObject,"JMG_Remove_Object_When_Creator_Destroyed",params);
	int ID = Commands->Get_ID(SoundObject);
	return ID;
}

void JMG_New_Swimming_Attach_Script::Remove_Repeating_Sound_Object(int *ID)
{
	GameObject *object = Commands->Find_Object(*ID);
	if (object)
	{
		Commands->Destroy_Object(object);
	}
	*ID = 0;
}

// New water zone scripts below 10/10/09
void JMG_New_Swimming_Zone::Created(GameObject *obj)
{
	Create_And_Return_Swimming_Zone_Node(Commands->Get_ID(obj))->ZoneType = Get_Int_Parameter("Water_Zone_Type");
}

void JMG_New_Swimming_Zone::Entered(GameObject *obj,GameObject *enter)
{
	Commands->Send_Custom_Event(obj,enter,347361,Get_Int_Parameter("Water_Zone_Type"),0);
}

void JMG_New_Swimming_Zone::Exited(GameObject *obj,GameObject *exit)
{
	Commands->Send_Custom_Event(obj,exit,347360,Get_Int_Parameter("Water_Zone_Type"),0);
}

// New Scuba Script Created 10/11/09
void JMG_New_Swimming_Scuba_Tank_Type::Created(GameObject *obj)
{
	//JeradTrace("JMG_New_Swimming_Scuba_Tank_Type");
	if (!SwimmingScubaGearNode)
	{
		SwimmingScubaGearNode = new SwimmingScubaGearControl;
		SwimmingScubaGearNode->ScubaGearType = Get_Int_Parameter("ScubaGearType");
		SwimmingScubaGearNode->HoldAirAmount = Get_Int_Parameter("HoldAirAmount");
		SwimmingScubaGearNode->UpgradeMaxAir = Get_Int_Parameter("UpgradeMaxAir");
		SwimmingScubaGearNode->EmitsBubbles = Get_Int_Parameter("EmitsBubbles");
		SwimmingScubaGearNode->PurchaseCost = Get_Int_Parameter("PurchaseCost");
		SwimmingScubaGearNode->TankHealth = Get_Float_Parameter("TankHealth");
		SwimmingScubaGearNode->TankArmor = Get_Float_Parameter("TankArmor");
		SwimmingScubaGearNode->TankSkin = Get_Parameter("TankSkin");
		SwimmingScubaGearNode->TankShield = Get_Parameter("TankShield");
		SwimmingScubaGearNode->SurfaceExplosion = Get_Parameter("SurfaceExplosion");
		SwimmingScubaGearNode->UnderwaterExplosion = Get_Parameter("UnderwaterExplosion");
		SwimmingScubaGearNode->TankModel = Get_Parameter("TankModel");
		SwimmingScubaGearNode->AttachBone = Get_Parameter("AttachBone");
		SwimmingScubaGearNode->next = NULL;
	}
	else
	{
		int end = 0;
		SwimmingScubaGearControl *Current = SwimmingScubaGearNode;
		while (Current != NULL && end == 0)
		{
			if (Get_Int_Parameter("ScubaGearType") == Current->ScubaGearType)// match
			{
				char ERRORs[2000];
				sprintf(ERRORs,"MESSAGE ERROR: Scuba tank type %d already exists!",Get_Int_Parameter("ScubaGearType"));
				Console_Input(ERRORs);
				end = 1;
			}
			else if (Current->next == NULL)
			{
				Current->next = new SwimmingScubaGearControl;
				Current = Current->next;
				Current->ScubaGearType = Get_Int_Parameter("ScubaGearType");
				Current->HoldAirAmount = Get_Int_Parameter("HoldAirAmount");
				Current->UpgradeMaxAir = Get_Int_Parameter("UpgradeMaxAir");
				Current->EmitsBubbles = Get_Int_Parameter("EmitsBubbles");
				Current->PurchaseCost = Get_Int_Parameter("PurchaseCost");
				Current->TankHealth = Get_Float_Parameter("TankHealth");
				Current->TankArmor = Get_Float_Parameter("TankArmor");
				Current->TankSkin = Get_Parameter("TankSkin");
				Current->TankShield = Get_Parameter("TankShield");
				Current->SurfaceExplosion = Get_Parameter("SurfaceExplosion");
				Current->UnderwaterExplosion = Get_Parameter("UnderwaterExplosion");
				Current->TankModel = Get_Parameter("TankModel");
				Current->AttachBone = Get_Parameter("AttachBone");
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
	//JeradTrace("Complete - JMG_New_Swimming_Scuba_Tank_Type");
}

void JMG_New_Swimming_Scuba_Tank_Powerup::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		Commands->Send_Custom_Event(obj,sender,5432158,Get_Int_Parameter("Scuba_Tank_Type"),0);
	}
}

void JMG_New_Swimming_Scuba_Tank_Attach_Script::Killed(GameObject *obj,GameObject *damager)
{
	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ID")),5432166,1,0);
}

void JMG_RP2_Vehicle::Created(GameObject *obj)
{
	char Message[2000];
	sprintf(Message,"MESSAGE Warning: JMG_RP2_Vehicle is no longer in use, yet vehicle preset %s is using it, please correct this.",Commands->Get_Preset_Name(obj));
	Console_Input(Message);
}

void JMG_RP2_Vehicle_Advanced::Created(GameObject *obj)
{
	AddNode(obj);
	int set;
	for (set = 0;set < 10;set++)
	{
		MyNode->mps[set] = 0.0f;
		MyNode->MPS[set] = 0.0f;
		idstore[set] = 0;
	}
	for (set = 0;set < 2;set++)
	{
		DamageEffectIDs[set] = 0;
	}
	if ((obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->Peek_Physical_Object() && obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
	{
		if (Get_Int_Parameter("Create_Clouds") == 1 || Get_Int_Parameter("Create_Clouds") == -2)
		{
			Commands->Attach_Script(obj,"JMG_RP2_Air_Craft_Cloud_Script","cloudemitter");
		}
	}
	if (Get_Vehicle_Seat_Count(obj) > 0)
	{
		Commands->Set_Player_Type(obj,-1);
	}
	if (Is_Script_Attached(obj,"JMG_RP2_Vehicle_Fire_Override"))
	{
		CanBurn = false;
	}
	else
	{
		Attach_Script_Once(obj,"JMG_RP2_Object_Send_Text_Message_On_Death",0);
		CanBurn = true;
	}
	enginedisabled = 0;
	Is_In_Water = 0;
	WaterType = NULL;
	MyNode->ArraySpot = 0;
	LPosition = Commands->Get_Position(obj);
	Commands->Start_Timer(obj,this,1.0f,24534533);
	Commands->Start_Timer(obj,this,0.1f,24534535);
}

void JMG_RP2_Vehicle_Advanced::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == EMPMESSAGE && !Is_Script_Attached(obj,"JMG_RP2_Vehicle_Ignore_EMP") && MyNode)
	{
		Vector3 SenderPos = Commands->Get_Position(sender);
		MyNode->EMPTime = 4*((int)((EMPSTANDARDDURATION*((((param-Commands->Get_Distance(Commands->Get_Position(obj),SenderPos))+10.0)/(float)param)*4.0f))));
		int sc = Get_Vehicle_Seat_Count(obj);
		for(int r = 0;r < sc;r++)
		{
			GameObject *VehicleOccupent = Get_Vehicle_Occupant(obj,r);
			if (VehicleOccupent)
			{
				Send_Message_Player(VehicleOccupent,127,0,127,"ElectroMagnetic Pulse detected - countermeasures engaged... Standby while internal computers reboot.");
			}
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		if (enginedisabled == 1 && Is_In_Water == 0)
		{
			Send_Message_Player(sender,127,0,127,"Repairs required in order for vehicle to function!");
		}
		else if (MyNode->EMPTime)
		{
			Send_Message_Player(sender,127,0,127,"Internal computers rebooting, please standby...");
		}
		if (MyNode->IsWarthog)
		{
			WarthogControl *MyWarthogNode = Get_Warthog_Node(obj);
			if (MyWarthogNode)
			{
				Commands->Send_Custom_Event(obj,Get_Vehicle_Driver(Commands->Find_Object(MyWarthogNode->BodyID)),90000028,Get_Int_Parameter("Water_Fill_Time"),0);
				Commands->Send_Custom_Event(obj,Get_Vehicle_Driver(Commands->Find_Object(MyWarthogNode->TurretID)),90000028,Get_Int_Parameter("Water_Fill_Time"),0);
				Commands->Send_Custom_Event(obj,Get_Vehicle_Driver(Commands->Find_Object(MyWarthogNode->GunnerID)),90000028,Get_Int_Parameter("Water_Fill_Time"),0);
			}
		}
		else
		{
			Commands->Send_Custom_Event(obj,sender,90000028,Get_Int_Parameter("Water_Fill_Time"),0);
		}
		int sc = Get_Vehicle_Seat_Count(obj);
		for(int r = 0;r < sc;r++)
		{
			GameObject *VehicleOccupent = Get_Vehicle_Occupant(obj,r);
			if (VehicleOccupent)
			{
				if (Commands->Get_Player_Type(VehicleOccupent) == 1)
				{
					Commands->Send_Custom_Event(obj,VehicleOccupent,4327718,1,0);
				}
			}
		}
		int r, end = 0;
		for(r = 0;r < 10 && end == 0;r++)
		{
			if (idstore[r] == 0)
			{
				end = 1;
				idstore[r] = Commands->Get_ID(sender);
			}
		}
		if (enginedisabled == 1 || MyNode->EMPTime)
		{
			Commands->Enable_Engine(obj,0);
		}
		if (Is_In_Water > 0 && Get_Int_Parameter("Water_Fill_Time") == -1)
		{
			if (WaterType)
			{
				Set_Fog_Enable_Player(sender,1);
				Set_Fog_Range_Player(sender,(WaterType->VehicleWaterMurkyness*0.75f),WaterType->VehicleWaterMurkyness,0);
				Set_Screen_Fade_Color_Player(sender,WaterType->VehicleScreenRed,WaterType->VehicleScreenGreen,WaterType->VehicleScreenBlue,0);
				Set_Screen_Fade_Opacity_Player(sender,WaterType->VehicleWaterColorThickness,0);
			}
		}
		else if (Get_Int_Parameter("Water_Fill_Time") == -1)
		{	
			RP2_Set_Fog_And_Screen_Color_To_Level_Default(sender);
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		int r, end = 0;
		for(r = 0;r < 10 && end == 0;r++)
		{
			if (idstore[r] == Commands->Get_ID(sender))
			{
				end = 1;
				GameObject *exiter = Commands->Find_Object(idstore[r]);
				idstore[r] = 0;
				if (Get_Int_Parameter("Water_Fill_Time") == -1)
				{
					RP2_Set_Fog_And_Screen_Color_To_Level_Default(exiter);
					RP2_Set_Fog_And_Screen_Color_To_Level_Default(exiter);
				}
				Commands->Send_Custom_Event(obj,exiter,90000029,1,0);
				if (Commands->Is_A_Star(exiter))
				{
					Commands->Set_Player_Type(exiter,-1);
				}
				else
				{
					Commands->Action_Reset(obj,10);
					Commands->Action_Reset(obj,100);
					Commands->Action_Reset(obj,1000);
				}
				idstore[r] = 0;
			}
		}
		if (enginedisabled == 1 || MyNode->EMPTime)
		{
			Commands->Enable_Engine(obj,0);
		}
		if (!Get_Vehicle_Occupant_Count(obj))
		{
			Commands->Set_Player_Type(obj,-1);
		}
		if (sender->As_PhysicalGameObj())//Function below is for vehicle exit damage
		{
			Vector3 Pos = Commands->Get_Position(sender),OldPos;
			OldPos = Pos;
			int x = 0;
			while (x < 3)
			{
				x++;
				Pos.Z -= 1.0f;
				Commands->Set_Position(sender,Pos);
				PhysicalGameObj *objphys = ((ScriptableGameObj *)sender)->As_PhysicalGameObj();
				if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
				{
					x = 5;
					TakeDamageOnExit(obj,sender);
				}
			}
			Commands->Set_Position(sender,OldPos);
		}
		Commands->Send_Custom_Event(obj,sender,90000029,1,0);
	}
	if (message == 596912)
	{
		Commands->Set_Health(sender,(param/100.0f));
	}
	if (message == 347361)
	{
		Is_In_Water++;
		if (Is_In_Water == 1)
		{
			// Water Definition Node Stuff
			SwimmingWaterZoneTypeControl *Current = SwimmingWaterZoneTypeNode;
			int end = 0;
			if (Current)
			{
				while (Current != NULL && end == 0)
				{
					if (param == Current->WaterZoneType)// match
					{
						end = 1;
						WaterType = Current;
					}
					Current = Current->next;
				}
			}
			if (end == 0)
			{
				char errormsg[1000];
				sprintf(errormsg,"ERROR: Water Zone Type %d not found! YOU MUST DIE!",param);
				Send_Message_Player(Get_Vehicle_Driver(obj),255,0,0,errormsg);
				Commands->Apply_Damage(obj,99999.99f,"BlamoKiller",0);
			}
			else
			{
				Commands->Create_Explosion(WaterType->Huge_Splash,Commands->Get_Position(obj),0);
				if (Get_Int_Parameter("Takes_Water_Damage") == 1)
				{
					char params[20];
					sprintf(params,"%f",WaterType->VehicleWaterDamage);
					Commands->Attach_Script(obj,"JMG_Do_Not_Drive_In_Water",params);
				}
				Commands->Send_Custom_Event(obj,obj,912397344,1,0.25f);
			}
		}
		// Back to original Swimming Script Stuff
		if ((obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->Peek_Physical_Object() && obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()) && Get_Int_Parameter("Create_Clouds") >= 0)
		{
			enginedisabled = 1;
			if (Commands->Get_Health(obj) == Commands->Get_Max_Health(obj))
			{
				Commands->Set_Health(obj,(Commands->Get_Max_Health(obj)*0.9f));
			}
			Commands->Enable_Engine(obj,0);
		}
	}
	if (message == 347360)
	{
		Is_In_Water--;
		if (Is_In_Water == 0)
		{
			if (Get_Int_Parameter("Takes_Water_Damage") == 1)
			{
				Remove_Script(obj,"JMG_Do_Not_Drive_In_Water");
			}
			int sc = Get_Vehicle_Seat_Count(obj);
			for (int r = 0;r < sc;r++)
			{
				GameObject *Player = Get_Vehicle_Occupant(obj,r);
				RP2_Set_Fog_And_Screen_Color_To_Level_Default(Player);
			}
		}
	}
	if (message == 912397343)
	{
		if (Commands->Get_ID(sender) == Commands->Get_ID(Get_Vehicle_Driver(obj)))
		{
			Commands->Start_Timer(obj,this,0.0f,24534534);
		}
		else if (Commands->Get_ID(Get_Vehicle_Driver(obj)) == 0 && Commands->Get_ID(sender) == Commands->Get_ID(Get_Vehicle_Gunner(obj)))
		{
			Commands->Start_Timer(obj,this,0.0f,24534534);
		}
		else if (Commands->Get_ID(Get_Vehicle_Gunner(obj)) == 0 && Commands->Get_ID(Get_Vehicle_Driver(obj)) == 0)
		{
			Commands->Start_Timer(obj,this,0.0f,24534534);
		}
	}
	if (message == 912397344 && Get_Int_Parameter("Water_Fill_Time") == -1)
	{
		int sc = Get_Vehicle_Seat_Count(obj);
		for (int r = 0;r < sc;r++)
		{
			GameObject *Player = Get_Vehicle_Occupant(obj,r);
			Set_Fog_Enable_Player(Player,1);
			Set_Fog_Range_Player(Player,(WaterType->VehicleWaterMurkyness*0.75f),WaterType->VehicleWaterMurkyness,0.0);
			Set_Screen_Fade_Color_Player(Player,WaterType->VehicleScreenRed,WaterType->VehicleScreenGreen,WaterType->VehicleScreenBlue,0.0);
			Set_Screen_Fade_Opacity_Player(Player,WaterType->VehicleWaterColorThickness,0.0);
		}
	}
}

void JMG_RP2_Vehicle_Advanced::Timer_Expired(GameObject *obj,int number)
{
	if (number == 24534533)
	{
		if (MyNode->EMPTime)
		{
			MyNode->EMPTime--;
			if (MyNode->EMPTime < 0)
			{
				MyNode->EMPTime = 0;
			}
			if (!MyNode->EMPTime)
			{
				if (Get_Vehicle_Occupant_Count(obj) && !enginedisabled)
				{
					Commands->Enable_Engine(obj,1);
				}
				int sc = Get_Vehicle_Seat_Count(obj);
				for(int r = 0;r < sc;r++)
				{
					GameObject *VehicleOccupent = Get_Vehicle_Occupant(obj,r);
					if (VehicleOccupent)
					{
						Send_Message_Player(VehicleOccupent,127,0,127,"Internal computers have successfully rebooted, have a nice day!");
					}
				}
				Commands->Enable_Vehicle_Transitions(obj,true);
			}
			else
			{
				Commands->Enable_Engine(obj,0);
				if (!(obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->Peek_Physical_Object() && obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
				{
					JMG_Force_Occupants_Exit(obj);
				}
			}
		}
		if (enginedisabled == 1)
		{
			Commands->Enable_Engine(obj,0);
			if (Commands->Get_Health(obj) == Commands->Get_Max_Health(obj) && !MyNode->EMPTime)
			{
				if (Get_Vehicle_Occupant_Count(obj))
				{
					Commands->Enable_Engine(obj,1);
				}
				enginedisabled = 0;
			}
		}
		Commands->Start_Timer(obj,this,0.25f,24534533);
	}
	if (number == 24534534)
	{
		int r,sc = Get_Vehicle_Seat_Count(obj);
		for(r = 0;r < sc;r++)
		{
			GameObject *VehicleOccupent = Get_Vehicle_Occupant(obj,r);
			if (VehicleOccupent)
			{
				if (Commands->Get_Player_Type(VehicleOccupent) != 1)
				{
					if (Commands->Is_A_Star(VehicleOccupent))
					{
						Commands->Set_Player_Type(VehicleOccupent,1);
					}
				}
			}
			//Commands->Send_Custom_Event(obj,Get_Vehicle_Occupant(obj,r),4327717,1,0);
		}
	}
	if (number == 24534535)
	{
		if (MyNode->AirSupply != -1)
		{
			if (Is_In_Water > 0 && MyNode->AirSupply > 0)
			{
				MyNode->AirSupply--;
			}
			if (Is_In_Water == 0 && Get_Int_Parameter("Water_Fill_Time") > MyNode->AirSupply)
			{
				MyNode->AirSupply++;
			}
		}
		Vector3 pos = Commands->Get_Position(obj);
		MyNode->ArraySpot++;
		if (MyNode->ArraySpot > 9)
		{
			MyNode->ArraySpot = 0;
		}
		MyNode->mps[MyNode->ArraySpot] = Commands->Get_Distance(pos,LPosition)*10.0f;
		MyNode->MPH = ((MyNode->mps[MyNode->ArraySpot] * 3600) * 0.000621371192f);
		MyNode->MPS[MyNode->ArraySpot] = MyNode->MPH;
		LPosition = pos;
		Commands->Start_Timer(obj,this,0.1f,24534535);
	}
	if (number == 24534539)
	{
		if (Get_Vehicle_Occupant_Count(obj))
		{
			char Speed[237];
			float amps = 0;
			for (int x = 0;x < 10;x++)
			{
				amps += MyNode->mps[x];
			}
			amps /= 10;
			sprintf(Speed,"MESSAGE Current Vehicle Speed:%.2fmph :: %.2f meters a second.",((amps * 3600) * 0.000621371192f),amps);
			Console_Input(Speed);
		}
		Commands->Start_Timer(obj,this,10.0f,24534539);
	}
}

void JMG_RP2_Vehicle_Advanced::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (!CanBurn){return;}
	float HealthTotal = Commands->Get_Health(obj)+Commands->Get_Shield_Strength(obj);
	float MaxHealthTotal = Commands->Get_Max_Health(obj)+Commands->Get_Max_Shield_Strength(obj);
	if (DamageEffectIDs[0] == 0)
	{
		if (HealthTotal <= (MaxHealthTotal * 0.5))
		{
			GameObject *object = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
			Commands->Set_Model(object,"carsmoke");
			Commands->Attach_To_Object_Bone(object,obj,"origin");
			DamageEffectIDs[0] = Commands->Get_ID(object);	
		}
	}
	else
	{
		if (HealthTotal > (MaxHealthTotal * 0.5))
		{
			Commands->Destroy_Object(Commands->Find_Object(DamageEffectIDs[0]));
			DamageEffectIDs[0] = 0;
		}
	}
	if (DamageEffectIDs[1] == 0)
	{
		if (HealthTotal <= (MaxHealthTotal * 0.25))
		{
			GameObject *object = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
			Commands->Set_Model(object,"carfire");
			Commands->Attach_To_Object_Bone(object,obj,"origin");
			DamageEffectIDs[1] = Commands->Get_ID(object);		
		}
	}
	else
	{
		if (HealthTotal > (MaxHealthTotal * 0.25))
		{
			Commands->Destroy_Object(Commands->Find_Object(DamageEffectIDs[1]));
			DamageEffectIDs[1] = 0;
		}
	}
}

void JMG_RP2_Vehicle_Advanced::Killed(GameObject *obj,GameObject *damager)
{
	int r;
	for(r = 0;r < 10;r++)
	{
		if (idstore[r] > 0)
		{
			GameObject *apassenger = Commands->Find_Object(idstore[r]);
			Commands->Send_Custom_Event(obj,apassenger,90000029,1,0);
			if (Commands->Is_A_Star(apassenger))
			{
				Commands->Set_Player_Type(apassenger,-1);
			}
			idstore[r] = 0;
		}
	}
	for(r = 0;r < 2;r++)
	{
		Commands->Destroy_Object(Commands->Find_Object(DamageEffectIDs[r]));
	}
}

void JMG_RP2_Vehicle_Advanced::JMG_Force_Occupants_Exit(GameObject *obj)
{
	Commands->Enable_Vehicle_Transitions(obj,true);
	int j = 0;
	while (Get_Vehicle_Occupant_Count(obj) > 0 && j < 5)
	{
		if (!obj || !obj->As_VehicleGameObj())
		{
			return;
		}
		int x = obj->As_VehicleGameObj()->Get_Occupant_Count();
		for (int i = 0;i < x;i++)
		{
			if (obj->As_VehicleGameObj()->Get_Occupant(i))
			{
				ActionParamsStruct params;
				params.Set_Basic((long)0,100,39);
				Commands->Action_Enter_Exit(obj->As_VehicleGameObj()->Get_Occupant(i),params);
			}
		}
		Commands->Enable_Vehicle_Transitions(obj,true);
		j++;
	}
	Commands->Enable_Vehicle_Transitions(obj,false);
	if (Get_Vehicle_Occupant_Count(obj) > 0)
	{
		Commands->Apply_Damage(obj,9999999.9f,"BlamoKiller",0);
	}
}

void JMG_RP2_Vehicle_Advanced::AddNode(GameObject *obj)
{
	if (!RP2VehicleNode)
	{
		RP2VehicleNode = new RP2VehicleControl;
		RP2VehicleNode->VehicleID = Commands->Get_ID(obj);
		RP2VehicleNode->AirSupply = Get_Int_Parameter("Water_Fill_Time");
		RP2VehicleNode->OnCarryAll = 0;
		const char *PresetName = Commands->Get_Preset_Name(obj);
		if (!_stricmp("Renhalo_Warthog",PresetName))
		{
			RP2VehicleNode->IsWarthog = 1;
		}
		else if (!_stricmp("Renhalo_Warthog_Gunner",PresetName) || !_stricmp("Renhalo_Warthog_Turret",PresetName))
		{
			RP2VehicleNode->IsWarthog = 2;
		}
		else
		{
			RP2VehicleNode->IsWarthog = 0;
		}
		RP2VehicleNode->EMPTime = 0;
		RP2VehicleNode->next = NULL;
		MyNode = RP2VehicleNode;
	}
	else
	{
		int end = 0;
		RP2VehicleControl *Current = RP2VehicleNode;
		int MyID = Commands->Get_ID(obj);
		while (Current != NULL && end == 0)
		{
			if (Current->VehicleID == MyID)
			{
				end = 1;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new RP2VehicleControl;
				Current = Current->next;
				Current->VehicleID = Commands->Get_ID(obj);
				Current->AirSupply = Get_Int_Parameter("Water_Fill_Time");
				Current->OnCarryAll = 0;
				Current->EMPTime = 0;
				const char *PresetName = Commands->Get_Preset_Name(obj);
				if (!_stricmp("Renhalo_Warthog",PresetName))
				{
					Current->IsWarthog = 1;
				}
				else if (!_stricmp("Renhalo_Warthog_Gunner",PresetName) || !_stricmp("Renhalo_Warthog_Turret",PresetName))
				{
					Current->IsWarthog = 2;
				}
				else
				{
					Current->IsWarthog = 0;
				}
				Current->next = NULL;
				MyNode = Current;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Vehicle_Advanced::TakeDamageOnExit(GameObject *obj,GameObject *sender)
{
	float amps = MyNode->MPH;
	if (amps > 35)
	{
		float percent = (amps-35.0f)/135.0f;
		float Damage = (((percent*Commands->Get_Max_Health(sender))*Commands->Get_Random(0.90f,1.1f))/2);
		float EndHealth = (Commands->Get_Health(sender) - Damage);
		if (EndHealth <= 0.0)
		{
			char DeathMessage[237];
			if (amps > 60)
			{
				const char *str = Get_Translated_Preset_Name(obj);
				const char *str2 = Get_Player_Name(sender);
				sprintf(DeathMessage,"%s died by jumping out of a %s traveling at %.0f miles per hour.",str2,str,amps);
				delete[] str2;
				delete[] str;
			}
			else
			{
				const char *str = Get_Translated_Preset_Name(obj);
				const char *str2 = Get_Player_Name(sender);
				sprintf(DeathMessage,"%s died by exiting a %s traveling at %.0f miles per hour.",str2,str,amps);
				delete[] str2;
				delete[] str;
			}
			RP2_Player_Death_Message_Control(sender,DeathMessage,0);
			Commands->Apply_Damage(sender,9999.0,"BlamoKiller",0);
		}
		else
		{
			char params[2000];
			sprintf(params,"1.0,34234,%s,%s",Get_Skin(sender),Get_Shield_Type(sender));
			Commands->Set_Shield_Type(sender,"Blamo");
			Set_Skin(sender,"Blamo");
			Commands->Attach_Script(sender,"JMG_Change_HP_Shields_On_Timer",params);
			Commands->Send_Custom_Event(obj,sender,596911,(int)(Damage*100),0);
			Commands->Send_Custom_Event(sender,obj,596912,(int)(EndHealth*100),0.1f);
		}
	}
}
void JMG_RP2_Submarine_Script_Advanced::Created(GameObject *obj)
{
	int set;
	for (set = 0;set < 10;set++)
	{
		idstore[set] = 0;
	}
	Vector3 pos;
	GameObject *object = Commands->Create_Object("Daves Arrow",pos);
	Commands->Attach_To_Object_Bone(object,obj,"SubBlock");
	Commands->Set_Model(object,"hoverplate");
	Sub_Block_ID = Commands->Get_ID(object);
	GameObject *object2 = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(object2,"hoverplate");
	Sub_Block_ID2 = Commands->Get_ID(object2);
	GameObject *object3 = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(object3,"invisiblenc");
	Commands->Attach_To_Object_Bone(object3,obj,"origin");
	UnderWaterEffectsID = Commands->Get_ID(object3);
	GameObject *object4 = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(object4,"invisiblenc");
	Commands->Attach_To_Object_Bone(object4,obj,"origin");
	SubAlarmID = Commands->Get_ID(object4);
	cancollide = 1;
	Pinging = 0;

	Is_In_Water = 0;
	Vector3 pos2 = Commands->Get_Position(obj);
	pos2.Z += 100.0f;
	PingTime = 0;
	PingReboundStart = 7;
	PingReboundEnd = 10;
	MaxAir = Get_Int_Parameter("Water_Fill_Time");
	if (MaxAir > 9000)
	{
		MaxAir = 9000;
	}
	if (MaxAir < 100)
	{
		MaxAir = 100;
	}
	WaterType = NULL;
	AddNode(obj);
	MyNode->ArraySpot = 0;
	LPosition = Commands->Get_Position(obj);
	Commands->Set_Position(obj,pos2);
	Commands->Start_Timer(obj,this,0.1f,24534535);
	Commands->Start_Timer(obj,this,0.1f,542423);
	Commands->Start_Timer(obj,this,0.25f,542424);
	Commands->Start_Timer(obj,this,0.5f,542425);
	Commands->Start_Timer(obj,this,0.75f,542426);
}

void JMG_RP2_Submarine_Script_Advanced::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7154148)
	{
		char CAir[257];
		sprintf(CAir,"Current Air Supply: %.0f%c",((float)MyNode->AirSupply/(float)MaxAir)*100.0f,'%');
		Send_Message_Player(sender,200,200,125,CAir);
		Send_Message_Player(sender,200,200,125,"Vehicle Special Key:");
		Send_Message_Player(sender,200,200,125,"H - Toggle Sonar");
	}
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		Commands->Send_Custom_Event(obj,sender,90000028,-1,0);
		int sc = Get_Vehicle_Seat_Count(obj);
		for(int r = 0;r < sc;r++)
		{
			GameObject *VehicleOccupent = Get_Vehicle_Occupant(obj,r);
			if (VehicleOccupent)
			{
				if (Commands->Get_Player_Type(VehicleOccupent) == 1)
				{
					Commands->Send_Custom_Event(obj,VehicleOccupent,4327718,1,0);
				}
			}
		}
		int r, end = 0;
		for(r = 0;r < 10 && end == 0;r++)
		{
			if (idstore[r] == 0)
			{
				end = 1;
				idstore[r] = Commands->Get_ID(sender);
			}
		}
		if (Is_In_Water > 0)
		{
			if (WaterType)
			{
				Set_Fog_Enable_Player(sender,1);
				Set_Fog_Range_Player(sender,10.0f,100.0f,0);
				Set_Screen_Fade_Color_Player(sender,WaterType->VehicleScreenRed,WaterType->VehicleScreenGreen,WaterType->VehicleScreenBlue,0);
				Set_Screen_Fade_Opacity_Player(sender,WaterType->VehicleWaterColorThickness,0);
			}
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		int r, end = 0;
		for(r = 0;r < 10 && end == 0;r++)
		{
			if (idstore[r] == Commands->Get_ID(sender))
			{
				end = 1;
				GameObject *exiter = Commands->Find_Object(idstore[r]);
				idstore[r] = 0;
				RP2_Set_Fog_And_Screen_Color_To_Level_Default(exiter);
				Commands->Send_Custom_Event(obj,exiter,90000029,1,0);
				Commands->Set_Player_Type(exiter,-1);
				idstore[r] = 0;
			}
		}
		Commands->Send_Custom_Event(obj,sender,90000029,1,0);
	}
	if (message == 347361)
	{
		Is_In_Water++;
		if (Is_In_Water == 1)
		{
			Commands->Create_3D_WAV_Sound_At_Bone("subdive.wav",obj,"origin");
			// Water Definition Node Stuff
			SwimmingWaterZoneTypeControl *Current = SwimmingWaterZoneTypeNode;
			int end = 0;
			if (Current)
			{
				while (Current != NULL && end == 0)
				{
					if (param == Current->WaterZoneType)// match
					{
						end = 1;
						WaterType = Current;
					}
					Current = Current->next;
				}
			}
			if (end == 0)
			{
				char errormsg[1000];
				sprintf(errormsg,"ERROR: Water Zone Type %d not found! YOU MUST DIE!",param);
				Send_Message_Player(Get_Vehicle_Driver(obj),255,0,0,errormsg);
				Commands->Apply_Damage(obj,99999.99f,"BlamoKiller",0);
			}
			else
			{
				Commands->Create_Explosion(WaterType->Huge_Splash,Commands->Get_Position(obj),0);
				Commands->Send_Custom_Event(obj,obj,912397344,2,0.0f);
				Commands->Send_Custom_Event(obj,obj,912397344,2,0.1f);
				Commands->Send_Custom_Event(obj,obj,912397344,2,0.5f);
				PingTime = 21;
			}
		}
	}
	if (message == 347360)
	{
		Is_In_Water--;
		if (Is_In_Water == 0)
		{
			int sc = Get_Vehicle_Seat_Count(obj);
			for (int r = 0;r < sc;r++)
			{
				GameObject *Player = Get_Vehicle_Occupant(obj,r);
				RP2_Set_Fog_And_Screen_Color_To_Level_Default(Player);
			}
			if (WaterType)
			{
				Commands->Create_Explosion(WaterType->Huge_Splash,Commands->Get_Position(obj),0);
			}
		}
	}
	if (message == 912397343)
	{
		if (Commands->Get_ID(sender) == Commands->Get_ID(Get_Vehicle_Driver(obj)))
		{
			Commands->Start_Timer(obj,this,0.0f,24534534);
		}
		else if (Commands->Get_ID(Get_Vehicle_Driver(obj)) == 0 && Commands->Get_ID(sender) == Commands->Get_ID(Get_Vehicle_Gunner(obj)))
		{
			Commands->Start_Timer(obj,this,0.0f,24534534);
		}
		else if (Commands->Get_ID(Get_Vehicle_Gunner(obj)) == 0 && Commands->Get_ID(Get_Vehicle_Driver(obj)) == 0)
		{
			Commands->Start_Timer(obj,this,0.0f,24534534);
		}
	}
	if (message == 912397344 && param == 2 && Is_In_Water) // Exit sub
	{
		int sc = Get_Vehicle_Seat_Count(obj);
		for (int r = 0;r < sc;r++)
		{
			GameObject *Player = Get_Vehicle_Occupant(obj,r);
			Set_Fog_Enable_Player(Player,1);
			Set_Fog_Range_Player(Player,100.0f,150.0f,0.0);
			Set_Screen_Fade_Color_Player(Player,WaterType->VehicleScreenRed,WaterType->VehicleScreenGreen,WaterType->VehicleScreenBlue,0.0);
			Set_Screen_Fade_Opacity_Player(Player,WaterType->VehicleWaterColorThickness,0.0);
		}
	}
	if (message == 7745473 && Is_In_Water)
	{
		if (PingTime != -1)
		{
			PingTime = -1;
			int sc = Get_Vehicle_Seat_Count(obj);
			for (int r = 0;r < sc;r++)
			{
				GameObject *Player = Get_Vehicle_Occupant(obj,r);
				Set_Fog_Enable_Player(Player,1);
				Set_Fog_Range_Player(Player,10.0,100.0f,1.00);
				Set_Screen_Fade_Color_Player(Player,WaterType->VehicleScreenRed,WaterType->VehicleScreenGreen,WaterType->VehicleScreenBlue,1.75);
				Set_Screen_Fade_Opacity_Player(Player,WaterType->VehicleWaterColorThickness,0);
			}
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver)
			{
				Send_Message_Player(Driver,0,127,255,"Powering down sonar...");
			}
		}
		else
		{
			PingTime = 21;
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver)
			{
				Send_Message_Player(Driver,0,127,255,"Powering up sonar...");
			}
		}
	}
}

void JMG_RP2_Submarine_Script_Advanced::Timer_Expired(GameObject *obj,int number)
{
	if (number == 24534534)
	{
		int r,sc = Get_Vehicle_Seat_Count(obj);
		for(r = 0;r < sc;r++)
		{
			GameObject *VehicleOccupent = Get_Vehicle_Occupant(obj,r);
			if (VehicleOccupent)
			{
				if (Commands->Get_Player_Type(VehicleOccupent) != 1)
				{
					Commands->Set_Player_Type(VehicleOccupent,1);
				}
			}
		}
	}
	if (number == 24534535)
	{
		if (Is_In_Water && MyNode->AirSupply > 0)
		{
			MyNode->AirSupply--;
			if (MyNode->AirSupply == MaxAir*0.75f)
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					Send_Message_Player(Driver,0,127,255,"Your sub has 75% of its clean air supply remaining!");
				}
			}
			if (MyNode->AirSupply == (int)(MaxAir/2))
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					Send_Message_Player(Driver,0,127,255,"Your sub has 50% of its clean air supply remaining!");
				}
			}
			if (MyNode->AirSupply == (int)(MaxAir*0.25))
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					Send_Message_Player(Driver,0,127,255,"Your sub has 25% of its clean air supply remaining!");
				}
			}
			if (MyNode->AirSupply == (int)(MaxAir*0.1f))
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					Send_Message_Player(Driver,0,127,255,"Your sub has 10% of its clean air supply remaining!");
				}
			}
			if (MyNode->AirSupply == (int)(MaxAir*0.05f))
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					Send_Message_Player(Driver,0,127,255,"Your sub only has 5% of its clean air supply remaining!");
				}
			}
			if (!MyNode->AirSupply)
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					Send_Message_Player(Driver,0,127,255,"Your sub is out of clean air, resurface immanently!");
				}
				Attach_Script_Once(obj,"JMG_Do_Not_Drive_In_Water","0.1");
				GameObject *object = Commands->Find_Object(SubAlarmID);
				if (object)
				{
					Commands->Set_Model(object,"Sub_Alarm");
				}
			}
		}
		if (!Is_In_Water && MaxAir > MyNode->AirSupply)
		{
			MyNode->AirSupply += 10;
			if (MyNode->AirSupply > 0 && Is_Script_Attached(obj,"JMG_Do_Not_Drive_In_Water"))
			{
				Remove_Script(obj,"JMG_Do_Not_Drive_In_Water");
				GameObject *object = Commands->Find_Object(SubAlarmID);
				if (object)
				{
					Commands->Set_Model(object,"invisiblenc");
				}
			}
			if (MyNode->AirSupply >= MaxAir)
			{
				MyNode->AirSupply = MaxAir;
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					Send_Message_Player(Driver,0,127,255,"Subs air cycle complete, you may now dive!");
				}
			}
		}
		Vector3 pos = Commands->Get_Position(obj);
		MyNode->ArraySpot++;
		if (MyNode->ArraySpot > 9)
		{
			MyNode->ArraySpot = 0;
		}
		MyNode->mps[MyNode->ArraySpot] = Commands->Get_Distance(pos,LPosition)*10.0f;
		MyNode->MPH = ((MyNode->mps[MyNode->ArraySpot] * 3600) * 0.000621371192f);
		MyNode->MPS[MyNode->ArraySpot] = MyNode->MPH;
		LPosition = pos;
		Commands->Start_Timer(obj,this,0.1f,24534535);
	}

	// Old Sub Stuff
	
	if (number == 542423)
	{
		Vector3 raiseheight = Commands->Get_Position(obj);
		if (Is_In_Water && Pinging == 0)
		{
			Pinging = 1;
			GameObject *object3 = Commands->Find_Object(UnderWaterEffectsID);
			Commands->Set_Model(object3,"UWSubE");
		}
		else if (!Is_In_Water && Pinging == 1)
		{
			Pinging = 0;
			GameObject *object3 = Commands->Find_Object(UnderWaterEffectsID);
			Commands->Set_Model(object3,"invisiblenc");
		}
		if (Get_Vehicle_Occupant_Count(obj) == 0 && raiseheight.Z < -22.165)
		{
			raiseheight.Z += 0.01f;
			Commands->Set_Position(obj,raiseheight);
		}
		Vector3 pos = Commands->Get_Position(obj);// Client side flying sub fix
		if (pos.Z < -21.25 && cancollide == 1)
		{
			GameObject *object = Commands->Find_Object(Sub_Block_ID);
			Commands->Set_Model(object,"invisiblenc");
			cancollide = 0;
		}
		else if (pos.Z >= -21.25 && cancollide == 0)
		{
			GameObject *object = Commands->Find_Object(Sub_Block_ID);
			Commands->Set_Model(object,"subblock");
			cancollide = 1;
		}
		GameObject *object2 = Commands->Find_Object(Sub_Block_ID2);
		pos.Z = -16.25;//-22.165 is the sub's highest point in the water
		Commands->Set_Position(object2,pos);
		Commands->Set_Facing(object2,Commands->Get_Facing(obj));
		if (Is_In_Water)
		{
			if (PingTime == 0)
			{
				PingSound(obj);
				int sc = Get_Vehicle_Seat_Count(obj);
				for (int r = 0;r < sc;r++)
				{
					GameObject *Player = Get_Vehicle_Occupant(obj,r);
					Set_Fog_Enable_Player(Player,1);
					Set_Fog_Range_Player(Player,10.0f,300.0f,0.25);			
					Set_Screen_Fade_Color_Player(Player,0.19f,0.5f,0.19f,0.1f);
					Set_Screen_Fade_Opacity_Player(Player,WaterType->VehicleWaterColorThickness,0);
				}
			}
			if (PingTime == PingReboundStart)
			{
				int sc = Get_Vehicle_Seat_Count(obj);
				for (int r = 0;r < sc;r++)
				{
					GameObject *Player = Get_Vehicle_Occupant(obj,r);
					Set_Fog_Enable_Player(Player,1);
					Set_Fog_Range_Player(Player,50.0f,300.0f,0.3f);
				}
			}
			if (PingTime == PingReboundEnd)
			{
				int sc = Get_Vehicle_Seat_Count(obj);
				for (int r = 0;r < sc;r++)
				{
					GameObject *Player = Get_Vehicle_Occupant(obj,r);
					Set_Fog_Enable_Player(Player,1);
					Set_Fog_Range_Player(Player,10.0f,100.0f,1.00);
					Set_Screen_Fade_Color_Player(Player,WaterType->VehicleScreenRed,WaterType->VehicleScreenGreen,WaterType->VehicleScreenBlue,1.75);
					Set_Screen_Fade_Opacity_Player(Player,WaterType->VehicleWaterColorThickness,0);
				}
			}
			if (PingTime != -1)
			{
				PingTime++;
				if (PingTime > 39)
				{
					PingTime = 0;
				}
			}
		}
		Commands->Start_Timer(obj,this,0.1f,542423);
	}
	if (number == 542424)
	{
		Is_In_Water = 0;
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z -= 100.0f;
		Commands->Set_Position(obj,pos);
	}
	if (number == 542425)
	{
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z -= 5.0f;
		Commands->Set_Position(obj,pos);
	}
	if (number == 542426)
	{
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z += 5.0f;
		Commands->Set_Position(obj,pos);
	}
}

void JMG_RP2_Submarine_Script_Advanced::Killed(GameObject *obj,GameObject *damager)
{
	int r;
	for(r = 0;r < 10;r++)
	{
		if (idstore[r] > 0)
		{
			GameObject *apassenger = Commands->Find_Object(idstore[r]);
			Commands->Send_Custom_Event(obj,apassenger,90000029,1,0);
			Commands->Set_Player_Type(apassenger,-1);
			idstore[r] = 0;
		}
	}
	GameObject *object = Commands->Find_Object(Sub_Block_ID);
	if (object){Commands->Destroy_Object(object);}
	object = Commands->Find_Object(SubAlarmID);
	if (object){Commands->Destroy_Object(object);}
	object = Commands->Find_Object(UnderWaterEffectsID);
	if (object){Commands->Destroy_Object(object);}
}

void JMG_RP2_Submarine_Script_Advanced::AddNode(GameObject *obj)
{
	if (!RP2VehicleNode)
	{
		RP2VehicleNode = new RP2VehicleControl;
		RP2VehicleNode->VehicleID = Commands->Get_ID(obj);
		RP2VehicleNode->AirSupply = MaxAir;;
		RP2VehicleNode->OnCarryAll = 0;
		RP2VehicleNode->IsWarthog = 0;
		RP2VehicleNode->EMPTime = 0;
		RP2VehicleNode->next = NULL;
		MyNode = RP2VehicleNode;
	}
	else
	{
		int end = 0;
		RP2VehicleControl *Current = RP2VehicleNode;
		int MyID = Commands->Get_ID(obj);
		while (Current != NULL && end == 0)
		{
			if (Current->VehicleID == MyID)
			{
				end = 1;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new RP2VehicleControl;
				Current = Current->next;
				Current->VehicleID = Commands->Get_ID(obj);
				Current->AirSupply = MaxAir;
				Current->OnCarryAll = 0;
				Current->EMPTime = 0;
				Current->IsWarthog = 0;
				Current->next = NULL;
				MyNode = Current;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Submarine_Script_Advanced::PingSound(GameObject *Sub)
{
	if (!Sub)
	{
		return;
	}
	Vector3 SubPos = Commands->Get_Position(Sub);
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = x->Data();
		if (o)
		{
			if (Commands->Is_A_Star(o))
			{
				if (ISUNDERWATER[Get_Player_ID(o)])
				{
					Create_Sound_Player(o,"SubPing",SubPos,Sub);
				}
			}
		}
		x = x->Next();
	}
}

void JMG_RP2_Special_Death_Control::Created(GameObject *obj)
{
	aco2 = 0;
	aco2reset = 0;
	unfreeze = 40;
	Commands->Start_Timer(obj,this,0.1f,6584256);
}

void JMG_RP2_Special_Death_Control::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damage)
	{
		if (Get_Vehicle(damager))
		{   
			damager = Get_Vehicle(damager);
			float dist = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(damager));
			if (dist < 15.0f && damage > 25.0f)
			{
				aco2 = 1;
				aco2reset = 3;
			}
		}
		else if (damage > 35 && !damager)
		{
			Commands->Create_Sound("Leg_Cracking_Sound",Commands->Get_Position(obj),obj);
		}
		if (Commands->Get_ID(damager) == 0 && damage > 10)
		{
			aco2 = 1;
			aco2reset = 3;
		}
		else
		{
			const char *wptr = Get_Current_Weapon(damager);
			if (wptr && damage > 10)// 10 to prevent dud trigger from burn, electric, or chem Special Damages
			{
				if (_stricmp(wptr,"Weapon_Liquid_Nitrogen") && _stricmp(wptr,"Weapon_Plasma_Torpedo_Launcher"))
				{
					if (!_stricmp(wptr,"Weapon_Barrett_M82") || 
					!_stricmp(wptr,"Weapon_Barrett_M82_Ai") || 
					!_stricmp(wptr,"Weapon_RPG-7") || 
					!_stricmp(wptr,"Weapon_M72_LAW") || 
					!_stricmp(wptr,"Weapon_FIM-92_Stinger") || 
					!_stricmp(wptr,"Weapon_Fragmentation_Grenade") || 
					!_stricmp(wptr,"Weapon_M203_Grenade_Launcher") || 
					!_stricmp(wptr,"Weapon_M32_Multiple_Grenade_Launcher") || 
					!_stricmp(wptr,"Weapon_Apache_Longbow_Hellfire_Missiles") || 
					!_stricmp(wptr,"Weapon_Apache_Longbow_Hydra_Rockets") || 
					!_stricmp(wptr,"Weapon_Comanche") || 
					!_stricmp(wptr,"Weapon_Harrier") || 
					!_stricmp(wptr,"Weapon_Hydra") || 
					!_stricmp(wptr,"Weapon_Hind") || 
					!_stricmp(wptr,"Weapon_M109_Howitzer") || 
					!_stricmp(wptr,"Weapon_M1A1_Abrams") || 
					!_stricmp(wptr,"Weapon_Comanche") || 
					!_stricmp(wptr,"Weapon_Scud_Launcher") || 
					!_stricmp(wptr,"Weapon_T-80") || 
					!_stricmp(wptr,"Weapon_Hellfire_Turret") || 
					!_stricmp(wptr,"Weapon_Rocket_Launcher_Halo_Style") || 
					!_stricmp(wptr,"Weapon_Renhalo_Hover_Craft") ||
					!_stricmp(wptr,"Weapon_Shore_Cannon"))
					{
						aco2 = 1;
						aco2reset = 3;
					}
				}
				if (!_stricmp(wptr,"Weapon_Shot_Gun_Jerad"))
				{
					aco2 = 1;
					aco2reset = 3;
				}
				if (!_stricmp(wptr,"Weapon_Renhalo_Hover_Craft"))// Standard Damage = 16 Head x 5 Neck x 3 Feet x 0.5 Missile 90 Min 65
				{
					if (damage == 16 || damage == 80 || damage == 48 || damage == 8)
					{
						aco2 = 2;
						aco2reset = 3;
					}
					else if (damage > 50)
					{
						aco2 = 1;
						aco2reset = 3;
					}
				}
				if (!_stricmp(wptr,"Weapon_Plasma_Torpedo_Launcher"))
				{
					aco2 = 2;
					aco2reset = 3;
				}
				if (!_stricmp(wptr,"Weapon_Liquid_Nitrogen"))
				{
					aco2 = 3;
					aco2reset = 3;
					unfreeze = 0;
					if (HoldID == 0)
					{
						GameObject *object = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
						Commands->Set_Model(object,"null");
						Commands->Attach_To_Object_Bone(obj,object,"none");
						HoldID = Commands->Get_ID(object);
					}
				}
			}
		}
	}
}

void JMG_RP2_Special_Death_Control::Killed(GameObject *obj,GameObject *damager)
{
	if (Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
	{
		aco2 = 1;
	}
	if (damager->As_VehicleGameObj())
	{
		if (!Get_Vehicle_Occupant_Count(damager) && Get_Vehicle_Seat_Count(damager))
		{
			aco2 = 1;
		}
	}
	if (aco2)
	{
		aco2reset = 100;
		Commands->Set_Model(obj,"infnc");
		Commands->Start_Timer(obj,this,0.01f,6584253);
	}
	if (aco2 == 1)
	{
		char splatter[512];
		sprintf(splatter,"bloodydeath%d",Commands->Get_Random_Int(0,6));
		Commands->Create_Explosion(splatter,Commands->Get_Position(obj),0);
	}
	else if (aco2 == 2)
	{
		Vector3 pos = Commands->Get_Bone_Position(obj,"c pelvis");
		Commands->Create_Explosion("Zap_explosion",Commands->Get_Bone_Position(obj,"c head"),0);
		for (int x = 0;x < 5;x++)
		{
			pos = Commands->Get_Bone_Position(obj,"c pelvis");
			pos.X += Commands->Get_Random(-0.25,0.25);
			pos.Y += Commands->Get_Random(-0.25,0.25);
			pos.Z += Commands->Get_Random(-1.25,1.25);
			Commands->Create_Explosion("Zap_explosion",pos,0);
		}
	}
	else if (aco2 == 3)
	{
		Commands->Create_Explosion("Frozen_Death",Commands->Get_Position(obj),0);
	}
	if (HoldID > 0)
	{
		GameObject *object = Commands->Find_Object(HoldID);
		if (Commands->Get_Health(object) > 0)
		{
			Commands->Destroy_Object(object);
		}
	}
}

void JMG_RP2_Special_Death_Control::Timer_Expired(GameObject *obj,int number)
{
	if (6584253 == number)
	{
		Commands->Set_Model(obj,"infnc");
		if (aco2 == 1)
		{
			Set_Fog_Enable_Player(obj,1);
			Set_Fog_Range_Player(obj,10.0f,50.0f,0.1f);
			Set_Screen_Fade_Color_Player(obj,0.45f,0,0,0.1f);
			Set_Screen_Fade_Opacity_Player(obj,0.85f,0.0);
			Set_Screen_Fade_Opacity_Player(obj,0.9f,1);
		}
		if (aco2 == 2)
		{
			Set_Fog_Enable_Player(obj,1);
			Set_Fog_Range_Player(obj,10.0f,50.0f,0.1f);
			Set_Screen_Fade_Opacity_Player(obj,0.95f,0.1f);
			Commands->Start_Timer(obj,this,0.1f,6584257);
		}
		if (aco2 == 3)
		{
			Set_Fog_Enable_Player(obj,1);
			Set_Fog_Range_Player(obj,10.0f,50.0f,0.1f);
			Set_Screen_Fade_Color_Player(obj,0.74f,0.84f,1,0.1f);
			Set_Screen_Fade_Opacity_Player(obj,0.9f,0.1f);
		}
	}
	if (6584254 == number)
	{
		Commands->Set_Animation(obj,"s_a_human.h_a_635a",false,0,0,28,false);
		if (Commands->Get_Health(obj) > 0.0f)
		{
			Commands->Start_Timer(obj,this,0.93f,6584255);
		}
	}
	if (6584255 == number)
	{
		int rand = Commands->Get_Random_Int(0,100);
		if (rand >= 50)
		{
			Commands->Set_Animation(obj,"s_a_human.h_a_h12c",false,0,0,100,false);
		}
		else
		{
			Commands->Set_Animation(obj,"s_a_human.h_a_h13c",false,0,0,90,false);
		}
	}
	if (6584256 == number && Commands->Get_Health(obj))
	{
		if (aco2reset > 0)
		{
			aco2reset--;
			if (aco2reset <= 0)
			{
				aco2 = 0;
			}
		}
		if (unfreeze < 30)
		{
			unfreeze++;
			if (unfreeze >= 30 && HoldID > 0)
			{
				GameObject *object = Commands->Find_Object(HoldID);
				if (Commands->Get_Health(object) > 0)
				{
					Commands->Destroy_Object(object);
				}
				HoldID = 0;
			}
		}
		Commands->Start_Timer(obj,this,0.1f,6584256);
	}
	if (6584257 == number)
	{
		float Red = Commands->Get_Random(0.5,1.0);
		Set_Screen_Fade_Opacity_Player(obj,Commands->Get_Random(0.25,1.0),0.0);
		Set_Screen_Fade_Color_Player(obj,Red,1,1,0.0);
		Commands->Start_Timer(obj,this,Commands->Get_Random(0.01f,0.1f),6584257);
	}
}

void JMG_RP2_Phone_Kill_Sender_Player::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		char DeathMSG[237];
		const char *str = Get_Player_Name(obj);
		sprintf(DeathMSG,"%s committed suicide.",str);
		delete[] str;
		RP2_Player_Death_Message_Control(obj,DeathMSG,0);
		Commands->Apply_Damage(Get_GameObj(param),99999.9f,"blamokiller",0);
	}
}

void JMG_RP2_House_Key_Control::Created(GameObject *obj)
{
	//JeradTrace("JMG_RP2_House_Key_Control");
	int CanWriteOutput = 1;
	FILE *FileHouse;
	FileHouse = fopen("Data/RolePlay2/BetaHouseControl.RP2","r");
	time_t secs=time(0);
	tm *t=localtime(&secs);
	int timeyear = t->tm_year;
	int timeday = t->tm_yday;
	if (FileHouse)
	{
		char FirstLine[2000];
		sprintf(FirstLine,"");
		fread(FirstLine,2000,1,FileHouse);
		if (strlen(FirstLine) < 1)
		{
			CanWriteOutput = 0;
		}
		rewind (FileHouse);
		while (!feof(FileHouse))
		{
			char OwnerName[256],Safty;
			int HouseNumber = 0,HouseDay = 0,HouseYear = 0,NumberOfPrePays = 0,RentTime = 0;
			fscanf(FileHouse,"%d %d %d %d %d%c\n",&HouseNumber,&NumberOfPrePays,&RentTime,&HouseYear,&HouseDay,&Safty);
			if (Safty == ';')
			{
				char TempOwnerName[256];
				fread(TempOwnerName,256,1,FileHouse);
				int loops = strlen(TempOwnerName),x = 0;
				while (x < loops)
				{
					if (TempOwnerName[x] != '\n')
					{
						OwnerName[x] = TempOwnerName[x];
					}
					else
					{
						OwnerName[x] = '\0';
					}
					x++;
				}
				fscanf(FileHouse,"\n");
				if (timeyear == HouseYear && timeday < HouseDay + RentTime)
				{
					AddUpdateHouseNode(OwnerName,HouseNumber,NumberOfPrePays,RentTime,HouseYear,HouseDay);
				}
				else
				{
					if (NumberOfPrePays > 1)
					{
						NumberOfPrePays--;
						AddUpdateHouseNode(OwnerName,HouseNumber,NumberOfPrePays,RentTime,timeyear,timeday);
					}
				}
			}
			else
			{
				fread(OwnerName,256,1,FileHouse);
				fscanf(FileHouse,"\n");
			}
		}
		fclose(FileHouse);
		Commands->Send_Custom_Event(obj,obj,654654,1,1.5f);
	}
	else
	{
		Console_Input("MESSAGE Warning: Primary House Control File not found! File Has been automatically created...");
		FILE *hfile;
		hfile = fopen("Data/RolePlay2/BetaHouseControl.RP2","w");
		fprintf(hfile,"");
		fflush(hfile);
		fclose(hfile);
	}
	//JeradTrace("Complete - JMG_RP2_House_Key_Control");
}

void JMG_RP2_House_Key_Control::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 654654)
	{
		if (RP2NewHouseSystemNode)
		{
			RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
			while (Current != NULL)
			{
				if (Current->IsOwned)
				{
					Commands->Send_Custom_Event(obj,Commands->Find_Object(Current->ControllerID),5814113,1,0);
				}
				Current = Current->next;
			}
		}
	}
}

void JMG_RP2_House_Key_Control::AddUpdateHouseNode(const char *OwnerName,int HouseNumber,int NumberOfPrePays,int RentTime,int HouseYear,int HouseDay)
{
	RP2NewHouseSystemControl *HouseNode = Add_Or_Update_Housing_Node(HouseNumber);
	if (HouseNode)
	{
		if (!HouseNode->IsOwned)
		{
			sprintf(HouseNode->PlayerName,"%s",OwnerName);
			HouseNode->IsOwned = 1;
		}
		HouseNode->RentTime = RentTime;
		HouseNode->HouseYear = HouseYear;
		HouseNode->HouseDay = HouseDay;
		HouseNode->NumberOfPrePays = NumberOfPrePays;
	}
}

void JMG_RP2_Grant_House_Keys_On_Spawn::Created(GameObject *obj)
{
	if (Commands->Is_A_Star(obj) && RP2NewHouseSystemNode)
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(obj)])
		{
			return;
		}
		char PName[256];
		const char *str = Get_Player_Name(obj);
		sprintf(PName,"%s",str);
		delete[] str;
		int end = 0;
		RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
		while (Current != NULL && !end)
		{
			if (!_stricmp(Current->PlayerName,PName))
			{
				end = 1;
				char Text[2000];
				sprintf(Text,"I have a key to my house at address %d.",Current->HouseAddress);
				Send_Message_Player(obj,160,127,50,Text);
				Commands->Grant_Key(obj,Current->HouseAddress,1);
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Open_Door_On_Poke_And_Key::Created(GameObject *obj)
{
	enabled = 0;
}

void JMG_RP2_Open_Door_On_Poke_And_Key::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Has_Key(poker,Get_Int_Parameter("Key")) && !Commands->Has_Key(poker,(0-Get_Int_Parameter("Key"))) && enabled == 0)
	{
		enabled = 1;
		char DoorAnim[2000];
		sprintf(DoorAnim,"%s.%s",Get_Model(obj),Get_Model(obj));
		Commands->Set_Animation(obj,DoorAnim,false,0,0,Get_Float_Parameter("Last_Frame"),false);
		if (_stricmp(Get_Parameter("Open_Sound"),"null"))
		{
			Commands->Create_Sound(Get_Parameter("Open_Sound"),Commands->Get_Position(obj),obj);
		}
		if (_stricmp(Get_Parameter("Explosion"),"null"))
		{
			Commands->Create_Explosion(Get_Parameter("Explosion"),Commands->Get_Position(obj),0);
		}
		Commands->Disable_Physical_Collisions(obj);
	}
}

void JMG_RP2_Open_Door_On_Poke_And_Key::Timer_Expired(GameObject *obj,int number)
{
	if (Get_Int_Parameter("Key") == number && enabled == 2)
	{
		enabled = 3;
		char DoorAnim[2000];
		sprintf(DoorAnim,"%s.%s",Get_Model(obj),Get_Model(obj));
		Commands->Set_Animation(obj,DoorAnim,false,0,Get_Float_Parameter("Last_Frame"),0,false);
		if (_stricmp(Get_Parameter("Close_Sound"),"null"))
		{
			Commands->Create_Sound(Get_Parameter("Close_Sound"),Commands->Get_Position(obj),obj);
		}
		Commands->Enable_Collisions(obj);
	}
} 

void JMG_RP2_Open_Door_On_Poke_And_Key::Animation_Complete(GameObject *obj,const char *anim)
{
	if (enabled == 1)
	{
		enabled = 2;
		if (Get_Float_Parameter("Stay_Open_Time") > 0)
		{
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Stay_Open_Time"),Get_Int_Parameter("Key"));
		}
	}
	else if (enabled == 3)
	{
		enabled = 0;
	}
}

void JMG_RP2_House_Address_Controller::Created(GameObject *obj)
{
	//JeradTrace("JMG_RP2_House_Address_Controller");
	char Animation[1000];
	sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
	Commands->Set_Animation(obj,Animation,true,0,0,0,1);
	HouseNode = Add_Or_Update_Housing_Node(Get_Int_Parameter("HouseAddress"));
	if (HouseNode)
	{
		HouseNode->ControllerID = Commands->Get_ID(obj);
		HouseNode->RentPrice = Get_Int_Parameter("Cost");
		HouseNode->RentTime = Get_Int_Parameter("RentTime");
	}
	//JeradTrace("Complete - JMG_RP2_House_Address_Controller");
}

void JMG_RP2_House_Address_Controller::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 5814112)
	{
		time_t secs=time(0);
		tm *t=localtime(&secs);
		int timeyear = t->tm_year;
		int timeday = t->tm_yday;
		if (HouseNode)
		{
			if (!HouseNode->IsOwned)
			{
				const char *str = Get_Player_Name(sender);
				sprintf(HouseNode->PlayerName,"%s",str);
				delete[] str;
				HouseNode->IsOwned = 1;
			}
			HouseNode->NumberOfPrePays++;
			HouseNode->HouseYear = timeyear;
			HouseNode->HouseDay = timeday;
		}
		char Animation[1000];
		sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
		Commands->Set_Animation(obj,Animation,true,0,1,1,1);
	}
	if (message == 5814113)
	{
		Commands->Disable_All_Collisions(obj);
		char Animation[1000];
		sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
		Commands->Set_Animation(obj,Animation,true,0,1,1,1);
	}
	if (message == 5814114)
	{
		Commands->Enable_Collisions(obj);
		char Animation[1000];
		sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
		Commands->Set_Animation(obj,Animation,true,0,0,0,1);
	}
}

void JMG_RP2_Phone_House_Phone_Number_Control_System::Created(GameObject *obj)
{
	sprintf(PhoneNumberMessage,"null");
	char TempNumber[256];
	const char *PhoneNumber = Get_Parameter("Phone_Number");
	sprintf(TempNumber,"");
	int x = 0,x2 = 0;
	int length = strlen(PhoneNumber);
	while (x2 < length)
	{
		if (x == 3)
		{
			TempNumber[x] = '-';
			x++;
		}
		TempNumber[x] = PhoneNumber[x2];
		x++;
		x2++;
	}
	sprintf(PhoneNumberMessage,"%s - Local Real Estate Agency",TempNumber);
}

void JMG_RP2_Phone_House_Phone_Number_Control_System::Custom(GameObject *obj,int message,int param,GameObject *sender)
{	
	if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							sprintf(Current->PhoneNumber,"%s - %s",Current->PhoneNumber,PhoneNumberMessage);
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && param == 2)
	{
		Send_Message_Player(sender,127,255,0,PhoneNumberMessage);
	}
	if (message == PHONECallStartCustom && param == 0)
	{							
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							if (!Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")))
							{
								GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
								GLOBALPHONETIMES[PlayerID] = 0;
								Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Script_ID"),Get_Player_ID(sender),(Get_Float_Parameter("Pickup_Delay")+Commands->Get_Random(0.0f,Get_Float_Parameter("Max_Random_Pickup_Delay"))));
							}
							else
							{
								for (int x = 1;x < 128;x++)
								{
									if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
									{
										GameObject *Player = Get_GameObj(x);
										Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
									}
								}
								Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
							}
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == Get_Int_Parameter("Script_ID"))
	{
		GameObject *player = Get_GameObj(param);
		Send_Message_Player(player,127,255,0,"Hello, and thank you for calling the automated house rental services, please enter the house address and press pound now.");
		Commands->Send_Custom_Event(obj,player,PHONENumberRequiresAdditionalNumberAndPound,Get_Int_Parameter("Script_ID"),0);// make it await pound
	}
	if (message == PHONECallStartCustom && param == Get_Int_Parameter("Script_ID"))
	{
		int end = 0;
		if (PhoneNumbers)
		{
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					HouseAddress = atoi(Current->PhonePound);
					end = 1;
				}
				Current = Current->next;
			}
		}	
		if (RP2NewHouseSystemNode)
		{
			int OwnedHouses = 0;
			char PlayerName[256];
			const char *str = Get_Player_Name(sender);
			sprintf(PlayerName,"%s",str);
			delete[] str;
			// Count houses you own
			RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
			while (Current != NULL)
			{
				if (!_stricmp(PlayerName,Current->PlayerName))
				{
					if (Current->HouseAddress != HouseAddress)
					{
						OwnedHouses++;
					}
				}
				Current = Current->next;
			}
			if (OwnedHouses)
			{
				Send_Message_Player(sender,127,255,0,"Sorry, but during this time we are only selling 1 house to each resident.");
				AutoCancelCall(obj,sender);
			}
			else
			{
				end = 0;
				CurHouse = Find_Housing_Node(HouseAddress);
				if (CurHouse)
				{
					if (CurHouse->NumberOfPrePays >= 2)
					{
						Send_Message_Player(sender,127,255,0,"Sorry, but our current policy does not allow you to pay rent more than two weeks in advance.");
						AutoCancelCall(obj,sender);
						return;
					}
					char confmes[237];
					if (!CurHouse->IsOwned){sprintf(confmes,"Would you like to rent the house at address %d for %d days, it will cost %d credits. ([1]yes [2]no)",CurHouse->HouseAddress,CurHouse->RentTime,CurHouse->RentPrice);}
					else{sprintf(confmes,"The house at address %d is already owned, if you would like you can increase its rent time of its current owner by %d days, doing so will cost you %d credits. ([1]yes [2]no)",CurHouse->HouseAddress,CurHouse->RentTime,CurHouse->RentPrice);}
					Send_Message_Player(sender,127,255,0,confmes);
					Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
					Commands->Send_Custom_Event(obj,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);// Start Timer
				}
				else
				{
					char confmes[2000];
					sprintf(confmes,"Sorry, but there is no house available for renting in our records that matches the address of %d. Have a nice day.",HouseAddress);
					Send_Message_Player(sender,127,255,0,confmes);
					AutoCancelCall(obj,sender);
				}
			}
		}
	}
	if (message == PHONENumberEndCallMessage && param == Get_Int_Parameter("Script_ID"))
	{
		int PlayerID = Get_Player_ID(sender);
		if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
		{
			GLOBALPHONELINES[PlayerID] = 0;
			GLOBALPHONETIMES[PlayerID] = 0;
		}
	}
	if (message == PHONESpecial1Key && param == Get_Int_Parameter("Script_ID"))
	{
		int PlayerID = Get_Player_ID(sender);
		if (Commands->Get_Money(sender) >= CurHouse->RentPrice)
		{
			if (CurHouse->IsOwned == 0)
			{
				Commands->Grant_Key(sender,CurHouse->HouseAddress,1);
			}
			Commands->Give_Money(sender,-(float)CurHouse->RentPrice,1);
			Send_Message_Player(sender,127,255,0,"Thank you, your purchase was successful!");
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
			Commands->Send_Custom_Event(sender,Commands->Find_Object(CurHouse->ControllerID),5814112,PlayerID,0);// player buys house, custom is sent to the controller
		}
		else
		{
			Send_Message_Player(sender,127,255,0,"It seems the funds on your card are inadequate. Sorry, but have a nice day.");
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
		}
	}
	if (message == PHONESpecial2Key && param == Get_Int_Parameter("Script_ID"))
	{
		Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
		Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
	}
	if (message == PHONENumberCallTimeMonitor && param == Get_Int_Parameter("Script_ID"))
	{
		ChargeForCall(obj);
	}
}

void JMG_RP2_Phone_House_Phone_Number_Control_System::AutoCancelCall(GameObject *obj,GameObject *player)
{
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}

void JMG_RP2_Phone_House_Phone_Number_Control_System::ChargeForCall(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
		{
			GameObject *Player = Get_GameObj(x);
			int CallTime = GLOBALPHONETIMES[x]++;
			if (Commands->Get_Health(Player) > 0)
			{
				int chargepersec = Get_Int_Parameter("Charge_Per_Second");
				if (Get_Int_Parameter("Max_Call_Duration") < CallTime)
				{
					AutoCancelCall(obj,Player);
				}
				else if (CallTime % 60 == 0)
				{
					int totalcharge = (chargepersec + Get_Int_Parameter("Charge_Per_Minute"));
					if (Commands->Get_Money(Player) >= totalcharge)
					{
						Commands->Give_Money(Player,-(float)totalcharge,1);
					}
					else
					{
						Send_Message_Player(Player,127,255,0,"Signal Lost");
						AutoCancelCall(obj,Player);
					}
				}
				else if (Commands->Get_Money(Player) >= chargepersec)
				{
					Commands->Give_Money(Player,-(float)chargepersec,1);
				}
				else
				{
					Send_Message_Player(Player,127,255,0,"Signal Lost");
					AutoCancelCall(obj,Player);
				}
			}
			else
			{
				Commands->Send_Custom_Event(Player,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
			}
			Commands->Send_Custom_Event(Player,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);
		}
	}
}

void JMG_RP2_RailRoad_Crossing_Control_Zone::Created(GameObject *obj)
{
	GateState = 2; // Gate Open
	TrainsInZone = 0;
	SoundID = 0;
	for (int x = 0;x < 128;x++)
	{
		TrainID[x] = 0;
	}
	GameObject *Crossing = Commands->Find_Object(Get_Int_Parameter("CrossingID"));
	sprintf(GateAnimation,"%s.%s",Get_Model(Crossing),Get_Model(Crossing));
	if (!Crossing)
	{
		char Error[2000];
		sprintf(Error,"MESSAGE ERROR: JMG_RP2_Rail_Road_Crossing_Control script on zone ID:%d was unable to find crossing gate ID:%d, script has auto removed.",Commands->Get_ID(obj),Get_Int_Parameter("CrossingID"));
		Console_Input(Error);
		Remove_Script(obj,"JMG_RP2_Rail_Road_Crossing_Control");
	}
	else
	{
		Commands->Set_Animation(Crossing,GateAnimation,false,0,Get_Float_Parameter("CrossingOpenFirstFrame"),Get_Float_Parameter("CrossingOpenLastFrame"),0);
		Commands->Start_Timer(obj,this,0.25f,911);
	}
}

void JMG_RP2_RailRoad_Crossing_Control_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (!_stricmp(Commands->Get_Preset_Name(enter),Get_Parameter("TrainPresetName")))
	{
		for (int x = 0,end = 0;x < 128 && end == 0;x++)
		{
			if (Commands->Get_ID(enter) == TrainID[x])
			{
				end = 1;
			}
			else if (TrainID[x] == 0)
			{
				TrainID[x] = Commands->Get_ID(enter);
				TrainsInZone++;
				end = 1;
			}
		}
	}
}

void JMG_RP2_RailRoad_Crossing_Control_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (!_stricmp(Commands->Get_Preset_Name(exit),Get_Parameter("TrainPresetName")))
	{
		for (int x = 0,end = 0;x < 128 && end == 0;x++)
		{
			if (Commands->Get_ID(exit) == TrainID[x])
			{
				TrainID[x] = 0;
				TrainsInZone--;
				end = 1;
			}
		}
	}
}

void JMG_RP2_RailRoad_Crossing_Control_Zone::Timer_Expired(GameObject *obj,int number)
{
	if (number == 911)
	{
		if (TrainsInZone > 0)
		{
			for (int x = 0;x < 128;x++)
			{
				if (TrainID[x] != 0)
				{
					GameObject *Zoner = Commands->Find_Object(TrainID[x]);
					if (Zoner)
					{
						if (!IsInsideZone(obj,Zoner))
						{
							TrainID[x] = 0;
							TrainsInZone--;
						}
					}
					else
					{
						TrainID[x] = 0;
						TrainsInZone--;
					}
				}
			}
		}
		GameObject *Gate = Commands->Find_Object(Get_Int_Parameter("CrossingID"));
		if (Gate)
		{
			float CurrentFrame = Get_Animation_Frame(Gate);
			// OPEN = 2 OPENING = 1 CLOSED = -2 CLOSING = -1
			// Special Loopers
			if (GateState == -1 && CurrentFrame == Get_Float_Parameter("CrossingClosingLastFrame"))
			{		
				GateState = -2;//Gate Closed Loop
				Commands->Set_Animation(Gate,GateAnimation,false,0,Get_Float_Parameter("CrossingClosedFirstFrame"),Get_Float_Parameter("CrossingClosedLastFrame"),0);
			}
			else if (GateState == 1 && CurrentFrame == Get_Float_Parameter("CrossingOpeningLastFrame"))
			{		
				GateState = 2;// Gate Open Loop
				Commands->Set_Animation(Gate,GateAnimation,false,0,Get_Float_Parameter("CrossingOpenFirstFrame"),Get_Float_Parameter("CrossingOpenLastFrame"),0);
			}
			else if (TrainsInZone > 0)
			{
				if (GateState == 2)// GateState != 1 && GateState != -2 && GateState != -1
				{
					GateState = -1;// Gate Closing
					if (!SoundID)
					{
						GameObject *Sound = Commands->Create_Object("Daves_Arrow_NT",Commands->Get_Position(obj));
						Commands->Set_Model(Sound,"RRcrossing");
						SoundID = Commands->Get_ID(Sound);
					}
					Commands->Set_Animation(Gate,GateAnimation,false,0,Get_Float_Parameter("CrossingClosingFirstFrame"),Get_Float_Parameter("CrossingClosingLastFrame"),0);
				}
				if (GateState == -2 && CurrentFrame == Get_Float_Parameter("CrossingClosedLastFrame"))// Gate Closed Loop
				{		
					Commands->Set_Animation(Gate,GateAnimation,false,0,Get_Float_Parameter("CrossingClosedFirstFrame"),Get_Float_Parameter("CrossingClosedLastFrame"),0);
				}
			}
			else 
			{
				if (GateState == -2)// GateState != -2 && GateState != 1 && GateState != 2
				{		
					GateState = 1;// Gate Open
					Commands->Set_Animation(Gate,GateAnimation,false,0,Get_Float_Parameter("CrossingOpeningFirstFrame"),Get_Float_Parameter("CrossingOpeningLastFrame"),0);
					if (SoundID)
					{
						GameObject *Sound = Commands->Find_Object(SoundID);
						if (Sound)
						{
							Commands->Destroy_Object(Sound);
						}
						SoundID = 0;
					}
				}
				if (GateState == 2 && CurrentFrame == Get_Float_Parameter("CrossingOpenLastFrame"))// Gate Open Loop
				{
					Commands->Set_Animation(Gate,GateAnimation,false,0,Get_Float_Parameter("CrossingOpenFirstFrame"),Get_Float_Parameter("CrossingOpenLastFrame"),0);
				}
			}
			Commands->Start_Timer(obj,this,0.25f,911);
		}
	}
}

void JMG_RP2_Street_Sign_Crushable::Created(GameObject *obj)
{
	Vector3 pos = Commands->Get_Position(obj);
	GameObject *Sign = Commands->Create_Object("Sign_Shadow",pos);
	SignID = Commands->Get_ID(Sign);
	Commands->Set_Model(Sign,Get_Model(obj));

	GameObject *SignHolder = Commands->Create_Object("Daves_Arrow_NT",pos);
	Commands->Set_Facing(SignHolder,Commands->Get_Facing(obj));
	Commands->Set_Model(SignHolder,"SignTipOver0");
	Commands->Attach_To_Object_Bone(Sign,SignHolder,"SignBone");
	SignControllerID = Commands->Get_ID(SignHolder);

	pos.Z -= 0.1f;
	Commands->Set_Model(obj,"HumanPole");
	Commands->Set_Position(obj,pos);
}

void JMG_RP2_Street_Sign_Crushable::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Commands->Get_Health(obj))
	{
		Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
		Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
	}
}

void JMG_RP2_Street_Sign_Crushable::Killed(GameObject *obj,GameObject *damager)
{
	GameObject *SignControl = Commands->Find_Object(SignControllerID);
	if (_stricmp(Get_Parameter("Knock_Over_Sound"),"null"))
	{
		Commands->Create_Sound(Get_Parameter("Knock_Over_Sound"),Commands->Get_Position(obj),obj);
	}
	if (Get_Vehicle(damager))
	{
		damager = Get_Vehicle(damager);
	}
	Vector3 Movement = Commands->Get_Position(obj);
	Vector3 pos = Commands->Get_Position(damager);
	float Distance = Commands->Get_Distance(Movement,pos);
	if (Distance > 0.0f && Distance != abs(Movement.Z - pos.Z))
	{
		Movement.X -= pos.X;
		Movement.Y -= pos.Y;
		float TempRotation = atan2(Movement.Y,Movement.X) * 180 / PI;
		Commands->Set_Facing(SignControl,TempRotation);
	}
	if (Commands->Get_Random_Int(0,100) > 50)
	{
		Commands->Set_Animation(SignControl,"SignTipOver0.SignTipOver0",true,0,0,4,0);
	}
	else
	{
		Commands->Set_Animation(SignControl,"SignTipOver1.SignTipOver1",true,0,0,4,0);
	}
	if (Get_Float_Parameter("Debris_Life_Time") > 0.0f)
	{
		char param[2000];
		sprintf(param,"%f",Get_Float_Parameter("Debris_Life_Time"));
		Attach_Script_Once(Commands->Find_Object(SignID),"JMG_Remove_Self_On_Timer",param);
		Attach_Script_Once(SignControl,"JMG_Remove_Self_On_Timer",param);
	}
}

void JMG_RP2_Phone_Create_Test_Object::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message") && Commands->Get_Health(sender))
	{
		/*Vector3 Pos;
		Pos.X = -982.92;
		Pos.Y = -285.51;
		Pos.Z = -3.65;//*/
		Vector3 Position = Commands->Get_Position(sender);
		Position.Z += 25.0f;
		GameObject *Object = Commands->Create_Object("Mad_Cat",Position);
		Commands->Attach_Script(Object,"JMG_RP2_Disallow_Favorite_Vehicle","");
		Commands->Enable_Engine(Object,false);
	}
}

void JMG_RP2_Node_Cleanup::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,5.0f,955551);
}

void JMG_RP2_Node_Cleanup::Timer_Expired(GameObject *obj,int number)
{
	if (955551 == number)
	{
		if (The_Game()->Is_Game_Over())
		{
			/*NCU*///JeradTrace("Start");
			/*NCU*///JeradTrace("PhoneNumbers");
			if (PhoneNumbers)
			{
				PhoneNumberControl *temp,*die;
				temp = PhoneNumbers;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				PhoneNumbers = NULL;
			}
			/*NCU*///JeradTrace("CellPhoneNumberNode");
			if (CellPhoneNumberNode)
			{
				CellPhoneNumberControl *temp,*die;
				temp = CellPhoneNumberNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				CellPhoneNumberNode = NULL;
			}
			/*NCU*///JeradTrace("PlayerRedialNumberNode");
			if (PlayerRedialNumberNode)
			{
				FILE *RewriteFileRedial;
				RewriteFileRedial = fopen("Data/RolePlay2/PhoneRedialNumbers.tmp","w");
				fflush(RewriteFileRedial);
				PlayerRedialNumberControl *Current = PlayerRedialNumberNode;
				while (Current != NULL)
				{
					fprintf(RewriteFileRedial,"[*]\n%s\n%d,%d,%d,%d,%d,%d,%d,%d,%d,%d;\n",Current->PlayerName,Current->NumberLength[0],Current->NumberLength[1],Current->NumberLength[2],Current->NumberLength[3],Current->NumberLength[4],Current->NumberLength[5],Current->NumberLength[6],Current->NumberLength[7],Current->NumberLength[8],Current->NumberLength[9]);
					fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber0);
					fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber1);
					fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber2);
					fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber3);
					fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber4);
					fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber5);
					fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber6);
					fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber7);
					fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber8);
					fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber9);
					fflush(RewriteFileRedial);
					Current = Current->next;
				}
				fclose(RewriteFileRedial);
				remove("Data/RolePlay2/BetaPhoneRedialNumbers.RP2");
				rename("Data/RolePlay2/PhoneRedialNumbers.tmp","Data/RolePlay2/BetaPhoneRedialNumbers.RP2");
				PlayerRedialNumberControl *temp,*die;
				temp = PlayerRedialNumberNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				PlayerRedialNumberNode = NULL;
			}
			/*NCU*///JeradTrace("RP2PhoneMissionNode");
			if (RP2PhoneMissionNode)
			{
				RP2PhoneMissionControl *temp,*die;
				temp = RP2PhoneMissionNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				RP2PhoneMissionNode = NULL;
			}
			/*NCU*///JeradTrace("RP2PlayerBankAccountNode");
			if (RP2PlayerBankAccountNode)
			{
				FILE *RP2BAS;
				RP2BAS = fopen("Data/RolePlay2/PlayerBankAccounts.tmp","w");
				RP2PlayerBankAccountControl *temp,*die;
				temp = RP2PlayerBankAccountNode;
				int Total = 0;
				int Number = 1;
				int SNumber;
				while (temp != NULL)
				{
					if ((int)temp->AccountBalance)
					{
						fprintf(RP2BAS,"[*]\n%s\n",temp->PlayerName);
						Number++;
						Total += (int)temp->AccountBalance;
						SNumber = Total;
						while (SNumber > 10)
						{
							SNumber -= 9;
						}
						fprintf(RP2BAS,"%d %d %d %d %d %d\n",(Total/Number)+SNumber,(Total*SNumber)+Number,(((Total/(Number+1))*Number)+(SNumber*Number)),(int)temp->AccountBalance,(((int)temp->AccountBalance/SNumber)+(SNumber*Number)),SNumber);
					}
					die = temp;
					temp = temp->next;
					delete die;
				}
				fclose(RP2BAS);
				remove("Data/RolePlay2/BetaPlayerBankAccounts.RP2");
				rename("Data/RolePlay2/PlayerBankAccounts.tmp","Data/RolePlay2/BetaPlayerBankAccounts.RP2");
				RP2PlayerBankAccountNode = NULL;
			}
			/*NCU*///JeradTrace("SwimmingWaterZoneTypeNode");
			if (SwimmingWaterZoneTypeNode)
			{
				SwimmingWaterZoneTypeControl *temp,*die;
				temp = SwimmingWaterZoneTypeNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				SwimmingWaterZoneTypeNode = NULL;
			}
			/*NCU*///JeradTrace("SwimmingAnimationTypeNode");
			if (SwimmingAnimationTypeNode)
			{
				SwimmingAnimationTypeControl *temp,*die;
				temp = SwimmingAnimationTypeNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				SwimmingAnimationTypeNode = NULL;
			}
			/*NCU*///JeradTrace("RP2VehicleNode");
			if (RP2VehicleNode)
			{
				RP2VehicleControl *temp,*die;
				temp = RP2VehicleNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				RP2VehicleNode = NULL;
			}
			/*NCU*///JeradTrace("SwimmingScubaGearNode");
			if (SwimmingScubaGearNode)
			{
				SwimmingScubaGearControl *temp,*die;
				temp = SwimmingScubaGearNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				SwimmingScubaGearNode = NULL;
			}
			/*NCU*///JeradTrace("RP2NewHouseSystemNode");
			if (RP2NewHouseSystemNode)
			{
				RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
				FILE *FileHouse;
				FileHouse = fopen("Data/RolePlay2/HouseControl.tmp","w");
				fflush(FileHouse);
				while (Current != NULL)
				{
					if (Current->IsOwned)
					{
						fprintf(FileHouse,"%d %d %d %d %d;\n%s\n",Current->HouseAddress,Current->NumberOfPrePays,Current->RentTime,Current->HouseYear,Current->HouseDay,Current->PlayerName);
						fflush(FileHouse);
					}
					Current = Current->next;
				}
				fclose(FileHouse);
				remove("Data/RolePlay2/BetaHouseControl.RP2");
				rename("Data/RolePlay2/HouseControl.tmp","Data/RolePlay2/BetaHouseControl.RP2");
				if (RP2NewHouseSystemNode)
				{
					RP2NewHouseSystemControl *temp,*die;
					temp = RP2NewHouseSystemNode;
					while (temp != NULL)
					{
						die = temp;
						temp = temp->next;
						delete die;
					}
					RP2NewHouseSystemNode = NULL;
				}
			}
			/*NCU*///JeradTrace("WeaponCupboardNode");
			if (WeaponCupboardNode)
			{
				FILE *RewriteFileCupboard;
				RewriteFileCupboard = fopen("Data/RolePlay2/WeaponsCupboard.tmp","w");
				fflush(RewriteFileCupboard);
				WeaponCupboardControl *Current = WeaponCupboardNode;
				while (Current != NULL)
				{
					RP2WeaponListControl *Weapon = Get_WLS_Weapon_Settings(Current->Weapon);
					if (Weapon)
					{
						int EncryptFactor = (Current->ID%100);
						fprintf(RewriteFileCupboard,";%d;\n%s\n",Current->ID,Encrypt(Weapon->WeaponName,EncryptFactor,3));
						fflush(RewriteFileCupboard);
					}
					Current = Current->next;
				}
				fclose(RewriteFileCupboard);
				remove("Data/RolePlay2/BetaWeaponsCupboard.RP2");
				rename("Data/RolePlay2/WeaponsCupboard.tmp","Data/RolePlay2/BetaWeaponsCupboard.RP2");
				WeaponCupboardControl *temp,*die;
				temp = WeaponCupboardNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				WeaponCupboardNode = NULL;
			}
			/*NCU*///JeradTrace("PlayerHouseVehicleNode");
			if (PlayerHouseVehicleNode)
			{
				FILE *RewriteFileVehicle;
				RewriteFileVehicle = fopen("Data/RolePlay2/GarageVehicle.tmp","w");
				fflush(RewriteFileVehicle);
				PlayerHouseVehicleControl *Current = PlayerHouseVehicleNode;
				while (Current != NULL)
				{
					if (_stricmp(Current->VehiclePreset,"null"))
					{
						int EncryptFactor = (Current->House_Address%10);
						fprintf(RewriteFileVehicle,"%d\n%s\n%.2f %.2f %.2f\n%.2f\n",Current->House_Address,Encrypt(Current->VehiclePreset,EncryptFactor,3),Current->VehiclePosition.X,Current->VehiclePosition.Y,Current->VehiclePosition.Z,Current->VehicleFacing);
						fflush(RewriteFileVehicle);
					}
					Current = Current->next;
				}
				fclose(RewriteFileVehicle);
				remove("Data/RolePlay2/BetaGarageVehicle.RP2");
				rename("Data/RolePlay2/GarageVehicle.tmp","Data/RolePlay2/BetaGarageVehicle.RP2");
				PlayerHouseVehicleControl *temp,*die;
				temp = PlayerHouseVehicleNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				PlayerHouseVehicleNode = NULL;
			}
			/*NCU*///JeradTrace("RP2WeaponListNode");
			if (RP2WeaponListNode)
			{
				RP2WeaponListControl *temp,*die;
				temp = RP2WeaponListNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				RP2WeaponListNode = NULL;
			}
			/*NCU*///JeradTrace("RP2GiveObjectiveByCreationLocationNode");
			if (RP2GiveObjectiveByCreationLocationNode)
			{
				RP2GiveObjectiveByCreationLocationControl *temp,*die;
				temp = RP2GiveObjectiveByCreationLocationNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				RP2GiveObjectiveByCreationLocationNode = NULL;
			}
			/*NCU*///JeradTrace("RP2PlayerMissionsNode");
			if (RP2PlayerMissionsNode)
			{
				FILE *RP2PMS;
				RP2PMS = fopen("Data/RolePlay2/PlayerMissions.tmp","w");
				fflush(RP2PMS);
				RP2PlayerMissionsControl *temp,*die;
				temp = RP2PlayerMissionsNode;
				int Total = 0;
				int Number = 0;
				int SNumber;
				while (temp != NULL)
				{
					die = temp;
					Total = 0;
					Number = 0;

					RP2PlayerVehicleFailMissionControl *tempm1,*diem1;
					tempm1 = temp->AllVehicles;
					while (tempm1 != NULL)
					{
						diem1 = tempm1;
						tempm1 = tempm1->next;
						delete diem1;
					}
					temp->AllVehicles = NULL;
					tempm1 = temp->FailOnTrackedVehicle;
					while (tempm1 != NULL)
					{
						diem1 = tempm1;
						tempm1 = tempm1->next;
						delete diem1;
					}
					temp->FailOnTrackedVehicle = NULL;
					tempm1 = temp->FailOnWheeledVehicle;
					while (tempm1 != NULL)
					{
						diem1 = tempm1;
						tempm1 = tempm1->next;
						delete diem1;
					}
					temp->FailOnWheeledVehicle = NULL;
					tempm1 = temp->FailOnMotorcycle;
					while (tempm1 != NULL)
					{
						diem1 = tempm1;
						tempm1 = tempm1->next;
						delete diem1;
					}
					temp->FailOnMotorcycle = NULL;
					tempm1 = temp->FailOnAircraft;
					while (tempm1 != NULL)
					{
						diem1 = tempm1;
						tempm1 = tempm1->next;
						delete diem1;
					}
					temp->FailOnAircraft = NULL;
					tempm1 = temp->FailOnTurret;
					while (tempm1 != NULL)
					{
						diem1 = tempm1;
						tempm1 = tempm1->next;
						delete diem1;
					}
					temp->FailOnTurret = NULL;
					tempm1 = temp->FailOnBoat;
					while (tempm1 != NULL)
					{
						diem1 = tempm1;
						tempm1 = tempm1->next;
						delete diem1;
					}
					temp->FailOnBoat = NULL;
					RP2PlayerMissionConflicts *tempm3,*diem3;
					tempm3 = temp->MissionConflicts;
					while (tempm3 != NULL)
					{
						diem3 = tempm3;
						tempm3 = tempm3->next;
						delete diem3;
					}
					temp->MissionConflicts = NULL;
					fprintf(RP2PMS,"[*]\n%s\n",die->PlayerName);
					if (die->Mission)
					{
						MissionTypes *temp2,*die2;
						temp2 = die->Mission;
						while (temp2 != NULL)//Addem Up
						{
							die2 = temp2;
							if (die2->MissionCompleted && die2->RegrantOnNewgame)
							{
								Number++;
								Total += die2->MissionType;
							}
							temp2 = temp2->next;
						}
						SNumber = Number;
						while (SNumber > 10)
						{
							SNumber -= 9;
						}
						fprintf(RP2PMS,"%d %d %d %d ",Number,(Total/2),(Total*SNumber),Total);
						temp2 = die->Mission;
						while (temp2 != NULL)
						{
							die2 = temp2;
							if (die2->MissionCompleted && die2->RegrantOnNewgame)
							{
								fprintf(RP2PMS,"%d ",die2->MissionType);
							}
							if (die2->MissionDataPoints)
							{
								MissionObjectives *temp3,*die3;
								temp3 = die2->MissionDataPoints;
								while (temp3 != NULL)
								{
									die3 = temp3;
									temp3 = temp3->next;
									delete die3;
								}
							}
							temp2 = temp2->next;
							delete die2;
						}
						fprintf(RP2PMS,"\n");
					}
					else
					{
						fprintf(RP2PMS,"0 0 0 0 \n");
					}
					temp = temp->next;
					delete die;
				}
				fclose(RP2PMS);
				remove("Data/RolePlay2/BetaPlayerMissions.RP2");
				rename("Data/RolePlay2/PlayerMissions.tmp","Data/RolePlay2/BetaPlayerMissions.RP2");
				RP2PlayerMissionsNode = NULL;
			}
			/*NCU*///JeradTrace("RP2MissionObjectiveTypeNode");
			if (RP2MissionObjectiveTypeNode)
			{
				RP2MissionObjectiveTypeControl *temp,*die;
				temp = RP2MissionObjectiveTypeNode;
				while (temp != NULL)
				{
					die = temp;
					RP2PlayerVehicleFailMissionExceptionControl *temp2,*die2;
					temp2 = temp->VehicleExceptions;
					while (temp2 != NULL)
					{
						die2 = temp2;
						temp2 = temp2->next;
						delete die2;
					}
					RP2PlayerMissionConflicts *temp3,*die3;
					temp3 = temp->MissionConflicts;
					while (temp3 != NULL)
					{
						die3 = temp3;
						temp3 = temp3->next;
						delete die3;
					}
					RP2MissionObjectiveTypeNode = NULL;
					temp = temp->next;
					delete die;
				}
				RP2MissionObjectiveTypeNode = NULL;
			}
			/*NCU*///JeradTrace("RP2RandomTeleportPositionNode");
			if (RP2RandomTeleportPositionNode)
			{
				RP2RandomTeleportPositionControl *temp,*die;
				temp = RP2RandomTeleportPositionNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				RP2RandomTeleportPositionNode = NULL;
			}
			/*NCU*///JeradTrace("SCUD_Missile_Launcher_Node");
			if (SCUD_Missile_Launcher_Node)
			{
				SCUD_Missile_Launcher_Control *temp,*die;
				temp = SCUD_Missile_Launcher_Node;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				SCUD_Missile_Launcher_Node = NULL;
			}
			/*NCU*///JeradTrace("PlayerCellPhoneIDNode");
			if (PlayerCellPhoneIDNode)
			{
				PlayerCellPhoneIDControl *temp,*die;
				temp = PlayerCellPhoneIDNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				PlayerCellPhoneIDNode = NULL;
			}
			/*NCU*///JeradTrace("ObjectLimitNode[LOOP]");
			for (int x = 0;x < 128;x++)
			{
				if (ObjectLimitNode[x])
				{
					ObjectLimitControl *temp,*die;
					temp = ObjectLimitNode[x];
					while (temp != NULL)
					{
						die = temp;
						temp = temp->next;
						delete die;
					}
					ObjectLimitNode[x] = NULL;
				}
			}
			/*NCU*///JeradTrace("DroppedWeaponNode");
			if (DroppedWeaponNode)
			{
				DroppedWeaponControl *temp,*die;
				temp = DroppedWeaponNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				DroppedWeaponNode = NULL;
			}
			/*NCU*///JeradTrace("FishTypeNode");
			if (FishTypeNode)
			{
				FishTypeControl *temp,*die;
				temp = FishTypeNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				FishTypeNode = NULL;
			}
			/*NCU*///JeradTrace("FishSchoolNode");
			if (FishSchoolNode)
			{
				FishSchoolControl *temp,*die;
				temp = FishSchoolNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				FishSchoolNode = NULL;
			}
			/*NCU*///JeradTrace("PlayerSpecificPNNode");
			if (PlayerSpecificPNNode)
			{
				PlayerSpecificPNControl *temp,*die;
				temp = PlayerSpecificPNNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				PlayerSpecificPNNode = NULL;
			}
			/*NCU*///JeradTrace("PlayerFavoriteVehicleNode");
			if (PlayerFavoriteVehicleNode)
			{
				FILE *RewriteFileFavVehicle;
				RewriteFileFavVehicle = fopen("Data/RolePlay2/FavoriteVehicles.tmp","w");
				fflush(RewriteFileFavVehicle);
				PlayerFavoriteVehicleControl *Current = PlayerFavoriteVehicleNode;
				while (Current != NULL)
				{
					int EncryptFactor = Current->VehicleCost/10+1;
					fprintf(RewriteFileFavVehicle,"%d\n",Current->VehicleCost);
					fprintf(RewriteFileFavVehicle,"%s\n",Encrypt(Current->PlayerName,EncryptFactor,3));
					fprintf(RewriteFileFavVehicle,"%s\n",Encrypt(Current->VehiclePreset,EncryptFactor,4));
					fprintf(RewriteFileFavVehicle,"%s\n",Encrypt(Current->VehicleName,EncryptFactor,5));
					fflush(RewriteFileFavVehicle);
					Current = Current->next;
				}
				fclose(RewriteFileFavVehicle);
				remove("Data/RolePlay2/BetaFavoriteVehicles.RP2");
				rename("Data/RolePlay2/FavoriteVehicles.tmp","Data/RolePlay2/BetaFavoriteVehicles.RP2");
				PlayerFavoriteVehicleControl *temp,*die;
				temp = PlayerFavoriteVehicleNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				PlayerFavoriteVehicleNode = NULL;
			}
			/*NCU*///JeradTrace("RP2PlayerSAWTArray[LOOP]");
			for (int x = 0;x < 128;x++)
			{
				if (RP2PlayerSAWTArray[x])
				{
					RP2PlayerSAWTControl *temp,*die;
					temp = RP2PlayerSAWTArray[x];
					while (temp != NULL)
					{
						die = temp;
						temp = temp->next;
						delete die;
					}
					RP2PlayerSAWTArray[x] = NULL;
				}
			}
			/*NCU*///JeradTrace("PlayerFavoriteWeaponNode");
			if (PlayerFavoriteWeaponNode)
			{
				FILE *RewriteFileFavWeapon;
				RewriteFileFavWeapon = fopen("Data/RolePlay2/FavoriteWeapons.tmp","w");
				fflush(RewriteFileFavWeapon);
				PlayerFavoriteWeaponControl *Current = PlayerFavoriteWeaponNode;
				while (Current != NULL)
				{
					int EncryptFactor = Current->WeaponCost/10+1;
					fprintf(RewriteFileFavWeapon,"%d\n",Current->WeaponCost);
					fprintf(RewriteFileFavWeapon,"%s\n",Encrypt(Current->PlayerName,EncryptFactor,3));
					fprintf(RewriteFileFavWeapon,"%s\n",Encrypt(Current->WeaponPreset,EncryptFactor,4));
					fprintf(RewriteFileFavWeapon,"%s\n",Encrypt(Current->WeaponName,EncryptFactor,5));
					fflush(RewriteFileFavWeapon);
					Current = Current->next;
				}
				fclose(RewriteFileFavWeapon);
				remove("Data/RolePlay2/BetaFavoriteWeapons.RP2");
				rename("Data/RolePlay2/FavoriteWeapons.tmp","Data/RolePlay2/BetaFavoriteWeapons.RP2");
				PlayerFavoriteWeaponControl *temp,*die;
				temp = PlayerFavoriteWeaponNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				PlayerFavoriteWeaponNode = NULL;
			}
			/*NCU*///JeradTrace("WarthogNode");
			if (WarthogNode)
			{
				WarthogControl *temp,*die;
				temp = WarthogNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				WarthogNode = NULL;
			}
			if (PlayerCharacterNode)
			{
				FILE *FilePlayerCharacters;
				FilePlayerCharacters = fopen("Data/RolePlay2/PlayerCharacters.tmp","w");
				fflush(FilePlayerCharacters);
				PlayerCharacterControl *Current = PlayerCharacterNode;
				while (Current != NULL)
				{
					fprintf(FilePlayerCharacters,"%s\n",Current->PlayerName);
					fprintf(FilePlayerCharacters,"%s\n",Current->PresetName);
					fflush(FilePlayerCharacters);
					Current = Current->next;
				}
				fclose(FilePlayerCharacters);
				remove("Data/RolePlay2/BetaPlayerCharacters.RP2");
				rename("Data/RolePlay2/PlayerCharacters.tmp","Data/RolePlay2/BetaPlayerCharacters.RP2");
				PlayerCharacterControl *temp,*die;
				temp = PlayerCharacterNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				PlayerCharacterNode = NULL;
			}
			if (HomeSecuritySystemNode)
			{
				HomeSecuritySystemControl *Current = HomeSecuritySystemNode;
				FILE *FileHouseSecuritySystem;
				FileHouseSecuritySystem = fopen("Data/RolePlay2/HomeSecuritySettings.tmp","w");
				fflush(FileHouseSecuritySystem);
				while (Current != NULL)
				{
					fprintf(FileHouseSecuritySystem,"%d\n",Current->HouseAddress);
					char EncryptString[256];
					sprintf(EncryptString,"%d %d %d %d %d %d %d %d %d",Current->RentPrice,Current->DetectIntruders,Current->DetectVandals,Current->CeilingGuns,Current->MissileDefenseSystem,Current->AutoRepair,Current->NumberOfPrePays,Current->RentDay,Current->RentYear);
					fprintf(FileHouseSecuritySystem,"%s\n",Encrypt(EncryptString,Current->HouseAddress,3));
					fflush(FileHouseSecuritySystem);
					Current = Current->next;
				}
				fclose(FileHouseSecuritySystem);
				remove("Data/RolePlay2/BetaHomeSecuritySettings.RP2");
				rename("Data/RolePlay2/HomeSecuritySettings.tmp","Data/RolePlay2/BetaHomeSecuritySettings.RP2");
				if (HomeSecuritySystemNode)
				{
					HomeSecuritySystemControl *temp,*die;
					temp = HomeSecuritySystemNode;
					while (temp != NULL)
					{
						die = temp;
						temp = temp->next;
						delete die;
					}
					HomeSecuritySystemNode = NULL;
				}
			}
			if (HomeSecurityObjectNode)
			{
				HomeSecurityObjectControl *temp,*die;
				temp = HomeSecurityObjectNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				HomeSecurityObjectNode = NULL;
			}
			if (HomeSecurityZoneNode)
			{
				HomeSecurityZoneControl *temp,*die;
				temp = HomeSecurityZoneNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				HomeSecurityZoneNode = NULL;
			}
			if (AntiMissileSystemNode)
			{
				AntiMissileSystemControl *temp,*die;
				temp = AntiMissileSystemNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				AntiMissileSystemNode = NULL;
			}
			if (RP2PUWCPlayerListNode)
			{
				RP2PUWCPlayerListControl *temp,*die;
				temp = RP2PUWCPlayerListNode;
				while (temp != NULL)
				{
					die = temp;
					if (die->List)
					{
						RP2PickedUpWeaponControl *temp2,*die2;
						temp2 = die->List;
						while (temp2 != NULL)
						{
							die2 = temp2;
							temp2 = temp2->next;
							delete die2;
						}
						die->List = NULL;
					}
					temp = temp->next;
					delete die;
				}
				RP2PUWCPlayerListNode = NULL;
			}
			if (RP2PickedUpWeaponNode)
			{
				RP2PickedUpWeaponControl *temp,*die;
				temp = RP2PickedUpWeaponNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				RP2PickedUpWeaponNode = NULL;
			}
			if (RP2PhoneTextNode)
			{
				RP2PhoneTextControl *temp,*die;
				temp = RP2PhoneTextNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				RP2PhoneTextNode = NULL;
			}
			if (RP2SwimmingZoneTypeIndexNode)
			{
				RP2SwimmingZoneTypeIndexControl *temp,*die;
				temp = RP2SwimmingZoneTypeIndexNode;
				while (temp != NULL)
				{
					die = temp;
					temp = temp->next;
					delete die;
				}
				RP2SwimmingZoneTypeIndexNode = NULL;
			}
			if (DefaultRP2WeatherNode){delete DefaultRP2WeatherNode;DefaultRP2WeatherNode = NULL;}
			if (ArcticRP2WeatherNode){delete ArcticRP2WeatherNode;ArcticRP2WeatherNode = NULL;}
			if (RenhaloRP2WeatherNode){delete RenhaloRP2WeatherNode;RenhaloRP2WeatherNode = NULL;}
			if (MarsRP2WeatherNode){delete MarsRP2WeatherNode;MarsRP2WeatherNode = NULL;}
			if (RCRP2WeatherNode){delete RCRP2WeatherNode;RCRP2WeatherNode = NULL;}
			if (CanadaRP2WeatherNode){delete CanadaRP2WeatherNode;CanadaRP2WeatherNode = NULL;}
			for (int x = 0;x <128;x++)
			{
				PlayerWeatherNodes[x] = NULL;
			}////////////////////////////////////////////////////////
			Test_All_Nodes_For_NULL();
			/*NCU*///JeradTrace("Finish");
			/*NCU*///JeradTrace("Destroy All");
			SLNode<BaseGameObj> *Current = GameObjManager::GameObjList.Head();
			while (Current)
			{
				GameObject *Object = Current->Data()->As_ScriptableGameObj();
				if (Object && Object != obj)
				{
					if (Commands->Is_A_Star(Object))
					{
						Remove_All_Scripts(Object);
					}
					else
					{
						Commands->Destroy_Object(Object);
					}
				}
				Current = Current->Next();
			}
			Commands->Destroy_Object(obj);
			/*NCU*///JeradTrace("Task Complete");
		}
		Commands->Start_Timer(obj,this,0.25f,955551);
	}
}

char *JMG_RP2_Node_Cleanup::Encrypt(const char *String,int EncryptionFactor,int Start)
{
	static char FinalString[256];
	sprintf(FinalString," ");
	int loops = strlen(String),x = 0;
	int CurrentAdd = Start;
	while (x < loops)
	{
		if (String[x] != '\0' && String[x] != '\n')
		{
			char Temp = (String[x]+(char)CurrentAdd);
			while (Temp > 125)
			{
				Temp -= 125;
			}
			FinalString[x] = Temp;
			CurrentAdd++;
			if (CurrentAdd > EncryptionFactor)
			{
				CurrentAdd = 1;
			}
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
		FinalString[x] = '\0';
	}
	return FinalString;
}

void JMG_RP2_Phone_Teleport_Sender_Player::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		GameObject *Player = Get_GameObj(param);
		Vector3 pos = Commands->Get_Bone_Position(Player,"c head");
		pos.X += 20.0f*(cos(Get_Float_Parameter("TeleportFacing")*3.14159265f/180));
		pos.Y += 20.0f*(sin(Get_Float_Parameter("TeleportFacing")*3.14159265f/180));
		Force_Camera_Look_Player(Player,pos);
		Commands->Set_Position(Player,Get_Vector3_Parameter("TeleportPosition"));
	}
}

void JMG_Remove_Object_When_Timer_Expired2::Created(GameObject *obj)
{
	if (The_Game()->Is_Gameplay_Permitted())
	{
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),2453810);
	}
	else
	{
		Commands->Start_Timer(obj,this,0.1f,2453811);
	}
}

void JMG_Remove_Object_When_Timer_Expired2::Timer_Expired(GameObject *obj,int number)
{
	if (number == 2453810)
	{
		Commands->Destroy_Object(obj);
	}
	if (number == 2453811)
	{
		if (The_Game()->Is_Gameplay_Permitted())
		{
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),2453810);
		}
		else
		{
			Commands->Start_Timer(obj,this,0.1f,2453811);
		}
	}
}
// Ported From Renhalo's Scripts
void JMG_Turret_Attach::Created(GameObject *obj)
{
	GameObject *object = Commands->Create_Object(Get_Parameter("Preset"),Vector3(0,0,0));
	char params[20];
	sprintf(params,"%d",Commands->Get_ID(obj));
	Commands->Attach_Script(object,"JMG_Remove_Object_When_Creator_Destroyed",params);
	Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("Bone_Name"));
	ObjectID = Commands->Get_ID(object);
}

void JMG_Turret_Attach::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		GameObject *object = Commands->Find_Object(ObjectID);
		Commands->Set_Player_Type(object,Commands->Get_Player_Type(sender));
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		GameObject *object = Commands->Find_Object(ObjectID);
		Commands->Set_Player_Type(object,Commands->Get_Player_Type(sender));
	}
}

void JMG_Turret_Attach::Killed(GameObject *obj,GameObject *damager)
{
	GameObject *object = Commands->Find_Object(ObjectID);
	if (object)
	{
		Commands->Destroy_Object(object);
	}
}

void JMG_Attach_Script_To_All_AI_Infantry::Created(GameObject *obj)
{
	const char *paramx = Get_Parameter("Params");
	char *params2 = newstr(paramx);
	char delim = Get_Parameter("Delim")[0];
	unsigned int x = strlen(params2);
	for (unsigned int i=0;i<x;i++)
	{
		if (params2[i] == delim)
		{
			params2[i] = ',';
		}
	}
	params = params2;
	Commands->Start_Timer(obj,this,0.25f,92562143);
}

void JMG_Attach_Script_To_All_AI_Infantry::Timer_Expired(GameObject *obj, int number)
{
	if (number == 92562143)
	{
		SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
		while (x)
		{
			GameObject *o = x->Data();
			if (o)
			{
				if (!Commands->Is_A_Star(o) && o->As_SoldierGameObj() && o != obj && !Is_Script_Attached(obj,Get_Parameter("Script")))
				{
					Commands->Attach_Script(o,Get_Parameter("Script"),params);
				}
			}
			x = x->Next();
		}
	}
}

void JMG_Remove_All_AI_Infantry::Created(GameObject *obj)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = x->Data();
		if (o)
		{
			if (!Commands->Is_A_Star(o) && o->As_SoldierGameObj() && o != obj)
			{
				Commands->Destroy_Object(o);
			}
		}
		x = x->Next();
	}
}

void JMG_Remove_All_Infantry::Created(GameObject *obj)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = x->Data();
		if (o)
		{
			if (o->As_SoldierGameObj() && o != obj)
			{
				Commands->Destroy_Object(o);
			}
		}
		x = x->Next();
	}
}

void JMG_RP2_Record_Vehicles_At_End_Of_Game::Created(GameObject *obj)
{
	FILE *filev;
	filev = fopen("Data/RolePlay2/RP2VehicleControl.RP2","w");
	if (filev)
	{  
		SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
		while (x)
		{
			GameObject *o = x->Data();
			if (o)
			{
				if (Is_Script_Attached(o,"Data/RolePlay2/JMG_RP2_Please_Record_Vehicle"))
				{
					Vector3 pos = Commands->Get_Position(o);
					fprintf(filev,"%s %.3f %.3f %.3f %.3f %.2f %.2f;\n",Commands->Get_Preset_Name(o),pos.X,pos.Y,pos.Z,Commands->Get_Facing(o),Commands->Get_Health(o),Commands->Get_Shield_Strength(o));	
					fflush(filev);
				}
				else if (o->As_VehicleGameObj())
				{
					if ((o->As_PhysicalGameObj() && o->As_PhysicalGameObj()->Peek_Physical_Object() && o->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()) || (o->As_PhysicalGameObj() && o->As_PhysicalGameObj()->Peek_Physical_Object() && o->As_PhysicalGameObj()->Peek_Physical_Object()->As_TrackedVehicleClass()) || (o->As_PhysicalGameObj() && o->As_PhysicalGameObj()->Peek_Physical_Object() && o->As_PhysicalGameObj()->Peek_Physical_Object()->As_WheeledVehicleClass()) || (o->As_PhysicalGameObj() && o->As_PhysicalGameObj()->Peek_Physical_Object() && o->As_PhysicalGameObj()->Peek_Physical_Object()->As_MotorcycleClass()))
					{
						if (!(Is_Script_Attached(o,"Data/RolePlay2/JMG_RP2_Do_Not_Record_Vehicle")))
						{
							Vector3 pos = Commands->Get_Position(o);
							fprintf(filev,"%s %.3f %.3f %.3f %.3f %.2f %.2f;\n",Commands->Get_Preset_Name(o),pos.X,pos.Y,pos.Z,Commands->Get_Facing(o),Commands->Get_Health(o),Commands->Get_Shield_Strength(o));
							fflush(filev);
						}
					}
				}
			}
			x = x->Next();
		}
		fclose(filev);
	}
}

void JMG_RP2_Do_Not_Record_Vehicle::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED && Get_Int_Parameter("Remove_Script_On_Entry"))
	{
		Remove_Script(obj,"JMG_RP2_Do_Not_Record_Vehicle");
	}
}

void JMG_RP2_Please_Record_Vehicle::Created(GameObject *obj)
{
	//Dummy Script
}

void JMG_RP2_Create_Vehicles_At_Start_Of_Game::Created(GameObject *obj)
{
	int CanRun = 1;
	FILE *filev2;
	filev2 = fopen("Data/RolePlay2/RP2VehicleControl.RP2","r");
	if (filev2)
	{  
		char FirstLine[20000];
		sprintf(FirstLine,"");
		fread(FirstLine,20000,1,filev2);
		if (strlen(FirstLine) < 2)
		{
			CanRun = 0;
		}
		rewind (filev2);
		int x = 0;
		while (!feof(filev2) && CanRun == 1)
		{
			char VehicleName[256],Safty;
			Vector3 pos;
			float Facing,Health,Shield;
			fscanf(filev2,"%s %f %f %f %f %f %f%c\n",VehicleName,&pos.X,&pos.Y,&pos.Z,&Facing,&Health,&Shield,&Safty);
			if (Safty == ';')
			{
				x++;
				GameObject *vehicle = Commands->Create_Object(VehicleName,pos);;
				Commands->Set_Facing(vehicle,Facing);
				Commands->Set_Health(vehicle,Health);
				Commands->Set_Shield_Strength(vehicle,Shield);
				Commands->Attach_Script(vehicle,"JMG_RP2_Do_Not_Record_Vehicle","1");
				char params[2000];
				sprintf(params,"%.2f %.2f %.2f",pos.X,pos.Y,pos.Z);
				Commands->Attach_Script(vehicle,"JMG_RP2_Checked_If_Recorded_Vehicle_Stuck",params);
			}
			else
			{
				char warning[2000];
				sprintf(warning,"MESSAGE Warning: Line %d is bad in RP2VehicleControl.rp2!",x);
				Console_Input(warning);
			}
		}
		fclose(filev2);
	}
}

void JMG_RP2_Checked_If_Recorded_Vehicle_Stuck::Created(GameObject *obj)
{
	MoveCount = 0;
	Vector3 pos = Get_Vector3_Parameter("CreatePosition");
	pos.Z += 0.1f;
	Commands->Set_Position(obj,pos);
	Commands->Start_Timer(obj,this,0.25f,55525);
}

void JMG_RP2_Checked_If_Recorded_Vehicle_Stuck::Timer_Expired(GameObject *obj,int number)
{
	if (number == 55525)
	{
		if (Commands->Get_Position(obj).Z == (Get_Vector3_Parameter("CreatePosition").Z+0.1f))
		{
			MoveCount++;
			Vector3 pos = Get_Vector3_Parameter("CreatePosition");
			pos.Z += (1.0f*MoveCount);
			Commands->Set_Position(obj,pos);
			Commands->Start_Timer(obj,this,0.25f,55526);
		}
		else
		{
			Remove_Script(obj,"JMG_RP2_Checked_If_Recorded_Vehicle_Stuck");
		}
	}
	if (number == 55526)
	{
		if (Commands->Get_Position(obj).Z == (Get_Vector3_Parameter("CreatePosition").Z+(1.0f*MoveCount)))
		{
			MoveCount++;
			Vector3 pos = Get_Vector3_Parameter("CreatePosition");
			pos.Z += (1.0f*MoveCount);
			Commands->Set_Position(obj,pos);
			Commands->Start_Timer(obj,this,0.25f,55526);
			if (MoveCount > 10)
			{
				Commands->Destroy_Object(obj);
			}
		}
		else
		{
			Remove_Script(obj,"JMG_RP2_Checked_If_Recorded_Vehicle_Stuck");
		}
	}
}

void JMG_RP2_Map_Vehicle_Control::Created(GameObject *obj)
{
	Attach_Script_Once(obj,"JMG_RP2_Create_Vehicles_At_Start_Of_Game",0);
}

void JMG_RP2_Map_Vehicle_Control::Timer_Expired(GameObject *obj,int number)
{
	if (955551 == number)
	{
		if (The_Game()->Is_Game_Over())
		{
			Attach_Script_Once(obj,"JMG_RP2_Record_Vehicles_At_End_Of_Game",0);
		}
	}
}

void JMG_RP2_Main_Map_Game_Control::Created(GameObject *obj)
{
	for (int x = 1;x < 128;x++) // Set up the max inventory size
	{
		RP2PlayerSAWTArray[x] = NULL;
		RP2StarMaxInventorySize[x] = STARTINGINVENTORYSIZE;
		ATTEMPTINGTOSPAWN[x] = 0;
		ISSELECTINGSPAWN[x] = 1;
		PHONEZONES[x] = 1;
		SPAWNINGALLOWED[x] = 1;
		IsInsideHouse[x] = 0;
		COMPLETEDACHIEVEMENTS[x] = 0;
		ObjectLimitNode[x] = NULL;
	}
	for (int x = 0;x < 128;x++)
	{
		for (int y = 0;y < 25;y++)
		{
			JRP2SSBDGrid[x][y] = 0;
			JRP2SSHDGrid[x][y] = 0;
		}
		JRP2SSBDGridTC[x] = 0;
		JRP2SSHDGridTC[x] = 0;
	}
	Commands->Start_Timer(obj,this,0.0f,955551);
	Commands->Start_Timer(obj,this,0.1f,955553);
	SaveTheGame = new JMG_RP2_Phone_Main_Map_Runtime_Save();
	Commands->Start_Timer(obj,this,SAVEGAMETIME,955552);
	RUNNINGGAMETIMES = 0;
	RUNNINGGAMETIMEM = 0;
	RUNNINGGAMETIMEH = 0;
	Commands->Start_Timer(obj,this,1.0f,955554);
}

void JMG_RP2_Main_Map_Game_Control::Timer_Expired(GameObject *obj,int number)
{
	if (955551 == number)
	{
		Commands->Attach_Script(obj,"JMG_RP2_Node_Cleanup","");
		Commands->Attach_Script(obj,"JMG_RP2_Map_Vehicle_Control","");
		Commands->Attach_Script(obj,"JMG_RP2_Load_Random_Teleport_File","Data/RolePlay2/RP2RandomTeleport.rp2");
		Commands->Attach_Script(obj,"JMG_RP2_Weapons_Cupboard_File_Control","");
		Commands->Attach_Script(obj,"JMG_RP2_Set_Up_Weapons_List","");
		Commands->Attach_Script(obj,"JMG_RP2_Phone_Load_Redial_Numbers","");
		Commands->Attach_Script(obj,"JMG_RP2_Mission_System_Load_Completed_Player_Missions","");
		Commands->Attach_Script(obj,"JMG_RP2_Load_Player_Bank_Accounts","");
		Commands->Attach_Script(obj,"JMG_RP2_Interest_Calculator","");
		Commands->Attach_Script(obj,"JMG_RP2_Phone_Load_Phone_Number_Strings","");
		Commands->Attach_Script(obj,"JMG_RP2_Mission_System_Strings_Loader","");
		Commands->Attach_Script(obj,"JMG_RP2_Housing_Vehicle_Load","");
		Commands->Attach_Script(obj,"JMG_RP2_Fishing_Random_School_Generator","");
		Commands->Attach_Script(obj,"JMG_RP2_Favorite_Vehicle_Main_Control_System","");
		Commands->Attach_Script(obj,"JMG_RP2_Favorite_Weapon_Main_Control_System","");
		Commands->Attach_Script(obj,"JMG_RP2_Load_Player_Characters","");
		Commands->Attach_Script(obj,"JMG_RP2_Load_House_Security_Setup","");
		Commands->Attach_Script(obj,"JMG_RP2_House_Security_System_Object_Control","");
		//Commands->Attach_Script(obj,"JMG_RP2_Count_Objects_On_Map_And_Print","");
	}
	if (955552 == number)
	{
		if (!The_Game()->Is_Game_Over())
		{
			if (SaveTheGame)
			{
				SaveTheGame->SaveStructsSilent();
			}
		}
		Commands->Start_Timer(obj,this,SAVEGAMETIME,955552);
	}
	if (955553 == number)
	{
		Server_Version();
	}
	if (955554 == number)
	{
		RUNNINGGAMETIMES++;
		if (RUNNINGGAMETIMES > 59)
		{
			RUNNINGGAMETIMES = 0;
			RUNNINGGAMETIMEM++;
			if (RUNNINGGAMETIMEM > 59)
			{
				RUNNINGGAMETIMEM = 0;
				RUNNINGGAMETIMEH++;
			}
		}
		if (GroupUp < 0)
		{
			GroupUp++;
		}
		Commands->Start_Timer(obj,this,1.0f,955554);
	}
}

void JMG_RP2_Main_Map_Game_Control::Server_Version()
{
	char Message[237];
	sprintf(Message,"Map: %s",MAPVERSION);
	char Message2[237];
	sprintf(Message2,"Scripts: %s",VERSION);
	for (int x = 1;x < 128;x++)
	{
		GameObject *Player = Get_GameObj(x);
		if (Player)
		{
			Send_Message_Player(Player,255,255,255,"Server Versions:");
			Send_Message_Player(Player,255,255,255,Message);
			Send_Message_Player(Player,255,255,255,Message2);
		}
	}
}

void JMG_RP2_Phone_Player_Phone_Number::Custom(GameObject *obj,int message,int param,GameObject *sender)
{	
	if (obj != sender)
	{
		PhoneNumberControl *Phone = NULL;
		if (PhoneNumbers)// Find Sender Phone
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					Phone = Current;
					end = 1;
				}
				Current = Current->next;
			}
		}
		if (CellPhoneNumberNode && Phone)
		{
			int end = 0;
			CellPhoneNumberControl *Current2 = CellPhoneNumberNode;
			while (Current2 != NULL && end == 0)
			{
				if (Phone->PhoneNumberLength == Current2->NumberLength)
				{
					if (!_stricmp(Phone->PhoneNumber,Current2->MyPhoneNumber))
					{
						end = 1;	
						if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
						{
							sprintf(Phone->PhoneNumber,"%s - %s",Phone->PhoneNumber,Current2->PlayerName);
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
						else
						{
							GameObject *Player = Get_GameObj(Current2->PlayerID);
							if (Commands->Get_Health(Player) > 0.0f && Has_Weapon(Player,"Weapon_Cell_Phone"))
							{
								Commands->Send_Custom_Event(obj,sender,PHONEFoundOtherPlayerStandBy,Current2->PlayerID,0);// Send Message with contact ID
							}
							else
							{
								Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Return busy signal
							}
							Phone->PhoneNumberLength = 3;
							sprintf(Phone->PhoneNumber,"null");
						}
					}
				}
				Current2 = Current2->next;
			}
		}
	}
}

void JMG_RP2_Grant_Powerup_Weapon_Limit::Custom(GameObject *obj,int message,int param,GameObject *sender)// OLD AND UNUSED, LEFT IN FOR REFERENCE
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		const char *GrantedWeapon = Get_Powerup_Weapon(Get_Parameter("Real_Powerup_Preset"));
		int PlayerID = Get_Player_ID(sender);
		int WeaponSize = Get_Int_Parameter("Weapon_Size");
		if (!ISSELECTINGSPAWN[PlayerID] && ((Has_Weapon(sender,GrantedWeapon) == 0 && Get_Weapon_Count(sender) < RP2MAXINVENTORYWEAPONLIMIT && (RP2StarCurrentInventorySize[PlayerID] + WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) || (Has_Weapon(sender,GrantedWeapon) == 1 && Get_Max_Clip_Bullets(sender,GrantedWeapon) > Get_Clip_Bullets(sender,GrantedWeapon))))
		{
			if (!Has_Weapon(sender,GrantedWeapon))// Doesn't have the weapon, take up some space
			{
				//WLS_Remove_Weapon_Weight(sender,GrantedWeapon,PlayerID);
			}
			Commands->Give_PowerUp(sender,GrantedWeapon,true);
			//if (Has_Weapon(sender,GrantedWeapon))// Saftey Precaution
			{
				int GrantBullets = Get_Int_Parameter("Bullets");
				if (GrantBullets == -1)// Nolimit, get max bullets
				{
					GrantBullets = Get_Max_Total_Bullets(sender,GrantedWeapon);
				}
				int GunBullets = Get_Clip_Bullets(sender,GrantedWeapon) + GrantBullets; // Add all your backpack bullets to the powerup's bullets
				if (Get_Total_Bullets(sender,GrantedWeapon) != 0)// Gun Is not Empty
				{
					if (Get_Max_Clip_Bullets(sender,GrantedWeapon) < GunBullets) // Too many bullets to fit in your backpack, have to drop some
					{
						int leftovers = GunBullets - Get_Max_Clip_Bullets(sender,GrantedWeapon);
						GunBullets = Get_Max_Clip_Bullets(sender,GrantedWeapon);
						DropGun(obj,leftovers,0.25f,0);
					}
					else if (Get_Float_Parameter("Spawn_Time") && Get_Int_Parameter("Spawn_Limit")) // Gun Used up, start respawn timer
					{
						DropGun(obj,-1,SpawnTime(),1);
					}
				}
				else if (Get_Float_Parameter("Spawn_Time") && Get_Int_Parameter("Spawn_Limit")) // Powerup gone, start respawn timer
				{
					DropGun(obj,-1,SpawnTime(),1);
				}
				int TempCarryOver = 0;
				if (Get_Max_Clip_Bullets(sender,GrantedWeapon) < GunBullets)
				{
					TempCarryOver = GunBullets - Get_Max_Clip_Bullets(sender,GrantedWeapon);
					GunBullets = Get_Max_Clip_Bullets(sender,GrantedWeapon);
				}
				Set_Bullets(sender,GrantedWeapon,Get_Bullets(sender,GrantedWeapon) + TempCarryOver);
				Set_Clip_Bullets(sender,GrantedWeapon,GunBullets);
			}
			Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
		}
		else
		{
			DropGun(obj,Get_Int_Parameter("Bullets"),0.25f,0);
		}
	}
}

void JMG_RP2_Grant_Powerup_Weapon_Limit::DropGun(GameObject *obj,int Bullets,float SpawnTime,int Add)// OLD AND UNUSED, LEFT IN FOR REFERENCE
{
	if (Get_Int_Parameter("Recreate_If_Grant_Fails"))
	{
		GameObject *object = Commands->Create_Object("Daves_Arrow_NT",Commands->Get_Position(obj));
		Commands->Set_Model(object,"null");
		Commands->Set_Facing(object,Commands->Get_Facing(obj));
		char params[2000];
		sprintf(params,"%s,%s,%d,%d,%f,%f,%f,%d,%d",Commands->Get_Preset_Name(obj),Get_Parameter("Real_Powerup_Preset"),Bullets,Get_Int_Parameter("Weapon_Size"),SpawnTime,Get_Float_Parameter("Spawn_Time"),Get_Float_Parameter("Random_Spawn_Time"),Get_Int_Parameter("Spawn_Limit"),(Get_Int_Parameter("Spawn_Count") + Add));
		Commands->Attach_Script(object,"JMG_RP2_Decoy_Recreate_Powerup",params);
		Commands->Destroy_Object(obj);
	}
}

float JMG_RP2_Grant_Powerup_Weapon_Limit::SpawnTime()// OLD AND UNUSED, LEFT IN FOR REFERENCE
{
	float RandomTime = Commands->Get_Random(0.0f,Get_Float_Parameter("Random_Spawn_Time")) + Get_Float_Parameter("Spawn_Time");
	if (RandomTime < 0.1f)
	{
		RandomTime = 0.1f;
	}
	return RandomTime;
}

void JMG_RP2_Decoy_Recreate_Powerup::Created(GameObject *obj)// OLD AND UNUSED, LEFT IN FOR REFERENCE
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("MySpawnTime"),955551);
}

void JMG_RP2_Decoy_Recreate_Powerup::Timer_Expired(GameObject *obj,int number)// OLD AND UNUSED, LEFT IN FOR REFERENCE
{
	if (955551 == number)
	{
		Vector3 Pos = Commands->Get_Position(obj);
		GameObject *NearestStar = Commands->Get_A_Star(Pos);
		if (Commands->Get_Distance(Commands->Get_Position(NearestStar),Pos) > 1.25)
		{
			GameObject *object = Commands->Create_Object(Get_Parameter("PowerUp_Name"),Pos);
			Commands->Set_Facing(object,Commands->Get_Facing(obj));
			char params[2000];
			sprintf(params,"%s,1,%d,%d,%f,%f,%d,%d",Get_Parameter("Real_Powerup_Preset"),Get_Int_Parameter("Bullets"),Get_Int_Parameter("Weapon_Size"),Get_Float_Parameter("SpawnTime"),Get_Float_Parameter("RandomSpawnTime"),Get_Int_Parameter("Spawn_Limit"),Get_Int_Parameter("Spawn_Count"));
			if (!Is_Script_Attached(object,"JMG_RP2_Grant_Powerup_Weapon_Limit"))
			{
				Commands->Attach_Script(object,"JMG_RP2_Grant_Powerup_Weapon_Limit",params);
			}
			Commands->Destroy_Object(obj);
		}
		else
		{
			Commands->Start_Timer(obj,this,0.25f,955551);
		}
	}
}

void JMG_Zone_Remove_Weapon_On_Entry::Entered(GameObject *obj,GameObject *enter)
{
	if (Has_Weapon(enter,Get_Parameter("Weapon_Name")))
	{
		Remove_Weapon(enter,Get_Parameter("Weapon_Name"));
	}
}

/*
JMG_RP2_WLS_Add_Weapon_Type - this is what creates the weapon table that the other scripts look at
*WeaponName
*PowerUpName
*Fake_Powerup
*Dropable
*WeaponCost
*BulletCost

JMG_RP2_WLS_Grant_Weapon - grants weapon on creation as long as it is within limits
*WeaponName
*Grant_Bullets

JMG_RP2_WLS_Grant_Weapon_Poke - grants you a weapon while watching the weapon limits
*WeaponName
*Grant_Bullets

JMG_RP2_WLS_Grant_Weapon_Poke_Special - attach to the admin box, weapon limits ignored but warns you when exceeded
*WeaponName
*Grant_Bullets

JMG_RP2_WLS_Buy_Weapon_Poker - this would be attached to weapon pt's
*WeaponName
*BuySound
*DeclinedSound
*WeaponCostOverride (Default 0)
*BulletCostOverride (Default 0)

JMG_RP2_WLS_Buy_Weapon_Vehicle_Owner - this one is attached to the fake vehicle weapons
*WeaponName
*BuySound
*DeclinedSound
*WeaponCostOverride (Default 0)
*BulletCostOverride (Default 0)

JMG_RP2_WLS_Weapon_Spawner_Control - this one is attached to spanwers
*WeaponName
*SpawnTime (Default 60)
*RandomSpawnTime (Default 30)
*SpawnCount (Default -1)
*GrantBullets (Default -1)

JMG_RP2_WLS_Zone_Remove_Weapon - Removes a weapon if the player has it, updating inventory weight correctly
*WeaponName
*/
void JMG_RP2_WLS_Add_Weapon_Type::Created(GameObject *obj)
{
	/*char message[2000];
	sprintf(message,"MESSAGE MY ID:%d",Commands->Get_ID(obj));
	Console_Input(message);*/
	Add_Node(obj);
}

void JMG_RP2_WLS_Add_Weapon_Type::Add_Node(GameObject *obj)
{
	if (!RP2WeaponListNode)
	{
		RP2WeaponListNode = new RP2WeaponListControl;
		sprintf(RP2WeaponListNode->WeaponName,"%s",Get_Parameter("Weapon_Name"));
		sprintf(RP2WeaponListNode->PowerUpName,"%s",Get_Parameter("Powerup_Name"));
		sprintf(RP2WeaponListNode->FakePowerUpName,"%s",Get_Parameter("Fake_Powerup"));
		RP2WeaponListNode->CanBeDropped = Get_Int_Parameter("Droppable");
		RP2WeaponListNode->WeaponSize = Get_Float_Parameter("Weapon_Size");
		RP2WeaponListNode->WeaponCost = Get_Int_Parameter("Weapon_Cost");
		RP2WeaponListNode->BulletCost = Get_Int_Parameter("Bullet_Cost");
		RP2WeaponListNode->DropHeight = Get_Float_Parameter("Drop_Height");
		RP2WeaponListNode->RespawnDistance = Get_Float_Parameter("Respawn_Distance");
		sprintf(RP2WeaponListNode->AltWeaponName,"%s",Get_Parameter("Alt_Weapon_Name"));
		RP2WeaponListNode->DropWhenEmpty = Get_Int_Parameter("Drop_When_Empty");
		RP2WeaponListNode->WeaponClass = Get_Int_Parameter("Weapon_Class");
		RP2WeaponListNode->DropMessage = Get_Int_Parameter("Drop_Message");
		RP2WeaponListNode->WeaponTier = Get_Int_Parameter("Weapon_Tier");
		RP2WeaponListNode->TierNumber = WeaponTierCounts[RP2WeaponListNode->WeaponTier];
		WeaponTierCounts[RP2WeaponListNode->WeaponTier]++;
		RP2WeaponListNode->AmmoSize = Get_Float_Parameter("Ammo_Size");
		RP2WeaponListNode->CanFavorite = Get_Int_Parameter("Can_Favorite");
		RP2WeaponListNode->CookTime = Get_Int_Parameter("Cook_Time");
		RP2WeaponListNode->next = NULL;
	}
	else
	{
		int end = 0;
		RP2WeaponListControl *Current = RP2WeaponListNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Get_Parameter("Weapon_Name"),Current->WeaponName))
			{
				end = 1;
				char ERRORMESSAGE[2000];
				sprintf(ERRORMESSAGE,"MESSAGE ERROR: \"%s\" IS ALREADY DEFINED! OBJECT ID:%d",Get_Parameter("Weapon_Name"),Commands->Get_ID(obj));
				Console_Input(ERRORMESSAGE);
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new RP2WeaponListControl;
				Current = Current->next;
				sprintf(Current->WeaponName,"%s",Get_Parameter("Weapon_Name"));
				sprintf(Current->PowerUpName,"%s",Get_Parameter("Powerup_Name"));
				sprintf(Current->FakePowerUpName,"%s",Get_Parameter("Fake_Powerup"));
				Current->CanBeDropped = Get_Int_Parameter("Droppable");
				Current->WeaponSize = Get_Float_Parameter("Weapon_Size");
				Current->WeaponCost = Get_Int_Parameter("Weapon_Cost");
				Current->BulletCost = Get_Int_Parameter("Bullet_Cost");
				Current->DropHeight = Get_Float_Parameter("Drop_Height");
				Current->RespawnDistance = Get_Float_Parameter("Respawn_Distance");
				sprintf(Current->AltWeaponName,"%s",Get_Parameter("Alt_Weapon_Name"));
				Current->DropWhenEmpty = Get_Int_Parameter("Drop_When_Empty");
				Current->WeaponClass = Get_Int_Parameter("Weapon_Class");
				Current->DropMessage = Get_Int_Parameter("Drop_Message");
				Current->WeaponTier = Get_Int_Parameter("Weapon_Tier");
				Current->TierNumber = WeaponTierCounts[Current->WeaponTier];
				WeaponTierCounts[Current->WeaponTier]++;
				Current->AmmoSize = Get_Float_Parameter("Ammo_Size");
				Current->CanFavorite = Get_Int_Parameter("Can_Favorite");
				Current->CookTime = Get_Int_Parameter("Cook_Time");
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_WLS_Buy_Weapon_Poker::Poked(GameObject *obj,GameObject *poker)
{
	int PlayerID = Get_Player_ID(poker);
	RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
	if (TheWeapon)
	{
		int WeaponCost = TheWeapon->WeaponCost;
		int BulletCost2 = TheWeapon->BulletCost;
		if (Get_Int_Parameter("Bullet_Cost_Override"))
		{
			BulletCost2 = Get_Int_Parameter("Bullet_Cost_Override");
		}
		if (Get_Int_Parameter("Weapon_Cost_Override"))
		{
			WeaponCost = Get_Int_Parameter("Weapon_Cost_Override");
		}
		if (!ISSELECTINGSPAWN[PlayerID] && ((Has_Weapon(poker,TheWeapon->WeaponName) == 0 && Get_Weapon_Count(poker) < RP2MAXINVENTORYWEAPONLIMIT && (RP2StarCurrentInventorySize[PlayerID] + TheWeapon->WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) || (Has_Weapon(poker,TheWeapon->WeaponName) == 1 && Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) > Get_Clip_Bullets(poker,TheWeapon->WeaponName))))
		{
			if (!Has_Weapon(poker,TheWeapon->WeaponName))// Buy Weapon First If You Don't Have it
			{
				if (WeaponCost <= Commands->Get_Money(poker))// Check if you have the money
				{
					WLS_Add_Weapon_Weight(poker,TheWeapon,PlayerID);
					Commands->Give_Money(poker,WeaponCost*-1.0f,0);
					SpecialGivePowerup(poker,TheWeapon);
					Commands->Create_Sound(Get_Parameter("Buy_Sound"),Commands->Get_Position(poker),poker);
				}
				else
				{
					char text[2000];
					sprintf(text,"This item costs $%.2f, I need another $%.2f to buy this item.",(float)WeaponCost,(float)WeaponCost - Commands->Get_Money(poker));
					Send_Message_Player(poker,127,0,0,text);
					Commands->Create_Sound(Get_Parameter("Declined_Sound"),Commands->Get_Position(poker),poker);
				}
			}
			if (Has_Weapon(poker,TheWeapon->WeaponName))// You must have the weapon before you can get the bullets
			{
				int GrantBullets = Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) - Get_Clip_Bullets(poker,TheWeapon->WeaponName);
				if (!Get_Total_Bullets(poker,TheWeapon->WeaponName))
				{
					GrantBullets = Get_Max_Total_Bullets(poker,TheWeapon->WeaponName);
				}
				float BulletCost = (float)(GrantBullets * BulletCost2);
				if (BulletCost > Commands->Get_Money(poker))// Buy as many shells as you can if you don't have enough to buy full ammo
				{
					GrantBullets = (int)(Commands->Get_Money(poker) / BulletCost2);
					BulletCost = (float)(GrantBullets * BulletCost2);
				}
				if (Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) == -1)// for weapons like the knife
				{
					Set_Bullets(poker,TheWeapon->WeaponName,Get_Max_Bullets(poker,TheWeapon->WeaponName));
					Set_Clip_Bullets(poker,TheWeapon->WeaponName,Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName));
				}
				else if (GrantBullets)// Buy only if you can get at least one shell
				{
					int GunBullets = Get_Clip_Bullets(poker,TheWeapon->WeaponName) + GrantBullets; // Add all your backpack bullets to the powerup's bullets
					int TempCarryOver = 0;
					if (Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) < GunBullets)
					{
						TempCarryOver = GunBullets - Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName);
						GunBullets = Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName);
					}
					Commands->Give_Money(poker,BulletCost*-1.0f,0);
					Set_Bullets(poker,TheWeapon->WeaponName,Get_Bullets(poker,TheWeapon->WeaponName) + TempCarryOver);
					Set_Clip_Bullets(poker,TheWeapon->WeaponName,GunBullets);
					Commands->Create_Sound(Get_Parameter("Buy_Sound"),Commands->Get_Position(poker),poker);
				}
				else
				{
					char text[2000];
					sprintf(text,"It costs $%.2f to buy one round for this item, I need another $%.2f to buy a round.",(float)BulletCost2,(float)BulletCost2 - Commands->Get_Money(poker));
					Send_Message_Player(poker,127,0,0,text);
					Commands->Create_Sound(Get_Parameter("Declined_Sound"),Commands->Get_Position(poker),poker);
				}
			}
			Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
		}
		else
		{
			RP2_Cannot_Grant_Weapon_Reasons(poker,TheWeapon,1);
		}
	}
}

void JMG_RP2_WLS_Weapon_Spawner_Control::Created(GameObject *obj)
{
	RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
	if (TheWeapon)
	{
		GameObject *object = Commands->Create_Object(TheWeapon->FakePowerUpName,Commands->Get_Position(obj));
		Commands->Set_Facing(object,Commands->Get_Facing(obj));
		char params[2000];
		sprintf(params,"%s,%d,%d,%f,%f,%d,%d,%d",Get_Parameter("Weapon_Name"),1,Get_Int_Parameter("Grant_Bullets"),Get_Float_Parameter("Spawn_Time"),Get_Float_Parameter("Random_Spawn_Time"),Get_Int_Parameter("Spawn_Limit"),Get_Int_Parameter("Grant_Bullets"),0);
		if (!Is_Script_Attached(object,"JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit"))
		{
			Commands->Attach_Script(object,"JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit",params);
		}
		/*sprintf(params,"MESSAGE Weapon:%s should only spawn once a game, if you see them message again check the spawner",Get_Parameter("Weapon_Name"));
		Console_Input(params);*/
		Commands->Destroy_Object(obj);
	}
}

void JMG_RP2_WLS_Grant_Weapon_Poke::Poked(GameObject *obj,GameObject *poker)
{
	int PlayerID = Get_Player_ID(poker);
	RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
	if (TheWeapon)
	{
		if (!ISSELECTINGSPAWN[PlayerID] && ((!Has_Weapon(poker,TheWeapon->WeaponName) && Get_Weapon_Count(poker) < RP2MAXINVENTORYWEAPONLIMIT && ((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) && ((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->AmmoSize) <= RP2StarMaxInventorySize[PlayerID])) || (Has_Weapon(poker,TheWeapon->WeaponName) && (Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) > Get_Clip_Bullets(poker,TheWeapon->WeaponName)) && ((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->AmmoSize) <= RP2StarMaxInventorySize[PlayerID]))))
		{
			if (!Has_Weapon(poker,TheWeapon->WeaponName))// Buy Weapon First If You Don't Have it
			{
				WLS_Add_Weapon_Weight(poker,TheWeapon,PlayerID);
				SpecialGivePowerup(poker,TheWeapon);
			}
			if (Has_Weapon(poker,TheWeapon->WeaponName))// You must have the weapon before you can get the bullets
			{
				int GrantBullets = Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) - Get_Clip_Bullets(poker,TheWeapon->WeaponName);
				if (TheWeapon->AmmoSize)// Ammo takes up inventory, needs special handeling
				{
					int GrantedBullets = 0;
					while (((Get_Total_Bullets(poker,TheWeapon->WeaponName) + GrantedBullets) < Get_Max_Total_Bullets(poker,TheWeapon->WeaponName)) && ((GrantBullets - GrantedBullets) > 0) && ((RP2StarCurrentInventorySize[PlayerID] + (TheWeapon->AmmoSize*GrantedBullets)) <= RP2StarMaxInventorySize[PlayerID]))
					{
						GrantedBullets++;
					}
					RP2StarCurrentInventorySize[PlayerID] += (TheWeapon->AmmoSize*GrantedBullets);
					GrantBullets = GrantedBullets;//All the ammo you get to play with due to the reduction
				}
				if (!Get_Total_Bullets(poker,TheWeapon->WeaponName))
				{
					GrantBullets = Get_Max_Total_Bullets(poker,TheWeapon->WeaponName);
				}
				if (Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) == -1)// for weapons like the knife
				{
					Set_Bullets(poker,TheWeapon->WeaponName,Get_Max_Bullets(poker,TheWeapon->WeaponName));
					Set_Clip_Bullets(poker,TheWeapon->WeaponName,Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName));
				}
				else if (Get_Int_Parameter("Grant_Bullets") != -2 && Get_Int_Parameter("Grant_Bullets") < GrantBullets)
				{
					Set_Bullets(poker,TheWeapon->WeaponName,-1);
					Set_Clip_Bullets(poker,TheWeapon->WeaponName,-1);
				}
				else if (Get_Int_Parameter("Grant_Bullets") != -1)
				{
					Set_Bullets(poker,TheWeapon->WeaponName,Get_Max_Bullets(poker,TheWeapon->WeaponName));
					Set_Clip_Bullets(poker,TheWeapon->WeaponName,Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName));
				}
				else
				{
					int GunBullets = Get_Clip_Bullets(poker,TheWeapon->WeaponName) + GrantBullets; // Add all your backpack bullets to the powerup's bullets
					int TempCarryOver = 0;
					if (Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) < GunBullets)
					{
						TempCarryOver = GunBullets - Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName);
						GunBullets = Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName);
					}
					Set_Bullets(poker,TheWeapon->WeaponName,Get_Bullets(poker,TheWeapon->WeaponName) + TempCarryOver);
					Set_Clip_Bullets(poker,TheWeapon->WeaponName,GunBullets);
				}
				if (TheWeapon->AmmoSize)
				{
					Add_Or_Update_RP2PlayerSAWT_Node(PlayerID,TheWeapon->WeaponName)->LastAmmoCount = Get_Total_Bullets(poker,TheWeapon->WeaponName);
				}
			}
			Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
		}
		else
		{
			RP2_Cannot_Grant_Weapon_Reasons(poker,TheWeapon,1);
		}
	}
}

void JMG_RP2_WLS_Grant_Weapon_Poke_Special::Poked(GameObject *obj,GameObject *poker)
{
	int PlayerID = Get_Player_ID(poker);
	RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
	if (TheWeapon)
	{
		if (Get_Weapon_Count(poker) == (RP2MAXINVENTORYWEAPONLIMIT + 1))
		{
			char mess[4000];
			sprintf(mess,"MESSAGE Due to the usage of \"JMG_RP2_WLS_Grant_Weapon_Poke_Special\" on object ID %d, a character weapon count has exceeded 50.",Commands->Get_ID(obj));
			Console_Input(mess);
			Console_Input("MESSAGE If you are using this script for testing your fine; however, in multiplayer, the exceeding of 50 weapons on one infantry will disconnect the clients. You have been warned!");
		}
		if (!Has_Weapon(poker,TheWeapon->WeaponName))
		{
			SpecialGivePowerup(poker,TheWeapon);
		}
		if (Has_Weapon(poker,TheWeapon->WeaponName))
		{
			int GrantBullets = Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) - Get_Clip_Bullets(poker,TheWeapon->WeaponName);
			if (TheWeapon->AmmoSize)// Ammo takes up inventory, needs special handeling
			{
				int GrantedBullets = 0;
				while (((Get_Total_Bullets(poker,TheWeapon->WeaponName) + GrantedBullets) < Get_Max_Total_Bullets(poker,TheWeapon->WeaponName)) && ((GrantBullets - GrantedBullets) > 0) && ((RP2StarCurrentInventorySize[PlayerID] + (TheWeapon->AmmoSize*GrantedBullets)) <= RP2StarMaxInventorySize[PlayerID]))
				{
					GrantedBullets++;
				}
				RP2StarCurrentInventorySize[PlayerID] += (TheWeapon->AmmoSize*GrantedBullets);
				GrantBullets = GrantedBullets;//All the ammo you get to play with due to the reduction
			}
			if (!Get_Total_Bullets(poker,TheWeapon->WeaponName))
			{
				GrantBullets = Get_Max_Total_Bullets(poker,TheWeapon->WeaponName);
			}
			else if (Get_Int_Parameter("Grant_Bullets") >= 0 && Get_Int_Parameter("Grant_Bullets") < GrantBullets)
			{
				GrantBullets = Get_Int_Parameter("Grant_Bullets");
			}
			if (Get_Int_Parameter("Grant_Bullets") == -1)
			{
				Set_Bullets(poker,TheWeapon->WeaponName,-1);
				Set_Clip_Bullets(poker,TheWeapon->WeaponName,-1);
			}
			if (Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) == -1)// for weapons like the knife
			{
				Set_Bullets(poker,TheWeapon->WeaponName,Get_Max_Bullets(poker,TheWeapon->WeaponName));
				Set_Clip_Bullets(poker,TheWeapon->WeaponName,Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName));
			}
			else if (Get_Int_Parameter("Grant_Bullets") < -1)
			{
				Set_Bullets(poker,TheWeapon->WeaponName,Get_Max_Bullets(poker,TheWeapon->WeaponName));
				Set_Clip_Bullets(poker,TheWeapon->WeaponName,Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName));
			}
			else
			{
				int GunBullets = Get_Clip_Bullets(poker,TheWeapon->WeaponName) + GrantBullets; // Add all your backpack bullets to the powerup's bullets
				int TempCarryOver = 0;
				if (Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName) < GunBullets)
				{
					TempCarryOver = GunBullets - Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName);
					GunBullets = Get_Max_Clip_Bullets(poker,TheWeapon->WeaponName);
				}
				Set_Bullets(poker,TheWeapon->WeaponName,Get_Bullets(poker,TheWeapon->WeaponName) + TempCarryOver);
				Set_Clip_Bullets(poker,TheWeapon->WeaponName,GunBullets);
			}
			if (TheWeapon->AmmoSize)
			{
				Add_Or_Update_RP2PlayerSAWT_Node(PlayerID,TheWeapon->WeaponName)->LastAmmoCount = Get_Total_Bullets(poker,TheWeapon->WeaponName);
			}
		}
	}
}

void JMG_RP2_WLS_Grant_Weapon::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.1f,45231897);
}

void JMG_RP2_WLS_Grant_Weapon::Timer_Expired(GameObject *obj,int number)
{
	if (number == 45231897)
	{
		int PlayerID = Get_Player_ID(obj);
		RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
		if (TheWeapon)
		{
			if (!ISSELECTINGSPAWN[PlayerID] && ((!Has_Weapon(obj,TheWeapon->WeaponName) && Get_Weapon_Count(obj) < RP2MAXINVENTORYWEAPONLIMIT && ((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) && ((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->AmmoSize) <= RP2StarMaxInventorySize[PlayerID])) || (Has_Weapon(obj,TheWeapon->WeaponName) && (Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) > Get_Clip_Bullets(obj,TheWeapon->WeaponName)) && ((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->AmmoSize) <= RP2StarMaxInventorySize[PlayerID]))))
			{
				if (!Has_Weapon(obj,TheWeapon->WeaponName))// Buy Weapon First If You Don't Have it
				{
					WLS_Add_Weapon_Weight(obj,TheWeapon,PlayerID);
					Commands->Give_PowerUp(obj,TheWeapon->PowerUpName,true);
				}
				if (Has_Weapon(obj,TheWeapon->WeaponName))// You must have the weapon before you can get the bullets
				{
					int GrantBullets = Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) - Get_Clip_Bullets(obj,TheWeapon->WeaponName);
					if (TheWeapon->AmmoSize)// Ammo takes up inventory, needs special handeling
					{
						int GrantedBullets = 0;
						while (((Get_Total_Bullets(obj,TheWeapon->WeaponName) + GrantedBullets) < Get_Max_Total_Bullets(obj,TheWeapon->WeaponName)) && ((GrantBullets - GrantedBullets) > 0) && ((RP2StarCurrentInventorySize[PlayerID] + (TheWeapon->AmmoSize*GrantedBullets)) <= RP2StarMaxInventorySize[PlayerID]))
						{
							GrantedBullets++;
						}
						RP2StarCurrentInventorySize[PlayerID] += (TheWeapon->AmmoSize*GrantedBullets);
						GrantBullets = GrantedBullets;//All the ammo you get to play with due to the reduction
					}
					if (!Get_Total_Bullets(obj,TheWeapon->WeaponName))
					{
						GrantBullets = Get_Max_Total_Bullets(obj,TheWeapon->WeaponName);
					}
					if (Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) == -1)// for weapons like the knife
					{
						Set_Bullets(obj,TheWeapon->WeaponName,Get_Max_Bullets(obj,TheWeapon->WeaponName));
						Set_Clip_Bullets(obj,TheWeapon->WeaponName,Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName));
					}
					else if (Get_Int_Parameter("Grant_Bullets") > 0)
					{
						Set_Bullets(obj,TheWeapon->WeaponName,0);
						Set_Clip_Bullets(obj,TheWeapon->WeaponName,Get_Int_Parameter("Grant_Bullets"));
					}
					else if (Get_Int_Parameter("Grant_Bullets") == -2 && Get_Int_Parameter("Grant_Bullets") < GrantBullets)
					{
						Set_Bullets(obj,TheWeapon->WeaponName,-1);
						Set_Clip_Bullets(obj,TheWeapon->WeaponName,-1);
					}
					else if (Get_Int_Parameter("Grant_Bullets") != -1)
					{
						Set_Bullets(obj,TheWeapon->WeaponName,Get_Max_Bullets(obj,TheWeapon->WeaponName));
						Set_Clip_Bullets(obj,TheWeapon->WeaponName,Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName));
					}
					else
					{
						int GunBullets = Get_Clip_Bullets(obj,TheWeapon->WeaponName) + GrantBullets; // Add all your backpack bullets to the powerup's bullets
						int TempCarryOver = 0;
						if (Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) < GunBullets)
						{
							TempCarryOver = GunBullets - Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName);
							GunBullets = Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName);
						}
						Set_Bullets(obj,TheWeapon->WeaponName,Get_Bullets(obj,TheWeapon->WeaponName) + TempCarryOver);
						Set_Clip_Bullets(obj,TheWeapon->WeaponName,GunBullets);
					}
					if (TheWeapon->AmmoSize)
					{
						Add_Or_Update_RP2PlayerSAWT_Node(PlayerID,TheWeapon->WeaponName)->LastAmmoCount = Get_Total_Bullets(obj,TheWeapon->WeaponName);
					}
				}
				//Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
			}
			else
			{
				RP2_Cannot_Grant_Weapon_Reasons(obj,TheWeapon,1);
			}
		}
	}
}

void JMG_RP2_WLS_Grant_Weapon_Special::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.1f,45231897);
}

void JMG_RP2_WLS_Grant_Weapon_Special::Timer_Expired(GameObject *obj,int number)
{
	if (number == 45231897)
	{
		int PlayerID = Get_Player_ID(obj);
		RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
		if (TheWeapon)
		{
			if (!ISSELECTINGSPAWN[PlayerID] && ((Has_Weapon(obj,TheWeapon->WeaponName) == 0 && Get_Weapon_Count(obj) < RP2MAXINVENTORYWEAPONLIMIT && (RP2StarCurrentInventorySize[PlayerID]) <= RP2StarMaxInventorySize[PlayerID]) || (Has_Weapon(obj,TheWeapon->WeaponName) == 1 && Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) > Get_Clip_Bullets(obj,TheWeapon->WeaponName))))
			{
				if (!Has_Weapon(obj,TheWeapon->WeaponName))// Buy Weapon First If You Don't Have it
				{
					WLS_Add_Weapon_Weight(obj,TheWeapon,PlayerID);
					RP2StarMaxInventorySize[PlayerID] += TheWeapon->WeaponSize;
					Commands->Give_PowerUp(obj,TheWeapon->PowerUpName,true);
				}
				if (Has_Weapon(obj,TheWeapon->WeaponName))// You must have the weapon before you can get the bullets
				{
					int GrantBullets = Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) - Get_Clip_Bullets(obj,TheWeapon->WeaponName);
					if (TheWeapon->AmmoSize)// Ammo takes up inventory, needs special handeling
					{
						int GrantedBullets = 0;
						while (((Get_Total_Bullets(obj,TheWeapon->WeaponName) + GrantedBullets) < Get_Max_Total_Bullets(obj,TheWeapon->WeaponName)) && ((GrantBullets - GrantedBullets) > 0))
						{
							GrantedBullets++;
						}
						RP2StarCurrentInventorySize[PlayerID] += (TheWeapon->AmmoSize*GrantedBullets);
						RP2StarMaxInventorySize[PlayerID] += (TheWeapon->AmmoSize*GrantedBullets);
						GrantBullets = GrantedBullets;//All the ammo you get to play with due to the reduction
					}
					if (!Get_Total_Bullets(obj,TheWeapon->WeaponName))
					{
						GrantBullets = Get_Max_Total_Bullets(obj,TheWeapon->WeaponName);
					}
					if (Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) == -1)// for weapons like the knife
					{
						Set_Bullets(obj,TheWeapon->WeaponName,Get_Max_Bullets(obj,TheWeapon->WeaponName));
						Set_Clip_Bullets(obj,TheWeapon->WeaponName,Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName));
					}
					else if (Get_Int_Parameter("Grant_Bullets") == -3)
					{
						Set_Bullets(obj,TheWeapon->WeaponName,Get_Max_Bullets(obj,TheWeapon->WeaponName));
						Set_Clip_Bullets(obj,TheWeapon->WeaponName,-1);
					}
					else if (Get_Int_Parameter("Grant_Bullets") != -2 && Get_Int_Parameter("Grant_Bullets") < GrantBullets)
					{
						Set_Bullets(obj,TheWeapon->WeaponName,-1);
						Set_Clip_Bullets(obj,TheWeapon->WeaponName,-1);
					}
					else if (Get_Int_Parameter("Grant_Bullets") != -1)
					{
						Set_Bullets(obj,TheWeapon->WeaponName,Get_Max_Bullets(obj,TheWeapon->WeaponName));
						Set_Clip_Bullets(obj,TheWeapon->WeaponName,Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName));
					}
					else
					{
						int GunBullets = Get_Clip_Bullets(obj,TheWeapon->WeaponName) + GrantBullets; // Add all your backpack bullets to the powerup's bullets
						int TempCarryOver = 0;
						if (Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) < GunBullets)
						{
							TempCarryOver = GunBullets - Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName);
							GunBullets = Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName);
						}
						Set_Bullets(obj,TheWeapon->WeaponName,Get_Bullets(obj,TheWeapon->WeaponName) + TempCarryOver);
						Set_Clip_Bullets(obj,TheWeapon->WeaponName,GunBullets);
					}
					if (TheWeapon->AmmoSize)
					{
						Add_Or_Update_RP2PlayerSAWT_Node(PlayerID,TheWeapon->WeaponName)->LastAmmoCount = Get_Total_Bullets(obj,TheWeapon->WeaponName);
					}
				}
				//Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
			}
			else
			{
				//RP2_Cannot_Grant_Weapon_Reasons(obj,TheWeapon->WeaponName,0,1);
			}
		}
	}
}

void JMG_RP2_WLS_Buy_Weapon_Vehicle_Owner::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.25,987);
}

void JMG_RP2_WLS_Buy_Weapon_Vehicle_Owner::Timer_Expired(GameObject *obj,int number)
{
	GameObject *owner = Get_Vehicle_Owner(obj);
	if (number == 987 && Commands->Get_ID(owner) > 0)
	{
		int PlayerID = Get_Player_ID(owner);
		RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
		if (TheWeapon)
		{
			int WeaponCost = TheWeapon->WeaponCost;
			int BulletCost2 = TheWeapon->BulletCost;
			if (Get_Int_Parameter("Bullet_Cost_Override"))
			{
				BulletCost2 = Get_Int_Parameter("Bullet_Cost_Override");
			}
			if (Get_Int_Parameter("Weapon_Cost_Override"))
			{
				WeaponCost = Get_Int_Parameter("Weapon_Cost_Override");
			}
			if (!ISSELECTINGSPAWN[PlayerID] && ((!Has_Weapon(owner,TheWeapon->WeaponName) && Get_Weapon_Count(owner) < RP2MAXINVENTORYWEAPONLIMIT && ((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) && ((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->AmmoSize) <= RP2StarMaxInventorySize[PlayerID])) || (Has_Weapon(owner,TheWeapon->WeaponName) && ((Get_Max_Clip_Bullets(owner,TheWeapon->WeaponName) > Get_Clip_Bullets(owner,TheWeapon->WeaponName)) || (!Get_Max_Clip_Bullets(owner,TheWeapon->WeaponName) && Get_Max_Bullets(owner,TheWeapon->WeaponName) > Get_Bullets(owner,TheWeapon->WeaponName))) && ((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->AmmoSize) <= RP2StarMaxInventorySize[PlayerID]))))
			{
				if (!Has_Weapon(owner,TheWeapon->WeaponName))// Buy Weapon First If You Don't Have it
				{
					if (WeaponCost <= Commands->Get_Money(owner))// Check if you have the money
					{
						WLS_Add_Weapon_Weight(owner,TheWeapon,PlayerID);
						Commands->Give_Money(owner,WeaponCost*-1.0f,0);
						SpecialGivePowerup(owner,TheWeapon);
						Commands->Create_Sound(Get_Parameter("Buy_Sound"),Commands->Get_Position(owner),owner);
					}
					else
					{
						char text[2000];
						sprintf(text,"This item costs $%.2f, I need another $%.2f to buy this item.",(float)WeaponCost,(float)WeaponCost - Commands->Get_Money(owner));
						Send_Message_Player(owner,127,0,0,text);
						Commands->Create_Sound(Get_Parameter("Declined_Sound"),Commands->Get_Position(owner),owner);
					}
				}
				if (Has_Weapon(owner,TheWeapon->WeaponName))// You must have the weapon before you can get the bullets
				{
					int GrantBullets = Get_Max_Clip_Bullets(owner,TheWeapon->WeaponName) - Get_Clip_Bullets(owner,TheWeapon->WeaponName);
					if (TheWeapon->AmmoSize)// Ammo takes up inventory, needs special handeling
					{
						int GrantedBullets = 0;
						while (((Get_Total_Bullets(owner,TheWeapon->WeaponName) + GrantedBullets) < Get_Max_Total_Bullets(owner,TheWeapon->WeaponName)) && ((GrantBullets - GrantedBullets) > 0) && ((RP2StarCurrentInventorySize[PlayerID] + (TheWeapon->AmmoSize*GrantedBullets)) <= RP2StarMaxInventorySize[PlayerID]))
						{
							GrantedBullets++;
						}
						RP2StarCurrentInventorySize[PlayerID] += (TheWeapon->AmmoSize*GrantedBullets);
						GrantBullets = GrantedBullets;//All the ammo you get to play with due to the reduction
					}
					if (!Get_Total_Bullets(owner,TheWeapon->WeaponName))
					{
						GrantBullets = Get_Max_Total_Bullets(owner,TheWeapon->WeaponName);
					}
					else if (!Get_Max_Clip_Bullets(owner,TheWeapon->WeaponName))
					{
						GrantBullets = Get_Max_Bullets(owner,TheWeapon->WeaponName) - Get_Bullets(owner,TheWeapon->WeaponName);
						float BulletCost = (float)(GrantBullets * BulletCost2);
						if (BulletCost > Commands->Get_Money(owner))// Buy as many shells as you can if you don't have enough to buy full ammo
						{
							GrantBullets = (int)(Commands->Get_Money(owner) / BulletCost2);
							BulletCost = (float)(GrantBullets * BulletCost2);
						}
						if (GrantBullets)// Buy only if you can get at least one shell
						{
							GrantBullets = Get_Bullets(owner,TheWeapon->WeaponName) + GrantBullets; // Add all your backpack bullets to the powerup's bullets
							Commands->Give_Money(owner,BulletCost*-1.0f,0);
							Set_Bullets(owner,TheWeapon->WeaponName,GrantBullets);
							Commands->Create_Sound(Get_Parameter("Buy_Sound"),Commands->Get_Position(owner),owner);
							return;
						}
						else
						{
							char text[2000];
							sprintf(text,"It costs $%.2f to buy one round for this item, I need another $%.2f to buy a round.",(float)BulletCost2,(float)BulletCost2 - Commands->Get_Money(owner));
							Send_Message_Player(owner,127,0,0,text);
							Commands->Create_Sound(Get_Parameter("Declined_Sound"),Commands->Get_Position(owner),owner);
							return;
						}
					}
					float BulletCost = (float)(GrantBullets * BulletCost2);
					if (BulletCost > Commands->Get_Money(owner))// Buy as many shells as you can if you don't have enough to buy full ammo
					{
						GrantBullets = (int)(Commands->Get_Money(owner) / BulletCost2);
						BulletCost = (float)(GrantBullets * BulletCost2);
					}
					if (Get_Max_Clip_Bullets(owner,TheWeapon->WeaponName) == -1)// for weapons like the knife
					{
						Set_Bullets(owner,TheWeapon->WeaponName,Get_Max_Bullets(owner,TheWeapon->WeaponName));
						Set_Clip_Bullets(owner,TheWeapon->WeaponName,Get_Max_Clip_Bullets(owner,TheWeapon->WeaponName));
					}
					else if (GrantBullets)// Buy only if you can get at least one shell
					{
						int GunBullets = Get_Clip_Bullets(owner,TheWeapon->WeaponName) + GrantBullets; // Add all your backpack bullets to the powerup's bullets
						int TempCarryOver = 0;
						if (Get_Max_Clip_Bullets(owner,TheWeapon->WeaponName) < GunBullets)
						{
							TempCarryOver = GunBullets - Get_Max_Clip_Bullets(owner,TheWeapon->WeaponName);
							GunBullets = Get_Max_Clip_Bullets(owner,TheWeapon->WeaponName);
						}
						Commands->Give_Money(owner,BulletCost*-1.0f,0);
						Set_Bullets(owner,TheWeapon->WeaponName,Get_Bullets(owner,TheWeapon->WeaponName) + TempCarryOver);
						Set_Clip_Bullets(owner,TheWeapon->WeaponName,GunBullets);
						Commands->Create_Sound(Get_Parameter("Buy_Sound"),Commands->Get_Position(owner),owner);
					}
					else
					{
						char text[2000];
						sprintf(text,"It costs $%.2f to buy one round for this item, I need another $%.2f to buy a round.",(float)BulletCost2,(float)BulletCost2 - Commands->Get_Money(owner));
						Send_Message_Player(owner,127,0,0,text);
						Commands->Create_Sound(Get_Parameter("Declined_Sound"),Commands->Get_Position(owner),owner);
					}
					if (TheWeapon->AmmoSize)
					{
						Add_Or_Update_RP2PlayerSAWT_Node(PlayerID,TheWeapon->WeaponName)->LastAmmoCount = Get_Total_Bullets(owner,TheWeapon->WeaponName);
					}
				}
				Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
			}
			else
			{
				RP2_Cannot_Grant_Weapon_Reasons(owner,TheWeapon,1);
			}
		}
		Commands->Destroy_Object(obj);
	}
}

void JMG_RP2_WLS_Zone_Remove_Weapon::Entered(GameObject *obj,GameObject *enter)
{
	RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
	if (Has_Weapon(enter,TheWeapon->WeaponName))
	{
		Remove_Weapon(enter,TheWeapon->WeaponName);
		WLS_Remove_Weapon_Weight(enter,TheWeapon,Get_Player_ID(enter));
	}
}

void JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit::Created(GameObject *obj)
{
	//Commands->Set_Model(obj,"InvisiblePU");
}

void JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		int DropWeapon = 1;
		RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
		int PlayerID = Get_Player_ID(sender);
		if (!ISSELECTINGSPAWN[PlayerID] && Commands->Get_Health(sender) && ((!Has_Weapon(sender,TheWeapon->WeaponName) && Get_Weapon_Count(sender) < RP2MAXINVENTORYWEAPONLIMIT && 
			((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) && 
			((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->AmmoSize) <= RP2StarMaxInventorySize[PlayerID])) || /*You donot have the weapon, your weapon count is less then the max and your inventory weight is less than the max*/
			(Has_Weapon(sender,TheWeapon->WeaponName) && 
			((Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName) > Get_Clip_Bullets(sender,TheWeapon->WeaponName)) || !Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName)) && 
			((RP2StarCurrentInventorySize[PlayerID] + TheWeapon->AmmoSize) <= RP2StarMaxInventorySize[PlayerID]))))// You already have the weapon, and you have room for more ammo
		{
			if (Has_Weapon(sender,TheWeapon->WeaponName) && !Get_Int_Parameter("Bullets"))//Grant the weapon, but you won't get any bullets
			{
				Send_Message_Player(sender,255,127,127,"I already have the weapon I just picked up, it also seems to have no ammo, it will do me no good to take it with me.");
				DropGunSpecial(obj,Get_Int_Parameter("Bullets"),0.25f,0);// Special Version keeps it from respawning someplace random after being recreated
			}
			else
			{
				if (!Has_Weapon(sender,TheWeapon->WeaponName))// Dont have the weapon, take up some space
				{
					SpecialGivePowerup(sender,TheWeapon);
					WLS_Add_Weapon_Weight(sender,TheWeapon,PlayerID);
				}
				if (Has_Weapon(sender,TheWeapon->WeaponName))// Make SURE it has the weapon
				{
					int GrantBullets = Get_Int_Parameter("Bullets"),SpecialLeftOvers = 0;
					if (GrantBullets == -1){GrantBullets = Get_Max_Total_Bullets(sender,TheWeapon->WeaponName);}// Powerup gives max bullets
					int GunBullets;
					if (!Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName))
					{
						GunBullets = Get_Bullets(sender,TheWeapon->WeaponName) + GrantBullets;
					}
					else
					{
						GunBullets = Get_Clip_Bullets(sender,TheWeapon->WeaponName) + GrantBullets;
					}
					if (TheWeapon->AmmoSize)// Ammo takes up inventory, needs special handeling
					{
						int GrantedBullets = 0;
						while ((GrantedBullets < Get_Max_Total_Bullets(sender,TheWeapon->WeaponName)) && ((GunBullets - GrantedBullets) > 0) && ((RP2StarCurrentInventorySize[PlayerID] + (TheWeapon->AmmoSize*GrantedBullets)) <= RP2StarMaxInventorySize[PlayerID]))
						{
							GrantedBullets++;
						}
						RP2StarCurrentInventorySize[PlayerID] += (TheWeapon->AmmoSize*GrantedBullets);
						SpecialLeftOvers = GunBullets - GrantedBullets;//This needs to be dropped
						GunBullets = GrantedBullets;//All the ammo you get to play with due to the reduction
						FillTheObject(obj,GrantedBullets,SpecialLeftOvers,&DropWeapon,sender,TheWeapon);
						Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",sender,"c head");
						return;//End, previous function should handel all special cases for the object class
					}
					// FOR WEAPONS WITH INFINITE AMMO
					if ((Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName) == -1 || Get_Max_Bullets(sender,TheWeapon->WeaponName) == -1))// for weapons like the knife/wrench
					{
						if (!DropWeapon)
						{// Start Respawn
							Set_Bullets(sender,TheWeapon->WeaponName,Get_Max_Bullets(sender,TheWeapon->WeaponName));
							Set_Clip_Bullets(sender,TheWeapon->WeaponName,Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName));
							if (Get_Int_Parameter("Spawn_Limit")) // Powerup gone, start respawn timer
							{
								DropGun(obj,Get_Int_Parameter("Spawn_Bullets"),SpawnTime(),1);
								DropWeapon = 0;
							}
						}
					}
					FillTheGun(obj,GunBullets,&DropWeapon,sender,TheWeapon);
				}
			}
			Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",sender,"c head");
		}
		else
		{
			if (DropWeapon)
			{
				DropWeapon = 0;
				DropGunSpecial(obj,Get_Int_Parameter("Bullets"),0.25f,0);// Special Version keeps it from respawning someplace random after being recreated
			}
			RP2_Cannot_Grant_Weapon_Reasons(sender,TheWeapon,Get_Int_Parameter("Bullets"));
		}
	}
}

void JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit::DropGun(GameObject *obj,int Bullets,float SpawnTime,int Add)
{
	RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
	if (Get_Int_Parameter("Recreate_If_Grant_Fails") && (((TheWeapon->DropWhenEmpty && Bullets) || (!TheWeapon->DropWhenEmpty && Bullets)) && Get_Int_Parameter("Spawn_Limit")))
	{
		int Limit = Get_Int_Parameter("Spawn_Limit");
		if (Get_Int_Parameter("Spawn_Limit") > 0)
		{
			Limit -= Add;
		}
		if (!Get_Int_Parameter("Spawn_Limit") && (TheWeapon->DropWhenEmpty && Bullets))
		{
			return;
		}
		if (!Bullets)
		{
			Bullets = Get_Int_Parameter("Spawn_Bullets");
		}
		GameObject *object = Commands->Create_Object("Daves_Arrow_NT",Commands->Get_Position(obj));
		Commands->Set_Model(object,"null");
		Commands->Set_Facing(object,Commands->Get_Facing(obj));
		char params[2000];
		sprintf(params,"%s,%d,%f,%f,%f,%d,%d,%d",Get_Parameter("Weapon_Name"),Bullets,SpawnTime,Get_Float_Parameter("Spawn_Time"),Get_Float_Parameter("Random_Spawn_Time"),Limit,Get_Int_Parameter("Spawn_Bullets"),Get_Int_Parameter("Powerup_Limited"));
		Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup",params);
		Commands->Destroy_Object(obj);
	}
}

void JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit::DropGunSpecial(GameObject *obj,int Bullets,float SpawnTime,int Add)
{
	RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
	if (Get_Int_Parameter("Recreate_If_Grant_Fails") && (((TheWeapon->DropWhenEmpty && Bullets) || (!TheWeapon->DropWhenEmpty && Bullets)) && Get_Int_Parameter("Spawn_Limit")))
	{
		int Limit = Get_Int_Parameter("Spawn_Limit");
		if (Get_Int_Parameter("Spawn_Limit") > 0)
		{
			Limit -= Add;
		}
		if (!Get_Int_Parameter("Spawn_Limit") && (TheWeapon->DropWhenEmpty && Bullets))
		{
			return;
		}
		if (!Bullets)
		{
			Bullets = Get_Int_Parameter("Spawn_Bullets");
		}
		GameObject *object = Commands->Create_Object("Daves_Arrow_NT",Commands->Get_Position(obj));
		Commands->Set_Model(object,"null");
		Commands->Set_Facing(object,Commands->Get_Facing(obj));
		char params[2000];
		sprintf(params,"%s,%d,%f,%f,%f,%d,%d,%d",Get_Parameter("Weapon_Name"),Bullets,SpawnTime,Get_Float_Parameter("Spawn_Time"),Get_Float_Parameter("Random_Spawn_Time"),Get_Int_Parameter("Spawn_Limit"),Get_Int_Parameter("Spawn_Bullets"),Get_Int_Parameter("Powerup_Limited"));
		Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);
		Commands->Destroy_Object(obj);
	}
}

void JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit::FailPickup(GameObject *obj,GameObject *sender,int PlayerID,RP2WeaponListControl *TheWeapon)
{
	/*if (Has_Weapon(sender,TheWeapon->AltWeaponName))// Give the weight back beings secondary weapon could not be granted
	{
		RP2StarCurrentInventorySize[PlayerID] += TheWeapon->WeaponSize;
	}*/
	RP2_Cannot_Grant_Weapon_Reasons(sender,TheWeapon,Get_Int_Parameter("Bullets"));
}

void JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit::FillTheGun(GameObject *obj,int GunBullets,int *DropWeapon,GameObject *sender,RP2WeaponListControl *TheWeapon)
{
	if (!Get_Total_Bullets(sender,TheWeapon->WeaponName) || !Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName))// Gun is empty, fill clip first
	{
		if (GunBullets > Get_Max_Bullets(sender,TheWeapon->WeaponName))// plenty of ammo
		{
			Set_Bullets(sender,TheWeapon->WeaponName,Get_Max_Bullets(sender,TheWeapon->WeaponName));
			GunBullets -= Get_Max_Bullets(sender,TheWeapon->WeaponName);
		}
		else// not enough ammo
		{
			Set_Bullets(sender,TheWeapon->WeaponName,GunBullets);
			GunBullets = 0;
		}
	}
	if (GunBullets > Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName))// plenty of ammo
	{
		GunBullets -= Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName);
		Set_Clip_Bullets(sender,TheWeapon->WeaponName,Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName));
	}
	else
	{
		Set_Clip_Bullets(sender,TheWeapon->WeaponName,GunBullets);
		GunBullets = 0;
	}
	if (*DropWeapon)
	{
		if ((Get_Int_Parameter("Spawn_Limit") - 1))
		{
			DropGun(obj,Get_Int_Parameter("Spawn_Bullets"),SpawnTime(),1);
			*DropWeapon = 0;
		}
		else
		{
			*DropWeapon = 0;
			DropGunSpecial(obj,GunBullets,0.25f,0);
		}
	}
	// UPDATE INVENTORY WEIGHTS
	if (TheWeapon->AmmoSize)
	{
		int PlayerID = Get_Player_ID(sender);
		Add_Or_Update_RP2PlayerSAWT_Node(PlayerID,TheWeapon->WeaponName)->LastAmmoCount = Get_Total_Bullets(sender,TheWeapon->WeaponName);
	}
}

void JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit::FillTheObject(GameObject *obj,int GunBullets,int LeftOvers,int *DropWeapon,GameObject *sender,RP2WeaponListControl *TheWeapon)
{
	if (!Get_Total_Bullets(sender,TheWeapon->WeaponName))// Gun is empty, fill clip first
	{
		if (GunBullets > Get_Max_Bullets(sender,TheWeapon->WeaponName))// plenty of ammo
		{
			Set_Bullets(sender,TheWeapon->WeaponName,Get_Max_Bullets(sender,TheWeapon->WeaponName));
			GunBullets -= Get_Max_Bullets(sender,TheWeapon->WeaponName);
		}
		else// not enough ammo
		{
			Set_Bullets(sender,TheWeapon->WeaponName,GunBullets);
			GunBullets = 0;
		}
	}
	if (GunBullets > Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName))// plenty of ammo
	{
		GunBullets -= Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName);
		Set_Clip_Bullets(sender,TheWeapon->WeaponName,Get_Max_Clip_Bullets(sender,TheWeapon->WeaponName));
	}
	else
	{
		Set_Clip_Bullets(sender,TheWeapon->WeaponName,GunBullets);
		GunBullets = 0;
	}
	if (*DropWeapon)
	{
		if (GunBullets || LeftOvers)
		{
			*DropWeapon = 0;
			DropGunSpecial(obj,(GunBullets+LeftOvers),0.25f,0);
		}
		else if (Get_Int_Parameter("Spawn_Limit"))
		{
			DropGun(obj,Get_Int_Parameter("Spawn_Bullets"),SpawnTime(),1);
			*DropWeapon = 0;
		}
	}
	// UPDATE INVENTORY WEIGHTS
	if (TheWeapon->AmmoSize)
	{
		int PlayerID = Get_Player_ID(sender);
		Add_Or_Update_RP2PlayerSAWT_Node(PlayerID,TheWeapon->WeaponName)->LastAmmoCount = Get_Total_Bullets(sender,TheWeapon->WeaponName);
	}
}

float JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit::SpawnTime()
{
	float RandomTime = Commands->Get_Random(0.0f,Get_Float_Parameter("Random_Spawn_Time")) + Get_Float_Parameter("Spawn_Time");
	if (RandomTime < 0.1f)
	{
		RandomTime = 0.1f;
	}
	return RandomTime;
}

void JMG_RP2_WLS_New_Decoy_Recreate_Powerup::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("MySpawnTime"),955551);
}

void JMG_RP2_WLS_New_Decoy_Recreate_Powerup::Timer_Expired(GameObject *obj,int number)
{
	if (955551 == number)
	{
		RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
		if (!TheWeapon)
		{
			Console_Input("MESSAGE WEAPON DROP ERROR: Weapon Node is missing!");
			Commands->Destroy_Object(obj);
			return;
		}
		Vector3 Pos = Commands->Get_Position(obj);
		GameObject *NearestStar = Commands->Get_A_Star(Pos);
		if (Commands->Get_Distance(Commands->Get_Position(NearestStar),Pos) > TheWeapon->RespawnDistance)
		{
			GameObject *object = Commands->Create_Object(TheWeapon->FakePowerUpName,Pos);
			Commands->Set_Facing(object,Commands->Get_Facing(obj));
			char params[2000];
			int Bullets = Get_Int_Parameter("Bullets");
			if (Get_Int_Parameter("Powerup_Limited"))
			{
				DroppedWeaponControl *Node = Find_Nearby_Dropped_Powerups(obj,TheWeapon->WeaponName);
				if (Node)
				{
					GameObject *Object = Commands->Find_Object(Node->PowerupID);
					if (Object)
					{
						Bullets += Node->Bullets;
						Node->Bullets = 0;
						Commands->Destroy_Object(Object);
					}
				}
				Dropped_Weapon_Limiter(object,TheWeapon,Bullets);
			}
			sprintf(params,"%s,%d,%d,%f,%f,%d,%d,%d",Get_Parameter("Weapon_Name"),1,Bullets,Get_Float_Parameter("SpawnTime"),Get_Float_Parameter("RandomSpawnTime"),Get_Int_Parameter("Spawn_Limit"),Get_Int_Parameter("Spawn_Bullets"),Get_Int_Parameter("Powerup_Limited"));
			Commands->Attach_Script(object,"JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit",params);
			Commands->Destroy_Object(obj);
		}
		else
		{
			Commands->Start_Timer(obj,this,0.25f,955551);
		}
	}
}

void JMG_RP2_Set_Up_Weapons_List::Created(GameObject *obj)
{	
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_357_Magnum,POW_357_Magnum,POW_357_Magnum_WL,													1,2.0,300,1,0.25,1.25,null,1,1,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Army_Laser_Rifle,POW_Army_Laser_Rifle,POW_Army_Laser_Rifle_WL,								1,4.0,500,2,0.25,1.25,null,1,3,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Auto_Shotgun,POW_Auto_Shotgun,POW_Auto_Shotgun_WL,											1,4.0,300,1,0.25,1.25,null,1,2,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Auto_Shotgun_Infinite,POW_Auto_Shotgun_Infinite,POW_Auto_Shotgun_Infinite_WL,					0,0.0,0,0,0.25,1.25,null,1,2,0,3,0.0,0,0");
	//Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Jointchaingun,POW_Cannablaster,POW_Cannablaster_WL,											1,10.0,0,0,0.25,1.75,null,1,8,0,2,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Jointchaingun,POW_Cannablaster,POW_Cannablaster_WL,											1,10.0,200,10,0.25,1.75,null,1,8,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Cloak,POW_Cloak_Weapon,POW_Cloak_Weapon_WL,													1,1.0,0,0,0.25,1.25,null,0,14,0,3,0.0,1,0");// Bullets only cost money
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Handcuffs,POW_Cuffs,POW_Cuffs_WL,																1,1.0,0,0,0.25,1.25,null,0,14,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Darts,POW_Darts,POW_Darts_WL,																	1,0.0,0,0,0.25,1.25,null,0,14,0,1,0.1f,1,0");// Bullets only cost money
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Flashlight,POW_Flash_Light,POW_Flash_Light_WL,												1,1.0,150,0,0.25,1.25,null,0,14,7745470,1,0.0,1,0");// Turn off light on drop
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Dual_Barrel_Sgun,POW_Double_Barrel_Sgun,POW_Double_Barrel_Sgun_WL,							1,4.0,430,1,0.25,1.25,null,1,2,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_G3A3,POW_G3A3,POW_G3A3_WL,																	1,4.0,400,1,0.25,2.25,null,1,7,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Gatling_Gun,POW_Gatling_Gun,POW_Gatling_Gun_WL,												1,10.0,900,1,0.25,2.75,null,1,8,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_M32_Multiple_Grenade_Launcher,POW_Grenade_Launcher,POW_Grenade_Launcher_WL,					1,6.0,500,3,0.25,1.25,null,1,4,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Laser_lol,POW_Laser_lol,POW_Laser_lol_WL,														1,4.0,1000,3,0.25,1.25,null,1,3,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Liquid_Nitrogen,POW_Liquid_Nitrogen,POW_Liquid_Nitrogen_WL,									1,4.0,500,0,0.25,1.25,null,1,13,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Liquid_Nitrogen_Infinity,POW_Liquid_Nitrogen_Infinity,POW_Liquid_Nitrogen_Infinity_WL,		0,0.0,0,0,0.25,1.25,null,1,13,0,3,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_M1_Garand,POW_M1_Garand,POW_M1_Garand_WL,														1,4.0,450,1,0.25,2.25,null,1,3,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_M203_Grenade_Launcher,POW_M203_Grenade_Launcher,POW_M203_Grenade_Launcher_WL,					1,4.0,0,0,0.25,1.25,Weapon_M4A1_Carbine,1,4,0,1,0.0,1,0");//Special
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Mauser_C96,POW_Mauser_C96,POW_Mauser_C96_WL,													1,2.0,300,1,0.25,1.25,null,1,1,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_MP5,POW_MP5,POW_MP5_WL,																		1,3.0,600,1,0.25,1.25,null,1,15,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Needle,POW_New_Needle,POW_New_Needle_WL,														1,1.0,0,0,0.25,1.25,null,1,10,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Rickroll_Radio,POW_Rickroll_Radio,POW_Rickroll_Radio_WL,										0,0.0,0,0,0.25,1.25,null,1,14,0,3,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Thompson,POW_Thompson,POW_Thompson_WL,														1,4.0,900,1,0.25,1.75,null,1,7,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Throwing_Star,POW_Throwing_Stars,POW_Throwing_Stars_WL,										1,0.0,0,20,0.25,1.25,null,0,14,0,1,0.05,1,0");// SPECIAL AMMO
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Wrench,POW_Wrench,POW_Wrench_WL,																1,2.0,0,0,0.25,1.25,null,0,14,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Flare_Gun,POW_Flare_Gun,POW_Flare_Gun_WL,														1,4.0,0,0,0.25,1.25,null,1,14,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_AK-47,POW_AK-47,POW_AK-47_WL,																	1,3.0,500,1,0.25,1.75,null,1,7,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Barrett_M82,POW_Barrett_M82,POW_Barrett_M82_WL,												1,8.0,1000,2,0.25,2.75,null,1,16,0,2,0.0,1,0");// was 3 but changed to 8 for better balance
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Beretta_92FS,POW_Beretta_92FS,POW_Beretta_92FS_WL,											1,1.0,800,1,0.25,1.25,null,1,1,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Bitchslap,POW_Bitchslap,POW_Bitchslap,														0,0.0,0,0,0.25,1.25,null,1,0,0,0,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Cell_Phone,POW_Cell_Phone,POW_Cell_Phone_WL,													1,1.0,0,0,0.25,1.25,null,0,9,PHONEResetCustom,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Empty_Hands,POW_Empty_Hands,POW_Empty_Hands_WL,												0,0.0,0,0,0.25,1.25,null,1,0,0,0,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_FIM-92_Stinger,POW_FIM-92_Stinger,POW_FIM-92_Stinger_WL,										1,8.0,0,0,0.25,1.25,null,1,5,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Flak_Cannon,POW_Flak_Cannon,POW_Flak_Cannon_WL,												1,10.0,0,0,0.25,1.25,null,1,6,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Flamethrower,POW_Flamethrower,POW_Flamethrower_WL,											1,4.0,800,0,0.25,1.25,null,1,13,3743374,3,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Fragmentation_Grenade,POW_Fragmentation_Grenade,POW_Fragmentation_Grenade_WL,					1,0.0,0,100,0.25,1.25,null,0,17,0,1,0.2,1,0");// Bullets only cost money
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Glock,POW_Glock,POW_Glock_WL,																	1,1.0,300,1,0.25,1.25,null,1,1,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Gravity_Gun,POW_Gravity_Gun,POW_Gravity_Gun_WL,												1,6.0,0,0,0.25,1.25,null,1,14,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Katana,POW_Katana,POW_Katana_WL,																1,4.0,500,0,0.25,1.25,null,1,11,0,2,0.0,1,0");// Size wise its a 6 but we'll set it to 4 for gameplay balance
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Knife,POW_Knife,POW_Knife_WL,																	1,2.0,200,0,0.25,1.25,null,1,12,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_M16A2,POW_M16A2,POW_M16A2_WL,																	1,4.0,800,1,0.25,1.25,null,1,7,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_M18_Smoke_Grenade_White,POW_M18_Smoke_Grenade_White,POW_M18_Smoke_Grenade_White_WL,			1,0.0,0,80,0.25,1.25,null,0,17,0,1,0.5,1,0");// Bullets only cost money
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_M4A1_Carbine,POW_M4A1_Carbine,POW_M4A1_Carbine_WL,											1,4.0,1000,1,0.25,1.25,Weapon_M203_Grenade_Launcher,1,7,0,1,0.0,1,0");//Special
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_M4A1_Carbine_Infinite,POW_M4A1_Carbine_Infinite,POW_M4A1_Carbine_Infinite_WL,					0,0.0,0,0,0.25,1.25,Weapon_M203_Grenade_Launcher,1,7,0,3,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Organs_Gun,POW_ORGANS_Gun,POW_ORGANS_Gun_WL,													1,4.0,0,0,0.25,1.25,null,1,14,0,3,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_M72_LAW,POW_M72_LAW,POW_M72_LAW_WL,															1,6.0,300,300,0.25,1.25,null,1,5,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Melee_Kick,POW_Melee_Kick,POW_Melee_Kick,														0,0.0,0,0,0.25,1.25,null,1,0,0,0,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Molotov_Cocktail,POW_Molotov_Cocktail,POW_Molotov_Cocktail_WL,								1,0.0,0,100,0.25,1.25,null,0,4,0,1,0.3,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_P90,POW_P90,POW_P90_WL,																		1,3.0,300,1,0.25,1.75,null,1,7,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_RPG-7,POW_RPG-7,POW_RPG-7_WL,																	1,6.0,300,200,0.25,1.25,null,1,5,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Rubber_Ducky,POW_Rubber_Duckies,POW_Rubber_Duckies_WL,										0,0.0,0,0,0.25,1.25,null,1,14,0,3,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Shotgun,POW_Shotgun,POW_Shotgun_WL,															1,2.0,400,1,0.25,1.75,null,1,2,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Silenced_Pistol,POW_Silenced_Pistol,POW_Silenced_Pistol_WL,									1,2.0,500,1,0.25,1.25,null,1,1,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Assult_Rifle,POW_Assult_Rifle,POW_Assult_Rifle_WL,											1,3.0,200,1,0.25,1.25,null,1,7,0,3,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Vortex_Beacon,POW_Vortex_Beacon,POW_Vortex_Beacon_WL,											0,6.0,0,0,0.25,1.25,null,0,10,0,3,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Plasma_Torpedo_Launcher,POW_Plasma_Torpedo_Launcher,POW_Plasma_Torpedo_Launcher_WL,			1,12.0,1200,50,0.25,1.25,null,1,5,0,3,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Rocket_Launcher_Halo_Style,POW_Rocket_Launcher_Halo_Style,POW_Rocket_Launcher_Halo_Style_WL,	1,10.0,250,100,0.25,1.25,null,1,5,0,3,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Tranquilizer_Gun,POW_Tranquilizer_Gun,POW_Tranquilizer_Gun_WL,								1,3.0,150,10,0.25,1.25,null,1,1,0,3,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Shotgun_Jerad,POW_Jerad's_Shot_Gun,null,														0,4.0,0,0,0.25,1.25,null,1,2,0,3,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Drugs,POW_Drugs,POW_Drugs_WL,																	1,0.0,0,100,0.25,1.25,null,0,10,0,0,0.2,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Detox,POW_Detox,POW_Detox_WL,																	1,0.0,0,1000,0.25,1.25,null,0,10,0,0,1.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Micro_SMG,POW_Micro_SMG,POW_Micro_SMG_WL,														1,3.0,800,1,0.25,1.25,null,1,15,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Pain_Pills,POW_Pain_Pills,POW_Pain_Pills_WL,													1,1.0,0,0,0.25,1.25,null,0,10,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Floppy_Disk,POW_Floppy_Disk,POW_Floppy_Disk_WL,												1,0.0,0,1,0.25,1.25,null,0,10,0,0,0.1f,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Floppy_Disk9,POW_Floppy_Disk9,POW_Floppy_Disk_WL9,											1,0.0,0,0,0.25,1.25,null,0,10,0,0,0.1f,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Vortex_Beacon_Player,POW_Vortex_Beacon_Player,POW_Vortex_Beacon_Player_WL,					1,0.0,500,0,0.25,1.75,null,0,10,0,3,4.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Particle_Projection_Rifle,POW_Particle_Projection_Rifle,POW_Particle_Projection_Rifle_WL,		1,5.0,1200,125,0.25,1.75,null,1,16,0,3,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Tactical_Nuke,POW_Tactical_Nuke,POW_Tactical_Nuke_WL,											1,0.0,0,3600,0.25,1.75,null,0,10,0,3,4.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Pizza,POW_Pizza,POW_Pizza_WL,																	1,0.0,0,100,0.25,1.25,null,0,10,0,0,0.25,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Dummy_Credit_Info,Dummy_Credit_Info,Dummy_Credit_Info,												1,0.0,0,0,0.0,0.0,null,0,10,0,0,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_AK-74,POW_AK-74,POW_AK-74_WL,																	1,4.0,600,1,0.25,1.75,null,1,7,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Battering_Ram,POW_Battering_Ram,POW_Battering_Ram_WL,											1,5.0,700,0,0.25,1.75,null,1,14,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Parachute,POW_Parachute,POW_Parachute_WL,														1,2.0,200,10,0.25,1.75,null,1,14,0,0,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Zombie_Melee,null,null,																		0,4.0,0,0,0.25,1.25,null,1,14,0,3,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Zombie_Freeze_Breath_lol,null,null,															0,4.0,0,0,0.25,1.25,null,1,14,0,3,0.0,0,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_AWP,POW_AWP,POW_AWP_WL,																		1,7.0,950,2,0.25,2.75,null,1,16,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Ammo_Box,POW_Ammo_Box,POW_Ammo_Box_WL,														1,3.0,200,10,0.5,2.75,null,1,14,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_M249_SAW,POW_M249_SAW,POW_M249_SAW_WL,														1,10.0,900,1,0.25,2.75,null,1,8,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Fire,POW_RAT_Fire,POW_RAT_Fire_WL,															1,1.0,1000,0,0.25,1.25,null,1,14,0,2,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Mac10,POW_Mac10,POW_Mac10_WL,																	1,2.0,700,1,0.25,1.25,null,1,15,0,1,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Radio,POW_Radio,POW_Radio_WL,																	1,2.0,50,0,0.25,1.25,null,1,14,0,1,0.0,1,0");

	//Ren Weapons
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_AutoRifle_Player,CnC_POW_AutoRifle_Player_GDI,CnC_POW_AutoRifle_Player_GDI_WL,			1,4.0,150,0,0.25,1.25,null,1,15,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_AutoRifle_Player_Nod,CnC_POW_AutoRifle_Player_Nod,CnC_POW_AutoRifle_Player_Nod_WL,		1,4.0,150,0,0.25,1.25,null,1,15,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Chaingun_Player,POW_Chaingun_Player,POW_Chaingun_Player_WL,									1,6.0,275,0,0.25,1.25,null,1,15,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Chaingun_Player_Nod,POW_Chaingun_Player_Nod,POW_Chaingun_Player_Nod_WL,						1,6.0,275,0,0.25,1.25,null,1,15,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CNC_Weapon_ChemSprayer_Player,POW_ChemSprayer_Player,POW_ChemSprayer_Player_WL,						1,6.0,250,0,0.25,1.25,null,1,13,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CNC_Weapon_Flamethrower_Player,POW_Flamethrower_Player,POW_Flamethrower_Player_WL,					1,3.0,150,0,0.25,1.25,null,1,13,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_GrenadeLauncher_Player,POW_GrenadeLauncher_Player,POW_GrenadeLauncher_Player_WL,				1,4.0,100,10,0.25,1.25,null,1,4,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_IonCannonBeacon_Player,CnC_POW_IonCannonBeacon_Player,CnC_POW_IonCannonBeacon_Player_WL,	1,0.0,0,1000,0.25,1.25,null,0,10,0,0,1.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_LaserChaingun_Player,POW_LaserChaingun_Player,POW_LaserChaingun_Player_WL,					1,6.0,450,0,0.25,1.25,null,1,13,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_LaserRifle_Player,POW_LaserRifle_Player,POW_LaserRifle_Player_WL,								1,5.0,400,0,0.25,1.25,null,1,3,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_MineProximity_Player,CnC_MineProximity_05,CnC_MineProximity_05_WL,							1,0.0,0.0,75,0.25,1.25,null,0,10,3,0,0,1.25,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_MineRemote_Player_2Max,CnC_POW_MineRemote_02,CnC_POW_MineRemote_02_WL,					1,0.0,0.0,25,0.25,1.25,null,0,10,3,0,0,0.75,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_MineTimed_Player_2Max,CnC_POW_MineTimed_Player_02,CnC_POW_MineTimed_Player_02_WL,			1,0.0,0.0,50,0.25,1.25,null,0,10,3,0,0,1.00,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_NukeBeacon_Player,CnC_POW_Nuclear_Missle_Beacon,CnC_POW_Nuclear_Missle_Beacon_WL,			1,0.0,0.0,1000,0.25,1.25,null,0,10,3,0,0,1.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_PersonalIonCannon_Player,POW_PersonalIonCannon_Player,POW_PersonalIonCannon_Player_WL,		1,8.0,1000,0,0.25,1.25,null,1,7,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CNC_Weapon_Pistol_Player,POW_Pistol_Player,POW_Pistol_Player_WL,										1,1.0,50,1,0.25,1.25,null,1,1,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Railgun_Player,POW_Railgun_Player,POW_Railgun_Player_WL,										1,8.0,1200,0,0.25,1.25,null,1,7,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_RamjetRifle_Player,POW_RamjetRifle_Player,POW_RamjetRifle_Player_WL,						1,9.0,1000,0,0.25,1.25,null,1,7,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_RepairGun_Player_Special,CnC_POW_RepairGun_Player,CnC_POW_RepairGun_Player_WL,			1,4.0,50,0,0.25,1.25,null,1,14,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_RocketLauncher_Player,CnC_POW_RocketLauncher_Player,CnC_POW_RocketLauncher_Player_WL,		1,6.0,400,0,0.25,1.25,null,1,5,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_Shotgun_Player,POW_Shotgun_Player,POW_Shotgun_Player_WL,										1,5.0,100,0,0.25,1.25,null,1,2,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_SniperRifle_Player,POW_SniperRifle_Player,POW_SniperRifle_Player_WL,						1,6.0,500,0,0.25,1.25,null,1,7,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","CnC_Weapon_SniperRifle_Player_Nod,POW_SniperRifle_Player_Nod,POW_SniperRifle_Player_Nod_WL,			1,6.0,500,0,0.25,1.25,null,1,7,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_TiberiumAutoRifle_Player,POW_TiberiumAutoRifle_Player,POW_TiberiumAutoRifle_Player_WL,		1,6.0,250,0,0.25,1.25,null,1,7,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_TiberiumFlechetteGun_Player,POW_TiberiumFlechetteGun_Player,POW_TiberiumFlechetteGun_Player_WL,1,5.0,450,0,0.25,1.25,null,1,15,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_VoltAutoRifle_Player,POW_VoltAutoRifle_Player,POW_VoltAutoRifle_Player_WL,					1,5.0,500,0,0.25,1.25,null,1,15,0,0,0.0,1,0");
	Commands->Attach_Script(obj,"JMG_RP2_WLS_Add_Weapon_Type","Weapon_VoltAutoRifle_Player_Nod,CnC_POW_VoltAutoRifle_Player_Nod,CnC_POW_VoltAutoRifle_Player_Nod_WL,1,5.0,500,0,0.25,1.25,null,1,15,0,0,0.0,1,0");
	//Weapon_Name,Powerup_Name,Fake_Powerup,Droppable,Weapon_Size,Weapon_Cost,Bullet_Cost,Drop_Height,Respawn_Distance,Alt_Weapon_Name,Drop_When_Empty,Weapon_Class,Drop_Message,Weapon_Tier,Ammo_Size,Can_Favorite,Cook_Time
}

void JMG_RP2_Housing_Weapons_Cupboard_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		if (!Get_Vehicle(enter) && !ISSELECTINGSPAWN[Get_Player_ID(enter)])
		{
			Commands->Send_Custom_Event(obj,enter,4045146,Get_Int_Parameter("CupboardID"),0);
			Commands->Send_Custom_Event(enter,Commands->Find_Object(Get_Int_Parameter("CupboardID")),4045147,1,0);
		}
	}
}

void JMG_RP2_Housing_Weapons_Cupboard_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (Commands->Is_A_Star(exit))
	{
		if (!Get_Vehicle(exit))
		{
			Commands->Send_Custom_Event(obj,exit,4045146,0,0);
		}
	}
}

void JMG_RP2_Housing_Weapons_Cupboard_WLS::Created(GameObject *obj)
{
	Weapon = NULL;
	AmmoPercent = 0.0f;
	GiveOutWeapon = 0;
	DownTime = 0;
	WeaponNode = NULL;
	CanState = 1;
	HouseNode = NULL;
	Commands->Start_Timer(obj,this,1.5f,4045146);
	Commands->Start_Timer(obj,this,1.0f,4045147);
}

void JMG_RP2_Housing_Weapons_Cupboard_WLS::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 4045146)
	{
		if (Commands->Is_A_Star(sender) && Is_Owned())
		{
			GameObject *Player = Get_GameObj_By_Player_Name(HouseNode->PlayerName);
			if (Player == sender)// You must now own the cupboard to swap the weapon it holds
			{
				const char *PlayerWeapon = Get_Current_Weapon(sender);
				if (PlayerWeapon)
				{
					Weapon = Get_WLS_Weapon_Settings(PlayerWeapon);
					if (Weapon)
					{
						if (WeaponNode)
						{
							sprintf(WeaponNode->Weapon,"%s",Weapon->WeaponName);
						}
						Commands->Enable_HUD_Pokable_Indicator(obj,1);
						GiveOutWeapon = 600;
						if (Get_Max_Clip_Bullets(sender,Weapon->WeaponName) == -1)// for weapons like the knife
						{
							AmmoPercent = 1.0f;
						}
						else
						{
							AmmoPercent = 0;
						}
						GiveOutWeapon = 0;
						Commands->Give_PowerUp(obj,Weapon->PowerUpName,true);
						const char *CurrentWeapon = Get_Current_Weapon(obj);
						if (CurrentWeapon)
						{
							Remove_Weapon(obj,CurrentWeapon);
						}
						char Weapon[2000];
						sprintf(Weapon,"Your weapons cupboard has been set to regenerate a %s.",Get_Weapon_Name());
						Send_Message_Player(sender,160,127,50,Weapon);
					}
				}
				else
				{
					Console_Input("MESSAGE ERROR: PLAYER WEAPON IS unknown!");
				}
				if (AmmoPercent < 1)
				{
					CanState = 1;
				}
				else
				{
					CanState = 0;
				}
			}
			else
			{
				Send_Message_Player(sender,160,127,50,"Only the owner of the house can place weapons into the cupboard.");
			}
		}
	}
	if (message == 4045147)
	{
		if (_stricmp(WeaponNode->Weapon,"null") && Weapon)
		{
			char WeaponText[2000];
			sprintf(WeaponText,"This weapon cupboard currently has a %s.",Get_Weapon_Name());
			Send_Message_Player(sender,160,127,50,WeaponText);
		}
		else
		{
			Send_Message_Player(sender,160,127,50,"This weapon cupboard is currently empty.");
		}
	}
}

void JMG_RP2_Housing_Weapons_Cupboard_WLS::Timer_Expired(GameObject *obj, int number)
{
	if (number == 4045146)
	{
		if (Weapon)
		{
			if (GiveOutWeapon == GIVEOUTNEWWEAPONTIMEM1 && Weapon->DropWhenEmpty && Is_Owned())
			{
				GameObject *HouseOwner = Get_GameObj_By_Player_Name(HouseNode->PlayerName);
				if (HouseOwner)
				{
					char WeaponText[2000];
					sprintf(WeaponText,"Weapons cupboard: Your %s is now in stock.",Get_Weapon_Name());
					Send_Message_Player(HouseOwner,160,127,50,WeaponText);
				}
			}
			if (GiveOutWeapon < GIVEOUTNEWWEAPONTIME)
			{
				GiveOutWeapon++;
			}
			if (DownTime < 10)
			{
				DownTime++;
			}
			if (AmmoPercent >= 1.0f && Is_Owned() && CanState)
			{
				CanState = 0;
				GameObject *HouseOwner = Get_GameObj_By_Player_Name(HouseNode->PlayerName);
				if (HouseOwner)
				{
					char WeaponText[2000];
					sprintf(WeaponText,"Weapons cupboard: Your %s is at its max.",Get_Weapon_Name());
					Send_Message_Player(HouseOwner,160,127,50,WeaponText);
				}
			}
			if (AmmoPercent < 1.0f && DownTime >= 10 && GiveOutWeapon >= GIVEOUTNEWWEAPONTIME)
			{
				AmmoPercent += 0.001f;
			}
		}
		if (GiveOutWeapon >= GIVEOUTNEWWEAPONTIME)
		{
			Commands->Set_Health(obj,Commands->Get_Max_Health(obj)*AmmoPercent+0.1f);
		}
		else
		{
			Commands->Set_Health(obj,1);
		}
		Commands->Start_Timer(obj,this,0.25f,4045146);
	}
	if (number == 4045147)
	{
		if (!WeaponNode)
		{
			DataNode(obj);
		}
		if (WeaponNode)
		{
			if (Is_Owned())
			{
				Weapon = Get_WLS_Weapon_Settings(WeaponNode->Weapon);
				if (Weapon)
				{
					if (WeaponNode)
					{
						sprintf(WeaponNode->Weapon,"%s",Weapon->WeaponName);
					}
					Commands->Enable_HUD_Pokable_Indicator(obj,1);
					AmmoPercent = 0.0f;
					GiveOutWeapon = 0;
					Commands->Give_PowerUp(obj,Weapon->PowerUpName,true);
					const char *CurrentWeapon = Get_Current_Weapon(obj);
					if (CurrentWeapon)
					{
						Remove_Weapon(obj,CurrentWeapon);
					}
					// Rename preset (Little on the hacky side, but its the best I can do for now)
					/*DamageableGameObjDef *d = (DamageableGameObjDef *)Get_Definition(obj);
					d->TranslatedNameID = Get_Translated_Weapon_ID(obj,Get_Gun_Position(obj,Weapon->WeaponName));*/
				}
			}
			else
			{
				if (WeaponNode)
				{
					sprintf(WeaponNode->Weapon,"null");
				}
			}
		}
	}
}

void JMG_RP2_Housing_Weapons_Cupboard_WLS::Poked(GameObject *obj,GameObject *poker)
{
	if (Weapon)//Crashes on poke
	{
		int PlayerID = Get_Player_ID(poker);
		if (!ISSELECTINGSPAWN[PlayerID] && ((!Has_Weapon(poker,Weapon->WeaponName) && Get_Weapon_Count(poker) < RP2MAXINVENTORYWEAPONLIMIT && (RP2StarCurrentInventorySize[PlayerID] + Weapon->WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) || (Has_Weapon(poker,Weapon->WeaponName) && Get_Max_Clip_Bullets(poker,Weapon->WeaponName) > Get_Clip_Bullets(poker,Weapon->WeaponName))))
		{
			int GrantBullets = Grant_Ammo_Amount();
			if (!Has_Weapon(poker,Weapon->WeaponName))
			{
				if ((GiveOutWeapon >= GIVEOUTNEWWEAPONTIME && Weapon->DropWhenEmpty) || (!Weapon->DropWhenEmpty && GrantBullets >= 1))
				{
					GiveOutWeapon = 0;
					WLS_Add_Weapon_Weight(poker,Weapon,PlayerID);
					SpecialGivePowerup(poker,Weapon);
				}
				else
				{
					Send_Message_Player(poker,160,127,50,"This weapons cupboard needs more time to get your gun in stock.");
				}
			}
			if (Has_Weapon(poker,Weapon->WeaponName))//Give Ammo
			{
				if (GrantBullets >= 1 || Get_Max_Clip_Bullets(poker,Weapon->WeaponName) == -1)
				{
					DownTime = 0;
					if (Get_Total_Bullets(poker,Weapon->WeaponName) < Get_Max_Total_Bullets(poker,Weapon->WeaponName))
					{
						if (Get_Total_Bullets(poker,Weapon->WeaponName) + GrantBullets > Get_Max_Total_Bullets(poker,Weapon->WeaponName))
						{
							int Refund = (Get_Total_Bullets(poker,Weapon->WeaponName) + GrantBullets) - Get_Max_Total_Bullets(poker,Weapon->WeaponName);
							GrantBullets -= Refund; 
							AmmoPercent = (float)Refund / Get_Max_Total_Bullets(poker,Weapon->WeaponName);
						}
						else if (Get_Max_Clip_Bullets(poker,Weapon->WeaponName) != -1)// for weapons like the knife
						{
							AmmoPercent = 0;
						}
					}
					if (Get_Max_Clip_Bullets(poker,Weapon->WeaponName) == -1)// for weapons like the knife
					{
						Set_Bullets(poker,Weapon->WeaponName,Get_Max_Bullets(poker,Weapon->WeaponName));
						Set_Clip_Bullets(poker,Weapon->WeaponName,Get_Max_Clip_Bullets(poker,Weapon->WeaponName));
						AmmoPercent = 0;
					}
					else
					{
						int GunBullets = Get_Clip_Bullets(poker,Weapon->WeaponName) + GrantBullets; // Add all your backpack bullets to the powerup's bullets
						int TempCarryOver = 0;
						if (Get_Max_Clip_Bullets(poker,Weapon->WeaponName) < GunBullets)
						{
							TempCarryOver = GunBullets - Get_Max_Clip_Bullets(poker,Weapon->WeaponName);
							GunBullets = Get_Max_Clip_Bullets(poker,Weapon->WeaponName);
						}
						Set_Bullets(poker,Weapon->WeaponName,Get_Bullets(poker,Weapon->WeaponName) + TempCarryOver);
						Set_Clip_Bullets(poker,Weapon->WeaponName,GunBullets);
					}
				}
				else
				{
					Send_Message_Player(poker,160,127,50,"This weapons cupboard needs more time to get ammo in stock.");
				}
			}
			Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
		}
		else
		{
			RP2_Cannot_Grant_Weapon_Reasons(poker,Weapon,1);
		}
	}
	else
	{
		Send_Message_Player(poker,160,127,50,"You must first drop a weapon into the weapons cupboard.");
	}
}

void JMG_RP2_Housing_Weapons_Cupboard_WLS::Find_House_Node()
{
	HouseNode = Find_Housing_Node(Get_Int_Parameter("HouseAddress"));
}

int JMG_RP2_Housing_Weapons_Cupboard_WLS::Is_Owned()
{
	if (!HouseNode)
	{
		HouseNode = Find_Housing_Node(Get_Int_Parameter("HouseAddress"));
	}
	if (HouseNode)
	{
		return HouseNode->IsOwned;
	}
	return 0;
}

void JMG_RP2_Housing_Weapons_Cupboard_WLS::DataNode(GameObject *obj)
{
	int MyID = Commands->Get_ID(obj);
	if (!WeaponCupboardNode)
	{
		Weapon = NULL;
		WeaponCupboardNode = new WeaponCupboardControl;
		sprintf(WeaponCupboardNode->Weapon,"null");
		WeaponCupboardNode->ID = MyID;
		WeaponNode = WeaponCupboardNode;
		WeaponCupboardNode->next = NULL;
	}
	else
	{
		int end = 0;
		WeaponCupboardControl *Current = WeaponCupboardNode;
		while (Current != NULL && end == 0)
		{
			if (Current->ID == MyID)
			{
				end = 1;
				WeaponNode = Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Weapon = NULL;
				Current->next = new WeaponCupboardControl;
				Current = Current->next;
				WeaponNode = Current;
				sprintf(Current->Weapon,"null");
				Current->ID = MyID;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

unsigned long JMG_RP2_Housing_Weapons_Cupboard_WLS::Get_Translated_Weapon_ID(GameObject *obj,int position)
{
	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
	if (!o2){return 0;}
	ArmedGameObj *o3 = o2->As_ArmedGameObj();
	if (!o3){return 0;}
	WeaponBagClass *w = o3->Get_Weapon_Bag();
	if ((position) && (position < w->Get_Count()))
	{
		return (w->Peek_Weapon(position)->Get_Definition()->IconNameID);
	}
	return 0;
}

char *JMG_RP2_Housing_Weapons_Cupboard_WLS::Get_Weapon_Name()
{
	static char WeaponName[237];
	sprintf(WeaponName,"null");
	if (WeaponNode)
	{
		GameObject *TempObject = Commands->Create_Object("Invisible_Box_NR",Vector3(0,0,0));
		Commands->Give_PowerUp(TempObject,Weapon->PowerUpName,true);
		const char *str = Get_Translated_Weapon(TempObject,Get_Gun_Position(TempObject,WeaponNode->Weapon));
		sprintf(WeaponName,"%s",str);
		delete[] str;
		Commands->Destroy_Object(TempObject);
	}
	return WeaponName;
}

int JMG_RP2_Housing_Weapons_Cupboard_WLS::Grant_Ammo_Amount()
{
	int Amount = 0;
	if (WeaponNode)
	{
		GameObject *TempObject = Commands->Create_Object("Invisible_Box_NR",Vector3(0,0,0));
		Commands->Give_PowerUp(TempObject,Weapon->PowerUpName,true);
		Amount = ((int)(AmmoPercent * (Get_Max_Total_Bullets(TempObject,Weapon->WeaponName))));
		Commands->Destroy_Object(TempObject);
	}
	return Amount;
}

void JMG_RP2_Weapons_Cupboard_File_Control::Created(GameObject *obj)
{
	long CanUseFile;
	FILE *FileCupboard;
	FileCupboard = fopen("Data/RolePlay2/BetaWeaponsCupboard.RP2","r");
	if (FileCupboard)
	{  
		fseek (FileCupboard,0,SEEK_END);
		CanUseFile = ftell(FileCupboard);
		rewind (FileCupboard);
		if (CanUseFile > 1)
		{
			while (!feof(FileCupboard))
			{
				int CupboardID;
				char WeaponName[256],Safty,Safty1;
				fscanf(FileCupboard,"%c%d%c\n",&Safty1,&CupboardID,&Safty);
				if (Safty1 == ';' && Safty == ';')
				{
					char TempWeapName[256];
					fread(TempWeapName,256,1,FileCupboard);
					int loops = strlen(TempWeapName),x = 0;
					while (x < loops)
					{
						if (TempWeapName[x] != '\n')
						{
							WeaponName[x] = TempWeapName[x];
						}
						else
						{
							WeaponName[x] = '\0';
						}
						x++;
					}
					int DecryptFactor = CupboardID % 100;
					DataNode(CupboardID,Decrypt(WeaponName,DecryptFactor,3));
					fscanf(FileCupboard,"\n");
				}
				else
				{
					Console_Input("MESSAGE BAD LINE READ IN \"BetaWeaponsCupboard.RP2\"");
					fread(WeaponName,256,1,FileCupboard);
					fscanf(FileCupboard,"\n");
				}
			}
		}
		fclose(FileCupboard);
	}
	else
	{
		Console_Input("MESSAGE Warning: Primary Weapons Cupboard Control File not found! File will be automatically created...");
		FILE *hfile;
		hfile = fopen("Data/RolePlay2/BetaWeaponsCupboard.RP2","w");
		fprintf(hfile,"");
		fflush(hfile);
		fclose(hfile);
	}
}

void JMG_RP2_Weapons_Cupboard_File_Control::DataNode(int ID,const char *Weapon)
{
	if (!WeaponCupboardNode)
	{
		WeaponCupboardNode = new WeaponCupboardControl;
		sprintf(WeaponCupboardNode->Weapon,"%s",Weapon);
		WeaponCupboardNode->ID = ID;
		WeaponCupboardNode->next = NULL;
	}
	else
	{
		int end = 0;
		WeaponCupboardControl *Current = WeaponCupboardNode;
		while (Current != NULL && end == 0)
		{
			if (Current->ID == ID)
			{
				end = 1;
				sprintf(Current->Weapon,"%s",Weapon);
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new WeaponCupboardControl;
				Current = Current->next;
				sprintf(Current->Weapon,"%s",Weapon);
				Current->ID = ID;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

char *JMG_RP2_Weapons_Cupboard_File_Control::Decrypt(const char *String,int EncryptionFactor,int Start)
{
	static char FinalString[2000];
	int loops = strlen(String),x = 0;
	int CurrentAdd = Start;
	while (x < loops)
	{
		if (String[x] != '\0' && String[x] != '\n')
		{
			char Temp = (String[x]-(char)CurrentAdd);
			while (Temp < 32)
			{
				Temp += 125;
			}/*
			if (Temp == 126)
			{
				Temp = 92;
			}*/
			FinalString[x] = Temp;
			CurrentAdd++;
			if (CurrentAdd > EncryptionFactor)
			{
				CurrentAdd = 1;
			}
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
		FinalString[x] = '\0';
	}
	return FinalString;
}

void JMG_RP2_Screen_Fade_Red_On_Damage::Created(GameObject *obj)
{
	ScreenOpacicity = 0.0f;
	Commands->Start_Timer(obj,this,0.1f,98765432);
}

void JMG_RP2_Screen_Fade_Red_On_Damage::Timer_Expired(GameObject *obj, int number)
{
	if (number == 98765432 && Commands->Get_Health(obj) > 0)
	{
		if (ScreenOpacicity > 0)
		{
			ScreenOpacicity -= 0.01f;
		}
		else
		{
			ScreenOpacicity = 0.0f;
		}
		ScreenFade(obj);
		Commands->Start_Timer(obj,this,0.1f,98765432);
	}
}

void JMG_RP2_Screen_Fade_Red_On_Damage::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	float Health = Commands->Get_Max_Health(obj);
	if (damage > 1.0f && Health)
	{
		float TotalHP = Health + Commands->Get_Max_Shield_Strength(obj);
		if ((ScreenOpacicity + damage)/TotalHP < 0.85)
		{
			ScreenOpacicity += damage/TotalHP;
		}
		else
		{
			ScreenOpacicity = 0.85f;
		}
	}
}

void JMG_RP2_Screen_Fade_Red_On_Damage::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 596911)
	{
		float Health = Commands->Get_Max_Health(obj);
		float TempParam = (float)param / 100.0f;
		if (TempParam > 1.0f && Health)
		{
			float TotalHP = Health + Commands->Get_Max_Shield_Strength(obj);
			if ((ScreenOpacicity + TempParam)/TotalHP < 0.85)
			{
				ScreenOpacicity += TempParam/TotalHP;
			}
			else
			{
				ScreenOpacicity = 0.85f;
			}
		}
	}
}

void JMG_RP2_Screen_Fade_Red_On_Damage::ScreenFade(GameObject *obj)
{
	int PlayerID = Get_Player_ID(obj);
	if (!DRUGSCREENEFFECTSON[PlayerID] && !ISUNDERWATER[PlayerID] && (!Get_Vehicle(obj) || (Get_Vehicle(obj) && ScreenOpacicity)) && !Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
	{
		if (ScreenOpacicity > 0.0f)
		{
			RP2WeatherStruct *MyNode = PlayerWeatherNodes[Get_Player_ID(obj)];
			if (MyNode)
			{
				Set_Screen_Fade_Color_Player(obj,(MyNode->ScreenColor.X+0.75f),MyNode->ScreenColor.Y,MyNode->ScreenColor.Z,0.1f);
				Set_Screen_Fade_Opacity_Player(obj,ScreenOpacicity,0.1f);
			}
			else
			{
				Set_Screen_Fade_Color_Player(obj,0.75,0,0,0.1f);
				Set_Screen_Fade_Opacity_Player(obj,ScreenOpacicity,0.1f);
			}
		}
	}
}

void JMG_RP2_Phone_Load_Redial_Numbers::Created(GameObject *obj)
{
	int CanWriteOutput = 1;
	FILE *FileRedial;
	int BadRead = 0;
	FileRedial = fopen("Data/RolePlay2/BetaPhoneRedialNumbers.RP2","r");
	if (FileRedial)
	{
		char FirstLine[200];
		sprintf(FirstLine,"");
		fread(FirstLine,200,1,FileRedial);
		if (strlen(FirstLine) < 1)
		{
			CanWriteOutput = 0;
		}
		rewind (FileRedial);
		if (CanWriteOutput)
		{
			while (!feof(FileRedial))
			{
				char PlayerName[256],Safty = '0',Safty1 = '0',Safty2 = '0';
				if (BadRead != 2)
				{
					fscanf(FileRedial,"%c%c%c\n",&Safty,&Safty1,&Safty2);
				}
				if ((Safty == '[' && Safty1 == '*' && Safty2 == ']') || BadRead == 2)
				{
					BadRead = 0;
					int NumberLength[10];				
					char TempPName[256];
					fread(TempPName,256,1,FileRedial);
					int loops = strlen(TempPName),x = 0;
					while (x < loops)
					{
						if (TempPName[x] != '\n')
						{
							PlayerName[x] = TempPName[x];
						}
						else
						{
							PlayerName[x] = '\0';
						}
						x++;
					}
					fscanf(FileRedial,"%d,%d,%d,%d,%d,%d,%d,%d,%d,%d%c\n",&NumberLength[0],&NumberLength[1],&NumberLength[2],&NumberLength[3],&NumberLength[4],&NumberLength[5],&NumberLength[6],&NumberLength[7],&NumberLength[8],&NumberLength[9],&Safty);
					if (Safty == ';')
					{
						PlayerRedialNumberControl *PlayerDial = DataNode(PlayerName);
						fread(PlayerDial->PhoneNumber0,200,1,FileRedial);
						fscanf(FileRedial,"\n");
						fread(PlayerDial->PhoneNumber1,200,1,FileRedial);
						fscanf(FileRedial,"\n");
						fread(PlayerDial->PhoneNumber2,200,1,FileRedial);
						fscanf(FileRedial,"\n");
						fread(PlayerDial->PhoneNumber3,200,1,FileRedial);
						fscanf(FileRedial,"\n");
						fread(PlayerDial->PhoneNumber4,200,1,FileRedial);
						fscanf(FileRedial,"\n");
						fread(PlayerDial->PhoneNumber5,200,1,FileRedial);
						fscanf(FileRedial,"\n");
						fread(PlayerDial->PhoneNumber6,200,1,FileRedial);
						fscanf(FileRedial,"\n");
						fread(PlayerDial->PhoneNumber7,200,1,FileRedial);
						fscanf(FileRedial,"\n");
						fread(PlayerDial->PhoneNumber8,200,1,FileRedial);
						fscanf(FileRedial,"\n");
						fread(PlayerDial->PhoneNumber9,200,1,FileRedial);
						fscanf(FileRedial,"\n");
						for (int y = 0;y < 10;y++)
						{
							PlayerDial->NumberLength[y] = NumberLength[y];
						}
					}
					else
					{
						BadRead = 1;
					}
				}
				else
				{
					BadRead = 1;
				}
				if (BadRead == 1)
				{
					Console_Input("MESSAGE BAD LINE READ IN \"BetaPhoneRedialNumbers.RP2\"");	
					char TempPName[2000];
					fread(TempPName,2000,1,FileRedial);
					while (!(TempPName[0] == '[' && TempPName[1] == '*' && TempPName[2] == ']') && !feof(FileRedial))
					{
						fread(TempPName,2000,1,FileRedial);
					}
					BadRead = 2;
				}
			}
		}
		fclose(FileRedial);
	}
	else
	{
		Console_Input("MESSAGE Warning: Phone Redial File not found! File will be automatically created...");
		FILE *hfile;
		hfile = fopen("Data/RolePlay2/BetaPhoneRedialNumbers.RP2","w");
		fprintf(hfile,"");
		fflush(hfile);
		fclose(hfile);
	}
}

PlayerRedialNumberControl *JMG_RP2_Phone_Load_Redial_Numbers::DataNode(char PlayerName[])
{
	if (!PlayerRedialNumberNode)
	{
		PlayerRedialNumberNode = new PlayerRedialNumberControl;
		sprintf(PlayerRedialNumberNode->PlayerName,"%s",PlayerName);
		PlayerRedialNumberNode->next = NULL;
		return PlayerRedialNumberNode;
	}
	else
	{
		int end = 0;
		PlayerRedialNumberControl *Current = PlayerRedialNumberNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				end = 1;
				return Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new PlayerRedialNumberControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Phone_Attach_Script_To_Sender_Player::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		const char *paramx = Get_Parameter("Params");
		char *params = newstr(paramx);
		char delim = Get_Parameter("Delim")[0];
		unsigned int x = strlen(params);
		for (unsigned int i=0;i<x;i++)
		{
			if (params[i] == delim)
			{
				params[i] = ',';
			}
		}
		Attach_Script_Once(Get_GameObj(param),Get_Parameter("Script"),params);
		delete params;
	}
}

void JMG_RP2_Display_Message_On_Pickup::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		Send_Message_Player(sender,0,255,64,Get_Parameter("PickupMessage"));
	}
}

void JMG_RP2_Simple_Smart_Base_Defense::Created(GameObject *obj)
{
	EnemyID = 0;
	TargetVisible = 0;
	Checking = 2;
	AGTargetID = 0;
	KillTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	if (Get_Int_Parameter("On_Grid") < 128 && Get_Int_Parameter("On_Grid") >= 0)
	{
		MyGrid = Get_Int_Parameter("On_Grid");
	}
	else
	{
		MyGrid = -1;
	}
	Commands->Start_Timer(obj,this,1.0,92562142);
	Commands->Start_Timer(obj,this,0.1f,92562143);
	Commands->Enable_Enemy_Seen(obj,true);
	Attach_Script_Once(obj,"JMG_RP2_Object_Send_Text_Message_On_Death","");
}

void JMG_RP2_Simple_Smart_Base_Defense::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
	{
		return;
	}
	if (Commands->Is_A_Star(seen))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(seen)])
		{
			return;
		}
	}
	if (!(seen->As_PhysicalGameObj() && seen->As_PhysicalGameObj()->Peek_Physical_Object() && seen->As_PhysicalGameObj()->Peek_Physical_Object()->As_ProjectileClass()))
	{
		float Distance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
		if (Distance <= Get_Float_Parameter("Max_Range") && Distance > Get_Float_Parameter("Min_Range"))
		{
			if (Checking == NOTHING)
			{	
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
				EnemyID = Commands->Get_ID(seen);
				Commands->Enable_Enemy_Seen(obj,false);
				Checking = SEARCHCOMPLETE;
			}
			if (Checking == SEARCHING)//See if still visible
			{
				if ((EnemyID == Commands->Get_ID(seen) && TargetVisible == 0) || (EnemyID == Commands->Get_ID(seen) && TargetVisible == 1 && Distance <= TargetDistance))
				{
					TargetVisible = true;// TARGET FOUND
					TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
				}
				else if (EnemyID != Commands->Get_ID(seen) && (Distance + 1.0f) < TargetDistance)// Closer Target Found, use this one
				{
					EnemyID = Commands->Get_ID(seen);
					TargetVisible = true;// TARGET FOUND!
					TargetDistance = Distance;
				}
			}
		}
	}
}

void JMG_RP2_Simple_Smart_Base_Defense::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damager && damage && _stricmp(Get_Skin(damager),"Blamo") && _stricmp(Get_Shield_Type(damager),"Blamo"))
	{
		if (((damager->As_PhysicalGameObj() && damager->As_PhysicalGameObj()->Peek_Physical_Object() && damager->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()) || (damager->As_PhysicalGameObj() && damager->As_PhysicalGameObj()->Peek_Physical_Object() && damager->As_PhysicalGameObj()->Peek_Physical_Object()->As_TrackedVehicleClass()) || (damager->As_PhysicalGameObj() && damager->As_PhysicalGameObj()->Peek_Physical_Object() && damager->As_PhysicalGameObj()->Peek_Physical_Object()->As_WheeledVehicleClass()) || (damager->As_PhysicalGameObj() && damager->As_PhysicalGameObj()->Peek_Physical_Object() && damager->As_PhysicalGameObj()->Peek_Physical_Object()->As_MotorcycleClass()) || (damager->As_PhysicalGameObj() && damager->As_PhysicalGameObj()->Peek_Physical_Object() && damager->As_PhysicalGameObj()->Peek_Physical_Object()->As_HumanPhysClass())) && !EnemyID && MyGrid != -1)
		{
				GiveToGrid(damager);
				AGTargetID = Commands->Get_ID(damager);
				SameTarget = 0;
				SelectNetworkTarget(obj);
				Checking = 1;
				TargetVisible = false;
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(AGTargetID)));
				Commands->Enable_Enemy_Seen(obj,true);
		}
	}
}

void JMG_RP2_Simple_Smart_Base_Defense::Timer_Expired(GameObject *obj,int number)
{
	if (92562143 == number)
	{
		if (EnemyID)
		{
			GameObject *Enemy = Commands->Find_Object(EnemyID);
			if (Enemy && KillTargetID != EnemyID)
			{
				AttackHoldFunction(obj,Enemy);
				KillTargetID = EnemyID;
			}
			if (!Enemy)
			{
				EnemyID = 0;
				KillTargetID = 0;
			}
		}
		Commands->Start_Timer(obj,this,0.25,92562143);
	}
	if (number == 92562142)
	{
		VisibilityCheck(obj);
		Commands->Start_Timer(obj,this,1.25,92562142);
	}
}

void JMG_RP2_Simple_Smart_Base_Defense::StopShootingAndReload(GameObject *obj)
{
	EnemyID = 0;
	AGTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	Checking = 2;
	KillTargetID = 0;
	Commands->Enable_Enemy_Seen(obj,true);
	Commands->Action_Reset(obj,100);
}

void JMG_RP2_Simple_Smart_Base_Defense::AttackHoldFunction(GameObject *obj,GameObject *Enemy)
{
	ActionParamsStruct params;
	params.Set_Basic(this,0,100);
	params.Set_Attack(Enemy,Get_Float_Parameter("Max_Range"),0,1);
	params.AttackCheckBlocked = false;
	Commands->Action_Attack(obj,params);
}

void JMG_RP2_Simple_Smart_Base_Defense::VisibilityCheck(GameObject *obj)
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (EnemyID == 0) // Always set to true if no enemy is targeted
	{
		Checking = NOTHING;
		Commands->Enable_Enemy_Seen(obj,true);
		SelectNetworkTarget(obj);
	}
	if (Checking == SEARCHCOMPLETE)// If not checking for an enemy start
	{
		Checking = SEARCHING;
		TargetVisible = false;
		TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(EnemyID)));
		Commands->Enable_Enemy_Seen(obj,true);
	}
	else if (Checking == SEARCHING && TargetVisible == 0)// If just completed the check, but no enemy found, clear target
	{
		EnemyID = 0;
		if (!AGTargetID)
		{
			StopShootingAndReload(obj);
		}
		else
		{
			AGAttackTime++;
			if (AGAttackTime > 15)
			{
				RemoveGridTarget(AGTargetID);
				StopShootingAndReload(obj);
			}
		}
		SelectNetworkTarget(obj);
	}
	else if (Checking == SEARCHING && TargetVisible == 1)// Enemy was found, keep the target
	{
		Commands->Enable_Enemy_Seen(obj,false);
		Checking = SEARCHCOMPLETE;
	}
}

void JMG_RP2_Simple_Smart_Base_Defense::GiveToGrid(GameObject *Enemy)
{
	int end = 0;
	int AddID = Commands->Get_ID(Enemy);
	for (int x = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSBDGrid[MyGrid][x] == AddID)
		{
			end = 1;
			JRP2SSBDGrid[MyGrid][x] = AddID;
			JRP2SSBDGridTC[MyGrid]++;
		}
		else if (JRP2SSBDGrid[MyGrid][x] == 0)
		{
			end = 1;
			JRP2SSBDGrid[MyGrid][x] = AddID;
			JRP2SSBDGridTC[MyGrid]++;
		}
	}
	if (end == 0)
	{
		for (int x = 0;x < 25 && end == 0;x++)
		{
			if (x < 24)
			{
				JRP2SSBDGrid[MyGrid][x] = JRP2SSBDGrid[MyGrid][(x+1)];
			}
			else
			{
				JRP2SSBDGrid[MyGrid][x] = AddID;
			}
		}
	}
}

int JMG_RP2_Simple_Smart_Base_Defense::GrabIDFromGrid()
{
	if (JRP2SSBDGridTC[MyGrid])
	{
		for (int x = 0,end = 0;x < 25 && end == 0;x++)
		{
			if (JRP2SSBDGrid[MyGrid][x] != 0)
			{
				end = 1;
				return JRP2SSBDGrid[MyGrid][x];
			}
		}
	}
	return 0;
}

void JMG_RP2_Simple_Smart_Base_Defense::RemoveGridTarget(int ID)
{
	for (int x = 0,end = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSBDGrid[MyGrid][x] == ID)
		{
			for (int y = x;y < 25;y++)
			{
				if (y < 24)
				{
					JRP2SSBDGrid[MyGrid][y] = JRP2SSBDGrid[MyGrid][(y+1)];
				}
				else
				{
					JRP2SSBDGrid[MyGrid][y] = 0;
				}
			}
			JRP2SSBDGridTC[MyGrid]--;
			end = 1;
		}
	}
}

void JMG_RP2_Simple_Smart_Base_Defense::SelectNetworkTarget(GameObject *obj) 
{
	if (AGTargetID && EnemyID && AGTargetID != EnemyID)
	{
		GameObject *Target = Commands->Find_Object(AGTargetID);
		GameObject *Target2 = Commands->Find_Object(EnemyID);
		float ObjectDistance = Commands->Get_Distance(Commands->Get_Position(Target),Commands->Get_Position(obj));
		float EnemyDistance = Commands->Get_Distance(Commands->Get_Position(Target2),Commands->Get_Position(obj));
		if (ObjectDistance < EnemyDistance)
		{
			EnemyID = AGTargetID;
		}
		else
		{
			AGTargetID = EnemyID;
		}
	}
	if (AGTargetID && !EnemyID)
	{
		SameTarget++;
		EnemyID = AGTargetID;
		GameObject *Target = Commands->Find_Object(AGTargetID);
		if (!Target || !Commands->Get_Health(Target))
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
			EnemyID = 0;
			Checking = 2;
			Commands->Enable_Enemy_Seen(obj,true);
		}
		if (SameTarget >= 40)
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
		}
	}
	else if (!EnemyID && MyGrid != -1)
	{
		if (JRP2SSBDGridTC[MyGrid])
		{
			SameTarget = 0;
			EnemyID = GrabIDFromGrid();
			GameObject *Target = Commands->Find_Object(EnemyID);
			if (!Commands->Get_Health(Target))
			{
				RemoveGridTarget(EnemyID);
			}
			else if (EnemyID && Target)
			{
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Target));
				Checking = 1;
				AGTargetID = EnemyID;
			}
		}
	}
	GameObject *NewTarget = Commands->Find_Object(AGTargetID);
	if (Commands->Is_A_Star(NewTarget))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(NewTarget)])
		{
			RemoveGridTarget(AGTargetID);
		}
	}
}

void JMG_RP2_Simple_Smart_House_Defense::Created(GameObject *obj)
{
	EnemyID = 0;
	TargetVisible = 0;
	Checking = 2;
	AGTargetID = 0;
	KillTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	if (Get_Int_Parameter("On_Grid") < 128 && Get_Int_Parameter("On_Grid") >= 0)
	{
		MyGrid = Get_Int_Parameter("On_Grid");
	}
	else
	{
		MyGrid = -1;
	}
	Commands->Start_Timer(obj,this,1.0,92562142);
	Commands->Start_Timer(obj,this,0.1f,92562143);
	Commands->Enable_Enemy_Seen(obj,true);
}

void JMG_RP2_Simple_Smart_House_Defense::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
	{
		return;
	}
	if (Commands->Is_A_Star(seen))
	{
			if (ISSELECTINGSPAWN[Get_Player_ID(seen)])
			{
				return;
			}
	}
	if (!Commands->Has_Key(seen,Get_Int_Parameter("House_Address")) && !Commands->Has_Key(seen,(0-Get_Int_Parameter("House_Address"))) && !(seen->As_PhysicalGameObj() && seen->As_PhysicalGameObj()->Peek_Physical_Object() && seen->As_PhysicalGameObj()->Peek_Physical_Object()->As_ProjectileClass()))
	{
		float Distance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
		if (Distance <= Get_Float_Parameter("Max_Range") && Distance > Get_Float_Parameter("Min_Range"))
		{
			if (Checking == NOTHING)
			{	
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
				EnemyID = Commands->Get_ID(seen);
				Commands->Enable_Enemy_Seen(obj,false);
				Checking = SEARCHCOMPLETE;
			}
			if (Checking == SEARCHING)//See if still visible
			{
				if ((EnemyID == Commands->Get_ID(seen) && TargetVisible == 0) || (EnemyID == Commands->Get_ID(seen) && TargetVisible == 1 && Distance <= TargetDistance))
				{
					TargetVisible = true;// TARGET FOUND
					TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
				}
				else if (EnemyID != Commands->Get_ID(seen) && Distance + 1.0f < TargetDistance)// Closer Target Found, use this one
				{
					EnemyID = Commands->Get_ID(seen);
					TargetVisible = true;// TARGET FOUND!
					TargetDistance = Distance;
				}
			}
		}
	}
}

void JMG_RP2_Simple_Smart_House_Defense::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damager && damage && _stricmp(Get_Skin(damager),"Blamo") && _stricmp(Get_Shield_Type(damager),"Blamo"))
	{
		if (!Commands->Has_Key(damager,Get_Int_Parameter("House_Address")) && !Commands->Has_Key(damager,(0-Get_Int_Parameter("House_Address"))) && ((damager->As_PhysicalGameObj() && damager->As_PhysicalGameObj()->Peek_Physical_Object() && damager->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()) || (damager->As_PhysicalGameObj() && damager->As_PhysicalGameObj()->Peek_Physical_Object() && damager->As_PhysicalGameObj()->Peek_Physical_Object()->As_TrackedVehicleClass()) || (damager->As_PhysicalGameObj() && damager->As_PhysicalGameObj()->Peek_Physical_Object() && damager->As_PhysicalGameObj()->Peek_Physical_Object()->As_WheeledVehicleClass()) || (damager->As_PhysicalGameObj() && damager->As_PhysicalGameObj()->Peek_Physical_Object() && damager->As_PhysicalGameObj()->Peek_Physical_Object()->As_MotorcycleClass()) || (damager->As_PhysicalGameObj() && damager->As_PhysicalGameObj()->Peek_Physical_Object() && damager->As_PhysicalGameObj()->Peek_Physical_Object()->As_HumanPhysClass())) && !EnemyID && MyGrid != -1)
		{
			GiveToGrid(damager);
			AGTargetID = Commands->Get_ID(damager);
			SameTarget = 0;
			SelectNetworkTarget(obj);
			Checking = 1;
			TargetVisible = false;
			TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(AGTargetID)));
			Commands->Enable_Enemy_Seen(obj,true);
		}
	}
}

void JMG_RP2_Simple_Smart_House_Defense::Timer_Expired(GameObject *obj,int number)
{
	if (92562143 == number)
	{
		if (EnemyID)
		{
			GameObject *Enemy = Commands->Find_Object(EnemyID);
			if (Enemy && KillTargetID != EnemyID)
			{
				AttackHoldFunction(obj,Enemy);
				KillTargetID = EnemyID;
			}
			if (!Enemy)
			{
				EnemyID = 0;
				KillTargetID = 0;
			}
		}
		Commands->Start_Timer(obj,this,0.25,92562143);
	}
	if (number == 92562142)
	{
		VisibilityCheck(obj);
		Commands->Start_Timer(obj,this,1.25,92562142);
	}
}

void JMG_RP2_Simple_Smart_House_Defense::StopShootingAndReload(GameObject *obj)
{
	EnemyID = 0;
	AGTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	Checking = 2;
	KillTargetID = 0;
	Commands->Enable_Enemy_Seen(obj,true);
	Commands->Action_Reset(obj,100);
}

void JMG_RP2_Simple_Smart_House_Defense::AttackHoldFunction(GameObject *obj,GameObject *Enemy)
{
	ActionParamsStruct params;
	params.Set_Basic(this,0,100);
	params.Set_Attack(Enemy,Get_Float_Parameter("Max_Range"),0,1);
	params.AttackCheckBlocked = false;
	Commands->Action_Attack(obj,params);
}

void JMG_RP2_Simple_Smart_House_Defense::VisibilityCheck(GameObject *obj)
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (EnemyID == 0) // Always set to true if no enemy is targeted
	{
		Checking = NOTHING;
		Commands->Enable_Enemy_Seen(obj,true);
		SelectNetworkTarget(obj);
	}
	if (Checking == SEARCHCOMPLETE)// If not checking for an enemy start
	{
		Checking = SEARCHING;
		TargetVisible = false;
		TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(EnemyID)));
		Commands->Enable_Enemy_Seen(obj,true);
	}
	else if (Checking == SEARCHING && TargetVisible == 0)// If just completed the check, but no enemy found, clear target
	{
		EnemyID = 0;
		if (!AGTargetID)
		{
			StopShootingAndReload(obj);
		}
		else
		{
			AGAttackTime++;
			if (AGAttackTime > 15)
			{
				RemoveGridTarget(AGTargetID);
				StopShootingAndReload(obj);
			}
		}
		SelectNetworkTarget(obj);
	}
	else if (Checking == SEARCHING && TargetVisible == 1)// Enemy was found, keep the target
	{
		Commands->Enable_Enemy_Seen(obj,false);
		Checking = SEARCHCOMPLETE;
	}
}

void JMG_RP2_Simple_Smart_House_Defense::GiveToGrid(GameObject *Enemy)
{
	int end = 0;
	int AddID = Commands->Get_ID(Enemy);
	for (int x = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSHDGrid[MyGrid][x] == AddID)
		{
			end = 1;
			JRP2SSHDGrid[MyGrid][x] = AddID;
			JRP2SSHDGridTC[MyGrid]++;
		}
		else if (JRP2SSHDGrid[MyGrid][x] == 0)
		{
			end = 1;
			JRP2SSHDGrid[MyGrid][x] = AddID;
			JRP2SSHDGridTC[MyGrid]++;
		}
	}
	if (end == 0)
	{
		for (int x = 0;x < 25 && end == 0;x++)
		{
			if (x < 24)
			{
				JRP2SSHDGrid[MyGrid][x] = JRP2SSHDGrid[MyGrid][(x+1)];
			}
			else
			{
				JRP2SSHDGrid[MyGrid][x] = AddID;
			}
		}
	}
}

int JMG_RP2_Simple_Smart_House_Defense::GrabIDFromGrid()
{
	if (JRP2SSHDGridTC[MyGrid])
	{
		for (int x = 0,end = 0;x < 25 && end == 0;x++)
		{
			if (JRP2SSHDGrid[MyGrid][x] != 0)
			{
				end = 1;
				return JRP2SSHDGrid[MyGrid][x];
			}
		}
	}
	return 0;
}

void JMG_RP2_Simple_Smart_House_Defense::RemoveGridTarget(int ID)
{
	for (int x = 0,end = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSHDGrid[MyGrid][x] == ID)
		{
			for (int y = x;y < 25;y++)
			{
				if (y < 24)
				{
					JRP2SSHDGrid[MyGrid][y] = JRP2SSHDGrid[MyGrid][(y+1)];
				}
				else
				{
					JRP2SSHDGrid[MyGrid][y] = 0;
				}
			}
			JRP2SSHDGridTC[MyGrid]--;
			end = 1;
		}
	}
}

void JMG_RP2_Simple_Smart_House_Defense::SelectNetworkTarget(GameObject *obj) 
{
	if (AGTargetID && EnemyID && AGTargetID != EnemyID)
	{
		GameObject *Target = Commands->Find_Object(AGTargetID);
		GameObject *Target2 = Commands->Find_Object(EnemyID);
		float ObjectDistance = Commands->Get_Distance(Commands->Get_Position(Target),Commands->Get_Position(obj));
		float EnemyDistance = Commands->Get_Distance(Commands->Get_Position(Target2),Commands->Get_Position(obj));
		if (ObjectDistance < EnemyDistance)
		{
			EnemyID = AGTargetID;
		}
		else
		{
			AGTargetID = EnemyID;
		}
	}
	if (AGTargetID && !EnemyID)
	{
		SameTarget++;
		EnemyID = AGTargetID;
		GameObject *Target = Commands->Find_Object(AGTargetID);
		if (!Target || !Commands->Get_Health(Target))
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
			EnemyID = 0;
			Checking = 2;
			Commands->Enable_Enemy_Seen(obj,true);
		}
		if (SameTarget >= 40)
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
		}
	}
	else if (!EnemyID && MyGrid != -1)
	{
		if (JRP2SSHDGridTC[MyGrid])
		{
			SameTarget = 0;
			EnemyID = GrabIDFromGrid();
			GameObject *Target = Commands->Find_Object(EnemyID);
			if (!Commands->Get_Health(Target) || (Commands->Has_Key(Target,Get_Int_Parameter("House_Address")) && !Commands->Has_Key(Target,(0-Get_Int_Parameter("House_Address")))))
			{
				RemoveGridTarget(EnemyID);
			}
			else if (EnemyID && Target)
			{
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Target));
				Checking = 1;
				AGTargetID = EnemyID;
			}
		}
	}
	GameObject *NewTarget = Commands->Find_Object(AGTargetID);
	if (Commands->Is_A_Star(NewTarget))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(NewTarget)])
		{
			RemoveGridTarget(AGTargetID);
		}
	}
}

void JMG_RP2_Phone_House_Key_Grant_Access_System::Created(GameObject *obj)
{
	sprintf(PhoneNumberMessage,"null");
	char TempNumber[256];
	const char *PhoneNumber = Get_Parameter("Phone_Number");
	sprintf(TempNumber,"");
	int x = 0,x2 = 0;
	int length = Get_Int_Parameter("Number_Of_Digits")+1;
	while (x2 < length)
	{
		if (x == 3)
		{
			TempNumber[x] = '-';
			x++;
		}
		TempNumber[x] = PhoneNumber[x2];
		x++;
		x2++;
	}
	TempNumber[length] = '\0';
	sprintf(PhoneNumberMessage,"%s - Home Security Access Center",TempNumber);
}

void JMG_RP2_Phone_House_Key_Grant_Access_System::Custom(GameObject *obj,int message,int param,GameObject *sender)
{	
	if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							sprintf(Current->PhoneNumber,"%s - %s",Current->PhoneNumber,PhoneNumberMessage);
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && param == 2)
	{
		Send_Message_Player(sender,127,255,0,PhoneNumberMessage);
	}
	if (message == PHONECallStartCustom && param == 0)
	{							
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							if (!Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")))
							{
								GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
								GLOBALPHONETIMES[PlayerID] = 0;
								CallerNode = Current;
								Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Script_ID"),Get_Player_ID(sender),(Get_Float_Parameter("Pickup_Delay")+Commands->Get_Random(0.0f,Get_Float_Parameter("Max_Random_Pickup_Delay"))));
							}
							else
							{
								for (int x = 1;x < 128;x++)
								{
									if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
									{
										GameObject *Player = Get_GameObj(x);
										Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
									}
								}
								Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
							}
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == Get_Int_Parameter("Script_ID"))
	{
		GameObject *player = Get_GameObj(param);
		Send_Message_Player(player,127,255,0,"Hello, and thank you for calling the Home Security Access Center, please enter the address of the house you would like to allow access to and then press pound.");
		Commands->Send_Custom_Event(obj,player,PHONENumberRequiresAdditionalNumberAndPound,Get_Int_Parameter("Script_ID"),0);// make it await pound
		Commands->Send_Custom_Event(obj,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);// Start Timer
	}
	if (message == PHONECallStartCustom && param == Get_Int_Parameter("Script_ID"))
	{
		int end = 0;
		int PlayerID = Get_Player_ID(sender);
		HouseAddress = 0;
		if (PhoneNumbers)
		{
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					HouseAddress = atoi(Current->PhonePound);
					end = 1;
				}
				Current = Current->next;
			}
		}	
		if (HouseAddress)
		{
			CurHouse = Find_Housing_Node(HouseAddress);
			if (CurHouse)
			{
				if (Commands->Has_Key(sender,HouseAddress) && !Commands->Has_Key(sender,(0-HouseAddress)))
				{
					Commands->Send_Custom_Event(obj,sender,40860517,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
					Send_Message_Player(sender,127,255,0,"We have found your house on file, now please enter the phone number of the person you would like to grant access to, then press enter.");
				}
				else
				{	
					char confmes[2000];
					sprintf(confmes,"We have found have found that you do not have access to the house at address:%d. Therefore, we cannot allow you to grant access to it for others. Sorry, but have a nice day!",HouseAddress);
					Send_Message_Player(sender,127,255,0,confmes);
				}
			}
			else
			{
				char confmes[2000];
				sprintf(confmes,"Sorry, but there is no house in our security records that matches the address of %d. Have a nice day.",HouseAddress);
				Send_Message_Player(sender,127,255,0,confmes);
				AutoCancelCall(obj,sender);
			}
		}
	}
	if (message == 40860502 && param == Get_Int_Parameter("Script_ID"))
	{
		char confmes[2000];
		const char *str = Get_Player_Name_By_ID(TargetID);
		sprintf(confmes,"Are you sure you want to give %s access to your house? ([1]yes [2]no)",str);
		delete[] str;
		Send_Message_Player(sender,127,255,0,confmes);
		Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
	}
	if (message == PHONENumberEndCallMessage && param == Get_Int_Parameter("Script_ID"))
	{
		int PlayerID = Get_Player_ID(sender);
		if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
		{
			GLOBALPHONELINES[PlayerID] = 0;
			GLOBALPHONETIMES[PlayerID] = 0;
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
		}
	}
	if (message == PHONESpecial1Key && param == Get_Int_Parameter("Script_ID"))
	{
		Commands->Grant_Key(Get_GameObj(TargetID),CurHouse->HouseAddress,1);
		char msg[2000];
		const char *str = Get_Player_Name(sender);
		sprintf(msg,"%s has given me a key to the house at address:%d.",str,CurHouse->HouseAddress);
		delete[] str;
		Send_Message_Player(Get_GameObj(TargetID),160,127,50,msg);
		CurHouse = NULL;
		Send_Message_Player(sender,127,255,0,"Thank you, your friend now has access to your home as long as he doesn't lose his key!");
		Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);// Hang up
		Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
	}
	if (message == PHONESpecial2Key && param == Get_Int_Parameter("Script_ID"))
	{
		Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
		Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
	}
	if (message == PHONENumberCallTimeMonitor && param == Get_Int_Parameter("Script_ID"))
	{
		ChargeForCall(obj);
	}
	if (message == 40860507 && param == Get_Int_Parameter("Script_ID"))
	{
		AutoCancelCall(obj,sender);
	}
	if (message == PHONEHousingKeyTransferCustom && param == Get_Int_Parameter("Script_ID") && CellPhoneNumberNode && CallerNode)
	{
		int end = 0;
		CellPhoneNumberControl *Current = CellPhoneNumberNode;
		while (Current != NULL && end == 0)
		{
			if (CallerNode->PhoneNumberLength == Current->NumberLength)
			{
				if (!_stricmp(CallerNode->PhoneNumber,Current->MyPhoneNumber))
				{
					end = 1;
					GameObject *Player = Get_GameObj(Current->PlayerID);
					if (Commands->Get_Health(Player) > 0.0f)
					{
						TargetID = Current->PlayerID;
						Commands->Send_Custom_Event(sender,obj,40860502,Get_Int_Parameter("Script_ID"),0);// Move to next part of script
					}
					else
					{
						Send_Message_Player(sender,127,255,0,"Sorry, we were unable to reach that person at this time, please try again later.");
						Commands->Send_Custom_Event(obj,sender,40860507,Get_Int_Parameter("Script_ID"),0);// Shutdown phone
					}
					CallerNode->PhoneNumberLength = 3;
					sprintf(CallerNode->PhoneNumber,"null");
					CallerNode = NULL;
				}
			}
			Current = Current->next;
		}
		if (end == 0)
		{
			Send_Message_Player(sender,127,255,0,"Sorry, we were unable to find that person in our records, have a nice day!");
			Commands->Send_Custom_Event(obj,sender,40860507,Get_Int_Parameter("Script_ID"),0);// Shutdown phone
		}
	}
}

void JMG_RP2_Phone_House_Key_Grant_Access_System::AutoCancelCall(GameObject *obj,GameObject *player)
{
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}

void JMG_RP2_Phone_House_Key_Grant_Access_System::ChargeForCall(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
		{
			GameObject *Player = Get_GameObj(x);
			int CallTime = GLOBALPHONETIMES[x]++;
			if (Commands->Get_Health(Player) > 0)
			{
				int chargepersec = Get_Int_Parameter("Charge_Per_Second");
				if (Get_Int_Parameter("Max_Call_Duration") < CallTime)
				{
					AutoCancelCall(obj,Player);
				}
				else if (CallTime % 60 == 0)
				{
					int totalcharge = (chargepersec + Get_Int_Parameter("Charge_Per_Minute"));
					if (Commands->Get_Money(Player) >= totalcharge)
					{
						Commands->Give_Money(Player,-(float)totalcharge,1);
					}
					else
					{
						Send_Message_Player(Player,127,255,0,"Signal Lost");
						AutoCancelCall(obj,Player);
					}
				}
				else if (Commands->Get_Money(Player) >= chargepersec)
				{
					Commands->Give_Money(Player,-(float)chargepersec,1);
				}
				else
				{
					Send_Message_Player(Player,127,255,0,"Signal Lost");
					AutoCancelCall(obj,Player);
				}
			}
			else
			{
				Commands->Send_Custom_Event(Player,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
			}
			Commands->Send_Custom_Event(Player,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);
		}
	}
}

void JMG_RP2_Jerads_Strike_Craft::Created(GameObject *obj)
{
	EnemyID = 0;
	TargetVisible = 0;
	Checking = 2;
	KillTargetID = 0;
	SameTarget = 0;
	ADS = 0;
	JumpCharge = 0;
	Primary = false;
	TryReverse = 0;
	Backward = false;
	LongRange = false;
	GameObject *object = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));//Invisible_Box_NR
	Commands->Attach_To_Object_Bone(object,obj,"HoverBone");
	Commands->Set_Model(object,"null");
	Hover_Plate_ID = Commands->Get_ID(object);
	JetTime = 0;
	Attach_Script_Once(obj,"JMG_RP2_Hovercraft_Hover_Control","");
	Commands->Start_Timer(obj,this,1.0,92562142);
	Commands->Start_Timer(obj,this,0.1f,92562143);
	Commands->Start_Timer(obj,this,0.5,92562144);
	Commands->Start_Timer(obj,this,1.0,92562141);
	Commands->Enable_Enemy_Seen(obj,true);
}

void JMG_RP2_Jerads_Strike_Craft::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7154148)
	{
		Send_Message_Player(sender,200,200,125,"Vehicle Special Keys:");
		Send_Message_Player(sender,200,200,125,"Q - Trigger jump jets");
		Send_Message_Player(sender,200,200,125,"H - Cycle though ADS modes");
		Send_Message_Player(sender,200,200,125,"B - Teleport to a random spot");
		Send_Message_Player(sender,200,200,125,"Middle Mouse - Teleport to nearest player");
	}
	RP2VehicleControl *AVehicleNode = Get_Vehicle_Node2(obj);
	if (AVehicleNode && !AVehicleNode->OnCarryAll)
	{
		if (message == 98562147)
		{
			if (OnIsland(obj))
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					Send_Message_Player(Driver,150,0,150,"Cannot use this action while still in Renhalo...");
				}
				return;
			}
			if (JumpCharge == STRIKECRAFTJUMPCHARGE)
			{
				Vector3 SPos;
				RP2RandomTeleportPositionControl *Node = NULL;
				for (int x = 0;x < 10;x++)
				{
					SPos.X = Commands->Get_Random(-5000.00f,5000.00f);
					SPos.Y = Commands->Get_Random(-5000.00f,5000.00f);
					SPos.Z = Commands->Get_Random(-5000.00f,5000.00f);
					if (Commands->Get_A_Star(SPos) != obj)
					{
						GameObject *NearStar = Get_A_Star2(obj,SPos);
						if (NearStar)
						{
							Node = Find_Closest_Teleport_Node(NearStar,10.0f,5000.0f);
						}
						else
						{
							Node = Find_Closest_Teleport_Node(Commands->Get_A_Star(SPos),10.0f,5000.0f);
						}
						if (Node)
						{
							x = 100;
						}
					}
				}
				if (!Node)
				{
					Node = Find_Closest_Teleport_Node(Commands->Get_A_Star(Commands->Get_Position(obj)),10.0f,5000.0f);
				}
				if (Node)
				{
					ScreenFade(Commands->Get_Position(obj));
					Vector3 Pos = Node->Telepos;
					Pos.Z += 5.0f;
					ScreenFade(Pos);
					Commands->Create_Sound("SFX.Volt_Auto_Rifle_Fire",Commands->Get_Position(obj),obj);
					GameObject *Placer = Commands->Create_Object("Daves_Arrow",Pos);
					Commands->Set_Facing(Placer,Commands->Get_Facing(obj));
					Commands->Attach_To_Object_Bone(obj,Placer,"null");
					Commands->Create_Sound("SFX.Volt_Auto_Rifle_Fire",Pos,obj);
					Commands->Attach_To_Object_Bone(obj,Placer,"null");
					Commands->Destroy_Object(Placer);
					JumpCharge = 0;
				}
			}
			else
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					char Notification[237];
					sprintf(Notification,"Capacitors at %.2f%c charge...",((float)JumpCharge/STRIKECRAFTJUMPCHARGE)*100.0f,'%');
					Send_Message_Player(Driver,150,0,150,Notification);
				}
			}
		}
		if (message == 7745472)
		{// B Key
			if (OnIsland(obj))
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					Send_Message_Player(Driver,150,0,150,"Cannot use this action while still in Renhalo...");
				}
				return;
			}
			if (JumpCharge == STRIKECRAFTJUMPCHARGE)
			{
				RP2RandomTeleportPositionControl *Node = Get_Matching_Teleport_Node(Commands->Get_Random_Int(0,TELEPORTMAXRANDCHOICE));
				if (Node)
				{
					ScreenFade(Commands->Get_Position(obj));
					Vector3 Pos = Node->Telepos;
					Pos.Z += 5.0f;
					ScreenFade(Pos);
					Commands->Create_Sound("SFX.Volt_Auto_Rifle_Fire",Commands->Get_Position(obj),obj);
					GameObject *Placer = Commands->Create_Object("Daves_Arrow",Pos);
					Commands->Set_Facing(Placer,Commands->Get_Facing(obj));
					Commands->Attach_To_Object_Bone(obj,Placer,"null");
					Commands->Create_Sound("SFX.Volt_Auto_Rifle_Fire",Pos,obj);
					Commands->Attach_To_Object_Bone(obj,Placer,"null");
					Commands->Destroy_Object(Placer);
					JumpCharge = 0;
				}
			}
			else
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					char Notification[237];
					sprintf(Notification,"Capacitors at %.2f%c charge...",((float)JumpCharge/STRIKECRAFTJUMPCHARGE)*100.0f,'%');
					Send_Message_Player(Driver,150,0,150,Notification);
				}
			}
		}
	}
	if (message == 7745473)
	{// G Key
		if (OnIsland(obj))
		{
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver)
			{
				Send_Message_Player(Driver,150,0,150,"Cannot use this action while still in Renhalo...");
			}
			return;
		}
		if (ADS == 0)
		{
			ADS = 1;
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver)
			{
				Send_Message_Player(Driver,150,0,150,"Powering up standard ADS...");
			}
		}
		else if (ADS == 1)
		{
			ADS = 2;
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver)
			{
				Send_Message_Player(Driver,150,0,150,"Switching to AI Tracking mode...");
			}
		}
		else
		{
			ADS = 0;
			StopShootingAndReload(obj);
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver)
			{
				Send_Message_Player(Driver,150,0,150,"Powering down ADS...");
			}
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		DriverID = Commands->Get_ID(Get_Vehicle_Driver(obj));
		if (ADS)
		{
			ADS = 2;
			Commands->Send_Custom_Event(obj,obj,7745473,1,0);
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		if (ADS)
		{
			Commands->Set_Player_Type(obj,-1);
			GameObject *Enemy = Commands->Find_Object(EnemyID);
			if (Enemy)
			{
				AttackHoldFunction(obj,Enemy);
			}
			else
			{
				AttackHoldFunction(obj,Enemy);
			}
		}
	}
	if (JetTime == 200 && message == 77454712)
	{// Q Key
		if (OnIsland(obj))
		{
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver)
			{
				Send_Message_Player(Driver,150,0,150,"Cannot use this action while still in Renhalo...");
			}
			return;
		}
		Commands->Set_Model(obj,Get_Model(obj));
		Vector3 Pos = Commands->Get_Position(obj);
		GameObject *object = Commands->Find_Object(Hover_Plate_ID);
		GameObject *object2 = Commands->Create_Object("Daves Arrow",Pos);
		Commands->Attach_To_Object_Bone(object2,obj,"HoverPlate");
		Commands->Set_Model(object2,"GSCEC");
		TempID = Commands->Get_ID(object2);
		Pos.Z -= 1.0f;
		GameObject *object3 = Commands->Create_Object("Daves Arrow",Pos);
		Commands->Attach_To_Object_Bone(object3,obj,"HoverPlate");
		Commands->Set_Model(object3,"GSCECS");
		Commands->Create_Sound("Scud_Launcher_Fire",Commands->Get_Position(obj),obj);
		TempID2 = Commands->Get_ID(object3);
		Commands->Create_Explosion("Explosion_Panther_Flamethrower",Pos,obj);
		JetTime = 0;
		if (object)
		{
			Commands->Set_Model(object,"hoverplate");
		}
	}
}

void JMG_RP2_Jerads_Strike_Craft::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
	{
		return;
	}
	if (Commands->Is_A_Star(seen))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(seen)])
		{
			return;
		}
	}
	if (Is_Script_Attached(seen,"JMG_Dont_Be_A_Douche"))
	{//Don't attack players with spawn kill
		return;
	}
	GameObject *Driver = Commands->Find_Object(DriverID);
	if (!(seen->As_PhysicalGameObj() && seen->As_PhysicalGameObj()->Peek_Physical_Object() && seen->As_PhysicalGameObj()->Peek_Physical_Object()->As_ProjectileClass()) && Commands->Get_Health(seen) && ADS && Driver != seen && Get_Vehicle(Driver) != seen && (ADS != 2 || (ADS == 2 && !Commands->Is_A_Star(seen)) && !Commands->Is_A_Star(Get_Vehicle_Driver(seen))))
	{
		float Distance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
		if (Distance <= 600)
		{
			if (Checking == NOTHING)
			{	
				if (Distance <= 200)
				{
					Primary = true;
				}
				else
				{
					Primary = false;
				}
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
				EnemyID = Commands->Get_ID(seen);
				Commands->Enable_Enemy_Seen(obj,false);
				Checking = SEARCHCOMPLETE;
			}
			if (Checking == SEARCHING)//See if still visible
			{
				if ((EnemyID == Commands->Get_ID(seen) && TargetVisible == 0) || (EnemyID == Commands->Get_ID(seen) && TargetVisible == 1 && Distance <= TargetDistance))
				{
					TargetVisible = true;// TARGET FOUND
					TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
				}
				else if (EnemyID != Commands->Get_ID(seen) && Distance < TargetDistance)// Closer Target Found, use this one
				{
					EnemyID = Commands->Get_ID(seen);
					TargetVisible = true;// TARGET FOUND!
					TargetDistance = Distance;
				}
			}
		}
	}
}

void JMG_RP2_Jerads_Strike_Craft::Timer_Expired(GameObject *obj,int number)
{
	if (92562144 == number)
	{
		if (ADS)
		{
			VisibilityCheck(obj);
			GameObject *Driver = Commands->Find_Object(DriverID);
			if (Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Driver)) > 100.0f)
			{
				RP2RandomTeleportPositionControl *Node = Find_Closest_Teleport_Node(Driver,10.0f,200.0f);
				if (Node)
				{
					Vector3 Pos = Node->Telepos;
					Pos.Z += 5.0f;
					Commands->Create_Sound("SFX.Volt_Auto_Rifle_Fire",Commands->Get_Position(obj),obj);
					GameObject *Placer = Commands->Create_Object("Daves_Arrow",Pos);
					Commands->Set_Facing(Placer,Commands->Get_Facing(obj));
					Commands->Attach_To_Object_Bone(obj,Placer,"null");
					Commands->Create_Sound("SFX.Volt_Auto_Rifle_Fire",Pos,obj);
					Commands->Attach_To_Object_Bone(obj,Placer,"null");
					Commands->Destroy_Object(Placer);
				}
			}
		}
		Commands->Start_Timer(obj,this,0.5,92562144);
	}
	if (92562143 == number)
	{
		if (EnemyID && ADS)
		{
			GameObject *Driver = Commands->Find_Object(DriverID);
			if (!Driver)
			{
				Commands->Send_Custom_Event(obj,obj,7745473,1,0);
				Commands->Send_Custom_Event(obj,obj,7745472,1,0);
				Driver = 0;
				Commands->Enable_Engine(obj,false);
			}
			GameObject *Enemy = Commands->Find_Object(EnemyID);
			if (Enemy && Commands->Get_Health(Enemy) != 0)
			{
				float Distance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Enemy));
				if (Distance > 240 && Primary == true)
				{
					AttackHoldFunction(obj,Enemy);
				}
				if (KillTargetID != EnemyID)
				{
					AttackHoldFunction(obj,Enemy);
				}
			}
			else
			{
				EnemyID = 0;
				KillTargetID = 0;
				Checking = 2;
				Commands->Enable_Enemy_Seen(obj,true);
			}
		}
		Commands->Start_Timer(obj,this,0.15f,92562143);
	}
	if (number == 92562142)
	{
		Vector3 Pos = Commands->Get_Position(obj);
		GameObject *Driver = Commands->Find_Object(DriverID);
		float Distance = Commands->Get_Distance(Pos,Commands->Get_Position(Driver));
		if (Get_Vehicle_Driver(obj) || !Driver || !ADS)
		{
			IsMoving = 0;
			TryReverse = 0;
			Backward = false;
		}
		else if (Distance < 15.0f && IsMoving == 0)
		{
			Backward = false;
			TryReverse = 0;
		}
		else if (!Get_Vehicle_Driver(obj) && Driver && ADS)
		{
			if (IsMoving)
			{
				float Distance = Commands->Get_Distance(Pos,MyLastPos);
				if (Distance < 0.25 && Backward == false)
				{
					if (TryReverse < 10)
					{
						TryReverse++;
					}
					else if (TryReverse == 10)
					{
						Backward = true;
						TryReverse = Commands->Get_Random_Int(10,20);
						AttackHoldFunction(obj,Commands->Find_Object(EnemyID));
					}
				}
				else
				{
					if (TryReverse - 1 == 1)
					{
						Backward = false;
						AttackHoldFunction(obj,Commands->Find_Object(EnemyID));
					}
					if (TryReverse > 0)
					{
						TryReverse--;
					}
					else
					{
						TryReverse = 0;
					}
				}
			}
		}
		MyLastPos = Pos;
		if (JetTime < 200)//-22.165 is water height
		{
			JetTime++;
			if (JetTime == 125)
			{
				GameObject *object = Commands->Find_Object(TempID2);
				if (object)
				{
					Commands->Destroy_Object(object);
				}
			}
			if (JetTime == 100)
			{
				GameObject *object = Commands->Find_Object(Hover_Plate_ID);
				if (object)
				{
					Commands->Set_Model(object,"null");
				}
				object = Commands->Find_Object(TempID);
				if (object)
				{
					Commands->Destroy_Object(object);
				}
			}
		}
		Commands->Start_Timer(obj,this,0.1f,92562142);
	}
	if (92562141 == number)
	{
		if (JumpCharge == 119)
		{
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver)
			{
				Send_Message_Player(Driver,150,0,150,"Capacitors charged.");
			}
		}
		if (JumpCharge < STRIKECRAFTJUMPCHARGE)
		{
			JumpCharge++;
		}
		Commands->Start_Timer(obj,this,1.0,92562141);
	}
}

void JMG_RP2_Jerads_Strike_Craft::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *object = Commands->Find_Object(Hover_Plate_ID);
	if (object)
	{
		Commands->Destroy_Object(object);
	}
	GameObject *object2 = Commands->Find_Object(TempID);
	if (object2)
	{
		Commands->Destroy_Object(object2);
	}
	GameObject *object3 = Commands->Find_Object(TempID2);
	if (object3)
	{
		Commands->Destroy_Object(object3);
	}
}

void JMG_RP2_Jerads_Strike_Craft::StopShootingAndReload(GameObject *obj)
{
	EnemyID = 0;
	TargetVisible = 0;
	Checking = 2;
	KillTargetID = 0;
	SameTarget = 0;
	Commands->Action_Reset(obj,100);
	Commands->Enable_Enemy_Seen(obj,true);
}

void JMG_RP2_Jerads_Strike_Craft::AttackHoldFunction(GameObject *obj,GameObject *Enemy)
{
	GameObject *Driver = Commands->Find_Object(DriverID);
	Vector3 MyPos = Commands->Get_Position(obj),EnemyPos = Commands->Get_Position(Enemy);
	float DistanceE = Commands->Get_Distance(MyPos,EnemyPos);
	IsMoving = 0;
	if (Enemy)
	{
		if (((DistanceE > 200) || (DistanceE > 150 && (Enemy->As_PhysicalGameObj() && Enemy->As_PhysicalGameObj()->Peek_Physical_Object() && Enemy->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))) && (Primary == true || LongRange == false))
		{
			Primary = false;
			LongRange = true;
		}
		else if (Primary == false || LongRange == true)
		{
			Primary = true;
			LongRange = false;
		}
	}
	if (!Get_Vehicle_Driver(obj) && Driver)
	{
		ActionParamsStruct params;
		params.Set_Basic(this,100,100);
		if (!Get_Vehicle_Driver(obj) && Driver)
		{
			IsMoving = 1;
			params.Set_Movement(Driver,1.0f,15,false);
			params.MoveFollow = true;
			params.MovePathfind =false;
			params.MoveBackup=Backward;
			MyLastPos = Commands->Get_Position(obj);
			Commands->Action_Goto(obj,params);
		}
		if (Enemy)
		{
			KillTargetID = EnemyID;
			if (LongRange == true)
			{
				params.Set_Attack(Enemy,600,0,Primary);
			}
			else
			{
				params.Set_Attack(Enemy,300,0,Primary);
			}
			Commands->Action_Attack(obj,params);
		}
	}
}

void JMG_RP2_Jerads_Strike_Craft::VisibilityCheck(GameObject *obj)
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (EnemyID == 0) // Always set to true if no enemy is targeted
	{
		Checking = NOTHING;
		Commands->Enable_Enemy_Seen(obj,true);
	}
	if (Checking == SEARCHCOMPLETE)// If not checking for an enemy start
	{
		Checking = SEARCHING;
		TargetVisible = false;
		TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(EnemyID)));
	}
	else if (Checking == SEARCHING && TargetVisible == 0)// If just completed the check, but enemy not found, clear target
	{
		EnemyID = 0;
		Checking = NOTHING;
		Commands->Enable_Enemy_Seen(obj,true);
	}
	else if (Checking == SEARCHING && TargetVisible == 1)// Enemy was found, keep the target
	{
		Commands->Enable_Enemy_Seen(obj,false);
		Checking = SEARCHCOMPLETE;
	}
}

void JMG_RP2_Jerads_Strike_Craft::ScreenFade(Vector3 HCPos)
{
	for (int x = 1;x < 128;x++)
	{
		GameObject *Player = Get_GameObj(x);
		if (Player)
		{
			if (Commands->Get_Distance(HCPos,Commands->Get_Position(Player)) <= 300.0f)
			{
				int PlayerID = x;
				if (!DRUGSCREENEFFECTSON[PlayerID] && !ISUNDERWATER[PlayerID])
				{
					RP2WeatherStruct *MyNode = PlayerWeatherNodes[Get_Player_ID(Player)];
					if (MyNode)
					{
						Set_Screen_Fade_Color_Player(Player,1.0,1.0,1.0,0);
						if (!Is_Script_Attached(Player,"JMG_RP2_Teleport_Zone_Script_Attach"))
						{
							Set_Screen_Fade_Opacity_Player(Player,1.0,0);
						}
						Set_Screen_Fade_Color_Player(Player,MyNode->ScreenColor.X,MyNode->ScreenColor.Y,MyNode->ScreenColor.Z,1.0);
						if (!Is_Script_Attached(Player,"JMG_RP2_Teleport_Zone_Script_Attach"))
						{
							Set_Screen_Fade_Opacity_Player(Player,MyNode->ScreenOpacity,1.0);
						}
					}
					else
					{
						Set_Screen_Fade_Color_Player(Player,1.0,1.0,1.0,0);
						if (!Is_Script_Attached(Player,"JMG_RP2_Teleport_Zone_Script_Attach"))
						{
							Set_Screen_Fade_Opacity_Player(Player,1.0,0.0);
						}
						Set_Screen_Fade_Color_Player(Player,0.0,0.0,0.0,1.0);
						if (!Is_Script_Attached(Player,"JMG_RP2_Teleport_Zone_Script_Attach"))
						{
							Set_Screen_Fade_Opacity_Player(Player,0,1.0);
						}
					}
				}
			}
		}
	}
}

int JMG_RP2_Jerads_Strike_Craft::OnIsland(GameObject *obj)
{
	Vector3 pos, MYPOS = Commands->Get_Position(obj);
	pos.X = 4892.0f;
	pos.Y = 5037.0f;
	pos.Z = -4995.0f;
	if (Commands->Get_Distance(MYPOS,pos) < 500)
	{
		return 1;
	}
	return 0;
}

GameObject *JMG_RP2_Jerads_Strike_Craft::Get_A_Star2(GameObject *obj,Vector3 pos)
{
	float CloseDistance = 0;
	GameObject *ClosestPlayer = NULL;
	for (int x = 1;x < 128;x++)
	{
		if (!ISSELECTINGSPAWN[x])
		{
			GameObject *Player = Get_GameObj(x);
			if (Player)
			{
				if (Player != Get_Vehicle_Driver(obj))
				{
					if (!ClosestPlayer)
					{
						CloseDistance = Commands->Get_Distance(pos,Commands->Get_Position(Player));
						ClosestPlayer = Player;
					}
					else
					{
						float Distance = Commands->Get_Distance(pos,Commands->Get_Position(Player));
						if (Distance < CloseDistance)
						{
							CloseDistance = Distance;
							ClosestPlayer = Player;
						}
					}
				}
			}
		}
	}
	return ClosestPlayer;
}

RP2VehicleControl *JMG_RP2_Jerads_Strike_Craft::Get_Vehicle_Node2(GameObject *obj)
{
	if (!RP2VehicleNode)
	{
		RP2VehicleNode = new RP2VehicleControl;
		RP2VehicleNode->VehicleID = Commands->Get_ID(obj);
		RP2VehicleNode->AirSupply = 0;
		RP2VehicleNode->OnCarryAll = 0;
		RP2VehicleNode->next = NULL;
		return RP2VehicleNode;
	}
	else
	{
		RP2VehicleControl *Current = RP2VehicleNode;
		int MyID = Commands->Get_ID(obj);
		while (Current != NULL)
		{
			if (Current->VehicleID == MyID)
			{
				return Current;
			}
			else if (Current->next == NULL)
			{
				Current->next = new RP2VehicleControl;
				Current = Current->next;
				Current->VehicleID = Commands->Get_ID(obj);
				Current->AirSupply = 0;
				Current->OnCarryAll = 0;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Map_Boundry::Entered(GameObject *obj,GameObject *enter)
{
	Vector3 EnterPos = Commands->Get_Position(enter);
	if (Get_Float_Parameter("Re-AlignX") != -1)
	{
		EnterPos.X = Get_Float_Parameter("Re-AlignX");
	}
	if (Get_Float_Parameter("Re-AlignY") != -1)
	{
		EnterPos.Y = Get_Float_Parameter("Re-AlignY");
	}
	if (Get_Float_Parameter("Re-AlignZ") != -1)
	{
		EnterPos.Z = Get_Float_Parameter("Re-AlignZ");
	}
	Commands->Set_Position(enter,EnterPos);
}

void JMG_RP2_SCUD_Launcher_Script::Created(GameObject *obj)
{
	MyNode = NULL;
	Add_Node(obj);
	SCUDLauncherNode->TargetingSystemID = 0;
	State = 0;
	Deploy = 0;
	IsArmed = 1;
	CanToggle = 1;
	Commands->Set_Model(obj,Get_Parameter("Armed_Model"));
	sprintf(Animation,"scud_launcher_s.scud_launcher_a");
	Commands->Set_Animation(obj,Animation,false,0,Get_Float_Parameter("UnDeployedFrame"),Get_Float_Parameter("UnDeployedFrame"),0);
	EngineEnabled = 1;
	PlayerID = 0;
	Commands->Start_Timer(obj,this,2.5f,987458);
	Commands->Start_Timer(obj,this,0.1f,92562142);
}

void JMG_RP2_SCUD_Launcher_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7154148)
	{
		Send_Message_Player(sender,200,200,125,"Vehicle Special Key:");
		Send_Message_Player(sender,200,200,125,"B - Deploy/Undeploy");
	}
	if ((message == 7745472 && CanToggle && !MyNode->EMPTime) || message == 91191153 || (message == EMPMESSAGE && Deploy))
	{
		Vector3 AlignPos = Commands->Get_Bone_Position(obj,"Align"),OriginPos = Commands->Get_Bone_Position(obj,"Origin");
		if ((AlignPos.Z > OriginPos.Z && Deploy == 0) || Deploy == 1)
		{
			AlignPos.Z = 0.0f;
			OriginPos.Z = 0.0f;
			if ((Commands->Get_Distance(OriginPos,AlignPos) < 10.0f && Deploy == 0) || Deploy == 1)
			{
				if (CanToggle)
				{
					Commands->Start_Timer(obj,this,1.0f,92562144);
				}
				CanToggle = 0;
				if (Deploy)
				{
					Deploy = 0;
					Send_Message_Player(sender,150,0,150,"Undeploying...");
					PlayerID = Commands->Get_ID(sender);
					RemoveTargetObject(obj);
				}
				else if (!Deploy)
				{
					Deploy = 1;
					Send_Message_Player(sender,150,0,150,"Deploying...");
				}
			}
			else
			{
				Send_Message_Player(sender,150,0,150,"Please find a more level location to deploy...");
			}
		}
		else
		{
			Send_Message_Player(sender,150,0,150,"Cannot deploy while upside down...");
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		DriverID = Get_Player_ID(sender);
		if (EngineEnabled == 0)
		{
			Commands->Enable_Engine(obj,false);
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED && EngineEnabled == 0)
	{
		Commands->Enable_Engine(obj,false);
	}
	if (message == 91151191 && Get_Current_Bullets(obj))
	{
		TargetSpot = Commands->Get_Position(sender);
		Set_Current_Clip_Bullets(obj,0);
		Set_Current_Bullets(obj,0);
		GameObject *Missile = Commands->Create_Object("SCUD_Missile_Up",Commands->Get_Bone_Position(obj,"MuzzleA0"));
		Commands->Set_Model(Missile,Get_Parameter("Missile_Model_Up"));
		Commands->Set_Facing(Missile,Commands->Get_Facing(obj));
		char params[2000];
		sprintf(params,"%d,%d",Commands->Get_ID(obj),DriverID);
		Commands->Attach_Script(Missile,"JMG_RP2_SCUD_Launcher_SCUD_Missile_Up",params);
		GameObject *Driver = Get_GameObj(DriverID);
		Commands->Send_Custom_Event(obj,Get_Vehicle(Driver),7745473,1,0);
		Commands->Create_Sound("Scud_Launcher_Fire",Commands->Get_Position(obj),obj);
		Send_Message_Player(Driver,150,0,150,"Launching SCUD...");
	}
	if (message == 91151192)
	{
		GameObject *TargetObject = Commands->Find_Object(SCUDLauncherNode->TargetingSystemID);
		if (SCUDLauncherNode->TargetingSystemID)
		{
			TargetSpot = Commands->Get_Position(TargetObject);
		}
		Vector3 MyPos = Commands->Get_Position(obj),TargetPos = TargetSpot;
		MyPos.Z = 0.0f;
		TargetPos.Z = 0.0f;
		GameObject *Driver = Get_GameObj(DriverID);
		float TravelTime = (Commands->Get_Distance(TargetPos,MyPos)/399);
		Commands->Start_Timer(obj,this,TravelTime+(TravelTime*0.1f)+1.0f,92562143);
		Send_Message_Player(Driver,150,0,150,"SCUD has entered orbit...");
	}
	if (message == 91191154)
	{
		Set_Current_Bullets(obj,-1);
	}
}

void JMG_RP2_SCUD_Launcher_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 987458)
	{
		MyNode = Get_Vehicle_Node(obj);
		if (!MyNode)
		{
			Commands->Start_Timer(obj,this,2.5f,987458);
		}
	}
	if (number == 92562142)
	{
		enum{UNDEPLOYED = 0,DEPLOYED = 1,InProgress = 2};
		float CurrentFrame = Get_Animation_Frame(obj);
		if (State)//Engine On
		{
			EngineEnabled = 0;
			Commands->Enable_Engine(obj,false);
		}
		else if (!State && !EngineEnabled)//Engine Off
		{
			EngineEnabled = 1;
			if (Get_Vehicle_Occupant_Count(obj))
			{
				Commands->Enable_Engine(obj,true);
			}
		}
		if (!Get_Current_Bullets(obj) && IsArmed)
		{
			IsArmed = 0;
			Commands->Set_Model(obj,Get_Parameter("Empty_Model"));
		}
		if (Get_Current_Bullets(obj) && !IsArmed)
		{
			IsArmed = 1;
			Commands->Set_Model(obj,Get_Parameter("Armed_Model"));
		}
		if (CurrentFrame == Get_Float_Parameter("UnDeployedFrame") && State != UNDEPLOYED)
		{
			State = UNDEPLOYED;
		}
		if (CurrentFrame == Get_Float_Parameter("DeployedFrame") && State != DEPLOYED)
		{
			State = DEPLOYED;
			CreateTargetObject(obj);
		}
		if (State != DEPLOYED && Deploy == 1)
		{
			if (!Get_Vehicle_Occupant_Count(obj) && Deploy)
			{
				Deploy = 0;
			}
			State = InProgress;
			Commands->Set_Animation(obj,Animation,false,0,CurrentFrame,Get_Float_Parameter("DeployedFrame"),0);
		}
		if (State != UNDEPLOYED && Deploy == 0)
		{
			State = InProgress;
			Commands->Set_Animation(obj,Animation,false,0,CurrentFrame,Get_Float_Parameter("UnDeployedFrame"),0);
		}
		if (PlayerID)
		{
			GameObject *Player = Commands->Find_Object(PlayerID);
			if (Player)
			{
				if (!Get_Vehicle(Player))
				{
					Commands->Set_Position(Player,Commands->Get_Position(obj));
					Soldier_Transition_Vehicle(Player);
				}
				else
				{
					PlayerID = 0;
				}
			}
		}
		Vector3 AlignPos = Commands->Get_Bone_Position(obj,"Align"),OriginPos = Commands->Get_Bone_Position(obj,"Origin");
		AlignPos.Z = 0.0f;
		OriginPos.Z = 0.0f;
		if ((Commands->Get_Distance(OriginPos,AlignPos) > 10.0f || AlignPos.Z < OriginPos.Z) && Deploy == 1)
		{
			Deploy = 0;
			RemoveTargetObject(obj);
		}
		// Undeploy when target system destroyed
		GameObject *TargetObject = Commands->Find_Object(SCUDLauncherNode->TargetingSystemID);
		if (!TargetObject && Deploy && State == DEPLOYED)
		{
			Deploy = 0;
		}
		Commands->Start_Timer(obj,this,0.1f,92562142);
	}
	if (number == 92562143)
	{
		GameObject *TargetObject = Commands->Find_Object(SCUDLauncherNode->TargetingSystemID);
		if (SCUDLauncherNode->TargetingSystemID)
		{
			TargetSpot = Commands->Get_Position(TargetObject);
		}
		TargetSpot.Z = 2500.0f;
		GameObject *Missile = Commands->Create_Object("SCUD_Missile_Down",TargetSpot);
		Commands->Set_Model(Missile,Get_Parameter("Missile_Model_Down"));
		Commands->Set_Facing(Missile,Commands->Get_Facing(obj));
		Send_Message_Player(Get_GameObj(DriverID),150,0,150,"SCUD has begun reentry.");
		char params[2000];
		sprintf(params,"%d,%d,%d",SCUDLauncherNode->TargetingSystemID,DriverID,Commands->Get_ID(obj));
		Commands->Attach_Script(Missile,"JMG_RP2_SCUD_Launcher_SCUD_Missile_Down",params);
	}
	if (number == 92562144)
	{
		CanToggle = 1;
	}
}

void JMG_RP2_SCUD_Launcher_Script::CreateTargetObject(GameObject *obj)
{
	if (!Get_Vehicle_Occupant_Count(obj) && Deploy)
	{
		Deploy = 0;
	}
	else
	{
		GameObject *TargetObject = Commands->Find_Object(SCUDLauncherNode->TargetingSystemID);
		if (!TargetObject)
		{
			Vector3 Pos = Commands->Get_Position(obj);
			Pos.Z -= 2.0f;
			TargetObject = Commands->Create_Object("SCUD_Targeting_Setup",Pos);
			Commands->Set_Facing(TargetObject,Commands->Get_Facing(obj));
			SCUDLauncherNode->TargetingSystemID = Commands->Get_ID(TargetObject);
			char params[2000];
			sprintf(params,"%d",Commands->Get_ID(obj));
			Commands->Attach_Script(TargetObject,"JMG_RP2_SCUD_Launcher_Targeting_System",params);
			Commands->Attach_Script(TargetObject,"JMG_RP2_SCUD_Launcher_Targeting_System_Camera_Facing","0");
		}
	}
}

void JMG_RP2_SCUD_Launcher_Script::RemoveTargetObject(GameObject *obj)
{
	GameObject *TargetObject = Commands->Find_Object(SCUDLauncherNode->TargetingSystemID);
	if (TargetObject)
	{
		Commands->Send_Custom_Event(obj,TargetObject,91191151,1,0);
		SCUDLauncherNode->TargetingSystemID = 0;
	}
}

void JMG_RP2_SCUD_Launcher_Script::Killed(GameObject *obj, GameObject *damager)
{
	Remove_Node(obj);
	GameObject *TargetObject = Commands->Find_Object(SCUDLauncherNode->TargetingSystemID);
	if (TargetObject)// Get into Targeting system
	{
		Commands->Send_Custom_Event(obj,TargetObject,91191150,1,0);
	}
}

void JMG_RP2_SCUD_Launcher_Script::Add_Node(GameObject *obj)
{
	if (!SCUD_Missile_Launcher_Node)
	{
		SCUD_Missile_Launcher_Node = new SCUD_Missile_Launcher_Control;
		SCUD_Missile_Launcher_Node->LauncherID = Commands->Get_ID(obj);
		SCUD_Missile_Launcher_Node->ScudID = 0;
		SCUD_Missile_Launcher_Node->TargetingSystemID = 0;
		SCUDLauncherNode = SCUD_Missile_Launcher_Node;
		SCUD_Missile_Launcher_Node->next = NULL;
	}
	else
	{
		int end = 0;
		SCUD_Missile_Launcher_Control *Current = SCUD_Missile_Launcher_Node;
		while (Current != NULL && end == 0)
		{
			if (Commands->Get_ID(obj) == Current->LauncherID)
			{
				end = 1;
				SCUD_Missile_Launcher_Node = Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new SCUD_Missile_Launcher_Control;
				Current = Current->next;
				Current->LauncherID = Commands->Get_ID(obj);
				Current->ScudID = 0;
				Current->TargetingSystemID = 0;
				SCUDLauncherNode = Current;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_SCUD_Launcher_Script::Remove_Node(GameObject *obj)
{
	if (SCUD_Missile_Launcher_Node)
	{
		SCUD_Missile_Launcher_Control *Current = SCUD_Missile_Launcher_Node,*Prev = NULL;
		while (Current != NULL)
		{
			if (Commands->Get_ID(obj) == Current->LauncherID)
			{
				if (Prev == NULL)// Head of list
				{
					SCUD_Missile_Launcher_Node = Current->next;
					delete Current;
					return;
				}
				else if (Prev != NULL && Current->next != NULL)// Middle of list
				{
					Prev->next = Current->next;
					delete Current;
					return;
				}
				else if (Prev != NULL && Current->next == NULL)// End of list
				{
					Prev->next = NULL;
					delete Current;
					return;
				}
			}
			Prev = Current;
			Current = Current->next;
		}
	}
}
void JMG_RP2_New_Soldier_Spawn_System::Created(GameObject *obj)
{
	PlayerID = Get_Player_ID(obj);
	RP2WeatherStruct *MyNode = PlayerWeatherNodes[PlayerID];
	if (!MyNode && DefaultRP2WeatherNode)
	{
		PlayerWeatherNodes[PlayerID] = DefaultRP2WeatherNode;
	}
	if (MyNode && MyNode->AreaID != 0)
	{
		PlayerWeatherNodes[PlayerID] = RP2_Area_Weather_Selection_Control(0,NULL);
	}
	Enable_Radar_Player(obj,false);
	if (Commands->Is_A_Star(obj))
	{
		for (int x = 1;x < 128;x++)
		{
			GameObject *Player = Get_GameObj(x);
			Set_Obj_Radar_Blip_Shape_Player(Player,obj,RADAR_BLIP_SHAPE_NONE);
		}
		Commands->Set_Is_Visible(obj,false);
		Commands->Set_Player_Type(obj,-1);
		PHONEZONES[PlayerID] = 1;
		Commands->Attach_Script(obj,"JMG_RP2_Player_Phone_Control_Script","");
		SPAWNINGALLOWED[PlayerID] = 1;
		ISSELECTINGSPAWN[PlayerID] = 1;
		ATTEMPTINGTOSPAWN[PlayerID] = 0;
		ISNEWSWIMMING[PlayerID] = 0;
		ISUNDERWATER[PlayerID] = 0;
		IsInsideHouse[PlayerID] = 0;
		CURRENTPLAYERPTZONE[PlayerID] = 0;
		if (RP2PlayerSAWTArray[PlayerID])
		{
			RP2PlayerSAWTControl *temp,*die;
			temp = RP2PlayerSAWTArray[PlayerID];
			while (temp != NULL)
			{
				die = temp;
				temp = temp->next;
				delete die;
			}
			RP2PlayerSAWTArray[PlayerID] = NULL;
		}
		MyPos.X = -745.4f;
		MyPos.Y = 6092.40f;
		MyPos.Z = -476.25;
		CanSpawnWhenEver = 1;
		CanBeSeen = 0;
		EnteredWater = 0;
		HasLeftClicked = 1;
		LastPos[0] = LastPos[1] = LastPos[2] = LastPos[3] = LastPos[4] = Commands->Get_Position(obj);
		HouseID = 0;
		RightClick = 0;
		SpawnLocation = Commands->Get_Position(obj);
		Commands->Start_Timer(obj,this,1.1f,5119113);
		Commands->Start_Timer(obj,this,1.0,5119116);
		Commands->Start_Timer(obj,this,0.0,5119117);
		Commands->Disable_Physical_Collisions(obj);
		Attach_Script_Once(obj,"JMG_New_Swimming_Script","1,1,-1,0,0,Invisible_Box,newhaadj,Weapon_Empty_Hands,POW_Empty_Hands,Breath_Sound,null,null,null,c_ag_civ1_male,null,SwimmingSkin,SwimmingDamage,0,null,null,0");
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Stuck,911911911");
	}
}

void JMG_RP2_New_Soldier_Spawn_System::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 911911911)
	{
		Commands->Destroy_Object(obj);
	}
	if (message == 21511235 && !ATTEMPTINGTOSPAWN[PlayerID] && Is_Gameplay_Permitted())// left click
	{
		CanBeSeen = 0;
		EnteredWater = 0;
		ATTEMPTINGTOSPAWN[PlayerID] = 1;
		if (CanSpawnWhenEver)
		{
			SpawnPlayer(obj);
		}
		else if (Can_Spawn_Messages(obj))
		{
			HasLeftClicked = 1;
			Commands->Set_Is_Visible(obj,true);
			PEOPLEINLINEFORSPAWNING++;
			SeeIfVisible(obj);
			Commands->Start_Timer(obj,this,1.0,5119115);
			Send_Message_Player(obj,150,0,0,"Attempting Spawn In:");
			Send_Message_Player(obj,150,0,0,"3");
		}
		else
		{
			ATTEMPTINGTOSPAWN[PlayerID] = 0;
		}
	}
	if (message == 21511236 && !Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach") && Is_Gameplay_Permitted())// right click
	{
		ATTEMPTINGTOSPAWN[PlayerID] = 0;
		CanBeSeen = 0;
		EnteredWater = 0;
		if (HouseID && !RightClick)
		{
			Commands->Set_Position(obj,Commands->Get_Position(Commands->Find_Object(HouseID)));
		}
		else
		{
			Commands->Set_Position(obj,SpawnLocation);
		}
		if (RightClick)
		{
			RightClick = 0;
		}
		else
		{
			RightClick = 1;
		}
		Set_Screen_Fade_Color_Player(obj,0.0,0.0,0.0,0);
		Set_Screen_Fade_Opacity_Player(obj,1.0,0.0);
		RP2WeatherStruct *MyNode = PlayerWeatherNodes[Get_Player_ID(obj)];
		if (MyNode)
		{
			Set_Screen_Fade_Opacity_Player(obj,MyNode->ScreenOpacity,1.0);
		}
		else
		{
			Set_Screen_Fade_Opacity_Player(obj,0,1.0);
		}
		Commands->Set_Animation(obj,"s_a_human.h_a_a0a0_l41",1,0,0,1,1);
	}
	if (message == 51191171)
	{
		CanBeSeen = 1;
	}
	if (message == 347361)
	{
		EnteredWater = 1;
		Send_Message_Player(obj,150,0,0,"You cannot spawn while in the water...");
	}
	if (message == 51191100)
	{
		if (param != SPAWNINGALLOWED[PlayerID])
		{
			if (!param)
			{
				Send_Message_Player(obj,150,0,0,"I cannot spawn in this area...");
			}
			else
			{
				Send_Message_Player(obj,150,0,0,"I may spawn in this area...");
			}
		}
		SPAWNINGALLOWED[PlayerID] = param;
	}
}

void JMG_RP2_New_Soldier_Spawn_System::Timer_Expired(GameObject *obj,int number)
{
	if (number == 5119117 && HasLeftClicked == 1)
	{
		Set_Screen_Fade_Color_Player(obj,0.75,0.75,0,0.1f);
		Set_Screen_Fade_Opacity_Player(obj,0.5,0.1f);
		Commands->Start_Timer(obj,this,0.1f,5119117);
	}
	if (number == 5119116)
	{
		char PlayerName[256];
		const char *str = Get_Player_Name(obj);
		sprintf(PlayerName,"%s",str);
		delete[] str;
		if (RP2NewHouseSystemNode)
		{
			RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
			while (Current != NULL)
			{
				if (!_stricmp(PlayerName,Current->PlayerName))
				{
					HouseID = Current->SpawnObjectID;
				}
				Current = Current->next;
			}
		}
		HasLeftClicked = 0;
		Set_Screen_Fade_Color_Player(obj,0,0.39f,0.78f,1.0);
		Set_Screen_Fade_Opacity_Player(obj,0.5,1.0);
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Primary_Fire,21511235");	
		Commands->Attach_Script(obj,"JMG_Keyboard_Input_Custom","Secondary_Fire,21511236");	
	}
	if (number == 5119115)
	{
		if (Can_Spawn_Messages(obj) && ATTEMPTINGTOSPAWN[PlayerID])
		{
			Send_Message_Player(obj,150,0,0,"2");
			Commands->Start_Timer(obj,this,1.0,5119114);
		}
	}
	if (number == 5119114)
	{
		if (Can_Spawn_Messages(obj) && ATTEMPTINGTOSPAWN[PlayerID])
		{
			Send_Message_Player(obj,150,0,0,"1");
			Commands->Start_Timer(obj,this,1.0,5119110);
		}
	}
	if (number == 5119110)
	{
		if (Can_Spawn_Messages(obj) && ATTEMPTINGTOSPAWN[PlayerID])
		{
			SpawnPlayer(obj);
		}
	}
	if (number == 5119111)
	{
		if (!ATTEMPTINGTOSPAWN[PlayerID])
		{
			if (Can_Spawn_Messages(obj))
			{
				if (HouseID && !RightClick)
				{
					Send_Message_Player(obj,150,0,0,"Press the fire button to spawn, alt fire will take you to your house...");
				}
				else
				{
					Send_Message_Player(obj,150,0,0,"Press the fire button to spawn, alt fire to return to original spawn position...");
				}
			}
		}
		Commands->Start_Timer(obj,this,15.0,5119111);
	}
	if (number == 5119112)
	{
		if (CanSpawnWhenEver)
		{
			if (Commands->Get_Distance(MyPos,Commands->Get_Position(obj)) > 37.0f)
			{
				CanSpawnWhenEver = 0;
			}
			else
			{
				CanSpawnWhenEver = 1;
			}
		}
		if (Get_Vehicle(obj))
		{
			Soldier_Transition_Vehicle(obj);
			Send_Message_Player(obj,150,0,0,"I cannot drive a vehicle while choosing where to spawn.");
		}
		if (!DRUGSCREENEFFECTSON[PlayerID] && !ISUNDERWATER[PlayerID] && !Get_Vehicle(obj))
		{
			Set_Screen_Fade_Color_Player(obj,0,0.39f,0.78f,1.0);
			if (!Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
			{
				Set_Screen_Fade_Opacity_Player(obj,0.5,1.0);
			}
		}
		//Keep your distance
		Vector3 POS = Commands->Get_Position(obj);
		if (Commands->Get_Distance(Commands->Get_Position(Get_A_Star2(obj,POS)),POS) < 5.0f && !CanSpawnWhenEver)
		{
			Relocate(obj);
		}
		else
		{
			int EnoughDistance = 1;
			for (int x = 0;x < 5 && EnoughDistance;x++)
			{
				if (Commands->Get_Distance(LastPos[x],POS) < 10.0f)
				{
					EnoughDistance = 0;
				}
			}
			if (EnoughDistance)
			{
				LastPos[0] = LastPos[1];
				LastPos[1] = LastPos[2];
				LastPos[2] = LastPos[3];
				LastPos[3] = LastPos[4];
				LastPos[4] = POS;
			}
		}
		Commands->Start_Timer(obj,this,0.1f,5119112);
	}
	if (number == 5119113)
	{
		if (Is_Gameplay_Permitted())
		{
			Commands->Start_Timer(obj,this,0.1f,5119111);
			Commands->Start_Timer(obj,this,0.1f,5119112);
		}
		else
		{
			Set_Screen_Fade_Color_Player(obj,0.75,0.75,0,0.1f);
			Set_Screen_Fade_Opacity_Player(obj,0.5,0.1f);
			Commands->Start_Timer(obj,this,0.1f,5119113);
		}
	}
}

int JMG_RP2_New_Soldier_Spawn_System::IsNotTooCloseToStar(GameObject *obj)
{
	SLNode<SmartGameObj> *Current = GameObjManager::SmartGameObjList.Head();
	while (Current) 
	{
		GameObject *o = Current->Data();
		if (obj && obj != o)
		{
			if (Commands->Is_A_Star(o))
			{
				float Distance = Commands->Get_Distance(Commands->Get_Position(o),Commands->Get_Position(obj));
				if (Distance < 1.0f)
				{
					return 0;
				}
			}
		}
		Current = Current->Next();
	}
	return 1;
}

int JMG_RP2_New_Soldier_Spawn_System::Can_Spawn_Messages(GameObject *obj)
{
	if (Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
	{
		Send_Message_Player(obj,150,0,0,"You cannot spawn while going through a door...");
	}
	else if (!SPAWNINGALLOWED[PlayerID])
	{
		Send_Message_Player(obj,150,0,0,"You cannot spawn while in this area...");
	}
	else if (ISNEWSWIMMING[PlayerID] || EnteredWater)
	{
		Send_Message_Player(obj,150,0,0,"You cannot spawn while in the water...");
	}
	else if (Get_Vehicle(obj))
	{
		Send_Message_Player(obj,150,0,0,"You cannot spawn while in a vehicle...");
	}
	else if (CanBeSeen)
	{
		Send_Message_Player(obj,150,0,0,"You cannot spawn while another player can see you...");
	}
	else if (!IsNotTooCloseToStar(obj))
	{
		Send_Message_Player(obj,150,0,0,"You cannot spawn that close to another player...");
	}
	else
	{
		return 1;
	}
	CanBeSeen = 0;
	EnteredWater = 0;
	HasLeftClicked = 0;
	PEOPLEINLINEFORSPAWNING--;
	ATTEMPTINGTOSPAWN[PlayerID] = 0;
	Commands->Set_Is_Visible(obj,false);
	return 0;
}

void JMG_RP2_New_Soldier_Spawn_System::SeeIfVisible(GameObject *obj)
{
	SLNode<SmartGameObj> *Current = GameObjManager::SmartGameObjList.Head();
	while (Current) 
	{
		GameObject *o = Current->Data();
		if (obj && obj != o)
		{
			if (Commands->Is_A_Star(o))
			{
				float Distance = Commands->Get_Distance(Commands->Get_Position(o),Commands->Get_Position(obj));
				if (Distance <= 300.0f)
				{
					Commands->Send_Custom_Event(obj,o,51191170,1,0);
				}
			}
		}
		Current = Current->Next();
	}
}

void JMG_RP2_New_Soldier_Spawn_System::SpawnPlayer(GameObject *obj)
{
	if (!PlayerWeatherNodes[Get_Player_ID(obj)] && DefaultRP2WeatherNode)
	{
		PlayerWeatherNodes[Get_Player_ID(obj)] = DefaultRP2WeatherNode;
	}
	ISSELECTINGSPAWN[PlayerID] = 0;
	Commands->Set_Is_Visible(obj,true);
	if (Is_Script_Attached(obj,"JMG_Keyboard_Input_Custom")){Remove_Script(obj,"JMG_Keyboard_Input_Custom");}
	if (Is_Script_Attached(obj,"JMG_New_Swimming_Script")){Remove_Script(obj,"JMG_New_Swimming_Script");}
	Change_Character(obj,"RP2_Default_Spawn_Infantry");
	if (Is_Script_Attached(obj,"JMG_RP2_New_Soldier_Spawn_System")){Remove_Script(obj,"JMG_RP2_New_Soldier_Spawn_System");}
	Commands->Attach_Script(obj,"JMG_RP2_Grant_House_Keys_On_Spawn","");
}

void JMG_RP2_New_Soldier_Spawn_System::Relocate(GameObject *obj)
{
	if (!Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
	{
		int end = 0;
		Vector3 POS = Commands->Get_Position(obj);
		for (int x = 4;x >= 0 && !end;x--)
		{
			if (Commands->Get_Distance(LastPos[x],Commands->Get_Position(Get_A_Star2(obj,LastPos[x]))) > 10.0f)
			{
				end = 1;
				Send_Message_Player(obj,150,0,0,"Please give the other players their space while selecting your spawn point!");
				Commands->Set_Position(obj,LastPos[x]);
			}
		}
		Set_Screen_Fade_Color_Player(obj,0.0,0.0,0.0,0);
		Set_Screen_Fade_Opacity_Player(obj,1.0,0.0);
		RP2WeatherStruct *MyNode = PlayerWeatherNodes[Get_Player_ID(obj)];
		if (MyNode)
		{
			Set_Screen_Fade_Opacity_Player(obj,MyNode->ScreenOpacity,1.0);
		}
		else
		{
			Set_Screen_Fade_Opacity_Player(obj,0,1.0);
		}
		Commands->Set_Animation(obj,"s_a_human.h_a_a0a0_l41",1,0,0,1,1);
	}
}

GameObject *JMG_RP2_New_Soldier_Spawn_System::Get_A_Star2(GameObject *obj,Vector3 pos)
{
	float CloseDistance = 0;
	GameObject *ClosestPlayer = NULL;
	for (int x = 1;x < 128;x++)
	{
		if (!ISSELECTINGSPAWN[x])
		{
			GameObject *Player = Get_GameObj(x);
			if (Player)
			{
				if (Player != obj)
				{
					if (!ClosestPlayer)
					{
						CloseDistance = Commands->Get_Distance(pos,Commands->Get_Position(Player));
						ClosestPlayer = Player;
					}
					else
					{
						float Distance = Commands->Get_Distance(pos,Commands->Get_Position(Player));
						if (Distance < CloseDistance)
						{
							CloseDistance = Distance;
							ClosestPlayer = Player;
						}
					}
				}
			}
		}
	}
	return ClosestPlayer;
}

void JMG_RP2_New_Soldier_Spawn_Allowed_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		Commands->Send_Custom_Event(obj,enter,51191100,Get_Int_Parameter("Allow_Spawing_After_Enter"),0);
	}
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::Created(GameObject *obj)
{
	MinFlightHeight = Commands->Get_Position(obj).Z + Get_Int_Parameter("Min_Flight_Height");
	EnemyID = 0;
	TargetVisible = 0;
	Checking = 2;
	AGTargetID = 0;
	KillTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	if (Get_Int_Parameter("On_Grid") < 128 && Get_Int_Parameter("On_Grid") >= 0)
	{
		MyGrid = Get_Int_Parameter("On_Grid");
	}
	else
	{
		MyGrid = -1;
	}
	Commands->Start_Timer(obj,this,1.0,92562142);
	Commands->Start_Timer(obj,this,0.1f,92562143);
	Commands->Enable_Enemy_Seen(obj,true);
	Attach_Script_Once(obj,"JMG_RP2_Object_Send_Text_Message_On_Death","");
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (MinFlightHeight > Commands->Get_Position(seen).Z || !_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
	{
		return;
	}
	if (Commands->Is_A_Star(seen))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(seen)])
		{
			return;
		}
		if (seen->As_PhysicalGameObj())//Check if infantry is at least 3m above the ground
		{
			Vector3 Pos = Commands->Get_Position(seen),OldPos;
			OldPos = Pos;
			int x = 0;
			while (x < 3)
			{
				x++;
				Pos.Z -= 1.0f;
				Commands->Set_Position(seen,Pos);
				PhysicalGameObj *objphys = ((ScriptableGameObj *)seen)->As_PhysicalGameObj();
				if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
				{
					x = 5;
				}
			}
			Commands->Set_Position(seen,OldPos);
			if (x == 5)
			{
				return;
			}
		}
	}
	GameObject *TempV = Get_Vehicle(seen);
	if (TempV)
	{
		seen = TempV;
	}
	if ((seen->As_PhysicalGameObj() && seen->As_PhysicalGameObj()->Peek_Physical_Object() && seen->As_PhysicalGameObj()->Peek_Physical_Object()->As_ProjectileClass()))
	{
		return;
	}
	Vector3 Pos = Commands->Get_Position(obj),EPos = Commands->Get_Position(seen);
	float Distance = Commands->Get_Distance(Pos,EPos);
	if (Distance <= Get_Float_Parameter("Max_Range") && Distance > Get_Float_Parameter("Min_Range"))
	{
		Pos.Z = 0.0;
		EPos.Z = 0.0;
		if (Commands->Get_Distance(Pos,EPos) <= 150)
		{
			if (Checking == NOTHING)
			{	
				TargetDistance = Distance;
				EnemyID = Commands->Get_ID(seen);
				Commands->Enable_Enemy_Seen(obj,false);
				Checking = SEARCHCOMPLETE;
			}
			if (Checking == SEARCHING)//See if still visible
			{
				if ((EnemyID == Commands->Get_ID(seen) && TargetVisible == 0) || (EnemyID == Commands->Get_ID(seen) && TargetVisible == 1 && Distance <= TargetDistance))
				{
					TargetVisible = true;// TARGET FOUND
					TargetDistance = Distance;
				}
				else if (EnemyID != Commands->Get_ID(seen) && Distance + 1.0f < TargetDistance)// Closer Target Found, use this one
				{
					EnemyID = Commands->Get_ID(seen);
					TargetVisible = true;// TARGET FOUND!
					TargetDistance = Distance;
				}
			}
		}
	}
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 9911591)
	{
		GiveToGrid(sender);
	}
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damager && damage && damager != obj && Get_Vehicle_Is_Visible(damager) && _stricmp(Get_Skin(damager),"Blamo") && _stricmp(Get_Shield_Type(damager),"Blamo"))
	{
		/*int ValidTarget = 0;
		if (MinFlightHeight < Commands->Get_Position(damager).Z)
		{
			ValidTarget = 1;
		}
		if (Commands->Is_A_Star(damager))
		{
			if (ISSELECTINGSPAWN[Get_Player_ID(damager)])
			{
				ValidTarget = 0;
			}
		}*/
		GameObject *FVehicle = Get_Vehicle(damager);
		if (!FVehicle)
		{
			FVehicle = damager;
		}
		{
			if (!EnemyID && MyGrid != -1)
			{
				KillTargetID = 0;
				GiveToGrid(FVehicle);
				AGTargetID = Commands->Get_ID(FVehicle);
				SameTarget = 0;
				SelectNetworkTarget(obj);
				Checking = 1;
				TargetVisible = false;
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(AGTargetID)));
				Commands->Enable_Enemy_Seen(obj,true);
			}
		}
	}
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::Timer_Expired(GameObject *obj,int number)
{
	if (92562143 == number)
	{
		if (EnemyID)
		{
			GameObject *Enemy = Commands->Find_Object(EnemyID);
			if (MinFlightHeight < Commands->Get_Position(Enemy).Z)
			{
				if (Enemy && KillTargetID != EnemyID)
				{
					AttackHoldFunction(obj,Enemy);
					KillTargetID = EnemyID;
				}
				if (!Enemy)
				{
					EnemyID = 0;
					KillTargetID = 0;
				}
			}
			else
			{
				StopShootingAndReload(obj);
			}
		}
		else
		{
			AGAttackTime++;
			if (AGAttackTime > 15)
			{
				RemoveGridTarget(AGTargetID);
				StopShootingAndReload(obj);
			}
		}
		Commands->Start_Timer(obj,this,0.25,92562143);
	}
	if (number == 92562142)
	{
		VisibilityCheck(obj);
		Commands->Start_Timer(obj,this,1.25,92562142);
	}
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::StopShootingAndReload(GameObject *obj)
{
	EnemyID = 0;
	AGTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	Checking = 2;
	KillTargetID = 0;
	Commands->Enable_Enemy_Seen(obj,true);
	Commands->Action_Reset(obj,100);
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::AttackHoldFunction(GameObject *obj,GameObject *Enemy)
{
	ActionParamsStruct params;
	params.Set_Basic(this,0,100);
	params.Set_Attack(Enemy,Get_Float_Parameter("Max_Range"),0,1);
	params.AttackCheckBlocked = false;
	Commands->Action_Attack(obj,params);
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::VisibilityCheck(GameObject *obj)
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (EnemyID == 0) // Always set to true if no enemy is targeted
	{
		Checking = NOTHING;
		Commands->Enable_Enemy_Seen(obj,true);
		SelectNetworkTarget(obj);
	}
	if (Checking == SEARCHCOMPLETE)// If not checking for an enemy start
	{
		Checking = SEARCHING;
		TargetVisible = false;
		TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(EnemyID)));
		Commands->Enable_Enemy_Seen(obj,true);
	}
	else if (Checking == SEARCHING && TargetVisible == 0)// If just completed the check, but no enemy found, clear target
	{
		EnemyID = 0;
		if (!AGTargetID)
		{
			StopShootingAndReload(obj);
		}
		else
		{
			AGAttackTime++;
			if (AGAttackTime > 15)
			{
				RemoveGridTarget(AGTargetID);
				StopShootingAndReload(obj);
			}
		}
		SelectNetworkTarget(obj);
	}
	else if (Checking == SEARCHING && TargetVisible == 1)// Enemy was found, keep the target
	{
		Commands->Enable_Enemy_Seen(obj,false);
		Checking = SEARCHCOMPLETE;
	}
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::GiveToGrid(GameObject *Enemy)
{
	int end = 0;
	int AddID = Commands->Get_ID(Enemy);
	for (int x = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSBDGrid[MyGrid][x] == AddID)
		{
			end = 1;
			JRP2SSBDGrid[MyGrid][x] = AddID;
			JRP2SSBDGridTC[MyGrid]++;
		}
		else if (JRP2SSBDGrid[MyGrid][x] == 0)
		{
			end = 1;
			JRP2SSBDGrid[MyGrid][x] = AddID;
			JRP2SSBDGridTC[MyGrid]++;
		}
	}
	if (end == 0)
	{
		for (int x = 0;x < 25 && end == 0;x++)
		{
			if (x < 24)
			{
				JRP2SSBDGrid[MyGrid][x] = JRP2SSBDGrid[MyGrid][(x+1)];
			}
			else
			{
				JRP2SSBDGrid[MyGrid][x] = AddID;
			}
		}
	}
}

int JMG_RP2_Simple_Smart_AA_Base_Defense::GrabIDFromGrid()
{
	if (JRP2SSBDGridTC[MyGrid])
	{
		for (int x = 0,end = 0;x < 25 && end == 0;x++)
		{
			if (JRP2SSBDGrid[MyGrid][x] != 0)
			{
				end = 1;
				return JRP2SSBDGrid[MyGrid][x];
			}
		}
	}
	return 0;
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::RemoveGridTarget(int ID)
{
	for (int x = 0,end = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSBDGrid[MyGrid][x] == ID)
		{
			for (int y = x;y < 25;y++)
			{
				if (y < 24)
				{
					JRP2SSBDGrid[MyGrid][y] = JRP2SSBDGrid[MyGrid][(y+1)];
				}
				else
				{
					JRP2SSBDGrid[MyGrid][y] = 0;
				}
			}
			JRP2SSBDGridTC[MyGrid]--;
			end = 1;
		}
	}
}

void JMG_RP2_Simple_Smart_AA_Base_Defense::SelectNetworkTarget(GameObject *obj) 
{
	if (AGTargetID && EnemyID && AGTargetID != EnemyID)
	{
		GameObject *Target = Commands->Find_Object(AGTargetID);
		GameObject *Target2 = Commands->Find_Object(EnemyID);
		float ObjectDistance = Commands->Get_Distance(Commands->Get_Position(Target),Commands->Get_Position(obj));
		float EnemyDistance = Commands->Get_Distance(Commands->Get_Position(Target2),Commands->Get_Position(obj));
		if (ObjectDistance < EnemyDistance)
		{
			EnemyID = AGTargetID;
		}
		else
		{
			AGTargetID = EnemyID;
		}
	}
	if (AGTargetID && !EnemyID)
	{
		SameTarget++;
		EnemyID = AGTargetID;
		GameObject *Target = Commands->Find_Object(AGTargetID);
		if (!Target || !Commands->Get_Health(Target))
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
			EnemyID = 0;
			Checking = 2;
			Commands->Enable_Enemy_Seen(obj,true);
		}
		if (SameTarget >= 40)
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
		}
	}
	else if (!EnemyID && MyGrid != -1)
	{
		if (JRP2SSBDGridTC[MyGrid])
		{
			SameTarget = 0;
			EnemyID = GrabIDFromGrid();
			GameObject *Target = Commands->Find_Object(EnemyID);
			if (!Commands->Get_Health(Target))
			{
				RemoveGridTarget(EnemyID);
			}
			else if (EnemyID && Target)
			{
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Target));
				Checking = 1;
				AGTargetID = EnemyID;
			}
		}
	}
	GameObject *NewTarget = Commands->Find_Object(AGTargetID);
	if (Commands->Is_A_Star(NewTarget))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(NewTarget)])
		{
			RemoveGridTarget(AGTargetID);
		}
	}
}

bool JMG_RP2_Simple_Smart_AA_Base_Defense::Get_Vehicle_Is_Visible(GameObject *obj)
{
	if (obj)
	{
		GameObject *TVehicle = Get_Vehicle(obj);
		if (!TVehicle)
		{
			TVehicle = obj;
		}
		if (!_stricmp(Commands->Get_Preset_Name(TVehicle),"SCUD_Targeting_Setup"))
		{
			if (SCUD_Missile_Launcher_Node)
			{
				int end = 0;
				SCUD_Missile_Launcher_Control *Current = SCUD_Missile_Launcher_Node;
				while (Current != NULL && end == 0)
				{
					if (Commands->Get_ID(TVehicle) == Current->TargetingSystemID)
					{
						GiveToGrid(Commands->Find_Object(Current->LauncherID));
						return false;
					}
					Current = Current->next;
				}
			}
			return false;
		}
		if (TVehicle->As_VehicleGameObj())
		{
			bool Visible;
			bool *b = (bool *)TVehicle;
			b += 0x994;
			Visible = *b;
			return Visible;
		}
	}
	return true;
}

void JMG_RP2_Simple_Smart_AG_Base_Defense::Created(GameObject *obj)
{
	float MyZPos = Commands->Get_Position(obj).Z;
	MaxZ = MyZPos + Get_Int_Parameter("Max_Z_Distance");
	MinZ = MyZPos + Get_Int_Parameter("Min_Z_Distance");
	EnemyID = 0;
	TargetVisible = 0;
	Checking = 2;
	AGTargetID = 0;
	KillTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	if (Get_Int_Parameter("On_Grid") < 128 && Get_Int_Parameter("On_Grid") >= 0)
	{
		MyGrid = Get_Int_Parameter("On_Grid");
	}
	else
	{
		MyGrid = -1;
	}
	Commands->Start_Timer(obj,this,1.0,92562142);
	Commands->Start_Timer(obj,this,0.1f,92562143);
	Commands->Enable_Enemy_Seen(obj,true);
	Attach_Script_Once(obj,"JMG_RP2_Object_Send_Text_Message_On_Death","");
}

void JMG_RP2_Simple_Smart_AG_Base_Defense::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (!(MinZ < Commands->Get_Position(seen).Z && MaxZ > Commands->Get_Position(seen).Z) || !_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
	{
		return;
	}
	if (Commands->Is_A_Star(seen))
	{
			if (ISSELECTINGSPAWN[Get_Player_ID(seen)])
			{
				return;
			}
	}
	if (!(seen->As_PhysicalGameObj() && seen->As_PhysicalGameObj()->Peek_Physical_Object() && seen->As_PhysicalGameObj()->Peek_Physical_Object()->As_ProjectileClass()))
	{
		float Distance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
		if (Distance <= Get_Float_Parameter("Max_Range") && Distance > Get_Float_Parameter("Min_Range"))
		{
			if (Checking == NOTHING)
			{	
				TargetDistance = Distance;
				EnemyID = Commands->Get_ID(seen);
				Commands->Enable_Enemy_Seen(obj,false);
				Checking = SEARCHCOMPLETE;
			}
			if (Checking == SEARCHING)//See if still visible
			{
				if ((EnemyID == Commands->Get_ID(seen) && TargetVisible == 0) || (EnemyID == Commands->Get_ID(seen) && TargetVisible == 1 && Distance <= TargetDistance))
				{
					TargetVisible = true;// TARGET FOUND
					TargetDistance = Distance;
				}
				else if (EnemyID != Commands->Get_ID(seen) && Distance + 1.0f < TargetDistance)// Closer Target Found, use this one
				{
					EnemyID = Commands->Get_ID(seen);
					TargetVisible = true;// TARGET FOUND!
					TargetDistance = Distance;
				}
			}
		}
	}
}

void JMG_RP2_Simple_Smart_AG_Base_Defense::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damager && damage && damager != obj && Get_Vehicle_Is_Visible(damager) && _stricmp(Get_Skin(damager),"Blamo") && _stricmp(Get_Shield_Type(damager),"Blamo"))
	{
		if (!EnemyID && MyGrid != -1)
		{
			GiveToGrid(damager);
			AGTargetID = Commands->Get_ID(damager);
			SameTarget = 0;
			SelectNetworkTarget(obj);
			Checking = 1;
			TargetVisible = false;
			TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(AGTargetID)));
			Commands->Enable_Enemy_Seen(obj,true);
		}
	}
}

void JMG_RP2_Simple_Smart_AG_Base_Defense::Timer_Expired(GameObject *obj,int number)
{
	if (92562143 == number)
	{
		if (EnemyID)
		{
			GameObject *Enemy = Commands->Find_Object(EnemyID);
			if (MinZ < Commands->Get_Position(Enemy).Z && MaxZ > Commands->Get_Position(Enemy).Z)
			{
				if (Enemy && KillTargetID != EnemyID)
				{
					AttackHoldFunction(obj,Enemy);
					KillTargetID = EnemyID;
				}
				if (!Enemy)
				{
					EnemyID = 0;
					KillTargetID = 0;
				}
			}
			else
			{
				StopShootingAndReload(obj);
			}
		}
		else if (AGTargetID)
		{
			AGAttackTime++;
			if (AGAttackTime > 15)
			{
				AGAttackTime = 0;
				RemoveGridTarget(AGTargetID);
				StopShootingAndReload(obj);
			}
		}
		else
		{
			AGAttackTime = 0;
			RemoveGridTarget(AGTargetID);
			StopShootingAndReload(obj);
		}
		Commands->Start_Timer(obj,this,0.25,92562143);
	}
	if (number == 92562142)
	{
		VisibilityCheck(obj);
		Commands->Start_Timer(obj,this,1.25,92562142);
	}
}

void JMG_RP2_Simple_Smart_AG_Base_Defense::StopShootingAndReload(GameObject *obj)
{
	EnemyID = 0;
	AGTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	Checking = 2;
	KillTargetID = 0;
	Commands->Enable_Enemy_Seen(obj,true);
	Commands->Action_Reset(obj,100);
}

void JMG_RP2_Simple_Smart_AG_Base_Defense::AttackHoldFunction(GameObject *obj,GameObject *Enemy)
{
	ActionParamsStruct params;
	params.Set_Basic(this,0,100);
	params.Set_Attack(Enemy,Get_Float_Parameter("Max_Range"),0,1);
	params.AttackCheckBlocked = false;
	Commands->Action_Attack(obj,params);
}

void JMG_RP2_Simple_Smart_AG_Base_Defense::VisibilityCheck(GameObject *obj)
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (EnemyID == 0) // Always set to true if no enemy is targeted
	{
		Checking = NOTHING;
		Commands->Enable_Enemy_Seen(obj,true);
		SelectNetworkTarget(obj);
	}
	if (Checking == SEARCHCOMPLETE)// If not checking for an enemy start
	{
		Checking = SEARCHING;
		TargetVisible = false;
		TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(EnemyID)));
		Commands->Enable_Enemy_Seen(obj,true);
	}
	else if (Checking == SEARCHING && TargetVisible == 0)// If just completed the check, but no enemy found, clear target
	{
		EnemyID = 0;
		if (!AGTargetID)
		{
			StopShootingAndReload(obj);
		}
		else
		{
			AGAttackTime++;
			if (AGAttackTime > 15)
			{
				RemoveGridTarget(AGTargetID);
				StopShootingAndReload(obj);
			}
		}
		SelectNetworkTarget(obj);
	}
	else if (Checking == SEARCHING && TargetVisible == 1)// Enemy was found, keep the target
	{
		Commands->Enable_Enemy_Seen(obj,false);
		Checking = SEARCHCOMPLETE;
	}
}

void JMG_RP2_Simple_Smart_AG_Base_Defense::GiveToGrid(GameObject *Enemy)
{
	int end = 0;
	int AddID = Commands->Get_ID(Enemy);
	for (int x = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSBDGrid[MyGrid][x] == AddID)
		{
			end = 1;
			JRP2SSBDGrid[MyGrid][x] = AddID;
			JRP2SSBDGridTC[MyGrid]++;
		}
		else if (JRP2SSBDGrid[MyGrid][x] == 0)
		{
			end = 1;
			JRP2SSBDGrid[MyGrid][x] = AddID;
			JRP2SSBDGridTC[MyGrid]++;
		}
	}
	if (end == 0)
	{
		for (int x = 0;x < 25 && end == 0;x++)
		{
			if (x < 24)
			{
				JRP2SSBDGrid[MyGrid][x] = JRP2SSBDGrid[MyGrid][(x+1)];
			}
			else
			{
				JRP2SSBDGrid[MyGrid][x] = AddID;
			}
		}
	}
}

int JMG_RP2_Simple_Smart_AG_Base_Defense::GrabIDFromGrid()
{
	if (JRP2SSBDGridTC[MyGrid])
	{
		for (int x = 0,end = 0;x < 25 && end == 0;x++)
		{
			if (JRP2SSBDGrid[MyGrid][x] != 0)
			{
				end = 1;
				return JRP2SSBDGrid[MyGrid][x];
			}
		}
	}
	return 0;
}

void JMG_RP2_Simple_Smart_AG_Base_Defense::RemoveGridTarget(int ID)
{
	for (int x = 0,end = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSBDGrid[MyGrid][x] == ID)
		{
			for (int y = x;y < 25;y++)
			{
				if (y < 24)
				{
					JRP2SSBDGrid[MyGrid][y] = JRP2SSBDGrid[MyGrid][(y+1)];
				}
				else
				{
					JRP2SSBDGrid[MyGrid][y] = 0;
				}
			}
			JRP2SSBDGridTC[MyGrid]--;
			end = 1;
		}
	}
}

void JMG_RP2_Simple_Smart_AG_Base_Defense::SelectNetworkTarget(GameObject *obj) 
{
	if (AGTargetID && EnemyID && AGTargetID != EnemyID)
	{
		GameObject *Target = Commands->Find_Object(AGTargetID);
		GameObject *Target2 = Commands->Find_Object(EnemyID);
		float ObjectDistance = Commands->Get_Distance(Commands->Get_Position(Target),Commands->Get_Position(obj));
		float EnemyDistance = Commands->Get_Distance(Commands->Get_Position(Target2),Commands->Get_Position(obj));
		if (ObjectDistance < EnemyDistance)
		{
			EnemyID = AGTargetID;
		}
		else
		{
			AGTargetID = EnemyID;
		}
	}
	if (AGTargetID && !EnemyID)
	{
		SameTarget++;
		EnemyID = AGTargetID;
		GameObject *Target = Commands->Find_Object(AGTargetID);
		if (!Target || !Commands->Get_Health(Target))
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
			EnemyID = 0;
			Checking = 2;
			Commands->Enable_Enemy_Seen(obj,true);
		}
		if (SameTarget >= 40)
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
		}
	}
	else if (!EnemyID && MyGrid != -1)
	{
		if (JRP2SSBDGridTC[MyGrid])
		{
			SameTarget = 0;
			EnemyID = GrabIDFromGrid();
			GameObject *Target = Commands->Find_Object(EnemyID);
			if (!Commands->Get_Health(Target))
			{
				RemoveGridTarget(EnemyID);
			}
			else if (EnemyID && Target)
			{
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Target));
				Checking = 1;
				AGTargetID = EnemyID;
			}
		}
	}
	GameObject *NewTarget = Commands->Find_Object(AGTargetID);
	if (Commands->Is_A_Star(NewTarget))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(NewTarget)])
		{
			RemoveGridTarget(AGTargetID);
		}
	}
}

bool JMG_RP2_Simple_Smart_AG_Base_Defense::Get_Vehicle_Is_Visible(GameObject *obj)
{
	if (obj)
	{
		GameObject *TVehicle = Get_Vehicle(obj);
		if (!TVehicle)
		{
			TVehicle = obj;
		}
		if (!_stricmp(Commands->Get_Preset_Name(TVehicle),"SCUD_Targeting_Setup"))
		{
			if (SCUD_Missile_Launcher_Node)
			{
				int end = 0;
				SCUD_Missile_Launcher_Control *Current = SCUD_Missile_Launcher_Node;
				while (Current != NULL && end == 0)
				{
					if (Commands->Get_ID(TVehicle) == Current->TargetingSystemID)
					{
						GiveToGrid(Commands->Find_Object(Current->LauncherID));
						return false;
					}
					Current = Current->next;
				}
			}
			return false;
		}
		if (TVehicle->As_VehicleGameObj())
		{
			bool Visible;
			bool *b = (bool *)TVehicle;
			b += 0x994;
			Visible = *b;
			return Visible;
		}
	}
	return true;
}

void JMG_Grant_Powerup_To_Beacon_Planter::Created(GameObject *obj)
{
	if (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->As_BeaconGameObj())
	{
		GameObject *Planter = Get_Beacon_Planter(obj);
		if (Planter)
		{
			Commands->Give_PowerUp(Planter,Get_Parameter("Powerup_Preset"),true);
		}
	}
	else
	{
		int BeaconID = Find_Nearest_Beacon_ID(obj);
		if (BeaconID)
		{
			GameObject *Planter = Get_Beacon_Planter(Commands->Find_Object(BeaconID));
			if (Planter)
			{
				Commands->Give_PowerUp(Planter,Get_Parameter("Powerup_Preset"),true);
			}
		}
	}
}

int JMG_Grant_Powerup_To_Beacon_Planter::Find_Nearest_Beacon_ID(GameObject *obj)
{
	if (!obj)
	{
		return 0;
	}
	Vector3 BeaconPosition = Commands->Get_Position(obj);
	float NearDist = 9999.0f;
	GameObject *TargetBeacon = NULL;
	SLNode<BeaconGameObj> *Current = GameObjManager::BeaconGameObjList.Head();
	while (Current)
	{
		GameObject *ObjectNode = Current->Data();
		if (ObjectNode)
		{
			Vector3 Pos = Commands->Get_Position(ObjectNode);
			float Distance = Commands->Get_Distance(BeaconPosition,Pos);
			if (Distance < NearDist)
			{
				NearDist = Distance;
				TargetBeacon = ObjectNode;
			}
		}
		Current = Current->Next();
	}
	if (TargetBeacon)
	{
		return Commands->Get_ID(TargetBeacon);
	}
	return 0;
}


void JMG_Send_Custom_To_Beacon_Planter::Created(GameObject *obj)
{
	if (obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->As_BeaconGameObj())
	{
		GameObject *Planter = Get_Beacon_Planter(obj);
		if (Planter)
		{
			Commands->Send_Custom_Event(obj,Planter,Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
		}
	}
	else
	{
		int BeaconID = Find_Nearest_Beacon_ID(obj);
		if (BeaconID)
		{
			GameObject *Planter = Get_Beacon_Planter(Commands->Find_Object(BeaconID));
			if (Planter)
			{
				Commands->Send_Custom_Event(obj,Planter,Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
			}
		}
	}
}

int JMG_Send_Custom_To_Beacon_Planter::Find_Nearest_Beacon_ID(GameObject *obj)
{
	if (!obj)
	{
		return 0;
	}
	Vector3 BeaconPosition = Commands->Get_Position(obj);
	float NearDist = 9999.0f;
	GameObject *TargetBeacon = NULL;
	SLNode<BeaconGameObj> *Current = GameObjManager::BeaconGameObjList.Head();
	while (Current)
	{
		GameObject *ObjectNode = Current->Data();
		if (ObjectNode)
		{
			Vector3 Pos = Commands->Get_Position(ObjectNode);
			float Distance = Commands->Get_Distance(BeaconPosition,Pos);
			if (Distance < NearDist)
			{
				NearDist = Distance;
				TargetBeacon = ObjectNode;
			}
		}
		Current = Current->Next();
	}
	if (TargetBeacon)
	{
		return Commands->Get_ID(TargetBeacon);
	}
	return 0;
}

void JMG_RP2_Mission_System_New_Mission_Type::Created(GameObject *obj)
{
	if (!RP2MissionObjectiveTypeNode)
	{
		RP2MissionObjectiveTypeNode = new RP2MissionObjectiveTypeControl;
		RP2MissionObjectiveTypeNode->MissionType = Get_Int_Parameter("Mission_Type");
		RP2MissionObjectiveTypeNode->ObjectiveCount = Get_Int_Parameter("Mission_Objective_Count");
		RP2MissionObjectiveTypeNode->DisplayMissionInfo = Get_Int_Parameter("Display_Mission_Info");
		RP2MissionObjectiveTypeNode->IsAchievement = Get_Int_Parameter("Is_Achievement");
		if (RP2MissionObjectiveTypeNode->IsAchievement)
		{
			TOTALACHIEVEMENTCOUNT = 1;
		}
		sprintf(RP2MissionObjectiveTypeNode->MissionRewardW3D,"%s",Get_Parameter("Mission_Reward_W3D"));
		sprintf(RP2MissionObjectiveTypeNode->MissionStartText,"null");
		sprintf(RP2MissionObjectiveTypeNode->MissionFailedText,"null");
		sprintf(RP2MissionObjectiveTypeNode->MissionSuccessfulText,"null");
		RP2MissionObjectiveTypeNode->CompleteMissionRewardMoney = Get_Int_Parameter("Mission_Reward_Money");
		sprintf(RP2MissionObjectiveTypeNode->CompleteMissionRewardWeapon,"%s",Get_Parameter("Mission_Reward_Weapon"));
		RP2MissionObjectiveTypeNode->CompleteMissionRewardInventory = Get_Int_Parameter("Mission_Reward_Inventory");
		RP2MissionObjectiveTypeNode->CompleteMissionRewardMaxHealth = Get_Int_Parameter("Mission_Reward_Health");
		RP2MissionObjectiveTypeNode->CompleteMissionRewardMaxArmor = Get_Int_Parameter("Mission_Reward_Armor");
		RP2MissionObjectiveTypeNode->MissionRewardCustomMessage = Get_Int_Parameter("Mission_Reward_Custom_Message");
		Vector3 ResetConditions = Get_Vector3_Parameter("Reset_On[Time|Death|Success]");
		RP2MissionObjectiveTypeNode->ResetOnDeath = (int)ResetConditions.Y;
		RP2MissionObjectiveTypeNode->ResetOnSuccess = (int)ResetConditions.Z;
		RP2MissionObjectiveTypeNode->ResetOnTime = (int)ResetConditions.X;
		Vector3 RegrantConditions = Get_Vector3_Parameter("Regrant_Rewards[NewGame|Spawn|FirstSpawn]");
		RP2MissionObjectiveTypeNode->RegrantOnSpawn = (int)RegrantConditions.Y;
		RP2MissionObjectiveTypeNode->RegrantOnNewgame = (int)RegrantConditions.X;
		RP2MissionObjectiveTypeNode->RegrantOnFirstSpawn = (int)RegrantConditions.Z;
		Vector3 ResetConditions2 = Get_Vector3_Parameter("Reset_On[ObjectiveOrder|Respawn|NULL]");
		RP2MissionObjectiveTypeNode->ObjectivesInOrder = (int)ResetConditions2.X;
		RP2MissionObjectiveTypeNode->ResetOnSpawn = (int)ResetConditions2.Y;
		Vector3 SpecialSettings = Get_Vector3_Parameter("Misc_Settings[MaxPlayers|StartObjective|PhoneChoice]");
		RP2MissionObjectiveTypeNode->OneAtATime = (int)SpecialSettings.X;
		RP2MissionObjectiveTypeNode->StartObjective = (int)SpecialSettings.Y;
		RP2MissionObjectiveTypeNode->RandomChoice = (int)SpecialSettings.Z;
		if (RP2MissionObjectiveTypeNode->RandomChoice)
		{
			Add_Phone_Node(RP2MissionObjectiveTypeNode->MissionType);
		}
		Vector3 MissionConditions = Get_Vector3_Parameter("CustomMissionEvents[Start|Failed|Successful]");
		RP2MissionObjectiveTypeNode->MissionMessageStart = (int)MissionConditions.X;
		RP2MissionObjectiveTypeNode->MissionMessageFailed = (int)MissionConditions.Y;
		RP2MissionObjectiveTypeNode->MissionMessageSuccess = (int)MissionConditions.Z;
		RP2MissionObjectiveTypeNode->InUse = 0;
		RP2MissionObjectiveTypeNode->AllVehicles = 0;
		RP2MissionObjectiveTypeNode->VehicleFails = 0;
		RP2MissionObjectiveTypeNode->FailOnTrackedVehicle = 0;
		RP2MissionObjectiveTypeNode->FailOnWheeledVehicle = 0;
		RP2MissionObjectiveTypeNode->FailOnMotorcycle = 0;
		RP2MissionObjectiveTypeNode->FailOnAircraft = 0;
		RP2MissionObjectiveTypeNode->FailOnTurret = 0;
		RP2MissionObjectiveTypeNode->FailOnBoat = 0;
		RP2MissionObjectiveTypeNode->VehicleExceptions = NULL;
		RP2MissionObjectiveTypeNode->MissionConflicts = NULL;
		RP2MissionObjectiveTypeNode->next = NULL;
	}
	else
	{
		int end = 0;
		RP2MissionObjectiveTypeControl *Current = RP2MissionObjectiveTypeNode;
		while (Current != NULL && end == 0)
		{
			if (Get_Int_Parameter("Mission_Type") == Current->MissionType)// match
			{
				char ERRORs[2000];
				sprintf(ERRORs,"MESSAGE ERROR: Mission Type %d already exists!",Get_Int_Parameter("Mission_Type"));
				Console_Input(ERRORs);
				end = 1;
			}
			else if (Current->next == NULL)
			{
				Current->next = new RP2MissionObjectiveTypeControl;
				Current = Current->next;
				Current->MissionType = Get_Int_Parameter("Mission_Type");
				Current->ObjectiveCount = Get_Int_Parameter("Mission_Objective_Count");
				Current->DisplayMissionInfo = Get_Int_Parameter("Display_Mission_Info");
				Current->IsAchievement = Get_Int_Parameter("Is_Achievement");
				if (Current->IsAchievement)
				{
					TOTALACHIEVEMENTCOUNT++;
				}
				sprintf(Current->MissionRewardW3D,"%s",Get_Parameter("Mission_Reward_W3D"));
				sprintf(Current->MissionStartText,"null");
				sprintf(Current->MissionFailedText,"null");
				sprintf(Current->MissionSuccessfulText,"null");
				Current->CompleteMissionRewardMoney = Get_Int_Parameter("Mission_Reward_Money");
				sprintf(Current->CompleteMissionRewardWeapon,"%s",Get_Parameter("Mission_Reward_Weapon"));
				Current->CompleteMissionRewardInventory = Get_Int_Parameter("Mission_Reward_Inventory");
				Current->CompleteMissionRewardMaxHealth = Get_Int_Parameter("Mission_Reward_Health");
				Current->CompleteMissionRewardMaxArmor = Get_Int_Parameter("Mission_Reward_Armor");
				Current->MissionRewardCustomMessage = Get_Int_Parameter("Mission_Reward_Custom_Message");
				Vector3 ResetConditions = Get_Vector3_Parameter("Reset_On[Time|Death|Success]");
				Current->ResetOnDeath = (int)ResetConditions.Y;
				Current->ResetOnSuccess = (int)ResetConditions.Z;
				Current->ResetOnTime = (int)ResetConditions.X;
				Vector3 RegrantConditions = Get_Vector3_Parameter("Regrant_Rewards[NewGame|Spawn|FirstSpawn]");
				Current->RegrantOnSpawn = (int)RegrantConditions.Y;
				Current->RegrantOnNewgame = (int)RegrantConditions.X;
				Current->RegrantOnFirstSpawn = (int)RegrantConditions.Z;
				Vector3 ResetConditions2 = Get_Vector3_Parameter("Reset_On[ObjectiveOrder|Respawn|NULL]");
				Current->ObjectivesInOrder = (int)ResetConditions2.X;
				Current->ResetOnSpawn = (int)ResetConditions2.Y;
				Vector3 SpecialSettings = Get_Vector3_Parameter("Misc_Settings[MaxPlayers|StartObjective|PhoneChoice]");
				Current->OneAtATime = (int)SpecialSettings.X;
				Current->StartObjective = (int)SpecialSettings.Y;
				Current->RandomChoice = (int)SpecialSettings.Z;
				if (Current->RandomChoice)
				{
					Add_Phone_Node(Current->MissionType);
				}
				Vector3 MissionConditions = Get_Vector3_Parameter("CustomMissionEvents[Start|Failed|Successful]");
				Current->MissionMessageStart = (int)MissionConditions.X;
				Current->MissionMessageFailed = (int)MissionConditions.Y;
				Current->MissionMessageSuccess = (int)MissionConditions.Z;
				Current->InUse = 0;
				Current->AllVehicles = 0;
				Current->VehicleFails = 0;
				Current->FailOnTrackedVehicle = 0;
				Current->FailOnWheeledVehicle = 0;
				Current->FailOnMotorcycle = 0;
				Current->FailOnAircraft = 0;
				Current->FailOnTurret = 0;
				Current->FailOnBoat = 0;
				Current->VehicleExceptions = NULL;
				Current->MissionConflicts = NULL;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Mission_System_New_Mission_Type::Add_Phone_Node(int MissionType)
{
	if (!RP2PhoneMissionNode)
	{
		RP2PhoneMissionNode = new RP2PhoneMissionControl;
		RP2PhoneMissionNode->MissionType = MissionType;
		RP2PhoneMissionNode->PhoneMissionNumber = 1;
		PHONEMAXRANDCHOICE = RP2PhoneMissionNode->PhoneMissionNumber;
		RP2PhoneMissionNode->next = NULL;
	}
	else
	{
		int end = 0;
		RP2PhoneMissionControl *Current = RP2PhoneMissionNode;
		while (Current != NULL && end == 0)
		{
			int Number = Current->PhoneMissionNumber;
			if (MissionType == Current->MissionType)// match
			{
				char ERRORs[2000];
				sprintf(ERRORs,"MESSAGE ERROR: Mission Type %d already exists!",Get_Int_Parameter("Mission_Type"));
				Console_Input(ERRORs);
				end = 1;
			}
			else if (Current->next == NULL)
			{
				Current->next = new RP2PhoneMissionControl;
				Current = Current->next;
				Current->MissionType = MissionType;
				Current->PhoneMissionNumber = (Number + 1);
				PHONEMAXRANDCHOICE = Current->PhoneMissionNumber;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Mission_System_Global_Mission_Controller::Created(GameObject *obj)
{
	MissionControlNode = NULL;
	MyMissionNode = NULL;
	MyMissions = NULL;
	Commands->Start_Timer(obj,this,60.0f,92562143);
}

void JMG_RP2_Mission_System_Global_Mission_Controller::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (Commands->Is_A_Star(sender) && param != -69)
	{
		MissionControlNode = NULL;
		MyMissionNode = NULL;
		MyMissions = NULL;
		if (Find_Mission_Type(message))
		{
			if (((MissionControlNode->OneAtATime && MissionControlNode->InUse < MissionControlNode->OneAtATime) || !MissionControlNode->OneAtATime) || param < -1)
			{
				if (Find_Player_Mission_Node(sender))
				{
					if (Find_Matching_Player_Mission_Type())
					{
						if (param >= -1) // 0 means objective doesn't count | -1 means it doesn't have to be unique
						{
							if (!MyMissions->StartedMission)// Has Mission Started?
							{
								int Conflicts = Check_For_Mission_Conflicts(message);// Check if you can start this mission
								if (Conflicts)
								{
									char Message[2000];
									sprintf(Message,"Sorry, but you cannot start this mission while mission %d is still in progress.",Conflicts);
									Send_Message_Player(sender,75,150,125,Message);
									return;
								}
							}
							int Check = Check_Player_Mission_Objectives(param);
							if (!MyMissions->MissionCompleted)//Has Not completed mission
							{
								if (!MyMissions->StartedMission)// Has Mission Started?
								{
									MissionControlNode->InUse++;
									Copy_Conflicts_To_Player_Conflicts();
									if (MyMissionNode && MissionControlNode && MissionControlNode->VehicleFails)// Add in vehicle fail conditions
									{
										if (MissionControlNode->VehicleFails < 6 && MissionControlNode->VehicleFails > 0)
										{
											MyMissionNode->FailOnTrackedVehicle = Add_In_Special_Mission_Settings(MyMissionNode->FailOnTrackedVehicle,MissionControlNode->FailOnTrackedVehicle);
											MyMissionNode->FailOnWheeledVehicle = Add_In_Special_Mission_Settings(MyMissionNode->FailOnWheeledVehicle,MissionControlNode->FailOnWheeledVehicle);
											MyMissionNode->FailOnMotorcycle = Add_In_Special_Mission_Settings(MyMissionNode->FailOnMotorcycle,MissionControlNode->FailOnMotorcycle);
											MyMissionNode->FailOnAircraft = Add_In_Special_Mission_Settings(MyMissionNode->FailOnAircraft,MissionControlNode->FailOnAircraft);
											MyMissionNode->FailOnTurret = Add_In_Special_Mission_Settings(MyMissionNode->FailOnTurret,MissionControlNode->FailOnTurret);
											MyMissionNode->FailOnBoat = Add_In_Special_Mission_Settings(MyMissionNode->FailOnBoat,MissionControlNode->FailOnBoat);
										}
										else
										{
											MyMissionNode->AllVehicles = Add_In_Special_Mission_Settings(MyMissionNode->AllVehicles,MissionControlNode->AllVehicles);
										}
									}
									if (MissionControlNode->StartObjective > -1 && param != MissionControlNode->StartObjective)// don't start
									{
										MissionControlNode->InUse--;
										MyMissions = Restart_Target_Mission(MyMissions);
										return;// end if not the start objective
									}
									MyMissions->StartedMission = 1;
									if (MissionControlNode->MissionMessageStart)// Send start custom
									{
										Commands->Send_Custom_Event(sender,Find_Object_By_Preset(2,RP2MISSIONMESSAGERECCIVER),MissionControlNode->MissionMessageStart,MissionControlNode->InUse,0);
									}
									char Message[2000];
									if (_stricmp(MissionControlNode->MissionStartText,"null"))
									{
										sprintf(Message,"Mission %d: %s.",MissionControlNode->MissionType,MissionControlNode->MissionStartText);
										Send_Message_Player(sender,75,150,125,Message);
									}
									if (Check == 1 && param != 0)// Update the mission Settings
									{
										MissionUpdate(obj,sender,1);
									}
									if (MyMissions->ResetOnTime && MissionControlNode->DisplayMissionInfo)
									{
										sprintf(Message,"Warning mission %d is timed!.",MissionControlNode->MissionType);
										Send_Message_Player(sender,75,150,125,Message);
									}
								}
								else if (Check == 1)// Update the mission the standard way
								{
									MissionUpdate(obj,sender,1);
								}
								else if (Check != 2 && MissionControlNode->DisplayMissionInfo && !MyMissions->MissionCompleted)
								{
									if (param)
									{
										char Message[2000];
										sprintf(Message,"I have already completed this part of mission %d once before.",MissionControlNode->MissionType);
										Send_Message_Player(sender,75,150,125,Message);
									}
								}
							}
							else if (MyMissions->ResetOnSuccess)
							{
								MissionControlNode->InUse--;
								MyMissions = Restart_Target_Mission(MyMissions);
								if (MissionControlNode->ObjectiveCount > 1)
								{
									Commands->Send_Custom_Event(sender,obj,message,param,0);
								}
							}
						}
						else if (param == -999)
						{
							if (!MyMissions->HasGranted && MyMissions->RegrantOnFirstSpawn)
							{
								if (MyMissions->RegrantOnFirstSpawn == 2)
								{
									MissionUpdate(obj,sender,0);
								}
								else
								{
									int PlayerID = Get_Player_ID(sender);
									RewardWeapon(sender);
									RP2StarMaxInventorySize[PlayerID] += MissionControlNode->CompleteMissionRewardInventory;
									Set_Max_Health(sender,(Commands->Get_Max_Health(sender) + MissionControlNode->CompleteMissionRewardMaxHealth));
									Set_Max_Shield_Strength(sender,(Commands->Get_Max_Shield_Strength(sender) + MissionControlNode->CompleteMissionRewardMaxArmor));
									if (MissionControlNode->IsAchievement)
									{
										COMPLETEDACHIEVEMENTS[PlayerID]++;
									}
								}
							}
							else
							{
								if (MyMissions->RegrantOnSpawn == 2)
								{
									MissionUpdate(obj,sender,0);
								}
								else
								{
									int PlayerID = Get_Player_ID(sender);
									RewardWeapon(sender);
									RP2StarMaxInventorySize[PlayerID] += MissionControlNode->CompleteMissionRewardInventory;
									Set_Max_Health(sender,(Commands->Get_Max_Health(sender) + MissionControlNode->CompleteMissionRewardMaxHealth));
									Set_Max_Shield_Strength(sender,(Commands->Get_Max_Shield_Strength(sender) + MissionControlNode->CompleteMissionRewardMaxArmor));
								}
							}
							MyMissions->HasGranted = 1;
						}
						else if (param == -2)// Restart mission with fail text
						{
							if (_stricmp(MissionControlNode->MissionFailedText,"null"))
							{
								Send_Message_Player(sender,75,150,125,MissionControlNode->MissionFailedText);
							}
							MyMissions = Mission_Failed(sender,MyMissions);
						}
						else if (param == -3)// reset mission with no fail text
						{
							MyMissions = Mission_Failed(sender,MyMissions);
						}
						else if (param == -4 && Check_If_Vehicle_Is_Excluded(sender))// vehicle fail mission
						{
							char Message[2000];
							sprintf(Message,"I have failed mission %d because I entered a vehicle which was off limits for the mission.",MissionControlNode->MissionType);
							Send_Message_Player(sender,75,150,125,Message);
							MyMissions = Mission_Failed(sender,MyMissions);
						}
						else if (param == -9115 && (!MyMissions->MissionCompleted || (MyMissions->MissionCompleted  && MissionControlNode->ResetOnSuccess)))
						{
							Send_Message_Player(sender,75,150,125,"You can only do one random phone acquired mission at a time, thus, your old mission has been reset.");
							MyMissions = Mission_Failed(sender,MyMissions);
						}
					}
				}
				else
				{
					char ERRORs[2000];
					const char *str = Get_Player_Name(sender);
					sprintf(ERRORs,"MESSAGE ERROR: %s <- This player's mission node does not exist!",str);
					delete[] str;
					Console_Input(ERRORs);
				}
			}
		}
		else
		{
			char ERRORs[2000];
			sprintf(ERRORs,"MESSAGE ERROR: Mission Type %d does not exist!",message);
			Console_Input(ERRORs);
		}
	}
}

void JMG_RP2_Mission_System_Global_Mission_Controller::Timer_Expired(GameObject *obj,int number)
{
	if (92562143 == number)
	{
		if (RP2PlayerMissionsNode)
		{
			RP2PlayerMissionsControl *Current = RP2PlayerMissionsNode;
			while (Current != NULL)// Go through players list
			{
				MissionTypes *Current2 = Current->Mission;
				while (Current2 != NULL)
				{
					if (Current2->ResetOnTime && !Current2->MissionCompleted && Current2->StartedMission)
					{
						if (Current2->ResetOnTime == 1)// Mission Failed > 0
						{
							Current2->ResetOnTime = 0;
							GameObject *Player = Get_GameObj_By_Player_Name(Current->PlayerName);
							if (MissionControlNode->DisplayMissionInfo)
							{
								char Message[2000];
								sprintf(Message,"I have failed to compete Mission %d in the required time!",Current2->MissionType);
								Send_Message_Player(Player,75,150,125,Message);
							}
							MissionTypes *DeleteMe = Current2;
							Current2 = Current2->next;
							Current->Mission = Mission_Failed(Player,DeleteMe);
						}
						else
						{
							Current2->ResetOnTime--;
							if (MissionControlNode->DisplayMissionInfo)
							{
								if (Current2->ResetOnTime == 1)
								{
									char Message[2000];
									sprintf(Message,"You only have %d minute remaining to complete mission %d!",Current2->ResetOnTime,Current2->MissionType);
									Send_Message_Player(Get_GameObj_By_Player_Name(Current->PlayerName),75,150,125,Message);
								}
								else if ((Current2->ResetOnTime % 10 == 0 || Current2->ResetOnTime <= 5) && Current2->ResetOnTime)
								{
									char Message[2000];
									sprintf(Message,"You only have %d minutes remaining to complete mission %d!",Current2->ResetOnTime,Current2->MissionType);
									Send_Message_Player(Get_GameObj_By_Player_Name(Current->PlayerName),75,150,125,Message);
								}
								else if (Current2->ResetOnTime && Current2->ResetOnTime == MissionControlNode->ResetOnTime - 1)
								{
									char Message[2000];
									sprintf(Message,"Mission %d will end in %d minutes!",Current2->MissionType,Current2->ResetOnTime);
									Send_Message_Player(Get_GameObj_By_Player_Name(Current->PlayerName),75,150,125,Message);
								}
							}
						}
					}
					if (Current2)// Make sure the node isn't null
					{
						Current2 = Current2->next;
					}
				}
				Current = Current->next;
			}
		}
		Commands->Start_Timer(obj,this,60.0f,92562143);
	}
}

int JMG_RP2_Mission_System_Global_Mission_Controller::Find_Mission_Type(int Message)
{
	if (RP2MissionObjectiveTypeNode)
	{
		int end = 0;
		RP2MissionObjectiveTypeControl *Current = RP2MissionObjectiveTypeNode;
		while (Current != NULL && end == 0)
		{
			if (Current->MissionType == Message)
			{
				end = 1;
				MissionControlNode = Current;
				return 1;
			}
			Current = Current->next;
		}
	}
	return 0;
}

int JMG_RP2_Mission_System_Global_Mission_Controller::Find_Player_Mission_Node(GameObject *obj)
{
	char PlayerName[256];
	const char *str = Get_Player_Name(obj);
	sprintf(PlayerName,"%s",str);
	delete[] str;
	if (RP2PlayerMissionsNode)
	{
		int end = 0;
		RP2PlayerMissionsControl *Current = RP2PlayerMissionsNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				MyMissionNode = Current;
				end = 1;
				return 1;
			}
			Current = Current->next;
		}
	}
	return 0;
}

int JMG_RP2_Mission_System_Global_Mission_Controller::Find_Matching_Player_Mission_Type()
{
	if (MyMissionNode && MissionControlNode) // No Missions have ever been created for this player, create a new one
	{
		if (!MyMissionNode->Mission) 
		{
			MyMissionNode->Mission = new MissionTypes;
			MyMissions = MyMissionNode->Mission;
			MyMissionNode->Mission->MissionType = MissionControlNode->MissionType;
			MyMissionNode->Mission->MissionCompleted = 0;
			MyMissionNode->Mission->CompletedMissionObjectives = 0;
			MyMissionNode->Mission->StartedMission = 0;
			MyMissionNode->Mission->MissionDataPoints = NULL;
			MyMissionNode->Mission->ResetOnDeath = MissionControlNode->ResetOnDeath;
			MyMissionNode->Mission->ResetOnSuccess = MissionControlNode->ResetOnSuccess;
			MyMissionNode->Mission->ResetOnTime = MissionControlNode->ResetOnTime;
			MyMissionNode->Mission->ResetOnSpawn = MissionControlNode->ResetOnSpawn;
			MyMissionNode->Mission->RegrantOnNewgame = MissionControlNode->RegrantOnNewgame;
			MyMissionNode->Mission->RegrantOnSpawn = MissionControlNode->RegrantOnSpawn;
			MyMissionNode->Mission->RegrantOnFirstSpawn = MissionControlNode->RegrantOnFirstSpawn;
			MyMissionNode->Mission->ObjectivesInOrder = MissionControlNode->ObjectivesInOrder;
			MyMissionNode->Mission->HasGranted;
			MyMissionNode->Mission->next = NULL;
			return 1;
		}
		else if (MyMissionNode->Mission)
		{
			int end = 0;
			MissionTypes *Current = MyMissionNode->Mission;// Players list of mission nodes
			while (Current != NULL && end == 0)
			{
				if (Current->MissionType == MissionControlNode->MissionType)// found old mission match on this player
				{
					end = 1;
					MyMissions = Current;
					return 1;
				}
				else if (Current->next == NULL)// Reached end of list and no match found, add a new mission type to the players list
				{
					end = 1;
					Current->next = new MissionTypes;
					Current = Current->next;
					Current->MissionType = MissionControlNode->MissionType;
					Current->MissionCompleted = 0;
					Current->CompletedMissionObjectives = 0;
					Current->StartedMission = 0;
					Current->MissionDataPoints = NULL;
					Current->ResetOnDeath = MissionControlNode->ResetOnDeath;
					Current->ResetOnSuccess = MissionControlNode->ResetOnSuccess;
					Current->ResetOnTime = MissionControlNode->ResetOnTime;
					Current->ResetOnSpawn = MissionControlNode->ResetOnSpawn;
					Current->RegrantOnNewgame = MissionControlNode->RegrantOnNewgame;
					Current->RegrantOnSpawn = MissionControlNode->RegrantOnSpawn;
					Current->RegrantOnFirstSpawn = MissionControlNode->RegrantOnFirstSpawn;
					Current->ObjectivesInOrder = MissionControlNode->ObjectivesInOrder;
					Current->HasGranted = 0;
					MyMissions = Current;
					Current->next = NULL;	
					return 1;
				}
				Current = Current->next;
			}
		}
	}
	return 0;
}

int JMG_RP2_Mission_System_Global_Mission_Controller::Check_Player_Mission_Objectives(int Objective)
{
	if (MyMissions->MissionDataPoints && Objective == -1)
	{
		MyMissions->CompletedMissionObjectives++;
		return 1;
	}
	else if (!MyMissions->MissionDataPoints)
	{
		MyMissions->MissionDataPoints = new MissionObjectives;
		MyMissions->MissionDataPoints->ObjectiveType = Objective;
		MyMissions->MissionDataPoints->next = NULL;
		if (Objective != 0)
		{
			MyMissions->CompletedMissionObjectives++;
		}
		return 1;
	}
	else
	{
		int end = 0;
		MissionObjectives *Current = MyMissions->MissionDataPoints;
		while (Current != NULL && end == 0)
		{
			int LastObjective = Current->ObjectiveType;
			if (Current->ObjectiveType == Objective)// Old Objective found MATCH!
			{
				end = 1;
				if (MyMissions->ObjectivesInOrder == 1 && !MyMissions->MissionCompleted)// Failed, matching objective found
				{
					GameObject *Player = Get_GameObj_By_Player_Name(MyMissionNode->PlayerName);
					if (_stricmp(MissionControlNode->MissionFailedText,"null"))
					{
						Send_Message_Player(Player,75,150,125,MissionControlNode->MissionFailedText);
					}
					Mission_Failed(Player,MyMissions);
					return 2;
				}
				return 0;
			}
			else if (Current->next == NULL)// Add a new objective
			{
				end = 1;
				if (MyMissions->ObjectivesInOrder == 1)
				{
					if (Objective != (LastObjective + 1))// If order is required, check
					{
						GameObject *Player = Get_GameObj_By_Player_Name(MyMissionNode->PlayerName);
						if (_stricmp(MissionControlNode->MissionFailedText,"null"))
						{
							Send_Message_Player(Player,75,150,125,MissionControlNode->MissionFailedText);
						}
						Mission_Failed(Player,MyMissions);
						return 2;
					}
					else
					{
						Current->next = new MissionObjectives;
						Current = Current->next;
						Current->ObjectiveType = Objective;
						Current->next = NULL;
						if (Objective != 0)
						{
							MyMissions->CompletedMissionObjectives++;
						}
						return 1;
					}
				}
				else if (MyMissions->ObjectivesInOrder == -1)
				{
					if (Objective != (LastObjective + 1))// If order is required, check
					{
						return 0;
					}
					else
					{
						Current->next = new MissionObjectives;
						Current = Current->next;
						Current->ObjectiveType = Objective;
						Current->next = NULL;
						if (Objective != 0)
						{
							MyMissions->CompletedMissionObjectives++;
						}
						return 1;
					}
				}
				else
				{
					Current->next = new MissionObjectives;
					Current = Current->next;
					Current->ObjectiveType = Objective;
					Current->next = NULL;
					if (Objective != 0)
					{
						MyMissions->CompletedMissionObjectives++;
					}
					return 1;
				}
			}
			Current = Current->next;
		}
	}
	return 0;
}

void JMG_RP2_Mission_System_Global_Mission_Controller::MissionUpdate(GameObject *obj,GameObject *sender,int AchivementUpdate)
{
	if (MissionControlNode->ObjectiveCount != MyMissions->CompletedMissionObjectives)// Display how many objectives remain
	{
		if (MissionControlNode->DisplayMissionInfo)
		{
			char Message[2000];
			sprintf(Message,"Objective complete! You have completed %d of the %d objectives for mission %d!",MyMissions->CompletedMissionObjectives,MissionControlNode->ObjectiveCount,MissionControlNode->MissionType);
			Send_Message_Player(sender,75,150,125,Message);
		}
	}
	else // Rewards
	{
		char Message[2000];
		int PlayerID = Get_Player_ID(sender);
		if (_stricmp(MissionControlNode->MissionSuccessfulText,"null"))
		{
			sprintf(Message,"%s",MissionControlNode->MissionSuccessfulText);
			Send_Message_Player(sender,75,150,125,Message);
		}
		if (MissionControlNode->IsAchievement && AchivementUpdate)
		{
			COMPLETEDACHIEVEMENTS[PlayerID]++;
			sprintf(Message,"You have completed %d of %d Achivements!",COMPLETEDACHIEVEMENTS[PlayerID],TOTALACHIEVEMENTCOUNT);
			Send_Message_Player(sender,75,150,125,Message);
		}
		MyMissions->MissionCompleted = 1;
		if (MissionControlNode->CompleteMissionRewardInventory)
		{
			sprintf(Message,"Max inventory increased by %d.",MissionControlNode->CompleteMissionRewardInventory);
			Send_Message_Player(sender,75,150,125,Message);
			RP2StarMaxInventorySize[PlayerID] += MissionControlNode->CompleteMissionRewardInventory;
		}
		if (MissionControlNode->CompleteMissionRewardMaxHealth)
		{
			sprintf(Message,"Max health increased by %d.",MissionControlNode->CompleteMissionRewardMaxHealth);
			Send_Message_Player(sender,75,150,125,Message);
			Set_Max_Health(sender,(Commands->Get_Max_Health(sender) + MissionControlNode->CompleteMissionRewardMaxHealth));
		}
		if (MissionControlNode->CompleteMissionRewardMaxArmor)
		{
			sprintf(Message,"Max armor increased by %d.",MissionControlNode->CompleteMissionRewardMaxArmor);
			Send_Message_Player(sender,75,150,125,Message);
			Set_Max_Shield_Strength(sender,(Commands->Get_Max_Shield_Strength(sender) + MissionControlNode->CompleteMissionRewardMaxArmor));
		}
		if (MissionControlNode->CompleteMissionRewardMoney)
		{
			sprintf(Message,"Rewarded %d credits.",MissionControlNode->CompleteMissionRewardMoney);
			Send_Message_Player(sender,75,150,125,Message);
			Commands->Give_Money(sender,(float)MissionControlNode->CompleteMissionRewardMoney,true);
		}
		if (_stricmp(MissionControlNode->CompleteMissionRewardWeapon,"null"))
		{
			RewardWeapon(sender);
			const char *str = Get_Translated_Weapon(sender,Get_Gun_Position(sender,MissionControlNode->CompleteMissionRewardWeapon));
			sprintf(Message,"Granted a %s.",str);
			delete[] str;
			Send_Message_Player(sender,75,150,125,Message);
		}
		if (MissionControlNode->MissionRewardCustomMessage)
		{
			Commands->Send_Custom_Event(obj,sender,MissionControlNode->MissionRewardCustomMessage,MissionControlNode->MissionType,0);
		}
		if (MissionControlNode->MissionMessageSuccess)
		{
			Commands->Send_Custom_Event(sender,Find_Object_By_Preset(2,RP2MISSIONMESSAGERECCIVER),MissionControlNode->MissionMessageSuccess,MissionControlNode->InUse,0);
		}
	}
}

void JMG_RP2_Mission_System_Global_Mission_Controller::RewardWeapon(GameObject *obj)
{
	int PlayerID = Get_Player_ID(obj);
	RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(MissionControlNode->CompleteMissionRewardWeapon);
	if (TheWeapon)
	{
		if (!ISSELECTINGSPAWN[PlayerID] && ((Has_Weapon(obj,TheWeapon->WeaponName) == 0 && Get_Weapon_Count(obj) < RP2MAXINVENTORYWEAPONLIMIT && (RP2StarCurrentInventorySize[PlayerID] + TheWeapon->WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) || (Has_Weapon(obj,TheWeapon->WeaponName) == 1 && Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName) > Get_Clip_Bullets(obj,TheWeapon->WeaponName))))
		{
			if (!Has_Weapon(obj,TheWeapon->WeaponName))// Buy Weapon First If You Don't Have it
			{
				WLS_Add_Weapon_Weight(obj,TheWeapon,PlayerID);
				SpecialGivePowerup(obj,TheWeapon);
			}
			if (Has_Weapon(obj,TheWeapon->WeaponName))// You must have the weapon before you can get the bullets
			{
				Set_Bullets(obj,TheWeapon->WeaponName,Get_Max_Bullets(obj,TheWeapon->WeaponName));
				Set_Clip_Bullets(obj,TheWeapon->WeaponName,Get_Max_Clip_Bullets(obj,TheWeapon->WeaponName));
			}
			Commands->Create_3D_Sound_At_Bone("Pickup Ammo Sound",obj,"c head");
		}
		else
		{
			RP2_Cannot_Grant_Weapon_Reasons(obj,TheWeapon,1);
		}
	}
}

MissionTypes *JMG_RP2_Mission_System_Global_Mission_Controller::Restart_Target_Mission(MissionTypes *TargetDelete)
{
	if (MyMissionNode)
	{
		Remove_Conflicts_From_Player_List();
		MyMissionNode->AllVehicles = Remove_Vehicle_Fail_From_Player_Listing(MyMissionNode->AllVehicles,MissionControlNode->AllVehicles);
		MyMissionNode->FailOnTrackedVehicle = Remove_Vehicle_Fail_From_Player_Listing(MyMissionNode->FailOnTrackedVehicle,MissionControlNode->FailOnTrackedVehicle);
		MyMissionNode->FailOnWheeledVehicle = Remove_Vehicle_Fail_From_Player_Listing(MyMissionNode->FailOnWheeledVehicle,MissionControlNode->FailOnWheeledVehicle);
		MyMissionNode->FailOnMotorcycle = Remove_Vehicle_Fail_From_Player_Listing(MyMissionNode->FailOnMotorcycle,MissionControlNode->FailOnMotorcycle);
		MyMissionNode->FailOnAircraft = Remove_Vehicle_Fail_From_Player_Listing(MyMissionNode->FailOnAircraft,MissionControlNode->FailOnAircraft);
		MyMissionNode->FailOnTurret = Remove_Vehicle_Fail_From_Player_Listing(MyMissionNode->FailOnTurret,MissionControlNode->FailOnTurret);
		MyMissionNode->FailOnBoat = Remove_Vehicle_Fail_From_Player_Listing(MyMissionNode->FailOnBoat,MissionControlNode->FailOnBoat);

		MissionTypes *Current = MyMissionNode->Mission,*OldCurrent = NULL;
		while (Current != NULL)
		{
			if (Current == TargetDelete)
			{
				// Delete the data points in the mission node!
				if (Current->MissionDataPoints)
				{
					MissionObjectives *temp,*die;
					temp = Current->MissionDataPoints;
					while (temp != NULL)
					{
						die = temp;
						temp = temp->next;
						delete die;
					}
					Current->MissionDataPoints = NULL;
				}
				// Delete the MISSION NODE!
				if (!OldCurrent && !Current->next)// Delete Only Node in list
				{
					delete Current;
					MyMissionNode->Mission = NULL;
					return MyMissionNode->Mission;
				}
				else if (!OldCurrent && Current->next)// Delete the head of the node list
				{
					MyMissionNode->Mission = Current->next;
					delete Current;
					return MyMissionNode->Mission;
				}
				else if (OldCurrent && Current->next)// Delete Middle Of List
				{
					OldCurrent->next = Current->next;
					delete Current;
					return MyMissionNode->Mission;
				}
				else if (OldCurrent && !Current->next)// Delete End Of List
				{
					OldCurrent->next = NULL;
					delete Current;
					return MyMissionNode->Mission;
				}
			}
			OldCurrent = Current;
			Current = Current->next;
		}
	}
	return NULL;
}

MissionTypes *JMG_RP2_Mission_System_Global_Mission_Controller::Mission_Failed(GameObject *obj,MissionTypes *Mission)
{
	MissionControlNode->InUse--;
	if (MissionControlNode->MissionMessageFailed)
	{
		Commands->Send_Custom_Event(obj,Find_Object_By_Preset(2,RP2MISSIONMESSAGERECCIVER),MissionControlNode->MissionMessageFailed,MissionControlNode->InUse,0);
	}
	return Restart_Target_Mission(Mission);
}

RP2PlayerVehicleFailMissionControl *JMG_RP2_Mission_System_Global_Mission_Controller::Add_In_Special_Mission_Settings(RP2PlayerVehicleFailMissionControl *Node,int Enable)
{
	if (MissionControlNode && MyMissionNode && Enable)
	{
		if (!Node)
		{
			Node = new RP2PlayerVehicleFailMissionControl;
			Node->MissionType = MissionControlNode->MissionType;
			Node->next = NULL;
		}
		else
		{
			RP2PlayerVehicleFailMissionControl *Current = Node;
			while (Current != NULL)
			{
				if (Current->MissionType == MissionControlNode->MissionType)
				{
					return Node;
				}
				else if (Current->next == NULL)
				{
					Current->next = new RP2PlayerVehicleFailMissionControl;
					Current = Current->next;
					Current->MissionType = MissionControlNode->MissionType;
					Current->next = NULL;
				}
				Current = Current->next;
			}
		}
	}
	return Node;
}

RP2PlayerVehicleFailMissionControl *JMG_RP2_Mission_System_Global_Mission_Controller::Remove_Vehicle_Fail_From_Player_Listing(RP2PlayerVehicleFailMissionControl *Node,int Enable)
{
StartMSGMCDeleteRVFFPL:
	if (MissionControlNode && MyMissionNode && Enable)
	{
		RP2PlayerVehicleFailMissionControl *Current = Node,*OldCurrent = NULL;
		while (Current != NULL)
		{
			if (Current->MissionType == MissionControlNode->MissionType)
			{
				// Delete the MISSION NODE!
				if (!OldCurrent && !Current->next)// Delete Only Node in list
				{
					delete Current;
					Node = NULL;
					goto StartMSGMCDeleteRVFFPL;
				}
				else if (OldCurrent && !Current->next)// Delete End Of List
				{
					OldCurrent->next = NULL;
					delete Current;
					goto StartMSGMCDeleteRVFFPL;
				}
				else if (!OldCurrent && Current->next)// Delete the head of the node list
				{
					Node = Current->next;
					delete Current;
					goto StartMSGMCDeleteRVFFPL;
				}
				else if (OldCurrent && Current->next)// Delete Middle Of List
				{
					OldCurrent->next = Current->next;
					OldCurrent = Current->next;
					delete Current;
					goto StartMSGMCDeleteRVFFPL;
				}
			}
			else
			{
				OldCurrent = Current;
				Current = Current->next;
			}
		}
	}
	return Node;
}

int JMG_RP2_Mission_System_Global_Mission_Controller::Check_For_Mission_Conflicts(int MissionType)
{
	if (MyMissionNode)
	{
		RP2PlayerMissionConflicts *Current = MyMissionNode->MissionConflicts;
		while (Current != NULL)
		{
			if (Current->ConflictingMission == MissionType)
			{
				return Current->MissionType;
			}
			Current = Current->next;
		}
	}
	return 0;
}

void JMG_RP2_Mission_System_Global_Mission_Controller::Copy_Conflicts_To_Player_Conflicts()
{
	if (MyMissionNode && MissionControlNode)
	{
		if (MissionControlNode->MissionConflicts)
		{
			if (!MyMissionNode->MissionConflicts)
			{
				MyMissionNode->MissionConflicts = new RP2PlayerMissionConflicts;
				MyMissionNode->MissionConflicts->MissionType = MissionControlNode->MissionConflicts->MissionType;
				MyMissionNode->MissionConflicts->ConflictingMission = MissionControlNode->MissionConflicts->ConflictingMission;
				MyMissionNode->MissionConflicts->next = NULL;
				RP2PlayerMissionConflicts *Current = MyMissionNode->MissionConflicts;
				RP2PlayerMissionConflicts *Current2 = MissionControlNode->MissionConflicts;
				while (Current2 != NULL)
				{
					Current->next = new RP2PlayerMissionConflicts;
					Current = Current->next;
					Current->MissionType = Current2->MissionType;
					Current->ConflictingMission = Current2->ConflictingMission;
					Current->next = NULL;
					Current2 = Current2->next;
				}
			}
			else
			{
				RP2PlayerMissionConflicts *Current = MyMissionNode->MissionConflicts;
				while (Current != NULL)
				{
					if (Current->next == NULL)
					{
						RP2PlayerMissionConflicts *Current2 = MissionControlNode->MissionConflicts;
						while (Current2 != NULL)
						{
							Current->next = new RP2PlayerMissionConflicts;
							Current = Current->next;
							Current->MissionType = Current2->MissionType;
							Current->ConflictingMission = Current2->ConflictingMission;
							Current->next = NULL;
							Current2 = Current2->next;
						}
					}
					Current = Current->next;
				}
			}
		}
	}
}

void JMG_RP2_Mission_System_Global_Mission_Controller::Remove_Conflicts_From_Player_List()
{
StartMSGMCDeleteRCFPL:
	if (MyMissionNode && MissionControlNode)
	{
		RP2PlayerMissionConflicts *Current = MyMissionNode->MissionConflicts,*OldCurrent = NULL;
		while (Current != NULL)
		{
			if (Current->MissionType == MissionControlNode->MissionType)
			{
				// Delete the MISSION NODE!
				if (!OldCurrent && !Current->next)// Delete Only Node in list
				{
					delete Current;
					MyMissionNode->MissionConflicts = NULL;
					goto StartMSGMCDeleteRCFPL;
				}
				else if (OldCurrent && !Current->next)// Delete End Of List
				{
					OldCurrent->next = NULL;
					delete Current;
					goto StartMSGMCDeleteRCFPL;
				}
				else if (!OldCurrent && Current->next)// Delete the head of the node list
				{
					MyMissionNode->MissionConflicts = Current->next;
					delete Current;
					Current = MyMissionNode->MissionConflicts;
					goto StartMSGMCDeleteRCFPL;
				}
				else if (OldCurrent && Current->next)// Delete Middle Of List
				{
					OldCurrent->next = Current->next;
					OldCurrent = Current->next;
					delete Current;
					goto StartMSGMCDeleteRCFPL;
				}
			}
			else
			{
				OldCurrent = Current;
				Current = Current->next;
			}
		}
	}
}

int JMG_RP2_Mission_System_Global_Mission_Controller::Check_If_Vehicle_Is_Excluded(GameObject *sender)
{
	GameObject *SVehicle = Get_Vehicle(sender);
	if (MissionControlNode && SVehicle)
	{
		const char *VName = Commands->Get_Preset_Name(SVehicle);
		if (MissionControlNode->VehicleExceptions)
		{
			RP2PlayerVehicleFailMissionExceptionControl *Current = MissionControlNode->VehicleExceptions;
			while (Current != NULL)
			{
				if (!_stricmp(Current->VehiclePreset,VName))
				{
					return 0;
				}
				Current = Current->next;
			}
		}
	}
	return 1;
}

void JMG_RP2_Mission_System_Mission_Objective_Poke::Created(GameObject *obj)
{
	Commands->Enable_HUD_Pokable_Indicator(obj,1);
}

void JMG_RP2_Mission_System_Mission_Objective_Poke::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(poker)])
		{
			Commands->Send_Custom_Event(poker,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0);
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Enter::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		GameObject *EnterV = Get_Vehicle(enter);
		if (!EnterV)
		{
			EnterV = enter;
		}
		Vector3 Detection = Get_Vector3_Parameter("Detect[Human|Vehicle|Aircraft]");
		if (Detection.X && ((!EnterV->As_SoldierGameObj() && !Detection.Y && !Detection.Z) || (!EnterV->As_SoldierGameObj() && (Detection.Y || Detection.Z))))
		{
			// Only Attach to the one type of vehicle that isn't detected
			if (!((Detection.Y && !(EnterV->As_PhysicalGameObj() && EnterV->As_PhysicalGameObj()->Peek_Physical_Object() && EnterV->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()) && EnterV->As_VehicleGameObj()) || Detection.Z && (EnterV->As_PhysicalGameObj() && EnterV->As_PhysicalGameObj()->Peek_Physical_Object() && EnterV->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass())))
			{
				char params[2000];
				sprintf(params,"%d,%d,%d",Commands->Get_ID(obj),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"));
				Commands->Attach_Script(EnterV,"JMG_RP2_MS_Mission_Objective_Enter_Attach_Script",params);
			}
			// Attach when no vehicles are detected
			if (!Detection.Y && !Detection.Z && !Is_Script_Attached(EnterV,"JMG_RP2_MS_Mission_Objective_Enter_Attach_Script"))
			{
				char params[2000];
				sprintf(params,"%d,%d,%d",Commands->Get_ID(obj),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"));
				Commands->Attach_Script(EnterV,"JMG_RP2_MS_Mission_Objective_Enter_Attach_Script",params);
			}
		}
		if ((Detection.X && EnterV->As_SoldierGameObj()) || (Detection.Y && !(EnterV->As_PhysicalGameObj() && EnterV->As_PhysicalGameObj()->Peek_Physical_Object() && EnterV->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()) && EnterV->As_VehicleGameObj()) || Detection.Z && (EnterV->As_PhysicalGameObj() && EnterV->As_PhysicalGameObj()->Peek_Physical_Object() && EnterV->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
		{
			if (!ISSELECTINGSPAWN[Get_Player_ID(enter)])
			{
				Commands->Send_Custom_Event(enter,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0);
			}
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Enter::Exit(GameObject *obj,GameObject *exiter)
{
	GameObject *EnterV = Get_Vehicle(exiter);
	if (!EnterV)
	{
		EnterV = exiter;
	}
	if (Is_Script_Attached(EnterV,"JMG_RP2_MS_Mission_Objective_Enter_Attach_Script"))
	{
		Remove_Script(EnterV,"JMG_RP2_MS_Mission_Objective_Enter_Attach_Script");
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Kill::Killed(GameObject *obj,GameObject *damager)
{
	if (Commands->Is_A_Star(damager))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(damager)])
		{
			Commands->Send_Custom_Event(damager,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0);
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		if (Commands->Is_A_Star(sender))
		{
			if (!ISSELECTINGSPAWN[Get_Player_ID(sender)])
			{
				Commands->Send_Custom_Event(sender,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0);
			}
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Kill_OAG::Created(GameObject *obj)
{
	Vector3 MyPos = Commands->Get_Position(obj);
	if (!RP2GiveObjectiveByCreationLocationNode)
	{
		RP2GiveObjectiveByCreationLocationNode = new RP2GiveObjectiveByCreationLocationControl;
		RP2GiveObjectiveByCreationLocationNode->CreatePos = MyPos;
		RP2GiveObjectiveByCreationLocationNode->ObjectiveID = OBJECTIVECOUNT;
		ObjectiveID = RP2GiveObjectiveByCreationLocationNode->ObjectiveID;
		RP2GiveObjectiveByCreationLocationNode->next = NULL;
	}
	else
	{
		int end = 0;
		RP2GiveObjectiveByCreationLocationControl *Current = RP2GiveObjectiveByCreationLocationNode;
		while (Current != NULL && end == 0)
		{
			if (MyPos.X == Current->CreatePos.X && MyPos.Y == Current->CreatePos.Y && MyPos.Z == Current->CreatePos.Z)
			{	
				ObjectiveID = Current->ObjectiveID;
				end = 1;
			}
			if (Current->next == NULL && end == 0)
			{
				end = 1;
				Current->next = new RP2GiveObjectiveByCreationLocationControl;
				Current = Current->next;
				Current->CreatePos = MyPos;
				OBJECTIVECOUNT++;
				Current->ObjectiveID = OBJECTIVECOUNT;
				ObjectiveID = Current->ObjectiveID;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Kill_OAG::Killed(GameObject *obj,GameObject *damager)
{
	if (Commands->Is_A_Star(damager))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(damager)])
		{
			Commands->Send_Custom_Event(damager,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),ObjectiveID,0);
		}
	}
}

void JMG_RP2_Mission_System_Load_Completed_Player_Missions::Created(GameObject *obj)
{
	int CanWriteOutput = 1;
	FILE *FileMission;
	int BadRead = 0;
	FileMission = fopen("Data/RolePlay2/BetaPlayerMissions.RP2","r");
	if (FileMission)
	{
		char FirstLine[200];
		sprintf(FirstLine,"");
		fread(FirstLine,200,1,FileMission);
		if (strlen(FirstLine) < 2)
		{
			CanWriteOutput = 0;
		}
		rewind (FileMission);
		if (CanWriteOutput)
		{
			while (!feof(FileMission))
			{
				MyMissionNode = NULL;
				MissionControlNode = NULL;
				char PlayerName[256],Safty = '0',Safty1 = '0',Safty2 = '0';
				if (BadRead != 2)
				{
					fscanf(FileMission,"%c%c%c\n",&Safty,&Safty1,&Safty2);
				}
				if ((Safty == '[' && Safty1 == '*' && Safty2 == ']') || BadRead == 2)
				{
					BadRead = 0;
					char TempPName[256];
					fread(TempPName,256,1,FileMission);
					int loops = strlen(TempPName),x = 0;
					while (x < loops)
					{
						if (TempPName[x] != '\n')
						{
							PlayerName[x] = TempPName[x];
						}
						else
						{
							PlayerName[x] = '\0';
						}
						x++;
					}
					Add_Players(PlayerName);
					int NumberOfMissions,Special1,Special2,Total;
					fscanf(FileMission,"%d %d %d %d ",&NumberOfMissions,&Special1,&Special2,&Total);
					int SNumberOfMissions = NumberOfMissions,TotalAdd = 0;
					while (SNumberOfMissions > 10)
					{
						SNumberOfMissions -= 9;
					}
					if (NumberOfMissions)
					{
						if ((Total/2) == Special1 && (Total*SNumberOfMissions) == Special2)
						{
							int Temp;
							for (int y = 0;y < NumberOfMissions;y++)
							{
								fscanf(FileMission,"%d ",&Temp);
								TotalAdd += Temp;
								if (Find_Mission_Type(Temp))
								{
									AddCompletedMissionToPlayer(Temp);
								}
								else
								{
									char ERROR2[2000];
									sprintf(ERROR2,"MESSAGE ERROR: MISSION TYPE %d HAS NOT BEEN DEFINED",Temp);
									Console_Input(ERROR2);
								}
							}
						}
						else if (MyMissionNode)
						{
							sprintf(MyMissionNode->PlayerName,"NULLMISSIONERROR");
						}
						if (TotalAdd != Total && MyMissionNode)
						{
							sprintf(MyMissionNode->PlayerName,"NULLMISSIONERROR");
						}
					}
					fscanf(FileMission,"\n");
				}
				else
				{
					Console_Input("MESSAGE BAD LINE READ IN \"BetaPlayerMissions.RP2\"");	
					char TempPName[2000];
					fread(TempPName,2000,1,FileMission);
					while (!(TempPName[0] == '[' && TempPName[1] == '*' && TempPName[2] == ']') && !feof(FileMission))
					{
						fread(TempPName,2000,1,FileMission);
					}
					BadRead = 2;
				}
			}
		}
		fclose(FileMission);
	}
	else
	{
		Console_Input("MESSAGE Warning: Player Missions File not found! File will be automatically created...");
		FILE *hfile;
		hfile = fopen("Data/RolePlay2/BetaPlayerMissions.RP2","w");
		fprintf(hfile,"");
		fflush(hfile);
		fclose(hfile);
	}
}

int JMG_RP2_Mission_System_Load_Completed_Player_Missions::Find_Mission_Type(int MissionType)
{
	if (RP2MissionObjectiveTypeNode)
	{
		int end = 0;
		RP2MissionObjectiveTypeControl *Current = RP2MissionObjectiveTypeNode;
		while (Current != NULL && end == 0)
		{
			if (Current->MissionType == MissionType)
			{
				end = 1;
				MissionControlNode = Current;
				return 1;
			}
			Current = Current->next;
		}
	}
	return 0;
}

void JMG_RP2_Mission_System_Load_Completed_Player_Missions::Add_Players(char PlayerName[])
{
	if (!RP2PlayerMissionsNode)//Update freefor all as well
	{
		RP2PlayerMissionsNode = new RP2PlayerMissionsControl;
		sprintf(RP2PlayerMissionsNode->PlayerName,"%s",PlayerName);
		RP2PlayerMissionsNode->Mission = NULL;
		RP2PlayerMissionsNode->FailOnTrackedVehicle = NULL;
		RP2PlayerMissionsNode->FailOnWheeledVehicle = NULL;
		RP2PlayerMissionsNode->FailOnMotorcycle = NULL;
		RP2PlayerMissionsNode->FailOnAircraft = NULL;
		RP2PlayerMissionsNode->FailOnTurret = NULL;
		RP2PlayerMissionsNode->FailOnBoat = NULL;
		RP2PlayerMissionsNode->AllVehicles = NULL;
		RP2PlayerMissionsNode->MissionConflicts = NULL;
		MyMissionNode = RP2PlayerMissionsNode;
		RP2PlayerMissionsNode->next = NULL;
	}
	else
	{
		int end = 0;
		RP2PlayerMissionsControl *Current = RP2PlayerMissionsNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				end = 1;
				MyMissionNode = Current;
			}
			if (Current->next == NULL && end == 0)
			{
				end = 1;
				Current->next = new RP2PlayerMissionsControl;
				Current = Current->next;
				Current->Mission = NULL;
				sprintf(Current->PlayerName,"%s",PlayerName);
				Current->FailOnTrackedVehicle = NULL;
				Current->FailOnWheeledVehicle = NULL;
				Current->FailOnMotorcycle = NULL;
				Current->FailOnAircraft = NULL;
				Current->FailOnTurret = NULL;
				Current->FailOnBoat = NULL;
				Current->AllVehicles = NULL;
				Current->MissionConflicts = NULL;
				MyMissionNode = Current;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

int JMG_RP2_Mission_System_Load_Completed_Player_Missions::AddCompletedMissionToPlayer(int MissionType)
{
	if (MyMissionNode && MissionControlNode) // No Missions have ever been created for this player, create a new one
	{
		if (!MyMissionNode->Mission) 
		{
			MyMissionNode->Mission = new MissionTypes;
			MyMissions = MyMissionNode->Mission;
			MyMissionNode->Mission->MissionType = MissionControlNode->MissionType;
			MyMissionNode->Mission->MissionCompleted = 1;
			MyMissionNode->Mission->CompletedMissionObjectives = 0;
			MyMissionNode->Mission->StartedMission = 1;
			MyMissionNode->Mission->MissionDataPoints = NULL;
			MyMissionNode->Mission->ResetOnDeath = MissionControlNode->ResetOnDeath;
			MyMissionNode->Mission->ResetOnSuccess = MissionControlNode->ResetOnSuccess;
			MyMissionNode->Mission->RegrantOnNewgame = MissionControlNode->RegrantOnNewgame;
			MyMissionNode->Mission->RegrantOnSpawn = MissionControlNode->RegrantOnSpawn;
			MyMissionNode->Mission->RegrantOnFirstSpawn = MissionControlNode->RegrantOnFirstSpawn;
			MyMissionNode->Mission->next = NULL;
			return 1;
		}
		else if (MyMissionNode->Mission)
		{
			int end = 0;
			MissionTypes *Current = MyMissionNode->Mission;// Players list of mission nodes
			while (Current != NULL && end == 0)
			{
				if (Current->MissionType == MissionControlNode->MissionType)// found old mission match on this player
				{
					end = 1;
					MyMissions = Current;
					return 1;
				}
				else if (Current->next == NULL)// Reached end of list and no match found, add a new mission type to the players list
				{
					end = 1;
					Current->next = new MissionTypes;
					Current = Current->next;
					Current->MissionType = MissionControlNode->MissionType;
					Current->MissionCompleted = 1;
					Current->CompletedMissionObjectives = 0;
					Current->StartedMission = 1;
					Current->MissionDataPoints = NULL;
					Current->ResetOnDeath = MissionControlNode->ResetOnDeath;
					Current->ResetOnSuccess = MissionControlNode->ResetOnSuccess;
					Current->RegrantOnNewgame = MissionControlNode->RegrantOnNewgame;
					Current->RegrantOnSpawn = MissionControlNode->RegrantOnSpawn;
					Current->RegrantOnFirstSpawn = MissionControlNode->RegrantOnFirstSpawn;
					MyMissions = Current;
					Current->next = NULL;	
					return 1;
				}
				Current = Current->next;
			}
		}
	}
	return 0;
}

void JMG_RP2_Mission_System_Mission_Objective_Custom_Param::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		GameObject *Player = Get_GameObj(param);
		if (Commands->Is_A_Star(Player))
		{
			if (!ISSELECTINGSPAWN[Get_Player_ID(Player)])
			{
				Commands->Send_Custom_Event(Player,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0);
			}
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Enter_Preset::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		GameObject *EnterV = Get_Vehicle(enter);
		if (!EnterV)
		{
			EnterV = enter;
		}
		if (!_stricmp(Commands->Get_Preset_Name(EnterV),Get_Parameter("Enter_Preset")))
		{
			const char *str = Get_Player_Name(enter);
			ObjectiveCount = Get_Player_Mission_Objective_Count(str,Get_Int_Parameter("Mission_Type"));
			delete[] str;
			Commands->Send_Custom_Event(enter,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0);
			if (Get_Int_Parameter("Sell_Vehicle"))
			{
				Commands->Send_Custom_Event(obj,EnterV,Get_Int_Parameter("CostRequestMessage"),0,0);
			}
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Enter_Preset::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("PriceReturnedMessage"))
	{
		GameObject *Driver = Get_Vehicle_Driver(sender);
		const char *str = Get_Player_Name(Driver);
		if (ObjectiveCount < Get_Player_Mission_Objective_Count(str,Get_Int_Parameter("Mission_Type")))
		{
			Commands->Create_3D_Sound_At_Bone(Get_Parameter("SellSound"),sender,"origin");
			Commands->Give_Money(Driver,(float)param,1);
			Commands->Create_Explosion(Get_Parameter("Sell_Explosion"),Commands->Get_Position(sender),0);
			JMG_Force_Occupants_Exit(sender);
		}
		delete[] str;
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Enter_Preset::JMG_Force_Occupants_Exit(GameObject *obj)
{
	if (Is_Script_Attached(obj,"JMG_RP2_Chinook_Door_Control"))
	{
		Remove_Script(obj,"JMG_RP2_Chinook_Door_Control");
	}
	Commands->Enable_Vehicle_Transitions(obj,true);
	int j = 0;
	if (!obj || !obj->As_VehicleGameObj())
	{
		return;
	}
	while (Get_Vehicle_Occupant_Count(obj) > 0 && j < 5)
	{
		if (!obj || !obj->As_VehicleGameObj())
		{
			return;
		}
		int x = obj->As_VehicleGameObj()->Get_Occupant_Count();
		for (int i = 0;i < x;i++)
		{
			if (obj->As_VehicleGameObj()->Get_Occupant(i))
			{
				ActionParamsStruct params;
				params.Set_Basic((long)0,100,39);
				Commands->Action_Enter_Exit(obj->As_VehicleGameObj()->Get_Occupant(i),params);
			}
		}
		Commands->Enable_Vehicle_Transitions(obj,true);
		j++;
	}
	if (Get_Vehicle_Occupant_Count(obj) == 0)
	{
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z += 10000.0f;
		Commands->Set_Position(obj,pos);
	}
	if (Is_Script_Attached(obj,"DAN_Drop_Wreckage_On_Death"))
	{
		Remove_Script(obj,"DAN_Drop_Wreckage_On_Death");
	}
	Commands->Apply_Damage(obj,9999999.9f,"BlamoKiller",0);
}

void JMG_RP2_Mission_System_Mission_Objective_Enter_Weapon::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		if (Has_Weapon(enter,Get_Parameter("Weapon_Name")))
		{
			const char *str = Get_Player_Name(enter);
			ObjectiveCount = Get_Player_Mission_Objective_Count(str,Get_Int_Parameter("Mission_Type"));
			delete[] str;
			Commands->Send_Custom_Event(enter,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0);
			Commands->Send_Custom_Event(enter,obj,Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0.1f);
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Enter_Weapon::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Mission_Type") && param == Get_Int_Parameter("Objective_Number"))
	{
		if (Get_Int_Parameter("Remove_Weapon"))
		{
			const char *str = Get_Player_Name(sender);
			if (ObjectiveCount < Get_Player_Mission_Objective_Count(str,Get_Int_Parameter("Mission_Type")))
			{
				if (Get_Vehicle(sender))
				{
					if (Has_Weapon(sender,"Weapon_Empty_Hands"))
					{
						Commands->Select_Weapon(sender,"Weapon_Empty_Hands");
						Remove_Weapon(sender,Get_Parameter("Weapon_Name"));
					}
				}
				else if (!_stricmp(Get_Current_Weapon(sender),Get_Parameter("Weapon_Name")))
				{
					if (Has_Weapon(sender,"Weapon_Empty_Hands"))
					{
						Commands->Select_Weapon(sender,"Weapon_Empty_Hands");
						Remove_Weapon(sender,Get_Parameter("Weapon_Name"));
					}
					else
					{
						Console_Input("MESSAGE ERROR: Weapon_Empty_Hands is not in players inventory, this weapon is required for A LOT of RP2 scripts to work!");
					}
				}
				else if (Has_Weapon(sender,"Weapon_Empty_Hands"))
				{
					Commands->Select_Weapon(sender,"Weapon_Empty_Hands");
					Remove_Weapon(sender,Get_Parameter("Weapon_Name"));
				}
				else
				{
					Console_Input("MESSAGE ERROR: Weapon_Empty_Hands is not in players inventory, this weapon is required for A LOT of RP2 scripts to work!");
				}
			}
			delete[] str;
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Vehicle::Created(GameObject *obj)
{
	DriverID = 0;
}

void JMG_RP2_Mission_System_Mission_Objective_Vehicle::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (Commands->Is_A_Star(sender))
	{
		if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
		{
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Commands->Is_A_Star(Driver))
			{
				DriverID = Get_Player_ID(Driver);
			}
			Vector3 Params = Get_Vector3_Parameter("On_Enter[Enable|MissionType|Objective]");
			if ((int)Params.X)
			{
				Commands->Send_Custom_Event(sender,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),(int)Params.Y,(int)Params.Z,0);
			}
		}
		if (message == CUSTOM_EVENT_VEHICLE_EXITED)
		{
			Vector3 Params = Get_Vector3_Parameter("On_Exit[Enable|MissionType|Objective]");
			if ((int)Params.X)
			{
				Commands->Send_Custom_Event(sender,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),(int)Params.Y,(int)Params.Z,0);
			}
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Vehicle::Killed(GameObject *obj,GameObject *damager)
{
	GameObject *Driver = Get_Vehicle_Driver(obj);
	if (Driver)
	{
		if (Commands->Is_A_Star(Driver))
		{
			Vector3 Params = Get_Vector3_Parameter("Vehicle_Killed[Enable|MissionType|Objective]");
			if ((int)Params.X)
			{
				Commands->Send_Custom_Event(Driver,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),(int)Params.Y,(int)Params.Z,0);
			}
		}
		else if (DriverID)
		{
			Vector3 Params = Get_Vector3_Parameter("Vehicle_Killed[Enable|MissionType|Objective]");
			if ((int)Params.X)
			{
				Commands->Send_Custom_Event(Get_GameObj(DriverID),Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),(int)Params.Y,(int)Params.Z,0);
			}
		}
	}
	if (damager)
	{
		if (Commands->Is_A_Star(damager))
		{
			Vector3 Params = Get_Vector3_Parameter("Vehicle_Killer[Enable|MissionType|Objective]");
			if ((int)Params.X)
			{
				Commands->Send_Custom_Event(damager,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),(int)Params.Y,(int)Params.Z,0);
			}
		}
	}
}

void JMG_RP2_Mission_System_Phone_Grant_Mission::Created(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		PlayerMissions[x] = 0;
	}
}

void JMG_RP2_Mission_System_Phone_Grant_Mission::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (11 == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,"18005551337"))
						{
							end = 1;
							sprintf(Current->PhoneNumber,"%s - 1(800)555-1337 - Grant a random mission.",Current->PhoneNumber);
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONECallStartCustom && param == 0)
	{							
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (11 == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,"18005551337"))
						{
							end = 1;
							if (!Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")))
							{
								GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
								GLOBALPHONETIMES[PlayerID] = 0;
								if (PlayerMissions[PlayerID])
								{
									Commands->Send_Custom_Event(sender,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),PlayerMissions[PlayerID],-9115,0);
								}
								Commands->Send_Custom_Event(sender,obj,169,Get_Player_ID(sender),Commands->Get_Random(1.0f,4.0f));
							}
							else
							{
								for (int x = 1;x < 128;x++)
								{
									if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
									{
										GameObject *Player = Get_GameObj(x);
										Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
									}
								}
								Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
							}
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && param == 2)
	{
		Send_Message_Player(sender,127,255,0,"1(800)555-1337 - Grant a random mission.");
	}
	if (message == 169)
	{
		GameObject *player = Get_GameObj(param);
		Send_Message_Player(player,127,255,0,"Searching for a mission, stand by...");
		Commands->Send_Custom_Event(obj,player,PHONEStopRingingNumberReached,0,0);
		Commands->Send_Custom_Event(player,obj,PHONECallWaiting,169,Commands->Get_Random(1,4.0f));
	}
	if (param == 169 && message == PHONECallWaiting)
	{
		char PlayerName[256];
		const char *str = Get_Player_Name(sender);
		sprintf(PlayerName,"%s",str);
		delete[] str;
		int Target = Commands->Get_Random_Int(1,(PHONEMAXRANDCHOICE+1));
		int MissionNumber = 0,end = 0;
		if (RP2PhoneMissionNode)
		{
			RP2PhoneMissionControl *Current = RP2PhoneMissionNode;
			while (Current != NULL && end == 0)
			{
				if (Current->PhoneMissionNumber == Target)
				{
					if (Check_Player_Mission_Avability(PlayerName,Current->MissionType))
					{
						MissionNumber = Current->MissionType;
					}
					end = 1;
				}
				Current = Current->next;
			}
			if (!MissionNumber)
			{
				end = 0;
				RP2PhoneMissionControl *Current = RP2PhoneMissionNode;
				while (Current != NULL && end == 0)
				{
					if (Check_Player_Mission_Avability(PlayerName,Current->MissionType))
					{
						MissionNumber = Current->MissionType;
					}
					end = 1;
					Current = Current->next;
				}
			}
		}
		if (!RP2PhoneMissionNode || !MissionNumber)
		{
			Send_Message_Player(sender,127,255,0,"No missions could be found, sorry.");
		}
		else
		{
			PlayerMissions[Get_Player_ID(sender)] = MissionNumber;
			Commands->Send_Custom_Event(sender,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),MissionNumber,0,0);
		}
		AutoCancelCall(obj,sender);
	}
}

void JMG_RP2_Mission_System_Phone_Grant_Mission::AutoCancelCall(GameObject *obj,GameObject *player)
{
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}


void JMG_RP2_Custom_Create_Object_Attach_Script::Created(GameObject *obj)
{
	ObjectID = 0;
}

void JMG_RP2_Custom_Create_Object_Attach_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message") && param == Get_Int_Parameter("Param"))
	{
		if (ObjectID)
		{
			GameObject *Object = Commands->Find_Object(ObjectID);
			if (Object)
			{
				Commands->Apply_Damage(Object,9999.9f,"BlamoKiller",0);
			}
			ObjectID = 0;
		}
		GameObject *object = Commands->Create_Object(Get_Parameter("Preset"),Get_Vector3_Parameter("Location"));
		Commands->Set_Facing(object,Get_Float_Parameter("Facing"));
		ObjectID = Commands->Get_ID(object);
		const char *script = Get_Parameter("Script");
		const char *paramx = Get_Parameter("Params");
		char *params = newstr(paramx);
		char delim = Get_Parameter("Delim")[0];
		unsigned int x = (unsigned int)strlen(params);
		for (unsigned int i=0;i<x;i++)
		{
			if (params[i] == delim)
			{
				params[i] = ',';
			}
		}
		Commands->Attach_Script(object,script,params);
		delete params;
	}
	if (message == Get_Int_Parameter("DestroyMessage") && param == Get_Int_Parameter("Param") && ObjectID)
	{
		GameObject *Object = Commands->Find_Object(ObjectID);
		if (Object)
		{
			Commands->Apply_Damage(Object,9999.9f,"BlamoKiller",0);
		}
		ObjectID = 0;
	}
}

void JMG_RP2_Phone_Main_Map_Runtime_Save::Created(GameObject *obj)
{
}

void JMG_RP2_Phone_Main_Map_Runtime_Save::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == PHONECallStartCustom && param == 0)
	{							
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (5 == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,"31337"))
						{
							end = 1;
							if (!Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")))
							{
								GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
								GLOBALPHONETIMES[PlayerID] = 0;
								Commands->Send_Custom_Event(obj,obj,5556662,Get_Player_ID(sender),0);
							}
							else
							{
								for (int x = 1;x < 128;x++)
								{
									if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
									{
										GameObject *Player = Get_GameObj(x);
										Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
									}
								}
								Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
							}
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == 5556662)
	{
		GameObject *player = Get_GameObj(param);
		char Message[256];
		const char *str = Get_Player_Name(player);
		sprintf(Message,"HOST: %s has started an in-game save, save will occur in:",str);
		delete[] str;
		MessageToPlayers(Message);
		MessageToPlayers("3");
		Commands->Send_Custom_Event(obj,player,PHONEStopRingingNumberReached,0,0);
		Commands->Send_Custom_Event(player,obj,4086050,5556662,1.0f);
	}
	if (param == 5556662 && message == 4086050)
	{
		MessageToPlayers("2");
		Commands->Send_Custom_Event(sender,obj,PHONEOtherEndHangUp,5556662,1.0f);
	}
	if (param == 5556662 && message == PHONEOtherEndHangUp)
	{
		MessageToPlayers("1");
		Commands->Send_Custom_Event(sender,obj,PHONECallWaiting,5556662,1.0f);
	}
	if (param == 5556662 && message == PHONECallWaiting)
	{
		MessageToPlayers("Beginning Save Process...");
		SaveStructs();
		AutoCancelCall(obj,sender);
	}
}

void JMG_RP2_Phone_Main_Map_Runtime_Save::AutoCancelCall(GameObject *obj,GameObject *player)
{
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}

void JMG_RP2_Phone_Main_Map_Runtime_Save::SaveStructs()
{
	MessageToPlayers("Saving: Player Redial Numbers...");
	if (PlayerRedialNumberNode)
	{
		FILE *RewriteFileRedial;
		RewriteFileRedial = fopen("Data/RolePlay2/PhoneRedialNumbers.tmp","w");
		fflush(RewriteFileRedial);
		PlayerRedialNumberControl *Current = PlayerRedialNumberNode;
		while (Current != NULL)
		{
			fprintf(RewriteFileRedial,"[*]\n%s\n%d,%d,%d,%d,%d,%d,%d,%d,%d,%d;\n",Current->PlayerName,Current->NumberLength[0],Current->NumberLength[1],Current->NumberLength[2],Current->NumberLength[3],Current->NumberLength[4],Current->NumberLength[5],Current->NumberLength[6],Current->NumberLength[7],Current->NumberLength[8],Current->NumberLength[9]);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber0);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber1);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber2);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber3);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber4);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber5);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber6);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber7);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber8);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber9);
			fflush(RewriteFileRedial);
			Current = Current->next;
		}
		fclose(RewriteFileRedial);
		remove("Data/RolePlay2/BetaPhoneRedialNumbers.RP2");
		rename("Data/RolePlay2/PhoneRedialNumbers.tmp","Data/RolePlay2/BetaPhoneRedialNumbers.RP2");
	}
	MessageToPlayers("Saving: Weapons Cupboard Weapons...");
	if (WeaponCupboardNode)
	{
		FILE *RewriteFileCupboard;
		RewriteFileCupboard = fopen("Data/RolePlay2/WeaponsCupboard.tmp","w");
		fflush(RewriteFileCupboard);
		WeaponCupboardControl *Current = WeaponCupboardNode;
		while (Current != NULL)
		{
			RP2WeaponListControl *Weapon = Get_WLS_Weapon_Settings(Current->Weapon);
			if (Weapon)
			{
				int EncryptFactor = Current->ID%100;
				fprintf(RewriteFileCupboard,";%d;\n%s\n",Current->ID,Encrypt(Weapon->WeaponName,EncryptFactor,3));
				fflush(RewriteFileCupboard);
			}
			Current = Current->next;
		}
		fclose(RewriteFileCupboard);
		remove("Data/RolePlay2/BetaWeaponsCupboard.RP2");
		rename("Data/RolePlay2/WeaponsCupboard.tmp","Data/RolePlay2/BetaWeaponsCupboard.RP2");
	}
	MessageToPlayers("Saving: Completed Player Missions...");
	if (RP2PlayerMissionsNode)
	{
		FILE *RP2PMS;
		RP2PMS = fopen("Data/RolePlay2/PlayerMissions.tmp","w");
		fflush(RP2PMS);
		RP2PlayerMissionsControl *temp,*die;
		temp = RP2PlayerMissionsNode;
		int Total = 0;
		int Number = 0;
		int SNumber;
		while (temp != NULL)
		{
			die = temp;
			Total = 0;
			Number = 0;
			fprintf(RP2PMS,"[*]\n%s\n",die->PlayerName);
			if (die->Mission)
			{
				MissionTypes *temp2,*die2;
				temp2 = die->Mission;
				while (temp2 != NULL)//Addem Up
				{
					die2 = temp2;
					if (die2->MissionCompleted && die2->RegrantOnNewgame)
					{
						Number++;
						Total += die2->MissionType;
					}
					temp2 = temp2->next;
				}
				SNumber = Number;
				while (SNumber > 10)
				{
					SNumber -= 9;
				}
				fprintf(RP2PMS,"%d %d %d %d ",Number,(Total/2),(Total*SNumber),Total);
				temp2 = die->Mission;
				while (temp2 != NULL)
				{
					die2 = temp2;
					if (die2->MissionCompleted && die2->RegrantOnNewgame)
					{
						fprintf(RP2PMS,"%d ",die2->MissionType);
					}
					temp2 = temp2->next;
				}
				fprintf(RP2PMS,"\n");
			}
			else
			{
				fprintf(RP2PMS,"0 0 0 0 \n");
			}
			temp = temp->next;
		}
		fclose(RP2PMS);
		remove("Data/RolePlay2/BetaPlayerMissions.RP2");
		rename("Data/RolePlay2/PlayerMissions.tmp","Data/RolePlay2/BetaPlayerMissions.RP2");
	}
	MessageToPlayers("Saving: Player Bank Accounts...");
	if (RP2PlayerBankAccountNode)
	{
		FILE *RP2BAS;
		RP2BAS = fopen("Data/RolePlay2/PlayerBankAccounts.tmp","w");
		fflush(RP2BAS);

		RP2PlayerBankAccountControl *temp;
		temp = RP2PlayerBankAccountNode;
		int Total = 0;
		int Number = 1;
		int SNumber;
		while (temp != NULL)
		{
			if ((int)temp->AccountBalance)
			{
				fprintf(RP2BAS,"[*]\n%s\n",temp->PlayerName);
				Number++;
				Total += (int)temp->AccountBalance;
				SNumber = Total;
				while (SNumber > 10)
				{
					SNumber -= 9;
				}
				fprintf(RP2BAS,"%d %d %d %d %d %d\n",(Total/Number)+SNumber,(Total*SNumber)+Number,(((Total/(Number+1))*Number)+(SNumber*Number)),(int)temp->AccountBalance,(((int)temp->AccountBalance/SNumber)+(SNumber*Number)),SNumber);
			}
			temp = temp->next;
		}
		fclose(RP2BAS);
		remove("Data/RolePlay2/BetaPlayerBankAccounts.RP2");
		rename("Data/RolePlay2/PlayerBankAccounts.tmp","Data/RolePlay2/BetaPlayerBankAccounts.RP2");
	}
	MessageToPlayers("Saving: House Garage Vehicles...");
	// Garage Node
	if (PlayerHouseVehicleNode)
	{
		FILE *RewriteFileVehicle;
		RewriteFileVehicle = fopen("Data/RolePlay2/GarageVehicle.tmp","w");
		fflush(RewriteFileVehicle);
		PlayerHouseVehicleControl *Current = PlayerHouseVehicleNode;
		while (Current != NULL)
		{
			if (_stricmp(Current->VehiclePreset,"null"))
			{
				int EncryptFactor = (Current->House_Address%10);
				fprintf(RewriteFileVehicle,"%d\n%s\n%.2f %.2f %.2f\n%.2f\n",Current->House_Address,Encrypt(Current->VehiclePreset,EncryptFactor,3),Current->VehiclePosition.X,Current->VehiclePosition.Y,Current->VehiclePosition.Z,Current->VehicleFacing);
				fflush(RewriteFileVehicle);
			}
			Current = Current->next;
		}
		fclose(RewriteFileVehicle);
		remove("Data/RolePlay2/BetaGarageVehicle.RP2");
		rename("Data/RolePlay2/GarageVehicle.tmp","Data/RolePlay2/BetaGarageVehicle.RP2");
	}
	MessageToPlayers("Saving: Housing...");
	if (RP2NewHouseSystemNode)
	{
		RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
		FILE *FileHouse;
		FileHouse = fopen("Data/RolePlay2/HouseControl.tmp","w");
		fflush(FileHouse);
		while (Current != NULL)
		{
			if (Current->IsOwned)
			{
				fprintf(FileHouse,"%d %d %d %d %d;\n%s\n",Current->HouseAddress,Current->NumberOfPrePays,Current->RentTime,Current->HouseYear,Current->HouseDay,Current->PlayerName);
				fflush(FileHouse);
			}
			Current = Current->next;
		}
		fclose(FileHouse);
		remove("Data/RolePlay2/BetaHouseControl.RP2");
		rename("Data/RolePlay2/HouseControl.tmp","Data/RolePlay2/BetaHouseControl.RP2");
	}
	MessageToPlayers("Saving: Favorite Vehicles...");
	if (PlayerFavoriteVehicleNode)
	{
		FILE *RewriteFileFavVehicle;
		RewriteFileFavVehicle = fopen("Data/RolePlay2/FavoriteVehicles.tmp","w");
		fflush(RewriteFileFavVehicle);
		PlayerFavoriteVehicleControl *Current = PlayerFavoriteVehicleNode;
		while (Current != NULL)
		{
			int EncryptFactor = Current->VehicleCost/10+1;
			fprintf(RewriteFileFavVehicle,"%d\n",Current->VehicleCost);
			fprintf(RewriteFileFavVehicle,"%s\n",Encrypt(Current->PlayerName,EncryptFactor,3));
			fprintf(RewriteFileFavVehicle,"%s\n",Encrypt(Current->VehiclePreset,EncryptFactor,4));
			fprintf(RewriteFileFavVehicle,"%s\n",Encrypt(Current->VehicleName,EncryptFactor,5));
			fflush(RewriteFileFavVehicle);
			Current = Current->next;
		}
		fclose(RewriteFileFavVehicle);
		remove("Data/RolePlay2/BetaFavoriteVehicles.RP2");
		rename("Data/RolePlay2/FavoriteVehicles.tmp","Data/RolePlay2/BetaFavoriteVehicles.RP2");
	}
	MessageToPlayers("Saving: Favorite Weapons...");
	if (PlayerFavoriteWeaponNode)
	{
		FILE *RewriteFileFavWeapon;
		RewriteFileFavWeapon = fopen("Data/RolePlay2/FavoriteWeapons.tmp","w");
		fflush(RewriteFileFavWeapon);
		PlayerFavoriteWeaponControl *Current = PlayerFavoriteWeaponNode;
		while (Current != NULL)
		{
			int EncryptFactor = Current->WeaponCost/10+1;
			fprintf(RewriteFileFavWeapon,"%d\n",Current->WeaponCost);
			fprintf(RewriteFileFavWeapon,"%s\n",Encrypt(Current->PlayerName,EncryptFactor,3));
			fprintf(RewriteFileFavWeapon,"%s\n",Encrypt(Current->WeaponPreset,EncryptFactor,4));
			fprintf(RewriteFileFavWeapon,"%s\n",Encrypt(Current->WeaponName,EncryptFactor,5));
			fflush(RewriteFileFavWeapon);
			Current = Current->next;
		}
		fclose(RewriteFileFavWeapon);
		remove("Data/RolePlay2/BetaFavoriteWeapons.RP2");
		rename("Data/RolePlay2/FavoriteWeapons.tmp","Data/RolePlay2/BetaFavoriteWeapons.RP2");
	}
	MessageToPlayers("Saving: Player Characters...");
	if (PlayerCharacterNode)
	{
		FILE *FilePlayerCharacters;
		FilePlayerCharacters = fopen("Data/RolePlay2/PlayerCharacters.tmp","w");
		fflush(FilePlayerCharacters);
		PlayerCharacterControl *Current = PlayerCharacterNode;
		while (Current != NULL)
		{
			fprintf(FilePlayerCharacters,"%s\n",Current->PlayerName);
			fprintf(FilePlayerCharacters,"%s\n",Current->PresetName);
			fflush(FilePlayerCharacters);
			Current = Current->next;
		}
		fclose(FilePlayerCharacters);
		remove("Data/RolePlay2/BetaPlayerCharacters.RP2");
		rename("Data/RolePlay2/PlayerCharacters.tmp","Data/RolePlay2/BetaPlayerCharacters.RP2");
	}
	MessageToPlayers("Saving: House Security Settings...");
	if (HomeSecuritySystemNode)
	{
		HomeSecuritySystemControl *Current = HomeSecuritySystemNode;
		FILE *FileHouseSecuritySystem;
		FileHouseSecuritySystem = fopen("Data/RolePlay2/HomeSecuritySettings.tmp","w");
		fflush(FileHouseSecuritySystem);
		while (Current != NULL)
		{
			fprintf(FileHouseSecuritySystem,"%d\n",Current->HouseAddress);
			char EncryptString[256];
			sprintf(EncryptString,"%d %d %d %d %d %d %d %d %d",Current->RentPrice,Current->DetectIntruders,Current->DetectVandals,Current->CeilingGuns,Current->MissileDefenseSystem,Current->AutoRepair,Current->NumberOfPrePays,Current->RentDay,Current->RentYear);
			fprintf(FileHouseSecuritySystem,"%s\n",Encrypt(EncryptString,Current->HouseAddress,3));
			fflush(FileHouseSecuritySystem);
			Current = Current->next;
		}
		fclose(FileHouseSecuritySystem);
		remove("Data/RolePlay2/BetaHomeSecuritySettings.RP2");
		rename("Data/RolePlay2/HomeSecuritySettings.tmp","Data/RolePlay2/BetaHomeSecuritySettings.RP2");
	}
	MessageToPlayers("Save Successful!");
}

void JMG_RP2_Phone_Main_Map_Runtime_Save::MessageToPlayers(const char *Message)
{
	for (int x = 1;x <= Get_Player_Count();x++)
	{
		GameObject *Player = Get_GameObj(x);
		if (Player)
		{
			Send_Message_Player(Player,255,255,255,Message);
		}
	}
}

char *JMG_RP2_Phone_Main_Map_Runtime_Save::Encrypt(const char *String,int EncryptionFactor,int Start)
{
	static char FinalString[256];
	int loops = strlen(String),x = 0;
	int CurrentAdd = Start;
	while (x < loops)
	{
		if (String[x] != '\0' && String[x] != '\n')
		{
			char Temp = (String[x]+(char)CurrentAdd);
			while (Temp > 125)
			{
				Temp -= 125;
			}
			//if (Temp == 92)
			//{
			//	Temp = 126;
			//	//printf("MESSAGE WARNING: BACKWARD SLASH DETECTED! Nap, if the string does corrupt in game let me know, I haven't managed to put together a case to test this situation yet.");
			//}
			FinalString[x] = Temp;
			CurrentAdd++;
			if (CurrentAdd > EncryptionFactor)
			{
				CurrentAdd = 1;
			}
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
		FinalString[x] = '\0';
	}
	return FinalString;
}

void JMG_RP2_Phone_Main_Map_Runtime_Save::SaveStructsSilent()
{
	if (PlayerRedialNumberNode)
	{
		FILE *RewriteFileRedial;
		RewriteFileRedial = fopen("Data/RolePlay2/PhoneRedialNumbers.tmp","w");
		fflush(RewriteFileRedial);
		PlayerRedialNumberControl *Current = PlayerRedialNumberNode;
		while (Current != NULL)
		{
			fprintf(RewriteFileRedial,"[*]\n%s\n%d,%d,%d,%d,%d,%d,%d,%d,%d,%d;\n",Current->PlayerName,Current->NumberLength[0],Current->NumberLength[1],Current->NumberLength[2],Current->NumberLength[3],Current->NumberLength[4],Current->NumberLength[5],Current->NumberLength[6],Current->NumberLength[7],Current->NumberLength[8],Current->NumberLength[9]);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber0);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber1);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber2);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber3);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber4);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber5);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber6);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber7);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber8);
			fprintf(RewriteFileRedial,"%s\n",Current->PhoneNumber9);
			fflush(RewriteFileRedial);
			Current = Current->next;
		}
		fclose(RewriteFileRedial);
		remove("Data/RolePlay2/BetaPhoneRedialNumbers.RP2");
		rename("Data/RolePlay2/PhoneRedialNumbers.tmp","Data/RolePlay2/BetaPhoneRedialNumbers.RP2");
	}
	if (WeaponCupboardNode)
	{
		FILE *RewriteFileCupboard;
		RewriteFileCupboard = fopen("Data/RolePlay2/WeaponsCupboard.tmp","w");
		fflush(RewriteFileCupboard);
		WeaponCupboardControl *Current = WeaponCupboardNode;
		while (Current != NULL)
		{
			RP2WeaponListControl *Weapon = Get_WLS_Weapon_Settings(Current->Weapon);
			if (Weapon)
			{
				int EncryptFactor = Current->ID%100;
				fprintf(RewriteFileCupboard,";%d;\n%s\n",Current->ID,Encrypt(Weapon->WeaponName,EncryptFactor,3));
				fflush(RewriteFileCupboard);
			}
			Current = Current->next;
		}
		fclose(RewriteFileCupboard);
		remove("Data/RolePlay2/BetaWeaponsCupboard.RP2");
		rename("Data/RolePlay2/WeaponsCupboard.tmp","Data/RolePlay2/BetaWeaponsCupboard.RP2");
	}
	if (RP2PlayerMissionsNode)
	{
		FILE *RP2PMS;
		RP2PMS = fopen("Data/RolePlay2/PlayerMissions.tmp","w");
		fflush(RP2PMS);
		RP2PlayerMissionsControl *temp,*die;
		temp = RP2PlayerMissionsNode;
		int Total = 0;
		int Number = 0;
		int SNumber;
		while (temp != NULL)
		{
			die = temp;
			Total = 0;
			Number = 0;
			fprintf(RP2PMS,"[*]\n%s\n",die->PlayerName);
			if (die->Mission)
			{
				MissionTypes *temp2,*die2;
				temp2 = die->Mission;
				while (temp2 != NULL)//Addem Up
				{
					die2 = temp2;
					if (die2->MissionCompleted && die2->RegrantOnNewgame)
					{
						Number++;
						Total += die2->MissionType;
					}
					temp2 = temp2->next;
				}
				SNumber = Number;
				while (SNumber > 10)
				{
					SNumber -= 9;
				}
				fprintf(RP2PMS,"%d %d %d %d ",Number,(Total/2),(Total*SNumber),Total);
				temp2 = die->Mission;
				while (temp2 != NULL)
				{
					die2 = temp2;
					if (die2->MissionCompleted && die2->RegrantOnNewgame)
					{
						fprintf(RP2PMS,"%d ",die2->MissionType);
					}
					temp2 = temp2->next;
				}
				fprintf(RP2PMS,"\n");
			}
			else
			{
				fprintf(RP2PMS,"0 0 0 0 \n");
			}
			temp = temp->next;
		}
		fclose(RP2PMS);
		remove("Data/RolePlay2/BetaPlayerMissions.RP2");
		rename("Data/RolePlay2/PlayerMissions.tmp","Data/RolePlay2/BetaPlayerMissions.RP2");
	}
	if (RP2PlayerBankAccountNode)
	{
		FILE *RP2BAS;
		RP2BAS = fopen("Data/RolePlay2/PlayerBankAccounts.tmp","w");
		fflush(RP2BAS);

		RP2PlayerBankAccountControl *temp;
		temp = RP2PlayerBankAccountNode;
		int Total = 0;
		int Number = 1;
		int SNumber;
		while (temp != NULL)
		{
			if ((int)temp->AccountBalance)
			{
				fprintf(RP2BAS,"[*]\n%s\n",temp->PlayerName);
				Number++;
				Total += (int)temp->AccountBalance;
				SNumber = Total;
				while (SNumber > 10)
				{
					SNumber -= 9;
				}
				fprintf(RP2BAS,"%d %d %d %d %d %d\n",(Total/Number)+SNumber,(Total*SNumber)+Number,(((Total/(Number+1))*Number)+(SNumber*Number)),(int)temp->AccountBalance,(((int)temp->AccountBalance/SNumber)+(SNumber*Number)),SNumber);
			}
			temp = temp->next;
		}
		fclose(RP2BAS);
		remove("Data/RolePlay2/BetaPlayerBankAccounts.RP2");
		rename("Data/RolePlay2/PlayerBankAccounts.tmp","Data/RolePlay2/BetaPlayerBankAccounts.RP2");
	}
	// Garage Node
	if (PlayerHouseVehicleNode)
	{
		FILE *RewriteFileVehicle;
		RewriteFileVehicle = fopen("Data/RolePlay2/GarageVehicle.tmp","w");
		fflush(RewriteFileVehicle);
		PlayerHouseVehicleControl *Current = PlayerHouseVehicleNode;
		while (Current != NULL)
		{
			if (_stricmp(Current->VehiclePreset,"null"))
			{
				int EncryptFactor = (Current->House_Address%10);
				fprintf(RewriteFileVehicle,"%d\n%s\n%.2f %.2f %.2f\n%.2f\n",Current->House_Address,Encrypt(Current->VehiclePreset,EncryptFactor,3),Current->VehiclePosition.X,Current->VehiclePosition.Y,Current->VehiclePosition.Z,Current->VehicleFacing);
				fflush(RewriteFileVehicle);
			}
			Current = Current->next;
		}
		fclose(RewriteFileVehicle);
		remove("Data/RolePlay2/BetaGarageVehicle.RP2");
		rename("Data/RolePlay2/GarageVehicle.tmp","Data/RolePlay2/BetaGarageVehicle.RP2");
	}
	if (RP2NewHouseSystemNode)
	{
		RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
		FILE *FileHouse;
		FileHouse = fopen("Data/RolePlay2/HouseControl.tmp","w");
		fflush(FileHouse);
		while (Current != NULL)
		{
			if (Current->IsOwned)
			{
				fprintf(FileHouse,"%d %d %d %d %d;\n%s\n",Current->HouseAddress,Current->NumberOfPrePays,Current->RentTime,Current->HouseYear,Current->HouseDay,Current->PlayerName);
				fflush(FileHouse);
			}
			Current = Current->next;
		}
		fclose(FileHouse);
		remove("Data/RolePlay2/BetaHouseControl.RP2");
		rename("Data/RolePlay2/HouseControl.tmp","Data/RolePlay2/BetaHouseControl.RP2");
	}
	if (PlayerFavoriteVehicleNode)
	{
		FILE *RewriteFileFavVehicle;
		RewriteFileFavVehicle = fopen("Data/RolePlay2/FavoriteVehicles.tmp","w");
		fflush(RewriteFileFavVehicle);
		PlayerFavoriteVehicleControl *Current = PlayerFavoriteVehicleNode;
		while (Current != NULL)
		{
			int EncryptFactor = Current->VehicleCost/10+1;
			fprintf(RewriteFileFavVehicle,"%d\n",Current->VehicleCost);
			fprintf(RewriteFileFavVehicle,"%s\n",Encrypt(Current->PlayerName,EncryptFactor,3));
			fprintf(RewriteFileFavVehicle,"%s\n",Encrypt(Current->VehiclePreset,EncryptFactor,4));
			fprintf(RewriteFileFavVehicle,"%s\n",Encrypt(Current->VehicleName,EncryptFactor,5));
			fflush(RewriteFileFavVehicle);
			Current = Current->next;
		}
		fclose(RewriteFileFavVehicle);
		remove("Data/RolePlay2/BetaFavoriteVehicles.RP2");
		rename("Data/RolePlay2/FavoriteVehicles.tmp","Data/RolePlay2/BetaFavoriteVehicles.RP2");
	}
	if (PlayerFavoriteWeaponNode)
	{
		FILE *RewriteFileFavWeapon;
		RewriteFileFavWeapon = fopen("Data/RolePlay2/FavoriteWeapons.tmp","w");
		fflush(RewriteFileFavWeapon);
		PlayerFavoriteWeaponControl *Current = PlayerFavoriteWeaponNode;
		while (Current != NULL)
		{
			int EncryptFactor = Current->WeaponCost/10+1;
			fprintf(RewriteFileFavWeapon,"%d\n",Current->WeaponCost);
			fprintf(RewriteFileFavWeapon,"%s\n",Encrypt(Current->PlayerName,EncryptFactor,3));
			fprintf(RewriteFileFavWeapon,"%s\n",Encrypt(Current->WeaponPreset,EncryptFactor,4));
			fprintf(RewriteFileFavWeapon,"%s\n",Encrypt(Current->WeaponName,EncryptFactor,5));
			fflush(RewriteFileFavWeapon);
			Current = Current->next;
		}
		fclose(RewriteFileFavWeapon);
		remove("Data/RolePlay2/BetaFavoriteWeapons.RP2");
		rename("Data/RolePlay2/FavoriteWeapons.tmp","Data/RolePlay2/BetaFavoriteWeapons.RP2");
	}
	if (PlayerCharacterNode)
	{
		FILE *FilePlayerCharacters;
		FilePlayerCharacters = fopen("Data/RolePlay2/PlayerCharacters.tmp","w");
		fflush(FilePlayerCharacters);
		PlayerCharacterControl *Current = PlayerCharacterNode;
		while (Current != NULL)
		{
			fprintf(FilePlayerCharacters,"%s\n",Current->PlayerName);
			fprintf(FilePlayerCharacters,"%s\n",Current->PresetName);
			fflush(FilePlayerCharacters);
			Current = Current->next;
		}
		fclose(FilePlayerCharacters);
		remove("Data/RolePlay2/BetaPlayerCharacters.RP2");
		rename("Data/RolePlay2/PlayerCharacters.tmp","Data/RolePlay2/BetaPlayerCharacters.RP2");
	}
	if (HomeSecuritySystemNode)
	{
		HomeSecuritySystemControl *Current = HomeSecuritySystemNode;
		FILE *FileHouseSecuritySystem;
		FileHouseSecuritySystem = fopen("Data/RolePlay2/HomeSecuritySettings.tmp","w");
		fflush(FileHouseSecuritySystem);
		while (Current != NULL)
		{
			fprintf(FileHouseSecuritySystem,"%d\n",Current->HouseAddress);
			char EncryptString[256];
			sprintf(EncryptString,"%d %d %d %d %d %d %d %d %d",Current->RentPrice,Current->DetectIntruders,Current->DetectVandals,Current->CeilingGuns,Current->MissileDefenseSystem,Current->AutoRepair,Current->NumberOfPrePays,Current->RentDay,Current->RentYear);
			fprintf(FileHouseSecuritySystem,"%s\n",Encrypt(EncryptString,Current->HouseAddress,3));
			fflush(FileHouseSecuritySystem);
			Current = Current->next;
		}
		fclose(FileHouseSecuritySystem);
		remove("Data/RolePlay2/BetaHomeSecuritySettings.RP2");
		rename("Data/RolePlay2/HomeSecuritySettings.tmp","Data/RolePlay2/BetaHomeSecuritySettings.RP2");
	}
}

void JMG_RP2_MS_Mission_Objective_Enter_Attach_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		GameObject *Zone = Commands->Find_Object(Get_Int_Parameter("ZoneID"));
		if (Zone)
		{
			if (IsInsideZone(Zone,obj))
			{
				if (Commands->Is_A_Star(sender))
				{
					Commands->Send_Custom_Event(sender,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0);
				}
			}
			else if (Is_Script_Attached(obj,"JMG_RP2_MS_Mission_Objective_Enter_Attach_Script"))
			{
				Remove_Script(obj,"JMG_RP2_MS_Mission_Objective_Enter_Attach_Script");
			}
		}
	}
}

void JMG_RP2_Load_Random_Teleport_File::Created(GameObject *obj)
{
	FILE *TP;
	TP = fopen(Get_Parameter("File_Name"), "r");
	if (TP == NULL)
	{
		char messag[1000];
		sprintf(messag,"MESSAGE Teleport Zone %d IS UNABLE TO LOAD \"%s\"! GAME IS UNSTABLE WITHOUT THIS FILE!!",Commands->Get_ID(obj),Get_Parameter("File_Name"));
		Console_Input(messag);
		Remove_Script(obj,"JMG_RP2_Load_Random_Teleport_File");
	}
	else
	{
		int G2G = 1;
		while (G2G)
		{
			float X,Y,Z;
			fscanf(TP,"%f %f %f",&X,&Y,&Z);
			if (!feof(TP))
			{
				Add_Teleport_Node(X,Y,Z);
			}
			else
			{
				G2G = 0;
			}
		}
		fclose(TP);
	}
}

void JMG_RP2_Load_Random_Teleport_File::Add_Teleport_Node(float X,float Y,float Z)
{
	if (!RP2RandomTeleportPositionNode)
	{
		RP2RandomTeleportPositionNode = new RP2RandomTeleportPositionControl;
		RP2RandomTeleportPositionNode->Telepos.X = X;
		RP2RandomTeleportPositionNode->Telepos.Y = Y;
		RP2RandomTeleportPositionNode->Telepos.Z = Z;
		RP2RandomTeleportPositionNode->SpotNumber = 1;
		TELEPORTMAXRANDCHOICE = RP2RandomTeleportPositionNode->SpotNumber;
		RP2RandomTeleportPositionNode->next = NULL;
	}
	else
	{
		int end = 0;
		RP2RandomTeleportPositionControl *Current = RP2RandomTeleportPositionNode;
		while (Current != NULL && end == 0)
		{
			int Number = Current->SpotNumber;
			if (Current->next == NULL)
			{
				Current->next = new RP2RandomTeleportPositionControl;
				Current = Current->next;
				Current->Telepos.X = X;
				Current->Telepos.Y = Y;
				Current->Telepos.Z = Z;
				Current->SpotNumber = (Number + 1);
				TELEPORTMAXRANDCHOICE = Current->SpotNumber;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Damage::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Commands->Is_A_Star(damager))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(damager)])
		{
			Commands->Send_Custom_Event(damager,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0);
		}
	}
}

void JMG_RP2_Phone_Banking_System::Created(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		BankCredits[x] = 0;
		DepositWithdraw[x] = 0;
		PlayerAccount[x] = NULL;
	}
	sprintf(PhoneNumberMessage,"null");
	char TempNumber[256];
	const char *PhoneNumber = Get_Parameter("Phone_Number");
	sprintf(TempNumber,"");
	int x = 0,x2 = 0;
	int length = strlen(PhoneNumber);
	while (x2 < length)
	{
		if (x == 3)
		{
			TempNumber[x] = '-';
			x++;
		}
		TempNumber[x] = PhoneNumber[x2];
		x++;
		x2++;
	}
	TempNumber[(length+1)] = '\0';
	sprintf(PhoneNumberMessage,"%s - Transfer your credits between checking and savings",TempNumber);
}

void JMG_RP2_Phone_Banking_System::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	int PlayerID = 0;
	if (Commands->Is_A_Star(sender))
	{
		PlayerID = Get_Player_ID(sender);
	}
	if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0;
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							sprintf(Current->PhoneNumber,"%s - %s",Current->PhoneNumber,PhoneNumberMessage);
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && param == 2)
	{
		Send_Message_Player(sender,127,255,0,PhoneNumberMessage);
	}
	if (message == PHONECallStartCustom && param == 0)
	{				
		if (PhoneNumbers)
		{
			int end = 0;
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							if (Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")) < 128)
							{
								GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
								GLOBALPHONETIMES[PlayerID] = 0;
								Commands->Send_Custom_Event(sender,obj,Get_Int_Parameter("Script_ID"),Get_Player_ID(sender),(Get_Float_Parameter("Pickup_Delay")+Commands->Get_Random(0.0f,Get_Float_Parameter("Max_Random_Pickup_Delay"))));
							}
							else
							{
								for (int x = 1;x < 128;x++)
								{
									if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
									{
										GameObject *Player = Get_GameObj(x);
										if (!Player)
										{
											GLOBALPHONELINES[x] = 0;
											GLOBALPHONETIMES[x] = 0;
										}
										Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
									}
								}
								Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
							}
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == Get_Int_Parameter("Script_ID"))
	{
		Account_Node(sender);
		DepositWithdraw[PlayerID] = 0;
		char confmes[2000];
		// Maximum string length of 237 discovered on 2/6/10 after the disconnects noticed on 2/5/10 during multiplayer tests
		const char *str = Get_Player_Name(sender);
		sprintf(confmes,"Hello %s and thank-you for calling the automated account management system. Our database shows you currently have %.0f credit(s) in your savings account.",str,PlayerAccount[PlayerID]->AccountBalance);
		delete[] str;
		Send_Message_Player(sender,127,255,0,confmes);
		sprintf(confmes,"Will you be depositing or withdrawing from your account today? ([1]Deposit [2]Withdraw)");
		Send_Message_Player(sender,127,255,0,confmes);
		Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2EntryNoDiscard,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2 (6 means special case so it doesn't discard the specialnumber).
	}
	if (message == PHONECallStartCustom && param == Get_Int_Parameter("Script_ID"))
	{
		BankCredits[PlayerID] = 0;
		int end = 0;
		if (PhoneNumbers)
		{
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					BankCredits[PlayerID] = (float)atoi(Current->PhonePound);
					end = 1;
				}
				Current = Current->next;
			}
		}
		if (BankCredits[PlayerID] > 0)
		{
			char confmes[2000];
			if (DepositWithdraw[PlayerID] == 1){sprintf(confmes,"Are you sure you would like to deposit %.0f credit(s) into your savings account? ([1]yes [2]no)",BankCredits[PlayerID]);}
			if (DepositWithdraw[PlayerID] == -1){sprintf(confmes,"Are you sure you would like to withdraw %.0f credit(s) into your checking account? ([1]yes [2]no)",BankCredits[PlayerID]);}
			Send_Message_Player(sender,127,255,0,confmes);
			Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
		}
		else
		{
			char confmes[2000];
			sprintf(confmes,"Ah, of course you'd like to move 0 credits... there done! Thank you, and please feel free to actually do something later!");
			Send_Message_Player(sender,127,255,0,confmes);
			AutoCancelCall(obj,sender);
		}
	}
	if (message == PHONENumberEndCallMessage && param == Get_Int_Parameter("Script_ID"))// Triggers on client hangup
	{
		if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
		{
			
			GLOBALPHONELINES[PlayerID] = 0;
			GLOBALPHONETIMES[PlayerID] = 0;
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
		}
	}
	if (message == PHONESpecial1Key && param == Get_Int_Parameter("Script_ID"))
	{
		if (!DepositWithdraw[PlayerID])
		{
			DepositWithdraw[PlayerID] = 1;
			char message2player[2000];
			const char *str = Get_Player_Name(sender);
			sprintf(message2player,"Okay then, please enter the amount of credit(s) you would like to deposit and press pound now.");
			delete[] str;
			Send_Message_Player(sender,127,255,0,message2player);
			Commands->Send_Custom_Event(obj,sender,PHONENumberRequiresAdditionalNumberAndPound,Get_Int_Parameter("Script_ID"),0);// make it await pound
		}
		else
		{
			if (DepositWithdraw[PlayerID] == 1)//Deposit
			{
				if (Commands->Get_Money(sender) >= BankCredits[PlayerID])
				{
					PlayerAccount[PlayerID]->AccountBalance += BankCredits[PlayerID];
					Commands->Give_Money(sender,-BankCredits[PlayerID],1);
					char confmes[2000];
					sprintf(confmes,"Thank you, deposit successful! You now have %.0f credits(s) in your savings account!",PlayerAccount[PlayerID]->AccountBalance);
					Send_Message_Player(sender,127,255,0,confmes);
					PlayerAccount[PlayerID]->InterestRate = InterestRate(sender);
					Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);// Hang up
				}
				else
				{
					char message2player[2000];
					const char *str = Get_Player_Name(sender);
					sprintf(message2player,"I'm sorry %s, money doesn't grow on trees, come back when you're a bit.... richer.",str);
					delete[] str;
					Send_Message_Player(sender,127,255,0,message2player);
					Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);// Hang up
				}
			}
			else
			{
				if (PlayerAccount[PlayerID]->AccountBalance >= BankCredits[PlayerID])
				{
					PlayerAccount[PlayerID]->AccountBalance -= BankCredits[PlayerID];
					Commands->Give_Money(sender,BankCredits[PlayerID],1);
					char confmes[2000];
					sprintf(confmes,"Thank you, your withdraw was successful! You now have %.0f credits(s) in your savings account!",PlayerAccount[PlayerID]->AccountBalance);
					Send_Message_Player(sender,127,255,0,confmes);
					Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);// Hang up
				}
				else
				{
					char message2player[2000];
					const char *str = Get_Player_Name(sender);
					sprintf(message2player,"I'm sorry %s, you currently don't have enough in your savings account to cover that!",str);
					delete[] str;
					Send_Message_Player(sender,127,255,0,message2player);
					Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);// Hang up
				}
			}
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
		}
	}
	if (message == PHONESpecial2Key && param == Get_Int_Parameter("Script_ID"))
	{
		if (!DepositWithdraw[PlayerID])
		{
			DepositWithdraw[PlayerID] = -1;
			char message2player[2000];
			const char *str = Get_Player_Name(sender);
			sprintf(message2player,"Okay then, please enter the amount of credit(s) you would like to withdraw and press pound now.");
			delete[] str;
			Send_Message_Player(sender,127,255,0,message2player);
			Commands->Send_Custom_Event(obj,sender,PHONENumberRequiresAdditionalNumberAndPound,Get_Int_Parameter("Script_ID"),0);// make it await pound
		}
		else
		{
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
		}
	}
	if (message == PHONENumberCallTimeMonitor && param == Get_Int_Parameter("Script_ID"))
	{
		ChargeForCall(obj);
	}
}

void JMG_RP2_Phone_Banking_System::AutoCancelCall(GameObject *obj,GameObject *player)
{
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}

void JMG_RP2_Phone_Banking_System::Account_Node(GameObject *obj)
{
	int PlayerID = Get_Player_ID(obj);
	char PlayerName[256];
	const char *str = Get_Player_Name(obj);
	sprintf(PlayerName,"%s",str);
	delete[] str;
	if (!RP2PlayerBankAccountNode)
	{
		RP2PlayerBankAccountNode = new RP2PlayerBankAccountControl;
		sprintf(RP2PlayerBankAccountNode->PlayerName,"%s",PlayerName);
		RP2PlayerBankAccountNode->AccountBalance = 0;
		RP2PlayerBankAccountNode->InterestRate = 0;
		PlayerAccount[PlayerID] = RP2PlayerBankAccountNode;
		RP2PlayerBankAccountNode->next = NULL;
	}
	else
	{
		int end = 0;
		RP2PlayerBankAccountControl *Current = RP2PlayerBankAccountNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(PlayerName,Current->PlayerName))
			{
				end = 1;
				PlayerAccount[PlayerID] = Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new RP2PlayerBankAccountControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				Current->AccountBalance = 0;
				Current->InterestRate = 0;
				PlayerAccount[PlayerID] = Current;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Phone_Banking_System::ChargeForCall(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
		{
			GameObject *Player = Get_GameObj(x);
			int CallTime = GLOBALPHONETIMES[x]++;
			if (Commands->Get_Health(Player) > 0)
			{
				int chargepersec = Get_Int_Parameter("Charge_Per_Second");
				if (Get_Int_Parameter("Max_Call_Duration") < CallTime)
				{
					AutoCancelCall(obj,Player);
				}
				else if (CallTime % 60 == 0)
				{
					int totalcharge = (chargepersec + Get_Int_Parameter("Charge_Per_Minute"));
					if (Commands->Get_Money(Player) >= totalcharge)
					{
						Commands->Give_Money(Player,-(float)totalcharge,1);
					}
					else
					{
						Send_Message_Player(Player,127,255,0,"Signal Lost");
						AutoCancelCall(obj,Player);
					}
				}
				else if (Commands->Get_Money(Player) >= chargepersec)
				{
					Commands->Give_Money(Player,-(float)chargepersec,1);
				}
				else
				{
					Send_Message_Player(Player,127,255,0,"Signal Lost");
					AutoCancelCall(obj,Player);
				}
			}
			else
			{
				Commands->Send_Custom_Event(Player,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
			}
			Commands->Send_Custom_Event(Player,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);
		}
	}
}

float JMG_RP2_Phone_Banking_System::InterestRate(GameObject *obj)
{
	int PlayerID = Get_Player_ID(obj);
	Vector3 Pos = Commands->Get_Position(obj);
	GameObject *ATM = Find_Closest_Preset_By_Team(2,Pos,RP2MAINMAPATMPRESET);
	if (ATM && obj)
	{
		float Distance = Commands->Get_Distance(Pos,Commands->Get_Position(ATM));
		if (Distance < 200 && Distance > 10)
		{
			float Rate = (1-Distance/200)*MAXINTRESTRATE;
			if (PlayerAccount[PlayerID]->InterestRate > Rate)
			{
				Rate = (Rate+PlayerAccount[PlayerID]->InterestRate)/2;
			}
			char message2player[2000];
			sprintf(message2player,"You are now generating %.3f%c interest on your money. (You stop gaining interest at $500,000).",(Rate*100),'%');
			Send_Message_Player(obj,127,255,0,message2player);
			return Rate;
		}
		else if (Distance <= 10)
		{
			char message2player[2000];
			sprintf(message2player,"You are now generating %.3f%c interest on your money. (You stop gaining interest at $500,000).",MAXINTRESTRATE*100,'%');
			Send_Message_Player(obj,127,255,0,message2player);
			return MAXINTRESTRATE;
		}
		else
		{
			if (PlayerAccount[PlayerID]->InterestRate)
			{
				float Rate = PlayerAccount[PlayerID]->InterestRate/2;
				char message2player[2000];
				sprintf(message2player,"You are now generating %.3f%c interest on your money. (You stop gaining interest at $500,000).",(Rate*100),'%');
				Send_Message_Player(obj,127,255,0,message2player);
				return Rate;
			}
			Send_Message_Player(obj,127,255,0,"You are now generating no interest on your money.");
			return 0;
		}
	}
	else
	{
		Send_Message_Player(obj,127,255,0,"You are now generating no interest on your money.");
		return 0;
	}
}

void JMG_RP2_Load_Player_Bank_Accounts::Created(GameObject *obj)
{
	FILE *FileBankAccounts;
	int BadRead = 0,Number = 1,Total = 0;
	FileBankAccounts = fopen("Data/RolePlay2/BetaPlayerBankAccounts.RP2","r");
	if (FileBankAccounts)
	{
		char FirstLine[200];
		sprintf(FirstLine,"");
		fread(FirstLine,200,1,FileBankAccounts);
		if (strlen(FirstLine) > 1)
		{
			rewind(FileBankAccounts);
			while (!feof(FileBankAccounts))
			{
				char PlayerName[256],Safty = '0',Safty1 = '0',Safty2 = '0';
				if (BadRead != 2)
				{
					fscanf(FileBankAccounts,"%c%c%c\n",&Safty,&Safty1,&Safty2);
				}
				if ((Safty == '[' && Safty1 == '*' && Safty2 == ']') || BadRead == 2)
				{
					BadRead = 0;
					char TempPName[256];
					fread(TempPName,256,1,FileBankAccounts);
					int loops = strlen(TempPName),x = 0;
					while (x < loops)
					{
						if (TempPName[x] != '\n')
						{
							PlayerName[x] = TempPName[x];
						}
						else
						{
							PlayerName[x] = '\0';
						}
						x++;
					}
					int Security1,Security2,Security3,AccountAmount,Security4,SNumber;
					fscanf(FileBankAccounts,"%d %d %d %d %d %d",&Security1,&Security2,&Security3,&AccountAmount,&Security4,&SNumber);
					Total += AccountAmount;
					Number++;
					if (((Total/Number)+SNumber) == Security1 && ((Total*SNumber)+Number) == Security2 && Security3 == (((Total/(Number+1))*Number)+(SNumber*Number)) && Security4 == ((AccountAmount/SNumber)+(SNumber*Number)))
					{
						Account_Node(PlayerName,(float)AccountAmount);
					}
					fscanf(FileBankAccounts,"\n");
				}
				else
				{
					Console_Input("MESSAGE BAD LINE READ IN \"PlayerBankAccounts.RP2\"");	
					char TempPName[2000];
					fread(TempPName,2000,1,FileBankAccounts);
					while (!(TempPName[0] == '[' && TempPName[1] == '*' && TempPName[2] == ']') && !feof(FileBankAccounts))
					{
						fread(TempPName,2000,1,FileBankAccounts);
					}
					BadRead = 2;
				}
			}
		}
		fclose(FileBankAccounts);
	}
	else
	{
		Console_Input("MESSAGE Warning: Player Bank Account File not found! File will be automatically created...");
		FILE *hfile;
		hfile = fopen("Data/RolePlay2/BetaPlayerBankAccounts.RP2","w");
		fprintf(hfile,"");
		fflush(hfile);
		fclose(hfile);
	}
}

void JMG_RP2_Load_Player_Bank_Accounts::Account_Node(char PlayerName[],float Amount)
{
	if (!RP2PlayerBankAccountNode)
	{
		RP2PlayerBankAccountNode = new RP2PlayerBankAccountControl;
		sprintf(RP2PlayerBankAccountNode->PlayerName,"%s",PlayerName);
		RP2PlayerBankAccountNode->AccountBalance = Amount;
		RP2PlayerBankAccountNode->InterestRate = 0.0f;
		RP2PlayerBankAccountNode->next = NULL;
	}
	else
	{
		int end = 0;
		RP2PlayerBankAccountControl *Current = RP2PlayerBankAccountNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(PlayerName,Current->PlayerName))
			{
				Current->AccountBalance = Amount;
				end = 1;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new RP2PlayerBankAccountControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				Current->AccountBalance = Amount;
				Current->InterestRate = 0.0f;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Interest_Calculator::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,INTRESTDELAY,987456);
}

void JMG_RP2_Interest_Calculator::Timer_Expired(GameObject *obj,int number)
{
	if (987456 == number)
	{
		if (RP2PlayerBankAccountNode)
		{
			RP2PlayerBankAccountControl *Current = RP2PlayerBankAccountNode;
			while (Current != NULL)
			{
				float CurrentAmount = Current->AccountBalance,Interest = Current->InterestRate;
				if (CurrentAmount < 500000 && Interest)
				{
					float Gain = (CurrentAmount * Interest);
					CurrentAmount = (Current->AccountBalance += (CurrentAmount * Interest));
					if (CurrentAmount > 500000)
					{
						Current->AccountBalance = 500000.0f;
					}
					GameObject *Player = Get_GameObj_By_Player_Name(Current->PlayerName);
					if (Player)
					{
						char mes[200];
						sprintf(mes,"%s: You have gained $%.2f in your savings account due to your %.3f%c interest! Your account now has a balance of %.2f.",Current->PlayerName,Gain,100*Interest,'%',CurrentAmount);
						Send_Message_Player(Player,0,150,0,mes);
					}
				}
				Current = Current->next;
			}
		}
		Commands->Start_Timer(obj,this,INTRESTDELAY,987456);
	}
}

void JMG_RP2_Phone_Transfer_Funds::Created(GameObject *obj)
{
	CallerNode = NULL;
	sprintf(PhoneNumberMessage,"null");
	char TempNumber[256];
	const char *PhoneNumber = Get_Parameter("Phone_Number");
	sprintf(TempNumber,"");
	int x = 0,x2 = 0;
	int length = Get_Int_Parameter("Number_Of_Digits")+1;
	while (x2 < length)
	{
		if (x == 3)
		{
			TempNumber[x] = '-';
			x++;
		}
		TempNumber[x] = PhoneNumber[x2];
		x++;
		x2++;
	}
	TempNumber[length] = '\0';
	sprintf(PhoneNumberMessage,"%s - Transfer credits to another person",TempNumber);
}

void JMG_RP2_Phone_Transfer_Funds::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							sprintf(Current->PhoneNumber,"%s - %s",Current->PhoneNumber,PhoneNumberMessage);
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && param == 2)
	{
		Send_Message_Player(sender,127,255,0,PhoneNumberMessage);
	}
	if (message == PHONECallStartCustom && param == 0 && PhoneNumbers)
	{
		int end = 0;
		int PlayerID = Get_Player_ID(sender);
		PhoneNumberControl *Current = PhoneNumbers;
		while (Current != NULL && end == 0)
		{
			if (PlayerID == Current->PlayerID)// match
			{
				if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
				{
					if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
					{
						end = 1;
						if (!Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")))
						{
							CallerNode = Current;
							GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
							GLOBALPHONETIMES[PlayerID] = 0;
							Commands->Send_Custom_Event(sender,obj,Get_Int_Parameter("Script_ID"),Get_Player_ID(sender),(Get_Float_Parameter("Pickup_Delay")+Commands->Get_Random(0.0f,Get_Float_Parameter("Max_Random_Pickup_Delay"))));
						}
						else
						{
							for (int x = 1;x < 128;x++)
							{
								if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
								{
									GameObject *Player = Get_GameObj(x);
									Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
								}
							}
							Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
						}
					}
				}
			}
			Current = Current->next;
		}
	}
	if (message == Get_Int_Parameter("Script_ID"))
	{
		TargetID = 0;
		CheckingSavings = 0;
		GameObject *player = Get_GameObj(param);
		char mes[200];
		const char *str = Get_Player_Name(sender);
		sprintf(mes,"Hello %s, please choose which account you would like to transfer your money from now: ([1]checking [2]savings)",str);
		delete[] str;
		Send_Message_Player(player,127,255,0,mes);
		Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2EntryNoDiscard,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2 (6 means special case so it doesn't discard the specialnumber).
		Commands->Send_Custom_Event(obj,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);// Start Timer
	}
	if (message == PHONESpecial1Key && param == Get_Int_Parameter("Script_ID"))// 1 key pressed by player
	{
		if (!CheckingSavings)
		{
			Credits = 0;
			CheckingSavings = 1;
			char message2player[2000];
			sprintf(message2player,"Now please enter the amount you would like to transfer from your checking account and press pound.");
			Send_Message_Player(sender,127,255,0,message2player);
			Commands->Send_Custom_Event(obj,sender,PHONENumberRequiresAdditionalNumberAndPound,Get_Int_Parameter("Script_ID"),0);// make it await pound
		}
		else if (TargetID)//Preform Transfer
		{
			if (CheckingSavings == 1)//Checking
			{
				if (Commands->Get_Money(sender) >= Credits)
				{
					Commands->Give_Money(Get_GameObj(TargetID),Credits,1);
					Commands->Give_Money(sender,-Credits,1);
					char message2player[2000];
					const char *str = Get_Player_Name(Get_GameObj(TargetID));
					sprintf(message2player,"Transfer successful, %s has received your money. Have a nice day!",str);
					delete[] str;
					Send_Message_Player(sender,127,255,0,message2player);
				}
			}
			else// Savings
			{
				if (PlayerAccount->AccountBalance >= Credits)
				{
					Commands->Give_Money(Get_GameObj(TargetID),Credits,1);
					PlayerAccount->AccountBalance -= Credits;
					GameObject *TargetPlayer = Get_GameObj(TargetID);
					char message2player[2000];
					const char *str = Get_Player_Name(TargetPlayer);
					sprintf(message2player,"Transfer successful, %s has received your money. Have a nice day! (You now have:%.0f in your savings)",str,PlayerAccount->AccountBalance);
					delete[] str;
					Send_Message_Player(sender,127,255,0,message2player);
					const char *str2 = Get_Player_Name(sender);
					sprintf(message2player,"%s has transfered $%.0f into your checking account.",str2,Credits);
					delete[] str2;
					Send_Message_Player(TargetPlayer,127,255,0,message2player);
				}
			}
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
		}
	}
	if (message == PHONESpecial2Key && param == Get_Int_Parameter("Script_ID"))// 2 Key pressed by player
	{
		if (!CheckingSavings)// Set mode to savings account
		{
			Credits = 0;
			CheckingSavings = 2;
			Account_Node(sender);
			char message2player[2000];
			sprintf(message2player,"Please enter the amount you would like to transfer from your savings account and press pound. (You currently have:%.0f in your savings)",PlayerAccount->AccountBalance);
			Send_Message_Player(sender,127,255,0,message2player);
			Commands->Send_Custom_Event(obj,sender,PHONENumberRequiresAdditionalNumberAndPound,Get_Int_Parameter("Script_ID"),0);// make it await pound
		}
		else// Cancel
		{
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// cancel
		}
	}
	if (message == PHONECallStartCustom && param == Get_Int_Parameter("Script_ID") && Credits == 0)// Break down amount of credits
	{
		Credits = 0;
		if (CallerNode)
		{
			Credits = (float)atoi(CallerNode->PhonePound);
		}
		if (Credits > 0)
		{
			char confmes[2000];
			sprintf(confmes,"Next, please enter the phone number of the person you would like to transfer %.0f too, and then press pound.",Credits);
			Send_Message_Player(sender,127,255,0,confmes);
			Commands->Send_Custom_Event(obj,sender,PHONENumberRequiresAdditionalNumberAndPound,Get_Int_Parameter("Script_ID"),0);// make it await pound
		}
		else
		{
			char confmes[2000];
			sprintf(confmes,"Ah, of course you'd like to move 0 credits... there done! Thank you, and please feel free to actually do something later!");
			Send_Message_Player(sender,127,255,0,confmes);
			AutoCancelCall(obj,sender);
		}
	}
	else if (message == PHONECallStartCustom && param == Get_Int_Parameter("Script_ID") && Credits != 0)
	{
		int end = 0;
		CellPhoneNumberControl *Current = CellPhoneNumberNode;
		while (Current != NULL && end == 0)
		{
			if (CallerNode->PhonePoundLength == Current->NumberLength)
			{
				if (!_stricmp(CallerNode->PhonePound,Current->MyPhoneNumber))
				{
					end = 1;
					GameObject *Player = Get_GameObj(Current->PlayerID);
					if (Get_Player_ID(sender) == Current->PlayerID)
					{
						Send_Message_Player(sender,127,255,0,"I'm sorry but you can't transfer money between accounts using this number, please use the other number.");
						AutoCancelCall(obj,sender);
					}
					else if (Commands->Get_Health(Player) > 0.0f)
					{
						TargetID = Current->PlayerID;
						char confmes[2000];
						if (CheckingSavings == 1)
						{
							const char *str = Get_Player_Name(Get_GameObj(TargetID));
							sprintf(confmes,"Are you sure you would like to transfer %.0f credit(s) from your checking account to %s? ([1]yes [2]no)",Credits,str);
							delete[] str;
						}
						if (CheckingSavings == 2)
						{
							const char *str = Get_Player_Name(Get_GameObj(TargetID));
							sprintf(confmes,"Are you sure you would like to transfer %.0f credit(s) from your savings account to %s? ([1]yes [2]no)",Credits,str);
							delete[] str;
						}
						Send_Message_Player(sender,127,255,0,confmes);
						Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
						Commands->Send_Custom_Event(obj,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);// Start Timer
					}
					else
					{
						Send_Message_Player(sender,127,255,0,"Sorry, we were unable to reach that person at this time, please try again later.");
						AutoCancelCall(obj,sender);
					}
					if (CallerNode)
					{
						CallerNode->PhoneNumberLength = 3;
						sprintf(CallerNode->PhoneNumber,"null");
					}
					CallerNode = NULL;
				}
			}
			Current = Current->next;
		}
		if (end == 0)
		{
			Send_Message_Player(sender,127,255,0,"Sorry, we were unable to find that person in our records, have a nice day!");
			AutoCancelCall(obj,sender);
		}
	}
	if (message == PHONENumberEndCallMessage && param == Get_Int_Parameter("Script_ID"))// Triggers on Client Hangup
	{
		CallerNode = NULL;
		int PlayerID = Get_Player_ID(sender);
		if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
		{
			GLOBALPHONELINES[PlayerID] = 0;
			GLOBALPHONETIMES[PlayerID] = 0;
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
		}
	}
	if (message == PHONENumberCallTimeMonitor && param == Get_Int_Parameter("Script_ID"))
	{
		ChargeForCall(obj);
	}
}

void JMG_RP2_Phone_Transfer_Funds::AutoCancelCall(GameObject *obj,GameObject *player)
{
	Credits = 0;
	if (CallerNode)
	{
		CallerNode->PhoneNumberLength = 3;
		sprintf(CallerNode->PhoneNumber,"null");
	}
	CallerNode = NULL;
	CheckingSavings = 0;
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}

void JMG_RP2_Phone_Transfer_Funds::Account_Node(GameObject *obj)
{
	char PlayerName[256];
	const char *str = Get_Player_Name(obj);
	sprintf(PlayerName,"%s",str);
	delete[] str;
	if (!RP2PlayerBankAccountNode)
	{
		RP2PlayerBankAccountNode = new RP2PlayerBankAccountControl;
		sprintf(RP2PlayerBankAccountNode->PlayerName,"%s",PlayerName);
		RP2PlayerBankAccountNode->AccountBalance = 0;
		PlayerAccount = RP2PlayerBankAccountNode;
		RP2PlayerBankAccountNode->next = NULL;
	}
	else
	{
		int end = 0;
		RP2PlayerBankAccountControl *Current = RP2PlayerBankAccountNode;
		while (Current != NULL && end == 0)
		{
			if (!_stricmp(PlayerName,Current->PlayerName))
			{
				end = 1;
				PlayerAccount = Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new RP2PlayerBankAccountControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				Current->AccountBalance = 0;
				PlayerAccount = Current;
				Current->next = NULL;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Phone_Transfer_Funds::ChargeForCall(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
		{
			GameObject *Player = Get_GameObj(x);
			int CallTime = GLOBALPHONETIMES[x]++;
			if (Commands->Get_Health(Player) > 0)
			{
				int chargepersec = Get_Int_Parameter("Charge_Per_Second");
				if (Get_Int_Parameter("Max_Call_Duration") < CallTime)
				{
					AutoCancelCall(obj,Player);
				}
				else if (CallTime % 60 == 0)
				{
					int totalcharge = (chargepersec + Get_Int_Parameter("Charge_Per_Minute"));
					if (Commands->Get_Money(Player) >= totalcharge)
					{
						Commands->Give_Money(Player,-(float)totalcharge,1);
					}
					else
					{
						Send_Message_Player(Player,127,255,0,"Signal Lost");
						AutoCancelCall(obj,Player);
					}
				}
				else if (Commands->Get_Money(Player) >= chargepersec)
				{
					Commands->Give_Money(Player,-(float)chargepersec,1);
				}
				else
				{
					Send_Message_Player(Player,127,255,0,"Signal Lost");
					AutoCancelCall(obj,Player);
				}
			}
			else
			{
				Commands->Send_Custom_Event(Player,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
			}
			Commands->Send_Custom_Event(Player,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);
		}
	}
}

void JMG_RP2_SCUD_Launcher_Targeting_System::Created(GameObject *obj)
{
	Set_Vehicle_Is_Visible(obj,false);
	GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
	if (SCUDLauncher)// Get into Targeting system
	{
		SCUDLauncherLocation = Commands->Get_Position(SCUDLauncher);
		Set_Max_Health(obj,Commands->Get_Max_Health(SCUDLauncher));
		Set_Max_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(SCUDLauncher));
		GameObject *Player = Get_Vehicle_Driver(SCUDLauncher);
		if (Player)
		{
			PlayerID = Commands->Get_ID(Player);
			Soldier_Transition_Vehicle(Player);
			Vector3 pos = Commands->Get_Position(obj);
			pos.Z -= 0.5f;
			Commands->Set_Position(Player,pos);
			Soldier_Transition_Vehicle(Player);
			if (!Get_Vehicle(Player))
			{
				Soldier_Transition_Vehicle(Player);
			}
		}
		Commands->Enable_Vehicle_Transitions(SCUDLauncher,false);
	}
	TransitionsEnabled = true;
	Commands->Start_Timer(obj,this,0.1f,987452);	
	Commands->Start_Timer(obj,this,0.1f,987453);	
}

void JMG_RP2_SCUD_Launcher_Targeting_System::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7154148)
	{
		Send_Message_Player(sender,200,200,125,"Vehicle Special Key:");
		Send_Message_Player(sender,200,200,125,"B - Deploy/Undeploy");
	}
	if (message == 91191150)// Launcher Killed
	{
		ReturnToSL(obj);
	}
	if (message == 91191151)// Launcher Undeployed
	{
		ReturnToSL(obj);
	}
	if (message == 98562145 || message == 98562146)// Click Mouse
	{
		GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
		if (SCUDLauncher)// Get into Targeting system
		{
			Commands->Send_Custom_Event(sender,SCUDLauncher,91151191,1,0);
		}
	}
	if (message == 7745472 || message == 75432167)// Undeploy/deploy
	{
		GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
		if (SCUDLauncher)// Get into Targeting system
		{
			Commands->Send_Custom_Event(sender,SCUDLauncher,7745472,1,0);
		}
		else
		{
			ReturnToSL(obj);
		}
	}
	if (message == 7745473)
	{
		if (!obj)
		{
			return;
		}
		Vector3 TargetPos = Commands->Get_Position(obj);
		TargetPos.Z = 0;
		for (int x = 1;x < 128;x++)
		{
			GameObject *Player = Get_GameObj(x);
			if (Player)
			{
				Vector3 PlayerPos = Commands->Get_Position(Player);
				PlayerPos.Z = 0;
				if (Commands->Get_Distance(PlayerPos,TargetPos) < 100)
				{
					Create_Sound_Player(Player,"AirRaidSiren",Commands->Get_Position(Player),obj);
				}
			}
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		Commands->Set_Is_Visible(sender,false);
	}
}

void JMG_RP2_SCUD_Launcher_Targeting_System::Timer_Expired(GameObject *obj, int number)
{	
	if (number == 987453)
	{
		if (Is_Script_Attached(obj,"JMG_RP2_Object_Send_Text_Message_On_Death"))
		{
			Remove_Script(obj,"JMG_RP2_Object_Send_Text_Message_On_Death");
		}
	}
	if (number == 987452)
	{
		GameObject *Player = Commands->Find_Object(PlayerID);
		if (!Get_Vehicle(Player))
		{
			Soldier_Transition_Vehicle(Player);
		}
		if (Get_Vehicle_Occupant_Count(obj) == 1 && TransitionsEnabled)
		{
			TransitionsEnabled = false;
			Commands->Enable_Vehicle_Transitions(obj,false);
			Vector3 Pos = Commands->Get_Position(obj);
			Pos.Z += 7;
			Commands->Set_Position(obj,Pos);
		}
		if (Get_Vehicle_Occupant_Count(obj) == 0 && !TransitionsEnabled)
		{
			TransitionsEnabled = true;
			GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
			if (SCUDLauncher)// Get into Targeting system
			{
				Commands->Enable_Vehicle_Transitions(SCUDLauncher,true);
				Commands->Send_Custom_Event(obj,SCUDLauncher,91191153,1,0);
			}
			Commands->Destroy_Object(obj);
		}
		if (Commands->Get_Position(obj).Z < -22.0)
		{
			ReturnToSL(obj);
		}
		GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
		if (SCUDLauncher)
		{
			if (Get_Current_Bullets(SCUDLauncher) == 0)
			{
				Set_Current_Clip_Bullets(obj,0);
				Set_Current_Bullets(obj,0);
			}
			else
			{
				Set_Current_Clip_Bullets(obj,Get_Current_Bullets(SCUDLauncher));
				Set_Current_Bullets(obj,Get_Current_Clip_Bullets(SCUDLauncher));
			}
			float Health = Commands->Get_Health(SCUDLauncher);
			if (Health)
			{
				Commands->Set_Health(obj,Commands->Get_Health(SCUDLauncher));
				Commands->Set_Shield_Strength(obj,Commands->Get_Shield_Strength(SCUDLauncher));
			}
		}
		Commands->Start_Timer(obj,this,0.1f,987452);	
	}
}

void JMG_RP2_SCUD_Launcher_Targeting_System::Killed(GameObject *obj, GameObject *damager)
{
	if (damager != obj)
	{
		GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
		if (SCUDLauncher)// Get into Targeting system
		{
			GameObject *Player = Commands->Find_Object(PlayerID);
			Commands->Send_Custom_Event(Player,SCUDLauncher,91191153,1,0);
		}
		else
		{
			ReturnToSL(obj);
		}
	}
	GameObject *Player = Commands->Find_Object(PlayerID);
	if (Player)
	{
		Commands->Set_Is_Visible(Player,true);
	}
}

void JMG_RP2_SCUD_Launcher_Targeting_System::ReturnToSL(GameObject *obj)
{
	GameObject *Player = Get_Vehicle_Driver(obj);
	if (Player)
	{
		Commands->Set_Is_Visible(Player,true);
		Commands->Enable_Vehicle_Transitions(obj,true);
		GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
		Commands->Set_Position(obj,SCUDLauncherLocation);
		if (SCUDLauncher)
		{
			Commands->Enable_Vehicle_Transitions(SCUDLauncher,true);
		}
		Soldier_Transition_Vehicle(Player);
		if (Is_Script_Attached(obj,"JMG_RP2_SCUD_Launcher_Targeting_System_Camera_Facing"))
		{
			Remove_Script(obj,"JMG_RP2_SCUD_Launcher_Targeting_System_Camera_Facing");
		}
		Commands->Apply_Damage(obj,9999.99f,"BlamoKiller",obj);
	}
}

void JMG_RP2_SCUD_Launcher_SCUD_Missile_Up::Created(GameObject *obj)
{
	// Missile engine Sound
	GameObject *ScudSound = Commands->Create_Object("Daves Arrow NT",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(ScudSound,obj,"Origin");
	Commands->Set_Model(ScudSound,"s_scud_rocket");
	char params[256];
	sprintf(params,"%d",Commands->Get_ID(obj));
	Commands->Attach_Script(ScudSound,"JMG_Move_And_Then_Remove_When_Creator_Removed",params);

	GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
	if (SCUDLauncher)
	{
		SCUDLauncherLocation = Commands->Get_Position(SCUDLauncher);
		Vector3 Position = Commands->Get_Position(obj);
		SCUDLauncherLocation.X = Position.X;
		SCUDLauncherLocation.Y = Position.Y;
	}
	ScudLauncherNode = Find_A_Scud_Launcher_Node(Get_Int_Parameter("LauncherID"));
	if (ScudLauncherNode)
	{
		ScudLauncherNode->ScudID = Commands->Get_ID(obj);
	}
	Commands->Start_Timer(obj,this,0.1f,987452);	
	Commands->Start_Timer(obj,this,1.0f,987453);	
	Commands->Start_Timer(obj,this,3.0f,987453);	
}

void JMG_RP2_SCUD_Launcher_SCUD_Missile_Up::Timer_Expired(GameObject *obj, int number)
{	
	if (number == 987452)
	{
		if (Commands->Get_Distance(SCUDLauncherLocation,Commands->Get_Position(obj)) >= 2000.0f)
		{
			GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
			if (SCUDLauncher)
			{
				Commands->Send_Custom_Event(obj,SCUDLauncher,91151192,1,0);
			}
			Commands->Destroy_Object(obj);
		}
		Commands->Start_Timer(obj,this,0.1f,987452);	
	}
	if (number == 987453)
	{
		FIND_ANTI_MISSILE_SYSTEM(obj);
	}
}

void JMG_RP2_SCUD_Launcher_SCUD_Missile_Up::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *Player = Get_GameObj(Get_Int_Parameter("PlayerID"));
	if (Player)
	{
		if (damager)
		{
			Send_Message_Player(Player,150,0,150,"SCUD was shot down prior to entering orbit!");
		}
		else if (Commands->Get_Distance(SCUDLauncherLocation,Commands->Get_Position(obj)) < 2000.0f)
		{
			Send_Message_Player(Player,150,0,150,"SCUD was destroyed prior to entering orbit!");
		}
		Commands->Create_Explosion("Explosion_NukeBeacon",Commands->Get_Position(obj),Player);
	}
	else
	{
		Commands->Create_Explosion("Explosion_NukeBeacon",Commands->Get_Position(obj),0);
	}
	GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
	if (SCUDLauncher)
	{
		Commands->Send_Custom_Event(obj,SCUDLauncher,91191154,1,0);
	}
	if (ScudLauncherNode)
	{
		ScudLauncherNode->ScudID = 0;
	}
	Commands->Set_Model(obj,"null");
}

void JMG_RP2_SCUD_Launcher_SCUD_Missile_Down::Created(GameObject *obj)
{
	// Missile engine Sound
	GameObject *ScudSound = Commands->Create_Object("Daves Arrow NT",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(ScudSound,obj,"Origin");
	Commands->Set_Model(ScudSound,"s_scud_rocket");
	char params[256];
	sprintf(params,"%d",Commands->Get_ID(obj));
	Commands->Attach_Script(ScudSound,"JMG_Move_And_Then_Remove_When_Creator_Removed",params);
	// Old Stuff
	SendMessage = 1;
	GameObject *TrackingObject = Commands->Find_Object(Get_Int_Parameter("TargetID"));
	if (TrackingObject)
	{
		Commands->Start_Timer(obj,this,0.1f,987452);
	}
	Vector3 Pos = Commands->Get_Position(obj);
	DownStartPos = Pos;
	ScudLauncherNode = Find_A_Scud_Launcher_Node(Get_Int_Parameter("LauncherID"));
	if (ScudLauncherNode)
	{
		ScudLauncherNode->ScudID = Commands->Get_ID(obj);
	}
	FIND_ANTI_MISSILE_SYSTEM(obj);
}

void JMG_RP2_SCUD_Launcher_SCUD_Missile_Down::Timer_Expired(GameObject *obj, int number)
{	
	if (number == 987452)
	{
		GameObject *TrackingObject = Commands->Find_Object(Get_Int_Parameter("TargetID"));
		if (TrackingObject)
		{
			Vector3 Movement = Commands->Get_Position(obj);
			Vector3 Target = Commands->Get_Position(TrackingObject);
			Movement.Z = 0.0f;
			Target.Z = 0.0f;
			float Distance = Commands->Get_Distance(Movement,Target);
			if (Distance > 1.0f)
			{
				if (Distance > 1.25f)
				{
					Distance = 1.25f;
				}
				Target.X -= Movement.X;
				Target.Y -= Movement.Y;
				float TempRotation = atan2(Target.Y,Target.X);
				Vector3 MyPos = Commands->Get_Position(obj);
				MyPos.Y += sin(TempRotation) * Distance;
				MyPos.X += cos(TempRotation) * Distance;
				Commands->Set_Position(obj,MyPos);
			}
			Commands->Start_Timer(obj,this,0.1f,987452);
		}	
	}
}

void JMG_RP2_SCUD_Launcher_SCUD_Missile_Down::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *Player = Get_GameObj(Get_Int_Parameter("PlayerID"));
	GameObject *SCUDLauncher = Commands->Find_Object(Get_Int_Parameter("LauncherID"));
	if (SCUDLauncher)
	{
		if (Commands->Get_Distance(DownStartPos,Commands->Get_Position(obj)) > 1800)
		{
			Commands->Send_Custom_Event(obj,SCUDLauncher,91191154,1,0);
			if (Player)
			{
				if (SendMessage)
				{
					Send_Message_Player(Player,150,0,150,"SCUD detonation detected!");
					SendMessage = 0;
				}
			}
		}
		else
		{
			if (Player)
			{
				if (SendMessage)
				{
					Send_Message_Player(Player,150,0,150,"SCUD was shot down during reentry!");
					SendMessage = 0;
				}
			}
			Commands->Send_Custom_Event(obj,SCUDLauncher,91191154,1,1);
		}
	}
	if (Player)
	{
		Commands->Create_Explosion("Explosion_NukeBeacon",Commands->Get_Position(obj),Player);
	}
	else
	{
		Commands->Create_Explosion("Explosion_NukeBeacon",Commands->Get_Position(obj),0);
	}
	if (ScudLauncherNode)
	{
		ScudLauncherNode->ScudID = 0;
	}
	Commands->Set_Model(obj,"null");
}


void JMG_RP2_SCUD_Launcher_Targeting_System_Camera_Facing::Created(GameObject *obj)
{	
	Vector3 Pos = Commands->Get_Position(obj);
	GameObject *DavesArrow = Commands->Create_Object("Daves Arrow",Pos);
	Commands->Attach_To_Object_Bone(DavesArrow,obj,"Turret");
	Commands->Set_Model(DavesArrow,"null");
	DavesArrowID = Commands->Get_ID(DavesArrow);
	Collide = 0;
	DropSpeed = 0;
	Pos.Z += (SCUDMOVEMENTHEIGHT+1.0f);
	GameObject *HeightCap = Commands->Create_Object("Daves Arrow",Pos);
	Commands->Attach_To_Object_Bone(HeightCap,obj,"HCap");
	Commands->Set_Model(HeightCap,"null");
	UpperBlockerID = Commands->Get_ID(HeightCap);
	LastPos = Commands->Get_Position(obj);
	Commands->Start_Timer(obj,this,0.1f,987452);
}

void JMG_RP2_SCUD_Launcher_Targeting_System_Camera_Facing::Timer_Expired(GameObject *obj, int number)
{	
	if (number == 987452)
	{
		GameObject *DavesArrow = Commands->Find_Object(DavesArrowID);
		if (DavesArrow)
		{
			Commands->Set_Facing(obj,Commands->Get_Facing(DavesArrow));
			Commands->Start_Timer(obj,this,0.1f,987452);
		}
		if (USEGOODSCUDTARGETINGMOVEMENT)
		{
			Vector3 AlignPos = Commands->Get_Bone_Position(obj,"WheelP00E"),OriginPos = Commands->Get_Bone_Position(obj,"Turret");
			float Distance = Commands->Get_Distance(OriginPos,AlignPos);
			if (Distance >= SCUDMOVEMENTHEIGHT && !Collide)
			{
				Collide = 1;
				GameObject *HeightCap = Commands->Find_Object(UpperBlockerID);
				if (HeightCap)
				{
					Commands->Set_Model(HeightCap,"subblock");
				}	
			}
			if (Distance < SCUDMOVEMENTHEIGHT && Collide)
			{
				Collide = 0;
				GameObject *HeightCap = Commands->Find_Object(UpperBlockerID);
				if (HeightCap)
				{
					Commands->Set_Model(HeightCap,"null");
				}	
			}
		}
		else
		{
			Vector3 Pos = Commands->Get_Position(obj);
			if (LastPos.Z >= Pos.Z)
			{
				if (DropSpeed < 0.75)
				{
					DropSpeed += 0.05f;
				}
				Pos.Z -= DropSpeed;
				Commands->Set_Position(obj,Pos);
			}
			else
			{
				DropSpeed = 0;
			}
			LastPos = Pos;
		}
	}
}

void JMG_RP2_SCUD_Launcher_Targeting_System_Camera_Facing::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *DavesArrow = Commands->Find_Object(DavesArrowID);
	if (DavesArrow)
	{
		Commands->Destroy_Object(DavesArrow);
	}	
	GameObject *HeightCap = Commands->Find_Object(UpperBlockerID);
	if (HeightCap)
	{
		Commands->Destroy_Object(HeightCap);
	}	
}

void JMG_RP2_Phone_Message_Player_On_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Phone_Script_ID") && param == Get_Int_Parameter("Text_Number"))
	{
		Send_Message_Player(sender,127,255,0,Get_Parameter("Text"));
	}
}

void JMG_RP2_Phone_Load_Phone_Number_Strings::Created(GameObject *obj)
{
	int CanReadFile = 1;
	int TotalReads = 0;
	int Total = 0;
	FILE *FilePhoneText;
	FilePhoneText = fopen("Data/RolePlay2/PhoneNumberText.RP2","r");
	if (FilePhoneText)
	{
		char FirstLine[200];
		sprintf(FirstLine,"");
		fread(FirstLine,200,1,FilePhoneText);
		if (strlen(FirstLine) < 1)
		{
			CanReadFile = 0;
		}
		else
		{
			rewind (FilePhoneText);
			while (!feof(FilePhoneText))
			{
				int ScriptID,Encryption,Security1,Security2,Security3,Special;
				fscanf(FilePhoneText,"%d %d %d %d %d %d\n",&ScriptID,&Encryption,&Security1,&Security2,&Security3,&Special);
				if (feof(FilePhoneText))
				{
					return;
				}
				TotalReads++;
				if (!Encryption)
				{
					Total += ScriptID;
					RP2PhoneTextControl *Node = DataNode(ScriptID);
					if (Node)
					{
						char Text[2000];
						fread(Text,2000,1,FilePhoneText);
						sprintf(Node->Greeting,"%s",RemoveReturn(Text));

						fread(Text,2000,1,FilePhoneText);
						sprintf(Node->Confirmation,"%s",RemoveReturn(Text));

						fread(Text,2000,1,FilePhoneText);
						sprintf(Node->Goodbye,"%s",RemoveReturn(Text));

						fread(Text,2000,1,FilePhoneText);
						sprintf(Node->Buy,"%s",RemoveReturn(Text));
						
						fread(Text,2000,1,FilePhoneText);
						sprintf(Node->Sorry,"%s",RemoveReturn(Text));
					}
				}
				else
				{
					ScriptID -= Encryption;
					Total += ScriptID;
					Special -= Total;
					if ((Total+Encryption+Special) == Security1 && (((Total+Special) * (ScriptID + 1))/(ScriptID+1)) == Security2 && ((ScriptID+ScriptID)/TotalReads) == Security3)
					{
						RP2PhoneTextControl *Node = DataNode(ScriptID);
						if (Node)
						{
							char Text[2000];
							fread(Text,2000,1,FilePhoneText);
							sprintf(Node->Greeting,"%s",RemoveReturnAndE(Text,Encryption,Special));

							fread(Text,2000,1,FilePhoneText);
							sprintf(Node->Confirmation,"%s",RemoveReturnAndE(Text,Encryption,Special+2));

							fread(Text,2000,1,FilePhoneText);
							sprintf(Node->Goodbye,"%s",RemoveReturnAndE(Text,Encryption,Special+4));

							fread(Text,2000,1,FilePhoneText);
							sprintf(Node->Buy,"%s",RemoveReturnAndE(Text,Encryption,Special+6));
							
							fread(Text,2000,1,FilePhoneText);
							sprintf(Node->Sorry,"%s",RemoveReturnAndE(Text,Encryption,Special+8));
						}
					}
					else
					{
						RP2PhoneTextControl *Node = DataNode(ScriptID);
						if (Node)
						{
							char Text[2000];
							fread(Text,2000,1,FilePhoneText);
							sprintf(Node->Greeting,"null");

							fread(Text,2000,1,FilePhoneText);
							sprintf(Node->Confirmation,"null");

							fread(Text,2000,1,FilePhoneText);
							sprintf(Node->Goodbye,"null");

							fread(Text,2000,1,FilePhoneText);
							sprintf(Node->Buy,"null");
							
							fread(Text,2000,1,FilePhoneText);
							sprintf(Node->Sorry,"null");
						}
					}
				}
			}
		}
		fclose(FilePhoneText);
	}
	else
	{
		Console_Input("MESSAGE ERROR: Phone Text Messages File not found! Phone scripts will not function properly!");
	}
}

RP2PhoneTextControl *JMG_RP2_Phone_Load_Phone_Number_Strings::DataNode(int ScriptID)
{
	if (!RP2PhoneTextNode)
	{
		RP2PhoneTextNode = new RP2PhoneTextControl;
		RP2PhoneTextNode->ScriptID = ScriptID;
		RP2PhoneTextNode->next = NULL;
		return RP2PhoneTextNode;
	}
	else
	{
		int end = 0;
		RP2PhoneTextControl *Current = RP2PhoneTextNode;
		while (Current != NULL && end == 0)
		{
			if (Current->ScriptID == ScriptID)
			{
				end = 1;
				return Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new RP2PhoneTextControl;
				Current = Current->next;
				Current->ScriptID = ScriptID;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

char *JMG_RP2_Phone_Load_Phone_Number_Strings::RemoveReturn(const char *String)
{
	static char FinalString[2000];
	int loops = strlen(String),x = 0;
	while (x < loops)
	{
		if (String[x] != '\n')
		{
			FinalString[x] = String[x];
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
	}
	return FinalString;
}

char *JMG_RP2_Phone_Load_Phone_Number_Strings::RemoveReturnAndE(const char *String,int EncryptionFactor,int Start)
{
	static char FinalString[2000];
	int loops = strlen(String),x = 0;
	int CurrentAdd = Start;
	while (x < loops)
	{
		if (String[x] != '\0' && String[x] != '\n')
		{
			char Temp = (String[x]-(char)CurrentAdd);
			while (Temp < 32)
			{
				Temp += 125;
			}/*
			if (Temp == 126)
			{
				Temp = 92;
			}*/
			FinalString[x] = Temp;
			CurrentAdd++;
			if (CurrentAdd > EncryptionFactor)
			{
				CurrentAdd = 1;
			}
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
	}
	return FinalString;
}

void JMG_RP2_Mission_System_Strings_Loader::Created(GameObject *obj)
{
	int CanReadFile = 1;
	int TotalReads = 0;
	int Total = 0;
	FILE *FileMissionText;
	FileMissionText = fopen("Data/RolePlay2/MissionSystemText.RP2","r");
	if (FileMissionText)
	{
		char FirstLine[200];
		sprintf(FirstLine,"");
		fread(FirstLine,200,1,FileMissionText);
		if (strlen(FirstLine) < 1)
		{
			CanReadFile = 0;
		}
		else
		{
			rewind (FileMissionText);
			while (!feof(FileMissionText))
			{
				int MissionType,Encryption,Security1,Security2,Security3,Special;
				fscanf(FileMissionText,"%d %d %d %d %d %d\n",&MissionType,&Encryption,&Security1,&Security2,&Security3,&Special);
				if (feof(FileMissionText))
				{
					return;
				}
				TotalReads++;
				if (!Encryption)
				{
					Total += MissionType;
					RP2MissionObjectiveTypeControl *Node = DataNode(MissionType);
					if (Node)
					{
						char Text[2000];
						fread(Text,2000,1,FileMissionText);
						sprintf(Node->MissionStartText,"%s",RemoveReturn(Text));

						fread(Text,2000,1,FileMissionText);
						sprintf(Node->MissionFailedText,"%s",RemoveReturn(Text));

						fread(Text,2000,1,FileMissionText);
						sprintf(Node->MissionSuccessfulText,"%s",RemoveReturn(Text));
					}
					else
					{
						Console_Input("MESSAGE ERROR: Mission Type has not been defined, TYPE 0 has been filled with the data!");
						return;
					}
				}
				else
				{
					MissionType -= Encryption;
					Total += MissionType;
					Special -= Total;
					if ((Total+Encryption+Special) == Security1 && (((Total+Special) * (MissionType + 1))/(MissionType+1)) == Security2 && ((MissionType+MissionType)/TotalReads) == Security3)
					{
						RP2MissionObjectiveTypeControl *Node = DataNode(MissionType);
						if (Node)
						{
							char Text[2000];
							fread(Text,2000,1,FileMissionText);
							sprintf(Node->MissionStartText,"%s",RemoveReturnAndE(Text,Encryption,Special+1));

							fread(Text,2000,1,FileMissionText);
							sprintf(Node->MissionFailedText,"%s",RemoveReturnAndE(Text,Encryption,Special+3));

							fread(Text,2000,1,FileMissionText);
							sprintf(Node->MissionSuccessfulText,"%s",RemoveReturnAndE(Text,Encryption,Special+5));
						}
						else
						{
							Console_Input("MESSAGE ERROR: Mission Type has not been defined, TYPE 0 has been filled with the data!");
							return;
						}
					}
					else
					{
						RP2MissionObjectiveTypeControl *Node = DataNode(MissionType);
						if (Node)
						{
							char Text[2000];
							fread(Text,2000,1,FileMissionText);
							sprintf(Node->MissionStartText,"null");

							fread(Text,2000,1,FileMissionText);
							sprintf(Node->MissionFailedText,"null");

							fread(Text,2000,1,FileMissionText);
							sprintf(Node->MissionSuccessfulText,"null");
						}
						else
						{
							Console_Input("MESSAGE ERROR: Mission Type has not been defined, TYPE 0 has been filled with the data!");
							return;
						}
					}
				}
			}
		}
		fclose(FileMissionText);
	}
	else
	{
		Console_Input("MESSAGE ERROR: Mission Text file not found! Mission scripts will not function properly!");
	}
}

RP2MissionObjectiveTypeControl *JMG_RP2_Mission_System_Strings_Loader::DataNode(int MissionType)
{
	if (RP2MissionObjectiveTypeNode)
	{
		int end = 0;
		RP2MissionObjectiveTypeControl *Current = RP2MissionObjectiveTypeNode;
		while (Current != NULL && end == 0)
		{
			if (Current->MissionType == MissionType)
			{
				end = 1;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

char *JMG_RP2_Mission_System_Strings_Loader::RemoveReturn(const char *String)
{
	static char FinalString[2000];
	int loops = strlen(String),x = 0;
	while (x < loops)
	{
		if (String[x] != '\n')
		{
			FinalString[x] = String[x];
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
	}
	return FinalString;
}

char *JMG_RP2_Mission_System_Strings_Loader::RemoveReturnAndE(const char *String,int EncryptionFactor,int Start)
{
	static char FinalString[2000];
	int loops = strlen(String),x = 0;
	int CurrentAdd = Start;
	while (x < loops)
	{
		if (String[x] != '\0' && String[x] != '\n')
		{
			char Temp = (String[x]-(char)CurrentAdd);
			while (Temp < 32)
			{
				Temp += 125;
			}/*
			if (Temp == 126)
			{
				Temp = 92;
			}*/
			FinalString[x] = Temp;
			CurrentAdd++;
			if (CurrentAdd > EncryptionFactor)
			{
				CurrentAdd = 1;
			}
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
	}
	return FinalString;
}

void JMG_RP2_Mission_System_Mission_Define_Mission_Conflicts::Created(GameObject *obj)
{
		Commands->Start_Timer(obj,this,0.0f,Get_Int_Parameter("Mission_Type"));
}

void JMG_RP2_Mission_System_Mission_Define_Mission_Conflicts::Timer_Expired(GameObject *obj, int number)
{	
	int MissionType = Get_Int_Parameter("Mission_Type");
	if (number == MissionType)
	{
		char ParseString[2000];
		sprintf(ParseString,"%s",Get_Parameter("Conflicting_Mission_List"));
		int NumberOfConflicts = strlen(ParseString);
		int y = 0;
		char TempNum[2000];
		for (int x = 0;x <= NumberOfConflicts;x++)
		{
			if (ParseString[x] == ' ' || ParseString[x] == '\n' || ParseString[x] == '\0')
			{
				TempNum[y] = '\0';
				y = 0;
				AddExcludedMission(MissionType,atoi(TempNum));
			}
			else
			{
				TempNum[y] = ParseString[x];
				y++;
			}
		}
	}
}

void JMG_RP2_Mission_System_Mission_Define_Mission_Conflicts::AddExcludedMission(int MissionType,int ExcludeMission)
{
	if (RP2MissionObjectiveTypeNode)
	{
		int end = 0;
		RP2MissionObjectiveTypeControl *Current = RP2MissionObjectiveTypeNode;
		while (Current != NULL && end == 0)
		{
			if (Current->MissionType == MissionType)
			{
				end = 1;
				if (!Current->MissionConflicts)
				{
					Current->MissionConflicts = new RP2PlayerMissionConflicts;
					Current->MissionConflicts->MissionType = MissionType;
					Current->MissionConflicts->ConflictingMission = ExcludeMission;
					Current->MissionConflicts->next = NULL;
					return;
				}
				else
				{
					RP2PlayerMissionConflicts *ConflictNode = Current->MissionConflicts;
					while (ConflictNode != NULL)
					{
						if (ConflictNode->MissionType == MissionType && ConflictNode->ConflictingMission == ExcludeMission)
						{
							char Error[256];
							sprintf(Error,"MESSAGE ERROR: Mission Conflict %d of MissionType %d\'s already is in the list!",ExcludeMission,MissionType);
							Console_Input(Error);	
							return;
						}
						else if (ConflictNode->next == NULL)
						{
							ConflictNode->next = new RP2PlayerMissionConflicts;
							ConflictNode = ConflictNode->next;
							ConflictNode->MissionType = MissionType;
							ConflictNode->ConflictingMission = ExcludeMission;
							ConflictNode->next = NULL;
							return;
						}
						ConflictNode = ConflictNode->next;
					}
				}
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Mission_System_Mission_Vehicle_Exception::Created(GameObject *obj)
{
		Commands->Start_Timer(obj,this,0.0f,Get_Int_Parameter("Mission_Type"));
}

void JMG_RP2_Mission_System_Mission_Vehicle_Exception::Timer_Expired(GameObject *obj, int number)
{	
	int MissionType = Get_Int_Parameter("Mission_Type");
	if (number == MissionType)
	{
		AddExcludedMission(MissionType);
	}
}

void JMG_RP2_Mission_System_Mission_Vehicle_Exception::AddExcludedMission(int MissionType)
{
	if (RP2MissionObjectiveTypeNode)
	{
		int end = 0;
		RP2MissionObjectiveTypeControl *Current = RP2MissionObjectiveTypeNode;
		while (Current != NULL && end == 0)
		{
			if (Current->MissionType == MissionType)
			{
				end = 1;
				if (!Current->MissionConflicts)
				{
					Current->VehicleExceptions = new RP2PlayerVehicleFailMissionExceptionControl;
					Current->VehicleExceptions->MissionType = MissionType;
					sprintf(Current->VehicleExceptions->VehiclePreset,"%s",Get_Parameter("Exclude_Vehicle_From_Fail_Condition"));
					Current->VehicleExceptions->next = NULL;
					return;
				}
				else
				{
					RP2PlayerVehicleFailMissionExceptionControl *VehicleExcpt = Current->VehicleExceptions;
					while (VehicleExcpt != NULL)
					{
						if (VehicleExcpt->MissionType == MissionType && !_stricmp(VehicleExcpt->VehiclePreset,Get_Parameter("Exclude_Vehicle_From_Fail_Condition")))
						{
							char Error[256];
							sprintf(Error,"MESSAGE ERROR: Mission Vehicle Excldue %s of MissionType %d\'s already is in the list!",Get_Parameter("Exclude_Vehicle_From_Fail_Condition"),MissionType);
							Console_Input(Error);	
							return;
						}
						else if (VehicleExcpt->next == NULL)
						{
							VehicleExcpt->next = new RP2PlayerVehicleFailMissionExceptionControl;
							VehicleExcpt = VehicleExcpt->next;
							VehicleExcpt->MissionType = MissionType;
							sprintf(VehicleExcpt->VehiclePreset,"%s",Get_Parameter("Exclude_Vehicle_From_Fail_Condition"));
							VehicleExcpt->next = NULL;
							return;
						}
						VehicleExcpt = VehicleExcpt->next;
					}
				}
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Character_Info::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	GameObject *SVehicle = Get_Vehicle(sender);
	if (message == 4327728 && !SVehicle)
	{
		int PlayerID = Get_Player_ID(sender);
		char Message[2000];
		const char *weap = Get_Current_Weapon(sender);
		float PrimaryDamage = 0.0f;
		float SecondaryDamage = 0.0f;
		float PrimaryEDamage = 0.0f;
		float SecondaryEDamage = 0.0f;
		float PrimaryTDamage = 0.0f;
		float SecondaryTDamage = 0.0f;
		float Gun_Price = 0.0f;
		float Bullet_Price = 0.0f;
		int DisplayItemStats = 1;
		char WeaponName[256];
		sprintf(WeaponName,"None");
		float InventoryWeight = 0;
		float InventoryWeight2 = 0;
		float InventoryWeight3 = 0;
		int IsPhone = 0;
		float WeaponReloadSize = 0.0f;
		if (weap)
		{
			RP2WeaponListControl *Weap2 = Get_WLS_Weapon_Settings(weap);
			if (Weap2->WeaponClass == BODY)
			{
				DisplayItemStats = 0;
			}
			if (Weap2->CanBeDropped)
			{
				Gun_Price = Weapon_Cost_Multiplier(Weap2->WeaponCost);
				Bullet_Price = Weapon_Cost_Multiplier(Weap2->BulletCost);
			}
			InventoryWeight = Weap2->WeaponSize;
			InventoryWeight2 = Weap2->AmmoSize;
			const char *str = Get_Translated_Weapon(sender,Get_Gun_Position(sender,weap));
			sprintf(WeaponName,"%s",str);
			delete[] str;

			InventoryWeight3 = InventoryWeight2 * Get_Total_Bullets(sender,weap);
			if (!_stricmp("Weapon_Cell_Phone",weap))
			{
				IsPhone = 1;
			}
			else if (_stricmp("Weapon_Flamethrower",weap))
			{
				const AmmoDefinitionClass *PrimaryAmmo = Get_Weapon_Ammo_Definition(weap,1);
				const AmmoDefinitionClass *SecondaryAmmo = Get_Weapon_Ammo_Definition(weap,0);
				const ExplosionDefinitionClass *Explosion;
				Explosion = Get_Explosion(Get_Definition_Name(PrimaryAmmo->ExplosionDefID));
				if (!Explosion)
				{
					PrimaryDamage = PrimaryAmmo->Damage;
				}
				else
				{
					PrimaryDamage = PrimaryAmmo->Damage;
					PrimaryEDamage = Explosion->DamageStrength;
				}
				Explosion = Get_Explosion(Get_Definition_Name(SecondaryAmmo->ExplosionDefID));
				if (!Explosion)
				{
					SecondaryDamage = SecondaryAmmo->Damage;
				}
				else
				{
					SecondaryDamage = SecondaryAmmo->Damage;
					SecondaryEDamage = Explosion->DamageStrength;
				}
				PrimaryTDamage = PrimaryDamage + PrimaryEDamage;
				SecondaryTDamage = SecondaryDamage + SecondaryEDamage;
			}
			WeaponReloadSize = Weapon_Refill_Modifier(obj,weap,100.0f);
		}
		//Send_Message_Player(sender,200,200,125,		"============================================");
		Send_Message_Player(sender,200,200,125,		"=============Current Character Info=============");
		//Send_Message_Player(sender,200,200,125,		"============================================");
		sprintf(Message,							"Inventory Capacity: %.2f/%.2f",RP2StarCurrentInventorySize[PlayerID],RP2StarMaxInventorySize[PlayerID]);	Send_Message_Player(sender,200,200,125,Message);
		sprintf(Message,							"Inventory Item Count: %d",(Get_Weapon_Count(sender)-3));												Send_Message_Player(sender,200,200,125,Message);if (!DisplayItemStats){return;}
		sprintf(Message,							"Held Item Name: %s",WeaponName);																		Send_Message_Player(sender,200,200,125,Message);
		if (InventoryWeight){sprintf(Message,		"Item Inventory Size: %.2f",InventoryWeight);															Send_Message_Player(sender,200,200,125,Message);}
		if (InventoryWeight2){sprintf(Message,		"Item Inventory Size: %.2f Each, %.2f Total",InventoryWeight2,InventoryWeight3);						Send_Message_Player(sender,200,200,125,Message);}
		if(!PrimaryDamage&&PrimaryEDamage){sprintf(Message,"(Primary)Explosive Damage: %.2f",PrimaryEDamage);												Send_Message_Player(sender,200,200,125,Message);}
		else if(PrimaryEDamage){sprintf(Message,	"(Primary)Projectile Damage: %.2f, Explosive Damage: %.2f",PrimaryDamage,PrimaryEDamage);				Send_Message_Player(sender,200,200,125,Message);}
		else if(PrimaryTDamage){sprintf(Message,	"Primary Damage: %.2f",PrimaryDamage);																	Send_Message_Player(sender,200,200,125,Message);}
		if(SecondaryEDamage&&!SecondaryDamage){sprintf(Message,"(Secondary)Explosive Damage: %.2f",SecondaryEDamage);										Send_Message_Player(sender,200,200,125,Message);}
		else if(SecondaryEDamage){sprintf(Message,	"(Secondary)Projectile Damage: %.2f, Explosive Damage: %.2f",SecondaryDamage,SecondaryEDamage);			Send_Message_Player(sender,200,200,125,Message);}
		else if(SecondaryTDamage){sprintf(Message,	"Secondary Damage: %.2f",SecondaryDamage);																Send_Message_Player(sender,200,200,125,Message);}
		if(Gun_Price&&Bullet_Price){sprintf(Message,"Weapon Sell Price: $%.2f",Gun_Price);																	Send_Message_Player(sender,200,200,125,Message);
		sprintf(Message,							"Ammo sell price: $%.2f",Bullet_Price);																	Send_Message_Player(sender,200,200,125,Message);}
		else if(Bullet_Price){sprintf(Message,		"Sell Price: $%.2f Each",Bullet_Price);																	Send_Message_Player(sender,200,200,125,Message);}
		else if(Gun_Price){sprintf(Message,			"Object Sell Price: $%.2f",Gun_Price);																	Send_Message_Player(sender,200,200,125,Message);}
		if (IsPhone){sprintf(Message,				"Map has been running for: %02d:%02d:%02d",RUNNINGGAMETIMEH,RUNNINGGAMETIMEM,RUNNINGGAMETIMES);			Send_Message_Player(sender,200,200,125,Message);House_Ownership_Details(obj);}
		else if (WeaponReloadSize){sprintf(Message,	"To completely refill this weapon it would use %.2f%c of your ammo crate.",WeaponReloadSize,'%');		Send_Message_Player(sender,200,200,125,Message);}
	}
	else if (message == 4327728)
	{
		RP2VehicleControl *TheVehicle = Get_Vehicle_Node(SVehicle);
		if (TheVehicle)
		{
			char Message[2000];
			const char *weap = Get_Current_Weapon(SVehicle);
			float PrimaryDamage = 0.0f;
			float SecondaryDamage = 0.0f;
			float PrimaryEDamage = 0.0f;
			float SecondaryEDamage = 0.0f;
			float PrimaryTDamage = 0.0f;
			float SecondaryTDamage = 0.0f;
			float amps = 0;
			for (int x = 0;x < 10;x++)
			{
				amps += TheVehicle->mps[x];
			}
			amps /= 10;
			amps = ((amps * 3600) * 0.000621371192f);
			if (weap)
			{
				if (_stricmp("Weapon_Hot_Air_Balloon",weap))
				{
					const ExplosionDefinitionClass *Explosion;

					const AmmoDefinitionClass *PrimaryAmmo = Get_Weapon_Ammo_Definition(weap,1);
					const AmmoDefinitionClass *SecondaryAmmo = Get_Weapon_Ammo_Definition(weap,0);

					Explosion = Get_Explosion(Get_Definition_Name(PrimaryAmmo->ExplosionDefID));
					if (!Explosion)
					{
						PrimaryDamage = PrimaryAmmo->Damage;
					}
					else
					{
						PrimaryDamage = PrimaryAmmo->Damage;
						PrimaryEDamage = Explosion->DamageStrength;
					}
					Explosion = Get_Explosion(Get_Definition_Name(SecondaryAmmo->ExplosionDefID));
					if (!Explosion)
					{
						SecondaryDamage = SecondaryAmmo->Damage;
					}
					else
					{
						SecondaryDamage = SecondaryAmmo->Damage;
						SecondaryEDamage = Explosion->DamageStrength;
					}
					PrimaryTDamage = PrimaryDamage + PrimaryEDamage;
					SecondaryTDamage = SecondaryDamage + SecondaryEDamage;
				}
			}
			//Send_Message_Player(sender,200,200,125,		"============================================");
			Send_Message_Player(sender,200,200,125,		"=============Current Vehicle Info=============");
			//Send_Message_Player(sender,200,200,125,		"============================================");
			sprintf(Message,							"Traveling at %.2f miles per hour.",amps);																Send_Message_Player(sender,200,200,125,Message);
			if(PrimaryEDamage){sprintf(Message,			"(Primary)Projectile Damage: %.2f, Explosive Damage: %.2f",PrimaryDamage,PrimaryEDamage);				Send_Message_Player(sender,200,200,125,Message);}
			else if(PrimaryTDamage){sprintf(Message,	"Primary Damage: %.2f",PrimaryDamage);																	Send_Message_Player(sender,200,200,125,Message);}
			if(SecondaryEDamage){sprintf(Message,		"(Secondary)Projectile Damage: %.2f, Explosive Damage: %.2f",SecondaryDamage,SecondaryEDamage);			Send_Message_Player(sender,200,200,125,Message);}
			else if(SecondaryTDamage){sprintf(Message,	"Secondary Damage: %.2f",SecondaryDamage);																Send_Message_Player(sender,200,200,125,Message);}
			Commands->Send_Custom_Event(obj,SVehicle,7154148,0,0);
		}
	}
}

float JMG_RP2_Character_Info::Weapon_Cost_Multiplier(int Cost)
{
	if (Get_Player_Count() > 9)
	{
		return (float)Cost;
	}
	else
	{
		return (float)((float)Cost * ((float)Get_Player_Count()/10.0f));
	}
}

RP2VehicleControl *JMG_RP2_Character_Info::Get_Vehicle_Node(GameObject *obj)
{
	if (RP2VehicleNode)
	{
		int MyID = Commands->Get_ID(obj);
		RP2VehicleControl *Current = RP2VehicleNode;
		while (Current != NULL)
		{
			if (Current->VehicleID == MyID)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Character_Info::House_Ownership_Details(GameObject *obj)
{
	if (Commands->Is_A_Star(obj))
	{
		int HouseAddress = 0;
		char PName[256];
		const char *str = Get_Player_Name(obj);
		sprintf(PName,"%s",str);
		delete[] str;
		RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
		while (Current != NULL)
		{
			if (!_stricmp(Current->PlayerName,PName))
			{
				HouseAddress = Current->HouseAddress;
				char Text[2000];
				time_t secs=time(0);
				tm *t=localtime(&secs);
				int timeday = t->tm_yday;
				if (!Current->NumberOfPrePays)
				{
					Current->NumberOfPrePays = 1;
				}
				int HouseDays = ((Current->HouseDay + 7 * Current->NumberOfPrePays) - timeday);
				if (HouseDays > 1)
				{
					sprintf(Text,"Your rent period for your house at address %d expires in %d days.",Current->HouseAddress,HouseDays);
				}
				else
				{
					sprintf(Text,"TODAY is your LAST day to extend your rent period for house at address %d. If you don't renew the rent period you will lose the house.",Current->HouseAddress);
				}
				Send_Message_Player(obj,200,200,125,Text);
				break;
			}
			Current = Current->next;
		}
		if (RP2NewHouseSystemNode)
		{
			HomeSecuritySystemControl *CurrentS = HomeSecuritySystemNode;
			while (CurrentS != NULL)
			{
				if (CurrentS->HouseAddress == HouseAddress)
				{
					char Text[2000];
					time_t secs=time(0);
					tm *t=localtime(&secs);
					int timeday = t->tm_yday;
					if (!CurrentS->NumberOfPrePays)
					{
						CurrentS->NumberOfPrePays = 1;
					}
					int HouseDays = ((CurrentS->RentDay + 7 * CurrentS->NumberOfPrePays) - timeday);
					if (HouseDays > 1)
					{
						sprintf(Text,"Your rent period for your house's security system at address %d expires in %d days.",CurrentS->HouseAddress,HouseDays);
					}
					else
					{
						sprintf(Text,"TODAY is your LAST day to extend your house's security plan at address %d!",CurrentS->HouseAddress);
					}
					Send_Message_Player(obj,200,200,125,Text);
					break;
				}
				CurrentS = CurrentS->next;
			}
		}
	}
}
void JMG_RP2_Force_Vehicle_Exit_And_Kill::Created(GameObject *obj)
{
	Attempts = 0;
	Commands->Start_Timer(obj,this,0.1f,92562243);
}

void JMG_RP2_Force_Vehicle_Exit_And_Kill::Timer_Expired(GameObject *obj,int number)
{
	if (92562243 == number)
	{
		GameObject *PVehicle = Get_Vehicle(obj);
		if (PVehicle && Commands->Get_Health(obj))
		{
			Toggle_Fly_Mode(obj);
		}
		GameObject *Damager = Commands->Find_Object(Get_Int_Parameter("Damager_ID"));
		if (Damager)
		{
			Commands->Apply_Damage(obj,9999.99f,"BlamoKiller",Damager);
		}
		else
		{
			Commands->Apply_Damage(obj,9999.99f,"BlamoKiller",0);
		}
			Commands->Start_Timer(obj,this,0.1f,92562243);
	}
}

void JMG_RP2_Carryall::Created(GameObject *obj)
{
	HasVehicleID = 0;
}

void JMG_RP2_Carryall::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7154148)
	{
		Send_Message_Player(sender,200,200,125,"Vehicle Special Key:");
		Send_Message_Player(sender,200,200,125,"Left Mouse - Pickup/Release a vehicle");
	}
	if (message == 88878)
	{
		char AttachB[40];
		sprintf(AttachB,"VBone%d",param);
		Commands->Attach_To_Object_Bone(sender,obj,AttachB);
	}
	if (message == 98562145)
	{
		if (HasVehicleID)
		{
			GameObject *HVehicle = Commands->Find_Object(HasVehicleID);
			if (!HVehicle)
			{
				HasVehicleID = 0;
			}
		}
		if (!HasVehicleID)
		{
			Vector3 AlignPos = Commands->Get_Bone_Position(obj,"WheelP00F"),OriginPos = Commands->Get_Bone_Position(obj,"Turret");
			if (Commands->Get_Distance(OriginPos,AlignPos) <= 2.5f)
			{
				GameObject *TargetV = Find_A_Vehicle(Commands->Get_Position(obj));
				if (TargetV)
				{
					if (Commands->Get_Distance(Commands->Get_Position(TargetV),AlignPos) < CARRYALLPICKUPRANGE)
					{
						Commands->Disable_Physical_Collisions(TargetV);
						Commands->Set_Player_Type(TargetV,-1);
						Commands->Attach_To_Object_Bone(TargetV,obj,"VBone0");
						Vehicle_Wheel_Bone(TargetV);
						Commands->Send_Custom_Event(obj,TargetV,88878,0,0);
						HasVehicleID = Commands->Get_ID(TargetV);
						RP2VehicleControl *VNode = Get_Vehicle_Node(TargetV);
						if (VNode)
						{
							VNode->OnCarryAll = 1;
						}
					}
				}
			}
		}
		else
		{
			GameObject *TargetV = Commands->Find_Object(HasVehicleID);
			if (TargetV->As_PhysicalGameObj())
			{
				Vector3 Pos = Commands->Get_Position(TargetV);
				PhysicalGameObj *objphys = ((ScriptableGameObj *)TargetV)->As_PhysicalGameObj();
				Commands->Disable_All_Collisions(obj);
				Commands->Enable_Collisions(TargetV);
				for (int x = 0;x < CARRYALLMINDROPHEIGHT;x++)
				{
					if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
					{
						Commands->Disable_All_Collisions(TargetV);
						Commands->Enable_Collisions(obj);
						GameObject *Driver = Get_Vehicle_Driver(obj);
						if (Driver)
						{
							Send_Message_Player(Driver,150,0,150,"I must get further above the ground before I can drop my cargo.");
						}
						return;
					}
					Pos.Z -= 1.0f;
					Commands->Set_Position(TargetV,Pos);
				}
				Commands->Disable_All_Collisions(TargetV);
				Commands->Enable_Collisions(obj);
			}
			DropZ = Commands->Get_Position(obj).Z;
			if (TargetV->As_PhysicalGameObj())
			{
				Commands->Attach_Script(TargetV,"JMG_RP2_Enable_Collisions_When_Safe","");
			}
			else
			{
				Commands->Attach_Script(TargetV,"JMG_RP2_Enable_Collisions_On_Timer","0.5");
			}
			Commands->Attach_To_Object_Bone(TargetV,0,"null");
			Commands->Start_Timer(obj,this,0.5f,567230);
			RP2VehicleControl *VNode = Get_Vehicle_Node(TargetV);
			if (VNode)
			{
				VNode->OnCarryAll = 0;
			}
		}
	}
}

void JMG_RP2_Carryall::Timer_Expired(GameObject *obj,int number)
{
	if (567230 == number)
	{
		if (DropZ > Commands->Get_Position(obj).Z + 0.5)
		{
			GameObject *DroppedVehicle = Commands->Find_Object(HasVehicleID);
			if (DroppedVehicle)
			{
				Commands->Apply_Damage(DroppedVehicle,99999.0f,"BlamoKiller",0);
			}
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver)
			{
				Send_Message_Player(Driver,150,0,150,"Oops, I fucked up big time by ramming the copter into the dropped vehicle. Nice going, self.");
			}
			Commands->Apply_Damage(obj,99999.0f,"BlamoKiller",0);
		}
		HasVehicleID = 0;
	}
}

void JMG_RP2_Carryall::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *HVehicle = Commands->Find_Object(HasVehicleID);
	if (HVehicle)
	{
		Commands->Enable_Collisions(HVehicle);
		RP2VehicleControl *VNode = Get_Vehicle_Node(HVehicle);
		if (VNode)
		{
			VNode->OnCarryAll = 1;
		}
	}
}

void JMG_RP2_Carryall::Vehicle_Wheel_Bone(GameObject *CarryV)
{
	if ((CarryV->As_PhysicalGameObj() && CarryV->As_PhysicalGameObj()->Peek_Physical_Object() && CarryV->As_PhysicalGameObj()->Peek_Physical_Object()->As_MotorcycleClass()))
	{
		sprintf(WheelName,"WheelP01S");
	}
	if ((CarryV->As_PhysicalGameObj() && CarryV->As_PhysicalGameObj()->Peek_Physical_Object() && CarryV->As_PhysicalGameObj()->Peek_Physical_Object()->As_WheeledVehicleClass()))
	{
		Vector3 OriginPos = Commands->Get_Bone_Position(CarryV,"DNE");
		if (Commands->Get_Distance(OriginPos,Commands->Get_Bone_Position(CarryV,"WheelP01S")) >= 0.0)
		{
			sprintf(WheelName,"WheelP01S");
		}
		else if (Commands->Get_Distance(OriginPos,Commands->Get_Bone_Position(CarryV,"WheelP01ES")) >= 0.0)
		{
			sprintf(WheelName,"WheelP01ES");
		}
		else if (Commands->Get_Distance(OriginPos,Commands->Get_Bone_Position(CarryV,"WheelP01EI")) >= 0.0)
		{
			sprintf(WheelName,"WheelP01EI");
		}
		else if (Commands->Get_Distance(OriginPos,Commands->Get_Bone_Position(CarryV,"WheelP01E")) >= 0.0)
		{
			sprintf(WheelName,"WheelP01E");
		}
	}
	if ((CarryV->As_PhysicalGameObj() && CarryV->As_PhysicalGameObj()->Peek_Physical_Object() && CarryV->As_PhysicalGameObj()->Peek_Physical_Object()->As_TrackedVehicleClass()))
	{
		if (Commands->Get_Distance(Commands->Get_Bone_Position(CarryV,"WheelP00E"),Commands->Get_Bone_Position(CarryV,"DNE")) >= 0.0)
		{
			sprintf(WheelName,"WheelP01ER");
		}
		else
		{
			sprintf(WheelName,"WheelP01EL");
		}
	}
}

GameObject *JMG_RP2_Carryall::Find_A_Vehicle(Vector3 Pos)
{
	float OldVehicleDist = 99999.0f;
	GameObject *TargetVehicle = NULL;
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *TempVehicle = x->Data()->As_ScriptableGameObj();
		if (TempVehicle)
		{
			if ((TempVehicle->As_PhysicalGameObj() && TempVehicle->As_PhysicalGameObj()->Peek_Physical_Object() && TempVehicle->As_PhysicalGameObj()->Peek_Physical_Object()->As_MotorcycleClass()) || (TempVehicle->As_PhysicalGameObj() && TempVehicle->As_PhysicalGameObj()->Peek_Physical_Object() && TempVehicle->As_PhysicalGameObj()->Peek_Physical_Object()->As_WheeledVehicleClass()) || (TempVehicle->As_PhysicalGameObj() && TempVehicle->As_PhysicalGameObj()->Peek_Physical_Object() && TempVehicle->As_PhysicalGameObj()->Peek_Physical_Object()->As_TrackedVehicleClass()))
			{
				if (TargetVehicle)
				{
					float TempDist = Commands->Get_Distance(Pos,Commands->Get_Position(TempVehicle));
					if (TempDist < OldVehicleDist)
					{
						RP2VehicleControl *VNode = Get_Vehicle_Node(TempVehicle);
						if (VNode)
						{
							if (VNode->IsWarthog != 2)
							{
								TargetVehicle = TempVehicle;
								OldVehicleDist = TempDist;
							}
						}
					}
				}
				else
				{
					TargetVehicle = TempVehicle;
					OldVehicleDist = Commands->Get_Distance(Pos,Commands->Get_Position(TargetVehicle));
				}
			}
		}
		x = x->Next();
	}
	return TargetVehicle;
}

RP2VehicleControl *JMG_RP2_Carryall::Get_Vehicle_Node(GameObject *obj)
{
	if (RP2VehicleNode)
	{
		int MyID = Commands->Get_ID(obj);
		RP2VehicleControl *Current = RP2VehicleNode;
		while (Current != NULL)
		{
			if (Current->VehicleID == MyID)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}
void JMG_RP2_Housing_Vehicle_Key_Press::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("SetVehicleKeyMessage"))
	{	
		Send_Message_Player(obj,160,127,50,"Your home's vehicle PT has been set to produce this vehicle.");
		Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ZoneID")),Get_Int_Parameter("SetVehicleKeyMessage"),1,0);
	}
}

void JMG_RP2_Housing_Vehicle_Zone::Created(GameObject *obj)
{
	PHVCNode = NULL;
	HouseOwner = NULL;
	Commands->Start_Timer(obj,this,0.0f,92562243);
}

void JMG_RP2_Housing_Vehicle_Zone::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Set_Vehicle_Key_Message"))
	{
		const char *str = Get_Player_Name(sender);
		if (!_stricmp(HouseOwner->PlayerName,str))
		{
			GameObject *TVehicle = Get_Vehicle(sender);
			if (_stricmp(PHVCNode->VehiclePreset,Commands->Get_Preset_Name(TVehicle)))
			{
				PHVCNode->HPPercent = 0;
			}
			PHVCNode->VehiclePosition = Commands->Get_Position(TVehicle);
			PHVCNode->VehicleFacing = Commands->Get_Facing(TVehicle);
			PHVCNode->IsSetup = 1;
			sprintf(PHVCNode->VehiclePreset,"%s",Commands->Get_Preset_Name(TVehicle));
		}
		delete[] str;
	}
}

void JMG_RP2_Housing_Vehicle_Zone::Timer_Expired(GameObject *obj,int number)
{
	if (92562243 == number)
	{
		Control_Node(obj,0);
	}
}

void JMG_RP2_Housing_Vehicle_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (!HouseOwner)
	{
		HouseOwner = Find_Housing_Node(Get_Int_Parameter("House_Address"));
	}
	if (HouseOwner)
	{
		const char *str = Get_Player_Name(enter);
		if (!_stricmp(HouseOwner->PlayerName,str))
		{
			GameObject *TVehicle = Get_Vehicle(enter);
			if (TVehicle)
			{
				if (_stricmp(PHVCNode->VehiclePreset,Commands->Get_Preset_Name(TVehicle)))
				{
					Send_Message_Player(enter,160,127,50,"Press the sell vehicle key to set this vehicle as your home's PT vehicle.");
				}
				if (!Is_Script_Attached(enter,"JMG_RP2_Housing_Vehicle_Key_Press"))
				{
					char params[4000];
					sprintf(params,"%d,%d",Get_Int_Parameter("Set_Vehicle_Key_Message"),Commands->Get_ID(obj));
					Commands->Attach_Script(enter,"JMG_RP2_Housing_Vehicle_Key_Press",params);
				}
			}
		}
		delete[] str;
	}
}

void JMG_RP2_Housing_Vehicle_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (Is_Script_Attached(exit,"JMG_RP2_Housing_Vehicle_Key_Press"))
	{
		Remove_Script(exit,"JMG_RP2_Housing_Vehicle_Key_Press");
	}
}

void JMG_RP2_Housing_Vehicle_Zone::Control_Node(GameObject *obj,GameObject *TVehicle)
{
	if (!PlayerHouseVehicleNode)
	{
		PlayerHouseVehicleNode = new PlayerHouseVehicleControl;
		PlayerHouseVehicleNode->House_Address = Get_Int_Parameter("House_Address");
		if (TVehicle)
		{
			sprintf(PlayerHouseVehicleNode->VehiclePreset,"%s",Commands->Get_Preset_Name(TVehicle));
			PlayerHouseVehicleNode->VehiclePosition = Commands->Get_Position(TVehicle);
			PlayerHouseVehicleNode->VehicleFacing = Commands->Get_Facing(TVehicle);
		}
		else
		{
			sprintf(PlayerHouseVehicleNode->VehiclePreset,"null");
			PlayerHouseVehicleNode->VehiclePosition = Commands->Get_Position(obj);
			PlayerHouseVehicleNode->VehicleFacing = 0;
		}
		PlayerHouseVehicleNode->ZoneID = Commands->Get_ID(obj);
		PlayerHouseVehicleNode->HPPercent = 0;
		PlayerHouseVehicleNode->IsSetup = 0;
		PHVCNode = PlayerHouseVehicleNode;
		PlayerHouseVehicleNode->next = NULL;
	}
	else
	{
		int end = 0;
		PlayerHouseVehicleControl *Current = PlayerHouseVehicleNode;
		while (Current != NULL && end == 0)
		{
			if (Get_Int_Parameter("House_Address") == Current->House_Address)
			{
				end = 1;
				Current->ZoneID = Commands->Get_ID(obj);
				PHVCNode = Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new PlayerHouseVehicleControl;
				Current = Current->next;
				Current->House_Address = Get_Int_Parameter("House_Address");
				if (TVehicle)
				{
					sprintf(Current->VehiclePreset,"%s",Commands->Get_Preset_Name(TVehicle));
					Current->VehiclePosition = Commands->Get_Position(TVehicle);
					Current->VehicleFacing = Commands->Get_Facing(TVehicle);
				}
				else
				{
					sprintf(Current->VehiclePreset,"null");
					Current->VehiclePosition = Commands->Get_Position(obj);;
					Current->VehicleFacing = 0;
				}
				Current->ZoneID = Commands->Get_ID(obj);
				Current->next = NULL;
				Current->HPPercent = 0;
				Current->IsSetup = 0;
				PHVCNode = Current;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Housing_Vehicle_PT::Created(GameObject *obj)
{
	HouseOwner = NULL;
	PHVCNode = NULL;
	CanState = 1;
	Commands->Start_Timer(obj,this,2.0f,92562243);
	Commands->Start_Timer(obj,this,1.5f,92562244);
	Commands->Start_Timer(obj,this,2.0f,4045147);
}

void JMG_RP2_Housing_Vehicle_PT::Poked(GameObject *obj,GameObject *poker)
{
	if (PHVCNode && HouseOwner)
	{
		if (Commands->Is_A_Star(poker) && HouseOwner->IsOwned && PHVCNode->HPPercent >= 0.1f)
		{
			if (ISSELECTINGSPAWN[Get_Player_ID(poker)])
			{
				Send_Message_Player(poker,150,0,0,"You must spawn before you can get this...");
				return;
			}
			if (_stricmp(PHVCNode->VehiclePreset,"null"))
			{
				Send_Message_Player(poker,160,127,50,"Your free vehicle awaits you in the garage!");
				GameObject *Zone = Commands->Find_Object(PHVCNode->ZoneID);
				Damage_All_Objects_In_Zone(Zone,999999.9f,"None",0);
				GameObject *newpreset = Commands->Create_Object(PHVCNode->VehiclePreset,PHVCNode->VehiclePosition);
				Commands->Set_Facing(newpreset,PHVCNode->VehicleFacing);
				if (Commands->Get_Max_Shield_Strength(newpreset) > 0)
				{
					if (PHVCNode->HPPercent > 0.5f)
					{
						Commands->Set_Health(newpreset,Commands->Get_Max_Health(newpreset));
						Commands->Set_Shield_Strength(newpreset,Commands->Get_Max_Shield_Strength(newpreset)*(PHVCNode->HPPercent));
					}
					else
					{
						Commands->Set_Health(newpreset,Commands->Get_Max_Health(newpreset)*(PHVCNode->HPPercent));
						Commands->Set_Shield_Strength(newpreset,0);
					}
				}
				else
				{
					Commands->Set_Health(newpreset,Commands->Get_Max_Health(newpreset)*(PHVCNode->HPPercent));
				}
				if (!Commands->Get_Health(newpreset))
				{
					Commands->Set_Health(newpreset,1.0f);
				}
				Commands->Apply_Damage(newpreset,0.0f,"None",0);
				PHVCNode->HPPercent = 0;
				CanState = 1;
			}
			else
			{
				Send_Message_Player(poker,160,127,50,"You must set a garage vehicle to produce! Do this by driving a vehicle into the garage and press the sell key.");
			}
		}
		else if (PHVCNode->HPPercent < 0.1f)
		{
			Send_Message_Player(poker,160,127,50,"You cannot produce a vehicle below 10% health!");
		}
		else
		{
			Send_Message_Player(poker,160,127,50,"WTF!?!?");
		}
	}
	else
	{
		Send_Message_Player(poker,160,127,50,"The system is still being installed, stand-by!");
	}
}

void JMG_RP2_Housing_Vehicle_PT::Timer_Expired(GameObject *obj,int number)
{
	if (92562244 == number)
	{
		if (!HouseOwner)
		{
			HouseOwner = Find_Housing_Node(Get_Int_Parameter("House_Address"));
			Commands->Start_Timer(obj,this,0.8f,92562243);
		}
		if (!PHVCNode)
		{
			Control_Node(obj);
		}
		if (!HouseOwner || !PHVCNode)
		{
			Commands->Start_Timer(obj,this,1.0f,92562244);
		}
	}
	if (92562243 == number)
	{
		if (PHVCNode && HouseOwner)
		{
			if (PHVCNode->HPPercent >= 1.0f && HouseOwner->IsOwned && CanState)
			{
				PHVCNode->HPPercent = 1;
				CanState = 0;
				GameObject *HouseOwner2 = Get_GameObj_By_Player_Name(HouseOwner->PlayerName);
				if (HouseOwner2)
				{
					Send_Message_Player(HouseOwner2,160,127,50,"You can now build a vehicle from your home at full heath.");
				}
			}
			if (PHVCNode->HPPercent < 1.0f)// && DownTime >= 10)
			{
				PHVCNode->HPPercent += 0.001f;
				if (PHVCNode->HPPercent > 0.01f)
				{
					Commands->Set_Health(obj,Commands->Get_Max_Health(obj)*PHVCNode->HPPercent+0.1f);
				}
				else
				{
					Commands->Set_Health(obj,1.0f);
				}
			}
		}
		Commands->Start_Timer(obj,this,0.8f,92562243);
	}
	if (number == 4045147)
	{
		if (!HouseOwner)
		{
			HouseOwner = Find_Housing_Node(Get_Int_Parameter("House_Address"));
		}
		if (PHVCNode)
		{
			if (!HouseOwner->IsOwned && PHVCNode->IsSetup)
			{
				PHVCNode->IsSetup = 0;
				sprintf(PHVCNode->VehiclePreset,"null");
			}
		}
		Commands->Start_Timer(obj,this,1.0f,4045147);
	}
}

void JMG_RP2_Housing_Vehicle_PT::Control_Node(GameObject *obj)
{
	if (!PlayerHouseVehicleNode)
	{
		PlayerHouseVehicleNode = new PlayerHouseVehicleControl;
		PlayerHouseVehicleNode->House_Address = Get_Int_Parameter("House_Address");
		sprintf(PlayerHouseVehicleNode->VehiclePreset,"null");
		PlayerHouseVehicleNode->VehiclePosition = Commands->Get_Position(obj);
		PlayerHouseVehicleNode->VehicleFacing = 0;
		PlayerHouseVehicleNode->HPPercent = 0;
		PlayerHouseVehicleNode->IsSetup = 0;
		PHVCNode = PlayerHouseVehicleNode;
		PlayerHouseVehicleNode->next = NULL;
	}
	else
	{
		int end = 0;
		PlayerHouseVehicleControl *Current = PlayerHouseVehicleNode;
		while (Current != NULL && end == 0)
		{
			if (Get_Int_Parameter("House_Address") == Current->House_Address)
			{
				PHVCNode = Current;
				Current->HPPercent = 0;
				end = 1;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new PlayerHouseVehicleControl;
				Current = Current->next;
				Current->House_Address = Get_Int_Parameter("House_Address");
				sprintf(Current->VehiclePreset,"null");
				Current->VehiclePosition = Commands->Get_Position(obj);
				Current->VehicleFacing = 0;
				Current->HPPercent = 0;
				Current->IsSetup = 0;
				Current->next = NULL;
				PHVCNode = Current;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Mission_System_Set_Vehicle_Mission_Fails::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.0f,Get_Int_Parameter("Mission_Type"));
}

void JMG_RP2_Mission_System_Set_Vehicle_Mission_Fails::Timer_Expired(GameObject *obj,int number)
{
	if (Get_Int_Parameter("Mission_Type") == number)
	{
		if (RP2MissionObjectiveTypeNode)
		{
			int end = 0;
			RP2MissionObjectiveTypeControl *Current = RP2MissionObjectiveTypeNode;
			while (Current != NULL && end == 0)
			{
				if (Get_Int_Parameter("Mission_Type") == Current->MissionType)
				{
					end = 1;
					Current->AllVehicles = 0;
					Current->VehicleFails = 0;
					Vector3 VehicleFails1 = Get_Vector3_Parameter("Fail_On_Vehicle_Entry[Tracked|Wheeled|Motorcycle]");
					Current->FailOnTrackedVehicle = (int)VehicleFails1.X;if (Current->FailOnTrackedVehicle){Current->VehicleFails++;}
					Current->FailOnWheeledVehicle = (int)VehicleFails1.Y;if (Current->FailOnWheeledVehicle){Current->VehicleFails++;}
					Current->FailOnMotorcycle = (int)VehicleFails1.Z;if (Current->FailOnMotorcycle){Current->VehicleFails++;}
					Vector3 VehicleFails2 = Get_Vector3_Parameter("Fail_On_Vehicle_Entry[VTOL|Boat|Turret]");
					Current->FailOnAircraft = (int)VehicleFails2.X;if (Current->FailOnAircraft){Current->VehicleFails++;}
					Current->FailOnTurret = (int)VehicleFails2.Z;if (Current->FailOnTurret){Current->VehicleFails++;}
					Current->FailOnBoat = (int)VehicleFails2.Y;if (Current->FailOnBoat){Current->VehicleFails++;}
					if (Current->VehicleFails == 6)
					{
						Current->AllVehicles = 1;
					}
					Current->VehicleExceptions = NULL;
					Current->MissionConflicts = NULL;
				}
				Current = Current->next;
			}
		}
	}
}

void JMG_RP2_Housing_Vehicle_Load::Created(GameObject *obj)
{
	long CanUseFile;
	FILE *FileVehicle;
	FileVehicle = fopen("Data/RolePlay2/BetaGarageVehicle.RP2","r");
	if (FileVehicle)
	{  
		fseek (FileVehicle,0,SEEK_END);
		CanUseFile = ftell(FileVehicle);
		rewind (FileVehicle);
		if (CanUseFile > 1)
		{
			while (!feof(FileVehicle))
			{
				int HouseAddress;
				Vector3 Position;
				float Facing;
				fscanf(FileVehicle,"%d\n",&HouseAddress);
				PlayerHouseVehicleControl *CurrentNode = DataNode(HouseAddress);
				if (CurrentNode)
				{
					char VehicleName[256],TempVehName[256];
					fread(TempVehName,256,1,FileVehicle);
					int loops = strlen(TempVehName),x = 0;
					while (x < loops)
					{
						if (TempVehName[x] != '\n')
						{
							VehicleName[x] = TempVehName[x];
						}
						else
						{
							VehicleName[x] = '\0';
						}
						x++;
					}
					int DecryptFactor = HouseAddress % 10;
					fscanf(FileVehicle,"\n");

					fscanf(FileVehicle,"%f %f %f\n",&Position.X,&Position.Y,&Position.Z);
					fscanf(FileVehicle,"%f\n",&Facing);

					sprintf(CurrentNode->VehiclePreset,"%s",Decrypt(VehicleName,DecryptFactor,3));
					CurrentNode->VehiclePosition = Position;
					CurrentNode->VehicleFacing = Facing;
					CurrentNode->IsSetup = 1;
					CurrentNode->HPPercent = 0;
				}
			}
		}
		fclose(FileVehicle);
	}
	else
	{
		Console_Input("MESSAGE Warning: Primary Weapons Cupboard Control File not found! File will be automatically created...");
		FILE *hfile;
		hfile = fopen("Data/RolePlay2/BetaGarageVehicle.RP2","w");
		fprintf(hfile,"");
		fflush(hfile);
		fclose(hfile);
	}
}

PlayerHouseVehicleControl *JMG_RP2_Housing_Vehicle_Load::DataNode(int ID)
{
	if (!PlayerHouseVehicleNode)
	{
		PlayerHouseVehicleNode = new PlayerHouseVehicleControl;
		PlayerHouseVehicleNode->House_Address = ID;
		PlayerHouseVehicleNode->next = NULL;
		return PlayerHouseVehicleNode;
	}
	else
	{
		int end = 0;
		PlayerHouseVehicleControl *Current = PlayerHouseVehicleNode;
		while (Current != NULL && end == 0)
		{
			if (Current->House_Address == ID)
			{
				end = 1;
				return Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new PlayerHouseVehicleControl;
				Current = Current->next;
				Current->House_Address = ID;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

char *JMG_RP2_Housing_Vehicle_Load::Decrypt(const char *String,int EncryptionFactor,int Start)
{
	static char FinalString[2000];
	int loops = strlen(String),x = 0;
	int CurrentAdd = Start;
	while (x < loops)
	{
		if (String[x] != '\0' && String[x] != '\n')
		{
			char Temp = (String[x]-(char)CurrentAdd);
			while (Temp < 32)
			{
				Temp += 125;
			}
			FinalString[x] = Temp;
			CurrentAdd++;
			if (CurrentAdd > EncryptionFactor)
			{
				CurrentAdd = 1;
			}
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
		FinalString[x] = '\0';
	}
	return FinalString;
}

void JMG_RP2_House_Spawn_Location::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.0f,45321);
}

void JMG_RP2_House_Spawn_Location::Timer_Expired(GameObject *obj,int number)
{
	if (45321 == number)
	{
		RP2NewHouseSystemControl *HouseNode = Add_Or_Update_Housing_Node(Get_Int_Parameter("House_Address"));
		if (HouseNode)
		{
			HouseNode->SpawnObjectID = Commands->Get_ID(obj);
		}
	}
}

void JMG_RP2_Mission_System_Mission_Objective_Powerup::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		if (Commands->Is_A_Star(sender))
		{
			if (!ISSELECTINGSPAWN[Get_Player_ID(sender)])
			{
				Commands->Send_Custom_Event(sender,Find_Object_By_Preset(2,RP2MISSIONCONTROLOBJECTNAME),Get_Int_Parameter("Mission_Type"),Get_Int_Parameter("Objective_Number"),0);
			}
		}
	}
}
void JMG_RP2_WLS_Random_Weapon_Spawner_Control::Created(GameObject *obj)
{
	SpawnCount = 1;
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Spawn_Time")+Commands->Get_Random(-Get_Float_Parameter("Random_Spawn_Time"),Get_Float_Parameter("Random_Spawn_Time")),9115126);
}

void JMG_RP2_WLS_Random_Weapon_Spawner_Control::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 9115125)
	{
		if (SpawnCount < Get_Int_Parameter("Spawn_Limit") || Get_Int_Parameter("Spawn_Limit") == -1)
		{
			Commands->Start_Timer(obj,this,(Get_Float_Parameter("Spawn_Time")+Commands->Get_Random(-Get_Float_Parameter("Random_Spawn_Time"),Get_Float_Parameter("Random_Spawn_Time"))),9115125);
			SpawnCount++;
		}
	}
}

void JMG_RP2_WLS_Random_Weapon_Spawner_Control::Timer_Expired(GameObject *obj,int number)
{
	if (9115126 == number)
	{
		SpawnWeapon(obj);
	}
	if (9115125 == number)
	{
		SpawnWeapon(obj);
	}
}

void JMG_RP2_WLS_Random_Weapon_Spawner_Control::SpawnWeapon(GameObject *obj)
{		
	int WeaponTier = Get_Int_Parameter("Weapon_Tier");
	int RandomWeaponTier = Commands->Get_Random_Int(0,WeaponTierCounts[WeaponTier]);
	// Find Random Weapon node
	RP2WeaponListControl *WeaponNode = NULL;
	if (RP2WeaponListNode)
	{
		int end = 0;
		RP2WeaponListControl *Current = RP2WeaponListNode;
		while (Current != NULL && end == 0)
		{
			if (RandomWeaponTier == Current->TierNumber && WeaponTier == Current->WeaponTier)
			{
				end = 1;
				WeaponNode = Current;
			}
			Current = Current->next;
		}
	}
	// Create Spawn
	if (WeaponNode)
	{
		GameObject *object = Commands->Create_Object(WeaponNode->FakePowerUpName,Commands->Get_Position(obj));
		Commands->Set_Facing(object,Commands->Get_Facing(obj));
		char params[2000];
		sprintf(params,"%s,0,%d,1.0,2.0,1,%d,-1",WeaponNode->WeaponName,Get_Int_Parameter("Grant_Bullets"),Get_Int_Parameter("Grant_Bullets"));
		if (!Is_Script_Attached(object,"JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit"))
		{
			Commands->Attach_Script(object,"JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit",params);
			sprintf(params,"%d",Commands->Get_ID(obj));
			Commands->Attach_Script(object,"JMG_RP2_Send_Custom_To_ID_On_Pickup",params);
		}
	}
}

void JMG_RP2_Send_Custom_To_ID_On_Pickup::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		if (Commands->Is_A_Star(sender))
		{
			if (!ISSELECTINGSPAWN[Get_Player_ID(sender)])
			{
				Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ID")),9115125,1,0);
			}
		}
	}
}

void JMG_RP2_Mission_Drop_Weapon_If_Mission_Is_Not_Started::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		if (Commands->Is_A_Star(sender))
		{
			if (!ISSELECTINGSPAWN[Get_Player_ID(sender)])
			{
				const char *str = Get_Player_Name(sender);
				if (!Check_Player_Mission_InComplete(str,Get_Int_Parameter("Mission_Type")))
				{
					char Message[2000];
					sprintf(Message,"Sorry, you cannot pick this up until you start mission %d.",Get_Int_Parameter("Mission_Type"));
					Send_Message_Player(sender,75,150,125,Message);
					RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
					if (TheWeapon)
					{
						if (Get_Int_Parameter("Drop_On_Fail"))
						{
							Vector3 pos = Commands->Get_Position(sender);
							pos.Z += TheWeapon->DropHeight;
							GameObject *object = Commands->Create_Object("Daves_Arrow_NT",pos);
							Commands->Set_Model(object,"null");
							Commands->Set_Facing(object,Commands->Get_Facing(sender));
							if (Has_Weapon(obj,TheWeapon->WeaponName))
							{
								char params[2000];
								sprintf(params,"%s,%d,0.0,0.25,0.25,1,%d,-1",TheWeapon->WeaponName,Get_Int_Parameter("Grant_Bullets"),Get_Int_Parameter("Grant_Bullets"));
								Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup",params);
							}
							if (Has_Weapon(sender,"Weapon_Empty_Hands"))
							{
								Commands->Select_Weapon(sender,"Weapon_Empty_Hands");
								Remove_Weapon(sender,TheWeapon->WeaponName);
							}
						}
						if (Has_Weapon(sender,"Weapon_Empty_Hands"))
						{
							Commands->Select_Weapon(sender,"Weapon_Empty_Hands");
							Remove_Weapon(sender,TheWeapon->WeaponName);
						}
						sprintf(Message,"%s,0.1",TheWeapon->WeaponName);
						Commands->Attach_Script(sender,"JMG_RP2_Remove_Weapon_Delay",Message);
					}
				}
				delete[] str;
			}
		}
	}
}

void JMG_RP2_Remove_Weapon_Delay::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Delay"),234789);
}

void JMG_RP2_Remove_Weapon_Delay::Timer_Expired(GameObject *obj,int number)
{
	if (234789 == number)
	{
		if (Has_Weapon(obj,"Weapon_Empty_Hands"))
		{
			Commands->Select_Weapon(obj,"Weapon_Empty_Hands");
			Remove_Weapon(obj,Get_Parameter("Weapon_Name"));
		}
		if (Is_Script_Attached(obj,"JMG_RP2_Remove_Weapon_Delay"))
		{
			Remove_Script(obj,"JMG_RP2_Remove_Weapon_Delay");
		}
	}
}

void JMG_RP2_Move_To_Random_Location_On_Create::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.0f,9023421);
}

void JMG_RP2_Move_To_Random_Location_On_Create::Timer_Expired(GameObject *obj, int number)
{
	if (number == 9023421)
	{
		if (Get_Int_Parameter("Random_Positions") > 1)
		{
			int Random = Commands->Get_Random_Int(0,Get_Int_Parameter("Random_Positions"));
			switch (Random)
			{
			case 0:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_0"));
				break;
			case 1:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_1"));
				break;
			case 2:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_2"));
				break;
			case 3:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_3"));
				break;
			case 4:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_4"));
				break;
			case 5:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_5"));
				break;
			case 6:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_6"));
				break;
			case 7:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_7"));
				break;
			case 8:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_8"));
				break;
			case 9:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_9"));
				break;
			default:
				Commands->Set_Position(obj,Get_Vector3_Parameter("Location_0"));
				break;
			}
		}
		if (Get_Int_Parameter("Move_Randomly"))
		{
			float RandomTime = Get_Float_Parameter("Random_Move_Time");
			float Time = Get_Float_Parameter("Move_Time")+Commands->Get_Random(-RandomTime,RandomTime);
			Commands->Start_Timer(obj,this,Time,9023421);
		}
		else if (Is_Script_Attached(obj,"JMG_RP2_Move_To_Random_Location_On_Create"))
		{
			Remove_Script(obj,"JMG_RP2_Move_To_Random_Location_On_Create");
		}
	}
}

void JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("MySpawnTime"),955551);
}

void JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special::Timer_Expired(GameObject *obj,int number)
{
	if (955551 == number)
	{
		RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(Get_Parameter("Weapon_Name"));
		if (!TheWeapon)
		{
			Console_Input("MESSAGE WEAPON DROP ERROR: Weapon Node is missing!");
			Commands->Destroy_Object(obj);
			return;
		}
		Vector3 Pos = Commands->Get_Position(obj);
		GameObject *NearestStar = Commands->Get_A_Star(Pos);
		if (Commands->Get_Distance(Commands->Get_Position(NearestStar),Pos) > TheWeapon->RespawnDistance)
		{
			GameObject *object = Commands->Create_Object(TheWeapon->FakePowerUpName,Pos);
			if (Is_Script_Attached(object,"JMG_RP2_Move_To_Random_Location_On_Create"))
			{
				Remove_Script(object,"JMG_RP2_Move_To_Random_Location_On_Create");
			}
			Commands->Set_Facing(object,Commands->Get_Facing(obj));
			char params[2000];
			int Bullets = Get_Int_Parameter("Bullets");
			if (Get_Int_Parameter("Powerup_Limited"))
			{
				DroppedWeaponControl *Node = Find_Nearby_Dropped_Powerups(obj,TheWeapon->WeaponName);
				if (Node)
				{
					GameObject *Object = Commands->Find_Object(Node->PowerupID);
					if (Object)
					{
						Bullets += Node->Bullets;
						Node->Bullets = 0;
						Commands->Destroy_Object(Object);
					}
				}
				Dropped_Weapon_Limiter(object,TheWeapon,Bullets);
			}
			sprintf(params,"%s,%d,%d,%f,%f,%d,%d,%d",Get_Parameter("Weapon_Name"),1,Bullets,Get_Float_Parameter("SpawnTime"),Get_Float_Parameter("RandomSpawnTime"),Get_Int_Parameter("Spawn_Limit"),Get_Int_Parameter("Spawn_Bullets"),Get_Int_Parameter("Powerup_Limited"));
			Commands->Attach_Script(object,"JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit",params);
			Commands->Destroy_Object(obj);
		}
		else
		{
			Commands->Start_Timer(obj,this,0.25f,955551);
		}
	}
}

void JMG_RP2_CarryAll_Vehicle_Height_Adjust::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 88878)
	{	
		Commands->Send_Custom_Event(obj,sender,88878,Get_Int_Parameter("HeightAdd"),0);
	}
}

void JMG_RP2_Enable_Collisions_On_Timer::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),987987);
}

void JMG_RP2_Enable_Collisions_On_Timer::Timer_Expired(GameObject *obj,int number)
{
	if (987987 == number)
	{
		Commands->Enable_Collisions(obj);
		if (Is_Script_Attached(obj,"JMG_RP2_Enable_Collisions_On_Timer"))
		{
			Remove_Script(obj,"JMG_RP2_Enable_Collisions_On_Timer");
		}
	}
}

// Created New Parachute Code 2/23/10
// Updated 8/25/10
void JMG_New_Parachute_Script::Created(GameObject *obj)
{
	create = 0;
	fallenough = 0;
	if (PARACHUTEENABLEDONSPAWN)
	{
		char params[256];
		sprintf(params,"Weapon_Parachute,%d",Commands->Get_Random_Int(5,15));
		Commands->Attach_Script(obj,"JMG_RP2_WLS_Grant_Weapon",params);
	}
	lastzmove = 0;
	go = 0;
	ParachuteID = 0;
	messagedisplayed = 0;
	Collide = 0;
	UpperBlockerID = 0;
	DropSpeed = 0;
	Commands->Start_Timer(obj,this,0.1f,10242349);
	Commands->Start_Timer(obj,this,0.1f,10242350);
}

void JMG_New_Parachute_Script::Timer_Expired(GameObject *obj,int number)
{
	if (10242349 == number && Commands->Get_Health(obj) > 0)
	{
		if (create == 0 && go == 1)
		{
			create = 1;
			go = 0;
			Vector3 pos = Commands->Get_Position(obj);
			Vector3 originalpos = pos;
			pos.Z += 4.669f;
			char params[200];
			sprintf(params,"%d",Commands->Get_ID(obj));
			const char *Armor = Get_Shield_Type(obj);// splatter prevention
			const char *Health = Get_Skin(obj);
			GameObject *Parachute = Commands->Create_Object("RP2_Vehicle_Parachute",pos);// Visible Chute
			Commands->Set_Shield_Type(obj,"blamo");
			Set_Skin(obj,"blamo");
			Commands->Set_Facing(Parachute,Commands->Get_Facing(obj));
			Commands->Attach_To_Object_Bone(obj,Parachute,"Origin2");
			Commands->Attach_Script(Parachute,"JMG_Remove_Object_When_Creator_Destroyed",params);
			Commands->Set_Health(Parachute,(float)Get_Total_Bullets(obj,"Weapon_Parachute"));
			Commands->Create_Sound("parachute_open",pos,obj);
			ParachuteID = Commands->Get_ID(Parachute);
			GameObject *HeightCap = Commands->Create_Object("Daves Arrow",pos);// Push down
			Commands->Attach_To_Object_Bone(HeightCap,Parachute,"HCap");
			Commands->Set_Model(HeightCap,"null");
			UpperBlockerID = Commands->Get_ID(HeightCap);
			Collide = 0;
			sprintf(params,"%s,%s",Health,Armor);
			Attach_Script_Once(obj,"JMG_Force_Enter_Vehicle",params);
			LastDrop = pos;
			DropSpeed = 0;
		}
		else if (create == 1 && Collide)
		{
			GameObject *Parachute = Commands->Find_Object(ParachuteID);
			if (Parachute)
			{
				if (Get_Vehicle_Occupant_Count(Parachute))
				{
					GameObject *CD = Commands->Find_Object(CollisionDetectorID);
					if (CD)
					{//rp2parachute.w3d
						Commands->Disable_Physical_Collisions(Parachute);
						Commands->Enable_Collisions(CD);
						PhysicalGameObj *objphys = ((ScriptableGameObj *)CD)->As_PhysicalGameObj();
						bool Collides = (bool)(!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false));
						if (Collides)
						{
							Commands->Send_Custom_Event(obj,obj,647455,1,0);
						}
						Commands->Disable_Physical_Collisions(CD);
						Commands->Enable_Collisions(Parachute);
					}
				}
			}
			else // Chute Die
			{
				Send_Message_Player(obj,0,255,64,"Damage + Parachute = Fail.");
				Set_Bullets(obj,"Weapon_Parachute",0);
				Set_Clip_Bullets(obj,"Weapon_Parachute",0);
				go = 0;
				create = 0;
				messagedisplayed = 0;
				Commands->Send_Custom_Event(obj,obj,647455,1,0);
			}
		}
		if (!Collide)
		{
			GameObject *Parachute = Commands->Find_Object(ParachuteID);
			if (Parachute)
			{
				if (Get_Vehicle_Occupant_Count(Parachute))
				{
					Collide = 1;
					Commands->Set_Model(Parachute,"RP2Parachute2");
					GameObject *HeightCap = Commands->Find_Object(UpperBlockerID);
					if (HeightCap)
					{
						Commands->Set_Model(HeightCap,"subblock");
					}
					GameObject *CollisionDetector = Commands->Create_Object("Invisible_Box_FR",Commands->Get_Position(Parachute));
					Commands->Enable_Vehicle_Transitions(CollisionDetector,false);
					Commands->Attach_To_Object_Bone(CollisionDetector,Parachute,"Origin2");
					Commands->Set_Model(CollisionDetector,"ParaCollider");
					Commands->Disable_All_Collisions(CollisionDetector);
					CollisionDetectorID = Commands->Get_ID(CollisionDetector);
				}
			}
		}
		// Combind code
		Vector3 pos = Commands->Get_Position(obj);
		if (lastpos.Z - PARACHUTEMINFALLSPEED > pos.Z && lastpos.Z - 50.0f < pos.Z && Get_Total_Bullets(obj,"Weapon_Parachute") > 0 && !Get_Vehicle(obj))
		{
			lastzmove++;
			if (lastzmove > PARACHUTEALLOWDEPLOYDELAY)
			{
				fallenough = 1;	
				if (messagedisplayed == 0)
				{
					messagedisplayed = 1;
					Send_Message_Player(obj,0,255,64,"Press the space bar to deploy your parachute!");
				}
			}
		}
		else 
		{
			lastzmove = 0;
			fallenough = 0;
		}
		if (create == 1 && Collide)
		{
			Vector3 pos = Commands->Get_Position(obj),originalpos = pos;
			float Speed = abs(LastDrop.Z-pos.Z);
			if (Speed > 0.1f)
			{
				DropSpeed = Speed;
			}
			else
			{
				Commands->Send_Custom_Event(obj,obj,647455,1,0);
			}
			LastDrop = pos;
		}
		lastpos = Commands->Get_Position(obj);
		if (ISNEWSWIMMING[Get_Player_ID(obj)] && Commands->Find_Object(ParachuteID))
		{
			Commands->Send_Custom_Event(obj,obj,647455,1,0);
		}
		Commands->Start_Timer(obj,this,0.1f,10242349);
	}
	if (10242350 == number && Commands->Get_Health(obj) > 0)
	{
		if (PARACHUTESLOWDAMAGE)
		{
			GameObject *Parachute = Commands->Find_Object(ParachuteID);
			if (Parachute)
			{
				if (Commands->Get_Health(Parachute) <= 1.0f)
				{
					Commands->Send_Custom_Event(obj,obj,647455,1,0);
				}
				else
				{
					Commands->Apply_Damage(Parachute,1.0f,"None",0);
				}
			}
		}
		Commands->Start_Timer(obj,this,2.5f,10242350);
	}
}

void JMG_New_Parachute_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 647455 && ParachuteID)
	{
		messagedisplayed = 0;
		create = 0;
		GameObject *Parachute = Commands->Find_Object(ParachuteID);
		int Parahealth = (int)Commands->Get_Health(Parachute);
		if (Parachute)
		{
			Vector3 pos = Commands->Get_Position(Parachute);
			pos.Z -= 5.0f;
			Commands->Set_Position(Parachute,pos);
			Commands->Apply_Damage(Parachute,9999999.00f,"BlamoKiller",0);
		}
		ParachuteID = 0;
		GameObject *Blocker = Commands->Find_Object(UpperBlockerID);
		if (Blocker)
		{
			Commands->Destroy_Object(Blocker);
		}
		UpperBlockerID = 0;
		GameObject *CD = Commands->Find_Object(CollisionDetectorID);
		if (CD)
		{
			Commands->Destroy_Object(CD);
		}
		if (Get_Total_Bullets(obj,"Weapon_Parachute"))
		{
			Set_Bullets(obj,"Weapon_Parachute",0);
			if (!PARACHUTESLOWDAMAGE)
			{
				int randomdamage = Commands->Get_Random_Int(5,15);
				Set_Clip_Bullets(obj,"Weapon_Parachute",(Parahealth-randomdamage));
			}
			else
			{
				Set_Clip_Bullets(obj,"Weapon_Parachute",Parahealth-1);
			}
			if (Get_Total_Bullets(obj,"Weapon_Parachute") <= 0)
			{
				Set_Clip_Bullets(obj,"Weapon_Parachute",0);
			}
			if (!Get_Total_Bullets(obj,"Weapon_Parachute"))
			{
				Send_Message_Player(obj,0,255,64,"Looks like that last jump was too much for my parachute, better repair it or buy a new one.");
			}
		}
		/*if (Get_Total_Bullets(obj,"Weapon_Parachute")){ChuteEnabled = 1;}
		else{ChuteEnabled = 0;}*/
	}
	/*if (message == 98472765 && Commands->Get_Health(obj) > 0)
	{
		if (haspowerup < param)
		{
			haspowerup = param;
			Send_Message_Player(obj,0,255,64,"I picked up a parachute, it seems to be in good condition!");
		}
		else
		{
			Send_Message_Player(obj,0,255,64,"Yeah... I think I'll keep my current parachute, thanks.");
		}
		ChuteEnabled = 1;
	}*/
	if (message == 35432167 && !Get_Vehicle(obj) && fallenough == 1)// Space Bar
	{
		go = 1;
	}
}

void JMG_New_Parachute_Script::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *Parachute = Commands->Find_Object(ParachuteID);
	if (Parachute)
	{
		Commands->Apply_Damage(Parachute,9999999.00f,"BlamoKiller",0);
	}
	GameObject *Blocker = Commands->Find_Object(UpperBlockerID);
	if (Blocker)
	{
		Commands->Destroy_Object(Blocker);
	}
	GameObject *CD = Commands->Find_Object(CollisionDetectorID);
	if (CD)
	{
		Commands->Destroy_Object(CD);
	}
	UpperBlockerID = 0;
	char Message[225];
	GameObject *Driver = Get_Vehicle_Driver(obj);
	if (Driver && Commands->Is_A_Star(Driver))
	{
		if (!damager)
		{
			return;
		}
		else if (Commands->Is_A_Star(damager))
		{
			const char *str = Get_Player_Name(Driver);
			const char *str2 = Get_Player_Name(damager);
			sprintf(Message,"%s's parachute was destroyed by %s.",str,str2);
			delete[] str;
			delete[] str2;
		}
		else
		{
			char KillernName[128];
			const char *str = Get_Translated_Preset_Name(damager);
			if (strlen(str) > 1)
			{// Get the name of the object that died
				sprintf(KillernName,"%s",str);
			}
			else
			{// Noname, give stupid name
				sprintf(KillernName,"Unnamed Object");
			}
			delete[] str;
			const char *str2 = Get_Player_Name(Driver);
			sprintf(Message,"%s's parachute was destroyed by a %s.",str2,KillernName);
			delete[] str2;
		}
		for (int x = 1;x < 128;x++)
		{// Send message to all players in game
			GameObject *Player = Get_GameObj(x);
			if (Player)
			{
				Send_Message_Player(Player,255,127,0,Message);
			}
		}
	}
}

void JMG_Force_Enter_Vehicle::Created(GameObject *obj)
{
	TimeOut = 0;
	Commands->Start_Timer(obj,this,0.1f,955551);
}

void JMG_Force_Enter_Vehicle::Timer_Expired(GameObject *obj,int number)
{
	if (955551 == number)
	{
		Soldier_Transition_Vehicle(obj);
		if (Get_Vehicle(obj) && Is_Script_Attached(obj,"JMG_Force_Enter_Vehicle"))
		{
			if (_stricmp(Get_Parameter("Armor"),"blamo") && _stricmp(Get_Parameter("Health"),"blamo") && _stricmp(Get_Parameter("Armor"),"Blamo") && _stricmp(Get_Parameter("Health"),"Blamo"))
			{
				Commands->Set_Shield_Type(obj,Get_Parameter("Armor"));
				Set_Skin(obj,Get_Parameter("Health"));
			}
			Remove_Script(obj,"JMG_Force_Enter_Vehicle");
		}
		else
		{
			TimeOut++;
			if (TimeOut > 50)
			{
				if (_stricmp(Get_Shield_Type(obj),"blamo") && _stricmp(Get_Skin(obj),"blamo") && _stricmp(Get_Shield_Type(obj),"Blamo") && _stricmp(Get_Skin(obj),"Blamo"))
				{
					Commands->Set_Shield_Type(obj,Get_Parameter("Armor"));
					Set_Skin(obj,Get_Parameter("Health"));
				}
				if (Is_Script_Attached(obj,"JMG_Force_Enter_Vehicle"))
				{
					Remove_Script(obj,"JMG_Force_Enter_Vehicle");
				}
			}
			Commands->Start_Timer(obj,this,0.1f,955551);
		}
	}
}

void JMG_RP2_Move_While_In_Zone::Created(GameObject *obj)
{
	if (Get_Int_Parameter("ZoneVariant(0-9)") < 0 || Get_Int_Parameter("ZoneVariant(0-9)") > 9)
	{
		char Text[237];
		sprintf(Text,"MESSAGE ERROR: ZoneID %d - JMG_RP2_Move_While_In_Zone->ZoneVariant(0-9) CANNOT be %d!",Commands->Get_ID(obj),Get_Int_Parameter("ZoneVariant(0-9)"));
		Console_Input(Text);
		Remove_Script(obj,"JMG_RP2_Move_While_In_Zone");
	}
	sprintf(ScriptName,"JMG_RP2_Move_While_In_Zone_Attach%d",Get_Int_Parameter("ZoneVariant(0-9)"));
}

void JMG_RP2_Move_While_In_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		char params[256];
		sprintf(params,"%f,%d,%f %f %f",Get_Float_Parameter("TimeDelay"),Commands->Get_ID(obj),Get_Vector3_Parameter("Movement").X,Get_Vector3_Parameter("Movement").Y,Get_Vector3_Parameter("Movement").Z);
		Commands->Attach_Script(enter,ScriptName,params);
	}
}

void JMG_RP2_Move_While_In_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (Is_Script_Attached(exit,ScriptName))
	{
		Remove_Script(exit,ScriptName);
	}
}

void JMG_RP2_Move_While_In_Zone_Attach::Created(GameObject *obj)
{
	MovementAllowed = 1;
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerID"));
}

void JMG_RP2_Move_While_In_Zone_Attach::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 911)
	{
		MovementAllowed = param;
	}
}

void JMG_RP2_Move_While_In_Zone_Attach::Timer_Expired(GameObject *obj,int number)
{
	if (Get_Int_Parameter("TimerID") == number)
	{
		Vector3 Pos = Commands->Get_Position(obj),Vector = Get_Vector3_Parameter("Movement"),OldPos;
		OldPos = Pos;
		Pos.X += Vector.X;
		Pos.Y += Vector.Y;
		Pos.Z += Vector.Z;
		PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
		Commands->Set_Position(obj,Pos);
		if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
		{
			Commands->Set_Position(obj,OldPos);	
		}
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerID"));
	}
}

void JMG_RP2_Move_While_In_Zone_2::Created(GameObject *obj)
{
	if (Get_Int_Parameter("ZoneVariant(0-9)") < 0 || Get_Int_Parameter("ZoneVariant(0-9)") > 9)
	{
		char Text[237];
		sprintf(Text,"MESSAGE ERROR: ZoneID %d - JMG_RP2_Move_While_In_Zone_2->ZoneVariant(0-9) CANNOT be %d!",Commands->Get_ID(obj),Get_Int_Parameter("ZoneVariant(0-9)"));
		Console_Input(Text);
		Remove_Script(obj,"JMG_RP2_Move_While_In_Zone_2");
	}
	sprintf(ScriptName,"JMG_RP2_Move_While_In_Zone_2_Attach_%d",Get_Int_Parameter("ZoneVariant(0-9)"));
}

void JMG_RP2_Move_While_In_Zone_2::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		char params[256];
		sprintf(params,"%f,%d,%f %f %f,%f %f %f",Get_Float_Parameter("TimeDelay"),Commands->Get_ID(obj),Get_Vector3_Parameter("Movement").X,Get_Vector3_Parameter("Movement").Y,Get_Vector3_Parameter("Movement").Z,Get_Vector3_Parameter("MoveToCenter").X,Get_Vector3_Parameter("MoveToCenter").Y,Get_Vector3_Parameter("MoveToCenter").Z);
		Commands->Attach_Script(enter,ScriptName,params);
	}
}

void JMG_RP2_Move_While_In_Zone_2::Exited(GameObject *obj,GameObject *exit)
{
	if (Is_Script_Attached(exit,ScriptName))
	{
		Remove_Script(exit,ScriptName);
	}
}

void JMG_RP2_Move_While_In_Zone_2_Attach::Created(GameObject *obj)
{
	MovementAllowed = 0;
	ZoneCenter = Commands->Get_Position(Commands->Find_Object(Get_Int_Parameter("TimerID")));
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerID"));
}

void JMG_RP2_Move_While_In_Zone_2_Attach::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 911)
	{
		MovementAllowed = param;
	}
}

void JMG_RP2_Move_While_In_Zone_2_Attach::Timer_Expired(GameObject *obj,int number)
{
	if (Get_Int_Parameter("TimerID") == number)
	{
		Vector3 Pos = Commands->Get_Position(obj),Vector = Get_Vector3_Parameter("Movement"),SpeedC = Get_Vector3_Parameter("CenterMovement"),OldPos;
		OldPos = Pos;
		Pos.X += Vector.X;
		Pos.Y += Vector.Y;
		Pos.Z += Vector.Z;
		Pos.X = Calculations(ZoneCenter.X,Pos.X,SpeedC.X);
		Pos.Y = Calculations(ZoneCenter.Y,Pos.Y,SpeedC.Y);
		Pos.Z = Calculations(ZoneCenter.Z,Pos.Z,SpeedC.Z);
		Commands->Set_Position(obj,Pos);
		PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
		if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
		{
			Commands->Set_Position(obj,OldPos);	
		}
		Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerID"));
	}
}

float JMG_RP2_Move_While_In_Zone_2_Attach::Calculations(float ZoneCenter,float Position,float Speed)
{
	if (Speed)
	{
		if (abs(ZoneCenter - Position) < abs(Speed))
		{
			return ZoneCenter;
		}
		else if (Position < ZoneCenter)
		{
			return (Position += Speed);
		}
		else if  (Position > ZoneCenter)
		{
			return (Position -= Speed);
		}
	}
	return Position;
}

void JMG_RP2_Simple_Smart_ID_Base_Defense::Created(GameObject *obj)
{
	EnemyID = 0;
	TargetVisible = 0;
	Checking = 2;
	AGTargetID = 0;
	KillTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	if (Get_Int_Parameter("On_Grid") < 128 && Get_Int_Parameter("On_Grid") >= 0)
	{
		MyGrid = Get_Int_Parameter("On_Grid");
	}
	else
	{
		MyGrid = -1;
	}
	Commands->Start_Timer(obj,this,1.0,92562142);
	Commands->Start_Timer(obj,this,0.1f,92562143);
	Commands->Enable_Enemy_Seen(obj,true);
	Attach_Script_Once(obj,"JMG_RP2_Object_Send_Text_Message_On_Death","");
}

void JMG_RP2_Simple_Smart_ID_Base_Defense::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
	{
		return;
	}
	if (Commands->Is_A_Star(seen))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(seen)])
		{
			return;
		}
	}
	if (!(seen->As_PhysicalGameObj() && seen->As_PhysicalGameObj()->Peek_Physical_Object() && seen->As_PhysicalGameObj()->Peek_Physical_Object()->As_ProjectileClass()))
	{
		float Distance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
		if (Distance <= Get_Float_Parameter("Max_Range") && Distance > Get_Float_Parameter("Min_Range"))
		{
			if (Checking == NOTHING)
			{	
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
				EnemyID = Commands->Get_ID(seen);
				Commands->Enable_Enemy_Seen(obj,false);
				Checking = SEARCHCOMPLETE;
			}
			if (Checking == SEARCHING)//See if still visible
			{
				if ((EnemyID == Commands->Get_ID(seen) && TargetVisible == 0) || (EnemyID == Commands->Get_ID(seen) && TargetVisible == 1 && Distance <= TargetDistance))
				{
					TargetVisible = true;// TARGET FOUND
					TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
				}
				else if (EnemyID != Commands->Get_ID(seen) && (Distance + 1.0f) < TargetDistance)// Closer Target Found, use this one
				{
					EnemyID = Commands->Get_ID(seen);
					TargetVisible = true;// TARGET FOUND!
					TargetDistance = Distance;
				}
			}
		}
	}
}

void JMG_RP2_Simple_Smart_ID_Base_Defense::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 9911591)
	{
		GiveToGrid(sender);
	}
}

void JMG_RP2_Simple_Smart_ID_Base_Defense::Timer_Expired(GameObject *obj,int number)
{
	if (92562143 == number)
	{
		if (EnemyID)
		{
			GameObject *Enemy = Commands->Find_Object(EnemyID);
			if (Enemy && KillTargetID != EnemyID)
			{
				AttackHoldFunction(obj,Enemy);
				KillTargetID = EnemyID;
			}
			if (!Enemy)
			{
				EnemyID = 0;
				KillTargetID = 0;
			}
		}
		Commands->Start_Timer(obj,this,0.25,92562143);
	}
	if (number == 92562142)
	{
		VisibilityCheck(obj);
		Commands->Start_Timer(obj,this,1.25,92562142);
	}
}

void JMG_RP2_Simple_Smart_ID_Base_Defense::StopShootingAndReload(GameObject *obj)
{
	EnemyID = 0;
	AGTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	Checking = 2;
	KillTargetID = 0;
	Commands->Enable_Enemy_Seen(obj,true);
	Commands->Action_Reset(obj,100);
}

void JMG_RP2_Simple_Smart_ID_Base_Defense::AttackHoldFunction(GameObject *obj,GameObject *Enemy)
{
	ActionParamsStruct params;
	params.Set_Basic(this,0,100);
	params.Set_Attack(Enemy,Get_Float_Parameter("Max_Range"),0,1);
	params.AttackCheckBlocked = false;
	Commands->Action_Attack(obj,params);
}

void JMG_RP2_Simple_Smart_ID_Base_Defense::VisibilityCheck(GameObject *obj)
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (EnemyID == 0) // Always set to true if no enemy is targeted
	{
		Checking = NOTHING;
		Commands->Enable_Enemy_Seen(obj,true);
		SelectNetworkTarget(obj);
	}
	if (Checking == SEARCHCOMPLETE)// If not checking for an enemy start
	{
		Checking = SEARCHING;
		TargetVisible = false;
		TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(EnemyID)));
		Commands->Enable_Enemy_Seen(obj,true);
	}
	else if (Checking == SEARCHING && TargetVisible == 0)// If just completed the check, but no enemy found, clear target
	{
		EnemyID = 0;
		if (!AGTargetID)
		{
			StopShootingAndReload(obj);
		}
		else
		{
			AGAttackTime++;
			if (AGAttackTime > 15)
			{
				RemoveGridTarget(AGTargetID);
				StopShootingAndReload(obj);
			}
		}
		SelectNetworkTarget(obj);
	}
	else if (Checking == SEARCHING && TargetVisible == 1)// Enemy was found, keep the target
	{
		Commands->Enable_Enemy_Seen(obj,false);
		Checking = SEARCHCOMPLETE;
	}
}

void JMG_RP2_Simple_Smart_ID_Base_Defense::GiveToGrid(GameObject *Enemy)
{
	int end = 0;
	int AddID = Commands->Get_ID(Enemy);
	for (int x = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSBDGrid[MyGrid][x] == AddID)
		{
			end = 1;
			JRP2SSBDGrid[MyGrid][x] = AddID;
			JRP2SSBDGridTC[MyGrid]++;
		}
		else if (JRP2SSBDGrid[MyGrid][x] == 0)
		{
			end = 1;
			JRP2SSBDGrid[MyGrid][x] = AddID;
			JRP2SSBDGridTC[MyGrid]++;
		}
	}
	if (end == 0)
	{
		for (int x = 0;x < 25 && end == 0;x++)
		{
			if (x < 24)
			{
				JRP2SSBDGrid[MyGrid][x] = JRP2SSBDGrid[MyGrid][(x+1)];
			}
			else
			{
				JRP2SSBDGrid[MyGrid][x] = AddID;
			}
		}
	}
}

int JMG_RP2_Simple_Smart_ID_Base_Defense::GrabIDFromGrid()
{
	if (JRP2SSBDGridTC[MyGrid])
	{
		for (int x = 0,end = 0;x < 25 && end == 0;x++)
		{
			if (JRP2SSBDGrid[MyGrid][x] != 0)
			{
				end = 1;
				return JRP2SSBDGrid[MyGrid][x];
			}
		}
	}
	return 0;
}

void JMG_RP2_Simple_Smart_ID_Base_Defense::RemoveGridTarget(int ID)
{
	for (int x = 0,end = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSBDGrid[MyGrid][x] == ID)
		{
			for (int y = x;y < 25;y++)
			{
				if (y < 24)
				{
					JRP2SSBDGrid[MyGrid][y] = JRP2SSBDGrid[MyGrid][(y+1)];
				}
				else
				{
					JRP2SSBDGrid[MyGrid][y] = 0;
				}
			}
			JRP2SSBDGridTC[MyGrid]--;
			end = 1;
		}
	}
}

void JMG_RP2_Simple_Smart_ID_Base_Defense::SelectNetworkTarget(GameObject *obj) 
{
	if (AGTargetID && EnemyID && AGTargetID != EnemyID)
	{
		GameObject *Target = Commands->Find_Object(AGTargetID);
		GameObject *Target2 = Commands->Find_Object(EnemyID);
		float ObjectDistance = Commands->Get_Distance(Commands->Get_Position(Target),Commands->Get_Position(obj));
		float EnemyDistance = Commands->Get_Distance(Commands->Get_Position(Target2),Commands->Get_Position(obj));
		if (ObjectDistance < EnemyDistance)
		{
			EnemyID = AGTargetID;
		}
		else
		{
			AGTargetID = EnemyID;
		}
	}
	if (AGTargetID && !EnemyID)
	{
		SameTarget++;
		EnemyID = AGTargetID;
		GameObject *Target = Commands->Find_Object(AGTargetID);
		if (!Target || !Commands->Get_Health(Target))
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
			EnemyID = 0;
			Checking = 2;
			Commands->Enable_Enemy_Seen(obj,true);
		}
		if (SameTarget >= 40)
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
		}
	}
	else if (!EnemyID && MyGrid != -1)
	{
		if (JRP2SSBDGridTC[MyGrid])
		{
			SameTarget = 0;
			EnemyID = GrabIDFromGrid();
			GameObject *Target = Commands->Find_Object(EnemyID);
			if (!Commands->Get_Health(Target))
			{
				RemoveGridTarget(EnemyID);
			}
			else if (EnemyID && Target)
			{
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Target));
				Checking = 1;
				AGTargetID = EnemyID;
			}
		}
	}
	GameObject *NewTarget = Commands->Find_Object(AGTargetID);
	if (Commands->Is_A_Star(NewTarget))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(NewTarget)])
		{
			RemoveGridTarget(AGTargetID);
		}
	}
}


void JMG_RP2_Move_While_In_Zone_Allow_Movement::Created(GameObject *obj)
{
	x = 1;
	for (int x = 1;x < 128;x++)
	{
		MovementEnabled[x] = 0;
	}
	Commands->Start_Timer(obj,this,0.0,911);
}

void JMG_RP2_Move_While_In_Zone_Allow_Movement::Timer_Expired(GameObject *obj,int number)
{
	if (number == 911)
	{
		x++;
		if (x < 128)
		{
			x = 1;
		}
		GameObject *Player = Get_GameObj(x);
		if (Player)
		{
			Vector3 Pos = Commands->Get_Position(Player);
			for (int y = 1;y < 128;y++)
			{
				GameObject *Player2 = Get_GameObj(y);
				if (Player2)
				{
					if (Commands->Get_Distance(Commands->Get_Position(Player2),Pos) < 10.0)
					{
						if (MovementEnabled[x])
						{
							Commands->Send_Custom_Event(obj,Player,4445451,0,0);
						}
						if (MovementEnabled[y])
						{
							Commands->Send_Custom_Event(obj,Player2,4445451,0,0);
						}
						MovementEnabled[x] = 0;
						MovementEnabled[y] = 0;
					}
					else
					{
						if (!MovementEnabled[x])
						{
							Commands->Send_Custom_Event(obj,Player,4445451,1,0);
						}
						if (!MovementEnabled[y])
						{
							Commands->Send_Custom_Event(obj,Player2,4445451,1,0);
						}
						MovementEnabled[x] = 1;
						MovementEnabled[y] = 1;
					}
				}
			}
		}
		Commands->Start_Timer(obj,this,0.0,911);
	}
}

void JMG_RP2_Count_Objects_On_Map_And_Print::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,1.0,456852);
}

void JMG_RP2_Count_Objects_On_Map_And_Print::Timer_Expired(GameObject *obj,int number)
{
	if (456852 == number)
	{
		int count = 0;
		SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
		while (x)
		{
			GameObject *o = x->Data();
			if (o)
			{
				count++;
			}
			x = x->Next();
		}
		char ObjectCount[256];
		sprintf(ObjectCount,"Number of Objects on the map: %d",count);
		//JeradTrace(ObjectCount);
		Commands->Start_Timer(obj,this,1.0f,456852);
	}
}

void JMG_RP2_WLS_Weapon_Sell_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(enter)])
		{
			if (!Get_Vehicle(enter))
			{
				Commands->Send_Custom_Event(obj,enter,4045156,Commands->Get_ID(obj),0);
				Send_Message_Player(enter,255,127,127,"Press the drop object key to sell the current object you are holding.");
			}
		}
	}
}

void JMG_RP2_WLS_Weapon_Sell_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (Commands->Is_A_Star(exit))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(exit)])
		{
			if (!Get_Vehicle(exit))
			{
				Commands->Send_Custom_Event(obj,exit,4045156,0,0);
			}
		}
	}
}

void JMG_RP2_WLS_Weapon_Sell_On_Poke::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(poker)])
		{
			Commands->Send_Custom_Event(obj,poker,3423433,1,0);
		}
	}
}

void JMG_RP2_Disable_Engine_On_Create::Created(GameObject *obj)
{
	Commands->Enable_Engine(obj,false);
}

void JMG_RP2_Player_Anti_Missile_System_Limit::Created(GameObject *obj)
{
	PlayerID = 0;
}

void JMG_RP2_Player_Anti_Missile_System_Limit::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 787911 && !PlayerID)
	{
		PlayerID = Get_Player_ID(sender);
		Add_Node(obj);
	}
}

void JMG_RP2_Player_Anti_Missile_System_Limit::Add_Node(GameObject *obj)
{
JMGRP2PAMSLDelete:
	if (!ObjectLimitNode[PlayerID])
	{
		ObjectLimitNode[PlayerID] = new ObjectLimitControl;
		ObjectLimitNode[PlayerID]->TurretID = Commands->Get_ID(obj);
		ObjectLimitNode[PlayerID]->next = NULL;
	}
	else
	{
		int end = 0,Count = 0;
		ObjectLimitControl *Current = ObjectLimitNode[PlayerID],*Prev = NULL;
		while (Current != NULL && !end)
		{
			Count++;
			GameObject *Turret = Commands->Find_Object(Current->TurretID);
			if (!Turret)
			{
				Count--;
				if (Prev == NULL)
				{
					ObjectLimitControl *Temp = ObjectLimitNode[PlayerID]->next;
					delete ObjectLimitNode[PlayerID];
					ObjectLimitNode[PlayerID] = Temp;
				}
				else if (Prev != NULL && Current->next == NULL)
				{
					Prev->next = NULL;
					delete Current;
					Current = Prev;
				}
				else if (Prev != NULL && Current->next != NULL)
				{
					Prev->next = Current->next;
					delete Current;
					Current = Prev;
				}
				goto JMGRP2PAMSLDelete;
			}
			if (Count >= 2 && Current->next == NULL)
			{
				end = 1;
				Current->next = new ObjectLimitControl;
				Current = Current->next;
				Current->TurretID = Commands->Get_ID(obj);
				Current->next = NULL;

				ObjectLimitControl *Temp = ObjectLimitNode[PlayerID]->next;
				Turret = Commands->Find_Object(ObjectLimitNode[PlayerID]->TurretID);
				if (Turret)
				{
					Commands->Destroy_Object(Turret);
				}
				delete ObjectLimitNode[PlayerID];
				ObjectLimitNode[PlayerID] = Temp;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new ObjectLimitControl;
				Current = Current->next;
				Current->TurretID = Commands->Get_ID(obj);
				Current->next = NULL;
			}
			Prev = Current;
			Current = Current->next;
		}
	}
}

void JMG_RP2_Phone_Player_Anti_Missile_System_Set::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		Commands->Send_Custom_Event(sender,obj,Get_Int_Parameter("Message") + 1,Get_Int_Parameter("Message"),0.1f);
	}
	if (message == Get_Int_Parameter("Message") + 1)
	{
		if (!sender)
		{
			return;
		}
		SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
		while (x)
		{
			GameObject *o = x->Data()->As_ScriptableGameObj();
			if (o)
			{
				if (!_stricmp(Commands->Get_Preset_Name(o),PLAYERANTIMISSILESYSTEM))
				{
					Commands->Send_Custom_Event(sender,o,787911,1,0.0f);
				}
			}
			x = x->Next();
		}
	}
}

void JMG_Change_HP_Shields_On_Timer::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
}

void JMG_Change_HP_Shields_On_Timer::Timer_Expired(GameObject *obj,int number)
{
	if (number == Get_Int_Parameter("TimerNum"))
	{
		Commands->Set_Shield_Type(obj,Get_Parameter("ArmorType"));
		Set_Skin(obj,Get_Parameter("SkinType"));
		if (Is_Script_Attached(obj,"JMG_Change_HP_Shields_On_Timer"))
		{
			Remove_Script(obj,"JMG_Change_HP_Shields_On_Timer");
		}
	}
}


void JMG_RP2_Phone_Sell_House_Phone_Number_Control_System::Created(GameObject *obj)
{
	sprintf(PhoneNumberMessage,"null");
	char TempNumber[256];
	const char *PhoneNumber = Get_Parameter("Phone_Number");
	sprintf(TempNumber,"");
	int x = 0,x2 = 0;
	int length = strlen(PhoneNumber);
	while (x2 < length)
	{
		if (x == 3)
		{
			TempNumber[x] = '-';
			x++;
		}
		TempNumber[x] = PhoneNumber[x2];
		x++;
		TempNumber[x] = '\0';
		x2++;
	}
	sprintf(PhoneNumberMessage,"%s - Put your house up for sale.",TempNumber);
}

void JMG_RP2_Phone_Sell_House_Phone_Number_Control_System::Custom(GameObject *obj,int message,int param,GameObject *sender)
{	
	if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							sprintf(Current->PhoneNumber,"%s - %s",Current->PhoneNumber,PhoneNumberMessage);
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && param == 2)
	{
		Send_Message_Player(sender,127,255,0,PhoneNumberMessage);
	}
	if (message == PHONECallStartCustom && param == 0)
	{							
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							if (!Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")))
							{
								GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
								GLOBALPHONETIMES[PlayerID] = 0;
								Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Script_ID"),Get_Player_ID(sender),(Get_Float_Parameter("Pickup_Delay")+Commands->Get_Random(0.0f,Get_Float_Parameter("Max_Random_Pickup_Delay"))));
							}
							else
							{
								for (int x = 1;x < 128;x++)
								{
									if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
									{
										GameObject *Player = Get_GameObj(x);
										Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
									}
								}
								Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
							}
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == Get_Int_Parameter("Script_ID"))
	{
		GameObject *player = Get_GameObj(param);
		Send_Message_Player(player,127,255,0,"Hello, and thank you for calling the automated house rental services, Please enter the address of the house you would like to sell and press pound.");
		Commands->Send_Custom_Event(obj,player,PHONENumberRequiresAdditionalNumberAndPound,Get_Int_Parameter("Script_ID"),0);// make it await pound
	}
	if (message == PHONECallStartCustom && param == Get_Int_Parameter("Script_ID"))
	{
		int end = 0;
		if (PhoneNumbers)
		{
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					HouseAddress = atoi(Current->PhonePound);
					end = 1;
				}
				Current = Current->next;
			}
		}
		int PlayerID = Get_Player_ID(sender);
		if (IsInsideHouse[PlayerID] == HouseAddress)
		{
			Send_Message_Player(sender,127,255,0,"Sorry, you cannot sell a house while inside of it!");
			AutoCancelCall(obj,sender);
			return;
		}
		if (RP2NewHouseSystemNode)
		{
			int OwnTheHouse = 0;
			char PlayerName[256];
			const char *str = Get_Player_Name(sender);
			sprintf(PlayerName,"%s",str);
			delete[] str;
			RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
			while (Current != NULL)
			{
				if (Current->IsOwned)
				{
					if (!_stricmp(PlayerName,Current->PlayerName))
					{
						if (Current->HouseAddress == HouseAddress)
						{
							OwnTheHouse = 1;
						}
					}
				}
				Current = Current->next;
			}
			if (!OwnTheHouse)
			{
				Send_Message_Player(sender,127,255,0,"Sorry, but you don't own that house, thus we cannot help you, have a nice day!");
				AutoCancelCall(obj,sender);
			}
			else
			{
				end = 0;
				CurHouse = Find_Housing_Node(HouseAddress);
				if (CurHouse)
				{
					time_t secs=time(0);
					tm *t=localtime(&secs);
					int timeyear = t->tm_year;
					int timeday = t->tm_yday;
					int Price = 70000;
					if (timeyear == CurHouse->HouseYear)
					{
						Price = (((CurHouse->HouseDay + CurHouse->RentTime * CurHouse->NumberOfPrePays) - timeday)-1) * (CurHouse->RentPrice/CurHouse->RentTime);
					}
					char confmes[237];
					sprintf(confmes,"Are you sure you'd like to sell your house at address %d for %d credits? ([1]yes [2]no)",CurHouse->HouseAddress,Price);
					Send_Message_Player(sender,127,255,0,confmes);
					Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
					Commands->Send_Custom_Event(sender,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);// Start Timer
				}
			}
		}
	}
	if (message == PHONENumberEndCallMessage && param == Get_Int_Parameter("Script_ID"))
	{
		int PlayerID = Get_Player_ID(sender);
		if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
		{
			GLOBALPHONELINES[PlayerID] = 0;
			GLOBALPHONETIMES[PlayerID] = 0;
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
		}
	}
	if (message == PHONESpecial1Key && param == Get_Int_Parameter("Script_ID"))
	{
		int PlayerID = Get_Player_ID(sender);
		time_t secs=time(0);
		tm *t=localtime(&secs);
		int timeyear = t->tm_year;
		int timeday = t->tm_yday;
		int Price = 70000;
		if (timeyear == CurHouse->HouseYear)
		{
			Price = (((CurHouse->HouseDay + CurHouse->RentTime * CurHouse->NumberOfPrePays) - timeday)-1) * (CurHouse->RentPrice/CurHouse->RentTime);
		}
		sprintf(CurHouse->PlayerName,"null");
		CurHouse->NumberOfPrePays = 0;
		CurHouse->HouseYear = 0;
		CurHouse->HouseDay = 0;
		CurHouse->IsOwned = 0;
		Commands->Give_Money(sender,(float)Price,1);
		Send_Message_Player(sender,127,255,0,"Action successful, your house has been sold!");
		Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);// Hang up
		Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
		Commands->Send_Custom_Event(sender,Commands->Find_Object(CurHouse->ControllerID),5814114,PlayerID,0);// player buys house, custom is sent to the controller
		Commands->Grant_Key(sender,0-CurHouse->HouseAddress,true);
	}
	if (message == PHONESpecial2Key && param == Get_Int_Parameter("Script_ID"))
	{
		Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
		Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
	}
	if (message == PHONENumberCallTimeMonitor && param == Get_Int_Parameter("Script_ID"))
	{
		ChargeForCall(obj);
	}
}

void JMG_RP2_Phone_Sell_House_Phone_Number_Control_System::AutoCancelCall(GameObject *obj,GameObject *player)
{
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}

void JMG_RP2_Phone_Sell_House_Phone_Number_Control_System::ChargeForCall(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
		{
			GameObject *Player = Get_GameObj(x);
			int CallTime = GLOBALPHONETIMES[x]++;
			if (Commands->Get_Health(Player) > 0)
			{
				int chargepersec = Get_Int_Parameter("Charge_Per_Second");
				if (Get_Int_Parameter("Max_Call_Duration") < CallTime)
				{
					AutoCancelCall(obj,Player);
				}
				else if (CallTime % 60 == 0)
				{
					int totalcharge = (chargepersec + Get_Int_Parameter("Charge_Per_Minute"));
					if (Commands->Get_Money(Player) >= totalcharge)
					{
						Commands->Give_Money(Player,-(float)totalcharge,1);
					}
					else
					{
						Send_Message_Player(Player,127,255,0,"Signal Lost");
						AutoCancelCall(obj,Player);
					}
				}
				else if (Commands->Get_Money(Player) >= chargepersec)
				{
					Commands->Give_Money(Player,-(float)chargepersec,1);
				}
				else
				{
					Send_Message_Player(Player,127,255,0,"Signal Lost");
					AutoCancelCall(obj,Player);
				}
			}
			else
			{
				Commands->Send_Custom_Event(Player,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
			}
			Commands->Send_Custom_Event(Player,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);
		}
	}
}

void JMG_RP2_Flame_Thrower_Script::Created(GameObject *obj)
{
	Heat = 0;
	CoolDownDelay = 0;
	NeedsToCoolDown = 0;
	LastCount = 0;
	CoolDownRate = 1;
	HeatUpRate = 1;
	EXPGrowth = 1;
	HeatEXPGrowth = 1;
	FireID = 0;
	FlameThrowerID = 0;
	TankHealth = 10;
	for (int x = 0;x < 5;x++)
	{
		GiveTempWarnings[x] = 1;
	}
	Commands->Start_Timer(obj,this,0.1f,64254633);
}

void JMG_RP2_Flame_Thrower_Script::Timer_Expired(GameObject *obj,int number)
{
	if (64254633 == number)
	{
		if (!Commands->Get_Health(obj))
		{
			return;
		}
		const char *CurrentWeap = Get_Current_Weapon(obj);
		if (CurrentWeap)
		{
			if (!_stricmp(CurrentWeap,"Weapon_Flamethrower") && !Get_Vehicle(obj))
			{
				if (!FlameThrowerID)
				{					
					GameObject *FlameThrower = Commands->Create_Object("Flamethrower_Fuel_Tank",Commands->Get_Position(obj));
					Commands->Attach_To_Object_Bone(FlameThrower,obj,"backgunbone");
					Set_Max_Health(FlameThrower,10);
					Commands->Set_Health(FlameThrower,TankHealth);
					Set_Max_Shield_Strength(FlameThrower,0);
					Commands->Set_Shield_Strength(FlameThrower,0);
					Set_Skin(FlameThrower,"None");
					Commands->Set_Shield_Type(FlameThrower,"None");
					char params[256];
					sprintf(params,"%d",Commands->Get_ID(obj));
					Commands->Attach_Script(FlameThrower,"JMG_Remove_Object_When_Creator_Destroyed",params);
					FlameThrowerID = Commands->Get_ID(FlameThrower);
				}
				else
				{
					GameObject *FlameThrower = Commands->Find_Object(FlameThrowerID);
					if (!FlameThrower)
					{
						RP2WeaponListControl *Weapon = Get_WLS_Weapon_Settings("Weapon_Flamethrower");
						WLS_Add_Weapon_Weight(obj,Weapon,Get_Player_ID(obj));
						Commands->Select_Weapon(obj,"Weapon_Empty_Hands");
						Remove_Weapon(obj,"Weapon_Flamethrower");
						Commands->Create_Explosion("Explosion_Rocket_Heavy",Commands->Get_Bone_Position(obj,"backgunbone"),FlameThrower);
						TankHealth = 10;
						Reset_Script();
						FlameThrowerID = 0;
						if (Commands->Get_Health(obj))
						{
							Send_Message_Player(obj,255,175,0,"My flamethrower's fuel tank was damaged causing it to combust; thus my flamethrower has been destroyed!");
						}
					}
				}
			}
			else
			{
				GameObject *FlameThrower = Commands->Find_Object(FlameThrowerID);
				if (FlameThrower)
				{
					TankHealth = Commands->Get_Health(FlameThrower);
					Commands->Destroy_Object(FlameThrower);
					FlameThrowerID = 0;
				}
			}
		}
		if (Has_Weapon(obj,"Weapon_Flamethrower"))
		{
			int BulletCount = Get_Bullets(obj,"Weapon_Flamethrower");
			// Heat up
			if (BulletCount != LastCount)
			{
				Heat += HeatUpRate;
				if (EXPGrowth > 1)
				{
					EXPGrowth--;
				}
				if (Heat >= 500)
				{
					NeedsToCoolDown = 1;
					if (GiveTempWarnings[4])
					{
						GiveTempWarnings[4] = 0;
						//Send_Message_Player(obj,255,50,0,"Holy Crap! Its definitelyoverheated, better let it cool down!");
						TEMPDISABLEWEAPONDROP[Get_Player_ID(obj)] = 1;
						if (!FireID)
						{
							GameObject *Fire = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
							Commands->Attach_To_Object_Bone(Fire,obj,"gunbone");
							Commands->Set_Model(Fire,"exp_fire");
							char params[20];
							sprintf(params,"%d",Commands->Get_ID(obj));
							Commands->Attach_Script(Fire,"JMG_Remove_Object_When_Creator_Destroyed",params);
							FireID = Commands->Get_ID(Fire);
						}
					}
					Commands->Apply_Damage(obj,20.0f,"None",0);
					Commands->Send_Custom_Event(obj,obj,596911,5000,0);
					HeatWarningMessages(4);
				}
				HeatEXPGrowth++;
				if (HeatEXPGrowth >= 5)
				{
					HeatEXPGrowth = 1;
					if (HeatUpRate < 25)
					{
						HeatUpRate++;
					}
					if (CoolDownRate > 1)
					{
						CoolDownRate--;
					}
				}
				if (CoolDownDelay < 15)
				{
					CoolDownDelay++;
				}
			}
			// Cool down delay
			else if (CoolDownDelay > 0)
			{
				CoolDownDelay--;
			}
			// Cool down
			if (!CoolDownDelay && Heat > 0)
			{
				Heat -= CoolDownRate;
				if (Heat < 0)
				{
					Heat = 0;
				}
				EXPGrowth++;
				if (!(EXPGrowth % 5) && Heat <= 400)
				{
					if (HeatUpRate > 1)
					{
						HeatUpRate--;
					}
					if (HeatEXPGrowth > 1)
					{
						HeatEXPGrowth--;
					}
					if (EXPGrowth >= 10)
					{
						EXPGrowth = 1;
						if (CoolDownRate < 5)
						{
							CoolDownRate++;
						}
					}
				}
				if (EXPGrowth >= 10 && Heat > 400)
				{
					EXPGrowth = 1;
					if (CoolDownRate < 2)
					{
						CoolDownRate++;
					}
				}
				if (!Heat && HeatUpRate <= 1 && HeatEXPGrowth <= 1)
				{
					const char *CurrentWeap = Get_Current_Weapon(obj);
					if (CurrentWeap)
					{
						if (!_stricmp(CurrentWeap,"Weapon_Flamethrower"))
						{
							Send_Message_Player(obj,255,175,0,"My flamethrower is as cool as its going to get.");
						}
					}
				}
			}
			LastCount = BulletCount;
			if (Heat <= 400 && NeedsToCoolDown)
			{
				NeedsToCoolDown = 0;
				Send_Message_Player(obj,255,175,0,"Sure it quit burning, but it's still very hot, I should let it cool down more before using it.");
				TEMPDISABLEWEAPONDROP[Get_Player_ID(obj)] = 0;
				GameObject *Fire = Commands->Find_Object(FireID);
				if (Fire)
				{
					Commands->Destroy_Object(Fire);
				}
				FireID = 0;
			}
			if (NeedsToCoolDown)
			{
				Commands->Select_Weapon(obj,"");
				Commands->Select_Weapon(obj,"Weapon_Flamethrower");
			}
			else if (CoolDownDelay)
			{
				/*if (Heat >= 125 && Heat < 250)
				{
					if (GiveTempWarnings[0])
					{
						GiveTempWarnings[0] = 0;
						//Send_Message_Player(obj,255,175,0,"It seems to be getting a little warm, but I bet I can get a lot more out of it!");
					}
					HeatWarningMessages(0);
				}*/
				if (Heat >= 250 && Heat < 375)
				{
					if (GiveTempWarnings[1])
					{
						GiveTempWarnings[1] = 0;
						Send_Message_Player(obj,255,175,0,"It seems to be getting a bit hot, but I'm sure I can push it further!");
					}
					HeatWarningMessages(1);
				}
				/*if (Heat >= 375 && Heat < 450)
				{
					if (GiveTempWarnings[2])
					{
						GiveTempWarnings[2] = 0;
						//Send_Message_Player(obj,255,175,0,"It's definitely getting close to overheating now!");
					}
					HeatWarningMessages(2);
				}*/
				if (Heat >= 450)
				{
					if (GiveTempWarnings[3])
					{
						GiveTempWarnings[3] = 0;
						Send_Message_Player(obj,255,100,0,"It's definitely getting close to overheating now!");
						//Send_Message_Player(obj,255,100,0,"Odd, I have a feeling that this has no safety to keep it from overheating!");
					}
					HeatWarningMessages(3);
				}
			}
		}
		Commands->Start_Timer(obj,this,0.1f,64254633);
	}
}

void JMG_RP2_Flame_Thrower_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{	
	if (message == 3743374)
	{
		Commands->Send_Custom_Event(obj,obj,3743375,1,5);
	}
	if (message == 3743375)
	{
		if (!Has_Weapon(obj,"Weapon_Flamethrower"))
		{
			Reset_Script();
		}
	}
}

void JMG_RP2_Flame_Thrower_Script::HeatWarningMessages(int IgnoreNumber)
{
	for (int x = 0;x < 5;x++)
	{
		if (x != IgnoreNumber)
		{
			GiveTempWarnings[x] = 1;
		}
	}
}

void JMG_RP2_Flame_Thrower_Script::Reset_Script()
{
	Heat = 0;
	CoolDownDelay = 0;
	NeedsToCoolDown = 0;
	LastCount = 0;
	CoolDownRate = 1;
	HeatUpRate = 1;
	EXPGrowth = 1;
	HeatEXPGrowth = 1;
	FireID = 0;
	FlameThrowerID = 0;
	for (int x = 0;x < 5;x++)
	{
		GiveTempWarnings[x] = 1;
	}
}


void JMG_RP2_Fishing_Define_Fish::Created(GameObject *obj)
{
	New_Node();
}

void JMG_RP2_Fishing_Define_Fish::New_Node()
{
	if (!FishTypeNode)
	{
		FishTypeNode = new FishTypeControl;
		FishTypeNode->FishID = 0;
		FishTypeNode->OriginalProbability = Get_Int_Parameter("Fish_Probability");
		FishTypeNode->Size = Get_Int_Parameter("Fish_Size");
		FishTypeNode->Value = Get_Int_Parameter("Fish_Value");
		FishTypeNode->Damage = Get_Float_Parameter("Fish_Damage");
		sprintf(FishTypeNode->Model,"%s",Get_Parameter("Fish_Model"));
		sprintf(FishTypeNode->Name,"%s",Get_Parameter("Fish_Name"));
		FishTypeNode->next = NULL;
	}
	else
	{
		int end = 0,FishCount = 0;
		FishTypeControl *Current = FishTypeNode;
		while (Current != NULL && !end)
		{
			if (Current->next == NULL)
			{
				end = 1;
				Current->next = new FishTypeControl;
				Current = Current->next;
				TOTALFISHCOUNT = Current->FishID = (FishCount + 1);
				Current->OriginalProbability = Get_Int_Parameter("Fish_Probability");
				Current->Size = Get_Int_Parameter("Fish_Size");
				Current->Value = Get_Int_Parameter("Fish_Value");
				Current->Damage = Get_Float_Parameter("Fish_Damage");
				sprintf(Current->Model,"%s",Get_Parameter("Fish_Model"));
				sprintf(Current->Name,"%s",Get_Parameter("Fish_Name"));
				Current->next = NULL;
			}
			FishCount = Current->FishID;
			Current = Current->next;
		}
	}
	float TotalProbability = 0.0f;
	if (FishTypeNode)
	{
		FishTypeControl *Current = FishTypeNode;
		while (Current != NULL)
		{
			TotalProbability += Current->OriginalProbability;
			Current = Current->next;
		}
	}
	TotalProbability = 100 / TotalProbability;
	float StackedProbability = 0;
	if (FishTypeNode)
	{
		FishTypeControl *Current = FishTypeNode;
		while (Current != NULL)
		{
			Current->Probability = Current->OriginalProbability * TotalProbability;
			Current->Probability += StackedProbability;
			StackedProbability = Current->Probability;
			Current = Current->next;
		}
	}
}

void JMG_RP2_Fishing_School::Created(GameObject *obj)
{
	FishSchool = NULL;
	New_Node(obj);
	if (!FishSchool)
	{
		if (Is_Script_Attached(obj,"JMG_RP2_Fishing_School"))
		{
			Remove_Script(obj,"JMG_RP2_Fishing_School");
		}
		return;
	}
	FishSchool->FishType = Find_Node(Commands->Get_Random_Int(0,100));
	if (FishSchool->FishType)
	{
		Commands->Set_Model(obj,FishSchool->FishType->Model);
		Commands->Start_Timer(obj,this,1.0f,7154145);
		Commands->Start_Timer(obj,this,600.0f,7154146);
		Commands->Start_Timer(obj,this,0.1f,7154147);
	}
	else
	{
		if (Is_Script_Attached(obj,"JMG_RP2_Fishing_School"))
		{
			Remove_Script(obj,"JMG_RP2_Fishing_School");
		}
	}
	Commands->Disable_All_Collisions(obj);
}

void JMG_RP2_Fishing_School::Timer_Expired(GameObject *obj,int number)
{
	if (number == 7154145 && FishSchool->FishType)
	{
		if (!FishSchool->ZoneHealth)
		{
			Vector3 Pos = Commands->Get_Position(obj);
			Send_Custom_To_Boats(obj,Pos,7154149);
			Commands->Destroy_Object(obj);
			return;
		}
		Vector3 Pos = Commands->Get_Position(obj);
		for (int x = 1;x < 128;x++)
		{
			GameObject *Player = Get_GameObj(x);
			if (Player)
			{
				if (ISNEWSWIMMING[x] && !Get_Vehicle(Player))
				{
					if (Commands->Get_Distance(Pos,Commands->Get_Position(Player)) <= SCHOOLRADIUS)
					{
						if (Commands->Get_Health(Player) <= FishSchool->FishType->Damage)
						{
							char DeathMessage[256];
							const char *str = Get_Player_Name(Player);
							sprintf(DeathMessage,"%s was killed by a %s.",str,FishSchool->FishType->Name);
							delete[] str;
							RP2_Player_Death_Message_Control(Player,DeathMessage,0);
							Commands->Apply_Damage(Player,9999.9f,"SwimmingDamage",0);
						}
						Commands->Apply_Damage(Player,FishSchool->FishType->Damage,"SwimmingDamage",0);
					}
				}
			}
		}
		Send_Custom_To_Boats(obj,Pos,7154145);
		Commands->Start_Timer(obj,this,1.0f,7154145);
	}
	if (number == 7154146 && FishSchool->FishType)
	{
		if (FishSchool->ZoneHealth == 100)
		{
			Commands->Destroy_Object(obj);
		}
	}
	if (number == 7154147 && FishSchool->FishType)
	{
		Vector3 Pos = Commands->Get_Position(obj);
		Send_Custom_To_Boats(obj,Pos,7154147);
		Commands->Start_Timer(obj,this,0.1f,7154147);
	}
}

void JMG_RP2_Fishing_School::Send_Custom_To_Boats(GameObject *obj,Vector3 Pos,int message)
{
	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
	while (x)
	{
		GameObject *TempVehicle = x->Data()->As_ScriptableGameObj();
		if (TempVehicle)
		{
			if ((TempVehicle->As_PhysicalGameObj() && TempVehicle->As_PhysicalGameObj()->Peek_Physical_Object() && TempVehicle->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
			{
				if (Commands->Get_Distance(Pos,Commands->Get_Position(TempVehicle)) <= SCHOOLRADIUS)
				{
					Commands->Send_Custom_Event(obj,TempVehicle,message,FishSchool->SchoolID,0);
				}
			}
		}
		x = x->Next();
	}
}

FishTypeControl *JMG_RP2_Fishing_School::Find_Node(int Probability)
{
	if (FishTypeNode)
	{
		float LastFishProb = 0.0;
		FishTypeControl *Current = FishTypeNode;
		while (Current != NULL)
		{
			if (Probability <= Current->Probability && Probability >= LastFishProb)
			{
				return Current;
			}
			LastFishProb = Current->Probability;
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Fishing_School::New_Node(GameObject *obj)
{
	if (!FishSchoolNode)
	{
		FishSchoolNode = new FishSchoolControl;
		FishSchoolNode->SchoolID = Commands->Get_ID(obj);
		FishSchoolNode->ZoneHealth = 100;
		FishSchoolNode->FishType = NULL;
		FishSchoolNode->next = NULL;
		FishSchool = FishSchoolNode;
	}
	else
	{
		int end = 0;
		FishSchoolControl *Current = FishSchoolNode;
		while (Current != NULL && !end)
		{
			if (Current->SchoolID == Commands->Get_ID(obj))
			{
				end = 1;
				Current->ZoneHealth = 100;
				Current->FishType = NULL;
				FishSchool = Current;
			}
			else if (Current->next == NULL)
			{
				end = 1;
				Current->next = new FishSchoolControl;
				Current = Current->next;
				Current->SchoolID = Commands->Get_ID(obj);
				Current->ZoneHealth = 100;
				Current->FishType = NULL;
				Current->next = NULL;
				FishSchool = Current;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Fishing_Boat::Created(GameObject *obj)
{
	FishPayLoad = 0;
	FishMarketValue = 0;
	FullLoadMessage = 0;
	CurrentSchool = NULL;
	MessageDelay = 0;
	Commands->Start_Timer(obj,this,0.2f,7154142);
}

void JMG_RP2_Fishing_Boat::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == 7154148)
	{
		char Message[256];
		sprintf(Message,"Boat Capacity %d/%d",FishPayLoad,Get_Int_Parameter("Boat_Capacity"));
		Send_Message_Player(sender,200,200,125,Message);
		sprintf(Message,"Catch Value $%.2f",FishMarketValue);
		Send_Message_Player(sender,200,200,125,Message);
	}
	if (message == 7154149 && param)
	{
		FishSchoolControl *School = Find_School(param);
		if (School)
		{
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver)
			{
				char Message[236];
				sprintf(Message,"I think the %s in this spot are all gone, I better find a new spot!",School->FishType->Name);
				Send_Message_Player(Driver,0,127,255,Message);
			}
		}
	}
	if (message == 7154147 && param && FishPayLoad < Get_Int_Parameter("Boat_Capacity"))
	{
		FishSchoolControl *School = Find_School(param);
		if (School)
		{
			GameObject *Driver = Get_Vehicle_Driver(obj);
			if (Driver && !MessageDelay)
			{
				char Message[236];
				sprintf(Message,"I am catching %s.",School->FishType->Name);
				Send_Message_Player(Driver,0,127,255,Message);
				CurrentSchool = School;
			}
			MessageDelay = 5;
		}
	}
	if (message == 7154145 && param)
	{
		FishSchoolControl *School = Find_School(param);
		if (School)
		{
			if (FishPayLoad + School->FishType->Size <= Get_Int_Parameter("Boat_Capacity"))
			{
				FullLoadMessage = 0;
				School->ZoneHealth -= School->FishType->Size;
				FishPayLoad += School->FishType->Size;
				FishMarketValue += School->FishType->Value;
			}
			else if (FishPayLoad < Get_Int_Parameter("Boat_Capacity") && !FullLoadMessage)
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					FullLoadMessage = 1;
					char Message[236];
					sprintf(Message,"My boat is too full to take on any more %s, but if I can a smaller catch I'm sure I can top it off.",School->FishType->Name);
					Send_Message_Player(Driver,0,127,255,Message);
				}
			}
			else if (!FullLoadMessage)
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					FullLoadMessage = 1;
					Send_Message_Player(Driver,0,127,255,"My boat is completly full, time to return to the docks and sell this catch.");
				}
			}
		}
	}
	if (message == 7154146)
	{
		GameObject *Driver = Get_Vehicle_Driver(obj);
		if (Driver && FishMarketValue)
		{
			char Message[236];
			sprintf(Message,"I have sold my catch for $%.2f credits.",FishMarketValue);
			Send_Message_Player(Driver,0,127,255,Message);
			Commands->Give_Money(Driver,FishMarketValue,true);
			FishPayLoad = 0;
			FishMarketValue = 0;
		}
	}
}

void JMG_RP2_Fishing_Boat::Timer_Expired(GameObject *obj,int number)
{
	if (number == 7154142)
	{
		if (MessageDelay)
		{
			MessageDelay--;
			if (!MessageDelay)
			{
				if (CurrentSchool)
				{
					GameObject *Driver = Get_Vehicle_Driver(obj);
					if (Driver)
					{
						char Message[236];
						sprintf(Message,"I am no longer catching %s.",CurrentSchool->FishType->Name);
						Send_Message_Player(Driver,0,127,255,Message);
					}
				}
				CurrentSchool = NULL;
			}
		}
		Commands->Start_Timer(obj,this,0.2f,7154142);
	}
}

FishSchoolControl *JMG_RP2_Fishing_Boat::Find_School(int SchoolID)
{
	if (FishSchoolNode)
	{
		FishSchoolControl *Current = FishSchoolNode;
		while (Current != NULL)
		{
			if (Current->SchoolID == SchoolID)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Fishing_Random_School_Generator::Created(GameObject *obj)
{
	for (int x = 0;x < NUMBEROFSCHOOLS;x++)
	{
		SchoolIDs[x] = 0;
	}
	if (Check_For_Zones())
	{
		Commands->Start_Timer(obj,this,5.0f,7154142);
	}
}

void JMG_RP2_Fishing_Random_School_Generator::Timer_Expired(GameObject *obj,int number)
{
	if (number == 7154142)
	{
		Commands->Start_Timer(obj,this,0.1f,7154142);
		for (int x = 0;x < NUMBEROFSCHOOLS;x++)
		{
			GameObject *FSchool = Commands->Find_Object(SchoolIDs[x]);
			if (!FSchool)
			{
				FSchool = Commands->Create_Object("Invisible_Box",Find_Zone_For_Fish());
				SchoolIDs[x] = Commands->Get_ID(FSchool);
				Commands->Attach_Script(FSchool,"JMG_RP2_Fishing_School","");
				return;
			}
		}
	}
}

Vector3 JMG_RP2_Fishing_Random_School_Generator::Find_Zone_For_Fish()
{
	int TooLong = 0;
	SLNode<ScriptZoneGameObj> *x = GameObjManager::ScriptZoneGameObjList.Head();
	while (x)
	{
		GameObject *TempZone = x->Data();
		if (TempZone)
		{
			if (Is_Script_Attached(TempZone,"JMG_New_Swimming_Zone") && !Is_Script_Attached(TempZone,"JMG_RP2_Fishing_No_Fish_Zone"))
			{
				TooLong++;
				if ((Is_Script_Attached(TempZone,"JMG_RP2_Fishing_Fish_Zone_25Percent") && Commands->Get_Random(0,100) < 3.75) || TooLong > 500)
				{
					return CreateSpot(TempZone);
				}
				else if (Is_Script_Attached(TempZone,"JMG_RP2_Fishing_Fish_Zone_50Percent") && Commands->Get_Random(0,100) < 7.5)
				{
					return CreateSpot(TempZone);
				}
				else if (!Is_Script_Attached(TempZone,"JMG_RP2_Fishing_Fish_Zone_25Percent") && ! Is_Script_Attached(TempZone,"JMG_RP2_Fishing_Fish_Zone_50Percent") && Commands->Get_Random(0,100) < 15)
				{
					return CreateSpot(TempZone);
				}
			}
		}
		x = x->Next();
		if (!x)
		{
			x = GameObjManager::ScriptZoneGameObjList.Head();
		}
	}
	return Vector3(0,0,0);
}

int JMG_RP2_Fishing_Random_School_Generator::Check_For_Zones()
{
	SLNode<ScriptZoneGameObj> *x = GameObjManager::ScriptZoneGameObjList.Head();
	while (x)
	{
		GameObject *TempZone = x->Data();
		if (TempZone)
		{
			if (Is_Script_Attached(TempZone,"JMG_New_Swimming_Zone") && !Is_Script_Attached(TempZone,"JMG_RP2_Fishing_No_Fish_Zone"))
			{
				return 1;
			}
		}
		x = x->Next();
	}
	return 0;
}
Vector3 JMG_RP2_Fishing_Random_School_Generator::CreateSpot(GameObject *TempZone)
{
	OBBoxClass *ZZBox = Get_Zone_Box(TempZone);
	Vector3 Pos2;
	Pos2.X = Commands->Get_Random((0.0f-ZZBox->Extent.X),ZZBox->Extent.X);
	Pos2.Y = Commands->Get_Random((0.0f-ZZBox->Extent.Y),ZZBox->Extent.Y);
	Pos2.Z = ZZBox->Center.Z+(ZZBox->Extent.Z);
	if (ZZBox->Basis[0][1] && ZZBox->Basis[0][0] > -1)
	{
		/*float Rotation = (acos(ZZBox->Basis[0][0])*180.0f/PI);
		float Rotation2 = (asin(ZZBox->Basis[0][1])*180.0f/PI);
		float TempRotation = (atan2(-Pos2.Y,-Pos2.X)*180.0f/PI);
		char Debug[257];
		sprintf(Debug,"MESSAGE Zone Roataion:%.2f BouyRoationFromZoneCenter:%.2f Position:X%.2f Y%.2f",Rotation,TempRotation,Pos2.Y,Pos2.X);
		Console_Input(Debug);
		Rotation += TempRotation;
		Rotation2 += TempRotation;
		Rotation *= PI180.0f;
		Rotation2 *= PI180.0f;
		Pos2.X = (cos(Rotation)*Pos2.X);
		Pos2.Y = (sin(Rotation2)*Pos2.Y);*/
		float Temp = Pos2.Y;
		Pos2.Y = Pos2.X;
		Pos2.X = Temp;
	}
	Pos2.X += ZZBox->Center.X;
	Pos2.Y += ZZBox->Center.Y;
	while (Pos2.Y < -4900)
	{
		Pos2.Y += 1000;
	}
	while (Pos2.Y > 4900)
	{
		Pos2.Y -= 1000;
	}
	while (Pos2.X < -4900)
	{
		Pos2.X += 1000;
	}
	while (Pos2.X > 4900)
	{
		Pos2.X -= 1000;
	}
	return Pos2;
}

void JMG_RP2_Fishing_No_Fish_Zone::Created(GameObject *obj)
{
	//Dummy Script
}

void JMG_RP2_Fishing_Unload_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if ((enter->As_PhysicalGameObj() && enter->As_PhysicalGameObj()->Peek_Physical_Object() && enter->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
	{
		Commands->Send_Custom_Event(obj,enter,7154146,0,0);
	}
}

void JMG_RP2_Fishing_Fish_Zone_50Percent::Created(GameObject *obj)
{
	//Dummy Script
}

void JMG_RP2_Fishing_Fish_Zone_25Percent::Created(GameObject *obj)
{
	//Dummy Script
}

void JMG_RP2_Phone_Player_Call_Tactical_Nuke::Custom(GameObject *obj,int message,int param,GameObject *sender)
{						
	if (PhoneNumbers)
	{
		int end = 0;
		int PlayerID = Get_Player_ID(sender);
		PhoneNumberControl *Current = PhoneNumbers;
		while (Current != NULL && !end)
		{
			if (PlayerID == Current->PlayerID && !Current->StarPressed)// match
			{
				if (10 == Current->PhoneNumberLength)
				{
					end = 1;
					GameObject *TargetObject = Commands->Find_Object(atoi(Current->PhoneNumber));
					if (TargetObject && Is_Script_Attached(TargetObject,"JMG_RP2_Tactical_Nuke_Phone_Triggered"))
					{
						Commands->Send_Custom_Event(obj,sender,PHONETriggerBomb,atoi(Current->PhoneNumber),0);// Send Message with contact ID
					}
				}
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Tactical_Nuke_Phone_Triggered::Created(GameObject *obj)
{
	char TempNumber[256];
	int MyID = Commands->Get_ID(obj);
	sprintf(TempNumber,"%d",MyID);
	JMG_RP2_Phone_Advanced_Phone_Number_Control_System *Format_PhoneNumber = 0;
	char TempNumber2[256];
	sprintf(TempNumber2,"%s",Format_PhoneNumber->FormatPhoneNumber(TempNumber));
	sprintf(TempNumber,"%s - detonate this bomb!",TempNumber2);
	int BeaconID = Find_Nearest_Beacon_ID(obj);
	if (BeaconID)
	{
		GameObject *Planter = Get_Beacon_Planter(Commands->Find_Object(BeaconID));
		if (Planter)
		{
			Send_Message_Player(Planter,200,50,50,TempNumber);
			if (Has_Weapon(Planter,"Weapon_Tactical_Nuke"))
			{
				Set_Bullets(Planter,"Weapon_Tactical_Nuke",Get_Bullets(Planter,"Weapon_Tactical_Nuke")-1);
			}
			JMG_RP2_Phone_Player_Special_Phone_Number *NodeController = 0;
			PlayerSpecificPNControl *PNDataNode = NodeController->Add_Node(MyID);
			if (PNDataNode)
			{
				sprintf(PNDataNode->Message,"%s",TempNumber);
				const char *str = Get_Player_Name(Planter);
				sprintf(PNDataNode->PlayerName,"%s",str);
				delete[] str;
			}
		}
	}
	Commands->Set_Animation(obj,"ABomb.ABomb",1,0,0,1,1);
	RingSoundID = 0;
	OwnerID = 0;
	Animating = 0;
}

void JMG_RP2_Tactical_Nuke_Phone_Triggered::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 40860544)// Connect
	{
		GameObject *Owner = Commands->Find_Object(OwnerID);
		if (Owner)
		{
			Commands->Send_Custom_Event(obj,sender,PHONELineBusy,1,0);// Line is busy
			return;
		}
		OwnerID = Commands->Get_ID(sender);
	}
	if (message == PHONEBombPhoneRing && !Animating)// Start Ring
	{
		Animating = 1;
		Commands->Set_Animation(obj,"ABomb.ABomb",1,0,2,3,1);
		if (!RingSoundID)
		{
			RingSoundID = Repeating_Sound_Object(obj,"Phone_Ring_Y_E");
		}
	}
	if (message == PHONEBombDetonate)// Blow Up
	{
		Commands->Send_Custom_Event(obj,sender,PHONESendSenderTheDisconnectSignal,1,0);// Give sender disconnect signal
		OwnerID = 0;
		Remove_Repeating_Sound_Object(&RingSoundID);
		Vector3 Pos = Commands->Get_Position(obj);
		Commands->Create_Explosion("Explosion_Panther_Flamethrower",Pos,sender);
		Commands->Create_Explosion("Proximity Mine Explosion Twiddler",Pos,sender);
		Commands->Create_Explosion("Proximity Mine Explosion Twiddler",Pos,sender);
		for (int x = 0;x < 100;x++)
		{
			Pos = Commands->Get_Position(obj);
			float Distance = Commands->Get_Random(0,50);
			float Rotation = Commands->Get_Random(-180.0,180);
			Pos.X += cos(Rotation*PI180)*Distance;
			Pos.Y += sin(Rotation*PI180)*Distance;
			Commands->Create_Explosion("Ground_Explosions_Twiddler",Pos,sender);
		}
		for (int x = 0;x < 50;x++)
		{
			Pos = Commands->Get_Position(obj);
			float Distance = Commands->Get_Random(0,25);
			float Rotation = Commands->Get_Random(-180.0,180);
			Pos.X += cos(Rotation*PI180)*Distance;
			Pos.Y += sin(Rotation*PI180)*Distance;
			Pos.Z += Commands->Get_Random(-10.0,10.0);
			Commands->Create_Explosion("Ground_Explosions_Twiddler",Pos,sender);
		}
		for (int x = 0;x < 25;x++)
		{
			Pos = Commands->Get_Position(obj);
			float Distance = Commands->Get_Random(0,12.5);
			float Rotation = Commands->Get_Random(-180.0,180);
			Pos.X += cos(Rotation*PI180)*Distance;
			Pos.Y += sin(Rotation*PI180)*Distance;
			Pos.Z += Commands->Get_Random(-25.0,25.0);
			Commands->Create_Explosion("Ground_Explosions_Twiddler",Pos,sender);
		}
		for (int x = 0;x < 25;x++)
		{
			Pos = Commands->Get_Position(obj);
			float Distance = Commands->Get_Random(0,12.5);
			float Rotation = Commands->Get_Random(-180.0,180);
			Pos.X += cos(Rotation*PI180)*Distance;
			Pos.Y += sin(Rotation*PI180)*Distance;
			Pos.Z += Commands->Get_Random(-25.0,25.0);
			Commands->Create_Explosion("Explosion_NukeBeacon",Pos,sender);
		}
		Pos = Commands->Get_Position(obj);
		Commands->Create_Explosion("Explosion_Tactical_Nuke_Innital_Blast",Pos,sender);
		Commands->Create_Explosion("Explosion_Tactical_Nuke_Innital_Blast",Pos,sender);
		GameObject *Radiation = Commands->Create_Object("Daves_Arrow_NT",Pos);
		char params[256];
		sprintf(params,"%d",Get_Player_ID(sender));
		Commands->Attach_Script(Radiation,"JMG_RP2_Tactical_Nuke_Radiation",params);
		Trigger_Vehicle_EMP(obj);
		if (obj)
		{
			JMG_RP2_Phone_Player_Special_Phone_Number *NodeController = 0;
			NodeController->Delete_Node(Commands->Get_ID(obj));
			Commands->Destroy_Object(obj);
		}
	}
	if (message == 40860543)// Lost Sender Connection
	{
		Animating = 0;
		Commands->Set_Animation(obj,"ABomb.ABomb",1,0,0,0,1);
		OwnerID = 0;
		Remove_Repeating_Sound_Object(&RingSoundID);
	}
}

void JMG_RP2_Tactical_Nuke_Phone_Triggered::Killed(GameObject *obj, GameObject *damager)
{
	if (damager != obj)
	{
		GameObject *Owner = Commands->Find_Object(OwnerID);
		if (Owner)
		{
			Commands->Send_Custom_Event(obj,Owner,PHONESendSenderTheDisconnectSignal,1,0);// Give sender disconnect signal
			Owner = 0;
		}
	}
	Remove_Repeating_Sound_Object(&RingSoundID);
	JMG_RP2_Phone_Player_Special_Phone_Number *NodeController = 0;
	NodeController->Delete_Node(Commands->Get_ID(obj));
}

int JMG_RP2_Tactical_Nuke_Phone_Triggered::Find_Nearest_Beacon_ID(GameObject *obj)
{
	if (!obj)
	{
		return 0;
	}
	Vector3 BeaconPosition = Commands->Get_Position(obj);
	float NearDist = 9999.0f;
	GameObject *TargetBeacon = NULL;
	SLNode<BeaconGameObj> *Current = GameObjManager::BeaconGameObjList.Head();
	while (Current)
	{
		GameObject *ObjectNode = Current->Data()->As_ScriptableGameObj();
		if (ObjectNode)
		{
			Vector3 Pos = Commands->Get_Position(ObjectNode);
			float Distance = Commands->Get_Distance(BeaconPosition,Pos);
			if (Distance < NearDist)
			{
				NearDist = Distance;
				TargetBeacon = ObjectNode;
			}
		}
		Current = Current->Next();
	}
	if (TargetBeacon)
	{
		return Commands->Get_ID(TargetBeacon);
	}
	return 0;
}

int JMG_RP2_Tactical_Nuke_Phone_Triggered::Repeating_Sound_Object(GameObject *obj,const char *Model)
{
	Vector3 pos;
	char params[20];
	sprintf(params,"%d",Commands->Get_ID(obj));
	GameObject *SoundObject = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(SoundObject,Model);
	Commands->Attach_To_Object_Bone(SoundObject,obj,"c R Hand");	
	Commands->Attach_Script(SoundObject,"JMG_Remove_Object_When_Creator_Destroyed",params);
	int ID = Commands->Get_ID(SoundObject);
	return ID;
}

void JMG_RP2_Tactical_Nuke_Phone_Triggered::Remove_Repeating_Sound_Object(int *ID)
{
	GameObject *SoundObject = Commands->Find_Object(*ID);
	if (SoundObject)
	{
		Commands->Destroy_Object(SoundObject);
	}
	*ID = 0;
}

void JMG_RP2_Tactical_Nuke_Phone_Triggered::Trigger_Vehicle_EMP(GameObject *obj)
{
	if (!obj)
	{
		return;
	}
	Vector3 Pos = Commands->Get_Position(obj);
	SLNode<BaseGameObj> *Current = GameObjManager::GameObjList.Head();
	while (Current)
	{
		GameObject *Object = Current->Data()->As_ScriptableGameObj();
		if (Object)
		{
			if (Object->As_VehicleGameObj())
			{
				if (Commands->Get_Distance(Pos,Commands->Get_Position(Object)) <= (float)EMPRANGE)
				{
					Commands->Send_Custom_Event(obj,Object,EMPMESSAGE,EMPRANGE,0);
				}
			}
		}
		Current = Current->Next();
	}
}

void JMG_RP2_Tactical_Nuke_Phone_Beacon::Created(GameObject *obj)
{
	int BeaconID = Find_Nearest_Beacon_ID(obj);
	if (BeaconID)
	{
		GameObject *Planter = Get_Beacon_Planter(Commands->Find_Object(BeaconID));
		if (Planter)
		{
			Vector3 Pos = Commands->Get_Position(Planter);
			Pos.Z += 0.081f;
			GameObject *Bomb = Commands->Create_Object("Flamethrower_Fuel_Tank",Pos);
			Commands->Set_Model(Bomb,"ABomb");
			Commands->Set_Facing(Bomb,Commands->Get_Facing(Planter));
			Commands->Attach_Script(Bomb,"JMG_RP2_Tactical_Nuke_Phone_Triggered","");
			Commands->Apply_Damage(obj,9999.9f,"BlamoKiller",0);
		}
	}
}

int JMG_RP2_Tactical_Nuke_Phone_Beacon::Find_Nearest_Beacon_ID(GameObject *obj)
{
	if (!obj)
	{
		return 0;
	}
	Vector3 BeaconPosition = Commands->Get_Position(obj);
	float NearDist = 9999.0f;
	GameObject *TargetBeacon = NULL;
	SLNode<BeaconGameObj> *Current = GameObjManager::BeaconGameObjList.Head();
	while (Current)
	{
		GameObject *ObjectNode = Current->Data()->As_ScriptableGameObj();
		if (ObjectNode)
		{
			Vector3 Pos = Commands->Get_Position(ObjectNode);
			float Distance = Commands->Get_Distance(BeaconPosition,Pos);
			if (Distance < NearDist)
			{
				NearDist = Distance;
				TargetBeacon = ObjectNode;
			}
		}
		Current = Current->Next();
	}
	if (TargetBeacon)
	{
		return Commands->Get_ID(TargetBeacon);
	}
	return 0;
}

void JMG_RP2_Phone_Player_Special_Phone_Number::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == PHONERequestKnownPhoneNumberList && param == 3)
	{
		Search_List(sender);
	}
}

void JMG_RP2_Phone_Player_Special_Phone_Number::Search_List(GameObject *obj)
{
	char PlayerName[256];
	const char *str = Get_Player_Name(obj);
	sprintf(PlayerName,"%s",str);
	delete[] str;
	if (PlayerSpecificPNNode)
	{
		PlayerSpecificPNControl *Current = PlayerSpecificPNNode;
		while (Current != NULL)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				Send_Message_Player(obj,127,255,0,Current->Message);
			}
			Current = Current->next;
		}
	}
}

PlayerSpecificPNControl *JMG_RP2_Phone_Player_Special_Phone_Number::Add_Node(int ID)
{
	if (!PlayerSpecificPNNode)
	{
		PlayerSpecificPNNode = new PlayerSpecificPNControl;
		PlayerSpecificPNNode->AttachedID = ID;
		PlayerSpecificPNNode->next = NULL;
		return PlayerSpecificPNNode;
	}
	else
	{
		PlayerSpecificPNControl *Current = PlayerSpecificPNNode;
		while (Current != NULL)
		{
			if (Current->AttachedID == ID)
			{
				return Current;
			}
			else if (Current->next == NULL)
			{
				Current->next = new PlayerSpecificPNControl;
				Current = Current->next;
				Current->AttachedID = ID;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Phone_Player_Special_Phone_Number::Delete_Node(int DeleteID)
{
	if (RP2PhoneMissionNode)
	{
		PlayerSpecificPNControl *Current = PlayerSpecificPNNode,*OldCurrent = NULL;
		while (Current != NULL)
		{
			if (Current->AttachedID == DeleteID)
			{
				// Delete the MISSION NODE!
				if (!OldCurrent && !Current->next)// Delete Only Node in list
				{
					delete Current;
					PlayerSpecificPNNode = NULL;
					return;
				}
				else if (!OldCurrent && Current->next)// Delete the head of the node list
				{
					PlayerSpecificPNNode = Current->next;
					delete Current;
					return;
				}
				else if (OldCurrent && Current->next)// Delete Middle Of List
				{
					OldCurrent->next = Current->next;
					delete Current;
					return;
				}
				else if (OldCurrent && !Current->next)// Delete End Of List
				{
					OldCurrent->next = NULL;
					delete Current;
					return;
				}
			}
			OldCurrent = Current;
			Current = Current->next;
		}
	}
}

void JMG_RP2_Favorite_Vehicle_Main_Control_System::Created(GameObject *obj)
{
	FILE *FavVehicleFile;
	FavVehicleFile = fopen("Data/RolePlay2/BetaFavoriteVehicles.RP2","r");
	if (FavVehicleFile)
	{
		while (!feof(FavVehicleFile))
		{
			int VehicleCost,EncryptFactor;
			char TempString[256];
			fscanf(FavVehicleFile,"%d\n",&VehicleCost);
			EncryptFactor = VehicleCost/10+1;
			fread(TempString,256,1,FavVehicleFile);
			PlayerFavoriteVehicleControl *ANode = Add_Node(Decrypt(TempString,EncryptFactor,3));
			ANode->VehicleCost = VehicleCost;
			fread(TempString,256,1,FavVehicleFile);
			sprintf(ANode->VehiclePreset,"%s",Decrypt(TempString,EncryptFactor,4));
			fread(TempString,256,1,FavVehicleFile);
			sprintf(ANode->VehicleName,"%s",Decrypt(TempString,EncryptFactor,5));
			fscanf(FavVehicleFile,"\n");
		}
		fclose(FavVehicleFile);
	}
}

PlayerFavoriteVehicleControl *JMG_RP2_Favorite_Vehicle_Main_Control_System::Add_Node(const char *PlayerName)
{
	if (!PlayerFavoriteVehicleNode)
	{
		PlayerFavoriteVehicleNode = new PlayerFavoriteVehicleControl;
		sprintf(PlayerFavoriteVehicleNode->PlayerName,"%s",PlayerName);
		PlayerFavoriteVehicleNode->next = NULL;
		return PlayerFavoriteVehicleNode;
	}
	else
	{
		PlayerFavoriteVehicleControl *Current = PlayerFavoriteVehicleNode;
		while (Current != NULL)
		{
			if (!_stricmp(PlayerName,Current->PlayerName))
			{
				return Current;
			}
			else if (Current->next == NULL)
			{
				Current->next = new PlayerFavoriteVehicleControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

char *JMG_RP2_Favorite_Vehicle_Main_Control_System::Decrypt(const char *String,int EncryptionFactor,int Start)
{
	static char FinalString[2000];
	int loops = strlen(String),x = 0;
	int CurrentAdd = Start;
	while (x < loops)
	{
		if (String[x] != '\0' && String[x] != '\n')
		{
			char Temp = (String[x]-(char)CurrentAdd);
			while (Temp < 32)
			{
				Temp += 125;
			}
			FinalString[x] = Temp;
			CurrentAdd++;
			if (CurrentAdd > EncryptionFactor)
			{
				CurrentAdd = 1;
			}
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
		FinalString[x] = '\0';
	}
	return FinalString;
}

PlayerFavoriteVehicleControl *JMG_RP2_Favorite_Vehicle_Main_Control_System::Find_Node(const char *PlayerName)
{
	if (PlayerFavoriteVehicleNode)
	{
		PlayerFavoriteVehicleControl *Current = PlayerFavoriteVehicleNode;
		while (Current != NULL)
		{
			if (!_stricmp(PlayerName,Current->PlayerName))
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Soldier_Set_Favorite_Vehicle::Custom(GameObject *obj,int message,int param,GameObject *sender)
{						
	if (message == 5656565)
	{
		GameObject *MyVehicle = Get_Vehicle(obj);
		RP2VehicleControl *ANode = Get_Vehicle_Node(MyVehicle);
		if (!ANode)
		{
			if (MyVehicle)
			{
				Send_Message_Player(obj,127,255,0,"Sorry, you cannot set this vehicle as your favorite!");
			}
			return;
		}
		if (ANode->IsWarthog == 2)
		{
			WarthogControl *MyNode = Get_Warthog_Node(MyVehicle);
			if (MyNode)
			{
				MyVehicle = Commands->Find_Object(MyNode->BodyID);
			}
		}
		if (Is_Script_Attached(MyVehicle,"JMG_Sell_Vehicle_On_Custom") || Is_Script_Attached(MyVehicle,"JMG_RP2_Housing_Vehicle_Key_Press"))
		{
			return;
		}
		if (Is_Script_Attached(MyVehicle,"JMG_Vehicle_Sell_Price") && !Is_Script_Attached(MyVehicle,"JMG_RP2_Disallow_Favorite_Vehicle"))
		{
			Commands->Send_Custom_Event(obj,MyVehicle,3057911,0,0);
		}
		else
		{
			Send_Message_Player(obj,127,255,0,"Sorry, you cannot set this vehicle as your favorite!");
		}
	}
	if (message == 3057911)
	{
		JMG_RP2_Favorite_Vehicle_Main_Control_System *OScript = 0;
		const char *str = Get_Player_Name(obj);
		PlayerFavoriteVehicleControl *ANode = OScript->Add_Node(str);
		delete[] str;
		if (ANode)
		{
			sprintf(ANode->VehiclePreset,"%s",Commands->Get_Preset_Name(sender));
			const char *str2 = Get_Translated_Preset_Name(sender);
			sprintf(ANode->VehicleName,"%s",str2);
			delete[] str2;
			ANode->VehicleCost = param;
			char Text[236];
			sprintf(Text,"Your favorite vehicle has been set to a %s!",ANode->VehicleName);
			Send_Message_Player(obj,127,255,0,Text);
		}
	}
}

void JMG_RP2_Phone_Buy_Favorite_Vehicle::Created(GameObject *obj)
{
	JMG_RP2_Phone_Advanced_Phone_Number_Control_System *OScript = 0;
	sprintf(PhoneNumber,"%s",OScript->FormatPhoneNumber("5557000"));
	delete OScript;
}

void JMG_RP2_Phone_Buy_Favorite_Vehicle::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (7 == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,"5557000"))
						{
							end = 1;
							JMG_RP2_Favorite_Vehicle_Main_Control_System *OScript = 0;
							const char *str = Get_Player_Name(sender);
							if (!OScript->Find_Node(str))
							{
								delete OScript;
								delete[] str;
								return;
							}
							delete[] str;
							delete OScript;
							sprintf(Current->PhoneNumber,"%s - Buy your favorite vehicle.",Current->PhoneNumber);
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONECallStartCustom && param == 0 && PhoneNumbers)
	{
		int end = 0;
		int PlayerID = Get_Player_ID(sender);
		PhoneNumberControl *Current = PhoneNumbers;
		while (Current != NULL && end == 0)
		{
			if (PlayerID == Current->PlayerID)// match
			{
				if (7 == Current->PhoneNumberLength)
				{
					if (!_stricmp(Current->PhoneNumber,"5557000"))
					{
						end = 1;
						JMG_RP2_Favorite_Vehicle_Main_Control_System *OScript = 0;
						const char *str = Get_Player_Name(sender);
						if (!OScript->Find_Node(str))
						{
							delete OScript;
							delete[] str;
							return;
						}
						delete[] str;
						delete OScript;
						if (Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")) < Get_Int_Parameter("Max_Callers"))
						{
							GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
							GLOBALPHONETIMES[PlayerID] = 0;
							Commands->Send_Custom_Event(sender,obj,Get_Int_Parameter("Script_ID"),PlayerID,(Get_Float_Parameter("Pickup_Delay")+Commands->Get_Random(0.0f,Get_Float_Parameter("Max_Random_Pickup_Delay"))));
						}
						else
						{
							for (int x = 1;x < 128;x++)
							{
								if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
								{
									GameObject *Player = Get_GameObj(x);
									Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
								}
							}
							Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
						}
					}
				}
			}
			Current = Current->next;
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && param == 2)
	{
		JMG_RP2_Favorite_Vehicle_Main_Control_System *OScript = 0;
		const char *str = Get_Player_Name(sender);
		PlayerFavoriteVehicleControl *ANode = OScript->Find_Node(str);
		delete[] str;
		delete OScript;
		if (!ANode)
		{
			return;
		}
		char Text[236];
		sprintf(Text,"%s - *Favorite* Buy a %s for %d.",PhoneNumber,ANode->VehicleName,ANode->VehicleCost);
		Send_Message_Player(sender,127,255,0,Text);
	}
	if (message == Get_Int_Parameter("Script_ID"))// First Step
	{
		if (GLOBALPHONELINES[Get_Player_ID(sender)] != Get_Int_Parameter("Script_ID"))
		{
			return;
		}
		Send_Message_Player(sender,127,255,0,"Thank you for calling the automated vehicle distribution center, will it be the usual today?");
		JMG_RP2_Favorite_Vehicle_Main_Control_System *OScript = 0;
		const char *str = Get_Player_Name(sender);
		PlayerFavoriteVehicleControl *ANode = OScript->Find_Node(str);
		delete[] str;
		delete OScript;
		if (!ANode)
		{
			return;
		}
		delete OScript;
		char Text[236];
		sprintf(Text,"Are you sure you would like to buy a %s for %d? ([1]Yes [2]No)",ANode->VehicleName,ANode->VehicleCost);
		Send_Message_Player(sender,127,255,0,Text);

		Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
		Commands->Send_Custom_Event(sender,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);// Start Timer
	}
	if (message == PHONENumberEndCallMessage && param == Get_Int_Parameter("Script_ID"))
	{
		int PlayerID = Get_Player_ID(sender);
		if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
		{
			GLOBALPHONELINES[PlayerID] = 0;
			GLOBALPHONETIMES[PlayerID] = 0;
		}
	}
	if (message == PHONESpecial1Key && param == Get_Int_Parameter("Script_ID"))// yes
	{
		JMG_RP2_Favorite_Vehicle_Main_Control_System *OScript = 0;
		const char *str = Get_Player_Name(sender);
		PlayerFavoriteVehicleControl *ANode = OScript->Find_Node(str);
		delete[] str;
		delete OScript;
		int cost = ANode->VehicleCost;
		if (Commands->Get_Money(sender) >= cost)
		{
			CreateFakeCinematic(sender);
			Commands->Give_Money(sender,-(float)cost,1);
			Send_Message_Player(sender,127,255,0,"Thank You! Your vehicle should arrive shortly!");
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
		}
		else
		{
			Send_Message_Player(sender,127,255,0,"Sorry, I don't give credit, come back when you're a little... richer.");
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
		}
	}
	if (message == PHONESpecial2Key && param == Get_Int_Parameter("Script_ID"))// no
	{
		Send_Message_Player(sender,127,255,0,"Ah well, thanks for calling, have a nice day!");
		Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
		Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
	}
	if (message == PHONENumberCallTimeMonitor && param == Get_Int_Parameter("Script_ID"))
	{
		ChargeForCall(obj);
	}
}

void JMG_RP2_Phone_Buy_Favorite_Vehicle::AutoCancelCall(GameObject *obj,GameObject *player)
{
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}

void JMG_RP2_Phone_Buy_Favorite_Vehicle::ChargeForCall(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
		{
			GameObject *Player = Get_GameObj(x);
			int CallTime = GLOBALPHONETIMES[x]++;
			if (Commands->Get_Health(Player) > 0)
			{
				int chargepersec = Get_Int_Parameter("Charge_Per_Second");
				if (Get_Int_Parameter("Max_Call_Duration") < CallTime)
				{
					AutoCancelCall(obj,Player);
				}
				else if (CallTime % 60 == 0)
				{
					int totalcharge = (chargepersec + Get_Int_Parameter("Charge_Per_Minute"));
					if (Commands->Get_Money(Player) >= totalcharge)
					{
						Commands->Give_Money(Player,-(float)totalcharge,1);
					}
					else
					{
						Send_Message_Player(Player,127,255,0,"Signal Lost");
						AutoCancelCall(obj,Player);
					}
				}
				else if (Commands->Get_Money(Player) >= chargepersec)
				{
					Commands->Give_Money(Player,-(float)chargepersec,1);
				}
				else
				{
					Send_Message_Player(Player,127,255,0,"Signal Lost");
					AutoCancelCall(obj,Player);
				}
			}
			else
			{
				Commands->Send_Custom_Event(Player,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
			}
			Commands->Send_Custom_Event(Player,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);
		}
	}
}

void JMG_RP2_Phone_Buy_Favorite_Vehicle::CreateFakeCinematic(GameObject *obj)
{
	JMG_RP2_Favorite_Vehicle_Main_Control_System *OScript = 0;
	const char *str = Get_Player_Name(obj);
	PlayerFavoriteVehicleControl *ANode = OScript->Find_Node(str);
	delete[] str;
	delete OScript;
	if (!ANode)
	{
		return;
	}
	Vector3 CreateLocation = Commands->Get_Position(obj);
	CreateLocation.Z += 2.0f;
	float Facing = Commands->Get_Facing(obj);
	if (_stricmp("Chinook",ANode->VehiclePreset))
	{
		GameObject *CinematicObj = CreateAObject("Daves_Arrow_NT","XG_TransprtBone","XG_TransprtBone.XG_HD_TTraj",CreateLocation,Facing,0,"none",700,1000);
		GameObject *Helicopter = CreateAObject("Vehicle_Drop_Helicopter","null","v_GDI_trnspt.v_GDI_trnspt",CreateLocation,Facing,CinematicObj,"BN_Trajectory",700,-1);
		Commands->Enable_Engine(Helicopter,true);
		GameObject *Harness = CreateAObject("Daves_Arrow_NT","XG_HD_HTraj","XG_HD_HTraj.XG_HD_HTraj",CreateLocation,Facing,0,"none",437,1000);//drop at 14.56 seconds
		GameObject *PVehicle = CreateAObject(ANode->VehiclePreset,"null","null",CreateLocation,Facing,Harness,"BN_Trajectory",0,1000);
		Commands->Disable_Physical_Collisions(PVehicle);
		Commands->Set_Player_Type(PVehicle,2);
		Commands->Attach_Script(PVehicle,"JMG_RP2_Set_Object_Team_On_Timer","14.3,68541,-1");
		Commands->Attach_Script(PVehicle,"JMG_RP2_Set_Physical_Collisions_On_Timer","14.3,68541,1 1 1");
		Commands->Attach_Script(PVehicle,"JMG_RP2_Disable_Engine_On_Create","");
		CreateAObject("Daves_Arrow_NT","XG_HD_Harness","XG_HD_Harness.XG_HD_Harness",CreateLocation,Facing,0,"none",437,1000);
		CreateAObject("Signal_Flare_Phone_Drop","null","null",CreateLocation,Facing,0,"none",437,1000);
	}
	else
	{
		GameObject *CinematicObj = CreateAObject("Daves_Arrow_NT","XG_TransprtBone","XG_TransprtBone.XG_HD_TTraj",CreateLocation,Facing,0,"none",437,1000);
		GameObject *PVehicle = CreateAObject(ANode->VehiclePreset,"null","null",CreateLocation,Facing,CinematicObj,"BN_Trajectory",0,1000);
		Commands->Disable_Physical_Collisions(PVehicle);
		Commands->Enable_Engine(PVehicle,true);
		Commands->Set_Player_Type(PVehicle,2);
		Commands->Attach_Script(PVehicle,"JMG_RP2_Set_Object_Team_On_Timer","14.3,68541,-1");
		Commands->Attach_Script(PVehicle,"JMG_RP2_Set_Physical_Collisions_On_Timer","14.3,68541,1 1 1");
		Commands->Attach_Script(PVehicle,"JMG_RP2_Set_Engine_On_Timer","14.3,68541,0");
		CreateAObject("Signal_Flare_Phone_Drop","null","null",CreateLocation,Facing,0,"none",437,1000);
	}
}

GameObject *JMG_RP2_Phone_Buy_Favorite_Vehicle::CreateAObject(const char *Preset,const char *Model,const char *Animation,Vector3 Pos,float Facing,GameObject *GAttachTo,const char *Bone,float DeathFrame,float LastFrame)
{
	GameObject *Object = Commands->Create_Object(Preset,Pos);
	Commands->Set_Facing(Object,Facing);
	if (_stricmp(Model,"null"))
	{
		Commands->Set_Model(Object,Model);
	}
	if (_stricmp(Animation,"null"))
	{
		Commands->Set_Animation(Object,Animation,1,0,0,LastFrame,1);
	}
	if (GAttachTo)
	{
		Commands->Attach_To_Object_Bone(Object,GAttachTo,Bone);
	}
	if (DeathFrame)
	{
		char params[235];
		sprintf(params,"%f",DeathFrame/30.0f);
		Commands->Attach_Script(Object,"JMG_Remove_Self_On_Timer",params);
	}
	return Object;
}

void JMG_RP2_Disallow_Favorite_Vehicle::Created(GameObject *obj)
{
	// Dummy Script
}

void JMG_RP2_Tactical_Nuke_Radiation::Created(GameObject *obj)
{
	RadLevel = 0;
	Commands->Set_Model(obj,"s_Radiation");
	RadiationTime = Commands->Get_Random_Int(MINRADTIME,MAXRADTIME);
	Commands->Start_Timer(obj,this,0.1f,456381);
}

void JMG_RP2_Tactical_Nuke_Radiation::Timer_Expired(GameObject *obj,int number)
{
	if (number == 456381)
	{
		RadLevel++;
		if (RadLevel < RadiationTime)
		{
			Commands->Create_Explosion("Explosion_Tactical_Nuke_Radiation",Commands->Get_Position(obj),Get_GameObj(Get_Int_Parameter("OwnerID")));
			Commands->Start_Timer(obj,this,0.1f,456381);
		}
		else
		{
			Commands->Destroy_Object(obj);
		}
	}
}

void JMG_RP2_Set_Object_Team_On_Timer::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerID"));
}

void JMG_RP2_Set_Object_Team_On_Timer::Timer_Expired(GameObject *obj,int number)
{
	if (number == Get_Int_Parameter("TimerID"))
	{
		Commands->Set_Player_Type(obj,Get_Int_Parameter("Team"));
	}
}

void JMG_RP2_Train_Kill_Zone_Control::Created(GameObject *obj)
{
	MyNode = NULL;
	AtTrainStation = true;
	MaxPayout = 0.0f;
	for (int y = 0;y < 3;y++)
	{
		VisitedStations[y] = 0;
	}
	GameObject *CD = Commands->Create_Object("Invisible_Box_FR",Commands->Get_Position(obj));
	Commands->Disable_All_Collisions(CD);
	Commands->Enable_Vehicle_Transitions(CD,false);
	Commands->Attach_To_Object_Bone(CD,obj,"NEB");
	Commands->Set_Model(CD,"TrainCollider");
	CollisionDetectorID = Commands->Get_ID(CD);
	Commands->Start_Timer(obj,this,1.0,9875132);
	Commands->Start_Timer(obj,this,0.1f,9875131);
	Commands->Start_Timer(obj,this,0.1f,9875130);
}

void JMG_RP2_Train_Kill_Zone_Control::Timer_Expired(GameObject *obj,int number)
{
	if (number == 9875131)
	{
		if (MyNode)
		{
			if (AtTrainStation && MyNode->MPH < 10 && MaxPayout)
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver && Commands->Is_A_Star(Driver))
				{
					Commands->Give_Money(Driver,MaxPayout,true);
				}
				char message2player[2000];
				sprintf(message2player,"I have been paid $%.0f for stopping at this train station.",MaxPayout);
				Send_Message_Player(Driver,0,150,0,message2player);
				MaxPayout = 0.0f;
			}
			if (MyNode->MPH >= 40)
			{
				bool Collides = true;
				GameObject *CD = Commands->Find_Object(CollisionDetectorID);
				if (CD)
				{
					Commands->Disable_Physical_Collisions(obj);
					Commands->Enable_Collisions(CD);
					PhysicalGameObj *objphys = ((ScriptableGameObj *)CD)->As_PhysicalGameObj();
					Collides = (bool)(!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),true));
					Commands->Disable_Physical_Collisions(CD);
					Commands->Enable_Collisions(obj);
				}
				if (Collides)
				{
					GameObject *Kill = obj;
					if (Get_Vehicle_Driver(obj)){Kill = Get_Vehicle_Driver(obj);}
					Commands->Create_Explosion("Explosion_Train_Move",Commands->Get_Bone_Position(obj,"killbox00"),Kill);
					Commands->Create_Explosion("Explosion_Train_Move",Commands->Get_Bone_Position(obj,"killbox01"),Kill);
					Commands->Create_Explosion("Explosion_Train_Move",Commands->Get_Bone_Position(obj,"killbox02"),Kill);
					Commands->Create_Explosion("Explosion_Train_Move",Commands->Get_Bone_Position(obj,"killbox03"),Kill);
					Commands->Create_Explosion("Explosion_Train_Move",Commands->Get_Bone_Position(obj,"killbox04"),Kill);
					Commands->Create_Explosion("Explosion_Train_Move",Commands->Get_Bone_Position(obj,"killbox05"),Kill);
				}
			}
		}
		Commands->Start_Timer(obj,this,0.1f,9875131);
	}
	if (number == 9875130)
	{
		MyNode = Find_Node(obj);
		if (!MyNode)
		{
			Commands->Start_Timer(obj,this,0.25,9875130);
		}
	}
	if (number == 9875132)
	{
		GameObject *Driver = Get_Vehicle_Driver(obj);
		if (MyNode && Driver && Commands->Is_A_Star(Driver) && MyNode->MPH >= 10)
		{
			Commands->Give_Money(Driver,(Get_Vehicle_Occupant_Count(obj)-1)*1.0f*((int)MyNode->MPH/10),true);
		}
		Commands->Start_Timer(obj,this,1.0,9875132);
	}
}

void JMG_RP2_Train_Kill_Zone_Control::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 74414)
	{
		if (param)
		{
			if (VisitedStations[0] == Commands->Get_ID(sender))
			{
				return;
			}
			int TempArray[3] = {0};
			TempArray[0] = Commands->Get_ID(sender);
			int Spot = 0;
			AtTrainStation = true;
			MaxPayout = TRAINSTATIONPAYOUT;
			for (int x = 0;x < 3;x++)
			{ 
				if (VisitedStations[x] == Commands->Get_ID(sender))
				{
					MaxPayout = TRAINSTATIONPAYOUT*(x/3.0f);
				}
				else
				{
					Spot++;
					if (Spot < 3)
					{
						TempArray[Spot] = VisitedStations[x];
					}
				}
			}
			for (int x = 0;x < 3;x++)
			{
				VisitedStations[x] = TempArray[x];
			}
		} 
		else
		{
			AtTrainStation = false;
		}
	}
}

void JMG_RP2_Train_Kill_Zone_Control::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *CD = Commands->Find_Object(CollisionDetectorID);
	if (CD)
	{
		Commands->Destroy_Object(CD);
	}
}

RP2VehicleControl *JMG_RP2_Train_Kill_Zone_Control::Find_Node(GameObject *obj)
{
	if (RP2VehicleNode)
	{
		RP2VehicleControl *Current = RP2VehicleNode;
		int MyID = Commands->Get_ID(obj);
		while (Current != NULL)
		{
			if (Current->VehicleID == MyID)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Set_Physical_Collisions_On_Timer::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerID"));
}

void JMG_RP2_Set_Physical_Collisions_On_Timer::Timer_Expired(GameObject *obj,int number)
{
	if (number == Get_Int_Parameter("TimerID"))
	{
		Vector3 Param = Get_Vector3_Parameter("Collide[Physical|Bullets|Camera]");
		if (Param.X || Param.Y)
		{
			Commands->Enable_Collisions(obj);
		}
		if (!(Param.X + Param.Y + Param.Z))
		{
			Commands->Disable_All_Collisions(obj);
		}
		if (!Param.X)
		{
			Commands->Disable_Physical_Collisions(obj);
		}
	}
}


void JMG_RP2_Set_Engine_On_Timer::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerID"));
}

void JMG_RP2_Set_Engine_On_Timer::Timer_Expired(GameObject *obj,int number)
{
	if (number == Get_Int_Parameter("TimerID"))
	{
		Commands->Enable_Engine(obj,Get_Int_Parameter("Enable"));
	}
}
void JMG_RP2_Favorite_Weapon_Main_Control_System::Created(GameObject *obj)
{
	FILE *FavWeaponFile;
	FavWeaponFile = fopen("Data/RolePlay2/BetaFavoriteWeapons.RP2","r");
	if (FavWeaponFile)
	{
		while (!feof(FavWeaponFile))
		{
			int WeaponCost,EncryptFactor;
			char TempString[256];
			fscanf(FavWeaponFile,"%d\n",&WeaponCost);
			EncryptFactor = WeaponCost/10+1;
			fread(TempString,256,1,FavWeaponFile);
			PlayerFavoriteWeaponControl *ANode = Add_Node(Decrypt(TempString,EncryptFactor,3));
			ANode->WeaponCost = WeaponCost;
			fread(TempString,256,1,FavWeaponFile);
			sprintf(ANode->WeaponPreset,"%s",Decrypt(TempString,EncryptFactor,4));
			fread(TempString,256,1,FavWeaponFile);
			sprintf(ANode->WeaponName,"%s",Decrypt(TempString,EncryptFactor,5));
			fscanf(FavWeaponFile,"\n");
		}
		fclose(FavWeaponFile);
	}
}

PlayerFavoriteWeaponControl *JMG_RP2_Favorite_Weapon_Main_Control_System::Add_Node(const char *PlayerName)
{
	if (!PlayerFavoriteWeaponNode)
	{
		PlayerFavoriteWeaponNode = new PlayerFavoriteWeaponControl;
		sprintf(PlayerFavoriteWeaponNode->PlayerName,"%s",PlayerName);
		PlayerFavoriteWeaponNode->next = NULL;
		return PlayerFavoriteWeaponNode;
	}
	else
	{
		PlayerFavoriteWeaponControl *Current = PlayerFavoriteWeaponNode;
		while (Current != NULL)
		{
			if (!_stricmp(PlayerName,Current->PlayerName))
			{
				return Current;
			}
			else if (Current->next == NULL)
			{
				Current->next = new PlayerFavoriteWeaponControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

char *JMG_RP2_Favorite_Weapon_Main_Control_System::Decrypt(const char *String,int EncryptionFactor,int Start)
{
	static char FinalString[2000];
	int loops = strlen(String),x = 0;
	int CurrentAdd = Start;
	while (x < loops)
	{
		if (String[x] != '\0' && String[x] != '\n')
		{
			char Temp = (String[x]-(char)CurrentAdd);
			while (Temp < 32)
			{
				Temp += 125;
			}
			FinalString[x] = Temp;
			CurrentAdd++;
			if (CurrentAdd > EncryptionFactor)
			{
				CurrentAdd = 1;
			}
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
		FinalString[x] = '\0';
	}
	return FinalString;
}

PlayerFavoriteWeaponControl *JMG_RP2_Favorite_Weapon_Main_Control_System::Find_Node(const char *PlayerName)
{
	if (PlayerFavoriteWeaponNode)
	{
		PlayerFavoriteWeaponControl *Current = PlayerFavoriteWeaponNode;
		while (Current != NULL)
		{
			if (!_stricmp(PlayerName,Current->PlayerName))
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Soldier_Set_Favorite_Weapon::Custom(GameObject *obj,int message,int param,GameObject *sender)
{						
	if (message == 5656565 && !Get_Vehicle(sender))
	{
		const char *PlayerWeapon = Get_Current_Weapon(sender);
		if (PlayerWeapon)
		{
			RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(PlayerWeapon);
			if (TheWeapon)
			{
				if (TheWeapon->CanFavorite)
				{
					JMG_RP2_Favorite_Weapon_Main_Control_System *OScript = 0;
					const char *str = Get_Player_Name(obj);
					PlayerFavoriteWeaponControl *ANode = OScript->Add_Node(str);
					delete[] str;
					if (ANode)
					{
						sprintf(ANode->WeaponPreset,"%s",TheWeapon->WeaponName);
						sprintf(ANode->WeaponName,"%s",Get_Weapon_Name(TheWeapon));
						int BulletCost = 0;
						if (TheWeapon->BulletCost)
						{
							BulletCost = Get_Total_Bullets(sender,TheWeapon->WeaponName);
						}
						ANode->WeaponCost = (TheWeapon->WeaponCost + BulletCost);
						char Text[236];
						sprintf(Text,"Your favorite Weapon has been set to a %s!",ANode->WeaponName);
						Send_Message_Player(obj,127,255,0,Text);
					}
				}
				else
				{
					Send_Message_Player(obj,127,255,0,"Sorry, you cannot set this Weapon as your favorite!");
				}
			}
		}
		else
		{
			Send_Message_Player(obj,127,255,0,"Sorry, you cannot set this Weapon as your favorite!");
		}
	}
}

char *JMG_RP2_Soldier_Set_Favorite_Weapon::Get_Weapon_Name(RP2WeaponListControl *WeaponNode)
{
	static char WeaponName[237];
	sprintf(WeaponName,"null");
	if (WeaponNode)
	{
		GameObject *TempObject = Commands->Create_Object("Invisible_Box_NR",Vector3(0,0,0));
		Commands->Give_PowerUp(TempObject,WeaponNode->PowerUpName,true);
		const char *str = Get_Translated_Weapon(TempObject,Get_Gun_Position(TempObject,WeaponNode->WeaponName));
		sprintf(WeaponName,"%s",str);
		delete[] str;
		Commands->Destroy_Object(TempObject);
	}
	return WeaponName;
}

void JMG_RP2_Phone_Buy_Favorite_Weapon::Created(GameObject *obj)
{
	JMG_RP2_Phone_Advanced_Phone_Number_Control_System *OScript = 0;
	sprintf(PhoneNumber,"%s",OScript->FormatPhoneNumber("5558000"));
	delete OScript;
}

void JMG_RP2_Phone_Buy_Favorite_Weapon::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (7 == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,"5558000"))
						{
							end = 1;
							JMG_RP2_Favorite_Weapon_Main_Control_System *OScript = 0;
							const char *str = Get_Player_Name(sender);
							if (!OScript->Find_Node(str))
							{
								delete OScript;
								delete[] str;
								return;
							}
							delete[] str;
							delete OScript;
							sprintf(Current->PhoneNumber,"%s - Buy your favorite weapon.",Current->PhoneNumber);
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONECallStartCustom && param == 0 && PhoneNumbers)
	{
		int end = 0;
		int PlayerID = Get_Player_ID(sender);
		PhoneNumberControl *Current = PhoneNumbers;
		while (Current != NULL && end == 0)
		{
			if (PlayerID == Current->PlayerID)// match
			{
				if (7 == Current->PhoneNumberLength)
				{
					if (!_stricmp(Current->PhoneNumber,"5558000"))
					{
						end = 1;
						JMG_RP2_Favorite_Weapon_Main_Control_System *OScript = 0;
						const char *str = Get_Player_Name(sender);
						if (!OScript->Find_Node(str))
						{
							delete OScript;
							delete[] str;
							return;
						}
						delete[] str;
						delete OScript;
						if (Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")) < Get_Int_Parameter("Max_Callers"))
						{
							GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
							GLOBALPHONETIMES[PlayerID] = 0;
							Commands->Send_Custom_Event(sender,obj,40860511,Get_Int_Parameter("Script_ID"),(Get_Float_Parameter("Pickup_Delay")+Commands->Get_Random(0.0f,Get_Float_Parameter("Max_Random_Pickup_Delay"))));
						}
						else
						{
							for (int x = 1;x < 128;x++)
							{
								if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
								{
									GameObject *Player = Get_GameObj(x);
									Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
								}
							}
							Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
						}
					}
				}
			}
			Current = Current->next;
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && param == 2)
	{
		JMG_RP2_Favorite_Weapon_Main_Control_System *OScript = 0;
		const char *str = Get_Player_Name(sender);
		PlayerFavoriteWeaponControl *ANode = OScript->Find_Node(str);
		delete[] str;
		delete OScript;
		if (!ANode)
		{
			return;
		}
		char Text[236];
		sprintf(Text,"%s - *Favorite* Buy a %s for %d.",PhoneNumber,ANode->WeaponName,ANode->WeaponCost);
		Send_Message_Player(sender,127,255,0,Text);
	}
	if (message == 40860511 && param == Get_Int_Parameter("Script_ID"))// First Step
	{
		if (GLOBALPHONELINES[Get_Player_ID(sender)] != Get_Int_Parameter("Script_ID"))
		{
			return;
		}
		Send_Message_Player(sender,127,255,0,"Thank you for calling the automated Weapon distribution center, will it be the usual today?");
		JMG_RP2_Favorite_Weapon_Main_Control_System *OScript = 0;
		const char *str = Get_Player_Name(sender);
		PlayerFavoriteWeaponControl *ANode = OScript->Find_Node(str);
		delete[] str;
		delete OScript;
		if (!ANode)
		{
			return;
		}
		delete OScript;
		char Text[236];
		sprintf(Text,"Are you sure you would like to buy a %s for %d? ([1]Yes [2]No)",ANode->WeaponName,ANode->WeaponCost);
		Send_Message_Player(sender,127,255,0,Text);

		Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
		Commands->Send_Custom_Event(sender,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);// Start Timer
	}
	if (message == PHONENumberEndCallMessage && param == Get_Int_Parameter("Script_ID"))
	{
		int PlayerID = Get_Player_ID(sender);
		if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
		{
			GLOBALPHONELINES[PlayerID] = 0;
			GLOBALPHONETIMES[PlayerID] = 0;
		}
	}
	if (message == PHONESpecial1Key && param == Get_Int_Parameter("Script_ID"))// yes
	{
		JMG_RP2_Favorite_Weapon_Main_Control_System *OScript = 0;
		const char *str = Get_Player_Name(sender);
		PlayerFavoriteWeaponControl *ANode = OScript->Find_Node(str);
		delete[] str;
		delete OScript;
		int cost = ANode->WeaponCost;
		if (Commands->Get_Money(sender) >= cost)
		{
			CreateFakeCinematic(obj,sender);
			Commands->Give_Money(sender,-(float)cost,1);
			Send_Message_Player(sender,127,255,0,"Thank You! Your Weapon should arrive shortly!");
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);// end call
		}
		else
		{
			Send_Message_Player(sender,127,255,0,"Sorry, I don't give credit, come back when you're a little... richer.");
			Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
		}
	}
	if (message == PHONESpecial2Key && param == Get_Int_Parameter("Script_ID"))// no
	{
		Send_Message_Player(sender,127,255,0,"Ah well, thanks for calling, have a nice day!");
		Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
		Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
	}
	if (message == PHONENumberCallTimeMonitor && param == Get_Int_Parameter("Script_ID"))
	{
		ChargeForCall(obj);
	}
	if (message == Get_Int_Parameter("Script_ID"))
	{
		GameObject *Box = Commands->Find_Object(param);
		SetAObject(Box,"X5D_Parachute","X5D_Parachute.X5D_ParaC_1",0,"none",91,1000);//260-169=91
		JMG_RP2_Favorite_Weapon_Main_Control_System *OScript = 0;
		const char *str = Get_Player_Name(sender);
		PlayerFavoriteWeaponControl *ANode = OScript->Find_Node(str);
		delete[] str;
		delete OScript;
		if (ANode)
		{
			RP2WeaponListControl *TheWeapon = Get_WLS_Weapon_Settings(ANode->WeaponPreset);
			if (TheWeapon)
			{
				GameObject *PWeapon = CreateAObject(obj,TheWeapon->FakePowerUpName,"0","null",Commands->Get_Position(Box),Commands->Get_Facing(Box),Box,"o_pack",0,0,0,0);
				GameObject *PWeapon2 = CreateRealWeapon(PWeapon,TheWeapon);
				Commands->Attach_To_Object_Bone(PWeapon2,Box,"o_pack");
			}
		}
	}
}

void JMG_RP2_Phone_Buy_Favorite_Weapon::AutoCancelCall(GameObject *obj,GameObject *player)
{
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}

void JMG_RP2_Phone_Buy_Favorite_Weapon::ChargeForCall(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
		{
			GameObject *Player = Get_GameObj(x);
			int CallTime = GLOBALPHONETIMES[x]++;
			if (Commands->Get_Health(Player) > 0)
			{
				int chargepersec = Get_Int_Parameter("Charge_Per_Second");
				if (Get_Int_Parameter("Max_Call_Duration") < CallTime)
				{
					AutoCancelCall(obj,Player);
				}
				else if (CallTime % 60 == 0)
				{
					int totalcharge = (chargepersec + Get_Int_Parameter("Charge_Per_Minute"));
					if (Commands->Get_Money(Player) >= totalcharge)
					{
						Commands->Give_Money(Player,-(float)totalcharge,1);
					}
					else
					{
						Send_Message_Player(Player,127,255,0,"Signal Lost");
						AutoCancelCall(obj,Player);
					}
				}
				else if (Commands->Get_Money(Player) >= chargepersec)
				{
					Commands->Give_Money(Player,-(float)chargepersec,1);
				}
				else
				{
					Send_Message_Player(Player,127,255,0,"Signal Lost");
					AutoCancelCall(obj,Player);
				}
			}
			else
			{
				Commands->Send_Custom_Event(Player,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
			}
			Commands->Send_Custom_Event(Player,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);
		}
	}
}

void JMG_RP2_Phone_Buy_Favorite_Weapon::CreateFakeCinematic(GameObject *obj,GameObject *Player)
{
	CreateLocation = Commands->Get_Position(Player);
	CreateLocation.Z += 2.0f;
	Facing = Commands->Get_Facing(Player);
	GameObject *CinematicObj = CreateAObject(obj,"Daves_Arrow_NT","X5D_Chinookfly","X5D_Chinookfly.X5D_Chinookfly",CreateLocation,Facing,0,"none",280,1000,0,0);
	GameObject *Helicopter = CreateAObject(obj,"Vehicle_Drop_Helicopter","0","null",CreateLocation,Facing,CinematicObj,"bn_chinook_1",280,0,0,0);
	Commands->Disable_Physical_Collisions(Helicopter);
	Commands->Enable_Engine(Helicopter,true);
	//CreateAObject(obj,"Daves_Arrow_NT","null","null",CreateLocation,Facing,0,"none",0,-1,5.63f,1);// Create Parachute at frame 169
	GameObject *Box = CreateAObject(obj,"Daves_Arrow_NT","null","null",CreateLocation,Facing,0,"none",0,0,0,0);// Create Weapon and box at frame 145
	Commands->Send_Custom_Event(Player,obj,Get_Int_Parameter("Script_ID"),Commands->Get_ID(Box),4.83f);//Pass the player and the powerup attacher to the timer control
	CreateAObject(obj,"Signal_Flare_Phone_Drop","0","null",CreateLocation,Facing,0,"none",145,1000,0,0);
}

GameObject *JMG_RP2_Phone_Buy_Favorite_Weapon::CreateAObject(GameObject *obj,const char *Preset,const char *Model,const char *Animation,Vector3 Pos,float Facing,GameObject *GAttachTo,const char *Bone,float DeathFrame,float LastFrame,float CreateDelay,int DelayTimer)
{
	GameObject *Object = Commands->Create_Object(Preset,Pos);
	if (_stricmp(Model,"0"))
	{
		Commands->Set_Model(Object,Model);
	}
	if (_stricmp(Animation,"null"))
	{
		Commands->Set_Animation(Object,Animation,1,0,0,LastFrame,1);
	}
	if (GAttachTo)
	{
		Commands->Attach_To_Object_Bone(Object,GAttachTo,Bone);
	}
	else
	{
		Commands->Set_Facing(Object,Facing);
	}
	if (DeathFrame)
	{
		char params[235];
		sprintf(params,"%f",DeathFrame/30.0f);
		Commands->Attach_Script(Object,"JMG_Remove_Self_On_Timer",params);
	}
	if (CreateDelay)
	{
		Commands->Send_Custom_Event(Object,obj,Get_Int_Parameter("Script_ID"),DelayTimer,CreateDelay);
	}
	return Object;
}

void JMG_RP2_Phone_Buy_Favorite_Weapon::SetAObject(GameObject *Object,const char *Model,const char *Animation,GameObject *GAttachTo,const char *Bone,float DeathFrame,float LastFrame)
{
	if (!Object)
	{
		return;
	}
	if (_stricmp(Model,"0"))
	{
		Commands->Set_Model(Object,Model);
	}
	if (_stricmp(Animation,"null"))
	{
		Commands->Set_Animation(Object,Animation,1,0,0,LastFrame,1);
	}
	if (GAttachTo)
	{
		Commands->Attach_To_Object_Bone(Object,GAttachTo,Bone);
	}
	if (DeathFrame)
	{
		char params[235];
		sprintf(params,"%f",DeathFrame/30.0f);
		Commands->Attach_Script(Object,"JMG_Remove_Self_On_Timer",params);
	}
}

GameObject *JMG_RP2_Phone_Buy_Favorite_Weapon::CreateRealWeapon(GameObject *obj,RP2WeaponListControl *TheWeapon)
{
	Vector3 Pos = Commands->Get_Position(obj);
	GameObject *object = Commands->Create_Object(TheWeapon->FakePowerUpName,Pos);
	Commands->Set_Facing(object,Commands->Get_Facing(obj));
	Dropped_Weapon_Limiter(object,TheWeapon,0);
	char params[2000];
	sprintf(params,"%s,1,-1,0.25,0.25,1,0,1",TheWeapon->WeaponName);
	Commands->Attach_Script(object,"JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit",params);
	Commands->Destroy_Object(obj);
	return object;
}

void JMG_RP2_Set_Map_Version::Created(GameObject *obj)
{
	sprintf(MAPVERSION,"%s",Get_Parameter("Map_Version"));
}

void JMG_RP2_Phone_Request_Display_Server_Version::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		JMG_RP2_Main_Map_Game_Control *MMGCScript = 0;
		MMGCScript->Server_Version();
		delete MMGCScript;
	}
}

void JMG_RP2_Phone_Request_Object_Count::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		//int C4Count = 0,CinematicCount = 0,BeaconCount = 0,ArmedCount = 0,PowerupCount = 0;
		int VehicleCount = 0,count = 0,ScriptZoneCount = 0,SimpleObjectCount = 0;
		int HumanCount = 0,StreetSign = 0,BuildingCount = 0,MiscCount = 0;
		int ScriptCount = 0,MostScriptsID = 0,MostScriptsCount = 0;
		SLNode<BaseGameObj> *y = GameObjManager::GameObjList.Head();
		while (y)
		{
			GameObject *o = y->Data()->As_ScriptableGameObj();
			if (o)
			{
				count++;
				if (o->As_PhysicalGameObj() && o->As_PhysicalGameObj()->As_PhysicalGameObj()){SimpleObjectCount++;}
				else if (o->As_VehicleGameObj()){VehicleCount++;}
				else if (o->As_SoldierGameObj()){if (Is_Script_Attached(o,"JMG_RP2_Street_Sign_Crushable")){StreetSign++;}else{HumanCount++;}}
				//else if (Is_Powerup(o)){PowerupCount++;}
				else if (o->As_ScriptZoneGameObj()){ScriptZoneCount++;}
				//else if (Is_Beacon(o)){BeaconCount++;}
				//else if (Is_Cinematic(o)){CinematicCount++;}
				//else if (Is_C4(o)){C4Count++;}
				//else if (Is_Armed(o)){ArmedCount++;}
				else {MiscCount++;}
			}
			y = y->Next();
		}
		char ObjectCount[256];
		sprintf(ObjectCount,"Total Object Count: %d",count);DisplayText(ObjectCount,1675,count);
		count = 0;
		SLNode<BuildingGameObj> *z = GameObjManager::BuildingGameObjList.Head();
		while (z)
		{
			GameObject *o = z->Data();
			if (o)
			{
				BuildingCount++;
			}
			z = z->Next();
		}
		SLNode<BaseGameObj> *j = GameObjManager::GameObjList.Head();
		while (j)
		{
			GameObject *o = j->Data()->As_ScriptableGameObj();
			if (o)
			{
				const SimpleDynVecClass<GameObjObserverClass *> *observers = &((ScriptableGameObj *)o)->Get_Observers();
				int TempSC = observers->Count();
				ScriptCount += TempSC;
				if (MostScriptsCount < TempSC)
				{
					MostScriptsCount = TempSC;
					MostScriptsID = Commands->Get_ID(o);
				}
			}
			j = j->Next();
		}
		SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
		while (x)
		{
			GameObject *o = x->Data();
			if (o)
			{
				count++;
			}
			x = x->Next();
		}
		sprintf(ObjectCount,"Total Smart Object Count: %d",count);DisplayText(ObjectCount,345,count);
		sprintf(ObjectCount,"Simple Object Count: %d",SimpleObjectCount);DisplayText(ObjectCount,1075,SimpleObjectCount);
		sprintf(ObjectCount,"Script Zone Count: %d",ScriptZoneCount);DisplayText(ObjectCount,275,ScriptZoneCount);
		sprintf(ObjectCount,"Vehicle Count: %d",VehicleCount);DisplayText(ObjectCount,285,VehicleCount);
		sprintf(ObjectCount,"Human Count: %d",HumanCount);DisplayText(ObjectCount,10,HumanCount);
		sprintf(ObjectCount,"Street Sign Count: %d",StreetSign);DisplayText(ObjectCount,56,StreetSign);
		//sprintf(ObjectCount,"Powerup Count: %d",PowerupCount);DisplayText(ObjectCount);
		//sprintf(ObjectCount,"Beacon Count: %d",BeaconCount);DisplayText(ObjectCount);
		//sprintf(ObjectCount,"Cinematic Count: %d",CinematicCount);DisplayText(ObjectCount);
		sprintf(ObjectCount,"Building Count: %d",BuildingCount);DisplayText(ObjectCount,6,BuildingCount);
		//sprintf(ObjectCount,"C4 Count: %d",C4Count);DisplayText(ObjectCount);
		//sprintf(ObjectCount,"Armed Count: %d",ArmedCount);DisplayText(ObjectCount);
		sprintf(ObjectCount,"Unknown Count: %d",MiscCount);DisplayText(ObjectCount,82,MiscCount);
		sprintf(ObjectCount,"Total Script Count: %d",ScriptCount);DisplayText(ObjectCount,2478,ScriptCount);
		sprintf(ObjectCount,"Most attached scripts:%d Preset:\"%s\" ID:%d",MostScriptsCount,Commands->Get_Preset_Name(Commands->Find_Object(MostScriptsID)),MostScriptsID);DisplayText(ObjectCount,115,MostScriptsCount);
	}
}

void JMG_RP2_Phone_Request_Object_Count::DisplayText(const char *Text,int RecordedMax,int Current)
{
	float Percent = (RecordedMax/255.0f);
	int RColor = 255,GColor = 255,BColor = 255;
	float Overfilled = (float)Current;
	if (RecordedMax < Overfilled)
	{
		while (RecordedMax < Overfilled)
		{
			if (GColor){GColor -= 1;}else{GColor = 0;}
			if (BColor){BColor -= 2;}else{BColor = 0;}
			Overfilled -= Percent;
		}
	}
	if (RecordedMax > Overfilled)
	{
		while (RecordedMax > Overfilled)
		{
			if (RColor){RColor -= 2;}else{RColor = 0;}
			if (GColor){GColor -= 1;}else{GColor = 0;}
			Overfilled += Percent;
		}
	}
	for (int x = 1;x < 128;x++)
	{
		GameObject *Player = Get_GameObj(x);
		if (Player)
		{
			Send_Message_Player(Player,RColor,GColor,BColor,Text);
		}
	}
}

enum {DoorOpen = 0,DoorShut = 500,DoorLockedDown = 1000,CloseCustom = 256521,OpenCustom = 256520,ToggleCustom = 256522,CompleteCustom = 256523,AddSwitchCustom = 256524};
void JMG_RP2_Renhalo_Blast_Doors::Created(GameObject *obj)
{
	for (int x = 0;x < 4;x++)
	{
		SwitchIDs[x] = 0;
	}
	char Params[256];
	sprintf(Params,"%d",Commands->Get_ID(obj));
	GameObject *Switch1 = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(Switch1,obj,"Box21");
	Commands->Set_Model(Switch1,"l11BDSwitch");
	Commands->Attach_Script(Switch1,"JMG_RP2_Renhalo_Blast_Door_Switch",Params);
	GameObject *Switch2 = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(Switch2,obj,"Box17");
	Commands->Set_Model(Switch2,"l11BDSwitch");
	Commands->Attach_Script(Switch2,"JMG_RP2_Renhalo_Blast_Door_Switch",Params);
	CAMode = 0;
	Enabled = true;
	if (!Get_Int_Parameter("Door_State"))
	{
		Commands->Set_Animation(obj,"l11Blastdoors.l11Blastdoorss",false,0,0,DoorOpen,false);
	}
	if (Get_Int_Parameter("Door_State") == 1)
	{
		CAMode = 1;
		Commands->Set_Animation(obj,"l11Blastdoors.l11Blastdoorsf",false,0,0,DoorShut,false);
	}
	if (Get_Int_Parameter("Door_State") == 2)
	{
		CAMode = 2;
		Commands->Set_Animation(obj,"l11Blastdoors.l11Blastdoorsf",false,0,0,DoorLockedDown,false);
	}
}

void JMG_RP2_Renhalo_Blast_Doors::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CloseCustom && Enabled)
	{
		if (!CAMode)
		{
			Enabled = false;
			CAMode = 1;
			Commands->Set_Animation(obj,"l11Blastdoors.l11Blastdoorsf",false,0,Get_Animation_Frame(obj),DoorShut,false);
			Send_Custom_To_Switches(obj,message);
		}
		else if (CAMode == 1)
		{
			Enabled = false;
			CAMode = 2;
			Commands->Set_Animation(obj,"l11Blastdoors.l11Blastdoorsf",false,0,Get_Animation_Frame(obj),DoorLockedDown,false);
			Send_Custom_To_Switches(obj,message);
		}
		else
		{
			Send_Custom_To_Switches(obj,CompleteCustom);
		}
	}
	if (message == OpenCustom && Enabled)
	{
		if (CAMode == 2)
		{
			Enabled = false;
			CAMode = 1;
			Commands->Set_Animation(obj,"l11Blastdoors.l11Blastdoorsb",false,0,Get_Animation_Frame(obj),DoorShut,false);
			Send_Custom_To_Switches(obj,message);
		}
		else if (CAMode == 1)
		{
			Enabled = false;
			CAMode = 0;
			Commands->Set_Animation(obj,"l11Blastdoors.l11Blastdoorsb",false,0,Get_Animation_Frame(obj),DoorOpen,false);
			Send_Custom_To_Switches(obj,message);
		}
		else
		{
			Send_Custom_To_Switches(obj,CompleteCustom);
		}
	}
	if (message == ToggleCustom && Enabled)
	{
		if (!CAMode)
		{
			Enabled = false;
			CAMode = 1;
			Commands->Set_Animation(obj,"l11Blastdoors.l11Blastdoorsf",false,0,Get_Animation_Frame(obj),DoorShut,false);
			Send_Custom_To_Switches(obj,CloseCustom);
		}
		else
		{
			Enabled = false;
			CAMode = 0;
			Commands->Set_Animation(obj,"l11Blastdoors.l11Blastdoorsb",false,0,Get_Animation_Frame(obj),DoorOpen,false);
			Send_Custom_To_Switches(obj,OpenCustom);
		}
	}
	if (message == AddSwitchCustom)
	{
		Add_Switch_ID(Commands->Get_ID(sender));
	}
}

void JMG_RP2_Renhalo_Blast_Doors::Animation_Complete(GameObject *obj,const char *anim)
{
	Enabled = true;
	Send_Custom_To_Switches(obj,CompleteCustom);
	Commands->Set_Animation(obj,"l11Blastdoors.l11Blastdoorss",false,0,Get_Animation_Frame(obj),Get_Animation_Frame(obj),false);
}

void JMG_RP2_Renhalo_Blast_Doors::Add_Switch_ID(int SenderID)
{
	for (int x = 0;x < 4 && SenderID;x++)
	{
		if (SwitchIDs[x] == SenderID)
		{
			SenderID = 0;
		}
		else if (!SwitchIDs[x])
		{
			SwitchIDs[x] = SenderID;
			SenderID = 0;
		}
	}
}

void JMG_RP2_Renhalo_Blast_Doors::Send_Custom_To_Switches(GameObject *obj,int Custom)
{
	for (int x = 0;x < 4;x++)
	{
		if (SwitchIDs[x])
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(SwitchIDs[x]),Custom,1,0);
		}
	}
}

void JMG_RP2_Renhalo_Blast_Door_Switch::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(poker)])
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Door_ID")),ToggleCustom,1,0);
		}
	}
}

void JMG_RP2_Renhalo_Blast_Door_Wall_Switch::Created(GameObject *obj)
{
	char Params[256];
	GameObject *Switch1 = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(Switch1,obj,"red_on");
	Commands->Set_Model(Switch1,"l11bdwSwitchb");
	sprintf(Params,"%d,%d,0",Commands->Get_ID(obj),CloseCustom);
	Commands->Attach_Script(Switch1,"JMG_RP2_Send_Custom_On_Poke",Params);
	GameObject *Switch2 = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(Switch2,obj,"green_on");
	Commands->Set_Model(Switch2,"l11bdwSwitchb");
	sprintf(Params,"%d,%d,0",Commands->Get_ID(obj),OpenCustom);
	Commands->Attach_Script(Switch2,"JMG_RP2_Send_Custom_On_Poke",Params);
	Commands->Set_Animation(obj,"l11bdwSwitch.l11bdwSwitch",false,0,2,2,false);
	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Door_ID")),AddSwitchCustom,1,0);
}

void JMG_RP2_Renhalo_Blast_Door_Wall_Switch::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CloseCustom)
	{
		Commands->Set_Animation(obj,"l11bdwSwitch.l11bdwSwitch",false,0,1,1,false);
		if (!param)
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Door_ID")),message,1,0);
		}
	}
	if (message == OpenCustom)
	{
		Commands->Set_Animation(obj,"l11bdwSwitch.l11bdwSwitch",false,0,0,0,false);
		if (!param)
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Door_ID")),message,1,0);
		}
	}
	if (message == CompleteCustom)
	{
		Commands->Set_Animation(obj,"l11bdwSwitch.l11bdwSwitch",false,0,2,2,false);
	}
}

void JMG_RP2_Send_Custom_On_Poke::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(poker)])
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ID")),Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),0);
		}
	}
}

void JMG_RP2_Renhalo_Blast_Door_Keycard::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		Send_Message_Player(sender,0,255,64,"I just picked up a level 1 security key.");
		Commands->Grant_Key(obj,Get_Int_Parameter("Key"),true);
	}
}

void JMG_RP2_Renhalo_Blast_Door_Wall_Switch_Key::Created(GameObject *obj)
{
	char Params[256];
	GameObject *Switch1 = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(Switch1,obj,"red_on");
	Commands->Set_Model(Switch1,"l11bdwSwitchb");
	sprintf(Params,"%d,%d,0,%d",Commands->Get_ID(obj),CloseCustom,Get_Int_Parameter("Key"));
	Commands->Attach_Script(Switch1,"JMG_RP2_Send_Custom_On_Poke",Params);
	GameObject *Switch2 = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(Switch2,obj,"green_on");
	Commands->Set_Model(Switch2,"l11bdwSwitchb");
	sprintf(Params,"%d,%d,0,%d",Commands->Get_ID(obj),OpenCustom,Get_Int_Parameter("Key"));
	Commands->Attach_Script(Switch2,"JMG_RP2_Send_Custom_On_Poke",Params);
	Commands->Set_Animation(obj,"l11bdwSwitch.l11bdwSwitch",false,0,2,2,false);
	Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Door_ID")),AddSwitchCustom,1,0);
}

void JMG_RP2_Renhalo_Blast_Door_Wall_Switch_Key::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CloseCustom)
	{
		Commands->Set_Animation(obj,"l11bdwSwitch.l11bdwSwitch",false,0,1,1,false);
		if (!param)
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Door_ID")),message,1,0);
		}
	}
	if (message == OpenCustom)
	{
		Commands->Set_Animation(obj,"l11bdwSwitch.l11bdwSwitch",false,0,0,0,false);
		if (!param)
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("Door_ID")),message,1,0);
		}
	}
	if (message == CompleteCustom)
	{
		Commands->Set_Animation(obj,"l11bdwSwitch.l11bdwSwitch",false,0,2,2,false);
	}
}

void JMG_RP2_Send_Custom_On_Poke_Key::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(poker)] && Commands->Has_Key(poker,Get_Int_Parameter("Key")))
		{
			Commands->Send_Custom_Event(obj,Commands->Find_Object(Get_Int_Parameter("ID")),Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),0);
		}
	}
}

void JMG_RP2_Renhalo_Warthog::Created(GameObject *obj)
{
	MyNode = Add_Node(Commands->Get_ID(obj));
	Vector3 Pos = Commands->Get_Position(obj);
	GameObject *Turret = Commands->Create_Object("Renhalo_Warthog_Turret",Pos);
	Commands->Attach_To_Object_Bone(Turret,obj,"Turrpos");
	MyNode->TurretID = Commands->Get_ID(Turret);
	GameObject *Gunner = Commands->Create_Object("Renhalo_Warthog_Gunner",Pos);
	Commands->Attach_To_Object_Bone(Gunner,obj,"Gunnerpos");
	MyNode->GunnerID = Commands->Get_ID(Gunner);
	Commands->Send_Custom_Event(obj,Gunner,VISIBLESEATCONNECTIONOBJECTOVERRIDECUSTOM,0,1.0f);
}

void JMG_RP2_Renhalo_Warthog::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 91151185 && MyNode && Commands->Get_Health(obj))
	{
		Vector3 Pos = Commands->Get_Position(obj);
		GameObject *Gunner = Commands->Create_Object("Renhalo_Warthog_Gunner",Pos);
		Commands->Attach_To_Object_Bone(Gunner,obj,"Gunnerpos");
		MyNode->GunnerID = Commands->Get_ID(Gunner);
	}
}

void JMG_RP2_Renhalo_Warthog::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	float Health = Commands->Get_Health(obj);
	float Armor = Commands->Get_Shield_Strength(obj);
	if (Health)
	{
		if (damager)
		{
			GameObject *TempVehicle = Get_Vehicle(damager);
			int DamagerID = Commands->Get_ID(damager);
			if (TempVehicle)
			{
				DamagerID = Commands->Get_ID(TempVehicle);
			}
			if (DamagerID == MyNode->TurretID || DamagerID == MyNode->GunnerID)
			{
				Commands->Apply_Damage(obj,-damage,"None",0);
			}
			else
			{
				Set_HP(Commands->Find_Object(MyNode->TurretID),Health,Armor);
				Set_HP(Commands->Find_Object(MyNode->GunnerID),Health,Armor);
			}
		}
		else
		{
			Set_HP(Commands->Find_Object(MyNode->TurretID),Health,Armor);
			Set_HP(Commands->Find_Object(MyNode->GunnerID),Health,Armor);
		}
	}
}

void JMG_RP2_Renhalo_Warthog::Killed(GameObject *obj, GameObject *damager)
{
	Commands->Apply_Damage(Commands->Find_Object(MyNode->TurretID),999999.9f,"BlamoKiller",0);
	Commands->Apply_Damage(Commands->Find_Object(MyNode->GunnerID),999999.9f,"BlamoKiller",0);
}

void JMG_RP2_Renhalo_Warthog::Set_HP(GameObject *obj,float Health,float Armor)
{
	Commands->Set_Health(obj,Health);
	Commands->Set_Shield_Strength(obj,Armor);
}

WarthogControl *JMG_RP2_Renhalo_Warthog::Add_Node(int ID)
{
	if (!WarthogNode)
	{
		WarthogNode = new WarthogControl;
		WarthogNode->BodyID = ID;
		WarthogNode->GunnerID = 0;
		WarthogNode->TurretID = 0;
		WarthogNode->next = NULL;
		return WarthogNode;
	}
	else
	{
		WarthogControl *Current = WarthogNode;
		while (Current)
		{
			if (ID == Current->BodyID)
			{
				return Current;
			}
			if (!Current->next)
			{
				Current->next = new WarthogControl;
				Current = Current->next;
				Current->BodyID = ID;
				Current->GunnerID = 0;
				Current->TurretID = 0;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Renhalo_Vehicle_Passenger::Created(GameObject *obj)
{
	//Select_Empty_Hands(obj);
}

void JMG_RP2_Renhalo_Vehicle_Passenger::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	// I just recreate the gunner object each time now, stops the crashing that way (crash occured when you would get out change weapons and get back in at random
	/*if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		const char *Weapon2 = Get_Current_Weapon(obj);
		if (Weapon2)
		{
			if (_stricmp("Weapon_Empty_Hands",Weapon2))
			{
				Select_Empty_Hands(obj);
				Remove_Weapon(obj,Weapon2);
			}
		}
		const char *Weapon = Get_Current_Weapon(sender);
		if (Weapon)
		{
			RP2WeaponListControl *WeaponNode = Get_WLS_Weapon_Settings(Weapon);
			if (WeaponNode)
			{
				if (WeaponNode->WeaponClass != 10 && WeaponNode->WeaponClass != 9)
				{
					Commands->Give_PowerUp(obj,WeaponNode->PowerUpName,false);
					Set_Clip_Bullets(obj,WeaponNode->WeaponName,Get_Clip_Bullets(sender,Weapon));
					Set_Bullets(obj,WeaponNode->WeaponName,Get_Bullets(sender,Weapon));
					Commands->Select_Weapon(obj,WeaponNode->WeaponName);
					Remove_Empty_Hands(obj);
				}
				else
				{
					Send_Message_Player(sender,150,0,150,"I cannot use this object while sitting shotgun in this vehicle.");
					Select_Empty_Hands(obj);
				}
			}
			else{Select_Empty_Hands(obj);}
		}
		else{Select_Empty_Hands(obj);}
		Commands->Set_Position(sender,Commands->Get_Position(obj));
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		if (!Commands->Get_Health(sender))
		{
			return;
		}
		const char *Weapon = Get_Current_Weapon(obj);
		if (Weapon)
		{
			if (_stricmp("Weapon_Empty_Hands",Weapon))
			{
				Set_Clip_Bullets(sender,Weapon,Get_Clip_Bullets(obj,Weapon));
				Set_Bullets(sender,Weapon,Get_Bullets(obj,Weapon));
				Select_Empty_Hands(obj);
				Remove_Weapon(obj,Weapon);
			}
		}
	}*/
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		const char *Weapon = Get_Current_Weapon(sender);
		if (Weapon)
		{
			RP2WeaponListControl *WeaponNode = Get_WLS_Weapon_Settings(Weapon);
			if (WeaponNode)
			{
				Commands->Give_PowerUp(obj,WeaponNode->PowerUpName,false);
				Set_Clip_Bullets(obj,WeaponNode->WeaponName,Get_Clip_Bullets(sender,Weapon));
				Set_Bullets(obj,WeaponNode->WeaponName,Get_Bullets(sender,Weapon));
				Commands->Select_Weapon(obj,WeaponNode->WeaponName);
			}
			else
			{
				Select_Empty_Hands(obj);
			}
		}
		else
		{
			Select_Empty_Hands(obj);
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		if (!Commands->Get_Health(sender))
		{
			return;
		}
		const char *Weapon = Get_Current_Weapon(obj);
		if (Weapon)
		{
			if (_stricmp("Weapon_Empty_Hands",Weapon))
			{
				Set_Clip_Bullets(sender,Weapon,Get_Clip_Bullets(obj,Weapon));
				Set_Bullets(sender,Weapon,Get_Bullets(obj,Weapon));
				if (!Get_Vehicle_Occupant_Count(obj))
				{
					WarthogControl *WartNode = Get_Warthog_Node(obj);
					if (WartNode)
					{
						Commands->Send_Custom_Event(obj,Commands->Find_Object(WartNode->BodyID),91151185,1,0);
						Commands->Destroy_Object(obj);
					}
				}
			}
		}
	}
}

void JMG_RP2_Renhalo_Vehicle_Passenger::Select_Empty_Hands(GameObject *obj)
{
	Commands->Give_PowerUp(obj,"POW_Empty_Hands",false);
	Commands->Select_Weapon(obj,"Weapon_Empty_Hands");
}

void JMG_RP2_Renhalo_Vehicle_Passenger::Remove_Empty_Hands(GameObject *obj)
{
	if (Has_Weapon(obj,"Weapon_Empty_Hands"))
	{
		Remove_Weapon(obj,"Weapon_Empty_Hands");
	}
}
void JMG_RP2_Create_Vehicle_At_Safe_Location::Created(GameObject *obj)
{
	Vector3 ExitPos,StartPos;
	StartPos = ExitPos = Commands->Get_Position(obj);
	PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
	objphys->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Find_Teleport_Location(StartPos,25.0f,&ExitPos);
	Commands->Set_Position(obj,ExitPos);
	if (Is_Script_Attached(obj,"JMG_RP2_Create_Vehicle_At_Safe_Location"))
	{
		Remove_Script(obj,"JMG_RP2_Create_Vehicle_At_Safe_Location");
	}
}

void JMG_RP2_Place_Vehicle_At_Safe_Location_Timer::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerID"));
}

void JMG_RP2_Place_Vehicle_At_Safe_Location_Timer::Timer_Expired(GameObject *obj,int number)
{
	if (number == Get_Int_Parameter("TimerID"))
	{
		Vector3 ExitPos,StartPos;
		StartPos = ExitPos = Commands->Get_Position(obj);
		PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
		objphys->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Find_Teleport_Location(StartPos,5.0f,&ExitPos);
		Commands->Set_Position(obj,ExitPos);
		if (Is_Script_Attached(obj,"JMG_RP2_Create_Vehicle_At_Safe_Location"))
		{
			Remove_Script(obj,"JMG_RP2_Create_Vehicle_At_Safe_Location");
		}
	}
}

void JMG_RP2_Get_Unstuck_Key::Created(GameObject *obj)
{
	Stuck = 0;
	LastPosition = Commands->Get_Position(obj);
	LastUpdatePos = LastPosition;
	OldestPosition = LastPosition;
	Moving = 0;
	Commands->Start_Timer(obj,this,0.1f,453455);
}

void JMG_RP2_Get_Unstuck_Key::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 911911911 && !Get_Vehicle(obj))
	{
		if (!Stuck)
		{
			if (ISNEWSWIMMING[Get_Player_ID(obj)])
			{// Your in the water, use the water code to kill yourself
				Stuck = 600;
				Commands->Start_Timer(obj,this,0.1f,453457);
				return;
			}
			if (Moving)
			{// Your moving
				Send_Message_Player(obj,255,25,25,"You obviously are not stuck!");
				return;
			}
			if (Commands->Get_Distance(LastUpdatePos,Commands->Get_Position(obj)) < 1.0f)
			{// In same spot, try finding a random spot
				LastUpdatePos.Z -= 0.5f;
				Commands->Set_Position(obj,LastUpdatePos);
				PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
				objphys->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Find_Teleport_Location(LastUpdatePos,3.0f,&LastUpdatePos);
				Commands->Set_Position(obj,LastUpdatePos);
				return;
			}
			Stuck = 600;
			Send_Message_Player(obj,255,25,25,"Stand-by... (5 seconds)");
			GameObject *Holder = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
			Commands->Set_Model(Holder,"null");
			Commands->Attach_To_Object_Bone(obj,Holder,"origin");
			char params[20];
			sprintf(params,"%d",Commands->Get_ID(obj));
			Commands->Attach_Script(Holder,"JMG_Remove_Object_When_Creator_Destroyed",params);
			HolderID = Commands->Get_ID(Holder);
			Commands->Start_Timer(obj,this,5.0f,453458);
		}
		else
		{
			Send_Message_Player(obj,255,25,25,"Sorry, you can only use the Stuck key once every 60 seconds!");
		}
	}
	if (message == 911911911 && Get_Vehicle(obj))
	{
		GameObject *TheVehicle = Get_Vehicle(obj);
		if (!Stuck)
		{
			if (Get_Vehicle_Driver(TheVehicle) == obj)
			{
				Soldier_Transition_Vehicle(obj);
				Commands->Start_Timer(obj,this,0.1f,453456);
			}
			else
			{
				Send_Message_Player(obj,255,25,25,"Sorry, only the driver of the vehicle can use this feature!");
			}
		}
		else
		{
			Send_Message_Player(obj,255,25,25,"Sorry, you can only use the Stuck key once every 60 seconds!");
		}
	}
}

void JMG_RP2_Get_Unstuck_Key::Timer_Expired(GameObject *obj,int number)
{
	if (number == 453455)
	{
		if (Stuck)
		{
			Stuck--;
		}
		Vector3 Pos = Commands->Get_Position(obj);
		if (Commands->Get_Distance(Pos,OldestPosition) > 10.0f && Commands->Get_Distance(Pos,LastUpdatePos) > 10.0f)
		{
			if (!Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach"))
			{
				LastUpdatePos = OldestPosition;
				OldestPosition = Pos;
			}
		}
		if (Commands->Get_Distance(Pos,LastPosition) < 0.05f)
		{
			Moving = 0;
		}
		else
		{
			Moving = 1;
		}
		LastPosition = Pos;
		Commands->Start_Timer(obj,this,0.1f,453455);
	}
	if (number == 453456)
	{
		GameObject *TheVehicle = Get_Vehicle(obj);
		if (TheVehicle)
		{
			Commands->Apply_Damage(TheVehicle,9999.9f,"None",0);
			Stuck = 600;
		}
		else
		{
			Send_Message_Player(obj,255,25,25,"Sorry, this only works if your transitions are blocked!");
		}
	}
	if (number == 453457 && ISNEWSWIMMING[Get_Player_ID(obj)])
	{// Kill yourself in the water
		Commands->Apply_Damage(obj,1.5f,"SwimmingDamage",obj);
		Commands->Start_Timer(obj,this,0.1f,453457);
	}
	if (number == 453458)
	{
		GameObject *Holder = Commands->Find_Object(HolderID); 
		if (Holder)
		{
			Commands->Destroy_Object(Holder);
		}
		Commands->Set_Position(obj,LastUpdatePos);
	}
}

void JMG_RP2_Grill::Created(GameObject *obj)
{
	GameObject *Flame = Commands->Create_Object("Daves_Arrow_NT",Commands->Get_Position(obj));
	Commands->Attach_To_Object_Bone(Flame,obj,"origin");
	Commands->Set_Model(Flame,"null");
	FlameID = Commands->Get_ID(Flame);
	FireOn = 0;
	FoodNode = NULL;
	Commands->Start_Timer(obj,this,1.0f,453455);
}

void JMG_RP2_Grill::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (!ISSELECTINGSPAWN[Get_Player_ID(poker)])
		{
			if (!FireOn && !FoodNode)//Turn on grill
			{
				FireOn = 1;
				Commands->Set_Model(Commands->Find_Object(FlameID),"exp_fire");
			}
			else if (FireOn && !FoodNode)//Add food/turn off grill
			{
				const char *MyFood = Get_Current_Weapon(poker);
				if (MyFood)
				{
					if (Get_Current_Bullets(poker))
					{
						RP2WeaponListControl *MyCurrentFood = Get_WLS_Weapon_Settings(MyFood);
						if (MyCurrentFood)
						{
							if (MyCurrentFood->CookTime)
							{
								GrillTime = 0;
								FoodNode = MyCurrentFood;
								Set_Current_Clip_Bullets(poker,Get_Current_Bullets(poker)-1);
							}
						}
					}
				}
				if (FireOn && !FoodNode)//Turn off grill
				{
					FireOn = 0;
					Commands->Set_Model(Commands->Find_Object(FlameID),"null");
				}
			}
			else if (FireOn && FoodNode)//Remove Food
			{
				Grant_Food(poker);
			}
		}
	}
}

void JMG_RP2_Grill::Timer_Expired(GameObject *obj,int number)
{
	if (number == 453455)
	{
		GrillTime++;
		if (FoodNode->CookTime <= GrillTime && FoodNode->CookTime)
		{
			GrillTime = 0;
			char NewFood[512],FoodnState[128];
			sprintf(NewFood,"%s",FoodNode->WeaponName);
			sprintf(FoodnState,"%s",&NewFood[strlen(NewFood)-1]);
			int FoodState = atoi(FoodnState);
			NewFood[strlen(NewFood-1)] = '\0';
			sprintf(NewFood,"%s%d",NewFood,FoodState+1);
			RP2WeaponListControl *MyFood = Get_WLS_Weapon_Settings(NewFood);
			if (MyFood)
			{
				GrillTime = 0;
				FoodNode = MyFood;
			}
		}
		Commands->Start_Timer(obj,this,1.0f,453455);
	}
}

void JMG_RP2_Grill::Grant_Food(GameObject *obj)
{
	int PlayerID = Get_Player_ID(obj);
	if (!ISSELECTINGSPAWN[PlayerID] && ((!Has_Weapon(obj,FoodNode->WeaponName) && Get_Weapon_Count(obj) < RP2MAXINVENTORYWEAPONLIMIT && 
		((RP2StarCurrentInventorySize[PlayerID] + FoodNode->WeaponSize) <= RP2StarMaxInventorySize[PlayerID]) && 
		((RP2StarCurrentInventorySize[PlayerID] + FoodNode->AmmoSize) <= RP2StarMaxInventorySize[PlayerID])) || /*You donot have the weapon, your weapon count is less then the max and your inventory weight is less than the max*/
		(Has_Weapon(obj,FoodNode->WeaponName) && 
		(Get_Max_Total_Bullets(obj,FoodNode->WeaponName) > Get_Total_Bullets(obj,FoodNode->WeaponName)) && 
		((RP2StarCurrentInventorySize[PlayerID] + FoodNode->AmmoSize) <= RP2StarMaxInventorySize[PlayerID]))))// You already have the weapon, and you have room for more ammo
	{
		if (!Has_Weapon(obj,FoodNode->WeaponName))// Dont have the weapon, take up some space
		{
			Commands->Give_PowerUp(obj,FoodNode->PowerUpName,1);
			RP2StarCurrentInventorySize[PlayerID] += FoodNode->WeaponSize;
		}
		if (Has_Weapon(obj,FoodNode->WeaponName))// Make SURE it has the weapon
		{
			int GunBullets = Get_Clip_Bullets(obj,FoodNode->WeaponName)+1; // Add all your backpack bullets to the powerup's bullets (SO THIS IS ALL THE BULLETS THAT CAN COME INTO PLAY)
			if (FoodNode->AmmoSize)// Ammo takes up inventory, needs special handeling
			{
				int GrantedBullets = 0;
				while (((Get_Total_Bullets(obj,FoodNode->WeaponName) + GrantedBullets) < Get_Max_Total_Bullets(obj,FoodNode->WeaponName)) && ((GunBullets - GrantedBullets) > 0) && ((RP2StarCurrentInventorySize[PlayerID] + (FoodNode->AmmoSize*GrantedBullets)) <= RP2StarMaxInventorySize[PlayerID]))
				{
					GrantedBullets++;
				}
				RP2StarCurrentInventorySize[PlayerID] += (FoodNode->AmmoSize*GrantedBullets);
				GunBullets = GrantedBullets;//All the ammo you get to play with due to the reduction
			}
			int TempCarryOver = 0;
			if (Get_Max_Clip_Bullets(obj,FoodNode->WeaponName) < GunBullets)
			{
				TempCarryOver = GunBullets - Get_Max_Clip_Bullets(obj,FoodNode->WeaponName);
				GunBullets = Get_Max_Clip_Bullets(obj,FoodNode->WeaponName);
			}
			Set_Bullets(obj,FoodNode->WeaponName,Get_Bullets(obj,FoodNode->WeaponName) + TempCarryOver);
			Set_Clip_Bullets(obj,FoodNode->WeaponName,GunBullets);
			if (FoodNode->AmmoSize)
			{
				Add_Or_Update_RP2PlayerSAWT_Node(PlayerID,FoodNode->WeaponName)->LastAmmoCount = Get_Total_Bullets(obj,FoodNode->WeaponName);
			}
			Commands->Select_Weapon(obj,FoodNode->WeaponName);
		}
		FoodNode = NULL;
	}
}

void JMG_RP2_Renhalo_Phone_Exit_Fix::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		PHONEZONES[Get_Player_ID(enter)] = 0;
		Commands->Send_Custom_Event(obj,enter,PHONEAquiredSignal,1,0);
	}
}

void JMG_RP2_Dropped_Credit_Card_Info_Powerup::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(sender)])
		{
			Vector3 pos = Commands->Get_Position(obj);
			pos.Z += 0.25;
			GameObject *object = Commands->Create_Object("Daves_Arrow_NT",pos);
			Commands->Set_Model(object,"null");
			Commands->Set_Facing(object,Commands->Get_Facing(obj));
			char params[2000];
			sprintf(params,"%s",Get_Parameter("Player_Name"));
			Commands->Attach_Script(object,"JMG_RP2_Dropped_Credit_Card_Info_Powerup_Control",params);
			Send_Message_Player(sender,150,0,0,"You must spawn before you can pick that up...");
			return;
		}
		GameObject *Player = Get_GameObj_By_Player_Name(Get_Parameter("Player_Name"));
		if (Player == sender)
		{
			Send_Message_Player(sender,0,150,0,"I have found (hopefully all) of my lost credit card info!");
			return;
		}
		if (Player)
		{
			float Money = Commands->Get_Money(Player);
			if (Money)
			{
				int TakeMoney = (int)(Commands->Get_Random(0.01f,0.05f) * Money);
				if (TakeMoney > 5000)
				{
					TakeMoney = 5000;
				}
				Commands->Give_Money(Player,(float)-TakeMoney,true);
				Commands->Give_Money(sender,(float)TakeMoney,true);
				char message2player[2000];
				const char *str = Get_Player_Name(sender);
				sprintf(message2player,"%s just stole $%.2f from my account using my credit card info!",str,(float)TakeMoney);
				delete[] str;
				Send_Message_Player(Player,0,150,0,message2player);
				Send_Message_Player(Player,0,150,0,"I have closed the account and opened a new one to prevent it from happening again.");
				sprintf(message2player,"I just stole $%.2f from %s's account!",(float)TakeMoney,Get_Parameter("Player_Name"));
				Send_Message_Player(sender,0,150,0,message2player);
			}
			else
			{
				char message2player[2000];
				sprintf(message2player,"Darn, it seems that %s is completely broke!",Get_Parameter("Player_Name"));
				Send_Message_Player(sender,0,150,0,message2player);
			}
		}
		else
		{
			char message2player[2000];
			sprintf(message2player,"%s seems to have closed their banking account!",Get_Parameter("Player_Name"));
			Send_Message_Player(sender,0,150,0,message2player);
		}
	}
}

void JMG_RP2_Dropped_Credit_Card_Info_Powerup_Control::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.1f,955551);
}

void JMG_RP2_Dropped_Credit_Card_Info_Powerup_Control::Timer_Expired(GameObject *obj,int number)
{
	if (955551 == number)
	{
		Vector3 Pos = Commands->Get_Position(obj);
		GameObject *NearestStar = Commands->Get_A_Star(Pos);
		if (Commands->Get_Distance(Commands->Get_Position(NearestStar),Pos) > 1.0f)
		{
			GameObject *object = Commands->Create_Object("POW_Auto_Shotgun_WL",Pos);
			Commands->Set_Model(object,"p_crate");
			Commands->Set_Facing(object,Commands->Get_Facing(obj));
			Dropped_Weapon_Limiter(object,Get_WLS_Weapon_Settings("Dummy_Credit_Info"),0);
			char params[256];
			sprintf(params,"%s",Get_Parameter("Player_Name"));
			Commands->Attach_Script(object,"JMG_RP2_Dropped_Credit_Card_Info_Powerup",params);
			Commands->Destroy_Object(obj);
		}
		else
		{
			Commands->Start_Timer(obj,this,0.25f,955551);
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Created(GameObject *obj)
{
	Commands->Innate_Disable(obj);
	RP2WeaponListControl *ANode2 = Get_WLS_Weapon_Settings("Weapon_M72_LAW");
	if (ANode2)
	{
		Commands->Give_PowerUp(obj,ANode2->PowerUpName,1);
		Set_Clip_Bullets(obj,ANode2->WeaponName,-1);
	}
	const char *MyWeapon = Get_Current_Weapon(obj);
	sprintf(PrimaryWeapon,"Weapon_M72_LAW");
	if (MyWeapon)
	{
		sprintf(PrimaryWeapon,"%s",MyWeapon);
	}
	SwarmSize++;
	GlobalHuntProbability = 1100/SwarmSize;
	SwarmHuntProbability = 220/SwarmSize;
	Attacking = 0;
	CurrentTarget = 0;
	speed = Commands->Get_Random(1.0,1.5);
	if (Get_Float_Parameter("AttackDistance") < 100)
	{
		speed = Commands->Get_Random(1.25,1.75);
	}
	if (Get_Float_Parameter("AttackDistance") < 10)
	{
		speed = Commands->Get_Random(1.75,2.25);
	}
	LastTargetLocation = HomeLocation = Commands->Get_Position(obj);
	StuckCount = 0;
	GiveUp = 0;
	IAmGroupingUp = 0;
	Hunting = 0;
	AttackMoveT = 0;
	Backward = 0;
	GotoSpot = 0;
	MovingToVehicle = 0;
	VehicleStuckCount = 0;
	EnterVehicleTargetID = 0;
	CanHearDelay = 0;
	AutoEnter = 0;
	NewVehicleAction = Commands->Get_Random_Int(50,150);
	LastPos = Commands->Get_Position(obj);
	JumpyAttack = Get_Int_Parameter("JumpyAttack");
	EnterVehicleMoveUpdate = 0;
	Commands->Enable_Enemy_Seen(obj,true);
	Commands->Start_Timer(obj,this,0.1f,92562143);
	Commands->Start_Timer(obj,this,1.0f,92562145);
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
	{
		return;
	}
	if (Commands->Is_A_Star(seen))// Don't attack players that haven't spawned
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(seen)])
		{
			return;
		}
	}
	if (Is_Script_Attached(seen,"JMG_Dont_Be_A_Douche"))//Don't attack players with spawn kill
	{
		return;
	}
	GameObject *MyVehicle = Get_Vehicle(obj);
	if (seen->As_VehicleGameObj())
	{
		Vector3 MyPos = Commands->Get_Position(obj);
		if (!Get_Vehicle_Occupant_Count(seen) && Commands->Get_Distance(MyPos,Commands->Get_Position(Commands->Get_A_Star(MyPos))) > 100.0f)// Ignore empty vehicles unless a soldier is less than 100m away
		{
			return;
		}
	}
	if (seen->As_VehicleGameObj() && !MyVehicle)
	{
		if (!Get_Vehicle_Seat_Count(seen))// Don't attack vehicles that can't be used
		{
			return;
		}
		if (!Get_Vehicle_Occupant_Count(seen) && !MyVehicle && Get_Int_Parameter("Can_Steal_Vehicles"))// Don't attack empty vehicles unless in a vehicle
		{
			EnterVehicleTargetID = Commands->Get_ID(seen);
			return;
		}
		if (Get_Float_Parameter("AttackDistance") < 10 && !MyVehicle && !Get_Int_Parameter("Can_Use_Rockets"))
		{
			return;
		}
	}
	if (!CurrentTarget && Commands->Get_Health(seen))
	{
		Attacking = 0;
		CurrentTarget = Commands->Get_ID(seen);
		GiveUp = 40;
		if (Get_Int_Parameter("Can_Use_Rockets") && !MyVehicle)// Not in a vehicle
		{
			const char *MyWeapon = Get_Current_Weapon(obj);
			if (MyWeapon && ((seen->As_PhysicalGameObj() && seen->As_PhysicalGameObj()->Peek_Physical_Object() && seen->As_PhysicalGameObj()->Peek_Physical_Object()->As_TrackedVehicleClass()) || ((seen->As_PhysicalGameObj() && seen->As_PhysicalGameObj()->Peek_Physical_Object() && seen->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()) && Get_Current_Weapon(seen))))//Weapon Choice
			{
				if (_stricmp("Weapon_M72_LAW",MyWeapon))
				{
					Commands->Select_Weapon(obj,"Weapon_M72_LAW");
				}
			}
			else
			{
				if (_stricmp(PrimaryWeapon,MyWeapon))
				{
					Commands->Select_Weapon(obj,PrimaryWeapon);
				}
			}
		}
	}
	if (CurrentTarget == Commands->Get_ID(seen))
	{
		if (!MyVehicle)
		{
			GiveUp = 30;
		}
		else
		{
			GiveUp = 40;
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Timer_Expired(GameObject *obj,int number)
{
	if (!Commands->Get_Health(obj))
	{
		return;
	}
	if (92562143 == number)
	{
		float Time = 0.1f;
		Vector3 Pos = Commands->Get_Position(obj);
		GameObject *MyVehicle = Get_Vehicle(obj);
		if (EnterVehicleTargetID)// Try to get in a vehicle
		{
			Vehicle_Enter_Logic(obj,Pos,&Time,MyVehicle);
		}
		if (AttackMoveT && !EnterVehicleTargetID)// Go to targets last seen position
		{
//Console_Input("MESSAGE Go to targets last seen position");
			Action_Reset(obj);
			Goto_Location(obj,LastEnemyPos,1,Commands->Get_Random(1.0,5.0));
			AttackMoveT = 0;
		}
		if (GroupUp == 1 && !IAmGroupingUp && !EnterVehicleTargetID)// Make sure they are all grouping up at the same time
		{
//Console_Input("MESSAGE All Grouped Up");
			IAmGroupingUp = 1;
			StuckCount = 0;
			Hunting = 0;
		}
		if (CurrentTarget)
		{
			Attack_Logic(obj,&Time,Pos,MyVehicle);
		}
		if (!IAmGroupingUp && MyVehicle && !CurrentTarget)
		{
			VehicleRandomAction(obj,&Time,MyVehicle);
		}
		if (Commands->Get_Distance(Pos,LastPos) < 0.025)////-------------------STUCK CHECKS-----------------------
		{
			StuckCount++;
			if (MyVehicle)// Vehicle Stuck Check
			{
				BackwardCount++;
				if (BackwardCount >= 20 && !Backward)//Stuck First Time
				{
//Console_Input("MESSAGE Reverse");
					Backward = 1;
					UpdateAction(obj);
					Commands->Start_Timer(obj,this,Commands->Get_Random(1.0f,3.0f),92562144);//Reverse Time
				}
				if (VehicleStuckCount >= 10 && !IAmGroupingUp)// Try something else
				{
					VehicleStuckCount = 0;
//Console_Input("MESSAGE Choose a random action 1");
					ChooseARandomAction(obj,&Time);
				}
			}
			if (!IAmGroupingUp)
			{
				UnGroupedStuckActions(obj,&Time);
			}
			else if (IAmGroupingUp)// Move to group
			{
				GroupedStuckActions(obj,&Time);
			}
		}
		else
		{
			StuckCount = 0;
		}
		LastPos = Pos;
		Commands->Start_Timer(obj,this,0.1f,92562143);
	}
	if (92562144 == number)//Car go forward
	{
//Console_Input("MESSAGE Forward");
		BackwardCount = 0;
		Backward = 0;
		UpdateAction(obj);
	}
	if (92562145 == number)//Car go forward
	{
		if (CanHearDelay)
		{
			CanHearDelay--;
		}
		Commands->Start_Timer(obj,this,1.0f,92562145);
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damager == obj || !_stricmp(Get_Skin(damager),"Blamo") || !_stricmp(Get_Shield_Type(damager),"Blamo"))
	{
		return;
	}
	if (damager)
	{
		//Console_Input("MESSAGE !DAMAGE!");
		if (!CurrentTarget && Commands->Get_Player_Type(damager) != Get_Player_Type(obj))
		{
			Attacking = 0;
			CurrentTarget = Commands->Get_ID(damager);
			FaceTarget(obj,Commands->Get_Position(damager));
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Sound_Heard(GameObject *obj,const CombatSound &sound)
{
	if (!CurrentTarget)
	{
		if (CanHearDelay)
		{
			return;
		}
		GameObject *SoundObject = sound.Creator;
		if (!SoundObject)
		{
			return;
		}
		if (!Commands->Is_A_Star(SoundObject))
		{
			return;
		}
		if (ISSELECTINGSPAWN[Get_Player_ID(SoundObject)])
		{
			return;
		}
		if (Get_Player_Type(SoundObject) != Get_Player_Type(obj))
		{
		//Console_Input("MESSAGE !SOUND!");
			Attacking = 0;
			CanHearDelay = Commands->Get_Random_Int(5,15);
			Goto_Location(obj,Commands->Get_Position(sound.Creator),1,Commands->Get_Random(5.0f,15.0f));
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Destroyed(GameObject *obj)
{
	SwarmSize--;
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Killed(GameObject *obj, GameObject *damager)
{
	const char *MyWeapon = Get_Current_Weapon(obj);
	RP2WeaponListControl *Weapon;
	if (!MyWeapon)
	{
		Weapon = Get_WLS_Weapon_Settings("Weapon_Ammo_Box");
	}
	else
	{
		Weapon = Get_WLS_Weapon_Settings(MyWeapon);
	}
	if (Weapon)
	{
		if (!Weapon->CanBeDropped)
		{
			Weapon = Get_WLS_Weapon_Settings("Weapon_Ammo_Box");
		}
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z += Weapon->DropHeight;
		GameObject *object = Commands->Create_Object("Daves_Arrow_NT",pos);
		Commands->Set_Model(object,"null");
		Commands->Set_Facing(object,Commands->Get_Facing(obj));
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			char params[2000];
			sprintf(params,"%s,%d,0.25,0.25,0.25,1,0,1",Weapon->WeaponName,Commands->Get_Random_Int(0,Get_Max_Total_Bullets(obj,Weapon->WeaponName)));
			Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);
		}
		else
		{
			char params[2000];
			sprintf(params,"%s,%d,0.25,0.25,0.25,1,0,1",Weapon->WeaponName,Commands->Get_Random_Int(0,1000));
			Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Attack_Target(GameObject *obj,int TargetID,bool Pathfind,float AttackRange)
{
	Action_Reset(obj);
	float MaxDistance = Commands->Get_Random(0.0,15);
	if (Get_Float_Parameter("AttackDistance") < 10)
	{
		MaxDistance = Commands->Get_Random(1.0,(Get_Float_Parameter("AttackDistance")-1));
	}
	Attacking = 1;
	Hunting = 0;
	GotoSpot = 0;
	MovingToVehicle = 0;
	Commands->Action_Reset(obj,10);
	GameObject *target = Commands->Find_Object(TargetID);
	if (target)
	{
		ActionParamsStruct params;
		params.Set_Movement(target,speed,MaxDistance,false);
		params.MoveFollow = true;
		GameObject *MyVehicle = Get_Vehicle(obj);
		if (MyVehicle)
		{
			obj = MyVehicle;
			AttackRange = 295.0f;
			params.MoveBackup=Backward;
			if ((MyVehicle->As_PhysicalGameObj() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
			{
				Pathfind = false;
			}
		}
		else
		{
			params.MoveBackup=0;
		}
		params.MovePathfind=Pathfind;
		Commands->Action_Goto(obj,params);
		params.Set_Basic(this,100,10);
		params.Set_Attack(target,AttackRange,0,1);
		params.AttackCheckBlocked = false;
		if (MyVehicle)
		{
			Commands->Action_Attack(MyVehicle,params);
		}
		else
		{
			Commands->Action_Attack(obj,params);
		}
		if (SwarmHunt)
		{
			SwarmHunt = 0;
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Goto_Location(GameObject *obj,Vector3 TargetLocation,bool Pathfind,float ArriveDistance)
{
	LastTargetLocation = TargetLocation;
	Action_Reset(obj);
	GotoSpot = 1;
	Attacking = 0;
	Hunting = 0;
	MovingToVehicle = 0;
	Commands->Action_Reset(obj,10);
	ActionParamsStruct params;
	params.Set_Basic(this,100,10);
	params.MoveFollow=false;
	GameObject *MyVehicle = Get_Vehicle(obj);
	if (MyVehicle)
	{
		obj = MyVehicle;
		params.MoveBackup=Backward;
		if ((MyVehicle->As_PhysicalGameObj() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
		{
			//TargetLocation.Z = Commands->Get_Safe_Flight_Height(TargetLocation.X,TargetLocation.Y);
			params.MovePathfind=false;
			ArriveDistance = 0.0f;
		}
	}
	else
	{
		params.MoveBackup=0;
		params.MovePathfind=Pathfind;
	}
	params.Set_Movement(TargetLocation,speed,ArriveDistance,false);
	Commands->Action_Goto(obj,params);
	if (SwarmHunt)
	{
		SwarmHunt = 0;
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Hunt_Star(GameObject *obj)
{
	Action_Reset(obj);
	Attacking = 0;
	Hunting = 1;
	GotoSpot = 0;
	MovingToVehicle = 0;
	Commands->Action_Reset(obj,10);
	ActionParamsStruct params;
	params.Set_Basic(this,99,10);
	if (Get_Vehicle(obj))
	{
		obj = Get_Vehicle(obj);
		params.MoveBackup=Backward;
	}
	else
	{
		params.MoveBackup=0;
	}
	params.Set_Movement(Commands->Get_A_Star(Commands->Get_Position(obj)),speed,Commands->Get_Random(5.0f,20.0f),false);
	params.MoveFollow = true;
	Commands->Action_Goto(obj,params);
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Swarm_Group_Up(GameObject *obj)
{
	if (!GroupUp)
	{
		RP2RandomTeleportPositionControl *ANode = Swarm_Get_Random_Teleport_Node(obj,300.0f);
		if (ANode)
		{
			GroupedSwarm = 0;
			SwarmLocation = ANode->Telepos;
			GroupUp = 1;
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Goto_Random_Spot(GameObject *obj,float MaxDistance)
{
	RP2RandomTeleportPositionControl *ANode = Swarm_Get_Random_Teleport_Node(obj,MaxDistance);
	if (ANode)
	{
		Goto_Location(obj,ANode->Telepos,1,Commands->Get_Random(5.0f,20.0f));
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::AttackMove(GameObject *obj,float AttackRange,Vector3 Pos)
{
	LastTargetLocation = Pos;
	Action_Reset(obj);
	GameObject *Target = Commands->Find_Object(CurrentTarget);
	Attacking = 1;
	Hunting = 0;
	GotoSpot = 1;
	MovingToVehicle = 0;
	if (Target)
	{
		Attacking = 1;
		Commands->Action_Reset(obj,10);
		ActionParamsStruct params;
		params.Set_Movement(Pos,speed,1.0,false);
		params.MovePathfind=false;
		GameObject *MyVehicle = Get_Vehicle(obj);
		if (MyVehicle)
		{
			obj = MyVehicle;
			AttackRange = 295.0f;
			params.MoveBackup=Backward;
		}
		else
		{
			params.MoveBackup=0;
		}
		Commands->Action_Goto(obj,params);
		params.Set_Basic(this,100,10);
		params.Set_Attack(Target,AttackRange,0,1);
		params.AttackCheckBlocked = false;
		if (MyVehicle)
		{
			Commands->Action_Attack(MyVehicle,params);
		}
		else
		{
			Commands->Action_Attack(obj,params);
		}
		if (SwarmHunt)
		{
			SwarmHunt = 0;
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Action_Reset(GameObject *obj)
{
	Commands->Action_Reset(obj,10);
	Commands->Action_Reset(obj,100);
	Commands->Action_Reset(obj,999);
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::FaceTarget(GameObject *obj,Vector3 pos)
{
	Vector3 Movement = Commands->Get_Position(obj);
	pos.X -= Movement.X;
	pos.Y -= Movement.Y;
	float TempRotation = atan2(pos.Y,pos.X) * 180 / PI;
	Commands->Set_Facing(obj,TempRotation);
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::UpdateAction(GameObject *obj)
{
	VehicleStuckCount++;
	if (GotoSpot && Hunting)
	{
		AttackMove(obj,Get_Float_Parameter("AttackDistance"),LastTargetLocation);
	}
	else if (GotoSpot)
	{
		Goto_Location(obj,LastTargetLocation,true,Commands->Get_Random(5.0f,15.0f));
	}
	else if (Attacking)
	{
		Attack_Target(obj,CurrentTarget,true,Get_Float_Parameter("AttackDistance"));
	}
	else if (Hunting)
	{
		Hunt_Star(obj);
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::ChooseARandomAction(GameObject *obj,float *Time)
{
	int Random = Commands->Get_Random_Int(0,10000);
	GameObject *MyVehicle = Get_Vehicle(obj);
	if (MyVehicle)
	{
		if (Random <= 1500)// Make random hunt attempt
		{
			CurrentTarget = Commands->Get_ID(Commands->Get_A_Star(Commands->Get_Position(obj)));
		}
		else if (Random <= 1500)// Make random hunt attempt
		{
			//Console_Input("MESSAGE :Hunt Star");
			Hunt_Star(obj);
			*Time = 2.0f;
		}
		else if (Random <= 10000)// Make a random move
		{
			//Console_Input("MESSAGE :Got Random Spot");
			Goto_Random_Spot(obj,200);
			*Time = 2.0f;
		}
	}
	else if (Hunting > 1 && Hunting < 10)
	{
		//Console_Input("MESSAGE :Remind hunting");
		Hunting++;
		Hunt_Star(obj);
		*Time = 2.0f;
	}
	else if (Random <= SwarmHuntProbability)// Randomly Choose to group up*/
	{
		//Console_Input("MESSAGE :Swarm Groupup");
		Swarm_Group_Up(obj);
	}
	else if (Random <= GlobalHuntProbability)// Global swarm hunt!
	{
		SwarmHunt = 1;
	}
	else if (Random <= 500)// Make random hunt attempt
	{
		//Console_Input("MESSAGE :Hunt Star");
		Hunt_Star(obj);
		*Time = 2.0f;
	}
	else if (Random <= 10000)// Make a random move
	{
		//Console_Input("MESSAGE :Got Random Spot");
		Goto_Random_Spot(obj,200);
		*Time = 2.0f;
	}
	else // GO HOME!
	{
	//Console_Input("MESSAGE :Go Home");
		Goto_Location(obj,HomeLocation,1,50.0f);
		*Time = 2.0f;
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::UnGroupedStuckActions(GameObject *obj,float *Time)
{
	if (StuckCount >= 20 && StuckCount < 30)// Make the swarm hunt if possibile
	{
		if (SwarmHunt && !Hunting)
		{
//Console_Input("MESSAGE Force into the swarm hunt!");
			Hunt_Star(obj);
			*Time = 2.0f;
		}
	}
	if (!(StuckCount % 30))
	{
//Console_Input("MESSAGE Choose a random action 2");
		ChooseARandomAction(obj,Time);
	}
	if (StuckCount == 121)
	{
//Console_Input("MESSAGE Stuck too long, hunt the star.");
		Hunt_Star(obj);
		*Time = 2.0f;
	}
	if (StuckCount == 601)// Attempt for a random move
	{
//Console_Input("MESSAGE Stuck too long, attempt random movement.");
		Goto_Random_Spot(obj,100);
		*Time = 2.0f;
	}
	if (StuckCount == 1001)// Last Ditch attempt for a random move
	{
		Goto_Random_Spot(obj,1000);
		*Time = 2.0f;
	}
	if (StuckCount > 3001)// Stuck WAY too long, kill
	{
		if (Get_Vehicle(obj))
		{
			StuckCount = 0;
			Commands->Apply_Damage(Get_Vehicle(obj),9999.99f,"BlamoKiller",0);
		}
		else
		{
			StuckCount = 0;
			Commands->Apply_Damage(obj,9999.99f,"BlamoKiller",0);
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::GroupedStuckActions(GameObject *obj,float *Time)
{
	if (StuckCount == 10)// Goto Swarm Meeting Location
	{
//Console_Input("MESSAGE Goto swarm meeting location");
		Goto_Location(obj,SwarmLocation,1,Commands->Get_Random(25.0f,50.0f));
	}
	if (StuckCount == 60)// Made it to the location
	{
		GroupedSwarm++;
	}
	if (StuckCount > 3000 || StuckCount > (SwarmSize * 100))// Give up and attack (5 min give up time max or 10 seconds per soldier)
	{
//Console_Input("MESSAGE Give up launch swarm attack");
		Hunt_Star(obj);
		GroupUp = -3;
		IAmGroupingUp = 0;
		StuckCount = -60;
		*Time = 2.0f;
	}
	if (GroupedSwarm == SwarmSize && IAmGroupingUp)//Attack!
	{
//Console_Input("MESSAGE Group successful, launch attack");
		Hunt_Star(obj);
		GroupUp = -3;
		IAmGroupingUp = 0;
		StuckCount = -60;
		*Time = 2.0f;
	}
	if (StuckCount > 6000)// Stuck WAY too long, kill
	{
		if (Get_Vehicle(obj))
		{
			StuckCount = 0;
			Commands->Apply_Damage(Get_Vehicle(obj),9999.99f,"BlamoKiller",0);
		}
		else
		{
			StuckCount = 0;
			Commands->Apply_Damage(obj,9999.99f,"BlamoKiller",0);
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::VehicleRandomAction(GameObject *obj,float *Time,GameObject *MyVehicle)
{
	if (!(MyVehicle->As_PhysicalGameObj() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object()->As_TrackedVehicleClass()))
	{
		NewVehicleAction--;
		if (NewVehicleAction <= 0)
		{
			//Console_Input("MESSAGE In a vehicle, stay ontop of your game");
			NewVehicleAction = Commands->Get_Random_Int(50,100);
			ChooseARandomAction(obj,Time);
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Attack_Logic(GameObject *obj,float *Time,Vector3 Pos,GameObject *MyVehicle)
{
	GameObject *CT = Commands->Find_Object(CurrentTarget);
	if (!Commands->Get_Health(CT) || !CT || MyVehicle == CT)// Targert is No more
	{
//Console_Input("MESSAGE Target is dead/no more");
		Attacking = 0;
		StuckCount = 0;
		CurrentTarget = 0;
		Action_Reset(obj);
	}
	if (GiveUp)
	{
		GiveUp--;
	}
	if (GiveUp <= 0)// Target not visible
	{
//Console_Input("MESSAGE Target left line of sight");
		StuckCount = 0;
		CurrentTarget = 0;
		if (Commands->Get_Random_Int(0,100) < 75)
		{
			AttackMoveT = 1;
			LastEnemyPos = Commands->Get_Position(CT);
			Goto_Location(obj,LastEnemyPos,1,Commands->Get_Random(1.0,5.0));
			*Time = Commands->Get_Random(0.0f,1.0f);
		}
		else
		{
			Action_Reset(obj);
		}
	}
	if (!Attacking && !EnterVehicleTargetID && CurrentTarget)
	{
//Console_Input("MESSAGE Command attack");
		Attack_Target(obj,CurrentTarget,1,Get_Float_Parameter("AttackDistance"));
	}
	if (!(StuckCount % 7) && CurrentTarget && !EnterVehicleTargetID)// Random Movement
	{
		if (Commands->Get_Random_Int(0,100) > 100*(Commands->Get_Distance(Pos,Commands->Get_Position(CT))/Get_Float_Parameter("AttackDistance")) && JumpyAttack && !MyVehicle)
		{
//Console_Input("MESSAGE Random movement during attack");
			RandomMoveSpot = Commands->Get_Position(obj);
			RandomMoveSpot.X += Commands->Get_Random(-10.0f,10.0f);
			RandomMoveSpot.Y += Commands->Get_Random(-10.0f,10.0f);
			AttackMove(obj,Get_Float_Parameter("AttackDistance"),RandomMoveSpot);
		}
		else
		{
			AttackMove(obj,Get_Float_Parameter("AttackDistance"),Commands->Get_Position(CT));
		}
	}
}

void JMG_Renhalo_Mindless_Hunt_And_Attack::Vehicle_Enter_Logic(GameObject *obj,Vector3 Pos,float *Time,GameObject *MyVehicle)
{
	Attacking = 0;
	Hunting = 0;
	GotoSpot = 0;
	GameObject *TVehicle = Commands->Find_Object(EnterVehicleTargetID);
	if (TVehicle && !MyVehicle && !Get_Vehicle_Occupant_Count(TVehicle))
	{
		EnterVehicleMoveUpdate++;
		Vector3 Postion = Commands->Get_Position(TVehicle);
		if (!CurrentTarget)
		{
			if (MovingToVehicle != 1)
			{
				Action_Reset(obj);
			}
			EnterVehicleMoveUpdate = 0;
			MovingToVehicle = 1;
			Goto_Location(obj,Postion,1,0.0f);
		}
		else if (EnterVehicleMoveUpdate > 30)
		{
			EnterVehicleMoveUpdate = 0;
			if (MovingToVehicle != 2)
			{
				Action_Reset(obj);
			}
			MovingToVehicle = 2;
			AttackMove(obj,Get_Float_Parameter("AttackDistance"),Postion);
		}
		if (Commands->Get_Distance(Postion,Pos) < 20.0f)
		{
			AutoEnter++;
			if (Commands->Get_Distance(Postion,Pos) < 5.0f || AutoEnter > 100)
			{
				AutoEnter = 0;
				Commands->Set_Position(obj,Postion);
				Soldier_Transition_Vehicle(obj);
				MovingToVehicle = 0;
			}
		}
	}
	else if (MyVehicle == TVehicle && !CurrentTarget)
	{
		AutoEnter = 0;
		MovingToVehicle = 0;
		EnterVehicleTargetID = 0;
		VehicleRandomAction(obj,Time,MyVehicle);
		NewVehicleAction = Commands->Get_Random_Int(5,50);
		Commands->Set_Player_Type(MyVehicle,Get_Player_Type(obj));
	}
	else if (MyVehicle)
	{
		Soldier_Transition_Vehicle(obj);
	}
	else
	{
		AutoEnter = 0;
		MovingToVehicle = 0;
		EnterVehicleTargetID = 0;
	}
}

void JMG_RP2_Phone_Create_AI_Swarm::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message") && Commands->Get_Health(sender))
	{
		Vector3 pos;
		pos.X = 0;
		pos.Y = 0;
		pos.Z = 7.49f;//
		Create_The_Swarm(sender,pos);
		pos.X = -838.258f;
		pos.Y = 270.78f;
		pos.Z = 8.04f;//
		Create_The_Swarm(sender,pos);
		pos.X = -941.31f;
		pos.Y = -77.18f;
		pos.Z = 24.00;//
		Create_The_Swarm(sender,pos);
		pos.X = -982.92f;
		pos.Y = -285.51f;
		pos.Z = -3.65f;//
		Create_The_Swarm(sender,pos);
		pos.X = -1358.84f;
		pos.Y = -243.42f;
		pos.Z = -3.69f;//
		Create_The_Swarm(sender,pos);
		pos.X = -1244.62f;
		pos.Y = -117.96f;
		pos.Z = -18.54f;//
		Create_The_Swarm(sender,pos);
		pos.X = -1513.57f;
		pos.Y = -118.30f;
		pos.Z = -21.52f;//
		Create_The_Swarm(sender,pos);
		pos.X = -1717.99f;
		pos.Y = 173.30f;
		pos.Z = -1.95f;//
		Create_The_Swarm(sender,pos);
		pos.X = -1335.46f;
		pos.Y = 333.04f;
		pos.Z = 7.44f;//
		Create_The_Swarm(sender,pos);
		pos.X = -1110.82f;
		pos.Y = -169.52f;
		pos.Z = -3.68f;//
		Create_The_Swarm(sender,pos);
		pos.X = -1730.08f;
		pos.Y = 409.08f;
		pos.Z = 10.17f;//
		Create_The_Swarm(sender,pos);
		if (param < 2)
		{
			Commands->Send_Custom_Event(sender,obj,message,param+1,0.1f);
		}
	}
}

void JMG_RP2_Phone_Create_AI_Swarm::Create_AI(GameObject *AI,GameObject *sender,Vector3 Location)
{
	char params[256];
	float Range = 0;
	if (Is_Script_Attached(AI,"JMG_Free_For_All_Script"))
	{
		Remove_Script(AI,"JMG_Free_For_All_Script");
	}
	if (Get_Int_Parameter("Soldier_Type") == 1)
	{
		Commands->Set_Player_Type(AI,0);
		RP2WeaponListControl *ANode = Get_WLS_Random_Weapon_Node();
		if (ANode)
		{
			Commands->Give_PowerUp(AI,ANode->PowerUpName,1);
			if (Has_Weapon(AI,ANode->WeaponName))
			{
				Commands->Select_Weapon(AI,ANode->WeaponName);
				Set_Clip_Bullets(AI,ANode->WeaponName,-1);
				const AmmoDefinitionClass *PrimaryAmmo = Get_Weapon_Ammo_Definition(ANode->WeaponName,1);
				if (PrimaryAmmo)
				{	
					Range = PrimaryAmmo->Range;
				}
				//if (The_Game()->MaxPlayers + 1 >= 2)
				{
					if (Range > 295)
					{
						Range = 295.0f;
					}
				}
				sprintf(params,"1,%d,%d,%f",Get_Int_Parameter("Can_Steal_Vehicles"),Get_Int_Parameter("Can_Use_Rockets"),Range);
			}
		}
	}
	else
	{
		Commands->Set_Player_Type(AI,2);
		const char *MyWeapon = Get_Current_Weapon(AI);
		if (MyWeapon)
		{
			const AmmoDefinitionClass *PrimaryAmmo = Get_Weapon_Ammo_Definition(MyWeapon,1);
			if (PrimaryAmmo)
			{	
				Range = PrimaryAmmo->Range;
			}
		}
	}
	sprintf(params,"1,%d,%d,%f",Get_Int_Parameter("Can_Steal_Vehicles"),Get_Int_Parameter("Can_Use_Rockets"),Range);
	Commands->Attach_Script(AI,"JMG_Renhalo_Mindless_Hunt_And_Attack",params);
	sprintf(params,"1.0,34234,%s,%s",Get_Skin(AI),Get_Shield_Type(AI));
	Commands->Set_Shield_Type(AI,"Blamo");
	Set_Skin(AI,"Blamo");
	Commands->Attach_Script(AI,"JMG_Change_HP_Shields_On_Timer",params);
	Commands->Attach_Script(AI,"M00_No_Falling_Damage_DME","0");
	if (AI->As_PhysicalGameObj())
	{
		Vector3 pos = Location;
		Vector3 ExitPos = pos;
		PhysicalGameObj *objphys = ((ScriptableGameObj *)AI)->As_PhysicalGameObj();
		objphys->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Find_Teleport_Location(pos,15.0f,&ExitPos);
		Commands->Set_Position(AI,ExitPos);
	}
}

GameObject *JMG_RP2_Phone_Create_AI_Swarm::Soldier_Twiddler(Vector3 Pos)
{
	/*switch(Commands->Get_Random_Int(0,4))
	{
	case 0: 
		return Commands->Create_Object("M07_Nod_APC_Twiddler",Pos);
		break;
	case 1: 
		return Commands->Create_Object("M08_Nod_APC_Twiddler",Pos);
		break;
	case 2: 
		return Commands->Create_Object("M10_Reinforcement",Pos);
		break;
	case 3: 
		return Commands->Create_Object("MX0_Area4_GDI_Reinforcement",Pos);
		break;
	case 4: 
		return Commands->Create_Object("MX0_Area4_GDI_Reinforcement",Pos);
		break;
	default:
		return Commands->Create_Object("MX0_Area4_GDI_Reinforcement",Pos);
		break;
	}*/
	if (Get_Int_Parameter("Soldier_Type") == 1)
	{
		switch(Commands->Get_Random_Int(0,2))
		{
		case 0: 
			return Commands->Create_Object("US_Marine_White",Pos);
			break;
		case 1: 
			return Commands->Create_Object("US_Marine_Black",Pos);
			break;
		default:
			return Commands->Create_Object("US_Marine_Black",Pos);
			break;
		}
	}
	else
	{
		switch(Commands->Get_Random_Int(0,4))
		{
		case 0: 
			return Commands->Create_Object("DM_Ice_Zombie",Pos);
			break;
		default:
			return Commands->Create_Object("DM_Zombie",Pos);
			break;
		}
	}
}

void JMG_RP2_Phone_Create_AI_Swarm::Create_The_Swarm(GameObject *sender,Vector3 pos)
{
	for (int x = 1;x < 128;x++)
	{
		GameObject *Player = Get_GameObj(x);
		if (Player)
		{
			if (Commands->Get_Distance(Commands->Get_Position(Player),pos) < 100)
			{
				return;
			}
		}
	}
	GameObject *AI = Soldier_Twiddler(pos);
	if (Is_Script_Attached(AI,"JMG_Mindless_Zombie_Hunt"))
	{
		Remove_Script(AI,"JMG_Mindless_Zombie_Hunt");
		Remove_Script(AI,"JMG_RP2_Freezer_Burn");
		Remove_Script(AI,"JMG_RP2_Random_Splatters");
		Commands->Attach_Script(AI,"JMG_Free_For_All_Script","");
	}
	Create_AI(AI,sender,pos);
}

void Spawn_Zombie_When_Killed_By_Zombie::Killed(GameObject *obj, GameObject *damager)
{
	if (damager)
	{
		if (!_stricmp(Commands->Get_Preset_Name(damager),"DM_Zombie"))
		{
			Vector3 Pos = Commands->Get_Position(obj);
			GameObject *AI; 
			switch(Commands->Get_Random_Int(0,4))
			{
			case 0: 
				AI = Commands->Create_Object("DM_Ice_Zombie",Pos);
				break;
			default:
				AI = Commands->Create_Object("DM_Zombie",Pos);
				break;
			}
			if (Is_Script_Attached(AI,"JMG_Mindless_Zombie_Hunt"))
			{
				Remove_Script(AI,"JMG_Mindless_Zombie_Hunt");
				Remove_Script(AI,"JMG_RP2_Freezer_Burn");
				Remove_Script(AI,"JMG_RP2_Random_Splatters");
				Commands->Attach_Script(AI,"JMG_Free_For_All_Script","");
			}
			char params[256];
			float Range = 0;
			if (Is_Script_Attached(AI,"JMG_Free_For_All_Script"))
			{
				Remove_Script(AI,"JMG_Free_For_All_Script");
			}
			Commands->Set_Player_Type(AI,2);
			const char *MyWeapon = Get_Current_Weapon(AI);
			if (MyWeapon)
			{
				const AmmoDefinitionClass *PrimaryAmmo = Get_Weapon_Ammo_Definition(MyWeapon,1);
				if (PrimaryAmmo)
				{	
					Range = PrimaryAmmo->Range;
				}
			}
			sprintf(params,"1,0,0,%f",Range);
			Commands->Attach_Script(AI,"JMG_Renhalo_Mindless_Hunt_And_Attack",params);
			sprintf(params,"1.0,34234,%s,%s",Get_Skin(AI),Get_Shield_Type(AI));
			Commands->Set_Shield_Type(AI,"Blamo");
			Set_Skin(AI,"Blamo");
			Commands->Attach_Script(AI,"JMG_Change_HP_Shields_On_Timer",params);
			Commands->Attach_Script(AI,"M00_No_Falling_Damage_DME","0");
			if (AI->As_PhysicalGameObj())
			{
				Vector3 pos = Pos;
				Vector3 ExitPos = pos;
				PhysicalGameObj *objphys = ((ScriptableGameObj *)AI)->As_PhysicalGameObj();
				objphys->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Find_Teleport_Location(pos,1.25f,&ExitPos);
				Commands->Set_Position(AI,ExitPos);
			}
		}
	}
}

void JMG_Bring_Up_Text_Box_On_Poke::Poked(GameObject *obj,GameObject *poker)
{
	Commands->Start_Timer(obj,this,Get_Float_Parameter("Delay"),92562143);
}

void JMG_Bring_Up_Text_Box_On_Poke::Timer_Expired(GameObject *obj,int number)
{
	if (92562143 == number)
	{
		char *NewMessage = newstr(Get_Parameter("Text_Message"));
		char Delim = Get_Parameter("Delim")[0];
		unsigned int x = strlen(NewMessage);
		for (unsigned int i=0;i<x;i++)
		{
			if (NewMessage[i] == Delim)
			{
				NewMessage[i] = ',';
			}
		}
		char TT[234];
		sprintf(TT,"admin_message %s",NewMessage);
		delete NewMessage;
		Console_Input(TT);
	}
}

void JMG_RP2_Phone_Create_AI_Swarm_One::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		Vector3 Pos = Spawn_Pos_Twiddler();
		GameObject *AI = Soldier_Twiddler(Pos);
		if (Is_Script_Attached(AI,"JMG_Mindless_Zombie_Hunt"))
		{
			Remove_Script(AI,"JMG_Mindless_Zombie_Hunt");
			Remove_Script(AI,"JMG_RP2_Freezer_Burn");
			Remove_Script(AI,"JMG_RP2_Random_Splatters");
			Commands->Attach_Script(AI,"JMG_Free_For_All_Script","");
		}
		GameObject *PhoneTower = Find_Nearest_Preset(Commands->Get_Position(obj),RP2PHONEBOOKPRESET);
		char Params[234];
		sprintf(Params,"%d,25453",Commands->Get_ID(PhoneTower));
		Commands->Attach_Script(AI,"JFW_Death_Send_Custom_ID",Params);
		Create_AI(AI,sender,Pos);
	}
}

void JMG_RP2_Phone_Create_AI_Swarm_One::Create_AI(GameObject *AI,GameObject *sender,Vector3 Location)
{
	char params[256];
	float Range = 0;
	if (Is_Script_Attached(AI,"JMG_Free_For_All_Script"))
	{
		Remove_Script(AI,"JMG_Free_For_All_Script");
	}
	if (Get_Int_Parameter("Soldier_Type") == 1)
	{
		Commands->Set_Player_Type(AI,0);
		RP2WeaponListControl *ANode = Get_WLS_Random_Weapon_Node();
		if (ANode)
		{
			Commands->Give_PowerUp(AI,ANode->PowerUpName,1);
			if (Has_Weapon(AI,ANode->WeaponName))
			{
				Commands->Select_Weapon(AI,ANode->WeaponName);
				Set_Clip_Bullets(AI,ANode->WeaponName,-1);
				const AmmoDefinitionClass *PrimaryAmmo = Get_Weapon_Ammo_Definition(ANode->WeaponName,1);
				if (PrimaryAmmo)
				{	
					Range = PrimaryAmmo->Range;
				}
				//if (The_Game()->MaxPlayers + 1 >= 2)
				{
					if (Range > 295)
					{
						Range = 295.0f;
					}
				}
				sprintf(params,"1,1,1,%f",Range);
			}
		}
	}
	else
	{
		Commands->Set_Player_Type(AI,2);
		const char *MyWeapon = Get_Current_Weapon(AI);
		if (MyWeapon)
		{
			const AmmoDefinitionClass *PrimaryAmmo = Get_Weapon_Ammo_Definition(MyWeapon,1);
			if (PrimaryAmmo)
			{	
				Range = PrimaryAmmo->Range;
			}
		}
	}
	sprintf(params,"1,1,1,%f",Range);
	Commands->Attach_Script(AI,"JMG_Renhalo_Mindless_Hunt_And_Attack",params);
	sprintf(params,"1.0,34234,%s,%s",Get_Skin(AI),Get_Shield_Type(AI));
	Commands->Set_Shield_Type(AI,"Blamo");
	Set_Skin(AI,"Blamo");
	Commands->Attach_Script(AI,"JMG_Change_HP_Shields_On_Timer",params);
	Commands->Attach_Script(AI,"M00_No_Falling_Damage_DME","0");
	if (AI->As_PhysicalGameObj())
	{
		Vector3 pos = Location;
		Vector3 ExitPos = pos;
		PhysicalGameObj *objphys = ((ScriptableGameObj *)AI)->As_PhysicalGameObj();
		objphys->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Find_Teleport_Location(pos,5.0f,&ExitPos);
		Commands->Set_Position(AI,ExitPos);
	}
}

GameObject *JMG_RP2_Phone_Create_AI_Swarm_One::Soldier_Twiddler(Vector3 Pos)
{
	if (Get_Int_Parameter("Soldier_Type") == 1)
	{
		switch(Commands->Get_Random_Int(0,2))
		{
		case 0: 
			return Commands->Create_Object("US_Marine_White",Pos);
			break;
		case 1: 
			return Commands->Create_Object("US_Marine_Black",Pos);
			break;
		default:
			return Commands->Create_Object("US_Marine_Black",Pos);
			break;
		}
	}
	else
	{
		switch(Commands->Get_Random_Int(0,4))
		{
		case 0: 
			return Commands->Create_Object("DM_Ice_Zombie",Pos);
			break;
		default:
			return Commands->Create_Object("DM_Zombie",Pos);
			break;
		}
	}
}

Vector3 JMG_RP2_Phone_Create_AI_Swarm_One::Spawn_Pos_Twiddler()
{
	Vector3 pos;
	switch(Commands->Get_Random_Int(0,11))
	{
	case 0:
		pos.X = 0;
		pos.Y = 0;
		pos.Z = 7.49f;//
		break;
	case 1:
		pos.X = -838.258f;
		pos.Y = 270.78f;
		pos.Z = 8.04f;//
		break;
	case 2:
		pos.X = -941.31f;
		pos.Y = -77.18f;
		pos.Z = 24.00;//
		break;
	case 3:
		pos.X = -982.92f;
		pos.Y = -285.51f;
		pos.Z = -3.65f;//
		break;
	case 4:
		pos.X = -1358.84f;
		pos.Y = -243.42f;
		pos.Z = -3.69f;//
		break;
	case 5:
		pos.X = -1244.62f;
		pos.Y = -117.96f;
		pos.Z = -18.54f;//
		break;
	case 6:
		pos.X = -1513.57f;
		pos.Y = -118.30f;
		pos.Z = -21.52f;//
		break;
	case 7:
		pos.X = -1717.99f;
		pos.Y = 173.30f;
		pos.Z = -1.95f;//
		break;
	case 8:
		pos.X = -1335.46f;
		pos.Y = 333.04f;
		pos.Z = 7.44f;//
		break;
	case 9:
		pos.X = -1110.82f;
		pos.Y = -169.52f;
		pos.Z = -3.68f;//
		break;
	default:
		pos.X = -1730.08f;
		pos.Y = 409.08f;
		pos.Z = 10.17f;//
		break;
	}
	return pos;
}
void JMG_RP2_Tutorial_Door_Teleport::Entered(GameObject *obj,GameObject *enter)//For Doors
{
	char params[2500];
	Vector3 pos; 
	if (Commands->Is_A_Star(enter))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(enter)])
		{
			Console_Input("admin_message Note: If you are unable to spawn, please make sure that key.cfg was installed correctly, also your key settings in <Options->BHS Options> are bound correctly.");
			Console_Input("admin_message You must spawn before you can pass through this door, to spawn you must please left click.");
			Commands->Send_Custom_Event(obj,enter,21511236,1,0);
			GameObject *Blocker = Commands->Create_Object("Daves Arrow",Commands->Get_Position(enter));
			Commands->Attach_To_Object_Bone(enter,Blocker,"null");
			Commands->Attach_Script(Blocker,"SUR_Timed_Death","0.5,9999.0,blamokiller");
			return;
		}
		if ((enter->As_PhysicalGameObj() && enter->As_PhysicalGameObj()->Peek_Physical_Object() && enter->As_PhysicalGameObj()->Peek_Physical_Object()->As_HumanPhysClass()) && !Get_Vehicle(enter))
		{
			if (Get_Int_Parameter("Object_ID") > 0)
			{
				pos = Commands->Get_Position(Commands->Find_Object(Get_Int_Parameter("Object_ID")));
			}
			else
			{
				pos = Get_Vector3_Parameter("TeleportLocation");
			}
			sprintf(params,"%f,%f,%f,%f,%f,%s,%s,%s,%s,%s",pos.X,pos.Y,pos.Z,Get_Float_Parameter("Enter_Rotation"),Get_Float_Parameter("Exit_Rotation"),Get_Parameter("Enter_Animation"),Get_Parameter("Exit_Animation"),Get_Parameter("Enter_Path_Animation"),Get_Parameter("Exit_Path_Animation"),Get_Parameter("Bone_Attach_Name"));
			Attach_Script_Once(enter,"JMG_RP2_Teleport_Zone_Script_Attach",params);
		}
	}
}

void JMG_RP2_Tutorial_Message_Zone::Created(GameObject *obj)
{
	EnterID = 0;
	ExitID = 0;
}

void JMG_RP2_Tutorial_Message_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (_stricmp(Get_Parameter("Enter_Message"),"null") && Commands->Is_A_Star(enter))
	{
		int TempID = Commands->Get_ID(enter);
		if (TempID != EnterID)
		{
			EnterID = TempID;
			Commands->Send_Custom_Event(obj,obj,435345,1,Get_Float_Parameter("Delay"));
		}
	}
}

void JMG_RP2_Tutorial_Message_Zone::Exit(GameObject *obj,GameObject *exiter)
{
	if (_stricmp(Get_Parameter("Exit_Message"),"null") && Commands->Is_A_Star(exiter))
	{
		int TempID = Commands->Get_ID(exiter);
		if (TempID != ExitID)
		{
			ExitID = TempID;
			Commands->Send_Custom_Event(obj,obj,435345,2,Get_Float_Parameter("Delay"));
		}
	}
}

void JMG_RP2_Tutorial_Message_Zone::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 435345)
	{
		char *NewMessage;
		if (param == 1)
		{
			NewMessage = newstr(Get_Parameter("Enter_Message"));
		}
		else
		{
			NewMessage = newstr(Get_Parameter("Exit_Message"));
		}
		char Delim = Get_Parameter("Delim")[0];
		unsigned int x = strlen(NewMessage);
		for (unsigned int i=0;i<x;i++)
		{
			if (NewMessage[i] == Delim)
			{
				NewMessage[i] = ',';
			}
		}
		char TT[234];
		sprintf(TT,"admin_message %s",NewMessage);
		delete NewMessage;
		Console_Input(TT);
		return;
	}
}

void JMG_RP2_Zone_Debug_Script::Created(GameObject *obj)
{
	Console_Input("MESSAGE JMG_RP2_Zone_Debug_Script Is being used!");
	char Debug[238];
	OBBoxClass *ZZBox = Get_Zone_Box(obj);
	sprintf(Debug,"ID:%d CenterX:%.2f CenterY:%.2f XMaxExtent:%.2f XMinExtent:%.2f YMaxExtent:%.2f YMinExtent:%.2f",Commands->Get_ID(obj),ZZBox->Center.X,ZZBox->Center.Y,ZZBox->Center.X-ZZBox->Extent.X,ZZBox->Center.X+ZZBox->Extent.X,ZZBox->Center.Y-ZZBox->Extent.Y,ZZBox->Center.Y+ZZBox->Extent.Y);
	JeradTrace(Debug);
	sprintf(Debug,"ID:%d Point0: %.2f %.2f %.2f Point1: %.2f %.2f %.2f Point2: %.2f %.2f %.2f",Commands->Get_ID(obj),ZZBox->Basis[0][0],ZZBox->Basis[0][1],ZZBox->Basis[0][2],ZZBox->Basis[1][0],ZZBox->Basis[1][1],ZZBox->Basis[1][2],ZZBox->Basis[2][0],ZZBox->Basis[2][1],ZZBox->Basis[2][2]);
	JeradTrace(Debug);
	sprintf(Debug,"ID:%d Rotation:%.2f",Commands->Get_ID(obj),asin(ZZBox->Basis[0][1])*180.0 / PI);
	JeradTrace(Debug);
}

void JMG_RP2_Load_Player_Characters::Created(GameObject *obj)
{
	FILE *FilePlayerCharacters;
	FilePlayerCharacters = fopen("Data/RolePlay2/BetaPlayerCharacters.RP2","r");
	if (FilePlayerCharacters)
	{
		char FirstLine[200];
		sprintf(FirstLine,"");
		fread(FirstLine,200,1,FilePlayerCharacters);
		if (strlen(FirstLine) > 1)
		{
			rewind(FilePlayerCharacters);
			while (!feof(FilePlayerCharacters))
			{
				char PlayerName[256],PresetName[256];
				fread(PlayerName,256,1,FilePlayerCharacters);
				int loops = strlen(PlayerName),x = 0;
				while (x < loops)
				{
					if (PlayerName[x] == '\n')
					{
						PlayerName[x] = '\0';
					}
					x++;
				}
				x = 0;
				fread(PresetName,256,1,FilePlayerCharacters);
				loops = strlen(PresetName);
				while (x < loops)
				{
					if (PresetName[x] == '\n')
					{
						PresetName[x] = '\0';
					}
					x++;
				}
				Player_Character_Node(PlayerName,PresetName);
				fscanf(FilePlayerCharacters,"\n");
			}
		}
		fclose(FilePlayerCharacters);
	}
}

void JMG_RP2_Load_Player_Characters::Player_Character_Node(const char *PlayerName,const char *PresetName)
{
	if (!PlayerCharacterNode)
	{
		PlayerCharacterNode = new PlayerCharacterControl;
		sprintf(PlayerCharacterNode->PlayerName,"%s",PlayerName);
		sprintf(PlayerCharacterNode->PresetName,"%s",PresetName);
		PlayerCharacterNode->next = NULL;
	}
	else
	{
		PlayerCharacterControl *Current = PlayerCharacterNode;
		while (Current != NULL)
		{
			if (!_stricmp(Current->PlayerName,PlayerName))
			{
				sprintf(Current->PresetName,"%s",PresetName);
				return;
			}
			if (Current->next == NULL)
			{
				Current->next = new PlayerCharacterControl;
				Current = Current->next;
				sprintf(Current->PlayerName,"%s",PlayerName);
				sprintf(Current->PresetName,"%s",PresetName);
				Current->next = NULL;
				return;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Phone_House_Security_System_Config_Number::Created(GameObject *obj)
{
	sprintf(PhoneNumberMessage,"null");
	char TempNumber[256];
	const char *PhoneNumber = Get_Parameter("Phone_Number");
	sprintf(TempNumber,"");
	int x = 0,x2 = 0;
	int length = strlen(PhoneNumber);
	while (x2 < length)
	{
		if (x == 3)
		{
			TempNumber[x] = '-';
			x++;
		}
		TempNumber[x] = PhoneNumber[x2];
		x++;
		TempNumber[x] = '\0';
		x2++;
	}
	sprintf(PhoneNumberMessage,"%s - Home Security Setup Hotline",TempNumber);
}

void JMG_RP2_Phone_House_Security_System_Config_Number::Custom(GameObject *obj,int message,int param,GameObject *sender)
{	
	if (message == PHONESearchForMatchingNumbersCustom && param == PHONESearchForMatchingNumbersCustom)
	{
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							sprintf(Current->PhoneNumber,"%s - %s",Current->PhoneNumber,PhoneNumberMessage);
							Commands->Send_Custom_Event(obj,sender,PHONECheckForRedialNumberMatchReturn,1,0);
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == PHONERequestKnownPhoneNumberList && param == 2)
	{
		Send_Message_Player(sender,127,255,0,PhoneNumberMessage);
	}
	if (message == PHONECallStartCustom && param == 0)
	{							
		if (PhoneNumbers)
		{
			int end = 0;
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					if (Get_Int_Parameter("Number_Of_Digits") == Current->PhoneNumberLength)
					{
						if (!_stricmp(Current->PhoneNumber,Get_Parameter("Phone_Number")))
						{
							end = 1;
							if (!Phone_Number_Count_Connections(Get_Int_Parameter("Script_ID")))
							{
								GLOBALPHONELINES[PlayerID] = Get_Int_Parameter("Script_ID");
								GLOBALPHONETIMES[PlayerID] = 0;
								Commands->Send_Custom_Event(sender,obj,Get_Int_Parameter("Script_ID"),Get_Player_ID(sender),(Get_Float_Parameter("Pickup_Delay")+Commands->Get_Random(0.0f,Get_Float_Parameter("Max_Random_Pickup_Delay"))));
							}
							else
							{
								for (int x = 1;x < 128;x++)
								{
									if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
									{
										GameObject *Player = Get_GameObj(x);
										Commands->Send_Custom_Event(obj,Player,PHONECallWaiting,0,0);// Use to send the other player the call waiting message when the script used to only allow for 1 player at a time
									}
								}
								Commands->Send_Custom_Event(obj,sender,PHONELineBusy,0,0);// Busy Message
							}
						}
					}
				}
				Current = Current->next;
			}
		}
	}
	if (message == Get_Int_Parameter("Script_ID"))
	{
		int PlayerID = Get_Player_ID(sender);
		if (GLOBALPHONELINES[PlayerID] != Get_Int_Parameter("Script_ID"))
		{
			return;
		}
		Send_Message_Player(sender,127,255,0,"Welcome to the automated housing security setup service, please enter your home's address and then press pound.");
		Commands->Send_Custom_Event(obj,sender,PHONENumberRequiresAdditionalNumberAndPound,Get_Int_Parameter("Script_ID"),0);// make it await pound
	}
	if (message == PHONECallStartCustom && param == Get_Int_Parameter("Script_ID"))
	{
		int end = 0;
		if (PhoneNumbers)
		{
			int PlayerID = Get_Player_ID(sender);
			PhoneNumberControl *Current = PhoneNumbers;
			while (Current != NULL && !end)
			{
				if (PlayerID == Current->PlayerID)// match
				{
					HouseAddress = atoi(Current->PhonePound);
					end = 1;
				}
				Current = Current->next;
			}
		}	
		if (RP2NewHouseSystemNode)
		{
			int HouseExists = 0;
			char PlayerName[256];
			const char *str = Get_Player_Name(sender);
			sprintf(PlayerName,"%s",str);
			delete[] str;
			// Count houses you own
			RP2NewHouseSystemControl *Current = RP2NewHouseSystemNode;
			while (Current != NULL)
			{
				if (!_stricmp(PlayerName,Current->PlayerName))
				{
					if (Current->HouseAddress == HouseAddress)
					{
						HouseExists = 1;
					}
				}
				Current = Current->next;
			}
			if (!HouseExists)
			{
				char confmes[237];
				sprintf(confmes,"Sorry, the house at %d is not under your name in our records.",HouseAddress);
				Send_Message_Player(sender,127,255,0,confmes);
				AutoCancelCall(obj,sender);
			}
			else
			{
				end = 0;
				HouseSecurity = Find_Security_Node(HouseAddress);
				if (HouseSecurity)
				{
					time_t secs=time(0);
					tm *t=localtime(&secs);
					int timeday = t->tm_yday;
					if (!HouseSecurity->NumberOfPrePays)
					{
						HouseSecurity->NumberOfPrePays = 1;
					}
					char confmes[237];
					int HouseDays = ((HouseSecurity->RentDay + 7 * HouseSecurity->NumberOfPrePays) - timeday);
					if (HouseDays){sprintf(confmes,"We have found your house on record, and have loaded your security settings, your plan has %d days remaining, please select an option from the list below:",HouseDays);Send_Message_Player(sender,127,255,0,confmes);}
					if (!HouseDays){Send_Message_Player(sender,127,255,0,"We have found your house on record, but it currently does not have a security plan, one will be created if you choose any setup option.");}
					sprintf(confmes,"1. Detect Intruders: %s",ReturnEnabled(HouseSecurity->DetectIntruders));Send_Message_Player(sender,127,255,0,confmes);
					sprintf(confmes,"2. Detect Property Damage: %s",ReturnEnabled(HouseSecurity->DetectVandals));Send_Message_Player(sender,127,255,0,confmes);
					sprintf(confmes,"3. Ceiling Guns: %s",ReturnEnabled(HouseSecurity->CeilingGuns));Send_Message_Player(sender,127,255,0,confmes);
					sprintf(confmes,"4. Missile Defense System: %s",ReturnEnabled(HouseSecurity->MissileDefenseSystem));Send_Message_Player(sender,127,255,0,confmes);
					sprintf(confmes,"5. Auto Repair Insurance: %s",ReturnEnabled(HouseSecurity->AutoRepair));Send_Message_Player(sender,127,255,0,confmes);
					sprintf(confmes,"6. Extend current plan.");Send_Message_Player(sender,127,255,0,confmes);
					sprintf(confmes,"7. Cancel current plan.");Send_Message_Player(sender,127,255,0,confmes);
					Commands->Send_Custom_Event(obj,sender,PHONENumberRequestSingleDigitPress,Get_Int_Parameter("Script_ID"),0);// make it ask for a number
				}
				else
				{
					char confmes[2000];
					sprintf(confmes,"Sorry, there seems to be an error with our server, you'll have to try again later.");
					Send_Message_Player(sender,127,255,0,confmes);
					AutoCancelCall(obj,sender);
				}
			}
		}
	}
	if (message >= 1 && message <= 7 && param == Get_Int_Parameter("Script_ID"))
	{
		char confmes[237];
		switch (message)
		{
		case 1:
			TogglePlanSettings(obj,sender,HouseSecurity->DetectIntruders,25000.0f,message);
			break;
		case 2:
			TogglePlanSettings(obj,sender,HouseSecurity->DetectVandals,25000.0f,message);
			break;
		case 3:
			TogglePlanSettings(obj,sender,HouseSecurity->CeilingGuns,25000.0f,message);
			break;
		case 4:
			TogglePlanSettings(obj,sender,HouseSecurity->MissileDefenseSystem,25000.0f,message);
			break;
		case 5:
			TogglePlanSettings(obj,sender,HouseSecurity->AutoRepair,100000.0f,message);
			break;
		case 6:
			SelectedOption = 6;
			Cost = (float)HouseSecurity->RentPrice;
			sprintf(confmes,"Are you sure you'd like to extend your current plan by 7 days? Doing so will cost $%.2f. ([1] yes [2]no)",Cost);
			Send_Message_Player(sender,127,255,0,confmes);
			Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
			break;
		case 7:
			SelectedOption = 7;
			Cost = SecurityPrice((float)HouseSecurity->RentPrice);
			Cost = -Cost;
			sprintf(confmes,"Cancel current plan for a refund of $%.2f. ([1] yes [2]no)",Cost);
			Send_Message_Player(sender,127,255,0,confmes);
			Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
			break;
		default:
			Console_Input("MESSAGE INVALID CHOICE IN SECURITY OPTION MENU! CODE ID:2000");
			AutoCancelCall(obj,sender);
			break;
		}
	}
	if (message == PHONESpecial1Key && param == Get_Int_Parameter("Script_ID"))
	{
		if (Cost > 0)
		{
			if (Commands->Get_Money(sender) >= Cost)
			{
				Commands->Give_Money(sender,-Cost,1);
				if (SelectedOption == 6)
				{
					Send_Message_Player(sender,127,255,0,"Thank you, your plan's lifetime has been successfully extended!");
				}
				else
				{
					Send_Message_Player(sender,127,255,0,"Thank you, your purchase was successful; the components of your updated service package will be installed shortly!");
				}
				Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
				switch (SelectedOption)
				{
				case 1:
					HouseSecurity->DetectIntruders = true;
					break;
				case 2:
					HouseSecurity->DetectVandals = true;
					break;
				case 3:
					HouseSecurity->CeilingGuns = true;
					EnableObjectSpawn(HSOCeilingGun);
					break;
				case 4:
					HouseSecurity->MissileDefenseSystem = true;
					EnableObjectSpawn(HSOAntiMissileSystem);
					break;
				case 5:
					HouseSecurity->AutoRepair = true;
					break;
				case 6:
					HouseSecurity->NumberOfPrePays++;
					break;
				default:
					Console_Input("MESSAGE INVALID CHOICE IN SECURITY OPTION MENU! CODE ID:1000");
					break;
				}
				time_t secs=time(0);
				tm *t=localtime(&secs);
				int timeday = t->tm_yday;
				int timeyear = t->tm_year;
				if (!((HouseSecurity->RentDay + 7 * HouseSecurity->NumberOfPrePays) - timeday))
				{
					HouseSecurity->RentYear = timeyear;
					HouseSecurity->RentDay = timeday;
					HouseSecurity->NumberOfPrePays = 1;
				}
			}
			else
			{
				Send_Message_Player(sender,127,255,0,"It seems the funds on your card are inadequate. Sorry, but have a nice day.");
				Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
			}
		}
		else
		{
			Commands->Give_Money(sender,-Cost,1);
			if (SelectedOption == 7)
			{
				Send_Message_Player(sender,127,255,0,"Thank you, your plan has been cancledand money has been refunded!");
			}
			else
			{
				Send_Message_Player(sender,127,255,0,"Thank you, your security package has been altered, and the leftover money has been sent to your checking account.");
			}
			switch (SelectedOption)
			{
			case 1:
				HouseSecurity->DetectIntruders = false;
				break;
			case 2:
				HouseSecurity->DetectVandals = false;
				break;
			case 3:
				HouseSecurity->CeilingGuns = false;
				DisableObjectSpawn(HSOCeilingGun);
				break;
			case 4:
				HouseSecurity->MissileDefenseSystem = false;
				DisableObjectSpawn(HSOAntiMissileSystem);
				break;
			case 5:
				HouseSecurity->AutoRepair = false;
				break;
			case 7:
				HouseSecurity->NumberOfPrePays = 0;
				HouseSecurity->RentPrice = 0;
				HouseSecurity->DetectIntruders = false;
				HouseSecurity->DetectVandals = false;
				HouseSecurity->CeilingGuns = false;
				HouseSecurity->MissileDefenseSystem = false;
				HouseSecurity->AutoRepair = false;
				break;
			default:
				Console_Input("MESSAGE INVALID CHOICE IN SECURITY OPTION MENU! CODE ID:9999");
				break;
			}
			Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
		}
	}
	if (message == PHONESpecial2Key && param == Get_Int_Parameter("Script_ID"))
	{
		Commands->Send_Custom_Event(sender,obj,PHONENumberEndCallMessage,0,0);// Hang up
		Commands->Send_Custom_Event(obj,sender,PHONEOtherEndHangUp,0,0);
	}
	if (message == PHONENumberEndCallMessage && param == Get_Int_Parameter("Script_ID"))
	{
		int PlayerID = Get_Player_ID(sender);
		if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
		{
			GLOBALPHONELINES[PlayerID] = 0;
			GLOBALPHONETIMES[PlayerID] = 0;
		}
	}
	if (message == PHONENumberCallTimeMonitor && param == Get_Int_Parameter("Script_ID"))
	{
		ChargeForCall(obj);
	}
}

void JMG_RP2_Phone_House_Security_System_Config_Number::AutoCancelCall(GameObject *obj,GameObject *player)
{
	int PlayerID = Get_Player_ID(player);
	if (GLOBALPHONELINES[PlayerID] == Get_Int_Parameter("Script_ID"))
	{
		GLOBALPHONELINES[PlayerID] = 0;
		GLOBALPHONETIMES[PlayerID] = 0;
		Commands->Send_Custom_Event(obj,player,PHONEOtherEndHangUp,0,0);
	}
}

void JMG_RP2_Phone_House_Security_System_Config_Number::ChargeForCall(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		if (GLOBALPHONELINES[x] == Get_Int_Parameter("Script_ID"))
		{
			GameObject *Player = Get_GameObj(x);
			int CallTime = GLOBALPHONETIMES[x]++;
			if (Commands->Get_Health(Player) > 0)
			{
				int chargepersec = Get_Int_Parameter("Charge_Per_Second");
				if (Get_Int_Parameter("Max_Call_Duration") < CallTime)
				{
					AutoCancelCall(obj,Player);
				}
				else if (CallTime % 60 == 0)
				{
					int totalcharge = (chargepersec + Get_Int_Parameter("Charge_Per_Minute"));
					if (Commands->Get_Money(Player) >= totalcharge)
					{
						Commands->Give_Money(Player,-(float)totalcharge,1);
					}
					else
					{
						Send_Message_Player(Player,127,255,0,"Signal Lost");
						AutoCancelCall(obj,Player);
					}
				}
				else if (Commands->Get_Money(Player) >= chargepersec)
				{
					Commands->Give_Money(Player,-(float)chargepersec,1);
				}
				else
				{
					Send_Message_Player(Player,127,255,0,"Signal Lost");
					AutoCancelCall(obj,Player);
				}
			}
			else
			{
				Commands->Send_Custom_Event(Player,obj,PHONENumberEndCallMessage,Get_Int_Parameter("Script_ID"),0);
			}
			Commands->Send_Custom_Event(Player,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);
		}
	}
}

char *JMG_RP2_Phone_House_Security_System_Config_Number::ReturnEnabled(bool value)
{
	static char *Message;
	if (value)
	{
		Message = "Enabled";
	}
	else
	{
		Message = "Disabled";
	}
	return Message;
}

float JMG_RP2_Phone_House_Security_System_Config_Number::SecurityPrice(float Price)
{
	time_t secs=time(0);
	tm *t=localtime(&secs);
	int timeyear = t->tm_year;
	int timeday = t->tm_yday;
	if (timeyear == HouseSecurity->RentYear)
	{
		return ((float)(((HouseSecurity->RentDay + 7 * HouseSecurity->NumberOfPrePays) - timeday)-1) * (Price/7));
	}
	return 2500.0f;
}

void JMG_RP2_Phone_House_Security_System_Config_Number::TogglePlanSettings(GameObject *obj,GameObject *sender,bool Owned,float Price,int Choice)
{
	SelectedOption = Choice;
	if (Owned)
	{
		HouseSecurity->RentPrice -= (int)Price;
		Cost = SecurityPrice(Price*(HouseSecurity->NumberOfPrePays));
		char confmes[237];
		sprintf(confmes,"You currently have this under your current plan, removing it will return $%.2f to your checking account, would you like to remove it? ([1] yes [2] no)",Cost);
		Cost = -Cost;
		Send_Message_Player(sender,127,255,0,confmes);
	}
	else
	{
		HouseSecurity->RentPrice += (int)Price;
		Cost = Price*(HouseSecurity->NumberOfPrePays);
		char confmes[237];
		sprintf(confmes,"You do not have this under your current plan; adding it to your current plan would cost $%.2f and will last either 7 days or until you no longer own the house, would you like to add it? ([1] yes [2]no)",Cost);
		Send_Message_Player(sender,127,255,0,confmes);
	}
	Commands->Send_Custom_Event(obj,sender,PHONENumberRequires1Or2Entry,Get_Int_Parameter("Script_ID"),0);// make it inquire with 1/2
	//Commands->Send_Custom_Event(sender,obj,PHONENumberCallTimeMonitor,Get_Int_Parameter("Script_ID"),1.0f);// Start Timer
}

void JMG_RP2_Phone_House_Security_System_Config_Number::EnableObjectSpawn(int SecurityObjectType)
{
	if (HomeSecurityObjectNode)
	{
		HomeSecurityObjectControl *Current = HomeSecurityObjectNode;
		while (Current != NULL)
		{
			if (Current->HouseAddress == HouseAddress && Current->DefenseType == SecurityObjectType)
			{
				Current->RespawnTime = 60;
			}
			Current = Current->next;
		}
	}
}

void JMG_RP2_Phone_House_Security_System_Config_Number::DisableObjectSpawn(int SecurityObjectType)
{
	if (HomeSecurityObjectNode)
	{
		HomeSecurityObjectControl *Current = HomeSecurityObjectNode;
		while (Current != NULL)
		{
			if (Current->HouseAddress == HouseAddress && Current->DefenseType == SecurityObjectType)
			{
				Current->RespawnTime = 0;
				GameObject *DefenseObject = Commands->Find_Object(Current->ObjectID);
				if (DefenseObject)
				{
					Commands->Destroy_Object(DefenseObject);
				}
			}
			Current = Current->next;
		}
	}
}

HomeSecuritySystemControl *JMG_RP2_Phone_House_Security_System_Config_Number::Find_Security_Node(int Address)
{
	if (!HomeSecuritySystemNode)
	{
		return (HomeSecuritySystemNode = CreateSecurityNode(HomeSecuritySystemNode,Address));
	}
	else
	{
		HomeSecuritySystemControl *Current = HomeSecuritySystemNode;
		while (Current != NULL)
		{
			if (Current->HouseAddress == Address)
			{
				return Current;
			}
			else if (Current->next == NULL)
			{
				return (Current->next = CreateSecurityNode(Current->next,Address));
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Load_House_Security_Setup::Created(GameObject *obj)
{
	int CanWriteOutput = 1;
	FILE *HomeSecuritySettings;
	HomeSecuritySettings = fopen("Data/RolePlay2/BetaHomeSecuritySettings.RP2","r");
	time_t secs=time(0);
	tm *t=localtime(&secs);
	int timeyear = t->tm_year;
	int timeday = t->tm_yday;
	if (!HomeSecuritySettings)
	{
		return;
	}
	char FirstLine[2000];
	sprintf(FirstLine,"");
	fread(FirstLine,2000,1,HomeSecuritySettings);
	if (strlen(FirstLine) < 1)
	{
		CanWriteOutput = 0;
	}
	rewind (HomeSecuritySettings);
	while (!feof(HomeSecuritySettings))
	{
		char EncryptedString[256],DecryptedString[256];
		int RentPrice,HouseAddress,DetectIntruders,DetectVandals,CeilingGuns,MissileDefenseSystem,AutoRepair,NumberOfPrePays,RentDay,RentYear;
		fscanf(HomeSecuritySettings,"%d\n",&HouseAddress);
		fread(EncryptedString,256,1,HomeSecuritySettings);
		fscanf(HomeSecuritySettings,"\n");
		if (HouseOwnedCheck(HouseAddress))
		{
			sprintf(DecryptedString,"%s",Decrypt(EncryptedString,HouseAddress,3));
			sscanf(DecryptedString,"%d %d %d %d %d %d %d %d %d",&RentPrice,&DetectIntruders,&DetectVandals,&CeilingGuns,&MissileDefenseSystem,&AutoRepair,&NumberOfPrePays,&RentDay,&RentYear);
			HomeSecuritySystemControl *HSNode = NULL;
			if (timeyear == RentYear && timeday < RentDay + 7)
			{
				HSNode = Find_Security_Node(HouseAddress);
				if (HSNode)
				{
					HSNode->RentYear = RentYear;
					HSNode->RentDay = RentDay;
				}
			}
			else
			{
				if (NumberOfPrePays > 1)
				{
					NumberOfPrePays--;
					HSNode = Find_Security_Node(HouseAddress);
					if (HSNode)
					{
						HSNode->RentYear = t->tm_year;
						HSNode->RentDay = t->tm_yday;
					}
				}
			}
			if (HSNode)
			{
				HSNode->NumberOfPrePays = NumberOfPrePays;
				HSNode->RentPrice = RentPrice;
				HSNode->DetectIntruders = DetectIntruders;
				HSNode->DetectVandals = DetectVandals;
				HSNode->CeilingGuns = CeilingGuns;
				HSNode->MissileDefenseSystem = MissileDefenseSystem;
				HSNode->AutoRepair = AutoRepair;
			}
		}
	}
	fclose(HomeSecuritySettings);
}

HomeSecuritySystemControl *JMG_RP2_Load_House_Security_Setup::Find_Security_Node(int Address)
{
	if (!HomeSecuritySystemNode)
	{
		return (HomeSecuritySystemNode = CreateSecurityNode(HomeSecuritySystemNode,Address));
	}
	else
	{
		HomeSecuritySystemControl *Current = HomeSecuritySystemNode;
		while (Current != NULL)
		{
			if (Current->HouseAddress == Address)
			{
				return Current;
			}
			else if (Current->next == NULL)
			{
				return (Current->next = CreateSecurityNode(Current->next,Address));
			}
			Current = Current->next;
		}
	}
	return NULL;
}

char *JMG_RP2_Load_House_Security_Setup::Decrypt(const char *String,int EncryptionFactor,int Start)
{
	static char FinalString[2000];
	int loops = strlen(String),x = 0;
	int CurrentAdd = Start;
	while (x < loops)
	{
		if (String[x] != '\0' && String[x] != '\n')
		{
			char Temp = (String[x]-(char)CurrentAdd);
			while (Temp < 32)
			{
				Temp += 125;
			}
			FinalString[x] = Temp;
			CurrentAdd++;
			if (CurrentAdd > EncryptionFactor)
			{
				CurrentAdd = 1;
			}
		}
		else
		{
			FinalString[x] = '\0';
		}
		x++;
		FinalString[x] = '\0';
	}
	return FinalString;
}

int JMG_RP2_Load_House_Security_Setup::HouseOwnedCheck(int Address)
{
	RP2NewHouseSystemControl *AHouseNode = Find_Housing_Node(Address);
	if (AHouseNode)
	{
		if (AHouseNode->IsOwned)
		{
			return 1;
		}
	}
	return 0;
}

void JMG_RP2_House_Security_Object::Created(GameObject *obj)
{
	Commands->Send_Custom_Event(obj,obj,1235426,0,1.0);
}

void JMG_RP2_House_Security_Object::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 1235426)
	{
		HomeSecuritySystemControl *ANode1 = Find_Housing_Security_Node(Get_Int_Parameter("House_Address"));
		if (ANode1 || param > 3)
		{
			Update_Security_Object(obj,ANode1);
		}
		else
		{
			Commands->Send_Custom_Event(obj,obj,1235426,param+1,1.0);
		}
	}
}

HomeSecurityObjectControl *JMG_RP2_House_Security_Object::Create_Security_Object_Node(int Address)
{
	if (!HomeSecurityObjectNode)
	{
		HomeSecurityObjectNode = new HomeSecurityObjectControl;
		HomeSecurityObjectNode->HouseAddress = Address;
		HomeSecurityObjectNode->next = NULL;
		return HomeSecurityObjectNode;
	}
	else
	{
		HomeSecurityObjectControl *Current = HomeSecurityObjectNode;
		while (Current != NULL)
		{
			if (Current->next == NULL)
			{
				Current->next = new HomeSecurityObjectControl;
				Current = Current->next;
				Current->HouseAddress = Address;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}


void JMG_RP2_House_Security_Object::Update_Security_Object(GameObject *obj,HomeSecuritySystemControl *ANode1)
{
	HomeSecurityObjectControl *ANode = Create_Security_Object_Node(Get_Int_Parameter("House_Address"));
	if (ANode)
	{
		sprintf(ANode->PresetName,"%s",Commands->Get_Preset_Name(obj));
		ANode->ObjectID = Commands->Get_ID(obj);
		ANode->Position = Commands->Get_Position(obj);
		ANode->Rotation = Commands->Get_Facing(obj);
		ANode->MaxHP = Commands->Get_Max_Health(obj)+Commands->Get_Max_Shield_Strength(obj);
		ANode->HealRate = 100.0f/ANode->MaxHP;
		ANode->RespawnTime = 0;
		Vector3 SecurityType = Get_Vector3_Parameter("ObjectType[Door|CeilingGun|AntiMissileSystem]");
		ANode->DefenseType = (int)(SecurityType.X*HSODoor+SecurityType.Y*HSOCeilingGun+SecurityType.Z*HSOAntiMissileSystem);
		ANode->AllowRepair = 1;
		if (ANode1)
		{
			if ((ANode1->CeilingGuns && ANode->DefenseType == HSOCeilingGun) || (ANode1->MissileDefenseSystem && ANode->DefenseType == HSOAntiMissileSystem) || (ANode->DefenseType == HSODoor) || Get_Int_Parameter("Spawn_On_Start"))
			{
				Attach_Script_Once(obj,"JMG_RP2_House_Security_Object_Repair_Control","");
			}
			else
			{
				Commands->Destroy_Object(obj);
			}
		}
		else if (!Get_Int_Parameter("Spawn_On_Start"))
		{
			Commands->Destroy_Object(obj);
		}
		else
		{
			Attach_Script_Once(obj,"JMG_RP2_House_Security_Object_Repair_Control","");
		}
	}
}

void JMG_RP2_House_Security_System_Object_Control::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,5.0,654654654);
}

void JMG_RP2_House_Security_System_Object_Control::Timer_Expired(GameObject *obj,int number)
{
	if (number == 654654654)
	{
		if (HomeSecuritySystemNode && HomeSecurityObjectNode)
		{
			HomeSecuritySystemControl *CurrentSN = HomeSecuritySystemNode;
			while (CurrentSN)
			{
				CheckAndRepairSecuritySystems(CurrentSN);
				CheckHomeAlarms(CurrentSN);
				CurrentSN = CurrentSN->next;
			}
		}
		Commands->Start_Timer(obj,this,1.0,654654654);
	}
}

void JMG_RP2_House_Security_System_Object_Control::NodeCheckup(HomeSecurityObjectControl *TheNode)
{
	GameObject *SecurityObject = Commands->Find_Object(TheNode->ObjectID);
	if (!SecurityObject)// Object No longer Exists
	{
		if (TheNode->RespawnTime)
		{
			TheNode->RespawnTime--;
			if (TheNode->RespawnTime == 1)
			{
				RecreateObject(TheNode);
				TheNode->RespawnTime = 0;
			}
		}
		else//Start respawn timer if object no longer exists
		{
			TheNode->RespawnTime = 60;
		}
	}
	else if (TheNode->AllowRepair)
	{
		float CurrentHealth = Commands->Get_Health(SecurityObject);
		float CurrentShield = Commands->Get_Shield_Strength(SecurityObject);
		float MaxHealth = Commands->Get_Max_Health(SecurityObject);
		float MaxShield = Commands->Get_Max_Shield_Strength(SecurityObject);
		if (CurrentHealth < MaxHealth)
		{
			Commands->Set_Health(SecurityObject,CurrentHealth+(TheNode->HealRate*10));
			if (CurrentHealth > MaxHealth)
			{
				Commands->Set_Health(SecurityObject,MaxHealth);
			}
		}
		else if (CurrentShield < MaxShield)
		{
			Commands->Set_Health(SecurityObject,CurrentShield+(TheNode->HealRate*10));
			if (CurrentShield > MaxShield)
			{
				Commands->Set_Health(SecurityObject,MaxShield);
			}
		}
	}
}

void JMG_RP2_House_Security_System_Object_Control::RecreateObject(HomeSecurityObjectControl *TheNode)
{
	GameObject *ReplaceObject = Commands->Create_Object(TheNode->PresetName,TheNode->Position);
	Commands->Set_Facing(ReplaceObject,TheNode->Rotation);
	TheNode->ObjectID = Commands->Get_ID(ReplaceObject);
	Attach_Script_Once(ReplaceObject,"JMG_RP2_House_Security_Object_Repair_Control","");
}

void JMG_RP2_House_Security_System_Object_Control::CheckHomeAlarms(HomeSecuritySystemControl *CurrentSN)
{
	if (CurrentSN->DetectIntruders && HomeSecurityZoneNode)
	{
		bool CheckSoundAlarm = false;
		int x = 0;
JMGRP2HSSOCLoopBegin:
		while (x < 127)// Loop through all the players
		{
			x++;
			if (CurrentSN->Intruding[x])// Check if player is marked as an intruder
			{
				GameObject *Intruder = Get_GameObj(x);
				if (!Intruder)
				{
					CurrentSN->Intruding[x] = 0;
					goto JMGRP2HSSOCLoopBegin;
				}
				if ((Commands->Has_Key(Intruder,CurrentSN->HouseAddress) && !Commands->Has_Key(Intruder,-CurrentSN->HouseAddress)) || ISSELECTINGSPAWN[x])
				{
					goto JMGRP2HSSOCLoopBegin;
				}
				HomeSecurityZoneControl *CurrentZone = HomeSecurityZoneNode;
				while (CurrentZone && !CheckSoundAlarm)// Check if inside zones
				{
					if (CurrentZone->HouseAddress == CurrentSN->HouseAddress)
					{
						if (IsInsideZone(Commands->Find_Object(CurrentZone->ZoneID),Intruder))
						{
							CheckSoundAlarm = true;
						}
					}
					CurrentZone = CurrentZone->next;
				}
			}
		}
		if (CheckSoundAlarm != CurrentSN->SoundAlarm)
		{
			RP2NewHouseSystemControl *My_House_Node = Find_Housing_Node(CurrentSN->HouseAddress);
			if (CheckSoundAlarm)
			{
				if (My_House_Node)
				{
					GameObject *HouseOwner = Get_GameObj_By_Player_Name(My_House_Node->PlayerName);
					if (HouseOwner)
					{
						char DamageText[2000];
						sprintf(DamageText,"Intruders have been detected in your home %d!",CurrentSN->HouseAddress);
						Send_Message_Player(HouseOwner,250,255,25,DamageText);
					}
				}
				for (int y = 0;y < 5;y++)
				{
					GameObject *Alarm = Commands->Find_Object(CurrentSN->HouseSecurityAlarmIDs[y]);
					if (Alarm)
					{
						Commands->Set_Model(Alarm,"s_HouseSA");
					}
				}
			}
			else if (!CheckSoundAlarm)
			{
				if (My_House_Node)
				{
					GameObject *HouseOwner = Get_GameObj_By_Player_Name(My_House_Node->PlayerName);
					if (HouseOwner)
					{
						char DamageText[2000];
						sprintf(DamageText,"House %d's security systems no longer detect any intruders.",CurrentSN->HouseAddress);
						Send_Message_Player(HouseOwner,250,255,25,DamageText);
					}
				}
				for (int y = 0;y < 5;y++)
				{
					GameObject *Alarm = Commands->Find_Object(CurrentSN->HouseSecurityAlarmIDs[y]);
					if (Alarm)
					{
						Commands->Set_Model(Alarm,"null");
					}
				}
			}
			CurrentSN->SoundAlarm = CheckSoundAlarm;
		}
	}
}

void JMG_RP2_House_Security_System_Object_Control::CheckAndRepairSecuritySystems(HomeSecuritySystemControl *CurrentSN)
{
	HomeSecurityObjectControl *CurrentSO = HomeSecurityObjectNode;
	while (CurrentSO)
	{
		if (CurrentSO->HouseAddress == CurrentSN->HouseAddress)
		{
			if ((CurrentSN->CeilingGuns && HSOCeilingGun == CurrentSO->DefenseType) || (CurrentSN->MissileDefenseSystem && HSOAntiMissileSystem == CurrentSO->DefenseType) || (HSODoor == CurrentSO->DefenseType))
			{
				if (CurrentSN->AutoRepair || CurrentSO->RespawnTime)//Check if current object can be replaced/repaired
				{
					NodeCheckup(CurrentSO);
				}
			}
		}
		CurrentSO = CurrentSO->next;
	}
}

void JMG_RP2_House_Security_Object_Repair_Control::Created(GameObject *obj)
{
	MyHouseNode = NULL;
	MyHouseSecurityNode = NULL;
	MyNode = Find_Object_Security_Node(Commands->Get_ID(obj));
	if (MyNode)
	{
		RepairDelay = 0;
		Commands->Start_Timer(obj,this,1.0,3543452);
	}
	else
	{
		Console_Input("MESSAGE ERROR::JMG_RP2_House_Security_Object_Repair_Control: ID could not be found in node list!");
	}
	Commands->Start_Timer(obj,this,1.0,3543454);
}

void JMG_RP2_House_Security_Object_Repair_Control::Timer_Expired(GameObject *obj,int number)
{
	if (number == 3543454)
	{
		if (!MyNode)
		{
			MyNode = Find_Object_Security_Node(Commands->Get_ID(obj));
		}
		if (!MyHouseNode)
		{
			MyHouseNode = Find_Housing_Node(MyNode->HouseAddress);
		}
		if (!MyHouseSecurityNode)
		{
			MyHouseSecurityNode = Find_Housing_Security_Node(MyNode->HouseAddress);
		}
		if (!MyHouseNode || !MyHouseSecurityNode || !MyNode)
		{
			Commands->Start_Timer(obj,this,1.0,3543454);
		}
	}
	if (number == 3543452)
	{
		if (RepairDelay)
		{
			RepairDelay--;
			if (!RepairDelay)
			{
				MyNode->AllowRepair = 1;
			}
		}
		Commands->Start_Timer(obj,this,1.0,3543452);
	}
}

void JMG_RP2_House_Security_Object_Repair_Control::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (!damage || !MyHouseNode || !MyNode || !MyHouseSecurityNode)
	{
		return;
	}
	if (!Commands->Get_Health(obj))
	{
		if (MyHouseSecurityNode->DetectVandals)
		{
			GameObject *HouseOwner = Get_GameObj_By_Player_Name(MyHouseNode->PlayerName);
			if (HouseOwner)
			{
				char DamagedObject[128];
				switch (MyNode->DefenseType)
				{
					case HSODoor:				sprintf(DamagedObject,"A door");break;
					case HSOCeilingGun:			sprintf(DamagedObject,"One of the ceiling guns");break;
					case HSOAntiMissileSystem:	sprintf(DamagedObject,"The anti missile system");break;
					default:					sprintf(DamagedObject,"A object");break;
				}
				char DamageText[2000];
				sprintf(DamageText,"%s at your house (address %d) was destroyed!",DamagedObject,MyNode->HouseAddress);
				Send_Message_Player(HouseOwner,250,255,25,DamageText);
			}
		}
	}
	else
	{
		if (MyNode->AllowRepair && MyHouseSecurityNode->DetectVandals)
		{
			GameObject *HouseOwner = Get_GameObj_By_Player_Name(MyHouseNode->PlayerName);
			if (HouseOwner)
			{
				char DamagedObject[128];
				switch (MyNode->DefenseType)
				{
					case HSODoor:				sprintf(DamagedObject,"A door");break;
					case HSOCeilingGun:			sprintf(DamagedObject,"One of the ceiling guns");break;
					case HSOAntiMissileSystem:	sprintf(DamagedObject,"The anti missile system");break;
					default:					sprintf(DamagedObject,"A object");break;
				}
				char DamageText[2000];
				sprintf(DamageText,"%s at your house (address %d) is taking damage!",DamagedObject,MyNode->HouseAddress);
				Send_Message_Player(HouseOwner,250,255,25,DamageText);
			}
		}
		MyNode->AllowRepair = 0;
		RepairDelay = 10;
	}
}

HomeSecurityObjectControl *JMG_RP2_House_Security_Object_Repair_Control::Find_Object_Security_Node(int ID)
{
	if (HomeSecurityObjectNode)
	{
		HomeSecurityObjectControl *Current = HomeSecurityObjectNode;
		while (Current != NULL)
		{
			if (Current->ObjectID == ID)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_House_Zone::Created(GameObject *obj)
{
	CreateSecurityZoneNode(obj);
	MyHouseSecurityNode = Find_Housing_Security_Node(Get_Int_Parameter("HouseAddress"));
}

void JMG_RP2_House_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (!MyHouseSecurityNode)
	{
		MyHouseSecurityNode = Find_Housing_Security_Node(Get_Int_Parameter("HouseAddress"));
	}
	if (Commands->Is_A_Star(enter) && MyHouseSecurityNode)
	{
		int PlayerID = Get_Player_ID(enter);
		MyHouseSecurityNode->Intruding[PlayerID]++;
		if (MyHouseSecurityNode->Intruding[PlayerID])
		{
			IsInsideHouse[PlayerID] = Get_Int_Parameter("HouseAddress");
		}
	}
}

void JMG_RP2_House_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (Commands->Is_A_Star(exit) && MyHouseSecurityNode)
	{
		int PlayerID = Get_Player_ID(exit);
		MyHouseSecurityNode->Intruding[PlayerID]--;
		if (!MyHouseSecurityNode->Intruding[PlayerID])
		{
			IsInsideHouse[PlayerID] = 0;
		}
	}
}

void JMG_RP2_House_Zone::CreateSecurityZoneNode(GameObject *obj)
{
	int MyID = Commands->Get_ID(obj);
	if (!HomeSecurityZoneNode)
	{
		HomeSecurityZoneNode = new HomeSecurityZoneControl;
		HomeSecurityZoneNode->HouseAddress = Get_Int_Parameter("HouseAddress");
		HomeSecurityZoneNode->ZoneID = MyID;
		HomeSecurityZoneNode->next = NULL;
		return;
	}
	else
	{
		HomeSecurityZoneControl *Current = HomeSecurityZoneNode;
		while (Current != NULL)
		{
			if (Current->ZoneID == MyID)
			{
				return;
			}
			else if (Current->next == NULL)
			{
				Current->next = new HomeSecurityZoneControl;
				Current = Current->next;
				Current->HouseAddress = Get_Int_Parameter("HouseAddress");
				Current->ZoneID = MyID;
				Current->next = NULL;
				return;
			}
			Current = Current->next;
		}
	}
	return;
}

void JMG_RP2_House_Security_Alarm_Object::Created(GameObject *obj)
{
	Commands->Set_Model(obj,"null");
	Commands->Start_Timer(obj,this,1.0,654654654);
}

void JMG_RP2_House_Security_Alarm_Object::Timer_Expired(GameObject *obj,int number)
{
	if (number == 654654654)
	{
		HomeSecuritySystemControl *ANode = Find_Housing_Security_Node(Get_Int_Parameter("HouseAddress"));
		if (ANode)
		{
			for (int x = 0;x < 5;x++)
			{
				if (!ANode->HouseSecurityAlarmIDs[x])
				{
					ANode->HouseSecurityAlarmIDs[x] = Commands->Get_ID(obj);
					return;
				}
			}
		}
		else
		{
			Commands->Start_Timer(obj,this,1.0,654654654);
		}
	}
}

void JMG_RP2_House_Repair_PT::Created(GameObject *obj)
{
	MyHouseSecurityNode = NULL;
	DoublePressTime = 0;
	Commands->Start_Timer(obj,this,0.1f,654654654);
	Commands->Start_Timer(obj,this,1.0,654654655);
}

void JMG_RP2_House_Repair_PT::Poked(GameObject *obj,GameObject *poker)
{
	if (!Commands->Is_A_Star(poker) || !MyHouseSecurityNode)
	{
		return;
	}
	if (ISSELECTINGSPAWN[Get_Player_ID(poker)])
	{
		Send_Message_Player(poker,250,255,25,"You must spawn before you can use this!");
		return;
	}
	char RepairMessage[220];
	float CollateralDamage,RepairPrice;
	int DamagedObjects,DestroyedObjects;
	PriceCalculation(&CollateralDamage,&RepairPrice,&DamagedObjects,&DestroyedObjects);
	if (!DoublePressTime)
	{
		if (CollateralDamage)
		{
			DoublePressTime = 50;
			char Grammer1[128];
			char Grammer2[128];
			switch (DamagedObjects)
			{
				case 0:sprintf(Grammer1,"No objects have been damaged,   ");break;
				case 1:sprintf(Grammer1,"1 object has been damaged, ");break;
				default:sprintf(Grammer1,"%d objects have been damaged, ",DamagedObjects);break;
			}
			switch (DestroyedObjects)
			{
				case 0:sprintf(Grammer2,"and no objects were destroyed");break;
				case 1:sprintf(Grammer2,"and 1 object has been destroyed");break;
				default:sprintf(Grammer2,"and %d objects have been destroyed",DestroyedObjects);break;
			}
			sprintf(RepairMessage,"%s%s, total damage of %.2f, repairs will cost $%.0f.",Grammer1,Grammer2,CollateralDamage,RepairPrice);
			Send_Message_Player(poker,250,255,25,RepairMessage);
		}
		else
		{
			Send_Message_Player(poker,250,255,25,"Nothing in your house has been damaged.");
		}
	}
	else if (DoublePressTime)
	{
		if (Commands->Get_Money(poker) >= RepairPrice)
		{
			sprintf(RepairMessage,"Repairs complete, repairs came to a total of $%.0f.",RepairPrice);
			Send_Message_Player(poker,250,255,25,RepairMessage);
			Commands->Give_Money(poker,-RepairPrice,true);
			RepairAllSecurityObjects();
		}
		else
		{
			Send_Message_Player(poker,250,255,25,"Unfortunately, I do not have them money needed to complete the repairs to my house.");
		}
	}
}

void JMG_RP2_House_Repair_PT::Timer_Expired(GameObject *obj,int number)
{
	if (number == 654654655)
	{
		MyHouseSecurityNode = Find_Housing_Security_Node(Get_Int_Parameter("HouseAddress"));
		if (!MyHouseSecurityNode)
		{
			Commands->Start_Timer(obj,this,1.0,654654655);
		}
	}
	if (number == 654654654)
	{
		if (DoublePressTime)
		{
			DoublePressTime--;
		}
		Commands->Start_Timer(obj,this,0.1f,654654654);
	}
}

void JMG_RP2_House_Repair_PT::PriceCalculation(float *Damage,float *Price,int *DamagedObjects,int *DestroyedObjects)
{
	float CollateralDamage = 0.0;
	float RepairPrice = 0.0;
	int Damaged = 0;
	int Destroyed = 0;
	if (HomeSecurityObjectNode)
	{
		HomeSecurityObjectControl *Current = HomeSecurityObjectNode;
		while (Current != NULL)
		{
			if (Current->HouseAddress == Get_Int_Parameter("HouseAddress") && CheckIfCanRepair(Current))
			{
				GameObject *SecurityObject = Commands->Find_Object(Current->ObjectID);
				if (SecurityObject)
				{
					float ObjectDamage = Current->MaxHP-(Commands->Get_Health(SecurityObject)+Commands->Get_Shield_Strength(SecurityObject));
					CollateralDamage += ObjectDamage;
					RepairPrice += OBJECTTOALREAPIRVALUE*(Current->MaxHP/(Commands->Get_Health(SecurityObject)+Commands->Get_Shield_Strength(SecurityObject)));
					if (ObjectDamage)
					{
						Damaged++;
					}
				}
				else
				{
					CollateralDamage += Current->MaxHP;
					if (MyHouseSecurityNode->AutoRepair)
					{
						RepairPrice += (OBJECTTOALREAPIRVALUE*((float)Current->RespawnTime/60.0f));
					}
					else
					{
						RepairPrice += OBJECTTOALREAPIRVALUE;
					}
					Destroyed++;
				}
			}
			Current = Current->next;
		}
	}
	*Damage = CollateralDamage;
	*Price = RepairPrice;
	*DamagedObjects = Damaged;
	*DestroyedObjects = Destroyed;
}

void JMG_RP2_House_Repair_PT::RepairAllSecurityObjects()
{
	if (HomeSecurityObjectNode)
	{
		HomeSecurityObjectControl *Current = HomeSecurityObjectNode;
		while (Current != NULL)
		{
			if (Current->HouseAddress == Get_Int_Parameter("HouseAddress") && CheckIfCanRepair(Current))
			{
				GameObject *SecurityObject = Commands->Find_Object(Current->ObjectID);
				if (SecurityObject)
				{
					Commands->Set_Health(SecurityObject,Commands->Get_Max_Health(SecurityObject));
					Commands->Set_Shield_Strength(SecurityObject,Commands->Get_Max_Shield_Strength(SecurityObject));
				}
				else
				{
					GameObject *ReplaceObject = Commands->Create_Object(Current->PresetName,Current->Position);
					Commands->Set_Facing(ReplaceObject,Current->Rotation);
					Current->ObjectID = Commands->Get_ID(ReplaceObject);
					Attach_Script_Once(ReplaceObject,"JMG_RP2_House_Security_Object_Repair_Control","");
				}
			}
			Current = Current->next;
		}
	}
}

int JMG_RP2_House_Repair_PT::CheckIfCanRepair(HomeSecurityObjectControl *Current)
{
	if ((MyHouseSecurityNode->CeilingGuns && HSOCeilingGun == Current->DefenseType) || (MyHouseSecurityNode->MissileDefenseSystem && HSOAntiMissileSystem == Current->DefenseType) || HSODoor == Current->DefenseType)
	{
		return 1;
	}
	return 0;
}

void JMG_RP2_House_GDI_PT_Zone::Created(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		PlayerID[x] = 0;
	}
	ZoneOccupants = 0;
}

void JMG_RP2_House_GDI_PT_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		int PlayerIDp = Get_Player_ID(enter);
		CURRENTPLAYERPTZONE[PlayerIDp] = Commands->Get_ID(obj);
		if (ZoneOccupants == 0)
		{
			Commands->Start_Timer(obj,this,0.1f,95959595);
		}
		ZoneOccupants++;
		if (!ISSELECTINGSPAWN[PlayerIDp] && Commands->Has_Key(enter,Get_Int_Parameter("House_Address")) && !Commands->Has_Key(enter,-Get_Int_Parameter("House_Address")))
		{
			Commands->Set_Player_Type(enter,1);
		}
		for (int x = 0,end = 0;x < 128 && end == 0;x++)
		{
			if (PlayerIDp == PlayerID[x])
			{
				end = 1;
			}
			else if (PlayerID[x] == 0)
			{
				PlayerID[x] = PlayerIDp;
				end = 1;
			}
		}
	}
}

void JMG_RP2_House_GDI_PT_Zone::Exited(GameObject *obj,GameObject *exit)
{
	if (Commands->Is_A_Star(exit))
	{
		int PlayerIDp = Get_Player_ID(exit);
		if (CURRENTPLAYERPTZONE[PlayerIDp] == Commands->Get_ID(obj))
		{
			CURRENTPLAYERPTZONE[PlayerIDp] = 0;
		}
		if (!ISSELECTINGSPAWN[PlayerIDp])
		{
			ZoneOccupants--;
			for (int x = 0,end = 0;x < 128 && end == 0;x++)
			{
				if (PlayerIDp == PlayerID[x])
				{
					PlayerID[x] = 0;
					Commands->Set_Player_Type(exit,-1);
					end = 1;
				}
			}
		}
		else
		{
			Commands->Send_Custom_Event(obj,exit,51191172,-1,0);
		}
	}
}

void JMG_RP2_House_GDI_PT_Zone::Timer_Expired(GameObject *obj,int number)
{
	if (number == 95959595)
	{
		for (int x = 0;x < 128;x++)
		{
			if (PlayerID[x] != 0)
			{
				GameObject *Zoner = Get_GameObj(PlayerID[x]);
				if (IsInsideZone(obj,Zoner))
				{
					if (!ISSELECTINGSPAWN[PlayerID[x]])
					{
						if (Commands->Get_Player_Type(Zoner) != 1)
						{
							Commands->Set_Player_Type(Zoner,1);
						}
					}
				}
			}
		}
		if (ZoneOccupants > 0)
		{
			Commands->Start_Timer(obj,this,0.01f,95959595);
		}
	}
}

void JMG_RP2_House_Missile_Defense_System::Created(GameObject *obj)
{
	EnemyID = 0;
	TargetVisible = 0;
	Checking = 2;
	AGTargetID = 0;
	KillTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	if (Get_Int_Parameter("On_Grid") < 128 && Get_Int_Parameter("On_Grid") >= 0)
	{
		MyGrid = Get_Int_Parameter("On_Grid");
	}
	else
	{
		MyGrid = -1;
	}
	Commands->Start_Timer(obj,this,1.0,92562142);
	Commands->Start_Timer(obj,this,0.1f,92562143);
	Commands->Enable_Enemy_Seen(obj,true);
}

void JMG_RP2_House_Missile_Defense_System::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
	{
		return;
	}
	if (Commands->Is_A_Star(seen))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(seen)])
		{
			return;
		}
	}
	if (Commands->Has_Key(seen,Get_Int_Parameter("House_Address")) && !Commands->Has_Key(seen,-Get_Int_Parameter("House_Address")))
	{
		return;
	}
	if (!(seen->As_PhysicalGameObj() && seen->As_PhysicalGameObj()->Peek_Physical_Object() && seen->As_PhysicalGameObj()->Peek_Physical_Object()->As_ProjectileClass()))
	{
		float Distance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
		if (Distance <= Get_Float_Parameter("Max_Range") && Distance > Get_Float_Parameter("Min_Range"))
		{
			if (Checking == NOTHING)
			{	
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
				EnemyID = Commands->Get_ID(seen);
				Commands->Enable_Enemy_Seen(obj,false);
				Checking = SEARCHCOMPLETE;
			}
			if (Checking == SEARCHING)//See if still visible
			{
				if ((EnemyID == Commands->Get_ID(seen) && TargetVisible == 0) || (EnemyID == Commands->Get_ID(seen) && TargetVisible == 1 && Distance <= TargetDistance))
				{
					TargetVisible = true;// TARGET FOUND
					TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(seen));
				}
				else if (EnemyID != Commands->Get_ID(seen) && (Distance + 1.0f) < TargetDistance)// Closer Target Found, use this one
				{
					EnemyID = Commands->Get_ID(seen);
					TargetVisible = true;// TARGET FOUND!
					TargetDistance = Distance;
				}
			}
		}
	}
}

void JMG_RP2_House_Missile_Defense_System::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 9911591)
	{
		if (SCUD_Missile_Launcher_Node)// Ignore SCUDs Launched by the house owner
		{
			int end = 0,SenderID = Commands->Get_ID(sender);
			SCUD_Missile_Launcher_Control *Current = SCUD_Missile_Launcher_Node;
			while (Current && !end)
			{
				if (SenderID == Current->ScudID)
				{
					end = 1;
					GameObject *SCUDLauncherObject = Commands->Find_Object(Current->LauncherID);
					if (SCUDLauncherObject)
					{
						GameObject *SCUDLauncherDriver = Get_Vehicle_Driver(SCUDLauncherObject);
						if (SCUDLauncherDriver)
						{
							if (Commands->Has_Key(SCUDLauncherDriver,Get_Int_Parameter("House_Address")) && !Commands->Has_Key(SCUDLauncherDriver,-Get_Int_Parameter("House_Address")))
							{
								return;
							}
						}
					}
					SCUDLauncherObject = Commands->Find_Object(Current->TargetingSystemID);
					if (SCUDLauncherObject)
					{
						GameObject *SCUDLauncherDriver = Get_Vehicle_Driver(SCUDLauncherObject);
						if (SCUDLauncherDriver)
						{
							if (Commands->Has_Key(SCUDLauncherDriver,Get_Int_Parameter("House_Address")) && !Commands->Has_Key(SCUDLauncherDriver,-Get_Int_Parameter("House_Address")))
							{
								return;
							}
						}
					}
				}
				Current = Current->next;
			}
		}
		GiveToGrid(sender);
	}
}

void JMG_RP2_House_Missile_Defense_System::Timer_Expired(GameObject *obj,int number)
{
	if (92562143 == number)
	{
		if (EnemyID)
		{
			GameObject *Enemy = Commands->Find_Object(EnemyID);
			if (Enemy && KillTargetID != EnemyID)
			{
				AttackHoldFunction(obj,Enemy);
				KillTargetID = EnemyID;
			}
			if (!Enemy)
			{
				EnemyID = 0;
				KillTargetID = 0;
			}
		}
		Commands->Start_Timer(obj,this,0.25,92562143);
	}
	if (number == 92562142)
	{
		VisibilityCheck(obj);
		Commands->Start_Timer(obj,this,1.25,92562142);
	}
}

void JMG_RP2_House_Missile_Defense_System::StopShootingAndReload(GameObject *obj)
{
	EnemyID = 0;
	AGTargetID = 0;
	SameTarget = 0;
	AGAttackTime = 0;
	Checking = 2;
	KillTargetID = 0;
	Commands->Enable_Enemy_Seen(obj,true);
	Commands->Action_Reset(obj,100);
}

void JMG_RP2_House_Missile_Defense_System::AttackHoldFunction(GameObject *obj,GameObject *Enemy)
{
	ActionParamsStruct params;
	params.Set_Basic(this,0,100);
	params.Set_Attack(Enemy,Get_Float_Parameter("Max_Range"),0,1);
	params.AttackCheckBlocked = false;
	Commands->Action_Attack(obj,params);
}

void JMG_RP2_House_Missile_Defense_System::VisibilityCheck(GameObject *obj)
{
	enum{SEARCHCOMPLETE = 0,SEARCHING = 1,NOTHING = 2};
	if (EnemyID == 0) // Always set to true if no enemy is targeted
	{
		Checking = NOTHING;
		Commands->Enable_Enemy_Seen(obj,true);
		SelectNetworkTarget(obj);
	}
	if (Checking == SEARCHCOMPLETE)// If not checking for an enemy start
	{
		Checking = SEARCHING;
		TargetVisible = false;
		TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Commands->Find_Object(EnemyID)));
		Commands->Enable_Enemy_Seen(obj,true);
	}
	else if (Checking == SEARCHING && TargetVisible == 0)// If just completed the check, but no enemy found, clear target
	{
		EnemyID = 0;
		if (!AGTargetID)
		{
			StopShootingAndReload(obj);
		}
		else
		{
			AGAttackTime++;
			if (AGAttackTime > 15)
			{
				RemoveGridTarget(AGTargetID);
				StopShootingAndReload(obj);
			}
		}
		SelectNetworkTarget(obj);
	}
	else if (Checking == SEARCHING && TargetVisible == 1)// Enemy was found, keep the target
	{
		Commands->Enable_Enemy_Seen(obj,false);
		Checking = SEARCHCOMPLETE;
	}
}

void JMG_RP2_House_Missile_Defense_System::GiveToGrid(GameObject *Enemy)
{
	int end = 0;
	int AddID = Commands->Get_ID(Enemy);
	for (int x = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSBDGrid[MyGrid][x] == AddID)
		{
			end = 1;
			JRP2SSBDGrid[MyGrid][x] = AddID;
			JRP2SSBDGridTC[MyGrid]++;
		}
		else if (JRP2SSBDGrid[MyGrid][x] == 0)
		{
			end = 1;
			JRP2SSBDGrid[MyGrid][x] = AddID;
			JRP2SSBDGridTC[MyGrid]++;
		}
	}
	if (end == 0)
	{
		for (int x = 0;x < 25 && end == 0;x++)
		{
			if (x < 24)
			{
				JRP2SSBDGrid[MyGrid][x] = JRP2SSBDGrid[MyGrid][(x+1)];
			}
			else
			{
				JRP2SSBDGrid[MyGrid][x] = AddID;
			}
		}
	}
}

int JMG_RP2_House_Missile_Defense_System::GrabIDFromGrid()
{
	if (JRP2SSBDGridTC[MyGrid])
	{
		for (int x = 0,end = 0;x < 25 && end == 0;x++)
		{
			if (JRP2SSBDGrid[MyGrid][x] != 0)
			{
				end = 1;
				return JRP2SSBDGrid[MyGrid][x];
			}
		}
	}
	return 0;
}

void JMG_RP2_House_Missile_Defense_System::RemoveGridTarget(int ID)
{
	for (int x = 0,end = 0;x < 25 && end == 0;x++)
	{
		if (JRP2SSBDGrid[MyGrid][x] == ID)
		{
			for (int y = x;y < 25;y++)
			{
				if (y < 24)
				{
					JRP2SSBDGrid[MyGrid][y] = JRP2SSBDGrid[MyGrid][(y+1)];
				}
				else
				{
					JRP2SSBDGrid[MyGrid][y] = 0;
				}
			}
			JRP2SSBDGridTC[MyGrid]--;
			end = 1;
		}
	}
}

void JMG_RP2_House_Missile_Defense_System::SelectNetworkTarget(GameObject *obj) 
{
	if (AGTargetID && EnemyID && AGTargetID != EnemyID)
	{
		GameObject *Target = Commands->Find_Object(AGTargetID);
		GameObject *Target2 = Commands->Find_Object(EnemyID);
		float ObjectDistance = Commands->Get_Distance(Commands->Get_Position(Target),Commands->Get_Position(obj));
		float EnemyDistance = Commands->Get_Distance(Commands->Get_Position(Target2),Commands->Get_Position(obj));
		if (ObjectDistance < EnemyDistance)
		{
			EnemyID = AGTargetID;
		}
		else
		{
			AGTargetID = EnemyID;
		}
	}
	if (AGTargetID && !EnemyID)
	{
		SameTarget++;
		EnemyID = AGTargetID;
		GameObject *Target = Commands->Find_Object(AGTargetID);
		if (!Target || !Commands->Get_Health(Target))
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
			EnemyID = 0;
			Checking = 2;
			Commands->Enable_Enemy_Seen(obj,true);
		}
		if (SameTarget >= 40)
		{
			RemoveGridTarget(AGTargetID);
			AGTargetID = 0;
			SameTarget = 0;
		}
	}
	else if (!EnemyID && MyGrid != -1)
	{
		if (JRP2SSBDGridTC[MyGrid])
		{
			SameTarget = 0;
			EnemyID = GrabIDFromGrid();
			GameObject *Target = Commands->Find_Object(EnemyID);
			if (!Commands->Get_Health(Target))
			{
				RemoveGridTarget(EnemyID);
			}
			else if (EnemyID && Target)
			{
				TargetDistance = Commands->Get_Distance(Commands->Get_Position(obj),Commands->Get_Position(Target));
				Checking = 1;
				AGTargetID = EnemyID;
			}
		}
	}
	GameObject *NewTarget = Commands->Find_Object(AGTargetID);
	if (Commands->Is_A_Star(NewTarget))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(NewTarget)])
		{
			RemoveGridTarget(AGTargetID);
		}
	}
}


void JMG_RP2_Object_Send_Text_Message_On_Death::Killed(GameObject *obj, GameObject *killer)
{
	char Message[225];
	char MyName[256];
	const char *preset = Get_Translated_Preset_Name(obj);
	if (strlen(preset) > 1)
	{// Get the name of the object that died
		sprintf(MyName,"%s",preset);
	}
	else
	{// Noname, give stupid name
		sprintf(MyName,"Unnamed Object (Object ID:%d/PresetName:%s",Commands->Get_ID(obj),Commands->Get_Preset_Name(obj));
	}
	delete[] preset;
	if (obj->As_VehicleGameObj())
	{
		GameObject *Driver = Get_Vehicle_Driver(obj);
		if (Driver && Commands->Is_A_Star(Driver))
		{
			if (!killer)
			{// killed by nothing
				const char *str = Get_Player_Name(Driver);
				sprintf(Message,"%s's %s was destroyed.",str,MyName);
				delete[] str;
			}
			else if (Commands->Is_A_Star(killer) || Commands->Is_A_Star(Get_Vehicle_Driver(killer)))
			{// killed by a player
				const char *KillerWeapon = Get_Current_Weapon(killer);
				if (Commands->Is_A_Star(Get_Vehicle_Driver(killer)))
				{
					killer = Get_Vehicle_Driver(killer);
				}
				if (Get_Vehicle(killer))
				{
					const char *str = Get_Translated_Preset_Name(Get_Vehicle(killer));
					const char *str2 = Get_Player_Name(Driver);
					const char *str3 = Get_Player_Name(killer);
					sprintf(Message,"%s's %s was destroyed by %s while driving a %s.",str2,MyName,str3,str);
					delete[] str3;
					delete[] str2;
					delete[] str;
				}
				else if (KillerWeapon)
				{
					char Data[128];
					Get_Killer_Weapon_Syntax(killer,Data);
					const char *str = Get_Player_Name(Driver);
					const char *str2 = Get_Player_Name(killer);
					sprintf(Message,"%s's %s was destroyed by %s %s.",str,MyName,str2,Data);
					delete[] str;
					delete[] str2;
				}
			}
			else if (killer == obj)
			{// killed itself
				if ((obj->As_PhysicalGameObj() && obj->As_PhysicalGameObj()->Peek_Physical_Object() && obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
				{
					const char *str = Get_Player_Name(Driver);
					sprintf(Message,"%s's %s crashed.",str,MyName);
					delete[] str;
				}
				else
				{
					const char *str = Get_Player_Name(Driver);
					sprintf(Message,"%s's %s was destroyed.",str,MyName);
					delete[] str;
				}
			}
			else
			{// killed by an object
				char KillernName[128];
				const char *str = Get_Translated_Preset_Name(killer);
				if (strlen(str) > 1)
				{// Get the name of the object that died
					sprintf(KillernName,"%s",str);
				}
				else
				{// Noname, give stupid name
					sprintf(KillernName,"Unnamed Object (Object ID:%d/PresetName:%s",Commands->Get_ID(killer),Commands->Get_Preset_Name(killer));
				}
				delete[] str;
				const char *str2 = Get_Player_Name(Driver);
				sprintf(Message,"%s's %s was destroyed by a %s.",str2,MyName,KillernName);
				delete[] str2;
			}
			for (int x = 1;x < 128;x++)
			{// Send message to all players in game
				GameObject *Player = Get_GameObj(x);
				if (Player)
				{
					Send_Message_Player(Player,255,127,0,Message);
				}
			}
			return;
		}
	}
	if (Commands->Is_A_Star(obj) || !killer)
	{// Don't do this on players
		return;
	}
	char KilledOrDestroyed[128];
	if (obj->As_SoldierGameObj())
	{// Decide if the word killed, or the word destroyed should be used in the phrase
		sprintf(KilledOrDestroyed,"killed");
	}
	else
	{
		sprintf(KilledOrDestroyed,"destroyed");
	}
	if (Commands->Is_A_Star(killer))
	{// Killed by player
		const char *KillerWeapon = Get_Current_Weapon(killer);
		if (Get_Vehicle(killer))
		{
			const char *str = Get_Translated_Preset_Name(Get_Vehicle(killer));
			const char *str2 = Get_Player_Name(killer);
			sprintf(Message,"%s %s a %s while driving a %s.",str2,KilledOrDestroyed,MyName,str);
			delete[] str2;
			delete[] str;
		}
		else if (KillerWeapon)
		{
			char Data[128];
			Get_Killer_Weapon_Syntax(killer,Data);
			const char *str = Get_Player_Name(killer);
			sprintf(Message,"%s %s a %s %s.",str,KilledOrDestroyed,MyName,Data);
			delete[] str;
		}
	}
	else if (killer == obj)
	{// Killed Itself
		if (obj->As_SoldierGameObj())
		{
			if (Get_Sex(obj) == 'B')
			{
				sprintf(Message,"A %s %s herself.",MyName,KilledOrDestroyed);
			}
			else
			{
				sprintf(Message,"A %s %s himself.",MyName,KilledOrDestroyed);
			}
		}
		else
		{
			sprintf(Message,"A %s %s itself.",MyName,KilledOrDestroyed);
		}
	}
	else if (!Commands->Is_A_Star(killer))
	{// Killed by a nonplayer object
		char KillerObject[256];
		const char *str = Get_Translated_Preset_Name(killer);
		if (strlen(str) > 1)
		{
			sprintf(KillerObject,"%s",str);
		}
		else
		{
			sprintf(KillerObject,"Unnamed Object");
		}
		delete[] str;
		sprintf(Message,"A %s was %s by a %s.",MyName,KilledOrDestroyed,KillerObject);
	}
	else
	{// Just diedSpontaneously combusted
		if (obj->As_SoldierGameObj())
		{// Decide if the word killed, or the word destroyed should be used in the phrase
			sprintf(Message,"A %s died.",MyName);
		}
		else
		{
			sprintf(Message,"A %s spontaneously combusted.",MyName);
		}
	}
	for (int x = 1;x < 128;x++)
	{// Send message to all players in game
		GameObject *Player = Get_GameObj(x);
		if (Player)
		{
			Send_Message_Player(Player,255,127,0,Message);
		}
	}
}

void JMG_RP2_Teleport_On_Frame_Range::Entered(GameObject *obj,GameObject *enter)
{
	float Frame = Get_Animation_Frame(Commands->Find_Object(Get_Int_Parameter("ID")));
	if (Frame >= Get_Float_Parameter("Enabled_Min") && Frame <= Get_Float_Parameter("Enabled_Max"))
	{
		Commands->Set_Position(enter,Get_Vector3_Parameter("Position"));
	}
}

void JMG_RP2_Anti_Missile_System_Dish::Created(GameObject *obj)
{
	MyDishNode = Create_Dish_Node(Commands->Get_ID(obj));
}

void JMG_RP2_Anti_Missile_System_Dish::Killed(GameObject *obj, GameObject *damager)
{
	if (MyDishNode)
	{
		if (Commands->Get_ID(obj) == MyDishNode->DishID)
		{
			MyDishNode->DishID = 0;
		}
	}
}

void JMG_RP2_Anti_Missile_System_Dish::Destroyed(GameObject *obj)
{
	if (MyDishNode)
	{
		if (Commands->Get_ID(obj) == MyDishNode->DishID)
		{
			MyDishNode->DishID = 0;
		}
	}
}

AntiMissileSystemControl *JMG_RP2_Anti_Missile_System_Dish::Create_Dish_Node(int ID)
{
	if (!AntiMissileSystemNode)
	{
		AntiMissileSystemNode = new AntiMissileSystemControl;
		AntiMissileSystemNode->DishID = ID;
		AntiMissileSystemNode->next = NULL;
		return AntiMissileSystemNode;
	}
	else
	{
		AntiMissileSystemControl *Current = AntiMissileSystemNode;
		while (Current != NULL)
		{
			if (Current->DishID == ID || !Current->DishID)
			{
				Current->DishID = ID;
				return Current;
			}
			else if (Current->next == NULL)
			{
				Current->next = new AntiMissileSystemControl;
				Current = Current->next;
				Current->DishID = ID;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_Tornado_Throw::Created(GameObject *obj)
{// Renhalo code, moved here because 2.9.2 doesn't allow for collision detection 8/3/10
	char anim[512];
	const char *modelname = Get_Model(obj);
	sprintf(anim,"%s.%s",modelname,modelname);
	Commands->Set_Animation(obj,anim,false,0,0,500,false);
	Commands->Start_Timer(obj,this,0.01f,4352153);
}

void JMG_Tornado_Throw::Timer_Expired(GameObject *obj,int number)
{// New code added in on 8/3/10 Jerad Gray to trigger collisions
	if (number == 4352153)
	{
		GameObject *TheVehicle = Commands->Find_Object(Get_Int_Parameter("ID"));
		PhysicalGameObj *objphys = ((ScriptableGameObj *)TheVehicle)->As_PhysicalGameObj();
		if (objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
		{
			LastSafeFrame = Get_Animation_Frame(obj);
			Commands->Start_Timer(obj,this,0.01f,4352153);
		}
		else
		{
			float Curframe = Get_Animation_Frame(obj);
			if (TheVehicle->As_VehicleGameObj())
			{
				if (Curframe < 180)
				{
					Commands->Apply_Damage(obj,800.0f,"none",0);
				}
				else
				{
					float DamagePercent = (Curframe/500.0f)*800.0f;
					Commands->Apply_Damage(obj,DamagePercent,"none",0);
				}
				Commands->Create_Sound("vehicle_collide_01",Commands->Get_Position(TheVehicle),TheVehicle);
			}
			else
			{
				if (Curframe < 180)
				{
					Commands->Apply_Damage(obj,1100.0f,"none",0);
				}
				else
				{
					float DamagePercent = (Curframe/500.0f)*1100.0f;
					Commands->Apply_Damage(obj,DamagePercent,"none",0);
				}
			}
			char anim[512];
			const char *modelname = Get_Model(obj);
			sprintf(anim,"%s.%s",modelname,modelname);
			Commands->Set_Animation(obj,anim,false,0,Curframe,LastSafeFrame,false);
		}
	}
}

void JMG_Tornado_Throw::Animation_Complete(GameObject *obj,const char *anim)
{
	GameObject *object = Commands->Find_Object(Get_Int_Parameter("ID"));
	Commands->Send_Custom_Event(obj,object,70464004,1,0);
	Commands->Destroy_Object(obj);
}

void JMG_RP2_Firetruck::Created(GameObject *obj)
{
	siren = 0;
	SirenID = 0;
	char params[128];
	sprintf(params,"%d",Commands->Get_ID(obj));
	MyZoneBox = new OBBoxClass;
	OBBoxClass *OtherBox = Get_Zone_Box(Commands->Find_Object(136934));
	for (int x = 0;x < 3 && OtherBox;x++)
	{
		for (int y = 0;y < 3;y++)
		{
			MyZoneBox->Basis[x][y] = OtherBox->Basis[x][y];
		}
	}
	MyZoneBox->Center = Commands->Get_Bone_Position(obj,"MuzzleA0");
	MyZoneBox->Extent.X = 2.0f;
	MyZoneBox->Extent.Y = 2.0f;
	MyZoneBox->Extent.Z = 2.0f;
	GameObject *ReEnterZone = Create_Zone("Script_Zone_All",*MyZoneBox);
	Commands->Attach_Script(ReEnterZone,"JMG_RP2_Fire_Truck_ReEnter_Zone",params);
	ReEnterZoneID = Commands->Get_ID(ReEnterZone);

	LastClickerID = 0;
	Set_Current_Bullets(obj,0);
	BucketPos = Commands->Get_Position(obj);
	EngineEnabled = true;
	Deployed = false;
	char Animation[256];
	sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
	Commands->Set_Animation(obj,Animation,false,0,0,0,false);
	Commands->Start_Timer(obj,this,0.1f,4352153);
}

void JMG_RP2_Firetruck::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	float CurFrame = Get_Animation_Frame(obj);
	if (message == 7154148)
	{
		Send_Message_Player(sender,200,200,125,"Vehicle Special Keys:");
		Send_Message_Player(sender,200,200,125,"B - Deploy/Undeploy");
		Send_Message_Player(sender,200,200,125,"LeftMouse (while deployed) - Climb ladder");
		Send_Message_Player(sender,200,200,125,"Right Click - Cycle through siren modes");
		Send_Message_Player(sender,200,200,125,"Numpad +/- - Extend/Retract ladder large amount");
		Send_Message_Player(sender,200,200,125,"+/- - Extend/Retract ladder small amounts");
	}
	if (message == 98562146)
	{
		if (SirenID > 0)
		{
			GameObject *Siren = Commands->Find_Object(SirenID);
			if (Siren)
			{
				Commands->Destroy_Object(Siren);
			}
			SirenID = 0;
		}
		if (siren == 0)
		{
			siren = 1;
			Vector3 pos;
			char params[20];
			sprintf(params,"%d",Commands->Get_ID(obj));
			GameObject *siren = Commands->Create_Object("Daves Arrow",pos);
			Commands->Attach_To_Object_Bone(siren,obj,"origin");	
			Commands->Set_Model(siren,"PoliceCarSiren1");
			SirenID = Commands->Get_ID(siren);
			Commands->Attach_Script(siren,"JMG_Remove_Object_When_Creator_Destroyed",params);
		}
		else if (siren == 1)
		{
			siren = 2;
			Vector3 pos;
			char params[20];
			sprintf(params,"%d",Commands->Get_ID(obj));
			GameObject *siren = Commands->Create_Object("Daves Arrow",pos);
			Commands->Attach_To_Object_Bone(siren,obj,"origin");	
			Commands->Set_Model(siren,"PoliceCarSiren2");
			SirenID = Commands->Get_ID(siren);
			Commands->Attach_Script(siren,"JMG_Remove_Object_When_Creator_Destroyed",params);
		}
		else if (siren == 2)
		{
			siren = 0;
		}
	}
	if (message == 7745472)
	{
		if (Deployed)
		{
			Send_Message_Player(sender,150,0,150,"Undeploying...");
			char Animation[256];
			sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
			Commands->Set_Animation(obj,Animation,false,0,CurFrame,0,false);
			Deployed = false;
		}
		else if (CurFrame == 0.0f)
		{
			Send_Message_Player(sender,150,0,150,"Deploying...");
			Deployed = true;
		}
		else
		{
			Send_Message_Player(sender,150,0,150,"Undeploying stand-by...");
		}
	}
	if (Deployed)
	{
		if ((message == 20012142 || message == 20112142) && CurFrame+1.0f <= 30)
		{
			char Animation[256];
			sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
			float GotoFrame = CurFrame;
			if (message == 20012142)
			{
				GotoFrame += 1.0f;
			}
			if (message == 20112142)
			{
				GotoFrame += 5.0f;
				if (GotoFrame > 30)
				{
					GotoFrame = 30.0f;
				}
			}
			Commands->Set_Animation(obj,Animation,false,0,CurFrame,GotoFrame,false);
		}
		if ((message == 20102142 || message == 20002142) && CurFrame-1.0f >= 0)
		{
			char Animation[256];
			sprintf(Animation,"%s.%s",Get_Model(obj),Get_Model(obj));
			float GotoFrame = CurFrame;
			if (message == 20002142)
			{
				GotoFrame -= 1.0f;
			}
			if (message == 20102142)
			{
				GotoFrame -= 5.0f;
				if (GotoFrame < 0)
				{
					GotoFrame = 0.0f;
				}
			}
			Commands->Set_Animation(obj,Animation,false,0,CurFrame,GotoFrame,false);
		}
		if (message == 98562145)
		{
			//Commands->Set_Position(Commands->Find_Object(137952),Find_Zone_Area(Commands->Find_Object(ReEnterZoneID)));//Used to find zone
			if (Commands->Get_Distance(BucketPos,Commands->Get_Bone_Position(obj,"MuzzleA0")) < 0.25 && sender)
			{
				JumpToLadder(obj,sender);
			}
			else
			{
				LastClickerID = Commands->Get_ID(sender);
			}
		}
	}
}

void JMG_RP2_Firetruck::Timer_Expired(GameObject *obj,int number)
{
	if (number == 4352153)
	{
		float CurFrame = Get_Animation_Frame(obj);
		if (Deployed || CurFrame != 0.0f)
		{//Engine On
			GameObject *TheZone = Commands->Find_Object(ReEnterZoneID);
			if (TheZone)
			{// Move the zone to the same spot as the end of the fire truck's ladder
				Vector3 TargetSpot = Commands->Get_Bone_Position(obj,"MuzzleA0");
				MyZoneBox->Center = TargetSpot;
				Set_Zone_Box(TheZone,*MyZoneBox);
			}
			EngineEnabled = false;
			Commands->Enable_Engine(obj,false);
		}
		else if (!Deployed && !EngineEnabled)//Engine Off
		{
			GameObject *TheZone = Commands->Find_Object(ReEnterZoneID);
			if (TheZone)
			{// Hide the Zone
				MyZoneBox->Center = Vector3(9000.0f,9000.0f,0.0f);
				Set_Zone_Box(TheZone,*MyZoneBox);
			}
			EngineEnabled = true;
			if (Get_Vehicle_Occupant_Count(obj))
			{
				Commands->Enable_Engine(obj,true);
			}
		}
		if (Get_Current_Bullets(obj) != 999)
		{
			if (Commands->Get_Distance(BucketPos,Commands->Get_Bone_Position(obj,"MuzzleA0")) < 0.25 && LastClickerID)
			{
				JumpToLadder(obj,Commands->Find_Object(LastClickerID));
			}
			Set_Current_Clip_Bullets(obj,999);
			BucketPos = Commands->Get_Bone_Position(obj,"MuzzleA0");
		}
		Commands->Start_Timer(obj,this,0.1f,4352153);
	}
}

void JMG_RP2_Firetruck::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *TheZone = Commands->Find_Object(ReEnterZoneID);
	if (TheZone)
	{
		Commands->Destroy_Object(TheZone);
	}
	if (MyZoneBox)
	{
		delete MyZoneBox;
	}
}


void JMG_RP2_Firetruck::JumpToLadder(GameObject *obj,GameObject *sender)
{
	if (!obj || !sender){return;}
	LastClickerID = 0;
	Soldier_Transition_Vehicle(sender);
	PhysicalGameObj *objphys = ((ScriptableGameObj *)sender)->As_PhysicalGameObj();
	Vector3 OldPos = Commands->Get_Position(sender);
	Commands->Set_Position(sender,Commands->Get_Bone_Position(obj,"MuzzleA0"));
	if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
	{
		Commands->Set_Position(sender,OldPos);
	}
}

Vector3 JMG_RP2_Firetruck::Find_Zone_Area(GameObject *TempZone)
{
	OBBoxClass *ZZBox = Get_Zone_Box(TempZone);
	Vector3 Pos2;
	Pos2.X = Commands->Get_Random((0.0f-ZZBox->Extent.X),ZZBox->Extent.X);
	Pos2.Y = Commands->Get_Random((0.0f-ZZBox->Extent.Y),ZZBox->Extent.Y);
	Pos2.Z = ZZBox->Center.Z+(ZZBox->Extent.Z);
	if (ZZBox->Basis[0][1] && ZZBox->Basis[0][0] > -1)
	{
		float Temp = Pos2.Y;
		Pos2.Y = Pos2.X;
		Pos2.X = Temp;
	}
	Pos2.X += ZZBox->Center.X;
	Pos2.Y += ZZBox->Center.Y;
	while (Pos2.Y < -4900)
	{
		Pos2.Y += 1000;
	}
	while (Pos2.Y > 4900)
	{
		Pos2.Y -= 1000;
	}
	while (Pos2.X < -4900)
	{
		Pos2.X += 1000;
	}
	while (Pos2.X > 4900)
	{
		Pos2.X -= 1000;
	}
	return Pos2;
}

void JMG_RP2_Vehicle_Speedometer::Created(GameObject *obj)
{
	MyNode = NULL;
	Set_Current_Bullets(obj,0);
	Commands->Start_Timer(obj,this,0.25f,4352153);
}

void JMG_RP2_Vehicle_Speedometer::Timer_Expired(GameObject *obj,int number)
{
	if (number == 4352153)
	{
		if (Get_Vehicle_Occupant_Count(obj))
		{
			if (!MyNode)
			{
				MyNode = FindNode(obj);
			}
			if (MyNode)
			{
				float Speed = 0;
				for (int x = 0;x < 10;x++)
				{
					Speed += MyNode->MPS[x];
				}
				Speed /= 10;
				int YourSpeed = (int)Speed;
				if (!YourSpeed)
				{// Make it look like it reads zero, this allows you to still fire the vehicle's horn
					YourSpeed = 1000;
				}
				Set_Current_Clip_Bullets(obj,YourSpeed);
			}
		}
		Commands->Start_Timer(obj,this,0.1f,4352153);
	}
}

RP2VehicleControl *JMG_RP2_Vehicle_Speedometer::FindNode(GameObject *obj)
{
	if (RP2VehicleNode)
	{
		RP2VehicleControl *Current = RP2VehicleNode;
		int MyID = Commands->Get_ID(obj);
		while (Current != NULL)
		{
			if (Current->VehicleID == MyID)
			{
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

void JMG_RP2_Hot_Air_Balloon::Created(GameObject *obj)
{	
	FireOn = 0;
	MovementDirection = -1;
	AirTemp = 0;
	Vector3 Pos = Commands->Get_Position(obj);
	GameObject *HeightCap = Commands->Create_Object("Daves Arrow",Pos);
	Commands->Attach_To_Object_Bone(HeightCap,obj,"MoveDn");
	Commands->Set_Model(HeightCap,"null");
	MoverID = Commands->Get_ID(HeightCap);
	HeightCap = Commands->Create_Object("Daves Arrow",Pos);
	Commands->Attach_To_Object_Bone(HeightCap,obj,"MoveUp");
	Commands->Set_Model(HeightCap,"null");
	MoverID2 = Commands->Get_ID(HeightCap);
	UpNeitherDown = 0;
	Commands->Set_Animation(obj,"A_HotAirBalloon.A_HotAirBalloon",true,0,910,910,true);
	EngineEnabled = false;
	Attach_Script_Once(obj,"JMG_RP2_Vehicle_Ignore_EMP","");
	Commands->Start_Timer(obj,this,0.1f,987452);
	Commands->Start_Timer(obj,this,1.0f,987453);
}

void JMG_RP2_Hot_Air_Balloon::Timer_Expired(GameObject *obj, int number)
{	
	if (number == 987454)
	{
		Commands->Enable_Engine(obj,true);
	}
	if (number == 987452)
	{
		float Current_Frame = Get_Animation_Frame(obj);
		if (Get_Current_Total_Bullets(obj) != 9999)
		{
			if (FireOn < 100)
			{
				FireOn += 10;
			}
		}
		else if (FireOn)
		{
			FireOn--;
		}
		AirTemp += (9999-Get_Current_Total_Bullets(obj));
		if (AirTemp > 5000)
		{
			AirTemp = 5000;
		}
		Set_Current_Clip_Bullets(obj,9999);
		if (AirTemp >= 910)
		{
			if (!EngineEnabled)
			{
				EngineEnabled = true;
				Commands->Enable_Engine(obj,true);
			}
			if (FireOn >= 95)
			{
				if (UpNeitherDown != 1){Commands->Set_Model(obj,Get_Model(obj));UpNeitherDown = 1;}
				GameObject *HeightCap = Commands->Find_Object(MoverID);
				if (HeightCap)
				{
					Commands->Set_Model(HeightCap,"null");
				}	
				HeightCap = Commands->Find_Object(MoverID2);
				if (HeightCap)
				{
					Commands->Set_Model(HeightCap,"BalloonBlock");
				}	
			}
			else if (FireOn)
			{
				if (UpNeitherDown != 0){Commands->Set_Model(obj,Get_Model(obj));UpNeitherDown = 0;}
				GameObject *HeightCap = Commands->Find_Object(MoverID);
				if (HeightCap)
				{
					Commands->Set_Model(HeightCap,"BalloonBlock");
				}	
				HeightCap = Commands->Find_Object(MoverID2);
				if (HeightCap)
				{
					Commands->Set_Model(HeightCap,"BalloonBlock");
				}	
			}
			else
			{
				if (UpNeitherDown != -1){Commands->Set_Model(obj,Get_Model(obj));UpNeitherDown = -1;}
				GameObject *HeightCap = Commands->Find_Object(MoverID);
				if (HeightCap)
				{
					Commands->Set_Model(HeightCap,"BalloonBlock");
				}	
				HeightCap = Commands->Find_Object(MoverID2);
				if (HeightCap)
				{
					Commands->Set_Model(HeightCap,"null");
				}	
			}
		}
		else
		{
			if (UpNeitherDown != 2){Commands->Set_Model(obj,Get_Model(obj));UpNeitherDown = 2;}
			EngineEnabled = false;
			Commands->Enable_Engine(obj,false);
			Commands->Set_Animation(obj,"A_HotAirBalloon.A_HotAirBalloon",true,0,Current_Frame,(910.0f-AirTemp),true);
			GameObject *HeightCap = Commands->Find_Object(MoverID);
			if (HeightCap)
			{
				Commands->Set_Model(HeightCap,"null");
			}	
			HeightCap = Commands->Find_Object(MoverID2);
			if (HeightCap)
			{
				Commands->Set_Model(HeightCap,"null");
			}	
		}
		if (AirTemp)
		{
			AirTemp--;
		}
		Commands->Start_Timer(obj,this,0.1f,987452);
	}
	if (number == 987453)
	{
		if (AirTemp >= 910)
		{
			Commands->Set_Animation(obj,"A_HotAirBalloon.A_HotAirBalloon",false,0,Get_Animation_Frame(obj),0,true);
		}
		else
		{
			Commands->Set_Animation(obj,"A_HotAirBalloon.A_HotAirBalloon",false,0,Get_Animation_Frame(obj),(910.0f-AirTemp),true);
		}
		Commands->Start_Timer(obj,this,1.0f,987453);
	}
}

void JMG_RP2_Hot_Air_Balloon::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7154148)
	{
		Send_Message_Player(sender,200,200,125,"Vehicle Special Key:");
		Send_Message_Player(sender,200,200,125,"Left/Right Mouse - Fire burner to increase balloon temp.");
	}
	if (message == 347361)
	{
		Killed(obj,obj);
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		Commands->Enable_Engine(obj,true);
		Commands->Start_Timer(obj,this,0.1f,987454);
	}
}

void JMG_RP2_Hot_Air_Balloon::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *HeightCap = Commands->Find_Object(MoverID);
	if (HeightCap)
	{
		Commands->Destroy_Object(HeightCap);
	}	
	HeightCap = Commands->Find_Object(MoverID2);
	if (HeightCap)
	{
		Commands->Destroy_Object(HeightCap);
	}	
}

void JMG_RP2_Fire_Truck_ReEnter_Zone::Entered(GameObject *obj,GameObject *enter)
{
	Send_Message_Player(enter,127,25,25,"Press the action key to enter the fire truck.");
	Commands->Send_Custom_Event(obj,enter,5193734,Get_Int_Parameter("FireTruckID"),0.0f);
}

void JMG_RP2_Fire_Truck_ReEnter_Zone::Exited(GameObject *obj,GameObject *exiter)
{
	Commands->Send_Custom_Event(obj,exiter,5193734,0,0.0f);
}

void JMG_RP2_Mech_MadCat::Created(GameObject *obj)
{	
	VoiceFiles = NULL;
	ReactorTemp = 300;// 300 kelvin is about 85 degrees
	HeatOverride = false;
	PlayingVoice = false;
	GaveHeatWarning = false;
	AttempttedAutoShutDownSequence = false;
	HeatOverrideEngaged = false;
	AutoStarting = false;
	ChangingState = false;
	IAEDE = false;
	SetState = MechState = ShutDown;
	WalkState = MIdle;
	CoolDownRate = 0;
	CoolDownSpeedUp = 10;
	Explosives = 0;
	Set_Current_Clip_Bullets(obj,9999);
	Set_Current_Bullets(obj,0);
	Is_In_Water = 0;
	GameObject *object = Commands->Create_Object("Daves_Arrow_NT",Commands->Get_Position(obj));//Invisible_Box_NR
	Commands->Attach_To_Object_Bone(object,obj,"HoverBone");
	Commands->Set_Model(object,"null");
	Hover_Plate_ID = Commands->Get_ID(object);
	JumpJetsOn = false;
	JetFuel = 60;
	JetCoolDownTime = 0;
	ReFuelStartDelay = 0;

	for (int x = 1;x < 128;x++)
	{
		GameObject *Player = Get_GameObj(x);
		Set_Obj_Radar_Blip_Shape_Player(Player,obj,RADAR_BLIP_SHAPE_NONE);
	}
	sprintf(LastMoveAnimation,"rp2madcat.rp2madcatf");
	Commands->Set_Model(obj,"rp2madcatc");
	Commands->Set_Animation(obj,"rp2madcatc.rp2madcatc",false,0,0,40,true);
	/*Vector3 MyPos = Commands->Get_Position(obj);
	MyPos.Z -= 5.362;
	Commands->Set_Position(obj,MyPos);*/
	Attach_Script_Once(obj,"JMG_RP2_Vehicle_Ignore_EMP","");
	Commands->Start_Timer(obj,this,0.1f,987452);
	Commands->Start_Timer(obj,this,0.25f,987456);
	Commands->Start_Timer(obj,this,5.0f,987457);
}

void JMG_RP2_Mech_MadCat::Timer_Expired(GameObject *obj, int number)
{
	if (number == 987454)
	{// Last Voice Message Ended, trigger next state/voice message
		PlayingVoice = false;
		MechState = SetState;
		if (VoiceFiles)
		{
			Eva_Talk(obj,VoiceFiles->EVAMessage,VoiceFiles->VoiceTime,(MechStates)VoiceFiles->SetState,VoiceFiles->TextMessage);
			Mech_Voice_Files *Temp = VoiceFiles->next;
			delete VoiceFiles;
			VoiceFiles = Temp;
		}
		// State Updates below
		if (MechState == OverHeatShuttingDown && !HeatOverrideEngaged)
		{// Special shutdown state for overheats
			HeatOverrideEngaged = true;
			Eva_Talk(obj,"Mech_Shut_Down",0.75,OverHeatShutDown,"Computer: Shutting down.");
		}
		else if (MechState == ShuttingDown)
		{// Mech was shutting down, change it's state to be shutdown
			MechState = ShutDown;
			Mech_ShutDown(obj);
			ChangingState = false;
		}
		else if (MechState == OverHeatShutDown)
		{
			ChangingState = false;
			AutoStarting = false;
			Mech_ShutDown(obj);
		}
		else if (MechState == PoweringUp)
		{// mech was powering up, change its state to on-line
			Mech_StartUp(obj);
			Set_Current_Clip_Bullets(obj,9999);
			MechState = OnLine;
			ChangingState = false;
		}
		else if (MechState == SelfDestruct)
		{// Start SelfDestruct
			if (!Explosives)
			{
				Mech_ShutDown(obj);
				Explosives = 10;
				Set_Skin(obj,"Blamo");
				Commands->Set_Shield_Type(obj,"Blamo");
				Commands->Start_Timer(obj,this,0.1f,987453);
				ChangingState = false;
			}
			Eva_Talk(obj,"Mech_SelfDestruct",2.99f,SelfDestruct,"Computer: Self destruct sequence initiated.");
		}
		if (IAEDE)
		{
			Eject_Pilot(obj);
		}
	}
	if (number == 987452)
	{
		if ((9999 != Get_Current_Bullets(obj) || JumpJetsOn) && Is_OnLine())
		{
			CoolDownRate = 0;
			CoolDownSpeedUp = 10;
		}
		else
		{
			CoolDownSpeedUp--;
			if (!CoolDownSpeedUp)
			{
				CoolDownSpeedUp = 10;
				CoolDownRate++;
				if (MechState == ShutDown && Is_In_Water)
				{
					if (CoolDownRate > 7)
					{
						CoolDownRate = 7;
					}
				}
				else if (MechState == ShutDown || Is_In_Water)
				{
					if (CoolDownRate > 5)
					{
						CoolDownRate = 5;
					}
				}
				else if (CoolDownRate > 3)
				{
					CoolDownRate = 3;
				}
			}
		}
		if (MechState == OverHeatShutDown && !AutoStarting && Get_Vehicle_Occupant_Count(obj))
		{// Mech is powered down
			if (ReactorTemp < 500)
			{// Begin Auto Bootup
				Eva_Talk(obj,"Mech_StartUp",8.36f,PoweringUp,"Computer: Reactor on-line, sensors on-line, weapons on-line, all systems nominal.");
				AutoStarting = true;
			}
		}
		if (Is_OnLine())
		{// Mech is on-line
			if (!Is_In_Water)
			{// On land
				ReactorTemp += (9999-Get_Current_Bullets(obj))/2;
			}
			else
			{// In water
				ReactorTemp += (9999-Get_Current_Bullets(obj))/3;
			}
			Set_Current_Clip_Bullets(obj,9999);
			if (ReactorTemp > 999){Commands->Set_Shield_Strength(obj,999.9f);/*Set_Current_Bullets(obj,999);*/}
			else{Commands->Set_Shield_Strength(obj,(float)ReactorTemp);/*Set_Current_Bullets(obj,ReactorTemp);*/}
			if (ReactorTemp > 1100)
			{// Overheated, thus explode
				Commands->Apply_Damage(obj,9999.9f,"BlamoKiller",obj);
			}
			if (ReactorTemp < 500 && (GaveHeatWarning || AttempttedAutoShutDownSequence || HeatOverrideEngaged))
			{// Reset warnings and shutdowns
				GaveHeatWarning = false;
				AttempttedAutoShutDownSequence = false;
				HeatOverrideEngaged = false;
			}
			if (ReactorTemp > 700 && !GaveHeatWarning)
			{// Reactor over 700 kelvin
				Eva_Talk(obj,"Mech_Heat_Warning",3.35f,MechState,"Computer: Internal heat at 700 Kelvin.");
				GaveHeatWarning = true;
			}
			if (ReactorTemp > 800 && !AttempttedAutoShutDownSequence)
			{// Reactor Too Hot, automatic shutdown engaged
				AttempttedAutoShutDownSequence = true;
				Eva_Talk(obj,"Mech_Shutdown_Reactor_Overheat",2.95f,OverHeatShuttingDown,"Computer: Reactor critical, shutdown imminent.");
			}
		}
		else
		{// Mech is in an off-line state
			Set_Current_Clip_Bullets(obj,0);
			//Set_Current_Bullets(obj,0);
			//Commands->Set_Shield_Strength(obj,0.0f);
		}
		ReactorTemp -= CoolDownRate;
		if (ReactorTemp < 300)
		{
			ReactorTemp = 300;
		}
		Mech_Animation(obj);
		Commands->Start_Timer(obj,this,0.1f,987452);
	}
	if (number == 987453)
	{// SelfDestruct
		GameObject *MyDriver = Get_Vehicle_Driver(obj);
		if (MyDriver)
		{
			if (Explosives < 100)
			{
				int MinRange = 0;
				Explosives += 3;
				if (Explosives > 10)
				{// Make the explosion splash into a ring
					MinRange = Explosives - 10;
				}
				for (int x = 0;x < Explosives;)
				{// More explosions as it spreads out
					x += 2;
					Vector3 Pos = Commands->Get_Position(obj);
					float Distance = Commands->Get_Random((float)MinRange,(float)Explosives);
					float Rotation = Commands->Get_Random(-180.0,180);
					Pos.X += cos(Rotation*PI180)*Distance;
					Pos.Y += sin(Rotation*PI180)*Distance;
					Commands->Create_Explosion("Explosion_M72_LAW_Twiddler",Pos,MyDriver);
				}
			}
			else
			{// Kill Mech and the driver
				Commands->Apply_Damage(obj,9999.9f,"BlamoKiller",MyDriver);
				Toggle_Fly_Mode(MyDriver);
				char Text[237];
				if (Get_Sex(MyDriver) == 'B')
				{
					const char *str = Get_Player_Name(MyDriver);
					sprintf(Text,"%s scuttled her Mech's reactor rather that deal with defeat.",str);
					delete[] str;
				}
				else
				{
					const char *str = Get_Player_Name(MyDriver);
					sprintf(Text,"%s scuttled his Mech's reactor rather that deal with defeat.",str);
					delete[] str;
				}
				RP2_Player_Death_Message_Control(MyDriver,Text,0);
				Commands->Set_Shield_Strength(MyDriver,0.0f);
				Commands->Set_Health(MyDriver,1.0f);
				Commands->Apply_Damage(MyDriver,9999.9f,"BlamoKiller",MyDriver);
			}
			Commands->Start_Timer(obj,this,0.1f,987453);
		}
	}
	if (number == 987456)
	{
		if (JumpJetsOn)
		{
			if (!Is_In_Water)
			{// On land
				ReactorTemp += 2;
			}
			else
			{// In water
				ReactorTemp++;
			}
			ReFuelStartDelay = 0;
			if (JetFuel > 0)
			{
				JetFuel--;
			}
			JetCoolDownTime++;
			if (JetFuel <= 0)
			{
				Commands->Set_Animation(obj,"rp2madcat.rp2madcat",false,0,0,0,true);
				JumpJetsOn = false;
				GameObject *object = Commands->Find_Object(Hover_Plate_ID);
				if (object)
				{// Remove hoverplate collision
					Commands->Set_Model(object,"null");
				}
				object = Commands->Find_Object(TempID);
				if (object)
				{// Remove the fire, just leave the smoke
					Commands->Destroy_Object(object);
				}
			}
		}
		else
		{
			if (JetFuel < 60)
			{
				ReFuelStartDelay++;
				if (ReFuelStartDelay > 40)
				{
					JetFuel++;
				}
			}
			if (JetCoolDownTime > 0)
			{
				JetCoolDownTime -= 5;
				if (JetCoolDownTime <= 0)
				{
					GameObject *object = Commands->Find_Object(TempID2);
					if (object)
					{// Remove Cooldown smoke
						Commands->Destroy_Object(object);
					}
				}
			}
		}
		if (!Get_Vehicle_Occupant_Count(obj) && Is_OnLine() && !ChangingState)
		{// Shut down mech if driver commits suicide or is dropped from the server
			ChangingState = true;
			Eva_Talk(obj,"Mech_Shut_Down",0.75,OverHeatShutDown,"Computer: Shutting down.");
		}
		Commands->Start_Timer(obj,this,0.25f,987456);
	}
	if (number == 987457)
	{
		if (_stricmp(Get_Model(obj),"rp2madcatc") && Is_OnLine())
		{
			GameObject *MyDriver = Get_Vehicle_Driver(obj);
			if (MyDriver && Commands->Is_A_Star(MyDriver))
			{
				Vector3 MyPos = Commands->Get_Position(obj);
				for (int x = 1;x < 128;x++)
				{
					GameObject *Player = Get_GameObj(x);
					if (Player && Player != MyDriver)
					{
						if (Commands->Get_Distance(MyPos,Commands->Get_Position(Player)) < 600)
						{
							Play_UI_SFX(obj,"Mech_Radar_Bleep");
							break;
						}
					}
				}
			}
		}
		if (Commands->Get_Health(obj) < Commands->Get_Max_Health(obj))
		{
			Commands->Set_Health(obj,Commands->Get_Health(obj)+1.0f);
			if (Commands->Get_Health(obj) > Commands->Get_Max_Health(obj))
			{
				Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
			}
		}
		Commands->Start_Timer(obj,this,5.0f,987457);
	}
}

void JMG_RP2_Mech_MadCat::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7154148)
	{
		Send_Message_Player(sender,200,200,125,"Vehicle Special Keys:");
		Send_Message_Player(sender,200,200,125,"Q - Shutdown/Startup Reactor");
		Send_Message_Player(sender,200,200,125,"O - Override automatic heat shutdown");
		Send_Message_Player(sender,200,200,125,"H - Eject from mech");
		Send_Message_Player(sender,200,200,125,"B - Self Destruct");
		Send_Message_Player(sender,200,200,125,"Spacebar - Toggle Jumpjets");
	}
	if (message == 347361)
	{
		Is_In_Water++;
	}
	if (message == 347360 && Is_In_Water)
	{
		Is_In_Water--;
	}
	if (message == 347361)
	{
		Killed(obj,obj);
	}
	if (message == 77454712 && !ChangingState)
	{//Toggle your mechs on-line state
		ChangingState = true;
		if (MechState == OnLine)
		{// shut down
			Eva_Talk(obj,"Mech_Shut_Down",0.75,ShuttingDown,"Computer: Shutting down.");
		}
		else if (MechState == ShutDown)
		{// start up
			Eva_Talk(obj,"Mech_StartUp",8.36f,PoweringUp,"Computer: Reactor on-line, sensors on-line, weapons on-line, all systems nominal.");
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		ChangingState = true;
		if (MechState == OnLine)
		{// Shut down when you exit the mech
			Eva_Talk(obj,"Mech_Shut_Down",0.75,ShuttingDown,"Computer: Shutting down.");
		}
		if (Commands->Is_A_Star(sender))
		{// Player exit radar override
			Enable_Radar_Player(sender,true);
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		ChangingState = true;
		if (MechState == ShutDown)
		{
			// Start up when you enter it
			Eva_Talk(obj,"Mech_StartUp",8.36f,PoweringUp,"Computer: Reactor on-line, sensors on-line, weapons on-line, all systems nominal.");
			if (Commands->Is_A_Star(sender))
			{// Player Enter radar override
				Enable_Radar_Player(sender,false);
			}
		}
	}
	if (message == 3423435 && (AttempttedAutoShutDownSequence || MechState == OverHeatShuttingDown) && !HeatOverrideEngaged && !ChangingState)
	{
		Eva_Talk(obj,"Mech_Heat_Override",3.13f,OnLine,"Computer: Emergency heat shutdown overridden.");
		HeatOverrideEngaged = true;
	}
	if (message == 7745473)
	{// Eject
		if (!Eject_Pilot(obj))
		{
			GameObject *MyDriver = Get_Vehicle_Driver(obj);
			if (MyDriver && Commands->Is_A_Star(MyDriver))
			{
				Send_Message_Player(MyDriver,0,127,255,"Warning: Cannot eject on minimal power reserves!");
			}
		}	
	}
	if (message == 7745472 && Is_OnLine() && !ChangingState)
	{// Self Destruct key pressed
		Commands->Set_Model(obj,"rp2madcatc");
		Commands->Set_Animation(obj,"rp2madcatc.rp2madcatc",false,0,0,0,true);
		ChangingState = true;
		Eva_Talk(obj,"Mech_SelfDestruct",2.99f,SelfDestruct,"Computer: Self destruct sequence initiated.");
	}
	if (message == 35432168 && Is_OnLine() && !ChangingState && JetFuel)
	{// Spacebar Toggles JumpJets
		if (!JumpJetsOn)
		{
			JumpJetsOn = true;
			Commands->Set_Model(obj,Get_Model(obj));
			Commands->Set_Animation(obj,LastMoveAnimation,false,0,Get_Animation_Frame(obj),0,true);
			Vector3 Pos = Commands->Get_Position(obj);
			GameObject *object2 = Commands->Find_Object(TempID);
			if (!object2)
			{
				object2 = Commands->Create_Object("Daves Arrow",Pos);
				Commands->Attach_To_Object_Bone(object2,obj,"HoverPlate");
				Commands->Set_Model(object2,"GSCEC");
				TempID = Commands->Get_ID(object2);
			}
			Pos.Z -= 1.0f;
			GameObject *object3 = Commands->Find_Object(TempID2);
			if (!object3)
			{
				object3 = Commands->Create_Object("Daves Arrow",Pos);
				Commands->Attach_To_Object_Bone(object3,obj,"HoverPlate");
				Commands->Set_Model(object3,"GSCECS");
				TempID2 = Commands->Get_ID(object3);
			}
			Commands->Create_Sound("Scud_Launcher_Fire",Commands->Get_Position(obj),obj);
			Commands->Create_Explosion("Explosion_Panther_Flamethrower",Pos,obj);
			GameObject *object = Commands->Find_Object(Hover_Plate_ID);
			if (object)
			{// Turn the collision plate on
				Commands->Set_Model(object,"MCHoverPlate");
			}
		}
		else
		{
			JumpJetsOn = false;
			GameObject *object = Commands->Find_Object(Hover_Plate_ID);
			Commands->Set_Animation(obj,"rp2madcat.rp2madcat",false,0,0,0,true);
			if (object)
			{// Turn the collision plate off
				Commands->Set_Model(object,"null");
			}
			object = Commands->Find_Object(TempID);
			if (object)
			{// Remove the fire, just leave the smoke
				Commands->Destroy_Object(object);
			}
		}
	}
	if (message == 9118115)
	{// Ammo explosion point fix
		Commands->Apply_Damage(obj,9999.9f,"BlamoKiller",sender);
	}
}

void JMG_RP2_Mech_MadCat::Animation_Complete(GameObject *obj,const char *anim)
{
	if (!_stricmp(anim,"rp2madcatc.rp2madcatc") && Is_OnLine())
	{
		Commands->Set_Model(obj,"rp2madcat");
		Commands->Set_Animation(obj,"rp2madcat.rp2madcat",false,0,0,0,true);
		Vector3 MyPos = Commands->Get_Position(obj);
		MyPos.Z += 6.362f;
		Commands->Set_Position(obj,MyPos);
	}
	/*if ((!_stricmp(anim,"rp2madcat.rp2madcatf") || !_stricmp(anim,"rp2madcat.rp2madcatb")) && Is_OnLine() && !JumpJetsOn)
	{
		if (WalkState == MForward)
		{
			sprintf(LastMoveAnimation,"rp2madcat.rp2madcatf");
			Commands->Set_Animation(obj,LastMoveAnimation,false,0,0,-1,true);
		}
		if (WalkState == MBackward)
		{
			sprintf(LastMoveAnimation,"rp2madcat.rp2madcatb");
			Commands->Set_Animation(obj,LastMoveAnimation,false,0,0,-1,true);
		}
		if (WalkState == MIdle)
		{
			sprintf(LastMoveAnimation,"rp2madcat.rp2madcatf");
			Commands->Set_Animation(obj,LastMoveAnimation,false,0,0,0,true);
		}
	}*/
}

void JMG_RP2_Mech_MadCat::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (Commands->Get_Health(obj) && Commands->Get_Health(obj) < 250.0f && damage)
	{
		if (Commands->Get_Random_Int(0,100) < 100*(damage/2500))
		{
			IAEDE = true;
			Eva_Talk(obj,"Mech_Internal_Ammo_Explosion",4.58f,MechState,"Computer: Internal Ammo Explosion Detected.");
			Commands->Send_Custom_Event(damager,obj,9118115,0,5.0f);
		}
	}
}

void JMG_RP2_Mech_MadCat::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *MyDriver = Get_Vehicle_Driver(obj);
	if (MyDriver)
	{// Kill the driver
		Commands->Set_Shield_Strength(MyDriver,0.0f);
		Commands->Set_Health(MyDriver,1.0f);
		Commands->Apply_Damage(MyDriver,9999.9f,"BlamoKiller",MyDriver);
	}
	GameObject *object = Commands->Find_Object(Hover_Plate_ID);
	if (object)
	{// Remove hoverplate collision
		Commands->Set_Model(object,"null");
	}
	object = Commands->Find_Object(TempID);
	if (object)
	{// Remove the fire, just leave the smoke
		Commands->Destroy_Object(object);
	}
	object = Commands->Find_Object(TempID2);
	if (object)
	{// Remove Cooldown smoke
		Commands->Destroy_Object(object);
	}
}

void JMG_RP2_Mech_MadCat::Eva_Talk(GameObject *obj,const char *VoiceFile,float PlayTime,MechStates GoToState,const char *TextMessage)
{
	GameObject *MyDriver = Get_Vehicle_Driver(obj);
	if (!PlayingVoice)
	{// Play the voice for the player
		if (MyDriver && Commands->Is_A_Star(MyDriver))
		{// Only play sound effects for humans
			Create_Sound_Player(MyDriver,VoiceFile,Commands->Get_Position(obj),obj);
			Send_Message_Player(MyDriver,0,127,255,TextMessage);
		}
		SetState = GoToState;
		Commands->Start_Timer(obj,this,PlayTime,987454);
	}
	else
	{// Add voice to the play list
		if (!VoiceFiles)
		{
			VoiceFiles = new Mech_Voice_Files;
			sprintf(VoiceFiles->EVAMessage,"%s",VoiceFile);
			VoiceFiles->VoiceTime = PlayTime;
			VoiceFiles->SetState = GoToState;
			sprintf(VoiceFiles->TextMessage,"%s",TextMessage);
			VoiceFiles->next = NULL;
		}
		else
		{
			Mech_Voice_Files *Current = VoiceFiles;
			while (!Current)
			{
				if (!Current->next)
				{
					Current->next = new Mech_Voice_Files;
					Current = Current->next;
					sprintf(Current->EVAMessage,"%s",VoiceFile);
					Current->VoiceTime = PlayTime;
					Current->SetState = GoToState;
					sprintf(Current->TextMessage,"%s",TextMessage);
					Current->next = NULL;
				}
			}
		}
	}
	PlayingVoice = true;
}

bool JMG_RP2_Mech_MadCat::Is_OnLine()
{
	if (MechState == ShutDown || MechState == PoweringUp || MechState == OverHeatShutDown || MechState == SelfDestruct)
	{
		return false;
	}
	return true;
}

void JMG_RP2_Mech_MadCat::Mech_ShutDown(GameObject *obj)
{
	JumpJetsOn = false;
	GameObject *object = Commands->Find_Object(Hover_Plate_ID);
	if (object)
	{// Remove hoverplate collision
		Commands->Set_Model(object,"null");
	}
	object = Commands->Find_Object(TempID);
	if (object)
	{// Remove the fire, just leave the smoke
		Commands->Destroy_Object(object);
	}
	Commands->Set_Model(obj,"rp2madcatc");
	Commands->Set_Animation(obj,"rp2madcatc.rp2madcatc",false,0,0,40,true);
	for (int x = 1;x < 128;x++)
	{
		GameObject *Player = Get_GameObj(x);
		Set_Obj_Radar_Blip_Shape_Player(Player,obj,RADAR_BLIP_SHAPE_NONE);
	}
	GameObject *MyDriver = Get_Vehicle_Driver(obj);
	if (MyDriver && Commands->Is_A_Star(MyDriver))
	{
		Enable_Radar_Player(MyDriver,false);
	}
}

void JMG_RP2_Mech_MadCat::Mech_StartUp(GameObject *obj)
{
	Commands->Set_Animation(obj,"rp2madcatc.rp2madcatc",false,0,40,0,true);
	for (int x = 1;x < 128;x++)
	{
		GameObject *Player = Get_GameObj(x);
		Set_Obj_Radar_Blip_Shape_Player(Player,obj,RADAR_BLIP_SHAPE_VEHICLE);
	}
	GameObject *MyDriver = Get_Vehicle_Driver(obj);
	if (MyDriver && Commands->Is_A_Star(MyDriver))
	{
		Enable_Radar_Player(MyDriver,true);
	}
}

bool JMG_RP2_Mech_MadCat::Eject_Pilot(GameObject *obj)
{
	if (!Is_OnLine() || !_stricmp(Get_Model(obj),"rp2madcatc"))
	{
		return false;
	}
	GameObject *MyDriver = Get_Vehicle_Driver(obj);
	if (MyDriver)
	{
		GameObject *EjectAnim = Commands->Create_Object("Invisible_Box_FR",Vector3(0.0f,0.0f,0.0f));
		Commands->Attach_To_Object_Bone(EjectAnim,obj,"Seat0");
		Commands->Set_Model(EjectAnim,"MadCatEject");
		PhysicalGameObj *objphys = ((ScriptableGameObj *)EjectAnim)->As_PhysicalGameObj();
		if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false) || Is_In_Water)
		{
			if (Commands->Is_A_Star(MyDriver))
			{
				Play_UI_SFX(obj,"Mech_Mask_Failure");
				if (Is_In_Water)
				{
					Send_Message_Player(MyDriver,0,127,255,"Warning: Cannot eject under water, eject failed!");
				}
				else
				{
					Send_Message_Player(MyDriver,0,127,255,"Warning: Eject path blocked by object, eject failed!");
				}
			}
			Commands->Destroy_Object(EjectAnim);
			return true;
		}
		else
		{
			ChangingState = true;
			Commands->Create_Explosion("Ground_Explosions_Twiddler",Commands->Get_Bone_Position(obj,"Eject"),0);
			Commands->Disable_All_Collisions(EjectAnim);
			Play_UI_SFX(obj,"Mech_Pilot_Eject");
			Force_Occupant_Exit(obj,0);
			Commands->Attach_To_Object_Bone(MyDriver,EjectAnim,"Eject");
			Commands->Attach_To_Object_Bone(EjectAnim,EjectAnim,"Origin");
			Commands->Attach_Script(EjectAnim,"JMG_Play_Animation_On_Create_The_Destroy","MadCatEject.MadCatEject,60.0,0");
			Commands->Attach_Script(MyDriver,"JMG_RP2_WLS_Grant_Weapon_Special","Weapon_Parachute,-2");
		}
	}
	return true;
}

void JMG_RP2_Mech_MadCat::Play_UI_SFX(GameObject *obj,const char *SoundFile)
{
	GameObject *MyDriver = Get_Vehicle_Driver(obj);
	if (MyDriver && Commands->Is_A_Star(MyDriver))
	{// Only play sound effects for humans
		Create_Sound_Player(MyDriver,SoundFile,Commands->Get_Position(obj),obj);
	}
}

void JMG_RP2_Mech_MadCat::Mech_Animation(GameObject *obj)
{
	char animation[512];
	sprintf(animation,"%s.%s",Get_Model(obj),Get_Model(obj));
	Vector3 mechposition = Commands->Get_Position(obj);
	float facing = Commands->Get_Facing(obj);
	float distance = Commands->Get_Distance(Commands->Get_Position(obj),LastPos);
	MechMovement TWalkState = WalkState;
	if (distance > 0.5)	
	{
		float xpos = LastPos.X;
		float ypos = LastPos.Y;
		float xdist = mechposition.X - xpos;
		float ydist = mechposition.Y - ypos;
		if (facing > -45 && facing < 45)
		{
			if (xdist > ydist)
			{
				TWalkState = MForward;
			}
			else if (ydist > xdist)
			{
				TWalkState = MBackward;
			}
		}
		if (facing < -45 && facing > -135)
		{
			if (xdist > ydist)
			{
				TWalkState = MForward;
			}
			else if (ydist > xdist)
			{
				TWalkState = MBackward;
			}
		}
		if (facing < -135 || facing > 135)
		{
			if (xdist < ydist)
			{
				TWalkState = MForward;
			}
			else if (ydist < xdist)
			{
				TWalkState = MBackward;
			}
		}
		if (facing < 135 && facing > 45)
		{
			if (xdist < ydist)
			{
				TWalkState = MForward;
			}
			else if (ydist < xdist)
			{
				TWalkState = MBackward;
			}
		}
	}
	else if (facing - OldFacing > 2.5 || facing - OldFacing < -2.5)
	{
		TWalkState = MForward;
	}
	else
	{
		TWalkState = MIdle;
	}
	if (JumpJetsOn)
	{
		TWalkState = MIdle;
	}
	LastPos = Commands->Get_Position(obj);
	OldFacing = facing;
	if (_stricmp(Get_Model(obj),"rp2madcatc"))
	{
		if (TWalkState != WalkState)
		{
			if (TWalkState == MForward)
			{
				Commands->Set_Animation(obj,"rp2madcat.rp2madcatf",true,0,0,-1,true);
			}
			if (TWalkState == MBackward)
			{
				Commands->Set_Animation(obj,"rp2madcat.rp2madcatb",true,0,0,-1,true);
			}
			if (TWalkState == MIdle)
			{
				if (WalkState == MForward)
				{
					Commands->Set_Animation(obj,"rp2madcat.rp2madcatf",false,0,Get_Animation_Frame(obj),40.0f,true);
				}
				else
				{
					Commands->Set_Animation(obj,"rp2madcat.rp2madcatb",false,0,Get_Animation_Frame(obj),40.0f,true);
				}
			}
		}
	}
	else
	{
		TWalkState = MCrouch;
	}
	WalkState = TWalkState;
}

void JMG_Play_Animation_On_Create_The_Destroy::Created(GameObject *obj)
{
	Commands->Set_Animation(obj,Get_Parameter("Animation"),true,0,0,Get_Float_Parameter("LastFrame"),0);
}

void JMG_Play_Animation_On_Create_The_Destroy::Animation_Complete(GameObject *obj,const char *anim)
{
	if (!_stricmp(anim,Get_Parameter("Animation")))
	{
		if (Get_Int_Parameter("DestroyOrKill"))
		{
			Commands->Apply_Damage(obj,9999.9f,"BlamoKiller",0);
		}
		else
		{
			Commands->Destroy_Object(obj);
		}
	}
}

void JMG_RP2_Ambulance_Zone::Entered(GameObject *obj,GameObject *enter)
{
	GameObject *Ambulance = Commands->Find_Object(Get_Int_Parameter("AmbulanceID"));
	if (Ambulance && Commands->Is_A_Star(enter))
	{
		Commands->Send_Custom_Event(Ambulance,enter,9119111,0,0.0f);
	}
}

void JMG_RP2_Ambulance_Zone::Exited(GameObject *obj,GameObject *exiter)
{
	if (Commands->Is_A_Star(exiter))
	{
		Commands->Send_Custom_Event(obj,exiter,9119110,Get_Int_Parameter("AmbulanceID"),0.0f);
	}
}

void JMG_RP2_Ambulance::Created(GameObject *obj)
{
	SirenID = 0;
	siren = 0;
	Commands->Start_Timer(obj,this,0.25f,4352154);
}

void JMG_RP2_Ambulance::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7154148)
	{
		Send_Message_Player(sender,200,200,125,"Vehicle Special Key:");
		Send_Message_Player(sender,200,200,125,"Right Click - Cycle through siren modes");
	}
	if (message == 98562146)
	{
		if (SirenID > 0)
		{
			GameObject *Siren = Commands->Find_Object(SirenID);
			if (Siren)
			{
				Commands->Destroy_Object(Siren);
			}
			SirenID = 0;
		}
		if (siren == 0)
		{
			siren = 1;
			Vector3 pos;
			char params[20];
			sprintf(params,"%d",Commands->Get_ID(obj));
			GameObject *siren = Commands->Create_Object("Daves Arrow",pos);
			Commands->Attach_To_Object_Bone(siren,obj,"origin");	
			Commands->Set_Model(siren,"PoliceCarSiren1");
			SirenID = Commands->Get_ID(siren);
			Commands->Attach_Script(siren,"JMG_Remove_Object_When_Creator_Destroyed",params);
		}
		else if (siren == 1)
		{
			siren = 2;
			Vector3 pos;
			char params[20];
			sprintf(params,"%d",Commands->Get_ID(obj));
			GameObject *siren = Commands->Create_Object("Daves Arrow",pos);
			Commands->Attach_To_Object_Bone(siren,obj,"origin");	
			Commands->Set_Model(siren,"PoliceCarSiren2");
			SirenID = Commands->Get_ID(siren);
			Commands->Attach_Script(siren,"JMG_Remove_Object_When_Creator_Destroyed",params);
		}
		else if (siren == 2)
		{
			siren = 0;
		}
	}
}

void JMG_RP2_Ambulance::Timer_Expired(GameObject *obj,int number)
{
	if (number == 4352154)
	{
		LastPos = Commands->Get_Position(obj);
		MyZoneBox1 = SetupAZoneBox(obj,MyZoneBox1,138044,&ReEnterZoneID1);
		MyZoneBox2 = SetupAZoneBox(obj,MyZoneBox2,138045,&ReEnterZoneID2);
		Commands->Start_Timer(obj,this,0.25f,4352153);
	}
	if (number == 4352153)
	{// Move the zones to the ambulance
		Vector3 Pos = Commands->Get_Position(obj);
		if (Commands->Get_Distance(Pos,LastPos) < 5)
		{
			Vector3 TargetSpot = Commands->Get_Bone_Position(obj,"Origin");
			GameObject *TheZone = Commands->Find_Object(ReEnterZoneID1);
			if (TheZone)
			{
				MyZoneBox1->Center = TargetSpot;
				Set_Zone_Box(TheZone,*MyZoneBox1);
			}
			TheZone = Commands->Find_Object(ReEnterZoneID2);
			if (TheZone)
			{
				MyZoneBox2->Center = TargetSpot;
				Set_Zone_Box(TheZone,*MyZoneBox2);
			}
		}
		else
		{// Move the zones away from the ambulance
			Vector3 TargetSpot = Vector3(1000.0f,1000.0f,1000.0f);
			GameObject *TheZone = Commands->Find_Object(ReEnterZoneID1);
			if (TheZone)
			{
				MyZoneBox1->Center = TargetSpot;
				Set_Zone_Box(TheZone,*MyZoneBox1);
			}
			TheZone = Commands->Find_Object(ReEnterZoneID2);
			if (TheZone)
			{
				MyZoneBox2->Center = TargetSpot;
				Set_Zone_Box(TheZone,*MyZoneBox2);
			}
		}
		LastPos = Pos;
		Commands->Start_Timer(obj,this,1.0f,4352153);
	}
}

void JMG_RP2_Ambulance::Killed(GameObject *obj, GameObject *damager)
{
	Vector3 TargetSpot = Vector3(1000.0f,1000.0f,1000.0f);
	GameObject *TheZone = Commands->Find_Object(ReEnterZoneID1);
	if (TheZone)
	{
		MyZoneBox1->Center = TargetSpot;
		Set_Zone_Box(TheZone,*MyZoneBox1);
		Commands->Attach_Script(TheZone,"JMG_Remove_Self_On_Timer","1.0");
	}
	TheZone = Commands->Find_Object(ReEnterZoneID2);
	if (TheZone)
	{
		MyZoneBox2->Center = TargetSpot;
		Set_Zone_Box(TheZone,*MyZoneBox2);
		Commands->Attach_Script(TheZone,"JMG_Remove_Self_On_Timer","1.0");
	}
	if (MyZoneBox1)
	{
		delete MyZoneBox1;
	}
	if (MyZoneBox2)
	{
		delete MyZoneBox2;
	}
}

OBBoxClass *JMG_RP2_Ambulance::SetupAZoneBox(GameObject *obj,OBBoxClass *TheBox,int ZoneRipID,int *ReEnterZoneID)
{
	char params[128];
	sprintf(params,"%d",Commands->Get_ID(obj));
	TheBox = new OBBoxClass;
	OBBoxClass *OtherBox = Get_Zone_Box(Commands->Find_Object(ZoneRipID));
	for (int x = 0;x < 3 && OtherBox;x++)
	{
		for (int y = 0;y < 3;y++)
		{
			TheBox->Basis[x][y] = OtherBox->Basis[x][y];
		}
	}
	TheBox->Center = Commands->Get_Bone_Position(obj,"Origin");
	TheBox->Extent.X = 15.0f;
	TheBox->Extent.Y = 15.0f;
	TheBox->Extent.Z = 15.0f;
	GameObject *ReEnterZone = Create_Zone("Script_Zone_All",*TheBox);
	Attach_Script_Once(ReEnterZone,"JMG_RP2_Ambulance_Zone",params);
	*ReEnterZoneID = Commands->Get_ID(ReEnterZone);
	return TheBox;
}

void JMG_Buy_Preset_On_Poke_Advanced::Created(GameObject *obj)
{
	enabled = true;
}

void JMG_Buy_Preset_On_Poke_Advanced::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(poker)])
		{
			Send_Message_Player(obj,150,0,0,"You must spawn before you can buy this...");
		}
		else
		{
			if (CheckPlayerType(poker,Get_Int_Parameter("Player_Type")))
			{
				return;
			}
			if (enabled)
			{
				float cost = (float)Get_Int_Parameter("Cost");
				if (cost <= Commands->Get_Money(poker))
				{
					enabled = false;
					if (Get_Int_Parameter("DeathZoneID"))
					{
						GameObject *Zone = Commands->Find_Object(Get_Int_Parameter("DeathZoneID"));
						Damage_All_Objects_In_Zone(Zone,999999.9f,"None",0);
					}
					Commands->Give_Money(poker,-1*cost,0);
					GameObject *newpreset = Commands->Create_Object(Get_Parameter("Preset"),Get_Vector3_Parameter("Location"));
					Commands->Set_Facing(newpreset,Get_Float_Parameter("Facing"));
					Commands->Create_Sound(Get_Parameter("BuySound"),Commands->Get_Position(poker),poker);
					Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
					RTeleportCall(poker,Commands->Find_Object(Get_Int_Parameter("TeleportTargetID")));
					if (Get_Int_Parameter("DestroyOnBuy"))
					{
						Commands->Destroy_Object(obj);
					}
				}
				else
				{
					Commands->Create_Sound(Get_Parameter("InadequateFundsSound"),Commands->Get_Position(poker),poker);
				}
			}
		}
	}
}

void JMG_Buy_Preset_On_Poke_Advanced::Timer_Expired(GameObject *obj,int number)
{
	if (Get_Int_Parameter("TimerNum") == number)
	{
		enabled = true;
	}
}

void JMG_Buy_Preset_On_Poke_Advanced::RTeleportCall(GameObject *obj,GameObject *TargetSpot)
{
	if (!TargetSpot)
	{
		return;
	}
	Vector3 Pos = Commands->Get_Position(TargetSpot);
	Vector3 ExitPos = Pos;
	float Facing = Commands->Get_Facing(TargetSpot);
	PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
	objphys->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass()->Find_Teleport_Location(Pos,1.0f,&ExitPos);
	Commands->Set_Position(obj,ExitPos);
	Vector3 pos = Commands->Get_Bone_Position(obj,"c head");
	pos.X += 20.0f*(cos(Facing*PI180));
	pos.Y += 20.0f*(sin(Facing*PI180));
	GameObject *object = Commands->Create_Object("Daves Arrow",pos);
	Commands->Set_Model(object,"null");
	Force_Camera_Look_Player(obj,pos);
	Commands->Send_Custom_Event(obj,obj,70451564,Commands->Get_ID(object),0.1f);
}


void JMG_RP2_PT_Poke_Grant_Powerup_Death::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(poker)])
		{
			Send_Message_Player(obj,150,0,0,"You must spawn before you can buy this...");
			return;
		}
		float cost = (float)Get_Int_Parameter("Cost");
		if (cost <= Commands->Get_Money(poker))
		{
			Commands->Give_Money(poker,-1*cost,0);
			Commands->Give_PowerUp(poker,Get_Parameter("Powerup_Name"),true);
			Commands->Create_Sound(Get_Parameter("BuySound"),Commands->Get_Position(poker),poker);
			Commands->Destroy_Object(obj);
		}
		else
		{
			Commands->Create_Sound(Get_Parameter("InadequateFundsSound"),Commands->Get_Position(poker),poker);
		}
	}
}

void JMG_RP2_Vehicle_Fire_Override::Created(GameObject *obj)
{
}

void JMG_RP2_Invulnerable_Until_Custom_Received::Created(GameObject *obj)
{
	sprintf(HealthType,"%s",Get_Skin(obj));
	sprintf(ArmorType,"%s",Get_Shield_Type(obj));
	Set_Skin(obj,"Blamo");
	Commands->Set_Shield_Type(obj,"Blamo");
}

void JMG_RP2_Invulnerable_Until_Custom_Received::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		Set_Skin(obj,HealthType);
		Commands->Set_Shield_Type(obj,ArmorType);
	}
}

void JMG_Send_Self_Custom_On_Create::Created(GameObject *obj)
{
	Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Message"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
}

void JMG_RP2_Enable_Collisions_When_Safe::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.1f,1453453);
}

void JMG_RP2_Enable_Collisions_When_Safe::Timer_Expired(GameObject *obj,int number)
{
	if (1453453 == number)
	{
		if (!obj->As_PhysicalGameObj() && Is_Script_Attached(obj,"JMG_RP2_Enable_Collisions_When_Safe"))
		{
			Remove_Script(obj,"JMG_RP2_Enable_Collisions_When_Safe");
			return;
		}
		PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
		Commands->Enable_Collisions(obj);
		if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
		{// Failed, try again
			Commands->Disable_All_Collisions(obj);
			Commands->Start_Timer(obj,this,0.1f,1453453);
		}
		else if (Is_Script_Attached(obj,"JMG_RP2_Enable_Collisions_When_Safe"))
		{// Successful, remove script
			Remove_Script(obj,"JMG_RP2_Enable_Collisions_When_Safe");
		}
	}
}

void JMG_RP2_Plasma_Torpedo_Launcher::Created(GameObject *obj)
{
	ClickedTimes = 0;
	ResetTime = 0.0f;
	LastAmmoCount = Get_Total_Bullets(obj,"Weapon_Plasma_Torpedo_Launcher");
	Commands->Start_Timer(obj,this,0.1f,987452);
}

void JMG_RP2_Plasma_Torpedo_Launcher::Timer_Expired(GameObject *obj, int number)
{
	if (number == 987452)
	{
		int AmmoCount = Get_Total_Bullets(obj,"Weapon_Plasma_Torpedo_Launcher");
		if (Has_Weapon(obj,"Weapon_Plasma_Torpedo_Launcher"))
		{
			if (AmmoCount < LastAmmoCount && ClickedTimes > 1)
			{// Weapon Fired
				float Damage = (ClickedTimes-1)*25.0f;
				if (Commands->Get_Health(obj)+Commands->Get_Shield_Strength(obj) <= Damage)
				{
					char Text[237];
					if (Get_Sex(obj) == 'B')
					{
						const char *str = Get_Player_Name(obj);
						sprintf(Text,"%s overloaded her Plasma Torpedo Launcher and has died as a result.",str);
						delete[] str;
					}
					else
					{
						const char *str = Get_Player_Name(obj);
						sprintf(Text,"%s overloaded his Plasma Torpedo Launcher and has died as a result.",str);
						delete[] str;
					}
					RP2_Player_Death_Message_Control(obj,Text,0);
				}
				Commands->Apply_Damage(obj,Damage,"None",obj);
				ClickedTimes = 0;
			}
			else if (AmmoCount < LastAmmoCount && !HasLeftClickedBefore)
			{// Player is cheating, or server is under a lot of lag
				if (Commands->Get_Health(obj)+Commands->Get_Shield_Strength(obj) <= 200.0f)
				{
					char Text[237];
					const char *str = Get_Player_Name(obj);
					sprintf(Text,"%s died from a Plasma Torpedo Launcher malfunction.",str);
					delete[] str;
					RP2_Player_Death_Message_Control(obj,Text,0);
				}
				Commands->Apply_Damage(obj,200.0f,"None",obj);
				ClickedTimes = 0;
			}
		}
		LastAmmoCount = AmmoCount;
		bool StillCounting = true;
		if (ResetTime <= 0.0f)
		{
			StillCounting = false;
		}
		ResetTime -= 0.1f;
		if (ResetTime <= 0.0f)
		{
			if (StillCounting && ClickedTimes && Has_Weapon(obj,"Weapon_Plasma_Torpedo_Launcher"))
			{
				Send_Message_Player(obj,200,200,125,"Plasma Torpedo Launcher's capacitors have discharged.");
			}
			ClickedTimes = 0;
		}
		Commands->Start_Timer(obj,this,0.1f,987452);
	}
}

void JMG_RP2_Plasma_Torpedo_Launcher::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 21511235 && !Get_Vehicle(obj))
	{
		HasLeftClickedBefore = true;
		const char *Weapon = Get_Current_Weapon(obj);
		if (Weapon)
		{
			if (!_stricmp(Weapon,"Weapon_Plasma_Torpedo_Launcher"))
			{
				ClickedTimes++;
				ResetTime = 2.7f;
			}
		}
	}
}

void JMG_RP2_Console_Command_On_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		Console_Input(Get_Parameter("Console_Command"));
	}
}

void JMG_RP2_Phone_Grant_Random_Weapon::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		Vector3 Pos = Commands->Get_Position(Get_GameObj(param));
		Pos.Z += 1.25f;
		Create_Random_Powerup_At_Location(Pos,0.0f);
	}
}

void JMG_RP2_Vehicle_Ignore_EMP::Created(GameObject *obj)
{
}

void JMG_RP2_Jet::Created(GameObject *obj)
{
	AlarmPlaying = false;
	EngineEnabled = false;
	EngineFailed = false;
	AllowCrash = true;
	AllowCrash2 = true;
	BlockOn = false;
	MyNode = NULL;
	InZone = false;
	Warning = 0;
	InFlight = false;
	Collides = false;
	Commands->Set_Animation(obj,"v_harrier.v_harrier",false,0,0,0,false);
	GameObject *Blocker = Commands->Create_Object("Daves Arrow",Commands->Get_Position(obj));
	Commands->Set_Model(Blocker,"null");
	Commands->Attach_To_Object_Bone(Blocker,obj,"Block1");
	MoverID = Commands->Get_ID(Blocker);
	Commands->Start_Timer(obj,this,0.1f,987452);
	Commands->Start_Timer(obj,this,2.5f,987453);
	Commands->Start_Timer(obj,this,2.5f,987454);
	Commands->Start_Timer(obj,this,2.5f,987458);
}

void JMG_RP2_Jet::Timer_Expired(GameObject *obj, int number)
{
	if (number == 987452)
	{
		CalculateAnimation(obj);
		Vector3 MyPos = Commands->Get_Position(obj);
		Vector3 OriginalPos = MyPos;
		PhysicalGameObj *objphys = obj->As_PhysicalGameObj();
		int MaxGroundSafty = 1;
		if (MyNode->MPH < 25)
		{
			MaxGroundSafty = 3;
		}
		if (MyNode->MPH < 50)
		{
			MaxGroundSafty = 2;
		}
		Collides = false;
		for (int x = 0;x < 3 && !Collides;x++)
		{
			MyPos.Z -= 2.2f;
			Commands->Set_Position(obj,MyPos);
			if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
			{
				Collides = true;
			}
		}
		if (!Collides)
		{// see if its high enough off the ground to be albe to move forward automatically/fall out of the sky
			InFlight = true;
			if (MyNode)
			{
				if (Warning > 0){Warning--;}
				else{Warning = 0;}
				if (MyNode->MPH < 50)
				{
					EngineEnabled = false;
					Commands->Enable_Engine(obj,false);
					EngineFailed = true;
					if (BlockOn)
					{
						GameObject *Blocker = Commands->Find_Object(MoverID);
						if (Blocker){Commands->Set_Model(Blocker,"null");BlockOn = false;}
					}
				}
				else if (MyNode->MPH < 100)
				{
					if (!Warning)
					{
						Warning = 600;
						GameObject *MyDriver = Get_Vehicle_Driver(obj);
						if (MyDriver && Commands->Is_A_Star(MyDriver))
						{
							if (!AlarmPlaying)
							{
								AlarmPlaying = true;
								Create_Sound_Player(MyDriver,"Harrier_Engine_Alarm",Commands->Get_Position(obj),obj);
								Commands->Start_Timer(obj,this,2.48f,987459);
							}
							Send_Message_Player(MyDriver,127,0,0,"Warning: Increase Speed!");
						}
					}
				}
				if (MyNode->MPH > 100 && Get_Vehicle_Occupant_Count(obj))
				{
					Warning = 0;
					EngineFailed = false;
					if (!EngineEnabled)
					{
						EngineEnabled = true;
						Commands->Enable_Engine(obj,true);
					}
					if (!BlockOn)
					{
						GameObject *Blocker = Commands->Find_Object(MoverID);
						if (Blocker){Commands->Set_Model(Blocker,"HarrierBlock");BlockOn = true;}
					}
				}
			}
		}
		else if (InFlight && Collides)
		{
			InFlight = false;
			if (EngineFailed && AllowCrash2)
			{
				AllowCrash2 = false;
				if (MyNode->MPH >= 95){Commands->Apply_Damage(obj,9999.9f,"BlamoKiller",obj);}
				else{Commands->Apply_Damage(obj,(MyNode->MPH/95*(Commands->Get_Max_Health(obj)+Commands->Get_Max_Shield_Strength(obj))),"None",obj);}
				Commands->Create_Sound("vehicle_collide_01",Commands->Get_Position(obj),obj);
			}
			if (Get_Vehicle_Occupant_Count(obj) && !EngineEnabled)
			{
				AllowCrash2 = true;
				EngineEnabled = true;
				Commands->Enable_Engine(obj,true);
			}
			GameObject *Blocker = Commands->Find_Object(MoverID);
			if (Blocker){Commands->Set_Model(Blocker,"null");BlockOn = false;}
		}
		if (MyNode && MyNode->MPH > 50)
		{
			MyPos = OriginalPos;
			float Facing = Commands->Get_Facing(obj);
			float PositionOffset = (MyNode->MPH/900.0f)*15.0f;
			MyPos.X += cos(Facing*PI180) * PositionOffset;
			MyPos.Y += sin(Facing*PI180) * PositionOffset;
			Commands->Set_Position(obj,MyPos);
			if (!objphys->Peek_Physical_Object()->As_MoveablePhysClass()->Can_Teleport(objphys->Get_Transform(),false))
			{
				if (AllowCrash)
				{
					AllowCrash = false;
					Commands->Apply_Damage(obj,((Commands->Get_Max_Health(obj)+Commands->Get_Max_Shield_Strength(obj))*0.1f),"None",obj);
					Commands->Create_Sound("vehicle_collide_01",Commands->Get_Position(obj),obj);
				}
			}
			else{AllowCrash = true;}
		}
		Commands->Set_Position(obj,OriginalPos);
		Commands->Start_Timer(obj,this,0.1f,987452);
	}
	if (number == 987453)
	{
		if (InZone)
		{
			Set_Current_Clip_Bullets(obj,Get_Current_Bullets(obj)+300);
			if (Get_Current_Total_Bullets(obj) >= 1800){Set_Current_Clip_Bullets(obj,1800);}
			if (Commands->Get_Health(obj) < Commands->Get_Max_Health(obj))
			{
				Commands->Set_Health(obj,Commands->Get_Health(obj)+1.0f);
			}
			if (Commands->Get_Health(obj) >= Commands->Get_Max_Health(obj))
			{
				Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
			}
		}
		Commands->Start_Timer(obj,this,0.1f,987453);
	}
	if (number == 987454)
	{
		Set_Current_Clip_Bullets(obj,Get_Current_Bullets(obj)+300);
		if (Get_Current_Total_Bullets(obj) >= 1800){Set_Current_Clip_Bullets(obj,1800);}
		Commands->Start_Timer(obj,this,3.0f,987454);
	}
	if (number == 987458)
	{
		CalculateAnimation(obj);
		if (!MyNode){MyNode = Get_Vehicle_Node(obj);}
		Commands->Start_Timer(obj,this,2.5f,987458);
	}
	if (number == 987459)
	{
		if (MyNode)
		{
			if (MyNode->MPH < 100 && !Collides)
			{
				GameObject *MyDriver = Get_Vehicle_Driver(obj);
				if (MyDriver && Commands->Is_A_Star(MyDriver))
				{
					Create_Sound_Player(MyDriver,"Harrier_Engine_Alarm",Commands->Get_Position(obj),obj);
				}
				Commands->Start_Timer(obj,this,2.48f,987459);
				return;
			}
		}
		AlarmPlaying = false;
	}
}

void JMG_RP2_Jet::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 543412)
	{//HarrierBlock
		if (param)
		{
			InZone = true;
		}
		else
		{
			InZone = false;
		}
	}
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		EngineEnabled = false;
		GameObject *Blocker = Commands->Find_Object(MoverID);
		if (Blocker){Commands->Set_Model(Blocker,"null");BlockOn = false;}
	}
}

void JMG_RP2_Jet::CalculateAnimation(GameObject *obj)
{
	int CurrentAmmo = Get_Current_Total_Bullets(obj);
	int AnimationFrame;
	if (!CurrentAmmo)
	{
		AnimationFrame = 6;
	}
	else
	{
		AnimationFrame = (int)(7-6.0f*(Get_Current_Total_Bullets(obj)/1800.0f));
	}
	Commands->Set_Animation(obj,"v_harrier.v_harrier",false,0,(float)AnimationFrame,(float)AnimationFrame,false);
}

void JMG_RP2_Jet_Reload_Zone::Entered(GameObject *obj,GameObject *enter)
{
	if ((enter->As_PhysicalGameObj() && enter->As_PhysicalGameObj()->Peek_Physical_Object() && enter->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
	{
		Commands->Send_Custom_Event(obj,enter,543412,1,0.0f);
	}
}

void JMG_RP2_Jet_Reload_Zone::Exited(GameObject *obj,GameObject *exiter)
{
	if ((exiter->As_PhysicalGameObj() && exiter->As_PhysicalGameObj()->Peek_Physical_Object() && exiter->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
	{
		Commands->Send_Custom_Event(obj,exiter,543412,0,0.0f);
	}
}

void JMG_Create_Powerup_At_Vehicle_Owner_Position::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.25,987);
}

void JMG_Create_Powerup_At_Vehicle_Owner_Position::Timer_Expired(GameObject *obj,int number)
{
	GameObject *owner = Get_Vehicle_Owner(obj);
	if (number == 987 && Commands->Get_ID(owner) > 0)
	{
		if (Commands->Get_Money(owner) >= Get_Float_Parameter("Cost"))
		{
			Commands->Give_Money(owner,-Get_Float_Parameter("Cost"),0);
			Commands->Create_Object(Get_Parameter("Powerup"),Commands->Get_Position(owner));
			Commands->Set_Position(owner,Commands->Get_Position(owner));
		}
		else
		{
			char text[2000];
			sprintf(text,"This item costs $%.2f, I need another $%.2f to buy this item.",Get_Float_Parameter("Cost"),Get_Float_Parameter("Cost") - Commands->Get_Money(owner));
			Send_Message_Player(owner,127,0,0,text);
		}
		Commands->Destroy_Object(obj);
	}
}

void JMG_RP2_Server_Remove_PTs_FPS_Improvement_Test::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == Get_Int_Parameter("Message"))
	{
		Console_Input("MESSAGE NOW REMOVING ALL PTs!");
		SLNode<BaseGameObj> *Current = GameObjManager::GameObjList.Head();
		while (Current)
		{
			GameObject *Object = Current->Data()->As_ScriptableGameObj();
			if (Object && Object != obj)
			{
				if (Is_Script_Attached(Object,"JMG_RP2_WLS_Buy_Weapon_Poker") || Is_Script_Attached(Object,"JMG_Buy_Preset_On_Poke"))
				{
					Commands->Destroy_Object(Object);
				}
			}
			Current = Current->Next();
		}
	}
}


void JMG_RP2_Simple_Smart_Base_Defense_Alarm::Created(GameObject *obj)
{
	for (int x = 0;x < 2;x++)
	{
		IDs[x].ID = 0;
		IDs[x].Time = 0;
	}
	AlarmPlaying = false;
	Commands->Start_Timer(obj,this,0.25f,987452);
}

void JMG_RP2_Simple_Smart_Base_Defense_Alarm::Timer_Expired(GameObject *obj, int number)
{
	if (number == 987452)
	{
		long int ID1 = GrabIDFromGrid(Get_Int_Parameter("Defense_Grid_1"));
		long int ID2 = GrabIDFromGrid(Get_Int_Parameter("Defense_Grid_2"));
		if (!AlarmPlaying && (ID1 || ID2))
		{
			AlarmPlaying = true;
			Commands->Create_Sound(Get_Parameter("Alarm_Sound"),Commands->Get_Position(obj),obj);
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Sound_Time"),987459);
		}
		if (UpdateRemoveIDTime(0,ID1) || UpdateRemoveIDTime(1,ID2)){}
		else if (ID1)
		{
			IDs[0].ID = ID1;
			IDs[0].Time = 0;
		}
		else if (ID2)
		{
			IDs[1].ID = ID2;
			IDs[1].Time = 0;
		}
		Commands->Start_Timer(obj,this,0.25f,987452);
	}
	if (number == 987459)
	{
		long int ID1 = GrabIDFromGrid(Get_Int_Parameter("Defense_Grid_1"));
		long int ID2 = GrabIDFromGrid(Get_Int_Parameter("Defense_Grid_2"));
		if (ID1 || ID2)
		{
			Commands->Create_Sound(Get_Parameter("Alarm_Sound"),Commands->Get_Position(obj),obj);
			Commands->Start_Timer(obj,this,Get_Float_Parameter("Sound_Time"),987459);
			return;
		}
		AlarmPlaying = false;
	}
}

long int JMG_RP2_Simple_Smart_Base_Defense_Alarm::GrabIDFromGrid(int Grid)
{
	if (JRP2SSBDGridTC[Grid])
	{
		for (int x = 0;x < 25;x++)
		{
			if (JRP2SSBDGrid[Grid][x] != 0)
			{
				return JRP2SSBDGrid[Grid][x];
			}
		}
	}
	return 0;
}

void JMG_RP2_Simple_Smart_Base_Defense_Alarm::RemoveIDFromGrid(long int ID)
{
	for (int x = 0;x < 25;x++)
	{
		if (JRP2SSBDGrid[Get_Int_Parameter("Defense_Grid_1")][x] == ID)
		{
			JRP2SSBDGrid[Get_Int_Parameter("Defense_Grid_1")][x] = 0;
		}
		if (JRP2SSBDGrid[Get_Int_Parameter("Defense_Grid_2")][x] == ID)
		{
			JRP2SSBDGrid[Get_Int_Parameter("Defense_Grid_2")][x] = 0;
		}
	}
}

bool JMG_RP2_Simple_Smart_Base_Defense_Alarm::UpdateRemoveIDTime(int WGID,long int ID)
{
	if (IDs[WGID].ID && ID && IDs[WGID].ID == ID)
	{
		IDs[WGID].Time++;
		if (IDs[WGID].Time > 60)
		{
			RemoveIDFromGrid(IDs[WGID].ID);
			IDs[WGID].ID = 0;
			IDs[WGID].Time = 0;
		}
		return true;
	}
	return false;
}

void JMG_RP2_Ammo_Crate_Control::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 789654)
	{
		if (Get_Vehicle(obj) || !Commands->Get_Health(obj)){return;}
		if (!Has_Weapon(obj,"Weapon_Ammo_Box"))
		{
			Send_Message_Player(obj,127,127,0,"You don't have an ammo box to pull ammo from.");
		}
		else if (!Get_Total_Bullets(obj,"Weapon_Ammo_Box"))
		{
			Send_Message_Player(obj,127,127,0,"Your ammo box is empty and therefore you cannot refil this weapon off of it.");
		}
		else
		{
			const char *MyWeapon = Get_Current_Weapon(obj);
			if (!MyWeapon)
			{
				Send_Message_Player(obj,127,127,0,"Error: Your holding no weapon, this is a BAD thing.");
				Commands->Destroy_Object(obj);
				return;
			}
			if (Get_Clip_Bullets(obj,MyWeapon) == -1)
			{
				Send_Message_Player(obj,127,127,0,"This iteam has no need for being refilled.");
				return;
			}
			RP2WeaponListControl *MyNode = Get_WLS_Weapon_Settings(MyWeapon);
			if (MyNode)
			{
				int WeaponType = MyNode->WeaponClass;
				if (WeaponType == BODY || WeaponType == PHONE || WeaponType == ITEM || WeaponType == SWORD || WeaponType == KNIFE || WeaponType == MISC)
				{
					Send_Message_Player(obj,127,127,0,"You cannot use your ammo crate to reload this weapon.");
				}
			}
			else
			{
				Send_Message_Player(obj,127,127,0,"ERROR: Weapon is not defined.");
				return;
			}
			TransferAmmoBetweenWeapons(obj,MyWeapon);
		}
	}
}

void JMG_RP2_Ammo_Crate_Control::TransferAmmoBetweenWeapons(GameObject *obj,const char *Weapon)
{// Get Ammo is current clip, set ammo is backpack clips
	const char *AmmoBox = "Weapon_Ammo_Box";
	float SingleBulletCost = (100.0f/(float)Get_Max_Clip_Bullets(obj,Weapon));
	SingleBulletCost = Weapon_Refill_Modifier(obj,Weapon,SingleBulletCost);
	float RefilBulletCost = SingleBulletCost*(Get_Max_Clip_Bullets(obj,Weapon) - Get_Clip_Bullets(obj,Weapon));
	if ((int)RefilBulletCost < 1.0)
	{
		RefilBulletCost = 1.0f;
	}
	int TotalAddedBullets;
	if ((int)RefilBulletCost <= Get_Total_Bullets(obj,AmmoBox))
	{
		Set_Bullets(obj,AmmoBox,Get_Bullets(obj,AmmoBox)-(int)RefilBulletCost);
		Set_Clip_Bullets(obj,Weapon,Get_Max_Clip_Bullets(obj,Weapon));
		TotalAddedBullets = (int)(RefilBulletCost/SingleBulletCost);
	}
	else
	{
		int RefilBullets = (int)(Get_Bullets(obj,AmmoBox)/SingleBulletCost);
		float NewBullets = Get_Bullets(obj,AmmoBox)-(RefilBullets*RefilBulletCost);
		if (NewBullets < 1)
		{
			NewBullets = 0.0f;
		}
		Set_Bullets(obj,AmmoBox,(int)NewBullets);
		Set_Clip_Bullets(obj,Weapon,Get_Clip_Bullets(obj,Weapon)+RefilBullets);
		TotalAddedBullets = RefilBullets;
	}
	char Message[125];
	sprintf(Message,"I pulled %d rounds from my ammo crate, it is now %.2f%c full.",TotalAddedBullets,((float)Get_Bullets(obj,AmmoBox)/(float)Get_Max_Bullets(obj,AmmoBox)),'%');
	Send_Message_Player(obj,127,127,0,Message);
}

void JMG_RP2_Train_Station::Entered(GameObject *obj,GameObject *enter)
{
	Commands->Send_Custom_Event(obj,enter,74414,1,0);
}

void JMG_RP2_Train_Station::Exited(GameObject *obj,GameObject *exit)
{
	Commands->Send_Custom_Event(obj,exit,74414,0,0);
}

void JMG_Buy_Preset_On_Poke_Hot_Air_Balloon::Created(GameObject *obj)
{
	enabled = true;
}

void JMG_Buy_Preset_On_Poke_Hot_Air_Balloon::Poked(GameObject *obj,GameObject *poker)
{
	if (Commands->Is_A_Star(poker))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(poker)])
		{
			Send_Message_Player(obj,150,0,0,"You must spawn before you can buy this...");
		}
		else
		{
			if (CheckPlayerType(poker,Get_Int_Parameter("Player_Type")))
			{
				return;
			}
			if (enabled)
			{
				float cost = (float)Get_Int_Parameter("Cost");
				if (cost <= Commands->Get_Money(poker))
				{
					enabled = false;
					if (Get_Int_Parameter("DeathZoneID"))
					{
						GameObject *Zone = Commands->Find_Object(Get_Int_Parameter("DeathZoneID"));
						Damage_All_Objects_In_Zone(Zone,999999.9f,"None",0);
					}
					Commands->Give_Money(poker,-1*cost,0);
					GameObject *newpreset = Commands->Create_Object(Get_Parameter("Preset"),Get_Vector3_Parameter("Location"));
					Commands->Set_Model(newpreset,Get_Parameter("SetModel"));
					Commands->Set_Facing(newpreset,Get_Float_Parameter("Facing"));
					Commands->Create_Sound(Get_Parameter("BuySound"),Commands->Get_Position(poker),poker);
					Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
				}
				else
				{
					Commands->Create_Sound(Get_Parameter("InadequateFundsSound"),Commands->Get_Position(poker),poker);
				}
			}
		}
	}
}

void JMG_Buy_Preset_On_Poke_Hot_Air_Balloon::Timer_Expired(GameObject *obj,int number)
{
	if (Get_Int_Parameter("TimerNum") == number)
	{
		enabled = true;
	}
}

void JMG_RP2_Change_Models_On_Custom::Created(GameObject *obj)
{
	ModelState = 1;
}

void JMG_RP2_Change_Models_On_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 10112142)
	{
		const char *Weapon = Get_Current_Weapon(obj);
		if (Weapon){if (!_stricmp(Weapon,"Weapon_Cell_Phone")){return;}}
		if (!ISNEWSWIMMING[Get_Player_ID(obj)] && Commands->Get_Health(obj) && !Get_Vehicle(obj))
		{
			ModelState--;
			if (!ModelState){ModelState = Get_Int_Parameter("Number_Of_Models");}
			Change_Model(obj);
		}
	}
	if (message == 10102142)
	{
		const char *Weapon = Get_Current_Weapon(obj);
		if (Weapon){if (!_stricmp(Weapon,"Weapon_Cell_Phone")){return;}}
		if (!ISNEWSWIMMING[Get_Player_ID(obj)] && Commands->Get_Health(obj) && !Get_Vehicle(obj))
		{
			ModelState++;
			if (ModelState > Get_Int_Parameter("Number_Of_Models")){ModelState = 1;}
			Change_Model(obj);
		}
	}
}

void JMG_RP2_Change_Models_On_Custom::Change_Model(GameObject *obj)
{
	switch (ModelState)
	{
	case 1:
		Commands->Set_Model(obj,Get_Parameter("Model_1"));
		break;
	case 2:
		Commands->Set_Model(obj,Get_Parameter("Model_2"));
		break;
	case 3:
		Commands->Set_Model(obj,Get_Parameter("Model_3"));
		break;
	case 4:
		Commands->Set_Model(obj,Get_Parameter("Model_4"));
		break;
	case 5:
		Commands->Set_Model(obj,Get_Parameter("Model_5"));
		break;
	case 6:
		Commands->Set_Model(obj,Get_Parameter("Model_6"));
		break;
	case 7:
		Commands->Set_Model(obj,Get_Parameter("Model_7"));
		break;
	case 8:
		Commands->Set_Model(obj,Get_Parameter("Model_8"));
		break;
	case 9:
		Commands->Set_Model(obj,Get_Parameter("Model_9"));
		break;
	case 10:
		Commands->Set_Model(obj,Get_Parameter("Model_10"));
		break;
	default:
		ModelState = 1;
		break;
	}
}

void JMG_RP2_Pull_Out_Phone_On_Keypress::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 331194043)
	{
		if (Get_Vehicle(obj)){return;}
		const char *Weapon = Get_Current_Weapon(obj);
		if (Weapon)
		{
			if (!_stricmp(Weapon,"Weapon_Cell_Phone")){return;}
		}
		if (Has_Weapon(obj,"Weapon_Cell_Phone"))
		{
			Commands->Select_Weapon(obj,"Weapon_Cell_Phone");
		}
	}
}

void JMG_RP2_Smart_AI::Created(GameObject *obj)
{
	for (int x = 0;x < 128;x++)
	{
		sprintf(AIPlayerStanding[x]->PlayerName,"null");
		AIPlayerStanding[x]->Standing = 0;
	}
	MyState = Wait;
	Commands->Innate_Disable(obj);
	Commands->Enable_Enemy_Seen(obj,true);
	Commands->Start_Timer(obj,this,0.1f,92562143);
	Commands->Start_Timer(obj,this,1.0f,92562145);
}

void JMG_RP2_Smart_AI::Enemy_Seen(GameObject *obj,GameObject *seen)	
{
	if (EnemyTargetID)
	{
		return;
	}
	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
	{
		return;
	}
	if (Commands->Is_A_Star(seen))// Don't attack players that haven't spawned
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(seen)])
		{
			return;
		}
		if (Is_Script_Attached(seen,"JMG_Dont_Be_A_Douche"))//Don't attack players with spawn kill
		{
			return;
		}
		if (AIPlayerStanding[Get_Player_ID(seen)]->Standing < -50)
		{
			return;
		}
	}
	if (ComparePriority(AttackTarget))
	{
		EnemyTargetID = Commands->Get_ID(seen);
	}
}

void JMG_RP2_Smart_AI::Timer_Expired(GameObject *obj,int number)
{
enum AIStates{Wait,Wander,EnterVehicle,AttackVehicle,RequestEntry,OfferARide,FollowingFriend,AvengeFriend,WaitForFriend,HuntAStar,AttackTarget,InvestigateSound,MoveToLastSeen};
	if (!Commands->Get_Health(obj)){return;}
	if (92562143 == number)
	{
		float Time = 0.1f;
		Vector3 Pos = Commands->Get_Position(obj);
		GameObject *MyVehicle = Get_Vehicle(obj);
		//if (EnterVehicleTargetID){Vehicle_Enter_Logic(obj,Pos,&Time,MyVehicle);}
		if (MyState == MoveToLastSeen)// Go to targets last seen position
		{
			Action_Reset(obj);
			Goto_Location(obj,LastEnemyPos,1,Commands->Get_Random(1.0,5.0));
		}
		if (MyState == AttackTarget)
		{
			Attack_Logic(obj,&Time,Pos,MyVehicle);
		}
		if (MyState == AttackTarget && MyVehicle)
		{
			VehicleRandomAction(obj,&Time,MyVehicle);
		}
		if (Commands->Get_Distance(Pos,LastPos) < 0.025 && MovingStates())////-------------------STUCK CHECKS-----------------------
		{
			StuckCount++;
			if (MyVehicle)
			{// Vehicle Stuck Check
				if (StuckCount >= 20 && !Backward)
				{//Stuck First Time
					Backward = true;
					//UpdateAction(obj);
					Commands->Start_Timer(obj,this,Commands->Get_Random(1.0f,3.0f),92562144);//Reverse Time
				}
				if (StuckCount >= 10)
				{// Try something else
					//ChooseARandomAction(obj,&Time);
				}
			}
		}
		else
		{
			StuckCount = 0;
		}
		LastPos = Pos;
		Commands->Start_Timer(obj,this,0.1f,92562143);
	}
}

void JMG_RP2_Smart_AI::Damaged(GameObject *obj,GameObject *damager,float damage)
{
	if (damager && damager == obj || !_stricmp(Get_Skin(damager),"Blamo") || !_stricmp(Get_Shield_Type(damager),"Blamo"))
	{
		return;
	}
	if (!EnemyTargetID && Commands->Get_Player_Type(damager) != Get_Player_Type(obj))
	{
		EnemyTargetID = Commands->Get_ID(damager);
		FaceTarget(obj,Commands->Get_Position(damager));
	}
}

void JMG_RP2_Smart_AI::Sound_Heard(GameObject *obj,const CombatSound &sound)
{
	if (ComparePriority(InvestigateSound))
	{
		GameObject *SoundObject = sound.Creator;
		if (!SoundObject){return;}
		if (!Commands->Is_A_Star(SoundObject)){return;}
		if (ISSELECTINGSPAWN[Get_Player_ID(SoundObject)]){return;}
		if (Get_Player_Type(SoundObject) != Get_Player_Type(obj))
		{
			MyState = InvestigateSound;
			Goto_Location(obj,Commands->Get_Position(sound.Creator),1,Commands->Get_Random(5.0f,15.0f));
		}
	}
}

void JMG_RP2_Smart_AI::Killed(GameObject *obj, GameObject *damager)
{
	const char *MyWeapon = Get_Current_Weapon(obj);
	RP2WeaponListControl *Weapon;
	if (!MyWeapon){Weapon = Get_WLS_Weapon_Settings("Weapon_Ammo_Box");}
	else{Weapon = Get_WLS_Weapon_Settings(MyWeapon);}
	if (Weapon)
	{
		if (!Weapon->CanBeDropped){Weapon = Get_WLS_Weapon_Settings("Weapon_Ammo_Box");}
		Vector3 pos = Commands->Get_Position(obj);
		pos.Z += Weapon->DropHeight;
		GameObject *object = Commands->Create_Object("Daves_Arrow_NT",pos);
		Commands->Set_Model(object,"null");
		Commands->Set_Facing(object,Commands->Get_Facing(obj));
		if (Has_Weapon(obj,Weapon->WeaponName))
		{
			char params[2000];
			sprintf(params,"%s,%d,0.25,0.25,0.25,1,0,1",Weapon->WeaponName,Commands->Get_Random_Int(0,Get_Max_Total_Bullets(obj,Weapon->WeaponName)));
			Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);
		}
		else
		{
			char params[2000];
			sprintf(params,"%s,%d,0.25,0.25,0.25,1,0,1",Weapon->WeaponName,Commands->Get_Random_Int(0,1000));
			Commands->Attach_Script(object,"JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special",params);
		}
	}
}

void JMG_RP2_Smart_AI::Attack_Target(GameObject *obj,int TargetID,bool Pathfind,float AttackRange)
{
	Action_Reset(obj);
	float MaxDistance = Commands->Get_Random(0.0,15);
	if (Get_Float_Parameter("AttackDistance") < 10)
	{
		MaxDistance = Commands->Get_Random(1.0,(Get_Float_Parameter("AttackDistance")-1));
	}
	Commands->Action_Reset(obj,10);
	GameObject *target = Commands->Find_Object(TargetID);
	if (target)
	{
		ActionParamsStruct params;
		params.Set_Movement(target,Speed,MaxDistance,false);
		params.MoveFollow = true;
		GameObject *MyVehicle = Get_Vehicle(obj);
		if (MyVehicle)
		{
			obj = MyVehicle;
			AttackRange = 295.0f;
			params.MoveBackup=Backward;
			if ((MyVehicle->As_PhysicalGameObj() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass())){Pathfind = false;}
		}
		else{params.MoveBackup=0;}
		params.MovePathfind=Pathfind;
		Commands->Action_Goto(obj,params);
		params.Set_Basic(this,100,10);
		params.Set_Attack(target,AttackRange,0,1);
		params.AttackCheckBlocked = false;
		if (MyVehicle){Commands->Action_Attack(MyVehicle,params);}
		else{Commands->Action_Attack(obj,params);}
	}
}

void JMG_RP2_Smart_AI::Goto_Location(GameObject *obj,Vector3 TargetLocation,bool Pathfind,float ArriveDistance)
{
	LastTargetLocation = TargetLocation;
	Action_Reset(obj);
	Commands->Action_Reset(obj,10);
	ActionParamsStruct params;
	params.Set_Basic(this,100,10);
	params.MoveFollow=false;
	GameObject *MyVehicle = Get_Vehicle(obj);
	if (MyVehicle)
	{
		obj = MyVehicle;
		params.MoveBackup=Backward;
		if ((MyVehicle->As_PhysicalGameObj() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object()->As_VTOLVehicleClass()))
		{
			params.MovePathfind=false;
			ArriveDistance = 0.0f;
		}
	}
	else
	{
		params.MoveBackup=0;
		params.MovePathfind=Pathfind;
	}
	params.Set_Movement(TargetLocation,Speed,ArriveDistance,false);
	Commands->Action_Goto(obj,params);
}

void JMG_RP2_Smart_AI::Hunt_Star(GameObject *obj)
{
	Action_Reset(obj);
	Commands->Action_Reset(obj,10);
	ActionParamsStruct params;
	params.Set_Basic(this,99,10);
	if (Get_Vehicle(obj))
	{
		obj = Get_Vehicle(obj);
		params.MoveBackup=Backward;
	}
	else{params.MoveBackup=0;}
	params.Set_Movement(Commands->Get_A_Star(Commands->Get_Position(obj)),Speed,Commands->Get_Random(5.0f,20.0f),false);
	params.MoveFollow = true;
	Commands->Action_Goto(obj,params);
}

void JMG_RP2_Smart_AI::Goto_Random_Spot(GameObject *obj,float MaxDistance)
{
	RP2RandomTeleportPositionControl *ANode = Swarm_Get_Random_Teleport_Node(obj,MaxDistance);
	if (ANode)
	{
		Goto_Location(obj,ANode->Telepos,1,Commands->Get_Random(5.0f,20.0f));
	}
}

void JMG_RP2_Smart_AI::AttackMove(GameObject *obj,float AttackRange,Vector3 Pos)
{
	Action_Reset(obj);
	GameObject *Target = Commands->Find_Object(EnemyTargetID);
	if (Target)
	{
		Commands->Action_Reset(obj,10);
		ActionParamsStruct params;
		params.Set_Movement(Pos,Speed,1.0,false);
		params.MovePathfind=false;
		GameObject *MyVehicle = Get_Vehicle(obj);
		if (MyVehicle)
		{
			obj = MyVehicle;
			AttackRange = 295.0f;
			params.MoveBackup=Backward;
		}
		else{params.MoveBackup=0;}
		Commands->Action_Goto(obj,params);
		params.Set_Basic(this,100,10);
		params.Set_Attack(Target,AttackRange,0,1);
		params.AttackCheckBlocked = false;
		if (MyVehicle){Commands->Action_Attack(MyVehicle,params);}
		else{Commands->Action_Attack(obj,params);}
	}
}

void JMG_RP2_Smart_AI::FaceTarget(GameObject *obj,Vector3 pos)
{
	Vector3 Movement = Commands->Get_Position(obj);
	pos.X -= Movement.X;
	pos.Y -= Movement.Y;
	float TempRotation = atan2(pos.Y,pos.X) * 180 / PI;
	Commands->Set_Facing(obj,TempRotation);
}

/*void JMG_RP2_Smart_AI::UpdateAction(GameObject *obj)
{
	VehicleStuckCount++;
	if (GotoSpot && Hunting)
	{
		AttackMove(obj,Get_Float_Parameter("AttackDistance"),LastTargetLocation);
	}
	else if (GotoSpot)
	{
		Goto_Location(obj,LastTargetLocation,true,Commands->Get_Random(5.0f,15.0f));
	}
	else if (Attacking)
	{
		Attack_Target(obj,CurrentTarget,true,Get_Float_Parameter("AttackDistance"));
	}
	else if (Hunting)
	{
		Hunt_Star(obj);
	}
}*/

/*void JMG_RP2_Smart_AI::ChooseARandomAction(GameObject *obj,float *Time)
{
	int Random = Commands->Get_Random_Int(0,10000);
	GameObject *MyVehicle = Get_Vehicle(obj);
	if (MyVehicle)
	{
		if (Random <= 1500)// Make random hunt attempt
		{
			CurrentTarget = Commands->Get_ID(Commands->Get_A_Star(Commands->Get_Position(obj)));
		}
		else if (Random <= 1500)// Make random hunt attempt
		{
			//Console_Input("MESSAGE :Hunt Star");
			Hunt_Star(obj);
			*Time = 2.0f;
		}
		else if (Random <= 10000)// Make a random move
		{
			//Console_Input("MESSAGE :Got Random Spot");
			Goto_Random_Spot(obj,200);
			*Time = 2.0f;
		}
	}
	else if (Hunting > 1 && Hunting < 10)
	{
		//Console_Input("MESSAGE :Remind hunting");
		Hunting++;
		Hunt_Star(obj);
		*Time = 2.0f;
	}
	else if (Random <= SwarmHuntProbability)// Randomly Choose to group up
	{
		//Console_Input("MESSAGE :Swarm Groupup");
		Swarm_Group_Up(obj);
	}
	else if (Random <= GlobalHuntProbability)// Global swarm hunt!
	{
		SwarmHunt = 1;
	}
	else if (Random <= 500)// Make random hunt attempt
	{
		//Console_Input("MESSAGE :Hunt Star");
		Hunt_Star(obj);
		*Time = 2.0f;
	}
	else if (Random <= 10000)// Make a random move
	{
		//Console_Input("MESSAGE :Got Random Spot");
		Goto_Random_Spot(obj,200);
		*Time = 2.0f;
	}
	else // GO HOME!
	{
	//Console_Input("MESSAGE :Go Home");
		Goto_Location(obj,HomeLocation,1,50.0f);
		*Time = 2.0f;
	}
}*/

void JMG_RP2_Smart_AI::VehicleRandomAction(GameObject *obj,float *Time,GameObject *MyVehicle)
{
	if (!(MyVehicle->As_PhysicalGameObj() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object() && MyVehicle->As_PhysicalGameObj()->Peek_Physical_Object()->As_TrackedVehicleClass()))
	{
		GiveUpTime--;
		if (GiveUpTime <= 0)
		{
			GiveUpTime = Commands->Get_Random_Int(50,100);
			//ChooseARandomAction(obj,Time);
		}
	}
}

void JMG_RP2_Smart_AI::Attack_Logic(GameObject *obj,float *Time,Vector3 Pos,GameObject *MyVehicle)
{
	GameObject *CT = Commands->Find_Object(EnemyTargetID);
	if (!Commands->Get_Health(CT) || !CT || MyVehicle == CT){Action_Reset(obj);}
	if (GiveUpTime){GiveUpTime--;}
	if (GiveUpTime <= 0)// Target not visible
	{
		StuckCount = 0;
		EnemyTargetID = 0;
		if (Commands->Get_Random_Int(0,100) < 75)
		{
			LastEnemyPos = Commands->Get_Position(CT);
			Goto_Location(obj,LastEnemyPos,1,Commands->Get_Random(1.0,5.0));
			*Time = Commands->Get_Random(0.0f,1.0f);
		}
		else{Action_Reset(obj);}
	}
	/*if (!Attacking && !EnterVehicleTargetID && EnemyTargetID)
	{
		Attack_Target(obj,EnemyTargetID,1,Get_Float_Parameter("AttackDistance"));
	}
	if (!(StuckCount % 7) && EnemyTargetID && !EnterVehicleTargetID)// Random Movement
	{
		if (Commands->Get_Random_Int(0,100) > 100*(Commands->Get_Distance(Pos,Commands->Get_Position(CT))/Get_Float_Parameter("AttackDistance")) && !MyVehicle)
		{
			RandomMoveSpot = Commands->Get_Position(obj);
			RandomMoveSpot.X += Commands->Get_Random(-10.0f,10.0f);
			RandomMoveSpot.Y += Commands->Get_Random(-10.0f,10.0f);
			AttackMove(obj,Get_Float_Parameter("AttackDistance"),RandomMoveSpot);
		}
		else
		{
			AttackMove(obj,Get_Float_Parameter("AttackDistance"),Commands->Get_Position(CT));
		}
	}*/
}

void JMG_RP2_Smart_AI::Vehicle_Enter_Logic(GameObject *obj,Vector3 Pos,float *Time,GameObject *MyVehicle)
{
	/*GameObject *TVehicle = Commands->Find_Object(EnterVehicleTargetID);
	if (TVehicle && !MyVehicle && !Get_Vehicle_Occupant_Count(TVehicle))
	{
		EnterVehicleMoveUpdate++;
		Vector3 Postion = Commands->Get_Position(TVehicle);
		if (!EnemyTargetID)
		{
			EnterVehicleMoveUpdate = 0;
			Goto_Location(obj,Postion,1,0.0f);
		}
		else if (EnterVehicleMoveUpdate > 30)
		{
			AttackMove(obj,Get_Float_Parameter("AttackDistance"),Postion);
		}
		if (Commands->Get_Distance(Postion,Pos) < 20.0f)
		{
			AutoEnter++;
			if (Commands->Get_Distance(Postion,Pos) < 5.0f || AutoEnter > 100)
			{
				AutoEnter = 0;
				Commands->Set_Position(obj,Postion);
				Soldier_Transition_Vehicle(obj);
			}
		}
	}
	else if (MyVehicle == TVehicle && !CurrentTarget)
	{
		AutoEnter = 0;
		EnterVehicleTargetID = 0;
		VehicleRandomAction(obj,Time,MyVehicle);
		NewVehicleAction = Commands->Get_Random_Int(5,50);
		Commands->Set_Player_Type(MyVehicle,Get_Player_Type(obj));
	}
	else if (MyVehicle)
	{
		Soldier_Transition_Vehicle(obj);
	}
	else
	{
		AutoEnter = 0;
		EnterVehicleTargetID = 0;
	}*/
}

bool JMG_RP2_Smart_AI::ComparePriority(AIStates NewState)
{
	if (GetPriority(MyState) <= GetPriority(NewState))
	{
		return true;
	}
	return false;
}

int JMG_RP2_Smart_AI::GetPriority(AIStates State)
{
	switch (State)
	{
	case Wait:
		return 0;
	case Wander:
		return 1;
	case EnterVehicle:
		return 2;
	case AttackVehicle:
		return 2;
	case RequestEntry:
		return 2;
	case OfferARide:
		return 2;
	case FollowingFriend:
		return 3;
	case AvengeFriend:
		return 4;
	case WaitForFriend:
		return 3;
	case HuntAStar:
		return 2;
	case AttackTarget:
		return 3;
	case InvestigateSound:
		return 1;
	case MoveToLastSeen:
		return 2;
	default:
		return 0;
	}
}

bool JMG_RP2_Smart_AI::MovingStates()
{
	switch (MyState)
	{
	case Wait:
		return false;
	case Wander:
		return true;
	case EnterVehicle:
		return true;
	case AttackVehicle:
		return true;
	case RequestEntry:
		return false;
	case OfferARide:
		return false;
	case FollowingFriend:
		return true;
	case AvengeFriend:
		return true;
	case WaitForFriend:
		return false;
	case HuntAStar:
		return true;
	case AttackTarget:
		return true;
	case InvestigateSound:
		return true;
	case MoveToLastSeen:
		return true;
	default:
		return 0;
	}
}

void JMG_RP2_Smart_AI::Action_Reset(GameObject *obj)
{
}

void JMG_RP2_Hovercraft_Hover_Control::Created(GameObject *obj)
{
	HoverOn = true;
	GameObject *object = Commands->Create_Object("Daves_Arrow_NT",Commands->Get_Position(obj));//Invisible_Box_NR
	Commands->Set_Model(object,Get_Parameter("HoverCraft_Bloker"));
	Hover_Plate_ID = Commands->Get_ID(object);
	Commands->Start_Timer(obj,this,0.1f,987);
	Commands->Start_Timer(obj,this,60.0f,9879);
}

void JMG_RP2_Hovercraft_Hover_Control::Timer_Expired(GameObject *obj,int number)
{
	if (number == 987)
	{
		Vector3 MyPos = Commands->Get_Position(obj);
		MyPos.Z = -23.0f;
		GameObject *object = Commands->Find_Object(Hover_Plate_ID);
		if ((MyPos.X > -1642.0f && MyPos.X < -610.0f && MyPos.Y < 460.0f && MyPos.Y > -376.0f) || (MyPos.X < 1537.51f && MyPos.X > 1166.0f && MyPos.Y < 350.0f && MyPos.Y > -48.14f))
		{
			if (HoverOn)
			{
				if (object)
				{
					Commands->Set_Model(object,"null");
				}
				HoverOn = false;
			}
		}
		else
		{
			if (!HoverOn)
			{
				if (object)
				{
					Commands->Set_Model(object,Get_Parameter("HoverCraft_Bloker"));
				}
				HoverOn = true;
			}
		}
		if (object)
		{
			Commands->Set_Position(object,MyPos);
		}
		Commands->Start_Timer(obj,this,0.01f,987);
	}
	if (number == 9879)
	{
	}
}


void JMG_RP2_Hovercraft_Hover_Control::Killed(GameObject *obj, GameObject *damager)
{
	GameObject *object = Commands->Find_Object(Hover_Plate_ID);
	if (object)
	{
		Commands->Destroy_Object(object);
	}
}

void JMG_RP2_Initilize_Area_Weather::Created(GameObject *obj)
{
	Commands->Start_Timer(obj,this,0.0f,987);
}

void JMG_RP2_Initilize_Area_Weather::Timer_Expired(GameObject *obj,int number)
{
	if (number == 987)
	{
		Setup_Area_Node();
	}
}


void JMG_RP2_Initilize_Area_Weather::Setup_Area_Node()
{
	RP2WeatherStruct *ANode = new RP2WeatherStruct;
	ANode->AreaID = Get_Int_Parameter("Weather_Node_Area");
	ANode->TransitionTime = Get_Float_Parameter("Zone_Switch_Time");
	ANode->FogEnabled = (bool)Get_Vector3_Parameter("Fog[Enable|Star|End]").X;
	ANode->FogMinDist = Get_Vector3_Parameter("Fog[Enable|Star|End]").Y;
	ANode->FogMaxDist = Get_Vector3_Parameter("Fog[Enable|Star|End]").Z;
	ANode->ScreenColor.X = Get_Vector3_Parameter("ScreenColor[Red|Green|Blue]").X;
	ANode->ScreenColor.Y = Get_Vector3_Parameter("ScreenColor[Red|Green|Blue]").Y;
	ANode->ScreenColor.Z = Get_Vector3_Parameter("ScreenColor[Red|Green|Blue]").Z;
	ANode->ScreenOpacity = Get_Float_Parameter("Screen_Opacity");
	ANode->CloudCover = Get_Vector3_Parameter("Cloud[Cover|Gloominess|NULL]").X;
	ANode->CloudGloominess = Get_Vector3_Parameter("Cloud[Cover|Gloominess|NULL]").Y;
	ANode->LightningIntensity = Get_Vector3_Parameter("Lightning[Intensity|Start|End]").X;
	ANode->LightningStart = Get_Vector3_Parameter("Lightning[Intensity|Start|End]").Y;
	ANode->LightningEnd = Get_Vector3_Parameter("Lightning[Intensity|Start|End]").Z;
	ANode->LightningHeading = Get_Vector3_Parameter("Lightning[Heading|Distribution|NULL]").X;
	ANode->LightningDistribution = Get_Vector3_Parameter("Lightning[Heading|Distribution|NULL]").Y;
	ANode->WarBlitzIntensity = Get_Vector3_Parameter("WarBlitz[Intensity|Start|End]").X;
	ANode->WarBlitzStart = Get_Vector3_Parameter("WarBlitz[Intensity|Start|End]").Y;
	ANode->WarBlitzEnd = Get_Vector3_Parameter("WarBlitz[Intensity|Start|End]").Z;
	ANode->WarBlitzHeading = Get_Vector3_Parameter("WarBlitz[Heading|Distribution|NULL]").X;
	ANode->WarBlitzDistribution = Get_Vector3_Parameter("WarBlitz[Heading|Distribution|NULL]").Y;
	ANode->WindSpeed = Get_Vector3_Parameter("Wind[Speed|Heading|Variability]").X;
	ANode->WindHeading = Get_Vector3_Parameter("Wind[Speed|Heading|Variability]").Y;
	ANode->WindVariability = Get_Vector3_Parameter("Wind[Speed|Heading|Variability]").Z;
	ANode->RainDensity = Get_Vector3_Parameter("Density[Rain|Snow|Ash]").X;
	ANode->SnowDensity = Get_Vector3_Parameter("Density[Rain|Snow|Ash]").Y;
	ANode->AshDensity = Get_Vector3_Parameter("Density[Rain|Snow|Ash]").Z;
	RP2_Area_Weather_Selection_Control(Get_Int_Parameter("Weather_Node_Area"),ANode);
}

void JMG_RP2_Change_Weather_Area_On_Enter::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		//if (Is_Script_Attached(obj,"JMG_RP2_Teleport_Zone_Script_Attach")){return;}
		RP2WeatherStruct *MyNode = PlayerWeatherNodes[Get_Player_ID(enter)];
		if (MyNode && MyNode->AreaID != Get_Int_Parameter("ChangeToArea"))
		{
			PlayerWeatherNodes[Get_Player_ID(enter)] = RP2_Area_Weather_Selection_Control(Get_Int_Parameter("ChangeToArea"),NULL);
			if (Get_Int_Parameter("OverrideTransitionTime") >= 0.0f)
			{
				MyNode->TransitionTime = Get_Float_Parameter("OverrideTransitionTime");
			}
		}
	}
}

void JMG_RP2_Change_Weather_When_In_Range::Created(GameObject *obj)
{
	for (int x = 0;x < 128;x++){PlayersInRange[x] = false;}
	MinDistance = Get_Float_Parameter("Distance")*Get_Float_Parameter("Distance");
	Commands->Start_Timer(obj,this,1.0f,987);
}

void JMG_RP2_Change_Weather_When_In_Range::Timer_Expired(GameObject *obj,int number)
{
	if (number == 987)
	{
		for (int x = 1;x < 128;x++)
		{
			GameObject *Player = Get_GameObj(x);
			if (Player)
			{
				if (SimpleDistance(Commands->Get_Position(obj),Commands->Get_Position(Player)) < MinDistance)
				{
					Change_Player_Area(Player,x,Get_Int_Parameter("In_Range_Area"));
					PlayersInRange[x] = true;
				}
				else
				{
					if (PlayersInRange[x])
					{
						Change_Player_Area(Player,x,Get_Int_Parameter("Left_Range_Area"));
						PlayersInRange[x] = false;
					}
				}
			}
		}
		Commands->Start_Timer(obj,this,1.0f,987);
	}
}

void JMG_RP2_Change_Weather_When_In_Range::Change_Player_Area(GameObject *PlayerObj,int PlayerID,int Area)
{
	RP2WeatherStruct *MyNode = PlayerWeatherNodes[PlayerID];
	if (MyNode && MyNode->AreaID != Area)
	{
		PlayerWeatherNodes[PlayerID] = RP2_Area_Weather_Selection_Control(Area,NULL);
		if (Get_Int_Parameter("OverrideTransitionTime") >= 0.0f)
		{
			MyNode->TransitionTime = Get_Float_Parameter("OverrideTransitionTime");
		}
	}
}


void JMG_RP2_Checkstand_Cashier::Created(GameObject *obj)
{
	CheckerGain = 0.0f;
	MaxPayout = 0.0f;
	PayoutTime = 0;
	/*for (int x = 0;x < 128;x++)
	{
		for (int y = 0;y < 10;y++)
		{
			Customers[x][y] = 0;
		}
	}*/
	Commands->Start_Timer(obj,this,1.0f,4732545);
}

void JMG_RP2_Checkstand_Cashier::Timer_Expired(GameObject *obj,int number)
{
	if (number == 4732545)
	{
		GameObject *Checker = Commands->Find_Object(CheckerID);
		if (Checker && PayoutTime < 500)
		{
			PayoutTime++;
			if (CheckerGain < MAXCHECKERPAYPERHOUR)
			{
				CheckerGain += 0.1f;
			}
			Commands->Give_Money(Checker,CheckerGain,true);
		}
		else if (CheckerID)
		{
			CheckerID = 0;
			PayoutTime = 0;
		}
		Commands->Start_Timer(obj,this,1.0f,4732545);
	}
}

void JMG_RP2_Checkstand_Cashier::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 3433434)
	{
		GameObject *Checker = Commands->Find_Object(CheckerID);
		if (Checker)
		{
			int PlayerID = Get_Player_ID(Checker);
			if (Customers[PlayerID][0] == Commands->Get_ID(sender))
			{
				return;
			}
			int Spot = 0;
			int TempArray[10] = {0};
			TempArray[0] = Get_Player_ID(sender);
			MaxPayout = TRAINSTATIONPAYOUT;
			for (int x = 0;x < 10;x++)
			{ 
				if (Customers[PlayerID][x] == Commands->Get_ID(sender))
				{
					MaxPayout = CHECKERCHECKOUTMAXPAYOUT*(x/10.0f);
				}
				else
				{
					Spot++;
					if (Spot < 10)
					{
						TempArray[Spot] = Customers[PlayerID][x];
					}
				}
			}
			for (int x = 0;x < 10;x++)
			{
				Customers[PlayerID][x] = TempArray[x];
			}
		}
	}
}

void JMG_RP2_Checkstand_Cashier::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter) && !CheckerID)
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(enter)])
		{
			return;
		}
		int ID = Commands->Get_ID(enter);
		if (ID != CheckerID)
		{
			CheckerGain = 0.0f;
		}
		CheckerID = ID;
	}
}

void JMG_RP2_Checkstand_Cashier::Exited(GameObject *obj,GameObject *exiter)
{
	if (Commands->Is_A_Star(exiter) && CheckerID == Commands->Get_ID(exiter))
	{
		CheckerID = 0;
		PayoutTime = 0;
	}
}

void JMG_RP2_Checkstand_Customer::Entered(GameObject *obj,GameObject *enter)
{
	if (Commands->Is_A_Star(enter))
	{
		if (ISSELECTINGSPAWN[Get_Player_ID(enter)])
		{
			return;
		}
		GameObject *Checkstand = Commands->Find_Object(Get_Int_Parameter("CheckstandID"));
		if (Checkstand)
		{
			Commands->Send_Custom_Event(enter,Checkstand,3433434,0,0);
		}
	}
}

void JMG_RP2_UFO_Script::Created(GameObject *obj)
{
	JumpCharge = 0;
	JetTime = 0;
	Commands->Start_Timer(obj,this,1.0f,4732545);
}

void JMG_RP2_UFO_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
{
	if (message == 7154148)
	{
		Send_Message_Player(sender,200,200,125,"Vehicle Special Keys:");
		Send_Message_Player(sender,200,200,125,"B - Hyperspace to a random spot");
		Send_Message_Player(sender,200,200,125,"Middle Mouse - Hyperspace to nearest player");
	}
	RP2VehicleControl *AVehicleNode = Get_Vehicle_Node2(obj);
	if (AVehicleNode && !AVehicleNode->OnCarryAll)
	{
		if (message == 98562147)
		{
			if (JumpCharge == STRIKECRAFTJUMPCHARGE)
			{
				Vector3 SPos;
				RP2RandomTeleportPositionControl *Node = NULL;
				for (int x = 0;x < 10;x++)
				{
					SPos.X = Commands->Get_Random(-5000.00f,5000.00f);
					SPos.Y = Commands->Get_Random(-5000.00f,5000.00f);
					SPos.Z = Commands->Get_Random(-5000.00f,5000.00f);
					if (Commands->Get_A_Star(SPos) != obj)
					{
						GameObject *NearStar = Get_A_Star2(obj,SPos);
						if (NearStar)
						{
							Node = Find_Closest_Teleport_Node(NearStar,10.0f,5000.0f);
						}
						else
						{
							Node = Find_Closest_Teleport_Node(Commands->Get_A_Star(SPos),10.0f,5000.0f);
						}
						if (Node)
						{
							x = 100;
						}
					}
				}
				if (!Node)
				{
					Node = Find_Closest_Teleport_Node(Commands->Get_A_Star(Commands->Get_Position(obj)),10.0f,5000.0f);
				}
				if (Node)
				{
					ScreenFade(Commands->Get_Position(obj));
					Vector3 Pos = Node->Telepos;
					Pos.Z += 100.0f;
					ScreenFade(Pos);
					Commands->Create_Sound("SFX.Volt_Auto_Rifle_Fire",Commands->Get_Position(obj),obj);
					GameObject *Placer = Commands->Create_Object("Daves_Arrow",Pos);
					Commands->Set_Facing(Placer,Commands->Get_Facing(obj));
					Commands->Attach_To_Object_Bone(obj,Placer,"null");
					Commands->Create_Sound("SFX.Volt_Auto_Rifle_Fire",Pos,obj);
					Commands->Attach_To_Object_Bone(obj,Placer,"null");
					Commands->Destroy_Object(Placer);
					JumpCharge = 0;
				}
			}
			else
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					char Notification[237];
					sprintf(Notification,"Capacitors at %.2f%c charge...",((float)JumpCharge/STRIKECRAFTJUMPCHARGE)*100.0f,'%');
					Send_Message_Player(Driver,150,0,150,Notification);
				}
			}
		}
		if (message == 7745472)
		{// B Key
			if (JumpCharge == STRIKECRAFTJUMPCHARGE)
			{
				RP2RandomTeleportPositionControl *Node = Get_Matching_Teleport_Node(Commands->Get_Random_Int(0,TELEPORTMAXRANDCHOICE));
				if (Node)
				{
					ScreenFade(Commands->Get_Position(obj));
					Vector3 Pos = Node->Telepos;
					Pos.Z += 100.0f;
					ScreenFade(Pos);
					Commands->Create_Sound("SFX.Volt_Auto_Rifle_Fire",Commands->Get_Position(obj),obj);
					GameObject *Placer = Commands->Create_Object("Daves_Arrow",Pos);
					Commands->Set_Facing(Placer,Commands->Get_Facing(obj));
					Commands->Attach_To_Object_Bone(obj,Placer,"null");
					Commands->Create_Sound("SFX.Volt_Auto_Rifle_Fire",Pos,obj);
					Commands->Attach_To_Object_Bone(obj,Placer,"null");
					Commands->Destroy_Object(Placer);
					JumpCharge = 0;
				}
			}
			else
			{
				GameObject *Driver = Get_Vehicle_Driver(obj);
				if (Driver)
				{
					char Notification[237];
					sprintf(Notification,"Capacitors at %.2f%c charge...",((float)JumpCharge/STRIKECRAFTJUMPCHARGE)*100.0f,'%');
					Send_Message_Player(Driver,150,0,150,Notification);
				}
			}
		}
	}
}

void JMG_RP2_UFO_Script::Timer_Expired(GameObject *obj,int number)
{
	if (number == 4732545)
	{
		if (JumpCharge < STRIKECRAFTJUMPCHARGE)
		{
			JumpCharge++;
		}
		Commands->Start_Timer(obj,this,1.0f,4732545);
	}
}

void JMG_RP2_UFO_Script::ScreenFade(Vector3 HCPos)
{
	for (int x = 1;x < 128;x++)
	{
		GameObject *Player = Get_GameObj(x);
		if (Player)
		{
			if (Commands->Get_Distance(HCPos,Commands->Get_Position(Player)) <= 300.0f)
			{
				int PlayerID = x;
				if (!DRUGSCREENEFFECTSON[PlayerID] && !ISUNDERWATER[PlayerID])
				{
					RP2WeatherStruct *MyNode = PlayerWeatherNodes[Get_Player_ID(Player)];
					if (MyNode)
					{
						Set_Screen_Fade_Color_Player(Player,1.0,1.0,1.0,0);
						if (!Is_Script_Attached(Player,"JMG_RP2_Teleport_Zone_Script_Attach"))
						{
							Set_Screen_Fade_Opacity_Player(Player,1.0,0);
						}
						Set_Screen_Fade_Color_Player(Player,MyNode->ScreenColor.X,MyNode->ScreenColor.Y,MyNode->ScreenColor.Z,1.0);
						if (!Is_Script_Attached(Player,"JMG_RP2_Teleport_Zone_Script_Attach"))
						{
							Set_Screen_Fade_Opacity_Player(Player,MyNode->ScreenOpacity,1.0);
						}
					}
					else
					{
						Set_Screen_Fade_Color_Player(Player,1.0,1.0,1.0,0);
						if (!Is_Script_Attached(Player,"JMG_RP2_Teleport_Zone_Script_Attach"))
						{
							Set_Screen_Fade_Opacity_Player(Player,1.0,0.0);
						}
						Set_Screen_Fade_Color_Player(Player,0.0,0.0,0.0,1.0);
						if (!Is_Script_Attached(Player,"JMG_RP2_Teleport_Zone_Script_Attach"))
						{
							Set_Screen_Fade_Opacity_Player(Player,0,1.0);
						}
					}
				}
			}
		}
	}
}

GameObject *JMG_RP2_UFO_Script::Get_A_Star2(GameObject *obj,Vector3 pos)
{
	float CloseDistance = 0;
	GameObject *ClosestPlayer = NULL;
	for (int x = 1;x < 128;x++)
	{
		if (!ISSELECTINGSPAWN[x])
		{
			GameObject *Player = Get_GameObj(x);
			if (Player)
			{
				if (Player != Get_Vehicle_Driver(obj))
				{
					if (!ClosestPlayer)
					{
						CloseDistance = Commands->Get_Distance(pos,Commands->Get_Position(Player));
						ClosestPlayer = Player;
					}
					else
					{
						float Distance = Commands->Get_Distance(pos,Commands->Get_Position(Player));
						if (Distance < CloseDistance)
						{
							CloseDistance = Distance;
							ClosestPlayer = Player;
						}
					}
				}
			}
		}
	}
	return ClosestPlayer;
}

RP2VehicleControl *JMG_RP2_UFO_Script::Get_Vehicle_Node2(GameObject *obj)
{
	if (!RP2VehicleNode)
	{
		RP2VehicleNode = new RP2VehicleControl;
		RP2VehicleNode->VehicleID = Commands->Get_ID(obj);
		RP2VehicleNode->AirSupply = 0;
		RP2VehicleNode->OnCarryAll = 0;
		RP2VehicleNode->next = NULL;
		return RP2VehicleNode;
	}
	else
	{
		RP2VehicleControl *Current = RP2VehicleNode;
		int MyID = Commands->Get_ID(obj);
		while (Current != NULL)
		{
			if (Current->VehicleID == MyID)
			{
				return Current;
			}
			else if (Current->next == NULL)
			{
				Current->next = new RP2VehicleControl;
				Current = Current->next;
				Current->VehicleID = Commands->Get_ID(obj);
				Current->AirSupply = 0;
				Current->OnCarryAll = 0;
				Current->next = NULL;
				return Current;
			}
			Current = Current->next;
		}
	}
	return NULL;
}

ScriptRegistrant<JMG_Slot_Machine_On_Poke> JMG_Slot_Machine_On_Poke("JMG_Slot_Machine_On_Poke","Cost:int,Percent:int,Winnings:int,PullSound:string,WinSound:string,LoseSound:string,WinAnimation:string,LoseAnimation:string,EnableMessage:int,DisableMessage:int,StartEnabled=0:int");
ScriptRegistrant<JMG_Visible_Infantry_In_Vehicle> JMG_Visible_Infantry_In_Vehicle("JMG_Visible_Infantry_In_Vehicle","ModelName:string,Message=200:int,Animation=s_a_human.rp2driveranim:string,SubObject=0:string,FirstFrame=0:float,LastFrame=-1.000:float,Blended=0:int");
ScriptRegistrant<JMG_Attach_Turret_And_Send_Custom> JMG_Attach_Turret_And_Send_Custom("JMG_Attach_Turret_And_Send_Custom","Preset=Master_Chief_Flash_Light_Beam:string,CreateMessage=959595:int,SendMessageMessage=595959:int,SendMessage=5656478:int,SendParam=1:int,BoneName=origin:string");
ScriptRegistrant<JMG_Flash_Light_Toggle> JMG_Flash_Light_Toggle("JMG_Flash_Light_Toggle","SendID1=100334:int,SendID2=100334:int,SendMessage1=959595:int,SendMessage2=595959:int,TriggerMessage=898524:int");
ScriptRegistrant<JMG_Dual_Weapon_Script> JMG_Dual_Weapon_Script("JMG_Dual_Weapon_Script","Message=987456:int,Weapon=Weapon_Tanaj:string");
ScriptRegistrant<JMG_Free_For_All_Script> JMG_Free_For_All_Script("JMG_Free_For_All_Script","");
ScriptRegistrant<JMG_Block_Refill_RP2> JMG_Block_Refill_RP2("JMG_Block_Refill_RP2","");
ScriptRegistrant<JMG_Druggy_Script> JMG_Druggy_Script("JMG_Druggy_Script","DrugLevelDropRate=10.00:float,WithdrawalDamageRate=0.25:float,DrugTypeMessage=911912913:int,Gain_Health_Max=2000:int,Max_Drug_Drop_Level=-1:int,Get_Hurt_While_High=0:int,Get_Hurt_While_High_Rate=1.00:float");
ScriptRegistrant<JMG_Get_Drugs_Power_Up> JMG_Get_Drugs_Power_Up("JMG_Get_Drugs_Power_Up","DrugTypeMessage=911912913:int,DrugAddAmount=5:int");
ScriptRegistrant<JMG_No_Heal_Zone> JMG_No_Heal_Zone("JMG_No_Heal_Zone","");
ScriptRegistrant<JMG_Parachute_Script> JMG_Parachute_Script("JMG_Parachute_Script","Falling_Preset:string");
ScriptRegistrant<JMG_Parachute_Power_Up> JMG_Parachute_Power_Up("JMG_Parachute_Power_Up","Condition=100:int");
ScriptRegistrant<JMG_Police_Car_Script> JMG_Police_Car_Script("JMG_Police_Car_Script","Siren_Sound_1=Police_Car_Siren_01:string,Siren_Sound_2=Police_Car_Siren_02:string");
ScriptRegistrant<JMG_RP2_Water_Kill_Zone> JMG_RP2_Water_Kill_Zone("JMG_RP2_Water_Kill_Zone","");
ScriptRegistrant<JMG_Boat_To_High> JMG_Boat_To_High("JMG_Boat_To_High","WaterLevel:float");
ScriptRegistrant<JMG_Plecos_Script> JMG_Plecos_Script("JMG_Plecos_Script","Delay_Time_Multiplier=1.00:float");
ScriptRegistrant<JMG_Detox_Powerup> JMG_Detox_Powerup("JMG_Detox_Powerup","");
ScriptRegistrant<JMG_Drug_Health_Increase_Powerup_Monitor> JMG_Drug_Health_Increase_Powerup_Monitor("JMG_Drug_Health_Increase_Powerup_Monitor","Add_Health_Amount(Amount X 1000)=0:int,Multiply_Health_Ratio(Ratio X 1000)=0:int");
ScriptRegistrant<JMG_Prostitute_Script> JMG_Prostitute_Script("JMG_Prostitute_Script","");
ScriptRegistrant<JMG_Keyboard_Input_Custom> JMG_Keyboard_Input_Custom("JMG_Keyboard_Input_Custom","Key:string,Message:int");
ScriptRegistrant<JMG_Prostitute_Attach_Script> JMG_Prostitute_Attach_Script("JMG_Prostitute_Attach_Script","ID:int");
ScriptRegistrant<JMG_Sword_Script> JMG_Sword_Script("JMG_Sword_Script","Weapon:string,BlockAnimation:string,Sword_Block_Sound:string,Sword_Break_Sound:string,Animation:string,Animation2:string,Animation3:string,ResetSwingComboTime=3.000:float,Sword_Health=100.000:float,Reset_Sword_Health_Once_Done_Blocking=0:int,NoDamageWeapon1:string,NoDamageWeapon2:string,SwordBrokePowerup=0:string");
ScriptRegistrant<JMG_Dual_P90_Script> JMG_Dual_P90_Script("JMG_Dual_P90_Script","");
ScriptRegistrant<JMG_RP2_Dual_Wield_Script> JMG_RP2_Dual_Wield_Script("JMG_RP2_Dual_Wield_Script","");
ScriptRegistrant<JMG_Swimming_Script> JMG_Swimming_Script("JMG_Swimming_Script","Skeleton=s_a_human:string,Animation_Name=jg_swim_:string,Not_Moving=i:string,Forward=f:string,Backward=b:string,Turn_Left=tl:string,Turn_Right=tr:string,Up=u:string,Down=d:string,Tilt_Up=tu:string,Tilt_Down=td:string,Tilt_Up_Backward=bu:string,Tilt_Down_Backward=bd:string,Swim_Left=l:string,Swim_Left_Tilt_Up=lu:string,Swim_Left_Tilt_Down=ld:string,Swim_Right=r:string,Swim_Right_Tilt_Up=ru:string,Swim_Right_Tilt_Down=rd:string,Not_Moving_Surface=i:string,Forward_Surface=fs:string,Backward_Surface=bs:string,Turn_Left_Surface=tl:string,Turn_Right_Surface=tr:string,Water_Jump=j:string,Drown_Time=15:int,Level_Default_Fog_Controller_ID=0:int,Invisible_Box_Object=Invisible_Box:string,Swimming_Height_Adjust_Model=HeightAdjust:string,Empty_Hands_Weapon=Weapon_Empty_Hands:string,Empty_Hands_Weapon_Powerup=POW_Empty_Hands:string,Breath_Sound=Breath_Sound:string,Urgent_Breath_Sound=Gasp_For_Breath_Sound:string,Scuba_Refill_Sound=TankRefillSound:string,Scuba_Breath_Sound=Tank_Pump_Air_Sound:string,Heart_Beat_Loop_Sound=HeartBeatSound:string,Starting_Scuba_Tank_Air_Ammount=0:int,Default_Model_Override=null:string,Swimming_Model_Override=null:string,Can_Swim=1:int");
ScriptRegistrant<JMG_Swimable_Water_Zone> JMG_Swimable_Water_Zone("JMG_Swimable_Water_Zone","ScreenRed=28:int,ScreenGreen=43:int,ScreenBlue=55:int,AddRedAmount=1:int,AddGreenAmount=-1:int,AddBlueAmount=-1:int,WaterMurkyness=150:int,WaterColorThickness=90:int,Depth_Before_Water_Darkens=150.00:float,Small_Splash=Explosion_Splash_Small:string,Medium_Splash=Explosion_Splash_Medium:string,Large_Splash=Explosion_Splash_Large:string,Huge_Splash=Explosion_Splash_Huge:string,Underwater_Effect_Controller=Invisible_Box_NR:string,Surface_Water_Effect=swimsurface:string,Underwater_Effect=swimunderwat:string,Surface_Swim_Sound=Surface_Swiming_Sound:string,Underwater_Swim_Sound=Underwater_Swiming_Sound:string");
ScriptRegistrant<JMG_Swimming_Attach_Script> JMG_Swimming_Attach_Script("JMG_Swimming_Attach_Script","ID:int,HeadID:int,Skeleton:string,Animation_Name:string,Not_Moving:string,Forward:string,Backward:string,Turn_Left:string,Turn_Right:string,Up:string,Down:string,Tilt_Up:string,Tilt_Down:string,Tilt_Up_Backward:string,Tilt_Down_Backward:string,Swim_Left:string,Swim_Left_Tilt_Up:string,Swim_Left_Tilt_Down:string,Swim_Right:string,Swim_Right_Tilt_Up:string,Swim_Right_Tilt_Down:string,Not_Moving_Surface:string,Forward_Surface:string,Backward_Surface:string,Turn_Left_Surface:string,Turn_Right_Surface:string,Water_Jump:string");
ScriptRegistrant<JMG_Swimming_Head_Attach_Script> JMG_Swimming_Head_Attach_Script("JMG_Swimming_Head_Attach_Script","SwimmingObjectID:int,PlayerID:int,Drown_Time:int,Current_Water_Zone:int,TankAirAmmount:int,MaxTankAirAmmount:int,Current_Drown_Time:int,Breath_Sound:string,Urgent_Breath_Sound:string,Scuba_Breath_Sound:string,Heart_Beat_Loop_Sound:string,Invisible_Box_Object:string");
ScriptRegistrant<JMG_Remove_Self_On_Timer> JMG_Remove_Self_On_Timer("JMG_Remove_Self_On_Timer","Time:float");
ScriptRegistrant<JMG_RP2_Freezer_Burn> JMG_RP2_Freezer_Burn("JMG_RP2_Freezer_Burn","Weapon:string,Explosion:string");
ScriptRegistrant<JMG_RP2_Random_Splatters> JMG_RP2_Random_Splatters("JMG_RP2_Random_Splatters","Damage_Amount:float,Splatter_Name:string,Number_Of_Random_Splatters:int");
ScriptRegistrant<JMG_RP2_Vehicle_Entry_Control> JMG_RP2_Vehicle_Entry_Control("JMG_RP2_Vehicle_Entry_Control","");
//ScriptRegistrant<JMG_Real_Plane_Physics> JMG_Real_Plane_Physics("JMG_Real_Plane_Physics","");
ScriptRegistrant<JMG_Advanced_Poke_Send_Custom> JMG_Advanced_Poke_Send_Custom("JMG_Advanced_Poke_Send_Custom","ID=0:int,Message:int,Param=0:int,Sound_Name=null:string,Poke_Animation=null:string,LastFrame=0:float,Player_Type=2:int");
ScriptRegistrant<JMG_Play_Animation_On_Zone> JMG_Play_Animation_On_Zone("JMG_Play_Animation_On_Zone","Player_Type=2:int,TriggerOnEnter=0:int,TriggerOnExit=0:int,Animation=null:string,Sound_Name=null:string,LastFrame=0:float,Damage=0,Damage_Type=BlamoKiller:string");
ScriptRegistrant<JMG_Weapon_Give_Powerup> JMG_Weapon_Give_Powerup("JMG_Weapon_Give_Powerup","Weapon:string,Powerup:string");
ScriptRegistrant<JMG_War_Blitz_Create> JMG_War_Blitz_Create("JMG_War_Blitz_Create","War_Blitz_Intensity=0.000:float,Start_Distance=0.000:float,End_Distance=1.000:float,War_Blitz_Heading=0.000:float,War_Blitz_Distribution=1.000:float,Delay=0.000:float,OnCreate=0:int,OnDestroy=0:int");
ScriptRegistrant<JMG_Keyboard_Input_Custom_ID_Veh> JMG_Keyboard_Input_Custom_ID_Veh("JMG_Keyboard_Input_Custom_ID_Veh","Key:string,Message:int,ID:int");
ScriptRegistrant<JMG_Keyboard_Vehicle_Input_Custom> JMG_Keyboard_Vehicle_Input_Custom("JMG_Keyboard_Vehicle_Input_Custom","Key:string,Message:int,User=0:int");
ScriptRegistrant<JMG_Play_Reload_Sound_On_Last_Shot> JMG_Play_Reload_Sound_On_Last_Shot("JMG_Play_Reload_Sound_On_Last_Shot","Weapon:string,Reload_Time:float,Sound_Name:string");
ScriptRegistrant<JMG_RP2_Teleport_Zone_Script> JMG_RP2_Teleport_Zone_Script("JMG_RP2_Teleport_Zone_Script","TeleportLocation:Vector3,Object_ID=0:int,Enter_Rotation=0.0:float,Exit_Rotation=0.0:float,Enter_Animation=s_a_human.h_a_a0b1:string,Exit_Animation=s_a_human.walkinanim:string,Enter_Path_Animation=walkin:string,Exit_Path_Animation=walkout:string,Bone_Attach_Name=humanpos:string");
ScriptRegistrant<JMG_RP2_Teleport_Zone_Script_Attach> JMG_RP2_Teleport_Zone_Script_Attach("JMG_RP2_Teleport_Zone_Script_Attach","X:float,Y:float,Z:float,Enter_Rotation:float,Exit_Rotation:float,Enter_Animation:string,Exit_Animation:string,Enter_Path_Animation:string,Exit_Path_Animation:string,Bone_Attach_Name:string");
ScriptRegistrant<JMG_RP2_Renhalo_Vortex> JMG_RP2_Renhalo_Vortex("JMG_RP2_Renhalo_Vortex","");
ScriptRegistrant<JMG_Find_And_Write_Positions> JMG_Find_And_Write_Positions("JMG_Find_And_Write_Positions","File_Name:string");
ScriptRegistrant<JMG_Send_Message_Until_Message_Reccived> JMG_Send_Message_Until_Message_Reccived("JMG_Send_Message_Until_Message_Reccived","ID:int,Message:int,Message_to_Reccive:int");
ScriptRegistrant<JMG_Random_Teleport_Zone_File> JMG_Random_Teleport_Zone_File("JMG_Random_Teleport_Zone_File","File_Name:string,NumberofLocations:int,UseSecurity=0:int,SecurityCodeM=0.000:float,SecurityCodeS=0.000:float,SecurityCodeO=0.000:float,SecurityCodeR=0.000:float");
ScriptRegistrant<JMG_Security_Printout_For_Teleport_Zone> JMG_Security_Printout_For_Teleport_Zone("JMG_Security_Printout_For_Teleport_Zone","File_Name:string,NumberofLocations:int");
ScriptRegistrant<JMG_Set_Rotation_To_Nearest_Soldier> JMG_Set_Rotation_To_Nearest_Soldier("JMG_Set_Rotation_To_Nearest_Soldier","");
ScriptRegistrant<JMG_RP2_Network_Link_Beacon> JMG_RP2_Network_Link_Beacon("JMG_RP2_Network_Link_Beacon","");
ScriptRegistrant<JMG_Set_Ammo_On_Enter_Reset_On_Exit> JMG_Set_Ammo_On_Enter_Reset_On_Exit("JMG_Set_Ammo_On_Enter_Reset_On_Exit","Weapon:string,Bullets:int,Clip_Bullets:int");
ScriptRegistrant<JMG_Send_Custom_With_ID_Of_Enter_Or_Exiter> JMG_Send_Custom_With_ID_Of_Enter_Or_Exiter("JMG_Send_Custom_With_ID_Of_Enter_Or_Exiter","ID:int,Enter_Message:int,Exit_Message:int");
ScriptRegistrant<JMG_Change_Or_Reset_Sender_Ammo_On_Custom> JMG_Change_Or_Reset_Sender_Ammo_On_Custom("JMG_Change_Or_Reset_Sender_Ammo_On_Custom","Weapon:string,Bullets:int,Clip_Bullets:int,Set_Ammo_Message:int,Reset_Ammo_Message:int");
ScriptRegistrant<JMG_Play_Animation_On_Create> JMG_Play_Animation_On_Create("JMG_Play_Animation_On_Create","Animation:string");
ScriptRegistrant<JMG_Set_Random_Rotation> JMG_Set_Random_Rotation("JMG_Set_Random_Rotation","");
ScriptRegistrant<JMG_Random_Explosive_Barrel> JMG_Random_Explosive_Barrel("JMG_Random_Explosive_Barrel","");
ScriptRegistrant<JMG_Dont_Be_A_Douche> JMG_Dont_Be_A_Douche("JMG_Dont_Be_A_Douche","Effect_Time=5.00:float");
ScriptRegistrant<JMG_RP2_Drown_Time_Modifier> JMG_RP2_Drown_Time_Modifier("JMG_RP2_Drown_Time_Modifier","Drown_Time=15:int");
ScriptRegistrant<JMG_Grant_Powerup_To_Vehicle_Owner> JMG_Grant_Powerup_To_Vehicle_Owner("JMG_Grant_Powerup_To_Vehicle_Owner","Powerup:string,Weapon_Name=placeholder:string,Cost=0:int,Weapon_Size=0:int");
ScriptRegistrant<JMG_Remove_Object_When_Creator_Destroyed> JMG_Remove_Object_When_Creator_Destroyed("JMG_Remove_Object_When_Creator_Destroyed","Creator_ID:int");
ScriptRegistrant<JMG_Enable_Flash_Light_On_Pickup> JMG_Enable_Flash_Light_On_Pickup("JMG_Enable_Flash_Light_On_Pickup","");
ScriptRegistrant<JMG_RP2_Nod_PT_Zone> JMG_RP2_Nod_PT_Zone("JMG_RP2_Nod_PT_Zone","");
ScriptRegistrant<JMG_RP2_GDI_PT_Zone> JMG_RP2_GDI_PT_Zone("JMG_RP2_GDI_PT_Zone","");
ScriptRegistrant<JMG_Remove_Object_When_Timer_Expired> JMG_Remove_Object_When_Timer_Expired("JMG_Remove_Object_When_Timer_Expired","Time:float");
ScriptRegistrant<JMG_Swimming_Water_Effects_Script> JMG_Swimming_Water_Effects_Script("JMG_Swimming_Water_Effects_Script","SwimmerID:int,Invisible_Box_Object:string,Surface_Water_Effect:string,Underwater_Effect:string,Surface_Swim_Sound:string,Underwater_Swim_Sound:string");
ScriptRegistrant<JMG_Do_Not_Drive_In_Water> JMG_Do_Not_Drive_In_Water("JMG_Do_Not_Drive_In_Water","DamageAmount:float");
ScriptRegistrant<JMG_Scuba_Tank_Powerup> JMG_Scuba_Tank_Powerup("JMG_Scuba_Tank_Powerup","Tank_Type=0:int,Max_Pressure_Add=60:int");
ScriptRegistrant<JMG_Send_Custom_To_Self_On_Timer> JMG_Send_Custom_To_Self_On_Timer("JMG_Send_Custom_To_Self_On_Timer","Message:int,Param:int,Time:float,Timer_Number:int,Repeat:int");
ScriptRegistrant<JMG_RP2_Ferriswheel_Script> JMG_RP2_Ferriswheel_Script("JMG_RP2_Ferriswheel_Script","ID:int");//WIll be reenabled upon 4.0's release
ScriptRegistrant<JMG_RP2_Death_Match_PT_Assister> JMG_RP2_Death_Match_PT_Assister("JMG_RP2_Death_Match_PT_Assister","Creator_ID:int,Creator_Team:int");
ScriptRegistrant<JMG_Random_Facing_On_Create> JMG_Random_Facing_On_Create("JMG_Random_Facing_On_Create","");
ScriptRegistrant<JMG_Move_And_Then_Remove_When_Creator_Removed> JMG_Move_And_Then_Remove_When_Creator_Removed("JMG_Move_And_Then_Remove_When_Creator_Removed","Creator_ID:int");
ScriptRegistrant<JMG_Create_Object_Attach_Script_Random_Facing> JMG_Create_Object_Attach_Script_Random_Facing("JMG_Create_Object_Attach_Script_Random_Facing","Preset:string,Script:string,Params:string,Delim:string");
ScriptRegistrant<JMG_RP2_Helicopter_Drop_Off_AI> JMG_RP2_Helicopter_Drop_Off_AI("JMG_RP2_Helicopter_Drop_Off_AI","Vehicle_Preset:string");
ScriptRegistrant<JMG_Helicopter_AI_Beacon> JMG_Helicopter_AI_Beacon("JMG_Helicopter_AI_Beacon","Preset=Nod_Transport_Helicopter:string,Script=JMG_RP2_Helicopter_Drop_Off_AI:string,Params=0:string,Delim=@:string");
ScriptRegistrant<JMG_Buy_Weapon_On_Poke_Advanced> JMG_Buy_Weapon_On_Poke_Advanced("JMG_Buy_Weapon_On_Poke_Advanced","Weapon_Powerup=null:string,Weapon_Size=0:int,Weapon_Cost=0:int,Bullet_Cost=0:int,Buy_Sound=null:string,Declined_Sound=null:string");
ScriptRegistrant<JMG_Buy_Armor_On_Poke_Advanced> JMG_Buy_Armor_On_Poke_Advanced("JMG_Buy_Armor_On_Poke_Advanced","Armor_Points_To_Grant=50.000:float,Cost_For_1_Armor=1:int");
ScriptRegistrant<JMG_Visible_Infantry_In_Vehicle2> JMG_Visible_Infantry_In_Vehicle2("JMG_Visible_Infantry_In_Vehicle2","Message:int,Animation:string");
ScriptRegistrant<JMG_Advanced_Visible_Driver> JMG_Advanced_Visible_Driver("JMG_Advanced_Visible_Driver","Default_Animation:int,BoneName:string,Driver_Animation=0:int,Debug=0:int");
ScriptRegistrant<JMG_RP2_Random_Teleport_Zone> JMG_RP2_Random_Teleport_Zone("JMG_RP2_Random_Teleport_Zone","Object_ID_1=0:int,Object_ID_2=0:int,Object_ID_3=0:int,Object_ID_4=0:int,Object_ID_5=0:int");
ScriptRegistrant<JMG_RP2_Cop_Arrest_Script> JMG_RP2_Cop_Arrest_Script("JMG_RP2_Cop_Arrest_Script","");
ScriptRegistrant<JMG_Jail_Cell_Control> JMG_Jail_Cell_Control("JMG_Jail_Cell_Control","");
ScriptRegistrant<JMG_Renhalo_Dart_Gun_Script> JMG_Renhalo_Dart_Gun_Script("JMG_Renhalo_Dart_Gun_Script","");
ScriptRegistrant<JMG_Jerad_Energy_Shield> JMG_Jerad_Energy_Shield("JMG_Jerad_Energy_Shield","");
ScriptRegistrant<JMG_RP2_Jerad> JMG_RP2_Jerad("JMG_RP2_Jerad","");
ScriptRegistrant<JMG_Keyboard_Input_Custom_ID_Veh2> JMG_Keyboard_Input_Custom_ID_Veh2("JMG_Keyboard_Input_Custom_ID_Veh2","Key:string,Message:int,Param:int");
ScriptRegistrant<JMG_Vehicle_Key_Custom> JMG_Vehicle_Key_Custom("JMG_Vehicle_Key_Custom","Message:int,Send_Message:int");
ScriptRegistrant<JMG_Switch_Weapon> JMG_Switch_Weapon("JMG_Switch_Weapon","Weapon:string,Time=0:float,TimerNumber=0:int,Message=0:int");
ScriptRegistrant<JMG_Health_Regen_Fixed> JMG_Health_Regen_Fixed("JMG_Health_Regen_Fixed","Time:float,TimerNum:int,Points:float");
ScriptRegistrant<JMG_Check_Model_Match_Or_Change> JMG_Check_Model_Match_Or_Change("JMG_Check_Model_Match_Or_Change","Time:float,TimerNum:int,Set_Model:string");
ScriptRegistrant<JMG_RP2_Throw_Script> JMG_RP2_Throw_Script("JMG_RP2_Throw_Script","Invisible_Box_Object:string,Number_Of_Random_Throws=1:int,Models_Throw_Small:string,Models_Throw_Medium:string,Models_Throw_Large:string,AttachThrowBone:string,MinDamageAmount=50.00:float,MediumDamageAmount=75.00:float,HighDamageAmount=100.00:float");
ScriptRegistrant<JMG_RP2_Teleport_On_Poke> JMG_RP2_Teleport_On_Poke("JMG_RP2_Teleport_On_Poke","TeleportLocation:Vector3,Object_ID=0:int,Enter_Rotation=0.0:float,Exit_Rotation=0.0:float,Enter_Animation=s_a_human.h_a_a0b1:string,Exit_Animation=s_a_human.walkinanim:string,Enter_Path_Animation=walkin:string,Exit_Path_Animation=walkout:string,Bone_Attach_Name=humanpos:string,Poke_Sound=null:string");
ScriptRegistrant<JMG_RP2_Elevator_Control> JMG_RP2_Elevator_Control("JMG_RP2_Elevator_Control","Switch_Poked_Message:int,Elevator_ID:int,Animation:string,Time:int,TimerNum:int,Add_Switch_Array_Message:int,Evtr_Swth_Move_Down_Model:string,Evtr_Swth_Move_Up_Model:string,Evtr_Swth_Up_Model:string,Evtr_Swth_Down_Model:string");
ScriptRegistrant<JMG_RP2_Create_Elevator_Switch_Attach_To_Bone> JMG_RP2_Create_Elevator_Switch_Attach_To_Bone("JMG_RP2_Create_Elevator_Switch_Attach_To_Bone","Create_Object:string,Attach_To_Object_ID:int,Attach_Bone:string,Poke_Message:int,Add_Array_Message:int");
ScriptRegistrant<JMG_Mindless_Zombie_Hunt> JMG_Mindless_Zombie_Hunt("JMG_Mindless_Zombie_Hunt","");
ScriptRegistrant<JMG_Attach_Script_To_All_Players> JMG_Attach_Script_To_All_Players("JMG_Attach_Script_To_All_Players","Script:string,Params:string,Delim:string");
//ScriptRegistrant<JMG_Renegade_Mutation_Mode> JMG_Renegade_Mutation_Mode("JMG_Renegade_Mutation_Mode","Spawn_Message=51191150:int,Suicide_Message=91191190:int,Killed_Message=91191191:int,Betrayed_Message=91191192:int");
//ScriptRegistrant<JMG_Renegade_Mutation_Mode_Infantry_Controller> JMG_Renegade_Mutation_Mode_Infantry_Controller("JMG_Renegade_Mutation_Mode_Infantry_Controller","Controller_ID:int,Spawn_Message:int,Suicide_Message:int,Killed_Message:int,Betrayed_Message:int");
//ScriptRegistrant<JMG_Renegade_Mutation_Mode_Start_Game_Key> JMG_Renegade_Mutation_Mode_Start_Game_Key("JMG_Renegade_Mutation_Mode_Start_Game_Key","Key:string,Message:int,ID:int");
ScriptRegistrant<JMG_Simple_Timed_Heal_Regen> JMG_Simple_Timed_Heal_Regen("JMG_Simple_Timed_Heal_Regen","Time:float,TimerNum:int,Add_Life:float");
ScriptRegistrant<JMG_RP2_Submarine_Script> JMG_RP2_Submarine_Script("JMG_RP2_Submarine_Script","");
ScriptRegistrant<JMG_Player_Path_Creator> JMG_Player_Path_Creator("JMG_Player_Path_Creator","");
//ScriptRegistrant<JMG_RP2_AI_Path_Controller> JMG_RP2_AI_Path_Controller("JMG_RP2_AI_Path_Controller","Path File=FinishedPathNetwork.txt:string");
//ScriptRegistrant<JMG_RP2_Follow_User_Made_Path_AI> JMG_RP2_Follow_User_Made_Path_AI("JMG_RP2_Follow_User_Made_Path_AI","Controller_ID:int");
ScriptRegistrant<JMG_Single_Player_Only_Script> JMG_Single_Player_Only_Script("JMG_Single_Player_Only_Script","");
ScriptRegistrant<JMG_Set_Position_On_Create> JMG_Set_Position_On_Create("JMG_Set_Position_On_Create","Position:Vector3");
ScriptRegistrant<JMG_RP2_Chinook_Door_Control> JMG_RP2_Chinook_Door_Control("JMG_RP2_Chinook_Door_Control","");
ScriptRegistrant<JMG_RP2_Vehicle_Animate_While_Firing> JMG_RP2_Vehicle_Animate_While_Firing("JMG_RP2_Vehicle_Animate_While_Firing","");
ScriptRegistrant<JMG_RP2_Air_Craft_Cloud_Script> JMG_RP2_Air_Craft_Cloud_Script("JMG_RP2_Air_Craft_Cloud_Script","Cloud_Emitter_Name:string");
ScriptRegistrant<JMG_Change_Armor_Type_On_Timer> JMG_Change_Armor_Type_On_Timer("JMG_Change_Armor_Type_On_Timer","Time:float,TimerNum:int,ArmorType:string");
ScriptRegistrant<JMG_Simple_Prone_On_Custom> JMG_Simple_Prone_On_Custom("JMG_Simple_Prone_On_Custom","ProneMessage:int,GotoProneAnimation:string,LastFrame:float,TimerNum:int,ZMoveAmount:float,ProneAnimation:string,ReverseGoProneAnimaton:int");
ScriptRegistrant<JMG_Enter_Console_Command_On_Create> JMG_Enter_Console_Command_On_Create("JMG_Enter_Console_Command_On_Create","ConsoleMessage1=0:string,ConsoleMessage2=0:string,ConsoleMessage3=0:string,ConsoleMessage4=0:string,ConsoleMessage5=0:string");
ScriptRegistrant<JMG_Swimming_Underwater_Effect_Script> JMG_Swimming_Underwater_Effect_Script("JMG_Swimming_Underwater_Effect_Script","Effect_W3D_Name:string,Attach_Bone_Name=null:string,Random_Effect_Placement_Distance=0.0:float,Effect_Enable_Depth=0.0:float,Effect_Disable_Depth=-1.0:float,Effect_Locked_At_Surface=0:int,Water_Surface_Height=-22.00:float");
ScriptRegistrant<JMG_Visible_Infantry_In_Vehicle_Attach_Script> JMG_Visible_Infantry_In_Vehicle_Attach_Script("JMG_Visible_Infantry_In_Vehicle_Attach_Script","PlayerID:int,VehicleID:int,Animation:string,Frame:float,IsDamagable:int,IsDriver:int,WheelBoneName:string");
ScriptRegistrant<JMG_Vehicle_Occupant_Visible_And_Damageable> JMG_Vehicle_Occupant_Visible_And_Damageable("JMG_Vehicle_Occupant_Visible_And_Damageable","VisibleDriverPreset=Daves_Arrow_NT:string,BoneName=fakeseat:string,DefaultAnimation=NULL:string,DriverAnimationOverride=NULL:string,TurnSteeringWheel=0:int,IsDamagable=1:int,SelectRandomAnimation=-1:int,LockAtFrame=-1.00:float,WheelBoneName=WheelP00ES:string,Debug=0:int");
ScriptRegistrant<JMG_Object_Toggle_On_Vehicle_Enter_Exit> JMG_Object_Toggle_On_Vehicle_Enter_Exit("JMG_Object_Toggle_On_Vehicle_Enter_Exit","BoneName=Headlight:string,Preset=Vehicle_Headlight:string,ObjectCount=2:int,ObjectType=1:int,ObjectControllerID=135753:int");
ScriptRegistrant<JMG_Object_Toggle_On_Vehicle_Enter_Exit_Controller> JMG_Object_Toggle_On_Vehicle_Enter_Exit_Controller("JMG_Object_Toggle_On_Vehicle_Enter_Exit_Controller","ObjectType:int,Enable=0:int");
ScriptRegistrant<JMG_Repair_Zone> JMG_Repair_Zone("JMG_Repair_Zone","Repair_Delay=0.01:float,Damage_Halt_Repair_Time=10:int,Add_Health=1:int,Add_Armor=1:int,Heath_Repair_Cost=0:int,Armor_Repair_Cost=0:int,Health_Repair_Sound_Time=0.0:float,Armor_Repair_Sound_Time=0.0:float,Health_Repair_Sound=null:string,Armor_Repair_Sound=null:string");
ScriptRegistrant<JMG_Repair_Zone_Attach_Script> JMG_Repair_Zone_Attach_Script("JMG_Repair_Zone_Attach_Script","Time:float,Damage_Halt_Repair_Time:int,Add_Health:int,Add_Armor:int,Heath_Repair_Cost:int,Armor_Repair_Cost:int,Health_Repair_Sound_Time=0.0:float,Armor_Repair_Sound_Time=0.0:float,Health_Repair_Sound:string,Armor_Repair_Sound:string");
ScriptRegistrant<JMG_Vehicle_Sell_Price> JMG_Vehicle_Sell_Price("JMG_Vehicle_Sell_Price","Price:int,Message=2497133:int,ReturnMessage=243057:int");
ScriptRegistrant<JMG_Attach_Script_To_All_Specified_Presets> JMG_Attach_Script_To_All_Specified_Presets("JMG_Attach_Script_To_All_Specified_Presets","Preset:string,Script:string,Params:string,Delim:string,Time:float,TimerNum:int");
ScriptRegistrant<JMG_RP2_Random_Civilian_Model> JMG_RP2_Random_Civilian_Model("JMG_RP2_Random_Civilian_Model","");
ScriptRegistrant<JMG_Sell_Vehicle_On_Custom> JMG_Sell_Vehicle_On_Custom("JMG_Sell_Vehicle_On_Custom","SellKeyMessage:int,CostRequestMessage:int,PriceReturnedMessage:int,SellSound:string,HealthValueRatio:float,ArmorValueRatio:float,MinimumSellCondition:float,Sell_Explosion:string");
ScriptRegistrant<JMG_Vehicle_Sell_Zone> JMG_Vehicle_Sell_Zone("JMG_Vehicle_Sell_Zone","SellKeyMessage=56565657:int,CostRequestMessage=2497133:int,PriceReturnedMessage=243057:int,SellSound=null:string,HealthValueRatio=0.5:float,ArmorValueRatio=0.5:float,MinimumSellCondition=0.0:float,Sell_Explosion=null:string");
ScriptRegistrant<JMG_Buy_Preset_On_Poke> JMG_Buy_Preset_On_Poke("JMG_Buy_Preset_On_Poke","Preset=null:string,Location:Vector3,Facing=0.0:float,DeathZoneID=0:int,Cost=0:int,InadequateFundsSound=null:string,BuySound=null:string,Time=0.0:float,TimerNum=0:int,Player_Type=2:int");
ScriptRegistrant<JMG_RP2_Vehicle_Door_Script> JMG_RP2_Vehicle_Door_Script("JMG_RP2_Vehicle_Door_Script","Animation:string,LastFrame:float");
ScriptRegistrant<JMG_Simple_Vehicle_Fire_Animation_Script> JMG_Simple_Vehicle_Fire_Animation_Script("JMG_Simple_Vehicle_Fire_Animation_Script","TimerNum:int,Animation:string,LastFrame:float");
ScriptRegistrant<JMG_Kill_All_In_Range_On_Create> JMG_Kill_All_In_Range_On_Create("JMG_Kill_All_In_Range_On_Create","DamageRange:float");
ScriptRegistrant<JMG_Kill_All_In_Range_On_Create_If_Above> JMG_Kill_All_In_Range_On_Create_If_Above("JMG_Kill_All_In_Range_On_Create_If_Above","DamageRange:float,KillSelf=0:int");
ScriptRegistrant<JMG_Kill_Nearest_Unit_Type_When_Stuck> JMG_Kill_Nearest_Unit_Type_When_Stuck("JMG_Kill_Nearest_Unit_Type_When_Stuck","ObjectName:string,Time:float,TimerNum:int");
ScriptRegistrant<JMG_Return_Fire_On_Damager> JMG_Return_Fire_On_Damager("JMG_Return_Fire_On_Damager","Max_Distance:float,Max_Weapon_Range:float,Innate_Disabled=1:int");
ScriptRegistrant<JMG_Return_Fire_On_Damager_2> JMG_Return_Fire_On_Damager_2("JMG_Return_Fire_On_Damager_2","Max_Distance:float,Max_Weapon_Range:float,Proxy_Range:float,Ignore_Team=3:int,Innate_Disabled=1:int,TimerNum:int,Pathfind=1:int");
ScriptRegistrant<JMG_Motion_Mine_Script> JMG_Motion_Mine_Script("JMG_Motion_Mine_Script","Safe_Time:float,Active_Mine_Model:string,Max_Mine_Detect_Range:float,Max_Safe_Speed:float,Mine_Explosion:string,Timer_Number:int");
ScriptRegistrant<JMG_Attach_Script_Collector_Once> JMG_Attach_Script_Collector_Once("JMG_Attach_Script_Collector_Once","Script:string,Params:string,Delim:string");
ScriptRegistrant<JMG_RP2_Player_Phone_Control_Script> JMG_RP2_Player_Phone_Control_Script("JMG_RP2_Player_Phone_Control_Script","");
//ScriptRegistrant<JMG_RP2_Phone_Number_Message> JMG_RP2_Phone_Number_Message("JMG_RP2_Phone_Number_Message","PhoneNumber:string,NumberOfDigits=10:int,Message:int,Description=null:string,ShowDescriptionInHelp=1:int");
ScriptRegistrant<JMG_Attach_Script_To_Poker> JMG_Attach_Script_To_Poker("JMG_Attach_Script_To_Poker","Script:string,Params:string,Delim:string");
ScriptRegistrant<JMG_Phone_Create_Cinematic_At_Custom_Sender_Position> JMG_Phone_Create_Cinematic_At_Custom_Sender_Position("JMG_Phone_Create_Cinematic_At_Custom_Sender_Position","Message:int,CinematicFile:string");
ScriptRegistrant<JMG_RP2_Phone_Enable_Zone> JMG_RP2_Phone_Enable_Zone("JMG_RP2_Phone_Enable_Zone","");
ScriptRegistrant<JMG_RP2_Phone_Disable_Zone> JMG_RP2_Phone_Disable_Zone("JMG_RP2_Phone_Disable_Zone","");
ScriptRegistrant<JMG_RP2_Phone_Disabled_While_In_Zone> JMG_RP2_Phone_Disabled_While_In_Zone("JMG_RP2_Phone_Disabled_While_In_Zone","");
ScriptRegistrant<JMG_RP2_Phone_Advanced_Phone_Number_Control_System> JMG_RP2_Phone_Advanced_Phone_Number_Control_System("JMG_RP2_Phone_Advanced_Phone_Number_Control_System","Script_ID=0:int,Phone_Number:string,Number_Of_Digits=10:int,Description=null:string,Show_In_Menu=1:int,Pickup_Delay=4.0:float,Max_Random_Pickup_Delay=4.0:float,Max_Callers=2:int,Require_Confirmation=0:int,Cost=0:int,Message=0:int,Charge_Per_Minute=0:int,Charge_Per_Second=0:int,Max_Call_Duration=60:int");
ScriptRegistrant<JMG_RP2_Phone_Create_Preset_At_Sender_Player> JMG_RP2_Phone_Create_Preset_At_Sender_Player("JMG_RP2_Phone_Create_Preset_At_Sender_Player","Message:int,Preset:string,Add_Z:float");
ScriptRegistrant<JMG_RP2_Phone_Play_Sound_At_Sender_Player> JMG_RP2_Phone_Play_Sound_At_Sender_Player("JMG_RP2_Phone_Play_Sound_At_Sender_Player","Message:int,Sound:string");
ScriptRegistrant<JMG_RP2_Phone_Hidden_Number_Allow_Display> JMG_RP2_Phone_Hidden_Number_Allow_Display("JMG_RP2_Phone_Hidden_Number_Allow_Display","AddPlayerMessage:int,Description=null:string");
ScriptRegistrant<JMG_RP2_Phone_Add_Number_To_List_Zone> JMG_RP2_Phone_Add_Number_To_List_Zone("JMG_RP2_Phone_Add_Number_To_List_Zone","Message:int");
ScriptRegistrant<JMG_Custom_Multiplier> JMG_Custom_Multiplier("JMG_Custom_Multiplier","Message:int,Number_Of_Output_Customs:int");
ScriptRegistrant<JMG_Grant_Weapon_On_Weapon> JMG_Grant_Weapon_On_Weapon("JMG_Grant_Weapon_On_Weapon","Damager_Weapon:string,Damage_Amount:float,Powerup_Name:string");
ScriptRegistrant<JMG_New_Swimming_Water_Type> JMG_New_Swimming_Water_Type("JMG_New_Swimming_Water_Type","Water_Type:int,ScreenRed=0.28:float,ScreenGreen=0.43:float,ScreenBlue=0.55:float,AddRedAmount=0.01:float,AddGreenAmount=-0.01:float,AddBlueAmount=-0.01:float,WaterMaxViewRange=150.0:float,WaterTranslucency=90.0:float,Depth_Before_Water_Darkens=150.00:float,Small_Splash=Splash_Small:string,Medium_Splash=Splash_Medium:string,Large_Splash=Splash_Large:string,Huge_Splash=Splash_Huge:string,Underwater_Effect_Controller=Invisible_Box_NR:string,Surface_Water_Effect=swimsurface:string,Underwater_Effect=swimunderwat:string,Water_Surface_Ambient_Sound=WaterSurfaceST:string,Underwater_Ambient_Sound=WaterUnderST:string,Scuba_Mask_Emitter=maskbubble:string,VehicleScreenRed=0.28:float,VehicleScreenGreen=0.43:float,VehicleScreenBlue=0.55:float,VehicleWaterMaxViewRange=150.0:float,VehicleWaterTranslucency=90.0:float,VehicleWaterDamage=1.0:float,SwimmingAnimationTypeOverride=0:int,InfantryWaterDamage=0.0:float,InfantryWaterDamageDelay=0:int");
ScriptRegistrant<JMG_New_Swimming_Animation_Type> JMG_New_Swimming_Animation_Type("JMG_New_Swimming_Animation_Type","Swimming_Animation_Type:int,Skeleton=s_a_human:string,Animation_Name=jg_swim_:string,Not_Moving=i:string,Forward=f:string,Backward=b:string,Turn_Left=tl:string,Turn_Right=tr:string,Up=u:string,Down=d:string,Tilt_Up=tu:string,Tilt_Down=td:string,Tilt_Up_Backward=bu:string,Tilt_Down_Backward=bd:string,Swim_Left=l:string,Swim_Left_Tilt_Up=lu:string,Swim_Left_Tilt_Down=ld:string,Swim_Right=r:string,Swim_Right_Tilt_Up=ru:string,Swim_Right_Tilt_Down=rd:string,Not_Moving_Surface=s:string,Forward_Surface=fs:string,Backward_Surface=bs:string,Turn_Left_Surface=rl:string,Turn_Right_Surface=rr:string,Left_Surface=ls:string,Right_Surface=rs:string");
ScriptRegistrant<JMG_New_Swimming_Script> JMG_New_Swimming_Script("JMG_New_Swimming_Script","Can_Swim=1:int,AnimationType=0:int,Drown_Time=15:int,Starting_Scuba_Tank_Air_Ammount=0:int,Drown_Damage_Percent_Ratio=0.0:float,Invisible_Box_Object=Invisible_Box:string,Swimming_Height_Adjust_Model=HeightAdjust:string,Swimming_Weapon=Weapon_Empty_Hands:string,Swimming_Weapon_Powerup=POW_Empty_Hands:string,Breath_Sound=Breath_Sound:string,Urgent_Breath_Sound=Gasp_For_Breath_Sound:string,Scuba_Refill_Sound=TankRefillSound:string,Heart_Beat_Loop_Sound=HeartBeatSound:string,Default_Model_Override=null:string,Swimming_Model_Override=null:string,Swimming_Skin=None:string,Swimming_Damage_Warhead=None:string,Drown_Damage_Health_And_Shield=0:int,Underwater_Death_Sound=null:string,Drown_Sound=null:string,Allow_Splash_Effects=1:int");
ScriptRegistrant<JMG_New_Swimming_Head_Attach_Script> JMG_New_Swimming_Head_Attach_Script("JMG_New_Swimming_Head_Attach_Script","PlayerID:int");
ScriptRegistrant<JMG_New_Swimming_Attach_Script> JMG_New_Swimming_Attach_Script("JMG_New_Swimming_Attach_Script","ID:int,AnimationType:int,Underwater_Effect_Controller:string,Surface_Water_Effect:string,Underwater_Effect:string,Water_Surface_Ambient_Sound:string,Underwater_Ambient_Sound:string,UnderWater:int,Swimming_Damage_Warhead:string,Allow_Splash_Effects:int");
ScriptRegistrant<JMG_New_Swimming_Zone> JMG_New_Swimming_Zone("JMG_New_Swimming_Zone","Water_Zone_Type:int");
ScriptRegistrant<JMG_New_Swimming_Scuba_Tank_Type> JMG_New_Swimming_Scuba_Tank_Type("JMG_New_Swimming_Scuba_Tank_Type","ScubaGearType=0:int,TankModel=null:string,AttachBone=null:string,HoldAirAmount=60:int,UpgradeMaxAir=0:int,EmitsBubbles=1:int,PurchaseCost=0:int,TankHealth=5:float,TankArmor=5:float,TankSkin=None:string,TankShield=None:string,SurfaceExplosion=null:string,UnderwaterExplosion=null:string");
ScriptRegistrant<JMG_New_Swimming_Scuba_Tank_Powerup> JMG_New_Swimming_Scuba_Tank_Powerup("JMG_New_Swimming_Scuba_Tank_Powerup","Scuba_Tank_Type=0:int");
ScriptRegistrant<JMG_New_Swimming_Scuba_Tank_Attach_Script> JMG_New_Swimming_Scuba_Tank_Attach_Script("JMG_New_Swimming_Scuba_Tank_Attach_Script","ID:int");
ScriptRegistrant<JMG_RP2_Vehicle> JMG_RP2_Vehicle("JMG_RP2_Vehicle","");
ScriptRegistrant<JMG_RP2_Vehicle_Advanced> JMG_RP2_Vehicle_Advanced("JMG_RP2_Vehicle_Advanced","Water_Fill_Time=300:int,Takes_Water_Damage=1:int,Create_Clouds=0:int");
ScriptRegistrant<JMG_RP2_Special_Death_Control> JMG_RP2_Special_Death_Control("JMG_RP2_Special_Death_Control","");
ScriptRegistrant<JMG_RP2_Phone_Kill_Sender_Player> JMG_RP2_Phone_Kill_Sender_Player("JMG_RP2_Phone_Kill_Sender_Player","Message:int");
ScriptRegistrant<JMG_RP2_House_Key_Control> JMG_RP2_House_Key_Control("JMG_RP2_House_Key_Control","");
ScriptRegistrant<JMG_RP2_Grant_House_Keys_On_Spawn> JMG_RP2_Grant_House_Keys_On_Spawn("JMG_RP2_Grant_House_Keys_On_Spawn","");
ScriptRegistrant<JMG_RP2_Open_Door_On_Poke_And_Key> JMG_RP2_Open_Door_On_Poke_And_Key("JMG_RP2_Open_Door_On_Poke_And_Key","Key:int,Last_Frame:float,Stay_Open_Time:float,Open_Sound=null:string,Close_Sound=null:string,Explosion=null:string");
ScriptRegistrant<JMG_RP2_House_Address_Controller> JMG_RP2_House_Address_Controller("JMG_RP2_House_Address_Controller","HouseAddress:int,Cost:int,RentTime:int");
ScriptRegistrant<JMG_RP2_Phone_House_Phone_Number_Control_System> JMG_RP2_Phone_House_Phone_Number_Control_System("JMG_RP2_Phone_House_Phone_Number_Control_System","Script_ID=0:int,Phone_Number:string,Number_Of_Digits=10:int,Pickup_Delay=4.0:float,Max_Random_Pickup_Delay=4.0:float,Charge_Per_Minute=0:int,Charge_Per_Second=0:int,Max_Call_Duration=60:int");
ScriptRegistrant<JMG_RP2_RailRoad_Crossing_Control_Zone> JMG_RP2_RailRoad_Crossing_Control_Zone("JMG_RP2_RailRoad_Crossing_Control_Zone","CrossingID:int,CrossingOpenFirstFrame:float,CrossingOpenLastFrame:float,CrossingClosingFirstFrame:float,CrossingClosingLastFrame:float,CrossingClosedFirstFrame:float,CrossingClosedLastFrame:float,CrossingOpeningFirstFrame:float,CrossingOpeningLastFrame:float,TrainPresetName=Subway_Car:string");
ScriptRegistrant<JMG_RP2_Street_Sign_Crushable> JMG_RP2_Street_Sign_Crushable("JMG_RP2_Street_Sign_Crushable","Debris_Life_Time=-1.0:float,Knock_Over_Sound=null:string");
ScriptRegistrant<JMG_RP2_Phone_Create_Test_Object> JMG_RP2_Phone_Create_Test_Object("JMG_RP2_Phone_Create_Test_Object","Message:int");
ScriptRegistrant<JMG_RP2_Node_Cleanup> JMG_RP2_Node_Cleanup("JMG_RP2_Node_Cleanup","");
ScriptRegistrant<JMG_RP2_Phone_Teleport_Sender_Player> JMG_RP2_Phone_Teleport_Sender_Player("JMG_RP2_Phone_Teleport_Sender_Player","Message:int,TeleportPosition:Vector3,TeleportFacing:float");
ScriptRegistrant<JMG_Remove_Object_When_Timer_Expired2> JMG_Remove_Object_When_Timer_Expired2("JMG_Remove_Object_When_Timer_Expired2","Time:float");
ScriptRegistrant<JMG_Turret_Attach> JMG_Turret_Attach("JMG_Turret_Attach","Preset:string,Bone_Name:string");
ScriptRegistrant<JMG_Attach_Script_To_All_AI_Infantry> JMG_Attach_Script_To_All_AI_Infantry("JMG_Attach_Script_To_All_AI_Infantry","Script:string,Params:string,Delim:string");
ScriptRegistrant<JMG_Remove_All_AI_Infantry> JMG_Remove_All_AI_Infantry("JMG_Remove_All_AI_Infantry","");
ScriptRegistrant<JMG_Remove_All_Infantry> JMG_Remove_All_Infantry("JMG_Remove_All_Infantry","");
ScriptRegistrant<JMG_RP2_Record_Vehicles_At_End_Of_Game> JMG_RP2_Record_Vehicles_At_End_Of_Game("JMG_RP2_Record_Vehicles_At_End_Of_Game","");
ScriptRegistrant<JMG_RP2_Do_Not_Record_Vehicle> JMG_RP2_Do_Not_Record_Vehicle("JMG_RP2_Do_Not_Record_Vehicle","Remove_Script_On_Entry=0:int");
ScriptRegistrant<JMG_RP2_Please_Record_Vehicle> JMG_RP2_Please_Record_Vehicle("JMG_RP2_Please_Record_Vehicle","");
ScriptRegistrant<JMG_RP2_Create_Vehicles_At_Start_Of_Game> JMG_RP2_Create_Vehicles_At_Start_Of_Game("JMG_RP2_Create_Vehicles_At_Start_Of_Game","");
ScriptRegistrant<JMG_RP2_Checked_If_Recorded_Vehicle_Stuck> JMG_RP2_Checked_If_Recorded_Vehicle_Stuck("JMG_RP2_Checked_If_Recorded_Vehicle_Stuck","CreatePosition:Vector3");
ScriptRegistrant<JMG_RP2_Map_Vehicle_Control> JMG_RP2_Map_Vehicle_Control("JMG_RP2_Map_Vehicle_Control","");
ScriptRegistrant<JMG_RP2_Main_Map_Game_Control> JMG_RP2_Main_Map_Game_Control("JMG_RP2_Main_Map_Game_Control","");
ScriptRegistrant<JMG_RP2_Phone_Player_Phone_Number> JMG_RP2_Phone_Player_Phone_Number("JMG_RP2_Phone_Player_Phone_Number","");
ScriptRegistrant<JMG_RP2_Grant_Powerup_Weapon_Limit> JMG_RP2_Grant_Powerup_Weapon_Limit("JMG_RP2_Grant_Powerup_Weapon_Limit","Real_Powerup_Preset:string,Recreate_If_Grant_Fails=0:int,Bullets=-1:int,Weapon_Size=0:int,Spawn_Time=0.0:float,Random_Spawn_Time=0.0:float,Spawn_Limit:int,Spawn_Count:int");
ScriptRegistrant<JMG_RP2_Decoy_Recreate_Powerup> JMG_RP2_Decoy_Recreate_Powerup("JMG_RP2_Decoy_Recreate_Powerup","PowerUp_Name:string,Real_Powerup_Preset:string,Bullets:int,Weapon_Size:int,MySpawnTime:float,SpawnTime:float,RandomSpawnTime:float,Spawn_Limit:int,Spawn_Count:int");
ScriptRegistrant<JMG_Zone_Remove_Weapon_On_Entry> JMG_Zone_Remove_Weapon_On_Entry("JMG_Zone_Remove_Weapon_On_Entry","Weapon_Name:string");
ScriptRegistrant<JMG_RP2_WLS_Add_Weapon_Type> JMG_RP2_WLS_Add_Weapon_Type("JMG_RP2_WLS_Add_Weapon_Type","Weapon_Name:string,Powerup_Name:string,Fake_Powerup:string,Droppable:int,Weapon_Size:float,Weapon_Cost:int,Bullet_Cost:int,Drop_Height:float,Respawn_Distance:float,Alt_Weapon_Name=null:string,Drop_When_Empty:int,Weapon_Class:int,Drop_Message:int,Weapon_Tier:int,Ammo_Size:float,Can_Favorite:int,Cook_Time:int");
ScriptRegistrant<JMG_RP2_WLS_Buy_Weapon_Poker> JMG_RP2_WLS_Buy_Weapon_Poker("JMG_RP2_WLS_Buy_Weapon_Poker","Weapon_Name:string,Buy_Sound=null:string,Declined_Sound=null:string,Weapon_Cost_Override=0:int,Bullet_Cost_Override=0:int");
ScriptRegistrant<JMG_RP2_WLS_Weapon_Spawner_Control> JMG_RP2_WLS_Weapon_Spawner_Control("JMG_RP2_WLS_Weapon_Spawner_Control","Weapon_Name:string,Spawn_Time=30.0:float,Random_Spawn_Time=10.0:float,Spawn_Limit=-1:int,Grant_Bullets=-1:int");
ScriptRegistrant<JMG_RP2_WLS_Grant_Weapon_Poke> JMG_RP2_WLS_Grant_Weapon_Poke("JMG_RP2_WLS_Grant_Weapon_Poke","Weapon_Name:string,Grant_Bullets=-2:int");
ScriptRegistrant<JMG_RP2_WLS_Grant_Weapon_Poke_Special> JMG_RP2_WLS_Grant_Weapon_Poke_Special("JMG_RP2_WLS_Grant_Weapon_Poke_Special","Weapon_Name:string,Grant_Bullets=-2:int");
ScriptRegistrant<JMG_RP2_WLS_Grant_Weapon> JMG_RP2_WLS_Grant_Weapon("JMG_RP2_WLS_Grant_Weapon","Weapon_Name:string,Grant_Bullets=-2:int");
ScriptRegistrant<JMG_RP2_WLS_Grant_Weapon_Special> JMG_RP2_WLS_Grant_Weapon_Special("JMG_RP2_WLS_Grant_Weapon_Special","Weapon_Name:string,Grant_Bullets=-2:int");
ScriptRegistrant<JMG_RP2_WLS_Buy_Weapon_Vehicle_Owner> JMG_RP2_WLS_Buy_Weapon_Vehicle_Owner("JMG_RP2_WLS_Buy_Weapon_Vehicle_Owner","Weapon_Name:string,Buy_Sound=null:string,Declined_Sound=null:string,Weapon_Cost_Override=0:int,Bullet_Cost_Override=0:int");
ScriptRegistrant<JMG_RP2_WLS_Zone_Remove_Weapon> JMG_RP2_WLS_Zone_Remove_Weapon("JMG_RP2_WLS_Zone_Remove_Weapon","Weapon_Name:string");
ScriptRegistrant<JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit> JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit("JMG_RP2_WLS_New_Grant_Powerup_Weapon_Limit","Weapon_Name:string,Recreate_If_Grant_Fails=0:int,Bullets=-1:int,Spawn_Time=0.0:float,Random_Spawn_Time=0.0:float,Spawn_Limit:int,Spawn_Bullets:int,Powerup_Limited:int");
ScriptRegistrant<JMG_RP2_WLS_New_Decoy_Recreate_Powerup> JMG_RP2_WLS_New_Decoy_Recreate_Powerup("JMG_RP2_WLS_New_Decoy_Recreate_Powerup","Weapon_Name:string,Bullets:int,MySpawnTime:float,SpawnTime:float,RandomSpawnTime:float,Spawn_Limit:int,Spawn_Bullets:int,Powerup_Limited:int");
ScriptRegistrant<JMG_RP2_Set_Up_Weapons_List> JMG_RP2_Set_Up_Weapons_List("JMG_RP2_Set_Up_Weapons_List","");
ScriptRegistrant<JMG_RP2_Housing_Weapons_Cupboard_Zone> JMG_RP2_Housing_Weapons_Cupboard_Zone("JMG_RP2_Housing_Weapons_Cupboard_Zone","CupboardID:int");
ScriptRegistrant<JMG_RP2_Housing_Weapons_Cupboard_WLS> JMG_RP2_Housing_Weapons_Cupboard_WLS("JMG_RP2_Housing_Weapons_Cupboard_WLS","HouseAddress:int");
ScriptRegistrant<JMG_RP2_Weapons_Cupboard_File_Control> JMG_RP2_Weapons_Cupboard_File_Control("JMG_RP2_Weapons_Cupboard_File_Control","");
ScriptRegistrant<JMG_RP2_Screen_Fade_Red_On_Damage> JMG_RP2_Screen_Fade_Red_On_Damage("JMG_RP2_Screen_Fade_Red_On_Damage","");
ScriptRegistrant<JMG_RP2_Phone_Load_Redial_Numbers> JMG_RP2_Phone_Load_Redial_Numbers("JMG_RP2_Phone_Load_Redial_Numbers","");
ScriptRegistrant<JMG_RP2_Submarine_Script_Advanced> JMG_RP2_Submarine_Script_Advanced("JMG_RP2_Submarine_Script_Advanced","Water_Fill_Time=3000:int");
ScriptRegistrant<JMG_RP2_Phone_Attach_Script_To_Sender_Player> JMG_RP2_Phone_Attach_Script_To_Sender_Player("JMG_RP2_Phone_Attach_Script_To_Sender_Player","Message:int,Script:string,Params:string,Delim=@:String");
ScriptRegistrant<JMG_RP2_Display_Message_On_Pickup> JMG_RP2_Display_Message_On_Pickup("JMG_RP2_Display_Message_On_Pickup","PickupMessage:string");
ScriptRegistrant<JMG_RP2_Simple_Smart_Base_Defense> JMG_RP2_Simple_Smart_Base_Defense("JMG_RP2_Simple_Smart_Base_Defense","On_Grid:int,Min_Range:float,Max_Range:float");
ScriptRegistrant<JMG_RP2_Simple_Smart_House_Defense> JMG_RP2_Simple_Smart_House_Defense("JMG_RP2_Simple_Smart_House_Defense","House_Address:int,On_Grid=-1:int,Min_Range:float,Max_Range:float");
ScriptRegistrant<JMG_RP2_Phone_House_Key_Grant_Access_System> JMG_RP2_Phone_House_Key_Grant_Access_System("JMG_RP2_Phone_House_Key_Grant_Access_System","Script_ID=0:int,Phone_Number:string,Number_Of_Digits=10:int,Pickup_Delay=4.0:float,Max_Random_Pickup_Delay=4.0:float,Charge_Per_Minute=0:int,Charge_Per_Second=0:int,Max_Call_Duration=60:int");
ScriptRegistrant<JMG_RP2_Jerads_Strike_Craft> JMG_RP2_Jerads_Strike_Craft("JMG_RP2_Jerads_Strike_Craft","");
ScriptRegistrant<JMG_RP2_Map_Boundry> JMG_RP2_Map_Boundry("JMG_RP2_Map_Boundry","Re-AlignX=-1.0:float,Re-AlignY=-1.0:float,Re-AlignZ=-1.0:float");
ScriptRegistrant<JMG_RP2_SCUD_Launcher_Script> JMG_RP2_SCUD_Launcher_Script("JMG_RP2_SCUD_Launcher_Script","Armed_Model=null:string,Empty_Model=null:string,UnDeployedFrame:float,DeployedFrame:float,Missile_Model_Up=null:string,Missile_Model_Down=null:string");
ScriptRegistrant<JMG_RP2_New_Soldier_Spawn_System> JMG_RP2_New_Soldier_Spawn_System("JMG_RP2_New_Soldier_Spawn_System","");
ScriptRegistrant<JMG_RP2_New_Soldier_Spawn_Allowed_Zone> JMG_RP2_New_Soldier_Spawn_Allowed_Zone("JMG_RP2_New_Soldier_Spawn_Allowed_Zone","Allow_Spawing_After_Enter=1:int");
ScriptRegistrant<JMG_RP2_Simple_Smart_AA_Base_Defense> JMG_RP2_Simple_Smart_AA_Base_Defense("JMG_RP2_Simple_Smart_AA_Base_Defense","On_Grid=-1:int,Min_Range=0.0:float,Max_Range=0.0:float,Min_Flight_Height=50.0:float");
ScriptRegistrant<JMG_RP2_Simple_Smart_AG_Base_Defense> JMG_RP2_Simple_Smart_AG_Base_Defense("JMG_RP2_Simple_Smart_AG_Base_Defense","On_Grid=-1:int,Min_Range=0.0:float,Max_Range=0.0:float,Min_Z_Distance=-50.0:float,Max_Z_Distance=50.0:float");
ScriptRegistrant<JMG_Grant_Powerup_To_Beacon_Planter> JMG_Grant_Powerup_To_Beacon_Planter("JMG_Grant_Powerup_To_Beacon_Planter","Powerup_Preset:string");
ScriptRegistrant<JMG_Send_Custom_To_Beacon_Planter> JMG_Send_Custom_To_Beacon_Planter("JMG_Send_Custom_To_Beacon_Planter","Message:int,Param=0:int,Delay=0.0:float");
ScriptRegistrant<JMG_RP2_Mission_System_New_Mission_Type> JMG_RP2_Mission_System_New_Mission_Type("JMG_RP2_Mission_System_New_Mission_Type","Mission_Type=0:int,Mission_Objective_Count=0:int,Editor_Description=null:string,Display_Mission_Info=1:int,Is_Achievement=0:int,Mission_Reward_Money=0:int,Mission_Reward_Weapon=null:string,Mission_Reward_Inventory=0:int,Mission_Reward_Custom_Message=0:int,Mission_Reward_Health=0:int,Mission_Reward_Armor=0:int,Reset_On[Time|Death|Success]=0.0 0.0 0.0:vector3,Reset_On[ObjectiveOrder|Respawn|NULL]=0.0 0.0 0.0:vector3,Regrant_Rewards[NewGame|Spawn|FirstSpawn]=1.0 0.0 0.0:vector3,Misc_Settings[MaxPlayers|StartObjective|PhoneChoice]=0.0 -1.0 0.0:vector3,CustomMissionEvents[Start|Failed|Successful]=0.0 0.0 0.0:vector3,Mission_Reward_W3D=null:string");//,Fail_On_Vehicle_Entry[Tracked|Wheeled|Motorcycle]=0.0 0.0 0.0:vector3,Fail_On_Vehicle_Entry[VTOL|Boat|Turret]=0.0 0.0 0.0:vector3");
ScriptRegistrant<JMG_RP2_Mission_System_Global_Mission_Controller> JMG_RP2_Mission_System_Global_Mission_Controller("JMG_RP2_Mission_System_Global_Mission_Controller","");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Poke> JMG_RP2_Mission_System_Mission_Objective_Poke("JMG_RP2_Mission_System_Mission_Objective_Poke","Mission_Type=0:int,Objective_Number=-1:int");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Enter> JMG_RP2_Mission_System_Mission_Objective_Enter("JMG_RP2_Mission_System_Mission_Objective_Enter","Mission_Type=0:int,Objective_Number=-1:int,Detect[Human|Vehicle|Aircraft]=1.0 1.0 1.0:vector3");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Kill> JMG_RP2_Mission_System_Mission_Objective_Kill("JMG_RP2_Mission_System_Mission_Objective_Kill","Mission_Type=0:int,Objective_Number=-1:int");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Custom> JMG_RP2_Mission_System_Mission_Objective_Custom("JMG_RP2_Mission_System_Mission_Objective_Custom","Mission_Type=0:int,Objective_Number=-1:int,Message=0:int");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Kill_OAG> JMG_RP2_Mission_System_Mission_Objective_Kill_OAG("JMG_RP2_Mission_System_Mission_Objective_Kill_OAG","Mission_Type=0:int");
ScriptRegistrant<JMG_RP2_Mission_System_Load_Completed_Player_Missions> JMG_RP2_Mission_System_Load_Completed_Player_Missions("JMG_RP2_Mission_System_Load_Completed_Player_Missions","");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Custom_Param> JMG_RP2_Mission_System_Mission_Objective_Custom_Param("JMG_RP2_Mission_System_Mission_Objective_Custom_Param","Mission_Type=0:int,Objective_Number=-1:int,Message=0:int");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Enter_Preset> JMG_RP2_Mission_System_Mission_Objective_Enter_Preset("JMG_RP2_Mission_System_Mission_Objective_Enter_Preset","Mission_Type=0:int,Objective_Number=-1:int,Enter_Preset=null:string,Sell_Vehicle=1:int,CostRequestMessage=2497133:int,PriceReturnedMessage=243057:int,SellSound=Vehicle_Purchase:string,Sell_Explosion=Explosion_Sell_Zone:string");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Enter_Weapon> JMG_RP2_Mission_System_Mission_Objective_Enter_Weapon("JMG_RP2_Mission_System_Mission_Objective_Enter_Weapon","Mission_Type=0:int,Objective_Number=-1:int,Weapon_Name=null:string,Remove_Weapon=1:int");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Vehicle> JMG_RP2_Mission_System_Mission_Objective_Vehicle("JMG_RP2_Mission_System_Mission_Objective_Vehicle","On_Enter[Enable|MissionType|Objective]=0.0 0.0 -1.0:vector3,On_Exit[Enable|MissionType|Objective]=0.0 0.0 -1.0:vector3,Vehicle_Killed[Enable|MissionType|Objective]=0.0 0.0 -1.0:vector3,Vehicle_Killer[Enable|MissionType|Objective]=0.0 0.0 -1.0:vector3");
ScriptRegistrant<JMG_RP2_Mission_System_Phone_Grant_Mission> JMG_RP2_Mission_System_Phone_Grant_Mission("JMG_RP2_Mission_System_Phone_Grant_Mission","Script_ID=169");
ScriptRegistrant<JMG_RP2_Custom_Create_Object_Attach_Script> JMG_RP2_Custom_Create_Object_Attach_Script("JMG_RP2_Custom_Create_Object_Attach_Script","Message:int,Param:int,Preset=null:string,Location:vector3,Facing:float,Script=null:string,Params=null:string,Delim=@:string,DestroyMessage=0:int");
ScriptRegistrant<JMG_RP2_Phone_Main_Map_Runtime_Save> JMG_RP2_Phone_Main_Map_Runtime_Save("JMG_RP2_Phone_Main_Map_Runtime_Save","Script_ID=5556662");
ScriptRegistrant<JMG_RP2_MS_Mission_Objective_Enter_Attach_Script> JMG_RP2_MS_Mission_Objective_Enter_Attach_Script("JMG_RP2_MS_Mission_Objective_Enter_Attach_Script","ZoneID:int,Mission_Type:int,Objective_Number:int");
ScriptRegistrant<JMG_RP2_Load_Random_Teleport_File> JMG_RP2_Load_Random_Teleport_File("JMG_RP2_Load_Random_Teleport_File","File_Name:string");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Damage> JMG_RP2_Mission_System_Mission_Objective_Damage("JMG_RP2_Mission_System_Mission_Objective_Damage","Mission_Type=0:int,Objective_Number=-1:int");
ScriptRegistrant<JMG_RP2_Phone_Banking_System> JMG_RP2_Phone_Banking_System("JMG_RP2_Phone_Banking_System","Script_ID=0:int,Phone_Number=null:string,Number_Of_Digits=10:int,Pickup_Delay=4.0:float,Max_Random_Pickup_Delay=4.0:float,Charge_Per_Minute=0:int,Charge_Per_Second=0:int,Max_Call_Duration=60:int");
ScriptRegistrant<JMG_RP2_Load_Player_Bank_Accounts> JMG_RP2_Load_Player_Bank_Accounts("JMG_RP2_Load_Player_Bank_Accounts","");
ScriptRegistrant<JMG_RP2_Interest_Calculator> JMG_RP2_Interest_Calculator("JMG_RP2_Interest_Calculator","");
ScriptRegistrant<JMG_RP2_Phone_Transfer_Funds> JMG_RP2_Phone_Transfer_Funds("JMG_RP2_Phone_Transfer_Funds","Script_ID=0:int,Phone_Number=null:string,Number_Of_Digits=10:int,Pickup_Delay=4.0:float,Max_Random_Pickup_Delay=4.0:float,Charge_Per_Minute=0:int,Charge_Per_Second=0:int,Max_Call_Duration=60:int");
ScriptRegistrant<JMG_RP2_SCUD_Launcher_Targeting_System> JMG_RP2_SCUD_Launcher_Targeting_System("JMG_RP2_SCUD_Launcher_Targeting_System","LauncherID:int");
ScriptRegistrant<JMG_RP2_SCUD_Launcher_SCUD_Missile_Up> JMG_RP2_SCUD_Launcher_SCUD_Missile_Up("JMG_RP2_SCUD_Launcher_SCUD_Missile_Up","LauncherID:int,PlayerID:int");
ScriptRegistrant<JMG_RP2_SCUD_Launcher_SCUD_Missile_Down> JMG_RP2_SCUD_Launcher_SCUD_Missile_Down("JMG_RP2_SCUD_Launcher_SCUD_Missile_Down","TargetID:int,PlayerID:int,LauncherID:int");
ScriptRegistrant<JMG_RP2_SCUD_Launcher_Targeting_System_Camera_Facing> JMG_RP2_SCUD_Launcher_Targeting_System_Camera_Facing("JMG_RP2_SCUD_Launcher_Targeting_System_Camera_Facing","");
ScriptRegistrant<JMG_RP2_Phone_Message_Player_On_Custom> JMG_RP2_Phone_Message_Player_On_Custom("JMG_RP2_Phone_Message_Player_On_Custom","Phone_Script_ID=0:int,Text_Number=0:int,Text=null:string");
ScriptRegistrant<JMG_RP2_Phone_Load_Phone_Number_Strings> JMG_RP2_Phone_Load_Phone_Number_Strings("JMG_RP2_Phone_Load_Phone_Number_Strings","");
ScriptRegistrant<JMG_RP2_Mission_System_Strings_Loader> JMG_RP2_Mission_System_Strings_Loader("JMG_RP2_Mission_System_Strings_Loader","");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Define_Mission_Conflicts> JMG_RP2_Mission_System_Mission_Define_Mission_Conflicts("JMG_RP2_Mission_System_Mission_Define_Mission_Conflicts","Mission_Type=0:int,Conflicting_Mission_List=0:string");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Vehicle_Exception> JMG_RP2_Mission_System_Mission_Vehicle_Exception("JMG_RP2_Mission_System_Mission_Vehicle_Exception","Mission_Type=0:int,Exclude_Vehicle_From_Fail_Condition=0:string");
ScriptRegistrant<JMG_RP2_Character_Info> JMG_RP2_Character_Info("JMG_RP2_Character_Info","");
ScriptRegistrant<JMG_RP2_Force_Vehicle_Exit_And_Kill> JMG_RP2_Force_Vehicle_Exit_And_Kill("JMG_RP2_Force_Vehicle_Exit_And_Kill","Damager_ID:int");
ScriptRegistrant<JMG_RP2_Carryall> JMG_RP2_Carryall("JMG_RP2_Carryall","");
ScriptRegistrant<JMG_RP2_Housing_Vehicle_Key_Press> JMG_RP2_Housing_Vehicle_Key_Press("JMG_RP2_Housing_Vehicle_Key_Press","SetVehicleKeyMessage:int,ZoneID:int");
ScriptRegistrant<JMG_RP2_Housing_Vehicle_Zone> JMG_RP2_Housing_Vehicle_Zone("JMG_RP2_Housing_Vehicle_Zone","House_Address:int,Set_Vehicle_Key_Message=5656565:int");
ScriptRegistrant<JMG_RP2_Housing_Vehicle_PT> JMG_RP2_Housing_Vehicle_PT("JMG_RP2_Housing_Vehicle_PT","House_Address:int");
ScriptRegistrant<JMG_RP2_Mission_System_Set_Vehicle_Mission_Fails> JMG_RP2_Mission_System_Set_Vehicle_Mission_Fails("JMG_RP2_Mission_System_Set_Vehicle_Mission_Fails","Mission_Type=0:int,Fail_On_Vehicle_Entry[Tracked|Wheeled|Motorcycle]=0.0 0.0 0.0:vector3,Fail_On_Vehicle_Entry[VTOL|Boat|Turret]=0.0 0.0 0.0:vector3");
ScriptRegistrant<JMG_RP2_Housing_Vehicle_Load> JMG_RP2_Housing_Vehicle_Load("JMG_RP2_Housing_Vehicle_Load","");
ScriptRegistrant<JMG_RP2_House_Spawn_Location> JMG_RP2_House_Spawn_Location("JMG_RP2_House_Spawn_Location","House_Address:int");
ScriptRegistrant<JMG_RP2_Mission_System_Mission_Objective_Powerup> JMG_RP2_Mission_System_Mission_Objective_Powerup("JMG_RP2_Mission_System_Mission_Objective_Powerup","Mission_Type=0:int,Objective_Number=-1:int");
ScriptRegistrant<JMG_RP2_WLS_Random_Weapon_Spawner_Control> JMG_RP2_WLS_Random_Weapon_Spawner_Control("JMG_RP2_WLS_Random_Weapon_Spawner_Control","Weapon_Tier=1:int,Spawn_Time=30.0:float,Random_Spawn_Time=10.0:float,Spawn_Limit=-1:int,Grant_Bullets=-1:int");
ScriptRegistrant<JMG_RP2_Send_Custom_To_ID_On_Pickup> JMG_RP2_Send_Custom_To_ID_On_Pickup("JMG_RP2_Send_Custom_To_ID_On_Pickup","ID:int");
ScriptRegistrant<JMG_RP2_Mission_Drop_Weapon_If_Mission_Is_Not_Started> JMG_RP2_Mission_Drop_Weapon_If_Mission_Is_Not_Started("JMG_RP2_Mission_Drop_Weapon_If_Mission_Is_Not_Started","Mission_Type=0:int,Weapon_Name:string,Drop_On_Fail=1:int,Spawn_Time=30.0:float,Random_Spawn_Time=10.0:float,Spawn_Limit=-1:int,Grant_Bullets=-1:int");
ScriptRegistrant<JMG_RP2_Remove_Weapon_Delay> JMG_RP2_Remove_Weapon_Delay("JMG_RP2_Remove_Weapon_Delay","Weapon_Name:string,Delay:float");
ScriptRegistrant<JMG_RP2_Move_To_Random_Location_On_Create> JMG_RP2_Move_To_Random_Location_On_Create("JMG_RP2_Move_To_Random_Location_On_Create","Random_Positions:int,Location_0:Vector3,Location_1:Vector3,Location_2:Vector3,Location_3:Vector3,Location_4:Vector3,Location_5:Vector3,Location_6:Vector3,Location_7:Vector3,Location_8:Vector3,Location_9:Vector3,Move_Randomly=0:int,Move_Time=30.0:float,Random_Move_Time=10.0:float");
ScriptRegistrant<JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special> JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special("JMG_RP2_WLS_New_Decoy_Recreate_Powerup_Special","Weapon_Name:string,Bullets:int,MySpawnTime:float,SpawnTime:float,RandomSpawnTime:float,Spawn_Limit:int,Spawn_Bullets:int,Powerup_Limited:int");
ScriptRegistrant<JMG_RP2_CarryAll_Vehicle_Height_Adjust> JMG_RP2_CarryAll_Vehicle_Height_Adjust("JMG_RP2_CarryAll_Vehicle_Height_Adjust","HeightAdd=2:int");
ScriptRegistrant<JMG_RP2_Enable_Collisions_On_Timer> JMG_RP2_Enable_Collisions_On_Timer("JMG_RP2_Enable_Collisions_On_Timer","Time=1.0:float");
ScriptRegistrant<JMG_New_Parachute_Script> JMG_New_Parachute_Script("JMG_New_Parachute_Script","");
ScriptRegistrant<JMG_Force_Enter_Vehicle> JMG_Force_Enter_Vehicle("JMG_Force_Enter_Vehicle","Health:string,Armor:string");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone> JMG_RP2_Move_While_In_Zone("JMG_RP2_Move_While_In_Zone","TimeDelay=0.0:float,Movement=0.0 0.0 0.0:Vector3,ZoneVariant(0-9)=0:int");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Attach> JMG_RP2_Move_While_In_Zone_Attach0("JMG_RP2_Move_While_In_Zone_Attach0","Time:float,TimerID:int,Movement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Attach> JMG_RP2_Move_While_In_Zone_Attach1("JMG_RP2_Move_While_In_Zone_Attach1","Time:float,TimerID:int,Movement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Attach> JMG_RP2_Move_While_In_Zone_Attach2("JMG_RP2_Move_While_In_Zone_Attach2","Time:float,TimerID:int,Movement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Attach> JMG_RP2_Move_While_In_Zone_Attach3("JMG_RP2_Move_While_In_Zone_Attach3","Time:float,TimerID:int,Movement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Attach> JMG_RP2_Move_While_In_Zone_Attach4("JMG_RP2_Move_While_In_Zone_Attach4","Time:float,TimerID:int,Movement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Attach> JMG_RP2_Move_While_In_Zone_Attach5("JMG_RP2_Move_While_In_Zone_Attach5","Time:float,TimerID:int,Movement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Attach> JMG_RP2_Move_While_In_Zone_Attach6("JMG_RP2_Move_While_In_Zone_Attach6","Time:float,TimerID:int,Movement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Attach> JMG_RP2_Move_While_In_Zone_Attach7("JMG_RP2_Move_While_In_Zone_Attach7","Time:float,TimerID:int,Movement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Attach> JMG_RP2_Move_While_In_Zone_Attach8("JMG_RP2_Move_While_In_Zone_Attach8","Time:float,TimerID:int,Movement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Attach> JMG_RP2_Move_While_In_Zone_Attach9("JMG_RP2_Move_While_In_Zone_Attach9","Time:float,TimerID:int,Movement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2> JMG_RP2_Move_While_In_Zone_2("JMG_RP2_Move_While_In_Zone_2","TimeDelay=0.0:float,Movement=0.0 0.0 0.0:Vector3,MoveToCenter=0.0 0.0 0.0:Vector3,ZoneVariant(0-9)=0:int");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2_Attach> JMG_RP2_Move_While_In_Zone_2_Attach_0("JMG_RP2_Move_While_In_Zone_2_Attach_0","Time:float,TimerID:int,Movement:Vector3,CenterMovement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2_Attach> JMG_RP2_Move_While_In_Zone_2_Attach_1("JMG_RP2_Move_While_In_Zone_2_Attach_1","Time:float,TimerID:int,Movement:Vector3,CenterMovement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2_Attach> JMG_RP2_Move_While_In_Zone_2_Attach_2("JMG_RP2_Move_While_In_Zone_2_Attach_2","Time:float,TimerID:int,Movement:Vector3,CenterMovement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2_Attach> JMG_RP2_Move_While_In_Zone_2_Attach_3("JMG_RP2_Move_While_In_Zone_2_Attach_3","Time:float,TimerID:int,Movement:Vector3,CenterMovement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2_Attach> JMG_RP2_Move_While_In_Zone_2_Attach_4("JMG_RP2_Move_While_In_Zone_2_Attach_4","Time:float,TimerID:int,Movement:Vector3,CenterMovement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2_Attach> JMG_RP2_Move_While_In_Zone_2_Attach_5("JMG_RP2_Move_While_In_Zone_2_Attach_5","Time:float,TimerID:int,Movement:Vector3,CenterMovement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2_Attach> JMG_RP2_Move_While_In_Zone_2_Attach_6("JMG_RP2_Move_While_In_Zone_2_Attach_6","Time:float,TimerID:int,Movement:Vector3,CenterMovement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2_Attach> JMG_RP2_Move_While_In_Zone_2_Attach_7("JMG_RP2_Move_While_In_Zone_2_Attach_7","Time:float,TimerID:int,Movement:Vector3,CenterMovement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2_Attach> JMG_RP2_Move_While_In_Zone_2_Attach_8("JMG_RP2_Move_While_In_Zone_2_Attach_8","Time:float,TimerID:int,Movement:Vector3,CenterMovement:Vector3");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_2_Attach> JMG_RP2_Move_While_In_Zone_2_Attach_9("JMG_RP2_Move_While_In_Zone_2_Attach_9","Time:float,TimerID:int,Movement:Vector3,CenterMovement:Vector3");
ScriptRegistrant<JMG_RP2_Simple_Smart_ID_Base_Defense> JMG_RP2_Simple_Smart_ID_Base_Defense("JMG_RP2_Simple_Smart_ID_Base_Defense","On_Grid:int,Min_Range:float,Max_Range:float");
ScriptRegistrant<JMG_RP2_Move_While_In_Zone_Allow_Movement> JMG_RP2_Move_While_In_Zone_Allow_Movement("JMG_RP2_Move_While_In_Zone_Allow_Movement","");
ScriptRegistrant<JMG_RP2_Count_Objects_On_Map_And_Print> JMG_RP2_Count_Objects_On_Map_And_Print("JMG_RP2_Count_Objects_On_Map_And_Print","");
ScriptRegistrant<JMG_RP2_WLS_Weapon_Sell_Zone> JMG_RP2_WLS_Weapon_Sell_Zone("JMG_RP2_WLS_Weapon_Sell_Zone","");
ScriptRegistrant<JMG_RP2_WLS_Weapon_Sell_On_Poke> JMG_RP2_WLS_Weapon_Sell_On_Poke("JMG_RP2_WLS_Weapon_Sell_On_Poke","");
ScriptRegistrant<JMG_RP2_Disable_Engine_On_Create> JMG_RP2_Disable_Engine_On_Create("JMG_RP2_Disable_Engine_On_Create","");
ScriptRegistrant<JMG_RP2_Player_Anti_Missile_System_Limit> JMG_RP2_Player_Anti_Missile_System_Limit("JMG_RP2_Player_Anti_Missile_System_Limit","Limit:int");
ScriptRegistrant<JMG_RP2_Phone_Player_Anti_Missile_System_Set> JMG_RP2_Phone_Player_Anti_Missile_System_Set("JMG_RP2_Phone_Player_Anti_Missile_System_Set","Message:int");
ScriptRegistrant<JMG_Change_HP_Shields_On_Timer> JMG_Change_HP_Shields_On_Timer("JMG_Change_HP_Shields_On_Timer","Time:float,TimerNum:int,SkinType:string,ArmorType:string");
ScriptRegistrant<JMG_RP2_Phone_Sell_House_Phone_Number_Control_System> JMG_RP2_Phone_Sell_House_Phone_Number_Control_System("JMG_RP2_Phone_Sell_House_Phone_Number_Control_System","Script_ID=0:int,Phone_Number:string,Number_Of_Digits=10:int,Pickup_Delay=4.0:float,Max_Random_Pickup_Delay=4.0:float,Charge_Per_Minute=0:int,Charge_Per_Second=0:int,Max_Call_Duration=60:int");
ScriptRegistrant<JMG_RP2_Flame_Thrower_Script> JMG_RP2_Flame_Thrower_Script("JMG_RP2_Flame_Thrower_Script","");
ScriptRegistrant<JMG_RP2_Fishing_Define_Fish> JMG_RP2_Fishing_Define_Fish("JMG_RP2_Fishing_Define_Fish","Fish_Name=null:string,Fish_Model=null:string,Fish_Probability=10:int,Fish_Size=1:int,Fish_Value=30:int,Fish_Damage=0.0:float");
ScriptRegistrant<JMG_RP2_Fishing_School> JMG_RP2_Fishing_School("JMG_RP2_Fishing_School","");
ScriptRegistrant<JMG_RP2_Fishing_Boat> JMG_RP2_Fishing_Boat("JMG_RP2_Fishing_Boat","Boat_Capacity=40:int");
ScriptRegistrant<JMG_RP2_Fishing_Random_School_Generator> JMG_RP2_Fishing_Random_School_Generator("JMG_RP2_Fishing_Random_School_Generator","");
ScriptRegistrant<JMG_RP2_Fishing_No_Fish_Zone> JMG_RP2_Fishing_No_Fish_Zone("JMG_RP2_Fishing_No_Fish_Zone","");
ScriptRegistrant<JMG_RP2_Fishing_Unload_Zone> JMG_RP2_Fishing_Unload_Zone("JMG_RP2_Fishing_Unload_Zone","");
ScriptRegistrant<JMG_RP2_Fishing_Fish_Zone_50Percent> JMG_RP2_Fishing_Fish_Zone_50Percent("JMG_RP2_Fishing_Fish_Zone_50Percent","");
ScriptRegistrant<JMG_RP2_Fishing_Fish_Zone_25Percent> JMG_RP2_Fishing_Fish_Zone_25Percent("JMG_RP2_Fishing_Fish_Zone_25Percent","");
ScriptRegistrant<JMG_RP2_Phone_Player_Call_Tactical_Nuke> JMG_RP2_Phone_Player_Call_Tactical_Nuke("JMG_RP2_Phone_Player_Call_Tactical_Nuke","");
ScriptRegistrant<JMG_RP2_Tactical_Nuke_Phone_Triggered> JMG_RP2_Tactical_Nuke_Phone_Triggered("JMG_RP2_Tactical_Nuke_Phone_Triggered","");
ScriptRegistrant<JMG_RP2_Tactical_Nuke_Phone_Beacon> JMG_RP2_Tactical_Nuke_Phone_Beacon("JMG_RP2_Tactical_Nuke_Phone_Beacon","");
ScriptRegistrant<JMG_RP2_Phone_Player_Special_Phone_Number> JMG_RP2_Phone_Player_Special_Phone_Number("JMG_RP2_Phone_Player_Special_Phone_Number","");
ScriptRegistrant<JMG_RP2_Favorite_Vehicle_Main_Control_System> JMG_RP2_Favorite_Vehicle_Main_Control_System("JMG_RP2_Favorite_Vehicle_Main_Control_System","");
ScriptRegistrant<JMG_RP2_Soldier_Set_Favorite_Vehicle> JMG_RP2_Soldier_Set_Favorite_Vehicle("JMG_RP2_Soldier_Set_Favorite_Vehicle","");
ScriptRegistrant<JMG_RP2_Phone_Buy_Favorite_Vehicle> JMG_RP2_Phone_Buy_Favorite_Vehicle("JMG_RP2_Phone_Buy_Favorite_Vehicle","Script_ID=0:int,Pickup_Delay=4.0:float,Max_Random_Pickup_Delay=4.0:float,Max_Callers=2:int,Charge_Per_Minute=0:int,Charge_Per_Second=0:int,Max_Call_Duration=60:int");
ScriptRegistrant<JMG_RP2_Disallow_Favorite_Vehicle> JMG_RP2_Disallow_Favorite_Vehicle("JMG_RP2_Disallow_Favorite_Vehicle","");
ScriptRegistrant<JMG_RP2_Tactical_Nuke_Radiation> JMG_RP2_Tactical_Nuke_Radiation("JMG_RP2_Tactical_Nuke_Radiation","OwnerID:int");
ScriptRegistrant<JMG_RP2_Set_Object_Team_On_Timer> JMG_RP2_Set_Object_Team_On_Timer("JMG_RP2_Set_Object_Team_On_Timer","Time:float,TimerID:int,Team:int");
ScriptRegistrant<JMG_RP2_Train_Kill_Zone_Control> JMG_RP2_Train_Kill_Zone_Control("JMG_RP2_Train_Kill_Zone_Control","");
ScriptRegistrant<JMG_RP2_Set_Physical_Collisions_On_Timer> JMG_RP2_Set_Physical_Collisions_On_Timer("JMG_RP2_Set_Physical_Collisions_On_Timer","Time:float,TimerID:int,Collide[Physical|Bullets|Camera]:Vector3");
ScriptRegistrant<JMG_RP2_Set_Engine_On_Timer> JMG_RP2_Set_Engine_On_Timer("JMG_RP2_Set_Engine_On_Timer","Time:float,TimerID:int,Enable:int");
ScriptRegistrant<JMG_RP2_Favorite_Weapon_Main_Control_System> JMG_RP2_Favorite_Weapon_Main_Control_System("JMG_RP2_Favorite_Weapon_Main_Control_System","");
ScriptRegistrant<JMG_RP2_Soldier_Set_Favorite_Weapon> JMG_RP2_Soldier_Set_Favorite_Weapon("JMG_RP2_Soldier_Set_Favorite_Weapon","");
ScriptRegistrant<JMG_RP2_Phone_Buy_Favorite_Weapon> JMG_RP2_Phone_Buy_Favorite_Weapon("JMG_RP2_Phone_Buy_Favorite_Weapon","Script_ID=0:int,Pickup_Delay=4.0:float,Max_Random_Pickup_Delay=4.0:float,Max_Callers=2:int,Charge_Per_Minute=0:int,Charge_Per_Second=0:int,Max_Call_Duration=60:int");
ScriptRegistrant<JMG_RP2_Set_Map_Version> JMG_RP2_Set_Map_Version("JMG_RP2_Set_Map_Version","Map_Version:string");
ScriptRegistrant<JMG_RP2_Phone_Request_Display_Server_Version> JMG_RP2_Phone_Request_Display_Server_Version("JMG_RP2_Phone_Request_Display_Server_Version","Message:int");
ScriptRegistrant<JMG_RP2_Phone_Request_Object_Count> JMG_RP2_Phone_Request_Object_Count("JMG_RP2_Phone_Request_Object_Count","Message:int");
ScriptRegistrant<JMG_RP2_Renhalo_Blast_Doors> JMG_RP2_Renhalo_Blast_Doors("JMG_RP2_Renhalo_Blast_Doors","Door_State:int");
ScriptRegistrant<JMG_RP2_Renhalo_Blast_Door_Switch> JMG_RP2_Renhalo_Blast_Door_Switch("JMG_RP2_Renhalo_Blast_Door_Switch","Door_ID:int");
ScriptRegistrant<JMG_RP2_Renhalo_Blast_Door_Wall_Switch> JMG_RP2_Renhalo_Blast_Door_Wall_Switch("JMG_RP2_Renhalo_Blast_Door_Wall_Switch","Door_ID:int");
ScriptRegistrant<JMG_RP2_Send_Custom_On_Poke> JMG_RP2_Send_Custom_On_Poke("JMG_RP2_Send_Custom_On_Poke","ID:int,Message:int,Param:int");
ScriptRegistrant<JMG_RP2_Renhalo_Blast_Door_Keycard> JMG_RP2_Renhalo_Blast_Door_Keycard("JMG_RP2_Renhalo_Blast_Door_Keycard","Key:int");
ScriptRegistrant<JMG_RP2_Renhalo_Blast_Door_Wall_Switch_Key> JMG_RP2_Renhalo_Blast_Door_Wall_Switch_Key("JMG_RP2_Renhalo_Blast_Door_Wall_Switch_Key","Door_ID:int,Key:int");
ScriptRegistrant<JMG_RP2_Send_Custom_On_Poke_Key> JMG_RP2_Send_Custom_On_Poke_Key("JMG_RP2_Send_Custom_On_Poke_Key","ID:int,Message:int,Param:int,Key:int");
ScriptRegistrant<JMG_RP2_Renhalo_Warthog> JMG_RP2_Renhalo_Warthog("JMG_RP2_Renhalo_Warthog","");
ScriptRegistrant<JMG_RP2_Renhalo_Vehicle_Passenger> JMG_RP2_Renhalo_Vehicle_Passenger("JMG_RP2_Renhalo_Vehicle_Passenger","");
ScriptRegistrant<JMG_RP2_Create_Vehicle_At_Safe_Location> JMG_RP2_Create_Vehicle_At_Safe_Location("JMG_RP2_Create_Vehicle_At_Safe_Location","");
ScriptRegistrant<JMG_RP2_Place_Vehicle_At_Safe_Location_Timer> JMG_RP2_Place_Vehicle_At_Safe_Location_Timer("JMG_RP2_Place_Vehicle_At_Safe_Location_Timer","Time:float,TimerID:int");
ScriptRegistrant<JMG_RP2_Get_Unstuck_Key> JMG_RP2_Get_Unstuck_Key("JMG_RP2_Get_Unstuck_Key","");
ScriptRegistrant<JMG_RP2_Grill> JMG_RP2_Grill("JMG_RP2_Grill","");
ScriptRegistrant<JMG_RP2_Renhalo_Phone_Exit_Fix> JMG_RP2_Renhalo_Phone_Exit_Fix("JMG_RP2_Renhalo_Phone_Exit_Fix","");
ScriptRegistrant<JMG_RP2_Dropped_Credit_Card_Info_Powerup> JMG_RP2_Dropped_Credit_Card_Info_Powerup("JMG_RP2_Dropped_Credit_Card_Info_Powerup","Player_Name:string");
ScriptRegistrant<JMG_RP2_Dropped_Credit_Card_Info_Powerup_Control> JMG_RP2_Dropped_Credit_Card_Info_Powerup_Control("JMG_RP2_Dropped_Credit_Card_Info_Powerup_Control","Player_Name:string");
ScriptRegistrant<JMG_Renhalo_Mindless_Hunt_And_Attack> JMG_Renhalo_Mindless_Hunt_And_Attack("JMG_Renhalo_Mindless_Hunt_And_Attack","JumpyAttack=1:int,Can_Steal_Vehicles=1:int,Can_Use_Rockets=1:int,AttackDistance=3.0:float");
ScriptRegistrant<JMG_RP2_Phone_Create_AI_Swarm> JMG_RP2_Phone_Create_AI_Swarm("JMG_RP2_Phone_Create_AI_Swarm","Message:int,Can_Steal_Vehicles:int,Can_Use_Rockets:int,Soldier_Type:int");
ScriptRegistrant<Spawn_Zombie_When_Killed_By_Zombie> Spawn_Zombie_When_Killed_By_Zombie("Spawn_Zombie_When_Killed_By_Zombie","");
ScriptRegistrant<JMG_Bring_Up_Text_Box_On_Poke> JMG_Bring_Up_Text_Box_On_Poke("JMG_Bring_Up_Text_Box_On_Poke","Text_Message=null:string,Delim=^:string,Delay=0.0:float");
ScriptRegistrant<JMG_RP2_Phone_Create_AI_Swarm_One> JMG_RP2_Phone_Create_AI_Swarm_One("JMG_RP2_Phone_Create_AI_Swarm_One","Message:int,Soldier_Type:int");
ScriptRegistrant<JMG_RP2_Tutorial_Door_Teleport> JMG_RP2_Tutorial_Door_Teleport("JMG_RP2_Tutorial_Door_Teleport","TeleportLocation:Vector3,Object_ID=0:int,Enter_Rotation=0.0:float,Exit_Rotation=0.0:float,Enter_Animation=s_a_human.h_a_a0b1:string,Exit_Animation=s_a_human.walkinanim:string,Enter_Path_Animation=walkin:string,Exit_Path_Animation=walkout:string,Bone_Attach_Name=humanpos:string");
ScriptRegistrant<JMG_RP2_Tutorial_Message_Zone> JMG_RP2_Tutorial_Message_Zone("JMG_RP2_Tutorial_Message_Zone","Enter_Message=null:string,Exit_Message=null:string,Delim=^:string,Delay=0.0:float");
ScriptRegistrant<JMG_RP2_Zone_Debug_Script> JMG_RP2_Zone_Debug_Script("JMG_RP2_Zone_Debug_Script","");
ScriptRegistrant<JMG_RP2_Load_Player_Characters> JMG_RP2_Load_Player_Characters("JMG_RP2_Load_Player_Characters","");
ScriptRegistrant<JMG_RP2_Phone_House_Security_System_Config_Number> JMG_RP2_Phone_House_Security_System_Config_Number("JMG_RP2_Phone_House_Security_System_Config_Number","Script_ID=0:int,Phone_Number:string,Number_Of_Digits=10:int,Pickup_Delay=4.0:float,Max_Random_Pickup_Delay=4.0:float,Charge_Per_Minute=0:int,Charge_Per_Second=0:int,Max_Call_Duration=60:int");
ScriptRegistrant<JMG_RP2_Load_House_Security_Setup> JMG_RP2_Load_House_Security_Setup("JMG_RP2_Load_House_Security_Setup","");
ScriptRegistrant<JMG_RP2_House_Security_Object> JMG_RP2_House_Security_Object("JMG_RP2_House_Security_Object","House_Address:int,ObjectType[Door|CeilingGun|AntiMissileSystem]=0.00 0.00 0.00:Vector3,Spawn_On_Start=0:int");
ScriptRegistrant<JMG_RP2_House_Security_System_Object_Control> JMG_RP2_House_Security_System_Object_Control("JMG_RP2_House_Security_System_Object_Control","");
ScriptRegistrant<JMG_RP2_House_Security_Object_Repair_Control> JMG_RP2_House_Security_Object_Repair_Control("JMG_RP2_House_Security_Object_Repair_Control","");
ScriptRegistrant<JMG_RP2_House_Zone> JMG_RP2_House_Zone("JMG_RP2_House_Zone","HouseAddress:int");
ScriptRegistrant<JMG_RP2_House_Security_Alarm_Object> JMG_RP2_House_Security_Alarm_Object("JMG_RP2_House_Security_Alarm_Object","HouseAddress:int");
ScriptRegistrant<JMG_RP2_House_Repair_PT> JMG_RP2_House_Repair_PT("JMG_RP2_House_Repair_PT","HouseAddress:int");
ScriptRegistrant<JMG_RP2_House_GDI_PT_Zone> JMG_RP2_House_GDI_PT_Zone("JMG_RP2_House_GDI_PT_Zone","House_Address:int");
ScriptRegistrant<JMG_RP2_House_Missile_Defense_System> JMG_RP2_House_Missile_Defense_System("JMG_RP2_House_Missile_Defense_System","On_Grid:int,Min_Range:float,Max_Range:float,House_Address:int");
ScriptRegistrant<JMG_RP2_Object_Send_Text_Message_On_Death> JMG_RP2_Object_Send_Text_Message_On_Death("JMG_RP2_Object_Send_Text_Message_On_Death","");
ScriptRegistrant<JMG_RP2_Teleport_On_Frame_Range> JMG_RP2_Teleport_On_Frame_Range("JMG_RP2_Teleport_On_Frame_Range","ID:int,Enabled_Min=0.0:float,Enabled_Max=0.0:float,Position=0.0 0.0 0.0:Vector3");
ScriptRegistrant<JMG_RP2_Anti_Missile_System_Dish> JMG_RP2_Anti_Missile_System_Dish("JMG_RP2_Anti_Missile_System_Dish","");
ScriptRegistrant<JMG_Tornado_Throw> JMG_Tornado_Throw("JMG_Tornado_Throw","ID:int");
ScriptRegistrant<JMG_RP2_Firetruck> JMG_RP2_Firetruck("JMG_RP2_Firetruck","");
ScriptRegistrant<JMG_RP2_Vehicle_Speedometer> JMG_RP2_Vehicle_Speedometer("JMG_RP2_Vehicle_Speedometer","");
ScriptRegistrant<JMG_RP2_Hot_Air_Balloon> JMG_RP2_Hot_Air_Balloon("JMG_RP2_Hot_Air_Balloon","");
ScriptRegistrant<JMG_RP2_Fire_Truck_ReEnter_Zone> JMG_RP2_Fire_Truck_ReEnter_Zone("JMG_RP2_Fire_Truck_ReEnter_Zone","FireTruckID:int");
ScriptRegistrant<JMG_RP2_Mech_MadCat> JMG_RP2_Mech_MadCat("JMG_RP2_Mech_MadCat","");
ScriptRegistrant<JMG_Play_Animation_On_Create_The_Destroy> JMG_Play_Animation_On_Create_The_Destroy("JMG_Play_Animation_On_Create_The_Destroy","Animation:string,LastFrame:float,DestroyOrKill=0:int");
ScriptRegistrant<JMG_RP2_Ambulance_Zone> JMG_RP2_Ambulance_Zone("JMG_RP2_Ambulance_Zone","AmbulanceID:int");
ScriptRegistrant<JMG_RP2_Ambulance> JMG_RP2_Ambulance("JMG_RP2_Ambulance","");
ScriptRegistrant<JMG_Buy_Preset_On_Poke_Advanced> JMG_Buy_Preset_On_Poke_Advanced("JMG_Buy_Preset_On_Poke_Advanced","Preset=null:string,Location:Vector3,Facing=0.0:float,DeathZoneID=0:int,Cost=0:int,InadequateFundsSound=Vehicle_Inadequate_Funds:string,BuySound=Vehicle_Purchase:string,Time=0.0:float,TimerNum=0:int,Player_Type=2:int,TeleportTargetID:int,DestroyOnBuy:int");
ScriptRegistrant<JMG_RP2_PT_Poke_Grant_Powerup_Death> JMG_RP2_PT_Poke_Grant_Powerup_Death("JMG_RP2_PT_Poke_Grant_Powerup_Death","Powerup_Name=null:string,Cost=0:int,InadequateFundsSound=Vehicle_Inadequate_Funds:string,BuySound=Vehicle_Purchase:string");
ScriptRegistrant<JMG_RP2_Vehicle_Fire_Override> JMG_RP2_Vehicle_Fire_Override("JMG_RP2_Vehicle_Fire_Override","");
ScriptRegistrant<JMG_RP2_Invulnerable_Until_Custom_Received> JMG_RP2_Invulnerable_Until_Custom_Received("JMG_RP2_Invulnerable_Until_Custom_Received","Message:int");
ScriptRegistrant<JMG_Send_Self_Custom_On_Create> JMG_Send_Self_Custom_On_Create("JMG_Send_Self_Custom_On_Create","Message:int,Param:int,Delay:float");
ScriptRegistrant<JMG_RP2_Enable_Collisions_When_Safe> JMG_RP2_Enable_Collisions_When_Safe("JMG_RP2_Enable_Collisions_When_Safe","");
ScriptRegistrant<JMG_RP2_Plasma_Torpedo_Launcher> JMG_RP2_Plasma_Torpedo_Launcher("JMG_RP2_Plasma_Torpedo_Launcher","");
ScriptRegistrant<JMG_RP2_Console_Command_On_Custom> JMG_RP2_Console_Command_On_Custom("JMG_RP2_Console_Command_On_Custom","Message:int,Console_Command:string");
ScriptRegistrant<JMG_RP2_Phone_Grant_Random_Weapon> JMG_RP2_Phone_Grant_Random_Weapon("JMG_RP2_Phone_Grant_Random_Weapon","Message:int");
ScriptRegistrant<JMG_RP2_Vehicle_Ignore_EMP> JMG_RP2_Vehicle_Ignore_EMP("JMG_RP2_Vehicle_Ignore_EMP","");
ScriptRegistrant<JMG_RP2_Jet> JMG_RP2_Jet("JMG_RP2_Jet","");
ScriptRegistrant<JMG_RP2_Jet_Reload_Zone> JMG_RP2_Jet_Reload_Zone("JMG_RP2_Jet_Reload_Zone","");
ScriptRegistrant<JMG_Create_Powerup_At_Vehicle_Owner_Position> JMG_Create_Powerup_At_Vehicle_Owner_Position("JMG_Create_Powerup_At_Vehicle_Owner_Position","Powerup:string,Cost:float");
ScriptRegistrant<JMG_RP2_Server_Remove_PTs_FPS_Improvement_Test> JMG_RP2_Server_Remove_PTs_FPS_Improvement_Test("JMG_RP2_Server_Remove_PTs_FPS_Improvement_Test","Message:int");
ScriptRegistrant<JMG_RP2_Simple_Smart_Base_Defense_Alarm> JMG_RP2_Simple_Smart_Base_Defense_Alarm("JMG_RP2_Simple_Smart_Base_Defense_Alarm","Defense_Grid_1:int,Defense_Grid_2:int,Alarm_Sound=null:string,Sound_Time:float");
ScriptRegistrant<JMG_RP2_Ammo_Crate_Control> JMG_RP2_Ammo_Crate_Control("JMG_RP2_Ammo_Crate_Control","");
ScriptRegistrant<JMG_RP2_Train_Station> JMG_RP2_Train_Station("JMG_RP2_Train_Station","");
ScriptRegistrant<JMG_Buy_Preset_On_Poke_Hot_Air_Balloon> JMG_Buy_Preset_On_Poke_Hot_Air_Balloon("JMG_Buy_Preset_On_Poke_Hot_Air_Balloon","Preset=null:string,Location:Vector3,Facing=0.0:float,DeathZoneID=0:int,Cost=0:int,InadequateFundsSound=Vehicle_Inadequate_Funds:string,BuySound=Vehicle_Purchase:string,Time=0.0:float,TimerNum=0:int,Player_Type=2:int,SetModel=null:string");
ScriptRegistrant<JMG_RP2_Change_Models_On_Custom> JMG_RP2_Change_Models_On_Custom("JMG_RP2_Change_Models_On_Custom","Number_Of_Models:int,Model_1=null:string,Model_2=null:string,Model_3=null:string,Model_4=null:string,Model_5=null:string,Model_6=null:string,Model_7=null:string,Model_8=null:string,Model_9=null:string,Model_10=null:string");
ScriptRegistrant<JMG_RP2_Pull_Out_Phone_On_Keypress> JMG_RP2_Pull_Out_Phone_On_Keypress("JMG_RP2_Pull_Out_Phone_On_Keypress","");
ScriptRegistrant<JMG_RP2_Hovercraft_Hover_Control> JMG_RP2_Hovercraft_Hover_Control("JMG_RP2_Hovercraft_Hover_Control","HoverCraft_Bloker=hoverplate:string,HoverCraft_Type=0:int");
ScriptRegistrant<JMG_RP2_Initilize_Area_Weather> JMG_RP2_Initilize_Area_Weather("JMG_RP2_Initilize_Area_Weather","Weather_Node_Area=0:int,Zone_Switch_Time=0.0:float,Fog[Enable|Star|End]=1.0 300.0 5000.00:Vector3,ScreenColor[Red|Green|Blue]=0.0 0.0 0.0:Vector3,Screen_Opacity=0.0:float,Cloud[Cover|Gloominess|NULL]=0.0 0.0 0.0:Vector3,Lightning[Intensity|Start|End]=0.0 0.0 0.0:Vector3,Lightning[Heading|Distribution|NULL]=0.0 0.0 0.0:Vector3,WarBlitz[Intensity|Start|End]=0.0 0.0 0.0:Vector3,WarBlitz[Heading|Distribution|NULL]=0.0 0.0 0.0:Vector3,Wind[Speed|Heading|Variability]=0.0 0.0 0.0:Vector3,Density[Rain|Snow|Ash]=0.0 0.0 0.0:Vector3");
ScriptRegistrant<JMG_RP2_Change_Weather_Area_On_Enter> JMG_RP2_Change_Weather_Area_On_Enter("JMG_RP2_Change_Weather_Area_On_Enter","OverrideTransitionTime=-1.0:float,ChangeToArea=0:int");
ScriptRegistrant<JMG_RP2_Change_Weather_When_In_Range> JMG_RP2_Change_Weather_When_In_Range("JMG_RP2_Change_Weather_When_In_Range","Distance:float,OverrideTransitionTime=-1.0:float,In_Range_Area:int,Left_Range_Area:int");
ScriptRegistrant<JMG_RP2_Checkstand_Cashier> JMG_RP2_Checkstand_Cashier("JMG_RP2_Checkstand_Cashier","");
ScriptRegistrant<JMG_RP2_Checkstand_Customer> JMG_RP2_Checkstand_Customer("JMG_RP2_Checkstand_Customer","CheckstandID:int");
ScriptRegistrant<JMG_RP2_UFO_Script> JMG_RP2_UFO_Script("JMG_RP2_UFO_Script","");
